!function(){var t={3618:function(t,n,e){var i=e(7537),r=e(3645)(i);r.push([t.id,"\n.border-active[data-v-3dc18507] {\n  border: 1px solid #ced4da;\n}\n.toolbar[data-v-3dc18507] {\n  max-width: 60%;\n  position: absolute;\n  right: 0;\n  z-index: 1;\n}\n","",{version:3,sources:["webpack://./kadi/assets/scripts/components/lib/graphs/CollectionLinksGraph.vue"],names:[],mappings:";AA2DA;EACA,yBAAA;AACA;AAEA;EACA,cAAA;EACA,kBAAA;EACA,QAAA;EACA,UAAA;AACA",sourcesContent:['\x3c!-- Copyright 2023 Karlsruhe Institute of Technology\n   -\n   - Licensed under the Apache License, Version 2.0 (the "License");\n   - you may not use this file except in compliance with the License.\n   - You may obtain a copy of the License at\n   -\n   -     http://www.apache.org/licenses/LICENSE-2.0\n   -\n   - Unless required by applicable law or agreed to in writing, software\n   - distributed under the License is distributed on an "AS IS" BASIS,\n   - WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   - See the License for the specific language governing permissions and\n   - limitations under the License. --\x3e\n\n<template>\n  <div class="card" ref="container">\n    <div class="toolbar mt-1 mr-1">\n      <i class="fa-solid fa-circle-notch fa-spin mr-2" v-if="loading"></i>\n      <button type="button"\n              :title="$t(\'Toggle forces\')"\n              :class="toolbarBtnClasses + (forceDisabled ? \' border-active\' : \'\')"\n              :disabled="!initialized"\n              @click="forceDisabled = !forceDisabled">\n        <i class="fa-solid fa-thumbtack"></i>\n      </button>\n      <button type="button"\n              :title="$t(\'Hide labels\')"\n              :class="toolbarBtnClasses + (labelsHidden ? \' border-active\' : \'\')"\n              :disabled="!initialized"\n              @click="toggleLabels">\n        <i class="fa-solid fa-font"></i>\n      </button>\n      <button type="button"\n              :title="$t(\'Download graph\')"\n              :class="toolbarBtnClasses"\n              :disabled="!initialized"\n              @click="downloadGraph">\n        <i class="fa-solid fa-download"></i>\n      </button>\n      <button type="button"\n              :title="$t(\'Reset view\')"\n              :class="toolbarBtnClasses"\n              :disabled="!initialized"\n              @click="resetView">\n        <i class="fa-solid fa-eye"></i>\n      </button>\n      <button type="button"\n              :title="$t(\'Toggle fullscreen\')"\n              :class="toolbarBtnClasses"\n              :disabled="!initialized"\n              @click="toggleFullscreen">\n        <i class="fa-solid fa-expand"></i>\n      </button>\n    </div>\n    <div ref="svgContainer"></div>\n  </div>\n</template>\n\n<style scoped>\n.border-active {\n  border: 1px solid #ced4da;\n}\n\n.toolbar {\n  max-width: 60%;\n  position: absolute;\n  right: 0;\n  z-index: 1;\n}\n</style>\n\n<script>\nimport * as d3 from \'d3\';\n\nimport graphMixin from \'scripts/components/mixins/graph-mixin\';\n\nexport default {\n  mixins: [graphMixin],\n  data() {\n    return {\n      data: null,\n      coordinateStrength: 0.1,\n    };\n  },\n  methods: {\n    getStartNode() {\n      return this.nodes.find((node) => node.id === this.data.id) || null;\n    },\n    disableForces() {\n      this.simulation.force(this.forces.x).strength(0);\n      this.simulation.force(this.forces.y).strength(0);\n    },\n    enableForces() {\n      this.simulation.force(this.forces.x).strength(this.coordinateStrength);\n      this.simulation.force(this.forces.y).strength(this.coordinateStrength);\n    },\n    resizeCallback() {\n      this.resizeView(this.$refs.container, this.$refs.svgContainer);\n      this.resetView();\n    },\n    findCollection(id, _collection = null) {\n      let collection = _collection;\n\n      if (collection === null) {\n        collection = this.data;\n      }\n      if (collection.id === id) {\n        return collection;\n      }\n      if (collection.children === null) {\n        return null;\n      }\n\n      for (const child of collection.children) {\n        const result = this.findCollection(id, child);\n\n        if (result !== null) {\n          return result;\n        }\n      }\n\n      return null;\n    },\n    iterateChildCollections(collection, callback) {\n      if (collection.children === null) {\n        return;\n      }\n\n      for (const child of collection.children) {\n        callback(child);\n        this.iterateChildCollections(child, callback);\n      }\n    },\n    updateRecordNodes(collection) {\n      for (const record of collection.records) {\n        this.nodes.push({...record, collection: collection.id, _type: this.types.record});\n      }\n      for (const recordLink of collection.record_links) {\n        this.links.push({...recordLink});\n      }\n    },\n    updateGraph() {\n      // Determine a (new) tree layout for the collection hierarchy.\n      const root = d3.hierarchy(this.data);\n\n      const treeLayout = d3\n        .tree()\n        .nodeSize([1250, 1000])\n        .separation(() => 1);\n\n      treeLayout(root);\n\n      for (const node of this.nodes) {\n        // If the node was never moved, use the coordinates of the tree layout.\n        if (node._type === this.types.collection && !node._moved) {\n          const treeNode = root.find((d) => d.data.id === node.id);\n\n          node.fx = treeNode.x;\n          node.fy = treeNode.y;\n        }\n      }\n\n      const recordsCallback = (d) => {\n        const collection = this.findCollection(d.id);\n\n        // Only update the data if the records are still uninitialized.\n        if (collection.records === null) {\n          this.updateData(collection.records_endpoint);\n          return;\n        }\n\n        for (const node of this.nodes) {\n          if (node._type === this.types.record && node.collection === collection.id) {\n            if (!this.excludedRecords.includes(node.id)) {\n              this.excludedRecords.push(node.id);\n            } else {\n              kadi.utils.removeFromArray(this.excludedRecords, node.id);\n            }\n          }\n        }\n\n        this.filterNodes();\n      };\n\n      const childrenCallback = (d) => {\n        const collection = this.findCollection(d.id);\n\n        // Only update the data if the children are still uninitialized.\n        if (collection.children === null) {\n          this.updateData(collection.children_endpoint);\n          return;\n        }\n\n        // Toggle the children.\n        collection._collapsed = !collection._collapsed;\n\n        const hasCollapsedParent = (child) => {\n          let parent = child.parent;\n\n          while (parent) {\n            if (parent._collapsed) {\n              return true;\n            }\n\n            parent = parent.parent;\n          }\n\n          return false;\n        };\n\n        this.iterateChildCollections(collection, (child) => {\n          if (collection._collapsed) {\n            if (!this.excludedCollections.includes(child.id)) {\n              this.excludedCollections.push(child.id);\n            }\n          // Do not remove the child if it has another parent that is collapsed.\n          } else if (!hasCollapsedParent(child)) {\n            kadi.utils.removeFromArray(this.excludedCollections, child.id);\n          }\n        });\n\n        this.filterNodes();\n      };\n\n      this.simulation.nodes(this.nodes);\n      this.simulation.force(this.forces.link).links(this.links);\n\n      this.drawNodes(true, recordsCallback, childrenCallback);\n      this.drawLinks();\n      this.drawLegend();\n\n      this.filterNodes();\n\n      this.simulation.alpha(1).restart();\n    },\n    updateData(endpoint) {\n      this.loading = true;\n\n      axios.get(endpoint)\n        .then((response) => {\n          const data = response.data;\n\n          if (!this.initialized) {\n            this.data = data;\n            this.nodes.push({...data, _type: this.types.collection});\n            this.updateRecordNodes(data);\n          } else {\n            const collection = this.findCollection(data.id);\n\n            // Initialize the records of the collection, if applicable.\n            if (data.records !== null) {\n              collection.records = data.records;\n              collection.record_links = data.record_links;\n\n              this.updateRecordNodes(collection);\n            }\n\n            // Initialize the children of the collection, if applicable.\n            if (data.children !== null) {\n              collection.children = data.children;\n\n              for (const child of collection.children) {\n                child.parent = collection;\n\n                this.nodes.push({...child, _type: this.types.collection});\n                this.links.push({id: `${collection.id}-${child.id}`, source: collection.id, target: child.id});\n              }\n            }\n          }\n\n          this.updateGraph();\n        })\n        .catch((error) => kadi.base.flashDanger($t(\'Error loading collection links.\'), {request: error.request}))\n        .finally(() => {\n          this.initialized = true;\n          this.loading = false;\n          this.forceDisabled = false;\n        });\n    },\n  },\n  mounted() {\n    this.createContainers(this.$refs.svgContainer);\n    this.createSimulation();\n\n    // Force the position of records to their collection coordinates.\n    const foorceCoordinate = (d, coordinate) => {\n      let result = 0;\n\n      if (d._type === this.types.record) {\n        const node = this.nodes.find((node) => node.id === d.collection);\n        result = node[`f${coordinate}`];\n      }\n\n      return result || 0;\n    };\n\n    const forceX = d3\n      .forceX()\n      .strength(this.coordinateStrength)\n      .x((d) => foorceCoordinate(d, this.forces.x));\n\n    const forceY = d3\n      .forceY()\n      .strength(this.coordinateStrength)\n      .y((d) => foorceCoordinate(d, this.forces.y));\n\n    this.simulation.force(this.forces.x, forceX).force(this.forces.y, forceY);\n\n    this.resizeCallback();\n    this.updateData(this.endpoint);\n\n    window.addEventListener(\'resize\', this.resizeCallback);\n  },\n  beforeDestroy() {\n    window.removeEventListener(\'resize\', this.resizeCallback);\n  },\n};\n<\/script>\n'],sourceRoot:""}]),t.exports=r},3645:function(t){"use strict";t.exports=function(t){var n=[];return n.toString=function(){return this.map((function(n){var e="",i=void 0!==n[5];return n[4]&&(e+="@supports (".concat(n[4],") {")),n[2]&&(e+="@media ".concat(n[2]," {")),i&&(e+="@layer".concat(n[5].length>0?" ".concat(n[5]):""," {")),e+=t(n),i&&(e+="}"),n[2]&&(e+="}"),n[4]&&(e+="}"),e})).join("")},n.i=function(t,e,i,r,o){"string"==typeof t&&(t=[[null,t,void 0]]);var s={};if(i)for(var a=0;a<this.length;a++){var l=this[a][0];null!=l&&(s[l]=!0)}for(var u=0;u<t.length;u++){var c=[].concat(t[u]);i&&s[c[0]]||(void 0!==o&&(void 0===c[5]||(c[1]="@layer".concat(c[5].length>0?" ".concat(c[5]):""," {").concat(c[1],"}")),c[5]=o),e&&(c[2]?(c[1]="@media ".concat(c[2]," {").concat(c[1],"}"),c[2]=e):c[2]=e),r&&(c[4]?(c[1]="@supports (".concat(c[4],") {").concat(c[1],"}"),c[4]=r):c[4]="".concat(r)),n.push(c))}},n}},7537:function(t){"use strict";t.exports=function(t){var n=t[1],e=t[3];if(!e)return n;if("function"==typeof btoa){var i=btoa(unescape(encodeURIComponent(JSON.stringify(e)))),r="sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(i),o="/*# ".concat(r," */");return[n].concat([o]).join("\n")}return[n].join("\n")}},9574:function(t,n,e){var i=e(3618);i.__esModule&&(i=i.default),"string"==typeof i&&(i=[[t.id,i,""]]),i.locals&&(t.exports=i.locals),(0,e(5346).Z)("ad282abe",i,!1,{})},5346:function(t,n,e){"use strict";function i(t,n){for(var e=[],i={},r=0;r<n.length;r++){var o=n[r],s=o[0],a={id:t+":"+r,css:o[1],media:o[2],sourceMap:o[3]};i[s]?i[s].parts.push(a):e.push(i[s]={id:s,parts:[a]})}return e}e.d(n,{Z:function(){return p}});var r="undefined"!=typeof document;if("undefined"!=typeof DEBUG&&DEBUG&&!r)throw new Error("vue-style-loader cannot be used in a non-browser environment. Use { target: 'node' } in your Webpack config to indicate a server-rendering environment.");var o={},s=r&&(document.head||document.getElementsByTagName("head")[0]),a=null,l=0,u=!1,c=function(){},h=null,f="data-vue-ssr-id",d="undefined"!=typeof navigator&&/msie [6-9]\b/.test(navigator.userAgent.toLowerCase());function p(t,n,e,r){u=e,h=r||{};var s=i(t,n);return y(s),function(n){for(var e=[],r=0;r<s.length;r++){var a=s[r];(l=o[a.id]).refs--,e.push(l)}for(n?y(s=i(t,n)):s=[],r=0;r<e.length;r++){var l;if(0===(l=e[r]).refs){for(var u=0;u<l.parts.length;u++)l.parts[u]();delete o[l.id]}}}}function y(t){for(var n=0;n<t.length;n++){var e=t[n],i=o[e.id];if(i){i.refs++;for(var r=0;r<i.parts.length;r++)i.parts[r](e.parts[r]);for(;r<e.parts.length;r++)i.parts.push(v(e.parts[r]));i.parts.length>e.parts.length&&(i.parts.length=e.parts.length)}else{var s=[];for(r=0;r<e.parts.length;r++)s.push(v(e.parts[r]));o[e.id]={id:e.id,refs:1,parts:s}}}}function g(){var t=document.createElement("style");return t.type="text/css",s.appendChild(t),t}function v(t){var n,e,i=document.querySelector("style["+f+'~="'+t.id+'"]');if(i){if(u)return c;i.parentNode.removeChild(i)}if(d){var r=l++;i=a||(a=g()),n=x.bind(null,i,r,!1),e=x.bind(null,i,r,!0)}else i=g(),n=w.bind(null,i),e=function(){i.parentNode.removeChild(i)};return n(t),function(i){if(i){if(i.css===t.css&&i.media===t.media&&i.sourceMap===t.sourceMap)return;n(t=i)}else e()}}var m,_=(m=[],function(t,n){return m[t]=n,m.filter(Boolean).join("\n")});function x(t,n,e,i){var r=e?"":i.css;if(t.styleSheet)t.styleSheet.cssText=_(n,r);else{var o=document.createTextNode(r),s=t.childNodes;s[n]&&t.removeChild(s[n]),s.length?t.insertBefore(o,s[n]):t.appendChild(o)}}function w(t,n){var e=n.css,i=n.media,r=n.sourceMap;if(i&&t.setAttribute("media",i),h.ssrId&&t.setAttribute(f,n.id),r&&(e+="\n/*# sourceURL="+r.sources[0]+" */",e+="\n/*# sourceMappingURL=data:application/json;base64,"+btoa(unescape(encodeURIComponent(JSON.stringify(r))))+" */"),t.styleSheet)t.styleSheet.cssText=e;else{for(;t.firstChild;)t.removeChild(t.firstChild);t.appendChild(document.createTextNode(e))}}}},n={};function e(i){var r=n[i];if(void 0!==r)return r.exports;var o=n[i]={id:i,exports:{}};return t[i](o,o.exports,e),o.exports}e.d=function(t,n){for(var i in n)e.o(n,i)&&!e.o(t,i)&&Object.defineProperty(t,i,{enumerable:!0,get:n[i]})},e.o=function(t,n){return Object.prototype.hasOwnProperty.call(t,n)},function(){"use strict";var t=function(){var t=this,n=t._self._c;return n("div",{ref:"container",staticClass:"card"},[n("div",{staticClass:"toolbar mt-1 mr-1"},[t.loading?n("i",{staticClass:"fa-solid fa-circle-notch fa-spin mr-2"}):t._e(),t._v(" "),n("button",{class:t.toolbarBtnClasses+(t.forceDisabled?" border-active":""),attrs:{type:"button",title:t.$t("Toggle forces"),disabled:!t.initialized},on:{click:function(n){t.forceDisabled=!t.forceDisabled}}},[n("i",{staticClass:"fa-solid fa-thumbtack"})]),t._v(" "),n("button",{class:t.toolbarBtnClasses+(t.labelsHidden?" border-active":""),attrs:{type:"button",title:t.$t("Hide labels"),disabled:!t.initialized},on:{click:t.toggleLabels}},[n("i",{staticClass:"fa-solid fa-font"})]),t._v(" "),n("button",{class:t.toolbarBtnClasses,attrs:{type:"button",title:t.$t("Download graph"),disabled:!t.initialized},on:{click:t.downloadGraph}},[n("i",{staticClass:"fa-solid fa-download"})]),t._v(" "),n("button",{class:t.toolbarBtnClasses,attrs:{type:"button",title:t.$t("Reset view"),disabled:!t.initialized},on:{click:t.resetView}},[n("i",{staticClass:"fa-solid fa-eye"})]),t._v(" "),n("button",{class:t.toolbarBtnClasses,attrs:{type:"button",title:t.$t("Toggle fullscreen"),disabled:!t.initialized},on:{click:t.toggleFullscreen}},[n("i",{staticClass:"fa-solid fa-expand"})])]),t._v(" "),n("div",{ref:"svgContainer"})])};function n(){}function i(t){return null==t?n:function(){return this.querySelector(t)}}function r(){return[]}function o(t){return null==t?r:function(){return this.querySelectorAll(t)}}function s(t){return function(){return this.matches(t)}}function a(t){return function(n){return n.matches(t)}}t._withStripped=!0;var l=Array.prototype.find;function u(){return this.firstElementChild}var c=Array.prototype.filter;function h(){return Array.from(this.children)}function f(t){return new Array(t.length)}function d(t,n){this.ownerDocument=t.ownerDocument,this.namespaceURI=t.namespaceURI,this._next=null,this._parent=t,this.__data__=n}function p(t,n,e,i,r,o){for(var s,a=0,l=n.length,u=o.length;a<u;++a)(s=n[a])?(s.__data__=o[a],i[a]=s):e[a]=new d(t,o[a]);for(;a<l;++a)(s=n[a])&&(r[a]=s)}function y(t,n,e,i,r,o,s){var a,l,u,c=new Map,h=n.length,f=o.length,p=new Array(h);for(a=0;a<h;++a)(l=n[a])&&(p[a]=u=s.call(l,l.__data__,a,n)+"",c.has(u)?r[a]=l:c.set(u,l));for(a=0;a<f;++a)u=s.call(t,o[a],a,o)+"",(l=c.get(u))?(i[a]=l,l.__data__=o[a],c.delete(u)):e[a]=new d(t,o[a]);for(a=0;a<h;++a)(l=n[a])&&c.get(p[a])===l&&(r[a]=l)}function g(t){return t.__data__}function v(t){return"object"==typeof t&&"length"in t?t:Array.from(t)}function m(t,n){return t<n?-1:t>n?1:t>=n?0:NaN}d.prototype={constructor:d,appendChild:function(t){return this._parent.insertBefore(t,this._next)},insertBefore:function(t,n){return this._parent.insertBefore(t,n)},querySelector:function(t){return this._parent.querySelector(t)},querySelectorAll:function(t){return this._parent.querySelectorAll(t)}};var _="http://www.w3.org/1999/xhtml",x={svg:"http://www.w3.org/2000/svg",xhtml:_,xlink:"http://www.w3.org/1999/xlink",xml:"http://www.w3.org/XML/1998/namespace",xmlns:"http://www.w3.org/2000/xmlns/"};function w(t){var n=t+="",e=n.indexOf(":");return e>=0&&"xmlns"!==(n=t.slice(0,e))&&(t=t.slice(e+1)),x.hasOwnProperty(n)?{space:x[n],local:t}:t}function b(t){return function(){this.removeAttribute(t)}}function k(t){return function(){this.removeAttributeNS(t.space,t.local)}}function $(t,n){return function(){this.setAttribute(t,n)}}function C(t,n){return function(){this.setAttributeNS(t.space,t.local,n)}}function A(t,n){return function(){var e=n.apply(this,arguments);null==e?this.removeAttribute(t):this.setAttribute(t,e)}}function z(t,n){return function(){var e=n.apply(this,arguments);null==e?this.removeAttributeNS(t.space,t.local):this.setAttributeNS(t.space,t.local,e)}}function N(t){return t.ownerDocument&&t.ownerDocument.defaultView||t.document&&t||t.defaultView}function M(t){return function(){this.style.removeProperty(t)}}function S(t,n,e){return function(){this.style.setProperty(t,n,e)}}function E(t,n,e){return function(){var i=n.apply(this,arguments);null==i?this.style.removeProperty(t):this.style.setProperty(t,i,e)}}function T(t,n){return t.style.getPropertyValue(n)||N(t).getComputedStyle(t,null).getPropertyValue(n)}function L(t){return function(){delete this[t]}}function B(t,n){return function(){this[t]=n}}function P(t,n){return function(){var e=n.apply(this,arguments);null==e?delete this[t]:this[t]=e}}function D(t){return t.trim().split(/^|\s+/)}function R(t){return t.classList||new q(t)}function q(t){this._node=t,this._names=D(t.getAttribute("class")||"")}function F(t,n){for(var e=R(t),i=-1,r=n.length;++i<r;)e.add(n[i])}function I(t,n){for(var e=R(t),i=-1,r=n.length;++i<r;)e.remove(n[i])}function H(t){return function(){F(this,t)}}function O(t){return function(){I(this,t)}}function X(t,n){return function(){(n.apply(this,arguments)?F:I)(this,t)}}function j(){this.textContent=""}function Y(t){return function(){this.textContent=t}}function V(t){return function(){var n=t.apply(this,arguments);this.textContent=null==n?"":n}}function U(){this.innerHTML=""}function G(t){return function(){this.innerHTML=t}}function K(t){return function(){var n=t.apply(this,arguments);this.innerHTML=null==n?"":n}}function W(){this.nextSibling&&this.parentNode.appendChild(this)}function Q(){this.previousSibling&&this.parentNode.insertBefore(this,this.parentNode.firstChild)}function Z(t){return function(){var n=this.ownerDocument,e=this.namespaceURI;return e===_&&n.documentElement.namespaceURI===_?n.createElement(t):n.createElementNS(e,t)}}function J(t){return function(){return this.ownerDocument.createElementNS(t.space,t.local)}}function tt(t){var n=w(t);return(n.local?J:Z)(n)}function nt(){return null}function et(){var t=this.parentNode;t&&t.removeChild(this)}function it(){var t=this.cloneNode(!1),n=this.parentNode;return n?n.insertBefore(t,this.nextSibling):t}function rt(){var t=this.cloneNode(!0),n=this.parentNode;return n?n.insertBefore(t,this.nextSibling):t}function ot(t){return function(){var n=this.__on;if(n){for(var e,i=0,r=-1,o=n.length;i<o;++i)e=n[i],t.type&&e.type!==t.type||e.name!==t.name?n[++r]=e:this.removeEventListener(e.type,e.listener,e.options);++r?n.length=r:delete this.__on}}}function st(t,n,e){return function(){var i,r=this.__on,o=function(t){return function(n){t.call(this,n,this.__data__)}}(n);if(r)for(var s=0,a=r.length;s<a;++s)if((i=r[s]).type===t.type&&i.name===t.name)return this.removeEventListener(i.type,i.listener,i.options),this.addEventListener(i.type,i.listener=o,i.options=e),void(i.value=n);this.addEventListener(t.type,o,e),i={type:t.type,name:t.name,value:n,listener:o,options:e},r?r.push(i):this.__on=[i]}}function at(t,n,e){var i=N(t),r=i.CustomEvent;"function"==typeof r?r=new r(n,e):(r=i.document.createEvent("Event"),e?(r.initEvent(n,e.bubbles,e.cancelable),r.detail=e.detail):r.initEvent(n,!1,!1)),t.dispatchEvent(r)}function lt(t,n){return function(){return at(this,t,n)}}function ut(t,n){return function(){return at(this,t,n.apply(this,arguments))}}q.prototype={add:function(t){this._names.indexOf(t)<0&&(this._names.push(t),this._node.setAttribute("class",this._names.join(" ")))},remove:function(t){var n=this._names.indexOf(t);n>=0&&(this._names.splice(n,1),this._node.setAttribute("class",this._names.join(" ")))},contains:function(t){return this._names.indexOf(t)>=0}};var ct=[null];function ht(t,n){this._groups=t,this._parents=n}function ft(){return new ht([[document.documentElement]],ct)}ht.prototype=ft.prototype={constructor:ht,select:function(t){"function"!=typeof t&&(t=i(t));for(var n=this._groups,e=n.length,r=new Array(e),o=0;o<e;++o)for(var s,a,l=n[o],u=l.length,c=r[o]=new Array(u),h=0;h<u;++h)(s=l[h])&&(a=t.call(s,s.__data__,h,l))&&("__data__"in s&&(a.__data__=s.__data__),c[h]=a);return new ht(r,this._parents)},selectAll:function(t){t="function"==typeof t?function(t){return function(){return null==(n=t.apply(this,arguments))?[]:Array.isArray(n)?n:Array.from(n);var n}}(t):o(t);for(var n=this._groups,e=n.length,i=[],r=[],s=0;s<e;++s)for(var a,l=n[s],u=l.length,c=0;c<u;++c)(a=l[c])&&(i.push(t.call(a,a.__data__,c,l)),r.push(a));return new ht(i,r)},selectChild:function(t){return this.select(null==t?u:function(t){return function(){return l.call(this.children,t)}}("function"==typeof t?t:a(t)))},selectChildren:function(t){return this.selectAll(null==t?h:function(t){return function(){return c.call(this.children,t)}}("function"==typeof t?t:a(t)))},filter:function(t){"function"!=typeof t&&(t=s(t));for(var n=this._groups,e=n.length,i=new Array(e),r=0;r<e;++r)for(var o,a=n[r],l=a.length,u=i[r]=[],c=0;c<l;++c)(o=a[c])&&t.call(o,o.__data__,c,a)&&u.push(o);return new ht(i,this._parents)},data:function(t,n){if(!arguments.length)return Array.from(this,g);var e,i=n?y:p,r=this._parents,o=this._groups;"function"!=typeof t&&(e=t,t=function(){return e});for(var s=o.length,a=new Array(s),l=new Array(s),u=new Array(s),c=0;c<s;++c){var h=r[c],f=o[c],d=f.length,m=v(t.call(h,h&&h.__data__,c,r)),_=m.length,x=l[c]=new Array(_),w=a[c]=new Array(_);i(h,f,x,w,u[c]=new Array(d),m,n);for(var b,k,$=0,C=0;$<_;++$)if(b=x[$]){for($>=C&&(C=$+1);!(k=w[C])&&++C<_;);b._next=k||null}}return(a=new ht(a,r))._enter=l,a._exit=u,a},enter:function(){return new ht(this._enter||this._groups.map(f),this._parents)},exit:function(){return new ht(this._exit||this._groups.map(f),this._parents)},join:function(t,n,e){var i=this.enter(),r=this,o=this.exit();return"function"==typeof t?(i=t(i))&&(i=i.selection()):i=i.append(t+""),null!=n&&(r=n(r))&&(r=r.selection()),null==e?o.remove():e(o),i&&r?i.merge(r).order():r},merge:function(t){for(var n=t.selection?t.selection():t,e=this._groups,i=n._groups,r=e.length,o=i.length,s=Math.min(r,o),a=new Array(r),l=0;l<s;++l)for(var u,c=e[l],h=i[l],f=c.length,d=a[l]=new Array(f),p=0;p<f;++p)(u=c[p]||h[p])&&(d[p]=u);for(;l<r;++l)a[l]=e[l];return new ht(a,this._parents)},selection:function(){return this},order:function(){for(var t=this._groups,n=-1,e=t.length;++n<e;)for(var i,r=t[n],o=r.length-1,s=r[o];--o>=0;)(i=r[o])&&(s&&4^i.compareDocumentPosition(s)&&s.parentNode.insertBefore(i,s),s=i);return this},sort:function(t){function n(n,e){return n&&e?t(n.__data__,e.__data__):!n-!e}t||(t=m);for(var e=this._groups,i=e.length,r=new Array(i),o=0;o<i;++o){for(var s,a=e[o],l=a.length,u=r[o]=new Array(l),c=0;c<l;++c)(s=a[c])&&(u[c]=s);u.sort(n)}return new ht(r,this._parents).order()},call:function(){var t=arguments[0];return arguments[0]=this,t.apply(null,arguments),this},nodes:function(){return Array.from(this)},node:function(){for(var t=this._groups,n=0,e=t.length;n<e;++n)for(var i=t[n],r=0,o=i.length;r<o;++r){var s=i[r];if(s)return s}return null},size:function(){let t=0;for(const n of this)++t;return t},empty:function(){return!this.node()},each:function(t){for(var n=this._groups,e=0,i=n.length;e<i;++e)for(var r,o=n[e],s=0,a=o.length;s<a;++s)(r=o[s])&&t.call(r,r.__data__,s,o);return this},attr:function(t,n){var e=w(t);if(arguments.length<2){var i=this.node();return e.local?i.getAttributeNS(e.space,e.local):i.getAttribute(e)}return this.each((null==n?e.local?k:b:"function"==typeof n?e.local?z:A:e.local?C:$)(e,n))},style:function(t,n,e){return arguments.length>1?this.each((null==n?M:"function"==typeof n?E:S)(t,n,null==e?"":e)):T(this.node(),t)},property:function(t,n){return arguments.length>1?this.each((null==n?L:"function"==typeof n?P:B)(t,n)):this.node()[t]},classed:function(t,n){var e=D(t+"");if(arguments.length<2){for(var i=R(this.node()),r=-1,o=e.length;++r<o;)if(!i.contains(e[r]))return!1;return!0}return this.each(("function"==typeof n?X:n?H:O)(e,n))},text:function(t){return arguments.length?this.each(null==t?j:("function"==typeof t?V:Y)(t)):this.node().textContent},html:function(t){return arguments.length?this.each(null==t?U:("function"==typeof t?K:G)(t)):this.node().innerHTML},raise:function(){return this.each(W)},lower:function(){return this.each(Q)},append:function(t){var n="function"==typeof t?t:tt(t);return this.select((function(){return this.appendChild(n.apply(this,arguments))}))},insert:function(t,n){var e="function"==typeof t?t:tt(t),r=null==n?nt:"function"==typeof n?n:i(n);return this.select((function(){return this.insertBefore(e.apply(this,arguments),r.apply(this,arguments)||null)}))},remove:function(){return this.each(et)},clone:function(t){return this.select(t?rt:it)},datum:function(t){return arguments.length?this.property("__data__",t):this.node().__data__},on:function(t,n,e){var i,r,o=function(t){return t.trim().split(/^|\s+/).map((function(t){var n="",e=t.indexOf(".");return e>=0&&(n=t.slice(e+1),t=t.slice(0,e)),{type:t,name:n}}))}(t+""),s=o.length;if(!(arguments.length<2)){for(a=n?st:ot,i=0;i<s;++i)this.each(a(o[i],n,e));return this}var a=this.node().__on;if(a)for(var l,u=0,c=a.length;u<c;++u)for(i=0,l=a[u];i<s;++i)if((r=o[i]).type===l.type&&r.name===l.name)return l.value},dispatch:function(t,n){return this.each(("function"==typeof n?ut:lt)(t,n))},[Symbol.iterator]:function*(){for(var t=this._groups,n=0,e=t.length;n<e;++n)for(var i,r=t[n],o=0,s=r.length;o<s;++o)(i=r[o])&&(yield i)}};var dt=ft,pt={value:()=>{}};function yt(){for(var t,n=0,e=arguments.length,i={};n<e;++n){if(!(t=arguments[n]+"")||t in i||/[\s.]/.test(t))throw new Error("illegal type: "+t);i[t]=[]}return new gt(i)}function gt(t){this._=t}function vt(t,n){for(var e,i=0,r=t.length;i<r;++i)if((e=t[i]).name===n)return e.value}function mt(t,n,e){for(var i=0,r=t.length;i<r;++i)if(t[i].name===n){t[i]=pt,t=t.slice(0,i).concat(t.slice(i+1));break}return null!=e&&t.push({name:n,value:e}),t}gt.prototype=yt.prototype={constructor:gt,on:function(t,n){var e,i,r=this._,o=(i=r,(t+"").trim().split(/^|\s+/).map((function(t){var n="",e=t.indexOf(".");if(e>=0&&(n=t.slice(e+1),t=t.slice(0,e)),t&&!i.hasOwnProperty(t))throw new Error("unknown type: "+t);return{type:t,name:n}}))),s=-1,a=o.length;if(!(arguments.length<2)){if(null!=n&&"function"!=typeof n)throw new Error("invalid callback: "+n);for(;++s<a;)if(e=(t=o[s]).type)r[e]=mt(r[e],t.name,n);else if(null==n)for(e in r)r[e]=mt(r[e],t.name,null);return this}for(;++s<a;)if((e=(t=o[s]).type)&&(e=vt(r[e],t.name)))return e},copy:function(){var t={},n=this._;for(var e in n)t[e]=n[e].slice();return new gt(t)},call:function(t,n){if((e=arguments.length-2)>0)for(var e,i,r=new Array(e),o=0;o<e;++o)r[o]=arguments[o+2];if(!this._.hasOwnProperty(t))throw new Error("unknown type: "+t);for(o=0,e=(i=this._[t]).length;o<e;++o)i[o].value.apply(n,r)},apply:function(t,n,e){if(!this._.hasOwnProperty(t))throw new Error("unknown type: "+t);for(var i=this._[t],r=0,o=i.length;r<o;++r)i[r].value.apply(n,e)}};var _t,xt,wt=yt,bt=0,kt=0,Ct=0,At=1e3,zt=0,Nt=0,Mt=0,St="object"==typeof performance&&performance.now?performance:Date,Et="object"==typeof window&&window.requestAnimationFrame?window.requestAnimationFrame.bind(window):function(t){setTimeout(t,17)};function Tt(){return Nt||(Et(Lt),Nt=St.now()+Mt)}function Lt(){Nt=0}function Bt(){this._call=this._time=this._next=null}function Pt(t,n,e){var i=new Bt;return i.restart(t,n,e),i}function Dt(){Nt=(zt=St.now())+Mt,bt=kt=0;try{!function(){Tt(),++bt;for(var t,n=_t;n;)(t=Nt-n._time)>=0&&n._call.call(void 0,t),n=n._next;--bt}()}finally{bt=0,function(){for(var t,n,e=_t,i=1/0;e;)e._call?(i>e._time&&(i=e._time),t=e,e=e._next):(n=e._next,e._next=null,e=t?t._next=n:_t=n);xt=t,qt(i)}(),Nt=0}}function Rt(){var t=St.now(),n=t-zt;n>At&&(Mt-=n,zt=t)}function qt(t){bt||(kt&&(kt=clearTimeout(kt)),t-Nt>24?(t<1/0&&(kt=setTimeout(Dt,t-St.now()-Mt)),Ct&&(Ct=clearInterval(Ct))):(Ct||(zt=St.now(),Ct=setInterval(Rt,At)),bt=1,Et(Dt)))}function Ft(t,n,e){var i=new Bt;return n=null==n?0:+n,i.restart((e=>{i.stop(),t(e+n)}),n,e),i}Bt.prototype=Pt.prototype={constructor:Bt,restart:function(t,n,e){if("function"!=typeof t)throw new TypeError("callback is not a function");e=(null==e?Tt():+e)+(null==n?0:+n),this._next||xt===this||(xt?xt._next=this:_t=this,xt=this),this._call=t,this._time=e,qt()},stop:function(){this._call&&(this._call=null,this._time=1/0,qt())}};var It=wt("start","end","cancel","interrupt"),Ht=[],Ot=0,Xt=3;function jt(t,n,e,i,r,o){var s=t.__transition;if(s){if(e in s)return}else t.__transition={};!function(t,n,e){var i,r=t.__transition;function o(l){var u,c,h,f;if(1!==e.state)return a();for(u in r)if((f=r[u]).name===e.name){if(f.state===Xt)return Ft(o);4===f.state?(f.state=6,f.timer.stop(),f.on.call("interrupt",t,t.__data__,f.index,f.group),delete r[u]):+u<n&&(f.state=6,f.timer.stop(),f.on.call("cancel",t,t.__data__,f.index,f.group),delete r[u])}if(Ft((function(){e.state===Xt&&(e.state=4,e.timer.restart(s,e.delay,e.time),s(l))})),e.state=2,e.on.call("start",t,t.__data__,e.index,e.group),2===e.state){for(e.state=Xt,i=new Array(h=e.tween.length),u=0,c=-1;u<h;++u)(f=e.tween[u].value.call(t,t.__data__,e.index,e.group))&&(i[++c]=f);i.length=c+1}}function s(n){for(var r=n<e.duration?e.ease.call(null,n/e.duration):(e.timer.restart(a),e.state=5,1),o=-1,s=i.length;++o<s;)i[o].call(t,r);5===e.state&&(e.on.call("end",t,t.__data__,e.index,e.group),a())}function a(){for(var i in e.state=6,e.timer.stop(),delete r[n],r)return;delete t.__transition}r[n]=e,e.timer=Pt((function(t){e.state=1,e.timer.restart(o,e.delay,e.time),e.delay<=t&&o(t-e.delay)}),0,e.time)}(t,e,{name:n,index:i,group:r,on:It,tween:Ht,time:o.time,delay:o.delay,duration:o.duration,ease:o.ease,timer:null,state:Ot})}function Yt(t,n){var e=Ut(t,n);if(e.state>Ot)throw new Error("too late; already scheduled");return e}function Vt(t,n){var e=Ut(t,n);if(e.state>Xt)throw new Error("too late; already running");return e}function Ut(t,n){var e=t.__transition;if(!e||!(e=e[n]))throw new Error("transition not found");return e}function Gt(t,n){var e,i,r,o=t.__transition,s=!0;if(o){for(r in n=null==n?null:n+"",o)(e=o[r]).name===n?(i=e.state>2&&e.state<5,e.state=6,e.timer.stop(),e.on.call(i?"interrupt":"cancel",t,t.__data__,e.index,e.group),delete o[r]):s=!1;s&&delete t.__transition}}function Kt(t,n){return t=+t,n=+n,function(e){return t*(1-e)+n*e}}var Wt,Qt=180/Math.PI,Zt={translateX:0,translateY:0,rotate:0,skewX:0,scaleX:1,scaleY:1};function Jt(t,n,e,i,r,o){var s,a,l;return(s=Math.sqrt(t*t+n*n))&&(t/=s,n/=s),(l=t*e+n*i)&&(e-=t*l,i-=n*l),(a=Math.sqrt(e*e+i*i))&&(e/=a,i/=a,l/=a),t*i<n*e&&(t=-t,n=-n,l=-l,s=-s),{translateX:r,translateY:o,rotate:Math.atan2(n,t)*Qt,skewX:Math.atan(l)*Qt,scaleX:s,scaleY:a}}function tn(t,n,e,i){function r(t){return t.length?t.pop()+" ":""}return function(o,s){var a=[],l=[];return o=t(o),s=t(s),function(t,i,r,o,s,a){if(t!==r||i!==o){var l=s.push("translate(",null,n,null,e);a.push({i:l-4,x:Kt(t,r)},{i:l-2,x:Kt(i,o)})}else(r||o)&&s.push("translate("+r+n+o+e)}(o.translateX,o.translateY,s.translateX,s.translateY,a,l),function(t,n,e,o){t!==n?(t-n>180?n+=360:n-t>180&&(t+=360),o.push({i:e.push(r(e)+"rotate(",null,i)-2,x:Kt(t,n)})):n&&e.push(r(e)+"rotate("+n+i)}(o.rotate,s.rotate,a,l),function(t,n,e,o){t!==n?o.push({i:e.push(r(e)+"skewX(",null,i)-2,x:Kt(t,n)}):n&&e.push(r(e)+"skewX("+n+i)}(o.skewX,s.skewX,a,l),function(t,n,e,i,o,s){if(t!==e||n!==i){var a=o.push(r(o)+"scale(",null,",",null,")");s.push({i:a-4,x:Kt(t,e)},{i:a-2,x:Kt(n,i)})}else 1===e&&1===i||o.push(r(o)+"scale("+e+","+i+")")}(o.scaleX,o.scaleY,s.scaleX,s.scaleY,a,l),o=s=null,function(t){for(var n,e=-1,i=l.length;++e<i;)a[(n=l[e]).i]=n.x(t);return a.join("")}}}var nn=tn((function(t){const n=new("function"==typeof DOMMatrix?DOMMatrix:WebKitCSSMatrix)(t+"");return n.isIdentity?Zt:Jt(n.a,n.b,n.c,n.d,n.e,n.f)}),"px, ","px)","deg)"),en=tn((function(t){return null==t?Zt:(Wt||(Wt=document.createElementNS("http://www.w3.org/2000/svg","g")),Wt.setAttribute("transform",t),(t=Wt.transform.baseVal.consolidate())?Jt((t=t.matrix).a,t.b,t.c,t.d,t.e,t.f):Zt)}),", ",")",")");function rn(t,n){var e,i;return function(){var r=Vt(this,t),o=r.tween;if(o!==e)for(var s=0,a=(i=e=o).length;s<a;++s)if(i[s].name===n){(i=i.slice()).splice(s,1);break}r.tween=i}}function on(t,n,e){var i,r;if("function"!=typeof e)throw new Error;return function(){var o=Vt(this,t),s=o.tween;if(s!==i){r=(i=s).slice();for(var a={name:n,value:e},l=0,u=r.length;l<u;++l)if(r[l].name===n){r[l]=a;break}l===u&&r.push(a)}o.tween=r}}function sn(t,n,e){var i=t._id;return t.each((function(){var t=Vt(this,i);(t.value||(t.value={}))[n]=e.apply(this,arguments)})),function(t){return Ut(t,i).value[n]}}function an(t,n,e){t.prototype=n.prototype=e,e.constructor=t}function ln(t,n){var e=Object.create(t.prototype);for(var i in n)e[i]=n[i];return e}function un(){}var cn=.7,hn=1/cn,fn="\\s*([+-]?\\d+)\\s*",dn="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)\\s*",pn="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)%\\s*",yn=/^#([0-9a-f]{3,8})$/,gn=new RegExp(`^rgb\\(${fn},${fn},${fn}\\)$`),vn=new RegExp(`^rgb\\(${pn},${pn},${pn}\\)$`),mn=new RegExp(`^rgba\\(${fn},${fn},${fn},${dn}\\)$`),_n=new RegExp(`^rgba\\(${pn},${pn},${pn},${dn}\\)$`),xn=new RegExp(`^hsl\\(${dn},${pn},${pn}\\)$`),wn=new RegExp(`^hsla\\(${dn},${pn},${pn},${dn}\\)$`),bn={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074};function kn(){return this.rgb().formatHex()}function $n(){return this.rgb().formatRgb()}function Cn(t){var n,e;return t=(t+"").trim().toLowerCase(),(n=yn.exec(t))?(e=n[1].length,n=parseInt(n[1],16),6===e?An(n):3===e?new Mn(n>>8&15|n>>4&240,n>>4&15|240&n,(15&n)<<4|15&n,1):8===e?zn(n>>24&255,n>>16&255,n>>8&255,(255&n)/255):4===e?zn(n>>12&15|n>>8&240,n>>8&15|n>>4&240,n>>4&15|240&n,((15&n)<<4|15&n)/255):null):(n=gn.exec(t))?new Mn(n[1],n[2],n[3],1):(n=vn.exec(t))?new Mn(255*n[1]/100,255*n[2]/100,255*n[3]/100,1):(n=mn.exec(t))?zn(n[1],n[2],n[3],n[4]):(n=_n.exec(t))?zn(255*n[1]/100,255*n[2]/100,255*n[3]/100,n[4]):(n=xn.exec(t))?Pn(n[1],n[2]/100,n[3]/100,1):(n=wn.exec(t))?Pn(n[1],n[2]/100,n[3]/100,n[4]):bn.hasOwnProperty(t)?An(bn[t]):"transparent"===t?new Mn(NaN,NaN,NaN,0):null}function An(t){return new Mn(t>>16&255,t>>8&255,255&t,1)}function zn(t,n,e,i){return i<=0&&(t=n=e=NaN),new Mn(t,n,e,i)}function Nn(t,n,e,i){return 1===arguments.length?((r=t)instanceof un||(r=Cn(r)),r?new Mn((r=r.rgb()).r,r.g,r.b,r.opacity):new Mn):new Mn(t,n,e,null==i?1:i);var r}function Mn(t,n,e,i){this.r=+t,this.g=+n,this.b=+e,this.opacity=+i}function Sn(){return`#${Bn(this.r)}${Bn(this.g)}${Bn(this.b)}`}function En(){const t=Tn(this.opacity);return`${1===t?"rgb(":"rgba("}${Ln(this.r)}, ${Ln(this.g)}, ${Ln(this.b)}${1===t?")":`, ${t})`}`}function Tn(t){return isNaN(t)?1:Math.max(0,Math.min(1,t))}function Ln(t){return Math.max(0,Math.min(255,Math.round(t)||0))}function Bn(t){return((t=Ln(t))<16?"0":"")+t.toString(16)}function Pn(t,n,e,i){return i<=0?t=n=e=NaN:e<=0||e>=1?t=n=NaN:n<=0&&(t=NaN),new Rn(t,n,e,i)}function Dn(t){if(t instanceof Rn)return new Rn(t.h,t.s,t.l,t.opacity);if(t instanceof un||(t=Cn(t)),!t)return new Rn;if(t instanceof Rn)return t;var n=(t=t.rgb()).r/255,e=t.g/255,i=t.b/255,r=Math.min(n,e,i),o=Math.max(n,e,i),s=NaN,a=o-r,l=(o+r)/2;return a?(s=n===o?(e-i)/a+6*(e<i):e===o?(i-n)/a+2:(n-e)/a+4,a/=l<.5?o+r:2-o-r,s*=60):a=l>0&&l<1?0:s,new Rn(s,a,l,t.opacity)}function Rn(t,n,e,i){this.h=+t,this.s=+n,this.l=+e,this.opacity=+i}function qn(t){return(t=(t||0)%360)<0?t+360:t}function Fn(t){return Math.max(0,Math.min(1,t||0))}function In(t,n,e){return 255*(t<60?n+(e-n)*t/60:t<180?e:t<240?n+(e-n)*(240-t)/60:n)}function Hn(t,n,e,i,r){var o=t*t,s=o*t;return((1-3*t+3*o-s)*n+(4-6*o+3*s)*e+(1+3*t+3*o-3*s)*i+s*r)/6}an(un,Cn,{copy(t){return Object.assign(new this.constructor,this,t)},displayable(){return this.rgb().displayable()},hex:kn,formatHex:kn,formatHex8:function(){return this.rgb().formatHex8()},formatHsl:function(){return Dn(this).formatHsl()},formatRgb:$n,toString:$n}),an(Mn,Nn,ln(un,{brighter(t){return t=null==t?hn:Math.pow(hn,t),new Mn(this.r*t,this.g*t,this.b*t,this.opacity)},darker(t){return t=null==t?cn:Math.pow(cn,t),new Mn(this.r*t,this.g*t,this.b*t,this.opacity)},rgb(){return this},clamp(){return new Mn(Ln(this.r),Ln(this.g),Ln(this.b),Tn(this.opacity))},displayable(){return-.5<=this.r&&this.r<255.5&&-.5<=this.g&&this.g<255.5&&-.5<=this.b&&this.b<255.5&&0<=this.opacity&&this.opacity<=1},hex:Sn,formatHex:Sn,formatHex8:function(){return`#${Bn(this.r)}${Bn(this.g)}${Bn(this.b)}${Bn(255*(isNaN(this.opacity)?1:this.opacity))}`},formatRgb:En,toString:En})),an(Rn,(function(t,n,e,i){return 1===arguments.length?Dn(t):new Rn(t,n,e,null==i?1:i)}),ln(un,{brighter(t){return t=null==t?hn:Math.pow(hn,t),new Rn(this.h,this.s,this.l*t,this.opacity)},darker(t){return t=null==t?cn:Math.pow(cn,t),new Rn(this.h,this.s,this.l*t,this.opacity)},rgb(){var t=this.h%360+360*(this.h<0),n=isNaN(t)||isNaN(this.s)?0:this.s,e=this.l,i=e+(e<.5?e:1-e)*n,r=2*e-i;return new Mn(In(t>=240?t-240:t+120,r,i),In(t,r,i),In(t<120?t+240:t-120,r,i),this.opacity)},clamp(){return new Rn(qn(this.h),Fn(this.s),Fn(this.l),Tn(this.opacity))},displayable(){return(0<=this.s&&this.s<=1||isNaN(this.s))&&0<=this.l&&this.l<=1&&0<=this.opacity&&this.opacity<=1},formatHsl(){const t=Tn(this.opacity);return`${1===t?"hsl(":"hsla("}${qn(this.h)}, ${100*Fn(this.s)}%, ${100*Fn(this.l)}%${1===t?")":`, ${t})`}`}}));var On=t=>()=>t;function Xn(t,n){var e=n-t;return e?function(t,n){return function(e){return t+e*n}}(t,e):On(isNaN(t)?n:t)}var jn=function t(n){var e=function(t){return 1==(t=+t)?Xn:function(n,e){return e-n?function(t,n,e){return t=Math.pow(t,e),n=Math.pow(n,e)-t,e=1/e,function(i){return Math.pow(t+i*n,e)}}(n,e,t):On(isNaN(n)?e:n)}}(n);function i(t,n){var i=e((t=Nn(t)).r,(n=Nn(n)).r),r=e(t.g,n.g),o=e(t.b,n.b),s=Xn(t.opacity,n.opacity);return function(n){return t.r=i(n),t.g=r(n),t.b=o(n),t.opacity=s(n),t+""}}return i.gamma=t,i}(1);function Yn(t){return function(n){var e,i,r=n.length,o=new Array(r),s=new Array(r),a=new Array(r);for(e=0;e<r;++e)i=Nn(n[e]),o[e]=i.r||0,s[e]=i.g||0,a[e]=i.b||0;return o=t(o),s=t(s),a=t(a),i.opacity=1,function(t){return i.r=o(t),i.g=s(t),i.b=a(t),i+""}}}Yn((function(t){var n=t.length-1;return function(e){var i=e<=0?e=0:e>=1?(e=1,n-1):Math.floor(e*n),r=t[i],o=t[i+1],s=i>0?t[i-1]:2*r-o,a=i<n-1?t[i+2]:2*o-r;return Hn((e-i/n)*n,s,r,o,a)}})),Yn((function(t){var n=t.length;return function(e){var i=Math.floor(((e%=1)<0?++e:e)*n),r=t[(i+n-1)%n],o=t[i%n],s=t[(i+1)%n],a=t[(i+2)%n];return Hn((e-i/n)*n,r,o,s,a)}}));var Vn=/[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g,Un=new RegExp(Vn.source,"g");function Gn(t,n){var e,i,r,o=Vn.lastIndex=Un.lastIndex=0,s=-1,a=[],l=[];for(t+="",n+="";(e=Vn.exec(t))&&(i=Un.exec(n));)(r=i.index)>o&&(r=n.slice(o,r),a[s]?a[s]+=r:a[++s]=r),(e=e[0])===(i=i[0])?a[s]?a[s]+=i:a[++s]=i:(a[++s]=null,l.push({i:s,x:Kt(e,i)})),o=Un.lastIndex;return o<n.length&&(r=n.slice(o),a[s]?a[s]+=r:a[++s]=r),a.length<2?l[0]?function(t){return function(n){return t(n)+""}}(l[0].x):function(t){return function(){return t}}(n):(n=l.length,function(t){for(var e,i=0;i<n;++i)a[(e=l[i]).i]=e.x(t);return a.join("")})}function Kn(t,n){var e;return("number"==typeof n?Kt:n instanceof Cn?jn:(e=Cn(n))?(n=e,jn):Gn)(t,n)}function Wn(t){return function(){this.removeAttribute(t)}}function Qn(t){return function(){this.removeAttributeNS(t.space,t.local)}}function Zn(t,n,e){var i,r,o=e+"";return function(){var s=this.getAttribute(t);return s===o?null:s===i?r:r=n(i=s,e)}}function Jn(t,n,e){var i,r,o=e+"";return function(){var s=this.getAttributeNS(t.space,t.local);return s===o?null:s===i?r:r=n(i=s,e)}}function te(t,n,e){var i,r,o;return function(){var s,a,l=e(this);if(null!=l)return(s=this.getAttribute(t))===(a=l+"")?null:s===i&&a===r?o:(r=a,o=n(i=s,l));this.removeAttribute(t)}}function ne(t,n,e){var i,r,o;return function(){var s,a,l=e(this);if(null!=l)return(s=this.getAttributeNS(t.space,t.local))===(a=l+"")?null:s===i&&a===r?o:(r=a,o=n(i=s,l));this.removeAttributeNS(t.space,t.local)}}function ee(t,n){var e,i;function r(){var r=n.apply(this,arguments);return r!==i&&(e=(i=r)&&function(t,n){return function(e){this.setAttributeNS(t.space,t.local,n.call(this,e))}}(t,r)),e}return r._value=n,r}function ie(t,n){var e,i;function r(){var r=n.apply(this,arguments);return r!==i&&(e=(i=r)&&function(t,n){return function(e){this.setAttribute(t,n.call(this,e))}}(t,r)),e}return r._value=n,r}function re(t,n){return function(){Yt(this,t).delay=+n.apply(this,arguments)}}function oe(t,n){return n=+n,function(){Yt(this,t).delay=n}}function se(t,n){return function(){Vt(this,t).duration=+n.apply(this,arguments)}}function ae(t,n){return n=+n,function(){Vt(this,t).duration=n}}var le=dt.prototype.constructor;function ue(t){return function(){this.style.removeProperty(t)}}var ce=0;function he(t,n,e,i){this._groups=t,this._parents=n,this._name=e,this._id=i}function fe(){return++ce}var de=dt.prototype;he.prototype=function(t){return dt().transition(t)}.prototype={constructor:he,select:function(t){var n=this._name,e=this._id;"function"!=typeof t&&(t=i(t));for(var r=this._groups,o=r.length,s=new Array(o),a=0;a<o;++a)for(var l,u,c=r[a],h=c.length,f=s[a]=new Array(h),d=0;d<h;++d)(l=c[d])&&(u=t.call(l,l.__data__,d,c))&&("__data__"in l&&(u.__data__=l.__data__),f[d]=u,jt(f[d],n,e,d,f,Ut(l,e)));return new he(s,this._parents,n,e)},selectAll:function(t){var n=this._name,e=this._id;"function"!=typeof t&&(t=o(t));for(var i=this._groups,r=i.length,s=[],a=[],l=0;l<r;++l)for(var u,c=i[l],h=c.length,f=0;f<h;++f)if(u=c[f]){for(var d,p=t.call(u,u.__data__,f,c),y=Ut(u,e),g=0,v=p.length;g<v;++g)(d=p[g])&&jt(d,n,e,g,p,y);s.push(p),a.push(u)}return new he(s,a,n,e)},selectChild:de.selectChild,selectChildren:de.selectChildren,filter:function(t){"function"!=typeof t&&(t=s(t));for(var n=this._groups,e=n.length,i=new Array(e),r=0;r<e;++r)for(var o,a=n[r],l=a.length,u=i[r]=[],c=0;c<l;++c)(o=a[c])&&t.call(o,o.__data__,c,a)&&u.push(o);return new he(i,this._parents,this._name,this._id)},merge:function(t){if(t._id!==this._id)throw new Error;for(var n=this._groups,e=t._groups,i=n.length,r=e.length,o=Math.min(i,r),s=new Array(i),a=0;a<o;++a)for(var l,u=n[a],c=e[a],h=u.length,f=s[a]=new Array(h),d=0;d<h;++d)(l=u[d]||c[d])&&(f[d]=l);for(;a<i;++a)s[a]=n[a];return new he(s,this._parents,this._name,this._id)},selection:function(){return new le(this._groups,this._parents)},transition:function(){for(var t=this._name,n=this._id,e=fe(),i=this._groups,r=i.length,o=0;o<r;++o)for(var s,a=i[o],l=a.length,u=0;u<l;++u)if(s=a[u]){var c=Ut(s,n);jt(s,t,e,u,a,{time:c.time+c.delay+c.duration,delay:0,duration:c.duration,ease:c.ease})}return new he(i,this._parents,t,e)},call:de.call,nodes:de.nodes,node:de.node,size:de.size,empty:de.empty,each:de.each,on:function(t,n){var e=this._id;return arguments.length<2?Ut(this.node(),e).on.on(t):this.each(function(t,n,e){var i,r,o=function(t){return(t+"").trim().split(/^|\s+/).every((function(t){var n=t.indexOf(".");return n>=0&&(t=t.slice(0,n)),!t||"start"===t}))}(n)?Yt:Vt;return function(){var s=o(this,t),a=s.on;a!==i&&(r=(i=a).copy()).on(n,e),s.on=r}}(e,t,n))},attr:function(t,n){var e=w(t),i="transform"===e?en:Kn;return this.attrTween(t,"function"==typeof n?(e.local?ne:te)(e,i,sn(this,"attr."+t,n)):null==n?(e.local?Qn:Wn)(e):(e.local?Jn:Zn)(e,i,n))},attrTween:function(t,n){var e="attr."+t;if(arguments.length<2)return(e=this.tween(e))&&e._value;if(null==n)return this.tween(e,null);if("function"!=typeof n)throw new Error;var i=w(t);return this.tween(e,(i.local?ee:ie)(i,n))},style:function(t,n,e){var i="transform"==(t+="")?nn:Kn;return null==n?this.styleTween(t,function(t,n){var e,i,r;return function(){var o=T(this,t),s=(this.style.removeProperty(t),T(this,t));return o===s?null:o===e&&s===i?r:r=n(e=o,i=s)}}(t,i)).on("end.style."+t,ue(t)):"function"==typeof n?this.styleTween(t,function(t,n,e){var i,r,o;return function(){var s=T(this,t),a=e(this),l=a+"";return null==a&&(this.style.removeProperty(t),l=a=T(this,t)),s===l?null:s===i&&l===r?o:(r=l,o=n(i=s,a))}}(t,i,sn(this,"style."+t,n))).each(function(t,n){var e,i,r,o,s="style."+n,a="end."+s;return function(){var l=Vt(this,t),u=l.on,c=null==l.value[s]?o||(o=ue(n)):void 0;u===e&&r===c||(i=(e=u).copy()).on(a,r=c),l.on=i}}(this._id,t)):this.styleTween(t,function(t,n,e){var i,r,o=e+"";return function(){var s=T(this,t);return s===o?null:s===i?r:r=n(i=s,e)}}(t,i,n),e).on("end.style."+t,null)},styleTween:function(t,n,e){var i="style."+(t+="");if(arguments.length<2)return(i=this.tween(i))&&i._value;if(null==n)return this.tween(i,null);if("function"!=typeof n)throw new Error;return this.tween(i,function(t,n,e){var i,r;function o(){var o=n.apply(this,arguments);return o!==r&&(i=(r=o)&&function(t,n,e){return function(i){this.style.setProperty(t,n.call(this,i),e)}}(t,o,e)),i}return o._value=n,o}(t,n,null==e?"":e))},text:function(t){return this.tween("text","function"==typeof t?function(t){return function(){var n=t(this);this.textContent=null==n?"":n}}(sn(this,"text",t)):function(t){return function(){this.textContent=t}}(null==t?"":t+""))},textTween:function(t){var n="text";if(arguments.length<1)return(n=this.tween(n))&&n._value;if(null==t)return this.tween(n,null);if("function"!=typeof t)throw new Error;return this.tween(n,function(t){var n,e;function i(){var i=t.apply(this,arguments);return i!==e&&(n=(e=i)&&function(t){return function(n){this.textContent=t.call(this,n)}}(i)),n}return i._value=t,i}(t))},remove:function(){return this.on("end.remove",function(t){return function(){var n=this.parentNode;for(var e in this.__transition)if(+e!==t)return;n&&n.removeChild(this)}}(this._id))},tween:function(t,n){var e=this._id;if(t+="",arguments.length<2){for(var i,r=Ut(this.node(),e).tween,o=0,s=r.length;o<s;++o)if((i=r[o]).name===t)return i.value;return null}return this.each((null==n?rn:on)(e,t,n))},delay:function(t){var n=this._id;return arguments.length?this.each(("function"==typeof t?re:oe)(n,t)):Ut(this.node(),n).delay},duration:function(t){var n=this._id;return arguments.length?this.each(("function"==typeof t?se:ae)(n,t)):Ut(this.node(),n).duration},ease:function(t){var n=this._id;return arguments.length?this.each(function(t,n){if("function"!=typeof n)throw new Error;return function(){Vt(this,t).ease=n}}(n,t)):Ut(this.node(),n).ease},easeVarying:function(t){if("function"!=typeof t)throw new Error;return this.each(function(t,n){return function(){var e=n.apply(this,arguments);if("function"!=typeof e)throw new Error;Vt(this,t).ease=e}}(this._id,t))},end:function(){var t,n,e=this,i=e._id,r=e.size();return new Promise((function(o,s){var a={value:s},l={value:function(){0==--r&&o()}};e.each((function(){var e=Vt(this,i),r=e.on;r!==t&&((n=(t=r).copy())._.cancel.push(a),n._.interrupt.push(a),n._.end.push(l)),e.on=n})),0===r&&o()}))},[Symbol.iterator]:de[Symbol.iterator]};var pe={time:null,delay:0,duration:250,ease:function(t){return((t*=2)<=1?t*t*t:(t-=2)*t*t+2)/2}};function ye(t,n){for(var e;!(e=t.__transition)||!(e=e[n]);)if(!(t=t.parentNode))throw new Error(`transition ${n} not found`);return e}dt.prototype.interrupt=function(t){return this.each((function(){Gt(this,t)}))},dt.prototype.transition=function(t){var n,e;t instanceof he?(n=t._id,t=t._name):(n=fe(),(e=pe).time=Tt(),t=null==t?null:t+"");for(var i=this._groups,r=i.length,o=0;o<r;++o)for(var s,a=i[o],l=a.length,u=0;u<l;++u)(s=a[u])&&jt(s,t,n,u,a,e||ye(s,n));return new he(i,this._parents,t,n)};const{abs:ge,max:ve,min:me}=Math;function _e(t){return{type:t}}function xe(t){return"string"==typeof t?new ht([[document.querySelector(t)]],[document.documentElement]):new ht([[t]],ct)}function we(t,n){if(t=function(t){let n;for(;n=t.sourceEvent;)t=n;return t}(t),void 0===n&&(n=t.currentTarget),n){var e=n.ownerSVGElement||n;if(e.createSVGPoint){var i=e.createSVGPoint();return i.x=t.clientX,i.y=t.clientY,[(i=i.matrixTransform(n.getScreenCTM().inverse())).x,i.y]}if(n.getBoundingClientRect){var r=n.getBoundingClientRect();return[t.clientX-r.left-n.clientLeft,t.clientY-r.top-n.clientTop]}}return[t.pageX,t.pageY]}["w","e"].map(_e),["n","s"].map(_e),["n","w","e","s","nw","ne","sw","se"].map(_e);const be={passive:!1},ke={capture:!0,passive:!1};function $e(t){t.stopImmediatePropagation()}function Ce(t){t.preventDefault(),t.stopImmediatePropagation()}function Ae(t){var n=t.document.documentElement,e=xe(t).on("dragstart.drag",Ce,ke);"onselectstart"in n?e.on("selectstart.drag",Ce,ke):(n.__noselect=n.style.MozUserSelect,n.style.MozUserSelect="none")}function ze(t,n){var e=t.document.documentElement,i=xe(t).on("dragstart.drag",null);n&&(i.on("click.drag",Ce,ke),setTimeout((function(){i.on("click.drag",null)}),0)),"onselectstart"in e?i.on("selectstart.drag",null):(e.style.MozUserSelect=e.__noselect,delete e.__noselect)}var Ne=t=>()=>t;function Me(t,{sourceEvent:n,subject:e,target:i,identifier:r,active:o,x:s,y:a,dx:l,dy:u,dispatch:c}){Object.defineProperties(this,{type:{value:t,enumerable:!0,configurable:!0},sourceEvent:{value:n,enumerable:!0,configurable:!0},subject:{value:e,enumerable:!0,configurable:!0},target:{value:i,enumerable:!0,configurable:!0},identifier:{value:r,enumerable:!0,configurable:!0},active:{value:o,enumerable:!0,configurable:!0},x:{value:s,enumerable:!0,configurable:!0},y:{value:a,enumerable:!0,configurable:!0},dx:{value:l,enumerable:!0,configurable:!0},dy:{value:u,enumerable:!0,configurable:!0},_:{value:c}})}function Se(t){return!t.ctrlKey&&!t.button}function Ee(){return this.parentNode}function Te(t,n){return null==n?{x:t.x,y:t.y}:n}function Le(){return navigator.maxTouchPoints||"ontouchstart"in this}function Be(t){return function(){return t}}function Pe(t){return 1e-6*(t()-.5)}function De(t){return t.index}function Re(t,n){var e=t.get(n);if(!e)throw new Error("node not found: "+n);return e}function qe(t,n,e,i){if(isNaN(n)||isNaN(e))return t;var r,o,s,a,l,u,c,h,f,d=t._root,p={data:i},y=t._x0,g=t._y0,v=t._x1,m=t._y1;if(!d)return t._root=p,t;for(;d.length;)if((u=n>=(o=(y+v)/2))?y=o:v=o,(c=e>=(s=(g+m)/2))?g=s:m=s,r=d,!(d=d[h=c<<1|u]))return r[h]=p,t;if(a=+t._x.call(null,d.data),l=+t._y.call(null,d.data),n===a&&e===l)return p.next=d,r?r[h]=p:t._root=p,t;do{r=r?r[h]=new Array(4):t._root=new Array(4),(u=n>=(o=(y+v)/2))?y=o:v=o,(c=e>=(s=(g+m)/2))?g=s:m=s}while((h=c<<1|u)==(f=(l>=s)<<1|a>=o));return r[f]=d,r[h]=p,t}function Fe(t,n,e,i,r){this.node=t,this.x0=n,this.y0=e,this.x1=i,this.y1=r}function Ie(t){return t[0]}function He(t){return t[1]}function Oe(t,n,e){var i=new Xe(null==n?Ie:n,null==e?He:e,NaN,NaN,NaN,NaN);return null==t?i:i.addAll(t)}function Xe(t,n,e,i,r,o){this._x=t,this._y=n,this._x0=e,this._y0=i,this._x1=r,this._y1=o,this._root=void 0}function je(t){for(var n={data:t.data},e=n;t=t.next;)e=e.next={data:t.data};return n}Me.prototype.on=function(){var t=this._.on.apply(this._,arguments);return t===this._?this:t};var Ye=Oe.prototype=Xe.prototype;Ye.copy=function(){var t,n,e=new Xe(this._x,this._y,this._x0,this._y0,this._x1,this._y1),i=this._root;if(!i)return e;if(!i.length)return e._root=je(i),e;for(t=[{source:i,target:e._root=new Array(4)}];i=t.pop();)for(var r=0;r<4;++r)(n=i.source[r])&&(n.length?t.push({source:n,target:i.target[r]=new Array(4)}):i.target[r]=je(n));return e},Ye.add=function(t){const n=+this._x.call(null,t),e=+this._y.call(null,t);return qe(this.cover(n,e),n,e,t)},Ye.addAll=function(t){var n,e,i,r,o=t.length,s=new Array(o),a=new Array(o),l=1/0,u=1/0,c=-1/0,h=-1/0;for(e=0;e<o;++e)isNaN(i=+this._x.call(null,n=t[e]))||isNaN(r=+this._y.call(null,n))||(s[e]=i,a[e]=r,i<l&&(l=i),i>c&&(c=i),r<u&&(u=r),r>h&&(h=r));if(l>c||u>h)return this;for(this.cover(l,u).cover(c,h),e=0;e<o;++e)qe(this,s[e],a[e],t[e]);return this},Ye.cover=function(t,n){if(isNaN(t=+t)||isNaN(n=+n))return this;var e=this._x0,i=this._y0,r=this._x1,o=this._y1;if(isNaN(e))r=(e=Math.floor(t))+1,o=(i=Math.floor(n))+1;else{for(var s,a,l=r-e||1,u=this._root;e>t||t>=r||i>n||n>=o;)switch(a=(n<i)<<1|t<e,(s=new Array(4))[a]=u,u=s,l*=2,a){case 0:r=e+l,o=i+l;break;case 1:e=r-l,o=i+l;break;case 2:r=e+l,i=o-l;break;case 3:e=r-l,i=o-l}this._root&&this._root.length&&(this._root=u)}return this._x0=e,this._y0=i,this._x1=r,this._y1=o,this},Ye.data=function(){var t=[];return this.visit((function(n){if(!n.length)do{t.push(n.data)}while(n=n.next)})),t},Ye.extent=function(t){return arguments.length?this.cover(+t[0][0],+t[0][1]).cover(+t[1][0],+t[1][1]):isNaN(this._x0)?void 0:[[this._x0,this._y0],[this._x1,this._y1]]},Ye.find=function(t,n,e){var i,r,o,s,a,l,u,c=this._x0,h=this._y0,f=this._x1,d=this._y1,p=[],y=this._root;for(y&&p.push(new Fe(y,c,h,f,d)),null==e?e=1/0:(c=t-e,h=n-e,f=t+e,d=n+e,e*=e);l=p.pop();)if(!(!(y=l.node)||(r=l.x0)>f||(o=l.y0)>d||(s=l.x1)<c||(a=l.y1)<h))if(y.length){var g=(r+s)/2,v=(o+a)/2;p.push(new Fe(y[3],g,v,s,a),new Fe(y[2],r,v,g,a),new Fe(y[1],g,o,s,v),new Fe(y[0],r,o,g,v)),(u=(n>=v)<<1|t>=g)&&(l=p[p.length-1],p[p.length-1]=p[p.length-1-u],p[p.length-1-u]=l)}else{var m=t-+this._x.call(null,y.data),_=n-+this._y.call(null,y.data),x=m*m+_*_;if(x<e){var w=Math.sqrt(e=x);c=t-w,h=n-w,f=t+w,d=n+w,i=y.data}}return i},Ye.remove=function(t){if(isNaN(o=+this._x.call(null,t))||isNaN(s=+this._y.call(null,t)))return this;var n,e,i,r,o,s,a,l,u,c,h,f,d=this._root,p=this._x0,y=this._y0,g=this._x1,v=this._y1;if(!d)return this;if(d.length)for(;;){if((u=o>=(a=(p+g)/2))?p=a:g=a,(c=s>=(l=(y+v)/2))?y=l:v=l,n=d,!(d=d[h=c<<1|u]))return this;if(!d.length)break;(n[h+1&3]||n[h+2&3]||n[h+3&3])&&(e=n,f=h)}for(;d.data!==t;)if(i=d,!(d=d.next))return this;return(r=d.next)&&delete d.next,i?(r?i.next=r:delete i.next,this):n?(r?n[h]=r:delete n[h],(d=n[0]||n[1]||n[2]||n[3])&&d===(n[3]||n[2]||n[1]||n[0])&&!d.length&&(e?e[f]=d:this._root=d),this):(this._root=r,this)},Ye.removeAll=function(t){for(var n=0,e=t.length;n<e;++n)this.remove(t[n]);return this},Ye.root=function(){return this._root},Ye.size=function(){var t=0;return this.visit((function(n){if(!n.length)do{++t}while(n=n.next)})),t},Ye.visit=function(t){var n,e,i,r,o,s,a=[],l=this._root;for(l&&a.push(new Fe(l,this._x0,this._y0,this._x1,this._y1));n=a.pop();)if(!t(l=n.node,i=n.x0,r=n.y0,o=n.x1,s=n.y1)&&l.length){var u=(i+o)/2,c=(r+s)/2;(e=l[3])&&a.push(new Fe(e,u,c,o,s)),(e=l[2])&&a.push(new Fe(e,i,c,u,s)),(e=l[1])&&a.push(new Fe(e,u,r,o,c)),(e=l[0])&&a.push(new Fe(e,i,r,u,c))}return this},Ye.visitAfter=function(t){var n,e=[],i=[];for(this._root&&e.push(new Fe(this._root,this._x0,this._y0,this._x1,this._y1));n=e.pop();){var r=n.node;if(r.length){var o,s=n.x0,a=n.y0,l=n.x1,u=n.y1,c=(s+l)/2,h=(a+u)/2;(o=r[0])&&e.push(new Fe(o,s,a,c,h)),(o=r[1])&&e.push(new Fe(o,c,a,l,h)),(o=r[2])&&e.push(new Fe(o,s,h,c,u)),(o=r[3])&&e.push(new Fe(o,c,h,l,u))}i.push(n)}for(;n=i.pop();)t(n.node,n.x0,n.y0,n.x1,n.y1);return this},Ye.x=function(t){return arguments.length?(this._x=t,this):this._x},Ye.y=function(t){return arguments.length?(this._y=t,this):this._y};const Ve=4294967296;function Ue(t){return t.x}function Ge(t){return t.y}var Ke=Math.PI*(3-Math.sqrt(5));function We(t){var n=0,e=t.children,i=e&&e.length;if(i)for(;--i>=0;)n+=e[i].value;else n=1;t.value=n}function Qe(t,n){t instanceof Map?(t=[void 0,t],void 0===n&&(n=Je)):void 0===n&&(n=Ze);for(var e,i,r,o,s,a=new ei(t),l=[a];e=l.pop();)if((r=n(e.data))&&(s=(r=Array.from(r)).length))for(e.children=r,o=s-1;o>=0;--o)l.push(i=r[o]=new ei(r[o])),i.parent=e,i.depth=e.depth+1;return a.eachBefore(ni)}function Ze(t){return t.children}function Je(t){return Array.isArray(t)?t[1]:null}function ti(t){void 0!==t.data.value&&(t.value=t.data.value),t.data=t.data.data}function ni(t){var n=0;do{t.height=n}while((t=t.parent)&&t.height<++n)}function ei(t){this.data=t,this.depth=this.height=0,this.parent=null}function ii(t,n){return t.parent===n.parent?1:2}function ri(t){var n=t.children;return n?n[0]:t.t}function oi(t){var n=t.children;return n?n[n.length-1]:t.t}function si(t,n,e){var i=e/(n.i-t.i);n.c-=i,n.s+=e,t.c+=i,n.z+=e,n.m+=e}function ai(t,n,e){return t.a.parent===n.parent?t.a:e}function li(t,n){this._=t,this.parent=null,this.children=null,this.A=null,this.a=this,this.z=0,this.m=0,this.c=0,this.s=0,this.t=null,this.i=n}ei.prototype=Qe.prototype={constructor:ei,count:function(){return this.eachAfter(We)},each:function(t,n){let e=-1;for(const i of this)t.call(n,i,++e,this);return this},eachAfter:function(t,n){for(var e,i,r,o=this,s=[o],a=[],l=-1;o=s.pop();)if(a.push(o),e=o.children)for(i=0,r=e.length;i<r;++i)s.push(e[i]);for(;o=a.pop();)t.call(n,o,++l,this);return this},eachBefore:function(t,n){for(var e,i,r=this,o=[r],s=-1;r=o.pop();)if(t.call(n,r,++s,this),e=r.children)for(i=e.length-1;i>=0;--i)o.push(e[i]);return this},find:function(t,n){let e=-1;for(const i of this)if(t.call(n,i,++e,this))return i},sum:function(t){return this.eachAfter((function(n){for(var e=+t(n.data)||0,i=n.children,r=i&&i.length;--r>=0;)e+=i[r].value;n.value=e}))},sort:function(t){return this.eachBefore((function(n){n.children&&n.children.sort(t)}))},path:function(t){for(var n=this,e=function(t,n){if(t===n)return t;var e=t.ancestors(),i=n.ancestors(),r=null;for(t=e.pop(),n=i.pop();t===n;)r=t,t=e.pop(),n=i.pop();return r}(n,t),i=[n];n!==e;)n=n.parent,i.push(n);for(var r=i.length;t!==e;)i.splice(r,0,t),t=t.parent;return i},ancestors:function(){for(var t=this,n=[t];t=t.parent;)n.push(t);return n},descendants:function(){return Array.from(this)},leaves:function(){var t=[];return this.eachBefore((function(n){n.children||t.push(n)})),t},links:function(){var t=this,n=[];return t.each((function(e){e!==t&&n.push({source:e.parent,target:e})})),n},copy:function(){return Qe(this).eachBefore(ti)},[Symbol.iterator]:function*(){var t,n,e,i,r=this,o=[r];do{for(t=o.reverse(),o=[];r=t.pop();)if(yield r,n=r.children)for(e=0,i=n.length;e<i;++e)o.push(n[e])}while(o.length)}},li.prototype=Object.create(ei.prototype);class ui extends Map{constructor(t,n=hi){if(super(),Object.defineProperties(this,{_intern:{value:new Map},_key:{value:n}}),null!=t)for(const[n,e]of t)this.set(n,e)}get(t){return super.get(ci(this,t))}has(t){return super.has(ci(this,t))}set(t,n){return super.set(function({_intern:t,_key:n},e){const i=n(e);return t.has(i)?t.get(i):(t.set(i,e),e)}(this,t),n)}delete(t){return super.delete(function({_intern:t,_key:n},e){const i=n(e);return t.has(i)&&(e=t.get(i),t.delete(i)),e}(this,t))}}function ci({_intern:t,_key:n},e){const i=n(e);return t.has(i)?t.get(i):e}function hi(t){return null!==t&&"object"==typeof t?t.valueOf():t}function fi(t,n){switch(arguments.length){case 0:break;case 1:this.range(t);break;default:this.range(n).domain(t)}return this}const di=Symbol("implicit");function pi(){var t=new ui,n=[],e=[],i=di;function r(r){let o=t.get(r);if(void 0===o){if(i!==di)return i;t.set(r,o=n.push(r)-1)}return e[o%e.length]}return r.domain=function(e){if(!arguments.length)return n.slice();n=[],t=new ui;for(const i of e)t.has(i)||t.set(i,n.push(i)-1);return r},r.range=function(t){return arguments.length?(e=Array.from(t),r):e.slice()},r.unknown=function(t){return arguments.length?(i=t,r):i},r.copy=function(){return pi(n,e).unknown(i)},fi.apply(r,arguments),r}var yi=function(t){for(var n=new Array(12),e=0;e<12;)n[e]="#"+t.slice(6*e,6*++e);return n}("a6cee31f78b4b2df8a33a02cfb9a99e31a1cfdbf6fff7f00cab2d66a3d9affff99b15928");function gi(t){return function(){return t}}function vi(t){this._context=t}function mi(t){return new vi(t)}Array.prototype.slice,vi.prototype={areaStart:function(){this._line=0},areaEnd:function(){this._line=NaN},lineStart:function(){this._point=0},lineEnd:function(){(this._line||0!==this._line&&1===this._point)&&this._context.closePath(),this._line=1-this._line},point:function(t,n){switch(t=+t,n=+n,this._point){case 0:this._point=1,this._line?this._context.lineTo(t,n):this._context.moveTo(t,n);break;case 1:this._point=2;default:this._context.lineTo(t,n)}}};const _i=Math.PI,xi=2*_i,wi=1e-6,bi=xi-wi;function ki(t){this._+=t[0];for(let n=1,e=t.length;n<e;++n)this._+=arguments[n]+t[n]}class $i{constructor(t){this._x0=this._y0=this._x1=this._y1=null,this._="",this._append=null==t?ki:function(t){let n=Math.floor(t);if(!(n>=0))throw new Error(`invalid digits: ${t}`);if(n>15)return ki;const e=10**n;return function(t){this._+=t[0];for(let n=1,i=t.length;n<i;++n)this._+=Math.round(arguments[n]*e)/e+t[n]}}(t)}moveTo(t,n){this._append`M${this._x0=this._x1=+t},${this._y0=this._y1=+n}`}closePath(){null!==this._x1&&(this._x1=this._x0,this._y1=this._y0,this._append`Z`)}lineTo(t,n){this._append`L${this._x1=+t},${this._y1=+n}`}quadraticCurveTo(t,n,e,i){this._append`Q${+t},${+n},${this._x1=+e},${this._y1=+i}`}bezierCurveTo(t,n,e,i,r,o){this._append`C${+t},${+n},${+e},${+i},${this._x1=+r},${this._y1=+o}`}arcTo(t,n,e,i,r){if(t=+t,n=+n,e=+e,i=+i,(r=+r)<0)throw new Error(`negative radius: ${r}`);let o=this._x1,s=this._y1,a=e-t,l=i-n,u=o-t,c=s-n,h=u*u+c*c;if(null===this._x1)this._append`M${this._x1=t},${this._y1=n}`;else if(h>wi)if(Math.abs(c*a-l*u)>wi&&r){let f=e-o,d=i-s,p=a*a+l*l,y=f*f+d*d,g=Math.sqrt(p),v=Math.sqrt(h),m=r*Math.tan((_i-Math.acos((p+h-y)/(2*g*v)))/2),_=m/v,x=m/g;Math.abs(_-1)>wi&&this._append`L${t+_*u},${n+_*c}`,this._append`A${r},${r},0,0,${+(c*f>u*d)},${this._x1=t+x*a},${this._y1=n+x*l}`}else this._append`L${this._x1=t},${this._y1=n}`}arc(t,n,e,i,r,o){if(t=+t,n=+n,o=!!o,(e=+e)<0)throw new Error(`negative radius: ${e}`);let s=e*Math.cos(i),a=e*Math.sin(i),l=t+s,u=n+a,c=1^o,h=o?i-r:r-i;null===this._x1?this._append`M${l},${u}`:(Math.abs(this._x1-l)>wi||Math.abs(this._y1-u)>wi)&&this._append`L${l},${u}`,e&&(h<0&&(h=h%xi+xi),h>bi?this._append`A${e},${e},0,1,${c},${t-s},${n-a}A${e},${e},0,1,${c},${this._x1=l},${this._y1=u}`:h>wi&&this._append`A${e},${e},0,${+(h>=_i)},${c},${this._x1=t+e*Math.cos(r)},${this._y1=n+e*Math.sin(r)}`)}rect(t,n,e,i){this._append`M${this._x0=this._x1=+t},${this._y0=this._y1=+n}h${e=+e}v${+i}h${-e}Z`}toString(){return this._}}function Ci(t){return t[0]}function Ai(t){return t[1]}class zi{constructor(t,n){this._context=t,this._x=n}areaStart(){this._line=0}areaEnd(){this._line=NaN}lineStart(){this._point=0}lineEnd(){(this._line||0!==this._line&&1===this._point)&&this._context.closePath(),this._line=1-this._line}point(t,n){switch(t=+t,n=+n,this._point){case 0:this._point=1,this._line?this._context.lineTo(t,n):this._context.moveTo(t,n);break;case 1:this._point=2;default:this._x?this._context.bezierCurveTo(this._x0=(this._x0+t)/2,this._y0,this._x0,n,t,n):this._context.bezierCurveTo(this._x0,this._y0=(this._y0+n)/2,t,this._y0,t,n)}this._x0=t,this._y0=n}}function Ni(t){return new zi(t,!1)}function Mi(t){return((t=Math.exp(t))+1/t)/2}var Si=function t(n,e,i){function r(t,r){var o,s,a=t[0],l=t[1],u=t[2],c=r[0],h=r[1],f=r[2],d=c-a,p=h-l,y=d*d+p*p;if(y<1e-12)s=Math.log(f/u)/n,o=function(t){return[a+t*d,l+t*p,u*Math.exp(n*t*s)]};else{var g=Math.sqrt(y),v=(f*f-u*u+i*y)/(2*u*e*g),m=(f*f-u*u-i*y)/(2*f*e*g),_=Math.log(Math.sqrt(v*v+1)-v),x=Math.log(Math.sqrt(m*m+1)-m);s=(x-_)/n,o=function(t){var i,r=t*s,o=Mi(_),c=u/(e*g)*(o*(i=n*r+_,((i=Math.exp(2*i))-1)/(i+1))-function(t){return((t=Math.exp(t))-1/t)/2}(_));return[a+c*d,l+c*p,u*o/Mi(n*r+_)]}}return o.duration=1e3*s*n/Math.SQRT2,o}return r.rho=function(n){var e=Math.max(.001,+n),i=e*e;return t(e,i,i*i)},r}(Math.SQRT2,2,4),Ei=t=>()=>t;function Ti(t,{sourceEvent:n,target:e,transform:i,dispatch:r}){Object.defineProperties(this,{type:{value:t,enumerable:!0,configurable:!0},sourceEvent:{value:n,enumerable:!0,configurable:!0},target:{value:e,enumerable:!0,configurable:!0},transform:{value:i,enumerable:!0,configurable:!0},_:{value:r}})}function Li(t,n,e){this.k=t,this.x=n,this.y=e}Li.prototype={constructor:Li,scale:function(t){return 1===t?this:new Li(this.k*t,this.x,this.y)},translate:function(t,n){return 0===t&0===n?this:new Li(this.k,this.x+this.k*t,this.y+this.k*n)},apply:function(t){return[t[0]*this.k+this.x,t[1]*this.k+this.y]},applyX:function(t){return t*this.k+this.x},applyY:function(t){return t*this.k+this.y},invert:function(t){return[(t[0]-this.x)/this.k,(t[1]-this.y)/this.k]},invertX:function(t){return(t-this.x)/this.k},invertY:function(t){return(t-this.y)/this.k},rescaleX:function(t){return t.copy().domain(t.range().map(this.invertX,this).map(t.invert,t))},rescaleY:function(t){return t.copy().domain(t.range().map(this.invertY,this).map(t.invert,t))},toString:function(){return"translate("+this.x+","+this.y+") scale("+this.k+")"}};var Bi=new Li(1,0,0);function Pi(t){t.stopImmediatePropagation()}function Di(t){t.preventDefault(),t.stopImmediatePropagation()}function Ri(t){return!(t.ctrlKey&&"wheel"!==t.type||t.button)}function qi(){var t=this;return t instanceof SVGElement?(t=t.ownerSVGElement||t).hasAttribute("viewBox")?[[(t=t.viewBox.baseVal).x,t.y],[t.x+t.width,t.y+t.height]]:[[0,0],[t.width.baseVal.value,t.height.baseVal.value]]:[[0,0],[t.clientWidth,t.clientHeight]]}function Fi(){return this.__zoom||Bi}function Ii(t){return-t.deltaY*(1===t.deltaMode?.05:t.deltaMode?1:.002)*(t.ctrlKey?10:1)}function Hi(){return navigator.maxTouchPoints||"ontouchstart"in this}function Oi(t,n,e){var i=t.invertX(n[0][0])-e[0][0],r=t.invertX(n[1][0])-e[1][0],o=t.invertY(n[0][1])-e[0][1],s=t.invertY(n[1][1])-e[1][1];return t.translate(r>i?(i+r)/2:Math.min(0,i)||Math.max(0,r),s>o?(o+s)/2:Math.min(0,o)||Math.max(0,s))}Li.prototype;var Xi={data(){return{suffix:kadi.utils.randomAlnum(),svg:null,legendContainer:null,graphContainer:null,linksContainer:null,nodesContainer:null,simulation:null,zoom:null,width:0,height:0,manyBodyStrength:-2e3,linkStrength:.25,forceDisabled:!1,labelsHidden:!1,initialized:!1,loading:!0,nodes:[],links:[],excludedTypes:[],excludedRecords:[],excludedCollections:[],fontFamily:"Arial, Helvetica, sans-serif",types:{record:"record",collection:"collection"},forces:{charge:"charge",link:"link",x:"x",y:"y"},displays:{inline:"inline",none:"none"},colors:{link:"#c9c9c9",linkFocus:"#8a8a8a",text:"black",textFocus:"#2c3e50"},prefixes:{graph:"graph",node:"node",nodeLabel:"node-label",controls:"controls",link:"link",linkLabel:"link-label",linkPath:"link-path",arrowHead:"arrow-head",arrowHeadFocus:"arrow-head-focus",iconGraph:"icon-graph",iconDown:"icon-down",iconUp:"icon-up"},icons:{graph:"M10.609,4.004c0.896-0.21,1.563-1.015,1.563-1.976C12.173,0.908,11.266,0,10.145,0C9.043,0,8.149,0.875,\n                8.115,1.965 L3.454,3.832C3.086,3.469,2.583,3.246,2.029,3.246C0.908,3.246,0,4.154,0,5.275c0,1.122,0.908,\n                2.029,2.029,2.029 c0.31,0,0.604-0.068,0.865-0.192l3.692,3.231c-0.061,0.192-0.093,0.398-0.093,0.614c0,\n                1.119,0.908,2.027,2.03,2.027 c1.119,0,2.027-0.908,2.027-2.027c0-0.704-0.354-1.324-0.897-1.686L10.609,\n                4.004L10.609,4.004z M3.964,5.889 C4.02,5.713,4.052,5.528,4.058,5.338l4.661-1.864c0.092,0.088,0.188,0.17,\n                0.295,0.241l-0.96,5.263 c-0.138,0.034-0.274,0.08-0.399,0.141L3.964,5.889z",down:"M5.724,5.75c0.422-0.42,1.106-0.42,1.529,0l5.403,5.403c0.423,0.424,0.423,1.109,0,1.53c-0.422,0.425-1.107,\n               0.425-1.53,0 L6.487,8.044L1.846,12.68c-0.422,0.422-1.107,0.422-1.529,0c-0.422-0.422-0.422-1.105,\n               0-1.529l5.404-5.403L5.724,5.75z",up:"M5.723,7.654c0.422,0.421,1.107,0.421,1.529,0l5.404-5.404c0.421-0.422,0.421-1.107,0-1.529\n             c-0.424-0.422-1.106-0.422-1.53,0L6.486,5.36l-4.64-4.636c-0.422-0.422-1.107-0.422-1.529,0c-0.422,\n             0.422-0.422,1.107,0,1.53 L5.72,7.657L5.723,7.654z"}}},props:{endpoint:String,filter:{type:String,default:""},isRendered:{type:Boolean,default:!0}},computed:{toolbarBtnClasses(){return"btn btn-link text-primary"}},watch:{isRendered(){this.resizeView(this.$refs.container,this.$refs.svgContainer)},filter(){this.filterNodes()},forceDisabled(){this.forceDisabled?(this.simulation.force(this.forces.charge).strength(0),this.simulation.force(this.forces.link).strength(0),this.disableForces()):(this.simulation.force(this.forces.charge).strength(this.manyBodyStrength),this.simulation.force(this.forces.link).strength(this.linkStrength),this.enableForces(),this.simulation.alpha(.5).restart())}},methods:{getStartNode(){return null},disableForces(){},enableForces(){},toggleFullscreen(){kadi.utils.toggleFullscreen(this.$refs.container)},b64EncodeUnicode(t){return window.btoa(window.encodeURIComponent(t).replace(/%([0-9A-F]{2})/g,((t,n)=>String.fromCharCode(`0x${n}`))))},downloadGraph(){const t=this.svg.node().cloneNode(!0),n=t.getElementById(`${this.prefixes.graph}-${this.suffix}`),e=this.graphContainer.node().getBBox(),i=this.legendContainer.node().getBBox();t.setAttribute("width",e.width+60+i.width),t.setAttribute("height",Math.max(e.height+60,i.height));const r=30-e.x+i.width,o=30-e.y;n.setAttribute("transform",`translate(${r},${o}) scale(1)`);const s=`<?xml version="1.0" encoding="utf-8"?>${(new XMLSerializer).serializeToString(t)}`,a=`data:image/svg+xml;base64,${this.b64EncodeUnicode(s)}`,l=this.getStartNode(),u=`${l?l.identifier_full:"graph"}.svg`,c=document.createElement("a");c.href=a,c.download=u,document.body.appendChild(c),c.click(),document.body.removeChild(c)},resizeView(t,n){this.isRendered&&(this.width=t.getBoundingClientRect().width-2,this.height=Math.round(window.innerHeight/window.innerWidth*this.width),kadi.utils.isFullscreen()?(n.style.height="100vh",t.style.borderRadius="0"):(n.style.height=`${this.height}px`,t.style.borderRadius="0.25rem"),this.svg.attr("width",this.width).attr("height",this.height))},resetView(){const t=this.getStartNode(),n=null===t?0:t.fx||0,e=null===t?0:t.fy||0;this.zoom.translateTo(this.svg,n,e,[.5*this.width,.5*this.height]),this.zoom.scaleTo(this.svg,1)},toggleLabels(){this.labelsHidden=!this.labelsHidden,this.graphContainer.selectAll(`.${this.prefixes.nodeLabel}-${this.suffix},.${this.prefixes.linkLabel}-${this.suffix}`).each(((t,n,e)=>{xe(e[n]).attr("display",this.labelsHidden?this.displays.none:this.displays.inline)}))},getBezierPoints(t){const n=t.target.x-t.source.x,e=t.target.y-t.source.y;return{x1:t.source.x,y1:t.source.y,x2:t.source.x+n/2+e/5*t.link_index,y2:t.source.y+e/2-n/5*t.link_index,x3:t.target.x,y3:t.target.y}},quadraticBezierCurve(t){const n=this.getBezierPoints(t);return`M ${n.x1},${n.y1} Q ${n.x2} ${n.y2} ${n.x3} ${n.y3}`},linkLabelTransformation(t){const n=this.getBezierPoints(t),e=n.x2+.25*(n.x1-n.x2)+.25*(n.x3-n.x2),i=n.y2+.25*(n.y1-n.y2)+.25*(n.y3-n.y2),r=1*(n.x2-n.x1)+1*(n.x3-n.x2),o=1*(n.y2-n.y1)+1*(n.y3-n.y2);let s=Math.atan2(o,r)*(180/Math.PI);s=n.x1>n.x3?s-180:s;const a=n.x1>n.x3?-15:5;return`translate(${e+Math.sin(s/180*Math.PI)*a} ${i-Math.cos(s/180*Math.PI)*a}) rotate(${s})`},isNodeDisplayed(t){return this.nodesContainer.select(`#${this.prefixes.node}-${t.id}-${this.suffix}`).attr("display")===this.displays.inline},filterNodes(){this.nodesContainer.selectAll(`.${this.prefixes.node}-${this.suffix}`).each(((t,n,e)=>{const i=xe(e[n]);t.identifier_full.includes(this.filter.trim())?(i.attr("display",this.displays.inline),t._type===this.types.collection?this.excludedCollections.includes(t.id)&&i.attr("display",this.displays.none):(this.excludedTypes.includes(t.type_full)||this.excludedRecords.includes(t.id)||t.collection&&this.excludedCollections.includes(t.collection))&&i.attr("display",this.displays.none)):i.attr("display",this.displays.none)})),this.linksContainer.selectAll(`.${this.prefixes.link}-${this.suffix}`).each(((t,n,e)=>{const i=xe(e[n]);this.isNodeDisplayed(t.source)&&this.isNodeDisplayed(t.target)?i.attr("display",this.displays.inline):i.attr("display",this.displays.none)}))},createContainers(t){this.zoom=function(){var t,n,e,i=Ri,r=qi,o=Oi,s=Ii,a=Hi,l=[0,1/0],u=[[-1/0,-1/0],[1/0,1/0]],c=250,h=Si,f=wt("start","zoom","end"),d=500,p=150,y=0,g=10;function v(t){t.property("__zoom",Fi).on("wheel.zoom",$,{passive:!1}).on("mousedown.zoom",C).on("dblclick.zoom",A).filter(a).on("touchstart.zoom",z).on("touchmove.zoom",N).on("touchend.zoom touchcancel.zoom",M).style("-webkit-tap-highlight-color","rgba(0,0,0,0)")}function m(t,n){return(n=Math.max(l[0],Math.min(l[1],n)))===t.k?t:new Li(n,t.x,t.y)}function _(t,n,e){var i=n[0]-e[0]*t.k,r=n[1]-e[1]*t.k;return i===t.x&&r===t.y?t:new Li(t.k,i,r)}function x(t){return[(+t[0][0]+ +t[1][0])/2,(+t[0][1]+ +t[1][1])/2]}function w(t,n,e,i){t.on("start.zoom",(function(){b(this,arguments).event(i).start()})).on("interrupt.zoom end.zoom",(function(){b(this,arguments).event(i).end()})).tween("zoom",(function(){var t=this,o=arguments,s=b(t,o).event(i),a=r.apply(t,o),l=null==e?x(a):"function"==typeof e?e.apply(t,o):e,u=Math.max(a[1][0]-a[0][0],a[1][1]-a[0][1]),c=t.__zoom,f="function"==typeof n?n.apply(t,o):n,d=h(c.invert(l).concat(u/c.k),f.invert(l).concat(u/f.k));return function(t){if(1===t)t=f;else{var n=d(t),e=u/n[2];t=new Li(e,l[0]-n[0]*e,l[1]-n[1]*e)}s.zoom(null,t)}}))}function b(t,n,e){return!e&&t.__zooming||new k(t,n)}function k(t,n){this.that=t,this.args=n,this.active=0,this.sourceEvent=null,this.extent=r.apply(t,n),this.taps=0}function $(t,...n){if(i.apply(this,arguments)){var e=b(this,n).event(t),r=this.__zoom,a=Math.max(l[0],Math.min(l[1],r.k*Math.pow(2,s.apply(this,arguments)))),c=we(t);if(e.wheel)e.mouse[0][0]===c[0]&&e.mouse[0][1]===c[1]||(e.mouse[1]=r.invert(e.mouse[0]=c)),clearTimeout(e.wheel);else{if(r.k===a)return;e.mouse=[c,r.invert(c)],Gt(this),e.start()}Di(t),e.wheel=setTimeout((function(){e.wheel=null,e.end()}),p),e.zoom("mouse",o(_(m(r,a),e.mouse[0],e.mouse[1]),e.extent,u))}}function C(t,...n){if(!e&&i.apply(this,arguments)){var r=t.currentTarget,s=b(this,n,!0).event(t),a=xe(t.view).on("mousemove.zoom",(function(t){if(Di(t),!s.moved){var n=t.clientX-c,e=t.clientY-h;s.moved=n*n+e*e>y}s.event(t).zoom("mouse",o(_(s.that.__zoom,s.mouse[0]=we(t,r),s.mouse[1]),s.extent,u))}),!0).on("mouseup.zoom",(function(t){a.on("mousemove.zoom mouseup.zoom",null),ze(t.view,s.moved),Di(t),s.event(t).end()}),!0),l=we(t,r),c=t.clientX,h=t.clientY;Ae(t.view),Pi(t),s.mouse=[l,this.__zoom.invert(l)],Gt(this),s.start()}}function A(t,...n){if(i.apply(this,arguments)){var e=this.__zoom,s=we(t.changedTouches?t.changedTouches[0]:t,this),a=e.invert(s),l=e.k*(t.shiftKey?.5:2),h=o(_(m(e,l),s,a),r.apply(this,n),u);Di(t),c>0?xe(this).transition().duration(c).call(w,h,s,t):xe(this).call(v.transform,h,s,t)}}function z(e,...r){if(i.apply(this,arguments)){var o,s,a,l,u=e.touches,c=u.length,h=b(this,r,e.changedTouches.length===c).event(e);for(Pi(e),s=0;s<c;++s)l=[l=we(a=u[s],this),this.__zoom.invert(l),a.identifier],h.touch0?h.touch1||h.touch0[2]===l[2]||(h.touch1=l,h.taps=0):(h.touch0=l,o=!0,h.taps=1+!!t);t&&(t=clearTimeout(t)),o&&(h.taps<2&&(n=l[0],t=setTimeout((function(){t=null}),d)),Gt(this),h.start())}}function N(t,...n){if(this.__zooming){var e,i,r,s,a=b(this,n).event(t),l=t.changedTouches,c=l.length;for(Di(t),e=0;e<c;++e)r=we(i=l[e],this),a.touch0&&a.touch0[2]===i.identifier?a.touch0[0]=r:a.touch1&&a.touch1[2]===i.identifier&&(a.touch1[0]=r);if(i=a.that.__zoom,a.touch1){var h=a.touch0[0],f=a.touch0[1],d=a.touch1[0],p=a.touch1[1],y=(y=d[0]-h[0])*y+(y=d[1]-h[1])*y,g=(g=p[0]-f[0])*g+(g=p[1]-f[1])*g;i=m(i,Math.sqrt(y/g)),r=[(h[0]+d[0])/2,(h[1]+d[1])/2],s=[(f[0]+p[0])/2,(f[1]+p[1])/2]}else{if(!a.touch0)return;r=a.touch0[0],s=a.touch0[1]}a.zoom("touch",o(_(i,r,s),a.extent,u))}}function M(t,...i){if(this.__zooming){var r,o,s=b(this,i).event(t),a=t.changedTouches,l=a.length;for(Pi(t),e&&clearTimeout(e),e=setTimeout((function(){e=null}),d),r=0;r<l;++r)o=a[r],s.touch0&&s.touch0[2]===o.identifier?delete s.touch0:s.touch1&&s.touch1[2]===o.identifier&&delete s.touch1;if(s.touch1&&!s.touch0&&(s.touch0=s.touch1,delete s.touch1),s.touch0)s.touch0[1]=this.__zoom.invert(s.touch0[0]);else if(s.end(),2===s.taps&&(o=we(o,this),Math.hypot(n[0]-o[0],n[1]-o[1])<g)){var u=xe(this).on("dblclick.zoom");u&&u.apply(this,arguments)}}}return v.transform=function(t,n,e,i){var r=t.selection?t.selection():t;r.property("__zoom",Fi),t!==r?w(t,n,e,i):r.interrupt().each((function(){b(this,arguments).event(i).start().zoom(null,"function"==typeof n?n.apply(this,arguments):n).end()}))},v.scaleBy=function(t,n,e,i){v.scaleTo(t,(function(){return this.__zoom.k*("function"==typeof n?n.apply(this,arguments):n)}),e,i)},v.scaleTo=function(t,n,e,i){v.transform(t,(function(){var t=r.apply(this,arguments),i=this.__zoom,s=null==e?x(t):"function"==typeof e?e.apply(this,arguments):e,a=i.invert(s),l="function"==typeof n?n.apply(this,arguments):n;return o(_(m(i,l),s,a),t,u)}),e,i)},v.translateBy=function(t,n,e,i){v.transform(t,(function(){return o(this.__zoom.translate("function"==typeof n?n.apply(this,arguments):n,"function"==typeof e?e.apply(this,arguments):e),r.apply(this,arguments),u)}),null,i)},v.translateTo=function(t,n,e,i,s){v.transform(t,(function(){var t=r.apply(this,arguments),s=this.__zoom,a=null==i?x(t):"function"==typeof i?i.apply(this,arguments):i;return o(Bi.translate(a[0],a[1]).scale(s.k).translate("function"==typeof n?-n.apply(this,arguments):-n,"function"==typeof e?-e.apply(this,arguments):-e),t,u)}),i,s)},k.prototype={event:function(t){return t&&(this.sourceEvent=t),this},start:function(){return 1==++this.active&&(this.that.__zooming=this,this.emit("start")),this},zoom:function(t,n){return this.mouse&&"mouse"!==t&&(this.mouse[1]=n.invert(this.mouse[0])),this.touch0&&"touch"!==t&&(this.touch0[1]=n.invert(this.touch0[0])),this.touch1&&"touch"!==t&&(this.touch1[1]=n.invert(this.touch1[0])),this.that.__zoom=n,this.emit("zoom"),this},end:function(){return 0==--this.active&&(delete this.that.__zooming,this.emit("end")),this},emit:function(t){var n=xe(this.that).datum();f.call(t,this.that,new Ti(t,{sourceEvent:this.sourceEvent,target:v,type:t,transform:this.that.__zoom,dispatch:f}),n)}},v.wheelDelta=function(t){return arguments.length?(s="function"==typeof t?t:Ei(+t),v):s},v.filter=function(t){return arguments.length?(i="function"==typeof t?t:Ei(!!t),v):i},v.touchable=function(t){return arguments.length?(a="function"==typeof t?t:Ei(!!t),v):a},v.extent=function(t){return arguments.length?(r="function"==typeof t?t:Ei([[+t[0][0],+t[0][1]],[+t[1][0],+t[1][1]]]),v):r},v.scaleExtent=function(t){return arguments.length?(l[0]=+t[0],l[1]=+t[1],v):[l[0],l[1]]},v.translateExtent=function(t){return arguments.length?(u[0][0]=+t[0][0],u[1][0]=+t[1][0],u[0][1]=+t[0][1],u[1][1]=+t[1][1],v):[[u[0][0],u[0][1]],[u[1][0],u[1][1]]]},v.constrain=function(t){return arguments.length?(o=t,v):o},v.duration=function(t){return arguments.length?(c=+t,v):c},v.interpolate=function(t){return arguments.length?(h=t,v):h},v.on=function(){var t=f.on.apply(f,arguments);return t===f?v:t},v.clickDistance=function(t){return arguments.length?(y=(t=+t)*t,v):Math.sqrt(y)},v.tapDistance=function(t){return arguments.length?(g=+t,v):g},v}().on("zoom",(t=>this.graphContainer.attr("transform",t.transform))),this.svg=xe(t).append("svg").call(this.zoom).on("dblclick.zoom",null),this.legendContainer=this.svg.append("g"),this.graphContainer=this.svg.append("g").attr("id",`${this.prefixes.graph}-${this.suffix}`),this.linksContainer=this.graphContainer.append("g"),this.nodesContainer=this.graphContainer.append("g");const n=this.svg.append("defs"),e=(t,e)=>{n.append("marker").attr("id",t).attr("viewBox","0 0 10 10").attr("refX",22).attr("refY",4.5).attr("orient","auto").attr("markerWidth",5).attr("markerHeight",5).append("path").attr("d","M 0 0 L 10 5 L 0 10 z").attr("fill",e)};e(`${this.prefixes.arrowHead}-${this.suffix}`,this.colors.link),e(`${this.prefixes.arrowHeadFocus}-${this.suffix}`,this.colors.linkFocus);const i=(t,e)=>{n.append("path").attr("id",t).attr("d",e).attr("fill","white")};i(`${this.prefixes.iconGraph}-${this.suffix}`,this.icons.graph),i(`${this.prefixes.iconDown}-${this.suffix}`,this.icons.up),i(`${this.prefixes.iconUp}-${this.suffix}`,this.icons.down)},createSimulation(){const t=function(){var t,n,e,i,r,o=Be(-30),s=1,a=1/0,l=.81;function u(e){var r,o=t.length,s=Oe(t,Ue,Ge).visitAfter(h);for(i=e,r=0;r<o;++r)n=t[r],s.visit(f)}function c(){if(t){var n,e,i=t.length;for(r=new Array(i),n=0;n<i;++n)e=t[n],r[e.index]=+o(e,n,t)}}function h(t){var n,e,i,o,s,a=0,l=0;if(t.length){for(i=o=s=0;s<4;++s)(n=t[s])&&(e=Math.abs(n.value))&&(a+=n.value,l+=e,i+=e*n.x,o+=e*n.y);t.x=i/l,t.y=o/l}else{(n=t).x=n.data.x,n.y=n.data.y;do{a+=r[n.data.index]}while(n=n.next)}t.value=a}function f(t,o,u,c){if(!t.value)return!0;var h=t.x-n.x,f=t.y-n.y,d=c-o,p=h*h+f*f;if(d*d/l<p)return p<a&&(0===h&&(p+=(h=Pe(e))*h),0===f&&(p+=(f=Pe(e))*f),p<s&&(p=Math.sqrt(s*p)),n.vx+=h*t.value*i/p,n.vy+=f*t.value*i/p),!0;if(!(t.length||p>=a)){(t.data!==n||t.next)&&(0===h&&(p+=(h=Pe(e))*h),0===f&&(p+=(f=Pe(e))*f),p<s&&(p=Math.sqrt(s*p)));do{t.data!==n&&(d=r[t.data.index]*i/p,n.vx+=h*d,n.vy+=f*d)}while(t=t.next)}}return u.initialize=function(n,i){t=n,e=i,c()},u.strength=function(t){return arguments.length?(o="function"==typeof t?t:Be(+t),c(),u):o},u.distanceMin=function(t){return arguments.length?(s=t*t,u):Math.sqrt(s)},u.distanceMax=function(t){return arguments.length?(a=t*t,u):Math.sqrt(a)},u.theta=function(t){return arguments.length?(l=t*t,u):Math.sqrt(l)},u}().strength(this.manyBodyStrength),n=function(t){var n,e,i,r,o,s,a=De,l=function(t){return 1/Math.min(r[t.source.index],r[t.target.index])},u=Be(30),c=1;function h(i){for(var r=0,a=t.length;r<c;++r)for(var l,u,h,f,d,p,y,g=0;g<a;++g)u=(l=t[g]).source,f=(h=l.target).x+h.vx-u.x-u.vx||Pe(s),d=h.y+h.vy-u.y-u.vy||Pe(s),f*=p=((p=Math.sqrt(f*f+d*d))-e[g])/p*i*n[g],d*=p,h.vx-=f*(y=o[g]),h.vy-=d*y,u.vx+=f*(y=1-y),u.vy+=d*y}function f(){if(i){var s,l,u=i.length,c=t.length,h=new Map(i.map(((t,n)=>[a(t,n,i),t])));for(s=0,r=new Array(u);s<c;++s)(l=t[s]).index=s,"object"!=typeof l.source&&(l.source=Re(h,l.source)),"object"!=typeof l.target&&(l.target=Re(h,l.target)),r[l.source.index]=(r[l.source.index]||0)+1,r[l.target.index]=(r[l.target.index]||0)+1;for(s=0,o=new Array(c);s<c;++s)l=t[s],o[s]=r[l.source.index]/(r[l.source.index]+r[l.target.index]);n=new Array(c),d(),e=new Array(c),p()}}function d(){if(i)for(var e=0,r=t.length;e<r;++e)n[e]=+l(t[e],e,t)}function p(){if(i)for(var n=0,r=t.length;n<r;++n)e[n]=+u(t[n],n,t)}return null==t&&(t=[]),h.initialize=function(t,n){i=t,s=n,f()},h.links=function(n){return arguments.length?(t=n,f(),h):t},h.id=function(t){return arguments.length?(a=t,h):a},h.iterations=function(t){return arguments.length?(c=+t,h):c},h.strength=function(t){return arguments.length?(l="function"==typeof t?t:Be(+t),d(),h):l},h.distance=function(t){return arguments.length?(u="function"==typeof t?t:Be(+t),p(),h):u},h}().strength(this.linkStrength).id((t=>t.id)).distance((t=>t.source._type===this.types.record?10*t.link_length+200:200));this.simulation=function(t){var n,e=1,i=.001,r=1-Math.pow(i,1/300),o=0,s=.6,a=new Map,l=Pt(h),u=wt("tick","end"),c=function(){let t=1;return()=>(t=(1664525*t+1013904223)%Ve)/Ve}();function h(){f(),u.call("tick",n),e<i&&(l.stop(),u.call("end",n))}function f(i){var l,u,c=t.length;void 0===i&&(i=1);for(var h=0;h<i;++h)for(e+=(o-e)*r,a.forEach((function(t){t(e)})),l=0;l<c;++l)null==(u=t[l]).fx?u.x+=u.vx*=s:(u.x=u.fx,u.vx=0),null==u.fy?u.y+=u.vy*=s:(u.y=u.fy,u.vy=0);return n}function d(){for(var n,e=0,i=t.length;e<i;++e){if((n=t[e]).index=e,null!=n.fx&&(n.x=n.fx),null!=n.fy&&(n.y=n.fy),isNaN(n.x)||isNaN(n.y)){var r=10*Math.sqrt(.5+e),o=e*Ke;n.x=r*Math.cos(o),n.y=r*Math.sin(o)}(isNaN(n.vx)||isNaN(n.vy))&&(n.vx=n.vy=0)}}function p(n){return n.initialize&&n.initialize(t,c),n}return null==t&&(t=[]),d(),n={tick:f,restart:function(){return l.restart(h),n},stop:function(){return l.stop(),n},nodes:function(e){return arguments.length?(t=e,d(),a.forEach(p),n):t},alpha:function(t){return arguments.length?(e=+t,n):e},alphaMin:function(t){return arguments.length?(i=+t,n):i},alphaDecay:function(t){return arguments.length?(r=+t,n):+r},alphaTarget:function(t){return arguments.length?(o=+t,n):o},velocityDecay:function(t){return arguments.length?(s=1-t,n):1-s},randomSource:function(t){return arguments.length?(c=t,a.forEach(p),n):c},force:function(t,e){return arguments.length>1?(null==e?a.delete(t):a.set(t,p(e)),n):a.get(t)},find:function(n,e,i){var r,o,s,a,l,u=0,c=t.length;for(null==i?i=1/0:i*=i,u=0;u<c;++u)(s=(r=n-(a=t[u]).x)*r+(o=e-a.y)*o)<i&&(l=a,i=s);return l},on:function(t,e){return arguments.length>1?(u.on(t,e),n):u.on(t)}}}().velocityDecay(.15).force(this.forces.charge,t).force(this.forces.link,n).on("tick",(()=>{this.nodesContainer.selectAll(`.${this.prefixes.node}-${this.suffix}`).attr("transform",(t=>`translate(${t.x} ${t.y})`)),this.linksContainer.selectAll(`.${this.prefixes.linkLabel}-${this.suffix}`).attr("transform",(t=>this.linkLabelTransformation(t))),this.linksContainer.selectAll(`.${this.prefixes.linkPath}-${this.suffix}`).attr("d",(t=>t.source._type===this.types.collection?function(t,n){var e=gi(!0),i=null,r=mi,o=null,s=function(t){let n=3;return t.digits=function(e){if(!arguments.length)return n;if(null==e)n=null;else{const t=Math.floor(e);if(!(t>=0))throw new RangeError(`invalid digits: ${e}`);n=t}return t},()=>new $i(n)}(a);function a(a){var l,u,c,h=(a=function(t){return"object"==typeof t&&"length"in t?t:Array.from(t)}(a)).length,f=!1;for(null==i&&(o=r(c=s())),l=0;l<=h;++l)!(l<h&&e(u=a[l],l,a))===f&&((f=!f)?o.lineStart():o.lineEnd()),f&&o.point(+t(u,l,a),+n(u,l,a));if(c)return o=null,c+""||null}return t="function"==typeof t?t:void 0===t?Ci:gi(t),n="function"==typeof n?n:void 0===n?Ai:gi(n),a.x=function(n){return arguments.length?(t="function"==typeof n?n:gi(+n),a):t},a.y=function(t){return arguments.length?(n="function"==typeof t?t:gi(+t),a):n},a.defined=function(t){return arguments.length?(e="function"==typeof t?t:gi(!!t),a):e},a.curve=function(t){return arguments.length?(r=t,null!=i&&(o=r(i)),a):r},a.context=function(t){return arguments.length?(null==t?i=o=null:o=r(i=t),a):i},a}().curve(Ni)([[t.source.x,t.source.y],[t.target.x,t.target.y-18]]):this.quadraticBezierCurve(t)))}))},getCollectionColor(t,n,e=!1){const i=t(n);return e?Cn(i).darker(.5):i},getTypeColor(t,n,e=!1){const i=null===n?"grey":t(n);return e?Cn(i).darker(.5):i},drawNodes(t=!1,n=null,e=null){const i=this.nodes.filter((t=>t._type===this.types.collection)).map((t=>t.id)),r=pi(yi).domain(i),o=this.nodes.filter((t=>t._type===this.types.record)).map((t=>t.type_full)),s=pi(yi).domain(o),a=this.getStartNode(),l=function(){var t,n,e,i,r=Se,o=Ee,s=Te,a=Le,l={},u=wt("start","drag","end"),c=0,h=0;function f(t){t.on("mousedown.drag",d).filter(a).on("touchstart.drag",g).on("touchmove.drag",v,be).on("touchend.drag touchcancel.drag",m).style("touch-action","none").style("-webkit-tap-highlight-color","rgba(0,0,0,0)")}function d(s,a){if(!i&&r.call(this,s,a)){var l=_(this,o.call(this,s,a),s,a,"mouse");l&&(xe(s.view).on("mousemove.drag",p,ke).on("mouseup.drag",y,ke),Ae(s.view),$e(s),e=!1,t=s.clientX,n=s.clientY,l("start",s))}}function p(i){if(Ce(i),!e){var r=i.clientX-t,o=i.clientY-n;e=r*r+o*o>h}l.mouse("drag",i)}function y(t){xe(t.view).on("mousemove.drag mouseup.drag",null),ze(t.view,e),Ce(t),l.mouse("end",t)}function g(t,n){if(r.call(this,t,n)){var e,i,s=t.changedTouches,a=o.call(this,t,n),l=s.length;for(e=0;e<l;++e)(i=_(this,a,t,n,s[e].identifier,s[e]))&&($e(t),i("start",t,s[e]))}}function v(t){var n,e,i=t.changedTouches,r=i.length;for(n=0;n<r;++n)(e=l[i[n].identifier])&&(Ce(t),e("drag",t,i[n]))}function m(t){var n,e,r=t.changedTouches,o=r.length;for(i&&clearTimeout(i),i=setTimeout((function(){i=null}),500),n=0;n<o;++n)(e=l[r[n].identifier])&&($e(t),e("end",t,r[n]))}function _(t,n,e,i,r,o){var a,h,d,p=u.copy(),y=we(o||e,n);if(null!=(d=s.call(t,new Me("beforestart",{sourceEvent:e,target:f,identifier:r,active:c,x:y[0],y:y[1],dx:0,dy:0,dispatch:p}),i)))return a=d.x-y[0]||0,h=d.y-y[1]||0,function e(o,s,u){var g,v=y;switch(o){case"start":l[r]=e,g=c++;break;case"end":delete l[r],--c;case"drag":y=we(u||s,n),g=c}p.call(o,t,new Me(o,{sourceEvent:s,subject:d,target:f,identifier:r,active:g,x:y[0]+a,y:y[1]+h,dx:y[0]-v[0],dy:y[1]-v[1],dispatch:p}),i)}}return f.filter=function(t){return arguments.length?(r="function"==typeof t?t:Ne(!!t),f):r},f.container=function(t){return arguments.length?(o="function"==typeof t?t:Ne(t),f):o},f.subject=function(t){return arguments.length?(s="function"==typeof t?t:Ne(t),f):s},f.touchable=function(t){return arguments.length?(a="function"==typeof t?t:Ne(!!t),f):a},f.on=function(){var t=u.on.apply(u,arguments);return t===u?f:t},f.clickDistance=function(t){return arguments.length?(h=(t=+t)*t,f):Math.sqrt(h)},f}().on("start",((t,n)=>{t.active||this.simulation.alphaTarget(.5).restart(),n.fx=n._fx=n.x,n.fy=n._fy=n.y})).on("drag",((t,n)=>{n.fx=t.x,n.fy=t.y,n._type===this.types.collection&&(this.simulation.force(this.forces.x).initialize(this.nodes),this.simulation.force(this.forces.y).initialize(this.nodes))})).on("end",((t,n)=>{t.active||this.simulation.alphaTarget(0),Math.sqrt((n.fx-n._fx)**2+(n.fy-n._fy)**2)>3&&(n._moved=!0),n._type!==this.types.record||a&&n.id===a.id||(n.fx=null,n.fy=null)})),u=this.nodesContainer.selectAll(`.${this.prefixes.node}-${this.suffix}`).data(this.nodes,(t=>t.id)).enter().append("g").attr("id",(t=>`${this.prefixes.node}-${t.id}-${this.suffix}`)).attr("class",`${this.prefixes.node}-${this.suffix}`).call(l),c=u.filter((t=>t._type===this.types.collection)),h=(t,n,e)=>{const i=e?this.displays.inline:this.displays.none,r=e?this.colors.linkFocus:this.colors.link;xe(t.currentTarget).select(`.${this.prefixes.controls}-${this.suffix}`).attr("display",i),this.linksContainer.selectAll(`.${this.prefixes.linkPath}-${this.suffix}`).each(((t,e,i)=>{t.source.id!==n.id&&t.target.id!==n.id||xe(i[e]).attr("stroke",r)}))};c.on("mouseover",((t,n)=>h(t,n,!0))).on("mouseout",((t,n)=>h(t,n,!1))).append("polygon").attr("points","-10,17 -20,0 -10,-17 10,-17 20,0 10,17").attr("fill",(t=>this.getCollectionColor(r,t.id))).attr("stroke",(t=>this.getCollectionColor(r,t.id,!0))).attr("stroke-width",(t=>a&&t.id===a.id?5:3)).attr("cursor","pointer");const f=c.append("g").attr("class",`${this.prefixes.controls}-${this.suffix}`).attr("display",this.displays.none),d=f.append("g").attr("cursor","pointer").on("click",((t,e)=>{null!==n&&n(e);const i=xe(t.currentTarget).select("use");i.attr("opacity")===String(.4)?i.attr("opacity",1):i.attr("opacity",.4)}));d.append("circle").attr("r",11).attr("cx",-23).attr("fill",(t=>this.getCollectionColor(r,t.id,!0))),d.append("use").attr("href",`#${this.prefixes.iconGraph}-${this.suffix}`).attr("transform","translate(-30 -6)").filter((t=>t.id===a.id)).attr("opacity",.4);const p=`#${this.prefixes.iconDown}-${this.suffix}`,y="translate(16.5 -3)",g=f.append("g").attr("cursor","pointer").on("click",((t,n)=>{null!==e&&e(n);const i=xe(t.currentTarget).select("use");i.attr("href")===p?i.attr("href",`#${this.prefixes.iconUp}-${this.suffix}`).attr("transform","translate(16.5 -9)"):i.attr("href",p).attr("transform",y)}));g.append("circle").attr("r",11).attr("cx",23).attr("fill",(t=>this.getCollectionColor(r,t.id,!0))),g.append("use").attr("href",p).attr("transform",y);const v=u.filter((t=>t._type===this.types.record)),m=(t,n,e)=>{const i=e?this.colors.linkFocus:this.colors.link,r=e?this.prefixes.arrowHeadFocus:this.prefixes.arrowHead;this.linksContainer.selectAll(`.${this.prefixes.linkPath}-${this.suffix}`).each(((t,e,o)=>{t.source._type!==this.types.record||t.source.id!==n.id&&t.target.id!==n.id||xe(o[e]).attr("stroke",i).attr("marker-end",`url(#${r}-${this.suffix})`)}))};v.on("mouseover",((t,n)=>m(0,n,!0))).on("mouseout",((t,n)=>m(0,n,!1))).append("circle").attr("r",20).attr("cursor","pointer").attr("stroke-width",(t=>a&&t.id===a.id?5:3)).attr("fill",(n=>t?"white":this.getTypeColor(s,n.type_full))).attr("stroke",(n=>t&&n.collection?this.getCollectionColor(r,n.collection):this.getTypeColor(s,n.type_full,!0))),t&&v.append("circle").attr("r",15).attr("cursor","pointer").attr("fill",(t=>this.getTypeColor(s,t.type_full)));const _=u.append("g").attr("class",`${this.prefixes.nodeLabel}-${this.suffix}`).attr("display",this.labelsHidden?this.displays.none:this.displays.inline);_.append("a").attr("href",(t=>t.url)).append("text").text((t=>`@${t.identifier}`)).attr("dy",38).attr("font-family",this.fontFamily).attr("font-weight","bold").attr("text-anchor","middle").on("mouseover",(t=>{xe(t.target).attr("fill",this.colors.textFocus).attr("font-size","115%")})).on("mouseout",(t=>{xe(t.target).attr("fill",this.colors.text).attr("font-size","100%")})).append("title").text((t=>t.identifier_full)),_.filter((t=>t.type)).append("text").text((t=>t.type)).attr("dy",50).attr("font-family",this.fontFamily).attr("font-size","70%").attr("text-anchor","middle").attr("cursor","default").append("title").text((t=>t.type_full))},drawLinks(){const t=(t,n,e)=>{const i=e?this.colors.linkFocus:this.colors.link,r=e?this.prefixes.arrowHeadFocus:this.prefixes.arrowHead,o=xe(t.currentTarget).select("path");o.attr("stroke",i),n.source._type===this.types.record&&o.attr("marker-end",`url(#${r}-${this.suffix})`)},n=this.linksContainer.selectAll(`.${this.prefixes.link}-${this.suffix}`).data(this.links,(t=>t.id)).enter().append("g").attr("class",`${this.prefixes.link}-${this.suffix}`).on("mouseover",((n,e)=>t(n,e,!0))).on("mouseout",((n,e)=>t(n,e,!1)));n.append("path").attr("class",`${this.prefixes.linkPath}-${this.suffix}`).attr("stroke",this.colors.link).attr("stroke-width",3).attr("fill","none").filter((t=>t.source._type===this.types.record)).attr("marker-end",`url(#${this.prefixes.arrowHead}-${this.suffix})`),n.filter((t=>t.source._type===this.types.record)).append("a").attr("href",(t=>t.url)).append("text").text((t=>t.name)).attr("class",`${this.prefixes.linkLabel}-${this.suffix}`).attr("display",this.labelsHidden?this.displays.none:this.displays.hidden).attr("font-family",this.fontFamily).attr("font-size","85%").attr("text-anchor","middle").on("mouseover",(t=>{xe(t.target).attr("fill",this.colors.textFocus).attr("font-size","100%")})).on("mouseout",(t=>{xe(t.target).attr("fill",this.colors.text).attr("font-size","85%")})).append("title").text((t=>t.name_full))},drawLegend(){this.legendContainer.selectAll("*").remove();const t=new Map;for(const n of this.nodes)if(n._type===this.types.record){const e=n.type_full,i={count:t.has(e)?t.get(e).count+1:1};t.set(e,i)}const n=Array.from(t.keys()),e=pi(yi).domain(n),i=[...n].sort(((t,n)=>(null===t)-(null===n)||Number(t>n)||-(t<n))),r=this.legendContainer.selectAll().data(i).enter().append("g");r.append("circle").attr("r",9).attr("cx",17).attr("cy",((t,n)=>9*(n+1)+17*n+8)).attr("fill",(t=>this.getTypeColor(e,t))).attr("stroke",(t=>this.getTypeColor(e,t,!0))).attr("stroke-width",2).attr("cursor","pointer").on("click",((t,n)=>{const e=xe(t.target),i=n;let r=1;this.excludedTypes.includes(i)?kadi.utils.removeFromArray(this.excludedTypes,i):(this.excludedTypes.push(i),r=.3),e.attr("opacity",r),this.filterNodes()})).filter((t=>this.excludedTypes.includes(t))).attr("opacity",.3),r.append("text").text((n=>`${n||"No type"} (${t.get(n).count})`)).attr("x",35).attr("y",((t,n)=>9*(n+1)+17*n+8)).attr("dy",5).attr("font-family",this.fontFamily).attr("font-size","95%").attr("font-style",(t=>null===t?"italic":"normal")).attr("fill",(t=>this.getTypeColor(e,t,!0))).attr("cursor","default")}}},ji={mixins:[Xi],data(){return{data:null,coordinateStrength:.1}},methods:{getStartNode(){return this.nodes.find((t=>t.id===this.data.id))||null},disableForces(){this.simulation.force(this.forces.x).strength(0),this.simulation.force(this.forces.y).strength(0)},enableForces(){this.simulation.force(this.forces.x).strength(this.coordinateStrength),this.simulation.force(this.forces.y).strength(this.coordinateStrength)},resizeCallback(){this.resizeView(this.$refs.container,this.$refs.svgContainer),this.resetView()},findCollection(t,n=null){let e=n;if(null===e&&(e=this.data),e.id===t)return e;if(null===e.children)return null;for(const n of e.children){const e=this.findCollection(t,n);if(null!==e)return e}return null},iterateChildCollections(t,n){if(null!==t.children)for(const e of t.children)n(e),this.iterateChildCollections(e,n)},updateRecordNodes(t){for(const n of t.records)this.nodes.push({...n,collection:t.id,_type:this.types.record});for(const n of t.record_links)this.links.push({...n})},updateGraph(){const t=Qe(this.data);(function(){var t=ii,n=1,e=1,i=null;function r(r){var l=function(t){for(var n,e,i,r,o,s=new li(t,0),a=[s];n=a.pop();)if(i=n._.children)for(n.children=new Array(o=i.length),r=o-1;r>=0;--r)a.push(e=n.children[r]=new li(i[r],r)),e.parent=n;return(s.parent=new li(null,0)).children=[s],s}(r);if(l.eachAfter(o),l.parent.m=-l.z,l.eachBefore(s),i)r.eachBefore(a);else{var u=r,c=r,h=r;r.eachBefore((function(t){t.x<u.x&&(u=t),t.x>c.x&&(c=t),t.depth>h.depth&&(h=t)}));var f=u===c?1:t(u,c)/2,d=f-u.x,p=n/(c.x+f+d),y=e/(h.depth||1);r.eachBefore((function(t){t.x=(t.x+d)*p,t.y=t.depth*y}))}return r}function o(n){var e=n.children,i=n.parent.children,r=n.i?i[n.i-1]:null;if(e){!function(t){for(var n,e=0,i=0,r=t.children,o=r.length;--o>=0;)(n=r[o]).z+=e,n.m+=e,e+=n.s+(i+=n.c)}(n);var o=(e[0].z+e[e.length-1].z)/2;r?(n.z=r.z+t(n._,r._),n.m=n.z-o):n.z=o}else r&&(n.z=r.z+t(n._,r._));n.parent.A=function(n,e,i){if(e){for(var r,o=n,s=n,a=e,l=o.parent.children[0],u=o.m,c=s.m,h=a.m,f=l.m;a=oi(a),o=ri(o),a&&o;)l=ri(l),(s=oi(s)).a=n,(r=a.z+h-o.z-u+t(a._,o._))>0&&(si(ai(a,n,i),n,r),u+=r,c+=r),h+=a.m,u+=o.m,f+=l.m,c+=s.m;a&&!oi(s)&&(s.t=a,s.m+=h-c),o&&!ri(l)&&(l.t=o,l.m+=u-f,i=n)}return i}(n,r,n.parent.A||i[0])}function s(t){t._.x=t.z+t.parent.m,t.m+=t.parent.m}function a(t){t.x*=n,t.y=t.depth*e}return r.separation=function(n){return arguments.length?(t=n,r):t},r.size=function(t){return arguments.length?(i=!1,n=+t[0],e=+t[1],r):i?null:[n,e]},r.nodeSize=function(t){return arguments.length?(i=!0,n=+t[0],e=+t[1],r):i?[n,e]:null},r})().nodeSize([1250,1e3]).separation((()=>1))(t);for(const n of this.nodes)if(n._type===this.types.collection&&!n._moved){const e=t.find((t=>t.data.id===n.id));n.fx=e.x,n.fy=e.y}this.simulation.nodes(this.nodes),this.simulation.force(this.forces.link).links(this.links),this.drawNodes(!0,(t=>{const n=this.findCollection(t.id);if(null!==n.records){for(const t of this.nodes)t._type===this.types.record&&t.collection===n.id&&(this.excludedRecords.includes(t.id)?kadi.utils.removeFromArray(this.excludedRecords,t.id):this.excludedRecords.push(t.id));this.filterNodes()}else this.updateData(n.records_endpoint)}),(t=>{const n=this.findCollection(t.id);null!==n.children?(n._collapsed=!n._collapsed,this.iterateChildCollections(n,(t=>{n._collapsed?this.excludedCollections.includes(t.id)||this.excludedCollections.push(t.id):(t=>{let n=t.parent;for(;n;){if(n._collapsed)return!0;n=n.parent}return!1})(t)||kadi.utils.removeFromArray(this.excludedCollections,t.id)})),this.filterNodes()):this.updateData(n.children_endpoint)})),this.drawLinks(),this.drawLegend(),this.filterNodes(),this.simulation.alpha(1).restart()},updateData(t){this.loading=!0,axios.get(t).then((t=>{const n=t.data;if(this.initialized){const t=this.findCollection(n.id);if(null!==n.records&&(t.records=n.records,t.record_links=n.record_links,this.updateRecordNodes(t)),null!==n.children){t.children=n.children;for(const n of t.children)n.parent=t,this.nodes.push({...n,_type:this.types.collection}),this.links.push({id:`${t.id}-${n.id}`,source:t.id,target:n.id})}}else this.data=n,this.nodes.push({...n,_type:this.types.collection}),this.updateRecordNodes(n);this.updateGraph()})).catch((t=>kadi.base.flashDanger($t("Error loading collection links."),{request:t.request}))).finally((()=>{this.initialized=!0,this.loading=!1,this.forceDisabled=!1}))}},mounted(){this.createContainers(this.$refs.svgContainer),this.createSimulation();const t=(t,n)=>{let e=0;return t._type===this.types.record&&(e=this.nodes.find((n=>n.id===t.collection))[`f${n}`]),e||0},n=function(t){var n,e,i,r=Be(.1);function o(t){for(var r,o=0,s=n.length;o<s;++o)(r=n[o]).vx+=(i[o]-r.x)*e[o]*t}function s(){if(n){var o,s=n.length;for(e=new Array(s),i=new Array(s),o=0;o<s;++o)e[o]=isNaN(i[o]=+t(n[o],o,n))?0:+r(n[o],o,n)}}return"function"!=typeof t&&(t=Be(null==t?0:+t)),o.initialize=function(t){n=t,s()},o.strength=function(t){return arguments.length?(r="function"==typeof t?t:Be(+t),s(),o):r},o.x=function(n){return arguments.length?(t="function"==typeof n?n:Be(+n),s(),o):t},o}().strength(this.coordinateStrength).x((n=>t(n,this.forces.x))),e=function(t){var n,e,i,r=Be(.1);function o(t){for(var r,o=0,s=n.length;o<s;++o)(r=n[o]).vy+=(i[o]-r.y)*e[o]*t}function s(){if(n){var o,s=n.length;for(e=new Array(s),i=new Array(s),o=0;o<s;++o)e[o]=isNaN(i[o]=+t(n[o],o,n))?0:+r(n[o],o,n)}}return"function"!=typeof t&&(t=Be(null==t?0:+t)),o.initialize=function(t){n=t,s()},o.strength=function(t){return arguments.length?(r="function"==typeof t?t:Be(+t),s(),o):r},o.y=function(n){return arguments.length?(t="function"==typeof n?n:Be(+n),s(),o):t},o}().strength(this.coordinateStrength).y((n=>t(n,this.forces.y)));this.simulation.force(this.forces.x,n).force(this.forces.y,e),this.resizeCallback(),this.updateData(this.endpoint),window.addEventListener("resize",this.resizeCallback)},beforeDestroy(){window.removeEventListener("resize",this.resizeCallback)}},Yi=ji;e(9574);var Vi=function(t,n,e,i,r,o,s,a){var l,u="function"==typeof t?t.options:t;if(n&&(u.render=n,u.staticRenderFns=[],u._compiled=!0),o&&(u._scopeId="data-v-"+o),l)if(u.functional){u._injectStyles=l;var c=u.render;u.render=function(t,n){return l.call(n),c(t,n)}}else{var h=u.beforeCreate;u.beforeCreate=h?[].concat(h,l):[l]}return{exports:t,options:u}}(Yi,t,0,0,0,"3dc18507"),Ui=Vi.exports;kadi.base.newVue({components:{CollectionLinksGraph:Ui},data:{currentTab:null,includeChildCollections:!1,renderLinksGraph:!1,visualizeLinks:!1,visualizeLinksParam:"visualize",linkFilter:""},computed:{getRecordsEndpoint(){const t=kadi.context.get_records_endpoint;return this.includeChildCollections?`${t}?children=true`:t},searchRecordsEndpoint(){const t=kadi.context.search_records_endpoint;return this.includeChildCollections?`${t}&child_collections=true`:t}},watch:{visualizeLinks(){this.visualizeLinks&&(this.renderLinksGraph=!0);const t=kadi.utils.setSearchParam(this.visualizeLinksParam,this.visualizeLinks);kadi.utils.replaceState(t)}},methods:{changeTab(t){this.currentTab=t;let n=null;n="links"===this.currentTab?kadi.utils.setSearchParam(this.visualizeLinksParam,this.visualizeLinks):kadi.utils.removeSearchParam(this.visualizeLinksParam),kadi.utils.replaceState(n)}},created(){"true"===kadi.utils.getSearchParam(this.visualizeLinksParam)&&(this.visualizeLinks=!0)},mounted(){const t=kadi.context.collection;kadi.base.visitItem("collection",t.title,t.identifier,`/collections/${t.id}`)}})}()}();
//# sourceMappingURL=view-collection.js.map