/*! For license information please see view-file.js.LICENSE.txt */
!function(){var e={3365:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,"\n.render-container[data-v-6285d09a] {\n  cursor: pointer;\n}\n.toolbar[data-v-6285d09a] {\n  position: absolute;\n  right: 0;\n  z-index: 1;\n}\n","",{version:3,sources:["webpack://./kadi/assets/scripts/components/lib/previews/ModelViewer.vue"],names:[],mappings:";AAyDA;EACA,eAAA;AACA;AAEA;EACA,kBAAA;EACA,QAAA;EACA,UAAA;AACA",sourcesContent:['\x3c!-- Copyright 2021 Karlsruhe Institute of Technology\n   -\n   - Licensed under the Apache License, Version 2.0 (the "License");\n   - you may not use this file except in compliance with the License.\n   - You may obtain a copy of the License at\n   -\n   -     http://www.apache.org/licenses/LICENSE-2.0\n   -\n   - Unless required by applicable law or agreed to in writing, software\n   - distributed under the License is distributed on an "AS IS" BASIS,\n   - WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   - See the License for the specific language governing permissions and\n   - limitations under the License. --\x3e\n\n<template>\n  <div>\n    <div v-if="fileSize > maxFileSize && !forceLoad">\n      <button type="button" class="btn btn-sm btn-light mb-2" @click="loadFile">\n        <i class="fa-solid fa-eye"></i> {{ $t(\'Load preview\') }}\n      </button>\n    </div>\n    <div class="card bg-light p-1" ref="container" v-else>\n      <div class="text-muted ml-1" v-if="error">\n        <i class="fa-solid fa-triangle-exclamation mr-1"></i> {{ error }}\n      </div>\n      <div v-else>\n        <div class="toolbar mr-1" v-if="!loading">\n          <button type="button"\n                  class="btn btn-link text-primary"\n                  :title="$t(\'Toggle wireframe\')"\n                  @click="toggleWireframe"\n                  v-if="material !== null">\n            <i class="fa-solid fa-cube"></i>\n          </button>\n          <button type="button"\n                  class="btn btn-link text-primary"\n                  :title="$t(\'Reset view\')"\n                  @click="resetView">\n            <i class="fa-solid fa-eye"></i>\n          </button>\n          <button type="button"\n                  class="btn btn-link text-primary"\n                  :title="$t(\'Toggle fullscreen\')"\n                  @click="toggleFullscreen">\n            <i class="fa-solid fa-expand"></i>\n          </button>\n        </div>\n        <div class="text-muted ml-1" v-if="loading">\n          <i class="fa-solid fa-circle-notch fa-spin mr-1"></i> {{ $t(\'Loading model...\') }}\n        </div>\n        <div class="render-container" ref="renderContainer"></div>\n      </div>\n    </div>\n  </div>\n</template>\n\n<style scoped>\n.render-container {\n  cursor: pointer;\n}\n\n.toolbar {\n  position: absolute;\n  right: 0;\n  z-index: 1;\n}\n</style>\n\n<script>\nimport * as THREE from \'three\';\nimport {OBJLoader} from \'three/examples/jsm/loaders/OBJLoader.js\';\nimport {STLLoader} from \'three/examples/jsm/loaders/STLLoader.js\';\nimport {XYZLoader} from \'three/examples/jsm/loaders/XYZLoader.js\';\nimport {TrackballControls} from \'three/examples/jsm/controls/TrackballControls.js\';\nimport WebGLUtil from \'three/examples/jsm/capabilities/WebGL.js\';\n\nexport default {\n  data() {\n    return {\n      loaders: {\n        \'obj\': OBJLoader,\n        \'stl\': STLLoader,\n        \'xyz\': XYZLoader,\n      },\n      renderer: null,\n      scene: null,\n      camera: null,\n      controls: null,\n      material: null,\n      distance: 0,\n      loading: true,\n      error: \'\',\n      forceLoad: false,\n    };\n  },\n  props: {\n    type: String,\n    modelUrl: String,\n    fileSize: Number,\n    maxFileSize: Number,\n  },\n  methods: {\n    resetView() {\n      this.controls.reset();\n      this.camera.position.set(0, 0, this.distance);\n      this.camera.updateProjectionMatrix();\n    },\n    toggleWireframe() {\n      this.material.wireframe = !this.material.wireframe;\n    },\n    toggleFullscreen() {\n      kadi.utils.toggleFullscreen(this.$refs.container);\n    },\n    resizeView() {\n      const width = this.$refs.renderContainer.getBoundingClientRect().width;\n      const height = Math.round(window.innerHeight / window.innerWidth * width);\n\n      if (kadi.utils.isFullscreen()) {\n        this.$refs.renderContainer.style.height = \'100vh\';\n        this.$refs.container.style.borderRadius = \'0\';\n      } else {\n        this.$refs.renderContainer.style.height = `${height}px`;\n        this.$refs.container.style.borderRadius = \'0.25rem\';\n      }\n\n      this.camera.aspect = width / height;\n      this.camera.updateProjectionMatrix();\n      this.renderer.setSize(width, height);\n    },\n    animate() {\n      window.requestAnimationFrame(this.animate);\n      this.renderer.render(this.scene, this.camera);\n      this.controls.update();\n    },\n    onLoad(data) {\n      this.loading = false;\n\n      this.renderer = new THREE.WebGLRenderer({antialias: true});\n      this.renderer.setPixelRatio(window.devicePixelRatio);\n      this.$refs.renderContainer.appendChild(this.renderer.domElement);\n\n      this.scene = new THREE.Scene();\n      this.scene.background = new THREE.Color(0xf7f7f7);\n\n      this.camera = new THREE.PerspectiveCamera();\n      this.scene.add(this.camera);\n\n      this.controls = new TrackballControls(this.camera, this.renderer.domElement);\n      this.controls.rotateSpeed = 2;\n\n      let object = null;\n\n      switch (this.type) {\n      case \'obj\':\n        this.material = new THREE.MeshNormalMaterial();\n        object = data;\n\n        object.traverse((child) => {\n          if (child instanceof THREE.Mesh) {\n            child.material = this.material;\n          }\n        });\n        break;\n      case \'stl\':\n        this.material = new THREE.MeshNormalMaterial();\n        object = new THREE.Mesh(data, this.material);\n        object.geometry.center();\n        break;\n      case \'xyz\':\n        object = new THREE.Points(data, new THREE.PointsMaterial({size: 0.1, color: 0}));\n        break;\n      default:\n        return;\n      }\n\n      this.scene.add(object);\n\n      // Calculate a good default distance along the z-axis for the camera relative to the size of the object.\n      const boundingBox = new THREE.Box3().setFromObject(object);\n      const length = boundingBox.getSize(new THREE.Vector3()).length();\n      const fov = this.camera.fov / 2 * (Math.PI / 180);\n\n      this.distance = length / 2 / Math.tan(fov);\n\n      // Check if the object would be even visible using the calculated distance. If not, attempt to calculate a new\n      // distance where at least part of the object should be visible.\n      if (this.distance - this.camera.far > boundingBox.max.z) {\n        this.distance = this.camera.far + boundingBox.max.z - (boundingBox.max.z / 10);\n      }\n\n      this.resizeView();\n      this.resetView();\n      this.animate();\n\n      window.addEventListener(\'resize\', this.resizeView);\n    },\n    onError(error) {\n      this.loading = false;\n      this.error = $t(\'Error loading model.\');\n      console.error(error);\n    },\n    async loadFile() {\n      this.forceLoad = true;\n      await this.$nextTick();\n\n      const loader = new this.loaders[this.type]();\n      loader.load(this.modelUrl, this.onLoad, null, this.onError);\n    },\n  },\n  mounted() {\n    if (!(this.type in this.loaders)) {\n      this.error = \'Invalid object type.\';\n      return;\n    }\n\n    if (!WebGLUtil.isWebGLAvailable()) {\n      this.error = $t(\'WebGL not available.\');\n      return;\n    }\n\n    if (this.fileSize <= this.maxFileSize) {\n      this.loadFile();\n    }\n  },\n  beforeDestroy() {\n    window.removeEventListener(\'resize\', this.resizeView);\n  },\n};\n<\/script>\n'],sourceRoot:""}]),e.exports=i},4464:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,"\n.editor-container[data-v-0b9afe58] {\n  border: 1px solid #ced4da;\n}\n.editor-toolbar[data-v-0b9afe58] {\n  position: absolute;\n  right: 0;\n  z-index: 1;\n}\n","",{version:3,sources:["webpack://./kadi/assets/scripts/components/lib/workflows/WorkflowEditor.vue"],names:[],mappings:";AAuGA;EACA,yBAAA;AACA;AAEA;EACA,kBAAA;EACA,QAAA;EACA,UAAA;AACA",sourcesContent:['\x3c!-- Copyright 2020 Karlsruhe Institute of Technology\n   -\n   - Licensed under the Apache License, Version 2.0 (the "License");\n   - you may not use this file except in compliance with the License.\n   - You may obtain a copy of the License at\n   -\n   -     http://www.apache.org/licenses/LICENSE-2.0\n   -\n   - Unless required by applicable law or agreed to in writing, software\n   - distributed under the License is distributed on an "AS IS" BASIS,\n   - WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   - See the License for the specific language governing permissions and\n   - limitations under the License. --\x3e\n\n<template>\n  <div ref="container">\n    <div v-if="toolsEndpoint">\n      <div class="modal-backdrop show" v-if="toolDialogActive"></div>\n      <div class="modal" tabindex="-1" ref="toolDialog">\n        <div class="modal-dialog modal-dialog-centered modal-lg">\n          <div class="modal-content">\n            <div class="modal-body">\n              <dynamic-pagination placeholder="No tools."\n                                  filter-placeholder="Filter by filename or record identifier"\n                                  :endpoint="toolsEndpoint"\n                                  :per-page="5"\n                                  :enable-filter="true">\n                <template #default="props">\n                  <div class="d-flex justify-content-between mb-4">\n                    <div>\n                      <strong>Tools</strong>\n                      <span class="badge badge-pill badge-light text-muted border border-muted">{{ props.total }}</span>\n                    </div>\n                    <button type="button" class="close" data-dismiss="modal">\n                      <i class="fa-solid fa-xmark fa-xs"></i>\n                    </button>\n                  </div>\n                  <ul class="list-group" v-if="props.total > 0">\n                    <li class="list-group-item bg-light py-2">\n                      <div class="row">\n                        <div class="col-lg-5">File</div>\n                        <div class="col-lg-5">Tool</div>\n                      </div>\n                    </li>\n                    <li class="list-group-item py-2" v-for="item in props.items" :key="item.id">\n                      <div class="row align-items-center">\n                        <div class="col-lg-5 mb-2 mb-lg-0">\n                          <strong>{{ item.file }}</strong>\n                          <br>\n                          @{{ item.record }}\n                        </div>\n                        <div class="col-lg-5 mb-2 mb-lg-0">\n                          <div v-if="item.tool">\n                            <strong>{{ item.tool.name }}</strong>\n                            <small>[{{ item.tool.type }}]</small>\n                            <span v-if="item.tool.version">\n                              <br>\n                              Version {{ item.tool.version }}\n                            </span>\n                          </div>\n                          <div v-else>\n                            <em class="text-muted">Invalid tool description.</em>\n                          </div>\n                        </div>\n                        <div class="col-lg-2 d-lg-flex justify-content-end">\n                          <div>\n                            <button type="button"\n                                    class="btn btn-light btn-sm"\n                                    :disabled="!item.tool"\n                                    @click="addTool(item.tool)">\n                              <i class="fa-solid fa-plus"></i>\n                            </button>\n                          </div>\n                        </div>\n                      </div>\n                    </li>\n                  </ul>\n                </template>\n              </dynamic-pagination>\n            </div>\n          </div>\n        </div>\n      </div>\n    </div>\n    <div class="card editor-container" :class="{\'bg-light\': !editable}" ref="editorContainer">\n      <div class="editor-toolbar mt-1 mr-1" ref="editorToolbar">\n        <button type="button" title="Reset view" :class="toolbarBtnClasses" @click="resetView">\n          <i class="fa-solid fa-eye"></i>\n        </button>\n        <button type="button" title="Toggle fullscreen" :class="toolbarBtnClasses" @click="toggleFullscreen">\n          <i class="fa-solid fa-expand"></i>\n        </button>\n        <button type="button" title="Reset editor" :class="toolbarBtnClasses" v-if="editable" @click="resetEditor">\n          <i class="fa-solid fa-broom"></i>\n        </button>\n      </div>\n      <div ref="editor"></div>\n    </div>\n    <slot :editor="editor"></slot>\n  </div>\n</template>\n\n<style scoped>\n.editor-container {\n  border: 1px solid #ced4da;\n}\n\n.editor-toolbar {\n  position: absolute;\n  right: 0;\n  z-index: 1;\n}\n</style>\n\n<script>\nimport \'regenerator-runtime\';\n\nimport AreaPlugin from \'rete-area-plugin\';\nimport ConnectionPlugin from \'rete-connection-plugin\';\nimport ContextMenuPlugin from \'rete-context-menu-plugin\';\nimport VueRenderPlugin from \'rete-vue-render-plugin\';\n\nimport WorkflowEditor from \'scripts/lib/workflows/editor\';\nimport {ToolComponent} from \'scripts/lib/workflows/components/core\';\nimport VueMenu from \'scripts/components/lib/workflows/view/Menu.vue\';\n\nimport annotationComponents from \'scripts/lib/workflows/components/annotation-components\';\nimport controlComponents from \'scripts/lib/workflows/components/control-components\';\nimport fileIoComponents from \'scripts/lib/workflows/components/file-io-components\';\nimport miscComponents from \'scripts/lib/workflows/components/misc-components\';\nimport sourceComponents from \'scripts/lib/workflows/components/source-components\';\nimport userInputComponents from \'scripts/lib/workflows/components/user-input-components\';\nimport userOutputComponents from \'scripts/lib/workflows/components/user-output-components\';\n\nimport \'styles/workflows/workflow-editor.scss\';\n\nexport default {\n  data() {\n    return {\n      version: \'kadi@0.1.0\',\n      editor: null,\n      area: null,\n      unsavedChanges_: false,\n      toolDialogActive: false,\n      menuItems: {},\n      currX: 0,\n      currY: 0,\n    };\n  },\n  props: {\n    editable: {\n      type: Boolean,\n      default: true,\n    },\n    workflowUrl: {\n      type: String,\n      default: null,\n    },\n    toolsEndpoint: {\n      type: String,\n      default: null,\n    },\n    unsavedChanges: {\n      type: Boolean,\n      default: false,\n    },\n    isRendered: {\n      type: Boolean,\n      default: true,\n    },\n  },\n  computed: {\n    toolbarBtnClasses() {\n      return \'btn btn-link text-primary\';\n    },\n  },\n  watch: {\n    workflowUrl() {\n      this.loadWorkflow(this.workflowUrl);\n    },\n    unsavedChanges() {\n      this.unsavedChanges_ = this.unsavedChanges;\n    },\n    unsavedChanges_() {\n      this.$emit(\'unsaved-changes\', this.unsavedChanges_);\n    },\n    isRendered() {\n      this.resizeView(false);\n    },\n  },\n  methods: {\n    resetView() {\n      this.area.zoomAt(this.editor);\n    },\n    toggleFullscreen() {\n      kadi.utils.toggleFullscreen(this.$refs.container);\n    },\n    resetEditor() {\n      if (!window.confirm(\'Are you sure you want to reset the editor?\')) {\n        return;\n      }\n\n      this.editor.clear();\n      this.unsavedChanges_ = false;\n    },\n    resizeView(resetView = true) {\n      // In case the component is not marked as rendered from the outside we do not attempt to resize it.\n      if (!this.isRendered) {\n        return;\n      }\n\n      const width = this.$refs.editorContainer.getBoundingClientRect().width;\n      if (kadi.utils.isFullscreen()) {\n        this.$refs.editorContainer.style.height = \'100vh\';\n        this.$refs.editorContainer.style.borderRadius = \'0\';\n      } else {\n        this.$refs.editorContainer.style.height = `${Math.round(window.innerHeight / window.innerWidth * width)}px`;\n        this.$refs.editorContainer.style.borderRadius = \'0.25rem\';\n      }\n      this.editor.view.resize();\n\n      if (resetView) {\n        this.resetView();\n      }\n    },\n    loadWorkflow(url) {\n      axios.get(url)\n        .then((response) => {\n          // Catch errors in the custom conversion function as well.\n          try {\n            this.editor.fromFlow(response.data)\n              .then((success) => {\n                if (!success) {\n                  kadi.base.flashWarning(\'Could not fully reconstruct workflow.\');\n                }\n              })\n              .catch((error) => {\n                console.error(error);\n                kadi.base.flashDanger(\'Error parsing workflow data.\');\n              })\n              .finally(() => this.resetView());\n          } catch (error) {\n            console.error(error);\n            kadi.base.flashDanger(\'Error parsing workflow data.\');\n          }\n        })\n        .catch((error) => kadi.base.flashDanger(\'Error loading workflow.\', {request: error.request}));\n    },\n    addTool(tool) {\n      const componentName = ToolComponent.nameFromTool(tool);\n\n      // Register the tool node if it is missing.\n      if (!this.editor.components.has(componentName)) {\n        this.editor.register(new ToolComponent(tool));\n      }\n\n      this.addNode(this.editor.components.get(componentName));\n    },\n    async addNode(component) {\n      const node = await component.createNode();\n\n      node.position[0] = this.currX;\n      node.position[1] = this.currY;\n\n      this.editor.addNode(node);\n    },\n    beforeUnload(e) {\n      if (this.unsavedChanges_) {\n        e.preventDefault();\n        (e || window.event).returnValue = \'\';\n        return \'\';\n      }\n      return null;\n    },\n  },\n  mounted() {\n    this.editor = new WorkflowEditor(this.version, this.$refs.editor);\n    this.area = AreaPlugin;\n\n    // Disable some events if the editor is not editable.\n    if (!this.editable) {\n      let handler = (e) => {\n        // Do not disable the toolbar.\n        if (!Array.from(this.$refs.editorToolbar.getElementsByTagName(\'*\')).includes(e.target)) {\n          e.preventDefault();\n          e.stopPropagation();\n        }\n      };\n      this.$refs.editorContainer.addEventListener(\'click\', handler, {capture: true});\n\n      handler = (e) => {\n        if (e.target !== this.$refs.editor) {\n          e.preventDefault();\n          e.stopPropagation();\n        }\n      };\n      this.$refs.editorContainer.addEventListener(\'pointerdown\', handler, {capture: true});\n      this.$refs.editorContainer.addEventListener(\'pointerup\', handler, {capture: true});\n\n      handler = (e) => {\n        e.preventDefault();\n        e.stopPropagation();\n      };\n      this.$refs.editorContainer.addEventListener(\'dblclick\', handler, {capture: true});\n      this.$refs.editorContainer.addEventListener(\'contextmenu\', handler, {capture: true});\n    }\n\n    // Register all plugins.\n    this.editor.use(AreaPlugin, {snap: {size: 16, dynamic: true}});\n    this.editor.use(ConnectionPlugin);\n    this.editor.use(VueRenderPlugin);\n    this.editor.use(ContextMenuPlugin, {\n      vueComponent: VueMenu,\n      searchBar: true,\n      delay: 0,\n      items: this.menuItems,\n      allocate: () => null,\n    });\n\n    // Register all builtin components.\n    [\n      ...annotationComponents,\n      ...controlComponents,\n      ...fileIoComponents,\n      ...sourceComponents,\n      ...userInputComponents,\n      ...userOutputComponents,\n      ...miscComponents,\n    ].forEach((c) => this.editor.register(c));\n\n    // Setup the context menu with the tool selection and all previously registered components.\n    if (this.toolsEndpoint) {\n      this.menuItems[\'Select Tools...\'] = () => {\n        this.toolDialogActive = true;\n        $(this.$refs.toolDialog).modal({backdrop: false});\n      };\n      $(this.$refs.toolDialog).on(\'hidden.bs.modal\', () => {\n        this.toolDialogActive = false;\n      });\n    }\n\n    for (const component of this.editor.components.values()) {\n      // Skip components that do not specify a menu item.\n      if (!component.menu) {\n        continue;\n      }\n\n      if (!this.menuItems[component.menu]) {\n        this.menuItems[component.menu] = {};\n      }\n      this.menuItems[component.menu][component.name] = () => this.addNode(component);\n    }\n\n    if (kadi.globals.environment === \'development\') {\n      this.menuItems.Debug = {\n        /* eslint-disable no-console */\n        \'Dump Flow\': () => console.info(this.editor.toFlow()),\n        \'Dump JSON\': () => console.info(this.editor.toJSON()),\n        /* eslint-enable no-console */\n      };\n    }\n\n    this.editor.on(\'showcontextmenu\', ({e}) => {\n      const area = this.editor.view.area;\n      const rect = area.el.getBoundingClientRect();\n\n      // Store the mouse position at the time the context menu was opened.\n      this.currX = (e.clientX - rect.left) / area.transform.k;\n      this.currY = (e.clientY - rect.top) / area.transform.k;\n    });\n\n    // Handle unsaved changes on all relevant events.\n    const events = [\n      \'nodecreated\',\n      \'noderemoved\',\n      \'nodetranslated\',\n      \'connectioncreated\',\n      \'connectionremoved\',\n      \'controlchanged\',\n      \'unsavedchanges\',\n    ];\n    this.editor.on(events.join(\' \'), () => {\n      if (!this.editor.silent) {\n        this.unsavedChanges_ = true;\n      }\n    });\n\n    // Finish initializion.\n    this.resizeView();\n\n    if (this.workflowUrl) {\n      this.loadWorkflow(this.workflowUrl);\n    }\n\n    window.addEventListener(\'resize\', this.resizeView);\n    window.addEventListener(\'beforeunload\', this.beforeUnload);\n  },\n  beforeDestroy() {\n    window.removeEventListener(\'resize\', this.resizeView);\n    window.removeEventListener(\'beforeunload\', this.beforeUnload);\n    $(this.$refs.toolDialog).modal(\'dispose\');\n  },\n};\n<\/script>\n'],sourceRoot:""}]),e.exports=i},9195:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,"\n.input[data-v-51a83194] {\n  width: 160px;\n}\n","",{version:3,sources:["webpack://./kadi/assets/scripts/components/lib/workflows/controls/FormatControl.vue"],names:[],mappings:";AA0BA;EACA,YAAA;AACA",sourcesContent:['\x3c!-- Copyright 2022 Karlsruhe Institute of Technology\n   -\n   - Licensed under the Apache License, Version 2.0 (the "License");\n   - you may not use this file except in compliance with the License.\n   - You may obtain a copy of the License at\n   -\n   -     http://www.apache.org/licenses/LICENSE-2.0\n   -\n   - Unless required by applicable law or agreed to in writing, software\n   - distributed under the License is distributed on an "AS IS" BASIS,\n   - WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   - See the License for the specific language governing permissions and\n   - limitations under the License. --\x3e\n\n<template>\n  <div class="input-group" @pointerdown.stop>\n    <input class="form-control input" :title="value" v-model="value">\n    <div class="input-group-append">\n      <button class="btn btn-light" title="Revert to default" @click="value = defaultFormat">\n        <i class="fa-solid fa-rotate"></i>\n      </button>\n    </div>\n  </div>\n</template>\n\n<style scoped>\n.input {\n  width: 160px;\n}\n</style>\n\n<script>\nimport workflowControlMixn from \'scripts/components/mixins/workflow-control-mixin\';\n\nexport default {\n  mixins: [workflowControlMixn],\n  data() {\n    return {\n      defaultFormat: \'\',\n    };\n  },\n  props: {\n    defaultValue: String,\n  },\n  methods: {\n    updateDefaultFormat(defaultFormat) {\n      this.defaultFormat = defaultFormat;\n    },\n  },\n};\n<\/script>\n'],sourceRoot:""}]),e.exports=i},9951:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,"\n.input[data-v-40afaf14] {\n  width: 45px;\n}\n","",{version:3,sources:["webpack://./kadi/assets/scripts/components/lib/workflows/controls/PortControl.vue"],names:[],mappings:";AA6BA;EACA,WAAA;AACA",sourcesContent:['\x3c!-- Copyright 2021 Karlsruhe Institute of Technology\n   -\n   - Licensed under the Apache License, Version 2.0 (the "License");\n   - you may not use this file except in compliance with the License.\n   - You may obtain a copy of the License at\n   -\n   -     http://www.apache.org/licenses/LICENSE-2.0\n   -\n   - Unless required by applicable law or agreed to in writing, software\n   - distributed under the License is distributed on an "AS IS" BASIS,\n   - WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   - See the License for the specific language governing permissions and\n   - limitations under the License. --\x3e\n\n<template>\n  <div class="input-group" @pointerdown.stop>\n    <input class="form-control input" :title="value" v-model.number="value">\n    <div class="input-group-append">\n      <button class="btn btn-light" title="Remove port" @click="value--">\n        <i class="fa-solid fa-minus"></i>\n      </button>\n      <button class="btn btn-light" title="Add port" @click="value++">\n        <i class="fa-solid fa-plus"></i>\n      </button>\n    </div>\n  </div>\n</template>\n\n<style scoped>\n.input {\n  width: 45px;\n}\n</style>\n\n<script>\nimport workflowControlMixn from \'scripts/components/mixins/workflow-control-mixin\';\n\nexport default {\n  mixins: [workflowControlMixn],\n  props: {\n    defaultValue: Number,\n  },\n  methods: {\n    convertValue() {\n      const value = Number(this.value);\n\n      if (window.isNaN(value)) {\n        this.value = this.defaultValue;\n      } else if (value > 99) {\n        this.value = 99;\n      } else if (value < 0) {\n        this.value = 0;\n      } else {\n        this.value = Math.floor(value);\n      }\n    },\n  },\n};\n<\/script>\n'],sourceRoot:""}]),e.exports=i},7391:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,".connection{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path{fill:none;stroke:#adadad;stroke-width:3px}.connection .main-path:hover{stroke-width:4px;stroke:#6d6d6d}.connection>*{pointer-events:all}.item{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:215px}.item:hover{background-color:#e3e3e3}.item:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}[class=connection] .main-path{stroke-width:4px;stroke:#6d6d6d}","",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss"],names:[],mappings:"AAyBA,YACE,2BAAA,CACA,mBAAA,CACA,iBAAA,CACA,UAAA,CAEA,uBACE,SAAA,CACA,cAnBe,CAoBf,gBAAA,CAEA,6BACE,gBAAA,CACA,cAAA,CAIJ,cACE,kBAAA,CAIJ,MACE,wBA5Bc,CA6Bd,6BAAA,CACA,8BAAA,CACA,aAAA,CACA,cAAA,CACA,WAAA,CACA,iBAAA,CACA,WArCmB,CAuCnB,YACE,wBAAA,CAGF,kBACE,4BAAA,CACA,0BA9CiB,CA+CjB,2BA/CiB,CAkDnB,iBACE,+BAAA,CACA,6BApDiB,CAqDjB,8BArDiB,CA0DrB,8BACE,gBAAA,CACA,cAAA",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$connection-color: #adadad;\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 215px;\n\n$item-bg-color: #f8f8f8;\n\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $connection-color;\n    stroke-width: 3px;\n\n    &:hover {\n      stroke-width: 4px;\n      stroke: darken($connection-color, 25%);\n    }\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: $item-bg-color;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: #2e2e2e;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n\n// Currently drawn connections only have a single class applied.\n[class=\'connection\'] .main-path {\n  stroke-width: 4px;\n  stroke: darken($connection-color, 25%);\n}\n'],sourceRoot:""}]),e.exports=i},5881:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,".sheet-nav[data-v-3f92f4b0]{border-color:#dee2e6;border-radius:0}.sheet-nav[data-v-3f92f4b0]:not(:first-child){margin-left:-1px}.sheet-nav.active[data-v-3f92f4b0]{background-color:#dbdbdb}.sheet-table[data-v-3f92f4b0]{font-size:.825rem}","",{version:3,sources:["webpack://./kadi/assets/scripts/components/lib/previews/ExcelViewer.vue"],names:[],mappings:"AACA,4BACE,oBAAA,CACA,eAAA,CAEA,8CACE,gBAAA,CAGF,mCACE,wBAAA,CAIJ,8BACE,iBAAA",sourcesContent:["\n.sheet-nav {\n  border-color: #dee2e6;\n  border-radius: 0;\n\n  &:not(:first-child) {\n    margin-left: -1px;\n  }\n\n  &.active {\n    background-color: #dbdbdb;\n  }\n}\n\n.sheet-table {\n  font-size: 0.825rem;\n}\n"],sourceRoot:""}]),e.exports=i},8540:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,'.connection[data-v-560bf204]{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path[data-v-560bf204]{fill:none;stroke:#adadad;stroke-width:3px}.connection .main-path[data-v-560bf204]:hover{stroke-width:4px;stroke:#6d6d6d}.connection>*[data-v-560bf204]{pointer-events:all}.item[data-v-560bf204]{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:215px}.item[data-v-560bf204]:hover{background-color:#e3e3e3}.item[data-v-560bf204]:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item[data-v-560bf204]:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}[class=connection] .main-path[data-v-560bf204]{stroke-width:4px;stroke:#6d6d6d}.item[data-v-560bf204]{width:215px}.item.hasSubitems[data-v-560bf204]:after{content:">";opacity:.6;position:absolute;right:5px;top:5px}.item .subitems[data-v-560bf204]{border:1px solid #c9c9c9;left:100%;max-height:155px;overflow-x:hidden;overflow-y:auto;position:absolute;top:0}.item .subitems .item[data-v-560bf204]{border:0;border-radius:0}',"",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss","webpack://./kadi/assets/scripts/components/lib/workflows/view/Item.vue"],names:[],mappings:"AAyBA,6BACE,2BAAA,CACA,mBAAA,CACA,iBAAA,CACA,UAAA,CAEA,wCACE,SAAA,CACA,cAnBe,CAoBf,gBAAA,CAEA,8CACE,gBAAA,CACA,cAAA,CAIJ,+BACE,kBAAA,CAIJ,uBACE,wBA5Bc,CA6Bd,6BAAA,CACA,8BAAA,CACA,aAAA,CACA,cAAA,CACA,WAAA,CACA,iBAAA,CACA,WArCmB,CAuCnB,6BACE,wBAAA,CAGF,mCACE,4BAAA,CACA,0BA9CiB,CA+CjB,2BA/CiB,CAkDnB,kCACE,+BAAA,CACA,6BApDiB,CAqDjB,8BArDiB,CA0DrB,+CACE,gBAAA,CACA,cAAA,CC1EF,uBACE,WDcmB,CCZnB,yCACE,WAAA,CACA,UAAA,CACA,iBAAA,CACA,SAAA,CACA,OAAA,CAGF,iCACE,wBAAA,CACA,SAAA,CACA,gBAAA,CACA,iBAAA,CACA,eAAA,CACA,iBAAA,CACA,KAAA,CAEA,uCACE,QAAA,CACA,eAAA",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$connection-color: #adadad;\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 215px;\n\n$item-bg-color: #f8f8f8;\n\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $connection-color;\n    stroke-width: 3px;\n\n    &:hover {\n      stroke-width: 4px;\n      stroke: darken($connection-color, 25%);\n    }\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: $item-bg-color;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: #2e2e2e;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n\n// Currently drawn connections only have a single class applied.\n[class=\'connection\'] .main-path {\n  stroke-width: 4px;\n  stroke: darken($connection-color, 25%);\n}\n',"\n@import 'styles/workflows/workflow-editor.scss';\n\n.item {\n  width: $context-menu-width;\n\n  &.hasSubitems:after {\n    content: '>';\n    opacity: 0.6;\n    position: absolute;\n    right: 5px;\n    top: 5px;\n  }\n\n  .subitems {\n    border: 1px solid $context-menu-accent-color;\n    left: 100%;\n    max-height: 155px;\n    overflow-x: hidden;\n    overflow-y: auto;\n    position: absolute;\n    top: 0;\n\n    .item {\n      border: 0;\n      border-radius: 0;\n    }\n  }\n}\n"],sourceRoot:""}]),e.exports=i},4297:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,".connection[data-v-b541c1c0]{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path[data-v-b541c1c0]{fill:none;stroke:#adadad;stroke-width:3px}.connection .main-path[data-v-b541c1c0]:hover{stroke-width:4px;stroke:#6d6d6d}.connection>*[data-v-b541c1c0]{pointer-events:all}.item[data-v-b541c1c0]{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:215px}.item[data-v-b541c1c0]:hover{background-color:#e3e3e3}.item[data-v-b541c1c0]:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item[data-v-b541c1c0]:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}[class=connection] .main-path[data-v-b541c1c0]{stroke-width:4px;stroke:#6d6d6d}.context-menu[data-v-b541c1c0]{left:0;margin-left:-107.5px;margin-top:-20px;padding:10px;position:fixed;top:0;width:215px;z-index:1000}","",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss","webpack://./kadi/assets/scripts/components/lib/workflows/view/Menu.vue"],names:[],mappings:"AAyBA,6BACE,2BAAA,CACA,mBAAA,CACA,iBAAA,CACA,UAAA,CAEA,wCACE,SAAA,CACA,cAnBe,CAoBf,gBAAA,CAEA,8CACE,gBAAA,CACA,cAAA,CAIJ,+BACE,kBAAA,CAIJ,uBACE,wBA5Bc,CA6Bd,6BAAA,CACA,8BAAA,CACA,aAAA,CACA,cAAA,CACA,WAAA,CACA,iBAAA,CACA,WArCmB,CAuCnB,6BACE,wBAAA,CAGF,mCACE,4BAAA,CACA,0BA9CiB,CA+CjB,2BA/CiB,CAkDnB,kCACE,+BAAA,CACA,6BApDiB,CAqDjB,8BArDiB,CA0DrB,+CACE,gBAAA,CACA,cAAA,CC1EF,+BACE,MAAA,CACA,oBAAA,CACA,gBAAA,CACA,YAAA,CACA,cAAA,CACA,KAAA,CACA,WDQmB,CCPnB,YAAA",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$connection-color: #adadad;\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 215px;\n\n$item-bg-color: #f8f8f8;\n\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $connection-color;\n    stroke-width: 3px;\n\n    &:hover {\n      stroke-width: 4px;\n      stroke: darken($connection-color, 25%);\n    }\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: $item-bg-color;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: #2e2e2e;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n\n// Currently drawn connections only have a single class applied.\n[class=\'connection\'] .main-path {\n  stroke-width: 4px;\n  stroke: darken($connection-color, 25%);\n}\n',"\n@import 'styles/workflows/workflow-editor.scss';\n\n.context-menu {\n  left: 0;\n  margin-left: -$context-menu-width * 0.5;\n  margin-top: -20px;\n  padding: 10px;\n  position: fixed;\n  top: 0;\n  width: $context-menu-width;\n  z-index: 1000;\n}\n"],sourceRoot:""}]),e.exports=i},9281:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,".connection[data-v-29f7742a]{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path[data-v-29f7742a]{fill:none;stroke:#adadad;stroke-width:3px}.connection .main-path[data-v-29f7742a]:hover{stroke-width:4px;stroke:#6d6d6d}.connection>*[data-v-29f7742a]{pointer-events:all}.item[data-v-29f7742a]{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:215px}.item[data-v-29f7742a]:hover{background-color:#e3e3e3}.item[data-v-29f7742a]:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item[data-v-29f7742a]:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}[class=connection] .main-path[data-v-29f7742a]{stroke-width:4px;stroke:#6d6d6d}.dropdown-menu[data-v-29f7742a]{min-width:0}.node[data-v-29f7742a]{background:rgba(247,247,247,.85);border:2px solid #2e2e2e;border-radius:.75rem;box-sizing:border-box;color:#2e2e2e;cursor:pointer;height:auto;min-width:150px;padding-bottom:10px;padding-top:10px;position:relative;-webkit-user-select:none;-moz-user-select:none;user-select:none}.node .content[data-v-29f7742a]{display:table;width:100%}.node .content .column[data-v-29f7742a]{display:table-cell;white-space:nowrap}.node .content .column[data-v-29f7742a]:not(:last-child){padding-right:20px}.node .control[data-v-29f7742a]{max-width:325px;padding:5px 15px}.node .control .title[data-v-29f7742a]{min-width:75px}.node .dropdown-btn[data-v-29f7742a]{border:1px solid rgba(0,0,0,.3)}.node .input[data-v-29f7742a]{margin-bottom:5px;margin-top:5px;text-align:left}.node .output[data-v-29f7742a]{margin-bottom:5px;margin-top:5px;text-align:right}.node .validation[data-v-29f7742a]{color:#fff;padding:5px;font-size:85%}.node.env[data-v-29f7742a]{background:rgba(71,142,89,.85);color:#fff}.node.env .dropdown-btn[data-v-29f7742a]{border:1px solid rgba(255,255,255,.3);color:#fff}.node.program[data-v-29f7742a]{background:rgba(44,62,80,.85);color:#fff}.node.program .dropdown-btn[data-v-29f7742a]{border:1px solid rgba(255,255,255,.3);color:#fff}.node[data-v-29f7742a]:hover,.node.selected[data-v-29f7742a]{background:rgba(222,222,222,.85)}.node:hover.env[data-v-29f7742a],.node.selected.env[data-v-29f7742a]{background:rgba(54,108,68,.85)}.node:hover.program[data-v-29f7742a],.node.selected.program[data-v-29f7742a]{background:rgba(26,37,47,.85)}","",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss","webpack://./kadi/assets/scripts/components/lib/workflows/view/Node.vue"],names:[],mappings:"AAyBA,6BACE,2BAAA,CACA,mBAAA,CACA,iBAAA,CACA,UAAA,CAEA,wCACE,SAAA,CACA,cAnBe,CAoBf,gBAAA,CAEA,8CACE,gBAAA,CACA,cAAA,CAIJ,+BACE,kBAAA,CAIJ,uBACE,wBA5Bc,CA6Bd,6BAAA,CACA,8BAAA,CACA,aAAA,CACA,cAAA,CACA,WAAA,CACA,iBAAA,CACA,WArCmB,CAuCnB,6BACE,wBAAA,CAGF,mCACE,4BAAA,CACA,0BA9CiB,CA+CjB,2BA/CiB,CAkDnB,kCACE,+BAAA,CACA,6BApDiB,CAqDjB,8BArDiB,CA0DrB,+CACE,gBAAA,CACA,cAAA,CCpEF,gCACE,WAAA,CAGF,uBACE,gCAAA,CACA,wBAAA,CACA,oBAAA,CACA,qBAAA,CACA,aAAA,CACA,cAAA,CACA,WAAA,CACA,eAAA,CACA,mBAAA,CACA,gBAAA,CACA,iBAAA,CACA,wBAAA,CAAA,qBAAA,CAAA,gBAAA,CAEA,gCACE,aAAA,CACA,UAAA,CAEA,wCACE,kBAAA,CACA,kBAAA,CAEA,yDACE,kBAAA,CAKN,gCACE,eAAA,CACA,gBAAA,CAEA,uCACE,cAAA,CAIJ,qCACE,+BAAA,CAGF,8BACE,iBAhDQ,CAiDR,cAjDQ,CAkDR,eAAA,CAGF,+BACE,iBAtDQ,CAuDR,cAvDQ,CAwDR,gBAAA,CAGF,mCACE,UAAA,CACA,WAAA,CACA,aAAA,CAGF,2BACE,8BAAA,CACA,UAAA,CAEA,yCACE,qCAAA,CACA,UAAA,CAIJ,+BACE,6BAAA,CACA,UAAA,CAEA,6CACE,qCAAA,CACA,UAAA,CAIJ,6DACE,gCAAA,CAEA,qEACE,8BAAA,CAGF,6EACE,6BAAA",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$connection-color: #adadad;\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 215px;\n\n$item-bg-color: #f8f8f8;\n\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $connection-color;\n    stroke-width: 3px;\n\n    &:hover {\n      stroke-width: 4px;\n      stroke: darken($connection-color, 25%);\n    }\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: $item-bg-color;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: #2e2e2e;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n\n// Currently drawn connections only have a single class applied.\n[class=\'connection\'] .main-path {\n  stroke-width: 4px;\n  stroke: darken($connection-color, 25%);\n}\n',"\n@import 'styles/workflows/workflow-editor.scss';\n\n$bg-builtin: #f7f7f7;\n$bg-env: #478e59;\n$bg-program: #2c3e50;\n\n$io-margin: 5px;\n\n.dropdown-menu {\n  min-width: 0;\n}\n\n.node {\n  background: rgba($bg-builtin, 0.85);\n  border: 2px solid #2e2e2e;\n  border-radius: 0.75rem;\n  box-sizing: border-box;\n  color: #2e2e2e;\n  cursor: pointer;\n  height: auto;\n  min-width: 150px;\n  padding-bottom: 10px;\n  padding-top: 10px;\n  position: relative;\n  user-select: none;\n\n  .content {\n    display: table;\n    width: 100%;\n\n    .column {\n      display: table-cell;\n      white-space: nowrap;\n\n      &:not(:last-child) {\n        padding-right: 20px;\n      }\n    }\n  }\n\n  .control {\n    max-width: 325px;\n    padding: $socket-margin $socket-size * 0.5 + $socket-margin;\n\n    .title {\n      min-width: 75px;\n    }\n  }\n\n  .dropdown-btn {\n    border: 1px solid rgba(black, 0.3);\n  }\n\n  .input {\n    margin-bottom: $io-margin;\n    margin-top: $io-margin;\n    text-align: left;\n  }\n\n  .output {\n    margin-bottom: $io-margin;\n    margin-top: $io-margin;\n    text-align: right;\n  }\n\n  .validation {\n    color: white;\n    padding: 5px;\n    font-size: 85%;\n  }\n\n  &.env {\n    background: rgba($bg-env, 0.85);\n    color: white;\n\n    .dropdown-btn {\n      border: 1px solid rgba(white, 0.3);\n      color: white;\n    }\n  }\n\n  &.program {\n    background: rgba($bg-program, 0.85);\n    color: white;\n\n    .dropdown-btn {\n      border: 1px solid rgba(white, 0.3);\n      color: white;\n    }\n  }\n\n  &:hover, &.selected {\n    background: rgba(darken($bg-builtin, 10%), 0.85);\n\n    &.env {\n      background: rgba(darken($bg-env, 10%), 0.85);\n    }\n\n    &.program {\n      background: rgba(darken($bg-program, 10%), 0.85);\n    }\n  }\n}\n"],sourceRoot:""}]),e.exports=i},3673:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,".node[data-v-51294ea3]{background:rgba(245,236,154,.85);border:2px solid #f5ec9a;cursor:pointer;padding-top:30px;width:350px}.node[data-v-51294ea3]:hover,.node.selected[data-v-51294ea3]{background:rgba(240,227,108,.85)}.node .content[data-v-51294ea3]{background:rgba(252,249,224,.85);border:0;border-radius:0;box-shadow:none;color:#000;height:35px;min-height:35px;overflow:hidden;padding:5px;resize:none}","",{version:3,sources:["webpack://./kadi/assets/scripts/components/lib/workflows/view/Note.vue"],names:[],mappings:"AAGA,uBACE,gCAAA,CACA,wBAAA,CACA,cAAA,CACA,gBAAA,CACA,WAAA,CAEA,6DACE,gCAAA,CAGF,gCACE,gCAAA,CACA,QAAA,CACA,eAAA,CACA,eAAA,CACA,UAAA,CACA,WAAA,CACA,eAAA,CACA,eAAA,CACA,WAAA,CACA,WAAA",sourcesContent:["\n$bg-note: #f5ec9a;\n\n.node {\n  background: rgba($bg-note, 0.85);\n  border: 2px solid $bg-note;\n  cursor: pointer;\n  padding-top: 30px;\n  width: 350px;\n\n  &:hover, &.selected {\n    background: rgba(darken($bg-note, 10%), 0.85);\n  }\n\n  .content {\n    background: rgba(lighten($bg-note, 15%), 0.85);\n    border: 0;\n    border-radius: 0;\n    box-shadow: none;\n    color: black;\n    height: 35px;\n    min-height: 35px;\n    overflow: hidden;\n    padding: 5px;\n    resize: none;\n  }\n}\n"],sourceRoot:""}]),e.exports=i},8270:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,".connection[data-v-60675475]{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path[data-v-60675475]{fill:none;stroke:#adadad;stroke-width:3px}.connection .main-path[data-v-60675475]:hover{stroke-width:4px;stroke:#6d6d6d}.connection>*[data-v-60675475]{pointer-events:all}.item[data-v-60675475],.search[data-v-60675475]{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:215px}.item[data-v-60675475]:hover,.search[data-v-60675475]:hover{background-color:#e3e3e3}.item[data-v-60675475]:first-child,.search[data-v-60675475]:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item[data-v-60675475]:last-child,.search[data-v-60675475]:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}[class=connection] .main-path[data-v-60675475]{stroke-width:4px;stroke:#6d6d6d}.search[data-v-60675475]{border-bottom:1px solid #c9c9c9;padding:7px}.search[data-v-60675475]:hover{background-color:#f8f8f8;cursor:default}","",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss","webpack://./kadi/assets/scripts/components/lib/workflows/view/Search.vue"],names:[],mappings:"AAyBA,6BACE,2BAAA,CACA,mBAAA,CACA,iBAAA,CACA,UAAA,CAEA,wCACE,SAAA,CACA,cAnBe,CAoBf,gBAAA,CAEA,8CACE,gBAAA,CACA,cAAA,CAIJ,+BACE,kBAAA,CAIJ,gDACE,wBA5Bc,CA6Bd,6BAAA,CACA,8BAAA,CACA,aAAA,CACA,cAAA,CACA,WAAA,CACA,iBAAA,CACA,WArCmB,CAuCnB,4DACE,wBAAA,CAGF,wEACE,4BAAA,CACA,0BA9CiB,CA+CjB,2BA/CiB,CAkDnB,sEACE,+BAAA,CACA,6BApDiB,CAqDjB,8BArDiB,CA0DrB,+CACE,gBAAA,CACA,cAAA,CC1EF,yBAEE,+BAAA,CACA,WAAA,CAEA,+BACE,wBDWY,CCVZ,cAAA",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$connection-color: #adadad;\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 215px;\n\n$item-bg-color: #f8f8f8;\n\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $connection-color;\n    stroke-width: 3px;\n\n    &:hover {\n      stroke-width: 4px;\n      stroke: darken($connection-color, 25%);\n    }\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: $item-bg-color;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: #2e2e2e;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n\n// Currently drawn connections only have a single class applied.\n[class=\'connection\'] .main-path {\n  stroke-width: 4px;\n  stroke: darken($connection-color, 25%);\n}\n',"\n@import 'styles/workflows/workflow-editor.scss';\n\n.search {\n  @extend .item;\n  border-bottom: 1px solid $context-menu-accent-color;\n  padding: 7px;\n\n  &:hover {\n    background-color: $item-bg-color;\n    cursor: default;\n  }\n}\n"],sourceRoot:""}]),e.exports=i},247:function(e,t,n){var r=n(7537),i=n(3645)(r);i.push([e.id,".connection[data-v-25150d6f]{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path[data-v-25150d6f]{fill:none;stroke:#adadad;stroke-width:3px}.connection .main-path[data-v-25150d6f]:hover{stroke-width:4px;stroke:#6d6d6d}.connection>*[data-v-25150d6f]{pointer-events:all}.item[data-v-25150d6f]{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:215px}.item[data-v-25150d6f]:hover{background-color:#e3e3e3}.item[data-v-25150d6f]:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item[data-v-25150d6f]:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}[class=connection] .main-path[data-v-25150d6f]{stroke-width:4px;stroke:#6d6d6d}.socket[data-v-25150d6f]{align-items:center;background:#fff;border:2px solid #d3d3d3;border-radius:10px;box-sizing:border-box;cursor:pointer;display:inline-flex;height:20px;justify-content:center;margin:5px;position:relative;vertical-align:middle;width:20px;z-index:2}.socket.incompatible[data-v-25150d6f]{opacity:.2;transition:opacity .25s}.socket.input[data-v-25150d6f]{margin-left:-10px}.socket.output[data-v-25150d6f]{margin-right:-10px}.socket.used[data-v-25150d6f]{border:2px solid #adadad}.socket[data-v-25150d6f]:hover{border-width:4px;border:2px solid #6d6d6d}.socket[data-v-25150d6f]:not(.incompatible){opacity:1;transition:opacity .5s}.socket.bool[data-v-25150d6f]{background:#fa5a5a;color:#ce0606}.socket.dep[data-v-25150d6f]{background:#72de6d;color:#2ba626}.socket.env[data-v-25150d6f]{background:#636363;color:#232323}.socket.float[data-v-25150d6f]{background:#77dfed;color:#1bb5ca}.socket.int[data-v-25150d6f]{background:#c660fc;color:#8f04d8}.socket.pipe[data-v-25150d6f]{background:#ebe836;color:#93910f}.socket.str[data-v-25150d6f]{background:#6b9fff;color:#0052eb}","",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss","webpack://./kadi/assets/scripts/components/lib/workflows/view/Socket.vue"],names:[],mappings:"AAyBA,6BACE,2BAAA,CACA,mBAAA,CACA,iBAAA,CACA,UAAA,CAEA,wCACE,SAAA,CACA,cAnBe,CAoBf,gBAAA,CAEA,8CACE,gBAAA,CACA,cAAA,CAIJ,+BACE,kBAAA,CAIJ,uBACE,wBA5Bc,CA6Bd,6BAAA,CACA,8BAAA,CACA,aAAA,CACA,cAAA,CACA,WAAA,CACA,iBAAA,CACA,WArCmB,CAuCnB,6BACE,wBAAA,CAGF,mCACE,4BAAA,CACA,0BA9CiB,CA+CjB,2BA/CiB,CAkDnB,kCACE,+BAAA,CACA,6BApDiB,CAqDjB,8BArDiB,CA0DrB,+CACE,gBAAA,CACA,cAAA,CClEF,yBACE,kBAAA,CACA,eAAA,CACA,wBAAA,CACA,kBAAA,CACA,qBAAA,CACA,cAAA,CACA,mBAAA,CACA,WDIY,CCHZ,sBAAA,CACA,UDCc,CAAA,iBAAA,CCCd,qBAAA,CACA,UDDY,CCEZ,SAAA,CAEA,sCACE,UAAA,CACA,uBAAA,CAGF,+BACE,iBAAA,CAGF,gCACE,kBAAA,CAGF,8BACE,wBAAA,CAGF,+BACE,gBAAA,CACA,wBAAA,CAGF,4CACE,SAAA,CACA,sBAAA,CAKF,8BACE,kBAtDM,CAuDN,aAAA,CAGF,6BACE,kBA1DK,CA2DL,aAAA,CAGF,6BACE,kBA9DK,CA+DL,aAAA,CAGF,+BACE,kBAlEO,CAmEP,aAAA,CAGF,6BACE,kBAtEK,CAuEL,aAAA,CAGF,8BACE,kBA1EM,CA2EN,aAAA,CAGF,6BACE,kBA9EK,CA+EL,aAAA",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$connection-color: #adadad;\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 215px;\n\n$item-bg-color: #f8f8f8;\n\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $connection-color;\n    stroke-width: 3px;\n\n    &:hover {\n      stroke-width: 4px;\n      stroke: darken($connection-color, 25%);\n    }\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: $item-bg-color;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: #2e2e2e;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n\n// Currently drawn connections only have a single class applied.\n[class=\'connection\'] .main-path {\n  stroke-width: 4px;\n  stroke: darken($connection-color, 25%);\n}\n',"\n@import 'styles/workflows/workflow-editor.scss';\n\n$bg-bool: #fa5a5a;\n$bg-dep: #72de6d;\n$bg-env: #636363;\n$bg-float: #77dfed;\n$bg-int: #c660fc;\n$bg-pipe: #ebe836;\n$bg-str: #6b9fff;\n\n.socket {\n  align-items: center;\n  background: white;\n  border: 2px solid lighten($connection-color, 15%);\n  border-radius: $socket-size * 0.5;\n  box-sizing: border-box;\n  cursor: pointer;\n  display: inline-flex;\n  height: $socket-size;\n  justify-content: center;\n  margin: $socket-margin;\n  position: relative;\n  vertical-align: middle;\n  width: $socket-size;\n  z-index: 2;\n\n  &.incompatible {\n    opacity: 0.2;\n    transition: opacity 0.25s;\n  }\n\n  &.input {\n    margin-left: -$socket-size * 0.5;\n  }\n\n  &.output {\n    margin-right: -$socket-size * 0.5;\n  }\n\n  &.used {\n    border: 2px solid $connection-color;\n  }\n\n  &:hover {\n    border-width: 4px;\n    border: 2px solid darken($connection-color, 25%);\n  }\n\n  &:not(.incompatible) {\n    opacity: 1;\n    transition: opacity 0.5s;\n  }\n\n  /* Socket types. */\n\n  &.bool {\n    background: $bg-bool;\n    color: darken($bg-bool, 25%);\n  }\n\n  &.dep {\n    background: $bg-dep;\n    color: darken($bg-dep, 25%);\n  }\n\n  &.env {\n    background: $bg-env;\n    color: darken($bg-env, 25%);\n  }\n\n  &.float {\n    background: $bg-float;\n    color: darken($bg-float, 25%);\n  }\n\n  &.int {\n    background: $bg-int;\n    color: darken($bg-int, 25%);\n  }\n\n  &.pipe {\n    background: $bg-pipe;\n    color: darken($bg-pipe, 25%);\n  }\n\n  &.str {\n    background: $bg-str;\n    color: darken($bg-str, 25%);\n  }\n}\n"],sourceRoot:""}]),e.exports=i},3645:function(e){"use strict";e.exports=function(e){var t=[];return t.toString=function(){return this.map((function(t){var n="",r=void 0!==t[5];return t[4]&&(n+="@supports (".concat(t[4],") {")),t[2]&&(n+="@media ".concat(t[2]," {")),r&&(n+="@layer".concat(t[5].length>0?" ".concat(t[5]):""," {")),n+=e(t),r&&(n+="}"),t[2]&&(n+="}"),t[4]&&(n+="}"),n})).join("")},t.i=function(e,n,r,i,a){"string"==typeof e&&(e=[[null,e,void 0]]);var o={};if(r)for(var s=0;s<this.length;s++){var c=this[s][0];null!=c&&(o[c]=!0)}for(var l=0;l<e.length;l++){var u=[].concat(e[l]);r&&o[u[0]]||(void 0!==a&&(void 0===u[5]||(u[1]="@layer".concat(u[5].length>0?" ".concat(u[5]):""," {").concat(u[1],"}")),u[5]=a),n&&(u[2]?(u[1]="@media ".concat(u[2]," {").concat(u[1],"}"),u[2]=n):u[2]=n),i&&(u[4]?(u[1]="@supports (".concat(u[4],") {").concat(u[1],"}"),u[4]=i):u[4]="".concat(i)),t.push(u))}},t}},7537:function(e){"use strict";e.exports=function(e){var t=e[1],n=e[3];if(!n)return t;if("function"==typeof btoa){var r=btoa(unescape(encodeURIComponent(JSON.stringify(n)))),i="sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(r),a="/*# ".concat(i," */");return[t].concat([a]).join("\n")}return[t].join("\n")}},5666:function(e){var t=function(e){"use strict";var t,n=Object.prototype,r=n.hasOwnProperty,i=Object.defineProperty||function(e,t,n){e[t]=n.value},a="function"==typeof Symbol?Symbol:{},o=a.iterator||"@@iterator",s=a.asyncIterator||"@@asyncIterator",c=a.toStringTag||"@@toStringTag";function l(e,t,n){return Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}),e[t]}try{l({},"")}catch(e){l=function(e,t,n){return e[t]=n}}function u(e,t,n,r){var a=t&&t.prototype instanceof g?t:g,o=Object.create(a.prototype),s=new R(r||[]);return i(o,"_invoke",{value:S(e,n,s)}),o}function d(e,t,n){try{return{type:"normal",arg:e.call(t,n)}}catch(e){return{type:"throw",arg:e}}}e.wrap=u;var f="suspendedStart",h="suspendedYield",p="executing",m="completed",v={};function g(){}function b(){}function _(){}var y={};l(y,o,(function(){return this}));var x=Object.getPrototypeOf,A=x&&x(x(L([])));A&&A!==n&&r.call(A,o)&&(y=A);var w=_.prototype=g.prototype=Object.create(y);function E(e){["next","throw","return"].forEach((function(t){l(e,t,(function(e){return this._invoke(t,e)}))}))}function T(e,t){function n(i,a,o,s){var c=d(e[i],e,a);if("throw"!==c.type){var l=c.arg,u=l.value;return u&&"object"==typeof u&&r.call(u,"__await")?t.resolve(u.__await).then((function(e){n("next",e,o,s)}),(function(e){n("throw",e,o,s)})):t.resolve(u).then((function(e){l.value=e,o(l)}),(function(e){return n("throw",e,o,s)}))}s(c.arg)}var a;i(this,"_invoke",{value:function(e,r){function i(){return new t((function(t,i){n(e,r,t,i)}))}return a=a?a.then(i,i):i()}})}function S(e,t,n){var r=f;return function(i,a){if(r===p)throw new Error("Generator is already running");if(r===m){if("throw"===i)throw a;return O()}for(n.method=i,n.arg=a;;){var o=n.delegate;if(o){var s=C(o,n);if(s){if(s===v)continue;return s}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(r===f)throw r=m,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);r=p;var c=d(e,t,n);if("normal"===c.type){if(r=n.done?m:h,c.arg===v)continue;return{value:c.arg,done:n.done}}"throw"===c.type&&(r=m,n.method="throw",n.arg=c.arg)}}}function C(e,n){var r=n.method,i=e.iterator[r];if(i===t)return n.delegate=null,"throw"===r&&e.iterator.return&&(n.method="return",n.arg=t,C(e,n),"throw"===n.method)||"return"!==r&&(n.method="throw",n.arg=new TypeError("The iterator does not provide a '"+r+"' method")),v;var a=d(i,e.iterator,n.arg);if("throw"===a.type)return n.method="throw",n.arg=a.arg,n.delegate=null,v;var o=a.arg;return o?o.done?(n[e.resultName]=o.value,n.next=e.nextLoc,"return"!==n.method&&(n.method="next",n.arg=t),n.delegate=null,v):o:(n.method="throw",n.arg=new TypeError("iterator result is not an object"),n.delegate=null,v)}function M(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function k(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function R(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(M,this),this.reset(!0)}function L(e){if(e){var n=e[o];if(n)return n.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var i=-1,a=function n(){for(;++i<e.length;)if(r.call(e,i))return n.value=e[i],n.done=!1,n;return n.value=t,n.done=!0,n};return a.next=a}}return{next:O}}function O(){return{value:t,done:!0}}return b.prototype=_,i(w,"constructor",{value:_,configurable:!0}),i(_,"constructor",{value:b,configurable:!0}),b.displayName=l(_,c,"GeneratorFunction"),e.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===b||"GeneratorFunction"===(t.displayName||t.name))},e.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,_):(e.__proto__=_,l(e,c,"GeneratorFunction")),e.prototype=Object.create(w),e},e.awrap=function(e){return{__await:e}},E(T.prototype),l(T.prototype,s,(function(){return this})),e.AsyncIterator=T,e.async=function(t,n,r,i,a){void 0===a&&(a=Promise);var o=new T(u(t,n,r,i),a);return e.isGeneratorFunction(n)?o:o.next().then((function(e){return e.done?e.value:o.next()}))},E(w),l(w,c,"Generator"),l(w,o,(function(){return this})),l(w,"toString",(function(){return"[object Generator]"})),e.keys=function(e){var t=Object(e),n=[];for(var r in t)n.push(r);return n.reverse(),function e(){for(;n.length;){var r=n.pop();if(r in t)return e.value=r,e.done=!1,e}return e.done=!0,e}},e.values=L,R.prototype={constructor:R,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=t,this.done=!1,this.delegate=null,this.method="next",this.arg=t,this.tryEntries.forEach(k),!e)for(var n in this)"t"===n.charAt(0)&&r.call(this,n)&&!isNaN(+n.slice(1))&&(this[n]=t)},stop:function(){this.done=!0;var e=this.tryEntries[0].completion;if("throw"===e.type)throw e.arg;return this.rval},dispatchException:function(e){if(this.done)throw e;var n=this;function i(r,i){return s.type="throw",s.arg=e,n.next=r,i&&(n.method="next",n.arg=t),!!i}for(var a=this.tryEntries.length-1;a>=0;--a){var o=this.tryEntries[a],s=o.completion;if("root"===o.tryLoc)return i("end");if(o.tryLoc<=this.prev){var c=r.call(o,"catchLoc"),l=r.call(o,"finallyLoc");if(c&&l){if(this.prev<o.catchLoc)return i(o.catchLoc,!0);if(this.prev<o.finallyLoc)return i(o.finallyLoc)}else if(c){if(this.prev<o.catchLoc)return i(o.catchLoc,!0)}else{if(!l)throw new Error("try statement without catch or finally");if(this.prev<o.finallyLoc)return i(o.finallyLoc)}}}},abrupt:function(e,t){for(var n=this.tryEntries.length-1;n>=0;--n){var i=this.tryEntries[n];if(i.tryLoc<=this.prev&&r.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var a=i;break}}a&&("break"===e||"continue"===e)&&a.tryLoc<=t&&t<=a.finallyLoc&&(a=null);var o=a?a.completion:{};return o.type=e,o.arg=t,a?(this.method="next",this.next=a.finallyLoc,v):this.complete(o)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),v},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.finallyLoc===e)return this.complete(n.completion,n.afterLoc),k(n),v}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.tryLoc===e){var r=n.completion;if("throw"===r.type){var i=r.arg;k(n)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(e,n,r){return this.delegate={iterator:L(e),resultName:n,nextLoc:r},"next"===this.method&&(this.arg=t),v}},e}(e.exports);try{regeneratorRuntime=t}catch(e){"object"==typeof globalThis?globalThis.regeneratorRuntime=t:Function("r","regeneratorRuntime = r")(t)}},2823:function(e,t,n){var r=n(3365);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("eef1bc4e",r,!1,{})},2924:function(e,t,n){var r=n(4464);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("0592a71a",r,!1,{})},5120:function(e,t,n){var r=n(9195);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("38b0e480",r,!1,{})},5124:function(e,t,n){var r=n(9951);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("21819bef",r,!1,{})},6566:function(e,t,n){var r=n(7391);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("19a3e2e4",r,!1,{})},4172:function(e,t,n){var r=n(5881);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("6461ff75",r,!1,{})},2202:function(e,t,n){var r=n(8540);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("08d15e26",r,!1,{})},7002:function(e,t,n){var r=n(4297);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("b6ed9894",r,!1,{})},6162:function(e,t,n){var r=n(9281);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("7502b7ba",r,!1,{})},3632:function(e,t,n){var r=n(3673);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("223ff0be",r,!1,{})},3637:function(e,t,n){var r=n(8270);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("319a14db",r,!1,{})},5515:function(e,t,n){var r=n(247);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("02bb1984",r,!1,{})},5346:function(e,t,n){"use strict";function r(e,t){for(var n=[],r={},i=0;i<t.length;i++){var a=t[i],o=a[0],s={id:e+":"+i,css:a[1],media:a[2],sourceMap:a[3]};r[o]?r[o].parts.push(s):n.push(r[o]={id:o,parts:[s]})}return n}n.d(t,{Z:function(){return p}});var i="undefined"!=typeof document;if("undefined"!=typeof DEBUG&&DEBUG&&!i)throw new Error("vue-style-loader cannot be used in a non-browser environment. Use { target: 'node' } in your Webpack config to indicate a server-rendering environment.");var a={},o=i&&(document.head||document.getElementsByTagName("head")[0]),s=null,c=0,l=!1,u=function(){},d=null,f="data-vue-ssr-id",h="undefined"!=typeof navigator&&/msie [6-9]\b/.test(navigator.userAgent.toLowerCase());function p(e,t,n,i){l=n,d=i||{};var o=r(e,t);return m(o),function(t){for(var n=[],i=0;i<o.length;i++){var s=o[i];(c=a[s.id]).refs--,n.push(c)}for(t?m(o=r(e,t)):o=[],i=0;i<n.length;i++){var c;if(0===(c=n[i]).refs){for(var l=0;l<c.parts.length;l++)c.parts[l]();delete a[c.id]}}}}function m(e){for(var t=0;t<e.length;t++){var n=e[t],r=a[n.id];if(r){r.refs++;for(var i=0;i<r.parts.length;i++)r.parts[i](n.parts[i]);for(;i<n.parts.length;i++)r.parts.push(g(n.parts[i]));r.parts.length>n.parts.length&&(r.parts.length=n.parts.length)}else{var o=[];for(i=0;i<n.parts.length;i++)o.push(g(n.parts[i]));a[n.id]={id:n.id,refs:1,parts:o}}}}function v(){var e=document.createElement("style");return e.type="text/css",o.appendChild(e),e}function g(e){var t,n,r=document.querySelector("style["+f+'~="'+e.id+'"]');if(r){if(l)return u;r.parentNode.removeChild(r)}if(h){var i=c++;r=s||(s=v()),t=y.bind(null,r,i,!1),n=y.bind(null,r,i,!0)}else r=v(),t=x.bind(null,r),n=function(){r.parentNode.removeChild(r)};return t(e),function(r){if(r){if(r.css===e.css&&r.media===e.media&&r.sourceMap===e.sourceMap)return;t(e=r)}else n()}}var b,_=(b=[],function(e,t){return b[e]=t,b.filter(Boolean).join("\n")});function y(e,t,n,r){var i=n?"":r.css;if(e.styleSheet)e.styleSheet.cssText=_(t,i);else{var a=document.createTextNode(i),o=e.childNodes;o[t]&&e.removeChild(o[t]),o.length?e.insertBefore(a,o[t]):e.appendChild(a)}}function x(e,t){var n=t.css,r=t.media,i=t.sourceMap;if(r&&e.setAttribute("media",r),d.ssrId&&e.setAttribute(f,t.id),i&&(n+="\n/*# sourceURL="+i.sources[0]+" */",n+="\n/*# sourceMappingURL=data:application/json;base64,"+btoa(unescape(encodeURIComponent(JSON.stringify(i))))+" */"),e.styleSheet)e.styleSheet.cssText=n;else{for(;e.firstChild;)e.removeChild(e.firstChild);e.appendChild(document.createTextNode(n))}}}},t={};function n(r){var i=t[r];if(void 0!==i)return i.exports;var a=t[r]={id:r,exports:{}};return e[r](a,a.exports,n),a.exports}n.d=function(e,t){for(var r in t)n.o(t,r)&&!n.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:t[r]})},n.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(e){if("object"==typeof window)return window}}(),n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},function(){"use strict";var e=function(){var e=this,t=e._self._c;return t("div",[e.fileSize>e.maxFileSize&&!e.forceLoad?t("div",[t("button",{staticClass:"btn btn-sm btn-light mb-2",attrs:{type:"button"},on:{click:e.loadWorkbook}},[t("i",{staticClass:"fa-solid fa-eye"}),e._v(" "+e._s(e.$t("Load preview"))+"\n    ")])]):t("div",{staticClass:"card"},[t("div",{staticClass:"card-body p-1"},[e.loading?e._e():t("div",[e.currentSheet.length>0?t("div",{staticClass:"table-responsive max-vh-75 mb-3"},[t("table",{staticClass:"sheet-table table table-sm table-bordered table-hover mb-0"},[t("thead",{staticClass:"bg-light text-center"},[t("tr",[t("th"),e._v(" "),e._l(e.currentSheet[0],(function(n,r){return t("th",{key:r},[e._v(e._s(r))])}))],2)]),e._v(" "),t("tbody",e._l(e.currentSheet,(function(n,r){return t("tr",{key:r},[t("th",{staticClass:"bg-light align-middle text-center"},[e._v(e._s(r+1))]),e._v(" "),e._l(n,(function(n,r){return t("td",{key:r},[e._v(e._s(n))])}))],2)})),0)])]):e._e(),e._v(" "),t("div",{staticClass:"mb-2"},[0===e.currentSheet.length?t("em",{staticClass:"text-muted"},[e._v(e._s(e.$t("No content.")))]):e._e()])]),e._v(" "),t("div",{staticClass:"overflow-auto ws-nowrap"},e._l(e.sheetNames,(function(n){return t("span",{key:n,staticClass:"sheet-nav btn btn-sm btn-light",class:{active:n===e.currentSheetName},on:{click:function(t){return e.loadSheet(n)}}},[e._v("\n          "+e._s(n)+"\n        ")])})),0),e._v(" "),e.loading?t("div",{staticClass:"text-muted ml-1"},[t("i",{staticClass:"fa-solid fa-circle-notch fa-spin mr-1"}),e._v(" "+e._s(e.$t("Loading workbook..."))+"\n      ")]):e._e()])])])};e._withStripped=!0;var t,r=1200,i=1252,a=[874,932,936,949,950,1250,1251,1252,1253,1254,1255,1256,1257,1258,1e4],o={0:1252,1:65001,2:65001,77:1e4,128:932,129:949,130:1361,134:936,136:950,161:1253,162:1254,163:1258,177:1255,178:1256,186:1257,204:1251,222:874,238:1250,255:1252,69:6969},s=function(e){-1!=a.indexOf(e)&&(i=o[0]=e)},c=function(e){r=e,s(e)};function l(){c(1200),s(1252)}function u(e){for(var t=[],n=0,r=e.length;n<r;++n)t[n]=e.charCodeAt(n);return t}function d(e){for(var t=[],n=0;n<e.length>>1;++n)t[n]=String.fromCharCode(e.charCodeAt(2*n)+(e.charCodeAt(2*n+1)<<8));return t.join("")}function f(e){for(var t=[],n=0;n<e.length>>1;++n)t[n]=String.fromCharCode(e.charCodeAt(2*n+1)+(e.charCodeAt(2*n)<<8));return t.join("")}var h=function(e){var t=e.charCodeAt(0),n=e.charCodeAt(1);return 255==t&&254==n?d(e.slice(2)):254==t&&255==n?f(e.slice(2)):65279==t?e.slice(1):e},p=function(e){return String.fromCharCode(e)},m=function(e){return String.fromCharCode(e)},v=null,g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";function b(e){for(var t="",n=0,r=0,i=0,a=0,o=0,s=0,c=0,l=0;l<e.length;)a=(n=e.charCodeAt(l++))>>2,o=(3&n)<<4|(r=e.charCodeAt(l++))>>4,s=(15&r)<<2|(i=e.charCodeAt(l++))>>6,c=63&i,isNaN(r)?s=c=64:isNaN(i)&&(c=64),t+=g.charAt(a)+g.charAt(o)+g.charAt(s)+g.charAt(c);return t}function _(e){var t="",n=0,r=0,i=0,a=0,o=0,s=0;e=e.replace(/^data:([^\/]+\/[^\/]+)?;base64\,/,"").replace(/[^\w\+\/\=]/g,"");for(var c=0;c<e.length;)n=g.indexOf(e.charAt(c++))<<2|(a=g.indexOf(e.charAt(c++)))>>4,t+=String.fromCharCode(n),r=(15&a)<<4|(o=g.indexOf(e.charAt(c++)))>>2,64!==o&&(t+=String.fromCharCode(r)),i=(3&o)<<6|(s=g.indexOf(e.charAt(c++))),64!==s&&(t+=String.fromCharCode(i));return t}var y=function(){return"undefined"!=typeof Buffer&&"undefined"!=typeof process&&void 0!==process.versions&&!!process.versions.node}(),x=function(){if("undefined"!=typeof Buffer){var e=!Buffer.from;if(!e)try{Buffer.from("foo","utf8")}catch(t){e=!0}return e?function(e,t){return t?new Buffer(e,t):new Buffer(e)}:Buffer.from.bind(Buffer)}return function(){}}(),A=function(){if("undefined"==typeof Buffer)return!1;var e=x([65,0]);return!!e&&1==e.toString("utf16le").length}();function w(e){return y?Buffer.alloc?Buffer.alloc(e):new Buffer(e):"undefined"!=typeof Uint8Array?new Uint8Array(e):new Array(e)}function E(e){return y?Buffer.allocUnsafe?Buffer.allocUnsafe(e):new Buffer(e):"undefined"!=typeof Uint8Array?new Uint8Array(e):new Array(e)}var T=function(e){return y?x(e,"binary"):e.split("").map((function(e){return 255&e.charCodeAt(0)}))};function S(e){if(Array.isArray(e))return e.map((function(e){return String.fromCharCode(e)})).join("");for(var t=[],n=0;n<e.length;++n)t[n]=String.fromCharCode(e[n]);return t.join("")}function C(e){if("undefined"==typeof ArrayBuffer)throw new Error("Unsupported");if(e instanceof ArrayBuffer)return C(new Uint8Array(e));for(var t=new Array(e.length),n=0;n<e.length;++n)t[n]=e[n];return t}var M=y?function(e){return Buffer.concat(e.map((function(e){return Buffer.isBuffer(e)?e:x(e)})))}:function(e){if("undefined"!=typeof Uint8Array){var t=0,n=0;for(t=0;t<e.length;++t)n+=e[t].length;var r=new Uint8Array(n),i=0;for(t=0,n=0;t<e.length;n+=i,++t)i=e[t].length,e[t]instanceof Uint8Array?r.set(e[t],n):"string"==typeof e[t]?r.set(new Uint8Array(T(e[t])),n):r.set(new Uint8Array(e[t]),n);return r}return[].concat.apply([],e.map((function(e){return Array.isArray(e)?e:[].slice.call(e)})))},k=/\u0000/g,R=/[\u0001-\u0006]/g;function L(e){for(var t="",n=e.length-1;n>=0;)t+=e.charAt(n--);return t}function O(e,t){var n=""+e;return n.length>=t?n:Ve("0",t-n.length)+n}function I(e,t){var n=""+e;return n.length>=t?n:Ve(" ",t-n.length)+n}function P(e,t){var n=""+e;return n.length>=t?n:n+Ve(" ",t-n.length)}var D=Math.pow(2,32);function N(e,t){return e>D||e<-D?function(e,t){var n=""+Math.round(e);return n.length>=t?n:Ve("0",t-n.length)+n}(e,t):function(e,t){var n=""+e;return n.length>=t?n:Ve("0",t-n.length)+n}(Math.round(e),t)}function U(e,t){return t=t||0,e.length>=7+t&&103==(32|e.charCodeAt(t))&&101==(32|e.charCodeAt(t+1))&&110==(32|e.charCodeAt(t+2))&&101==(32|e.charCodeAt(t+3))&&114==(32|e.charCodeAt(t+4))&&97==(32|e.charCodeAt(t+5))&&108==(32|e.charCodeAt(t+6))}var F=[["Sun","Sunday"],["Mon","Monday"],["Tue","Tuesday"],["Wed","Wednesday"],["Thu","Thursday"],["Fri","Friday"],["Sat","Saturday"]],B=[["J","Jan","January"],["F","Feb","February"],["M","Mar","March"],["A","Apr","April"],["M","May","May"],["J","Jun","June"],["J","Jul","July"],["A","Aug","August"],["S","Sep","September"],["O","Oct","October"],["N","Nov","November"],["D","Dec","December"]],z={0:"General",1:"0",2:"0.00",3:"#,##0",4:"#,##0.00",9:"0%",10:"0.00%",11:"0.00E+00",12:"# ?/?",13:"# ??/??",14:"m/d/yy",15:"d-mmm-yy",16:"d-mmm",17:"mmm-yy",18:"h:mm AM/PM",19:"h:mm:ss AM/PM",20:"h:mm",21:"h:mm:ss",22:"m/d/yy h:mm",37:"#,##0 ;(#,##0)",38:"#,##0 ;[Red](#,##0)",39:"#,##0.00;(#,##0.00)",40:"#,##0.00;[Red](#,##0.00)",45:"mm:ss",46:"[h]:mm:ss",47:"mmss.0",48:"##0.0E+0",49:"@",56:'"上午/下午 "hh"時"mm"分"ss"秒 "'},H={5:37,6:38,7:39,8:40,23:0,24:0,25:0,26:0,27:14,28:14,29:14,30:14,31:14,50:14,51:14,52:14,53:14,54:14,55:14,56:14,57:14,58:14,59:1,60:2,61:3,62:4,67:9,68:10,69:12,70:13,71:14,72:14,73:15,74:16,75:17,76:20,77:21,78:22,79:45,80:46,81:47,82:0},V={5:'"$"#,##0_);\\("$"#,##0\\)',63:'"$"#,##0_);\\("$"#,##0\\)',6:'"$"#,##0_);[Red]\\("$"#,##0\\)',64:'"$"#,##0_);[Red]\\("$"#,##0\\)',7:'"$"#,##0.00_);\\("$"#,##0.00\\)',65:'"$"#,##0.00_);\\("$"#,##0.00\\)',8:'"$"#,##0.00_);[Red]\\("$"#,##0.00\\)',66:'"$"#,##0.00_);[Red]\\("$"#,##0.00\\)',41:'_(* #,##0_);_(* \\(#,##0\\);_(* "-"_);_(@_)',42:'_("$"* #,##0_);_("$"* \\(#,##0\\);_("$"* "-"_);_(@_)',43:'_(* #,##0.00_);_(* \\(#,##0.00\\);_(* "-"??_);_(@_)',44:'_("$"* #,##0.00_);_("$"* \\(#,##0.00\\);_("$"* "-"??_);_(@_)'};function G(e,t,n){for(var r=e<0?-1:1,i=e*r,a=0,o=1,s=0,c=1,l=0,u=0,d=Math.floor(i);l<t&&(s=(d=Math.floor(i))*o+a,u=d*l+c,!(i-d<5e-8));)i=1/(i-d),a=o,o=s,c=l,l=u;if(u>t&&(l>t?(u=c,s=a):(u=l,s=o)),!n)return[0,r*s,u];var f=Math.floor(r*s/u);return[f,r*s-f*u,u]}function W(e,t,n){if(e>2958465||e<0)return null;var r=0|e,i=Math.floor(86400*(e-r)),a=0,o=[],s={D:r,T:i,u:86400*(e-r)-i,y:0,m:0,d:0,H:0,M:0,S:0,q:0};if(Math.abs(s.u)<1e-6&&(s.u=0),t&&t.date1904&&(r+=1462),s.u>.9999&&(s.u=0,86400==++i&&(s.T=i=0,++r,++s.D)),60===r)o=n?[1317,10,29]:[1900,2,29],a=3;else if(0===r)o=n?[1317,8,29]:[1900,1,0],a=6;else{r>60&&--r;var c=new Date(1900,0,1);c.setDate(c.getDate()+r-1),o=[c.getFullYear(),c.getMonth()+1,c.getDate()],a=c.getDay(),r<60&&(a=(a+6)%7),n&&(a=function(e,t){t[0]-=581;var n=e.getDay();return e<60&&(n=(n+6)%7),n}(c,o))}return s.y=o[0],s.m=o[1],s.d=o[2],s.S=i%60,i=Math.floor(i/60),s.M=i%60,i=Math.floor(i/60),s.H=i,s.q=a,s}var j=new Date(1899,11,31,0,0,0),X=j.getTime(),Y=new Date(1900,2,1,0,0,0);function q(e,t){var n=e.getTime();return t?n-=1262304e5:e>=Y&&(n+=864e5),(n-(X+6e4*(e.getTimezoneOffset()-j.getTimezoneOffset())))/864e5}function K(e){return-1==e.indexOf(".")?e:e.replace(/(?:\.0*|(\.\d*[1-9])0+)$/,"$1")}function Z(e){var t,n=Math.floor(Math.log(Math.abs(e))*Math.LOG10E);return t=n>=-4&&n<=-1?e.toPrecision(10+n):Math.abs(n)<=9?function(e){var t=e<0?12:11,n=K(e.toFixed(12));return n.length<=t||(n=e.toPrecision(10)).length<=t?n:e.toExponential(5)}(e):10===n?e.toFixed(10).substr(0,12):function(e){var t=K(e.toFixed(11));return t.length>(e<0?12:11)||"0"===t||"-0"===t?e.toPrecision(6):t}(e),K(function(e){return-1==e.indexOf("E")?e:e.replace(/(?:\.0*|(\.\d*[1-9])0+)[Ee]/,"$1E").replace(/(E[+-])(\d)$/,"$10$2")}(t.toUpperCase()))}function J(e,t){switch(typeof e){case"string":return e;case"boolean":return e?"TRUE":"FALSE";case"number":return(0|e)===e?e.toString(10):Z(e);case"undefined":return"";case"object":if(null==e)return"";if(e instanceof Date)return be(14,q(e,t&&t.date1904),t)}throw new Error("unsupported value in General format: "+e)}function Q(e,t,n,r){var i,a="",o=0,s=0,c=n.y,l=0;switch(e){case 98:c=n.y+543;case 121:switch(t.length){case 1:case 2:i=c%100,l=2;break;default:i=c%1e4,l=4}break;case 109:switch(t.length){case 1:case 2:i=n.m,l=t.length;break;case 3:return B[n.m-1][1];case 5:return B[n.m-1][0];default:return B[n.m-1][2]}break;case 100:switch(t.length){case 1:case 2:i=n.d,l=t.length;break;case 3:return F[n.q][0];default:return F[n.q][1]}break;case 104:switch(t.length){case 1:case 2:i=1+(n.H+11)%12,l=t.length;break;default:throw"bad hour format: "+t}break;case 72:switch(t.length){case 1:case 2:i=n.H,l=t.length;break;default:throw"bad hour format: "+t}break;case 77:switch(t.length){case 1:case 2:i=n.M,l=t.length;break;default:throw"bad minute format: "+t}break;case 115:if("s"!=t&&"ss"!=t&&".0"!=t&&".00"!=t&&".000"!=t)throw"bad second format: "+t;return 0!==n.u||"s"!=t&&"ss"!=t?(s=r>=2?3===r?1e3:100:1===r?10:1,(o=Math.round(s*(n.S+n.u)))>=60*s&&(o=0),"s"===t?0===o?"0":""+o/s:(a=O(o,2+r),"ss"===t?a.substr(0,2):"."+a.substr(2,t.length-1))):O(n.S,t.length);case 90:switch(t){case"[h]":case"[hh]":i=24*n.D+n.H;break;case"[m]":case"[mm]":i=60*(24*n.D+n.H)+n.M;break;case"[s]":case"[ss]":i=60*(60*(24*n.D+n.H)+n.M)+Math.round(n.S+n.u);break;default:throw"bad abstime format: "+t}l=3===t.length?1:2;break;case 101:i=c,l=1}return l>0?O(i,l):""}function ee(e){if(e.length<=3)return e;for(var t=e.length%3,n=e.substr(0,t);t!=e.length;t+=3)n+=(n.length>0?",":"")+e.substr(t,3);return n}var te=/%/g;function ne(e,t){var n,r=e.indexOf("E")-e.indexOf(".")-1;if(e.match(/^#+0.0E\+0$/)){if(0==t)return"0.0E+0";if(t<0)return"-"+ne(e,-t);var i=e.indexOf(".");-1===i&&(i=e.indexOf("E"));var a=Math.floor(Math.log(t)*Math.LOG10E)%i;if(a<0&&(a+=i),-1===(n=(t/Math.pow(10,a)).toPrecision(r+1+(i+a)%i)).indexOf("e")){var o=Math.floor(Math.log(t)*Math.LOG10E);for(-1===n.indexOf(".")?n=n.charAt(0)+"."+n.substr(1)+"E+"+(o-n.length+a):n+="E+"+(o-a);"0."===n.substr(0,2);)n=(n=n.charAt(0)+n.substr(2,i)+"."+n.substr(2+i)).replace(/^0+([1-9])/,"$1").replace(/^0+\./,"0.");n=n.replace(/\+-/,"-")}n=n.replace(/^([+-]?)(\d*)\.(\d*)[Ee]/,(function(e,t,n,r){return t+n+r.substr(0,(i+a)%i)+"."+r.substr(a)+"E"}))}else n=t.toExponential(r);return e.match(/E\+00$/)&&n.match(/e[+-]\d$/)&&(n=n.substr(0,n.length-1)+"0"+n.charAt(n.length-1)),e.match(/E\-/)&&n.match(/e\+/)&&(n=n.replace(/e\+/,"e")),n.replace("e","E")}var re=/# (\?+)( ?)\/( ?)(\d+)/,ie=/^#*0*\.([0#]+)/,ae=/\).*[0#]/,oe=/\(###\) ###\\?-####/;function se(e){for(var t,n="",r=0;r!=e.length;++r)switch(t=e.charCodeAt(r)){case 35:break;case 63:n+=" ";break;case 48:n+="0";break;default:n+=String.fromCharCode(t)}return n}function ce(e,t){var n=Math.pow(10,t);return""+Math.round(e*n)/n}function le(e,t){var n=e-Math.floor(e),r=Math.pow(10,t);return t<(""+Math.round(n*r)).length?0:Math.round(n*r)}function ue(e,t,n){if(40===e.charCodeAt(0)&&!t.match(ae)){var r=t.replace(/\( */,"").replace(/ \)/,"").replace(/\)/,"");return n>=0?ue("n",r,n):"("+ue("n",r,-n)+")"}if(44===t.charCodeAt(t.length-1))return function(e,t,n){for(var r=t.length-1;44===t.charCodeAt(r-1);)--r;return he(e,t.substr(0,r),n/Math.pow(10,3*(t.length-r)))}(e,t,n);if(-1!==t.indexOf("%"))return function(e,t,n){var r=t.replace(te,""),i=t.length-r.length;return he(e,r,n*Math.pow(10,2*i))+Ve("%",i)}(e,t,n);if(-1!==t.indexOf("E"))return ne(t,n);if(36===t.charCodeAt(0))return"$"+ue(e,t.substr(" "==t.charAt(1)?2:1),n);var i,a,o,s,c=Math.abs(n),l=n<0?"-":"";if(t.match(/^00+$/))return l+N(c,t.length);if(t.match(/^[#?]+$/))return"0"===(i=N(n,0))&&(i=""),i.length>t.length?i:se(t.substr(0,t.length-i.length))+i;if(a=t.match(re))return function(e,t,n){var r=parseInt(e[4],10),i=Math.round(t*r),a=Math.floor(i/r),o=i-a*r,s=r;return n+(0===a?"":""+a)+" "+(0===o?Ve(" ",e[1].length+1+e[4].length):I(o,e[1].length)+e[2]+"/"+e[3]+O(s,e[4].length))}(a,c,l);if(t.match(/^#+0+$/))return l+N(c,t.length-t.indexOf("0"));if(a=t.match(ie))return i=ce(n,a[1].length).replace(/^([^\.]+)$/,"$1."+se(a[1])).replace(/\.$/,"."+se(a[1])).replace(/\.(\d*)$/,(function(e,t){return"."+t+Ve("0",se(a[1]).length-t.length)})),-1!==t.indexOf("0.")?i:i.replace(/^0\./,".");if(t=t.replace(/^#+([0.])/,"$1"),a=t.match(/^(0*)\.(#*)$/))return l+ce(c,a[2].length).replace(/\.(\d*[1-9])0*$/,".$1").replace(/^(-?\d*)$/,"$1.").replace(/^0\./,a[1].length?"0.":".");if(a=t.match(/^#{1,3},##0(\.?)$/))return l+ee(N(c,0));if(a=t.match(/^#,##0\.([#0]*0)$/))return n<0?"-"+ue(e,t,-n):ee(""+(Math.floor(n)+function(e,t){return t<(""+Math.round((e-Math.floor(e))*Math.pow(10,t))).length?1:0}(n,a[1].length)))+"."+O(le(n,a[1].length),a[1].length);if(a=t.match(/^#,#*,#0/))return ue(e,t.replace(/^#,#*,/,""),n);if(a=t.match(/^([0#]+)(\\?-([0#]+))+$/))return i=L(ue(e,t.replace(/[\\-]/g,""),n)),o=0,L(L(t.replace(/\\/g,"")).replace(/[0#]/g,(function(e){return o<i.length?i.charAt(o++):"0"===e?"0":""})));if(t.match(oe))return"("+(i=ue(e,"##########",n)).substr(0,3)+") "+i.substr(3,3)+"-"+i.substr(6);var u="";if(a=t.match(/^([#0?]+)( ?)\/( ?)([#0?]+)/))return o=Math.min(a[4].length,7),s=G(c,Math.pow(10,o)-1,!1),i=""+l," "==(u=he("n",a[1],s[1])).charAt(u.length-1)&&(u=u.substr(0,u.length-1)+"0"),i+=u+a[2]+"/"+a[3],(u=P(s[2],o)).length<a[4].length&&(u=se(a[4].substr(a[4].length-u.length))+u),i+=u;if(a=t.match(/^# ([#0?]+)( ?)\/( ?)([#0?]+)/))return o=Math.min(Math.max(a[1].length,a[4].length),7),l+((s=G(c,Math.pow(10,o)-1,!0))[0]||(s[1]?"":"0"))+" "+(s[1]?I(s[1],o)+a[2]+"/"+a[3]+P(s[2],o):Ve(" ",2*o+1+a[2].length+a[3].length));if(a=t.match(/^[#0?]+$/))return i=N(n,0),t.length<=i.length?i:se(t.substr(0,t.length-i.length))+i;if(a=t.match(/^([#0?]+)\.([#0]+)$/)){i=""+n.toFixed(Math.min(a[2].length,10)).replace(/([^0])0+$/,"$1"),o=i.indexOf(".");var d=t.indexOf(".")-o,f=t.length-i.length-d;return se(t.substr(0,d)+i+t.substr(t.length-f))}if(a=t.match(/^00,000\.([#0]*0)$/))return o=le(n,a[1].length),n<0?"-"+ue(e,t,-n):ee(function(e){return e<2147483647&&e>-2147483648?""+(e>=0?0|e:e-1|0):""+Math.floor(e)}(n)).replace(/^\d,\d{3}$/,"0$&").replace(/^\d*$/,(function(e){return"00,"+(e.length<3?O(0,3-e.length):"")+e}))+"."+O(o,a[1].length);switch(t){case"###,##0.00":return ue(e,"#,##0.00",n);case"###,###":case"##,###":case"#,###":var h=ee(N(c,0));return"0"!==h?l+h:"";case"###,###.00":return ue(e,"###,##0.00",n).replace(/^0\./,".");case"#,###.00":return ue(e,"#,##0.00",n).replace(/^0\./,".")}throw new Error("unsupported format |"+t+"|")}function de(e,t){var n,r=e.indexOf("E")-e.indexOf(".")-1;if(e.match(/^#+0.0E\+0$/)){if(0==t)return"0.0E+0";if(t<0)return"-"+de(e,-t);var i=e.indexOf(".");-1===i&&(i=e.indexOf("E"));var a=Math.floor(Math.log(t)*Math.LOG10E)%i;if(a<0&&(a+=i),!(n=(t/Math.pow(10,a)).toPrecision(r+1+(i+a)%i)).match(/[Ee]/)){var o=Math.floor(Math.log(t)*Math.LOG10E);-1===n.indexOf(".")?n=n.charAt(0)+"."+n.substr(1)+"E+"+(o-n.length+a):n+="E+"+(o-a),n=n.replace(/\+-/,"-")}n=n.replace(/^([+-]?)(\d*)\.(\d*)[Ee]/,(function(e,t,n,r){return t+n+r.substr(0,(i+a)%i)+"."+r.substr(a)+"E"}))}else n=t.toExponential(r);return e.match(/E\+00$/)&&n.match(/e[+-]\d$/)&&(n=n.substr(0,n.length-1)+"0"+n.charAt(n.length-1)),e.match(/E\-/)&&n.match(/e\+/)&&(n=n.replace(/e\+/,"e")),n.replace("e","E")}function fe(e,t,n){if(40===e.charCodeAt(0)&&!t.match(ae)){var r=t.replace(/\( */,"").replace(/ \)/,"").replace(/\)/,"");return n>=0?fe("n",r,n):"("+fe("n",r,-n)+")"}if(44===t.charCodeAt(t.length-1))return function(e,t,n){for(var r=t.length-1;44===t.charCodeAt(r-1);)--r;return he(e,t.substr(0,r),n/Math.pow(10,3*(t.length-r)))}(e,t,n);if(-1!==t.indexOf("%"))return function(e,t,n){var r=t.replace(te,""),i=t.length-r.length;return he(e,r,n*Math.pow(10,2*i))+Ve("%",i)}(e,t,n);if(-1!==t.indexOf("E"))return de(t,n);if(36===t.charCodeAt(0))return"$"+fe(e,t.substr(" "==t.charAt(1)?2:1),n);var i,a,o,s,c=Math.abs(n),l=n<0?"-":"";if(t.match(/^00+$/))return l+O(c,t.length);if(t.match(/^[#?]+$/))return i=""+n,0===n&&(i=""),i.length>t.length?i:se(t.substr(0,t.length-i.length))+i;if(a=t.match(re))return function(e,t,n){return n+(0===t?"":""+t)+Ve(" ",e[1].length+2+e[4].length)}(a,c,l);if(t.match(/^#+0+$/))return l+O(c,t.length-t.indexOf("0"));if(a=t.match(ie))return i=(i=(""+n).replace(/^([^\.]+)$/,"$1."+se(a[1])).replace(/\.$/,"."+se(a[1]))).replace(/\.(\d*)$/,(function(e,t){return"."+t+Ve("0",se(a[1]).length-t.length)})),-1!==t.indexOf("0.")?i:i.replace(/^0\./,".");if(t=t.replace(/^#+([0.])/,"$1"),a=t.match(/^(0*)\.(#*)$/))return l+(""+c).replace(/\.(\d*[1-9])0*$/,".$1").replace(/^(-?\d*)$/,"$1.").replace(/^0\./,a[1].length?"0.":".");if(a=t.match(/^#{1,3},##0(\.?)$/))return l+ee(""+c);if(a=t.match(/^#,##0\.([#0]*0)$/))return n<0?"-"+fe(e,t,-n):ee(""+n)+"."+Ve("0",a[1].length);if(a=t.match(/^#,#*,#0/))return fe(e,t.replace(/^#,#*,/,""),n);if(a=t.match(/^([0#]+)(\\?-([0#]+))+$/))return i=L(fe(e,t.replace(/[\\-]/g,""),n)),o=0,L(L(t.replace(/\\/g,"")).replace(/[0#]/g,(function(e){return o<i.length?i.charAt(o++):"0"===e?"0":""})));if(t.match(oe))return"("+(i=fe(e,"##########",n)).substr(0,3)+") "+i.substr(3,3)+"-"+i.substr(6);var u="";if(a=t.match(/^([#0?]+)( ?)\/( ?)([#0?]+)/))return o=Math.min(a[4].length,7),s=G(c,Math.pow(10,o)-1,!1),i=""+l," "==(u=he("n",a[1],s[1])).charAt(u.length-1)&&(u=u.substr(0,u.length-1)+"0"),i+=u+a[2]+"/"+a[3],(u=P(s[2],o)).length<a[4].length&&(u=se(a[4].substr(a[4].length-u.length))+u),i+=u;if(a=t.match(/^# ([#0?]+)( ?)\/( ?)([#0?]+)/))return o=Math.min(Math.max(a[1].length,a[4].length),7),l+((s=G(c,Math.pow(10,o)-1,!0))[0]||(s[1]?"":"0"))+" "+(s[1]?I(s[1],o)+a[2]+"/"+a[3]+P(s[2],o):Ve(" ",2*o+1+a[2].length+a[3].length));if(a=t.match(/^[#0?]+$/))return i=""+n,t.length<=i.length?i:se(t.substr(0,t.length-i.length))+i;if(a=t.match(/^([#0]+)\.([#0]+)$/)){i=""+n.toFixed(Math.min(a[2].length,10)).replace(/([^0])0+$/,"$1"),o=i.indexOf(".");var d=t.indexOf(".")-o,f=t.length-i.length-d;return se(t.substr(0,d)+i+t.substr(t.length-f))}if(a=t.match(/^00,000\.([#0]*0)$/))return n<0?"-"+fe(e,t,-n):ee(""+n).replace(/^\d,\d{3}$/,"0$&").replace(/^\d*$/,(function(e){return"00,"+(e.length<3?O(0,3-e.length):"")+e}))+"."+O(0,a[1].length);switch(t){case"###,###":case"##,###":case"#,###":var h=ee(""+c);return"0"!==h?l+h:"";default:if(t.match(/\.[0#?]*$/))return fe(e,t.slice(0,t.lastIndexOf(".")),n)+se(t.slice(t.lastIndexOf(".")))}throw new Error("unsupported format |"+t+"|")}function he(e,t,n){return(0|n)===n?fe(e,t,n):ue(e,t,n)}var pe=/\[[HhMmSs\u0E0A\u0E19\u0E17]*\]/;function me(e){for(var t=0,n="",r="";t<e.length;)switch(n=e.charAt(t)){case"G":U(e,t)&&(t+=6),t++;break;case'"':for(;34!==e.charCodeAt(++t)&&t<e.length;);++t;break;case"\\":case"_":t+=2;break;case"@":++t;break;case"B":case"b":if("1"===e.charAt(t+1)||"2"===e.charAt(t+1))return!0;case"M":case"D":case"Y":case"H":case"S":case"E":case"m":case"d":case"y":case"h":case"s":case"e":case"g":return!0;case"A":case"a":case"上":if("A/P"===e.substr(t,3).toUpperCase())return!0;if("AM/PM"===e.substr(t,5).toUpperCase())return!0;if("上午/下午"===e.substr(t,5).toUpperCase())return!0;++t;break;case"[":for(r=n;"]"!==e.charAt(t++)&&t<e.length;)r+=e.charAt(t);if(r.match(pe))return!0;break;case".":case"0":case"#":for(;t<e.length&&("0#?.,E+-%".indexOf(n=e.charAt(++t))>-1||"\\"==n&&"-"==e.charAt(t+1)&&"0#".indexOf(e.charAt(t+2))>-1););break;case"?":for(;e.charAt(++t)===n;);break;case"*":++t," "!=e.charAt(t)&&"*"!=e.charAt(t)||++t;break;case"(":case")":++t;break;case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":for(;t<e.length&&"0123456789".indexOf(e.charAt(++t))>-1;);break;default:++t}return!1}var ve=/\[(=|>[=]?|<[>=]?)(-?\d+(?:\.\d*)?)\]/;function ge(e,t){if(null==t)return!1;var n=parseFloat(t[2]);switch(t[1]){case"=":if(e==n)return!0;break;case">":if(e>n)return!0;break;case"<":if(e<n)return!0;break;case"<>":if(e!=n)return!0;break;case">=":if(e>=n)return!0;break;case"<=":if(e<=n)return!0}return!1}function be(e,t,n){null==n&&(n={});var r="";switch(typeof e){case"string":r="m/d/yy"==e&&n.dateNF?n.dateNF:e;break;case"number":null==(r=14==e&&n.dateNF?n.dateNF:(null!=n.table?n.table:z)[e])&&(r=n.table&&n.table[H[e]]||z[H[e]]),null==r&&(r=V[e]||"General")}if(U(r,0))return J(t,n);t instanceof Date&&(t=q(t,n.date1904));var i=function(e,t){var n=function(e){for(var t=[],n=!1,r=0,i=0;r<e.length;++r)switch(e.charCodeAt(r)){case 34:n=!n;break;case 95:case 42:case 92:++r;break;case 59:t[t.length]=e.substr(i,r-i),i=r+1}if(t[t.length]=e.substr(i),!0===n)throw new Error("Format |"+e+"| unterminated string ");return t}(e),r=n.length,i=n[r-1].indexOf("@");if(r<4&&i>-1&&--r,n.length>4)throw new Error("cannot find right format for |"+n.join("|")+"|");if("number"!=typeof t)return[4,4===n.length||i>-1?n[n.length-1]:"@"];switch(n.length){case 1:n=i>-1?["General","General","General",n[0]]:[n[0],n[0],n[0],"@"];break;case 2:n=i>-1?[n[0],n[0],n[0],n[1]]:[n[0],n[1],n[0],"@"];break;case 3:n=i>-1?[n[0],n[1],n[0],n[2]]:[n[0],n[1],n[2],"@"]}var a=t>0?n[0]:t<0?n[1]:n[2];if(-1===n[0].indexOf("[")&&-1===n[1].indexOf("["))return[r,a];if(null!=n[0].match(/\[[=<>]/)||null!=n[1].match(/\[[=<>]/)){var o=n[0].match(ve),s=n[1].match(ve);return ge(t,o)?[r,n[0]]:ge(t,s)?[r,n[1]]:[r,n[null!=o&&null!=s?2:1]]}return[r,a]}(r,t);if(U(i[1]))return J(t,n);if(!0===t)t="TRUE";else if(!1===t)t="FALSE";else if(""===t||null==t)return"";return function(e,t,n,r){for(var i,a,o,s=[],c="",l=0,u="",d="t",f="H";l<e.length;)switch(u=e.charAt(l)){case"G":if(!U(e,l))throw new Error("unrecognized character "+u+" in "+e);s[s.length]={t:"G",v:"General"},l+=7;break;case'"':for(c="";34!==(o=e.charCodeAt(++l))&&l<e.length;)c+=String.fromCharCode(o);s[s.length]={t:"t",v:c},++l;break;case"\\":var h=e.charAt(++l),p="("===h||")"===h?h:"t";s[s.length]={t:p,v:h},++l;break;case"_":s[s.length]={t:"t",v:" "},l+=2;break;case"@":s[s.length]={t:"T",v:t},++l;break;case"B":case"b":if("1"===e.charAt(l+1)||"2"===e.charAt(l+1)){if(null==i&&null==(i=W(t,n,"2"===e.charAt(l+1))))return"";s[s.length]={t:"X",v:e.substr(l,2)},d=u,l+=2;break}case"M":case"D":case"Y":case"H":case"S":case"E":u=u.toLowerCase();case"m":case"d":case"y":case"h":case"s":case"e":case"g":if(t<0)return"";if(null==i&&null==(i=W(t,n)))return"";for(c=u;++l<e.length&&e.charAt(l).toLowerCase()===u;)c+=u;"m"===u&&"h"===d.toLowerCase()&&(u="M"),"h"===u&&(u=f),s[s.length]={t:u,v:c},d=u;break;case"A":case"a":case"上":var m={t:u,v:u};if(null==i&&(i=W(t,n)),"A/P"===e.substr(l,3).toUpperCase()?(null!=i&&(m.v=i.H>=12?e.charAt(l+2):u),m.t="T",f="h",l+=3):"AM/PM"===e.substr(l,5).toUpperCase()?(null!=i&&(m.v=i.H>=12?"PM":"AM"),m.t="T",l+=5,f="h"):"上午/下午"===e.substr(l,5).toUpperCase()?(null!=i&&(m.v=i.H>=12?"下午":"上午"),m.t="T",l+=5,f="h"):(m.t="t",++l),null==i&&"T"===m.t)return"";s[s.length]=m,d=u;break;case"[":for(c=u;"]"!==e.charAt(l++)&&l<e.length;)c+=e.charAt(l);if("]"!==c.slice(-1))throw'unterminated "[" block: |'+c+"|";if(c.match(pe)){if(null==i&&null==(i=W(t,n)))return"";s[s.length]={t:"Z",v:c.toLowerCase()},d=c.charAt(1)}else c.indexOf("$")>-1&&(c=(c.match(/\$([^-\[\]]*)/)||[])[1]||"$",me(e)||(s[s.length]={t:"t",v:c}));break;case".":if(null!=i){for(c=u;++l<e.length&&"0"===(u=e.charAt(l));)c+=u;s[s.length]={t:"s",v:c};break}case"0":case"#":for(c=u;++l<e.length&&"0#?.,E+-%".indexOf(u=e.charAt(l))>-1;)c+=u;s[s.length]={t:"n",v:c};break;case"?":for(c=u;e.charAt(++l)===u;)c+=u;s[s.length]={t:u,v:c},d=u;break;case"*":++l," "!=e.charAt(l)&&"*"!=e.charAt(l)||++l;break;case"(":case")":s[s.length]={t:1===r?"t":u,v:u},++l;break;case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":for(c=u;l<e.length&&"0123456789".indexOf(e.charAt(++l))>-1;)c+=e.charAt(l);s[s.length]={t:"D",v:c};break;case" ":s[s.length]={t:u,v:u},++l;break;case"$":s[s.length]={t:"t",v:"$"},++l;break;default:if(-1===",$-+/():!^&'~{}<>=€acfijklopqrtuvwxzP".indexOf(u))throw new Error("unrecognized character "+u+" in "+e);s[s.length]={t:"t",v:u},++l}var v,g=0,b=0;for(l=s.length-1,d="t";l>=0;--l)switch(s[l].t){case"h":case"H":s[l].t=f,d="h",g<1&&(g=1);break;case"s":(v=s[l].v.match(/\.0+$/))&&(b=Math.max(b,v[0].length-1)),g<3&&(g=3);case"d":case"y":case"M":case"e":d=s[l].t;break;case"m":"s"===d&&(s[l].t="M",g<2&&(g=2));break;case"X":break;case"Z":g<1&&s[l].v.match(/[Hh]/)&&(g=1),g<2&&s[l].v.match(/[Mm]/)&&(g=2),g<3&&s[l].v.match(/[Ss]/)&&(g=3)}switch(g){case 0:break;case 1:i.u>=.5&&(i.u=0,++i.S),i.S>=60&&(i.S=0,++i.M),i.M>=60&&(i.M=0,++i.H);break;case 2:i.u>=.5&&(i.u=0,++i.S),i.S>=60&&(i.S=0,++i.M)}var _,y="";for(l=0;l<s.length;++l)switch(s[l].t){case"t":case"T":case" ":case"D":break;case"X":s[l].v="",s[l].t=";";break;case"d":case"m":case"y":case"h":case"H":case"M":case"s":case"e":case"b":case"Z":s[l].v=Q(s[l].t.charCodeAt(0),s[l].v,i,b),s[l].t="t";break;case"n":case"?":for(_=l+1;null!=s[_]&&("?"===(u=s[_].t)||"D"===u||(" "===u||"t"===u)&&null!=s[_+1]&&("?"===s[_+1].t||"t"===s[_+1].t&&"/"===s[_+1].v)||"("===s[l].t&&(" "===u||"n"===u||")"===u)||"t"===u&&("/"===s[_].v||" "===s[_].v&&null!=s[_+1]&&"?"==s[_+1].t));)s[l].v+=s[_].v,s[_]={v:"",t:";"},++_;y+=s[l].v,l=_-1;break;case"G":s[l].t="t",s[l].v=J(t,n)}var x,A,w="";if(y.length>0){40==y.charCodeAt(0)?(x=t<0&&45===y.charCodeAt(0)?-t:t,A=he("n",y,x)):(A=he("n",y,x=t<0&&r>1?-t:t),x<0&&s[0]&&"t"==s[0].t&&(A=A.substr(1),s[0].v="-"+s[0].v)),_=A.length-1;var E=s.length;for(l=0;l<s.length;++l)if(null!=s[l]&&"t"!=s[l].t&&s[l].v.indexOf(".")>-1){E=l;break}var T=s.length;if(E===s.length&&-1===A.indexOf("E")){for(l=s.length-1;l>=0;--l)null!=s[l]&&-1!=="n?".indexOf(s[l].t)&&(_>=s[l].v.length-1?(_-=s[l].v.length,s[l].v=A.substr(_+1,s[l].v.length)):_<0?s[l].v="":(s[l].v=A.substr(0,_+1),_=-1),s[l].t="t",T=l);_>=0&&T<s.length&&(s[T].v=A.substr(0,_+1)+s[T].v)}else if(E!==s.length&&-1===A.indexOf("E")){for(_=A.indexOf(".")-1,l=E;l>=0;--l)if(null!=s[l]&&-1!=="n?".indexOf(s[l].t)){for(a=s[l].v.indexOf(".")>-1&&l===E?s[l].v.indexOf(".")-1:s[l].v.length-1,w=s[l].v.substr(a+1);a>=0;--a)_>=0&&("0"===s[l].v.charAt(a)||"#"===s[l].v.charAt(a))&&(w=A.charAt(_--)+w);s[l].v=w,s[l].t="t",T=l}for(_>=0&&T<s.length&&(s[T].v=A.substr(0,_+1)+s[T].v),_=A.indexOf(".")+1,l=E;l<s.length;++l)if(null!=s[l]&&(-1!=="n?(".indexOf(s[l].t)||l===E)){for(a=s[l].v.indexOf(".")>-1&&l===E?s[l].v.indexOf(".")+1:0,w=s[l].v.substr(0,a);a<s[l].v.length;++a)_<A.length&&(w+=A.charAt(_++));s[l].v=w,s[l].t="t",T=l}}}for(l=0;l<s.length;++l)null!=s[l]&&"n?".indexOf(s[l].t)>-1&&(x=r>1&&t<0&&l>0&&"-"===s[l-1].v?-t:t,s[l].v=he(s[l].t,s[l].v,x),s[l].t="t");var S="";for(l=0;l!==s.length;++l)null!=s[l]&&(S+=s[l].v);return S}(i[1],t,n,i[0])}function _e(){var e;e||(e={}),e[0]="General",e[1]="0",e[2]="0.00",e[3]="#,##0",e[4]="#,##0.00",e[9]="0%",e[10]="0.00%",e[11]="0.00E+00",e[12]="# ?/?",e[13]="# ??/??",e[14]="m/d/yy",e[15]="d-mmm-yy",e[16]="d-mmm",e[17]="mmm-yy",e[18]="h:mm AM/PM",e[19]="h:mm:ss AM/PM",e[20]="h:mm",e[21]="h:mm:ss",e[22]="m/d/yy h:mm",e[37]="#,##0 ;(#,##0)",e[38]="#,##0 ;[Red](#,##0)",e[39]="#,##0.00;(#,##0.00)",e[40]="#,##0.00;[Red](#,##0.00)",e[45]="mm:ss",e[46]="[h]:mm:ss",e[47]="mmss.0",e[48]="##0.0E+0",e[49]="@",e[56]='"上午/下午 "hh"時"mm"分"ss"秒 "',z=e}var ye={5:'"$"#,##0_);\\("$"#,##0\\)',6:'"$"#,##0_);[Red]\\("$"#,##0\\)',7:'"$"#,##0.00_);\\("$"#,##0.00\\)',8:'"$"#,##0.00_);[Red]\\("$"#,##0.00\\)',23:"General",24:"General",25:"General",26:"General",27:"m/d/yy",28:"m/d/yy",29:"m/d/yy",30:"m/d/yy",31:"m/d/yy",32:"h:mm:ss",33:"h:mm:ss",34:"h:mm:ss",35:"h:mm:ss",36:"m/d/yy",41:'_(* #,##0_);_(* (#,##0);_(* "-"_);_(@_)',42:'_("$"* #,##0_);_("$"* (#,##0);_("$"* "-"_);_(@_)',43:'_(* #,##0.00_);_(* (#,##0.00);_(* "-"??_);_(@_)',44:'_("$"* #,##0.00_);_("$"* (#,##0.00);_("$"* "-"??_);_(@_)',50:"m/d/yy",51:"m/d/yy",52:"m/d/yy",53:"m/d/yy",54:"m/d/yy",55:"m/d/yy",56:"m/d/yy",57:"m/d/yy",58:"m/d/yy",59:"0",60:"0.00",61:"#,##0",62:"#,##0.00",63:'"$"#,##0_);\\("$"#,##0\\)',64:'"$"#,##0_);[Red]\\("$"#,##0\\)',65:'"$"#,##0.00_);\\("$"#,##0.00\\)',66:'"$"#,##0.00_);[Red]\\("$"#,##0.00\\)',67:"0%",68:"0.00%",69:"# ?/?",70:"# ??/??",71:"m/d/yy",72:"m/d/yy",73:"d-mmm-yy",74:"d-mmm",75:"mmm-yy",76:"h:mm",77:"h:mm:ss",78:"m/d/yy h:mm",79:"mm:ss",80:"[h]:mm:ss",81:"mmss.0"},xe=/[dD]+|[mM]+|[yYeE]+|[Hh]+|[Ss]+/g,Ae={"d.m":"d\\.m"};function we(e,t){return function(e,t){if("number"!=typeof t){t=+t||-1;for(var n=0;n<392;++n)if(null!=z[n]){if(z[n]==e){t=n;break}}else t<0&&(t=n);t<0&&(t=391)}return z[t]=e,t}(Ae[e]||e,t)}var Ee,Te=function(){var e={version:"1.2.0"},t=function(){for(var e=0,t=new Array(256),n=0;256!=n;++n)e=1&(e=1&(e=1&(e=1&(e=1&(e=1&(e=1&(e=1&(e=n)?-306674912^e>>>1:e>>>1)?-306674912^e>>>1:e>>>1)?-306674912^e>>>1:e>>>1)?-306674912^e>>>1:e>>>1)?-306674912^e>>>1:e>>>1)?-306674912^e>>>1:e>>>1)?-306674912^e>>>1:e>>>1)?-306674912^e>>>1:e>>>1,t[n]=e;return"undefined"!=typeof Int32Array?new Int32Array(t):t}(),n=function(e){var t=0,n=0,r=0,i="undefined"!=typeof Int32Array?new Int32Array(4096):new Array(4096);for(r=0;256!=r;++r)i[r]=e[r];for(r=0;256!=r;++r)for(n=e[r],t=256+r;t<4096;t+=256)n=i[t]=n>>>8^e[255&n];var a=[];for(r=1;16!=r;++r)a[r-1]="undefined"!=typeof Int32Array&&"function"==typeof i.subarray?i.subarray(256*r,256*r+256):i.slice(256*r,256*r+256);return a}(t),r=n[0],i=n[1],a=n[2],o=n[3],s=n[4],c=n[5],l=n[6],u=n[7],d=n[8],f=n[9],h=n[10],p=n[11],m=n[12],v=n[13],g=n[14];return e.table=t,e.bstr=function(e,n){for(var r=-1^n,i=0,a=e.length;i<a;)r=r>>>8^t[255&(r^e.charCodeAt(i++))];return~r},e.buf=function(e,n){for(var b=-1^n,_=e.length-15,y=0;y<_;)b=g[e[y++]^255&b]^v[e[y++]^b>>8&255]^m[e[y++]^b>>16&255]^p[e[y++]^b>>>24]^h[e[y++]]^f[e[y++]]^d[e[y++]]^u[e[y++]]^l[e[y++]]^c[e[y++]]^s[e[y++]]^o[e[y++]]^a[e[y++]]^i[e[y++]]^r[e[y++]]^t[e[y++]];for(_+=15;y<_;)b=b>>>8^t[255&(b^e[y++])];return~b},e.str=function(e,n){for(var r=-1^n,i=0,a=e.length,o=0,s=0;i<a;)(o=e.charCodeAt(i++))<128?r=r>>>8^t[255&(r^o)]:o<2048?r=(r=r>>>8^t[255&(r^(192|o>>6&31))])>>>8^t[255&(r^(128|63&o))]:o>=55296&&o<57344?(o=64+(1023&o),s=1023&e.charCodeAt(i++),r=(r=(r=(r=r>>>8^t[255&(r^(240|o>>8&7))])>>>8^t[255&(r^(128|o>>2&63))])>>>8^t[255&(r^(128|s>>6&15|(3&o)<<4))])>>>8^t[255&(r^(128|63&s))]):r=(r=(r=r>>>8^t[255&(r^(224|o>>12&15))])>>>8^t[255&(r^(128|o>>6&63))])>>>8^t[255&(r^(128|63&o))];return~r},e}(),Se=function(){var e,t={};function n(e){if("/"==e.charAt(e.length-1))return-1===e.slice(0,-1).indexOf("/")?e:n(e.slice(0,-1));var t=e.lastIndexOf("/");return-1===t?e:e.slice(0,t+1)}function r(e){if("/"==e.charAt(e.length-1))return r(e.slice(0,-1));var t=e.lastIndexOf("/");return-1===t?e:e.slice(t+1)}function i(e,t){"string"==typeof t&&(t=new Date(t));var n=t.getHours();n=(n=n<<6|t.getMinutes())<<5|t.getSeconds()>>>1,e.write_shift(2,n);var r=t.getFullYear()-1980;r=(r=r<<4|t.getMonth()+1)<<5|t.getDate(),e.write_shift(2,r)}function a(e){_n(e,0);for(var t={},n=0;e.l<=e.length-4;){var r=e.read_shift(2),i=e.read_shift(2),a=e.l+i,o={};switch(r){case 21589:1&(n=e.read_shift(1))&&(o.mtime=e.read_shift(4)),i>5&&(2&n&&(o.atime=e.read_shift(4)),4&n&&(o.ctime=e.read_shift(4))),o.mtime&&(o.mt=new Date(1e3*o.mtime));break;case 1:var s=e.read_shift(4),c=e.read_shift(4);o.usz=c*Math.pow(2,32)+s,s=e.read_shift(4),c=e.read_shift(4),o.csz=c*Math.pow(2,32)+s}e.l=a,t[r]=o}return t}function o(){return e||(e=Ee)}function s(e,t){if(80==e[0]&&75==e[1])return he(e,t);if(109==(32|e[0])&&105==(32|e[1]))return function(e,t){if("mime-version:"!=O(e.slice(0,13)).toLowerCase())throw new Error("Unsupported MAD header");var n=t&&t.root||"",r=(y&&Buffer.isBuffer(e)?e.toString("binary"):O(e)).split("\r\n"),i=0,a="";for(i=0;i<r.length;++i)if(a=r[i],/^Content-Location:/i.test(a)&&(a=a.slice(a.indexOf("file")),n||(n=a.slice(0,a.lastIndexOf("/")+1)),a.slice(0,n.length)!=n))for(;n.length>0&&(n=(n=n.slice(0,n.length-1)).slice(0,n.lastIndexOf("/")+1),a.slice(0,n.length)!=n););var o=(r[1]||"").match(/boundary="(.*?)"/);if(!o)throw new Error("MAD cannot find boundary");var s="--"+(o[1]||""),c={FileIndex:[],FullPaths:[]};f(c);var l,u=0;for(i=0;i<r.length;++i){var d=r[i];d!==s&&d!==s+"--"||(u++&&_e(c,r.slice(l,i),n),l=i)}return c}(e,t);if(e.length<512)throw new Error("CFB file size "+e.length+" < 512");var n,r,i,a,o,s,h=512,p=[],m=e.slice(0,512);_n(m,0);var v=function(e){if(80==e[e.l]&&75==e[e.l+1])return[0,0];e.chk(A,"Header Signature: "),e.l+=16;var t=e.read_shift(2,"u");return[e.read_shift(2,"u"),t]}(m);switch(n=v[0]){case 3:h=512;break;case 4:h=4096;break;case 0:if(0==v[1])return he(e,t);default:throw new Error("Major Version: Expected 3 or 4 saw "+n)}512!==h&&_n(m=e.slice(0,h),28);var b=e.slice(0,h);!function(e,t){var n;switch(e.l+=2,n=e.read_shift(2)){case 9:if(3!=t)throw new Error("Sector Shift: Expected 9 saw "+n);break;case 12:if(4!=t)throw new Error("Sector Shift: Expected 12 saw "+n);break;default:throw new Error("Sector Shift: Expected 9 or 12 saw "+n)}e.chk("0600","Mini Sector Shift: "),e.chk("000000000000","Reserved: ")}(m,n);var _=m.read_shift(4,"i");if(3===n&&0!==_)throw new Error("# Directory Sectors: Expected 0 saw "+_);m.l+=4,a=m.read_shift(4,"i"),m.l+=4,m.chk("00100000","Mini Stream Cutoff Size: "),o=m.read_shift(4,"i"),r=m.read_shift(4,"i"),s=m.read_shift(4,"i"),i=m.read_shift(4,"i");for(var x=-1,w=0;w<109&&!((x=m.read_shift(4,"i"))<0);++w)p[w]=x;var E=function(e,t){for(var n=Math.ceil(e.length/t)-1,r=[],i=1;i<n;++i)r[i-1]=e.slice(i*t,(i+1)*t);return r[n-1]=e.slice(n*t),r}(e,h);l(s,i,E,h,p);var T=function(e,t,n,r){var i=e.length,a=[],o=[],s=[],c=[],l=r-1,u=0,d=0,f=0,h=0;for(u=0;u<i;++u)if(s=[],(f=u+t)>=i&&(f-=i),!o[f]){c=[];var p=[];for(d=f;d>=0;){p[d]=!0,o[d]=!0,s[s.length]=d,c.push(e[d]);var m=n[Math.floor(4*d/r)];if(r<4+(h=4*d&l))throw new Error("FAT boundary crossed: "+d+" 4 "+r);if(!e[m])break;if(p[d=dn(e[m],h)])break}a[f]={nodes:s,data:Bt([c])}}return a}(E,a,p,h);a<T.length&&(T[a].name="!Directory"),r>0&&o!==g&&(T[o].name="!MiniFAT"),T[p[0]].name="!FAT",T.fat_addrs=p,T.ssz=h;var S=[],C=[],M=[];!function(e,t,n,r,i,a,o,s){for(var l,f=0,h=r.length?2:0,p=t[e].data,m=0,v=0;m<p.length;m+=128){var b=p.slice(m,m+128);_n(b,64),v=b.read_shift(2),l=Ht(b,0,v-h),r.push(l);var _={name:l,type:b.read_shift(1),color:b.read_shift(1),L:b.read_shift(4,"i"),R:b.read_shift(4,"i"),C:b.read_shift(4,"i"),clsid:b.read_shift(16),state:b.read_shift(4,"i"),start:0,size:0};0!==b.read_shift(2)+b.read_shift(2)+b.read_shift(2)+b.read_shift(2)&&(_.ct=d(b,b.l-8)),0!==b.read_shift(2)+b.read_shift(2)+b.read_shift(2)+b.read_shift(2)&&(_.mt=d(b,b.l-8)),_.start=b.read_shift(4,"i"),_.size=b.read_shift(4,"i"),_.size<0&&_.start<0&&(_.size=_.type=0,_.start=g,_.name=""),5===_.type?(f=_.start,i>0&&f!==g&&(t[f].name="!StreamData")):_.size>=4096?(_.storage="fat",void 0===t[_.start]&&(t[_.start]=u(n,_.start,t.fat_addrs,t.ssz)),t[_.start].name=_.name,_.content=t[_.start].data.slice(0,_.size)):(_.storage="minifat",_.size<0?_.size=0:f!==g&&_.start!==g&&t[f]&&(_.content=c(_,t[f].data,(t[s]||{}).data))),_.content&&_n(_.content,0),a[l]=_,o.push(_)}}(a,T,E,S,r,{},C,o),function(e,t,n){for(var r=0,i=0,a=0,o=0,s=0,c=n.length,l=[],u=[];r<c;++r)l[r]=u[r]=r,t[r]=n[r];for(;s<u.length;++s)i=e[r=u[s]].L,a=e[r].R,o=e[r].C,l[r]===r&&(-1!==i&&l[i]!==i&&(l[r]=l[i]),-1!==a&&l[a]!==a&&(l[r]=l[a])),-1!==o&&(l[o]=r),-1!==i&&r!=l[r]&&(l[i]=l[r],u.lastIndexOf(i)<s&&u.push(i)),-1!==a&&r!=l[r]&&(l[a]=l[r],u.lastIndexOf(a)<s&&u.push(a));for(r=1;r<c;++r)l[r]===r&&(-1!==a&&l[a]!==a?l[r]=l[a]:-1!==i&&l[i]!==i&&(l[r]=l[i]));for(r=1;r<c;++r)if(0!==e[r].type){if((s=r)!=l[s])do{s=l[s],t[r]=t[s]+"/"+t[r]}while(0!==s&&-1!==l[s]&&s!=l[s]);l[r]=-1}for(t[0]+="/",r=1;r<c;++r)2!==e[r].type&&(t[r]+="/")}(C,M,S),S.shift();var k={FileIndex:C,FullPaths:M};return t&&t.raw&&(k.raw={header:b,sectors:E}),k}function c(e,t,n){for(var r=e.start,i=e.size,a=[],o=r;n&&i>0&&o>=0;)a.push(t.slice(o*v,o*v+v)),i-=v,o=dn(n,4*o);return 0===a.length?xn(0):M(a).slice(0,e.size)}function l(e,t,n,r,i){var a=g;if(e===g){if(0!==t)throw new Error("DIFAT chain shorter than expected")}else if(-1!==e){var o=n[e],s=(r>>>2)-1;if(!o)return;for(var c=0;c<s&&(a=dn(o,4*c))!==g;++c)i.push(a);t>=1&&l(dn(o,r-4),t-1,n,r,i)}}function u(e,t,n,r,i){var a=[],o=[];i||(i=[]);var s=r-1,c=0,l=0;for(c=t;c>=0;){i[c]=!0,a[a.length]=c,o.push(e[c]);var u=n[Math.floor(4*c/r)];if(r<4+(l=4*c&s))throw new Error("FAT boundary crossed: "+c+" 4 "+r);if(!e[u])break;c=dn(e[u],l)}return{nodes:a,data:Bt([o])}}function d(e,t){return new Date(1e3*(un(e,t+4)/1e7*Math.pow(2,32)+un(e,t)/1e7-11644473600))}function f(e,t){var n=t||{},r=n.root||"Root Entry";if(e.FullPaths||(e.FullPaths=[]),e.FileIndex||(e.FileIndex=[]),e.FullPaths.length!==e.FileIndex.length)throw new Error("inconsistent CFB structure");0===e.FullPaths.length&&(e.FullPaths[0]=r+"/",e.FileIndex[0]={name:r,type:5}),n.CLSID&&(e.FileIndex[0].clsid=n.CLSID),function(e){var t="Sh33tJ5";if(!Se.find(e,"/"+t)){var n=xn(4);n[0]=55,n[1]=n[3]=50,n[2]=54,e.FileIndex.push({name:t,type:2,content:n,size:4,L:69,R:69,C:69}),e.FullPaths.push(e.FullPaths[0]+t),h(e)}}(e)}function h(e,t){f(e);for(var i=!1,a=!1,o=e.FullPaths.length-1;o>=0;--o){var s=e.FileIndex[o];switch(s.type){case 0:a?i=!0:(e.FileIndex.pop(),e.FullPaths.pop());break;case 1:case 2:case 5:a=!0,isNaN(s.R*s.L*s.C)&&(i=!0),s.R>-1&&s.L>-1&&s.R==s.L&&(i=!0);break;default:i=!0}}if(i||t){var c=new Date(1987,1,19),l=0,u=Object.create?Object.create(null):{},d=[];for(o=0;o<e.FullPaths.length;++o)u[e.FullPaths[o]]=!0,0!==e.FileIndex[o].type&&d.push([e.FullPaths[o],e.FileIndex[o]]);for(o=0;o<d.length;++o){var h=n(d[o][0]);for(a=u[h];!a;){for(;n(h)&&!u[n(h)];)h=n(h);d.push([h,{name:r(h).replace("/",""),type:1,clsid:C,ct:c,mt:c,content:null}]),u[h]=!0,a=u[h=n(d[o][0])]}}for(d.sort((function(e,t){return function(e,t){for(var n=e.split("/"),r=t.split("/"),i=0,a=0,o=Math.min(n.length,r.length);i<o;++i){if(a=n[i].length-r[i].length)return a;if(n[i]!=r[i])return n[i]<r[i]?-1:1}return n.length-r.length}(e[0],t[0])})),e.FullPaths=[],e.FileIndex=[],o=0;o<d.length;++o)e.FullPaths[o]=d[o][0],e.FileIndex[o]=d[o][1];for(o=0;o<d.length;++o){var p=e.FileIndex[o],m=e.FullPaths[o];if(p.name=r(m).replace("/",""),p.L=p.R=p.C=-(p.color=1),p.size=p.content?p.content.length:0,p.start=0,p.clsid=p.clsid||C,0===o)p.C=d.length>1?1:-1,p.size=0,p.type=5;else if("/"==m.slice(-1)){for(l=o+1;l<d.length&&n(e.FullPaths[l])!=m;++l);for(p.C=l>=d.length?-1:l,l=o+1;l<d.length&&n(e.FullPaths[l])!=n(m);++l);p.R=l>=d.length?-1:l,p.type=1}else n(e.FullPaths[o+1]||"")==n(m)&&(p.R=o+1),p.type=2}}}function p(e,t){var n=t||{};if("mad"==n.fileType)return function(e,t){for(var n=t||{},r=n.boundary||"SheetJS",i=["MIME-Version: 1.0",'Content-Type: multipart/related; boundary="'+(r="------="+r).slice(2)+'"',"","",""],a=e.FullPaths[0],o=a,s=e.FileIndex[0],c=1;c<e.FullPaths.length;++c)if(o=e.FullPaths[c].slice(a.length),(s=e.FileIndex[c]).size&&s.content&&"Sh33tJ5"!=o){o=o.replace(/[\x00-\x08\x0B\x0C\x0E-\x1F\x7E-\xFF]/g,(function(e){return"_x"+e.charCodeAt(0).toString(16)+"_"})).replace(/[\u0080-\uFFFF]/g,(function(e){return"_u"+e.charCodeAt(0).toString(16)+"_"}));for(var l=s.content,u=y&&Buffer.isBuffer(l)?l.toString("binary"):O(l),d=0,f=Math.min(1024,u.length),h=0,p=0;p<=f;++p)(h=u.charCodeAt(p))>=32&&h<128&&++d;var m=d>=4*f/5;i.push(r),i.push("Content-Location: "+(n.root||"file:///C:/SheetJS/")+o),i.push("Content-Transfer-Encoding: "+(m?"quoted-printable":"base64")),i.push("Content-Type: "+ve(s,o)),i.push(""),i.push(m?be(u):ge(u))}return i.push(r+"--\r\n"),i.join("\r\n")}(e,n);if(h(e),"zip"===n.fileType)return function(e,t){var n,r=t||{},a=[],o=[],s=xn(1),c=r.compression?8:0,l=0,u=0,d=0,f=0,h=e.FullPaths[0],p=h,v=e.FileIndex[0],g=[],b=0;for(l=1;l<e.FullPaths.length;++l)if(p=e.FullPaths[l].slice(h.length),(v=e.FileIndex[l]).size&&v.content&&"Sh33tJ5"!=p){var _=d,y=xn(p.length);for(u=0;u<p.length;++u)y.write_shift(1,127&p.charCodeAt(u));y=y.slice(0,y.l),g[f]="string"==typeof v.content?Te.bstr(v.content,0):Te.buf(v.content,0);var x="string"==typeof v.content?T(v.content):v.content;8==c&&(n=x,x=m?m.deflateRawSync(n):ie(n)),(s=xn(30)).write_shift(4,67324752),s.write_shift(2,20),s.write_shift(2,0),s.write_shift(2,c),v.mt?i(s,v.mt):s.write_shift(4,0),s.write_shift(-4,g[f]),s.write_shift(4,x.length),s.write_shift(4,v.content.length),s.write_shift(2,y.length),s.write_shift(2,0),d+=s.length,a.push(s),d+=y.length,a.push(y),d+=x.length,a.push(x),(s=xn(46)).write_shift(4,33639248),s.write_shift(2,0),s.write_shift(2,20),s.write_shift(2,0),s.write_shift(2,c),s.write_shift(4,0),s.write_shift(-4,g[f]),s.write_shift(4,x.length),s.write_shift(4,v.content.length),s.write_shift(2,y.length),s.write_shift(2,0),s.write_shift(2,0),s.write_shift(2,0),s.write_shift(2,0),s.write_shift(4,0),s.write_shift(4,_),b+=s.l,o.push(s),b+=y.length,o.push(y),++f}return(s=xn(22)).write_shift(4,101010256),s.write_shift(2,0),s.write_shift(2,0),s.write_shift(2,f),s.write_shift(2,f),s.write_shift(4,b),s.write_shift(4,d),s.write_shift(2,0),M([M(a),M(o),s])}(e,n);var r=function(e){for(var t=0,n=0,r=0;r<e.FileIndex.length;++r){var i=e.FileIndex[r];if(i.content){var a=i.content.length;a>0&&(a<4096?t+=a+63>>6:n+=a+511>>9)}}for(var o=e.FullPaths.length+3>>2,s=t+127>>7,c=(t+7>>3)+n+o+s,l=c+127>>7,u=l<=109?0:Math.ceil((l-109)/127);c+l+u+127>>7>l;)u=++l<=109?0:Math.ceil((l-109)/127);var d=[1,u,l,s,o,n,t,0];return e.FileIndex[0].size=t<<6,d[7]=(e.FileIndex[0].start=d[0]+d[1]+d[2]+d[3]+d[4]+d[5])+(d[6]+7>>3),d}(e),a=xn(r[7]<<9),o=0,s=0;for(o=0;o<8;++o)a.write_shift(1,S[o]);for(o=0;o<8;++o)a.write_shift(2,0);for(a.write_shift(2,62),a.write_shift(2,3),a.write_shift(2,65534),a.write_shift(2,9),a.write_shift(2,6),o=0;o<3;++o)a.write_shift(2,0);for(a.write_shift(4,0),a.write_shift(4,r[2]),a.write_shift(4,r[0]+r[1]+r[2]+r[3]-1),a.write_shift(4,0),a.write_shift(4,4096),a.write_shift(4,r[3]?r[0]+r[1]+r[2]-1:g),a.write_shift(4,r[3]),a.write_shift(-4,r[1]?r[0]-1:g),a.write_shift(4,r[1]),o=0;o<109;++o)a.write_shift(-4,o<r[2]?r[1]+o:-1);if(r[1])for(s=0;s<r[1];++s){for(;o<236+127*s;++o)a.write_shift(-4,o<r[2]?r[1]+o:-1);a.write_shift(-4,s===r[1]-1?g:s+1)}var c=function(e){for(s+=e;o<s-1;++o)a.write_shift(-4,o+1);e&&(++o,a.write_shift(-4,g))};for(s=o=0,s+=r[1];o<s;++o)a.write_shift(-4,L.DIFSECT);for(s+=r[2];o<s;++o)a.write_shift(-4,L.FATSECT);c(r[3]),c(r[4]);for(var l=0,u=0,d=e.FileIndex[0];l<e.FileIndex.length;++l)(d=e.FileIndex[l]).content&&((u=d.content.length)<4096||(d.start=s,c(u+511>>9)));for(c(r[6]+7>>3);511&a.l;)a.write_shift(-4,L.ENDOFCHAIN);for(s=o=0,l=0;l<e.FileIndex.length;++l)(d=e.FileIndex[l]).content&&(!(u=d.content.length)||u>=4096||(d.start=s,c(u+63>>6)));for(;511&a.l;)a.write_shift(-4,L.ENDOFCHAIN);for(o=0;o<r[4]<<2;++o){var f=e.FullPaths[o];if(f&&0!==f.length){d=e.FileIndex[o],0===o&&(d.start=d.size?d.start-1:g);var p=0===o&&n.root||d.name;if(p.length>32&&(console.error("Name "+p+" will be truncated to "+p.slice(0,32)),p=p.slice(0,32)),u=2*(p.length+1),a.write_shift(64,p,"utf16le"),a.write_shift(2,u),a.write_shift(1,d.type),a.write_shift(1,d.color),a.write_shift(-4,d.L),a.write_shift(-4,d.R),a.write_shift(-4,d.C),d.clsid)a.write_shift(16,d.clsid,"hex");else for(l=0;l<4;++l)a.write_shift(4,0);a.write_shift(4,d.state||0),a.write_shift(4,0),a.write_shift(4,0),a.write_shift(4,0),a.write_shift(4,0),a.write_shift(4,d.start),a.write_shift(4,d.size),a.write_shift(4,0)}else{for(l=0;l<17;++l)a.write_shift(4,0);for(l=0;l<3;++l)a.write_shift(4,-1);for(l=0;l<12;++l)a.write_shift(4,0)}}for(o=1;o<e.FileIndex.length;++o)if((d=e.FileIndex[o]).size>=4096)if(a.l=d.start+1<<9,y&&Buffer.isBuffer(d.content))d.content.copy(a,a.l,0,d.size),a.l+=d.size+511&-512;else{for(l=0;l<d.size;++l)a.write_shift(1,d.content[l]);for(;511&l;++l)a.write_shift(1,0)}for(o=1;o<e.FileIndex.length;++o)if((d=e.FileIndex[o]).size>0&&d.size<4096)if(y&&Buffer.isBuffer(d.content))d.content.copy(a,a.l,0,d.size),a.l+=d.size+63&-64;else{for(l=0;l<d.size;++l)a.write_shift(1,d.content[l]);for(;63&l;++l)a.write_shift(1,0)}if(y)a.l=a.length;else for(;a.l<a.length;)a.write_shift(1,0);return a}t.version="1.2.2";var m,v=64,g=-2,A="d0cf11e0a1b11ae1",S=[208,207,17,224,161,177,26,225],C="00000000000000000000000000000000",L={MAXREGSECT:-6,DIFSECT:-4,FATSECT:-3,ENDOFCHAIN:g,FREESECT:-1,HEADER_SIGNATURE:A,HEADER_MINOR_VERSION:"3e00",MAXREGSID:-6,NOSTREAM:-1,HEADER_CLSID:C,EntryTypes:["unknown","storage","stream","lockbytes","property","root"]};function O(e){for(var t=new Array(e.length),n=0;n<e.length;++n)t[n]=String.fromCharCode(e[n]);return t.join("")}for(var I,P,D=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],N=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258],U=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577],F="undefined"!=typeof Uint8Array,B=F?new Uint8Array(256):[],z=0;z<256;++z)B[z]=(void 0,255&((P=139536&((I=z)<<1|I<<11)|558144&(I<<5|I<<15))>>16|P>>8|P));function H(e,t){var n=B[255&e];return t<=8?n>>>8-t:(n=n<<8|B[e>>8&255],t<=16?n>>>16-t:(n=n<<8|B[e>>16&255])>>>24-t)}function V(e,t){var n=7&t,r=t>>>3;return(e[r]|(n<=6?0:e[r+1]<<8))>>>n&3}function G(e,t){var n=7&t,r=t>>>3;return(e[r]|(n<=5?0:e[r+1]<<8))>>>n&7}function $(e,t){var n=7&t,r=t>>>3;return(e[r]|(n<=3?0:e[r+1]<<8))>>>n&31}function W(e,t){var n=7&t,r=t>>>3;return(e[r]|(n<=1?0:e[r+1]<<8))>>>n&127}function j(e,t,n){var r=7&t,i=t>>>3,a=(1<<n)-1,o=e[i]>>>r;return n<8-r?o&a:(o|=e[i+1]<<8-r,n<16-r?o&a:(o|=e[i+2]<<16-r,n<24-r?o&a:(o|=e[i+3]<<24-r)&a))}function X(e,t,n){var r=7&t,i=t>>>3;return r<=5?e[i]|=(7&n)<<r:(e[i]|=n<<r&255,e[i+1]=(7&n)>>8-r),t+3}function Y(e,t,n){return n=(1&n)<<(7&t),e[t>>>3]|=n,t+1}function q(e,t,n){var r=t>>>3;return n<<=7&t,e[r]|=255&n,n>>>=8,e[r+1]=n,t+8}function K(e,t,n){var r=t>>>3;return n<<=7&t,e[r]|=255&n,n>>>=8,e[r+1]=255&n,e[r+2]=n>>>8,t+16}function Z(e,t){var n=e.length,r=2*n>t?2*n:t+5,i=0;if(n>=t)return e;if(y){var a=E(r);if(e.copy)e.copy(a);else for(;i<e.length;++i)a[i]=e[i];return a}if(F){var o=new Uint8Array(r);if(o.set)o.set(e);else for(;i<n;++i)o[i]=e[i];return o}return e.length=r,e}function J(e){for(var t=new Array(e),n=0;n<e;++n)t[n]=0;return t}function Q(e,t,n){var r=1,i=0,a=0,o=0,s=0,c=e.length,l=F?new Uint16Array(32):J(32);for(a=0;a<32;++a)l[a]=0;for(a=c;a<n;++a)e[a]=0;c=e.length;var u=F?new Uint16Array(c):J(c);for(a=0;a<c;++a)l[i=e[a]]++,r<i&&(r=i),u[a]=0;for(l[0]=0,a=1;a<=r;++a)l[a+16]=s=s+l[a-1]<<1;for(a=0;a<c;++a)0!=(s=e[a])&&(u[a]=l[s+16]++);var d=0;for(a=0;a<c;++a)if(0!=(d=e[a]))for(s=H(u[a],r)>>r-d,o=(1<<r+4-d)-1;o>=0;--o)t[s|o<<d]=15&d|a<<4;return r}var ee=F?new Uint16Array(512):J(512),te=F?new Uint16Array(32):J(32);if(!F){for(var ne=0;ne<512;++ne)ee[ne]=0;for(ne=0;ne<32;++ne)te[ne]=0}!function(){for(var e=[],t=0;t<32;t++)e.push(5);Q(e,te,32);var n=[];for(t=0;t<=143;t++)n.push(8);for(;t<=255;t++)n.push(9);for(;t<=279;t++)n.push(7);for(;t<=287;t++)n.push(8);Q(n,ee,288)}();var re=function(){for(var e=F?new Uint8Array(32768):[],t=0,n=0;t<U.length-1;++t)for(;n<U[t+1];++n)e[n]=t;for(;n<32768;++n)e[n]=29;var r=F?new Uint8Array(259):[];for(t=0,n=0;t<N.length-1;++t)for(;n<N[t+1];++n)r[n]=t;return function(t,n){return t.length<8?function(e,t){for(var n=0;n<e.length;){var r=Math.min(65535,e.length-n),i=n+r==e.length;for(t.write_shift(1,+i),t.write_shift(2,r),t.write_shift(2,65535&~r);r-- >0;)t[t.l++]=e[n++]}return t.l}(t,n):function(t,n){for(var i=0,a=0,o=F?new Uint16Array(32768):[];a<t.length;){var s=Math.min(65535,t.length-a);if(s<10){for(7&(i=X(n,i,+!(a+s!=t.length)))&&(i+=8-(7&i)),n.l=i/8|0,n.write_shift(2,s),n.write_shift(2,65535&~s);s-- >0;)n[n.l++]=t[a++];i=8*n.l}else{i=X(n,i,+!(a+s!=t.length)+2);for(var c=0;s-- >0;){var l=t[a],u=-1,d=0;if((u=o[c=32767&(c<<5^l)])&&((u|=-32768&a)>a&&(u-=32768),u<a))for(;t[u+d]==t[a+d]&&d<250;)++d;if(d>2){(l=r[d])<=22?i=q(n,i,B[l+1]>>1)-1:(q(n,i,3),q(n,i+=5,B[l-23]>>5),i+=3);var f=l<8?0:l-4>>2;f>0&&(K(n,i,d-N[l]),i+=f),l=e[a-u],i=q(n,i,B[l]>>3),i-=3;var h=l<4?0:l-2>>1;h>0&&(K(n,i,a-u-U[l]),i+=h);for(var p=0;p<d;++p)o[c]=32767&a,c=32767&(c<<5^t[a]),++a;s-=d-1}else l<=143?l+=48:i=Y(n,i,1),i=q(n,i,B[l]),o[c]=32767&a,++a}i=q(n,i,0)-1}}return n.l=(i+7)/8|0,n.l}(t,n)}}();function ie(e){var t=xn(50+Math.floor(1.1*e.length)),n=re(e,t);return t.slice(0,n)}var ae=F?new Uint16Array(32768):J(32768),oe=F?new Uint16Array(32768):J(32768),se=F?new Uint16Array(128):J(128),ce=1,le=1;function ue(e,t){var n=$(e,t)+257,r=$(e,t+=5)+1,i=function(e,t){var n=7&t,r=t>>>3;return(e[r]|(n<=4?0:e[r+1]<<8))>>>n&15}(e,t+=5)+4;t+=4;for(var a=0,o=F?new Uint8Array(19):J(19),s=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],c=1,l=F?new Uint8Array(8):J(8),u=F?new Uint8Array(8):J(8),d=o.length,f=0;f<i;++f)o[D[f]]=a=G(e,t),c<a&&(c=a),l[a]++,t+=3;var h=0;for(l[0]=0,f=1;f<=c;++f)u[f]=h=h+l[f-1]<<1;for(f=0;f<d;++f)0!=(h=o[f])&&(s[f]=u[h]++);var p=0;for(f=0;f<d;++f)if(0!=(p=o[f])){h=B[s[f]]>>8-p;for(var m=(1<<7-p)-1;m>=0;--m)se[h|m<<p]=7&p|f<<3}var v=[];for(c=1;v.length<n+r;)switch(t+=7&(h=se[W(e,t)]),h>>>=3){case 16:for(a=3+V(e,t),t+=2,h=v[v.length-1];a-- >0;)v.push(h);break;case 17:for(a=3+G(e,t),t+=3;a-- >0;)v.push(0);break;case 18:for(a=11+W(e,t),t+=7;a-- >0;)v.push(0);break;default:v.push(h),c<h&&(c=h)}var g=v.slice(0,n),b=v.slice(n);for(f=n;f<286;++f)g[f]=0;for(f=r;f<30;++f)b[f]=0;return ce=Q(g,ae,286),le=Q(b,oe,30),t}function de(e,t){var n=function(e,t){if(3==e[0]&&!(3&e[1]))return[w(t),2];for(var n=0,r=0,i=E(t||1<<18),a=0,o=i.length>>>0,s=0,c=0;0==(1&r);)if(r=G(e,n),n+=3,r>>>1!=0)for(r>>1==1?(s=9,c=5):(n=ue(e,n),s=ce,c=le);;){!t&&o<a+32767&&(o=(i=Z(i,a+32767)).length);var l=j(e,n,s),u=r>>>1==1?ee[l]:ae[l];if(n+=15&u,0==((u>>>=4)>>>8&255))i[a++]=u;else{if(256==u)break;var d=(u-=257)<8?0:u-4>>2;d>5&&(d=0);var f=a+N[u];d>0&&(f+=j(e,n,d),n+=d),l=j(e,n,c),n+=15&(u=r>>>1==1?te[l]:oe[l]);var h=(u>>>=4)<4?0:u-2>>1,p=U[u];for(h>0&&(p+=j(e,n,h),n+=h),!t&&o<f&&(o=(i=Z(i,f+100)).length);a<f;)i[a]=i[a-p],++a}}else{7&n&&(n+=8-(7&n));var m=e[n>>>3]|e[1+(n>>>3)]<<8;if(n+=32,m>0)for(!t&&o<a+m&&(o=(i=Z(i,a+m)).length);m-- >0;)i[a++]=e[n>>>3],n+=8}return t?[i,n+7>>>3]:[i.slice(0,a),n+7>>>3]}(e.slice(e.l||0),t);return e.l+=n[1],n[0]}function fe(e,t){if(!e)throw new Error(t);"undefined"!=typeof console&&console.error(t)}function he(e,t){var n=e;_n(n,0);var r={FileIndex:[],FullPaths:[]};f(r,{root:t.root});for(var i=n.length-4;(80!=n[i]||75!=n[i+1]||5!=n[i+2]||6!=n[i+3])&&i>=0;)--i;n.l=i+4,n.l+=4;var o=n.read_shift(2);n.l+=6;var s=n.read_shift(4);for(n.l=s,i=0;i<o;++i){n.l+=20;var c=n.read_shift(4),l=n.read_shift(4),u=n.read_shift(2),d=n.read_shift(2),h=n.read_shift(2);n.l+=8;var p=n.read_shift(4),m=a(n.slice(n.l+u,n.l+u+d));n.l+=u+d+h;var v=n.l;n.l=p+4,m&&m[1]&&((m[1]||{}).usz&&(l=m[1].usz),(m[1]||{}).csz&&(c=m[1].csz)),pe(n,c,l,r,m),n.l=v}return r}function pe(e,t,n,r,i){e.l+=2;var o=e.read_shift(2),s=e.read_shift(2),c=function(e){var t=65535&e.read_shift(2),n=65535&e.read_shift(2),r=new Date,i=31&n,a=15&(n>>>=5);n>>>=4,r.setMilliseconds(0),r.setFullYear(n+1980),r.setMonth(a-1),r.setDate(i);var o=31&t,s=63&(t>>>=5);return t>>>=6,r.setHours(t),r.setMinutes(s),r.setSeconds(o<<1),r}(e);if(8257&o)throw new Error("Unsupported ZIP encryption");e.read_shift(4);for(var l=e.read_shift(4),u=e.read_shift(4),d=e.read_shift(2),f=e.read_shift(2),h="",p=0;p<d;++p)h+=String.fromCharCode(e[e.l++]);if(f){var v=a(e.slice(e.l,e.l+f));(v[21589]||{}).mt&&(c=v[21589].mt),(v[1]||{}).usz&&(u=v[1].usz),(v[1]||{}).csz&&(l=v[1].csz),i&&((i[21589]||{}).mt&&(c=i[21589].mt),(i[1]||{}).usz&&(u=v[1].usz),(i[1]||{}).csz&&(l=v[1].csz))}e.l+=f;var g=e.slice(e.l,e.l+l);switch(s){case 8:g=function(e,t){if(!m)return de(e,t);var n=new(0,m.InflateRaw),r=n._processChunk(e.slice(e.l),n._finishFlushFlag);return e.l+=n.bytesRead,r}(e,u);break;case 0:break;default:throw new Error("Unsupported ZIP Compression method "+s)}var b=!1;8&o&&(134695760==e.read_shift(4)&&(e.read_shift(4),b=!0),l=e.read_shift(4),u=e.read_shift(4)),l!=t&&fe(b,"Bad compressed size: "+t+" != "+l),u!=n&&fe(b,"Bad uncompressed size: "+n+" != "+u),ye(r,h,g,{unsafe:!0,mt:c})}var me={htm:"text/html",xml:"text/xml",gif:"image/gif",jpg:"image/jpeg",png:"image/png",mso:"application/x-mso",thmx:"application/vnd.ms-officetheme",sh33tj5:"application/octet-stream"};function ve(e,t){if(e.ctype)return e.ctype;var n=e.name||"",r=n.match(/\.([^\.]+)$/);return r&&me[r[1]]||t&&(r=(n=t).match(/[\.\\]([^\.\\])+$/))&&me[r[1]]?me[r[1]]:"application/octet-stream"}function ge(e){for(var t=b(e),n=[],r=0;r<t.length;r+=76)n.push(t.slice(r,r+76));return n.join("\r\n")+"\r\n"}function be(e){var t=e.replace(/[\x00-\x08\x0B\x0C\x0E-\x1F\x7E-\xFF=]/g,(function(e){var t=e.charCodeAt(0).toString(16).toUpperCase();return"="+(1==t.length?"0"+t:t)}));"\n"==(t=t.replace(/ $/gm,"=20").replace(/\t$/gm,"=09")).charAt(0)&&(t="=0D"+t.slice(1));for(var n=[],r=(t=t.replace(/\r(?!\n)/gm,"=0D").replace(/\n\n/gm,"\n=0A").replace(/([^\r\n])\n/gm,"$1=0A")).split("\r\n"),i=0;i<r.length;++i){var a=r[i];if(0!=a.length)for(var o=0;o<a.length;){var s=76,c=a.slice(o,o+s);"="==c.charAt(s-1)?s--:"="==c.charAt(s-2)?s-=2:"="==c.charAt(s-3)&&(s-=3),c=a.slice(o,o+s),(o+=s)<a.length&&(c+="="),n.push(c)}else n.push("")}return n.join("\r\n")}function _e(e,t,n){for(var r,i="",a="",o="",s=0;s<10;++s){var c=t[s];if(!c||c.match(/^\s*$/))break;var l=c.match(/^(.*?):\s*([^\s].*)$/);if(l)switch(l[1].toLowerCase()){case"content-location":i=l[2].trim();break;case"content-type":o=l[2].trim();break;case"content-transfer-encoding":a=l[2].trim()}}switch(++s,a.toLowerCase()){case"base64":r=T(_(t.slice(s).join("")));break;case"quoted-printable":r=function(e){for(var t=[],n=0;n<e.length;++n){for(var r=e[n];n<=e.length&&"="==r.charAt(r.length-1);)r=r.slice(0,r.length-1)+e[++n];t.push(r)}for(var i=0;i<t.length;++i)t[i]=t[i].replace(/[=][0-9A-Fa-f]{2}/g,(function(e){return String.fromCharCode(parseInt(e.slice(1),16))}));return T(t.join("\r\n"))}(t.slice(s));break;default:throw new Error("Unsupported Content-Transfer-Encoding "+a)}var u=ye(e,i.slice(n.length),r,{unsafe:!0});o&&(u.ctype=o)}function ye(e,t,n,i){var a=i&&i.unsafe;a||f(e);var o=!a&&Se.find(e,t);if(!o){var s=e.FullPaths[0];t.slice(0,s.length)==s?s=t:("/"!=s.slice(-1)&&(s+="/"),s=(s+t).replace("//","/")),o={name:r(t),type:2},e.FileIndex.push(o),e.FullPaths.push(s),a||Se.utils.cfb_gc(e)}return o.content=n,o.size=n?n.length:0,i&&(i.CLSID&&(o.clsid=i.CLSID),i.mt&&(o.mt=i.mt),i.ct&&(o.ct=i.ct)),o}return t.find=function(e,t){var n=e.FullPaths.map((function(e){return e.toUpperCase()})),r=n.map((function(e){var t=e.split("/");return t[t.length-("/"==e.slice(-1)?2:1)]})),i=!1;47===t.charCodeAt(0)?(i=!0,t=n[0].slice(0,-1)+t):i=-1!==t.indexOf("/");var a=t.toUpperCase(),o=!0===i?n.indexOf(a):r.indexOf(a);if(-1!==o)return e.FileIndex[o];var s=!a.match(R);for(a=a.replace(k,""),s&&(a=a.replace(R,"!")),o=0;o<n.length;++o){if((s?n[o].replace(R,"!"):n[o]).replace(k,"")==a)return e.FileIndex[o];if((s?r[o].replace(R,"!"):r[o]).replace(k,"")==a)return e.FileIndex[o]}return null},t.read=function(t,n){var r=n&&n.type;switch(r||y&&Buffer.isBuffer(t)&&(r="buffer"),r||"base64"){case"file":return function(t,n){return o(),s(e.readFileSync(t),n)}(t,n);case"base64":return s(T(_(t)),n);case"binary":return s(T(t),n)}return s(t,n)},t.parse=s,t.write=function(t,n){var r=p(t,n);switch(n&&n.type||"buffer"){case"file":return o(),e.writeFileSync(n.filename,r),r;case"binary":return"string"==typeof r?r:O(r);case"base64":return b("string"==typeof r?r:O(r));case"buffer":if(y)return Buffer.isBuffer(r)?r:x(r);case"array":return"string"==typeof r?T(r):r}return r},t.writeFile=function(t,n,r){o();var i=p(t,r);e.writeFileSync(n,i)},t.utils={cfb_new:function(e){var t={};return f(t,e),t},cfb_add:ye,cfb_del:function(e,t){f(e);var n=Se.find(e,t);if(n)for(var r=0;r<e.FileIndex.length;++r)if(e.FileIndex[r]==n)return e.FileIndex.splice(r,1),e.FullPaths.splice(r,1),!0;return!1},cfb_mov:function(e,t,n){f(e);var i=Se.find(e,t);if(i)for(var a=0;a<e.FileIndex.length;++a)if(e.FileIndex[a]==i)return e.FileIndex[a].name=r(n),e.FullPaths[a]=n,!0;return!1},cfb_gc:function(e){h(e,!0)},ReadShift:hn,CheckField:bn,prep_blob:_n,bconcat:M,use_zlib:function(e){try{var t=new(0,e.InflateRaw);if(t._processChunk(new Uint8Array([3,0]),t._finishFlushFlag),!t.bytesRead)throw new Error("zlib does not expose bytesRead");m=e}catch(e){console.error("cannot use native zlib: "+(e.message||e))}},_deflateRaw:ie,_inflateRaw:de,consts:L},t}();function Ce(e){for(var t=Object.keys(e),n=[],r=0;r<t.length;++r)Object.prototype.hasOwnProperty.call(e,t[r])&&n.push(t[r]);return n}function Me(e){for(var t=[],n=Ce(e),r=0;r!==n.length;++r)t[e[n[r]]]=n[r];return t}var ke=new Date(1899,11,30,0,0,0);function Re(e,t){var n=e.getTime();return t&&(n-=1263168e5),(n-(ke.getTime()+6e4*(e.getTimezoneOffset()-ke.getTimezoneOffset())))/864e5}var Le=new Date,Oe=ke.getTime()+6e4*(Le.getTimezoneOffset()-ke.getTimezoneOffset()),Ie=Le.getTimezoneOffset();function Pe(e){var t=new Date;return t.setTime(24*e*60*60*1e3+Oe),t.getTimezoneOffset()!==Ie&&t.setTime(t.getTime()+6e4*(t.getTimezoneOffset()-Ie)),t}function De(e){var t=0,n=0,r=!1,i=e.match(/P([0-9\.]+Y)?([0-9\.]+M)?([0-9\.]+D)?T([0-9\.]+H)?([0-9\.]+M)?([0-9\.]+S)?/);if(!i)throw new Error("|"+e+"| is not an ISO8601 Duration");for(var a=1;a!=i.length;++a)if(i[a]){switch(n=1,a>3&&(r=!0),i[a].slice(i[a].length-1)){case"Y":throw new Error("Unsupported ISO Duration Field: "+i[a].slice(i[a].length-1));case"D":n*=24;case"H":n*=60;case"M":if(!r)throw new Error("Unsupported ISO Duration Field: M");n*=60}t+=n*parseInt(i[a],10)}return t}var Ne=new Date("2017-02-19T19:06:09.000Z"),Ue=isNaN(Ne.getFullYear())?new Date("2/19/17"):Ne,Fe=2017==Ue.getFullYear();function Be(e,t){var n=new Date(e);if(Fe)return t>0?n.setTime(n.getTime()+60*n.getTimezoneOffset()*1e3):t<0&&n.setTime(n.getTime()-60*n.getTimezoneOffset()*1e3),n;if(e instanceof Date)return e;if(1917==Ue.getFullYear()&&!isNaN(n.getFullYear())){var r=n.getFullYear();return e.indexOf(""+r)>-1||n.setFullYear(n.getFullYear()+100),n}var i=e.match(/\d+/g)||["2017","2","19","0","0","0"],a=new Date(+i[0],+i[1]-1,+i[2],+i[3]||0,+i[4]||0,+i[5]||0);return e.indexOf("Z")>-1&&(a=new Date(a.getTime()-60*a.getTimezoneOffset()*1e3)),a}function ze(e,t){if(y&&Buffer.isBuffer(e)){if(t&&A){if(255==e[0]&&254==e[1])return Tt(e.slice(2).toString("utf16le"));if(254==e[1]&&255==e[2])return Tt(f(e.slice(2).toString("binary")))}return e.toString("binary")}if("undefined"!=typeof TextDecoder)try{if(t){if(255==e[0]&&254==e[1])return Tt(new TextDecoder("utf-16le").decode(e.slice(2)));if(254==e[0]&&255==e[1])return Tt(new TextDecoder("utf-16be").decode(e.slice(2)))}var n={"€":"","‚":"","ƒ":"","„":"","…":"","†":"","‡":"","ˆ":"","‰":"","Š":"","‹":"","Œ":"","Ž":"","‘":"","’":"","“":"","”":"","•":"","–":"","—":"","˜":"","™":"","š":"","›":"","œ":"","ž":"","Ÿ":""};return Array.isArray(e)&&(e=new Uint8Array(e)),new TextDecoder("latin1").decode(e).replace(/[€‚ƒ„…†‡ˆ‰Š‹ŒŽ‘’“”•–—˜™š›œžŸ]/g,(function(e){return n[e]||e}))}catch(e){}for(var r=[],i=0;i!=e.length;++i)r.push(String.fromCharCode(e[i]));return r.join("")}function He(e){if("undefined"!=typeof JSON&&!Array.isArray(e))return JSON.parse(JSON.stringify(e));if("object"!=typeof e||null==e)return e;if(e instanceof Date)return new Date(e.getTime());var t={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&(t[n]=He(e[n]));return t}function Ve(e,t){for(var n="";n.length<t;)n+=e;return n}function Ge(e){var t=Number(e);if(!isNaN(t))return isFinite(t)?t:NaN;if(!/\d/.test(e))return t;var n=1,r=e.replace(/([\d]),([\d])/g,"$1$2").replace(/[$]/g,"").replace(/[%]/g,(function(){return n*=100,""}));return isNaN(t=Number(r))?(r=r.replace(/[(](.*)[)]/,(function(e,t){return n=-n,t})),isNaN(t=Number(r))?t:t/n):t/n}var $e=/^(0?\d|1[0-2])(?:|:([0-5]?\d)(?:|(\.\d+)(?:|:([0-5]?\d))|:([0-5]?\d)(|\.\d+)))\s+([ap])m?$/,We=["january","february","march","april","may","june","july","august","september","october","november","december"];function je(e){var t=e.toLowerCase(),n=t.replace(/\s+/g," ").trim().match($e);if(n)return function(e){return e[2]?e[3]?e[4]?new Date(1899,11,30,+e[1]%12+("p"==e[7]?12:0),+e[2],+e[4],1e3*parseFloat(e[3])):new Date(1899,11,30,"p"==e[7]?12:0,+e[1],+e[2],1e3*parseFloat(e[3])):e[5]?new Date(1899,11,30,+e[1]%12+("p"==e[7]?12:0),+e[2],+e[5],e[6]?1e3*parseFloat(e[6]):0):new Date(1899,11,30,+e[1]%12+("p"==e[7]?12:0),+e[2],0,0):new Date(1899,11,30,+e[1]%12+("p"==e[7]?12:0),0,0,0)}(n);var r=new Date(e),i=new Date(NaN),a=r.getYear(),o=(r.getMonth(),r.getDate());if(isNaN(o))return i;if(t.match(/jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec/)){if((t=t.replace(/[^a-z]/g,"").replace(/([^a-z]|^)[ap]m?([^a-z]|$)/,"")).length>3&&-1==We.indexOf(t))return i}else if(t.replace(/[ap]m?/,"").match(/[a-z]/))return i;return a<0||a>8099||e.match(/[^-0-9:,\/\\]/)?i:r}var Xe=function(){var e=5=="abacaba".split(/(:?b)/i).length;return function(t,n,r){if(e||"string"==typeof n)return t.split(n);for(var i=t.split(n),a=[i[0]],o=1;o<i.length;++o)a.push(r),a.push(i[o]);return a}}();function Ye(e){return e?e.content&&e.type?ze(e.content,!0):e.data?h(e.data):e.asNodeBuffer&&y?h(e.asNodeBuffer().toString("binary")):e.asBinary?h(e.asBinary()):e._data&&e._data.getContent?h(ze(Array.prototype.slice.call(e._data.getContent(),0))):null:null}function qe(e){if(!e)return null;if(e.data)return u(e.data);if(e.asNodeBuffer&&y)return e.asNodeBuffer();if(e._data&&e._data.getContent){var t=e._data.getContent();return"string"==typeof t?u(t):Array.prototype.slice.call(t)}return e.content&&e.type?e.content:null}function Ke(e,t){for(var n=e.FullPaths||Ce(e.files),r=t.toLowerCase().replace(/[\/]/g,"\\"),i=r.replace(/\\/g,"/"),a=0;a<n.length;++a){var o=n[a].replace(/^Root Entry[\/]/,"").toLowerCase();if(r==o||i==o)return e.files?e.files[n[a]]:e.FileIndex[a]}return null}function Ze(e,t){var n=Ke(e,t);if(null==n)throw new Error("Cannot find file "+t+" in zip");return n}function Je(e,t,n){if(!n)return(r=Ze(e,t))&&".bin"===r.name.slice(-4)?qe(r):Ye(r);var r;if(!t)return null;try{return Je(e,t)}catch(e){return null}}function Qe(e,t,n){if(!n)return Ye(Ze(e,t));if(!t)return null;try{return Qe(e,t)}catch(e){return null}}function et(e,t,n){if(!n)return qe(Ze(e,t));if(!t)return null;try{return et(e,t)}catch(e){return null}}function tt(e){for(var t=e.FullPaths||Ce(e.files),n=[],r=0;r<t.length;++r)"/"!=t[r].slice(-1)&&n.push(t[r].replace(/^Root Entry[\/]/,""));return n.sort()}function nt(e,t){switch(t.type){case"base64":return Se.read(e,{type:"base64"});case"binary":return Se.read(e,{type:"binary"});case"buffer":case"array":return Se.read(e,{type:"buffer"})}throw new Error("Unrecognized type "+t.type)}function rt(e,t){if("/"==e.charAt(0))return e.slice(1);var n=t.split("/");"/"!=t.slice(-1)&&n.pop();for(var r=e.split("/");0!==r.length;){var i=r.shift();".."===i?n.pop():"."!==i&&n.push(i)}return n.join("/")}var it='<?xml version="1.0" encoding="UTF-8" standalone="yes"?>\r\n',at=/([^"\s?>\/]+)\s*=\s*((?:")([^"]*)(?:")|(?:')([^']*)(?:')|([^'">\s]+))/g,ot=/<[\/\?]?[a-zA-Z0-9:_-]+(?:\s+[^"\s?>\/]+\s*=\s*(?:"[^"]*"|'[^']*'|[^'">\s=]+))*\s*[\/\?]?>/gm,st=it.match(ot)?ot:/<[^>]*>/g,ct=/<\w*:/,lt=/<(\/?)\w+:/;function ut(e,t,n){for(var r={},i=0,a=0;i!==e.length&&32!==(a=e.charCodeAt(i))&&10!==a&&13!==a;++i);if(t||(r[0]=e.slice(0,i)),i===e.length)return r;var o=e.match(at),s=0,c="",l=0,u="",d="",f=1;if(o)for(l=0;l!=o.length;++l){for(d=o[l],a=0;a!=d.length&&61!==d.charCodeAt(a);++a);for(u=d.slice(0,a).trim();32==d.charCodeAt(a+1);)++a;for(f=34==(i=d.charCodeAt(a+1))||39==i?1:0,c=d.slice(a+1+f,d.length-f),s=0;s!=u.length&&58!==u.charCodeAt(s);++s);if(s===u.length)u.indexOf("_")>0&&(u=u.slice(0,u.indexOf("_"))),r[u]=c,n||(r[u.toLowerCase()]=c);else{var h=(5===s&&"xmlns"===u.slice(0,5)?"xmlns":"")+u.slice(s+1);if(r[h]&&"ext"==u.slice(s-3,s))continue;r[h]=c,n||(r[h.toLowerCase()]=c)}}return r}function dt(e){return e.replace(lt,"<$1")}var ft={"&quot;":'"',"&apos;":"'","&gt;":">","&lt;":"<","&amp;":"&"},ht=Me(ft),pt=function(){var e=/&(?:quot|apos|gt|lt|amp|#x?([\da-fA-F]+));/gi,t=/_x([\da-fA-F]{4})_/gi;function n(r){var i=r+"",a=i.indexOf("<![CDATA[");if(-1==a)return i.replace(e,(function(e,t){return ft[e]||String.fromCharCode(parseInt(t,e.indexOf("x")>-1?16:10))||e})).replace(t,(function(e,t){return String.fromCharCode(parseInt(t,16))}));var o=i.indexOf("]]>");return n(i.slice(0,a))+i.slice(a+9,o)+n(i.slice(o+3))}return function(e,t){var r=n(e);return t?r.replace(/\r\n/g,"\n"):r}}(),mt=/[&<>'"]/g,vt=/[\u0000-\u001f]/g;function gt(e){return(e+"").replace(mt,(function(e){return ht[e]})).replace(/\n/g,"<br/>").replace(vt,(function(e){return"&#x"+("000"+e.charCodeAt(0).toString(16)).slice(-4)+";"}))}var bt=function(){var e=/&#(\d+);/g;function t(e,t){return String.fromCharCode(parseInt(t,10))}return function(n){return n.replace(e,t)}}();function _t(e){switch(e){case 1:case!0:case"1":case"true":return!0;case 0:case!1:case"0":case"false":return!1}return!1}function yt(e){for(var t="",n=0,r=0,i=0,a=0,o=0,s=0;n<e.length;)(r=e.charCodeAt(n++))<128?t+=String.fromCharCode(r):(i=e.charCodeAt(n++),r>191&&r<224?(o=(31&r)<<6,o|=63&i,t+=String.fromCharCode(o)):(a=e.charCodeAt(n++),r<240?t+=String.fromCharCode((15&r)<<12|(63&i)<<6|63&a):(s=((7&r)<<18|(63&i)<<12|(63&a)<<6|63&(o=e.charCodeAt(n++)))-65536,t+=String.fromCharCode(55296+(s>>>10&1023)),t+=String.fromCharCode(56320+(1023&s)))));return t}function xt(e){var t,n,r,i=w(2*e.length),a=1,o=0,s=0;for(n=0;n<e.length;n+=a)a=1,(r=e.charCodeAt(n))<128?t=r:r<224?(t=64*(31&r)+(63&e.charCodeAt(n+1)),a=2):r<240?(t=4096*(15&r)+64*(63&e.charCodeAt(n+1))+(63&e.charCodeAt(n+2)),a=3):(a=4,t=262144*(7&r)+4096*(63&e.charCodeAt(n+1))+64*(63&e.charCodeAt(n+2))+(63&e.charCodeAt(n+3)),s=55296+((t-=65536)>>>10&1023),t=56320+(1023&t)),0!==s&&(i[o++]=255&s,i[o++]=s>>>8,s=0),i[o++]=t%256,i[o++]=t>>>8;return i.slice(0,o).toString("ucs2")}function At(e){return x(e,"binary").toString("utf8")}var wt="foo bar bazâð£",Et=y&&(At(wt)==yt(wt)&&At||xt(wt)==yt(wt)&&xt)||yt,Tt=y?function(e){return x(e,"utf8").toString("binary")}:function(e){for(var t=[],n=0,r=0,i=0;n<e.length;)switch(r=e.charCodeAt(n++),!0){case r<128:t.push(String.fromCharCode(r));break;case r<2048:t.push(String.fromCharCode(192+(r>>6))),t.push(String.fromCharCode(128+(63&r)));break;case r>=55296&&r<57344:r-=55296,i=e.charCodeAt(n++)-56320+(r<<10),t.push(String.fromCharCode(240+(i>>18&7))),t.push(String.fromCharCode(144+(i>>12&63))),t.push(String.fromCharCode(128+(i>>6&63))),t.push(String.fromCharCode(128+(63&i)));break;default:t.push(String.fromCharCode(224+(r>>12))),t.push(String.fromCharCode(128+(r>>6&63))),t.push(String.fromCharCode(128+(63&r)))}return t.join("")},St=function(){var e={};return function(t,n){var r=t+"|"+(n||"");return e[r]?e[r]:e[r]=new RegExp("<(?:\\w+:)?"+t+'(?: xml:space="preserve")?(?:[^>]*)>([\\s\\S]*?)</(?:\\w+:)?'+t+">",n||"")}}(),Ct=function(){var e=[["nbsp"," "],["middot","·"],["quot",'"'],["apos","'"],["gt",">"],["lt","<"],["amp","&"]].map((function(e){return[new RegExp("&"+e[0]+";","ig"),e[1]]}));return function(t){for(var n=t.replace(/^[\t\n\r ]+/,"").replace(/[\t\n\r ]+$/,"").replace(/>\s+/g,">").replace(/\s+</g,"<").replace(/[\t\n\r ]+/g," ").replace(/<\s*[bB][rR]\s*\/?>/g,"\n").replace(/<[^>]*>/g,""),r=0;r<e.length;++r)n=n.replace(e[r][0],e[r][1]);return n}}(),Mt=function(){var e={};return function(t){return void 0!==e[t]?e[t]:e[t]=new RegExp("<(?:vt:)?"+t+">([\\s\\S]*?)</(?:vt:)?"+t+">","g")}}(),kt=/<\/?(?:vt:)?variant>/g,Rt=/<(?:vt:)([^>]*)>([\s\S]*)</;function Lt(e,t){var n=ut(e),r=e.match(Mt(n.baseType))||[],i=[];if(r.length!=n.size){if(t.WTF)throw new Error("unexpected vector length "+r.length+" != "+n.size);return i}return r.forEach((function(e){var t=e.replace(kt,"").match(Rt);t&&i.push({v:Et(t[2]),t:t[1]})})),i}var Ot=/(^\s|\s$|\n)/;function It(e,t,n){return"<"+e+(null!=n?function(e){return Ce(e).map((function(t){return" "+t+'="'+e[t]+'"'})).join("")}(n):"")+(null!=t?(t.match(Ot)?' xml:space="preserve"':"")+">"+t+"</"+e:"/")+">"}function Pt(e){if(y&&Buffer.isBuffer(e))return e.toString("utf8");if("string"==typeof e)return e;if("undefined"!=typeof Uint8Array&&e instanceof Uint8Array)return Et(S(C(e)));throw new Error("Bad input format: expected Buffer or string")}var Dt=/<(\/?)([^\s?><!\/:]*:|)([^\s?<>:\/]+)(?:[\s?:\/](?:[^>=]|="[^"]*?")*)?>/gm,Nt={CORE_PROPS:"http://schemas.openxmlformats.org/package/2006/metadata/core-properties",CUST_PROPS:"http://schemas.openxmlformats.org/officeDocument/2006/custom-properties",EXT_PROPS:"http://schemas.openxmlformats.org/officeDocument/2006/extended-properties",CT:"http://schemas.openxmlformats.org/package/2006/content-types",RELS:"http://schemas.openxmlformats.org/package/2006/relationships",TCMNT:"http://schemas.microsoft.com/office/spreadsheetml/2018/threadedcomments",dc:"http://purl.org/dc/elements/1.1/",dcterms:"http://purl.org/dc/terms/",dcmitype:"http://purl.org/dc/dcmitype/",mx:"http://schemas.microsoft.com/office/mac/excel/2008/main",r:"http://schemas.openxmlformats.org/officeDocument/2006/relationships",sjs:"http://schemas.openxmlformats.org/package/2006/sheetjs/core-properties",vt:"http://schemas.openxmlformats.org/officeDocument/2006/docPropsVTypes",xsi:"http://www.w3.org/2001/XMLSchema-instance",xsd:"http://www.w3.org/2001/XMLSchema"},Ut=["http://schemas.openxmlformats.org/spreadsheetml/2006/main","http://purl.oclc.org/ooxml/spreadsheetml/main","http://schemas.microsoft.com/office/excel/2006/main","http://schemas.microsoft.com/office/excel/2006/2"],Ft=function(e){for(var t=[],n=0;n<e[0].length;++n)if(e[0][n])for(var r=0,i=e[0][n].length;r<i;r+=10240)t.push.apply(t,e[0][n].slice(r,r+10240));return t},Bt=y?function(e){return e[0].length>0&&Buffer.isBuffer(e[0][0])?Buffer.concat(e[0].map((function(e){return Buffer.isBuffer(e)?e:x(e)}))):Ft(e)}:Ft,zt=function(e,t,n){for(var r=[],i=t;i<n;i+=2)r.push(String.fromCharCode(cn(e,i)));return r.join("").replace(k,"")},Ht=y?function(e,t,n){return Buffer.isBuffer(e)&&A?e.toString("utf16le",t,n).replace(k,""):zt(e,t,n)}:zt,Vt=function(e,t,n){for(var r=[],i=t;i<t+n;++i)r.push(("0"+e[i].toString(16)).slice(-2));return r.join("")},Gt=y?function(e,t,n){return Buffer.isBuffer(e)?e.toString("hex",t,t+n):Vt(e,t,n)}:Vt,Wt=function(e,t,n){for(var r=[],i=t;i<n;i++)r.push(String.fromCharCode(sn(e,i)));return r.join("")},jt=y?function(e,t,n){return Buffer.isBuffer(e)?e.toString("utf8",t,n):Wt(e,t,n)}:Wt,Xt=function(e,t){var n=un(e,t);return n>0?jt(e,t+4,t+4+n-1):""},Yt=Xt,qt=function(e,t){var n=un(e,t);return n>0?jt(e,t+4,t+4+n-1):""},Kt=qt,Zt=function(e,t){var n=2*un(e,t);return n>0?jt(e,t+4,t+4+n-1):""},Jt=Zt,Qt=function(e,t){var n=un(e,t);return n>0?Ht(e,t+4,t+4+n):""},en=Qt,tn=function(e,t){var n=un(e,t);return n>0?jt(e,t+4,t+4+n):""},nn=tn,rn=function(e,t){return function(e,t){for(var n=1-2*(e[t+7]>>>7),r=((127&e[t+7])<<4)+(e[t+6]>>>4&15),i=15&e[t+6],a=5;a>=0;--a)i=256*i+e[t+a];return 2047==r?0==i?n*(1/0):NaN:(0==r?r=-1022:(r-=1023,i+=Math.pow(2,52)),n*Math.pow(2,r-52)*i)}(e,t)},an=rn,on=function(e){return Array.isArray(e)||"undefined"!=typeof Uint8Array&&e instanceof Uint8Array};y&&(Yt=function(e,t){if(!Buffer.isBuffer(e))return Xt(e,t);var n=e.readUInt32LE(t);return n>0?e.toString("utf8",t+4,t+4+n-1):""},Kt=function(e,t){if(!Buffer.isBuffer(e))return qt(e,t);var n=e.readUInt32LE(t);return n>0?e.toString("utf8",t+4,t+4+n-1):""},Jt=function(e,t){if(!Buffer.isBuffer(e)||!A)return Zt(e,t);var n=2*e.readUInt32LE(t);return e.toString("utf16le",t+4,t+4+n-1)},en=function(e,t){if(!Buffer.isBuffer(e)||!A)return Qt(e,t);var n=e.readUInt32LE(t);return e.toString("utf16le",t+4,t+4+n)},nn=function(e,t){if(!Buffer.isBuffer(e))return tn(e,t);var n=e.readUInt32LE(t);return e.toString("utf8",t+4,t+4+n)},an=function(e,t){return Buffer.isBuffer(e)?e.readDoubleLE(t):rn(e,t)},on=function(e){return Buffer.isBuffer(e)||Array.isArray(e)||"undefined"!=typeof Uint8Array&&e instanceof Uint8Array}),void 0!==t&&(Ht=function(e,n,r){return t.utils.decode(1200,e.slice(n,r)).replace(k,"")},jt=function(e,n,r){return t.utils.decode(65001,e.slice(n,r))},Yt=function(e,n){var r=un(e,n);return r>0?t.utils.decode(i,e.slice(n+4,n+4+r-1)):""},Kt=function(e,n){var i=un(e,n);return i>0?t.utils.decode(r,e.slice(n+4,n+4+i-1)):""},Jt=function(e,n){var r=2*un(e,n);return r>0?t.utils.decode(1200,e.slice(n+4,n+4+r-1)):""},en=function(e,n){var r=un(e,n);return r>0?t.utils.decode(1200,e.slice(n+4,n+4+r)):""},nn=function(e,n){var r=un(e,n);return r>0?t.utils.decode(65001,e.slice(n+4,n+4+r)):""});var sn=function(e,t){return e[t]},cn=function(e,t){return 256*e[t+1]+e[t]},ln=function(e,t){var n=256*e[t+1]+e[t];return n<32768?n:-1*(65535-n+1)},un=function(e,t){return e[t+3]*(1<<24)+(e[t+2]<<16)+(e[t+1]<<8)+e[t]},dn=function(e,t){return e[t+3]<<24|e[t+2]<<16|e[t+1]<<8|e[t]},fn=function(e,t){return e[t]<<24|e[t+1]<<16|e[t+2]<<8|e[t+3]};function hn(e,n){var i,a,o,s,c,l,u="",d=[];switch(n){case"dbcs":if(l=this.l,y&&Buffer.isBuffer(this)&&A)u=this.slice(this.l,this.l+2*e).toString("utf16le");else for(c=0;c<e;++c)u+=String.fromCharCode(cn(this,l)),l+=2;e*=2;break;case"utf8":u=jt(this,this.l,this.l+e);break;case"utf16le":e*=2,u=Ht(this,this.l,this.l+e);break;case"wstr":if(void 0===t)return hn.call(this,e,"dbcs");u=t.utils.decode(r,this.slice(this.l,this.l+2*e)),e*=2;break;case"lpstr-ansi":u=Yt(this,this.l),e=4+un(this,this.l);break;case"lpstr-cp":u=Kt(this,this.l),e=4+un(this,this.l);break;case"lpwstr":u=Jt(this,this.l),e=4+2*un(this,this.l);break;case"lpp4":e=4+un(this,this.l),u=en(this,this.l),2&e&&(e+=2);break;case"8lpp4":e=4+un(this,this.l),u=nn(this,this.l),3&e&&(e+=4-(3&e));break;case"cstr":for(e=0,u="";0!==(o=sn(this,this.l+e++));)d.push(p(o));u=d.join("");break;case"_wstr":for(e=0,u="";0!==(o=cn(this,this.l+e));)d.push(p(o)),e+=2;e+=2,u=d.join("");break;case"dbcs-cont":for(u="",l=this.l,c=0;c<e;++c){if(this.lens&&-1!==this.lens.indexOf(l))return o=sn(this,l),this.l=l+1,s=hn.call(this,e-c,o?"dbcs-cont":"sbcs-cont"),d.join("")+s;d.push(p(cn(this,l))),l+=2}u=d.join(""),e*=2;break;case"cpstr":if(void 0!==t){u=t.utils.decode(r,this.slice(this.l,this.l+e));break}case"sbcs-cont":for(u="",l=this.l,c=0;c!=e;++c){if(this.lens&&-1!==this.lens.indexOf(l))return o=sn(this,l),this.l=l+1,s=hn.call(this,e-c,o?"dbcs-cont":"sbcs-cont"),d.join("")+s;d.push(p(sn(this,l))),l+=1}u=d.join("");break;default:switch(e){case 1:return i=sn(this,this.l),this.l++,i;case 2:return i=("i"===n?ln:cn)(this,this.l),this.l+=2,i;case 4:case-4:return"i"===n||0==(128&this[this.l+3])?(i=(e>0?dn:fn)(this,this.l),this.l+=4,i):(a=un(this,this.l),this.l+=4,a);case 8:case-8:if("f"===n)return a=8==e?an(this,this.l):an([this[this.l+7],this[this.l+6],this[this.l+5],this[this.l+4],this[this.l+3],this[this.l+2],this[this.l+1],this[this.l+0]],0),this.l+=8,a;e=8;case 16:u=Gt(this,this.l,e)}}return this.l+=e,u}var pn=function(e,t,n){e[n]=255&t,e[n+1]=t>>>8&255,e[n+2]=t>>>16&255,e[n+3]=t>>>24&255},mn=function(e,t,n){e[n]=255&t,e[n+1]=t>>8&255,e[n+2]=t>>16&255,e[n+3]=t>>24&255},vn=function(e,t,n){e[n]=255&t,e[n+1]=t>>>8&255};function gn(e,n,a){var o=0,s=0;if("dbcs"===a){for(s=0;s!=n.length;++s)vn(this,n.charCodeAt(s),this.l+2*s);o=2*n.length}else if("sbcs"===a||"cpstr"==a)if(void 0!==t&&874==i){for(s=0;s!=n.length;++s){var c=t.utils.encode(i,n.charAt(s));this[this.l+s]=c[0]}o=n.length}else if(void 0!==t&&"cpstr"==a){if((c=t.utils.encode(r,n)).length==n.length)for(s=0;s<n.length;++s)0==c[s]&&0!=n.charCodeAt(s)&&(c[s]=95);if(c.length==2*n.length)for(s=0;s<n.length;++s)0==c[2*s]&&0==c[2*s+1]&&0!=n.charCodeAt(s)&&(c[2*s]=95);for(s=0;s<c.length;++s)this[this.l+s]=c[s];o=c.length}else{for(n=n.replace(/[^\x00-\x7F]/g,"_"),s=0;s!=n.length;++s)this[this.l+s]=255&n.charCodeAt(s);o=n.length}else{if("hex"===a){for(;s<e;++s)this[this.l++]=parseInt(n.slice(2*s,2*s+2),16)||0;return this}if("utf16le"===a){var l=Math.min(this.l+e,this.length);for(s=0;s<Math.min(n.length,e);++s){var u=n.charCodeAt(s);this[this.l++]=255&u,this[this.l++]=u>>8}for(;this.l<l;)this[this.l++]=0;return this}switch(e){case 1:o=1,this[this.l]=255&n;break;case 2:o=2,this[this.l]=255&n,n>>>=8,this[this.l+1]=255&n;break;case 3:o=3,this[this.l]=255&n,n>>>=8,this[this.l+1]=255&n,n>>>=8,this[this.l+2]=255&n;break;case 4:o=4,pn(this,n,this.l);break;case 8:if(o=8,"f"===a){!function(e,t,n){var r=(t<0||1/t==-1/0?1:0)<<7,i=0,a=0,o=r?-t:t;isFinite(o)?0==o?i=a=0:(i=Math.floor(Math.log(o)/Math.LN2),a=o*Math.pow(2,52-i),i<=-1023&&(!isFinite(a)||a<Math.pow(2,52))?i=-1022:(a-=Math.pow(2,52),i+=1023)):(i=2047,a=isNaN(t)?26985:0);for(var s=0;s<=5;++s,a/=256)e[n+s]=255&a;e[n+6]=(15&i)<<4|15&a,e[n+7]=i>>4|r}(this,n,this.l);break}case 16:break;case-4:o=4,mn(this,n,this.l)}}return this.l+=o,this}function bn(e,t){var n=Gt(this,this.l,e.length>>1);if(n!==e)throw new Error(t+"Expected "+e+" saw "+n);this.l+=e.length>>1}function _n(e,t){e.l=t,e.read_shift=hn,e.chk=bn,e.write_shift=gn}function yn(e,t){e.l+=t}function xn(e){var t=w(e);return _n(t,0),t}function An(e,t,n){if(e){var r,i,a;_n(e,e.l||0);for(var o=e.length,s=0,c=0;e.l<o;){128&(s=e.read_shift(1))&&(s=(127&s)+((127&e.read_shift(1))<<7));var l=bs[s]||bs[65535];for(a=127&(r=e.read_shift(1)),i=1;i<4&&128&r;++i)a+=(127&(r=e.read_shift(1)))<<7*i;c=e.l+a;var u=l.f&&l.f(e,a,n);if(e.l=c,t(u,l,s))return}}}function wn(){var e=[],t=y?256:2048,n=function(e){var t=xn(e);return _n(t,0),t},r=n(t),i=function(){r&&(r.l&&(r.length>r.l&&((r=r.slice(0,r.l)).l=r.length),r.length>0&&e.push(r)),r=null)},a=function(e){return r&&e<r.length-r.l?r:(i(),r=n(Math.max(e+1,t)))};return{next:a,push:function(e){i(),null==(r=e).l&&(r.l=r.length),a(t)},end:function(){return i(),M(e)},_bufs:e}}function En(e,t,n){var r=He(e);if(t.s?(r.cRel&&(r.c+=t.s.c),r.rRel&&(r.r+=t.s.r)):(r.cRel&&(r.c+=t.c),r.rRel&&(r.r+=t.r)),!n||n.biff<12){for(;r.c>=256;)r.c-=256;for(;r.r>=65536;)r.r-=65536}return r}function Tn(e,t,n){var r=He(e);return r.s=En(r.s,t.s,n),r.e=En(r.e,t.s,n),r}function Sn(e,t){if(e.cRel&&e.c<0)for(e=He(e);e.c<0;)e.c+=t>8?16384:256;if(e.rRel&&e.r<0)for(e=He(e);e.r<0;)e.r+=t>8?1048576:t>5?65536:16384;var n=In(e);return e.cRel||null==e.cRel||(n=n.replace(/^([A-Z])/,"$$$1")),e.rRel||null==e.rRel||(n=n.replace(/([A-Z]|^)(\d+)$/,"$1$$$2")),n}function Cn(e,t){return 0!=e.s.r||e.s.rRel||e.e.r!=(t.biff>=12?1048575:t.biff>=8?65536:16384)||e.e.rRel?0!=e.s.c||e.s.cRel||e.e.c!=(t.biff>=12?16383:255)||e.e.cRel?Sn(e.s,t.biff)+":"+Sn(e.e,t.biff):(e.s.rRel?"":"$")+kn(e.s.r)+":"+(e.e.rRel?"":"$")+kn(e.e.r):(e.s.cRel?"":"$")+Ln(e.s.c)+":"+(e.e.cRel?"":"$")+Ln(e.e.c)}function Mn(e){return parseInt(e.replace(/\$(\d+)$/,"$1"),10)-1}function kn(e){return""+(e+1)}function Rn(e){for(var t=e.replace(/^\$([A-Z])/,"$1"),n=0,r=0;r!==t.length;++r)n=26*n+t.charCodeAt(r)-64;return n-1}function Ln(e){if(e<0)throw new Error("invalid column "+e);var t="";for(++e;e;e=Math.floor((e-1)/26))t=String.fromCharCode((e-1)%26+65)+t;return t}function On(e){for(var t=0,n=0,r=0;r<e.length;++r){var i=e.charCodeAt(r);i>=48&&i<=57?t=10*t+(i-48):i>=65&&i<=90&&(n=26*n+(i-64))}return{c:n-1,r:t-1}}function In(e){for(var t=e.c+1,n="";t;t=(t-1)/26|0)n=String.fromCharCode((t-1)%26+65)+n;return n+(e.r+1)}function Pn(e){var t=e.indexOf(":");return-1==t?{s:On(e),e:On(e)}:{s:On(e.slice(0,t)),e:On(e.slice(t+1))}}function Dn(e,t){return void 0===t||"number"==typeof t?Dn(e.s,e.e):("string"!=typeof e&&(e=In(e)),"string"!=typeof t&&(t=In(t)),e==t?e:e+":"+t)}function Nn(e){var t={s:{c:0,r:0},e:{c:0,r:0}},n=0,r=0,i=0,a=e.length;for(n=0;r<a&&!((i=e.charCodeAt(r)-64)<1||i>26);++r)n=26*n+i;for(t.s.c=--n,n=0;r<a&&!((i=e.charCodeAt(r)-48)<0||i>9);++r)n=10*n+i;if(t.s.r=--n,r===a||10!=i)return t.e.c=t.s.c,t.e.r=t.s.r,t;for(++r,n=0;r!=a&&!((i=e.charCodeAt(r)-64)<1||i>26);++r)n=26*n+i;for(t.e.c=--n,n=0;r!=a&&!((i=e.charCodeAt(r)-48)<0||i>9);++r)n=10*n+i;return t.e.r=--n,t}function Un(e,t,n){return null==e||null==e.t||"z"==e.t?"":void 0!==e.w?e.w:("d"==e.t&&!e.z&&n&&n.dateNF&&(e.z=n.dateNF),"e"==e.t?pr[e.v]||e.v:function(e,t){var n="d"==e.t&&t instanceof Date;if(null!=e.z)try{return e.w=be(e.z,n?Re(t):t)}catch(e){}try{return e.w=be((e.XF||{}).numFmtId||(n?14:0),n?Re(t):t)}catch(e){return""+t}}(e,null==t?e.v:t))}function Fn(e,t){var n=t&&t.sheet?t.sheet:"Sheet1",r={};return r[n]=e,{SheetNames:[n],Sheets:r}}function Bn(e,t,n){var r=n||{},i=e?null!=e["!data"]:r.dense;null!=v&&null==i&&(i=v);var a=e||{};i&&!a["!data"]&&(a["!data"]=[]);var o=0,s=0;if(a&&null!=r.origin){if("number"==typeof r.origin)o=r.origin;else{var c="string"==typeof r.origin?On(r.origin):r.origin;o=c.r,s=c.c}a["!ref"]||(a["!ref"]="A1:A1")}var l={s:{c:1e7,r:1e7},e:{c:0,r:0}};if(a["!ref"]){var u=Nn(a["!ref"]);l.s.c=u.s.c,l.s.r=u.s.r,l.e.c=Math.max(l.e.c,u.e.c),l.e.r=Math.max(l.e.r,u.e.r),-1==o&&(l.e.r=o=u.e.r+1)}for(var d=[],f=0;f!=t.length;++f)if(t[f]){if(!Array.isArray(t[f]))throw new Error("aoa_to_sheet expects an array of arrays");var h=o+f,p=""+(h+1);i&&(a["!data"][h]||(a["!data"][h]=[]),d=a["!data"][h]);for(var m=0;m!=t[f].length;++m)if(void 0!==t[f][m]){var g={v:t[f][m]},b=s+m;if(l.s.r>h&&(l.s.r=h),l.s.c>b&&(l.s.c=b),l.e.r<h&&(l.e.r=h),l.e.c<b&&(l.e.c=b),!t[f][m]||"object"!=typeof t[f][m]||Array.isArray(t[f][m])||t[f][m]instanceof Date)if(Array.isArray(g.v)&&(g.f=t[f][m][1],g.v=g.v[0]),null===g.v)if(g.f)g.t="n";else if(r.nullError)g.t="e",g.v=0;else{if(!r.sheetStubs)continue;g.t="z"}else"number"==typeof g.v?g.t="n":"boolean"==typeof g.v?g.t="b":g.v instanceof Date?(g.z=r.dateNF||z[14],r.cellDates?(g.t="d",g.w=be(g.z,Re(g.v,r.date1904))):(g.t="n",g.v=Re(g.v,r.date1904),g.w=be(g.z,g.v))):g.t="s";else g=t[f][m];if(i)d[b]&&d[b].z&&(g.z=d[b].z),d[b]=g;else{var _=Ln(b)+p;a[_]&&a[_].z&&(g.z=a[_].z),a[_]=g}}}return l.s.c<1e7&&(a["!ref"]=Dn(l)),a}function zn(e,t){return Bn(null,e,t)}function Hn(e){var t=e.read_shift(4);return 0===t?"":e.read_shift(t,"dbcs")}function Vn(e){return{ich:e.read_shift(2),ifnt:e.read_shift(2)}}function Gn(e,t){var n=e.l,r=e.read_shift(1),i=Hn(e),a=[],o={t:i,h:i};if(0!=(1&r)){for(var s=e.read_shift(4),c=0;c!=s;++c)a.push(Vn(e));o.r=a}else o.r=[{ich:0,ifnt:0}];return e.l=n+t,o}var $n=Gn;function Wn(e){var t=e.read_shift(4),n=e.read_shift(2);return n+=e.read_shift(1)<<16,e.l++,{c:t,iStyleRef:n}}function jn(e){var t=e.read_shift(2);return t+=e.read_shift(1)<<16,e.l++,{c:-1,iStyleRef:t}}var Xn=Hn;function Yn(e){var t=e.read_shift(4);return 0===t||4294967295===t?"":e.read_shift(t,"dbcs")}var qn=Hn,Kn=Yn;function Zn(e){var t=e.slice(e.l,e.l+4),n=1&t[0],r=2&t[0];e.l+=4;var i=0===r?an([0,0,0,0,252&t[0],t[1],t[2],t[3]],0):dn(t,0)>>2;return n?i/100:i}function Jn(e){var t={s:{},e:{}};return t.s.r=e.read_shift(4),t.e.r=e.read_shift(4),t.s.c=e.read_shift(4),t.e.c=e.read_shift(4),t}var Qn=Jn;function er(e){if(e.length-e.l<8)throw"XLS Xnum Buffer underflow";return e.read_shift(8,"f")}function tr(e,t){var n=e.read_shift(4);switch(n){case 0:return"";case 4294967295:case 4294967294:return{2:"BITMAP",3:"METAFILEPICT",8:"DIB",14:"ENHMETAFILE"}[e.read_shift(4)]||""}if(n>400)throw new Error("Unsupported Clipboard: "+n.toString(16));return e.l-=4,e.read_shift(0,1==t?"lpstr":"lpwstr")}var nr=2,rr=3,ir=12,ar=80,or=81,sr=[ar,or],cr={1:{n:"CodePage",t:nr},2:{n:"Category",t:ar},3:{n:"PresentationFormat",t:ar},4:{n:"ByteCount",t:rr},5:{n:"LineCount",t:rr},6:{n:"ParagraphCount",t:rr},7:{n:"SlideCount",t:rr},8:{n:"NoteCount",t:rr},9:{n:"HiddenCount",t:rr},10:{n:"MultimediaClipCount",t:rr},11:{n:"ScaleCrop",t:11},12:{n:"HeadingPairs",t:4108},13:{n:"TitlesOfParts",t:4126},14:{n:"Manager",t:ar},15:{n:"Company",t:ar},16:{n:"LinksUpToDate",t:11},17:{n:"CharacterCount",t:rr},19:{n:"SharedDoc",t:11},22:{n:"HyperlinksChanged",t:11},23:{n:"AppVersion",t:rr,p:"version"},24:{n:"DigSig",t:65},26:{n:"ContentType",t:ar},27:{n:"ContentStatus",t:ar},28:{n:"Language",t:ar},29:{n:"Version",t:ar},255:{},2147483648:{n:"Locale",t:19},2147483651:{n:"Behavior",t:19},1919054434:{}},lr={1:{n:"CodePage",t:nr},2:{n:"Title",t:ar},3:{n:"Subject",t:ar},4:{n:"Author",t:ar},5:{n:"Keywords",t:ar},6:{n:"Comments",t:ar},7:{n:"Template",t:ar},8:{n:"LastAuthor",t:ar},9:{n:"RevNumber",t:ar},10:{n:"EditTime",t:64},11:{n:"LastPrinted",t:64},12:{n:"CreatedDate",t:64},13:{n:"ModifiedDate",t:64},14:{n:"PageCount",t:rr},15:{n:"WordCount",t:rr},16:{n:"CharCount",t:rr},17:{n:"Thumbnail",t:71},18:{n:"Application",t:ar},19:{n:"DocSecurity",t:rr},255:{},2147483648:{n:"Locale",t:19},2147483651:{n:"Behavior",t:19},1919054434:{}},ur={1:"US",2:"CA",3:"",7:"RU",20:"EG",30:"GR",31:"NL",32:"BE",33:"FR",34:"ES",36:"HU",39:"IT",41:"CH",43:"AT",44:"GB",45:"DK",46:"SE",47:"NO",48:"PL",49:"DE",52:"MX",55:"BR",61:"AU",64:"NZ",66:"TH",81:"JP",82:"KR",84:"VN",86:"CN",90:"TR",105:"JS",213:"DZ",216:"MA",218:"LY",351:"PT",354:"IS",358:"FI",420:"CZ",886:"TW",961:"LB",962:"JO",963:"SY",964:"IQ",965:"KW",966:"SA",971:"AE",972:"IL",974:"QA",981:"IR",65535:"US"},dr=[null,"solid","mediumGray","darkGray","lightGray","darkHorizontal","darkVertical","darkDown","darkUp","darkGrid","darkTrellis","lightHorizontal","lightVertical","lightDown","lightUp","lightGrid","lightTrellis","gray125","gray0625"];function fr(e){return e.map((function(e){return[e>>16&255,e>>8&255,255&e]}))}var hr=He(fr([0,16777215,16711680,65280,255,16776960,16711935,65535,0,16777215,16711680,65280,255,16776960,16711935,65535,8388608,32768,128,8421376,8388736,32896,12632256,8421504,10066431,10040166,16777164,13434879,6684774,16744576,26316,13421823,128,16711935,16776960,65535,8388736,8388608,32896,255,52479,13434879,13434828,16777113,10079487,16751052,13408767,16764057,3368703,3394764,10079232,16763904,16750848,16737792,6710937,9868950,13158,3381606,13056,3355392,10040064,10040166,3355545,3355443,0,16777215,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])),pr={0:"#NULL!",7:"#DIV/0!",15:"#VALUE!",23:"#REF!",29:"#NAME?",36:"#NUM!",42:"#N/A",43:"#GETTING_DATA",255:"#WTF?"},mr={"#NULL!":0,"#DIV/0!":7,"#VALUE!":15,"#REF!":23,"#NAME?":29,"#NUM!":36,"#N/A":42,"#GETTING_DATA":43,"#WTF?":255},vr=["_xlnm.Consolidate_Area","_xlnm.Auto_Open","_xlnm.Auto_Close","_xlnm.Extract","_xlnm.Database","_xlnm.Criteria","_xlnm.Print_Area","_xlnm.Print_Titles","_xlnm.Recorder","_xlnm.Data_Form","_xlnm.Auto_Activate","_xlnm.Auto_Deactivate","_xlnm.Sheet_Title","_xlnm._FilterDatabase"],gr={"application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml":"workbooks","application/vnd.ms-excel.sheet.macroEnabled.main+xml":"workbooks","application/vnd.ms-excel.sheet.binary.macroEnabled.main":"workbooks","application/vnd.ms-excel.addin.macroEnabled.main+xml":"workbooks","application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml":"workbooks","application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml":"sheets","application/vnd.ms-excel.worksheet":"sheets","application/vnd.ms-excel.binIndexWs":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml":"charts","application/vnd.ms-excel.chartsheet":"charts","application/vnd.ms-excel.macrosheet+xml":"macros","application/vnd.ms-excel.macrosheet":"macros","application/vnd.ms-excel.intlmacrosheet":"TODO","application/vnd.ms-excel.binIndexMs":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml":"dialogs","application/vnd.ms-excel.dialogsheet":"dialogs","application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml":"strs","application/vnd.ms-excel.sharedStrings":"strs","application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml":"styles","application/vnd.ms-excel.styles":"styles","application/vnd.openxmlformats-package.core-properties+xml":"coreprops","application/vnd.openxmlformats-officedocument.custom-properties+xml":"custprops","application/vnd.openxmlformats-officedocument.extended-properties+xml":"extprops","application/vnd.openxmlformats-officedocument.customXmlProperties+xml":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.customProperty":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml":"comments","application/vnd.ms-excel.comments":"comments","application/vnd.ms-excel.threadedcomments+xml":"threadedcomments","application/vnd.ms-excel.person+xml":"people","application/vnd.openxmlformats-officedocument.spreadsheetml.sheetMetadata+xml":"metadata","application/vnd.ms-excel.sheetMetadata":"metadata","application/vnd.ms-excel.pivotTable":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.pivotTable+xml":"TODO","application/vnd.openxmlformats-officedocument.drawingml.chart+xml":"TODO","application/vnd.ms-office.chartcolorstyle+xml":"TODO","application/vnd.ms-office.chartstyle+xml":"TODO","application/vnd.ms-office.chartex+xml":"TODO","application/vnd.ms-excel.calcChain":"calcchains","application/vnd.openxmlformats-officedocument.spreadsheetml.calcChain+xml":"calcchains","application/vnd.openxmlformats-officedocument.spreadsheetml.printerSettings":"TODO","application/vnd.ms-office.activeX":"TODO","application/vnd.ms-office.activeX+xml":"TODO","application/vnd.ms-excel.attachedToolbars":"TODO","application/vnd.ms-excel.connections":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml":"TODO","application/vnd.ms-excel.externalLink":"links","application/vnd.openxmlformats-officedocument.spreadsheetml.externalLink+xml":"links","application/vnd.ms-excel.pivotCacheDefinition":"TODO","application/vnd.ms-excel.pivotCacheRecords":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheDefinition+xml":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheRecords+xml":"TODO","application/vnd.ms-excel.queryTable":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.queryTable+xml":"TODO","application/vnd.ms-excel.userNames":"TODO","application/vnd.ms-excel.revisionHeaders":"TODO","application/vnd.ms-excel.revisionLog":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.revisionHeaders+xml":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.revisionLog+xml":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.userNames+xml":"TODO","application/vnd.ms-excel.tableSingleCells":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.tableSingleCells+xml":"TODO","application/vnd.ms-excel.slicer":"TODO","application/vnd.ms-excel.slicerCache":"TODO","application/vnd.ms-excel.slicer+xml":"TODO","application/vnd.ms-excel.slicerCache+xml":"TODO","application/vnd.ms-excel.wsSortMap":"TODO","application/vnd.ms-excel.table":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml":"TODO","application/vnd.openxmlformats-officedocument.theme+xml":"themes","application/vnd.openxmlformats-officedocument.themeOverride+xml":"TODO","application/vnd.ms-excel.Timeline+xml":"TODO","application/vnd.ms-excel.TimelineCache+xml":"TODO","application/vnd.ms-office.vbaProject":"vba","application/vnd.ms-office.vbaProjectSignature":"TODO","application/vnd.ms-office.volatileDependencies":"TODO","application/vnd.openxmlformats-officedocument.spreadsheetml.volatileDependencies+xml":"TODO","application/vnd.ms-excel.controlproperties+xml":"TODO","application/vnd.openxmlformats-officedocument.model+data":"TODO","application/vnd.ms-excel.Survey+xml":"TODO","application/vnd.openxmlformats-officedocument.drawing+xml":"drawings","application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml":"TODO","application/vnd.openxmlformats-officedocument.drawingml.diagramColors+xml":"TODO","application/vnd.openxmlformats-officedocument.drawingml.diagramData+xml":"TODO","application/vnd.openxmlformats-officedocument.drawingml.diagramLayout+xml":"TODO","application/vnd.openxmlformats-officedocument.drawingml.diagramStyle+xml":"TODO","application/vnd.openxmlformats-officedocument.vmlDrawing":"TODO","application/vnd.openxmlformats-package.relationships+xml":"rels","application/vnd.openxmlformats-officedocument.oleObject":"TODO","image/png":"TODO",sheet:"js"},br={WB:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/officeDocument",SHEET:"http://sheetjs.openxmlformats.org/officeDocument/2006/relationships/officeDocument",HLINK:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/hyperlink",VML:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/vmlDrawing",XPATH:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/externalLinkPath",XMISS:"http://schemas.microsoft.com/office/2006/relationships/xlExternalLinkPath/xlPathMissing",XLINK:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/externalLink",CXML:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/customXml",CXMLP:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/customXmlProps",CMNT:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/comments",CORE_PROPS:"http://schemas.openxmlformats.org/package/2006/relationships/metadata/core-properties",EXT_PROPS:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/extended-properties",CUST_PROPS:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/custom-properties",SST:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/sharedStrings",STY:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/styles",THEME:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/theme",CHART:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/chart",CHARTEX:"http://schemas.microsoft.com/office/2014/relationships/chartEx",CS:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/chartsheet",WS:["http://schemas.openxmlformats.org/officeDocument/2006/relationships/worksheet","http://purl.oclc.org/ooxml/officeDocument/relationships/worksheet"],DS:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/dialogsheet",MS:"http://schemas.microsoft.com/office/2006/relationships/xlMacrosheet",IMG:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/image",DRAW:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/drawing",XLMETA:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/sheetMetadata",TCMNT:"http://schemas.microsoft.com/office/2017/10/relationships/threadedComment",PEOPLE:"http://schemas.microsoft.com/office/2017/10/relationships/person",CONN:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/connections",VBA:"http://schemas.microsoft.com/office/2006/relationships/vbaProject"};function _r(e){var t=e.lastIndexOf("/");return e.slice(0,t+1)+"_rels/"+e.slice(t+1)+".rels"}function yr(e,t){var n={"!id":{}};if(!e)return n;"/"!==t.charAt(0)&&(t="/"+t);var r={};return(e.match(st)||[]).forEach((function(e){var i=ut(e);if("<Relationship"===i[0]){var a={};a.Type=i.Type,a.Target=pt(i.Target),a.Id=i.Id,i.TargetMode&&(a.TargetMode=i.TargetMode);var o="External"===i.TargetMode?i.Target:rt(i.Target,t);n[o]=a,r[i.Id]=a}})),n["!id"]=r,n}var xr="application/vnd.oasis.opendocument.spreadsheet",Ar=[["cp:category","Category"],["cp:contentStatus","ContentStatus"],["cp:keywords","Keywords"],["cp:lastModifiedBy","LastAuthor"],["cp:lastPrinted","LastPrinted"],["cp:revision","RevNumber"],["cp:version","Version"],["dc:creator","Author"],["dc:description","Comments"],["dc:identifier","Identifier"],["dc:language","Language"],["dc:subject","Subject"],["dc:title","Title"],["dcterms:created","CreatedDate","date"],["dcterms:modified","ModifiedDate","date"]],wr=function(){for(var e=new Array(Ar.length),t=0;t<Ar.length;++t){var n=Ar[t],r="(?:"+n[0].slice(0,n[0].indexOf(":"))+":)"+n[0].slice(n[0].indexOf(":")+1);e[t]=new RegExp("<"+r+"[^>]*>([\\s\\S]*?)</"+r+">")}return e}();function Er(e){var t={};e=Et(e);for(var n=0;n<Ar.length;++n){var r=Ar[n],i=e.match(wr[n]);null!=i&&i.length>0&&(t[r[1]]=pt(i[1])),"date"===r[2]&&t[r[1]]&&(t[r[1]]=Be(t[r[1]]))}return t}var Tr=[["Application","Application","string"],["AppVersion","AppVersion","string"],["Company","Company","string"],["DocSecurity","DocSecurity","string"],["Manager","Manager","string"],["HyperlinksChanged","HyperlinksChanged","bool"],["SharedDoc","SharedDoc","bool"],["LinksUpToDate","LinksUpToDate","bool"],["ScaleCrop","ScaleCrop","bool"],["HeadingPairs","HeadingPairs","raw"],["TitlesOfParts","TitlesOfParts","raw"]];function Sr(e,t,n,r){var i=[];if("string"==typeof e)i=Lt(e,r);else for(var a=0;a<e.length;++a)i=i.concat(e[a].map((function(e){return{v:e}})));var o="string"==typeof t?Lt(t,r).map((function(e){return e.v})):t,s=0,c=0;if(o.length>0)for(var l=0;l!==i.length;l+=2){switch(c=+i[l+1].v,i[l].v){case"Worksheets":case"工作表":case"Листы":case"أوراق العمل":case"ワークシート":case"גליונות עבודה":case"Arbeitsblätter":case"Çalışma Sayfaları":case"Feuilles de calcul":case"Fogli di lavoro":case"Folhas de cálculo":case"Planilhas":case"Regneark":case"Hojas de cálculo":case"Werkbladen":n.Worksheets=c,n.SheetNames=o.slice(s,s+c);break;case"Named Ranges":case"Rangos con nombre":case"名前付き一覧":case"Benannte Bereiche":case"Navngivne områder":n.NamedRanges=c,n.DefinedNames=o.slice(s,s+c);break;case"Charts":case"Diagramme":n.Chartsheets=c,n.ChartNames=o.slice(s,s+c)}s+=c}}var Cr,Mr=/<[^>]+>[^<]*/g,kr={Title:"Title",Subject:"Subject",Author:"Author",Keywords:"Keywords",Comments:"Description",LastAuthor:"LastAuthor",RevNumber:"Revision",Application:"AppName",LastPrinted:"LastPrinted",CreatedDate:"Created",ModifiedDate:"LastSaved",Category:"Category",Manager:"Manager",Company:"Company",AppVersion:"Version",ContentStatus:"ContentStatus",Identifier:"Identifier",Language:"Language"};function Rr(e,t,n){Cr||(Cr=Me(kr)),e[t=Cr[t]||t]=n}function Lr(e){var t=e.read_shift(4),n=e.read_shift(4);return new Date(1e3*(n/1e7*Math.pow(2,32)+t/1e7-11644473600)).toISOString().replace(/\.000/,"")}function Or(e,t,n){var r=e.l,i=e.read_shift(0,"lpstr-cp");if(n)for(;e.l-r&3;)++e.l;return i}function Ir(e,t,n){var r=e.read_shift(0,"lpwstr");return n&&(e.l+=4-(r.length+1&3)&3),r}function Pr(e,t,n){return 31===t?Ir(e):Or(e,0,n)}function Dr(e,t,n){return Pr(e,t,!1===n?0:4)}function Nr(e){var t=e.l,n=Br(e,or);return 0==e[e.l]&&0==e[e.l+1]&&e.l-t&2&&(e.l+=2),[n,Br(e,rr)]}function Ur(e,t){for(var n=e.read_shift(4),r={},i=0;i!=n;++i){var a=e.read_shift(4),o=e.read_shift(4);r[a]=e.read_shift(o,1200===t?"utf16le":"utf8").replace(k,"").replace(R,"!"),1200===t&&o%2&&(e.l+=2)}return 3&e.l&&(e.l=e.l>>3<<2),r}function Fr(e){var t=e.read_shift(4),n=e.slice(e.l,e.l+t);return e.l+=t,(3&t)>0&&(e.l+=4-(3&t)&3),n}function Br(e,t,n){var r,i=e.read_shift(2),a=n||{};if(e.l+=2,t!==ir&&i!==t&&-1===sr.indexOf(t)&&(4126!=(65534&t)||4126!=(65534&i)))throw new Error("Expected type "+t+" saw "+i);switch(t===ir?i:t){case 2:return r=e.read_shift(2,"i"),a.raw||(e.l+=2),r;case 3:return e.read_shift(4,"i");case 11:return 0!==e.read_shift(4);case 19:return e.read_shift(4);case 30:return Or(e,0,4).replace(k,"");case 31:return Ir(e);case 64:return Lr(e);case 65:return Fr(e);case 71:return function(e){var t={};return t.Size=e.read_shift(4),e.l+=t.Size+3-(t.Size-1)%4,t}(e);case 80:return Dr(e,i,!a.raw).replace(k,"");case 81:return function(e,t){if(!t)throw new Error("VtUnalignedString must have positive length");return Pr(e,t,0)}(e,i).replace(k,"");case 4108:return function(e){for(var t=e.read_shift(4),n=[],r=0;r<t/2;++r)n.push(Nr(e));return n}(e);case 4126:case 4127:return 4127==i?function(e){for(var t=e.read_shift(4),n=[],r=0;r!=t;++r){var i=e.l;n[r]=e.read_shift(0,"lpwstr").replace(k,""),e.l-i&2&&(e.l+=2)}return n}(e):function(e){for(var t=e.read_shift(4),n=[],r=0;r!=t;++r)n[r]=e.read_shift(0,"lpstr-cp").replace(k,"");return n}(e);default:throw new Error("TypedPropertyValue unrecognized type "+t+" "+i)}}function zr(e,t){var n=e.l,r=e.read_shift(4),i=e.read_shift(4),a=[],o=0,s=0,l=-1,u={};for(o=0;o!=i;++o){var d=e.read_shift(4),f=e.read_shift(4);a[o]=[d,f+n]}a.sort((function(e,t){return e[1]-t[1]}));var h={};for(o=0;o!=i;++o){if(e.l!==a[o][1]){var p=!0;if(o>0&&t)switch(t[a[o-1][0]].t){case 2:e.l+2===a[o][1]&&(e.l+=2,p=!1);break;case 80:case 4108:e.l<=a[o][1]&&(e.l=a[o][1],p=!1)}if((!t||0==o)&&e.l<=a[o][1]&&(p=!1,e.l=a[o][1]),p)throw new Error("Read Error: Expected address "+a[o][1]+" at "+e.l+" :"+o)}if(t){if(0==a[o][0]&&a.length>o+1&&a[o][1]==a[o+1][1])continue;var m=t[a[o][0]];if(h[m.n]=Br(e,m.t,{raw:!0}),"version"===m.p&&(h[m.n]=String(h[m.n]>>16)+"."+("0000"+String(65535&h[m.n])).slice(-4)),"CodePage"==m.n)switch(h[m.n]){case 0:h[m.n]=1252;case 874:case 932:case 936:case 949:case 950:case 1250:case 1251:case 1253:case 1254:case 1255:case 1256:case 1257:case 1258:case 1e4:case 1200:case 1201:case 1252:case 65e3:case-536:case 65001:case-535:c(s=h[m.n]>>>0&65535);break;default:throw new Error("Unsupported CodePage: "+h[m.n])}}else if(1===a[o][0]){if(s=h.CodePage=Br(e,nr),c(s),-1!==l){var v=e.l;e.l=a[l][1],u=Ur(e,s),e.l=v}}else if(0===a[o][0]){if(0===s){l=o,e.l=a[o+1][1];continue}u=Ur(e,s)}else{var g,b=u[a[o][0]];switch(e[e.l]){case 65:e.l+=4,g=Fr(e);break;case 30:case 31:e.l+=4,g=Dr(e,e[e.l-4]).replace(/\u0000+$/,"");break;case 3:e.l+=4,g=e.read_shift(4,"i");break;case 19:e.l+=4,g=e.read_shift(4);break;case 5:e.l+=4,g=e.read_shift(8,"f");break;case 11:e.l+=4,g=Gr(e,4);break;case 64:e.l+=4,g=Be(Lr(e));break;default:throw new Error("unparsed value: "+e[e.l])}h[b]=g}}return e.l=n+r,h}function Hr(e,t,n){var r=e.content;if(!r)return{};_n(r,0);var i,a,o,s,c=0;r.chk("feff","Byte Order: "),r.read_shift(2);var l=r.read_shift(4),u=r.read_shift(16);if(u!==Se.utils.consts.HEADER_CLSID&&u!==n)throw new Error("Bad PropertySet CLSID "+u);if(1!==(i=r.read_shift(4))&&2!==i)throw new Error("Unrecognized #Sets: "+i);if(a=r.read_shift(16),s=r.read_shift(4),1===i&&s!==r.l)throw new Error("Length mismatch: "+s+" !== "+r.l);2===i&&(o=r.read_shift(16),c=r.read_shift(4));var d,f=zr(r,t),h={SystemIdentifier:l};for(var p in f)h[p]=f[p];if(h.FMTID=a,1===i)return h;if(c-r.l==2&&(r.l+=2),r.l!==c)throw new Error("Length mismatch 2: "+r.l+" !== "+c);try{d=zr(r,null)}catch(e){}for(p in d)h[p]=d[p];return h.FMTID=[a,o],h}function Vr(e,t){return e.read_shift(t),null}function Gr(e,t){return 1===e.read_shift(t)}function $r(e){return e.read_shift(2,"u")}function Wr(e,t){return function(e,t,n){for(var r=[],i=e.l+t;e.l<i;)r.push(n(e,i-e.l));if(i!==e.l)throw new Error("Slurp error");return r}(e,t,$r)}function jr(e,t,n){var i=e.read_shift(n&&n.biff>=12?2:1),a="sbcs-cont",o=r;n&&n.biff>=8&&(r=1200),n&&8!=n.biff?12==n.biff&&(a="wstr"):e.read_shift(1)&&(a="dbcs-cont"),n.biff>=2&&n.biff<=5&&(a="cpstr");var s=i?e.read_shift(i,a):"";return r=o,s}function Xr(e){var t=r;r=1200;var n,i=e.read_shift(2),a=e.read_shift(1),o=4&a,s=8&a,c=1+(1&a),l=0,u={};s&&(l=e.read_shift(2)),o&&(n=e.read_shift(4));var d=2==c?"dbcs-cont":"sbcs-cont",f=0===i?"":e.read_shift(i,d);return s&&(e.l+=4*l),o&&(e.l+=n),u.t=f,s||(u.raw="<t>"+u.t+"</t>",u.r=u.t),r=t,u}function Yr(e,t,n){if(n){if(n.biff>=2&&n.biff<=5)return e.read_shift(t,"cpstr");if(n.biff>=12)return e.read_shift(t,"dbcs-cont")}return 0===e.read_shift(1)?e.read_shift(t,"sbcs-cont"):e.read_shift(t,"dbcs-cont")}function qr(e,t,n){var r=e.read_shift(n&&2==n.biff?1:2);return 0===r?(e.l++,""):Yr(e,r,n)}function Kr(e,t,n){if(n.biff>5)return qr(e,0,n);var r=e.read_shift(1);return 0===r?(e.l++,""):e.read_shift(r,n.biff<=4||!e.lens?"cpstr":"sbcs-cont")}function Zr(e){var t=e.read_shift(4);return t>0?e.read_shift(t,"utf16le").replace(k,""):""}function Jr(e){return[e.read_shift(1),e.read_shift(1),e.read_shift(1),e.read_shift(1)]}function Qr(e,t){var n=Jr(e);return n[3]=0,n}function ei(e){return{r:e.read_shift(2),c:e.read_shift(2),ixfe:e.read_shift(2)}}function ti(e,t,n){var r=n.biff>8?4:2;return[e.read_shift(r),e.read_shift(r,"i"),e.read_shift(r,"i")]}function ni(e){return[e.read_shift(2),Zn(e)]}function ri(e){var t=e.read_shift(2),n=e.read_shift(2);return{s:{c:e.read_shift(2),r:t},e:{c:e.read_shift(2),r:n}}}function ii(e){var t=e.read_shift(2),n=e.read_shift(2);return{s:{c:e.read_shift(1),r:t},e:{c:e.read_shift(1),r:n}}}var ai=ii;function oi(e){e.l+=4;var t=e.read_shift(2),n=e.read_shift(2),r=e.read_shift(2);return e.l+=12,[n,t,r]}function si(e){e.l+=2,e.l+=e.read_shift(2)}var ci={0:si,4:si,5:si,6:si,7:function(e){return e.l+=4,e.cf=e.read_shift(2),{}},8:si,9:si,10:si,11:si,12:si,13:function(e){var t={};return e.l+=4,e.l+=16,t.fSharedNote=e.read_shift(2),e.l+=4,t},14:si,15:si,16:si,17:si,18:si,19:si,20:si,21:oi};function li(e,t){var n={BIFFVer:0,dt:0};switch(n.BIFFVer=e.read_shift(2),(t-=2)>=2&&(n.dt=e.read_shift(2),e.l-=2),n.BIFFVer){case 1536:case 1280:case 1024:case 768:case 512:case 2:case 7:break;default:if(t>6)throw new Error("Unexpected BIFF Ver "+n.BIFFVer)}return e.read_shift(t),n}function ui(e,t,n){var r=0;n&&2==n.biff||(r=e.read_shift(2));var i=e.read_shift(2);return n&&2==n.biff&&(r=1-(i>>15),i&=32767),[{Unsynced:1&r,DyZero:(2&r)>>1,ExAsc:(4&r)>>2,ExDsc:(8&r)>>3},i]}var di=Kr;function fi(e,t,n){var r=e.l+t,i=8!=n.biff&&n.biff?2:4,a=e.read_shift(i),o=e.read_shift(i),s=e.read_shift(2),c=e.read_shift(2);return e.l=r,{s:{r:a,c:s},e:{r:o,c:c}}}function hi(e,t,n){var r=ei(e);2!=n.biff&&9!=t||++e.l;var i=function(e){var t=e.read_shift(1);return 1===e.read_shift(1)?t:1===t}(e);return r.val=i,r.t=!0===i||!1===i?"b":"e",r}var pi=function(e,t,n){return 0===t?"":Kr(e,0,n)};function mi(e,t,n){var r,i=e.read_shift(2),a={fBuiltIn:1&i,fWantAdvise:i>>>1&1,fWantPict:i>>>2&1,fOle:i>>>3&1,fOleLink:i>>>4&1,cf:i>>>5&1023,fIcon:i>>>15&1};return 14849===n.sbcch&&(r=function(e,t,n){e.l+=4,t-=4;var r=e.l+t,i=jr(e,0,n),a=e.read_shift(2);if(a!==(r-=e.l))throw new Error("Malformed AddinUdf: padding = "+r+" != "+a);return e.l+=a,i}(e,t-2,n)),a.body=r||e.read_shift(t-2),"string"==typeof r&&(a.Name=r),a}function vi(e,t,n){var r=e.l+t,i=e.read_shift(2),a=e.read_shift(1),o=e.read_shift(1),s=e.read_shift(n&&2==n.biff?1:2),c=0;(!n||n.biff>=5)&&(5!=n.biff&&(e.l+=2),c=e.read_shift(2),5==n.biff&&(e.l+=2),e.l+=4);var l=Yr(e,o,n);32&i&&(l=vr[l.charCodeAt(0)]);var u=r-e.l;n&&2==n.biff&&--u;var d=r!=e.l&&0!==s&&u>0?function(e,t,n,r){var i,a=e.l+t,o=ro(e,r,n);return a!==e.l&&(i=no(e,a-e.l,o,n)),[o,i]}(e,u,n,s):[];return{chKey:a,Name:l,itab:c,rgce:d}}function gi(e,t,n){if(n.biff<8)return bi(e,0,n);if(!(n.biff>8)&&t==e[e.l]+(3==e[e.l+1]?1:0)+1)return bi(e,0,n);for(var r=[],i=e.l+t,a=e.read_shift(n.biff>8?4:2);0!=a--;)r.push(ti(e,n.biff,n));if(e.l!=i)throw new Error("Bad ExternSheet: "+e.l+" != "+i);return r}function bi(e,t,n){3==e[e.l+1]&&e[e.l]++;var r=jr(e,0,n);return 3==r.charCodeAt(0)?r.slice(1):r}function _i(e,t,n){var r=ai(e,6);switch(n.biff){case 2:e.l++,t-=7;break;case 3:case 4:e.l+=2,t-=8;break;default:e.l+=6,t-=12}return[r,lo(e,t,n)]}var yi={8:function(e,t){var n=e.l+t;e.l+=10;var r=e.read_shift(2);e.l+=4,e.l+=2,e.l+=2,e.l+=2,e.l+=4;var i=e.read_shift(1);return e.l+=i,e.l=n,{fmt:r}}};function xi(e,t,n){if(!n.cellStyles)return yn(e,t);var r=n&&n.biff>=12?4:2,i=e.read_shift(r),a=e.read_shift(r),o=e.read_shift(r),s=e.read_shift(r),c=e.read_shift(2);2==r&&(e.l+=2);var l={s:i,e:a,w:o,ixfe:s,flags:c};return(n.biff>=5||!n.biff)&&(l.level=c>>8&7),l}var Ai=ei,wi=Wr,Ei=qr,Ti=[2,3,48,49,131,139,140,245],Si=function(){var e={1:437,2:850,3:1252,4:1e4,100:852,101:866,102:865,103:861,104:895,105:620,106:737,107:857,120:950,121:949,122:936,123:932,124:874,125:1255,126:1256,150:10007,151:10029,152:10006,200:1250,201:1251,202:1254,203:1253,0:20127,8:865,9:437,10:850,11:437,13:437,14:850,15:437,16:850,17:437,18:850,19:932,20:850,21:437,22:850,23:865,24:437,25:437,26:850,27:437,28:863,29:850,31:852,34:852,35:852,36:860,37:850,38:866,55:850,64:852,77:936,78:949,79:950,80:874,87:1252,88:1252,89:1252,108:863,134:737,135:852,136:857,204:1257,255:16969},n=Me({1:437,2:850,3:1252,4:1e4,100:852,101:866,102:865,103:861,104:895,105:620,106:737,107:857,120:950,121:949,122:936,123:932,124:874,125:1255,126:1256,150:10007,151:10029,152:10006,200:1250,201:1251,202:1254,203:1253,0:20127});function a(n,r){var i=r||{};i.dateNF||(i.dateNF="yyyymmdd");var a=zn(function(n,r){var i=[],a=w(1);switch(r.type){case"base64":a=T(_(n));break;case"binary":a=T(n);break;case"buffer":case"array":a=n}_n(a,0);var o=a.read_shift(1),s=!!(136&o),c=!1,l=!1;switch(o){case 2:case 3:case 131:case 139:case 245:break;case 48:case 49:c=!0,s=!0;break;case 140:l=!0;break;default:throw new Error("DBF Unsupported Version: "+o.toString(16))}var u=0,d=521;2==o&&(u=a.read_shift(2)),a.l+=3,2!=o&&(u=a.read_shift(4)),u>1048576&&(u=1e6),2!=o&&(d=a.read_shift(2));var f=a.read_shift(2),h=r.codepage||1252;2!=o&&(a.l+=16,a.read_shift(1),0!==a[a.l]&&(h=e[a[a.l]]),a.l+=1,a.l+=2),l&&(a.l+=36);for(var p=[],m={},v=Math.min(a.length,2==o?521:d-10-(c?264:0)),g=l?32:11;a.l<v&&13!=a[a.l];)switch((m={}).name=(void 0!==t?t.utils.decode(h,a.slice(a.l,a.l+g)):S(a.slice(a.l,a.l+g))).replace(/[\u0000\r\n].*$/g,""),a.l+=g,m.type=String.fromCharCode(a.read_shift(1)),2==o||l||(m.offset=a.read_shift(4)),m.len=a.read_shift(1),2==o&&(m.offset=a.read_shift(2)),m.dec=a.read_shift(1),m.name.length&&p.push(m),2!=o&&(a.l+=l?13:14),m.type){case"B":c&&8==m.len||!r.WTF||console.log("Skipping "+m.name+":"+m.type);break;case"G":case"P":r.WTF&&console.log("Skipping "+m.name+":"+m.type);break;case"+":case"0":case"@":case"C":case"D":case"F":case"I":case"L":case"M":case"N":case"O":case"T":case"Y":break;default:throw new Error("Unknown Field Type: "+m.type)}if(13!==a[a.l]&&(a.l=d-1),13!==a.read_shift(1))throw new Error("DBF Terminator not found "+a.l+" "+a[a.l]);a.l=d;var b=0,y=0;for(i[0]=[],y=0;y!=p.length;++y)i[0][y]=p[y].name;for(;u-- >0;)if(42!==a[a.l])for(++a.l,i[++b]=[],y=0,y=0;y!=p.length;++y){var x=a.slice(a.l,a.l+p[y].len);a.l+=p[y].len,_n(x,0);var A=void 0!==t?t.utils.decode(h,x):S(x);switch(p[y].type){case"C":A.trim().length&&(i[b][y]=A.replace(/\s+$/,""));break;case"D":8===A.length?i[b][y]=new Date(+A.slice(0,4),+A.slice(4,6)-1,+A.slice(6,8)):i[b][y]=A;break;case"F":i[b][y]=parseFloat(A.trim());break;case"+":case"I":i[b][y]=l?2147483648^x.read_shift(-4,"i"):x.read_shift(4,"i");break;case"L":switch(A.trim().toUpperCase()){case"Y":case"T":i[b][y]=!0;break;case"N":case"F":i[b][y]=!1;break;case"":case"?":break;default:throw new Error("DBF Unrecognized L:|"+A+"|")}break;case"M":if(!s)throw new Error("DBF Unexpected MEMO for type "+o.toString(16));i[b][y]="##MEMO##"+(l?parseInt(A.trim(),10):x.read_shift(4));break;case"N":(A=A.replace(/\u0000/g,"").trim())&&"."!=A&&(i[b][y]=+A||0);break;case"@":i[b][y]=new Date(x.read_shift(-8,"f")-621356832e5);break;case"T":i[b][y]=new Date(864e5*(x.read_shift(4)-2440588)+x.read_shift(4));break;case"Y":i[b][y]=x.read_shift(4,"i")/1e4+x.read_shift(4,"i")/1e4*Math.pow(2,32);break;case"O":i[b][y]=-x.read_shift(-8,"f");break;case"B":if(c&&8==p[y].len){i[b][y]=x.read_shift(8,"f");break}case"G":case"P":x.l+=p[y].len;break;case"0":if("_NullFlags"===p[y].name)break;default:throw new Error("DBF Unsupported data type "+p[y].type)}}else a.l+=f;if(2!=o&&a.l<a.length&&26!=a[a.l++])throw new Error("DBF EOF Marker missing "+(a.l-1)+" of "+a.length+" "+a[a.l-1].toString(16));return r&&r.sheetRows&&(i=i.slice(0,r.sheetRows)),r.DBF=p,i}(n,i),i);return a["!cols"]=i.DBF.map((function(e){return{wch:e.len,DBF:e}})),delete i.DBF,a}var o={B:8,C:250,L:1,D:8,"?":0,"":0};return{to_workbook:function(e,t){try{var n=Fn(a(e,t),t);return n.bookType="dbf",n}catch(e){if(t&&t.WTF)throw e}return{SheetNames:[],Sheets:{}}},to_sheet:a,from_sheet:function(a,s){var l=s||{},u=r;if(+l.codepage>=0&&c(+l.codepage),"string"==l.type)throw new Error("Cannot write DBF to JS string");var d=wn(),f=rc(a,{header:1,raw:!0,cellDates:!0}),h=f[0],p=f.slice(1),m=a["!cols"]||[],v=0,g=0,b=0,_=1;for(v=0;v<h.length;++v)if(((m[v]||{}).DBF||{}).name)h[v]=m[v].DBF.name,++b;else if(null!=h[v]){if(++b,"number"==typeof h[v]&&(h[v]=h[v].toString(10)),"string"!=typeof h[v])throw new Error("DBF Invalid column name "+h[v]+" |"+typeof h[v]+"|");if(h.indexOf(h[v])!==v)for(g=0;g<1024;++g)if(-1==h.indexOf(h[v]+"_"+g)){h[v]+="_"+g;break}}var y=Nn(a["!ref"]),x=[],A=[],w=[];for(v=0;v<=y.e.c-y.s.c;++v){var E="",T="",S=0,C=[];for(g=0;g<p.length;++g)null!=p[g][v]&&C.push(p[g][v]);if(0!=C.length&&null!=h[v]){for(g=0;g<C.length;++g){switch(typeof C[g]){case"number":T="B";break;case"string":default:T="C";break;case"boolean":T="L";break;case"object":T=C[g]instanceof Date?"D":"C"}S=Math.max(S,(void 0!==t&&"string"==typeof C[g]?t.utils.encode(i,C[g]):String(C[g])).length),E=E&&E!=T?"C":T}S>250&&(S=250),"C"==(T=((m[v]||{}).DBF||{}).type)&&m[v].DBF.len>S&&(S=m[v].DBF.len),"B"==E&&"N"==T&&(E="N",w[v]=m[v].DBF.dec,S=m[v].DBF.len),A[v]="C"==E||"N"==T?S:o[E]||0,_+=A[v],x[v]=E}else x[v]="?"}var M=d.next(32);for(M.write_shift(4,318902576),M.write_shift(4,p.length),M.write_shift(2,296+32*b),M.write_shift(2,_),v=0;v<4;++v)M.write_shift(4,0);var k=+n[r]||3;for(M.write_shift(4,0|k<<8),e[k]!=+l.codepage&&(l.codepage&&console.error("DBF Unsupported codepage "+r+", using 1252"),r=1252),v=0,g=0;v<h.length;++v)if(null!=h[v]){var R=d.next(32),L=(h[v].slice(-10)+"\0\0\0\0\0\0\0\0\0\0\0").slice(0,11);R.write_shift(1,L,"sbcs"),R.write_shift(1,"?"==x[v]?"C":x[v],"sbcs"),R.write_shift(4,g),R.write_shift(1,A[v]||o[x[v]]||0),R.write_shift(1,w[v]||0),R.write_shift(1,2),R.write_shift(4,0),R.write_shift(1,0),R.write_shift(4,0),R.write_shift(4,0),g+=A[v]||o[x[v]]||0}var O=d.next(264);for(O.write_shift(4,13),v=0;v<65;++v)O.write_shift(4,0);for(v=0;v<p.length;++v){var I=d.next(_);for(I.write_shift(1,0),g=0;g<h.length;++g)if(null!=h[g])switch(x[g]){case"L":I.write_shift(1,null==p[v][g]?63:p[v][g]?84:70);break;case"B":I.write_shift(8,p[v][g]||0,"f");break;case"N":var P="0";for("number"==typeof p[v][g]&&(P=p[v][g].toFixed(w[g]||0)),P.length>A[g]&&(P=P.slice(0,A[g])),b=0;b<A[g]-P.length;++b)I.write_shift(1,32);I.write_shift(1,P,"sbcs");break;case"D":p[v][g]?(I.write_shift(4,("0000"+p[v][g].getFullYear()).slice(-4),"sbcs"),I.write_shift(2,("00"+(p[v][g].getMonth()+1)).slice(-2),"sbcs"),I.write_shift(2,("00"+p[v][g].getDate()).slice(-2),"sbcs")):I.write_shift(8,"00000000","sbcs");break;case"C":var D=I.l,N=String(null!=p[v][g]?p[v][g]:"").slice(0,A[g]);for(I.write_shift(1,N,"cpstr"),D+=A[g]-I.l,b=0;b<D;++b)I.write_shift(1,32)}}return r=u,d.next(1).write_shift(1,26),d.end()}}}(),Ci=function(){var e={AA:"À",BA:"Á",CA:"Â",DA:195,HA:"Ä",JA:197,AE:"È",BE:"É",CE:"Ê",HE:"Ë",AI:"Ì",BI:"Í",CI:"Î",HI:"Ï",AO:"Ò",BO:"Ó",CO:"Ô",DO:213,HO:"Ö",AU:"Ù",BU:"Ú",CU:"Û",HU:"Ü",Aa:"à",Ba:"á",Ca:"â",Da:227,Ha:"ä",Ja:229,Ae:"è",Be:"é",Ce:"ê",He:"ë",Ai:"ì",Bi:"í",Ci:"î",Hi:"ï",Ao:"ò",Bo:"ó",Co:"ô",Do:245,Ho:"ö",Au:"ù",Bu:"ú",Cu:"û",Hu:"ü",KC:"Ç",Kc:"ç",q:"æ",z:"œ",a:"Æ",j:"Œ",DN:209,Dn:241,Hy:255,S:169,c:170,R:174,"B ":180,0:176,1:177,2:178,3:179,5:181,6:182,7:183,Q:185,k:186,b:208,i:216,l:222,s:240,y:248,"!":161,'"':162,"#":163,"(":164,"%":165,"'":167,"H ":168,"+":171,";":187,"<":188,"=":189,">":190,"?":191,"{":223},n=new RegExp("N("+Ce(e).join("|").replace(/\|\|\|/,"|\\||").replace(/([?()+])/g,"\\$1")+"|\\|)","gm"),r=function(t,n){var r=e[n];return"number"==typeof r?m(r):r},i=function(e,t,n){var r=t.charCodeAt(0)-32<<4|n.charCodeAt(0)-48;return 59==r?e:m(r)};function a(e,a){var o,s=e.split(/[\n\r]+/),l=-1,u=-1,d=0,f=0,h=[],p=[],m=null,v={},g=[],b=[],_=[],y=0,x={Workbook:{WBProps:{},Names:[]}};for(+a.codepage>=0&&c(+a.codepage);d!==s.length;++d){y=0;var A,w=s[d].trim().replace(/\x1B([\x20-\x2F])([\x30-\x3F])/g,i).replace(n,r),E=w.replace(/;;/g,"\0").split(";").map((function(e){return e.replace(/\u0000/g,";")})),T=E[0];if(w.length>0)switch(T){case"ID":case"E":case"B":case"W":break;case"O":for(f=1;f<E.length;++f)if("V"===E[f].charAt(0)){var S=parseInt(E[f].slice(1),10);S>=1&&S<=4&&(x.Workbook.WBProps.date1904=!0)}break;case"P":"P"===E[1].charAt(0)&&p.push(w.slice(3).replace(/;;/g,";"));break;case"NN":var C={Sheet:0};for(f=1;f<E.length;++f)switch(E[f].charAt(0)){case"N":C.Name=E[f].slice(1);break;case"E":C.Ref=(a&&a.sheet||"Sheet1")+"!"+La(E[f].slice(1))}x.Workbook.Names.push(C);break;case"C":var M=!1,k=!1,R=!1,L=!1,O=-1,I=-1,P="",D="z";for(f=1;f<E.length;++f)switch(E[f].charAt(0)){case"A":case"G":break;case"X":u=parseInt(E[f].slice(1),10)-1,k=!0;break;case"Y":for(l=parseInt(E[f].slice(1),10)-1,k||(u=0),o=h.length;o<=l;++o)h[o]=[];break;case"K":'"'===(A=E[f].slice(1)).charAt(0)?(A=A.slice(1,A.length-1),D="s"):"TRUE"===A||"FALSE"===A?(A="TRUE"===A,D="b"):isNaN(Ge(A))?isNaN(je(A).getDate())||(A=Be(A),D="d",a.cellDates||(D="n",A=Re(A,x.Workbook.WBProps.date1904))):(A=Ge(A),D="n",null!==m&&me(m)&&a.cellDates&&(A=Pe(x.Workbook.WBProps.date1904?A+1462:A),D="d")),void 0!==t&&"string"==typeof A&&"string"!=(a||{}).type&&(a||{}).codepage&&(A=t.utils.decode(a.codepage,A)),M=!0;break;case"E":L=!0,P=La(E[f].slice(1),{r:l,c:u});break;case"S":R=!0;break;case"R":O=parseInt(E[f].slice(1),10)-1;break;case"C":I=parseInt(E[f].slice(1),10)-1;break;default:if(a&&a.WTF)throw new Error("SYLK bad record "+w)}if(M&&(h[l][u]?(h[l][u].t=D,h[l][u].v=A):h[l][u]={t:D,v:A},m&&(h[l][u].z=m),!1!==a.cellText&&m&&(h[l][u].w=be(h[l][u].z,h[l][u].v,{date1904:x.Workbook.WBProps.date1904})),m=null),R){if(L)throw new Error("SYLK shared formula cannot have own formula");var N=O>-1&&h[O][I];if(!N||!N[1])throw new Error("SYLK shared formula cannot find base");P=Pa(N[1],{r:l-O,c:u-I})}P&&(h[l][u]?h[l][u].f=P:h[l][u]={t:"n",f:P});break;case"F":var U=0;for(f=1;f<E.length;++f)switch(E[f].charAt(0)){case"X":u=parseInt(E[f].slice(1),10)-1,++U;break;case"Y":for(l=parseInt(E[f].slice(1),10)-1,o=h.length;o<=l;++o)h[o]=[];break;case"M":y=parseInt(E[f].slice(1),10)/20;break;case"F":case"G":case"S":case"D":case"N":break;case"P":m=p[parseInt(E[f].slice(1),10)];break;case"W":for(_=E[f].slice(1).split(" "),o=parseInt(_[0],10);o<=parseInt(_[1],10);++o)y=parseInt(_[2],10),b[o-1]=0===y?{hidden:!0}:{wch:y};break;case"C":b[u=parseInt(E[f].slice(1),10)-1]||(b[u]={});break;case"R":g[l=parseInt(E[f].slice(1),10)-1]||(g[l]={}),y>0?(g[l].hpt=y,g[l].hpx=da(y)):0===y&&(g[l].hidden=!0);break;default:if(a&&a.WTF)throw new Error("SYLK bad record "+w)}U<1&&(m=null);break;default:if(a&&a.WTF)throw new Error("SYLK bad record "+w)}}return g.length>0&&(v["!rows"]=g),b.length>0&&(v["!cols"]=b),b.forEach((function(e){ca(e)})),a&&a.sheetRows&&(h=h.slice(0,a.sheetRows)),[h,v,x]}function o(e,t,n,r){var i="C;Y"+(n+1)+";X"+(r+1)+";K";switch(e.t){case"n":i+=e.v||0,e.f&&!e.F&&(i+=";E"+Ia(e.f,{r:n,c:r}));break;case"b":i+=e.v?"TRUE":"FALSE";break;case"e":i+=e.w||e.v;break;case"d":i+='"'+(e.w||e.v)+'"';break;case"s":i+='"'+(null==e.v?"":String(e.v)).replace(/"/g,"").replace(/;/g,";;")+'"'}return i}return e["|"]=254,{to_workbook:function(e,t){var n=function(e,t){switch(t.type){case"base64":return a(_(e),t);case"binary":return a(e,t);case"buffer":return a(y&&Buffer.isBuffer(e)?e.toString("binary"):S(e),t);case"array":return a(ze(e),t)}throw new Error("Unrecognized type "+t.type)}(e,t),r=n[0],i=n[1],o=n[2],s=He(t);s.date1904=(((o||{}).Workbook||{}).WBProps||{}).date1904;var c=zn(r,s);Ce(i).forEach((function(e){c[e]=i[e]}));var l=Fn(c,t);return Ce(o).forEach((function(e){l[e]=o[e]})),l.bookType="sylk",l},from_sheet:function(e,t,n){var r,i,a=["ID;PSheetJS;N;E"],s=[],c=Nn(e["!ref"]),l=null!=e["!data"],u="\r\n",d=(((n||{}).Workbook||{}).WBProps||{}).date1904;a.push("P;PGeneral"),a.push("F;P0;DG0G8;M255"),e["!cols"]&&(i=a,e["!cols"].forEach((function(e,t){var n="F;W"+(t+1)+" "+(t+1)+" ";e.hidden?n+="0":("number"!=typeof e.width||e.wpx||(e.wpx=ra(e.width)),"number"!=typeof e.wpx||e.wch||(e.wch=ia(e.wpx)),"number"==typeof e.wch&&(n+=Math.round(e.wch)))," "!=n.charAt(n.length-1)&&i.push(n)}))),e["!rows"]&&function(e,t){t.forEach((function(t,n){var r="F;";t.hidden?r+="M0;":t.hpt?r+="M"+20*t.hpt+";":t.hpx&&(r+="M"+20*ua(t.hpx)+";"),r.length>2&&e.push(r+"R"+(n+1))}))}(a,e["!rows"]),a.push("B;Y"+(c.e.r-c.s.r+1)+";X"+(c.e.c-c.s.c+1)+";D"+[c.s.c,c.s.r,c.e.c,c.e.r].join(" ")),a.push("O;L;D;B"+(d?";V4":"")+";K47;G100 0.001");for(var f=c.s.r;f<=c.e.r;++f)if(!l||e["!data"][f]){for(var h=[],p=c.s.c;p<=c.e.c;++p)(r=l?e["!data"][f][p]:e[Ln(p)+kn(f)])&&(null!=r.v||r.f&&!r.F)&&h.push(o(r,0,f,p));s.push(h.join(u))}return a.join(u)+u+s.join(u)+u+"E"+u}}}(),Mi=function(){function e(e,t){for(var n=e.split("\n"),r=-1,i=-1,a=0,o=[];a!==n.length;++a)if("BOT"!==n[a].trim()){if(!(r<0)){for(var s=n[a].trim().split(","),c=s[0],l=s[1],u=n[++a]||"";1&(u.match(/["]/g)||[]).length&&a<n.length-1;)u+="\n"+n[++a];switch(u=u.trim(),+c){case-1:if("BOT"===u){o[++r]=[],i=0;continue}if("EOD"!==u)throw new Error("Unrecognized DIF special command "+u);break;case 0:"TRUE"===u?o[r][i]=!0:"FALSE"===u?o[r][i]=!1:isNaN(Ge(l))?isNaN(je(l).getDate())?o[r][i]=l:o[r][i]=Be(l):o[r][i]=Ge(l),++i;break;case 1:(u=(u=u.slice(1,u.length-1)).replace(/""/g,'"'))&&u.match(/^=".*"$/)&&(u=u.slice(2,-1)),o[r][i++]=""!==u?u:null}if("EOD"===u)break}}else o[++r]=[],i=0;return t&&t.sheetRows&&(o=o.slice(0,t.sheetRows)),o}function t(t,n){return zn(function(t,n){switch(n.type){case"base64":return e(_(t),n);case"binary":return e(t,n);case"buffer":return e(y&&Buffer.isBuffer(t)?t.toString("binary"):S(t),n);case"array":return e(ze(t),n)}throw new Error("Unrecognized type "+n.type)}(t,n),n)}function n(e,t){return"0,"+String(e)+"\r\n"+t}function r(e){return'1,0\r\n"'+e.replace(/"/g,'""')+'"'}return{to_workbook:function(e,n){var r=Fn(t(e,n),n);return r.bookType="dif",r},to_sheet:t,from_sheet:function(e){for(var t=Nn(e["!ref"]),i=null!=e["!data"],a=['TABLE\r\n0,1\r\n"sheetjs"\r\n',"VECTORS\r\n0,"+(t.e.r-t.s.r+1)+'\r\n""\r\n',"TUPLES\r\n0,"+(t.e.c-t.s.c+1)+'\r\n""\r\n','DATA\r\n0,0\r\n""\r\n'],o=t.s.r;o<=t.e.r;++o){for(var s=i?e["!data"][o]:[],c="-1,0\r\nBOT\r\n",l=t.s.c;l<=t.e.c;++l){var u=i?s&&s[l]:e[In({r:o,c:l})];if(null!=u){switch(u.t){case"n":null!=u.w?c+="0,"+u.w+"\r\nV":null!=u.v?c+=n(u.v,"V"):null==u.f||u.F?c+='1,0\r\n""':c+=r("="+u.f);break;case"b":c+=u.v?n(1,"TRUE"):n(0,"FALSE");break;case"s":c+=r(isNaN(+u.v)?u.v:'="'+u.v+'"');break;case"d":u.w||(u.w=be(u.z||z[14],Re(Be(u.v)))),c+=n(u.w,"V");break;default:c+='1,0\r\n""'}c+="\r\n"}else c+='1,0\r\n""\r\n'}a.push(c)}return a.join("")+"-1,0\r\nEOD"}}}(),ki=function(){function e(e){return e.replace(/\\/g,"\\b").replace(/:/g,"\\c").replace(/\n/g,"\\n")}function t(e,t){return zn(function(e,t){for(var n=e.split("\n"),r=-1,i=-1,a=0,o=[];a!==n.length;++a){var s=n[a].trim().split(":");if("cell"===s[0]){var c=On(s[1]);if(o.length<=c.r)for(r=o.length;r<=c.r;++r)o[r]||(o[r]=[]);switch(r=c.r,i=c.c,s[2]){case"t":o[r][i]=s[3].replace(/\\b/g,"\\").replace(/\\c/g,":").replace(/\\n/g,"\n");break;case"v":o[r][i]=+s[3];break;case"vtf":var l=s[s.length-1];case"vtc":"nl"===s[3]?o[r][i]=!!+s[4]:o[r][i]=+s[4],"vtf"==s[2]&&(o[r][i]=[o[r][i],l])}}}return t&&t.sheetRows&&(o=o.slice(0,t.sheetRows)),o}(e,t),t)}var n=["socialcalc:version:1.5","MIME-Version: 1.0","Content-Type: multipart/mixed; boundary=SocialCalcSpreadsheetControlSave"].join("\n"),r=["--SocialCalcSpreadsheetControlSave","Content-type: text/plain; charset=UTF-8"].join("\n")+"\n",i=["# SocialCalc Spreadsheet Control Save","part:sheet"].join("\n"),a="--SocialCalcSpreadsheetControlSave--";function o(t){if(!t||!t["!ref"])return"";for(var n,r=[],i=[],a="",o=Pn(t["!ref"]),s=null!=t["!data"],c=o.s.r;c<=o.e.r;++c)for(var l=o.s.c;l<=o.e.c;++l)if(a=In({r:c,c:l}),(n=s?(t["!data"][c]||[])[l]:t[a])&&null!=n.v&&"z"!==n.t){switch(i=["cell",a,"t"],n.t){case"s":case"str":i.push(e(n.v));break;case"n":n.f?(i[2]="vtf",i[3]="n",i[4]=n.v,i[5]=e(n.f)):(i[2]="v",i[3]=n.v);break;case"b":i[2]="vt"+(n.f?"f":"c"),i[3]="nl",i[4]=n.v?"1":"0",i[5]=e(n.f||(n.v?"TRUE":"FALSE"));break;case"d":var u=Re(Be(n.v));i[2]="vtc",i[3]="nd",i[4]=""+u,i[5]=n.w||be(n.z||z[14],u);break;case"e":continue}r.push(i.join(":"))}return r.push("sheet:c:"+(o.e.c-o.s.c+1)+":r:"+(o.e.r-o.s.r+1)+":tvf:1"),r.push("valueformat:1:text-wiki"),r.join("\n")}return{to_workbook:function(e,n){return Fn(t(e,n),n)},to_sheet:t,from_sheet:function(e){return[n,r,i,r,o(e),a].join("\n")}}}(),Ri=function(){function e(e,t,n,r,i){i.raw?t[n][r]=e:""===e||("TRUE"===e?t[n][r]=!0:"FALSE"===e?t[n][r]=!1:isNaN(Ge(e))?isNaN(je(e).getDate())?t[n][r]=e:t[n][r]=Be(e):t[n][r]=Ge(e))}var n={44:",",9:"\t",59:";",124:"|"},r={44:3,9:2,59:1,124:0};function i(e){for(var t={},i=!1,a=0,o=0;a<e.length;++a)34==(o=e.charCodeAt(a))?i=!i:!i&&o in n&&(t[o]=(t[o]||0)+1);for(a in o=[],t)Object.prototype.hasOwnProperty.call(t,a)&&o.push([t[a],a]);if(!o.length)for(a in t=r)Object.prototype.hasOwnProperty.call(t,a)&&o.push([t[a],a]);return o.sort((function(e,t){return e[0]-t[0]||r[e[1]]-r[t[1]]})),n[o.pop()[1]]||44}function a(e,t){var n=t||{},r="";null!=v&&null==n.dense&&(n.dense=v);var a={};n.dense&&(a["!data"]=[]);var o={s:{c:0,r:0},e:{c:0,r:0}};"sep="==e.slice(0,4)?13==e.charCodeAt(5)&&10==e.charCodeAt(6)?(r=e.charAt(4),e=e.slice(7)):13==e.charCodeAt(5)||10==e.charCodeAt(5)?(r=e.charAt(4),e=e.slice(6)):r=i(e.slice(0,1024)):r=n&&n.FS?n.FS:i(e.slice(0,1024));var s,c,l=0,u=0,d=0,f=0,h=0,p=r.charCodeAt(0),m=!1,g=0,b=e.charCodeAt(0),_=null!=n.dateNF?(c=(c="number"==typeof(s=n.dateNF)?z[s]:s).replace(xe,"(\\d+)"),new RegExp("^"+c+"$")):null;function y(){var t=e.slice(f,h);"\r"==t.slice(-1)&&(t=t.slice(0,-1));var r={};if('"'==t.charAt(0)&&'"'==t.charAt(t.length-1)&&(t=t.slice(1,-1).replace(/""/g,'"')),0===t.length?r.t="z":n.raw||0===t.trim().length?(r.t="s",r.v=t):61==t.charCodeAt(0)?34==t.charCodeAt(1)&&34==t.charCodeAt(t.length-1)?(r.t="s",r.v=t.slice(2,-1).replace(/""/g,'"')):1!=t.length?(r.t="n",r.f=t.slice(1)):(r.t="s",r.v=t):"TRUE"==t?(r.t="b",r.v=!0):"FALSE"==t?(r.t="b",r.v=!1):isNaN(d=Ge(t))?!isNaN((d=je(t)).getDate())||_&&t.match(_)?(r.z=n.dateNF||z[14],_&&t.match(_)&&(t=function(e,t,n){var r=-1,i=-1,a=-1,o=-1,s=-1,c=-1;(t.match(xe)||[]).forEach((function(e,t){var l=parseInt(n[t+1],10);switch(e.toLowerCase().charAt(0)){case"y":r=l;break;case"d":a=l;break;case"h":o=l;break;case"s":c=l;break;case"m":o>=0?s=l:i=l}})),c>=0&&-1==s&&i>=0&&(s=i,i=-1);var l=(""+(r>=0?r:(new Date).getFullYear())).slice(-4)+"-"+("00"+(i>=1?i:1)).slice(-2)+"-"+("00"+(a>=1?a:1)).slice(-2);7==l.length&&(l="0"+l),8==l.length&&(l="20"+l);var u=("00"+(o>=0?o:0)).slice(-2)+":"+("00"+(s>=0?s:0)).slice(-2)+":"+("00"+(c>=0?c:0)).slice(-2);return-1==o&&-1==s&&-1==c?l:-1==r&&-1==i&&-1==a?u:l+"T"+u}(0,n.dateNF,t.match(_)||[]),d=Be(t,1)),n.cellDates?(r.t="d",r.v=d):(r.t="n",r.v=Re(d)),!1!==n.cellText&&(r.w=be(r.z,r.v instanceof Date?Re(r.v):r.v)),n.cellNF||delete r.z):(r.t="s",r.v=t):(r.t="n",!1!==n.cellText&&(r.w=t),r.v=d),"z"==r.t||(n.dense?(a["!data"][l]||(a["!data"][l]=[]),a["!data"][l][u]=r):a[In({c:u,r:l})]=r),f=h+1,b=e.charCodeAt(f),o.e.c<u&&(o.e.c=u),o.e.r<l&&(o.e.r=l),g==p)++u;else if(u=0,++l,n.sheetRows&&n.sheetRows<=l)return!0}e:for(;h<e.length;++h)switch(g=e.charCodeAt(h)){case 34:34===b&&(m=!m);break;case 13:if(m)break;10==e.charCodeAt(h+1)&&++h;case p:case 10:if(!m&&y())break e}return h-f>0&&y(),a["!ref"]=Dn(o),a}function o(n,r){var i="",o="string"==r.type?[0,0,0,0]:Js(n,r);switch(r.type){case"base64":i=_(n);break;case"binary":case"string":i=n;break;case"buffer":i=65001==r.codepage?n.toString("utf8"):r.codepage&&void 0!==t?t.utils.decode(r.codepage,n):y&&Buffer.isBuffer(n)?n.toString("binary"):S(n);break;case"array":i=ze(n);break;default:throw new Error("Unrecognized type "+r.type)}return 239==o[0]&&187==o[1]&&191==o[2]?i=Et(i.slice(3)):"string"!=r.type&&"buffer"!=r.type&&65001==r.codepage?i=Et(i):"binary"==r.type&&void 0!==t&&r.codepage&&(i=t.utils.decode(r.codepage,t.utils.encode(28591,i))),"socialcalc:version:"==i.slice(0,19)?ki.to_sheet("string"==r.type?i:Et(i),r):function(t,n){return n&&n.PRN?n.FS||"sep="==t.slice(0,4)||t.indexOf("\t")>=0||t.indexOf(",")>=0||t.indexOf(";")>=0?a(t,n):zn(function(t,n){var r=n||{},i=[];if(!t||0===t.length)return i;for(var a=t.split(/[\r\n]/),o=a.length-1;o>=0&&0===a[o].length;)--o;for(var s=10,c=0,l=0;l<=o;++l)-1==(c=a[l].indexOf(" "))?c=a[l].length:c++,s=Math.max(s,c);for(l=0;l<=o;++l){i[l]=[];var u=0;for(e(a[l].slice(0,s).trim(),i,l,u,r),u=1;u<=(a[l].length-s)/10+1;++u)e(a[l].slice(s+10*(u-1),s+10*u).trim(),i,l,u,r)}return r.sheetRows&&(i=i.slice(0,r.sheetRows)),i}(t,n),n):a(t,n)}(i,r)}return{to_workbook:function(e,t){return Fn(o(e,t),t)},to_sheet:o,from_sheet:function(e){for(var t,n=[],r=Nn(e["!ref"]),i=null!=e["!data"],a=r.s.r;a<=r.e.r;++a){for(var o=[],s=r.s.c;s<=r.e.c;++s){var c=In({r:a,c:s});if((t=i?(e["!data"][a]||[])[s]:e[c])&&null!=t.v){for(var l=(t.w||(Un(t),t.w)||"").slice(0,10);l.length<10;)l+=" ";o.push(l+(0===s?" ":""))}else o.push("          ")}n.push(o.join(""))}return n.join("\n")}}}(),Li=function(){function e(e,t,n){if(e){_n(e,e.l||0);for(var r=n.Enum||b;e.l<e.length;){var i=e.read_shift(2),a=r[i]||r[65535],o=e.read_shift(2),s=e.l+o,c=a.f&&a.f(e,o,n);if(e.l=s,t(c,a,i))return}}}function t(t,n){if(!t)return t;var r=n||{};null!=v&&null==r.dense&&(r.dense=v);var i={},a="Sheet1",o="",s=0,c={},l=[],u=[],d=[];r.dense&&(d=i["!data"]=[]);var f={s:{r:0,c:0},e:{r:0,c:0}},h=r.sheetRows||0;if(81==t[4]&&80==t[5]&&87==t[6])return function(e,t){_n(e,0);var n=t||{};null!=v&&null==n.dense&&(n.dense=v);var r={};n.dense&&(r["!data"]=[]);var i=[],a="",o={s:{r:-1,c:-1},e:{r:-1,c:-1}},s=0,c=0,l=0,u=0,d={SheetNames:[],Sheets:{}};e:for(;e.l<e.length;){var f=e.read_shift(2),h=e.read_shift(2),p=e.slice(e.l,e.l+h);switch(_n(p,0),f){case 1:if(962023505!=p.read_shift(4))throw"Bad QPW9 BOF!";break;case 2:break e;case 1025:case 1026:case 1032:default:break;case 1031:for(p.l+=12;p.l<p.length;)s=p.read_shift(2),c=p.read_shift(1),i.push(p.read_shift(s,"cstr"));break;case 1537:var m=p.read_shift(2);r={},n.dense&&(r["!data"]=[]),o.s.c=p.read_shift(2),o.e.c=p.read_shift(2),o.s.r=p.read_shift(4),o.e.r=p.read_shift(4),p.l+=4,p.l+2<p.length&&(s=p.read_shift(2),c=p.read_shift(1),a=0==s?"":p.read_shift(s,"cstr")),a||(a=Ln(m));break;case 1538:if(o.s.c>255||o.s.r>999999)break;o.e.c<o.s.c&&(o.e.c=o.s.c),o.e.r<o.s.r&&(o.e.r=o.s.r),r["!ref"]=Dn(o),lc(d,r,a);break;case 2561:l=p.read_shift(2),o.e.c<l&&(o.e.c=l),o.s.c>l&&(o.s.c=l),u=p.read_shift(4),o.s.r>u&&(o.s.r=u),u=p.read_shift(4),o.e.r<u&&(o.e.r=u);break;case 3073:u=p.read_shift(4),s=p.read_shift(4),o.s.r>u&&(o.s.r=u),o.e.r<u+s-1&&(o.e.r=u+s-1);for(var g=Ln(l);p.l<p.length;){var b={t:"z"},_=p.read_shift(1);128&_&&(p.l+=2);var y=64&_?p.read_shift(2)-1:0;switch(31&_){case 1:break;case 2:b={t:"n",v:p.read_shift(2)};break;case 3:b={t:"n",v:p.read_shift(2,"i")};break;case 5:b={t:"n",v:p.read_shift(8,"f")};break;case 7:b={t:"s",v:i[c=p.read_shift(4)-1]};break;case 8:b={t:"n",v:p.read_shift(8,"f")},p.l+=2,p.l+=4;break;default:throw"Unrecognized QPW cell type "+(31&_)}var x=0;if(32&_)switch(31&_){case 2:case 7:x=p.read_shift(2);break;case 3:x=p.read_shift(2,"i");break;default:throw"Unsupported delta for QPW cell type "+(31&_)}for((n.sheetStubs||"z"!=b.t)&&(null!=r["!data"]?(r["!data"][u]||(r["!data"][u]=[]),r["!data"][u][l]=b):r[g+kn(u)]=b),++u,--s;y-- >0&&s>=0;){if(32&_)switch(31&_){case 2:b={t:"n",v:b.v+x&65535};break;case 3:(b={t:"n",v:b.v+x&65535}).v>32767&&(b.v-=65536);break;case 7:b={t:"s",v:i[c=c+x>>>0]};break;default:throw"Cannot apply delta for QPW cell type "+(31&_)}else switch(31&_){case 1:b={t:"z"};break;case 2:b={t:"n",v:p.read_shift(2)};break;case 7:b={t:"s",v:i[c=p.read_shift(4)-1]};break;default:throw"Cannot apply repeat for QPW cell type "+(31&_)}(n.sheetStubs||"z"!=b.t)&&(null!=r["!data"]?(r["!data"][u]||(r["!data"][u]=[]),r["!data"][u][l]=b):r[g+kn(u)]=b),++u,--s}}}e.l+=h}return d}(t,n);if(0==t[2]&&(8==t[3]||9==t[3])&&t.length>=16&&5==t[14]&&108===t[15])throw new Error("Unsupported Works 3 for Mac file");if(2==t[2])r.Enum=b,e(t,(function(e,t,n){switch(n){case 0:r.vers=e,e>=4096&&(r.qpro=!0);break;case 255:r.vers=e,r.works=!0;break;case 6:f=e;break;case 204:e&&(o=e);break;case 222:o=e;break;case 15:case 51:(!r.qpro&&!r.works||51==n)&&e[1].v.charCodeAt(0)<48&&(e[1].v=e[1].v.slice(1)),(r.works||r.works2)&&(e[1].v=e[1].v.replace(/\r\n/g,"\n"));case 13:case 14:case 16:14==n&&112==(112&e[2])&&(15&e[2])>1&&(15&e[2])<15&&(e[1].z=r.dateNF||z[14],r.cellDates&&(e[1].t="d",e[1].v=Pe(e[1].v))),r.qpro&&e[3]>s&&(i["!ref"]=Dn(f),c[a]=i,l.push(a),i={},r.dense&&(d=i["!data"]=[]),f={s:{r:0,c:0},e:{r:0,c:0}},s=e[3],a=o||"Sheet"+(s+1),o="");var u=r.dense?(d[e[0].r]||[])[e[0].c]:i[In(e[0])];if(u){u.t=e[1].t,u.v=e[1].v,null!=e[1].z&&(u.z=e[1].z),null!=e[1].f&&(u.f=e[1].f);break}r.dense?(d[e[0].r]||(d[e[0].r]=[]),d[e[0].r][e[0].c]=e[1]):i[In(e[0])]=e[1];break;case 21509:r.works2=!0}}),r);else{if(26!=t[2]&&14!=t[2])throw new Error("Unrecognized LOTUS BOF "+t[2]);r.Enum=y,14==t[2]&&(r.qpro=!0,t.l=0),e(t,(function(e,t,n){switch(n){case 204:a=e;break;case 22:e[1].v.charCodeAt(0)<48&&(e[1].v=e[1].v.slice(1)),e[1].v=e[1].v.replace(/\x0F./g,(function(e){return String.fromCharCode(e.charCodeAt(1)-32)})).replace(/\r\n/g,"\n");case 23:case 24:case 25:case 37:case 39:case 40:if(e[3]>s&&(i["!ref"]=Dn(f),c[a]=i,l.push(a),i={},r.dense&&(d=i["!data"]=[]),f={s:{r:0,c:0},e:{r:0,c:0}},s=e[3],a="Sheet"+(s+1)),h>0&&e[0].r>=h)break;r.dense?(d[e[0].r]||(d[e[0].r]=[]),d[e[0].r][e[0].c]=e[1]):i[In(e[0])]=e[1],f.e.c<e[0].c&&(f.e.c=e[0].c),f.e.r<e[0].r&&(f.e.r=e[0].r);break;case 27:e[14e3]&&(u[e[14e3][0]]=e[14e3][1]);break;case 1537:u[e[0]]=e[1],e[0]==s&&(a=e[1])}}),r)}if(i["!ref"]=Dn(f),c[o||a]=i,l.push(o||a),!u.length)return{SheetNames:l,Sheets:c};for(var p={},m=[],g=0;g<u.length;++g)c[l[g]]?(m.push(u[g]||l[g]),p[u[g]]=c[u[g]]||c[l[g]]):(m.push(u[g]),p[u[g]]={"!ref":"A1"});return{SheetNames:m,Sheets:p}}function n(e,t,n){var r=[{c:0,r:0},{t:"n",v:0},0,0];return n.qpro&&20768!=n.vers?(r[0].c=e.read_shift(1),r[3]=e.read_shift(1),r[0].r=e.read_shift(2),e.l+=2):n.works?(r[0].c=e.read_shift(2),r[0].r=e.read_shift(2),r[2]=e.read_shift(2)):(r[2]=e.read_shift(1),r[0].c=e.read_shift(2),r[0].r=e.read_shift(2)),r}function r(e,t,n){var r=xn(7+n.length);r.write_shift(1,255),r.write_shift(2,t),r.write_shift(2,e),r.write_shift(1,39);for(var i=0;i<r.length;++i){var a=n.charCodeAt(i);r.write_shift(1,a>=128?95:a)}return r.write_shift(1,0),r}function i(e,t,n){var r=xn(7);return r.write_shift(1,255),r.write_shift(2,t),r.write_shift(2,e),r.write_shift(2,n,"i"),r}function a(e,t,n){var r=xn(13);return r.write_shift(1,255),r.write_shift(2,t),r.write_shift(2,e),r.write_shift(8,n,"f"),r}function o(e,t,n){var r=32768&t;return t=(r?e:0)+((t&=-32769)>=8192?t-16384:t),(r?"":"$")+(n?Ln(t):kn(t))}var s={31:["NA",0],33:["ABS",1],34:["TRUNC",1],35:["SQRT",1],36:["LOG",1],37:["LN",1],38:["PI",0],39:["SIN",1],40:["COS",1],41:["TAN",1],42:["ATAN2",2],43:["ATAN",1],44:["ASIN",1],45:["ACOS",1],46:["EXP",1],47:["MOD",2],49:["ISNA",1],50:["ISERR",1],51:["FALSE",0],52:["TRUE",0],53:["RAND",0],63:["ROUND",2],68:["ISNUMBER",1],69:["ISTEXT",1],70:["LEN",1],71:["VALUE",1],73:["MID",3],74:["CHAR",1],80:["SUM",69],81:["AVERAGEA",69],82:["COUNTA",69],83:["MINA",69],84:["MAXA",69],102:["UPPER",1],103:["LOWER",1],107:["PROPER",1],109:["TRIM",1],111:["T",1]},l=["","","","","","","","","","+","-","*","/","^","=","<>","<=",">=","<",">","","","","","&","","","","","","",""];function u(e){var t=[{c:0,r:0},{t:"n",v:0},0];return t[0].r=e.read_shift(2),t[3]=e[e.l++],t[0].c=e[e.l++],t}function d(e,t,n,r){var i=xn(6+r.length);i.write_shift(2,e),i.write_shift(1,n),i.write_shift(1,t),i.write_shift(1,39);for(var a=0;a<r.length;++a){var o=r.charCodeAt(a);i.write_shift(1,o>=128?95:o)}return i.write_shift(1,0),i}function f(e,t){var n=u(e),r=e.read_shift(4),i=e.read_shift(4),a=e.read_shift(2);if(65535==a)return 0===r&&3221225472===i?(n[1].t="e",n[1].v=15):0===r&&3489660928===i?(n[1].t="e",n[1].v=42):n[1].v=0,n;var o=32768&a;return a=(32767&a)-16446,n[1].v=(1-2*o)*(i*Math.pow(2,a+32)+r*Math.pow(2,a)),n}function h(e,t,n,r){var i=xn(14);if(i.write_shift(2,e),i.write_shift(1,n),i.write_shift(1,t),0==r)return i.write_shift(4,0),i.write_shift(4,0),i.write_shift(2,65535),i;var a,o=0,s=0,c=0;return r<0&&(o=1,r=-r),s=0|Math.log2(r),0==(2147483648&(c=(r/=Math.pow(2,s-31))>>>0))&&(++s,c=(r/=2)>>>0),r-=c,c|=2147483648,c>>>=0,a=(r*=Math.pow(2,32))>>>0,i.write_shift(4,a),i.write_shift(4,c),s+=16383+(o?32768:0),i.write_shift(2,s),i}function p(e,t){var n=u(e),r=e.read_shift(8,"f");return n[1].v=r,n}function m(e,t){return 0==e[e.l+t-1]?e.read_shift(t,"cstr"):""}function g(e,t){var n=xn(5+e.length);n.write_shift(2,14e3),n.write_shift(2,t);for(var r=0;r<e.length;++r){var i=e.charCodeAt(r);n[n.l++]=i>127?95:i}return n[n.l++]=0,n}var b={0:{n:"BOF",f:$r},1:{n:"EOF"},2:{n:"CALCMODE"},3:{n:"CALCORDER"},4:{n:"SPLIT"},5:{n:"SYNC"},6:{n:"RANGE",f:function(e,t,n){var r={s:{c:0,r:0},e:{c:0,r:0}};return 8==t&&n.qpro?(r.s.c=e.read_shift(1),e.l++,r.s.r=e.read_shift(2),r.e.c=e.read_shift(1),e.l++,r.e.r=e.read_shift(2),r):(r.s.c=e.read_shift(2),r.s.r=e.read_shift(2),12==t&&n.qpro&&(e.l+=2),r.e.c=e.read_shift(2),r.e.r=e.read_shift(2),12==t&&n.qpro&&(e.l+=2),65535==r.s.c&&(r.s.c=r.e.c=r.s.r=r.e.r=0),r)}},7:{n:"WINDOW1"},8:{n:"COLW1"},9:{n:"WINTWO"},10:{n:"COLW2"},11:{n:"NAME"},12:{n:"BLANK"},13:{n:"INTEGER",f:function(e,t,r){var i=n(e,0,r);return i[1].v=e.read_shift(2,"i"),i}},14:{n:"NUMBER",f:function(e,t,r){var i=n(e,0,r);return i[1].v=e.read_shift(8,"f"),i}},15:{n:"LABEL",f:function(e,t,r){var i=e.l+t,a=n(e,0,r);if(a[1].t="s",20768==r.vers){e.l++;var o=e.read_shift(1);return a[1].v=e.read_shift(o,"utf8"),a}return r.qpro&&e.l++,a[1].v=e.read_shift(i-e.l,"cstr"),a}},16:{n:"FORMULA",f:function(e,t,r){var i=e.l+t,a=n(e,0,r);if(a[1].v=e.read_shift(8,"f"),r.qpro)e.l=i;else{var c=e.read_shift(2);!function(e,t){_n(e,0);for(var n=[],r=0,i="",a="",c="",u="";e.l<e.length;){var d=e[e.l++];switch(d){case 0:n.push(e.read_shift(8,"f"));break;case 1:a=o(t[0].c,e.read_shift(2),!0),i=o(t[0].r,e.read_shift(2),!1),n.push(a+i);break;case 2:var f=o(t[0].c,e.read_shift(2),!0),h=o(t[0].r,e.read_shift(2),!1);a=o(t[0].c,e.read_shift(2),!0),i=o(t[0].r,e.read_shift(2),!1),n.push(f+h+":"+a+i);break;case 3:if(e.l<e.length)return void console.error("WK1 premature formula end");break;case 4:n.push("("+n.pop()+")");break;case 5:n.push(e.read_shift(2));break;case 6:for(var p="";d=e[e.l++];)p+=String.fromCharCode(d);n.push('"'+p.replace(/"/g,'""')+'"');break;case 8:n.push("-"+n.pop());break;case 23:n.push("+"+n.pop());break;case 22:n.push("NOT("+n.pop()+")");break;case 20:case 21:u=n.pop(),c=n.pop(),n.push(["AND","OR"][d-20]+"("+c+","+u+")");break;default:if(d<32&&l[d])u=n.pop(),c=n.pop(),n.push(c+l[d]+u);else{if(!s[d])return d<=7?console.error("WK1 invalid opcode "+d.toString(16)):d<=24?console.error("WK1 unsupported op "+d.toString(16)):d<=30?console.error("WK1 invalid opcode "+d.toString(16)):d<=115?console.error("WK1 unsupported function opcode "+d.toString(16)):console.error("WK1 unrecognized opcode "+d.toString(16));if(69==(r=s[d][1])&&(r=e[e.l++]),r>n.length)return void console.error("WK1 bad formula parse 0x"+d.toString(16)+":|"+n.join("|")+"|");var m=n.slice(-r);n.length-=r,n.push(s[d][0]+"("+m.join(",")+")")}}}1==n.length?t[1].f=""+n[0]:console.error("WK1 bad formula parse |"+n.join("|")+"|")}(e.slice(e.l,e.l+c),a),e.l+=c}return a}},24:{n:"TABLE"},25:{n:"ORANGE"},26:{n:"PRANGE"},27:{n:"SRANGE"},28:{n:"FRANGE"},29:{n:"KRANGE1"},32:{n:"HRANGE"},35:{n:"KRANGE2"},36:{n:"PROTEC"},37:{n:"FOOTER"},38:{n:"HEADER"},39:{n:"SETUP"},40:{n:"MARGINS"},41:{n:"LABELFMT"},42:{n:"TITLES"},43:{n:"SHEETJS"},45:{n:"GRAPH"},46:{n:"NGRAPH"},47:{n:"CALCCOUNT"},48:{n:"UNFORMATTED"},49:{n:"CURSORW12"},50:{n:"WINDOW"},51:{n:"STRING",f:function(e,t,r){var i=e.l+t,a=n(e,0,r);if(a[1].t="s",20768==r.vers){var o=e.read_shift(1);return a[1].v=e.read_shift(o,"utf8"),a}return a[1].v=e.read_shift(i-e.l,"cstr"),a}},55:{n:"PASSWORD"},56:{n:"LOCKED"},60:{n:"QUERY"},61:{n:"QUERYNAME"},62:{n:"PRINT"},63:{n:"PRINTNAME"},64:{n:"GRAPH2"},65:{n:"GRAPHNAME"},66:{n:"ZOOM"},67:{n:"SYMSPLIT"},68:{n:"NSROWS"},69:{n:"NSCOLS"},70:{n:"RULER"},71:{n:"NNAME"},72:{n:"ACOMM"},73:{n:"AMACRO"},74:{n:"PARSE"},102:{n:"PRANGES??"},103:{n:"RRANGES??"},104:{n:"FNAME??"},105:{n:"MRANGES??"},204:{n:"SHEETNAMECS",f:m},222:{n:"SHEETNAMELP",f:function(e,t){var n=e[e.l++];n>t-1&&(n=t-1);for(var r="";r.length<n;)r+=String.fromCharCode(e[e.l++]);return r}},255:{n:"BOF",f:$r},65535:{n:""}},y={0:{n:"BOF"},1:{n:"EOF"},2:{n:"PASSWORD"},3:{n:"CALCSET"},4:{n:"WINDOWSET"},5:{n:"SHEETCELLPTR"},6:{n:"SHEETLAYOUT"},7:{n:"COLUMNWIDTH"},8:{n:"HIDDENCOLUMN"},9:{n:"USERRANGE"},10:{n:"SYSTEMRANGE"},11:{n:"ZEROFORCE"},12:{n:"SORTKEYDIR"},13:{n:"FILESEAL"},14:{n:"DATAFILLNUMS"},15:{n:"PRINTMAIN"},16:{n:"PRINTSTRING"},17:{n:"GRAPHMAIN"},18:{n:"GRAPHSTRING"},19:{n:"??"},20:{n:"ERRCELL"},21:{n:"NACELL"},22:{n:"LABEL16",f:function(e,t){var n=u(e);return n[1].t="s",n[1].v=e.read_shift(t-4,"cstr"),n}},23:{n:"NUMBER17",f:f},24:{n:"NUMBER18",f:function(e,t){var n=u(e);n[1].v=e.read_shift(2);var r=n[1].v>>1;if(1&n[1].v)switch(7&r){case 0:r=5e3*(r>>3);break;case 1:r=500*(r>>3);break;case 2:r=(r>>3)/20;break;case 3:r=(r>>3)/200;break;case 4:r=(r>>3)/2e3;break;case 5:r=(r>>3)/2e4;break;case 6:r=(r>>3)/16;break;case 7:r=(r>>3)/64}return n[1].v=r,n}},25:{n:"FORMULA19",f:function(e,t){var n=f(e);return e.l+=t-14,n}},26:{n:"FORMULA1A"},27:{n:"XFORMAT",f:function(e,t){for(var n={},r=e.l+t;e.l<r;){var i=e.read_shift(2);if(14e3==i){for(n[i]=[0,""],n[i][0]=e.read_shift(2);e[e.l];)n[i][1]+=String.fromCharCode(e[e.l]),e.l++;e.l++}}return n}},28:{n:"DTLABELMISC"},29:{n:"DTLABELCELL"},30:{n:"GRAPHWINDOW"},31:{n:"CPA"},32:{n:"LPLAUTO"},33:{n:"QUERY"},34:{n:"HIDDENSHEET"},35:{n:"??"},37:{n:"NUMBER25",f:function(e,t){var n=u(e),r=e.read_shift(4);return n[1].v=r>>6,n}},38:{n:"??"},39:{n:"NUMBER27",f:p},40:{n:"FORMULA28",f:function(e,t){var n=p(e);return e.l+=t-12,n}},142:{n:"??"},147:{n:"??"},150:{n:"??"},151:{n:"??"},152:{n:"??"},153:{n:"??"},154:{n:"??"},155:{n:"??"},156:{n:"??"},163:{n:"??"},174:{n:"??"},175:{n:"??"},176:{n:"??"},177:{n:"??"},184:{n:"??"},185:{n:"??"},186:{n:"??"},187:{n:"??"},188:{n:"??"},195:{n:"??"},201:{n:"??"},204:{n:"SHEETNAMECS",f:m},205:{n:"??"},206:{n:"??"},207:{n:"??"},208:{n:"??"},256:{n:"??"},259:{n:"??"},260:{n:"??"},261:{n:"??"},262:{n:"??"},263:{n:"??"},265:{n:"??"},266:{n:"??"},267:{n:"??"},268:{n:"??"},270:{n:"??"},271:{n:"??"},384:{n:"??"},389:{n:"??"},390:{n:"??"},393:{n:"??"},396:{n:"??"},512:{n:"??"},514:{n:"??"},513:{n:"??"},516:{n:"??"},517:{n:"??"},640:{n:"??"},641:{n:"??"},642:{n:"??"},643:{n:"??"},644:{n:"??"},645:{n:"??"},646:{n:"??"},647:{n:"??"},648:{n:"??"},658:{n:"??"},659:{n:"??"},660:{n:"??"},661:{n:"??"},662:{n:"??"},665:{n:"??"},666:{n:"??"},768:{n:"??"},772:{n:"??"},1537:{n:"SHEETINFOQP",f:function(e,t,n){if(n.qpro&&!(t<21)){var r=e.read_shift(1);return e.l+=17,e.l+=1,e.l+=2,[r,e.read_shift(t-21,"cstr")]}}},1600:{n:"??"},1602:{n:"??"},1793:{n:"??"},1794:{n:"??"},1795:{n:"??"},1796:{n:"??"},1920:{n:"??"},2048:{n:"??"},2049:{n:"??"},2052:{n:"??"},2688:{n:"??"},10998:{n:"??"},12849:{n:"??"},28233:{n:"??"},28484:{n:"??"},65535:{n:""}};return{sheet_to_wk1:function(e,t){var n=t||{};if(+n.codepage>=0&&c(+n.codepage),"string"==n.type)throw new Error("Cannot write WK1 to JS string");var o,s=wn(),l=Nn(e["!ref"]),u=null!=e["!data"],d=[];ys(s,0,(1030,(o=xn(2)).write_shift(2,1030),o)),ys(s,6,function(e){var t=xn(8);return t.write_shift(2,e.s.c),t.write_shift(2,e.s.r),t.write_shift(2,e.e.c),t.write_shift(2,e.e.r),t}(l));for(var f=Math.min(l.e.r,8191),h=l.s.c;h<=l.e.c;++h)d[h]=Ln(h);for(var p=l.s.r;p<=f;++p){var m=kn(p);for(h=l.s.c;h<=l.e.c;++h){var v=u?(e["!data"][p]||[])[h]:e[d[h]+m];v&&"z"!=v.t&&("n"==v.t?(0|v.v)==v.v&&v.v>=-32768&&v.v<=32767?ys(s,13,i(p,h,v.v)):ys(s,14,a(p,h,v.v)):ys(s,15,r(p,h,Un(v).slice(0,239))))}}return ys(s,1),s.end()},book_to_wk3:function(e,t){var n=t||{};if(+n.codepage>=0&&c(+n.codepage),"string"==n.type)throw new Error("Cannot write WK3 to JS string");var r=wn();ys(r,0,function(e){var t=xn(26);t.write_shift(2,4096),t.write_shift(2,4),t.write_shift(4,0);for(var n=0,r=0,i=0,a=0;a<e.SheetNames.length;++a){var o=e.SheetNames[a],s=e.Sheets[o];if(s&&s["!ref"]){++i;var c=Pn(s["!ref"]);n<c.e.r&&(n=c.e.r),r<c.e.c&&(r=c.e.c)}}return n>8191&&(n=8191),t.write_shift(2,n),t.write_shift(1,i),t.write_shift(1,r),t.write_shift(2,0),t.write_shift(2,0),t.write_shift(1,1),t.write_shift(1,2),t.write_shift(4,0),t.write_shift(4,0),t}(e));for(var i=0,a=0;i<e.SheetNames.length;++i)(e.Sheets[e.SheetNames[i]]||{})["!ref"]&&ys(r,27,g(e.SheetNames[i],a++));var o=0;for(i=0;i<e.SheetNames.length;++i){var s=e.Sheets[e.SheetNames[i]];if(s&&s["!ref"]){for(var l=Nn(s["!ref"]),u=null!=s["!data"],f=[],p=Math.min(l.e.r,8191),m=l.s.r;m<=p;++m)for(var v=kn(m),b=l.s.c;b<=l.e.c;++b){m===l.s.r&&(f[b]=Ln(b));var _=f[b]+v,y=u?(s["!data"][m]||[])[b]:s[_];y&&"z"!=y.t&&("n"==y.t?ys(r,23,h(m,b,o,y.v)):ys(r,22,d(m,b,o,Un(y).slice(0,239))))}++o}}return ys(r,1),r.end()},to_workbook:function(e,n){switch(n.type){case"base64":return t(T(_(e)),n);case"binary":return t(T(e),n);case"buffer":case"array":return t(e,n)}throw"Unsupported type "+n.type}}}(),Oi=function(){var e=St("t"),t=St("rPr");function n(n){var r=n.match(e);if(!r)return{t:"s",v:""};var i={t:"s",v:pt(r[1])},a=n.match(t);return a&&(i.s=function(e){var t={},n=e.match(st),r=0,i=!1;if(n)for(;r!=n.length;++r){var a=ut(n[r]);switch(a[0].replace(/\w*:/g,"")){case"<condense":case"<extend":break;case"<shadow":if(!a.val)break;case"<shadow>":case"<shadow/>":t.shadow=1;break;case"</shadow>":break;case"<charset":if("1"==a.val)break;t.cp=o[parseInt(a.val,10)];break;case"<outline":if(!a.val)break;case"<outline>":case"<outline/>":t.outline=1;break;case"</outline>":break;case"<rFont":t.name=a.val;break;case"<sz":t.sz=a.val;break;case"<strike":if(!a.val)break;case"<strike>":case"<strike/>":t.strike=1;break;case"</strike>":break;case"<u":if(!a.val)break;switch(a.val){case"double":t.uval="double";break;case"singleAccounting":t.uval="single-accounting";break;case"doubleAccounting":t.uval="double-accounting"}case"<u>":case"<u/>":t.u=1;break;case"</u>":break;case"<b":if("0"==a.val)break;case"<b>":case"<b/>":t.b=1;break;case"</b>":break;case"<i":if("0"==a.val)break;case"<i>":case"<i/>":t.i=1;break;case"</i>":break;case"<color":a.rgb&&(t.color=a.rgb.slice(2,8));break;case"<color>":case"<color/>":case"</color>":break;case"<family":t.family=a.val;break;case"<family>":case"<family/>":case"</family>":break;case"<vertAlign":t.valign=a.val;break;case"<vertAlign>":case"<vertAlign/>":case"</vertAlign>":case"<scheme":case"<scheme>":case"<scheme/>":case"</scheme>":case"<extLst":case"<extLst>":case"</extLst>":break;case"<ext":i=!0;break;case"</ext>":i=!1;break;default:if(47!==a[0].charCodeAt(1)&&!i)throw new Error("Unrecognized rich format "+a[0])}}return t}(a[1])),i}var r=/<(?:\w+:)?r>/g,i=/<\/(?:\w+:)?r>/;return function(e){return e.replace(r,"").split(i).map(n).filter((function(e){return e.v}))}}(),Ii=function(){var e=/(\r\n|\n)/g;function t(t){var n=[[],t.v,[]];return t.v?(t.s&&function(e,t,n){var r=[];e.u&&r.push("text-decoration: underline;"),e.uval&&r.push("text-underline-style:"+e.uval+";"),e.sz&&r.push("font-size:"+e.sz+"pt;"),e.outline&&r.push("text-effect: outline;"),e.shadow&&r.push("text-shadow: auto;"),t.push('<span style="'+r.join("")+'">'),e.b&&(t.push("<b>"),n.push("</b>")),e.i&&(t.push("<i>"),n.push("</i>")),e.strike&&(t.push("<s>"),n.push("</s>"));var i=e.valign||"";"superscript"==i||"super"==i?i="sup":"subscript"==i&&(i="sub"),""!=i&&(t.push("<"+i+">"),n.push("</"+i+">")),n.push("</span>")}(t.s,n[0],n[2]),n[0].join("")+n[1].replace(e,"<br/>")+n[2].join("")):""}return function(e){return e.map(t).join("")}}(),Pi=/<(?:\w+:)?t[^>]*>([^<]*)<\/(?:\w+:)?t>/g,Di=/<(?:\w+:)?r\b[^>]*>/,Ni=/<(?:\w+:)?rPh.*?>([\s\S]*?)<\/(?:\w+:)?rPh>/g;function Ui(e,t){var n=!t||t.cellHTML,r={};return e?(e.match(/^\s*<(?:\w+:)?t[^>]*>/)?(r.t=pt(Et(e.slice(e.indexOf(">")+1).split(/<\/(?:\w+:)?t>/)[0]||""),!0),r.r=Et(e),n&&(r.h=gt(r.t))):e.match(Di)&&(r.r=Et(e),r.t=pt(Et((e.replace(Ni,"").match(Pi)||[]).join("").replace(st,"")),!0),n&&(r.h=Ii(Oi(r.r)))),r):{t:""}}var Fi=/<(?:\w+:)?sst([^>]*)>([\s\S]*)<\/(?:\w+:)?sst>/,Bi=/<(?:\w+:)?(?:si|sstItem)>/g,zi=/<\/(?:\w+:)?(?:si|sstItem)>/;function Hi(e){if(void 0!==t)return t.utils.encode(i,e);for(var n=[],r=e.split(""),a=0;a<r.length;++a)n[a]=r[a].charCodeAt(0);return n}function Vi(e,t){var n={};return n.Major=e.read_shift(2),n.Minor=e.read_shift(2),t>=4&&(e.l+=t-4),n}function Gi(e){for(var t=e.read_shift(4),n=e.l+t-4,r={},i=e.read_shift(4),a=[];i-- >0;)a.push({t:e.read_shift(4),v:e.read_shift(0,"lpp4")});if(r.name=e.read_shift(0,"lpp4"),r.comps=a,e.l!=n)throw new Error("Bad DataSpaceMapEntry: "+e.l+" != "+n);return r}function $i(e,t){var n=e.l+t,r={};r.Flags=63&e.read_shift(4),e.l+=4,r.AlgID=e.read_shift(4);var i=!1;switch(r.AlgID){case 26126:case 26127:case 26128:i=36==r.Flags;break;case 26625:i=4==r.Flags;break;case 0:i=16==r.Flags||4==r.Flags||36==r.Flags;break;default:throw"Unrecognized encryption algorithm: "+r.AlgID}if(!i)throw new Error("Encryption Flags/AlgID mismatch");return r.AlgIDHash=e.read_shift(4),r.KeySize=e.read_shift(4),r.ProviderType=e.read_shift(4),e.l+=8,r.CSPName=e.read_shift(n-e.l>>1,"utf16le"),e.l=n,r}function Wi(e,t){var n={},r=e.l+t;return e.l+=4,n.Salt=e.slice(e.l,e.l+16),e.l+=16,n.Verifier=e.slice(e.l,e.l+16),e.l+=16,e.read_shift(4),n.VerifierHash=e.slice(e.l,r),e.l=r,n}function ji(e){if(36!=(63&e.read_shift(4)))throw new Error("EncryptionInfo mismatch");var t=e.read_shift(4);return{t:"Std",h:$i(e,t),v:Wi(e,e.length-e.l)}}function Xi(){throw new Error("File is password-protected: ECMA-376 Extensible")}function Yi(e){var t=["saltSize","blockSize","keyBits","hashSize","cipherAlgorithm","cipherChaining","hashAlgorithm","saltValue"];e.l+=4;var n=e.read_shift(e.length-e.l,"utf8"),r={};return n.replace(st,(function(e){var n=ut(e);switch(dt(n[0])){case"<?xml":case"<encryption":case"</encryption>":case"</keyEncryptors>":case"</keyEncryptor>":break;case"<keyData":t.forEach((function(e){r[e]=n[e]}));break;case"<dataIntegrity":r.encryptedHmacKey=n.encryptedHmacKey,r.encryptedHmacValue=n.encryptedHmacValue;break;case"<keyEncryptors>":case"<keyEncryptors":r.encs=[];break;case"<keyEncryptor":r.uri=n.uri;break;case"<encryptedKey":r.encs.push(n);break;default:throw n[0]}})),r}var qi=function(){var e=[187,255,255,186,255,255,185,128,0,190,15,0,191,15,0],t=[57840,7439,52380,33984,4364,3600,61902,12606,6258,57657,54287,34041,10252,43370,20163],n=[44796,19929,39858,10053,20106,40212,10761,31585,63170,64933,60267,50935,40399,11199,17763,35526,1453,2906,5812,11624,23248,885,1770,3540,7080,14160,28320,56640,55369,41139,20807,41614,21821,43642,17621,28485,56970,44341,19019,38038,14605,29210,60195,50791,40175,10751,21502,43004,24537,18387,36774,3949,7898,15796,31592,63184,47201,24803,49606,37805,14203,28406,56812,17824,35648,1697,3394,6788,13576,27152,43601,17539,35078,557,1114,2228,4456,30388,60776,51953,34243,7079,14158,28316,14128,28256,56512,43425,17251,34502,7597,13105,26210,52420,35241,883,1766,3532,4129,8258,16516,33032,4657,9314,18628],r=function(e,t){return 255&((n=e^t)/2|128*n);var n};return function(i){for(var a,o,s,c=Hi(i),l=function(e){for(var r=t[e.length-1],i=104,a=e.length-1;a>=0;--a)for(var o=e[a],s=0;7!=s;++s)64&o&&(r^=n[i]),o*=2,--i;return r}(c),u=c.length,d=w(16),f=0;16!=f;++f)d[f]=0;for(1==(1&u)&&(a=l>>8,d[u]=r(e[0],a),--u,a=255&l,o=c[c.length-1],d[u]=r(o,a));u>0;)a=l>>8,d[--u]=r(c[u],a),a=255&l,d[--u]=r(c[u],a);for(u=15,s=15-c.length;s>0;)a=l>>8,d[u]=r(e[s],a),--s,a=255&l,d[--u]=r(c[u],a),--u,--s;return d}}();function Ki(e,t){var n=t||{},r={},i=n.dense;i&&(r["!data"]=[]);var a=e.match(/\\trowd[\s\S]*?\\row\b/g);if(!a)throw new Error("RTF missing table");var o={s:{c:0,r:0},e:{c:0,r:a.length-1}},s=[];return a.forEach((function(e,t){i&&(s=r["!data"][t]=[]);for(var a,c=/\\[\w\-]+\b/g,l=0,u=-1,d=[];null!=(a=c.exec(e));){var f=e.slice(l,c.lastIndex-a[0].length);switch(32==f.charCodeAt(0)&&(f=f.slice(1)),f.length&&d.push(f),a[0]){case"\\cell":if(++u,d.length){var h={v:d.join(""),t:"s"};"TRUE"==h.v||"FALSE"==h.v?(h.v="TRUE"==h.v,h.t="b"):isNaN(Ge(h.v))||(h.t="n",!1!==n.cellText&&(h.w=h.v),h.v=Ge(h.v)),i?s[u]=h:r[In({r:t,c:u})]=h}d=[];break;case"\\par":d.push("\n")}l=c.lastIndex}u>o.e.c&&(o.e.c=u)})),r["!ref"]=Dn(o),r}function Zi(e){for(var t=0,n=1;3!=t;++t)n=256*n+(e[t]>255?255:e[t]<0?0:e[t]);return n.toString(16).toUpperCase().slice(1)}function Ji(e,t){if(0===t)return e;var n,r,i=function(e){var t=e[0]/255,n=e[1]/255,r=e[2]/255,i=Math.max(t,n,r),a=Math.min(t,n,r),o=i-a;if(0===o)return[0,0,t];var s,c=0,l=i+a;switch(s=o/(l>1?2-l:l),i){case t:c=((n-r)/o+6)%6;break;case n:c=(r-t)/o+2;break;case r:c=(t-n)/o+4}return[c/6,s,l/2]}((r=(n=e).slice("#"===n[0]?1:0).slice(0,6),[parseInt(r.slice(0,2),16),parseInt(r.slice(2,4),16),parseInt(r.slice(4,6),16)]));return i[2]=t<0?i[2]*(1+t):1-(1-i[2])*(1-t),Zi(function(e){var t,n=e[0],r=e[1],i=e[2],a=2*r*(i<.5?i:1-i),o=i-a/2,s=[o,o,o],c=6*n;if(0!==r)switch(0|c){case 0:case 6:t=a*c,s[0]+=a,s[1]+=t;break;case 1:t=a*(2-c),s[0]+=t,s[1]+=a;break;case 2:t=a*(c-2),s[1]+=a,s[2]+=t;break;case 3:t=a*(4-c),s[1]+=t,s[2]+=a;break;case 4:t=a*(c-4),s[2]+=a,s[0]+=t;break;case 5:t=a*(6-c),s[2]+=t,s[0]+=a}for(var l=0;3!=l;++l)s[l]=Math.round(255*s[l]);return s}(i))}var Qi=6,ea=15,ta=1,na=Qi;function ra(e){return Math.floor((e+Math.round(128/na)/256)*na)}function ia(e){return Math.floor((e-5)/na*100+.5)/100}function aa(e){return Math.round((e*na+5)/na*256)/256}function oa(e){return aa(ia(ra(e)))}function sa(e){var t=Math.abs(e-oa(e)),n=na;if(t>.005)for(na=ta;na<ea;++na)Math.abs(e-oa(e))<=t&&(t=Math.abs(e-oa(e)),n=na);na=n}function ca(e){e.width?(e.wpx=ra(e.width),e.wch=ia(e.wpx),e.MDW=na):e.wpx?(e.wch=ia(e.wpx),e.width=aa(e.wch),e.MDW=na):"number"==typeof e.wch&&(e.width=aa(e.wch),e.wpx=ra(e.width),e.MDW=na),e.customWidth&&delete e.customWidth}var la=96;function ua(e){return 96*e/la}function da(e){return e*la/96}var fa={None:"none",Solid:"solid",Gray50:"mediumGray",Gray75:"darkGray",Gray25:"lightGray",HorzStripe:"darkHorizontal",VertStripe:"darkVertical",ReverseDiagStripe:"darkDown",DiagStripe:"darkUp",DiagCross:"darkGrid",ThickDiagCross:"darkTrellis",ThinHorzStripe:"lightHorizontal",ThinVertStripe:"lightVertical",ThinReverseDiagStripe:"lightDown",ThinHorzCross:"lightGrid"},ha=["numFmtId","fillId","fontId","borderId","xfId"],pa=["applyAlignment","applyBorder","applyFill","applyFont","applyNumberFormat","applyProtection","pivotButton","quotePrefix"],ma=function(){var e=/<(?:\w+:)?numFmts([^>]*)>[\S\s]*?<\/(?:\w+:)?numFmts>/,t=/<(?:\w+:)?cellXfs([^>]*)>[\S\s]*?<\/(?:\w+:)?cellXfs>/,n=/<(?:\w+:)?fills([^>]*)>[\S\s]*?<\/(?:\w+:)?fills>/,r=/<(?:\w+:)?fonts([^>]*)>[\S\s]*?<\/(?:\w+:)?fonts>/,i=/<(?:\w+:)?borders([^>]*)>[\S\s]*?<\/(?:\w+:)?borders>/;return function(a,s,c){var l,u={};return a?((l=(a=a.replace(/<!--([\s\S]*?)-->/gm,"").replace(/<!DOCTYPE[^\[]*\[[^\]]*\]>/gm,"")).match(e))&&function(e,t,n){t.NumberFmt=[];for(var r=Ce(z),i=0;i<r.length;++i)t.NumberFmt[r[i]]=z[r[i]];var a=e[0].match(st);if(a)for(i=0;i<a.length;++i){var o=ut(a[i]);switch(dt(o[0])){case"<numFmts":case"</numFmts>":case"<numFmts/>":case"<numFmts>":case"</numFmt>":break;case"<numFmt":var s=pt(Et(o.formatCode)),c=parseInt(o.numFmtId,10);if(t.NumberFmt[c]=s,c>0){if(c>392){for(c=392;c>60&&null!=t.NumberFmt[c];--c);t.NumberFmt[c]=s}we(s,c)}break;default:if(n.WTF)throw new Error("unrecognized "+o[0]+" in numFmts")}}}(l,u,c),(l=a.match(r))&&function(e,t,n,r){t.Fonts=[];var i={},a=!1;(e[0].match(st)||[]).forEach((function(e){var s=ut(e);switch(dt(s[0])){case"<fonts":case"<fonts>":case"</fonts>":case"<font":case"<font>":case"<name/>":case"</name>":case"<sz/>":case"</sz>":case"<vertAlign/>":case"</vertAlign>":case"<family/>":case"</family>":case"<scheme/>":case"</scheme>":case"<color/>":case"</color>":case"<extLst":case"<extLst>":case"</extLst>":break;case"</font>":case"<font/>":t.Fonts.push(i),i={};break;case"<name":s.val&&(i.name=Et(s.val));break;case"<b":i.bold=s.val?_t(s.val):1;break;case"<b/>":i.bold=1;break;case"<i":i.italic=s.val?_t(s.val):1;break;case"<i/>":i.italic=1;break;case"<u":switch(s.val){case"none":i.underline=0;break;case"single":i.underline=1;break;case"double":i.underline=2;break;case"singleAccounting":i.underline=33;break;case"doubleAccounting":i.underline=34}break;case"<u/>":i.underline=1;break;case"<strike":i.strike=s.val?_t(s.val):1;break;case"<strike/>":i.strike=1;break;case"<outline":i.outline=s.val?_t(s.val):1;break;case"<outline/>":i.outline=1;break;case"<shadow":i.shadow=s.val?_t(s.val):1;break;case"<shadow/>":i.shadow=1;break;case"<condense":i.condense=s.val?_t(s.val):1;break;case"<condense/>":i.condense=1;break;case"<extend":i.extend=s.val?_t(s.val):1;break;case"<extend/>":i.extend=1;break;case"<sz":s.val&&(i.sz=+s.val);break;case"<vertAlign":s.val&&(i.vertAlign=s.val);break;case"<family":s.val&&(i.family=parseInt(s.val,10));break;case"<scheme":s.val&&(i.scheme=s.val);break;case"<charset":if("1"==s.val)break;s.codepage=o[parseInt(s.val,10)];break;case"<color":if(i.color||(i.color={}),s.auto&&(i.color.auto=_t(s.auto)),s.rgb)i.color.rgb=s.rgb.slice(-6);else if(s.indexed){i.color.index=parseInt(s.indexed,10);var c=hr[i.color.index];81==i.color.index&&(c=hr[1]),c||(c=hr[1]),i.color.rgb=c[0].toString(16)+c[1].toString(16)+c[2].toString(16)}else s.theme&&(i.color.theme=parseInt(s.theme,10),s.tint&&(i.color.tint=parseFloat(s.tint)),s.theme&&n.themeElements&&n.themeElements.clrScheme&&(i.color.rgb=Ji(n.themeElements.clrScheme[i.color.theme].rgb,i.color.tint||0)));break;case"<AlternateContent":case"<ext":a=!0;break;case"</AlternateContent>":case"</ext>":a=!1;break;default:if(r&&r.WTF&&!a)throw new Error("unrecognized "+s[0]+" in fonts")}}))}(l,u,s,c),(l=a.match(n))&&function(e,t,n,r){t.Fills=[];var i={},a=!1;(e[0].match(st)||[]).forEach((function(e){var n=ut(e);switch(dt(n[0])){case"<fills":case"<fills>":case"</fills>":case"</fill>":case"<gradientFill>":case"<patternFill/>":case"</patternFill>":case"<bgColor/>":case"</bgColor>":case"<fgColor/>":case"</fgColor>":case"<stop":case"<stop/>":case"</stop>":case"<color":case"<color/>":case"</color>":case"<extLst":case"<extLst>":case"</extLst>":break;case"<fill>":case"<fill":case"<fill/>":i={},t.Fills.push(i);break;case"<gradientFill":case"</gradientFill>":t.Fills.push(i),i={};break;case"<patternFill":case"<patternFill>":n.patternType&&(i.patternType=n.patternType);break;case"<bgColor":i.bgColor||(i.bgColor={}),n.indexed&&(i.bgColor.indexed=parseInt(n.indexed,10)),n.theme&&(i.bgColor.theme=parseInt(n.theme,10)),n.tint&&(i.bgColor.tint=parseFloat(n.tint)),n.rgb&&(i.bgColor.rgb=n.rgb.slice(-6));break;case"<fgColor":i.fgColor||(i.fgColor={}),n.theme&&(i.fgColor.theme=parseInt(n.theme,10)),n.tint&&(i.fgColor.tint=parseFloat(n.tint)),null!=n.rgb&&(i.fgColor.rgb=n.rgb.slice(-6));break;case"<ext":a=!0;break;case"</ext>":a=!1;break;default:if(r&&r.WTF&&!a)throw new Error("unrecognized "+n[0]+" in fills")}}))}(l,u,0,c),(l=a.match(i))&&function(e,t,n,r){t.Borders=[];var i={},a=!1;(e[0].match(st)||[]).forEach((function(e){var n=ut(e);switch(dt(n[0])){case"<borders":case"<borders>":case"</borders>":case"</border>":case"<left/>":case"<left":case"<left>":case"</left>":case"<right/>":case"<right":case"<right>":case"</right>":case"<top/>":case"<top":case"<top>":case"</top>":case"<bottom/>":case"<bottom":case"<bottom>":case"</bottom>":case"<diagonal":case"<diagonal>":case"<diagonal/>":case"</diagonal>":case"<horizontal":case"<horizontal>":case"<horizontal/>":case"</horizontal>":case"<vertical":case"<vertical>":case"<vertical/>":case"</vertical>":case"<start":case"<start>":case"<start/>":case"</start>":case"<end":case"<end>":case"<end/>":case"</end>":case"<color":case"<color>":case"<color/>":case"</color>":case"<extLst":case"<extLst>":case"</extLst>":break;case"<border":case"<border>":case"<border/>":i={},n.diagonalUp&&(i.diagonalUp=_t(n.diagonalUp)),n.diagonalDown&&(i.diagonalDown=_t(n.diagonalDown)),t.Borders.push(i);break;case"<ext":a=!0;break;case"</ext>":a=!1;break;default:if(r&&r.WTF&&!a)throw new Error("unrecognized "+n[0]+" in borders")}}))}(l,u,0,c),(l=a.match(t))&&function(e,t,n){var r;t.CellXf=[];var i=!1;(e[0].match(st)||[]).forEach((function(e){var a=ut(e),o=0;switch(dt(a[0])){case"<cellXfs":case"<cellXfs>":case"<cellXfs/>":case"</cellXfs>":case"</xf>":case"</alignment>":case"<protection":case"</protection>":case"<protection/>":case"<extLst":case"<extLst>":case"</extLst>":break;case"<xf":case"<xf/>":for(delete(r=a)[0],o=0;o<ha.length;++o)r[ha[o]]&&(r[ha[o]]=parseInt(r[ha[o]],10));for(o=0;o<pa.length;++o)r[pa[o]]&&(r[pa[o]]=_t(r[pa[o]]));if(t.NumberFmt&&r.numFmtId>392)for(o=392;o>60;--o)if(t.NumberFmt[r.numFmtId]==t.NumberFmt[o]){r.numFmtId=o;break}t.CellXf.push(r);break;case"<alignment":case"<alignment/>":var s={};a.vertical&&(s.vertical=a.vertical),a.horizontal&&(s.horizontal=a.horizontal),null!=a.textRotation&&(s.textRotation=a.textRotation),a.indent&&(s.indent=a.indent),a.wrapText&&(s.wrapText=_t(a.wrapText)),r.alignment=s;break;case"<AlternateContent":case"<ext":i=!0;break;case"</AlternateContent>":case"</ext>":i=!1;break;default:if(n&&n.WTF&&!i)throw new Error("unrecognized "+a[0]+" in cellXfs")}}))}(l,u,c),u):u}}(),va=yn,ga=yn,ba=["</a:lt1>","</a:dk1>","</a:lt2>","</a:dk2>","</a:accent1>","</a:accent2>","</a:accent3>","</a:accent4>","</a:accent5>","</a:accent6>","</a:hlink>","</a:folHlink>"];function _a(e,t,n){t.themeElements.clrScheme=[];var r={};(e[0].match(st)||[]).forEach((function(e){var i=ut(e);switch(i[0]){case"<a:clrScheme":case"</a:clrScheme>":break;case"<a:srgbClr":r.rgb=i.val;break;case"<a:sysClr":r.rgb=i.lastClr;break;case"<a:dk1>":case"</a:dk1>":case"<a:lt1>":case"</a:lt1>":case"<a:dk2>":case"</a:dk2>":case"<a:lt2>":case"</a:lt2>":case"<a:accent1>":case"</a:accent1>":case"<a:accent2>":case"</a:accent2>":case"<a:accent3>":case"</a:accent3>":case"<a:accent4>":case"</a:accent4>":case"<a:accent5>":case"</a:accent5>":case"<a:accent6>":case"</a:accent6>":case"<a:hlink>":case"</a:hlink>":case"<a:folHlink>":case"</a:folHlink>":"/"===i[0].charAt(1)?(t.themeElements.clrScheme[ba.indexOf(i[0])]=r,r={}):r.name=i[0].slice(3,i[0].length-1);break;default:if(n&&n.WTF)throw new Error("Unrecognized "+i[0]+" in clrScheme")}}))}function ya(){}function xa(){}var Aa=/<a:clrScheme([^>]*)>[\s\S]*<\/a:clrScheme>/,wa=/<a:fontScheme([^>]*)>[\s\S]*<\/a:fontScheme>/,Ea=/<a:fmtScheme([^>]*)>[\s\S]*<\/a:fmtScheme>/,Ta=/<a:themeElements([^>]*)>[\s\S]*<\/a:themeElements>/;function Sa(e,t){var n;e&&0!==e.length||(e=function(e,t){if(t&&t.themeXLSX)return t.themeXLSX;if(e&&"string"==typeof e.raw)return e.raw;var n=[it];return n[n.length]='<a:theme xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main" name="Office Theme">',n[n.length]="<a:themeElements>",n[n.length]='<a:clrScheme name="Office">',n[n.length]='<a:dk1><a:sysClr val="windowText" lastClr="000000"/></a:dk1>',n[n.length]='<a:lt1><a:sysClr val="window" lastClr="FFFFFF"/></a:lt1>',n[n.length]='<a:dk2><a:srgbClr val="1F497D"/></a:dk2>',n[n.length]='<a:lt2><a:srgbClr val="EEECE1"/></a:lt2>',n[n.length]='<a:accent1><a:srgbClr val="4F81BD"/></a:accent1>',n[n.length]='<a:accent2><a:srgbClr val="C0504D"/></a:accent2>',n[n.length]='<a:accent3><a:srgbClr val="9BBB59"/></a:accent3>',n[n.length]='<a:accent4><a:srgbClr val="8064A2"/></a:accent4>',n[n.length]='<a:accent5><a:srgbClr val="4BACC6"/></a:accent5>',n[n.length]='<a:accent6><a:srgbClr val="F79646"/></a:accent6>',n[n.length]='<a:hlink><a:srgbClr val="0000FF"/></a:hlink>',n[n.length]='<a:folHlink><a:srgbClr val="800080"/></a:folHlink>',n[n.length]="</a:clrScheme>",n[n.length]='<a:fontScheme name="Office">',n[n.length]="<a:majorFont>",n[n.length]='<a:latin typeface="Cambria"/>',n[n.length]='<a:ea typeface=""/>',n[n.length]='<a:cs typeface=""/>',n[n.length]='<a:font script="Jpan" typeface="ＭＳ Ｐゴシック"/>',n[n.length]='<a:font script="Hang" typeface="맑은 고딕"/>',n[n.length]='<a:font script="Hans" typeface="宋体"/>',n[n.length]='<a:font script="Hant" typeface="新細明體"/>',n[n.length]='<a:font script="Arab" typeface="Times New Roman"/>',n[n.length]='<a:font script="Hebr" typeface="Times New Roman"/>',n[n.length]='<a:font script="Thai" typeface="Tahoma"/>',n[n.length]='<a:font script="Ethi" typeface="Nyala"/>',n[n.length]='<a:font script="Beng" typeface="Vrinda"/>',n[n.length]='<a:font script="Gujr" typeface="Shruti"/>',n[n.length]='<a:font script="Khmr" typeface="MoolBoran"/>',n[n.length]='<a:font script="Knda" typeface="Tunga"/>',n[n.length]='<a:font script="Guru" typeface="Raavi"/>',n[n.length]='<a:font script="Cans" typeface="Euphemia"/>',n[n.length]='<a:font script="Cher" typeface="Plantagenet Cherokee"/>',n[n.length]='<a:font script="Yiii" typeface="Microsoft Yi Baiti"/>',n[n.length]='<a:font script="Tibt" typeface="Microsoft Himalaya"/>',n[n.length]='<a:font script="Thaa" typeface="MV Boli"/>',n[n.length]='<a:font script="Deva" typeface="Mangal"/>',n[n.length]='<a:font script="Telu" typeface="Gautami"/>',n[n.length]='<a:font script="Taml" typeface="Latha"/>',n[n.length]='<a:font script="Syrc" typeface="Estrangelo Edessa"/>',n[n.length]='<a:font script="Orya" typeface="Kalinga"/>',n[n.length]='<a:font script="Mlym" typeface="Kartika"/>',n[n.length]='<a:font script="Laoo" typeface="DokChampa"/>',n[n.length]='<a:font script="Sinh" typeface="Iskoola Pota"/>',n[n.length]='<a:font script="Mong" typeface="Mongolian Baiti"/>',n[n.length]='<a:font script="Viet" typeface="Times New Roman"/>',n[n.length]='<a:font script="Uigh" typeface="Microsoft Uighur"/>',n[n.length]='<a:font script="Geor" typeface="Sylfaen"/>',n[n.length]="</a:majorFont>",n[n.length]="<a:minorFont>",n[n.length]='<a:latin typeface="Calibri"/>',n[n.length]='<a:ea typeface=""/>',n[n.length]='<a:cs typeface=""/>',n[n.length]='<a:font script="Jpan" typeface="ＭＳ Ｐゴシック"/>',n[n.length]='<a:font script="Hang" typeface="맑은 고딕"/>',n[n.length]='<a:font script="Hans" typeface="宋体"/>',n[n.length]='<a:font script="Hant" typeface="新細明體"/>',n[n.length]='<a:font script="Arab" typeface="Arial"/>',n[n.length]='<a:font script="Hebr" typeface="Arial"/>',n[n.length]='<a:font script="Thai" typeface="Tahoma"/>',n[n.length]='<a:font script="Ethi" typeface="Nyala"/>',n[n.length]='<a:font script="Beng" typeface="Vrinda"/>',n[n.length]='<a:font script="Gujr" typeface="Shruti"/>',n[n.length]='<a:font script="Khmr" typeface="DaunPenh"/>',n[n.length]='<a:font script="Knda" typeface="Tunga"/>',n[n.length]='<a:font script="Guru" typeface="Raavi"/>',n[n.length]='<a:font script="Cans" typeface="Euphemia"/>',n[n.length]='<a:font script="Cher" typeface="Plantagenet Cherokee"/>',n[n.length]='<a:font script="Yiii" typeface="Microsoft Yi Baiti"/>',n[n.length]='<a:font script="Tibt" typeface="Microsoft Himalaya"/>',n[n.length]='<a:font script="Thaa" typeface="MV Boli"/>',n[n.length]='<a:font script="Deva" typeface="Mangal"/>',n[n.length]='<a:font script="Telu" typeface="Gautami"/>',n[n.length]='<a:font script="Taml" typeface="Latha"/>',n[n.length]='<a:font script="Syrc" typeface="Estrangelo Edessa"/>',n[n.length]='<a:font script="Orya" typeface="Kalinga"/>',n[n.length]='<a:font script="Mlym" typeface="Kartika"/>',n[n.length]='<a:font script="Laoo" typeface="DokChampa"/>',n[n.length]='<a:font script="Sinh" typeface="Iskoola Pota"/>',n[n.length]='<a:font script="Mong" typeface="Mongolian Baiti"/>',n[n.length]='<a:font script="Viet" typeface="Arial"/>',n[n.length]='<a:font script="Uigh" typeface="Microsoft Uighur"/>',n[n.length]='<a:font script="Geor" typeface="Sylfaen"/>',n[n.length]="</a:minorFont>",n[n.length]="</a:fontScheme>",n[n.length]='<a:fmtScheme name="Office">',n[n.length]="<a:fillStyleLst>",n[n.length]='<a:solidFill><a:schemeClr val="phClr"/></a:solidFill>',n[n.length]='<a:gradFill rotWithShape="1">',n[n.length]="<a:gsLst>",n[n.length]='<a:gs pos="0"><a:schemeClr val="phClr"><a:tint val="50000"/><a:satMod val="300000"/></a:schemeClr></a:gs>',n[n.length]='<a:gs pos="35000"><a:schemeClr val="phClr"><a:tint val="37000"/><a:satMod val="300000"/></a:schemeClr></a:gs>',n[n.length]='<a:gs pos="100000"><a:schemeClr val="phClr"><a:tint val="15000"/><a:satMod val="350000"/></a:schemeClr></a:gs>',n[n.length]="</a:gsLst>",n[n.length]='<a:lin ang="16200000" scaled="1"/>',n[n.length]="</a:gradFill>",n[n.length]='<a:gradFill rotWithShape="1">',n[n.length]="<a:gsLst>",n[n.length]='<a:gs pos="0"><a:schemeClr val="phClr"><a:tint val="100000"/><a:shade val="100000"/><a:satMod val="130000"/></a:schemeClr></a:gs>',n[n.length]='<a:gs pos="100000"><a:schemeClr val="phClr"><a:tint val="50000"/><a:shade val="100000"/><a:satMod val="350000"/></a:schemeClr></a:gs>',n[n.length]="</a:gsLst>",n[n.length]='<a:lin ang="16200000" scaled="0"/>',n[n.length]="</a:gradFill>",n[n.length]="</a:fillStyleLst>",n[n.length]="<a:lnStyleLst>",n[n.length]='<a:ln w="9525" cap="flat" cmpd="sng" algn="ctr"><a:solidFill><a:schemeClr val="phClr"><a:shade val="95000"/><a:satMod val="105000"/></a:schemeClr></a:solidFill><a:prstDash val="solid"/></a:ln>',n[n.length]='<a:ln w="25400" cap="flat" cmpd="sng" algn="ctr"><a:solidFill><a:schemeClr val="phClr"/></a:solidFill><a:prstDash val="solid"/></a:ln>',n[n.length]='<a:ln w="38100" cap="flat" cmpd="sng" algn="ctr"><a:solidFill><a:schemeClr val="phClr"/></a:solidFill><a:prstDash val="solid"/></a:ln>',n[n.length]="</a:lnStyleLst>",n[n.length]="<a:effectStyleLst>",n[n.length]="<a:effectStyle>",n[n.length]="<a:effectLst>",n[n.length]='<a:outerShdw blurRad="40000" dist="20000" dir="5400000" rotWithShape="0"><a:srgbClr val="000000"><a:alpha val="38000"/></a:srgbClr></a:outerShdw>',n[n.length]="</a:effectLst>",n[n.length]="</a:effectStyle>",n[n.length]="<a:effectStyle>",n[n.length]="<a:effectLst>",n[n.length]='<a:outerShdw blurRad="40000" dist="23000" dir="5400000" rotWithShape="0"><a:srgbClr val="000000"><a:alpha val="35000"/></a:srgbClr></a:outerShdw>',n[n.length]="</a:effectLst>",n[n.length]="</a:effectStyle>",n[n.length]="<a:effectStyle>",n[n.length]="<a:effectLst>",n[n.length]='<a:outerShdw blurRad="40000" dist="23000" dir="5400000" rotWithShape="0"><a:srgbClr val="000000"><a:alpha val="35000"/></a:srgbClr></a:outerShdw>',n[n.length]="</a:effectLst>",n[n.length]='<a:scene3d><a:camera prst="orthographicFront"><a:rot lat="0" lon="0" rev="0"/></a:camera><a:lightRig rig="threePt" dir="t"><a:rot lat="0" lon="0" rev="1200000"/></a:lightRig></a:scene3d>',n[n.length]='<a:sp3d><a:bevelT w="63500" h="25400"/></a:sp3d>',n[n.length]="</a:effectStyle>",n[n.length]="</a:effectStyleLst>",n[n.length]="<a:bgFillStyleLst>",n[n.length]='<a:solidFill><a:schemeClr val="phClr"/></a:solidFill>',n[n.length]='<a:gradFill rotWithShape="1">',n[n.length]="<a:gsLst>",n[n.length]='<a:gs pos="0"><a:schemeClr val="phClr"><a:tint val="40000"/><a:satMod val="350000"/></a:schemeClr></a:gs>',n[n.length]='<a:gs pos="40000"><a:schemeClr val="phClr"><a:tint val="45000"/><a:shade val="99000"/><a:satMod val="350000"/></a:schemeClr></a:gs>',n[n.length]='<a:gs pos="100000"><a:schemeClr val="phClr"><a:shade val="20000"/><a:satMod val="255000"/></a:schemeClr></a:gs>',n[n.length]="</a:gsLst>",n[n.length]='<a:path path="circle"><a:fillToRect l="50000" t="-80000" r="50000" b="180000"/></a:path>',n[n.length]="</a:gradFill>",n[n.length]='<a:gradFill rotWithShape="1">',n[n.length]="<a:gsLst>",n[n.length]='<a:gs pos="0"><a:schemeClr val="phClr"><a:tint val="80000"/><a:satMod val="300000"/></a:schemeClr></a:gs>',n[n.length]='<a:gs pos="100000"><a:schemeClr val="phClr"><a:shade val="30000"/><a:satMod val="200000"/></a:schemeClr></a:gs>',n[n.length]="</a:gsLst>",n[n.length]='<a:path path="circle"><a:fillToRect l="50000" t="50000" r="50000" b="50000"/></a:path>',n[n.length]="</a:gradFill>",n[n.length]="</a:bgFillStyleLst>",n[n.length]="</a:fmtScheme>",n[n.length]="</a:themeElements>",n[n.length]="<a:objectDefaults>",n[n.length]="<a:spDef>",n[n.length]='<a:spPr/><a:bodyPr/><a:lstStyle/><a:style><a:lnRef idx="1"><a:schemeClr val="accent1"/></a:lnRef><a:fillRef idx="3"><a:schemeClr val="accent1"/></a:fillRef><a:effectRef idx="2"><a:schemeClr val="accent1"/></a:effectRef><a:fontRef idx="minor"><a:schemeClr val="lt1"/></a:fontRef></a:style>',n[n.length]="</a:spDef>",n[n.length]="<a:lnDef>",n[n.length]='<a:spPr/><a:bodyPr/><a:lstStyle/><a:style><a:lnRef idx="2"><a:schemeClr val="accent1"/></a:lnRef><a:fillRef idx="0"><a:schemeClr val="accent1"/></a:fillRef><a:effectRef idx="1"><a:schemeClr val="accent1"/></a:effectRef><a:fontRef idx="minor"><a:schemeClr val="tx1"/></a:fontRef></a:style>',n[n.length]="</a:lnDef>",n[n.length]="</a:objectDefaults>",n[n.length]="<a:extraClrSchemeLst/>",n[n.length]="</a:theme>",n.join("")}());var r={};if(!(n=e.match(Ta)))throw new Error("themeElements not found in theme");return function(e,t,n){var r;t.themeElements={},[["clrScheme",Aa,_a],["fontScheme",wa,ya],["fmtScheme",Ea,xa]].forEach((function(i){if(!(r=e.match(i[1])))throw new Error(i[0]+" not found in themeElements");i[2](r,t,n)}))}(n[0],r,t),r.raw=e,r}function Ca(e){var t=e.read_shift(2),n=e.read_shift(2)-4,r=[t];switch(t){case 4:case 5:case 7:case 8:case 9:case 10:case 11:case 13:r[1]=function(e){var t={};switch(t.xclrType=e.read_shift(2),t.nTintShade=e.read_shift(2),t.xclrType){case 0:case 4:e.l+=4;break;case 1:t.xclrValue=function(e,t){return yn(e,4)}(e);break;case 2:t.xclrValue=Jr(e);break;case 3:t.xclrValue=function(e){return e.read_shift(4)}(e)}return e.l+=8,t}(e);break;case 6:r[1]=function(e,t){return yn(e,t)}(e,n);break;case 14:case 15:r[1]=e.read_shift(1===n?1:2);break;default:throw new Error("Unrecognized ExtProp type: "+t+" "+n)}return r}function Ma(e,t,n,r){var i,a=null!=e["!data"];t.forEach((function(t){var o=On(t.ref);if(!(o.r<0||o.c<0)){if(a?(e["!data"][o.r]||(e["!data"][o.r]=[]),i=e["!data"][o.r][o.c]):i=e[t.ref],!i){i={t:"z"},a?e["!data"][o.r][o.c]=i:e[t.ref]=i;var s=Nn(e["!ref"]||"BDWGO1000001:A1");s.s.r>o.r&&(s.s.r=o.r),s.e.r<o.r&&(s.e.r=o.r),s.s.c>o.c&&(s.s.c=o.c),s.e.c<o.c&&(s.e.c=o.c);var c=Dn(s);e["!ref"]=c}i.c||(i.c=[]);var l={a:t.author,t:t.t,r:t.r,T:n};t.h&&(l.h=t.h);for(var u=i.c.length-1;u>=0;--u){if(!n&&i.c[u].T)return;n&&!i.c[u].T&&i.c.splice(u,1)}if(n&&r)for(u=0;u<r.length;++u)if(l.a==r[u].id){l.a=r[u].name||l.a;break}i.c.push(l)}}))}var ka=Hn,Ra="application/vnd.ms-office.vbaProject",La=function(){var e=/(^|[^A-Za-z_])R(\[?-?\d+\]|[1-9]\d*|)C(\[?-?\d+\]|[1-9]\d*|)(?![A-Za-z0-9_])/g,t={r:0,c:0};function n(e,n,r,i){var a=!1,o=!1;0==r.length?o=!0:"["==r.charAt(0)&&(o=!0,r=r.slice(1,-1)),0==i.length?a=!0:"["==i.charAt(0)&&(a=!0,i=i.slice(1,-1));var s=r.length>0?0|parseInt(r,10):0,c=i.length>0?0|parseInt(i,10):0;return a?c+=t.c:--c,o?s+=t.r:--s,n+(a?"":"$")+Ln(c)+(o?"":"$")+kn(s)}return function(r,i){return t=i,r.replace(e,n)}}(),Oa=/(^|[^._A-Z0-9])([$]?)([A-Z]{1,2}|[A-W][A-Z]{2}|X[A-E][A-Z]|XF[A-D])([$]?)(10[0-3]\d{4}|104[0-7]\d{3}|1048[0-4]\d{2}|10485[0-6]\d|104857[0-6]|[1-9]\d{0,5})(?![_.\(A-Za-z0-9])/g,Ia=function(){return function(e,t){return e.replace(Oa,(function(e,n,r,i,a,o){var s=Rn(i)-(r?0:t.c),c=Mn(o)-(a?0:t.r);return n+"R"+("$"==a?c+1:0==c?"":"["+c+"]")+"C"+("$"==r?s+1:0==s?"":"["+s+"]")}))}}();function Pa(e,t){return e.replace(Oa,(function(e,n,r,i,a,o){return n+("$"==r?r+i:Ln(Rn(i)+t.c))+("$"==a?a+o:kn(Mn(o)+t.r))}))}function Da(e,t,n){var r=Pn(t).s,i=On(n);return Pa(e,{r:i.r-r.r,c:i.c-r.c})}function Na(e){return e.replace(/_xlfn\./g,"")}function Ua(e){e.l+=1}function Fa(e,t){var n=e.read_shift(1==t?1:2);return[16383&n,n>>14&1,n>>15&1]}function Ba(e,t,n){var r=2;if(n){if(n.biff>=2&&n.biff<=5)return za(e);12==n.biff&&(r=4)}var i=e.read_shift(r),a=e.read_shift(r),o=Fa(e,2),s=Fa(e,2);return{s:{r:i,c:o[0],cRel:o[1],rRel:o[2]},e:{r:a,c:s[0],cRel:s[1],rRel:s[2]}}}function za(e){var t=Fa(e,2),n=Fa(e,2),r=e.read_shift(1),i=e.read_shift(1);return{s:{r:t[0],c:r,cRel:t[1],rRel:t[2]},e:{r:n[0],c:i,cRel:n[1],rRel:n[2]}}}function Ha(e,t,n){if(n&&n.biff>=2&&n.biff<=5)return function(e){var t=Fa(e,2),n=e.read_shift(1);return{r:t[0],c:n,cRel:t[1],rRel:t[2]}}(e);var r=e.read_shift(n&&12==n.biff?4:2),i=Fa(e,2);return{r:r,c:i[0],cRel:i[1],rRel:i[2]}}function Va(e){var t=e.read_shift(2),n=e.read_shift(2);return{r:t,c:255&n,fQuoted:!!(16384&n),cRel:n>>15,rRel:n>>15}}function Ga(e){var t=1&e[e.l+1];return e.l+=4,[t,1]}function $a(e){return[e.read_shift(1),e.read_shift(1)]}function Wa(e,t){var n=[e.read_shift(1)];if(12==t)switch(n[0]){case 2:n[0]=4;break;case 4:n[0]=16;break;case 0:n[0]=1;break;case 1:n[0]=2}switch(n[0]){case 4:n[1]=Gr(e,1)?"TRUE":"FALSE",12!=t&&(e.l+=7);break;case 37:case 16:n[1]=pr[e[e.l]],e.l+=12==t?4:8;break;case 0:e.l+=8;break;case 1:n[1]=er(e);break;case 2:n[1]=Kr(e,0,{biff:t>0&&t<8?2:t});break;default:throw new Error("Bad SerAr: "+n[0])}return n}function ja(e,t,n){for(var r=e.read_shift(12==n.biff?4:2),i=[],a=0;a!=r;++a)i.push((12==n.biff?Qn:ri)(e,8));return i}function Xa(e,t,n){var r=0,i=0;12==n.biff?(r=e.read_shift(4),i=e.read_shift(4)):(i=1+e.read_shift(1),r=1+e.read_shift(2)),n.biff>=2&&n.biff<8&&(--r,0==--i&&(i=256));for(var a=0,o=[];a!=r&&(o[a]=[]);++a)for(var s=0;s!=i;++s)o[a][s]=Wa(e,n.biff);return o}function Ya(e,t,n){return e.l+=2,[Va(e)]}function qa(e){return e.l+=6,[]}function Ka(e){return e.l+=2,[$r(e),1&e.read_shift(2)]}var Za=["Data","All","Headers","??","?Data2","??","?DataHeaders","??","Totals","??","??","??","?DataTotals","??","??","??","?Current"],Ja={1:{n:"PtgExp",f:function(e,t,n){return e.l++,n&&12==n.biff?[e.read_shift(4,"i"),0]:[e.read_shift(2),e.read_shift(n&&2==n.biff?1:2)]}},2:{n:"PtgTbl",f:yn},3:{n:"PtgAdd",f:Ua},4:{n:"PtgSub",f:Ua},5:{n:"PtgMul",f:Ua},6:{n:"PtgDiv",f:Ua},7:{n:"PtgPower",f:Ua},8:{n:"PtgConcat",f:Ua},9:{n:"PtgLt",f:Ua},10:{n:"PtgLe",f:Ua},11:{n:"PtgEq",f:Ua},12:{n:"PtgGe",f:Ua},13:{n:"PtgGt",f:Ua},14:{n:"PtgNe",f:Ua},15:{n:"PtgIsect",f:Ua},16:{n:"PtgUnion",f:Ua},17:{n:"PtgRange",f:Ua},18:{n:"PtgUplus",f:Ua},19:{n:"PtgUminus",f:Ua},20:{n:"PtgPercent",f:Ua},21:{n:"PtgParen",f:Ua},22:{n:"PtgMissArg",f:Ua},23:{n:"PtgStr",f:function(e,t,n){return e.l++,jr(e,0,n)}},26:{n:"PtgSheet",f:function(e,t,n){return e.l+=5,e.l+=2,e.l+=2==n.biff?1:4,["PTGSHEET"]}},27:{n:"PtgEndSheet",f:function(e,t,n){return e.l+=2==n.biff?4:5,["PTGENDSHEET"]}},28:{n:"PtgErr",f:function(e){return e.l++,pr[e.read_shift(1)]}},29:{n:"PtgBool",f:function(e){return e.l++,0!==e.read_shift(1)}},30:{n:"PtgInt",f:function(e){return e.l++,e.read_shift(2)}},31:{n:"PtgNum",f:function(e){return e.l++,er(e)}},32:{n:"PtgArray",f:function(e,t,n){var r=(96&e[e.l++])>>5;return e.l+=2==n.biff?6:12==n.biff?14:7,[r]}},33:{n:"PtgFunc",f:function(e,t,n){var r=(96&e[e.l])>>5;e.l+=1;var i=e.read_shift(n&&n.biff<=3?1:2);return[yo[i],_o[i],r]}},34:{n:"PtgFuncVar",f:function(e,t,n){var r=e[e.l++],i=e.read_shift(1),a=n&&n.biff<=3?[88==r?-1:0,e.read_shift(1)]:function(e){return[e[e.l+1]>>7,32767&e.read_shift(2)]}(e);return[i,(0===a[0]?_o:bo)[a[1]]]}},35:{n:"PtgName",f:function(e,t,n){var r=e.read_shift(1)>>>5&3,i=!n||n.biff>=8?4:2,a=e.read_shift(i);switch(n.biff){case 2:e.l+=5;break;case 3:case 4:e.l+=8;break;case 5:e.l+=12}return[r,0,a]}},36:{n:"PtgRef",f:function(e,t,n){var r=(96&e[e.l])>>5;return e.l+=1,[r,Ha(e,0,n)]}},37:{n:"PtgArea",f:function(e,t,n){return[(96&e[e.l++])>>5,Ba(e,n.biff>=2&&n.biff,n)]}},38:{n:"PtgMemArea",f:function(e,t,n){var r=e.read_shift(1)>>>5&3;return e.l+=n&&2==n.biff?3:4,[r,e.read_shift(n&&2==n.biff?1:2)]}},39:{n:"PtgMemErr",f:yn},40:{n:"PtgMemNoMem",f:yn},41:{n:"PtgMemFunc",f:function(e,t,n){return[e.read_shift(1)>>>5&3,e.read_shift(n&&2==n.biff?1:2)]}},42:{n:"PtgRefErr",f:function(e,t,n){var r=e.read_shift(1)>>>5&3;return e.l+=4,n.biff<8&&e.l--,12==n.biff&&(e.l+=2),[r]}},43:{n:"PtgAreaErr",f:function(e,t,n){var r=(96&e[e.l++])>>5;return e.l+=n&&n.biff>8?12:n.biff<8?6:8,[r]}},44:{n:"PtgRefN",f:function(e,t,n){var r=(96&e[e.l])>>5;e.l+=1;var i=function(e,t,n){var r=n&&n.biff?n.biff:8;if(r>=2&&r<=5)return function(e){var t=e.read_shift(2),n=e.read_shift(1),r=(32768&t)>>15,i=(16384&t)>>14;return t&=16383,1==r&&t>=8192&&(t-=16384),1==i&&n>=128&&(n-=256),{r:t,c:n,cRel:i,rRel:r}}(e);var i=e.read_shift(r>=12?4:2),a=e.read_shift(2),o=(16384&a)>>14,s=(32768&a)>>15;if(a&=16383,1==s)for(;i>524287;)i-=1048576;if(1==o)for(;a>8191;)a-=16384;return{r:i,c:a,cRel:o,rRel:s}}(e,0,n);return[r,i]}},45:{n:"PtgAreaN",f:function(e,t,n){var r=(96&e[e.l++])>>5,i=function(e,t,n){if(n.biff<8)return za(e);var r=e.read_shift(12==n.biff?4:2),i=e.read_shift(12==n.biff?4:2),a=Fa(e,2),o=Fa(e,2);return{s:{r:r,c:a[0],cRel:a[1],rRel:a[2]},e:{r:i,c:o[0],cRel:o[1],rRel:o[2]}}}(e,0,n);return[r,i]}},46:{n:"PtgMemAreaN",f:function(e){return[e.read_shift(1)>>>5&3,e.read_shift(2)]}},47:{n:"PtgMemNoMemN",f:function(e){return[e.read_shift(1)>>>5&3,e.read_shift(2)]}},57:{n:"PtgNameX",f:function(e,t,n){return 5==n.biff?function(e){var t=e.read_shift(1)>>>5&3,n=e.read_shift(2,"i");e.l+=8;var r=e.read_shift(2);return e.l+=12,[t,n,r]}(e):[e.read_shift(1)>>>5&3,e.read_shift(2),e.read_shift(4)]}},58:{n:"PtgRef3d",f:function(e,t,n){var r=(96&e[e.l])>>5;e.l+=1;var i=e.read_shift(2);return n&&5==n.biff&&(e.l+=12),[r,i,Ha(e,0,n)]}},59:{n:"PtgArea3d",f:function(e,t,n){var r=(96&e[e.l++])>>5,i=e.read_shift(2,"i");if(n&&5===n.biff)e.l+=12;return[r,i,Ba(e,0,n)]}},60:{n:"PtgRefErr3d",f:function(e,t,n){var r=(96&e[e.l++])>>5,i=e.read_shift(2),a=4;if(n)switch(n.biff){case 5:a=15;break;case 12:a=6}return e.l+=a,[r,i]}},61:{n:"PtgAreaErr3d",f:function(e,t,n){var r=(96&e[e.l++])>>5,i=e.read_shift(2),a=8;if(n)switch(n.biff){case 5:e.l+=12,a=6;break;case 12:a=12}return e.l+=a,[r,i]}},255:{}},Qa={64:32,96:32,65:33,97:33,66:34,98:34,67:35,99:35,68:36,100:36,69:37,101:37,70:38,102:38,71:39,103:39,72:40,104:40,73:41,105:41,74:42,106:42,75:43,107:43,76:44,108:44,77:45,109:45,78:46,110:46,79:47,111:47,88:34,120:34,89:57,121:57,90:58,122:58,91:59,123:59,92:60,124:60,93:61,125:61},eo={1:{n:"PtgElfLel",f:Ka},2:{n:"PtgElfRw",f:Ya},3:{n:"PtgElfCol",f:Ya},6:{n:"PtgElfRwV",f:Ya},7:{n:"PtgElfColV",f:Ya},10:{n:"PtgElfRadical",f:Ya},11:{n:"PtgElfRadicalS",f:qa},13:{n:"PtgElfColS",f:qa},15:{n:"PtgElfColSV",f:qa},16:{n:"PtgElfRadicalLel",f:Ka},25:{n:"PtgList",f:function(e){e.l+=2;var t=e.read_shift(2),n=e.read_shift(2),r=e.read_shift(4),i=e.read_shift(2),a=e.read_shift(2);return{ixti:t,coltype:3&n,rt:Za[n>>2&31],idx:r,c:i,C:a}}},29:{n:"PtgSxName",f:function(e){return e.l+=2,[e.read_shift(4)]}},255:{}},to={0:{n:"PtgAttrNoop",f:function(e){return e.l+=4,[0,0]}},1:{n:"PtgAttrSemi",f:function(e,t,n){var r=255&e[e.l+1]?1:0;return e.l+=n&&2==n.biff?3:4,[r]}},2:{n:"PtgAttrIf",f:function(e,t,n){var r=255&e[e.l+1]?1:0;return e.l+=2,[r,e.read_shift(n&&2==n.biff?1:2)]}},4:{n:"PtgAttrChoose",f:function(e,t,n){e.l+=2;for(var r=e.read_shift(n&&2==n.biff?1:2),i=[],a=0;a<=r;++a)i.push(e.read_shift(n&&2==n.biff?1:2));return i}},8:{n:"PtgAttrGoto",f:function(e,t,n){var r=255&e[e.l+1]?1:0;return e.l+=2,[r,e.read_shift(n&&2==n.biff?1:2)]}},16:{n:"PtgAttrSum",f:function(e,t,n){e.l+=n&&2==n.biff?3:4}},32:{n:"PtgAttrBaxcel",f:Ga},33:{n:"PtgAttrBaxcel",f:Ga},64:{n:"PtgAttrSpace",f:function(e){return e.read_shift(2),$a(e)}},65:{n:"PtgAttrSpaceSemi",f:function(e){return e.read_shift(2),$a(e)}},128:{n:"PtgAttrIfError",f:function(e){var t=255&e[e.l+1]?1:0;return e.l+=2,[t,e.read_shift(2)]}},255:{}};function no(e,t,n,r){if(r.biff<8)return yn(e,t);for(var i=e.l+t,a=[],o=0;o!==n.length;++o)switch(n[o][0]){case"PtgArray":n[o][1]=Xa(e,0,r),a.push(n[o][1]);break;case"PtgMemArea":n[o][2]=ja(e,n[o][1],r),a.push(n[o][2]);break;case"PtgExp":r&&12==r.biff&&(n[o][1][1]=e.read_shift(4),a.push(n[o][1]));break;case"PtgList":case"PtgElfRadicalS":case"PtgElfColS":case"PtgElfColSV":throw"Unsupported "+n[o][0]}return 0!=(t=i-e.l)&&a.push(yn(e,t)),a}function ro(e,t,n){for(var r,i,a=e.l+t,o=[];a!=e.l;)t=a-e.l,i=e[e.l],r=Ja[i]||Ja[Qa[i]],24!==i&&25!==i||(r=(24===i?eo:to)[e[e.l+1]]),r&&r.f?o.push([r.n,r.f(e,t,n)]):yn(e,t);return o}function io(e){for(var t=[],n=0;n<e.length;++n){for(var r=e[n],i=[],a=0;a<r.length;++a){var o=r[a];o?2===o[0]?i.push('"'+o[1].replace(/"/g,'""')+'"'):i.push(o[1]):i.push("")}t.push(i.join(","))}return t.join(";")}var ao={PtgAdd:"+",PtgConcat:"&",PtgDiv:"/",PtgEq:"=",PtgGe:">=",PtgGt:">",PtgLe:"<=",PtgLt:"<",PtgMul:"*",PtgNe:"<>",PtgPower:"^",PtgSub:"-"};function oo(e,t,n){if(!e)return"SH33TJSERR0";if(n.biff>8&&(!e.XTI||!e.XTI[t]))return e.SheetNames[t];if(!e.XTI)return"SH33TJSERR6";var r=e.XTI[t];if(n.biff<8)return t>1e4&&(t-=65536),t<0&&(t=-t),0==t?"":e.XTI[t-1];if(!r)return"SH33TJSERR1";var i="";if(n.biff>8)switch(e[r[0]][0]){case 357:return i=-1==r[1]?"#REF":e.SheetNames[r[1]],r[1]==r[2]?i:i+":"+e.SheetNames[r[2]];case 358:return null!=n.SID?e.SheetNames[n.SID]:"SH33TJSSAME"+e[r[0]][0];default:return"SH33TJSSRC"+e[r[0]][0]}switch(e[r[0]][0][0]){case 1025:return i=-1==r[1]?"#REF":e.SheetNames[r[1]]||"SH33TJSERR3",r[1]==r[2]?i:i+":"+e.SheetNames[r[2]];case 14849:return e[r[0]].slice(1).map((function(e){return e.Name})).join(";;");default:return e[r[0]][0][3]?(i=-1==r[1]?"#REF":e[r[0]][0][3][r[1]]||"SH33TJSERR4",r[1]==r[2]?i:i+":"+e[r[0]][0][3][r[2]]):"SH33TJSERR2"}}function so(e,t,n){var r=oo(e,t,n);return"#REF"==r?r:function(e,t){if(!(e||t&&t.biff<=5&&t.biff>=2))throw new Error("empty sheet name");return/[^\w\u4E00-\u9FFF\u3040-\u30FF]/.test(e)?"'"+e.replace(/'/g,"''")+"'":e}(r,n)}function co(e,t,n,r,i){var a,o,s,c,l=i&&i.biff||8,u={s:{c:0,r:0},e:{c:0,r:0}},d=[],f=0,h=0,p="";if(!e[0]||!e[0][0])return"";for(var m,v,g,b,_=-1,y="",x=0,A=e[0].length;x<A;++x){var w=e[0][x];switch(w[0]){case"PtgUminus":d.push("-"+d.pop());break;case"PtgUplus":d.push("+"+d.pop());break;case"PtgPercent":d.push(d.pop()+"%");break;case"PtgAdd":case"PtgConcat":case"PtgDiv":case"PtgEq":case"PtgGe":case"PtgGt":case"PtgLe":case"PtgLt":case"PtgMul":case"PtgNe":case"PtgPower":case"PtgSub":if(a=d.pop(),o=d.pop(),_>=0){switch(e[0][_][1][0]){case 0:y=Ve(" ",e[0][_][1][1]);break;case 1:y=Ve("\r",e[0][_][1][1]);break;default:if(y="",i.WTF)throw new Error("Unexpected PtgAttrSpaceType "+e[0][_][1][0])}o+=y,_=-1}d.push(o+ao[w[0]]+a);break;case"PtgIsect":a=d.pop(),o=d.pop(),d.push(o+" "+a);break;case"PtgUnion":a=d.pop(),o=d.pop(),d.push(o+","+a);break;case"PtgRange":a=d.pop(),o=d.pop(),d.push((v=a,void 0,void 0,g=(m=o).lastIndexOf("!"),b=v.lastIndexOf("!"),-1==g&&-1==b?m+":"+v:g>0&&b>0&&m.slice(0,g).toLowerCase()==v.slice(0,b).toLowerCase()?m+":"+v.slice(b+1):(console.error("Cannot hydrate range",m,v),m+":"+v)));break;case"PtgAttrChoose":case"PtgAttrGoto":case"PtgAttrIf":case"PtgAttrIfError":case"PtgAttrBaxcel":case"PtgAttrSemi":case"PtgMemArea":case"PtgTbl":case"PtgMemErr":case"PtgMemAreaN":case"PtgMemNoMemN":case"PtgAttrNoop":case"PtgSheet":case"PtgEndSheet":case"PtgMemFunc":case"PtgMemNoMem":break;case"PtgRef":s=En(w[1][1],u,i),d.push(Sn(s,l));break;case"PtgRefN":s=n?En(w[1][1],n,i):w[1][1],d.push(Sn(s,l));break;case"PtgRef3d":f=w[1][1],s=En(w[1][2],u,i),p=so(r,f,i),d.push(p+"!"+Sn(s,l));break;case"PtgFunc":case"PtgFuncVar":var E=w[1][0],T=w[1][1];E||(E=0);var S=0==(E&=127)?[]:d.slice(-E);d.length-=E,"User"===T&&(T=S.shift()),d.push(T+"("+S.join(",")+")");break;case"PtgBool":d.push(w[1]?"TRUE":"FALSE");break;case"PtgInt":case"PtgErr":d.push(w[1]);break;case"PtgNum":d.push(String(w[1]));break;case"PtgStr":d.push('"'+w[1].replace(/"/g,'""')+'"');break;case"PtgAreaN":c=Tn(w[1][1],n?{s:n}:u,i),d.push(Cn(c,i));break;case"PtgArea":c=Tn(w[1][1],u,i),d.push(Cn(c,i));break;case"PtgArea3d":f=w[1][1],c=w[1][2],p=so(r,f,i),d.push(p+"!"+Cn(c,i));break;case"PtgAttrSum":d.push("SUM("+d.pop()+")");break;case"PtgName":h=w[1][2];var C=(r.names||[])[h-1]||(r[0]||[])[h],M=C?C.Name:"SH33TJSNAME"+String(h);M&&"_xlfn."==M.slice(0,6)&&!i.xlfn&&(M=M.slice(6)),d.push(M);break;case"PtgNameX":var k,R=w[1][1];if(h=w[1][2],!(i.biff<=5)){var L="";if(14849==((r[R]||[])[0]||[])[0]||(1025==((r[R]||[])[0]||[])[0]?r[R][h]&&r[R][h].itab>0&&(L=r.SheetNames[r[R][h].itab-1]+"!"):L=r.SheetNames[h-1]+"!"),r[R]&&r[R][h])L+=r[R][h].Name;else if(r[0]&&r[0][h])L+=r[0][h].Name;else{var O=(oo(r,R,i)||"").split(";;");O[h-1]?L=O[h-1]:L+="SH33TJSERRX"}d.push(L);break}R<0&&(R=-R),r[R]&&(k=r[R][h]),k||(k={Name:"SH33TJSERRY"}),d.push(k.Name);break;case"PtgParen":var I="(",P=")";if(_>=0){switch(y="",e[0][_][1][0]){case 2:I=Ve(" ",e[0][_][1][1])+I;break;case 3:I=Ve("\r",e[0][_][1][1])+I;break;case 4:P=Ve(" ",e[0][_][1][1])+P;break;case 5:P=Ve("\r",e[0][_][1][1])+P;break;default:if(i.WTF)throw new Error("Unexpected PtgAttrSpaceType "+e[0][_][1][0])}_=-1}d.push(I+d.pop()+P);break;case"PtgRefErr":case"PtgRefErr3d":case"PtgAreaErr":case"PtgAreaErr3d":d.push("#REF!");break;case"PtgExp":s={c:w[1][1],r:w[1][0]};var D={c:n.c,r:n.r};if(r.sharedf[In(s)]){var N=r.sharedf[In(s)];d.push(co(N,0,D,r,i))}else{var U=!1;for(a=0;a!=r.arrayf.length;++a)if(o=r.arrayf[a],!(s.c<o[0].s.c||s.c>o[0].e.c||s.r<o[0].s.r||s.r>o[0].e.r)){d.push(co(o[1],0,D,r,i)),U=!0;break}U||d.push(w[1])}break;case"PtgArray":d.push("{"+io(w[1])+"}");break;case"PtgAttrSpace":case"PtgAttrSpaceSemi":_=x;break;case"PtgMissArg":d.push("");break;case"PtgList":d.push("Table"+w[1].idx+"[#"+w[1].rt+"]");break;case"PtgElfCol":case"PtgElfColS":case"PtgElfColSV":case"PtgElfColV":case"PtgElfLel":case"PtgElfRadical":case"PtgElfRadicalLel":case"PtgElfRadicalS":case"PtgElfRw":case"PtgElfRwV":throw new Error("Unsupported ELFs");default:throw new Error("Unrecognized Formula Token: "+String(w))}if(3!=i.biff&&_>=0&&-1==["PtgAttrSpace","PtgAttrSpaceSemi","PtgAttrGoto"].indexOf(e[0][x][0])){var F=!0;switch((w=e[0][_])[1][0]){case 4:F=!1;case 0:y=Ve(" ",w[1][1]);break;case 5:F=!1;case 1:y=Ve("\r",w[1][1]);break;default:if(y="",i.WTF)throw new Error("Unexpected PtgAttrSpaceType "+w[1][0])}d.push((F?y:"")+d.pop()+(F?"":y)),_=-1}}if(d.length>1&&i.WTF)throw new Error("bad formula stack");return"TRUE"==d[0]||"FALSE"!=d[0]&&d[0]}function lo(e,t,n){var r,i=e.l+t,a=2==n.biff?1:2,o=e.read_shift(a);if(65535==o)return[[],yn(e,t-2)];var s=ro(e,o,n);return t!==o+a&&(r=no(e,t-o-a,s,n)),e.l=i,[s,r]}function uo(e,t,n){var r,i=e.l+t,a=e.read_shift(2),o=ro(e,a,n);return 65535==a?[[],yn(e,t-2)]:(t!==a+2&&(r=no(e,i-a-2,o,n)),[o,r])}function fo(e,t,n){var r=e.l+t,i=ei(e);2==n.biff&&++e.l;var a=function(e){var t;if(65535!==cn(e,e.l+6))return[er(e),"n"];switch(e[e.l]){case 0:return e.l+=8,["String","s"];case 1:return t=1===e[e.l+2],e.l+=8,[t,"b"];case 2:return t=e[e.l+2],e.l+=8,[t,"e"];case 3:return e.l+=8,["","s"]}return[]}(e),o=e.read_shift(1);2!=n.biff&&(e.read_shift(1),n.biff>=5&&e.read_shift(4));var s=function(e,t,n){var r,i=e.l+t,a=2==n.biff?1:2,o=e.read_shift(a);if(65535==o)return[[],yn(e,t-2)];var s=ro(e,o,n);return t!==o+a&&(r=no(e,t-o-a,s,n)),e.l=i,[s,r]}(e,r-e.l,n);return{cell:i,val:a[0],formula:s,shared:o>>3&1,tt:a[1]}}function ho(e,t,n){var r=e.read_shift(4),i=ro(e,r,n),a=e.read_shift(4);return[i,a>0?no(e,a,i,n):null]}var po=ho,mo=ho,vo=ho,go=ho,bo={0:"BEEP",1:"OPEN",2:"OPEN.LINKS",3:"CLOSE.ALL",4:"SAVE",5:"SAVE.AS",6:"FILE.DELETE",7:"PAGE.SETUP",8:"PRINT",9:"PRINTER.SETUP",10:"QUIT",11:"NEW.WINDOW",12:"ARRANGE.ALL",13:"WINDOW.SIZE",14:"WINDOW.MOVE",15:"FULL",16:"CLOSE",17:"RUN",22:"SET.PRINT.AREA",23:"SET.PRINT.TITLES",24:"SET.PAGE.BREAK",25:"REMOVE.PAGE.BREAK",26:"FONT",27:"DISPLAY",28:"PROTECT.DOCUMENT",29:"PRECISION",30:"A1.R1C1",31:"CALCULATE.NOW",32:"CALCULATION",34:"DATA.FIND",35:"EXTRACT",36:"DATA.DELETE",37:"SET.DATABASE",38:"SET.CRITERIA",39:"SORT",40:"DATA.SERIES",41:"TABLE",42:"FORMAT.NUMBER",43:"ALIGNMENT",44:"STYLE",45:"BORDER",46:"CELL.PROTECTION",47:"COLUMN.WIDTH",48:"UNDO",49:"CUT",50:"COPY",51:"PASTE",52:"CLEAR",53:"PASTE.SPECIAL",54:"EDIT.DELETE",55:"INSERT",56:"FILL.RIGHT",57:"FILL.DOWN",61:"DEFINE.NAME",62:"CREATE.NAMES",63:"FORMULA.GOTO",64:"FORMULA.FIND",65:"SELECT.LAST.CELL",66:"SHOW.ACTIVE.CELL",67:"GALLERY.AREA",68:"GALLERY.BAR",69:"GALLERY.COLUMN",70:"GALLERY.LINE",71:"GALLERY.PIE",72:"GALLERY.SCATTER",73:"COMBINATION",74:"PREFERRED",75:"ADD.OVERLAY",76:"GRIDLINES",77:"SET.PREFERRED",78:"AXES",79:"LEGEND",80:"ATTACH.TEXT",81:"ADD.ARROW",82:"SELECT.CHART",83:"SELECT.PLOT.AREA",84:"PATTERNS",85:"MAIN.CHART",86:"OVERLAY",87:"SCALE",88:"FORMAT.LEGEND",89:"FORMAT.TEXT",90:"EDIT.REPEAT",91:"PARSE",92:"JUSTIFY",93:"HIDE",94:"UNHIDE",95:"WORKSPACE",96:"FORMULA",97:"FORMULA.FILL",98:"FORMULA.ARRAY",99:"DATA.FIND.NEXT",100:"DATA.FIND.PREV",101:"FORMULA.FIND.NEXT",102:"FORMULA.FIND.PREV",103:"ACTIVATE",104:"ACTIVATE.NEXT",105:"ACTIVATE.PREV",106:"UNLOCKED.NEXT",107:"UNLOCKED.PREV",108:"COPY.PICTURE",109:"SELECT",110:"DELETE.NAME",111:"DELETE.FORMAT",112:"VLINE",113:"HLINE",114:"VPAGE",115:"HPAGE",116:"VSCROLL",117:"HSCROLL",118:"ALERT",119:"NEW",120:"CANCEL.COPY",121:"SHOW.CLIPBOARD",122:"MESSAGE",124:"PASTE.LINK",125:"APP.ACTIVATE",126:"DELETE.ARROW",127:"ROW.HEIGHT",128:"FORMAT.MOVE",129:"FORMAT.SIZE",130:"FORMULA.REPLACE",131:"SEND.KEYS",132:"SELECT.SPECIAL",133:"APPLY.NAMES",134:"REPLACE.FONT",135:"FREEZE.PANES",136:"SHOW.INFO",137:"SPLIT",138:"ON.WINDOW",139:"ON.DATA",140:"DISABLE.INPUT",142:"OUTLINE",143:"LIST.NAMES",144:"FILE.CLOSE",145:"SAVE.WORKBOOK",146:"DATA.FORM",147:"COPY.CHART",148:"ON.TIME",149:"WAIT",150:"FORMAT.FONT",151:"FILL.UP",152:"FILL.LEFT",153:"DELETE.OVERLAY",155:"SHORT.MENUS",159:"SET.UPDATE.STATUS",161:"COLOR.PALETTE",162:"DELETE.STYLE",163:"WINDOW.RESTORE",164:"WINDOW.MAXIMIZE",166:"CHANGE.LINK",167:"CALCULATE.DOCUMENT",168:"ON.KEY",169:"APP.RESTORE",170:"APP.MOVE",171:"APP.SIZE",172:"APP.MINIMIZE",173:"APP.MAXIMIZE",174:"BRING.TO.FRONT",175:"SEND.TO.BACK",185:"MAIN.CHART.TYPE",186:"OVERLAY.CHART.TYPE",187:"SELECT.END",188:"OPEN.MAIL",189:"SEND.MAIL",190:"STANDARD.FONT",191:"CONSOLIDATE",192:"SORT.SPECIAL",193:"GALLERY.3D.AREA",194:"GALLERY.3D.COLUMN",195:"GALLERY.3D.LINE",196:"GALLERY.3D.PIE",197:"VIEW.3D",198:"GOAL.SEEK",199:"WORKGROUP",200:"FILL.GROUP",201:"UPDATE.LINK",202:"PROMOTE",203:"DEMOTE",204:"SHOW.DETAIL",206:"UNGROUP",207:"OBJECT.PROPERTIES",208:"SAVE.NEW.OBJECT",209:"SHARE",210:"SHARE.NAME",211:"DUPLICATE",212:"APPLY.STYLE",213:"ASSIGN.TO.OBJECT",214:"OBJECT.PROTECTION",215:"HIDE.OBJECT",216:"SET.EXTRACT",217:"CREATE.PUBLISHER",218:"SUBSCRIBE.TO",219:"ATTRIBUTES",220:"SHOW.TOOLBAR",222:"PRINT.PREVIEW",223:"EDIT.COLOR",224:"SHOW.LEVELS",225:"FORMAT.MAIN",226:"FORMAT.OVERLAY",227:"ON.RECALC",228:"EDIT.SERIES",229:"DEFINE.STYLE",240:"LINE.PRINT",243:"ENTER.DATA",249:"GALLERY.RADAR",250:"MERGE.STYLES",251:"EDITION.OPTIONS",252:"PASTE.PICTURE",253:"PASTE.PICTURE.LINK",254:"SPELLING",256:"ZOOM",259:"INSERT.OBJECT",260:"WINDOW.MINIMIZE",265:"SOUND.NOTE",266:"SOUND.PLAY",267:"FORMAT.SHAPE",268:"EXTEND.POLYGON",269:"FORMAT.AUTO",272:"GALLERY.3D.BAR",273:"GALLERY.3D.SURFACE",274:"FILL.AUTO",276:"CUSTOMIZE.TOOLBAR",277:"ADD.TOOL",278:"EDIT.OBJECT",279:"ON.DOUBLECLICK",280:"ON.ENTRY",281:"WORKBOOK.ADD",282:"WORKBOOK.MOVE",283:"WORKBOOK.COPY",284:"WORKBOOK.OPTIONS",285:"SAVE.WORKSPACE",288:"CHART.WIZARD",289:"DELETE.TOOL",290:"MOVE.TOOL",291:"WORKBOOK.SELECT",292:"WORKBOOK.ACTIVATE",293:"ASSIGN.TO.TOOL",295:"COPY.TOOL",296:"RESET.TOOL",297:"CONSTRAIN.NUMERIC",298:"PASTE.TOOL",302:"WORKBOOK.NEW",305:"SCENARIO.CELLS",306:"SCENARIO.DELETE",307:"SCENARIO.ADD",308:"SCENARIO.EDIT",309:"SCENARIO.SHOW",310:"SCENARIO.SHOW.NEXT",311:"SCENARIO.SUMMARY",312:"PIVOT.TABLE.WIZARD",313:"PIVOT.FIELD.PROPERTIES",314:"PIVOT.FIELD",315:"PIVOT.ITEM",316:"PIVOT.ADD.FIELDS",318:"OPTIONS.CALCULATION",319:"OPTIONS.EDIT",320:"OPTIONS.VIEW",321:"ADDIN.MANAGER",322:"MENU.EDITOR",323:"ATTACH.TOOLBARS",324:"VBAActivate",325:"OPTIONS.CHART",328:"VBA.INSERT.FILE",330:"VBA.PROCEDURE.DEFINITION",336:"ROUTING.SLIP",338:"ROUTE.DOCUMENT",339:"MAIL.LOGON",342:"INSERT.PICTURE",343:"EDIT.TOOL",344:"GALLERY.DOUGHNUT",350:"CHART.TREND",352:"PIVOT.ITEM.PROPERTIES",354:"WORKBOOK.INSERT",355:"OPTIONS.TRANSITION",356:"OPTIONS.GENERAL",370:"FILTER.ADVANCED",373:"MAIL.ADD.MAILER",374:"MAIL.DELETE.MAILER",375:"MAIL.REPLY",376:"MAIL.REPLY.ALL",377:"MAIL.FORWARD",378:"MAIL.NEXT.LETTER",379:"DATA.LABEL",380:"INSERT.TITLE",381:"FONT.PROPERTIES",382:"MACRO.OPTIONS",383:"WORKBOOK.HIDE",384:"WORKBOOK.UNHIDE",385:"WORKBOOK.DELETE",386:"WORKBOOK.NAME",388:"GALLERY.CUSTOM",390:"ADD.CHART.AUTOFORMAT",391:"DELETE.CHART.AUTOFORMAT",392:"CHART.ADD.DATA",393:"AUTO.OUTLINE",394:"TAB.ORDER",395:"SHOW.DIALOG",396:"SELECT.ALL",397:"UNGROUP.SHEETS",398:"SUBTOTAL.CREATE",399:"SUBTOTAL.REMOVE",400:"RENAME.OBJECT",412:"WORKBOOK.SCROLL",413:"WORKBOOK.NEXT",414:"WORKBOOK.PREV",415:"WORKBOOK.TAB.SPLIT",416:"FULL.SCREEN",417:"WORKBOOK.PROTECT",420:"SCROLLBAR.PROPERTIES",421:"PIVOT.SHOW.PAGES",422:"TEXT.TO.COLUMNS",423:"FORMAT.CHARTTYPE",424:"LINK.FORMAT",425:"TRACER.DISPLAY",430:"TRACER.NAVIGATE",431:"TRACER.CLEAR",432:"TRACER.ERROR",433:"PIVOT.FIELD.GROUP",434:"PIVOT.FIELD.UNGROUP",435:"CHECKBOX.PROPERTIES",436:"LABEL.PROPERTIES",437:"LISTBOX.PROPERTIES",438:"EDITBOX.PROPERTIES",439:"PIVOT.REFRESH",440:"LINK.COMBO",441:"OPEN.TEXT",442:"HIDE.DIALOG",443:"SET.DIALOG.FOCUS",444:"ENABLE.OBJECT",445:"PUSHBUTTON.PROPERTIES",446:"SET.DIALOG.DEFAULT",447:"FILTER",448:"FILTER.SHOW.ALL",449:"CLEAR.OUTLINE",450:"FUNCTION.WIZARD",451:"ADD.LIST.ITEM",452:"SET.LIST.ITEM",453:"REMOVE.LIST.ITEM",454:"SELECT.LIST.ITEM",455:"SET.CONTROL.VALUE",456:"SAVE.COPY.AS",458:"OPTIONS.LISTS.ADD",459:"OPTIONS.LISTS.DELETE",460:"SERIES.AXES",461:"SERIES.X",462:"SERIES.Y",463:"ERRORBAR.X",464:"ERRORBAR.Y",465:"FORMAT.CHART",466:"SERIES.ORDER",467:"MAIL.LOGOFF",468:"CLEAR.ROUTING.SLIP",469:"APP.ACTIVATE.MICROSOFT",470:"MAIL.EDIT.MAILER",471:"ON.SHEET",472:"STANDARD.WIDTH",473:"SCENARIO.MERGE",474:"SUMMARY.INFO",475:"FIND.FILE",476:"ACTIVE.CELL.FONT",477:"ENABLE.TIPWIZARD",478:"VBA.MAKE.ADDIN",480:"INSERTDATATABLE",481:"WORKGROUP.OPTIONS",482:"MAIL.SEND.MAILER",485:"AUTOCORRECT",489:"POST.DOCUMENT",491:"PICKLIST",493:"VIEW.SHOW",494:"VIEW.DEFINE",495:"VIEW.DELETE",509:"SHEET.BACKGROUND",510:"INSERT.MAP.OBJECT",511:"OPTIONS.MENONO",517:"MSOCHECKS",518:"NORMAL",519:"LAYOUT",520:"RM.PRINT.AREA",521:"CLEAR.PRINT.AREA",522:"ADD.PRINT.AREA",523:"MOVE.BRK",545:"HIDECURR.NOTE",546:"HIDEALL.NOTES",547:"DELETE.NOTE",548:"TRAVERSE.NOTES",549:"ACTIVATE.NOTES",620:"PROTECT.REVISIONS",621:"UNPROTECT.REVISIONS",647:"OPTIONS.ME",653:"WEB.PUBLISH",667:"NEWWEBQUERY",673:"PIVOT.TABLE.CHART",753:"OPTIONS.SAVE",755:"OPTIONS.SPELL",808:"HIDEALL.INKANNOTS"},_o={0:"COUNT",1:"IF",2:"ISNA",3:"ISERROR",4:"SUM",5:"AVERAGE",6:"MIN",7:"MAX",8:"ROW",9:"COLUMN",10:"NA",11:"NPV",12:"STDEV",13:"DOLLAR",14:"FIXED",15:"SIN",16:"COS",17:"TAN",18:"ATAN",19:"PI",20:"SQRT",21:"EXP",22:"LN",23:"LOG10",24:"ABS",25:"INT",26:"SIGN",27:"ROUND",28:"LOOKUP",29:"INDEX",30:"REPT",31:"MID",32:"LEN",33:"VALUE",34:"TRUE",35:"FALSE",36:"AND",37:"OR",38:"NOT",39:"MOD",40:"DCOUNT",41:"DSUM",42:"DAVERAGE",43:"DMIN",44:"DMAX",45:"DSTDEV",46:"VAR",47:"DVAR",48:"TEXT",49:"LINEST",50:"TREND",51:"LOGEST",52:"GROWTH",53:"GOTO",54:"HALT",55:"RETURN",56:"PV",57:"FV",58:"NPER",59:"PMT",60:"RATE",61:"MIRR",62:"IRR",63:"RAND",64:"MATCH",65:"DATE",66:"TIME",67:"DAY",68:"MONTH",69:"YEAR",70:"WEEKDAY",71:"HOUR",72:"MINUTE",73:"SECOND",74:"NOW",75:"AREAS",76:"ROWS",77:"COLUMNS",78:"OFFSET",79:"ABSREF",80:"RELREF",81:"ARGUMENT",82:"SEARCH",83:"TRANSPOSE",84:"ERROR",85:"STEP",86:"TYPE",87:"ECHO",88:"SET.NAME",89:"CALLER",90:"DEREF",91:"WINDOWS",92:"SERIES",93:"DOCUMENTS",94:"ACTIVE.CELL",95:"SELECTION",96:"RESULT",97:"ATAN2",98:"ASIN",99:"ACOS",100:"CHOOSE",101:"HLOOKUP",102:"VLOOKUP",103:"LINKS",104:"INPUT",105:"ISREF",106:"GET.FORMULA",107:"GET.NAME",108:"SET.VALUE",109:"LOG",110:"EXEC",111:"CHAR",112:"LOWER",113:"UPPER",114:"PROPER",115:"LEFT",116:"RIGHT",117:"EXACT",118:"TRIM",119:"REPLACE",120:"SUBSTITUTE",121:"CODE",122:"NAMES",123:"DIRECTORY",124:"FIND",125:"CELL",126:"ISERR",127:"ISTEXT",128:"ISNUMBER",129:"ISBLANK",130:"T",131:"N",132:"FOPEN",133:"FCLOSE",134:"FSIZE",135:"FREADLN",136:"FREAD",137:"FWRITELN",138:"FWRITE",139:"FPOS",140:"DATEVALUE",141:"TIMEVALUE",142:"SLN",143:"SYD",144:"DDB",145:"GET.DEF",146:"REFTEXT",147:"TEXTREF",148:"INDIRECT",149:"REGISTER",150:"CALL",151:"ADD.BAR",152:"ADD.MENU",153:"ADD.COMMAND",154:"ENABLE.COMMAND",155:"CHECK.COMMAND",156:"RENAME.COMMAND",157:"SHOW.BAR",158:"DELETE.MENU",159:"DELETE.COMMAND",160:"GET.CHART.ITEM",161:"DIALOG.BOX",162:"CLEAN",163:"MDETERM",164:"MINVERSE",165:"MMULT",166:"FILES",167:"IPMT",168:"PPMT",169:"COUNTA",170:"CANCEL.KEY",171:"FOR",172:"WHILE",173:"BREAK",174:"NEXT",175:"INITIATE",176:"REQUEST",177:"POKE",178:"EXECUTE",179:"TERMINATE",180:"RESTART",181:"HELP",182:"GET.BAR",183:"PRODUCT",184:"FACT",185:"GET.CELL",186:"GET.WORKSPACE",187:"GET.WINDOW",188:"GET.DOCUMENT",189:"DPRODUCT",190:"ISNONTEXT",191:"GET.NOTE",192:"NOTE",193:"STDEVP",194:"VARP",195:"DSTDEVP",196:"DVARP",197:"TRUNC",198:"ISLOGICAL",199:"DCOUNTA",200:"DELETE.BAR",201:"UNREGISTER",204:"USDOLLAR",205:"FINDB",206:"SEARCHB",207:"REPLACEB",208:"LEFTB",209:"RIGHTB",210:"MIDB",211:"LENB",212:"ROUNDUP",213:"ROUNDDOWN",214:"ASC",215:"DBCS",216:"RANK",219:"ADDRESS",220:"DAYS360",221:"TODAY",222:"VDB",223:"ELSE",224:"ELSE.IF",225:"END.IF",226:"FOR.CELL",227:"MEDIAN",228:"SUMPRODUCT",229:"SINH",230:"COSH",231:"TANH",232:"ASINH",233:"ACOSH",234:"ATANH",235:"DGET",236:"CREATE.OBJECT",237:"VOLATILE",238:"LAST.ERROR",239:"CUSTOM.UNDO",240:"CUSTOM.REPEAT",241:"FORMULA.CONVERT",242:"GET.LINK.INFO",243:"TEXT.BOX",244:"INFO",245:"GROUP",246:"GET.OBJECT",247:"DB",248:"PAUSE",251:"RESUME",252:"FREQUENCY",253:"ADD.TOOLBAR",254:"DELETE.TOOLBAR",255:"User",256:"RESET.TOOLBAR",257:"EVALUATE",258:"GET.TOOLBAR",259:"GET.TOOL",260:"SPELLING.CHECK",261:"ERROR.TYPE",262:"APP.TITLE",263:"WINDOW.TITLE",264:"SAVE.TOOLBAR",265:"ENABLE.TOOL",266:"PRESS.TOOL",267:"REGISTER.ID",268:"GET.WORKBOOK",269:"AVEDEV",270:"BETADIST",271:"GAMMALN",272:"BETAINV",273:"BINOMDIST",274:"CHIDIST",275:"CHIINV",276:"COMBIN",277:"CONFIDENCE",278:"CRITBINOM",279:"EVEN",280:"EXPONDIST",281:"FDIST",282:"FINV",283:"FISHER",284:"FISHERINV",285:"FLOOR",286:"GAMMADIST",287:"GAMMAINV",288:"CEILING",289:"HYPGEOMDIST",290:"LOGNORMDIST",291:"LOGINV",292:"NEGBINOMDIST",293:"NORMDIST",294:"NORMSDIST",295:"NORMINV",296:"NORMSINV",297:"STANDARDIZE",298:"ODD",299:"PERMUT",300:"POISSON",301:"TDIST",302:"WEIBULL",303:"SUMXMY2",304:"SUMX2MY2",305:"SUMX2PY2",306:"CHITEST",307:"CORREL",308:"COVAR",309:"FORECAST",310:"FTEST",311:"INTERCEPT",312:"PEARSON",313:"RSQ",314:"STEYX",315:"SLOPE",316:"TTEST",317:"PROB",318:"DEVSQ",319:"GEOMEAN",320:"HARMEAN",321:"SUMSQ",322:"KURT",323:"SKEW",324:"ZTEST",325:"LARGE",326:"SMALL",327:"QUARTILE",328:"PERCENTILE",329:"PERCENTRANK",330:"MODE",331:"TRIMMEAN",332:"TINV",334:"MOVIE.COMMAND",335:"GET.MOVIE",336:"CONCATENATE",337:"POWER",338:"PIVOT.ADD.DATA",339:"GET.PIVOT.TABLE",340:"GET.PIVOT.FIELD",341:"GET.PIVOT.ITEM",342:"RADIANS",343:"DEGREES",344:"SUBTOTAL",345:"SUMIF",346:"COUNTIF",347:"COUNTBLANK",348:"SCENARIO.GET",349:"OPTIONS.LISTS.GET",350:"ISPMT",351:"DATEDIF",352:"DATESTRING",353:"NUMBERSTRING",354:"ROMAN",355:"OPEN.DIALOG",356:"SAVE.DIALOG",357:"VIEW.GET",358:"GETPIVOTDATA",359:"HYPERLINK",360:"PHONETIC",361:"AVERAGEA",362:"MAXA",363:"MINA",364:"STDEVPA",365:"VARPA",366:"STDEVA",367:"VARA",368:"BAHTTEXT",369:"THAIDAYOFWEEK",370:"THAIDIGIT",371:"THAIMONTHOFYEAR",372:"THAINUMSOUND",373:"THAINUMSTRING",374:"THAISTRINGLENGTH",375:"ISTHAIDIGIT",376:"ROUNDBAHTDOWN",377:"ROUNDBAHTUP",378:"THAIYEAR",379:"RTD",380:"CUBEVALUE",381:"CUBEMEMBER",382:"CUBEMEMBERPROPERTY",383:"CUBERANKEDMEMBER",384:"HEX2BIN",385:"HEX2DEC",386:"HEX2OCT",387:"DEC2BIN",388:"DEC2HEX",389:"DEC2OCT",390:"OCT2BIN",391:"OCT2HEX",392:"OCT2DEC",393:"BIN2DEC",394:"BIN2OCT",395:"BIN2HEX",396:"IMSUB",397:"IMDIV",398:"IMPOWER",399:"IMABS",400:"IMSQRT",401:"IMLN",402:"IMLOG2",403:"IMLOG10",404:"IMSIN",405:"IMCOS",406:"IMEXP",407:"IMARGUMENT",408:"IMCONJUGATE",409:"IMAGINARY",410:"IMREAL",411:"COMPLEX",412:"IMSUM",413:"IMPRODUCT",414:"SERIESSUM",415:"FACTDOUBLE",416:"SQRTPI",417:"QUOTIENT",418:"DELTA",419:"GESTEP",420:"ISEVEN",421:"ISODD",422:"MROUND",423:"ERF",424:"ERFC",425:"BESSELJ",426:"BESSELK",427:"BESSELY",428:"BESSELI",429:"XIRR",430:"XNPV",431:"PRICEMAT",432:"YIELDMAT",433:"INTRATE",434:"RECEIVED",435:"DISC",436:"PRICEDISC",437:"YIELDDISC",438:"TBILLEQ",439:"TBILLPRICE",440:"TBILLYIELD",441:"PRICE",442:"YIELD",443:"DOLLARDE",444:"DOLLARFR",445:"NOMINAL",446:"EFFECT",447:"CUMPRINC",448:"CUMIPMT",449:"EDATE",450:"EOMONTH",451:"YEARFRAC",452:"COUPDAYBS",453:"COUPDAYS",454:"COUPDAYSNC",455:"COUPNCD",456:"COUPNUM",457:"COUPPCD",458:"DURATION",459:"MDURATION",460:"ODDLPRICE",461:"ODDLYIELD",462:"ODDFPRICE",463:"ODDFYIELD",464:"RANDBETWEEN",465:"WEEKNUM",466:"AMORDEGRC",467:"AMORLINC",468:"CONVERT",724:"SHEETJS",469:"ACCRINT",470:"ACCRINTM",471:"WORKDAY",472:"NETWORKDAYS",473:"GCD",474:"MULTINOMIAL",475:"LCM",476:"FVSCHEDULE",477:"CUBEKPIMEMBER",478:"CUBESET",479:"CUBESETCOUNT",480:"IFERROR",481:"COUNTIFS",482:"SUMIFS",483:"AVERAGEIF",484:"AVERAGEIFS"},yo={2:1,3:1,10:0,15:1,16:1,17:1,18:1,19:0,20:1,21:1,22:1,23:1,24:1,25:1,26:1,27:2,30:2,31:3,32:1,33:1,34:0,35:0,38:1,39:2,40:3,41:3,42:3,43:3,44:3,45:3,47:3,48:2,53:1,61:3,63:0,65:3,66:3,67:1,68:1,69:1,70:1,71:1,72:1,73:1,74:0,75:1,76:1,77:1,79:2,80:2,83:1,85:0,86:1,89:0,90:1,94:0,95:0,97:2,98:1,99:1,101:3,102:3,105:1,106:1,108:2,111:1,112:1,113:1,114:1,117:2,118:1,119:4,121:1,126:1,127:1,128:1,129:1,130:1,131:1,133:1,134:1,135:1,136:2,137:2,138:2,140:1,141:1,142:3,143:4,144:4,161:1,162:1,163:1,164:1,165:2,172:1,175:2,176:2,177:3,178:2,179:1,184:1,186:1,189:3,190:1,195:3,196:3,197:1,198:1,199:3,201:1,207:4,210:3,211:1,212:2,213:2,214:1,215:1,225:0,229:1,230:1,231:1,232:1,233:1,234:1,235:3,244:1,247:4,252:2,257:1,261:1,271:1,273:4,274:2,275:2,276:2,277:3,278:3,279:1,280:3,281:3,282:3,283:1,284:1,285:2,286:4,287:3,288:2,289:4,290:3,291:3,292:3,293:4,294:1,295:3,296:1,297:3,298:1,299:2,300:3,301:3,302:4,303:2,304:2,305:2,306:2,307:2,308:2,309:3,310:2,311:2,312:2,313:2,314:2,315:2,316:4,325:2,326:2,327:2,328:2,331:2,332:2,337:2,342:1,343:1,346:2,347:1,350:4,351:3,352:1,353:2,360:1,368:1,369:1,370:1,371:1,372:1,373:1,374:1,375:1,376:1,377:1,378:1,382:3,385:1,392:1,393:1,396:2,397:2,398:2,399:1,400:1,401:1,402:1,403:1,404:1,405:1,406:1,407:1,408:1,409:1,410:1,414:4,415:1,416:1,417:2,420:1,421:1,422:2,424:1,425:2,426:2,427:2,428:2,430:3,438:3,439:3,440:3,443:2,444:2,445:2,446:2,447:6,448:6,449:2,450:2,464:2,468:3,476:2,479:1,480:2,65535:0};function xo(e){return"of:"==e.slice(0,3)&&(e=e.slice(3)),61==e.charCodeAt(0)&&61==(e=e.slice(1)).charCodeAt(0)&&(e=e.slice(1)),(e=(e=(e=(e=(e=e.replace(/COM\.MICROSOFT\./g,"")).replace(/\[((?:\.[A-Z]+[0-9]+)(?::\.[A-Z]+[0-9]+)?)\]/g,(function(e,t){return t.replace(/\./g,"")}))).replace(/\$'([^']|'')+'/g,(function(e){return e.slice(1)}))).replace(/\$([^\]\. #$]+)/g,(function(e,t){return t.match(/^([A-Z]{1,2}|[A-W][A-Z]{2}|X[A-E][A-Z]|XF[A-D])?(10[0-3]\d{4}|104[0-7]\d{3}|1048[0-4]\d{2}|10485[0-6]\d|104857[0-6]|[1-9]\d{0,5})?$/)?e:t}))).replace(/\[.(#[A-Z]*[?!])\]/g,"$1")).replace(/[;~]/g,",").replace(/\|/g,";")}function Ao(e){var t=(e=(e=e.replace(/\$'([^']|'')+'/g,(function(e){return e.slice(1)}))).replace(/\$([^\]\. #$]+)/g,(function(e,t){return t.match(/^([A-Z]{1,2}|[A-W][A-Z]{2}|X[A-E][A-Z]|XF[A-D])?(10[0-3]\d{4}|104[0-7]\d{3}|1048[0-4]\d{2}|10485[0-6]\d|104857[0-6]|[1-9]\d{0,5})?$/)?e:t}))).split(":");return[t[0].split(".")[0],t[0].split(".")[1]+(t.length>1?":"+(t[1].split(".")[1]||t[1].split(".")[0]):"")]}var wo={},Eo={};function To(e,t){if(e){var n=[.7,.7,.75,.75,.3,.3];"xlml"==t&&(n=[1,1,1,1,.5,.5]),null==e.left&&(e.left=n[0]),null==e.right&&(e.right=n[1]),null==e.top&&(e.top=n[2]),null==e.bottom&&(e.bottom=n[3]),null==e.header&&(e.header=n[4]),null==e.footer&&(e.footer=n[5])}}function So(e,t,n,r,i,a){try{r.cellNF&&(e.z=z[t])}catch(e){if(r.WTF)throw e}if("z"!==e.t||r.cellStyles){if("d"===e.t&&"string"==typeof e.v&&(e.v=Be(e.v)),(!r||!1!==r.cellText)&&"z"!==e.t)try{if(null==z[t]&&we(ye[t]||"General",t),"e"===e.t)e.w=e.w||pr[e.v];else if(0===t)if("n"===e.t)(0|e.v)===e.v?e.w=e.v.toString(10):e.w=Z(e.v);else if("d"===e.t){var o=Re(e.v);e.w=(0|o)===o?o.toString(10):Z(o)}else{if(void 0===e.v)return"";e.w=J(e.v,Eo)}else"d"===e.t?e.w=be(t,Re(e.v),Eo):e.w=be(t,e.v,Eo)}catch(e){if(r.WTF)throw e}if(r.cellStyles&&null!=n)try{e.s=a.Fills[n],e.s.fgColor&&e.s.fgColor.theme&&!e.s.fgColor.rgb&&(e.s.fgColor.rgb=Ji(i.themeElements.clrScheme[e.s.fgColor.theme].rgb,e.s.fgColor.tint||0),r.WTF&&(e.s.fgColor.raw_rgb=i.themeElements.clrScheme[e.s.fgColor.theme].rgb)),e.s.bgColor&&e.s.bgColor.theme&&(e.s.bgColor.rgb=Ji(i.themeElements.clrScheme[e.s.bgColor.theme].rgb,e.s.bgColor.tint||0),r.WTF&&(e.s.bgColor.raw_rgb=i.themeElements.clrScheme[e.s.bgColor.theme].rgb))}catch(e){if(r.WTF&&a.Fills)throw e}}}var Co=/<(?:\w:)?mergeCell ref="[A-Z0-9:]+"\s*[\/]?>/g,Mo=/<(?:\w+:)?sheetData[^>]*>([\s\S]*)<\/(?:\w+:)?sheetData>/,ko=/<(?:\w:)?hyperlink [^>]*>/gm,Ro=/"(\w*:\w*)"/,Lo=/<(?:\w:)?col\b[^>]*[\/]?>/g,Oo=/<(?:\w:)?autoFilter[^>]*([\/]|>([\s\S]*)<\/(?:\w:)?autoFilter)>/g,Io=/<(?:\w:)?pageMargins[^>]*\/>/g,Po=/<(?:\w:)?sheetPr\b(?:[^>a-z][^>]*)?\/>/,Do=/<(?:\w:)?sheetPr[^>]*(?:[\/]|>([\s\S]*)<\/(?:\w:)?sheetPr)>/,No=/<(?:\w:)?sheetViews[^>]*(?:[\/]|>([\s\S]*)<\/(?:\w:)?sheetViews)>/;function Uo(e,t,n,r){var i=ut(e);n.Sheets[r]||(n.Sheets[r]={}),i.codeName&&(n.Sheets[r].CodeName=pt(Et(i.codeName)))}var Fo=/<(?:\w:)?sheetView(?:[^>a-z][^>]*)?\/?>/g,Bo=function(){var e=/<(?:\w+:)?c[ \/>]/,t=/<\/(?:\w+:)?row>/,n=/r=["']([^"']*)["']/,r=/<(?:\w+:)?is>([\S\s]*?)<\/(?:\w+:)?is>/,i=/ref=["']([^"']*)["']/,a=St("v"),o=St("f");return function(s,c,l,u,d,f){for(var h,p,m,v,g,b=0,_="",y=[],x=[],A=0,w=0,E=0,T="",S=0,C=0,M=0,k=0,R=Array.isArray(f.CellXf),L=[],O=[],I=null!=c["!data"],P=[],D={},N=!1,U=!!l.sheetStubs,F=s.split(t),B=0,H=F.length;B!=H;++B){var V=(_=F[B].trim()).length;if(0!==V){var G=0;e:for(b=0;b<V;++b)switch(_[b]){case">":if("/"!=_[b-1]){++b;break e}if(l&&l.cellStyles){if(S=null!=(p=ut(_.slice(G,b),!0)).r?parseInt(p.r,10):S+1,C=-1,l.sheetRows&&l.sheetRows<S)continue;D={},N=!1,p.ht&&(N=!0,D.hpt=parseFloat(p.ht),D.hpx=da(D.hpt)),p.hidden&&_t(p.hidden)&&(N=!0,D.hidden=!0),null!=p.outlineLevel&&(N=!0,D.level=+p.outlineLevel),N&&(P[S-1]=D)}break;case"<":G=b}if(G>=b)break;if(S=null!=(p=ut(_.slice(G,b),!0)).r?parseInt(p.r,10):S+1,C=-1,!(l.sheetRows&&l.sheetRows<S)){l.nodim||(u.s.r>S-1&&(u.s.r=S-1),u.e.r<S-1&&(u.e.r=S-1)),l&&l.cellStyles&&(D={},N=!1,p.ht&&(N=!0,D.hpt=parseFloat(p.ht),D.hpx=da(D.hpt)),p.hidden&&_t(p.hidden)&&(N=!0,D.hidden=!0),null!=p.outlineLevel&&(N=!0,D.level=+p.outlineLevel),N&&(P[S-1]=D)),y=_.slice(b).split(e);for(var $=0;$!=y.length&&"<"==y[$].trim().charAt(0);++$);for(y=y.slice($),b=0;b!=y.length;++b)if(0!==(_=y[b].trim()).length){if(x=_.match(n),A=b,w=0,E=0,_="<c "+("<"==_.slice(0,1)?">":"")+_,null!=x&&2===x.length){for(A=0,T=x[1],w=0;w!=T.length&&!((E=T.charCodeAt(w)-64)<1||E>26);++w)A=26*A+E;C=--A}else++C;for(w=0;w!=_.length&&62!==_.charCodeAt(w);++w);if(++w,(p=ut(_.slice(0,w),!0)).r||(p.r=In({r:S-1,c:C})),h={t:""},null!=(x=(T=_.slice(w)).match(a))&&""!==x[1]&&(h.v=pt(x[1])),l.cellFormula){if(null!=(x=T.match(o))&&""!==x[1]){if(h.f=pt(Et(x[1]),!0),l.xlfn||(h.f=Na(h.f)),x[0].indexOf('t="array"')>-1)h.F=(T.match(i)||[])[1],h.F.indexOf(":")>-1&&L.push([Nn(h.F),h.F]);else if(x[0].indexOf('t="shared"')>-1){v=ut(x[0]);var W=pt(Et(x[1]));l.xlfn||(W=Na(W)),O[parseInt(v.si,10)]=[v,W,p.r]}}else(x=T.match(/<f[^>]*\/>/))&&O[(v=ut(x[0])).si]&&(h.f=Da(O[v.si][1],O[v.si][2],p.r));var j=On(p.r);for(w=0;w<L.length;++w)j.r>=L[w][0].s.r&&j.r<=L[w][0].e.r&&j.c>=L[w][0].s.c&&j.c<=L[w][0].e.c&&(h.F=L[w][1])}if(null==p.t&&void 0===h.v)if(h.f||h.F)h.v=0,h.t="n";else{if(!U)continue;h.t="z"}else h.t=p.t||"n";switch(u.s.c>C&&(u.s.c=C),u.e.c<C&&(u.e.c=C),h.t){case"n":if(""==h.v||null==h.v){if(!U)continue;h.t="z"}else h.v=parseFloat(h.v);break;case"s":if(void 0===h.v){if(!U)continue;h.t="z"}else m=wo[parseInt(h.v,10)],h.v=m.t,h.r=m.r,l.cellHTML&&(h.h=m.h);break;case"str":h.t="s",h.v=null!=h.v?pt(Et(h.v),!0):"",l.cellHTML&&(h.h=gt(h.v));break;case"inlineStr":x=T.match(r),h.t="s",null!=x&&(m=Ui(x[1]))?(h.v=m.t,l.cellHTML&&(h.h=m.h)):h.v="";break;case"b":h.v=_t(h.v);break;case"d":l.cellDates?h.v=Be(h.v,1):(h.v=Re(Be(h.v,1)),h.t="n");break;case"e":l&&!1===l.cellText||(h.w=h.v),h.v=mr[h.v]}if(M=k=0,g=null,R&&void 0!==p.s&&null!=(g=f.CellXf[p.s])&&(null!=g.numFmtId&&(M=g.numFmtId),l.cellStyles&&null!=g.fillId&&(k=g.fillId)),So(h,M,k,l,d,f),l.cellDates&&R&&"n"==h.t&&me(z[M])&&(h.t="d",h.v=Pe(h.v)),p.cm&&l.xlmeta){var X=(l.xlmeta.Cell||[])[+p.cm-1];X&&"XLDAPR"==X.type&&(h.D=!0)}var Y;l.nodim&&(Y=On(p.r),u.s.r>Y.r&&(u.s.r=Y.r),u.e.r<Y.r&&(u.e.r=Y.r)),I?(Y=On(p.r),c["!data"][Y.r]||(c["!data"][Y.r]=[]),c["!data"][Y.r][Y.c]=h):c[p.r]=h}}}}P.length>0&&(c["!rows"]=P)}}(),zo=Qn;function Ho(e){return[jn(e),er(e),"n"]}var Vo=Qn,Go=["left","right","top","bottom","header","footer"];var $o=[["allowRefreshQuery",!1,"bool"],["autoCompressPictures",!0,"bool"],["backupFile",!1,"bool"],["checkCompatibility",!1,"bool"],["CodeName",""],["date1904",!1,"bool"],["defaultThemeVersion",0,"int"],["filterPrivacy",!1,"bool"],["hidePivotFieldList",!1,"bool"],["promptedSolutions",!1,"bool"],["publishItems",!1,"bool"],["refreshAllConnections",!1,"bool"],["saveExternalLinkValues",!0,"bool"],["showBorderUnselectedTables",!0,"bool"],["showInkAnnotation",!0,"bool"],["showObjects","all"],["showPivotChartFilter",!1,"bool"],["updateLinks","userSet"]],Wo=[["activeTab",0,"int"],["autoFilterDateGrouping",!0,"bool"],["firstSheet",0,"int"],["minimized",!1,"bool"],["showHorizontalScroll",!0,"bool"],["showSheetTabs",!0,"bool"],["showVerticalScroll",!0,"bool"],["tabRatio",600,"int"],["visibility","visible"]],jo=[],Xo=[["calcCompleted","true"],["calcMode","auto"],["calcOnSave","true"],["concurrentCalc","true"],["fullCalcOnLoad","false"],["fullPrecision","true"],["iterate","false"],["iterateCount","100"],["iterateDelta","0.001"],["refMode","A1"]];function Yo(e,t){for(var n=0;n!=e.length;++n)for(var r=e[n],i=0;i!=t.length;++i){var a=t[i];if(null==r[a[0]])r[a[0]]=a[1];else switch(a[2]){case"bool":"string"==typeof r[a[0]]&&(r[a[0]]=_t(r[a[0]]));break;case"int":"string"==typeof r[a[0]]&&(r[a[0]]=parseInt(r[a[0]],10))}}}function qo(e,t){for(var n=0;n!=t.length;++n){var r=t[n];if(null==e[r[0]])e[r[0]]=r[1];else switch(r[2]){case"bool":"string"==typeof e[r[0]]&&(e[r[0]]=_t(e[r[0]]));break;case"int":"string"==typeof e[r[0]]&&(e[r[0]]=parseInt(e[r[0]],10))}}}function Ko(e){qo(e.WBProps,$o),qo(e.CalcPr,Xo),Yo(e.WBView,Wo),Yo(e.Sheets,jo),Eo.date1904=_t(e.WBProps.date1904)}var Zo=":][*?/\\".split("");var Jo=/<\w+:workbook/;function Qo(e,t){var n={};return e.read_shift(4),n.ArchID=e.read_shift(4),e.l+=t-8,n}function es(e,t,n,r,i,a,o,s){return".bin"===t.slice(-4)?function(e,t,n,r,i,a,o){if(!e)return e;var s=t||{};r||(r={"!id":{}}),null!=v&&null==s.dense&&(s.dense=v);var c,l={};s.dense&&(l["!data"]=[]);var u,d,f,h,p,m,g,b,_,y={s:{r:2e6,c:2e6},e:{r:0,c:0}},x=[],A=!1,w=!1,E=[];s.biff=12,s["!row"]=0;var T=0,S=!1,C=[],M={},k=s.supbooks||i.supbooks||[[]];if(k.sharedf=M,k.arrayf=C,k.SheetNames=i.SheetNames||i.Sheets.map((function(e){return e.name})),!s.supbooks&&(s.supbooks=k,i.Names))for(var R=0;R<i.Names.length;++R)k[0][R+1]=i.Names[R];var L,O,I=[],P=[],D=!1;if(bs[16]={n:"BrtShortReal",f:Ho},An(e,(function(e,t,v){if(!w)switch(v){case 148:c=e;break;case 0:u=e,s.sheetRows&&s.sheetRows<=u.r&&(w=!0),b=kn(h=u.r),s["!row"]=u.r,(e.hidden||e.hpt||null!=e.level)&&(e.hpt&&(e.hpx=da(e.hpt)),P[e.r]=e);break;case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 9:case 10:case 11:case 13:case 14:case 15:case 16:case 17:case 18:case 62:switch(d={t:e[2]},e[2]){case"n":d.v=e[1];break;case"s":g=wo[e[1]],d.v=g.t,d.r=g.r;break;case"b":d.v=!!e[1];break;case"e":d.v=e[1],!1!==s.cellText&&(d.w=pr[d.v]);break;case"str":d.t="s",d.v=e[1];break;case"is":d.t="s",d.v=e[1].t}if((f=o.CellXf[e[0].iStyleRef])&&So(d,f.numFmtId,null,s,a,o),p=-1==e[0].c?p+1:e[0].c,s.dense?(l["!data"][h]||(l["!data"][h]=[]),l["!data"][h][p]=d):l[Ln(p)+b]=d,s.cellFormula){for(S=!1,T=0;T<C.length;++T){var R=C[T];u.r>=R[0].s.r&&u.r<=R[0].e.r&&p>=R[0].s.c&&p<=R[0].e.c&&(d.F=Dn(R[0]),S=!0)}!S&&e.length>3&&(d.f=e[3])}if(y.s.r>u.r&&(y.s.r=u.r),y.s.c>p&&(y.s.c=p),y.e.r<u.r&&(y.e.r=u.r),y.e.c<p&&(y.e.c=p),s.cellDates&&f&&"n"==d.t&&me(z[f.numFmtId])){var N=W(d.v);N&&(d.t="d",d.v=new Date(N.y,N.m-1,N.d,N.H,N.M,N.S,N.u))}L&&("XLDAPR"==L.type&&(d.D=!0),L=void 0),O&&(O=void 0);break;case 1:case 12:if(!s.sheetStubs||A)break;d={t:"z",v:void 0},p=-1==e[0].c?p+1:e[0].c,s.dense?(l["!data"][h]||(l["!data"][h]=[]),l["!data"][h][p]=d):l[Ln(p)+b]=d,y.s.r>u.r&&(y.s.r=u.r),y.s.c>p&&(y.s.c=p),y.e.r<u.r&&(y.e.r=u.r),y.e.c<p&&(y.e.c=p),L&&("XLDAPR"==L.type&&(d.D=!0),L=void 0),O&&(O=void 0);break;case 176:E.push(e);break;case 49:L=((s.xlmeta||{}).Cell||[])[e-1];break;case 494:var U=r["!id"][e.relId];for(U?(e.Target=U.Target,e.loc&&(e.Target+="#"+e.loc),e.Rel=U):""==e.relId&&(e.Target="#"+e.loc),h=e.rfx.s.r;h<=e.rfx.e.r;++h)for(p=e.rfx.s.c;p<=e.rfx.e.c;++p)s.dense?(l["!data"][h]||(l["!data"][h]=[]),l["!data"][h][p]||(l["!data"][h][p]={t:"z",v:void 0}),l["!data"][h][p].l=e):(m=Ln(p)+kn(h),l[m]||(l[m]={t:"z",v:void 0}),l[m].l=e);break;case 426:if(!s.cellFormula)break;C.push(e),(_=s.dense?l["!data"][h][p]:l[Ln(p)+b]).f=co(e[1],0,{r:u.r,c:p},k,s),_.F=Dn(e[0]);break;case 427:if(!s.cellFormula)break;M[In(e[0].s)]=e[1],(_=s.dense?l["!data"][h][p]:l[Ln(p)+b]).f=co(e[1],0,{r:u.r,c:p},k,s);break;case 60:if(!s.cellStyles)break;for(;e.e>=e.s;)I[e.e--]={width:e.w/256,hidden:!!(1&e.flags),level:e.level},D||(D=!0,sa(e.w/256)),ca(I[e.e+1]);break;case 161:l["!autofilter"]={ref:Dn(e)};break;case 476:l["!margins"]=e;break;case 147:i.Sheets[n]||(i.Sheets[n]={}),e.name&&(i.Sheets[n].CodeName=e.name),(e.above||e.left)&&(l["!outline"]={above:e.above,left:e.left});break;case 137:i.Views||(i.Views=[{}]),i.Views[0]||(i.Views[0]={}),e.RTL&&(i.Views[0].RTL=!0);break;case 485:case 64:case 1053:case 151:case 152:case 175:case 644:case 625:case 562:case 396:case 1112:case 1146:case 471:case 1050:case 649:case 1105:case 589:case 607:case 564:case 1055:case 168:case 174:case 1180:case 499:case 507:case 550:case 171:case 167:case 1177:case 169:case 1181:case 551:case 552:case 661:case 639:case 478:case 537:case 477:case 536:case 1103:case 680:case 1104:case 1024:case 663:case 535:case 678:case 504:case 1043:case 428:case 170:case 3072:case 50:case 2070:case 1045:break;case 35:A=!0;break;case 36:A=!1;break;case 37:x.push(v),A=!0;break;case 38:x.pop(),A=!1;break;default:if(t.T);else if(!A||s.WTF)throw new Error("Unexpected record 0x"+v.toString(16))}}),s),delete s.supbooks,delete s["!row"],!l["!ref"]&&(y.s.r<2e6||c&&(c.e.r>0||c.e.c>0||c.s.r>0||c.s.c>0))&&(l["!ref"]=Dn(c||y)),s.sheetRows&&l["!ref"]){var N=Nn(l["!ref"]);s.sheetRows<=+N.e.r&&(N.e.r=s.sheetRows-1,N.e.r>y.e.r&&(N.e.r=y.e.r),N.e.r<N.s.r&&(N.s.r=N.e.r),N.e.c>y.e.c&&(N.e.c=y.e.c),N.e.c<N.s.c&&(N.s.c=N.e.c),l["!fullref"]=l["!ref"],l["!ref"]=Dn(N))}return E.length>0&&(l["!merges"]=E),I.length>0&&(l["!cols"]=I),P.length>0&&(l["!rows"]=P),l}(e,r,n,i,a,o,s):function(e,t,n,r,i,a,o){if(!e)return e;r||(r={"!id":{}}),null!=v&&null==t.dense&&(t.dense=v);var s={};t.dense&&(s["!data"]=[]);var c={s:{r:2e6,c:2e6},e:{r:0,c:0}},l="",u="",d=e.match(Mo);d?(l=e.slice(0,d.index),u=e.slice(d.index+d[0].length)):l=u=e;var f=l.match(Po);f?Uo(f[0],0,i,n):(f=l.match(Do))&&function(e,t,n,r,i){Uo(e.slice(0,e.indexOf(">")),0,r,i)}(f[0],f[1],0,i,n);var h=(l.match(/<(?:\w*:)?dimension/)||{index:-1}).index;if(h>0){var p=l.slice(h,h+50).match(Ro);!p||t&&t.nodim||function(e,t){var n=Nn(t);n.s.r<=n.e.r&&n.s.c<=n.e.c&&n.s.r>=0&&n.s.c>=0&&(e["!ref"]=Dn(n))}(s,p[1])}var m=l.match(No);m&&m[1]&&function(e,t){t.Views||(t.Views=[{}]),(e.match(Fo)||[]).forEach((function(e,n){var r=ut(e);t.Views[n]||(t.Views[n]={}),+r.zoomScale&&(t.Views[n].zoom=+r.zoomScale),r.rightToLeft&&_t(r.rightToLeft)&&(t.Views[n].RTL=!0)}))}(m[1],i);var g=[];if(t.cellStyles){var b=l.match(Lo);b&&function(e,t){for(var n=!1,r=0;r!=t.length;++r){var i=ut(t[r],!0);i.hidden&&(i.hidden=_t(i.hidden));var a=parseInt(i.min,10)-1,o=parseInt(i.max,10)-1;for(i.outlineLevel&&(i.level=+i.outlineLevel||0),delete i.min,delete i.max,i.width=+i.width,!n&&i.width&&(n=!0,sa(i.width)),ca(i);a<=o;)e[a++]=He(i)}}(g,b)}d&&Bo(d[1],s,t,c,a,o);var _=u.match(Oo);_&&(s["!autofilter"]=function(e){return{ref:(e.match(/ref="([^"]*)"/)||[])[1]}}(_[0]));var y=[],x=u.match(Co);if(x)for(h=0;h!=x.length;++h)y[h]=Nn(x[h].slice(x[h].indexOf('"')+1));var A=u.match(ko);A&&function(e,t,n){for(var r=null!=e["!data"],i=0;i!=t.length;++i){var a=ut(Et(t[i]),!0);if(!a.ref)return;var o=((n||{})["!id"]||[])[a.id];o?(a.Target=o.Target,a.location&&(a.Target+="#"+pt(a.location))):(a.Target="#"+pt(a.location),o={Target:a.Target,TargetMode:"Internal"}),a.Rel=o,a.tooltip&&(a.Tooltip=a.tooltip,delete a.tooltip);for(var s=Nn(a.ref),c=s.s.r;c<=s.e.r;++c)for(var l=s.s.c;l<=s.e.c;++l){var u=Ln(l)+kn(c);r?(e["!data"][c]||(e["!data"][c]=[]),e["!data"][c][l]||(e["!data"][c][l]={t:"z",v:void 0}),e["!data"][c][l].l=a):(e[u]||(e[u]={t:"z",v:void 0}),e[u].l=a)}}}(s,A,r);var w,E,T=u.match(Io);if(T&&(s["!margins"]=(w=ut(T[0]),E={},["left","right","top","bottom","header","footer"].forEach((function(e){w[e]&&(E[e]=parseFloat(w[e]))})),E)),t&&t.nodim&&(c.s.c=c.s.r=0),!s["!ref"]&&c.e.c>=c.s.c&&c.e.r>=c.s.r&&(s["!ref"]=Dn(c)),t.sheetRows>0&&s["!ref"]){var S=Nn(s["!ref"]);t.sheetRows<=+S.e.r&&(S.e.r=t.sheetRows-1,S.e.r>c.e.r&&(S.e.r=c.e.r),S.e.r<S.s.r&&(S.s.r=S.e.r),S.e.c>c.e.c&&(S.e.c=c.e.c),S.e.c<S.s.c&&(S.s.c=S.e.c),s["!fullref"]=s["!ref"],s["!ref"]=Dn(S))}return g.length>0&&(s["!cols"]=g),y.length>0&&(s["!merges"]=y),s}(e,r,n,i,a,o,s)}var ts,ns=/([\w:]+)=((?:")([^"]*)(?:")|(?:')([^']*)(?:'))/g,rs=/([\w:]+)=((?:")(?:[^"]*)(?:")|(?:')(?:[^']*)(?:'))/;function is(e,t){var n=e.split(/\s+/),r=[];if(t||(r[0]=n[0]),1===n.length)return r;var i,a,o,s=e.match(ns);if(s)for(o=0;o!=s.length;++o)-1===(a=(i=s[o].match(rs))[1].indexOf(":"))?r[i[1]]=i[2].slice(1,i[2].length-1):r["xmlns:"===i[1].slice(0,6)?"xmlns"+i[1].slice(6):i[1].slice(a+1)]=i[2].slice(1,i[2].length-1);return r}function as(e){var t={};if(1===e.split(/\s+/).length)return t;var n,r,i,a=e.match(ns);if(a)for(i=0;i!=a.length;++i)-1===(r=(n=a[i].match(rs))[1].indexOf(":"))?t[n[1]]=n[2].slice(1,n[2].length-1):t["xmlns:"===n[1].slice(0,6)?"xmlns"+n[1].slice(6):n[1].slice(r+1)]=n[2].slice(1,n[2].length-1);return t}function os(e,t,n,r){var i=r;switch((n[0].match(/dt:dt="([\w.]+)"/)||["",""])[1]){case"boolean":i=_t(r);break;case"i2":case"int":i=parseInt(r,10);break;case"r4":case"float":i=parseFloat(r);break;case"date":case"dateTime.tz":i=Be(r);break;case"i8":case"string":case"fixed":case"uuid":case"bin.base64":break;default:throw new Error("bad custprop:"+n[0])}e[pt(t)]=i}function ss(e,t,n){if(n.cellStyles&&t.Interior){var r=t.Interior;r.Pattern&&(r.patternType=fa[r.Pattern]||r.Pattern)}e[t.ID]=t}function cs(e,t,n,r,i,a,o,s,c,l){var u="General",d=r.StyleID,f={};l=l||{};var h=[],p=0;for(void 0===d&&s&&(d=s.StyleID),void 0===d&&o&&(d=o.StyleID);void 0!==a[d]&&(a[d].nf&&(u=a[d].nf),a[d].Interior&&h.push(a[d].Interior),a[d].Parent);)d=a[d].Parent;switch(n.Type){case"Boolean":r.t="b",r.v=_t(e);break;case"String":r.t="s",r.r=bt(pt(e)),r.v=e.indexOf("<")>-1?pt(t||e).replace(/<.*?>/g,""):r.r;break;case"DateTime":"Z"!=e.slice(-1)&&(e+="Z"),r.v=(Be(e)-new Date(Date.UTC(1899,11,30)))/864e5,r.v!=r.v?r.v=pt(e):r.v<60&&(r.v=r.v-1),u&&"General"!=u||(u="yyyy-mm-dd");case"Number":void 0===r.v&&(r.v=+e),r.t||(r.t="n");break;case"Error":r.t="e",r.v=mr[e],!1!==l.cellText&&(r.w=e);break;default:""==e&&""==t?r.t="z":(r.t="s",r.v=bt(t||e))}if(function(e,t,n){if("z"!==e.t){if(!n||!1!==n.cellText)try{"e"===e.t?e.w=e.w||pr[e.v]:"General"===t?"n"===e.t?(0|e.v)===e.v?e.w=e.v.toString(10):e.w=Z(e.v):e.w=J(e.v):e.w=(r=t||"General",i=e.v,"General"===(a=ts[r]||pt(r))?J(i):be(a,i))}catch(e){if(n.WTF)throw e}var r,i,a;try{var o=ts[t]||t||"General";if(n.cellNF&&(e.z=o),n.cellDates&&"n"==e.t&&me(o)){var s=W(e.v);s&&(e.t="d",e.v=new Date(s.y,s.m-1,s.d,s.H,s.M,s.S,s.u))}}catch(e){if(n.WTF)throw e}}}(r,u,l),!1!==l.cellFormula)if(r.Formula){var m=pt(r.Formula);61==m.charCodeAt(0)&&(m=m.slice(1)),r.f=La(m,i),delete r.Formula,"RC"==r.ArrayRange?r.F=La("RC:RC",i):r.ArrayRange&&(r.F=La(r.ArrayRange,i),c.push([Nn(r.F),r.F]))}else for(p=0;p<c.length;++p)i.r>=c[p][0].s.r&&i.r<=c[p][0].e.r&&i.c>=c[p][0].s.c&&i.c<=c[p][0].e.c&&(r.F=c[p][1]);l.cellStyles&&(h.forEach((function(e){!f.patternType&&e.patternType&&(f.patternType=e.patternType)})),r.s=f),void 0!==r.StyleID&&(r.ixfe=r.StyleID)}function ls(e){e.t=e.v||"",e.t=e.t.replace(/\r\n/g,"\n").replace(/\r/g,"\n"),e.v=e.w=e.ixfe=void 0}function us(e,n){var r=n||{};_e();var i=h(Pt(e));"binary"!=r.type&&"array"!=r.type&&"base64"!=r.type||(i=void 0!==t?t.utils.decode(65001,u(i)):Et(i));var a,o=i.slice(0,1024).toLowerCase(),s=!1;if((1023&(o=o.replace(/".*?"/g,"")).indexOf(">"))>Math.min(1023&o.indexOf(","),1023&o.indexOf(";"))){var c=He(r);return c.type="string",Ri.to_workbook(i,c)}if(-1==o.indexOf("<?xml")&&["html","table","head","meta","script","style","div"].forEach((function(e){o.indexOf("<"+e)>=0&&(s=!0)})),s)return function(e,t){var n=e.match(/<table[\s\S]*?>[\s\S]*?<\/table>/gi);if(!n||0==n.length)throw new Error("Invalid HTML: could not find <table>");if(1==n.length){var r=Fn(xs(n[0],t),t);return r.bookType="html",r}var i={SheetNames:[],Sheets:{}};return n.forEach((function(e,n){lc(i,xs(e,t),"Sheet"+(n+1))})),i.bookType="html",i}(i,r);ts={"General Number":"General","General Date":z[22],"Long Date":"dddd, mmmm dd, yyyy","Medium Date":z[15],"Short Date":z[14],"Long Time":z[19],"Medium Time":z[18],"Short Time":z[20],Currency:'"$"#,##0.00_);[Red]\\("$"#,##0.00\\)',Fixed:z[2],Standard:z[4],Percent:z[10],Scientific:z[11],"Yes/No":'"Yes";"Yes";"No";@',"True/False":'"True";"True";"False";@',"On/Off":'"Yes";"Yes";"No";@'};var l,d=[];null!=v&&null==r.dense&&(r.dense=v);var f={},p=[],m={},g="";r.dense&&(m["!data"]=[]);var b,_={},y={},x=is('<Data ss:Type="String">'),A=0,w=0,E=0,T={s:{r:2e6,c:2e6},e:{r:0,c:0}},S={},C={},M="",k=0,R=[],L={},O={},I=0,P=[],D=[],N={},U=[],F=!1,B=[],H=[],V={},G=0,$=0,W={Sheets:[],WBProps:{date1904:!1}},j={};Dt.lastIndex=0,i=i.replace(/<!--([\s\S]*?)-->/gm,"");for(var X,Y="";a=Dt.exec(i);)switch(a[3]=(Y=a[3]).toLowerCase()){case"data":if("data"==Y){if("/"===a[1]){if((l=d.pop())[0]!==a[3])throw new Error("Bad state: "+l.join("|"))}else"/"!==a[0].charAt(a[0].length-2)&&d.push([a[3],!0]);break}if(d[d.length-1][1])break;"/"===a[1]?cs(i.slice(A,a.index),M,x,"comment"==d[d.length-1][0]?N:_,{c:w,r:E},S,U[w],y,B,r):(M="",x=is(a[0]),A=a.index+a[0].length);break;case"cell":if("/"===a[1])if(D.length>0&&(_.c=D),(!r.sheetRows||r.sheetRows>E)&&void 0!==_.v&&(r.dense?(m["!data"][E]||(m["!data"][E]=[]),m["!data"][E][w]=_):m[Ln(w)+kn(E)]=_),_.HRef&&(_.l={Target:pt(_.HRef)},_.HRefScreenTip&&(_.l.Tooltip=_.HRefScreenTip),delete _.HRef,delete _.HRefScreenTip),(_.MergeAcross||_.MergeDown)&&(G=w+(0|parseInt(_.MergeAcross,10)),$=E+(0|parseInt(_.MergeDown,10)),(G>w||$>E)&&R.push({s:{c:w,r:E},e:{c:G,r:$}})),r.sheetStubs)if(_.MergeAcross||_.MergeDown){for(var q=w;q<=G;++q)for(var K=E;K<=$;++K)(q>w||K>E)&&(r.dense?(m["!data"][K]||(m["!data"][K]=[]),m["!data"][K][q]={t:"z"}):m[Ln(q)+kn(K)]={t:"z"});w=G+1}else++w;else _.MergeAcross?w=G+1:++w;else(_=as(a[0])).Index&&(w=+_.Index-1),w<T.s.c&&(T.s.c=w),w>T.e.c&&(T.e.c=w),"/>"===a[0].slice(-2)&&++w,D=[];break;case"row":"/"===a[1]||"/>"===a[0].slice(-2)?(E<T.s.r&&(T.s.r=E),E>T.e.r&&(T.e.r=E),"/>"===a[0].slice(-2)&&(y=is(a[0])).Index&&(E=+y.Index-1),w=0,++E):((y=is(a[0])).Index&&(E=+y.Index-1),V={},("0"==y.AutoFitHeight||y.Height)&&(V.hpx=parseInt(y.Height,10),V.hpt=ua(V.hpx),H[E]=V),"1"==y.Hidden&&(V.hidden=!0,H[E]=V));break;case"worksheet":if("/"===a[1]){if((l=d.pop())[0]!==a[3])throw new Error("Bad state: "+l.join("|"));p.push(g),T.s.r<=T.e.r&&T.s.c<=T.e.c&&(m["!ref"]=Dn(T),r.sheetRows&&r.sheetRows<=T.e.r&&(m["!fullref"]=m["!ref"],T.e.r=r.sheetRows-1,m["!ref"]=Dn(T))),R.length&&(m["!merges"]=R),U.length>0&&(m["!cols"]=U),H.length>0&&(m["!rows"]=H),f[g]=m}else T={s:{r:2e6,c:2e6},e:{r:0,c:0}},E=w=0,d.push([a[3],!1]),l=is(a[0]),g=pt(l.Name),m={},r.dense&&(m["!data"]=[]),R=[],B=[],H=[],j={name:g,Hidden:0},W.Sheets.push(j);break;case"table":if("/"===a[1]){if((l=d.pop())[0]!==a[3])throw new Error("Bad state: "+l.join("|"))}else{if("/>"==a[0].slice(-2))break;d.push([a[3],!1]),U=[],F=!1}break;case"style":"/"===a[1]?ss(S,C,r):C=is(a[0]);break;case"numberformat":C.nf=pt(is(a[0]).Format||"General"),ts[C.nf]&&(C.nf=ts[C.nf]);for(var Z=0;392!=Z&&z[Z]!=C.nf;++Z);if(392==Z)for(Z=57;392!=Z;++Z)if(null==z[Z]){we(C.nf,Z);break}break;case"column":if("table"!==d[d.length-1][0])break;if("/"===a[1])break;if((b=is(a[0])).Hidden&&(b.hidden=!0,delete b.Hidden),b.Width&&(b.wpx=parseInt(b.Width,10)),!F&&b.wpx>10){F=!0,na=Qi;for(var J=0;J<U.length;++J)U[J]&&ca(U[J])}F&&ca(b),U[b.Index-1||U.length]=b;for(var Q=0;Q<+b.Span;++Q)U[U.length]=He(b);break;case"namedrange":if("/"===a[1])break;W.Names||(W.Names=[]);var ee=ut(a[0]),te={Name:(X=ee.Name,vr.indexOf("_xlnm."+X)>-1?"_xlnm."+X:X),Ref:La(ee.RefersTo.slice(1),{r:0,c:0})};W.Sheets.length>0&&(te.Sheet=W.Sheets.length-1),W.Names.push(te);break;case"namedcell":case"b":case"i":case"u":case"s":case"em":case"h2":case"h3":case"sub":case"sup":case"span":case"alignment":case"borders":case"border":case"protection":case"paragraphs":case"name":case"pixelsperinch":case"null":break;case"font":if("/>"===a[0].slice(-2))break;"/"===a[1]?M+=i.slice(k,a.index):k=a.index+a[0].length;break;case"interior":if(!r.cellStyles)break;C.Interior=is(a[0]);break;case"author":case"title":case"description":case"created":case"keywords":case"subject":case"category":case"company":case"lastauthor":case"lastsaved":case"lastprinted":case"version":case"revision":case"totaltime":case"hyperlinkbase":case"manager":case"contentstatus":case"identifier":case"language":case"appname":if("/>"===a[0].slice(-2))break;"/"===a[1]?Rr(L,Y,i.slice(I,a.index)):I=a.index+a[0].length;break;case"styles":case"workbook":if("/"===a[1]){if((l=d.pop())[0]!==a[3])throw new Error("Bad state: "+l.join("|"))}else d.push([a[3],!1]);break;case"comment":if("/"===a[1]){if((l=d.pop())[0]!==a[3])throw new Error("Bad state: "+l.join("|"));ls(N),D.push(N)}else d.push([a[3],!1]),N={a:(l=is(a[0])).Author};break;case"autofilter":if("/"===a[1]){if((l=d.pop())[0]!==a[3])throw new Error("Bad state: "+l.join("|"))}else if("/"!==a[0].charAt(a[0].length-2)){var ne=is(a[0]);m["!autofilter"]={ref:La(ne.Range).replace(/\$/g,"")},d.push([a[3],!0])}break;case"datavalidation":if("/"===a[1]){if((l=d.pop())[0]!==a[3])throw new Error("Bad state: "+l.join("|"))}else"/"!==a[0].charAt(a[0].length-2)&&d.push([a[3],!0]);break;case"componentoptions":case"documentproperties":case"customdocumentproperties":case"officedocumentsettings":case"pivottable":case"pivotcache":case"names":case"mapinfo":case"pagebreaks":case"querytable":case"sorting":case"schema":case"conditionalformatting":case"smarttagtype":case"smarttags":case"excelworkbook":case"workbookoptions":case"worksheetoptions":if("/"===a[1]){if((l=d.pop())[0]!==a[3])throw new Error("Bad state: "+l.join("|"))}else"/"!==a[0].charAt(a[0].length-2)&&d.push([a[3],!0]);break;default:if(0==d.length&&"document"==a[3])return ks(i,r);if(0==d.length&&"uof"==a[3])return ks(i,r);var re=!0;switch(d[d.length-1][0]){case"officedocumentsettings":switch(a[3]){case"allowpng":case"removepersonalinformation":case"downloadcomponents":case"locationofcomponents":case"colors":case"color":case"index":case"rgb":case"targetscreensize":case"readonlyrecommended":break;default:re=!1}break;case"componentoptions":switch(a[3]){case"toolbar":case"hideofficelogo":case"spreadsheetautofit":case"label":case"caption":case"maxheight":case"maxwidth":case"nextsheetnumber":break;default:re=!1}break;case"excelworkbook":switch(a[3]){case"date1904":W.WBProps.date1904=!0;break;case"windowheight":case"windowwidth":case"windowtopx":case"windowtopy":case"tabratio":case"protectstructure":case"protectwindow":case"protectwindows":case"activesheet":case"displayinknotes":case"firstvisiblesheet":case"supbook":case"sheetname":case"sheetindex":case"sheetindexfirst":case"sheetindexlast":case"dll":case"acceptlabelsinformulas":case"donotsavelinkvalues":case"iteration":case"maxiterations":case"maxchange":case"path":case"xct":case"count":case"selectedsheets":case"calculation":case"uncalced":case"startupprompt":case"crn":case"externname":case"formula":case"colfirst":case"collast":case"wantadvise":case"boolean":case"error":case"text":case"ole":case"noautorecover":case"publishobjects":case"donotcalculatebeforesave":case"number":case"refmoder1c1":case"embedsavesmarttags":break;default:re=!1}break;case"workbookoptions":switch(a[3]){case"owcversion":case"height":case"width":break;default:re=!1}break;case"worksheetoptions":switch(a[3]){case"visible":if("/>"===a[0].slice(-2));else if("/"===a[1])switch(i.slice(I,a.index)){case"SheetHidden":j.Hidden=1;break;case"SheetVeryHidden":j.Hidden=2}else I=a.index+a[0].length;break;case"header":m["!margins"]||To(m["!margins"]={},"xlml"),isNaN(+ut(a[0]).Margin)||(m["!margins"].header=+ut(a[0]).Margin);break;case"footer":m["!margins"]||To(m["!margins"]={},"xlml"),isNaN(+ut(a[0]).Margin)||(m["!margins"].footer=+ut(a[0]).Margin);break;case"pagemargins":var ie=ut(a[0]);m["!margins"]||To(m["!margins"]={},"xlml"),isNaN(+ie.Top)||(m["!margins"].top=+ie.Top),isNaN(+ie.Left)||(m["!margins"].left=+ie.Left),isNaN(+ie.Right)||(m["!margins"].right=+ie.Right),isNaN(+ie.Bottom)||(m["!margins"].bottom=+ie.Bottom);break;case"displayrighttoleft":W.Views||(W.Views=[]),W.Views[0]||(W.Views[0]={}),W.Views[0].RTL=!0;break;case"freezepanes":case"frozennosplit":case"splithorizontal":case"splitvertical":case"donotdisplaygridlines":case"activerow":case"activecol":case"toprowbottompane":case"leftcolumnrightpane":case"unsynced":case"print":case"printerrors":case"panes":case"scale":case"pane":case"number":case"layout":case"pagesetup":case"selected":case"protectobjects":case"enableselection":case"protectscenarios":case"validprinterinfo":case"horizontalresolution":case"verticalresolution":case"numberofcopies":case"activepane":case"toprowvisible":case"leftcolumnvisible":case"fittopage":case"rangeselection":case"papersizeindex":case"pagelayoutzoom":case"pagebreakzoom":case"filteron":case"fitwidth":case"fitheight":case"commentslayout":case"zoom":case"lefttoright":case"gridlines":case"allowsort":case"allowfilter":case"allowinsertrows":case"allowdeleterows":case"allowinsertcols":case"allowdeletecols":case"allowinserthyperlinks":case"allowformatcells":case"allowsizecols":case"allowsizerows":case"tabcolorindex":case"donotdisplayheadings":case"showpagelayoutzoom":case"blackandwhite":case"donotdisplayzeros":case"displaypagebreak":case"rowcolheadings":case"donotdisplayoutline":case"noorientation":case"allowusepivottables":case"zeroheight":case"viewablerange":case"selection":case"protectcontents":break;case"nosummaryrowsbelowdetail":m["!outline"]||(m["!outline"]={}),m["!outline"].above=!0;break;case"nosummarycolumnsrightdetail":m["!outline"]||(m["!outline"]={}),m["!outline"].left=!0;break;default:re=!1}break;case"pivottable":case"pivotcache":switch(a[3]){case"immediateitemsondrop":case"showpagemultipleitemlabel":case"compactrowindent":case"location":case"pivotfield":case"orientation":case"layoutform":case"layoutsubtotallocation":case"layoutcompactrow":case"position":case"pivotitem":case"datatype":case"datafield":case"sourcename":case"parentfield":case"ptlineitems":case"ptlineitem":case"countofsameitems":case"item":case"itemtype":case"ptsource":case"cacheindex":case"consolidationreference":case"filename":case"reference":case"nocolumngrand":case"norowgrand":case"blanklineafteritems":case"hidden":case"subtotal":case"basefield":case"mapchilditems":case"function":case"refreshonfileopen":case"printsettitles":case"mergelabels":case"defaultversion":case"refreshname":case"refreshdate":case"refreshdatecopy":case"versionlastrefresh":case"versionlastupdate":case"versionupdateablemin":case"versionrefreshablemin":case"calculation":break;default:re=!1}break;case"pagebreaks":switch(a[3]){case"colbreaks":case"colbreak":case"rowbreaks":case"rowbreak":case"colstart":case"colend":case"rowend":break;default:re=!1}break;case"autofilter":switch(a[3]){case"autofiltercolumn":case"autofiltercondition":case"autofilterand":case"autofilteror":break;default:re=!1}break;case"querytable":switch(a[3]){case"id":case"autoformatfont":case"autoformatpattern":case"querysource":case"querytype":case"enableredirections":case"refreshedinxl9":case"urlstring":case"htmltables":case"connection":case"commandtext":case"refreshinfo":case"notitles":case"nextid":case"columninfo":case"overwritecells":case"donotpromptforfile":case"textwizardsettings":case"source":case"number":case"decimal":case"thousandseparator":case"trailingminusnumbers":case"formatsettings":case"fieldtype":case"delimiters":case"tab":case"comma":case"autoformatname":case"versionlastedit":case"versionlastrefresh":break;default:re=!1}break;case"datavalidation":switch(a[3]){case"range":case"type":case"min":case"max":case"sort":case"descending":case"order":case"casesensitive":case"value":case"errorstyle":case"errormessage":case"errortitle":case"inputmessage":case"inputtitle":case"combohide":case"inputhide":case"condition":case"qualifier":case"useblank":case"value1":case"value2":case"format":case"cellrangelist":break;default:re=!1}break;case"sorting":case"conditionalformatting":switch(a[3]){case"range":case"type":case"min":case"max":case"sort":case"descending":case"order":case"casesensitive":case"value":case"errorstyle":case"errormessage":case"errortitle":case"cellrangelist":case"inputmessage":case"inputtitle":case"combohide":case"inputhide":case"condition":case"qualifier":case"useblank":case"value1":case"value2":case"format":break;default:re=!1}break;case"mapinfo":case"schema":case"data":switch(a[3]){case"map":case"entry":case"range":case"xpath":case"field":case"xsdtype":case"filteron":case"aggregate":case"elementtype":case"attributetype":case"schema":case"element":case"complextype":case"datatype":case"all":case"attribute":case"extends":case"row":break;default:re=!1}break;case"smarttags":break;default:re=!1}if(re)break;if(a[3].match(/!\[CDATA/))break;if(!d[d.length-1][1])throw"Unrecognized tag: "+a[3]+"|"+d.join("|");if("customdocumentproperties"===d[d.length-1][0]){if("/>"===a[0].slice(-2))break;"/"===a[1]?os(O,Y,P,i.slice(I,a.index)):(P=a,I=a.index+a[0].length);break}if(r.WTF)throw"Unrecognized tag: "+a[3]+"|"+d.join("|")}var ae={};return r.bookSheets||r.bookProps||(ae.Sheets=f),ae.SheetNames=p,ae.Workbook=W,ae.SSF=He(z),ae.Props=L,ae.Custprops=O,ae.bookType="xlml",ae}function ds(e,t){switch(Xs(t=t||{}),t.type||"base64"){case"base64":return us(_(e),t);case"binary":case"buffer":case"file":return us(e,t);case"array":return us(S(e),t)}}var fs=[60,1084,2066,2165,2175];function hs(e,t,n,r,i){var a=r,o=[],s=n.slice(n.l,n.l+a);if(i&&i.enc&&i.enc.insitu&&s.length>0)switch(e){case 9:case 521:case 1033:case 2057:case 47:case 405:case 225:case 406:case 312:case 404:case 10:case 133:break;default:i.enc.insitu(s)}o.push(s),n.l+=a;for(var c=cn(n,n.l),l=_s[c],u=0;null!=l&&fs.indexOf(c)>-1;)a=cn(n,n.l+2),u=n.l+4,2066==c?u+=4:2165!=c&&2175!=c||(u+=12),s=n.slice(u,n.l+4+a),o.push(s),n.l+=4+a,l=_s[c=cn(n,n.l)];var d=M(o);_n(d,0);var f=0;d.lens=[];for(var h=0;h<o.length;++h)d.lens.push(f),f+=o[h].length;if(d.length<r)throw"XLS Record 0x"+e.toString(16)+" Truncated: "+d.length+" < "+r;return t.f(d,d.length,i)}function ps(e,t,n){if("z"!==e.t&&e.XF){var r=0;try{r=e.z||e.XF.numFmtId||0,t.cellNF&&(e.z=z[r])}catch(e){if(t.WTF)throw e}if(!t||!1!==t.cellText)try{"e"===e.t?e.w=e.w||pr[e.v]:0===r||"General"==r?"n"===e.t?(0|e.v)===e.v?e.w=e.v.toString(10):e.w=Z(e.v):e.w=J(e.v):e.w=be(r,e.v,{date1904:!!n,dateNF:t&&t.dateNF})}catch(e){if(t.WTF)throw e}if(t.cellDates&&r&&"n"==e.t&&me(z[r]||String(r))){var i=W(e.v);i&&(e.t="d",e.v=new Date(i.y,i.m-1,i.d,i.H,i.M,i.S,i.u))}}}function ms(e,t,n){return{v:e,ixfe:t,t:n}}var vs={SI:"e0859ff2f94f6810ab9108002b27b3d9",DSI:"02d5cdd59c2e1b10939708002b2cf9ae",UDI:"05d5cdd59c2e1b10939708002b2cf9ae"};function gs(e,t){var n,r,i,a;if(t||(t={}),Xs(t),l(),t.codepage&&s(t.codepage),e.FullPaths){if(Se.find(e,"/encryption"))throw new Error("File is password-protected");n=Se.find(e,"!CompObj"),r=Se.find(e,"/Workbook")||Se.find(e,"/Book")}else{switch(t.type){case"base64":e=T(_(e));break;case"binary":e=T(e);break;case"buffer":break;case"array":Array.isArray(e)||(e=Array.prototype.slice.call(e))}_n(e,0),r={content:e}}if(n&&function(e){var t={},n=e.content;if(n.l=28,t.AnsiUserType=n.read_shift(0,"lpstr-ansi"),t.AnsiClipboardFormat=function(e){return tr(e,1)}(n),n.length-n.l<=4)return t;var r=n.read_shift(4);0==r||r>40||(n.l-=4,t.Reserved1=n.read_shift(0,"lpstr-ansi"),n.length-n.l<=4||1907505652!==(r=n.read_shift(4))||(t.UnicodeClipboardFormat=function(e){return tr(e,2)}(n),0==(r=n.read_shift(4))||r>40||(n.l-=4,t.Reserved2=n.read_shift(0,"lpwstr"))))}(n),t.bookProps&&!t.bookSheets)i={};else{var o=y?"buffer":"array";if(r&&r.content)i=function(e,t){var n={opts:{}},r={};null!=v&&null==t.dense&&(t.dense=v);var i={};t.dense&&(i["!data"]=[]);var a,o,s,l,u,d,f,h,p={},m={},g=null,b=[],_="",y={},x="",A={},w=[],E=[],T=[],S={Sheets:[],WBProps:{date1904:!1},Views:[{}]},C={},M=function(e){return e<8?hr[e]:e<64&&T[e-8]||hr[e]},k=function(e,t,n){if(!(B>1||n.sheetRows&&e.r>=n.sheetRows)){if(n.cellStyles&&t.XF&&t.XF.data&&function(e,t,n){var r,i=t.XF.data;i&&i.patternType&&n&&n.cellStyles&&(t.s={},t.s.patternType=i.patternType,(r=Zi(M(i.icvFore)))&&(t.s.fgColor={rgb:r}),(r=Zi(M(i.icvBack)))&&(t.s.bgColor={rgb:r}))}(0,t,n),delete t.ixfe,delete t.XF,a=e,x=In(e),m&&m.s&&m.e||(m={s:{r:0,c:0},e:{r:0,c:0}}),e.r<m.s.r&&(m.s.r=e.r),e.c<m.s.c&&(m.s.c=e.c),e.r+1>m.e.r&&(m.e.r=e.r+1),e.c+1>m.e.c&&(m.e.c=e.c+1),n.cellFormula&&t.f)for(var r=0;r<w.length;++r)if(!(w[r][0].s.c>e.c||w[r][0].s.r>e.r||w[r][0].e.c<e.c||w[r][0].e.r<e.r)){t.F=Dn(w[r][0]),w[r][0].s.c==e.c&&w[r][0].s.r==e.r||delete t.f,t.f&&(t.f=""+co(w[r][1],0,e,N,R));break}n.dense?(i["!data"][e.r]||(i["!data"][e.r]=[]),i["!data"][e.r][e.c]=t):i[x]=t}},R={enc:!1,sbcch:0,snames:[],sharedf:A,arrayf:w,rrtabid:[],lastuser:"",biff:8,codepage:0,winlocked:0,cellStyles:!!t&&!!t.cellStyles,WTF:!!t&&!!t.wtf};t.password&&(R.password=t.password);var L=[],O=[],I=[],P=[],D=!1,N=[];N.SheetNames=R.snames,N.sharedf=R.sharedf,N.arrayf=R.arrayf,N.names=[],N.XTI=[];var U,F=0,B=0,H=0,V=[],G=[];R.codepage=1200,c(1200);for(var $=!1;e.l<e.length-1;){var W=e.l,j=e.read_shift(2);if(0===j&&10===F)break;var X=e.l===e.length?0:e.read_shift(2),Y=_s[j];if(0==B&&-1==[9,521,1033,2057].indexOf(j))break;if(Y&&Y.f){if(t.bookSheets&&133===F&&133!==j)break;if(F=j,2===Y.r||12==Y.r){var q=e.read_shift(2);if(X-=2,!R.enc&&q!==j&&((255&q)<<8|q>>8)!==j)throw new Error("rt mismatch: "+q+"!="+j);12==Y.r&&(e.l+=10,X-=10)}var K={};if(K=10===j?Y.f(e,X,R):hs(j,Y,e,X,R),0==B&&-1===[9,521,1033,2057].indexOf(F))continue;switch(j){case 34:n.opts.Date1904=S.WBProps.date1904=K;break;case 134:n.opts.WriteProtect=!0;break;case 47:if(R.enc||(e.l=0),R.enc=K,!t.password)throw new Error("File is password-protected");if(null==K.valid)throw new Error("Encryption scheme unsupported");if(!K.valid)throw new Error("Password is incorrect");break;case 92:R.lastuser=K;break;case 66:var Z=Number(K);switch(Z){case 21010:Z=1200;break;case 32768:Z=1e4;break;case 32769:Z=1252}c(R.codepage=Z),$=!0;break;case 317:R.rrtabid=K;break;case 25:R.winlocked=K;break;case 439:n.opts.RefreshAll=K;break;case 12:n.opts.CalcCount=K;break;case 16:n.opts.CalcDelta=K;break;case 17:n.opts.CalcIter=K;break;case 13:n.opts.CalcMode=K;break;case 14:n.opts.CalcPrecision=K;break;case 95:n.opts.CalcSaveRecalc=K;break;case 15:R.CalcRefMode=K;break;case 2211:n.opts.FullCalc=K;break;case 129:K.fDialog&&(i["!type"]="dialog"),K.fBelow||((i["!outline"]||(i["!outline"]={})).above=!0),K.fRight||((i["!outline"]||(i["!outline"]={})).left=!0);break;case 224:E.push(K);break;case 430:N.push([K]),N[N.length-1].XTI=[];break;case 35:case 547:N[N.length-1].push(K);break;case 24:case 536:U={Name:K.Name,Ref:co(K.rgce,0,null,N,R)},K.itab>0&&(U.Sheet=K.itab-1),N.names.push(U),N[0]||(N[0]=[],N[0].XTI=[]),N[N.length-1].push(K),"_xlnm._FilterDatabase"==K.Name&&K.itab>0&&K.rgce&&K.rgce[0]&&K.rgce[0][0]&&"PtgArea3d"==K.rgce[0][0][0]&&(G[K.itab-1]={ref:Dn(K.rgce[0][0][1][2])});break;case 22:R.ExternCount=K;break;case 23:0==N.length&&(N[0]=[],N[0].XTI=[]),N[N.length-1].XTI=N[N.length-1].XTI.concat(K),N.XTI=N.XTI.concat(K);break;case 2196:if(R.biff<8)break;null!=U&&(U.Comment=K[1]);break;case 18:i["!protect"]=K;break;case 19:0!==K&&R.WTF&&console.error("Password verifier: "+K);break;case 133:p[K.pos]=K,R.snames.push(K.name);break;case 10:if(--B)break;if(m.e){if(m.e.r>0&&m.e.c>0){if(m.e.r--,m.e.c--,i["!ref"]=Dn(m),t.sheetRows&&t.sheetRows<=m.e.r){var J=m.e.r;m.e.r=t.sheetRows-1,i["!fullref"]=i["!ref"],i["!ref"]=Dn(m),m.e.r=J}m.e.r++,m.e.c++}L.length>0&&(i["!merges"]=L),O.length>0&&(i["!objects"]=O),I.length>0&&(i["!cols"]=I),P.length>0&&(i["!rows"]=P),S.Sheets.push(C)}""===_?y=i:r[_]=i,i={},t.dense&&(i["!data"]=[]);break;case 9:case 521:case 1033:case 2057:if(8===R.biff&&(R.biff={9:2,521:3,1033:4}[j]||{512:2,768:3,1024:4,1280:5,1536:8,2:2,7:2}[K.BIFFVer]||8),R.biffguess=0==K.BIFFVer,0==K.BIFFVer&&4096==K.dt&&(R.biff=5,$=!0,c(R.codepage=28591)),8==R.biff&&0==K.BIFFVer&&16==K.dt&&(R.biff=2),B++)break;if(i={},t.dense&&(i["!data"]=[]),R.biff<8&&!$&&($=!0,c(R.codepage=t.codepage||1252)),R.biff<5||0==K.BIFFVer&&4096==K.dt){""===_&&(_="Sheet1"),m={s:{r:0,c:0},e:{r:0,c:0}};var Q={pos:e.l-X,name:_};p[Q.pos]=Q,R.snames.push(_)}else _=(p[W]||{name:""}).name;32==K.dt&&(i["!type"]="chart"),64==K.dt&&(i["!type"]="macro"),L=[],O=[],R.arrayf=w=[],I=[],P=[],D=!1,C={Hidden:(p[W]||{hs:0}).hs,name:_};break;case 515:case 3:case 2:"chart"==i["!type"]&&(t.dense?(i["!data"][K.r]||[])[K.c]:i[Ln(K.c)+kn(K.r)])&&++K.c,d={ixfe:K.ixfe,XF:E[K.ixfe]||{},v:K.val,t:"n"},H>0&&(d.z=V[d.ixfe>>8&63]),ps(d,t,n.opts.Date1904),k({c:K.c,r:K.r},d,t);break;case 5:case 517:d={ixfe:K.ixfe,XF:E[K.ixfe],v:K.val,t:K.t},H>0&&(d.z=V[d.ixfe>>8&63]),ps(d,t,n.opts.Date1904),k({c:K.c,r:K.r},d,t);break;case 638:d={ixfe:K.ixfe,XF:E[K.ixfe],v:K.rknum,t:"n"},H>0&&(d.z=V[d.ixfe>>8&63]),ps(d,t,n.opts.Date1904),k({c:K.c,r:K.r},d,t);break;case 189:for(var ee=K.c;ee<=K.C;++ee){var te=K.rkrec[ee-K.c][0];d={ixfe:te,XF:E[te],v:K.rkrec[ee-K.c][1],t:"n"},H>0&&(d.z=V[d.ixfe>>8&63]),ps(d,t,n.opts.Date1904),k({c:ee,r:K.r},d,t)}break;case 6:case 518:case 1030:if("String"==K.val){g=K;break}if((d=ms(K.val,K.cell.ixfe,K.tt)).XF=E[d.ixfe],t.cellFormula){var ne=K.formula;if(ne&&ne[0]&&ne[0][0]&&"PtgExp"==ne[0][0][0]){var re=ne[0][0][1][0],ie=ne[0][0][1][1],ae=In({r:re,c:ie});A[ae]?d.f=""+co(K.formula,0,K.cell,N,R):d.F=((t.dense?(i["!data"][re]||[])[ie]:i[ae])||{}).F}else d.f=""+co(K.formula,0,K.cell,N,R)}H>0&&(d.z=V[d.ixfe>>8&63]),ps(d,t,n.opts.Date1904),k(K.cell,d,t),g=K;break;case 7:case 519:if(!g)throw new Error("String record expects Formula");g.val=K,(d=ms(K,g.cell.ixfe,"s")).XF=E[d.ixfe],t.cellFormula&&(d.f=""+co(g.formula,0,g.cell,N,R)),H>0&&(d.z=V[d.ixfe>>8&63]),ps(d,t,n.opts.Date1904),k(g.cell,d,t),g=null;break;case 33:case 545:w.push(K);var oe=In(K[0].s);if(o=t.dense?(i["!data"][K[0].s.r]||[])[K[0].s.c]:i[oe],t.cellFormula&&o){if(!g)break;if(!oe||!o)break;o.f=""+co(K[1],0,K[0],N,R),o.F=Dn(K[0])}break;case 1212:if(!t.cellFormula)break;if(x){if(!g)break;A[In(g.cell)]=K[0],((o=t.dense?(i["!data"][g.cell.r]||[])[g.cell.c]:i[In(g.cell)])||{}).f=""+co(K[0],0,a,N,R)}break;case 253:d=ms(b[K.isst].t,K.ixfe,"s"),b[K.isst].h&&(d.h=b[K.isst].h),d.XF=E[d.ixfe],H>0&&(d.z=V[d.ixfe>>8&63]),ps(d,t,n.opts.Date1904),k({c:K.c,r:K.r},d,t);break;case 513:t.sheetStubs&&(d={ixfe:K.ixfe,XF:E[K.ixfe],t:"z"},H>0&&(d.z=V[d.ixfe>>8&63]),ps(d,t,n.opts.Date1904),k({c:K.c,r:K.r},d,t));break;case 190:if(t.sheetStubs)for(var se=K.c;se<=K.C;++se){var ce=K.ixfe[se-K.c];d={ixfe:ce,XF:E[ce],t:"z"},H>0&&(d.z=V[d.ixfe>>8&63]),ps(d,t,n.opts.Date1904),k({c:se,r:K.r},d,t)}break;case 214:case 516:case 4:(d=ms(K.val,K.ixfe,"s")).XF=E[d.ixfe],H>0&&(d.z=V[d.ixfe>>8&63]),ps(d,t,n.opts.Date1904),k({c:K.c,r:K.r},d,t);break;case 0:case 512:1===B&&(m=K);break;case 252:b=K;break;case 1054:if(4==R.biff){V[H++]=K[1];for(var le=0;le<H+163&&z[le]!=K[1];++le);le>=163&&we(K[1],H+163)}else we(K[1],K[0]);break;case 30:V[H++]=K;for(var ue=0;ue<H+163&&z[ue]!=K;++ue);ue>=163&&we(K,H+163);break;case 229:L=L.concat(K);break;case 93:O[K.cmo[0]]=R.lastobj=K;break;case 438:R.lastobj.TxO=K;break;case 127:R.lastobj.ImData=K;break;case 440:for(u=K[0].s.r;u<=K[0].e.r;++u)for(l=K[0].s.c;l<=K[0].e.c;++l)(o=t.dense?(i["!data"][u]||[])[l]:i[In({c:l,r:u})])&&(o.l=K[1]);break;case 2048:for(u=K[0].s.r;u<=K[0].e.r;++u)for(l=K[0].s.c;l<=K[0].e.c;++l)(o=t.dense?(i["!data"][u]||[])[l]:i[In({c:l,r:u})])&&o.l&&(o.l.Tooltip=K[1]);break;case 28:if(R.biff<=5&&R.biff>=2)break;o=t.dense?(i["!data"][K[0].r]||[])[K[0].c]:i[In(K[0])];var de=O[K[2]];o||(t.dense?(i["!data"][K[0].r]||(i["!data"][K[0].r]=[]),o=i["!data"][K[0].r][K[0].c]={t:"z"}):o=i[In(K[0])]={t:"z"},m.e.r=Math.max(m.e.r,K[0].r),m.s.r=Math.min(m.s.r,K[0].r),m.e.c=Math.max(m.e.c,K[0].c),m.s.c=Math.min(m.s.c,K[0].c)),o.c||(o.c=[]),s={a:K[1],t:de.TxO.t},o.c.push(s);break;case 2173:E[K.ixfe],K.ext.forEach((function(e){e[0]}));break;case 125:if(!R.cellStyles)break;for(;K.e>=K.s;)I[K.e--]={width:K.w/256,level:K.level||0,hidden:!!(1&K.flags)},D||(D=!0,sa(K.w/256)),ca(I[K.e+1]);break;case 520:var fe={};null!=K.level&&(P[K.r]=fe,fe.level=K.level),K.hidden&&(P[K.r]=fe,fe.hidden=!0),K.hpt&&(P[K.r]=fe,fe.hpt=K.hpt,fe.hpx=da(K.hpt));break;case 38:case 39:case 40:case 41:i["!margins"]||To(i["!margins"]={}),i["!margins"][{38:"left",39:"right",40:"top",41:"bottom"}[j]]=K;break;case 161:i["!margins"]||To(i["!margins"]={}),i["!margins"].header=K.header,i["!margins"].footer=K.footer;break;case 574:K.RTL&&(S.Views[0].RTL=!0);break;case 146:T=K;break;case 2198:h=K;break;case 140:f=K;break;case 442:_?C.CodeName=K||C.name:S.WBProps.CodeName=K||"ThisWorkbook"}}else Y||console.error("Missing Info for XLS Record 0x"+j.toString(16)),e.l+=X}return n.SheetNames=Ce(p).sort((function(e,t){return Number(e)-Number(t)})).map((function(e){return p[e].name})),t.bookSheets||(n.Sheets=r),!n.SheetNames.length&&y["!ref"]?(n.SheetNames.push("Sheet1"),n.Sheets&&(n.Sheets.Sheet1=y)):n.Preamble=y,n.Sheets&&G.forEach((function(e,t){n.Sheets[n.SheetNames[t]]["!autofilter"]=e})),n.Strings=b,n.SSF=He(z),R.enc&&(n.Encryption=R.enc),h&&(n.Themes=h),n.Metadata={},void 0!==f&&(n.Metadata.Country=f),N.names.length>0&&(S.Names=N.names),n.Workbook=S,n}(r.content,t);else if((a=Se.find(e,"PerfectOffice_MAIN"))&&a.content)i=Li.to_workbook(a.content,(t.type=o,t));else{if(!(a=Se.find(e,"NativeContent_MAIN"))||!a.content)throw(a=Se.find(e,"MN0"))&&a.content?new Error("Unsupported Works 4 for Mac file"):new Error("Cannot find Workbook stream");i=Li.to_workbook(a.content,(t.type=o,t))}t.bookVBA&&e.FullPaths&&Se.find(e,"/_VBA_PROJECT_CUR/VBA/dir")&&(i.vbaraw=function(e){var t=Se.utils.cfb_new({root:"R"});return e.FullPaths.forEach((function(n,r){if("/"!==n.slice(-1)&&n.match(/_VBA_PROJECT_CUR/)){var i=n.replace(/^[^\/]*/,"R").replace(/\/_VBA_PROJECT_CUR\u0000*/,"");Se.utils.cfb_add(t,i,e.FileIndex[r].content)}})),Se.write(t)}(e))}var u={};return e.FullPaths&&function(e,t,n){var r=Se.find(e,"/!DocumentSummaryInformation");if(r&&r.size>0)try{var i=Hr(r,cr,vs.DSI);for(var a in i)t[a]=i[a]}catch(e){if(n.WTF)throw e}var o=Se.find(e,"/!SummaryInformation");if(o&&o.size>0)try{var s=Hr(o,lr,vs.SI);for(var c in s)null==t[c]&&(t[c]=s[c])}catch(e){if(n.WTF)throw e}t.HeadingPairs&&t.TitlesOfParts&&(Sr(t.HeadingPairs,t.TitlesOfParts,t,n),delete t.HeadingPairs,delete t.TitlesOfParts)}(e,u,t),i.Props=i.Custprops=u,t.bookFiles&&(i.cfb=e),i}var bs={0:{f:function(e,t){var n={},r=e.l+t;n.r=e.read_shift(4),e.l+=4;var i=e.read_shift(2);e.l+=1;var a=e.read_shift(1);return e.l=r,7&a&&(n.level=7&a),16&a&&(n.hidden=!0),32&a&&(n.hpt=i/20),n}},1:{f:function(e){return[Wn(e)]}},2:{f:function(e){return[Wn(e),Zn(e),"n"]}},3:{f:function(e){return[Wn(e),e.read_shift(1),"e"]}},4:{f:function(e){return[Wn(e),e.read_shift(1),"b"]}},5:{f:function(e){return[Wn(e),er(e),"n"]}},6:{f:function(e){return[Wn(e),Hn(e),"str"]}},7:{f:function(e){return[Wn(e),e.read_shift(4),"s"]}},8:{f:function(e,t,n){var r=e.l+t,i=Wn(e);i.r=n["!row"];var a=[i,Hn(e),"str"];if(n.cellFormula){e.l+=2;var o=mo(e,r-e.l,n);a[3]=co(o,0,i,n.supbooks,n)}else e.l=r;return a}},9:{f:function(e,t,n){var r=e.l+t,i=Wn(e);i.r=n["!row"];var a=[i,er(e),"n"];if(n.cellFormula){e.l+=2;var o=mo(e,r-e.l,n);a[3]=co(o,0,i,n.supbooks,n)}else e.l=r;return a}},10:{f:function(e,t,n){var r=e.l+t,i=Wn(e);i.r=n["!row"];var a=[i,e.read_shift(1),"b"];if(n.cellFormula){e.l+=2;var o=mo(e,r-e.l,n);a[3]=co(o,0,i,n.supbooks,n)}else e.l=r;return a}},11:{f:function(e,t,n){var r=e.l+t,i=Wn(e);i.r=n["!row"];var a=[i,e.read_shift(1),"e"];if(n.cellFormula){e.l+=2;var o=mo(e,r-e.l,n);a[3]=co(o,0,i,n.supbooks,n)}else e.l=r;return a}},12:{f:function(e){return[jn(e)]}},13:{f:function(e){return[jn(e),Zn(e),"n"]}},14:{f:function(e){return[jn(e),e.read_shift(1),"e"]}},15:{f:function(e){return[jn(e),e.read_shift(1),"b"]}},16:{f:Ho},17:{f:function(e){return[jn(e),Hn(e),"str"]}},18:{f:function(e){return[jn(e),e.read_shift(4),"s"]}},19:{f:Gn},20:{},21:{},22:{},23:{},24:{},25:{},26:{},27:{},28:{},29:{},30:{},31:{},32:{},33:{},34:{},35:{T:1},36:{T:-1},37:{T:1},38:{T:-1},39:{f:function(e,t,n){var r=e.l+t,i=e.read_shift(4);e.l+=1;var a=e.read_shift(4),o=qn(e),s=vo(e,0,n),c=Yn(e);32&i&&(o="_xlnm."+o),e.l=r;var l={Name:o,Ptg:s,Flags:i};return a<268435455&&(l.Sheet=a),c&&(l.Comment=c),l}},40:{},42:{},43:{f:function(e,t,n){var r={};r.sz=e.read_shift(2)/20;var i=function(e){var t=e.read_shift(1);return e.l++,{fBold:1&t,fItalic:2&t,fUnderline:4&t,fStrikeout:8&t,fOutline:16&t,fShadow:32&t,fCondense:64&t,fExtend:128&t}}(e);switch(i.fItalic&&(r.italic=1),i.fCondense&&(r.condense=1),i.fExtend&&(r.extend=1),i.fShadow&&(r.shadow=1),i.fOutline&&(r.outline=1),i.fStrikeout&&(r.strike=1),700===e.read_shift(2)&&(r.bold=1),e.read_shift(2)){case 1:r.vertAlign="superscript";break;case 2:r.vertAlign="subscript"}var a=e.read_shift(1);0!=a&&(r.underline=a);var o=e.read_shift(1);o>0&&(r.family=o);var s=e.read_shift(1);switch(s>0&&(r.charset=s),e.l++,r.color=function(e){var t={},n=e.read_shift(1)>>>1,r=e.read_shift(1),i=e.read_shift(2,"i"),a=e.read_shift(1),o=e.read_shift(1),s=e.read_shift(1);switch(e.l++,n){case 0:t.auto=1;break;case 1:t.index=r;var c=hr[r];c&&(t.rgb=Zi(c));break;case 2:t.rgb=Zi([a,o,s]);break;case 3:t.theme=r}return 0!=i&&(t.tint=i>0?i/32767:i/32768),t}(e),e.read_shift(1)){case 1:r.scheme="major";break;case 2:r.scheme="minor"}return r.name=Hn(e),r}},44:{f:function(e,t){return[e.read_shift(2),Hn(e)]}},45:{f:va},46:{f:ga},47:{f:function(e,t){var n=e.l+t,r=e.read_shift(2),i=e.read_shift(2);return e.l=n,{ixfe:r,numFmtId:i}}},48:{},49:{f:function(e){return e.read_shift(4,"i")}},50:{},51:{f:function(e){for(var t=[],n=e.read_shift(4);n-- >0;)t.push([e.read_shift(4),e.read_shift(4)]);return t}},52:{T:1},53:{T:-1},54:{T:1},55:{T:-1},56:{T:1},57:{T:-1},58:{},59:{},60:{f:xi},62:{f:function(e){return[Wn(e),Gn(e),"is"]}},63:{f:function(e){var t={};t.i=e.read_shift(4);var n={};n.r=e.read_shift(4),n.c=e.read_shift(4),t.r=In(n);var r=e.read_shift(1);return 2&r&&(t.l="1"),8&r&&(t.a="1"),t}},64:{f:function(){}},65:{},66:{},67:{},68:{},69:{},70:{},128:{},129:{T:1},130:{T:-1},131:{T:1,f:yn,p:0},132:{T:-1},133:{T:1},134:{T:-1},135:{T:1},136:{T:-1},137:{T:1,f:function(e){var t=e.read_shift(2);return e.l+=28,{RTL:32&t}}},138:{T:-1},139:{T:1},140:{T:-1},141:{T:1},142:{T:-1},143:{T:1},144:{T:-1},145:{T:1},146:{T:-1},147:{f:function(e,t){var n={},r=e[e.l];return++e.l,n.above=!(64&r),n.left=!(128&r),e.l+=18,n.name=Xn(e,t-19),n}},148:{f:zo,p:16},151:{f:function(){}},152:{},153:{f:function(e,t){var n={},r=e.read_shift(4);n.defaultThemeVersion=e.read_shift(4);var i=t>8?Hn(e):"";return i.length>0&&(n.CodeName=i),n.autoCompressPictures=!!(65536&r),n.backupFile=!!(64&r),n.checkCompatibility=!!(4096&r),n.date1904=!!(1&r),n.filterPrivacy=!!(8&r),n.hidePivotFieldList=!!(1024&r),n.promptedSolutions=!!(16&r),n.publishItems=!!(2048&r),n.refreshAllConnections=!!(262144&r),n.saveExternalLinkValues=!!(128&r),n.showBorderUnselectedTables=!!(4&r),n.showInkAnnotation=!!(32&r),n.showObjects=["all","placeholders","none"][r>>13&3],n.showPivotChartFilter=!!(32768&r),n.updateLinks=["userSet","never","always"][r>>8&3],n}},154:{},155:{},156:{f:function(e,t){var n={};return n.Hidden=e.read_shift(4),n.iTabID=e.read_shift(4),n.strRelID=Kn(e,t-8),n.name=Hn(e),n}},157:{},158:{},159:{T:1,f:function(e){return[e.read_shift(4),e.read_shift(4)]}},160:{T:-1},161:{T:1,f:Qn},162:{T:-1},163:{T:1},164:{T:-1},165:{T:1},166:{T:-1},167:{},168:{},169:{},170:{},171:{},172:{T:1},173:{T:-1},174:{},175:{},176:{f:Vo},177:{T:1},178:{T:-1},179:{T:1},180:{T:-1},181:{T:1},182:{T:-1},183:{T:1},184:{T:-1},185:{T:1},186:{T:-1},187:{T:1},188:{T:-1},189:{T:1},190:{T:-1},191:{T:1},192:{T:-1},193:{T:1},194:{T:-1},195:{T:1},196:{T:-1},197:{T:1},198:{T:-1},199:{T:1},200:{T:-1},201:{T:1},202:{T:-1},203:{T:1},204:{T:-1},205:{T:1},206:{T:-1},207:{T:1},208:{T:-1},209:{T:1},210:{T:-1},211:{T:1},212:{T:-1},213:{T:1},214:{T:-1},215:{T:1},216:{T:-1},217:{T:1},218:{T:-1},219:{T:1},220:{T:-1},221:{T:1},222:{T:-1},223:{T:1},224:{T:-1},225:{T:1},226:{T:-1},227:{T:1},228:{T:-1},229:{T:1},230:{T:-1},231:{T:1},232:{T:-1},233:{T:1},234:{T:-1},235:{T:1},236:{T:-1},237:{T:1},238:{T:-1},239:{T:1},240:{T:-1},241:{T:1},242:{T:-1},243:{T:1},244:{T:-1},245:{T:1},246:{T:-1},247:{T:1},248:{T:-1},249:{T:1},250:{T:-1},251:{T:1},252:{T:-1},253:{T:1},254:{T:-1},255:{T:1},256:{T:-1},257:{T:1},258:{T:-1},259:{T:1},260:{T:-1},261:{T:1},262:{T:-1},263:{T:1},264:{T:-1},265:{T:1},266:{T:-1},267:{T:1},268:{T:-1},269:{T:1},270:{T:-1},271:{T:1},272:{T:-1},273:{T:1},274:{T:-1},275:{T:1},276:{T:-1},277:{},278:{T:1},279:{T:-1},280:{T:1},281:{T:-1},282:{T:1},283:{T:1},284:{T:-1},285:{T:1},286:{T:-1},287:{T:1},288:{T:-1},289:{T:1},290:{T:-1},291:{T:1},292:{T:-1},293:{T:1},294:{T:-1},295:{T:1},296:{T:-1},297:{T:1},298:{T:-1},299:{T:1},300:{T:-1},301:{T:1},302:{T:-1},303:{T:1},304:{T:-1},305:{T:1},306:{T:-1},307:{T:1},308:{T:-1},309:{T:1},310:{T:-1},311:{T:1},312:{T:-1},313:{T:-1},314:{T:1},315:{T:-1},316:{T:1},317:{T:-1},318:{T:1},319:{T:-1},320:{T:1},321:{T:-1},322:{T:1},323:{T:-1},324:{T:1},325:{T:-1},326:{T:1},327:{T:-1},328:{T:1},329:{T:-1},330:{T:1},331:{T:-1},332:{T:1},333:{T:-1},334:{T:1},335:{f:function(e,t){return{flags:e.read_shift(4),version:e.read_shift(4),name:Hn(e)}}},336:{T:-1},337:{f:function(e){return e.l+=4,0!=e.read_shift(4)},T:1},338:{T:-1},339:{T:1},340:{T:-1},341:{T:1},342:{T:-1},343:{T:1},344:{T:-1},345:{T:1},346:{T:-1},347:{T:1},348:{T:-1},349:{T:1},350:{T:-1},351:{},352:{},353:{T:1},354:{T:-1},355:{f:Kn},357:{},358:{},359:{},360:{T:1},361:{},362:{f:gi},363:{},364:{},366:{},367:{},368:{},369:{},370:{},371:{},372:{T:1},373:{T:-1},374:{T:1},375:{T:-1},376:{T:1},377:{T:-1},378:{T:1},379:{T:-1},380:{T:1},381:{T:-1},382:{T:1},383:{T:-1},384:{T:1},385:{T:-1},386:{T:1},387:{T:-1},388:{T:1},389:{T:-1},390:{T:1},391:{T:-1},392:{T:1},393:{T:-1},394:{T:1},395:{T:-1},396:{},397:{},398:{},399:{},400:{},401:{T:1},403:{},404:{},405:{},406:{},407:{},408:{},409:{},410:{},411:{},412:{},413:{},414:{},415:{},416:{},417:{},418:{},419:{},420:{},421:{},422:{T:1},423:{T:1},424:{T:-1},425:{T:-1},426:{f:function(e,t,n){var r=e.l+t,i=Jn(e),a=e.read_shift(1),o=[i];if(o[2]=a,n.cellFormula){var s=po(e,r-e.l,n);o[1]=s}else e.l=r;return o}},427:{f:function(e,t,n){var r=e.l+t,i=[Qn(e,16)];if(n.cellFormula){var a=go(e,r-e.l,n);i[1]=a,e.l=r}else e.l=r;return i}},428:{},429:{T:1},430:{T:-1},431:{T:1},432:{T:-1},433:{T:1},434:{T:-1},435:{T:1},436:{T:-1},437:{T:1},438:{T:-1},439:{T:1},440:{T:-1},441:{T:1},442:{T:-1},443:{T:1},444:{T:-1},445:{T:1},446:{T:-1},447:{T:1},448:{T:-1},449:{T:1},450:{T:-1},451:{T:1},452:{T:-1},453:{T:1},454:{T:-1},455:{T:1},456:{T:-1},457:{T:1},458:{T:-1},459:{T:1},460:{T:-1},461:{T:1},462:{T:-1},463:{T:1},464:{T:-1},465:{T:1},466:{T:-1},467:{T:1},468:{T:-1},469:{T:1},470:{T:-1},471:{},472:{},473:{T:1},474:{T:-1},475:{},476:{f:function(e){var t={};return Go.forEach((function(n){t[n]=er(e)})),t}},477:{},478:{},479:{T:1},480:{T:-1},481:{T:1},482:{T:-1},483:{T:1},484:{T:-1},485:{f:function(){}},486:{T:1},487:{T:-1},488:{T:1},489:{T:-1},490:{T:1},491:{T:-1},492:{T:1},493:{T:-1},494:{f:function(e,t){var n=e.l+t,r=Qn(e,16),i=Yn(e),a=Hn(e),o=Hn(e),s=Hn(e);e.l=n;var c={rfx:r,relId:i,loc:a,display:s};return o&&(c.Tooltip=o),c}},495:{T:1},496:{T:-1},497:{T:1},498:{T:-1},499:{},500:{T:1},501:{T:-1},502:{T:1},503:{T:-1},504:{},505:{T:1},506:{T:-1},507:{},508:{T:1},509:{T:-1},510:{T:1},511:{T:-1},512:{},513:{},514:{T:1},515:{T:-1},516:{T:1},517:{T:-1},518:{T:1},519:{T:-1},520:{T:1},521:{T:-1},522:{},523:{},524:{},525:{},526:{},527:{},528:{T:1},529:{T:-1},530:{T:1},531:{T:-1},532:{T:1},533:{T:-1},534:{},535:{},536:{},537:{},538:{T:1},539:{T:-1},540:{T:1},541:{T:-1},542:{T:1},548:{},549:{},550:{f:Kn},551:{},552:{},553:{},554:{T:1},555:{T:-1},556:{T:1},557:{T:-1},558:{T:1},559:{T:-1},560:{T:1},561:{T:-1},562:{},564:{},565:{T:1},566:{T:-1},569:{T:1},570:{T:-1},572:{},573:{T:1},574:{T:-1},577:{},578:{},579:{},580:{},581:{},582:{},583:{},584:{},585:{},586:{},587:{},588:{T:-1},589:{},590:{T:1},591:{T:-1},592:{T:1},593:{T:-1},594:{T:1},595:{T:-1},596:{},597:{T:1},598:{T:-1},599:{T:1},600:{T:-1},601:{T:1},602:{T:-1},603:{T:1},604:{T:-1},605:{T:1},606:{T:-1},607:{},608:{T:1},609:{T:-1},610:{},611:{T:1},612:{T:-1},613:{T:1},614:{T:-1},615:{T:1},616:{T:-1},617:{T:1},618:{T:-1},619:{T:1},620:{T:-1},625:{},626:{T:1},627:{T:-1},628:{T:1},629:{T:-1},630:{T:1},631:{T:-1},632:{f:ka},633:{T:1},634:{T:-1},635:{T:1,f:function(e){var t={};t.iauthor=e.read_shift(4);var n=Qn(e,16);return t.rfx=n.s,t.ref=In(n.s),e.l+=16,t}},636:{T:-1},637:{f:$n},638:{T:1},639:{},640:{T:-1},641:{T:1},642:{T:-1},643:{T:1},644:{},645:{T:-1},646:{T:1},648:{T:1},649:{},650:{T:-1},651:{f:function(e,t){return e.l+=10,{name:Hn(e)}}},652:{},653:{T:1},654:{T:-1},655:{T:1},656:{T:-1},657:{T:1},658:{T:-1},659:{},660:{T:1},661:{},662:{T:-1},663:{},664:{T:1},665:{},666:{T:-1},667:{},668:{},669:{},671:{T:1},672:{T:-1},673:{T:1},674:{T:-1},675:{},676:{},677:{},678:{},679:{},680:{},681:{},1024:{},1025:{},1026:{T:1},1027:{T:-1},1028:{T:1},1029:{T:-1},1030:{},1031:{T:1},1032:{T:-1},1033:{T:1},1034:{T:-1},1035:{},1036:{},1037:{},1038:{T:1},1039:{T:-1},1040:{},1041:{T:1},1042:{T:-1},1043:{},1044:{},1045:{},1046:{T:1},1047:{T:-1},1048:{T:1},1049:{T:-1},1050:{},1051:{T:1},1052:{T:1},1053:{f:function(){}},1054:{T:1},1055:{},1056:{T:1},1057:{T:-1},1058:{T:1},1059:{T:-1},1061:{},1062:{T:1},1063:{T:-1},1064:{T:1},1065:{T:-1},1066:{T:1},1067:{T:-1},1068:{T:1},1069:{T:-1},1070:{T:1},1071:{T:-1},1072:{T:1},1073:{T:-1},1075:{T:1},1076:{T:-1},1077:{T:1},1078:{T:-1},1079:{T:1},1080:{T:-1},1081:{T:1},1082:{T:-1},1083:{T:1},1084:{T:-1},1085:{},1086:{T:1},1087:{T:-1},1088:{T:1},1089:{T:-1},1090:{T:1},1091:{T:-1},1092:{T:1},1093:{T:-1},1094:{T:1},1095:{T:-1},1096:{},1097:{T:1},1098:{},1099:{T:-1},1100:{T:1},1101:{T:-1},1102:{},1103:{},1104:{},1105:{},1111:{},1112:{},1113:{T:1},1114:{T:-1},1115:{T:1},1116:{T:-1},1117:{},1118:{T:1},1119:{T:-1},1120:{T:1},1121:{T:-1},1122:{T:1},1123:{T:-1},1124:{T:1},1125:{T:-1},1126:{},1128:{T:1},1129:{T:-1},1130:{},1131:{T:1},1132:{T:-1},1133:{T:1},1134:{T:-1},1135:{T:1},1136:{T:-1},1137:{T:1},1138:{T:-1},1139:{T:1},1140:{T:-1},1141:{},1142:{T:1},1143:{T:-1},1144:{T:1},1145:{T:-1},1146:{},1147:{T:1},1148:{T:-1},1149:{T:1},1150:{T:-1},1152:{T:1},1153:{T:-1},1154:{T:-1},1155:{T:-1},1156:{T:-1},1157:{T:1},1158:{T:-1},1159:{T:1},1160:{T:-1},1161:{T:1},1162:{T:-1},1163:{T:1},1164:{T:-1},1165:{T:1},1166:{T:-1},1167:{T:1},1168:{T:-1},1169:{T:1},1170:{T:-1},1171:{},1172:{T:1},1173:{T:-1},1177:{},1178:{T:1},1180:{},1181:{},1182:{},2048:{T:1},2049:{T:-1},2050:{},2051:{T:1},2052:{T:-1},2053:{},2054:{},2055:{T:1},2056:{T:-1},2057:{T:1},2058:{T:-1},2060:{},2067:{},2068:{T:1},2069:{T:-1},2070:{},2071:{},2072:{T:1},2073:{T:-1},2075:{},2076:{},2077:{T:1},2078:{T:-1},2079:{},2080:{T:1},2081:{T:-1},2082:{},2083:{T:1},2084:{T:-1},2085:{T:1},2086:{T:-1},2087:{T:1},2088:{T:-1},2089:{T:1},2090:{T:-1},2091:{},2092:{},2093:{T:1},2094:{T:-1},2095:{},2096:{T:1},2097:{T:-1},2098:{T:1},2099:{T:-1},2100:{T:1},2101:{T:-1},2102:{},2103:{T:1},2104:{T:-1},2105:{},2106:{T:1},2107:{T:-1},2108:{},2109:{T:1},2110:{T:-1},2111:{T:1},2112:{T:-1},2113:{T:1},2114:{T:-1},2115:{},2116:{},2117:{},2118:{T:1},2119:{T:-1},2120:{},2121:{T:1},2122:{T:-1},2123:{T:1},2124:{T:-1},2125:{},2126:{T:1},2127:{T:-1},2128:{},2129:{T:1},2130:{T:-1},2131:{T:1},2132:{T:-1},2133:{T:1},2134:{},2135:{},2136:{},2137:{T:1},2138:{T:-1},2139:{T:1},2140:{T:-1},2141:{},3072:{},3073:{},4096:{T:1},4097:{T:-1},5002:{T:1},5003:{T:-1},5081:{T:1},5082:{T:-1},5083:{},5084:{T:1},5085:{T:-1},5086:{T:1},5087:{T:-1},5088:{},5089:{},5090:{},5092:{T:1},5093:{T:-1},5094:{},5095:{T:1},5096:{T:-1},5097:{},5099:{},65535:{n:""}},_s={6:{f:fo},10:{f:Vr},12:{f:$r},13:{f:$r},14:{f:Gr},15:{f:Gr},16:{f:er},17:{f:Gr},18:{f:Gr},19:{f:$r},20:{f:pi},21:{f:pi},23:{f:gi},24:{f:vi},25:{f:Gr},26:{},27:{},28:{f:function(e,t,n){return function(e,t,n){if(!(n.biff<8)){var r=e.read_shift(2),i=e.read_shift(2),a=e.read_shift(2),o=e.read_shift(2),s=Kr(e,0,n);return n.biff<8&&e.read_shift(1),[{r:r,c:i},s,o,a]}}(e,0,n)}},29:{},34:{f:Gr},35:{f:mi},38:{f:er},39:{f:er},40:{f:er},41:{f:er},42:{f:Gr},43:{f:Gr},47:{f:function(e,t,n){var r={Type:n.biff>=8?e.read_shift(2):0};return r.Type?function(e,t,n){var r=n||{};r.Info=e.read_shift(2),e.l-=2,1===r.Info?r.Data=function(e){var t={},n=t.EncryptionVersionInfo=Vi(e,4);if(1!=n.Major||1!=n.Minor)throw"unrecognized version code "+n.Major+" : "+n.Minor;return t.Salt=e.read_shift(16),t.EncryptedVerifier=e.read_shift(16),t.EncryptedVerifierHash=e.read_shift(16),t}(e):r.Data=function(e,t){var n={},r=n.EncryptionVersionInfo=Vi(e,4);if(t-=4,2!=r.Minor)throw new Error("unrecognized minor version code: "+r.Minor);if(r.Major>4||r.Major<2)throw new Error("unrecognized major version code: "+r.Major);n.Flags=e.read_shift(4),t-=4;var i=e.read_shift(4);return t-=4,n.EncryptionHeader=$i(e,i),t-=i,n.EncryptionVerifier=Wi(e,t),n}(e,t)}(e,t-2,r):function(e,t,n,r){var i,a,o,s={key:$r(e),verificationBytes:$r(e)};n.password&&(s.verifier=function(e){var t,n,r=0,i=Hi(e),a=i.length+1;for((t=w(a))[0]=i.length,n=1;n!=a;++n)t[n]=i[n-1];for(n=a-1;n>=0;--n)r=((0==(16384&r)?0:1)|r<<1&32767)^t[n];return 52811^r}(n.password)),r.valid=s.verificationBytes===s.verifier,r.valid&&(r.insitu=(i=n.password,a=0,o=qi(i),function(e){var t=function(e,t,n,r,i){var a,o;for(i||(i=t),r||(r=qi("")),a=0;a!=t.length;++a)o=t[a],o=255&((o^=r[n])>>5|o<<3),i[a]=o,++n;return[i,n,r]}(0,e,a,o);return a=t[1],t[0]}))}(e,n.biff,n,r),r}},49:{f:function(e,t,n){var r={dyHeight:e.read_shift(2),fl:e.read_shift(2)};switch(n&&n.biff||8){case 2:break;case 3:case 4:e.l+=2;break;default:e.l+=10}return r.name=jr(e,0,n),r}},51:{f:$r},60:{},61:{f:function(e){return{Pos:[e.read_shift(2),e.read_shift(2)],Dim:[e.read_shift(2),e.read_shift(2)],Flags:e.read_shift(2),CurTab:e.read_shift(2),FirstTab:e.read_shift(2),Selected:e.read_shift(2),TabRatio:e.read_shift(2)}}},64:{f:Gr},65:{f:function(){}},66:{f:$r},77:{},80:{},81:{},82:{},85:{f:$r},89:{},90:{},91:{},92:{f:function(e,t,n){if(n.enc)return e.l+=t,"";var r=e.l,i=Kr(e,0,n);return e.read_shift(t+r-e.l),i}},93:{f:function(e,t,n){if(n&&n.biff<8)return function(e,t,n){e.l+=4;var r=e.read_shift(2),i=e.read_shift(2),a=e.read_shift(2);e.l+=2,e.l+=2,e.l+=2,e.l+=2,e.l+=2,e.l+=2,e.l+=2,e.l+=2,e.l+=2,e.l+=6,t-=36;var o=[];return o.push((yi[r]||yn)(e,t,n)),{cmo:[i,r,a],ft:o}}(e,t,n);var r=oi(e),i=function(e,t){for(var n=e.l+t,r=[];e.l<n;){var i=e.read_shift(2);e.l-=2;try{r[i]=ci[i](e,n-e.l)}catch(t){return e.l=n,r}}return e.l!=n&&(e.l=n),r}(e,t-22,r[1]);return{cmo:r,ft:i}}},94:{},95:{f:Gr},96:{},97:{},99:{f:Gr},125:{f:xi},128:{f:function(e){e.l+=4;var t=[e.read_shift(2),e.read_shift(2)];if(0!==t[0]&&t[0]--,0!==t[1]&&t[1]--,t[0]>7||t[1]>7)throw new Error("Bad Gutters: "+t.join("|"));return t}},129:{f:function(e,t,n){var r=n&&8==n.biff||2==t?e.read_shift(2):(e.l+=t,0);return{fDialog:16&r,fBelow:64&r,fRight:128&r}}},130:{f:$r},131:{f:Gr},132:{f:Gr},133:{f:function(e,t,n){var r=e.read_shift(4),i=3&e.read_shift(1),a=e.read_shift(1);switch(a){case 0:a="Worksheet";break;case 1:a="Macrosheet";break;case 2:a="Chartsheet";break;case 6:a="VBAModule"}var o=jr(e,0,n);return 0===o.length&&(o="Sheet1"),{pos:r,hs:i,dt:a,name:o}}},134:{},140:{f:function(e){var t,n=[0,0];return t=e.read_shift(2),n[0]=ur[t]||t,t=e.read_shift(2),n[1]=ur[t]||t,n}},141:{f:$r},144:{},146:{f:function(e){for(var t=e.read_shift(2),n=[];t-- >0;)n.push(Qr(e));return n}},151:{},152:{},153:{},154:{},155:{},156:{f:$r},157:{},158:{},160:{f:wi},161:{f:function(e,t){var n={};return t<32||(e.l+=16,n.header=er(e),n.footer=er(e),e.l+=2),n}},174:{},175:{},176:{},177:{},178:{},180:{},181:{},182:{},184:{},185:{},189:{f:function(e,t){for(var n=e.l+t-2,r=e.read_shift(2),i=e.read_shift(2),a=[];e.l<n;)a.push(ni(e));if(e.l!==n)throw new Error("MulRK read error");var o=e.read_shift(2);if(a.length!=o-i+1)throw new Error("MulRK length mismatch");return{r:r,c:i,C:o,rkrec:a}}},190:{f:function(e,t){for(var n=e.l+t-2,r=e.read_shift(2),i=e.read_shift(2),a=[];e.l<n;)a.push(e.read_shift(2));if(e.l!==n)throw new Error("MulBlank read error");var o=e.read_shift(2);if(a.length!=o-i+1)throw new Error("MulBlank length mismatch");return{r:r,c:i,C:o,ixfe:a}}},193:{f:Vr},197:{},198:{},199:{},200:{},201:{},202:{f:Gr},203:{},204:{},205:{},206:{},207:{},208:{},209:{},210:{},211:{},213:{},215:{},216:{},217:{},218:{f:$r},220:{},221:{f:Gr},222:{},224:{f:function(e,t,n){var r={};return r.ifnt=e.read_shift(2),r.numFmtId=e.read_shift(2),r.flags=e.read_shift(2),r.fStyle=r.flags>>2&1,r.data=function(e,t,n,r){var i={},a=e.read_shift(4),o=e.read_shift(4),s=e.read_shift(4),c=e.read_shift(2);return i.patternType=dr[s>>26],r.cellStyles?(i.alc=7&a,i.fWrap=a>>3&1,i.alcV=a>>4&7,i.fJustLast=a>>7&1,i.trot=a>>8&255,i.cIndent=a>>16&15,i.fShrinkToFit=a>>20&1,i.iReadOrder=a>>22&2,i.fAtrNum=a>>26&1,i.fAtrFnt=a>>27&1,i.fAtrAlc=a>>28&1,i.fAtrBdr=a>>29&1,i.fAtrPat=a>>30&1,i.fAtrProt=a>>31&1,i.dgLeft=15&o,i.dgRight=o>>4&15,i.dgTop=o>>8&15,i.dgBottom=o>>12&15,i.icvLeft=o>>16&127,i.icvRight=o>>23&127,i.grbitDiag=o>>30&3,i.icvTop=127&s,i.icvBottom=s>>7&127,i.icvDiag=s>>14&127,i.dgDiag=s>>21&15,i.icvFore=127&c,i.icvBack=c>>7&127,i.fsxButton=c>>14&1,i):i}(e,0,r.fStyle,n),r}},225:{f:function(e,t){return 0===t||e.read_shift(2),1200}},226:{f:Vr},227:{},229:{f:function(e,t){for(var n=[],r=e.read_shift(2);r--;)n.push(ri(e));return n}},233:{},235:{},236:{},237:{},239:{},240:{},241:{},242:{},244:{},245:{},246:{},247:{},248:{},249:{},251:{},252:{f:function(e,t){for(var n=e.l+t,r=e.read_shift(4),i=e.read_shift(4),a=[],o=0;o!=i&&e.l<n;++o)a.push(Xr(e));return a.Count=r,a.Unique=i,a}},253:{f:function(e){var t=ei(e);return t.isst=e.read_shift(4),t}},255:{f:function(e,t){var n={};return n.dsst=e.read_shift(2),e.l+=t-2,n}},256:{},259:{},290:{},311:{},312:{},315:{},317:{f:Wr},318:{},319:{},320:{},330:{},331:{},333:{},334:{},335:{},336:{},337:{},338:{},339:{},340:{},351:{},352:{f:Gr},353:{f:Vr},401:{},402:{},403:{},404:{},405:{},406:{},407:{},408:{},425:{},426:{},427:{},428:{},429:{},430:{f:function(e,t,n){var r=e.l+t,i=e.read_shift(2),a=e.read_shift(2);if(n.sbcch=a,1025==a||14849==a)return[a,i];if(a<1||a>255)throw new Error("Unexpected SupBook type: "+a);for(var o=Yr(e,a),s=[];r>e.l;)s.push(qr(e));return[a,i,o,s]}},431:{f:Gr},432:{},433:{},434:{},437:{},438:{f:function(e,t,n){var r=e.l,i="";try{e.l+=4;var a=(n.lastobj||{cmo:[0,0]}).cmo[1];-1==[0,5,7,11,12,14].indexOf(a)?e.l+=6:function(e){var t=e.read_shift(1);e.l++;var n=e.read_shift(2);e.l+=2}(e);var o=e.read_shift(2);e.read_shift(2),$r(e);var s=e.read_shift(2);e.l+=s;for(var c=1;c<e.lens.length-1;++c){if(e.l-r!=e.lens[c])throw new Error("TxO: bad continue record");var l=e[e.l];if((i+=Yr(e,e.lens[c+1]-e.lens[c]-1)).length>=(l?o:2*o))break}if(i.length!==o&&i.length!==2*o)throw new Error("cchText: "+o+" != "+i.length);return e.l=r+t,{t:i}}catch(n){return e.l=r+t,{t:i}}}},439:{f:Gr},440:{f:function(e,t){var n=ri(e);e.l+=16;var r=function(e,t){var n=e.l+t,r=e.read_shift(4);if(2!==r)throw new Error("Unrecognized streamVersion: "+r);var i=e.read_shift(2);e.l+=2;var a,o,s,c,l,u,d="";16&i&&(a=Zr(e,e.l)),128&i&&(o=Zr(e,e.l)),257==(257&i)&&(s=Zr(e,e.l)),1==(257&i)&&(c=function(e,t){var n=e.read_shift(16);switch(n){case"e0c9ea79f9bace118c8200aa004ba90b":return function(e){var t=e.read_shift(4),n=e.l,r=!1;t>24&&(e.l+=t-24,"795881f43b1d7f48af2c825dc4852763"===e.read_shift(16)&&(r=!0),e.l=n);var i=e.read_shift((r?t-24:t)>>1,"utf16le").replace(k,"");return r&&(e.l+=24),i}(e);case"0303000000000000c000000000000046":return function(e){for(var t=e.read_shift(2),n="";t-- >0;)n+="../";var r=e.read_shift(0,"lpstr-ansi");if(e.l+=2,57005!=e.read_shift(2))throw new Error("Bad FileMoniker");if(0===e.read_shift(4))return n+r.replace(/\\/g,"/");var i=e.read_shift(4);if(3!=e.read_shift(2))throw new Error("Bad FileMoniker");return n+e.read_shift(i>>1,"utf16le").replace(k,"")}(e);default:throw new Error("Unsupported Moniker "+n)}}(e,e.l)),8&i&&(d=Zr(e,e.l)),32&i&&(l=e.read_shift(16)),64&i&&(u=Lr(e)),e.l=n;var f=o||s||c||"";f&&d&&(f+="#"+d),f||(f="#"+d),2&i&&"/"==f.charAt(0)&&"/"!=f.charAt(1)&&(f="file://"+f);var h={Target:f};return l&&(h.guid=l),u&&(h.time=u),a&&(h.Tooltip=a),h}(e,t-24);return[n,r]}},441:{},442:{f:qr},443:{},444:{f:$r},445:{},446:{},448:{f:Vr},449:{f:function(e){return e.read_shift(2),e.read_shift(4)},r:2},450:{f:Vr},512:{f:fi},513:{f:Ai},515:{f:function(e,t,n){n.biffguess&&2==n.biff&&(n.biff=5);var r=ei(e),i=er(e);return r.val=i,r}},516:{f:function(e,t,n){n.biffguess&&2==n.biff&&(n.biff=5),e.l;var r=ei(e);2==n.biff&&e.l++;var i=qr(e,e.l,n);return r.val=i,r}},517:{f:hi},519:{f:Ei},520:{f:function(e){var t={};t.r=e.read_shift(2),t.c=e.read_shift(2),t.cnt=e.read_shift(2)-t.c;var n=e.read_shift(2);e.l+=4;var r=e.read_shift(1);return e.l+=3,7&r&&(t.level=7&r),32&r&&(t.hidden=!0),64&r&&(t.hpt=n/20),t}},523:{},545:{f:_i},549:{f:ui},566:{},574:{f:function(e,t,n){return n&&n.biff>=2&&n.biff<5?{}:{RTL:64&e.read_shift(2)}}},638:{f:function(e){var t=e.read_shift(2),n=e.read_shift(2),r=ni(e);return{r:t,c:n,ixfe:r[0],rknum:r[1]}}},659:{},1048:{},1054:{f:function(e,t,n){return[e.read_shift(2),Kr(e,0,n)]}},1084:{},1212:{f:function(e,t,n){var r=ii(e);e.l++;var i=e.read_shift(1);return[uo(e,t-=8,n),i,r]}},2048:{f:function(e,t){e.read_shift(2);var n=ri(e),r=e.read_shift((t-10)/2,"dbcs-cont");return[n,r=r.replace(k,"")]}},2049:{},2050:{},2051:{},2052:{},2053:{},2054:{},2055:{},2056:{},2057:{f:li},2058:{},2059:{},2060:{},2061:{},2062:{},2063:{},2064:{},2066:{},2067:{},2128:{},2129:{},2130:{},2131:{},2132:{},2133:{},2134:{},2135:{},2136:{},2137:{},2138:{},2146:{},2147:{r:12},2148:{},2149:{},2150:{},2151:{f:Vr},2152:{},2154:{},2155:{},2156:{},2161:{},2162:{},2164:{},2165:{},2166:{},2167:{},2168:{},2169:{},2170:{},2171:{},2172:{f:function(e){e.l+=2;var t={cxfs:0,crc:0};return t.cxfs=e.read_shift(2),t.crc=e.read_shift(4),t},r:12},2173:{f:function(e,t){e.l,e.l+=2;var n=e.read_shift(2);e.l+=2;for(var r=e.read_shift(2),i=[];r-- >0;)i.push(Ca(e,e.l));return{ixfe:n,ext:i}},r:12},2174:{},2175:{},2180:{},2181:{},2182:{},2183:{},2184:{},2185:{},2186:{},2187:{},2188:{f:Gr,r:12},2189:{},2190:{r:12},2191:{},2192:{},2194:{},2195:{},2196:{f:function(e,t,n){if(!(n.biff<8)){var r=e.read_shift(2),i=e.read_shift(2);return[Yr(e,r,n),Yr(e,i,n)]}e.l+=t},r:12},2197:{},2198:{f:function(e,t,n){var r=e.l+t;if(124226!==e.read_shift(4))if(n.cellStyles){var i,a=e.slice(e.l);e.l=r;try{i=nt(a,{type:"array"})}catch(e){return}var o=Qe(i,"theme/theme/theme1.xml",!0);if(o)return Sa(o,n)}else e.l=r},r:12},2199:{},2200:{},2201:{},2202:{f:function(e){return[0!==e.read_shift(4),0!==e.read_shift(4),e.read_shift(4)]},r:12},2203:{f:Vr},2204:{},2205:{},2206:{},2207:{},2211:{f:function(e){var t=function(e){var t=e.read_shift(2),n=e.read_shift(2);return e.l+=8,{type:t,flags:n}}(e);if(2211!=t.type)throw new Error("Invalid Future Record "+t.type);return 0!==e.read_shift(4)}},2212:{},2213:{},2214:{},2215:{},4097:{},4098:{},4099:{},4102:{},4103:{},4105:{},4106:{},4107:{},4108:{},4109:{},4116:{},4117:{},4118:{},4119:{},4120:{},4121:{},4122:{},4123:{},4124:{},4125:{},4126:{},4127:{},4128:{},4129:{},4130:{},4132:{},4133:{},4134:{f:$r},4135:{},4146:{},4147:{},4148:{},4149:{},4154:{},4156:{},4157:{},4158:{},4159:{},4160:{},4161:{},4163:{},4164:{f:function(e,t,n){var r={area:!1};if(5!=n.biff)return e.l+=t,r;var i=e.read_shift(1);return e.l+=3,16&i&&(r.area=!0),r}},4165:{},4166:{},4168:{},4170:{},4171:{},4174:{},4175:{},4176:{},4177:{},4187:{},4188:{f:function(e){for(var t=e.read_shift(2),n=[];t-- >0;)n.push(Qr(e));return n}},4189:{},4191:{},4192:{},4193:{},4194:{},4195:{},4196:{},4197:{},4198:{},4199:{},4200:{},0:{f:fi},1:{},2:{f:function(e){var t=ei(e);++e.l;var n=e.read_shift(2);return t.t="n",t.val=n,t}},3:{f:function(e){var t=ei(e);++e.l;var n=er(e);return t.t="n",t.val=n,t}},4:{f:function(e,t,n){n.biffguess&&5==n.biff&&(n.biff=2);var r=ei(e);++e.l;var i=Kr(e,0,n);return r.t="str",r.val=i,r}},5:{f:hi},7:{f:function(e){var t=e.read_shift(1);return 0===t?(e.l++,""):e.read_shift(t,"sbcs-cont")}},8:{},9:{f:li},11:{},22:{f:$r},30:{f:di},31:{},32:{},33:{f:_i},36:{},37:{f:ui},50:{f:function(e,t){e.l+=6,e.l+=2,e.l+=1,e.l+=3,e.l+=1,e.l+=t-13}},62:{},52:{},67:{},68:{f:$r},69:{},86:{},126:{},127:{f:function(e){var t=e.read_shift(2),n=e.read_shift(2),r=e.read_shift(4),i={fmt:t,env:n,len:r,data:e.slice(e.l,e.l+r)};return e.l+=r,i}},135:{},136:{},137:{},145:{},148:{},149:{},150:{},169:{},171:{},188:{},191:{},192:{},194:{},195:{},214:{f:function(e,t,n){var r=e.l+t,i=ei(e),a=e.read_shift(2),o=Yr(e,a,n);return e.l=r,i.t="str",i.val=o,i}},223:{},234:{},354:{},421:{},518:{f:fo},521:{f:li},536:{f:vi},547:{f:mi},561:{},579:{},1030:{f:fo},1033:{f:li},1091:{},2157:{},2163:{},2177:{},2240:{},2241:{},2242:{},2243:{},2244:{},2245:{},2246:{},2247:{},2248:{},2249:{},2250:{},2251:{},2262:{r:12},101:{},102:{},105:{},106:{},107:{},109:{},112:{},114:{},29282:{}};function ys(e,t,n,r){var i=t;if(!isNaN(i)){var a=r||(n||[]).length||0,o=e.next(4);o.write_shift(2,i),o.write_shift(2,a),a>0&&on(n)&&e.push(n)}}function xs(e,t){var n=t||{},r=null!=n.dense?n.dense:v,i={};r&&(i["!data"]=[]);var a=(e=e.replace(/<!--.*?-->/g,"")).match(/<table/i);if(!a)throw new Error("Invalid HTML: could not find <table>");var o=e.match(/<\/table/i),s=a.index,c=o&&o.index||e.length,l=Xe(e.slice(s,c),/(:?<tr[^>]*>)/i,"<tr>"),u=-1,d=0,f=0,h=0,p={s:{r:1e7,c:1e7},e:{r:0,c:0}},m=[];for(s=0;s<l.length;++s){var g=l[s].trim(),b=g.slice(0,3).toLowerCase();if("<tr"!=b){if("<td"==b||"<th"==b){var _=g.split(/<\/t[dh]>/i);for(c=0;c<_.length;++c){var y=_[c].trim();if(y.match(/<t[dh]/i)){for(var x=y,A=0;"<"==x.charAt(0)&&(A=x.indexOf(">"))>-1;)x=x.slice(A+1);for(var w=0;w<m.length;++w){var E=m[w];E.s.c==d&&E.s.r<u&&u<=E.e.r&&(d=E.e.c+1,w=-1)}var T=ut(y.slice(0,y.indexOf(">")));h=T.colspan?+T.colspan:1,((f=+T.rowspan)>1||h>1)&&m.push({s:{r:u,c:d},e:{r:u+(f||1)-1,c:d+h-1}});var S=T.t||T["data-t"]||"";if(x.length)if(x=Ct(x),p.s.r>u&&(p.s.r=u),p.e.r<u&&(p.e.r=u),p.s.c>d&&(p.s.c=d),p.e.c<d&&(p.e.c=d),x.length){var C={t:"s",v:x};n.raw||!x.trim().length||"s"==S||("TRUE"===x?C={t:"b",v:!0}:"FALSE"===x?C={t:"b",v:!1}:isNaN(Ge(x))?isNaN(je(x).getDate())||(C={t:"d",v:Be(x)},n.cellDates||(C={t:"n",v:Re(C.v)}),C.z=n.dateNF||z[14]):C={t:"n",v:Ge(x)}),r?(i["!data"][u]||(i["!data"][u]=[]),i["!data"][u][d]=C):i[In({r:u,c:d})]=C,d+=h}else d+=h;else d+=h}}}}else{if(++u,n.sheetRows&&n.sheetRows<=u){--u;break}d=0}}return i["!ref"]=Dn(p),m.length&&(i["!merges"]=m),i}function As(e,t,n,r){for(var i=e["!merges"]||[],a=[],o={},s=null!=e["!data"],c=t.s.c;c<=t.e.c;++c){for(var l=0,u=0,d=0;d<i.length;++d)if(!(i[d].s.r>n||i[d].s.c>c||i[d].e.r<n||i[d].e.c<c)){if(i[d].s.r<n||i[d].s.c<c){l=-1;break}l=i[d].e.r-i[d].s.r+1,u=i[d].e.c-i[d].s.c+1;break}if(!(l<0)){var f=Ln(c)+kn(n),h=s?(e["!data"][n]||[])[c]:e[f],p=h&&null!=h.v&&(h.h||gt(h.w||(Un(h),h.w)||""))||"";o={},l>1&&(o.rowspan=l),u>1&&(o.colspan=u),r.editable?p='<span contenteditable="true">'+p+"</span>":h&&(o["data-t"]=h&&h.t||"z",null!=h.v&&(o["data-v"]=h.v),null!=h.z&&(o["data-z"]=h.z),h.l&&"#"!=(h.l.Target||"#").charAt(0)&&(p='<a href="'+gt(h.l.Target)+'">'+p+"</a>")),o.id=(r.id||"sjs")+"-"+f,a.push(It("td",p,o))}}return"<tr>"+a.join("")+"</tr>"}function ws(e,t,n){var r=t.rows;if(!r)throw"Unsupported origin when "+t.tagName+" is not a TABLE";var i=n||{},a=null!=e["!data"],o=0,s=0;if(null!=i.origin)if("number"==typeof i.origin)o=i.origin;else{var c="string"==typeof i.origin?On(i.origin):i.origin;o=c.r,s=c.c}var l=Math.min(i.sheetRows||1e7,r.length),u={s:{r:0,c:0},e:{r:o,c:s}};if(e["!ref"]){var d=Pn(e["!ref"]);u.s.r=Math.min(u.s.r,d.s.r),u.s.c=Math.min(u.s.c,d.s.c),u.e.r=Math.max(u.e.r,d.e.r),u.e.c=Math.max(u.e.c,d.e.c),-1==o&&(u.e.r=o=d.e.r+1)}var f=[],h=0,p=e["!rows"]||(e["!rows"]=[]),m=0,v=0,g=0,b=0,_=0,y=0;for(e["!cols"]||(e["!cols"]=[]);m<r.length&&v<l;++m){var x=r[m];if(Ts(x)){if(i.display)continue;p[v]={hidden:!0}}var A=x.cells;for(g=b=0;g<A.length;++g){var w=A[g];if(!i.display||!Ts(w)){var E=w.hasAttribute("data-v")?w.getAttribute("data-v"):w.hasAttribute("v")?w.getAttribute("v"):Ct(w.innerHTML),T=w.getAttribute("data-z")||w.getAttribute("z");for(h=0;h<f.length;++h){var S=f[h];S.s.c==b+s&&S.s.r<v+o&&v+o<=S.e.r&&(b=S.e.c+1-s,h=-1)}y=+w.getAttribute("colspan")||1,((_=+w.getAttribute("rowspan")||1)>1||y>1)&&f.push({s:{r:v+o,c:b+s},e:{r:v+o+(_||1)-1,c:b+s+(y||1)-1}});var C={t:"s",v:E},M=w.getAttribute("data-t")||w.getAttribute("t")||"";null!=E&&(0==E.length?C.t=M||"z":i.raw||0==E.trim().length||"s"==M||("TRUE"===E?C={t:"b",v:!0}:"FALSE"===E?C={t:"b",v:!1}:isNaN(Ge(E))?isNaN(je(E).getDate())||(C={t:"d",v:Be(E)},i.cellDates||(C={t:"n",v:Re(C.v)}),C.z=i.dateNF||z[14]):C={t:"n",v:Ge(E)})),void 0===C.z&&null!=T&&(C.z=T);var k="",R=w.getElementsByTagName("A");if(R&&R.length)for(var L=0;L<R.length&&(!R[L].hasAttribute("href")||"#"==(k=R[L].getAttribute("href")).charAt(0));++L);k&&"#"!=k.charAt(0)&&"javascript:"!=k.slice(0,11).toLowerCase()&&(C.l={Target:k}),a?(e["!data"][v+o]||(e["!data"][v+o]=[]),e["!data"][v+o][b+s]=C):e[In({c:b+s,r:v+o})]=C,u.e.c<b+s&&(u.e.c=b+s),b+=y}}++v}return f.length&&(e["!merges"]=(e["!merges"]||[]).concat(f)),u.e.r=Math.max(u.e.r,v-1+o),e["!ref"]=Dn(u),v>=l&&(e["!fullref"]=Dn((u.e.r=r.length-m+v-1+o,u))),e}function Es(e,t){var n={};return(t||{}).dense&&(n["!data"]=[]),ws(n,e,t)}function Ts(e){var t="",n=function(e){return e.ownerDocument.defaultView&&"function"==typeof e.ownerDocument.defaultView.getComputedStyle?e.ownerDocument.defaultView.getComputedStyle:"function"==typeof getComputedStyle?getComputedStyle:null}(e);return n&&(t=n(e).getPropertyValue("display")),t||(t=e.style&&e.style.display),"none"===t}function Ss(e,t,n){var r=n||{},i=Pt(e);Dt.lastIndex=0,i=i.replace(/<!--([\s\S]*?)-->/gm,"").replace(/<!DOCTYPE[^\[]*\[[^\]]*\]>/gm,"");for(var a,o,s,c="",l="",u=0,d=-1,f="";a=Dt.exec(i);)switch(a[3]=a[3].replace(/_.*$/,"")){case"number-style":case"currency-style":case"percentage-style":case"date-style":case"time-style":case"text-style":"/"===a[1]?("false"==o["truncate-on-overflow"]&&(c.match(/h/)?c=c.replace(/h+/,"[$&]"):c.match(/m/)?c=c.replace(/m+/,"[$&]"):c.match(/s/)&&(c=c.replace(/s+/,"[$&]"))),r[o.name]=c,c=""):"/"!==a[0].charAt(a[0].length-2)&&(c="",o=ut(a[0],!1));break;case"boolean-style":"/"===a[1]?(r[o.name]="General",c=""):"/"!==a[0].charAt(a[0].length-2)&&(c="",o=ut(a[0],!1));break;case"boolean":c+="General";break;case"text":"/"===a[1]?"%"==(f=i.slice(d,Dt.lastIndex-a[0].length))&&"<number:percentage-style"==o[0]?c+="%":c+='"'+f.replace(/"/g,'""')+'"':"/"!==a[0].charAt(a[0].length-2)&&(d=Dt.lastIndex);break;case"day":"short"===(s=ut(a[0],!1)).style?c+="d":c+="dd";break;case"day-of-week":switch((s=ut(a[0],!1)).style){case"short":default:c+="ddd";break;case"long":c+="dddd"}break;case"era":"short"===(s=ut(a[0],!1)).style?c+="ee":c+="eeee";break;case"hours":"short"===(s=ut(a[0],!1)).style?c+="h":c+="hh";break;case"minutes":"short"===(s=ut(a[0],!1)).style?c+="m":c+="mm";break;case"month":switch((s=ut(a[0],!1)).textual&&(c+="mm"),s.style){case"short":default:c+="m";break;case"long":c+="mm"}break;case"seconds":"short"===(s=ut(a[0],!1)).style?c+="s":c+="ss",s["decimal-places"]&&(c+="."+Ve("0",+s["decimal-places"]));break;case"year":switch((s=ut(a[0],!1)).style){case"short":default:c+="yy";break;case"long":c+="yyyy"}break;case"am-pm":c+="AM/PM";break;case"week-of-year":case"quarter":console.error("Excel does not support ODS format token "+a[3]);break;case"fill-character":"/"===a[1]?c+='"'+(f=i.slice(d,Dt.lastIndex-a[0].length)).replace(/"/g,'""')+'"*':"/"!==a[0].charAt(a[0].length-2)&&(d=Dt.lastIndex);break;case"scientific-number":c+="0."+Ve("0",+(s=ut(a[0],!1))["min-decimal-places"]||+s["decimal-places"]||2)+Ve("?",+s["decimal-places"]-+s["min-decimal-places"]||0)+"E"+(_t(s["forced-exponent-sign"])?"+":"")+Ve("0",+s["min-exponent-digits"]||2);break;case"fraction":+(s=ut(a[0],!1))["min-integer-digits"]?c+=Ve("0",+s["min-integer-digits"]):c+="#",c+=" ",c+=Ve("?",+s["min-numerator-digits"]||1),c+="/",+s["denominator-value"]?c+=s["denominator-value"]:c+=Ve("?",+s["min-denominator-digits"]||1);break;case"currency-symbol":"/"===a[1]?c+='"'+i.slice(d,Dt.lastIndex-a[0].length).replace(/"/g,'""')+'"':"/"!==a[0].charAt(a[0].length-2)?d=Dt.lastIndex:c+="$";break;case"text-properties":switch(((s=ut(a[0],!1)).color||"").toLowerCase().replace("#","")){case"ff0000":case"red":c="[Red]"+c}break;case"text-content":c+="@";break;case"map":s=ut(a[0],!1),"value()>=0"==pt(s.condition)?c=r[s["apply-style-name"]]+";"+c:console.error("ODS number format may be incorrect: "+s.condition);break;case"number":if("/"===a[1])break;l="",l+=Ve("0",+(s=ut(a[0],!1))["min-integer-digits"]||1),_t(s.grouping)&&(l=ee(Ve("#",Math.max(0,4-l.length))+l)),(+s["min-decimal-places"]||+s["decimal-places"])&&(l+="."),+s["min-decimal-places"]&&(l+=Ve("0",+s["min-decimal-places"]||1)),+s["decimal-places"]-(+s["min-decimal-places"]||0)&&(l+=Ve("0",+s["decimal-places"]-(+s["min-decimal-places"]||0))),c+=l;break;case"embedded-text":"/"===a[1]?0==u?c+='"'+i.slice(d,Dt.lastIndex-a[0].length).replace(/"/g,'""')+'"':c=c.slice(0,u)+'"'+i.slice(d,Dt.lastIndex-a[0].length).replace(/"/g,'""')+'"'+c.slice(u):"/"!==a[0].charAt(a[0].length-2)&&(d=Dt.lastIndex,u=-+ut(a[0],!1).position||0)}return r}function Cs(e,t,n){var r=t||{};null!=v&&null==r.dense&&(r.dense=v);var i,a,o,s,c,l,u,d=Pt(e),f=[],h=0,p={},m=[],g={};r.dense&&(g["!data"]=[]);var b,_={value:""},y="",x=0,A=[],w=-1,E=-1,T={s:{r:1e6,c:1e7},e:{r:0,c:0}},S=0,C=n||{},M={},k=[],R={},L=[],O=1,I=1,P=[],D={Names:[],WBProps:{}},N={},U=["",""],F=[],B={},z="",H=0,V=!1,G=!1,$=0,W=0;for(Dt.lastIndex=0,d=d.replace(/<!--([\s\S]*?)-->/gm,"").replace(/<!DOCTYPE[^\[]*\[[^\]]*\]>/gm,"");l=Dt.exec(d);)switch(l[3]=l[3].replace(/_.*$/,"")){case"table":case"工作表":"/"===l[1]?(T.e.c>=T.s.c&&T.e.r>=T.s.r?g["!ref"]=Dn(T):g["!ref"]="A1:A1",r.sheetRows>0&&r.sheetRows<=T.e.r&&(g["!fullref"]=g["!ref"],T.e.r=r.sheetRows-1,g["!ref"]=Dn(T)),k.length&&(g["!merges"]=k),L.length&&(g["!rows"]=L),s.name=s["名称"]||s.name,"undefined"!=typeof JSON&&JSON.stringify(s),m.push(s.name),p[s.name]=g,G=!1):"/"!==l[0].charAt(l[0].length-2)&&(s=ut(l[0],!1),w=E=-1,T.s.r=T.s.c=1e7,T.e.r=T.e.c=0,g={},r.dense&&(g["!data"]=[]),k=[],L=[],G=!0);break;case"table-row-group":"/"===l[1]?--S:++S;break;case"table-row":case"行":if("/"===l[1]){w+=O,O=1;break}if((c=ut(l[0],!1))["行号"]?w=c["行号"]-1:-1==w&&(w=0),(O=+c["number-rows-repeated"]||1)<10)for($=0;$<O;++$)S>0&&(L[w+$]={level:S});E=-1;break;case"covered-table-cell":"/"!==l[1]&&++E,r.sheetStubs&&(r.dense?(g["!data"][w]||(g["!data"][w]=[]),g["!data"][w][E]={t:"z"}):g[In({r:w,c:E})]={t:"z"}),y="",A=[];break;case"table-cell":case"数据":if("/"===l[0].charAt(l[0].length-2))++E,_=ut(l[0],!1),I=parseInt(_["number-columns-repeated"]||"1",10),u={t:"z",v:null},_.formula&&0!=r.cellFormula&&(u.f=xo(pt(_.formula))),_["style-name"]&&M[_["style-name"]]&&(u.z=M[_["style-name"]]),"string"==(_["数据类型"]||_["value-type"])&&(u.t="s",u.v=pt(_["string-value"]||""),r.dense?(g["!data"][w]||(g["!data"][w]=[]),g["!data"][w][E]=u):g[Ln(E)+kn(w)]=u),E+=I-1;else if("/"!==l[1]){y="",x=0,A=[],I=1;var j=O?w+O-1:w;if(++E>T.e.c&&(T.e.c=E),E<T.s.c&&(T.s.c=E),w<T.s.r&&(T.s.r=w),j>T.e.r&&(T.e.r=j),F=[],B={},u={t:(_=ut(l[0],!1))["数据类型"]||_["value-type"],v:null},_["style-name"]&&M[_["style-name"]]&&(u.z=M[_["style-name"]]),r.cellFormula)if(_.formula&&(_.formula=pt(_.formula)),_["number-matrix-columns-spanned"]&&_["number-matrix-rows-spanned"]&&(R={s:{r:w,c:E},e:{r:w+(parseInt(_["number-matrix-rows-spanned"],10)||0)-1,c:E+(parseInt(_["number-matrix-columns-spanned"],10)||0)-1}},u.F=Dn(R),P.push([R,u.F])),_.formula)u.f=xo(_.formula);else for($=0;$<P.length;++$)w>=P[$][0].s.r&&w<=P[$][0].e.r&&E>=P[$][0].s.c&&E<=P[$][0].e.c&&(u.F=P[$][1]);switch((_["number-columns-spanned"]||_["number-rows-spanned"])&&(R={s:{r:w,c:E},e:{r:w+(parseInt(_["number-rows-spanned"],10)||0)-1,c:E+(parseInt(_["number-columns-spanned"],10)||0)-1}},k.push(R)),_["number-columns-repeated"]&&(I=parseInt(_["number-columns-repeated"],10)),u.t){case"boolean":u.t="b",u.v=_t(_["boolean-value"])||+_["boolean-value"]>=1;break;case"float":case"percentage":case"currency":u.t="n",u.v=parseFloat(_.value);break;case"date":u.t="d",u.v=Be(_["date-value"]),r.cellDates||(u.t="n",u.v=Re(u.v,D.WBProps.date1904)-W),u.z||(u.z="m/d/yy");break;case"time":u.t="n",u.v=De(_["time-value"])/86400,r.cellDates&&(u.t="d",u.v=Pe(u.v)),u.z||(u.z="HH:MM:SS");break;case"number":u.t="n",u.v=parseFloat(_["数据数值"]);break;default:if("string"!==u.t&&"text"!==u.t&&u.t)throw new Error("Unsupported value type "+u.t);u.t="s",null!=_["string-value"]&&(y=pt(_["string-value"]),A=[])}}else{if(V=!1,"s"===u.t&&(u.v=y||"",A.length&&(u.R=A),V=0==x),N.Target&&(u.l=N),F.length>0&&(u.c=F,F=[]),y&&!1!==r.cellText&&(u.w=y),V&&(u.t="z",delete u.v),(!V||r.sheetStubs)&&!(r.sheetRows&&r.sheetRows<=w))for(var X=0;X<O;++X){if(I=parseInt(_["number-columns-repeated"]||"1",10),r.dense)for(g["!data"][w+X]||(g["!data"][w+X]=[]),g["!data"][w+X][E]=0==X?u:He(u);--I>0;)g["!data"][w+X][E+I]=He(u);else for(g[In({r:w+X,c:E})]=u;--I>0;)g[In({r:w+X,c:E+I})]=He(u);T.e.c<=E&&(T.e.c=E)}E+=(I=parseInt(_["number-columns-repeated"]||"1",10))-1,I=0,u={},y="",A=[]}N={};break;case"document":case"document-content":case"电子表格文档":case"spreadsheet":case"主体":case"scripts":case"styles":case"font-face-decls":case"master-styles":if("/"===l[1]){if((i=f.pop())[0]!==l[3])throw"Bad state: "+i}else"/"!==l[0].charAt(l[0].length-2)&&f.push([l[3],!0]);break;case"annotation":if("/"===l[1]){if((i=f.pop())[0]!==l[3])throw"Bad state: "+i;B.t=y,A.length&&(B.R=A),B.a=z,F.push(B)}else"/"!==l[0].charAt(l[0].length-2)&&f.push([l[3],!1]);z="",H=0,y="",x=0,A=[];break;case"creator":"/"===l[1]?z=d.slice(H,l.index):H=l.index+l[0].length;break;case"meta":case"元数据":case"settings":case"config-item-set":case"config-item-map-indexed":case"config-item-map-entry":case"config-item-map-named":case"shapes":case"frame":case"text-box":case"image":case"data-pilot-tables":case"list-style":case"form":case"dde-links":case"event-listeners":case"chart":if("/"===l[1]){if((i=f.pop())[0]!==l[3])throw"Bad state: "+i}else"/"!==l[0].charAt(l[0].length-2)&&f.push([l[3],!1]);y="",x=0,A=[];break;case"scientific-number":case"currency-symbol":case"fill-character":case"script":case"libraries":case"automatic-styles":case"default-style":case"page-layout":case"map":case"font-face":case"paragraph-properties":case"table-properties":case"table-column-properties":case"table-row-properties":case"table-cell-properties":case"number":case"fraction":case"day":case"month":case"year":case"era":case"day-of-week":case"week-of-year":case"quarter":case"hours":case"minutes":case"seconds":case"am-pm":case"boolean":case"text-content":case"text-properties":case"embedded-text":case"body":case"电子表格":case"forms":case"table-column":case"table-header-rows":case"table-rows":case"table-column-group":case"table-header-columns":case"table-columns":case"graphic-properties":case"calculation-settings":case"named-expressions":case"label-range":case"label-ranges":case"named-expression":case"sort":case"sort-by":case"sort-groups":case"tab":case"line-break":case"span":case"s":case"date":case"object":case"title":case"标题":case"desc":case"binary-data":case"table-source":case"scenario":case"iteration":case"content-validations":case"content-validation":case"help-message":case"error-message":case"database-ranges":case"filter":case"filter-and":case"filter-or":case"filter-condition":case"list-level-style-bullet":case"list-level-style-number":case"list-level-properties":case"sender-firstname":case"sender-lastname":case"sender-initials":case"sender-title":case"sender-position":case"sender-email":case"sender-phone-private":case"sender-fax":case"sender-company":case"sender-phone-work":case"sender-street":case"sender-city":case"sender-postal-code":case"sender-country":case"sender-state-or-province":case"author-name":case"author-initials":case"chapter":case"file-name":case"template-name":case"sheet-name":case"event-listener":case"initial-creator":case"creation-date":case"print-date":case"generator":case"document-statistic":case"user-defined":case"editing-duration":case"editing-cycles":case"config-item":case"page-number":case"page-count":case"time":case"cell-range-source":case"detective":case"operation":case"highlighted-range":case"data-pilot-table":case"source-cell-range":case"source-service":case"data-pilot-field":case"data-pilot-level":case"data-pilot-subtotals":case"data-pilot-subtotal":case"data-pilot-members":case"data-pilot-member":case"data-pilot-display-info":case"data-pilot-sort-info":case"data-pilot-layout-info":case"data-pilot-field-reference":case"data-pilot-groups":case"data-pilot-group":case"data-pilot-group-member":case"rect":case"dde-connection-decls":case"dde-connection-decl":case"dde-link":case"dde-source":case"properties":case"property":case"table-protection":case"data-pilot-grand-total":case"office-document-common-attrs":break;case"text-style":case"boolean-style":case"number-style":case"currency-style":case"percentage-style":case"date-style":case"time-style":if("/"===l[1]){var Y=Dt.lastIndex;Ss(d.slice(o,Dt.lastIndex),0,C),Dt.lastIndex=Y}else"/"!==l[0].charAt(l[0].length-2)&&(o=Dt.lastIndex-l[0].length);break;case"style":var q=ut(l[0],!1);"table-cell"==q.family&&C[q["data-style-name"]]&&(M[q.name]=C[q["data-style-name"]]);break;case"text":if("/>"===l[0].slice(-2))break;if("/"===l[1])switch(f[f.length-1][0]){case"number-style":case"date-style":case"time-style":d.slice(h,l.index)}else h=l.index+l[0].length;break;case"named-range":U=Ao((a=ut(l[0],!1))["cell-range-address"]);var K={Name:a.name,Ref:U[0]+"!"+U[1]};G&&(K.Sheet=m.length),D.Names.push(K);break;case"null-date":switch((a=ut(l[0],!1))["date-value"]){case"1904-01-01":D.WBProps.date1904=!0;case"1900-01-01":W=0}break;case"p":case"文本串":if(["master-styles"].indexOf(f[f.length-1][0])>-1)break;if("/"!==l[1]||_&&_["string-value"])ut(l[0],!1),x=l.index+l[0].length;else{var Z=(b=void 0,b=d.slice(x,l.index).replace(/[\t\r\n]/g," ").trim().replace(/ +/g," ").replace(/<text:s\/>/g," ").replace(/<text:s text:c="(\d+)"\/>/g,(function(e,t){return Array(parseInt(t,10)+1).join(" ")})).replace(/<text:tab[^>]*\/>/g,"\t").replace(/<text:line-break\/>/g,"\n"),[pt(b.replace(/<[^>]*>/g,""))]);y=(y.length>0?y+"\n":"")+Z[0]}break;case"database-range":if("/"===l[1])break;try{p[(U=Ao(ut(l[0])["target-range-address"]))[0]]["!autofilter"]={ref:U[1]}}catch(e){}break;case"a":if("/"!==l[1]){if(!(N=ut(l[0],!1)).href)break;N.Target=pt(N.href),delete N.href,"#"==N.Target.charAt(0)&&N.Target.indexOf(".")>-1?(U=Ao(N.Target.slice(1)),N.Target="#"+U[0]+"!"+U[1]):N.Target.match(/^\.\.[\\\/]/)&&(N.Target=N.Target.slice(3))}break;default:switch(l[2]){case"dc:":case"calcext:":case"loext:":case"ooo:":case"chartooo:":case"draw:":case"style:":case"chart:":case"form:":case"uof:":case"表:":case"字:":break;default:if(r.WTF)throw new Error(l)}}var J={Sheets:p,SheetNames:m,Workbook:D};return r.bookSheets&&delete J.Sheets,J}function Ms(e,t){t=t||{},Ke(e,"META-INF/manifest.xml")&&function(e,t){for(var n,r,i=Pt(e);n=Dt.exec(i);)switch(n[3]){case"manifest":break;case"file-entry":if("/"==(r=ut(n[0],!1)).path&&r.type!==xr)throw new Error("This OpenDocument is not a spreadsheet");break;case"encryption-data":case"algorithm":case"start-key-generation":case"key-derivation":throw new Error("Unsupported ODS Encryption");default:if(t&&t.WTF)throw n}}(Je(e,"META-INF/manifest.xml"),t);var n=Qe(e,"styles.xml"),r=n&&Ss(Et(n)),i=Qe(e,"content.xml");if(!i)throw new Error("Missing content.xml in ODS / UOF file");var a=Cs(Et(i),t,r);return Ke(e,"meta.xml")&&(a.Props=Er(Je(e,"meta.xml"))),a.bookType="ods",a}function ks(e,t){var n=Cs(e,t);return n.bookType="fods",n}var Rs=function(){try{return"undefined"==typeof Uint8Array||void 0===Uint8Array.prototype.subarray?"slice":"undefined"!=typeof Buffer?void 0===Buffer.prototype.subarray?"slice":("function"==typeof Buffer.from?Buffer.from([72,62]):new Buffer([72,62]))instanceof Uint8Array?"subarray":"slice":"subarray"}catch(e){return"slice"}}();function Ls(e){return new DataView(e.buffer,e.byteOffset,e.byteLength)}function Os(e){return"undefined"!=typeof TextDecoder?(new TextDecoder).decode(e):Et(S(e))}function Is(e){for(var t=0,n=0;n<e.length;++n)t+=e[n].length;var r=new Uint8Array(t),i=0;for(n=0;n<e.length;++n){var a=e[n],o=a.length;if(o<250)for(var s=0;s<o;++s)r[i++]=a[s];else r.set(a,i),i+=o}return r}function Ps(e){return 16843009*((e=(858993459&(e-=e>>1&1431655765))+(e>>2&858993459))+(e>>4)&252645135)>>>24}function Ds(e,t){var n=t.l,r=127&e[n];e:if(e[n++]>=128){if(r|=(127&e[n])<<7,e[n++]<128)break e;if(r|=(127&e[n])<<14,e[n++]<128)break e;if(r|=(127&e[n])<<21,e[n++]<128)break e;if(r+=(127&e[n])*Math.pow(2,28),++n,e[n++]<128)break e;if(r+=(127&e[n])*Math.pow(2,35),++n,e[n++]<128)break e;if(r+=(127&e[n])*Math.pow(2,42),++n,e[n++]<128)break e}return t.l=n,r}function Ns(e){var t=0,n=127&e[t];e:if(e[t++]>=128){if(n|=(127&e[t])<<7,e[t++]<128)break e;if(n|=(127&e[t])<<14,e[t++]<128)break e;if(n|=(127&e[t])<<21,e[t++]<128)break e;n|=(127&e[t])<<28}return n}function Us(e){for(var t=[],n={l:0};n.l<e.length;){var r,i=n.l,a=Ds(e,n),o=7&a;a=a/8|0;var s=n.l;switch(o){case 0:for(;e[s++]>=128;);r=e[Rs](n.l,s),n.l=s;break;case 1:r=e[Rs](s,s+8),n.l=s+8;break;case 2:var c=Ds(e,n);r=e[Rs](n.l,n.l+c),n.l+=c;break;case 5:r=e[Rs](s,s+4),n.l=s+4;break;default:throw new Error("PB Type ".concat(o," for Field ").concat(a," at offset ").concat(i))}var l={data:r,type:o};null==t[a]&&(t[a]=[]),t[a].push(l)}return t}function Fs(e,t){return(null==e?void 0:e.map((function(e){return t(e.data)})))||[]}function Bs(e,t){if(0!=e)throw new Error("Unexpected Snappy chunk type ".concat(e));for(var n={l:0},r=Ds(t,n),i=[],a=n.l;a<t.length;){var o=3&t[a];if(0!=o){var s=0,c=0;if(1==o?(c=4+(t[a]>>2&7),s=(224&t[a++])<<3,s|=t[a++]):(c=1+(t[a++]>>2),2==o?(s=t[a]|t[a+1]<<8,a+=2):(s=(t[a]|t[a+1]<<8|t[a+2]<<16|t[a+3]<<24)>>>0,a+=4)),0==s)throw new Error("Invalid offset 0");for(var l=i.length-1,u=s;l>=0&&u>=i[l].length;)u-=i[l].length,--l;if(l<0){if(0!=u)throw new Error("Invalid offset beyond length");u=i[l=0].length}if(c<u)i.push(i[l][Rs](i[l].length-u,i[l].length-u+c));else{for(u>0&&(i.push(i[l][Rs](i[l].length-u)),c-=u),++l;c>=i[l].length;)i.push(i[l]),c-=i[l].length,++l;c&&i.push(i[l][Rs](0,c))}i.length>25&&(i=[Is(i)])}else{var d=t[a++]>>2;if(d<60)++d;else{var f=d-59;d=t[a],f>1&&(d|=t[a+1]<<8),f>2&&(d|=t[a+2]<<16),f>3&&(d|=t[a+3]<<24),d>>>=0,d++,a+=f}i.push(t[Rs](a,a+d)),a+=d}}for(var h=0,p=0;p<i.length;++p)h+=i[p].length;if(h!=r)throw new Error("Unexpected length: ".concat(h," != ").concat(r));return i}var zs=function(){return{sst:[],rsst:[],ofmt:[],nfmt:[]}};function Hs(e,t,n,r,i){var a,o,s,c,l=255&t,u=t>>8,d=u>=5?i:r;e:if(n&(u>4?8:4)&&"n"==e.t&&7==l){var f=(null==(a=d[7])?void 0:a[0])?Ns(d[7][0].data):-1;if(-1==f)break e;var h=(null==(o=d[15])?void 0:o[0])?Ns(d[15][0].data):-1,p=(null==(s=d[16])?void 0:s[0])?Ns(d[16][0].data):-1,m=(null==(c=d[40])?void 0:c[0])?Ns(d[40][0].data):-1,v=e.v,g=v;t:if(m){if(0==v){h=p=2;break t}h=v>=604800?1:v>=86400?2:v>=3600?4:v>=60?8:v>=1?16:32,Math.floor(v)!=v?p=32:v%60?p=16:v%3600?p=8:v%86400?p=4:v%604800&&(p=2),p<h&&(p=h)}if(-1==h||-1==p)break e;var b=[],_=[];1==h&&(g=v/604800,1==p?_.push('d"d"'):v-=604800*(g|=0),b.push(g+(2==f?" week"+(1==g?"":"s"):1==f?"w":""))),h<=2&&p>=2&&(g=v/86400,p>2&&(v-=86400*(g|=0)),_.push('d"d"'),b.push(g+(2==f?" day"+(1==g?"":"s"):1==f?"d":""))),h<=4&&p>=4&&(g=v/3600,p>4&&(v-=3600*(g|=0)),_.push((h>=4?"[h]":"h")+'"h"'),b.push(g+(2==f?" hour"+(1==g?"":"s"):1==f?"h":""))),h<=8&&p>=8&&(g=v/60,p>8&&(v-=60*(g|=0)),_.push((h>=8?"[m]":"m")+'"m"'),0==f?b.push((8==h&&8==p||g>=10?"":"0")+g):b.push(g+(2==f?" minute"+(1==g?"":"s"):1==f?"m":""))),h<=16&&p>=16&&(g=v,p>16&&(v-=g|=0),_.push((h>=16?"[s]":"s")+'"s"'),0==f?b.push((16==p&&16==h||g>=10?"":"0")+g):b.push(g+(2==f?" second"+(1==g?"":"s"):1==f?"s":""))),p>=32&&(g=Math.round(1e3*v),h<32&&_.push('.000"ms"'),0==f?b.push((g>=100?"":g>=10?"0":"00")+g):b.push(g+(2==f?" millisecond"+(1==g?"":"s"):1==f?"ms":""))),e.w=b.join(0==f?":":" "),e.z=_.join(0==f?'":"':" "),0==f&&(e.w=e.w.replace(/:(\d\d\d)$/,".$1"))}}function Vs(e,t){switch(e[0]){case 0:case 1:case 2:case 3:case 4:return function(e,t,n){var r,i=Ls(e),a=i.getUint32(4,!0),o=-1,s=-1,c=-1,l=NaN,u=new Date(2001,0,1),d=n>1?12:8;2&a&&(c=i.getUint32(d,!0),d+=4),d+=4*Ps(a&(n>1?3468:396)),512&a&&(o=i.getUint32(d,!0),d+=4),d+=4*Ps(a&(n>1?12288:4096)),16&a&&(s=i.getUint32(d,!0),d+=4),32&a&&(l=i.getFloat64(d,!0),d+=8),64&a&&(u.setTime(u.getTime()+1e3*i.getFloat64(d,!0)),d+=8),n>1&&255&(a=i.getUint32(8,!0)>>>16)&&(-1==c&&(c=i.getUint32(d,!0)),d+=4);var f=e[n>=4?1:2];switch(f){case 0:return;case 2:case 7:r={t:"n",v:l};break;case 3:r={t:"s",v:t.sst[s]};break;case 5:r={t:"d",v:u};break;case 6:r={t:"b",v:l>0};break;case 8:r={t:"e",v:0};break;case 9:if(!(o>-1))throw new Error("Unsupported cell type ".concat(e[Rs](0,4)));r={t:"s",v:t.rsst[o]};break;default:throw new Error("Unsupported cell type ".concat(e[Rs](0,4)))}return c>-1&&Hs(r,f|n<<8,a,t.ofmt[c],t.nfmt[c]),7==f&&(r.v/=86400),r}(e,t,e[0]);case 5:return function(e,t){var n,r=Ls(e),i=(r.getUint32(4,!0),r.getUint32(8,!0)),a=12,o=-1,s=-1,c=-1,l=NaN,u=NaN,d=new Date(2001,0,1);1&i&&(l=function(e,t){for(var n=(127&e[t+15])<<7|e[t+14]>>1,r=1&e[t+14],i=t+13;i>=t;--i)r=256*r+e[i];return(128&e[t+15]?-r:r)*Math.pow(10,n-6176)}(e,a),a+=16),2&i&&(u=r.getFloat64(a,!0),a+=8),4&i&&(d.setTime(d.getTime()+1e3*r.getFloat64(a,!0)),a+=8),8&i&&(s=r.getUint32(a,!0),a+=4),16&i&&(o=r.getUint32(a,!0),a+=4);var f=e[1];switch(f){case 0:return;case 2:case 10:n={t:"n",v:l};break;case 3:n={t:"s",v:t.sst[s]};break;case 5:n={t:"d",v:d};break;case 6:n={t:"b",v:u>0};break;case 7:n={t:"n",v:u};break;case 8:n={t:"e",v:0};break;case 9:n={t:"s",v:t.rsst[o]};break;default:throw new Error("Unsupported cell type ".concat(e[1]," : ").concat(31&i," : ").concat(e[Rs](0,4)))}return a+=4*Ps(8160&i),516096&i&&(-1==c&&(c=r.getUint32(a,!0)),a+=4),c>-1&&Hs(n,1280|f,i>>13,t.ofmt[c],t.nfmt[c]),7==f&&(n.v/=86400),n}(e,t);default:throw new Error("Unsupported payload version ".concat(e[0]))}}function Gs(e){return Ns(Us(e)[1][0].data)}function $s(e,t){var n=Us(t.data),r=Ns(n[1][0].data),i=n[3],a=[];return(i||[]).forEach((function(t){var n=Us(t.data);if(n[1]){var i=Ns(n[1][0].data)>>>0;switch(r){case 1:a[i]=Os(n[3][0].data);break;case 8:var o=Us(e[Gs(n[9][0].data)][0].data),s=e[Gs(o[1][0].data)][0],c=Ns(s.meta[1][0].data);if(2001!=c)throw new Error("2000 unexpected reference to ".concat(c));var l=Us(s.data);a[i]=l[3].map((function(e){return Os(e.data)})).join("");break;case 2:a[i]=Us(n[6][0].data);break;default:throw r}}})),a}function Ws(e,t,n){var r=Us(t.data),i={"!ref":"A1"};(null==n?void 0:n.dense)&&(i["!data"]=[]);var a=e[Gs(r[2][0].data)],o=Ns(a[0].meta[1][0].data);if(6001!=o)throw new Error("6000 unexpected reference to ".concat(o));return function(e,t,n){var r,i,a,o,s,c,l=Us(t.data),u={s:{r:0,c:0},e:{r:0,c:0}};if(u.e.r=(Ns(l[6][0].data)>>>0)-1,u.e.r<0)throw new Error("Invalid row varint ".concat(l[6][0].data));if(u.e.c=(Ns(l[7][0].data)>>>0)-1,u.e.c<0)throw new Error("Invalid col varint ".concat(l[7][0].data));n["!ref"]=Dn(u);var d=null!=n["!data"],f=n,h=Us(l[4][0].data),p=zs();(null==(r=h[4])?void 0:r[0])&&(p.sst=$s(e,e[Gs(h[4][0].data)][0])),(null==(i=h[11])?void 0:i[0])&&(p.ofmt=$s(e,e[Gs(h[11][0].data)][0])),(null==(a=h[17])?void 0:a[0])&&(p.rsst=$s(e,e[Gs(h[17][0].data)][0])),(null==(o=h[22])?void 0:o[0])&&(p.nfmt=$s(e,e[Gs(h[22][0].data)][0]));var m=Us(h[3][0].data),v=0;if(m[1].forEach((function(t){var r=Us(t.data),i=e[Gs(r[2][0].data)][0],a=Ns(i.meta[1][0].data);if(6002!=a)throw new Error("6001 unexpected reference to ".concat(a));var o=function(e,t){var n,r=Us(t.data),i=-1;(null==(n=null==r?void 0:r[7])?void 0:n[0])&&(i=Ns(r[7][0].data)>>>0?1:0);var a=Fs(r[5],(function(e){return function(e,t){var n,r,i,a,o,s,c,l,u,d,f,h,p,m,v,g,b=Us(e),_=Ns(b[1][0].data)>>>0,y=Ns(b[2][0].data)>>>0,x=(null==(r=null==(n=b[8])?void 0:n[0])?void 0:r.data)&&Ns(b[8][0].data)>0||!1;if((null==(a=null==(i=b[7])?void 0:i[0])?void 0:a.data)&&0!=t)v=null==(s=null==(o=b[7])?void 0:o[0])?void 0:s.data,g=null==(l=null==(c=b[6])?void 0:c[0])?void 0:l.data;else{if(!(null==(d=null==(u=b[4])?void 0:u[0])?void 0:d.data)||1==t)throw"NUMBERS Tile missing ".concat(t," cell storage");v=null==(h=null==(f=b[4])?void 0:f[0])?void 0:h.data,g=null==(m=null==(p=b[3])?void 0:p[0])?void 0:m.data}for(var A=x?4:1,w=Ls(v),E=[],T=0;T<v.length/2;++T){var S=w.getUint16(2*T,!0);S<65535&&E.push([T,S])}if(E.length!=y)throw"Expected ".concat(y," cells, found ").concat(E.length);var C=[];for(T=0;T<E.length-1;++T)C[E[T][0]]=g[Rs](E[T][1]*A,E[T+1][1]*A);return E.length>=1&&(C[E[E.length-1][0]]=g[Rs](E[E.length-1][1]*A)),{R:_,cells:C}}(e,i)}));return{nrows:Ns(r[4][0].data)>>>0,data:a.reduce((function(e,t){return e[t.R]||(e[t.R]=[]),t.cells.forEach((function(n,r){if(e[t.R][r])throw new Error("Duplicate cell r=".concat(t.R," c=").concat(r));e[t.R][r]=n})),e}),[])}}(0,i);o.data.forEach((function(e,t){e.forEach((function(e,r){var i=Vs(e,p);i&&(d?(f["!data"][v+t]||(f["!data"][v+t]=[]),f["!data"][v+t][r]=i):n[Ln(r)+kn(v+t)]=i)}))})),v+=o.nrows})),null==(s=h[13])?void 0:s[0]){var g=e[Gs(h[13][0].data)][0],b=Ns(g.meta[1][0].data);if(6144!=b)throw new Error("Expected merge type 6144, found ".concat(b));n["!merges"]=null==(c=Us(g.data))?void 0:c[1].map((function(e){var t=Us(e.data),n=Ls(Us(t[1][0].data)[1][0].data),r=Ls(Us(t[2][0].data)[1][0].data);return{s:{r:n.getUint16(0,!0),c:n.getUint16(2,!0)},e:{r:n.getUint16(0,!0)+r.getUint16(0,!0)-1,c:n.getUint16(2,!0)+r.getUint16(2,!0)-1}}}))}}(e,a[0],i),i}function js(e,t){var n,r,i,a,o,s,c,l={},u=[];if(e.FullPaths.forEach((function(e){if(e.match(/\.iwpv2/))throw new Error("Unsupported password protection")})),e.FileIndex.forEach((function(e){if(e.name.match(/\.iwa$/)&&0==e.content[0]){var t,n;try{t=function(e){Array.isArray(e)&&(e=new Uint8Array(e));for(var t=[],n=0;n<e.length;){var r=e[n++],i=e[n]|e[n+1]<<8|e[n+2]<<16;n+=3,t.push.apply(t,Bs(r,e[Rs](n,n+i))),n+=i}if(n!==e.length)throw new Error("data is not a valid framed stream!");return 1==t.length?t[0]:Is(t)}(e.content)}catch(t){return console.log("?? "+e.content.length+" "+(t.message||t))}try{n=function(e){for(var t,n=[],r={l:0};r.l<e.length;){var i=Ds(e,r),a=Us(e[Rs](r.l,r.l+i));r.l+=i;var o={id:Ns(a[1][0].data),messages:[]};a[2].forEach((function(t){var n=Us(t.data),i=Ns(n[3][0].data);o.messages.push({meta:n,data:e[Rs](r.l,r.l+i)}),r.l+=i})),(null==(t=a[3])?void 0:t[0])&&(o.merge=Ns(a[3][0].data)>>>0>0),n.push(o)}return n}(t)}catch(e){return console.log("## "+(e.message||e))}n.forEach((function(e){l[e.id]=e.messages,u.push(e.id)}))}})),!u.length)throw new Error("File has no messages");if((null==(i=null==(r=null==(n=null==l?void 0:l[1])?void 0:n[0].meta)?void 0:r[1])?void 0:i[0].data)&&1e4==Ns(l[1][0].meta[1][0].data))throw new Error("Pages documents are not supported");var d=(null==(c=null==(s=null==(o=null==(a=null==l?void 0:l[1])?void 0:a[0])?void 0:o.meta)?void 0:s[1])?void 0:c[0].data)&&1==Ns(l[1][0].meta[1][0].data)&&l[1][0];if(d||u.forEach((function(e){l[e].forEach((function(e){if(1==Ns(e.meta[1][0].data)>>>0){if(d)throw new Error("Document has multiple roots");d=e}}))})),!d)throw new Error("Cannot find Document root");return function(e,t,n){var r,i={SheetNames:[],Sheets:{}},a=Us(t.data);if(null==(r=a[2])?void 0:r[0])throw new Error("Keynote presentations are not supported");if(Fs(a[1],Gs).forEach((function(t){e[t].forEach((function(t){if(2==Ns(t.meta[1][0].data)){var r=function(e,t,n){var r,i=Us(t.data),a={name:(null==(r=i[1])?void 0:r[0])?Os(i[1][0].data):"",sheets:[]};return Fs(i[2],Gs).forEach((function(t){e[t].forEach((function(t){6e3==Ns(t.meta[1][0].data)&&a.sheets.push(Ws(e,t,n))}))})),a}(e,t,n);r.sheets.forEach((function(e,t){lc(i,e,0==t?r.name:r.name+"_"+t,!0)}))}}))})),0==i.SheetNames.length)throw new Error("Empty NUMBERS file");return i.bookType="numbers",i}(l,d,t)}function Xs(e){var t;(t=[["cellNF",!1],["cellHTML",!0],["cellFormula",!0],["cellStyles",!1],["cellText",!0],["cellDates",!1],["sheetStubs",!1],["sheetRows",0,"n"],["bookDeps",!1],["bookSheets",!1],["bookProps",!1],["bookFiles",!1],["bookVBA",!1],["password",""],["WTF",!1]],function(e){for(var n=0;n!=t.length;++n){var r=t[n];void 0===e[r[0]]&&(e[r[0]]=r[1]),"n"===r[2]&&(e[r[0]]=Number(e[r[0]]))}})(e)}function Ys(e,t,n,r,i,a,o,s,c,l,u,d){try{a[r]=yr(Qe(e,n,!0),t);var f,h=Je(e,t);switch(s){case"sheet":f=es(h,t,i,c,a[r],l,u,d);break;case"chart":if(!(f=function(e,t,n,r,i,a,o,s){return".bin"===t.slice(-4)?function(e,t,n,r,i){if(!e)return e;r||(r={"!id":{}});var a={"!type":"chart","!drawel":null,"!rel":""},o=[],s=!1;return An(e,(function(e,r,c){switch(c){case 550:a["!rel"]=e;break;case 651:i.Sheets[n]||(i.Sheets[n]={}),e.name&&(i.Sheets[n].CodeName=e.name);break;case 562:case 652:case 669:case 679:case 551:case 552:case 476:case 3072:break;case 35:s=!0;break;case 36:s=!1;break;case 37:o.push(c);break;case 38:o.pop();break;default:if(r.T>0)o.push(c);else if(r.T<0)o.pop();else if(!s||t.WTF)throw new Error("Unexpected record 0x"+c.toString(16))}}),t),r["!id"][a["!rel"]]&&(a["!drawel"]=r["!id"][a["!rel"]]),a}(e,r,n,i,a):function(e,t,n,r,i){if(!e)return e;r||(r={"!id":{}});var a,o={"!type":"chart","!drawel":null,"!rel":""},s=e.match(Po);return s&&Uo(s[0],0,i,n),(a=e.match(/drawing r:id="(.*?)"/))&&(o["!rel"]=a[1]),r["!id"][o["!rel"]]&&(o["!drawel"]=r["!id"][o["!rel"]]),o}(e,0,n,i,a)}(h,t,i,c,a[r],l))||!f["!drawel"])break;var p=rt(f["!drawel"].Target,t),m=_r(p),v=function(e,t){if(!e)return"??";var n=(e.match(/<c:chart [^>]*r:id="([^"]*)"/)||["",""])[1];return t["!id"][n].Target}(Qe(e,p,!0),yr(Qe(e,m,!0),p)),g=rt(v,p),b=_r(g);f=function(e,t,n,r,i,a){var o=a||{"!type":"chart"};if(!e)return a;var s=0,c=0,l="A",u={s:{r:2e6,c:2e6},e:{r:0,c:0}};return(e.match(/<c:numCache>[\s\S]*?<\/c:numCache>/gm)||[]).forEach((function(e){var t=function(e){var t,n=[],r=e.match(/^<c:numCache>/);(e.match(/<c:pt idx="(\d*)">(.*?)<\/c:pt>/gm)||[]).forEach((function(e){var t=e.match(/<c:pt idx="(\d*?)"><c:v>(.*)<\/c:v><\/c:pt>/);t&&(n[+t[1]]=r?+t[2]:t[2])}));var i=pt((e.match(/<c:formatCode>([\s\S]*?)<\/c:formatCode>/)||["","General"])[1]);return(e.match(/<c:f>(.*?)<\/c:f>/gm)||[]).forEach((function(e){t=e.replace(/<.*?>/g,"")})),[n,i,t]}(e);u.s.r=u.s.c=0,u.e.c=s,l=Ln(s),t[0].forEach((function(e,n){o["!data"]?(o["!data"][n]||(o["!data"][n]=[]),o["!data"][n][s]={t:"n",v:e,z:t[1]}):o[l+kn(n)]={t:"n",v:e,z:t[1]},c=n})),u.e.r<c&&(u.e.r=c),++s})),s>0&&(o["!ref"]=Dn(u)),o}(Qe(e,g,!0),0,0,yr(Qe(e,b,!0),g),0,f);break;case"macro":x=t,a[r],x.slice(-4),f={"!type":"macro"};break;case"dialog":f=function(e,t,n,r,i,a,o,s){return t.slice(-4),{"!type":"dialog"}}(0,t,0,0,a[r]);break;default:throw new Error("Unrecognized sheet type "+s)}o[r]=f;var _=[],y=[];a&&a[r]&&Ce(a[r]).forEach((function(n){var i="";if(a[r][n].Type==br.CMNT){if(i=rt(a[r][n].Target,t),!(_=function(e,t,n){return".bin"===t.slice(-4)?function(e,t){var n=[],r=[],i={},a=!1;return An(e,(function(e,o,s){switch(s){case 632:r.push(e);break;case 635:i=e;break;case 637:i.t=e.t,i.h=e.h,i.r=e.r;break;case 636:if(i.author=r[i.iauthor],delete i.iauthor,t.sheetRows&&i.rfx&&t.sheetRows<=i.rfx.r)break;i.t||(i.t=""),delete i.rfx,n.push(i);break;case 3072:case 37:case 38:break;case 35:a=!0;break;case 36:a=!1;break;default:if(o.T);else if(!a||t.WTF)throw new Error("Unexpected record 0x"+s.toString(16))}})),n}(e,n):function(e,t){if(e.match(/<(?:\w+:)?comments *\/>/))return[];var n=[],r=[],i=e.match(/<(?:\w+:)?authors>([\s\S]*)<\/(?:\w+:)?authors>/);i&&i[1]&&i[1].split(/<\/\w*:?author>/).forEach((function(e){if(""!==e&&""!==e.trim()){var t=e.match(/<(?:\w+:)?author[^>]*>(.*)/);t&&n.push(t[1])}}));var a=e.match(/<(?:\w+:)?commentList>([\s\S]*)<\/(?:\w+:)?commentList>/);return a&&a[1]&&a[1].split(/<\/\w*:?comment>/).forEach((function(e){if(""!==e&&""!==e.trim()){var i=e.match(/<(?:\w+:)?comment[^>]*>/);if(i){var a=ut(i[0]),o={author:a.authorId&&n[a.authorId]||"sheetjsghost",ref:a.ref,guid:a.guid},s=On(a.ref);if(!(t.sheetRows&&t.sheetRows<=s.r)){var c=e.match(/<(?:\w+:)?text>([\s\S]*)<\/(?:\w+:)?text>/),l=!!c&&!!c[1]&&Ui(c[1])||{r:"",t:"",h:""};o.r=l.r,"<t></t>"==l.r&&(l.t=l.h=""),o.t=(l.t||"").replace(/\r\n/g,"\n").replace(/\r/g,"\n"),t.cellHTML&&(o.h=l.h),r.push(o)}}}})),r}(e,n)}(Je(e,i,!0),i,c))||!_.length)return;Ma(f,_,!1)}a[r][n].Type==br.TCMNT&&(i=rt(a[r][n].Target,t),y=y.concat(function(e,t){var n=[],r=!1,i={},a=0;return e.replace(st,(function(o,s){var c=ut(o);switch(dt(c[0])){case"<?xml":case"<ThreadedComments":case"</ThreadedComments>":case"<extLst":case"<extLst>":case"</extLst>":case"<extLst/>":break;case"<threadedComment":i={author:c.personId,guid:c.id,ref:c.ref,T:1};break;case"</threadedComment>":null!=i.t&&n.push(i);break;case"<text>":case"<text":a=s+o.length;break;case"</text>":i.t=e.slice(a,s).replace(/\r\n/g,"\n").replace(/\r/g,"\n");break;case"<mentions":case"<mentions>":case"<ext":r=!0;break;case"</mentions>":case"</ext>":r=!1;break;default:if(!r&&t.WTF)throw new Error("unrecognized "+c[0]+" in threaded comments")}return o})),n}(Je(e,i,!0),c)))})),y&&y.length&&Ma(f,y,!0,c.people||[])}catch(e){if(c.WTF)throw e}var x}function qs(e){return"/"==e.charAt(0)?e.slice(1):e}function Ks(e,t){if(_e(),Xs(t=t||{}),Ke(e,"META-INF/manifest.xml"))return Ms(e,t);if(Ke(e,"objectdata.xml"))return Ms(e,t);if(Ke(e,"Index/Document.iwa")){if("undefined"==typeof Uint8Array)throw new Error("NUMBERS file parsing requires Uint8Array support");if(void 0!==js){if(e.FileIndex)return js(e,t);var n=Se.utils.cfb_new();return tt(e).forEach((function(t){!function(e,t,n){if(e.FullPaths){var r;if("string"==typeof n)return r=y?x(n):function(e){for(var t=[],n=0,r=e.length+250,i=w(e.length+255),a=0;a<e.length;++a){var o=e.charCodeAt(a);if(o<128)i[n++]=o;else if(o<2048)i[n++]=192|o>>6&31,i[n++]=128|63&o;else if(o>=55296&&o<57344){o=64+(1023&o);var s=1023&e.charCodeAt(++a);i[n++]=240|o>>8&7,i[n++]=128|o>>2&63,i[n++]=128|s>>6&15|(3&o)<<4,i[n++]=128|63&s}else i[n++]=224|o>>12&15,i[n++]=128|o>>6&63,i[n++]=128|63&o;n>r&&(t.push(i.slice(0,n)),n=0,i=w(65535),r=65530)}return t.push(i.slice(0,n)),M(t)}(n),Se.utils.cfb_add(e,t,r);Se.utils.cfb_add(e,t,n)}else e.file(t,n)}(n,t,et(e,t))})),js(n,t)}throw new Error("Unsupported NUMBERS file")}if(!Ke(e,"[Content_Types].xml")){if(Ke(e,"index.xml.gz"))throw new Error("Unsupported NUMBERS 08 file");if(Ke(e,"index.xml"))throw new Error("Unsupported NUMBERS 09 file");var r=Se.find(e,"Index.zip");if(r)return delete(t=He(t)).type,"string"==typeof r.content&&(t.type="binary"),"undefined"!=typeof Bun&&Buffer.isBuffer(r.content)?tc(new Uint8Array(r.content),t):tc(r.content,t);throw new Error("Unsupported ZIP file")}var i,a,o=tt(e),s=function(e){var t={workbooks:[],sheets:[],charts:[],dialogs:[],macros:[],rels:[],strs:[],comments:[],threadedcomments:[],links:[],coreprops:[],extprops:[],custprops:[],themes:[],styles:[],calcchains:[],vba:[],drawings:[],metadata:[],people:[],TODO:[],xmlns:""};if(!e||!e.match)return t;var n={};if((e.match(st)||[]).forEach((function(e){var r=ut(e);switch(r[0].replace(ct,"<")){case"<?xml":break;case"<Types":t.xmlns=r["xmlns"+(r[0].match(/<(\w+):/)||["",""])[1]];break;case"<Default":n[r.Extension.toLowerCase()]=r.ContentType;break;case"<Override":void 0!==t[gr[r.ContentType]]&&t[gr[r.ContentType]].push(r.PartName)}})),t.xmlns!==Nt.CT)throw new Error("Unknown Namespace: "+t.xmlns);return t.calcchain=t.calcchains.length>0?t.calcchains[0]:"",t.sst=t.strs.length>0?t.strs[0]:"",t.style=t.styles.length>0?t.styles[0]:"",t.defaults=n,delete t.calcchains,t}(Qe(e,"[Content_Types].xml")),c=!1;if(0===s.workbooks.length&&Je(e,a="xl/workbook.xml",!0)&&s.workbooks.push(a),0===s.workbooks.length){if(!Je(e,a="xl/workbook.bin",!0))throw new Error("Could not find workbook");s.workbooks.push(a),c=!0}"bin"==s.workbooks[0].slice(-3)&&(c=!0);var l={},u={};if(!t.bookSheets&&!t.bookProps){if(wo=[],s.sst)try{wo=function(e,t,n){return".bin"===t.slice(-4)?function(e,t){var n=[],r=!1;return An(e,(function(e,i,a){switch(a){case 159:n.Count=e[0],n.Unique=e[1];break;case 19:n.push(e);break;case 160:return!0;case 35:r=!0;break;case 36:r=!1;break;default:if(i.T,!r||t.WTF)throw new Error("Unexpected record 0x"+a.toString(16))}})),n}(e,n):function(e,t){var n=[],r="";if(!e)return n;var i=e.match(Fi);if(i){r=i[2].replace(Bi,"").split(zi);for(var a=0;a!=r.length;++a){var o=Ui(r[a].trim(),t);null!=o&&(n[n.length]=o)}i=ut(i[1]),n.Count=i.count,n.Unique=i.uniqueCount}return n}(e,n)}(Je(e,qs(s.sst)),s.sst,t)}catch(e){if(t.WTF)throw e}t.cellStyles&&s.themes.length&&(l=Sa(Qe(e,s.themes[0].replace(/^\//,""),!0)||"",t)),s.style&&(u=function(e,t,n,r){return".bin"===t.slice(-4)?function(e,t,n){var r={NumberFmt:[]};for(var i in z)r.NumberFmt[i]=z[i];r.CellXf=[],r.Fonts=[];var a=[],o=!1;return An(e,(function(e,i,s){switch(s){case 44:r.NumberFmt[e[0]]=e[1],we(e[1],e[0]);break;case 43:r.Fonts.push(e),null!=e.color.theme&&t&&t.themeElements&&t.themeElements.clrScheme&&(e.color.rgb=Ji(t.themeElements.clrScheme[e.color.theme].rgb,e.color.tint||0));break;case 1025:case 45:case 46:case 48:case 507:case 572:case 475:case 1171:case 2102:case 1130:case 512:case 2095:case 3072:break;case 47:617==a[a.length-1]&&r.CellXf.push(e);break;case 35:o=!0;break;case 36:o=!1;break;case 37:a.push(s),o=!0;break;case 38:a.pop(),o=!1;break;default:if(i.T>0)a.push(s);else if(i.T<0)a.pop();else if(!o||n.WTF&&37!=a[a.length-1])throw new Error("Unexpected record 0x"+s.toString(16))}})),r}(e,n,r):ma(e,n,r)}(Je(e,qs(s.style)),s.style,l,t))}s.links.map((function(n){try{return yr(Qe(e,_r(qs(n))),n),function(e,t,n,r){if(".bin"===n.slice(-4))return function(e,t,n,r){if(!e)return e;var i=r||{},a=!1;An(e,(function(e,t,n){switch(n){case 359:case 363:case 364:case 366:case 367:case 368:case 369:case 370:case 371:case 472:case 577:case 578:case 579:case 580:case 581:case 582:case 583:case 584:case 585:case 586:case 587:break;case 35:a=!0;break;case 36:a=!1;break;default:if(t.T);else if(!a||i.WTF)throw new Error("Unexpected record 0x"+n.toString(16))}}),i)}(e,0,0,r)}(Je(e,qs(n)),0,n,t)}catch(e){}}));var d=function(e,t,n){return".bin"===t.slice(-4)?function(e,t){var n={AppVersion:{},WBProps:{},WBView:[],Sheets:[],CalcPr:{},xmlns:""},r=[],i=!1;t||(t={}),t.biff=12;var a=[],o=[[]];return o.SheetNames=[],o.XTI=[],bs[16]={n:"BrtFRTArchID$",f:Qo},An(e,(function(e,s,c){switch(c){case 156:o.SheetNames.push(e.name),n.Sheets.push(e);break;case 153:n.WBProps=e;break;case 39:null!=e.Sheet&&(t.SID=e.Sheet),e.Ref=co(e.Ptg,0,null,o,t),delete t.SID,delete e.Ptg,a.push(e);break;case 1036:case 361:case 2071:case 158:case 143:case 664:case 353:case 3072:case 3073:case 534:case 677:case 157:case 610:case 2050:case 155:case 548:case 676:case 128:case 665:case 2128:case 2125:case 549:case 2053:case 596:case 2076:case 2075:case 2082:case 397:case 154:case 1117:case 553:case 2091:case 16:break;case 357:case 358:case 355:case 667:o[0].length?o.push([c,e]):o[0]=[c,e],o[o.length-1].XTI=[];break;case 362:0===o.length&&(o[0]=[],o[0].XTI=[]),o[o.length-1].XTI=o[o.length-1].XTI.concat(e),o.XTI=o.XTI.concat(e);break;case 35:case 37:r.push(c),i=!0;break;case 36:case 38:r.pop(),i=!1;break;default:if(s.T);else if(!i||t.WTF&&37!=r[r.length-1]&&35!=r[r.length-1])throw new Error("Unexpected record 0x"+c.toString(16))}}),t),Ko(n),n.Names=a,n.supbooks=o,n}(e,n):function(e,t){if(!e)throw new Error("Could not find file");var n={AppVersion:{},WBProps:{},WBView:[],Sheets:[],CalcPr:{},Names:[],xmlns:""},r=!1,i="xmlns",a={},o=0;if(e.replace(st,(function(s,c){var l=ut(s);switch(dt(l[0])){case"<?xml":case"</workbook>":case"<fileVersion/>":case"</fileVersion>":case"<fileSharing":case"<fileSharing/>":case"</workbookPr>":case"<workbookProtection":case"<workbookProtection/>":case"<bookViews":case"<bookViews>":case"</bookViews>":case"</workbookView>":case"<sheets":case"<sheets>":case"</sheets>":case"</sheet>":case"<functionGroups":case"<functionGroups/>":case"<functionGroup":case"<externalReferences":case"</externalReferences>":case"<externalReferences>":case"<externalReference":case"<definedNames/>":case"<definedName/>":case"</calcPr>":case"<oleSize":case"<customWorkbookViews>":case"</customWorkbookViews>":case"<customWorkbookViews":case"<customWorkbookView":case"</customWorkbookView>":case"<pivotCaches>":case"</pivotCaches>":case"<pivotCaches":case"<pivotCache":case"<smartTagPr":case"<smartTagPr/>":case"<smartTagTypes":case"<smartTagTypes>":case"</smartTagTypes>":case"<smartTagType":case"<webPublishing":case"<webPublishing/>":case"<fileRecoveryPr":case"<fileRecoveryPr/>":case"<webPublishObjects>":case"<webPublishObjects":case"</webPublishObjects>":case"<webPublishObject":case"<extLst":case"<extLst>":case"</extLst>":case"<extLst/>":case"<ArchID":case"<revisionPtr":break;case"<workbook":s.match(Jo)&&(i="xmlns"+s.match(/<(\w+):/)[1]),n.xmlns=l[i];break;case"<fileVersion":delete l[0],n.AppVersion=l;break;case"<workbookPr":case"<workbookPr/>":$o.forEach((function(e){if(null!=l[e[0]])switch(e[2]){case"bool":n.WBProps[e[0]]=_t(l[e[0]]);break;case"int":n.WBProps[e[0]]=parseInt(l[e[0]],10);break;default:n.WBProps[e[0]]=l[e[0]]}})),l.codeName&&(n.WBProps.CodeName=Et(l.codeName));break;case"<workbookView":case"<workbookView/>":delete l[0],n.WBView.push(l);break;case"<sheet":switch(l.state){case"hidden":l.Hidden=1;break;case"veryHidden":l.Hidden=2;break;default:l.Hidden=0}delete l.state,l.name=pt(Et(l.name)),delete l[0],n.Sheets.push(l);break;case"<definedNames>":case"<definedNames":case"<ext":case"<AlternateContent":case"<AlternateContent>":r=!0;break;case"</definedNames>":case"</ext>":case"</AlternateContent>":r=!1;break;case"<definedName":(a={}).Name=Et(l.name),l.comment&&(a.Comment=l.comment),l.localSheetId&&(a.Sheet=+l.localSheetId),_t(l.hidden||"0")&&(a.Hidden=!0),o=c+s.length;break;case"</definedName>":a.Ref=pt(Et(e.slice(o,c))),n.Names.push(a);break;case"<calcPr":case"<calcPr/>":delete l[0],n.CalcPr=l;break;default:if(!r&&t.WTF)throw new Error("unrecognized "+l[0]+" in workbook")}return s})),-1===Ut.indexOf(n.xmlns))throw new Error("Unknown Namespace: "+n.xmlns);return Ko(n),n}(e,n)}(Je(e,qs(s.workbooks[0])),s.workbooks[0],t),f={},h="";s.coreprops.length&&((h=Je(e,qs(s.coreprops[0]),!0))&&(f=Er(h)),0!==s.extprops.length&&(h=Je(e,qs(s.extprops[0]),!0))&&function(e,t,n){var r={};t||(t={}),e=Et(e),Tr.forEach((function(n){var i=(e.match(St(n[0]))||[])[1];switch(n[2]){case"string":i&&(t[n[1]]=pt(i));break;case"bool":t[n[1]]="true"===i;break;case"raw":var a=e.match(new RegExp("<"+n[0]+"[^>]*>([\\s\\S]*?)</"+n[0]+">"));a&&a.length>0&&(r[n[1]]=a[1])}})),r.HeadingPairs&&r.TitlesOfParts&&Sr(r.HeadingPairs,r.TitlesOfParts,t,n)}(h,f,t));var p={};t.bookSheets&&!t.bookProps||0!==s.custprops.length&&(h=Qe(e,qs(s.custprops[0]),!0))&&(p=function(e,t){var n={},r="",i=e.match(Mr);if(i)for(var a=0;a!=i.length;++a){var o=i[a],s=ut(o);switch(dt(s[0])){case"<?xml":case"<Properties":break;case"<property":r=pt(s.name);break;case"</property>":r=null;break;default:if(0===o.indexOf("<vt:")){var c=o.split(">"),l=c[0].slice(4),u=c[1];switch(l){case"lpstr":case"bstr":case"lpwstr":case"cy":case"error":n[r]=pt(u);break;case"bool":n[r]=_t(u);break;case"i1":case"i2":case"i4":case"i8":case"int":case"uint":n[r]=parseInt(u,10);break;case"r4":case"r8":case"decimal":n[r]=parseFloat(u);break;case"filetime":case"date":n[r]=Be(u);break;default:if("/"==l.slice(-1))break;t.WTF&&"undefined"!=typeof console&&console.warn("Unexpected",o,l,c)}}else if("</"===o.slice(0,2));else if(t.WTF)throw new Error(o)}}return n}(h,t));var m={};if((t.bookSheets||t.bookProps)&&(d.Sheets?i=d.Sheets.map((function(e){return e.name})):f.Worksheets&&f.SheetNames.length>0&&(i=f.SheetNames),t.bookProps&&(m.Props=f,m.Custprops=p),t.bookSheets&&void 0!==i&&(m.SheetNames=i),t.bookSheets?m.SheetNames:t.bookProps))return m;i={};var v,g={};t.bookDeps&&s.calcchain&&(v=Je(e,qs(s.calcchain)),g=".bin"===s.calcchain.slice(-4)?function(e,t,n){var r=[];return An(e,(function(e,t,n){if(63===n)r.push(e);else if(!t.T)throw new Error("Unexpected record 0x"+n.toString(16))})),r}(v):function(e){var t=[];if(!e)return t;var n=1;return(e.match(st)||[]).forEach((function(e){var r=ut(e);switch(r[0]){case"<?xml":case"<calcChain":case"<calcChain>":case"</calcChain>":break;case"<c":delete r[0],r.i?n=r.i:r.i=n,t.push(r)}})),t}(v));var b,_,A=0,E={},T=d.Sheets;f.Worksheets=T.length,f.SheetNames=[];for(var S=0;S!=T.length;++S)f.SheetNames[S]=T[S].name;var C=c?"bin":"xml",k=s.workbooks[0].lastIndexOf("/"),R=(s.workbooks[0].slice(0,k+1)+"_rels/"+s.workbooks[0].slice(k+1)+".rels").replace(/^\//,"");Ke(e,R)||(R="xl/_rels/workbook."+C+".rels");var L=yr(Qe(e,R,!0),R.replace(/_rels.*/,"s5s"));(s.metadata||[]).length>=1&&(t.xlmeta=function(e,t,n){return".bin"===t.slice(-4)?function(e,t,n){var r={Types:[],Cell:[],Value:[]},i=n||{},a=[],o=!1,s=2;return An(e,(function(e,t,n){switch(n){case 335:r.Types.push({name:e.name});break;case 51:e.forEach((function(e){1==s?r.Cell.push({type:r.Types[e[0]-1].name,index:e[1]}):0==s&&r.Value.push({type:r.Types[e[0]-1].name,index:e[1]})}));break;case 337:s=e?1:0;break;case 338:s=2;break;case 35:a.push(n),o=!0;break;case 36:a.pop(),o=!1;break;default:if(t.T);else if(!o||i.WTF&&35!=a[a.length-1])throw new Error("Unexpected record 0x"+n.toString(16))}})),r}(e,0,n):function(e,t,n){var r={Types:[],Cell:[],Value:[]};if(!e)return r;var i,a=!1,o=2;return e.replace(st,(function(e){var t=ut(e);switch(dt(t[0])){case"<?xml":case"<metadata":case"</metadata>":case"<metadataTypes":case"</metadataTypes>":case"</metadataType>":case"</futureMetadata>":case"<bk>":case"</bk>":case"</rc>":case"<extLst":case"<extLst>":case"</extLst>":case"<extLst/>":break;case"<metadataType":r.Types.push({name:t.name});break;case"<futureMetadata":for(var s=0;s<r.Types.length;++s)r.Types[s].name==t.name&&(i=r.Types[s]);break;case"<rc":1==o?r.Cell.push({type:r.Types[t.t-1].name,index:+t.v}):0==o&&r.Value.push({type:r.Types[t.t-1].name,index:+t.v});break;case"<cellMetadata":o=1;break;case"</cellMetadata>":case"</valueMetadata>":o=2;break;case"<valueMetadata":o=0;break;case"<ext":a=!0;break;case"</ext>":a=!1;break;case"<rvb":if(!i)break;i.offsets||(i.offsets=[]),i.offsets.push(+t.i);break;default:if(!a&&(null==n?void 0:n.WTF))throw new Error("unrecognized "+t[0]+" in metadata")}return e})),r}(e,0,n)}(Je(e,qs(s.metadata[0])),s.metadata[0],t)),(s.people||[]).length>=1&&(t.people=function(e,t){var n=[],r=!1;return e.replace(st,(function(e){var i=ut(e);switch(dt(i[0])){case"<?xml":case"<personList":case"</personList>":case"</person>":case"<extLst":case"<extLst>":case"</extLst>":case"<extLst/>":break;case"<person":n.push({name:i.displayname,id:i.id});break;case"<ext":r=!0;break;case"</ext>":r=!1;break;default:if(!r&&t.WTF)throw new Error("unrecognized "+i[0]+" in threaded comments")}return e})),n}(Je(e,qs(s.people[0])),t)),L&&(L=function(e,t){if(!e)return 0;try{e=t.map((function(t){return t.id||(t.id=t.strRelID),[t.name,e["!id"][t.id].Target,(n=e["!id"][t.id].Type,br.WS.indexOf(n)>-1?"sheet":br.CS&&n==br.CS?"chart":br.DS&&n==br.DS?"dialog":br.MS&&n==br.MS?"macro":n&&n.length?n:"sheet")];var n}))}catch(e){return null}return e&&0!==e.length?e:null}(L,d.Sheets));var O=Je(e,"xl/worksheets/sheet.xml",!0)?1:0;e:for(A=0;A!=f.Worksheets;++A){var I="sheet";if(L&&L[A]?(b="xl/"+L[A][1].replace(/[\/]?xl\//,""),Ke(e,b)||(b=L[A][1]),Ke(e,b)||(b=R.replace(/_rels\/.*$/,"")+L[A][1]),I=L[A][2]):b=(b="xl/worksheets/sheet"+(A+1-O)+"."+C).replace(/sheet0\./,"sheet."),_=b.replace(/^(.*)(\/)([^\/]*)$/,"$1/_rels/$3.rels"),t&&null!=t.sheets)switch(typeof t.sheets){case"number":if(A!=t.sheets)continue e;break;case"string":if(f.SheetNames[A].toLowerCase()!=t.sheets.toLowerCase())continue e;break;default:if(Array.isArray&&Array.isArray(t.sheets)){for(var P=!1,D=0;D!=t.sheets.length;++D)"number"==typeof t.sheets[D]&&t.sheets[D]==A&&(P=1),"string"==typeof t.sheets[D]&&t.sheets[D].toLowerCase()==f.SheetNames[A].toLowerCase()&&(P=1);if(!P)continue e}}Ys(e,b,_,f.SheetNames[A],A,E,i,I,t,d,l,u)}return m={Directory:s,Workbook:d,Props:f,Custprops:p,Deps:g,Sheets:i,SheetNames:f.SheetNames,Strings:wo,Styles:u,Themes:l,SSF:He(z)},t&&t.bookFiles&&(e.files?(m.keys=o,m.files=e.files):(m.keys=[],m.files={},e.FullPaths.forEach((function(t,n){t=t.replace(/^Root Entry[\/]/,""),m.keys.push(t),m.files[t]=e.FileIndex[n]})))),t&&t.bookVBA&&(s.vba.length>0?m.vbaraw=Je(e,qs(s.vba[0]),!0):s.defaults&&s.defaults.bin===Ra&&(m.vbaraw=Je(e,"xl/vbaProject.bin",!0))),m.bookType=c?"xlsb":"xlsx",m}function Zs(e,t){var n,r,i=t||{},a="Workbook",o=Se.find(e,a);try{if(a="/!DataSpaces/Version",!(o=Se.find(e,a))||!o.content)throw new Error("ECMA-376 Encrypted file missing "+a);if(n=o.content,(r={}).id=n.read_shift(0,"lpp4"),r.R=Vi(n,4),r.U=Vi(n,4),r.W=Vi(n,4),a="/!DataSpaces/DataSpaceMap",!(o=Se.find(e,a))||!o.content)throw new Error("ECMA-376 Encrypted file missing "+a);var s=function(e){var t=[];e.l+=4;for(var n=e.read_shift(4);n-- >0;)t.push(Gi(e));return t}(o.content);if(1!==s.length||1!==s[0].comps.length||0!==s[0].comps[0].t||"StrongEncryptionDataSpace"!==s[0].name||"EncryptedPackage"!==s[0].comps[0].v)throw new Error("ECMA-376 Encrypted file bad "+a);if(a="/!DataSpaces/DataSpaceInfo/StrongEncryptionDataSpace",!(o=Se.find(e,a))||!o.content)throw new Error("ECMA-376 Encrypted file missing "+a);var c=function(e){var t=[];e.l+=4;for(var n=e.read_shift(4);n-- >0;)t.push(e.read_shift(0,"lpp4"));return t}(o.content);if(1!=c.length||"StrongEncryptionTransform"!=c[0])throw new Error("ECMA-376 Encrypted file bad "+a);if(a="/!DataSpaces/TransformInfo/StrongEncryptionTransform/!Primary",!(o=Se.find(e,a))||!o.content)throw new Error("ECMA-376 Encrypted file missing "+a);!function(e){var t=function(e){var t={};return e.read_shift(4),e.l+=4,t.id=e.read_shift(0,"lpp4"),t.name=e.read_shift(0,"lpp4"),t.R=Vi(e,4),t.U=Vi(e,4),t.W=Vi(e,4),t}(e);if(t.ename=e.read_shift(0,"8lpp4"),t.blksz=e.read_shift(4),t.cmode=e.read_shift(4),4!=e.read_shift(4))throw new Error("Bad !Primary record")}(o.content)}catch(e){}if(a="/EncryptionInfo",!(o=Se.find(e,a))||!o.content)throw new Error("ECMA-376 Encrypted file missing "+a);var l=function(e){var t=Vi(e);switch(t.Minor){case 2:return[t.Minor,ji(e)];case 3:return[t.Minor,Xi()];case 4:return[t.Minor,Yi(e)]}throw new Error("ECMA-376 Encrypted file unrecognized Version: "+t.Minor)}(o.content);if(a="/EncryptedPackage",!(o=Se.find(e,a))||!o.content)throw new Error("ECMA-376 Encrypted file missing "+a);if(4==l[0]&&"undefined"!=typeof decrypt_agile)return decrypt_agile(l[1],o.content,i.password||"",i);if(2==l[0]&&"undefined"!=typeof decrypt_std76)return decrypt_std76(l[1],o.content,i.password||"",i);throw new Error("File is password-protected")}function Js(e,t){var n="";switch((t||{}).type||"base64"){case"buffer":case"array":return[e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7]];case"base64":n=_(e.slice(0,12));break;case"binary":n=e;break;default:throw new Error("Unrecognized type "+(t&&t.type||"undefined"))}return[n.charCodeAt(0),n.charCodeAt(1),n.charCodeAt(2),n.charCodeAt(3),n.charCodeAt(4),n.charCodeAt(5),n.charCodeAt(6),n.charCodeAt(7)]}function Qs(e,t){var n=0;e:for(;n<e.length;)switch(e.charCodeAt(n)){case 10:case 13:case 32:++n;break;case 60:return ds(e.slice(n),t);default:break e}return Ri.to_workbook(e,t)}function ec(e,t,n,r){return r?(n.type="string",Ri.to_workbook(e,n)):Ri.to_workbook(t,n)}function tc(e,n){l();var r=n||{};if(r.codepage&&void 0===t&&console.error("Codepage tables are not loaded.  Non-ASCII characters may not give expected results"),"undefined"!=typeof ArrayBuffer&&e instanceof ArrayBuffer)return tc(new Uint8Array(e),((r=He(r)).type="array",r));"undefined"!=typeof Uint8Array&&e instanceof Uint8Array&&!r.type&&(r.type="undefined"!=typeof Deno?"buffer":"array");var i,a=e,o=!1;if(r.cellStyles&&(r.cellNF=!0,r.sheetStubs=!0),Eo={},r.dateNF&&(Eo.dateNF=r.dateNF),r.type||(r.type=y&&Buffer.isBuffer(e)?"buffer":"base64"),"file"==r.type&&(r.type=y?"buffer":"binary",a=function(e){if(void 0!==Ee)return Ee.readFileSync(e);if("undefined"!=typeof Deno)return Deno.readFileSync(e);if("undefined"!=typeof $&&"undefined"!=typeof File&&"undefined"!=typeof Folder)try{var t=File(e);t.open("r"),t.encoding="binary";var n=t.read();return t.close(),n}catch(e){if(!e.message||!e.message.match(/onstruct/))throw e}throw new Error("Cannot access file "+e)}(e),"undefined"==typeof Uint8Array||y||(r.type="array")),"string"==r.type&&(o=!0,r.type="binary",r.codepage=65001,a=function(e){return e.match(/[^\x00-\x7F]/)?Tt(e):e}(e)),"array"==r.type&&"undefined"!=typeof Uint8Array&&e instanceof Uint8Array&&"undefined"!=typeof ArrayBuffer){var s=new ArrayBuffer(3),c=new Uint8Array(s);if(c.foo="bar",!c.foo)return(r=He(r)).type="array",tc(C(a),r)}switch((i=Js(a,r))[0]){case 208:if(207===i[1]&&17===i[2]&&224===i[3]&&161===i[4]&&177===i[5]&&26===i[6]&&225===i[7])return function(e,t){return Se.find(e,"EncryptedPackage")?Zs(e,t):gs(e,t)}(Se.read(a,r),r);break;case 9:if(i[1]<=8)return gs(a,r);break;case 60:return ds(a,r);case 73:if(73===i[1]&&42===i[2]&&0===i[3])throw new Error("TIFF Image File is not a spreadsheet");if(68===i[1])return function(e,t){var n=t||{},r=!!n.WTF;n.WTF=!0;try{var i=Ci.to_workbook(e,n);return n.WTF=r,i}catch(i){if(n.WTF=r,!i.message.match(/SYLK bad record ID/)&&r)throw i;return Ri.to_workbook(e,t)}}(a,r);break;case 84:if(65===i[1]&&66===i[2]&&76===i[3])return Mi.to_workbook(a,r);break;case 80:return 75===i[1]&&i[2]<9&&i[3]<9?function(e,t){var n=e,r=t||{};return r.type||(r.type=y&&Buffer.isBuffer(e)?"buffer":"base64"),Ks(nt(n,r),r)}(a,r):ec(e,a,r,o);case 239:return 60===i[3]?ds(a,r):ec(e,a,r,o);case 255:if(254===i[1])return function(e,n){var r=e;return"base64"==n.type&&(r=_(r)),"undefined"!=typeof ArrayBuffer&&e instanceof ArrayBuffer&&(r=new Uint8Array(e)),r=void 0!==t?t.utils.decode(1200,r.slice(2),"str"):y&&Buffer.isBuffer(e)?e.slice(2).toString("utf16le"):"undefined"!=typeof Uint8Array&&r instanceof Uint8Array?"undefined"!=typeof TextDecoder?new TextDecoder("utf-16le").decode(r.slice(2)):function(e){for(var t=[],n=0;n<e.length>>1;++n)t[n]=String.fromCharCode(e[2*n]+(e[2*n+1]<<8));return t.join("")}(r.slice(2)):d(r.slice(2)),n.type="binary",Qs(r,n)}(a,r);if(0===i[1]&&2===i[2]&&0===i[3])return Li.to_workbook(a,r);break;case 0:if(0===i[1]){if(i[2]>=2&&0===i[3])return Li.to_workbook(a,r);if(0===i[2]&&(8===i[3]||9===i[3]))return Li.to_workbook(a,r)}break;case 3:case 131:case 139:case 140:return Si.to_workbook(a,r);case 123:if(92===i[1]&&114===i[2]&&116===i[3])return function(e,t){var n=Fn(function(e,t){switch(t.type){case"base64":return Ki(_(e),t);case"binary":return Ki(e,t);case"buffer":return Ki(y&&Buffer.isBuffer(e)?e.toString("binary"):S(e),t);case"array":return Ki(ze(e),t)}throw new Error("Unrecognized type "+t.type)}(e,t),t);return n.bookType="rtf",n}(a,r);break;case 10:case 13:case 32:return function(e,t){var n="",r=Js(e,t);switch(t.type){case"base64":n=_(e);break;case"binary":n=e;break;case"buffer":n=e.toString("binary");break;case"array":n=ze(e);break;default:throw new Error("Unrecognized type "+t.type)}return 239==r[0]&&187==r[1]&&191==r[2]&&(n=Et(n)),t.type="binary",Qs(n,t)}(a,r);case 137:if(80===i[1]&&78===i[2]&&71===i[3])throw new Error("PNG Image File is not a spreadsheet");break;case 8:if(231===i[1])throw new Error("Unsupported Multiplan 1.x file!");break;case 12:if(236===i[1])throw new Error("Unsupported Multiplan 2.x file!");if(237===i[1])throw new Error("Unsupported Multiplan 3.x file!")}return Ti.indexOf(i[0])>-1&&i[2]<=12&&i[3]<=31?Si.to_workbook(a,r):ec(e,a,r,o)}function nc(e,t,n,r,i,a,o){var s=kn(n),c=o.defval,l=o.raw||!Object.prototype.hasOwnProperty.call(o,"raw"),u=!0,d=null!=e["!data"],f=1===i?[]:{};if(1!==i)if(Object.defineProperty)try{Object.defineProperty(f,"__rowNum__",{value:n,enumerable:!1})}catch(e){f.__rowNum__=n}else f.__rowNum__=n;if(!d||e["!data"][n])for(var h=t.s.c;h<=t.e.c;++h){var p=d?(e["!data"][n]||[])[h]:e[r[h]+s];if(void 0!==p&&void 0!==p.t){var m=p.v;switch(p.t){case"z":if(null==m)break;continue;case"e":m=0==m?null:void 0;break;case"s":case"d":case"b":case"n":break;default:throw new Error("unrecognized type "+p.t)}if(null!=a[h]){if(null==m)if("e"==p.t&&null===m)f[a[h]]=null;else if(void 0!==c)f[a[h]]=c;else{if(!l||null!==m)continue;f[a[h]]=null}else f[a[h]]=l&&("n"!==p.t||"n"===p.t&&!1!==o.rawNumbers)?m:Un(p,m,o);null!=m&&(u=!1)}}else{if(void 0===c)continue;null!=a[h]&&(f[a[h]]=c)}}return{row:f,isempty:u}}function rc(e,t){if(null==e||null==e["!ref"])return[];var n={t:"n",v:0},r=0,i=1,a=[],o=0,s="",c={s:{r:0,c:0},e:{r:0,c:0}},l=t||{},u=null!=l.range?l.range:e["!ref"];switch(1===l.header?r=1:"A"===l.header?r=2:Array.isArray(l.header)?r=3:null==l.header&&(r=0),typeof u){case"string":c=Nn(u);break;case"number":(c=Nn(e["!ref"])).s.r=u;break;default:c=u}r>0&&(i=0);var d=kn(c.s.r),f=[],h=[],p=0,m=0,v=null!=e["!data"],g=c.s.r,b=0,_={};v&&!e["!data"][g]&&(e["!data"][g]=[]);var y=l.skipHidden&&e["!cols"]||[],x=l.skipHidden&&e["!rows"]||[];for(b=c.s.c;b<=c.e.c;++b)if(!(y[b]||{}).hidden)switch(f[b]=Ln(b),n=v?e["!data"][g][b]:e[f[b]+d],r){case 1:a[b]=b-c.s.c;break;case 2:a[b]=f[b];break;case 3:a[b]=l.header[b-c.s.c];break;default:if(null==n&&(n={w:"__EMPTY",t:"s"}),s=o=Un(n,null,l),m=_[o]||0){do{s=o+"_"+m++}while(_[s]);_[o]=m,_[s]=1}else _[o]=1;a[b]=s}for(g=c.s.r+i;g<=c.e.r;++g)if(!(x[g]||{}).hidden){var A=nc(e,c,g,f,r,a,l);(!1===A.isempty||(1===r?!1!==l.blankrows:l.blankrows))&&(h[p++]=A.row)}return h.length=p,h}var ic=/"/g;function ac(e,t,n,r,i,a,o,s){for(var c=!0,l=[],u="",d=kn(n),f=null!=e["!data"],h=f&&e["!data"][n]||[],p=t.s.c;p<=t.e.c;++p)if(r[p]){var m=f?h[p]:e[r[p]+d];if(null==m)u="";else if(null!=m.v){c=!1,u=""+(s.rawNumbers&&"n"==m.t?m.v:Un(m,null,s));for(var v=0,g=0;v!==u.length;++v)if((g=u.charCodeAt(v))===i||g===a||34===g||s.forceQuotes){u='"'+u.replace(ic,'""')+'"';break}"ID"==u&&(u='"ID"')}else null==m.f||m.F?u="":(c=!1,(u="="+m.f).indexOf(",")>=0&&(u='"'+u.replace(ic,'""')+'"'));l.push(u)}return!1===s.blankrows&&c?null:l.join(o)}function oc(e,t){var n=[],r=null==t?{}:t;if(null==e||null==e["!ref"])return"";for(var i=Nn(e["!ref"]),a=void 0!==r.FS?r.FS:",",o=a.charCodeAt(0),s=void 0!==r.RS?r.RS:"\n",c=s.charCodeAt(0),l=new RegExp(("|"==a?"\\|":a)+"+$"),u="",d=[],f=r.skipHidden&&e["!cols"]||[],h=r.skipHidden&&e["!rows"]||[],p=i.s.c;p<=i.e.c;++p)(f[p]||{}).hidden||(d[p]=Ln(p));for(var m=0,v=i.s.r;v<=i.e.r;++v)(h[v]||{}).hidden||null!=(u=ac(e,i,v,d,o,c,a,r))&&(r.strip&&(u=u.replace(l,"")),(u||!1!==r.blankrows)&&n.push((m++?s:"")+u));return n.join("")}function sc(e,t,n){var r=n||{},i=e?null!=e["!data"]:r.dense;null!=v&&null==i&&(i=v);var a=+!r.skipHeader,o=e||{};!e&&i&&(o["!data"]=[]);var s=0,c=0;if(o&&null!=r.origin)if("number"==typeof r.origin)s=r.origin;else{var l="string"==typeof r.origin?On(r.origin):r.origin;s=l.r,c=l.c}var u={s:{c:0,r:0},e:{c:c,r:s+t.length-1+a}};if(o["!ref"]){var d=Nn(o["!ref"]);u.e.c=Math.max(u.e.c,d.e.c),u.e.r=Math.max(u.e.r,d.e.r),-1==s&&(s=d.e.r+1,u.e.r=s+t.length-1+a)}else-1==s&&(s=0,u.e.r=t.length-1+a);var f=r.header||[],h=0,p=[];t.forEach((function(e,t){i&&!o["!data"][s+t+a]&&(o["!data"][s+t+a]=[]),i&&(p=o["!data"][s+t+a]),Ce(e).forEach((function(n){-1==(h=f.indexOf(n))&&(f[h=f.length]=n);var l=e[n],u="z",d="",m=i?"":Ln(c+h)+kn(s+t+a),v=i?p[c+h]:o[m];!l||"object"!=typeof l||l instanceof Date?("number"==typeof l?u="n":"boolean"==typeof l?u="b":"string"==typeof l?u="s":l instanceof Date?(u="d",r.cellDates||(u="n",l=Re(l)),d=null!=v&&v.z&&me(v.z)?v.z:r.dateNF||z[14]):null===l&&r.nullError&&(u="e",l=0),v?(v.t=u,v.v=l,delete v.w,delete v.R,d&&(v.z=d)):i?p[c+h]=v={t:u,v:l}:o[m]=v={t:u,v:l},d&&(v.z=d)):i?p[c+h]=l:o[m]=l}))})),u.e.c=Math.max(u.e.c,c+f.length-1);var m=kn(s);if(i&&!o["!data"][s]&&(o["!data"][s]=[]),a)for(h=0;h<f.length;++h)i?o["!data"][s][h+c]={t:"s",v:f[h]}:o[Ln(h+c)+m]={t:"s",v:f[h]};return o["!ref"]=Dn(u),o}function cc(e,t,n){if("string"==typeof t){if(null!=e["!data"]){var r=On(t);return e["!data"][r.r]||(e["!data"][r.r]=[]),e["!data"][r.r][r.c]||(e["!data"][r.r][r.c]={t:"z"})}return e[t]||(e[t]={t:"z"})}return cc(e,"number"!=typeof t?In(t):Ln(n||0)+kn(t))}function lc(e,t,n,r){var i=1;if(!n)for(;i<=65535&&-1!=e.SheetNames.indexOf(n="Sheet"+i);++i,n=void 0);if(!n||e.SheetNames.length>=65535)throw new Error("Too many worksheets");if(r&&e.SheetNames.indexOf(n)>=0){var a=n.match(/(^.*?)(\d+)$/);i=a&&+a[2]||0;var o=a&&a[1]||n;for(++i;i<=65535&&-1!=e.SheetNames.indexOf(n=o+i);++i);}if(function(e,t){try{if(""==e)throw new Error("Sheet name cannot be blank");if(e.length>31)throw new Error("Sheet name cannot exceed 31 chars");if(39==e.charCodeAt(0)||39==e.charCodeAt(e.length-1))throw new Error("Sheet name cannot start or end with apostrophe (')");if("history"==e.toLowerCase())throw new Error("Sheet name cannot be 'History'");Zo.forEach((function(t){if(-1!=e.indexOf(t))throw new Error("Sheet name cannot contain : \\ / ? * [ ]")}))}catch(e){if(t)return!1;throw e}}(n),e.SheetNames.indexOf(n)>=0)throw new Error("Worksheet with name |"+n+"| already exists!");return e.SheetNames.push(n),e.Sheets[n]=t,n}function uc(e,t,n){return t?(e.l={Target:t},n&&(e.l.Tooltip=n)):delete e.l,e}var dc={encode_col:Ln,encode_row:kn,encode_cell:In,encode_range:Dn,decode_col:Rn,decode_row:Mn,split_cell:function(e){return e.replace(/(\$?[A-Z]*)(\$?\d*)/,"$1,$2").split(",")},decode_cell:On,decode_range:Pn,format_cell:Un,sheet_add_aoa:Bn,sheet_add_json:sc,sheet_add_dom:ws,aoa_to_sheet:zn,json_to_sheet:function(e,t){return sc(null,e,t)},table_to_sheet:Es,table_to_book:function(e,t){return Fn(Es(e,t),t)},sheet_to_csv:oc,sheet_to_txt:function(e,n){n||(n={}),n.FS="\t",n.RS="\n";var r=oc(e,n);if(void 0===t||"string"==n.type)return r;var i=t.utils.encode(1200,r,"str");return String.fromCharCode(255)+String.fromCharCode(254)+i},sheet_to_json:rc,sheet_to_html:function(e,t){var n=t||{},r=null!=n.header?n.header:'<html><head><meta charset="utf-8"/><title>SheetJS Table Export</title></head><body>',i=null!=n.footer?n.footer:"</body></html>",a=[r],o=Pn(e["!ref"]);a.push(function(e,t,n){return[].join("")+"<table"+(n&&n.id?' id="'+n.id+'"':"")+">"}(0,0,n));for(var s=o.s.r;s<=o.e.r;++s)a.push(As(e,o,s,n));return a.push("</table>"+i),a.join("")},sheet_to_formulae:function(e){var t,n="",r="";if(null==e||null==e["!ref"])return[];var i,a=Nn(e["!ref"]),o="",s=[],c=[],l=null!=e["!data"];for(i=a.s.c;i<=a.e.c;++i)s[i]=Ln(i);for(var u=a.s.r;u<=a.e.r;++u)for(o=kn(u),i=a.s.c;i<=a.e.c;++i)if(n=s[i]+o,r="",void 0!==(t=l?(e["!data"][u]||[])[i]:e[n])){if(null!=t.F){if(n=t.F,!t.f)continue;r=t.f,-1==n.indexOf(":")&&(n=n+":"+n)}if(null!=t.f)r=t.f;else{if("z"==t.t)continue;if("n"==t.t&&null!=t.v)r=""+t.v;else if("b"==t.t)r=t.v?"TRUE":"FALSE";else if(void 0!==t.w)r="'"+t.w;else{if(void 0===t.v)continue;r="s"==t.t?"'"+t.v:""+t.v}}c[c.length]=n+"="+r}return c},sheet_to_row_object_array:rc,sheet_get_cell:cc,book_new:function(){return{SheetNames:[],Sheets:{}}},book_append_sheet:lc,book_set_sheet_visibility:function(e,t,n){e.Workbook||(e.Workbook={}),e.Workbook.Sheets||(e.Workbook.Sheets=[]);var r=function(e,t){if("number"==typeof t){if(t>=0&&e.SheetNames.length>t)return t;throw new Error("Cannot find sheet # "+t)}if("string"==typeof t){var n=e.SheetNames.indexOf(t);if(n>-1)return n;throw new Error("Cannot find sheet name |"+t+"|")}throw new Error("Cannot find sheet |"+t+"|")}(e,t);switch(e.Workbook.Sheets[r]||(e.Workbook.Sheets[r]={}),n){case 0:case 1:case 2:break;default:throw new Error("Bad sheet visibility setting "+n)}e.Workbook.Sheets[r].Hidden=n},cell_set_number_format:function(e,t){return e.z=t,e},cell_set_hyperlink:uc,cell_set_internal_link:function(e,t,n){return uc(e,"#"+t,n)},cell_add_comment:function(e,t,n){e.c||(e.c=[]),e.c.push({t:t,a:n||"SheetJS"})},sheet_set_array_formula:function(e,t,n,r){for(var i="string"!=typeof t?t:Nn(t),a="string"==typeof t?t:Dn(t),o=i.s.r;o<=i.e.r;++o)for(var s=i.s.c;s<=i.e.c;++s){var c=cc(e,o,s);c.t="n",c.F=a,delete c.v,o==i.s.r&&s==i.s.c&&(c.f=n,r&&(c.D=!0))}var l=Pn(e["!ref"]);return l.s.r>i.s.r&&(l.s.r=i.s.r),l.s.c>i.s.c&&(l.s.c=i.s.c),l.e.r<i.e.r&&(l.e.r=i.e.r),l.e.c<i.e.c&&(l.e.c=i.e.c),e["!ref"]=Dn(l),e},consts:{SHEET_VISIBLE:0,SHEET_HIDDEN:1,SHEET_VERY_HIDDEN:2}},fc={data(){return{workbook:null,sheetNames:[],sheets:{},currentSheetName:null,currentSheet:[],loading:!0,forceLoad:!1}},props:{sheetUrl:String,fileSize:Number,maxFileSize:Number},methods:{loadWorkbook(){this.forceLoad=!0,axios.get(this.sheetUrl,{responseType:"arraybuffer"}).then((e=>{try{this.workbook=tc(e.data,{cellDates:!0,cellFormula:!1,cellHTML:!1,cellText:!1}),this.sheetNames=this.workbook.SheetNames,this.loadSheet(this.sheetNames[0])}catch(e){console.error(e),kadi.base.flashDanger($t("Error parsing workbook."))}})).catch((e=>kadi.base.flashDanger($t("Error loading workbook."),{request:e.request}))).finally((()=>this.loading=!1))},loadSheet(e){this.sheets[e]||(this.sheets[e]=dc.sheet_to_json(this.workbook.Sheets[e],{blankrows:!0,dateNF:"dd mmm yyyy hh:mm:ss",defval:"",header:"A",raw:!1})),this.currentSheet=this.sheets[e],this.currentSheetName=e}},mounted(){this.fileSize<=this.maxFileSize&&this.loadWorkbook()}};function hc(e,t,n,r,i,a,o,s){var c,l="function"==typeof e?e.options:e;if(t&&(l.render=t,l.staticRenderFns=n,l._compiled=!0),r&&(l.functional=!0),a&&(l._scopeId="data-v-"+a),o?(c=function(e){(e=e||this.$vnode&&this.$vnode.ssrContext||this.parent&&this.parent.$vnode&&this.parent.$vnode.ssrContext)||"undefined"==typeof __VUE_SSR_CONTEXT__||(e=__VUE_SSR_CONTEXT__),i&&i.call(this,e),e&&e._registeredComponents&&e._registeredComponents.add(o)},l._ssrRegister=c):i&&(c=s?function(){i.call(this,(l.functional?this.parent:this).$root.$options.shadowRoot)}:i),c)if(l.functional){l._injectStyles=c;var u=l.render;l.render=function(e,t){return c.call(t),u(e,t)}}else{var d=l.beforeCreate;l.beforeCreate=d?[].concat(d,c):[c]}return{exports:e,options:l}}n(4172);var pc=hc(fc,e,[],!1,null,"3f92f4b0",null).exports,mc=function(){var e=this,t=e._self._c;return t("div",[e.fileSize>e.maxFileSize&&!e.forceLoad?t("div",[t("button",{staticClass:"btn btn-sm btn-light mb-2",attrs:{type:"button"},on:{click:e.loadFile}},[t("i",{staticClass:"fa-solid fa-eye"}),e._v(" "+e._s(e.$t("Load preview"))+"\n    ")])]):t("div",{ref:"container",staticClass:"card bg-light p-1"},[e.error?t("div",{staticClass:"text-muted ml-1"},[t("i",{staticClass:"fa-solid fa-triangle-exclamation mr-1"}),e._v(" "+e._s(e.error)+"\n    ")]):t("div",[e.loading?e._e():t("div",{staticClass:"toolbar mr-1"},[null!==e.material?t("button",{staticClass:"btn btn-link text-primary",attrs:{type:"button",title:e.$t("Toggle wireframe")},on:{click:e.toggleWireframe}},[t("i",{staticClass:"fa-solid fa-cube"})]):e._e(),e._v(" "),t("button",{staticClass:"btn btn-link text-primary",attrs:{type:"button",title:e.$t("Reset view")},on:{click:e.resetView}},[t("i",{staticClass:"fa-solid fa-eye"})]),e._v(" "),t("button",{staticClass:"btn btn-link text-primary",attrs:{type:"button",title:e.$t("Toggle fullscreen")},on:{click:e.toggleFullscreen}},[t("i",{staticClass:"fa-solid fa-expand"})])]),e._v(" "),e.loading?t("div",{staticClass:"text-muted ml-1"},[t("i",{staticClass:"fa-solid fa-circle-notch fa-spin mr-1"}),e._v(" "+e._s(e.$t("Loading model..."))+"\n      ")]):e._e(),e._v(" "),t("div",{ref:"renderContainer",staticClass:"render-container"})])])])};mc._withStripped=!0;const vc="154",gc=1,bc=2,_c=3,yc=100,xc=0,Ac=1,wc=2,Ec=0,Tc=1,Sc=2,Cc=3,Mc=4,kc=5,Rc=301,Lc=302,Oc=306,Ic=1e3,Pc=1001,Dc=1002,Nc=1003,Uc=1005,Fc=1006,Bc=1008,zc=1009,Hc=1012,Vc=1014,Gc=1015,$c=1016,Wc=1020,jc=1023,Xc=1026,Yc=1027,qc=33776,Kc=33777,Zc=33778,Jc=33779,Qc=36492,el=2300,tl=2301,nl=2302,rl=3001,il="srgb",al="srgb-linear",ol="display-p3",sl=7680,cl="300 es",ll=1035,ul=2e3,dl=2001;class fl{addEventListener(e,t){void 0===this._listeners&&(this._listeners={});const n=this._listeners;void 0===n[e]&&(n[e]=[]),-1===n[e].indexOf(t)&&n[e].push(t)}hasEventListener(e,t){if(void 0===this._listeners)return!1;const n=this._listeners;return void 0!==n[e]&&-1!==n[e].indexOf(t)}removeEventListener(e,t){if(void 0===this._listeners)return;const n=this._listeners[e];if(void 0!==n){const e=n.indexOf(t);-1!==e&&n.splice(e,1)}}dispatchEvent(e){if(void 0===this._listeners)return;const t=this._listeners[e.type];if(void 0!==t){e.target=this;const n=t.slice(0);for(let t=0,r=n.length;t<r;t++)n[t].call(this,e);e.target=null}}}const hl=["00","01","02","03","04","05","06","07","08","09","0a","0b","0c","0d","0e","0f","10","11","12","13","14","15","16","17","18","19","1a","1b","1c","1d","1e","1f","20","21","22","23","24","25","26","27","28","29","2a","2b","2c","2d","2e","2f","30","31","32","33","34","35","36","37","38","39","3a","3b","3c","3d","3e","3f","40","41","42","43","44","45","46","47","48","49","4a","4b","4c","4d","4e","4f","50","51","52","53","54","55","56","57","58","59","5a","5b","5c","5d","5e","5f","60","61","62","63","64","65","66","67","68","69","6a","6b","6c","6d","6e","6f","70","71","72","73","74","75","76","77","78","79","7a","7b","7c","7d","7e","7f","80","81","82","83","84","85","86","87","88","89","8a","8b","8c","8d","8e","8f","90","91","92","93","94","95","96","97","98","99","9a","9b","9c","9d","9e","9f","a0","a1","a2","a3","a4","a5","a6","a7","a8","a9","aa","ab","ac","ad","ae","af","b0","b1","b2","b3","b4","b5","b6","b7","b8","b9","ba","bb","bc","bd","be","bf","c0","c1","c2","c3","c4","c5","c6","c7","c8","c9","ca","cb","cc","cd","ce","cf","d0","d1","d2","d3","d4","d5","d6","d7","d8","d9","da","db","dc","dd","de","df","e0","e1","e2","e3","e4","e5","e6","e7","e8","e9","ea","eb","ec","ed","ee","ef","f0","f1","f2","f3","f4","f5","f6","f7","f8","f9","fa","fb","fc","fd","fe","ff"];let pl=1234567;const ml=Math.PI/180,vl=180/Math.PI;function gl(){const e=4294967295*Math.random()|0,t=4294967295*Math.random()|0,n=4294967295*Math.random()|0,r=4294967295*Math.random()|0;return(hl[255&e]+hl[e>>8&255]+hl[e>>16&255]+hl[e>>24&255]+"-"+hl[255&t]+hl[t>>8&255]+"-"+hl[t>>16&15|64]+hl[t>>24&255]+"-"+hl[63&n|128]+hl[n>>8&255]+"-"+hl[n>>16&255]+hl[n>>24&255]+hl[255&r]+hl[r>>8&255]+hl[r>>16&255]+hl[r>>24&255]).toLowerCase()}function bl(e,t,n){return Math.max(t,Math.min(n,e))}function _l(e,t){return(e%t+t)%t}function yl(e,t,n){return(1-n)*e+n*t}function xl(e){return 0==(e&e-1)&&0!==e}function Al(e){return Math.pow(2,Math.floor(Math.log(e)/Math.LN2))}function wl(e,t){switch(t.constructor){case Float32Array:return e;case Uint32Array:return e/4294967295;case Uint16Array:return e/65535;case Uint8Array:return e/255;case Int32Array:return Math.max(e/2147483647,-1);case Int16Array:return Math.max(e/32767,-1);case Int8Array:return Math.max(e/127,-1);default:throw new Error("Invalid component type.")}}function El(e,t){switch(t.constructor){case Float32Array:return e;case Uint32Array:return Math.round(4294967295*e);case Uint16Array:return Math.round(65535*e);case Uint8Array:return Math.round(255*e);case Int32Array:return Math.round(2147483647*e);case Int16Array:return Math.round(32767*e);case Int8Array:return Math.round(127*e);default:throw new Error("Invalid component type.")}}const Tl={DEG2RAD:ml,RAD2DEG:vl,generateUUID:gl,clamp:bl,euclideanModulo:_l,mapLinear:function(e,t,n,r,i){return r+(e-t)*(i-r)/(n-t)},inverseLerp:function(e,t,n){return e!==t?(n-e)/(t-e):0},lerp:yl,damp:function(e,t,n,r){return yl(e,t,1-Math.exp(-n*r))},pingpong:function(e,t=1){return t-Math.abs(_l(e,2*t)-t)},smoothstep:function(e,t,n){return e<=t?0:e>=n?1:(e=(e-t)/(n-t))*e*(3-2*e)},smootherstep:function(e,t,n){return e<=t?0:e>=n?1:(e=(e-t)/(n-t))*e*e*(e*(6*e-15)+10)},randInt:function(e,t){return e+Math.floor(Math.random()*(t-e+1))},randFloat:function(e,t){return e+Math.random()*(t-e)},randFloatSpread:function(e){return e*(.5-Math.random())},seededRandom:function(e){void 0!==e&&(pl=e);let t=pl+=1831565813;return t=Math.imul(t^t>>>15,1|t),t^=t+Math.imul(t^t>>>7,61|t),((t^t>>>14)>>>0)/4294967296},degToRad:function(e){return e*ml},radToDeg:function(e){return e*vl},isPowerOfTwo:xl,ceilPowerOfTwo:function(e){return Math.pow(2,Math.ceil(Math.log(e)/Math.LN2))},floorPowerOfTwo:Al,setQuaternionFromProperEuler:function(e,t,n,r,i){const a=Math.cos,o=Math.sin,s=a(n/2),c=o(n/2),l=a((t+r)/2),u=o((t+r)/2),d=a((t-r)/2),f=o((t-r)/2),h=a((r-t)/2),p=o((r-t)/2);switch(i){case"XYX":e.set(s*u,c*d,c*f,s*l);break;case"YZY":e.set(c*f,s*u,c*d,s*l);break;case"ZXZ":e.set(c*d,c*f,s*u,s*l);break;case"XZX":e.set(s*u,c*p,c*h,s*l);break;case"YXY":e.set(c*h,s*u,c*p,s*l);break;case"ZYZ":e.set(c*p,c*h,s*u,s*l);break;default:console.warn("THREE.MathUtils: .setQuaternionFromProperEuler() encountered an unknown order: "+i)}},normalize:El,denormalize:wl};class Sl{constructor(e=0,t=0){Sl.prototype.isVector2=!0,this.x=e,this.y=t}get width(){return this.x}set width(e){this.x=e}get height(){return this.y}set height(e){this.y=e}set(e,t){return this.x=e,this.y=t,this}setScalar(e){return this.x=e,this.y=e,this}setX(e){return this.x=e,this}setY(e){return this.y=e,this}setComponent(e,t){switch(e){case 0:this.x=t;break;case 1:this.y=t;break;default:throw new Error("index is out of range: "+e)}return this}getComponent(e){switch(e){case 0:return this.x;case 1:return this.y;default:throw new Error("index is out of range: "+e)}}clone(){return new this.constructor(this.x,this.y)}copy(e){return this.x=e.x,this.y=e.y,this}add(e){return this.x+=e.x,this.y+=e.y,this}addScalar(e){return this.x+=e,this.y+=e,this}addVectors(e,t){return this.x=e.x+t.x,this.y=e.y+t.y,this}addScaledVector(e,t){return this.x+=e.x*t,this.y+=e.y*t,this}sub(e){return this.x-=e.x,this.y-=e.y,this}subScalar(e){return this.x-=e,this.y-=e,this}subVectors(e,t){return this.x=e.x-t.x,this.y=e.y-t.y,this}multiply(e){return this.x*=e.x,this.y*=e.y,this}multiplyScalar(e){return this.x*=e,this.y*=e,this}divide(e){return this.x/=e.x,this.y/=e.y,this}divideScalar(e){return this.multiplyScalar(1/e)}applyMatrix3(e){const t=this.x,n=this.y,r=e.elements;return this.x=r[0]*t+r[3]*n+r[6],this.y=r[1]*t+r[4]*n+r[7],this}min(e){return this.x=Math.min(this.x,e.x),this.y=Math.min(this.y,e.y),this}max(e){return this.x=Math.max(this.x,e.x),this.y=Math.max(this.y,e.y),this}clamp(e,t){return this.x=Math.max(e.x,Math.min(t.x,this.x)),this.y=Math.max(e.y,Math.min(t.y,this.y)),this}clampScalar(e,t){return this.x=Math.max(e,Math.min(t,this.x)),this.y=Math.max(e,Math.min(t,this.y)),this}clampLength(e,t){const n=this.length();return this.divideScalar(n||1).multiplyScalar(Math.max(e,Math.min(t,n)))}floor(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this}ceil(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this}round(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this}roundToZero(){return this.x=this.x<0?Math.ceil(this.x):Math.floor(this.x),this.y=this.y<0?Math.ceil(this.y):Math.floor(this.y),this}negate(){return this.x=-this.x,this.y=-this.y,this}dot(e){return this.x*e.x+this.y*e.y}cross(e){return this.x*e.y-this.y*e.x}lengthSq(){return this.x*this.x+this.y*this.y}length(){return Math.sqrt(this.x*this.x+this.y*this.y)}manhattanLength(){return Math.abs(this.x)+Math.abs(this.y)}normalize(){return this.divideScalar(this.length()||1)}angle(){return Math.atan2(-this.y,-this.x)+Math.PI}angleTo(e){const t=Math.sqrt(this.lengthSq()*e.lengthSq());if(0===t)return Math.PI/2;const n=this.dot(e)/t;return Math.acos(bl(n,-1,1))}distanceTo(e){return Math.sqrt(this.distanceToSquared(e))}distanceToSquared(e){const t=this.x-e.x,n=this.y-e.y;return t*t+n*n}manhattanDistanceTo(e){return Math.abs(this.x-e.x)+Math.abs(this.y-e.y)}setLength(e){return this.normalize().multiplyScalar(e)}lerp(e,t){return this.x+=(e.x-this.x)*t,this.y+=(e.y-this.y)*t,this}lerpVectors(e,t,n){return this.x=e.x+(t.x-e.x)*n,this.y=e.y+(t.y-e.y)*n,this}equals(e){return e.x===this.x&&e.y===this.y}fromArray(e,t=0){return this.x=e[t],this.y=e[t+1],this}toArray(e=[],t=0){return e[t]=this.x,e[t+1]=this.y,e}fromBufferAttribute(e,t){return this.x=e.getX(t),this.y=e.getY(t),this}rotateAround(e,t){const n=Math.cos(t),r=Math.sin(t),i=this.x-e.x,a=this.y-e.y;return this.x=i*n-a*r+e.x,this.y=i*r+a*n+e.y,this}random(){return this.x=Math.random(),this.y=Math.random(),this}*[Symbol.iterator](){yield this.x,yield this.y}}class Cl{constructor(e,t,n,r,i,a,o,s,c){Cl.prototype.isMatrix3=!0,this.elements=[1,0,0,0,1,0,0,0,1],void 0!==e&&this.set(e,t,n,r,i,a,o,s,c)}set(e,t,n,r,i,a,o,s,c){const l=this.elements;return l[0]=e,l[1]=r,l[2]=o,l[3]=t,l[4]=i,l[5]=s,l[6]=n,l[7]=a,l[8]=c,this}identity(){return this.set(1,0,0,0,1,0,0,0,1),this}copy(e){const t=this.elements,n=e.elements;return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t[4]=n[4],t[5]=n[5],t[6]=n[6],t[7]=n[7],t[8]=n[8],this}extractBasis(e,t,n){return e.setFromMatrix3Column(this,0),t.setFromMatrix3Column(this,1),n.setFromMatrix3Column(this,2),this}setFromMatrix4(e){const t=e.elements;return this.set(t[0],t[4],t[8],t[1],t[5],t[9],t[2],t[6],t[10]),this}multiply(e){return this.multiplyMatrices(this,e)}premultiply(e){return this.multiplyMatrices(e,this)}multiplyMatrices(e,t){const n=e.elements,r=t.elements,i=this.elements,a=n[0],o=n[3],s=n[6],c=n[1],l=n[4],u=n[7],d=n[2],f=n[5],h=n[8],p=r[0],m=r[3],v=r[6],g=r[1],b=r[4],_=r[7],y=r[2],x=r[5],A=r[8];return i[0]=a*p+o*g+s*y,i[3]=a*m+o*b+s*x,i[6]=a*v+o*_+s*A,i[1]=c*p+l*g+u*y,i[4]=c*m+l*b+u*x,i[7]=c*v+l*_+u*A,i[2]=d*p+f*g+h*y,i[5]=d*m+f*b+h*x,i[8]=d*v+f*_+h*A,this}multiplyScalar(e){const t=this.elements;return t[0]*=e,t[3]*=e,t[6]*=e,t[1]*=e,t[4]*=e,t[7]*=e,t[2]*=e,t[5]*=e,t[8]*=e,this}determinant(){const e=this.elements,t=e[0],n=e[1],r=e[2],i=e[3],a=e[4],o=e[5],s=e[6],c=e[7],l=e[8];return t*a*l-t*o*c-n*i*l+n*o*s+r*i*c-r*a*s}invert(){const e=this.elements,t=e[0],n=e[1],r=e[2],i=e[3],a=e[4],o=e[5],s=e[6],c=e[7],l=e[8],u=l*a-o*c,d=o*s-l*i,f=c*i-a*s,h=t*u+n*d+r*f;if(0===h)return this.set(0,0,0,0,0,0,0,0,0);const p=1/h;return e[0]=u*p,e[1]=(r*c-l*n)*p,e[2]=(o*n-r*a)*p,e[3]=d*p,e[4]=(l*t-r*s)*p,e[5]=(r*i-o*t)*p,e[6]=f*p,e[7]=(n*s-c*t)*p,e[8]=(a*t-n*i)*p,this}transpose(){let e;const t=this.elements;return e=t[1],t[1]=t[3],t[3]=e,e=t[2],t[2]=t[6],t[6]=e,e=t[5],t[5]=t[7],t[7]=e,this}getNormalMatrix(e){return this.setFromMatrix4(e).invert().transpose()}transposeIntoArray(e){const t=this.elements;return e[0]=t[0],e[1]=t[3],e[2]=t[6],e[3]=t[1],e[4]=t[4],e[5]=t[7],e[6]=t[2],e[7]=t[5],e[8]=t[8],this}setUvTransform(e,t,n,r,i,a,o){const s=Math.cos(i),c=Math.sin(i);return this.set(n*s,n*c,-n*(s*a+c*o)+a+e,-r*c,r*s,-r*(-c*a+s*o)+o+t,0,0,1),this}scale(e,t){return this.premultiply(Ml.makeScale(e,t)),this}rotate(e){return this.premultiply(Ml.makeRotation(-e)),this}translate(e,t){return this.premultiply(Ml.makeTranslation(e,t)),this}makeTranslation(e,t){return e.isVector2?this.set(1,0,e.x,0,1,e.y,0,0,1):this.set(1,0,e,0,1,t,0,0,1),this}makeRotation(e){const t=Math.cos(e),n=Math.sin(e);return this.set(t,-n,0,n,t,0,0,0,1),this}makeScale(e,t){return this.set(e,0,0,0,t,0,0,0,1),this}equals(e){const t=this.elements,n=e.elements;for(let e=0;e<9;e++)if(t[e]!==n[e])return!1;return!0}fromArray(e,t=0){for(let n=0;n<9;n++)this.elements[n]=e[n+t];return this}toArray(e=[],t=0){const n=this.elements;return e[t]=n[0],e[t+1]=n[1],e[t+2]=n[2],e[t+3]=n[3],e[t+4]=n[4],e[t+5]=n[5],e[t+6]=n[6],e[t+7]=n[7],e[t+8]=n[8],e}clone(){return(new this.constructor).fromArray(this.elements)}}const Ml=new Cl;function kl(e){for(let t=e.length-1;t>=0;--t)if(e[t]>=65535)return!0;return!1}function Rl(e){return document.createElementNS("http://www.w3.org/1999/xhtml",e)}Int8Array,Uint8Array,Uint8ClampedArray,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array;const Ll={};function Ol(e){e in Ll||(Ll[e]=!0,console.warn(e))}function Il(e){return e<.04045?.0773993808*e:Math.pow(.9478672986*e+.0521327014,2.4)}function Pl(e){return e<.0031308?12.92*e:1.055*Math.pow(e,.41666)-.055}const Dl=(new Cl).fromArray([.8224621,.0331941,.0170827,.177538,.9668058,.0723974,-1e-7,1e-7,.9105199]),Nl=(new Cl).fromArray([1.2249401,-.0420569,-.0196376,-.2249404,1.0420571,-.0786361,1e-7,0,1.0982735]),Ul={[al]:e=>e,[il]:e=>e.convertSRGBToLinear(),[ol]:function(e){return e.convertSRGBToLinear().applyMatrix3(Nl)}},Fl={[al]:e=>e,[il]:e=>e.convertLinearToSRGB(),[ol]:function(e){return e.applyMatrix3(Dl).convertLinearToSRGB()}},Bl={enabled:!0,get legacyMode(){return console.warn("THREE.ColorManagement: .legacyMode=false renamed to .enabled=true in r150."),!this.enabled},set legacyMode(e){console.warn("THREE.ColorManagement: .legacyMode=false renamed to .enabled=true in r150."),this.enabled=!e},get workingColorSpace(){return al},set workingColorSpace(e){console.warn("THREE.ColorManagement: .workingColorSpace is readonly.")},convert:function(e,t,n){if(!1===this.enabled||t===n||!t||!n)return e;const r=Ul[t],i=Fl[n];if(void 0===r||void 0===i)throw new Error(`Unsupported color space conversion, "${t}" to "${n}".`);return i(r(e))},fromWorkingColorSpace:function(e,t){return this.convert(e,this.workingColorSpace,t)},toWorkingColorSpace:function(e,t){return this.convert(e,t,this.workingColorSpace)}};let zl;class Hl{static getDataURL(e){if(/^data:/i.test(e.src))return e.src;if("undefined"==typeof HTMLCanvasElement)return e.src;let t;if(e instanceof HTMLCanvasElement)t=e;else{void 0===zl&&(zl=Rl("canvas")),zl.width=e.width,zl.height=e.height;const n=zl.getContext("2d");e instanceof ImageData?n.putImageData(e,0,0):n.drawImage(e,0,0,e.width,e.height),t=zl}return t.width>2048||t.height>2048?(console.warn("THREE.ImageUtils.getDataURL: Image converted to jpg for performance reasons",e),t.toDataURL("image/jpeg",.6)):t.toDataURL("image/png")}static sRGBToLinear(e){if("undefined"!=typeof HTMLImageElement&&e instanceof HTMLImageElement||"undefined"!=typeof HTMLCanvasElement&&e instanceof HTMLCanvasElement||"undefined"!=typeof ImageBitmap&&e instanceof ImageBitmap){const t=Rl("canvas");t.width=e.width,t.height=e.height;const n=t.getContext("2d");n.drawImage(e,0,0,e.width,e.height);const r=n.getImageData(0,0,e.width,e.height),i=r.data;for(let e=0;e<i.length;e++)i[e]=255*Il(i[e]/255);return n.putImageData(r,0,0),t}if(e.data){const t=e.data.slice(0);for(let e=0;e<t.length;e++)t instanceof Uint8Array||t instanceof Uint8ClampedArray?t[e]=Math.floor(255*Il(t[e]/255)):t[e]=Il(t[e]);return{data:t,width:e.width,height:e.height}}return console.warn("THREE.ImageUtils.sRGBToLinear(): Unsupported image type. No color space conversion applied."),e}}let Vl=0;class Gl{constructor(e=null){this.isSource=!0,Object.defineProperty(this,"id",{value:Vl++}),this.uuid=gl(),this.data=e,this.version=0}set needsUpdate(e){!0===e&&this.version++}toJSON(e){const t=void 0===e||"string"==typeof e;if(!t&&void 0!==e.images[this.uuid])return e.images[this.uuid];const n={uuid:this.uuid,url:""},r=this.data;if(null!==r){let e;if(Array.isArray(r)){e=[];for(let t=0,n=r.length;t<n;t++)r[t].isDataTexture?e.push($l(r[t].image)):e.push($l(r[t]))}else e=$l(r);n.url=e}return t||(e.images[this.uuid]=n),n}}function $l(e){return"undefined"!=typeof HTMLImageElement&&e instanceof HTMLImageElement||"undefined"!=typeof HTMLCanvasElement&&e instanceof HTMLCanvasElement||"undefined"!=typeof ImageBitmap&&e instanceof ImageBitmap?Hl.getDataURL(e):e.data?{data:Array.from(e.data),width:e.width,height:e.height,type:e.data.constructor.name}:(console.warn("THREE.Texture: Unable to serialize Texture."),{})}let Wl=0;class jl extends fl{constructor(e=jl.DEFAULT_IMAGE,t=jl.DEFAULT_MAPPING,n=1001,r=1001,i=1006,a=1008,o=1023,s=1009,c=jl.DEFAULT_ANISOTROPY,l=""){super(),this.isTexture=!0,Object.defineProperty(this,"id",{value:Wl++}),this.uuid=gl(),this.name="",this.source=new Gl(e),this.mipmaps=[],this.mapping=t,this.channel=0,this.wrapS=n,this.wrapT=r,this.magFilter=i,this.minFilter=a,this.anisotropy=c,this.format=o,this.internalFormat=null,this.type=s,this.offset=new Sl(0,0),this.repeat=new Sl(1,1),this.center=new Sl(0,0),this.rotation=0,this.matrixAutoUpdate=!0,this.matrix=new Cl,this.generateMipmaps=!0,this.premultiplyAlpha=!1,this.flipY=!0,this.unpackAlignment=4,"string"==typeof l?this.colorSpace=l:(Ol("THREE.Texture: Property .encoding has been replaced by .colorSpace."),this.colorSpace=l===rl?il:""),this.userData={},this.version=0,this.onUpdate=null,this.isRenderTargetTexture=!1,this.needsPMREMUpdate=!1}get image(){return this.source.data}set image(e=null){this.source.data=e}updateMatrix(){this.matrix.setUvTransform(this.offset.x,this.offset.y,this.repeat.x,this.repeat.y,this.rotation,this.center.x,this.center.y)}clone(){return(new this.constructor).copy(this)}copy(e){return this.name=e.name,this.source=e.source,this.mipmaps=e.mipmaps.slice(0),this.mapping=e.mapping,this.channel=e.channel,this.wrapS=e.wrapS,this.wrapT=e.wrapT,this.magFilter=e.magFilter,this.minFilter=e.minFilter,this.anisotropy=e.anisotropy,this.format=e.format,this.internalFormat=e.internalFormat,this.type=e.type,this.offset.copy(e.offset),this.repeat.copy(e.repeat),this.center.copy(e.center),this.rotation=e.rotation,this.matrixAutoUpdate=e.matrixAutoUpdate,this.matrix.copy(e.matrix),this.generateMipmaps=e.generateMipmaps,this.premultiplyAlpha=e.premultiplyAlpha,this.flipY=e.flipY,this.unpackAlignment=e.unpackAlignment,this.colorSpace=e.colorSpace,this.userData=JSON.parse(JSON.stringify(e.userData)),this.needsUpdate=!0,this}toJSON(e){const t=void 0===e||"string"==typeof e;if(!t&&void 0!==e.textures[this.uuid])return e.textures[this.uuid];const n={metadata:{version:4.6,type:"Texture",generator:"Texture.toJSON"},uuid:this.uuid,name:this.name,image:this.source.toJSON(e).uuid,mapping:this.mapping,channel:this.channel,repeat:[this.repeat.x,this.repeat.y],offset:[this.offset.x,this.offset.y],center:[this.center.x,this.center.y],rotation:this.rotation,wrap:[this.wrapS,this.wrapT],format:this.format,internalFormat:this.internalFormat,type:this.type,colorSpace:this.colorSpace,minFilter:this.minFilter,magFilter:this.magFilter,anisotropy:this.anisotropy,flipY:this.flipY,generateMipmaps:this.generateMipmaps,premultiplyAlpha:this.premultiplyAlpha,unpackAlignment:this.unpackAlignment};return Object.keys(this.userData).length>0&&(n.userData=this.userData),t||(e.textures[this.uuid]=n),n}dispose(){this.dispatchEvent({type:"dispose"})}transformUv(e){if(300!==this.mapping)return e;if(e.applyMatrix3(this.matrix),e.x<0||e.x>1)switch(this.wrapS){case Ic:e.x=e.x-Math.floor(e.x);break;case Pc:e.x=e.x<0?0:1;break;case Dc:1===Math.abs(Math.floor(e.x)%2)?e.x=Math.ceil(e.x)-e.x:e.x=e.x-Math.floor(e.x)}if(e.y<0||e.y>1)switch(this.wrapT){case Ic:e.y=e.y-Math.floor(e.y);break;case Pc:e.y=e.y<0?0:1;break;case Dc:1===Math.abs(Math.floor(e.y)%2)?e.y=Math.ceil(e.y)-e.y:e.y=e.y-Math.floor(e.y)}return this.flipY&&(e.y=1-e.y),e}set needsUpdate(e){!0===e&&(this.version++,this.source.needsUpdate=!0)}get encoding(){return Ol("THREE.Texture: Property .encoding has been replaced by .colorSpace."),this.colorSpace===il?rl:3e3}set encoding(e){Ol("THREE.Texture: Property .encoding has been replaced by .colorSpace."),this.colorSpace=e===rl?il:""}}jl.DEFAULT_IMAGE=null,jl.DEFAULT_MAPPING=300,jl.DEFAULT_ANISOTROPY=1;class Xl{constructor(e=0,t=0,n=0,r=1){Xl.prototype.isVector4=!0,this.x=e,this.y=t,this.z=n,this.w=r}get width(){return this.z}set width(e){this.z=e}get height(){return this.w}set height(e){this.w=e}set(e,t,n,r){return this.x=e,this.y=t,this.z=n,this.w=r,this}setScalar(e){return this.x=e,this.y=e,this.z=e,this.w=e,this}setX(e){return this.x=e,this}setY(e){return this.y=e,this}setZ(e){return this.z=e,this}setW(e){return this.w=e,this}setComponent(e,t){switch(e){case 0:this.x=t;break;case 1:this.y=t;break;case 2:this.z=t;break;case 3:this.w=t;break;default:throw new Error("index is out of range: "+e)}return this}getComponent(e){switch(e){case 0:return this.x;case 1:return this.y;case 2:return this.z;case 3:return this.w;default:throw new Error("index is out of range: "+e)}}clone(){return new this.constructor(this.x,this.y,this.z,this.w)}copy(e){return this.x=e.x,this.y=e.y,this.z=e.z,this.w=void 0!==e.w?e.w:1,this}add(e){return this.x+=e.x,this.y+=e.y,this.z+=e.z,this.w+=e.w,this}addScalar(e){return this.x+=e,this.y+=e,this.z+=e,this.w+=e,this}addVectors(e,t){return this.x=e.x+t.x,this.y=e.y+t.y,this.z=e.z+t.z,this.w=e.w+t.w,this}addScaledVector(e,t){return this.x+=e.x*t,this.y+=e.y*t,this.z+=e.z*t,this.w+=e.w*t,this}sub(e){return this.x-=e.x,this.y-=e.y,this.z-=e.z,this.w-=e.w,this}subScalar(e){return this.x-=e,this.y-=e,this.z-=e,this.w-=e,this}subVectors(e,t){return this.x=e.x-t.x,this.y=e.y-t.y,this.z=e.z-t.z,this.w=e.w-t.w,this}multiply(e){return this.x*=e.x,this.y*=e.y,this.z*=e.z,this.w*=e.w,this}multiplyScalar(e){return this.x*=e,this.y*=e,this.z*=e,this.w*=e,this}applyMatrix4(e){const t=this.x,n=this.y,r=this.z,i=this.w,a=e.elements;return this.x=a[0]*t+a[4]*n+a[8]*r+a[12]*i,this.y=a[1]*t+a[5]*n+a[9]*r+a[13]*i,this.z=a[2]*t+a[6]*n+a[10]*r+a[14]*i,this.w=a[3]*t+a[7]*n+a[11]*r+a[15]*i,this}divideScalar(e){return this.multiplyScalar(1/e)}setAxisAngleFromQuaternion(e){this.w=2*Math.acos(e.w);const t=Math.sqrt(1-e.w*e.w);return t<1e-4?(this.x=1,this.y=0,this.z=0):(this.x=e.x/t,this.y=e.y/t,this.z=e.z/t),this}setAxisAngleFromRotationMatrix(e){let t,n,r,i;const a=.01,o=.1,s=e.elements,c=s[0],l=s[4],u=s[8],d=s[1],f=s[5],h=s[9],p=s[2],m=s[6],v=s[10];if(Math.abs(l-d)<a&&Math.abs(u-p)<a&&Math.abs(h-m)<a){if(Math.abs(l+d)<o&&Math.abs(u+p)<o&&Math.abs(h+m)<o&&Math.abs(c+f+v-3)<o)return this.set(1,0,0,0),this;t=Math.PI;const e=(c+1)/2,s=(f+1)/2,g=(v+1)/2,b=(l+d)/4,_=(u+p)/4,y=(h+m)/4;return e>s&&e>g?e<a?(n=0,r=.707106781,i=.707106781):(n=Math.sqrt(e),r=b/n,i=_/n):s>g?s<a?(n=.707106781,r=0,i=.707106781):(r=Math.sqrt(s),n=b/r,i=y/r):g<a?(n=.707106781,r=.707106781,i=0):(i=Math.sqrt(g),n=_/i,r=y/i),this.set(n,r,i,t),this}let g=Math.sqrt((m-h)*(m-h)+(u-p)*(u-p)+(d-l)*(d-l));return Math.abs(g)<.001&&(g=1),this.x=(m-h)/g,this.y=(u-p)/g,this.z=(d-l)/g,this.w=Math.acos((c+f+v-1)/2),this}min(e){return this.x=Math.min(this.x,e.x),this.y=Math.min(this.y,e.y),this.z=Math.min(this.z,e.z),this.w=Math.min(this.w,e.w),this}max(e){return this.x=Math.max(this.x,e.x),this.y=Math.max(this.y,e.y),this.z=Math.max(this.z,e.z),this.w=Math.max(this.w,e.w),this}clamp(e,t){return this.x=Math.max(e.x,Math.min(t.x,this.x)),this.y=Math.max(e.y,Math.min(t.y,this.y)),this.z=Math.max(e.z,Math.min(t.z,this.z)),this.w=Math.max(e.w,Math.min(t.w,this.w)),this}clampScalar(e,t){return this.x=Math.max(e,Math.min(t,this.x)),this.y=Math.max(e,Math.min(t,this.y)),this.z=Math.max(e,Math.min(t,this.z)),this.w=Math.max(e,Math.min(t,this.w)),this}clampLength(e,t){const n=this.length();return this.divideScalar(n||1).multiplyScalar(Math.max(e,Math.min(t,n)))}floor(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this.z=Math.floor(this.z),this.w=Math.floor(this.w),this}ceil(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this.z=Math.ceil(this.z),this.w=Math.ceil(this.w),this}round(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this.z=Math.round(this.z),this.w=Math.round(this.w),this}roundToZero(){return this.x=this.x<0?Math.ceil(this.x):Math.floor(this.x),this.y=this.y<0?Math.ceil(this.y):Math.floor(this.y),this.z=this.z<0?Math.ceil(this.z):Math.floor(this.z),this.w=this.w<0?Math.ceil(this.w):Math.floor(this.w),this}negate(){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this.w=-this.w,this}dot(e){return this.x*e.x+this.y*e.y+this.z*e.z+this.w*e.w}lengthSq(){return this.x*this.x+this.y*this.y+this.z*this.z+this.w*this.w}length(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z+this.w*this.w)}manhattanLength(){return Math.abs(this.x)+Math.abs(this.y)+Math.abs(this.z)+Math.abs(this.w)}normalize(){return this.divideScalar(this.length()||1)}setLength(e){return this.normalize().multiplyScalar(e)}lerp(e,t){return this.x+=(e.x-this.x)*t,this.y+=(e.y-this.y)*t,this.z+=(e.z-this.z)*t,this.w+=(e.w-this.w)*t,this}lerpVectors(e,t,n){return this.x=e.x+(t.x-e.x)*n,this.y=e.y+(t.y-e.y)*n,this.z=e.z+(t.z-e.z)*n,this.w=e.w+(t.w-e.w)*n,this}equals(e){return e.x===this.x&&e.y===this.y&&e.z===this.z&&e.w===this.w}fromArray(e,t=0){return this.x=e[t],this.y=e[t+1],this.z=e[t+2],this.w=e[t+3],this}toArray(e=[],t=0){return e[t]=this.x,e[t+1]=this.y,e[t+2]=this.z,e[t+3]=this.w,e}fromBufferAttribute(e,t){return this.x=e.getX(t),this.y=e.getY(t),this.z=e.getZ(t),this.w=e.getW(t),this}random(){return this.x=Math.random(),this.y=Math.random(),this.z=Math.random(),this.w=Math.random(),this}*[Symbol.iterator](){yield this.x,yield this.y,yield this.z,yield this.w}}class Yl extends fl{constructor(e=1,t=1,n={}){super(),this.isWebGLRenderTarget=!0,this.width=e,this.height=t,this.depth=1,this.scissor=new Xl(0,0,e,t),this.scissorTest=!1,this.viewport=new Xl(0,0,e,t);const r={width:e,height:t,depth:1};void 0!==n.encoding&&(Ol("THREE.WebGLRenderTarget: option.encoding has been replaced by option.colorSpace."),n.colorSpace=n.encoding===rl?il:""),this.texture=new jl(r,n.mapping,n.wrapS,n.wrapT,n.magFilter,n.minFilter,n.format,n.type,n.anisotropy,n.colorSpace),this.texture.isRenderTargetTexture=!0,this.texture.flipY=!1,this.texture.generateMipmaps=void 0!==n.generateMipmaps&&n.generateMipmaps,this.texture.internalFormat=void 0!==n.internalFormat?n.internalFormat:null,this.texture.minFilter=void 0!==n.minFilter?n.minFilter:Fc,this.depthBuffer=void 0===n.depthBuffer||n.depthBuffer,this.stencilBuffer=void 0!==n.stencilBuffer&&n.stencilBuffer,this.depthTexture=void 0!==n.depthTexture?n.depthTexture:null,this.samples=void 0!==n.samples?n.samples:0}setSize(e,t,n=1){this.width===e&&this.height===t&&this.depth===n||(this.width=e,this.height=t,this.depth=n,this.texture.image.width=e,this.texture.image.height=t,this.texture.image.depth=n,this.dispose()),this.viewport.set(0,0,e,t),this.scissor.set(0,0,e,t)}clone(){return(new this.constructor).copy(this)}copy(e){this.width=e.width,this.height=e.height,this.depth=e.depth,this.scissor.copy(e.scissor),this.scissorTest=e.scissorTest,this.viewport.copy(e.viewport),this.texture=e.texture.clone(),this.texture.isRenderTargetTexture=!0;const t=Object.assign({},e.texture.image);return this.texture.source=new Gl(t),this.depthBuffer=e.depthBuffer,this.stencilBuffer=e.stencilBuffer,null!==e.depthTexture&&(this.depthTexture=e.depthTexture.clone()),this.samples=e.samples,this}dispose(){this.dispatchEvent({type:"dispose"})}}class ql extends jl{constructor(e=null,t=1,n=1,r=1){super(null),this.isDataArrayTexture=!0,this.image={data:e,width:t,height:n,depth:r},this.magFilter=Nc,this.minFilter=Nc,this.wrapR=Pc,this.generateMipmaps=!1,this.flipY=!1,this.unpackAlignment=1}}class Kl extends jl{constructor(e=null,t=1,n=1,r=1){super(null),this.isData3DTexture=!0,this.image={data:e,width:t,height:n,depth:r},this.magFilter=Nc,this.minFilter=Nc,this.wrapR=Pc,this.generateMipmaps=!1,this.flipY=!1,this.unpackAlignment=1}}class Zl{constructor(e=0,t=0,n=0,r=1){this.isQuaternion=!0,this._x=e,this._y=t,this._z=n,this._w=r}static slerpFlat(e,t,n,r,i,a,o){let s=n[r+0],c=n[r+1],l=n[r+2],u=n[r+3];const d=i[a+0],f=i[a+1],h=i[a+2],p=i[a+3];if(0===o)return e[t+0]=s,e[t+1]=c,e[t+2]=l,void(e[t+3]=u);if(1===o)return e[t+0]=d,e[t+1]=f,e[t+2]=h,void(e[t+3]=p);if(u!==p||s!==d||c!==f||l!==h){let e=1-o;const t=s*d+c*f+l*h+u*p,n=t>=0?1:-1,r=1-t*t;if(r>Number.EPSILON){const i=Math.sqrt(r),a=Math.atan2(i,t*n);e=Math.sin(e*a)/i,o=Math.sin(o*a)/i}const i=o*n;if(s=s*e+d*i,c=c*e+f*i,l=l*e+h*i,u=u*e+p*i,e===1-o){const e=1/Math.sqrt(s*s+c*c+l*l+u*u);s*=e,c*=e,l*=e,u*=e}}e[t]=s,e[t+1]=c,e[t+2]=l,e[t+3]=u}static multiplyQuaternionsFlat(e,t,n,r,i,a){const o=n[r],s=n[r+1],c=n[r+2],l=n[r+3],u=i[a],d=i[a+1],f=i[a+2],h=i[a+3];return e[t]=o*h+l*u+s*f-c*d,e[t+1]=s*h+l*d+c*u-o*f,e[t+2]=c*h+l*f+o*d-s*u,e[t+3]=l*h-o*u-s*d-c*f,e}get x(){return this._x}set x(e){this._x=e,this._onChangeCallback()}get y(){return this._y}set y(e){this._y=e,this._onChangeCallback()}get z(){return this._z}set z(e){this._z=e,this._onChangeCallback()}get w(){return this._w}set w(e){this._w=e,this._onChangeCallback()}set(e,t,n,r){return this._x=e,this._y=t,this._z=n,this._w=r,this._onChangeCallback(),this}clone(){return new this.constructor(this._x,this._y,this._z,this._w)}copy(e){return this._x=e.x,this._y=e.y,this._z=e.z,this._w=e.w,this._onChangeCallback(),this}setFromEuler(e,t){const n=e._x,r=e._y,i=e._z,a=e._order,o=Math.cos,s=Math.sin,c=o(n/2),l=o(r/2),u=o(i/2),d=s(n/2),f=s(r/2),h=s(i/2);switch(a){case"XYZ":this._x=d*l*u+c*f*h,this._y=c*f*u-d*l*h,this._z=c*l*h+d*f*u,this._w=c*l*u-d*f*h;break;case"YXZ":this._x=d*l*u+c*f*h,this._y=c*f*u-d*l*h,this._z=c*l*h-d*f*u,this._w=c*l*u+d*f*h;break;case"ZXY":this._x=d*l*u-c*f*h,this._y=c*f*u+d*l*h,this._z=c*l*h+d*f*u,this._w=c*l*u-d*f*h;break;case"ZYX":this._x=d*l*u-c*f*h,this._y=c*f*u+d*l*h,this._z=c*l*h-d*f*u,this._w=c*l*u+d*f*h;break;case"YZX":this._x=d*l*u+c*f*h,this._y=c*f*u+d*l*h,this._z=c*l*h-d*f*u,this._w=c*l*u-d*f*h;break;case"XZY":this._x=d*l*u-c*f*h,this._y=c*f*u-d*l*h,this._z=c*l*h+d*f*u,this._w=c*l*u+d*f*h;break;default:console.warn("THREE.Quaternion: .setFromEuler() encountered an unknown order: "+a)}return!1!==t&&this._onChangeCallback(),this}setFromAxisAngle(e,t){const n=t/2,r=Math.sin(n);return this._x=e.x*r,this._y=e.y*r,this._z=e.z*r,this._w=Math.cos(n),this._onChangeCallback(),this}setFromRotationMatrix(e){const t=e.elements,n=t[0],r=t[4],i=t[8],a=t[1],o=t[5],s=t[9],c=t[2],l=t[6],u=t[10],d=n+o+u;if(d>0){const e=.5/Math.sqrt(d+1);this._w=.25/e,this._x=(l-s)*e,this._y=(i-c)*e,this._z=(a-r)*e}else if(n>o&&n>u){const e=2*Math.sqrt(1+n-o-u);this._w=(l-s)/e,this._x=.25*e,this._y=(r+a)/e,this._z=(i+c)/e}else if(o>u){const e=2*Math.sqrt(1+o-n-u);this._w=(i-c)/e,this._x=(r+a)/e,this._y=.25*e,this._z=(s+l)/e}else{const e=2*Math.sqrt(1+u-n-o);this._w=(a-r)/e,this._x=(i+c)/e,this._y=(s+l)/e,this._z=.25*e}return this._onChangeCallback(),this}setFromUnitVectors(e,t){let n=e.dot(t)+1;return n<Number.EPSILON?(n=0,Math.abs(e.x)>Math.abs(e.z)?(this._x=-e.y,this._y=e.x,this._z=0,this._w=n):(this._x=0,this._y=-e.z,this._z=e.y,this._w=n)):(this._x=e.y*t.z-e.z*t.y,this._y=e.z*t.x-e.x*t.z,this._z=e.x*t.y-e.y*t.x,this._w=n),this.normalize()}angleTo(e){return 2*Math.acos(Math.abs(bl(this.dot(e),-1,1)))}rotateTowards(e,t){const n=this.angleTo(e);if(0===n)return this;const r=Math.min(1,t/n);return this.slerp(e,r),this}identity(){return this.set(0,0,0,1)}invert(){return this.conjugate()}conjugate(){return this._x*=-1,this._y*=-1,this._z*=-1,this._onChangeCallback(),this}dot(e){return this._x*e._x+this._y*e._y+this._z*e._z+this._w*e._w}lengthSq(){return this._x*this._x+this._y*this._y+this._z*this._z+this._w*this._w}length(){return Math.sqrt(this._x*this._x+this._y*this._y+this._z*this._z+this._w*this._w)}normalize(){let e=this.length();return 0===e?(this._x=0,this._y=0,this._z=0,this._w=1):(e=1/e,this._x=this._x*e,this._y=this._y*e,this._z=this._z*e,this._w=this._w*e),this._onChangeCallback(),this}multiply(e){return this.multiplyQuaternions(this,e)}premultiply(e){return this.multiplyQuaternions(e,this)}multiplyQuaternions(e,t){const n=e._x,r=e._y,i=e._z,a=e._w,o=t._x,s=t._y,c=t._z,l=t._w;return this._x=n*l+a*o+r*c-i*s,this._y=r*l+a*s+i*o-n*c,this._z=i*l+a*c+n*s-r*o,this._w=a*l-n*o-r*s-i*c,this._onChangeCallback(),this}slerp(e,t){if(0===t)return this;if(1===t)return this.copy(e);const n=this._x,r=this._y,i=this._z,a=this._w;let o=a*e._w+n*e._x+r*e._y+i*e._z;if(o<0?(this._w=-e._w,this._x=-e._x,this._y=-e._y,this._z=-e._z,o=-o):this.copy(e),o>=1)return this._w=a,this._x=n,this._y=r,this._z=i,this;const s=1-o*o;if(s<=Number.EPSILON){const e=1-t;return this._w=e*a+t*this._w,this._x=e*n+t*this._x,this._y=e*r+t*this._y,this._z=e*i+t*this._z,this.normalize(),this._onChangeCallback(),this}const c=Math.sqrt(s),l=Math.atan2(c,o),u=Math.sin((1-t)*l)/c,d=Math.sin(t*l)/c;return this._w=a*u+this._w*d,this._x=n*u+this._x*d,this._y=r*u+this._y*d,this._z=i*u+this._z*d,this._onChangeCallback(),this}slerpQuaternions(e,t,n){return this.copy(e).slerp(t,n)}random(){const e=Math.random(),t=Math.sqrt(1-e),n=Math.sqrt(e),r=2*Math.PI*Math.random(),i=2*Math.PI*Math.random();return this.set(t*Math.cos(r),n*Math.sin(i),n*Math.cos(i),t*Math.sin(r))}equals(e){return e._x===this._x&&e._y===this._y&&e._z===this._z&&e._w===this._w}fromArray(e,t=0){return this._x=e[t],this._y=e[t+1],this._z=e[t+2],this._w=e[t+3],this._onChangeCallback(),this}toArray(e=[],t=0){return e[t]=this._x,e[t+1]=this._y,e[t+2]=this._z,e[t+3]=this._w,e}fromBufferAttribute(e,t){return this._x=e.getX(t),this._y=e.getY(t),this._z=e.getZ(t),this._w=e.getW(t),this}toJSON(){return this.toArray()}_onChange(e){return this._onChangeCallback=e,this}_onChangeCallback(){}*[Symbol.iterator](){yield this._x,yield this._y,yield this._z,yield this._w}}class Jl{constructor(e=0,t=0,n=0){Jl.prototype.isVector3=!0,this.x=e,this.y=t,this.z=n}set(e,t,n){return void 0===n&&(n=this.z),this.x=e,this.y=t,this.z=n,this}setScalar(e){return this.x=e,this.y=e,this.z=e,this}setX(e){return this.x=e,this}setY(e){return this.y=e,this}setZ(e){return this.z=e,this}setComponent(e,t){switch(e){case 0:this.x=t;break;case 1:this.y=t;break;case 2:this.z=t;break;default:throw new Error("index is out of range: "+e)}return this}getComponent(e){switch(e){case 0:return this.x;case 1:return this.y;case 2:return this.z;default:throw new Error("index is out of range: "+e)}}clone(){return new this.constructor(this.x,this.y,this.z)}copy(e){return this.x=e.x,this.y=e.y,this.z=e.z,this}add(e){return this.x+=e.x,this.y+=e.y,this.z+=e.z,this}addScalar(e){return this.x+=e,this.y+=e,this.z+=e,this}addVectors(e,t){return this.x=e.x+t.x,this.y=e.y+t.y,this.z=e.z+t.z,this}addScaledVector(e,t){return this.x+=e.x*t,this.y+=e.y*t,this.z+=e.z*t,this}sub(e){return this.x-=e.x,this.y-=e.y,this.z-=e.z,this}subScalar(e){return this.x-=e,this.y-=e,this.z-=e,this}subVectors(e,t){return this.x=e.x-t.x,this.y=e.y-t.y,this.z=e.z-t.z,this}multiply(e){return this.x*=e.x,this.y*=e.y,this.z*=e.z,this}multiplyScalar(e){return this.x*=e,this.y*=e,this.z*=e,this}multiplyVectors(e,t){return this.x=e.x*t.x,this.y=e.y*t.y,this.z=e.z*t.z,this}applyEuler(e){return this.applyQuaternion(eu.setFromEuler(e))}applyAxisAngle(e,t){return this.applyQuaternion(eu.setFromAxisAngle(e,t))}applyMatrix3(e){const t=this.x,n=this.y,r=this.z,i=e.elements;return this.x=i[0]*t+i[3]*n+i[6]*r,this.y=i[1]*t+i[4]*n+i[7]*r,this.z=i[2]*t+i[5]*n+i[8]*r,this}applyNormalMatrix(e){return this.applyMatrix3(e).normalize()}applyMatrix4(e){const t=this.x,n=this.y,r=this.z,i=e.elements,a=1/(i[3]*t+i[7]*n+i[11]*r+i[15]);return this.x=(i[0]*t+i[4]*n+i[8]*r+i[12])*a,this.y=(i[1]*t+i[5]*n+i[9]*r+i[13])*a,this.z=(i[2]*t+i[6]*n+i[10]*r+i[14])*a,this}applyQuaternion(e){const t=this.x,n=this.y,r=this.z,i=e.x,a=e.y,o=e.z,s=e.w,c=s*t+a*r-o*n,l=s*n+o*t-i*r,u=s*r+i*n-a*t,d=-i*t-a*n-o*r;return this.x=c*s+d*-i+l*-o-u*-a,this.y=l*s+d*-a+u*-i-c*-o,this.z=u*s+d*-o+c*-a-l*-i,this}project(e){return this.applyMatrix4(e.matrixWorldInverse).applyMatrix4(e.projectionMatrix)}unproject(e){return this.applyMatrix4(e.projectionMatrixInverse).applyMatrix4(e.matrixWorld)}transformDirection(e){const t=this.x,n=this.y,r=this.z,i=e.elements;return this.x=i[0]*t+i[4]*n+i[8]*r,this.y=i[1]*t+i[5]*n+i[9]*r,this.z=i[2]*t+i[6]*n+i[10]*r,this.normalize()}divide(e){return this.x/=e.x,this.y/=e.y,this.z/=e.z,this}divideScalar(e){return this.multiplyScalar(1/e)}min(e){return this.x=Math.min(this.x,e.x),this.y=Math.min(this.y,e.y),this.z=Math.min(this.z,e.z),this}max(e){return this.x=Math.max(this.x,e.x),this.y=Math.max(this.y,e.y),this.z=Math.max(this.z,e.z),this}clamp(e,t){return this.x=Math.max(e.x,Math.min(t.x,this.x)),this.y=Math.max(e.y,Math.min(t.y,this.y)),this.z=Math.max(e.z,Math.min(t.z,this.z)),this}clampScalar(e,t){return this.x=Math.max(e,Math.min(t,this.x)),this.y=Math.max(e,Math.min(t,this.y)),this.z=Math.max(e,Math.min(t,this.z)),this}clampLength(e,t){const n=this.length();return this.divideScalar(n||1).multiplyScalar(Math.max(e,Math.min(t,n)))}floor(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this.z=Math.floor(this.z),this}ceil(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this.z=Math.ceil(this.z),this}round(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this.z=Math.round(this.z),this}roundToZero(){return this.x=this.x<0?Math.ceil(this.x):Math.floor(this.x),this.y=this.y<0?Math.ceil(this.y):Math.floor(this.y),this.z=this.z<0?Math.ceil(this.z):Math.floor(this.z),this}negate(){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this}dot(e){return this.x*e.x+this.y*e.y+this.z*e.z}lengthSq(){return this.x*this.x+this.y*this.y+this.z*this.z}length(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)}manhattanLength(){return Math.abs(this.x)+Math.abs(this.y)+Math.abs(this.z)}normalize(){return this.divideScalar(this.length()||1)}setLength(e){return this.normalize().multiplyScalar(e)}lerp(e,t){return this.x+=(e.x-this.x)*t,this.y+=(e.y-this.y)*t,this.z+=(e.z-this.z)*t,this}lerpVectors(e,t,n){return this.x=e.x+(t.x-e.x)*n,this.y=e.y+(t.y-e.y)*n,this.z=e.z+(t.z-e.z)*n,this}cross(e){return this.crossVectors(this,e)}crossVectors(e,t){const n=e.x,r=e.y,i=e.z,a=t.x,o=t.y,s=t.z;return this.x=r*s-i*o,this.y=i*a-n*s,this.z=n*o-r*a,this}projectOnVector(e){const t=e.lengthSq();if(0===t)return this.set(0,0,0);const n=e.dot(this)/t;return this.copy(e).multiplyScalar(n)}projectOnPlane(e){return Ql.copy(this).projectOnVector(e),this.sub(Ql)}reflect(e){return this.sub(Ql.copy(e).multiplyScalar(2*this.dot(e)))}angleTo(e){const t=Math.sqrt(this.lengthSq()*e.lengthSq());if(0===t)return Math.PI/2;const n=this.dot(e)/t;return Math.acos(bl(n,-1,1))}distanceTo(e){return Math.sqrt(this.distanceToSquared(e))}distanceToSquared(e){const t=this.x-e.x,n=this.y-e.y,r=this.z-e.z;return t*t+n*n+r*r}manhattanDistanceTo(e){return Math.abs(this.x-e.x)+Math.abs(this.y-e.y)+Math.abs(this.z-e.z)}setFromSpherical(e){return this.setFromSphericalCoords(e.radius,e.phi,e.theta)}setFromSphericalCoords(e,t,n){const r=Math.sin(t)*e;return this.x=r*Math.sin(n),this.y=Math.cos(t)*e,this.z=r*Math.cos(n),this}setFromCylindrical(e){return this.setFromCylindricalCoords(e.radius,e.theta,e.y)}setFromCylindricalCoords(e,t,n){return this.x=e*Math.sin(t),this.y=n,this.z=e*Math.cos(t),this}setFromMatrixPosition(e){const t=e.elements;return this.x=t[12],this.y=t[13],this.z=t[14],this}setFromMatrixScale(e){const t=this.setFromMatrixColumn(e,0).length(),n=this.setFromMatrixColumn(e,1).length(),r=this.setFromMatrixColumn(e,2).length();return this.x=t,this.y=n,this.z=r,this}setFromMatrixColumn(e,t){return this.fromArray(e.elements,4*t)}setFromMatrix3Column(e,t){return this.fromArray(e.elements,3*t)}setFromEuler(e){return this.x=e._x,this.y=e._y,this.z=e._z,this}setFromColor(e){return this.x=e.r,this.y=e.g,this.z=e.b,this}equals(e){return e.x===this.x&&e.y===this.y&&e.z===this.z}fromArray(e,t=0){return this.x=e[t],this.y=e[t+1],this.z=e[t+2],this}toArray(e=[],t=0){return e[t]=this.x,e[t+1]=this.y,e[t+2]=this.z,e}fromBufferAttribute(e,t){return this.x=e.getX(t),this.y=e.getY(t),this.z=e.getZ(t),this}random(){return this.x=Math.random(),this.y=Math.random(),this.z=Math.random(),this}randomDirection(){const e=2*(Math.random()-.5),t=Math.random()*Math.PI*2,n=Math.sqrt(1-e**2);return this.x=n*Math.cos(t),this.y=n*Math.sin(t),this.z=e,this}*[Symbol.iterator](){yield this.x,yield this.y,yield this.z}}const Ql=new Jl,eu=new Zl;class tu{constructor(e=new Jl(1/0,1/0,1/0),t=new Jl(-1/0,-1/0,-1/0)){this.isBox3=!0,this.min=e,this.max=t}set(e,t){return this.min.copy(e),this.max.copy(t),this}setFromArray(e){this.makeEmpty();for(let t=0,n=e.length;t<n;t+=3)this.expandByPoint(ru.fromArray(e,t));return this}setFromBufferAttribute(e){this.makeEmpty();for(let t=0,n=e.count;t<n;t++)this.expandByPoint(ru.fromBufferAttribute(e,t));return this}setFromPoints(e){this.makeEmpty();for(let t=0,n=e.length;t<n;t++)this.expandByPoint(e[t]);return this}setFromCenterAndSize(e,t){const n=ru.copy(t).multiplyScalar(.5);return this.min.copy(e).sub(n),this.max.copy(e).add(n),this}setFromObject(e,t=!1){return this.makeEmpty(),this.expandByObject(e,t)}clone(){return(new this.constructor).copy(this)}copy(e){return this.min.copy(e.min),this.max.copy(e.max),this}makeEmpty(){return this.min.x=this.min.y=this.min.z=1/0,this.max.x=this.max.y=this.max.z=-1/0,this}isEmpty(){return this.max.x<this.min.x||this.max.y<this.min.y||this.max.z<this.min.z}getCenter(e){return this.isEmpty()?e.set(0,0,0):e.addVectors(this.min,this.max).multiplyScalar(.5)}getSize(e){return this.isEmpty()?e.set(0,0,0):e.subVectors(this.max,this.min)}expandByPoint(e){return this.min.min(e),this.max.max(e),this}expandByVector(e){return this.min.sub(e),this.max.add(e),this}expandByScalar(e){return this.min.addScalar(-e),this.max.addScalar(e),this}expandByObject(e,t=!1){if(e.updateWorldMatrix(!1,!1),void 0!==e.boundingBox)null===e.boundingBox&&e.computeBoundingBox(),iu.copy(e.boundingBox),iu.applyMatrix4(e.matrixWorld),this.union(iu);else{const n=e.geometry;if(void 0!==n)if(t&&void 0!==n.attributes&&void 0!==n.attributes.position){const t=n.attributes.position;for(let n=0,r=t.count;n<r;n++)ru.fromBufferAttribute(t,n).applyMatrix4(e.matrixWorld),this.expandByPoint(ru)}else null===n.boundingBox&&n.computeBoundingBox(),iu.copy(n.boundingBox),iu.applyMatrix4(e.matrixWorld),this.union(iu)}const n=e.children;for(let e=0,r=n.length;e<r;e++)this.expandByObject(n[e],t);return this}containsPoint(e){return!(e.x<this.min.x||e.x>this.max.x||e.y<this.min.y||e.y>this.max.y||e.z<this.min.z||e.z>this.max.z)}containsBox(e){return this.min.x<=e.min.x&&e.max.x<=this.max.x&&this.min.y<=e.min.y&&e.max.y<=this.max.y&&this.min.z<=e.min.z&&e.max.z<=this.max.z}getParameter(e,t){return t.set((e.x-this.min.x)/(this.max.x-this.min.x),(e.y-this.min.y)/(this.max.y-this.min.y),(e.z-this.min.z)/(this.max.z-this.min.z))}intersectsBox(e){return!(e.max.x<this.min.x||e.min.x>this.max.x||e.max.y<this.min.y||e.min.y>this.max.y||e.max.z<this.min.z||e.min.z>this.max.z)}intersectsSphere(e){return this.clampPoint(e.center,ru),ru.distanceToSquared(e.center)<=e.radius*e.radius}intersectsPlane(e){let t,n;return e.normal.x>0?(t=e.normal.x*this.min.x,n=e.normal.x*this.max.x):(t=e.normal.x*this.max.x,n=e.normal.x*this.min.x),e.normal.y>0?(t+=e.normal.y*this.min.y,n+=e.normal.y*this.max.y):(t+=e.normal.y*this.max.y,n+=e.normal.y*this.min.y),e.normal.z>0?(t+=e.normal.z*this.min.z,n+=e.normal.z*this.max.z):(t+=e.normal.z*this.max.z,n+=e.normal.z*this.min.z),t<=-e.constant&&n>=-e.constant}intersectsTriangle(e){if(this.isEmpty())return!1;this.getCenter(du),fu.subVectors(this.max,du),au.subVectors(e.a,du),ou.subVectors(e.b,du),su.subVectors(e.c,du),cu.subVectors(ou,au),lu.subVectors(su,ou),uu.subVectors(au,su);let t=[0,-cu.z,cu.y,0,-lu.z,lu.y,0,-uu.z,uu.y,cu.z,0,-cu.x,lu.z,0,-lu.x,uu.z,0,-uu.x,-cu.y,cu.x,0,-lu.y,lu.x,0,-uu.y,uu.x,0];return!!mu(t,au,ou,su,fu)&&(t=[1,0,0,0,1,0,0,0,1],!!mu(t,au,ou,su,fu)&&(hu.crossVectors(cu,lu),t=[hu.x,hu.y,hu.z],mu(t,au,ou,su,fu)))}clampPoint(e,t){return t.copy(e).clamp(this.min,this.max)}distanceToPoint(e){return this.clampPoint(e,ru).distanceTo(e)}getBoundingSphere(e){return this.isEmpty()?e.makeEmpty():(this.getCenter(e.center),e.radius=.5*this.getSize(ru).length()),e}intersect(e){return this.min.max(e.min),this.max.min(e.max),this.isEmpty()&&this.makeEmpty(),this}union(e){return this.min.min(e.min),this.max.max(e.max),this}applyMatrix4(e){return this.isEmpty()||(nu[0].set(this.min.x,this.min.y,this.min.z).applyMatrix4(e),nu[1].set(this.min.x,this.min.y,this.max.z).applyMatrix4(e),nu[2].set(this.min.x,this.max.y,this.min.z).applyMatrix4(e),nu[3].set(this.min.x,this.max.y,this.max.z).applyMatrix4(e),nu[4].set(this.max.x,this.min.y,this.min.z).applyMatrix4(e),nu[5].set(this.max.x,this.min.y,this.max.z).applyMatrix4(e),nu[6].set(this.max.x,this.max.y,this.min.z).applyMatrix4(e),nu[7].set(this.max.x,this.max.y,this.max.z).applyMatrix4(e),this.setFromPoints(nu)),this}translate(e){return this.min.add(e),this.max.add(e),this}equals(e){return e.min.equals(this.min)&&e.max.equals(this.max)}}const nu=[new Jl,new Jl,new Jl,new Jl,new Jl,new Jl,new Jl,new Jl],ru=new Jl,iu=new tu,au=new Jl,ou=new Jl,su=new Jl,cu=new Jl,lu=new Jl,uu=new Jl,du=new Jl,fu=new Jl,hu=new Jl,pu=new Jl;function mu(e,t,n,r,i){for(let a=0,o=e.length-3;a<=o;a+=3){pu.fromArray(e,a);const o=i.x*Math.abs(pu.x)+i.y*Math.abs(pu.y)+i.z*Math.abs(pu.z),s=t.dot(pu),c=n.dot(pu),l=r.dot(pu);if(Math.max(-Math.max(s,c,l),Math.min(s,c,l))>o)return!1}return!0}const vu=new tu,gu=new Jl,bu=new Jl;class _u{constructor(e=new Jl,t=-1){this.center=e,this.radius=t}set(e,t){return this.center.copy(e),this.radius=t,this}setFromPoints(e,t){const n=this.center;void 0!==t?n.copy(t):vu.setFromPoints(e).getCenter(n);let r=0;for(let t=0,i=e.length;t<i;t++)r=Math.max(r,n.distanceToSquared(e[t]));return this.radius=Math.sqrt(r),this}copy(e){return this.center.copy(e.center),this.radius=e.radius,this}isEmpty(){return this.radius<0}makeEmpty(){return this.center.set(0,0,0),this.radius=-1,this}containsPoint(e){return e.distanceToSquared(this.center)<=this.radius*this.radius}distanceToPoint(e){return e.distanceTo(this.center)-this.radius}intersectsSphere(e){const t=this.radius+e.radius;return e.center.distanceToSquared(this.center)<=t*t}intersectsBox(e){return e.intersectsSphere(this)}intersectsPlane(e){return Math.abs(e.distanceToPoint(this.center))<=this.radius}clampPoint(e,t){const n=this.center.distanceToSquared(e);return t.copy(e),n>this.radius*this.radius&&(t.sub(this.center).normalize(),t.multiplyScalar(this.radius).add(this.center)),t}getBoundingBox(e){return this.isEmpty()?(e.makeEmpty(),e):(e.set(this.center,this.center),e.expandByScalar(this.radius),e)}applyMatrix4(e){return this.center.applyMatrix4(e),this.radius=this.radius*e.getMaxScaleOnAxis(),this}translate(e){return this.center.add(e),this}expandByPoint(e){if(this.isEmpty())return this.center.copy(e),this.radius=0,this;gu.subVectors(e,this.center);const t=gu.lengthSq();if(t>this.radius*this.radius){const e=Math.sqrt(t),n=.5*(e-this.radius);this.center.addScaledVector(gu,n/e),this.radius+=n}return this}union(e){return e.isEmpty()?this:this.isEmpty()?(this.copy(e),this):(!0===this.center.equals(e.center)?this.radius=Math.max(this.radius,e.radius):(bu.subVectors(e.center,this.center).setLength(e.radius),this.expandByPoint(gu.copy(e.center).add(bu)),this.expandByPoint(gu.copy(e.center).sub(bu))),this)}equals(e){return e.center.equals(this.center)&&e.radius===this.radius}clone(){return(new this.constructor).copy(this)}}const yu=new Jl,xu=new Jl,Au=new Jl,wu=new Jl,Eu=new Jl,Tu=new Jl,Su=new Jl;class Cu{constructor(e=new Jl,t=new Jl(0,0,-1)){this.origin=e,this.direction=t}set(e,t){return this.origin.copy(e),this.direction.copy(t),this}copy(e){return this.origin.copy(e.origin),this.direction.copy(e.direction),this}at(e,t){return t.copy(this.origin).addScaledVector(this.direction,e)}lookAt(e){return this.direction.copy(e).sub(this.origin).normalize(),this}recast(e){return this.origin.copy(this.at(e,yu)),this}closestPointToPoint(e,t){t.subVectors(e,this.origin);const n=t.dot(this.direction);return n<0?t.copy(this.origin):t.copy(this.origin).addScaledVector(this.direction,n)}distanceToPoint(e){return Math.sqrt(this.distanceSqToPoint(e))}distanceSqToPoint(e){const t=yu.subVectors(e,this.origin).dot(this.direction);return t<0?this.origin.distanceToSquared(e):(yu.copy(this.origin).addScaledVector(this.direction,t),yu.distanceToSquared(e))}distanceSqToSegment(e,t,n,r){xu.copy(e).add(t).multiplyScalar(.5),Au.copy(t).sub(e).normalize(),wu.copy(this.origin).sub(xu);const i=.5*e.distanceTo(t),a=-this.direction.dot(Au),o=wu.dot(this.direction),s=-wu.dot(Au),c=wu.lengthSq(),l=Math.abs(1-a*a);let u,d,f,h;if(l>0)if(u=a*s-o,d=a*o-s,h=i*l,u>=0)if(d>=-h)if(d<=h){const e=1/l;u*=e,d*=e,f=u*(u+a*d+2*o)+d*(a*u+d+2*s)+c}else d=i,u=Math.max(0,-(a*d+o)),f=-u*u+d*(d+2*s)+c;else d=-i,u=Math.max(0,-(a*d+o)),f=-u*u+d*(d+2*s)+c;else d<=-h?(u=Math.max(0,-(-a*i+o)),d=u>0?-i:Math.min(Math.max(-i,-s),i),f=-u*u+d*(d+2*s)+c):d<=h?(u=0,d=Math.min(Math.max(-i,-s),i),f=d*(d+2*s)+c):(u=Math.max(0,-(a*i+o)),d=u>0?i:Math.min(Math.max(-i,-s),i),f=-u*u+d*(d+2*s)+c);else d=a>0?-i:i,u=Math.max(0,-(a*d+o)),f=-u*u+d*(d+2*s)+c;return n&&n.copy(this.origin).addScaledVector(this.direction,u),r&&r.copy(xu).addScaledVector(Au,d),f}intersectSphere(e,t){yu.subVectors(e.center,this.origin);const n=yu.dot(this.direction),r=yu.dot(yu)-n*n,i=e.radius*e.radius;if(r>i)return null;const a=Math.sqrt(i-r),o=n-a,s=n+a;return s<0?null:o<0?this.at(s,t):this.at(o,t)}intersectsSphere(e){return this.distanceSqToPoint(e.center)<=e.radius*e.radius}distanceToPlane(e){const t=e.normal.dot(this.direction);if(0===t)return 0===e.distanceToPoint(this.origin)?0:null;const n=-(this.origin.dot(e.normal)+e.constant)/t;return n>=0?n:null}intersectPlane(e,t){const n=this.distanceToPlane(e);return null===n?null:this.at(n,t)}intersectsPlane(e){const t=e.distanceToPoint(this.origin);return 0===t||e.normal.dot(this.direction)*t<0}intersectBox(e,t){let n,r,i,a,o,s;const c=1/this.direction.x,l=1/this.direction.y,u=1/this.direction.z,d=this.origin;return c>=0?(n=(e.min.x-d.x)*c,r=(e.max.x-d.x)*c):(n=(e.max.x-d.x)*c,r=(e.min.x-d.x)*c),l>=0?(i=(e.min.y-d.y)*l,a=(e.max.y-d.y)*l):(i=(e.max.y-d.y)*l,a=(e.min.y-d.y)*l),n>a||i>r?null:((i>n||isNaN(n))&&(n=i),(a<r||isNaN(r))&&(r=a),u>=0?(o=(e.min.z-d.z)*u,s=(e.max.z-d.z)*u):(o=(e.max.z-d.z)*u,s=(e.min.z-d.z)*u),n>s||o>r?null:((o>n||n!=n)&&(n=o),(s<r||r!=r)&&(r=s),r<0?null:this.at(n>=0?n:r,t)))}intersectsBox(e){return null!==this.intersectBox(e,yu)}intersectTriangle(e,t,n,r,i){Eu.subVectors(t,e),Tu.subVectors(n,e),Su.crossVectors(Eu,Tu);let a,o=this.direction.dot(Su);if(o>0){if(r)return null;a=1}else{if(!(o<0))return null;a=-1,o=-o}wu.subVectors(this.origin,e);const s=a*this.direction.dot(Tu.crossVectors(wu,Tu));if(s<0)return null;const c=a*this.direction.dot(Eu.cross(wu));if(c<0)return null;if(s+c>o)return null;const l=-a*wu.dot(Su);return l<0?null:this.at(l/o,i)}applyMatrix4(e){return this.origin.applyMatrix4(e),this.direction.transformDirection(e),this}equals(e){return e.origin.equals(this.origin)&&e.direction.equals(this.direction)}clone(){return(new this.constructor).copy(this)}}class Mu{constructor(e,t,n,r,i,a,o,s,c,l,u,d,f,h,p,m){Mu.prototype.isMatrix4=!0,this.elements=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],void 0!==e&&this.set(e,t,n,r,i,a,o,s,c,l,u,d,f,h,p,m)}set(e,t,n,r,i,a,o,s,c,l,u,d,f,h,p,m){const v=this.elements;return v[0]=e,v[4]=t,v[8]=n,v[12]=r,v[1]=i,v[5]=a,v[9]=o,v[13]=s,v[2]=c,v[6]=l,v[10]=u,v[14]=d,v[3]=f,v[7]=h,v[11]=p,v[15]=m,this}identity(){return this.set(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1),this}clone(){return(new Mu).fromArray(this.elements)}copy(e){const t=this.elements,n=e.elements;return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t[4]=n[4],t[5]=n[5],t[6]=n[6],t[7]=n[7],t[8]=n[8],t[9]=n[9],t[10]=n[10],t[11]=n[11],t[12]=n[12],t[13]=n[13],t[14]=n[14],t[15]=n[15],this}copyPosition(e){const t=this.elements,n=e.elements;return t[12]=n[12],t[13]=n[13],t[14]=n[14],this}setFromMatrix3(e){const t=e.elements;return this.set(t[0],t[3],t[6],0,t[1],t[4],t[7],0,t[2],t[5],t[8],0,0,0,0,1),this}extractBasis(e,t,n){return e.setFromMatrixColumn(this,0),t.setFromMatrixColumn(this,1),n.setFromMatrixColumn(this,2),this}makeBasis(e,t,n){return this.set(e.x,t.x,n.x,0,e.y,t.y,n.y,0,e.z,t.z,n.z,0,0,0,0,1),this}extractRotation(e){const t=this.elements,n=e.elements,r=1/ku.setFromMatrixColumn(e,0).length(),i=1/ku.setFromMatrixColumn(e,1).length(),a=1/ku.setFromMatrixColumn(e,2).length();return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=0,t[4]=n[4]*i,t[5]=n[5]*i,t[6]=n[6]*i,t[7]=0,t[8]=n[8]*a,t[9]=n[9]*a,t[10]=n[10]*a,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,this}makeRotationFromEuler(e){const t=this.elements,n=e.x,r=e.y,i=e.z,a=Math.cos(n),o=Math.sin(n),s=Math.cos(r),c=Math.sin(r),l=Math.cos(i),u=Math.sin(i);if("XYZ"===e.order){const e=a*l,n=a*u,r=o*l,i=o*u;t[0]=s*l,t[4]=-s*u,t[8]=c,t[1]=n+r*c,t[5]=e-i*c,t[9]=-o*s,t[2]=i-e*c,t[6]=r+n*c,t[10]=a*s}else if("YXZ"===e.order){const e=s*l,n=s*u,r=c*l,i=c*u;t[0]=e+i*o,t[4]=r*o-n,t[8]=a*c,t[1]=a*u,t[5]=a*l,t[9]=-o,t[2]=n*o-r,t[6]=i+e*o,t[10]=a*s}else if("ZXY"===e.order){const e=s*l,n=s*u,r=c*l,i=c*u;t[0]=e-i*o,t[4]=-a*u,t[8]=r+n*o,t[1]=n+r*o,t[5]=a*l,t[9]=i-e*o,t[2]=-a*c,t[6]=o,t[10]=a*s}else if("ZYX"===e.order){const e=a*l,n=a*u,r=o*l,i=o*u;t[0]=s*l,t[4]=r*c-n,t[8]=e*c+i,t[1]=s*u,t[5]=i*c+e,t[9]=n*c-r,t[2]=-c,t[6]=o*s,t[10]=a*s}else if("YZX"===e.order){const e=a*s,n=a*c,r=o*s,i=o*c;t[0]=s*l,t[4]=i-e*u,t[8]=r*u+n,t[1]=u,t[5]=a*l,t[9]=-o*l,t[2]=-c*l,t[6]=n*u+r,t[10]=e-i*u}else if("XZY"===e.order){const e=a*s,n=a*c,r=o*s,i=o*c;t[0]=s*l,t[4]=-u,t[8]=c*l,t[1]=e*u+i,t[5]=a*l,t[9]=n*u-r,t[2]=r*u-n,t[6]=o*l,t[10]=i*u+e}return t[3]=0,t[7]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,this}makeRotationFromQuaternion(e){return this.compose(Lu,e,Ou)}lookAt(e,t,n){const r=this.elements;return Du.subVectors(e,t),0===Du.lengthSq()&&(Du.z=1),Du.normalize(),Iu.crossVectors(n,Du),0===Iu.lengthSq()&&(1===Math.abs(n.z)?Du.x+=1e-4:Du.z+=1e-4,Du.normalize(),Iu.crossVectors(n,Du)),Iu.normalize(),Pu.crossVectors(Du,Iu),r[0]=Iu.x,r[4]=Pu.x,r[8]=Du.x,r[1]=Iu.y,r[5]=Pu.y,r[9]=Du.y,r[2]=Iu.z,r[6]=Pu.z,r[10]=Du.z,this}multiply(e){return this.multiplyMatrices(this,e)}premultiply(e){return this.multiplyMatrices(e,this)}multiplyMatrices(e,t){const n=e.elements,r=t.elements,i=this.elements,a=n[0],o=n[4],s=n[8],c=n[12],l=n[1],u=n[5],d=n[9],f=n[13],h=n[2],p=n[6],m=n[10],v=n[14],g=n[3],b=n[7],_=n[11],y=n[15],x=r[0],A=r[4],w=r[8],E=r[12],T=r[1],S=r[5],C=r[9],M=r[13],k=r[2],R=r[6],L=r[10],O=r[14],I=r[3],P=r[7],D=r[11],N=r[15];return i[0]=a*x+o*T+s*k+c*I,i[4]=a*A+o*S+s*R+c*P,i[8]=a*w+o*C+s*L+c*D,i[12]=a*E+o*M+s*O+c*N,i[1]=l*x+u*T+d*k+f*I,i[5]=l*A+u*S+d*R+f*P,i[9]=l*w+u*C+d*L+f*D,i[13]=l*E+u*M+d*O+f*N,i[2]=h*x+p*T+m*k+v*I,i[6]=h*A+p*S+m*R+v*P,i[10]=h*w+p*C+m*L+v*D,i[14]=h*E+p*M+m*O+v*N,i[3]=g*x+b*T+_*k+y*I,i[7]=g*A+b*S+_*R+y*P,i[11]=g*w+b*C+_*L+y*D,i[15]=g*E+b*M+_*O+y*N,this}multiplyScalar(e){const t=this.elements;return t[0]*=e,t[4]*=e,t[8]*=e,t[12]*=e,t[1]*=e,t[5]*=e,t[9]*=e,t[13]*=e,t[2]*=e,t[6]*=e,t[10]*=e,t[14]*=e,t[3]*=e,t[7]*=e,t[11]*=e,t[15]*=e,this}determinant(){const e=this.elements,t=e[0],n=e[4],r=e[8],i=e[12],a=e[1],o=e[5],s=e[9],c=e[13],l=e[2],u=e[6],d=e[10],f=e[14];return e[3]*(+i*s*u-r*c*u-i*o*d+n*c*d+r*o*f-n*s*f)+e[7]*(+t*s*f-t*c*d+i*a*d-r*a*f+r*c*l-i*s*l)+e[11]*(+t*c*u-t*o*f-i*a*u+n*a*f+i*o*l-n*c*l)+e[15]*(-r*o*l-t*s*u+t*o*d+r*a*u-n*a*d+n*s*l)}transpose(){const e=this.elements;let t;return t=e[1],e[1]=e[4],e[4]=t,t=e[2],e[2]=e[8],e[8]=t,t=e[6],e[6]=e[9],e[9]=t,t=e[3],e[3]=e[12],e[12]=t,t=e[7],e[7]=e[13],e[13]=t,t=e[11],e[11]=e[14],e[14]=t,this}setPosition(e,t,n){const r=this.elements;return e.isVector3?(r[12]=e.x,r[13]=e.y,r[14]=e.z):(r[12]=e,r[13]=t,r[14]=n),this}invert(){const e=this.elements,t=e[0],n=e[1],r=e[2],i=e[3],a=e[4],o=e[5],s=e[6],c=e[7],l=e[8],u=e[9],d=e[10],f=e[11],h=e[12],p=e[13],m=e[14],v=e[15],g=u*m*c-p*d*c+p*s*f-o*m*f-u*s*v+o*d*v,b=h*d*c-l*m*c-h*s*f+a*m*f+l*s*v-a*d*v,_=l*p*c-h*u*c+h*o*f-a*p*f-l*o*v+a*u*v,y=h*u*s-l*p*s-h*o*d+a*p*d+l*o*m-a*u*m,x=t*g+n*b+r*_+i*y;if(0===x)return this.set(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);const A=1/x;return e[0]=g*A,e[1]=(p*d*i-u*m*i-p*r*f+n*m*f+u*r*v-n*d*v)*A,e[2]=(o*m*i-p*s*i+p*r*c-n*m*c-o*r*v+n*s*v)*A,e[3]=(u*s*i-o*d*i-u*r*c+n*d*c+o*r*f-n*s*f)*A,e[4]=b*A,e[5]=(l*m*i-h*d*i+h*r*f-t*m*f-l*r*v+t*d*v)*A,e[6]=(h*s*i-a*m*i-h*r*c+t*m*c+a*r*v-t*s*v)*A,e[7]=(a*d*i-l*s*i+l*r*c-t*d*c-a*r*f+t*s*f)*A,e[8]=_*A,e[9]=(h*u*i-l*p*i-h*n*f+t*p*f+l*n*v-t*u*v)*A,e[10]=(a*p*i-h*o*i+h*n*c-t*p*c-a*n*v+t*o*v)*A,e[11]=(l*o*i-a*u*i-l*n*c+t*u*c+a*n*f-t*o*f)*A,e[12]=y*A,e[13]=(l*p*r-h*u*r+h*n*d-t*p*d-l*n*m+t*u*m)*A,e[14]=(h*o*r-a*p*r-h*n*s+t*p*s+a*n*m-t*o*m)*A,e[15]=(a*u*r-l*o*r+l*n*s-t*u*s-a*n*d+t*o*d)*A,this}scale(e){const t=this.elements,n=e.x,r=e.y,i=e.z;return t[0]*=n,t[4]*=r,t[8]*=i,t[1]*=n,t[5]*=r,t[9]*=i,t[2]*=n,t[6]*=r,t[10]*=i,t[3]*=n,t[7]*=r,t[11]*=i,this}getMaxScaleOnAxis(){const e=this.elements,t=e[0]*e[0]+e[1]*e[1]+e[2]*e[2],n=e[4]*e[4]+e[5]*e[5]+e[6]*e[6],r=e[8]*e[8]+e[9]*e[9]+e[10]*e[10];return Math.sqrt(Math.max(t,n,r))}makeTranslation(e,t,n){return e.isVector3?this.set(1,0,0,e.x,0,1,0,e.y,0,0,1,e.z,0,0,0,1):this.set(1,0,0,e,0,1,0,t,0,0,1,n,0,0,0,1),this}makeRotationX(e){const t=Math.cos(e),n=Math.sin(e);return this.set(1,0,0,0,0,t,-n,0,0,n,t,0,0,0,0,1),this}makeRotationY(e){const t=Math.cos(e),n=Math.sin(e);return this.set(t,0,n,0,0,1,0,0,-n,0,t,0,0,0,0,1),this}makeRotationZ(e){const t=Math.cos(e),n=Math.sin(e);return this.set(t,-n,0,0,n,t,0,0,0,0,1,0,0,0,0,1),this}makeRotationAxis(e,t){const n=Math.cos(t),r=Math.sin(t),i=1-n,a=e.x,o=e.y,s=e.z,c=i*a,l=i*o;return this.set(c*a+n,c*o-r*s,c*s+r*o,0,c*o+r*s,l*o+n,l*s-r*a,0,c*s-r*o,l*s+r*a,i*s*s+n,0,0,0,0,1),this}makeScale(e,t,n){return this.set(e,0,0,0,0,t,0,0,0,0,n,0,0,0,0,1),this}makeShear(e,t,n,r,i,a){return this.set(1,n,i,0,e,1,a,0,t,r,1,0,0,0,0,1),this}compose(e,t,n){const r=this.elements,i=t._x,a=t._y,o=t._z,s=t._w,c=i+i,l=a+a,u=o+o,d=i*c,f=i*l,h=i*u,p=a*l,m=a*u,v=o*u,g=s*c,b=s*l,_=s*u,y=n.x,x=n.y,A=n.z;return r[0]=(1-(p+v))*y,r[1]=(f+_)*y,r[2]=(h-b)*y,r[3]=0,r[4]=(f-_)*x,r[5]=(1-(d+v))*x,r[6]=(m+g)*x,r[7]=0,r[8]=(h+b)*A,r[9]=(m-g)*A,r[10]=(1-(d+p))*A,r[11]=0,r[12]=e.x,r[13]=e.y,r[14]=e.z,r[15]=1,this}decompose(e,t,n){const r=this.elements;let i=ku.set(r[0],r[1],r[2]).length();const a=ku.set(r[4],r[5],r[6]).length(),o=ku.set(r[8],r[9],r[10]).length();this.determinant()<0&&(i=-i),e.x=r[12],e.y=r[13],e.z=r[14],Ru.copy(this);const s=1/i,c=1/a,l=1/o;return Ru.elements[0]*=s,Ru.elements[1]*=s,Ru.elements[2]*=s,Ru.elements[4]*=c,Ru.elements[5]*=c,Ru.elements[6]*=c,Ru.elements[8]*=l,Ru.elements[9]*=l,Ru.elements[10]*=l,t.setFromRotationMatrix(Ru),n.x=i,n.y=a,n.z=o,this}makePerspective(e,t,n,r,i,a,o=2e3){const s=this.elements,c=2*i/(t-e),l=2*i/(n-r),u=(t+e)/(t-e),d=(n+r)/(n-r);let f,h;if(o===ul)f=-(a+i)/(a-i),h=-2*a*i/(a-i);else{if(o!==dl)throw new Error("THREE.Matrix4.makePerspective(): Invalid coordinate system: "+o);f=-a/(a-i),h=-a*i/(a-i)}return s[0]=c,s[4]=0,s[8]=u,s[12]=0,s[1]=0,s[5]=l,s[9]=d,s[13]=0,s[2]=0,s[6]=0,s[10]=f,s[14]=h,s[3]=0,s[7]=0,s[11]=-1,s[15]=0,this}makeOrthographic(e,t,n,r,i,a,o=2e3){const s=this.elements,c=1/(t-e),l=1/(n-r),u=1/(a-i),d=(t+e)*c,f=(n+r)*l;let h,p;if(o===ul)h=(a+i)*u,p=-2*u;else{if(o!==dl)throw new Error("THREE.Matrix4.makeOrthographic(): Invalid coordinate system: "+o);h=i*u,p=-1*u}return s[0]=2*c,s[4]=0,s[8]=0,s[12]=-d,s[1]=0,s[5]=2*l,s[9]=0,s[13]=-f,s[2]=0,s[6]=0,s[10]=p,s[14]=-h,s[3]=0,s[7]=0,s[11]=0,s[15]=1,this}equals(e){const t=this.elements,n=e.elements;for(let e=0;e<16;e++)if(t[e]!==n[e])return!1;return!0}fromArray(e,t=0){for(let n=0;n<16;n++)this.elements[n]=e[n+t];return this}toArray(e=[],t=0){const n=this.elements;return e[t]=n[0],e[t+1]=n[1],e[t+2]=n[2],e[t+3]=n[3],e[t+4]=n[4],e[t+5]=n[5],e[t+6]=n[6],e[t+7]=n[7],e[t+8]=n[8],e[t+9]=n[9],e[t+10]=n[10],e[t+11]=n[11],e[t+12]=n[12],e[t+13]=n[13],e[t+14]=n[14],e[t+15]=n[15],e}}const ku=new Jl,Ru=new Mu,Lu=new Jl(0,0,0),Ou=new Jl(1,1,1),Iu=new Jl,Pu=new Jl,Du=new Jl,Nu=new Mu,Uu=new Zl;class Fu{constructor(e=0,t=0,n=0,r=Fu.DEFAULT_ORDER){this.isEuler=!0,this._x=e,this._y=t,this._z=n,this._order=r}get x(){return this._x}set x(e){this._x=e,this._onChangeCallback()}get y(){return this._y}set y(e){this._y=e,this._onChangeCallback()}get z(){return this._z}set z(e){this._z=e,this._onChangeCallback()}get order(){return this._order}set order(e){this._order=e,this._onChangeCallback()}set(e,t,n,r=this._order){return this._x=e,this._y=t,this._z=n,this._order=r,this._onChangeCallback(),this}clone(){return new this.constructor(this._x,this._y,this._z,this._order)}copy(e){return this._x=e._x,this._y=e._y,this._z=e._z,this._order=e._order,this._onChangeCallback(),this}setFromRotationMatrix(e,t=this._order,n=!0){const r=e.elements,i=r[0],a=r[4],o=r[8],s=r[1],c=r[5],l=r[9],u=r[2],d=r[6],f=r[10];switch(t){case"XYZ":this._y=Math.asin(bl(o,-1,1)),Math.abs(o)<.9999999?(this._x=Math.atan2(-l,f),this._z=Math.atan2(-a,i)):(this._x=Math.atan2(d,c),this._z=0);break;case"YXZ":this._x=Math.asin(-bl(l,-1,1)),Math.abs(l)<.9999999?(this._y=Math.atan2(o,f),this._z=Math.atan2(s,c)):(this._y=Math.atan2(-u,i),this._z=0);break;case"ZXY":this._x=Math.asin(bl(d,-1,1)),Math.abs(d)<.9999999?(this._y=Math.atan2(-u,f),this._z=Math.atan2(-a,c)):(this._y=0,this._z=Math.atan2(s,i));break;case"ZYX":this._y=Math.asin(-bl(u,-1,1)),Math.abs(u)<.9999999?(this._x=Math.atan2(d,f),this._z=Math.atan2(s,i)):(this._x=0,this._z=Math.atan2(-a,c));break;case"YZX":this._z=Math.asin(bl(s,-1,1)),Math.abs(s)<.9999999?(this._x=Math.atan2(-l,c),this._y=Math.atan2(-u,i)):(this._x=0,this._y=Math.atan2(o,f));break;case"XZY":this._z=Math.asin(-bl(a,-1,1)),Math.abs(a)<.9999999?(this._x=Math.atan2(d,c),this._y=Math.atan2(o,i)):(this._x=Math.atan2(-l,f),this._y=0);break;default:console.warn("THREE.Euler: .setFromRotationMatrix() encountered an unknown order: "+t)}return this._order=t,!0===n&&this._onChangeCallback(),this}setFromQuaternion(e,t,n){return Nu.makeRotationFromQuaternion(e),this.setFromRotationMatrix(Nu,t,n)}setFromVector3(e,t=this._order){return this.set(e.x,e.y,e.z,t)}reorder(e){return Uu.setFromEuler(this),this.setFromQuaternion(Uu,e)}equals(e){return e._x===this._x&&e._y===this._y&&e._z===this._z&&e._order===this._order}fromArray(e){return this._x=e[0],this._y=e[1],this._z=e[2],void 0!==e[3]&&(this._order=e[3]),this._onChangeCallback(),this}toArray(e=[],t=0){return e[t]=this._x,e[t+1]=this._y,e[t+2]=this._z,e[t+3]=this._order,e}_onChange(e){return this._onChangeCallback=e,this}_onChangeCallback(){}*[Symbol.iterator](){yield this._x,yield this._y,yield this._z,yield this._order}}Fu.DEFAULT_ORDER="XYZ";class Bu{constructor(){this.mask=1}set(e){this.mask=(1<<e|0)>>>0}enable(e){this.mask|=1<<e|0}enableAll(){this.mask=-1}toggle(e){this.mask^=1<<e|0}disable(e){this.mask&=~(1<<e|0)}disableAll(){this.mask=0}test(e){return 0!=(this.mask&e.mask)}isEnabled(e){return 0!=(this.mask&(1<<e|0))}}let zu=0;const Hu=new Jl,Vu=new Zl,Gu=new Mu,$u=new Jl,Wu=new Jl,ju=new Jl,Xu=new Zl,Yu=new Jl(1,0,0),qu=new Jl(0,1,0),Ku=new Jl(0,0,1),Zu={type:"added"},Ju={type:"removed"};class Qu extends fl{constructor(){super(),this.isObject3D=!0,Object.defineProperty(this,"id",{value:zu++}),this.uuid=gl(),this.name="",this.type="Object3D",this.parent=null,this.children=[],this.up=Qu.DEFAULT_UP.clone();const e=new Jl,t=new Fu,n=new Zl,r=new Jl(1,1,1);t._onChange((function(){n.setFromEuler(t,!1)})),n._onChange((function(){t.setFromQuaternion(n,void 0,!1)})),Object.defineProperties(this,{position:{configurable:!0,enumerable:!0,value:e},rotation:{configurable:!0,enumerable:!0,value:t},quaternion:{configurable:!0,enumerable:!0,value:n},scale:{configurable:!0,enumerable:!0,value:r},modelViewMatrix:{value:new Mu},normalMatrix:{value:new Cl}}),this.matrix=new Mu,this.matrixWorld=new Mu,this.matrixAutoUpdate=Qu.DEFAULT_MATRIX_AUTO_UPDATE,this.matrixWorldNeedsUpdate=!1,this.matrixWorldAutoUpdate=Qu.DEFAULT_MATRIX_WORLD_AUTO_UPDATE,this.layers=new Bu,this.visible=!0,this.castShadow=!1,this.receiveShadow=!1,this.frustumCulled=!0,this.renderOrder=0,this.animations=[],this.userData={}}onBeforeRender(){}onAfterRender(){}applyMatrix4(e){this.matrixAutoUpdate&&this.updateMatrix(),this.matrix.premultiply(e),this.matrix.decompose(this.position,this.quaternion,this.scale)}applyQuaternion(e){return this.quaternion.premultiply(e),this}setRotationFromAxisAngle(e,t){this.quaternion.setFromAxisAngle(e,t)}setRotationFromEuler(e){this.quaternion.setFromEuler(e,!0)}setRotationFromMatrix(e){this.quaternion.setFromRotationMatrix(e)}setRotationFromQuaternion(e){this.quaternion.copy(e)}rotateOnAxis(e,t){return Vu.setFromAxisAngle(e,t),this.quaternion.multiply(Vu),this}rotateOnWorldAxis(e,t){return Vu.setFromAxisAngle(e,t),this.quaternion.premultiply(Vu),this}rotateX(e){return this.rotateOnAxis(Yu,e)}rotateY(e){return this.rotateOnAxis(qu,e)}rotateZ(e){return this.rotateOnAxis(Ku,e)}translateOnAxis(e,t){return Hu.copy(e).applyQuaternion(this.quaternion),this.position.add(Hu.multiplyScalar(t)),this}translateX(e){return this.translateOnAxis(Yu,e)}translateY(e){return this.translateOnAxis(qu,e)}translateZ(e){return this.translateOnAxis(Ku,e)}localToWorld(e){return this.updateWorldMatrix(!0,!1),e.applyMatrix4(this.matrixWorld)}worldToLocal(e){return this.updateWorldMatrix(!0,!1),e.applyMatrix4(Gu.copy(this.matrixWorld).invert())}lookAt(e,t,n){e.isVector3?$u.copy(e):$u.set(e,t,n);const r=this.parent;this.updateWorldMatrix(!0,!1),Wu.setFromMatrixPosition(this.matrixWorld),this.isCamera||this.isLight?Gu.lookAt(Wu,$u,this.up):Gu.lookAt($u,Wu,this.up),this.quaternion.setFromRotationMatrix(Gu),r&&(Gu.extractRotation(r.matrixWorld),Vu.setFromRotationMatrix(Gu),this.quaternion.premultiply(Vu.invert()))}add(e){if(arguments.length>1){for(let e=0;e<arguments.length;e++)this.add(arguments[e]);return this}return e===this?(console.error("THREE.Object3D.add: object can't be added as a child of itself.",e),this):(e&&e.isObject3D?(null!==e.parent&&e.parent.remove(e),e.parent=this,this.children.push(e),e.dispatchEvent(Zu)):console.error("THREE.Object3D.add: object not an instance of THREE.Object3D.",e),this)}remove(e){if(arguments.length>1){for(let e=0;e<arguments.length;e++)this.remove(arguments[e]);return this}const t=this.children.indexOf(e);return-1!==t&&(e.parent=null,this.children.splice(t,1),e.dispatchEvent(Ju)),this}removeFromParent(){const e=this.parent;return null!==e&&e.remove(this),this}clear(){for(let e=0;e<this.children.length;e++){const t=this.children[e];t.parent=null,t.dispatchEvent(Ju)}return this.children.length=0,this}attach(e){return this.updateWorldMatrix(!0,!1),Gu.copy(this.matrixWorld).invert(),null!==e.parent&&(e.parent.updateWorldMatrix(!0,!1),Gu.multiply(e.parent.matrixWorld)),e.applyMatrix4(Gu),this.add(e),e.updateWorldMatrix(!1,!0),this}getObjectById(e){return this.getObjectByProperty("id",e)}getObjectByName(e){return this.getObjectByProperty("name",e)}getObjectByProperty(e,t){if(this[e]===t)return this;for(let n=0,r=this.children.length;n<r;n++){const r=this.children[n].getObjectByProperty(e,t);if(void 0!==r)return r}}getObjectsByProperty(e,t){let n=[];this[e]===t&&n.push(this);for(let r=0,i=this.children.length;r<i;r++){const i=this.children[r].getObjectsByProperty(e,t);i.length>0&&(n=n.concat(i))}return n}getWorldPosition(e){return this.updateWorldMatrix(!0,!1),e.setFromMatrixPosition(this.matrixWorld)}getWorldQuaternion(e){return this.updateWorldMatrix(!0,!1),this.matrixWorld.decompose(Wu,e,ju),e}getWorldScale(e){return this.updateWorldMatrix(!0,!1),this.matrixWorld.decompose(Wu,Xu,e),e}getWorldDirection(e){this.updateWorldMatrix(!0,!1);const t=this.matrixWorld.elements;return e.set(t[8],t[9],t[10]).normalize()}raycast(){}traverse(e){e(this);const t=this.children;for(let n=0,r=t.length;n<r;n++)t[n].traverse(e)}traverseVisible(e){if(!1===this.visible)return;e(this);const t=this.children;for(let n=0,r=t.length;n<r;n++)t[n].traverseVisible(e)}traverseAncestors(e){const t=this.parent;null!==t&&(e(t),t.traverseAncestors(e))}updateMatrix(){this.matrix.compose(this.position,this.quaternion,this.scale),this.matrixWorldNeedsUpdate=!0}updateMatrixWorld(e){this.matrixAutoUpdate&&this.updateMatrix(),(this.matrixWorldNeedsUpdate||e)&&(null===this.parent?this.matrixWorld.copy(this.matrix):this.matrixWorld.multiplyMatrices(this.parent.matrixWorld,this.matrix),this.matrixWorldNeedsUpdate=!1,e=!0);const t=this.children;for(let n=0,r=t.length;n<r;n++){const r=t[n];!0!==r.matrixWorldAutoUpdate&&!0!==e||r.updateMatrixWorld(e)}}updateWorldMatrix(e,t){const n=this.parent;if(!0===e&&null!==n&&!0===n.matrixWorldAutoUpdate&&n.updateWorldMatrix(!0,!1),this.matrixAutoUpdate&&this.updateMatrix(),null===this.parent?this.matrixWorld.copy(this.matrix):this.matrixWorld.multiplyMatrices(this.parent.matrixWorld,this.matrix),!0===t){const e=this.children;for(let t=0,n=e.length;t<n;t++){const n=e[t];!0===n.matrixWorldAutoUpdate&&n.updateWorldMatrix(!1,!0)}}}toJSON(e){const t=void 0===e||"string"==typeof e,n={};t&&(e={geometries:{},materials:{},textures:{},images:{},shapes:{},skeletons:{},animations:{},nodes:{}},n.metadata={version:4.6,type:"Object",generator:"Object3D.toJSON"});const r={};function i(t,n){return void 0===t[n.uuid]&&(t[n.uuid]=n.toJSON(e)),n.uuid}if(r.uuid=this.uuid,r.type=this.type,""!==this.name&&(r.name=this.name),!0===this.castShadow&&(r.castShadow=!0),!0===this.receiveShadow&&(r.receiveShadow=!0),!1===this.visible&&(r.visible=!1),!1===this.frustumCulled&&(r.frustumCulled=!1),0!==this.renderOrder&&(r.renderOrder=this.renderOrder),Object.keys(this.userData).length>0&&(r.userData=this.userData),r.layers=this.layers.mask,r.matrix=this.matrix.toArray(),r.up=this.up.toArray(),!1===this.matrixAutoUpdate&&(r.matrixAutoUpdate=!1),this.isInstancedMesh&&(r.type="InstancedMesh",r.count=this.count,r.instanceMatrix=this.instanceMatrix.toJSON(),null!==this.instanceColor&&(r.instanceColor=this.instanceColor.toJSON())),this.isScene)this.background&&(this.background.isColor?r.background=this.background.toJSON():this.background.isTexture&&(r.background=this.background.toJSON(e).uuid)),this.environment&&this.environment.isTexture&&!0!==this.environment.isRenderTargetTexture&&(r.environment=this.environment.toJSON(e).uuid);else if(this.isMesh||this.isLine||this.isPoints){r.geometry=i(e.geometries,this.geometry);const t=this.geometry.parameters;if(void 0!==t&&void 0!==t.shapes){const n=t.shapes;if(Array.isArray(n))for(let t=0,r=n.length;t<r;t++){const r=n[t];i(e.shapes,r)}else i(e.shapes,n)}}if(this.isSkinnedMesh&&(r.bindMode=this.bindMode,r.bindMatrix=this.bindMatrix.toArray(),void 0!==this.skeleton&&(i(e.skeletons,this.skeleton),r.skeleton=this.skeleton.uuid)),void 0!==this.material)if(Array.isArray(this.material)){const t=[];for(let n=0,r=this.material.length;n<r;n++)t.push(i(e.materials,this.material[n]));r.material=t}else r.material=i(e.materials,this.material);if(this.children.length>0){r.children=[];for(let t=0;t<this.children.length;t++)r.children.push(this.children[t].toJSON(e).object)}if(this.animations.length>0){r.animations=[];for(let t=0;t<this.animations.length;t++){const n=this.animations[t];r.animations.push(i(e.animations,n))}}if(t){const t=a(e.geometries),r=a(e.materials),i=a(e.textures),o=a(e.images),s=a(e.shapes),c=a(e.skeletons),l=a(e.animations),u=a(e.nodes);t.length>0&&(n.geometries=t),r.length>0&&(n.materials=r),i.length>0&&(n.textures=i),o.length>0&&(n.images=o),s.length>0&&(n.shapes=s),c.length>0&&(n.skeletons=c),l.length>0&&(n.animations=l),u.length>0&&(n.nodes=u)}return n.object=r,n;function a(e){const t=[];for(const n in e){const r=e[n];delete r.metadata,t.push(r)}return t}}clone(e){return(new this.constructor).copy(this,e)}copy(e,t=!0){if(this.name=e.name,this.up.copy(e.up),this.position.copy(e.position),this.rotation.order=e.rotation.order,this.quaternion.copy(e.quaternion),this.scale.copy(e.scale),this.matrix.copy(e.matrix),this.matrixWorld.copy(e.matrixWorld),this.matrixAutoUpdate=e.matrixAutoUpdate,this.matrixWorldNeedsUpdate=e.matrixWorldNeedsUpdate,this.matrixWorldAutoUpdate=e.matrixWorldAutoUpdate,this.layers.mask=e.layers.mask,this.visible=e.visible,this.castShadow=e.castShadow,this.receiveShadow=e.receiveShadow,this.frustumCulled=e.frustumCulled,this.renderOrder=e.renderOrder,this.animations=e.animations,this.userData=JSON.parse(JSON.stringify(e.userData)),!0===t)for(let t=0;t<e.children.length;t++){const n=e.children[t];this.add(n.clone())}return this}}Qu.DEFAULT_UP=new Jl(0,1,0),Qu.DEFAULT_MATRIX_AUTO_UPDATE=!0,Qu.DEFAULT_MATRIX_WORLD_AUTO_UPDATE=!0;const ed=new Jl,td=new Jl,nd=new Jl,rd=new Jl,id=new Jl,ad=new Jl,od=new Jl,sd=new Jl,cd=new Jl,ld=new Jl;let ud=!1;class dd{constructor(e=new Jl,t=new Jl,n=new Jl){this.a=e,this.b=t,this.c=n}static getNormal(e,t,n,r){r.subVectors(n,t),ed.subVectors(e,t),r.cross(ed);const i=r.lengthSq();return i>0?r.multiplyScalar(1/Math.sqrt(i)):r.set(0,0,0)}static getBarycoord(e,t,n,r,i){ed.subVectors(r,t),td.subVectors(n,t),nd.subVectors(e,t);const a=ed.dot(ed),o=ed.dot(td),s=ed.dot(nd),c=td.dot(td),l=td.dot(nd),u=a*c-o*o;if(0===u)return i.set(-2,-1,-1);const d=1/u,f=(c*s-o*l)*d,h=(a*l-o*s)*d;return i.set(1-f-h,h,f)}static containsPoint(e,t,n,r){return this.getBarycoord(e,t,n,r,rd),rd.x>=0&&rd.y>=0&&rd.x+rd.y<=1}static getUV(e,t,n,r,i,a,o,s){return!1===ud&&(console.warn("THREE.Triangle.getUV() has been renamed to THREE.Triangle.getInterpolation()."),ud=!0),this.getInterpolation(e,t,n,r,i,a,o,s)}static getInterpolation(e,t,n,r,i,a,o,s){return this.getBarycoord(e,t,n,r,rd),s.setScalar(0),s.addScaledVector(i,rd.x),s.addScaledVector(a,rd.y),s.addScaledVector(o,rd.z),s}static isFrontFacing(e,t,n,r){return ed.subVectors(n,t),td.subVectors(e,t),ed.cross(td).dot(r)<0}set(e,t,n){return this.a.copy(e),this.b.copy(t),this.c.copy(n),this}setFromPointsAndIndices(e,t,n,r){return this.a.copy(e[t]),this.b.copy(e[n]),this.c.copy(e[r]),this}setFromAttributeAndIndices(e,t,n,r){return this.a.fromBufferAttribute(e,t),this.b.fromBufferAttribute(e,n),this.c.fromBufferAttribute(e,r),this}clone(){return(new this.constructor).copy(this)}copy(e){return this.a.copy(e.a),this.b.copy(e.b),this.c.copy(e.c),this}getArea(){return ed.subVectors(this.c,this.b),td.subVectors(this.a,this.b),.5*ed.cross(td).length()}getMidpoint(e){return e.addVectors(this.a,this.b).add(this.c).multiplyScalar(1/3)}getNormal(e){return dd.getNormal(this.a,this.b,this.c,e)}getPlane(e){return e.setFromCoplanarPoints(this.a,this.b,this.c)}getBarycoord(e,t){return dd.getBarycoord(e,this.a,this.b,this.c,t)}getUV(e,t,n,r,i){return!1===ud&&(console.warn("THREE.Triangle.getUV() has been renamed to THREE.Triangle.getInterpolation()."),ud=!0),dd.getInterpolation(e,this.a,this.b,this.c,t,n,r,i)}getInterpolation(e,t,n,r,i){return dd.getInterpolation(e,this.a,this.b,this.c,t,n,r,i)}containsPoint(e){return dd.containsPoint(e,this.a,this.b,this.c)}isFrontFacing(e){return dd.isFrontFacing(this.a,this.b,this.c,e)}intersectsBox(e){return e.intersectsTriangle(this)}closestPointToPoint(e,t){const n=this.a,r=this.b,i=this.c;let a,o;id.subVectors(r,n),ad.subVectors(i,n),sd.subVectors(e,n);const s=id.dot(sd),c=ad.dot(sd);if(s<=0&&c<=0)return t.copy(n);cd.subVectors(e,r);const l=id.dot(cd),u=ad.dot(cd);if(l>=0&&u<=l)return t.copy(r);const d=s*u-l*c;if(d<=0&&s>=0&&l<=0)return a=s/(s-l),t.copy(n).addScaledVector(id,a);ld.subVectors(e,i);const f=id.dot(ld),h=ad.dot(ld);if(h>=0&&f<=h)return t.copy(i);const p=f*c-s*h;if(p<=0&&c>=0&&h<=0)return o=c/(c-h),t.copy(n).addScaledVector(ad,o);const m=l*h-f*u;if(m<=0&&u-l>=0&&f-h>=0)return od.subVectors(i,r),o=(u-l)/(u-l+(f-h)),t.copy(r).addScaledVector(od,o);const v=1/(m+p+d);return a=p*v,o=d*v,t.copy(n).addScaledVector(id,a).addScaledVector(ad,o)}equals(e){return e.a.equals(this.a)&&e.b.equals(this.b)&&e.c.equals(this.c)}}let fd=0;class hd extends fl{constructor(){super(),this.isMaterial=!0,Object.defineProperty(this,"id",{value:fd++}),this.uuid=gl(),this.name="",this.type="Material",this.blending=1,this.side=0,this.vertexColors=!1,this.opacity=1,this.transparent=!1,this.alphaHash=!1,this.blendSrc=204,this.blendDst=205,this.blendEquation=yc,this.blendSrcAlpha=null,this.blendDstAlpha=null,this.blendEquationAlpha=null,this.depthFunc=3,this.depthTest=!0,this.depthWrite=!0,this.stencilWriteMask=255,this.stencilFunc=519,this.stencilRef=0,this.stencilFuncMask=255,this.stencilFail=sl,this.stencilZFail=sl,this.stencilZPass=sl,this.stencilWrite=!1,this.clippingPlanes=null,this.clipIntersection=!1,this.clipShadows=!1,this.shadowSide=null,this.colorWrite=!0,this.precision=null,this.polygonOffset=!1,this.polygonOffsetFactor=0,this.polygonOffsetUnits=0,this.dithering=!1,this.alphaToCoverage=!1,this.premultipliedAlpha=!1,this.forceSinglePass=!1,this.visible=!0,this.toneMapped=!0,this.userData={},this.version=0,this._alphaTest=0}get alphaTest(){return this._alphaTest}set alphaTest(e){this._alphaTest>0!=e>0&&this.version++,this._alphaTest=e}onBuild(){}onBeforeRender(){}onBeforeCompile(){}customProgramCacheKey(){return this.onBeforeCompile.toString()}setValues(e){if(void 0!==e)for(const t in e){const n=e[t];if(void 0===n){console.warn(`THREE.Material: parameter '${t}' has value of undefined.`);continue}const r=this[t];void 0!==r?r&&r.isColor?r.set(n):r&&r.isVector3&&n&&n.isVector3?r.copy(n):this[t]=n:console.warn(`THREE.Material: '${t}' is not a property of THREE.${this.type}.`)}}toJSON(e){const t=void 0===e||"string"==typeof e;t&&(e={textures:{},images:{}});const n={metadata:{version:4.6,type:"Material",generator:"Material.toJSON"}};function r(e){const t=[];for(const n in e){const r=e[n];delete r.metadata,t.push(r)}return t}if(n.uuid=this.uuid,n.type=this.type,""!==this.name&&(n.name=this.name),this.color&&this.color.isColor&&(n.color=this.color.getHex()),void 0!==this.roughness&&(n.roughness=this.roughness),void 0!==this.metalness&&(n.metalness=this.metalness),void 0!==this.sheen&&(n.sheen=this.sheen),this.sheenColor&&this.sheenColor.isColor&&(n.sheenColor=this.sheenColor.getHex()),void 0!==this.sheenRoughness&&(n.sheenRoughness=this.sheenRoughness),this.emissive&&this.emissive.isColor&&(n.emissive=this.emissive.getHex()),this.emissiveIntensity&&1!==this.emissiveIntensity&&(n.emissiveIntensity=this.emissiveIntensity),this.specular&&this.specular.isColor&&(n.specular=this.specular.getHex()),void 0!==this.specularIntensity&&(n.specularIntensity=this.specularIntensity),this.specularColor&&this.specularColor.isColor&&(n.specularColor=this.specularColor.getHex()),void 0!==this.shininess&&(n.shininess=this.shininess),void 0!==this.clearcoat&&(n.clearcoat=this.clearcoat),void 0!==this.clearcoatRoughness&&(n.clearcoatRoughness=this.clearcoatRoughness),this.clearcoatMap&&this.clearcoatMap.isTexture&&(n.clearcoatMap=this.clearcoatMap.toJSON(e).uuid),this.clearcoatRoughnessMap&&this.clearcoatRoughnessMap.isTexture&&(n.clearcoatRoughnessMap=this.clearcoatRoughnessMap.toJSON(e).uuid),this.clearcoatNormalMap&&this.clearcoatNormalMap.isTexture&&(n.clearcoatNormalMap=this.clearcoatNormalMap.toJSON(e).uuid,n.clearcoatNormalScale=this.clearcoatNormalScale.toArray()),void 0!==this.iridescence&&(n.iridescence=this.iridescence),void 0!==this.iridescenceIOR&&(n.iridescenceIOR=this.iridescenceIOR),void 0!==this.iridescenceThicknessRange&&(n.iridescenceThicknessRange=this.iridescenceThicknessRange),this.iridescenceMap&&this.iridescenceMap.isTexture&&(n.iridescenceMap=this.iridescenceMap.toJSON(e).uuid),this.iridescenceThicknessMap&&this.iridescenceThicknessMap.isTexture&&(n.iridescenceThicknessMap=this.iridescenceThicknessMap.toJSON(e).uuid),void 0!==this.anisotropy&&(n.anisotropy=this.anisotropy),void 0!==this.anisotropyRotation&&(n.anisotropyRotation=this.anisotropyRotation),this.anisotropyMap&&this.anisotropyMap.isTexture&&(n.anisotropyMap=this.anisotropyMap.toJSON(e).uuid),this.map&&this.map.isTexture&&(n.map=this.map.toJSON(e).uuid),this.matcap&&this.matcap.isTexture&&(n.matcap=this.matcap.toJSON(e).uuid),this.alphaMap&&this.alphaMap.isTexture&&(n.alphaMap=this.alphaMap.toJSON(e).uuid),this.lightMap&&this.lightMap.isTexture&&(n.lightMap=this.lightMap.toJSON(e).uuid,n.lightMapIntensity=this.lightMapIntensity),this.aoMap&&this.aoMap.isTexture&&(n.aoMap=this.aoMap.toJSON(e).uuid,n.aoMapIntensity=this.aoMapIntensity),this.bumpMap&&this.bumpMap.isTexture&&(n.bumpMap=this.bumpMap.toJSON(e).uuid,n.bumpScale=this.bumpScale),this.normalMap&&this.normalMap.isTexture&&(n.normalMap=this.normalMap.toJSON(e).uuid,n.normalMapType=this.normalMapType,n.normalScale=this.normalScale.toArray()),this.displacementMap&&this.displacementMap.isTexture&&(n.displacementMap=this.displacementMap.toJSON(e).uuid,n.displacementScale=this.displacementScale,n.displacementBias=this.displacementBias),this.roughnessMap&&this.roughnessMap.isTexture&&(n.roughnessMap=this.roughnessMap.toJSON(e).uuid),this.metalnessMap&&this.metalnessMap.isTexture&&(n.metalnessMap=this.metalnessMap.toJSON(e).uuid),this.emissiveMap&&this.emissiveMap.isTexture&&(n.emissiveMap=this.emissiveMap.toJSON(e).uuid),this.specularMap&&this.specularMap.isTexture&&(n.specularMap=this.specularMap.toJSON(e).uuid),this.specularIntensityMap&&this.specularIntensityMap.isTexture&&(n.specularIntensityMap=this.specularIntensityMap.toJSON(e).uuid),this.specularColorMap&&this.specularColorMap.isTexture&&(n.specularColorMap=this.specularColorMap.toJSON(e).uuid),this.envMap&&this.envMap.isTexture&&(n.envMap=this.envMap.toJSON(e).uuid,void 0!==this.combine&&(n.combine=this.combine)),void 0!==this.envMapIntensity&&(n.envMapIntensity=this.envMapIntensity),void 0!==this.reflectivity&&(n.reflectivity=this.reflectivity),void 0!==this.refractionRatio&&(n.refractionRatio=this.refractionRatio),this.gradientMap&&this.gradientMap.isTexture&&(n.gradientMap=this.gradientMap.toJSON(e).uuid),void 0!==this.transmission&&(n.transmission=this.transmission),this.transmissionMap&&this.transmissionMap.isTexture&&(n.transmissionMap=this.transmissionMap.toJSON(e).uuid),void 0!==this.thickness&&(n.thickness=this.thickness),this.thicknessMap&&this.thicknessMap.isTexture&&(n.thicknessMap=this.thicknessMap.toJSON(e).uuid),void 0!==this.attenuationDistance&&this.attenuationDistance!==1/0&&(n.attenuationDistance=this.attenuationDistance),void 0!==this.attenuationColor&&(n.attenuationColor=this.attenuationColor.getHex()),void 0!==this.size&&(n.size=this.size),null!==this.shadowSide&&(n.shadowSide=this.shadowSide),void 0!==this.sizeAttenuation&&(n.sizeAttenuation=this.sizeAttenuation),1!==this.blending&&(n.blending=this.blending),0!==this.side&&(n.side=this.side),this.vertexColors&&(n.vertexColors=!0),this.opacity<1&&(n.opacity=this.opacity),!0===this.transparent&&(n.transparent=this.transparent),n.depthFunc=this.depthFunc,n.depthTest=this.depthTest,n.depthWrite=this.depthWrite,n.colorWrite=this.colorWrite,n.stencilWrite=this.stencilWrite,n.stencilWriteMask=this.stencilWriteMask,n.stencilFunc=this.stencilFunc,n.stencilRef=this.stencilRef,n.stencilFuncMask=this.stencilFuncMask,n.stencilFail=this.stencilFail,n.stencilZFail=this.stencilZFail,n.stencilZPass=this.stencilZPass,void 0!==this.rotation&&0!==this.rotation&&(n.rotation=this.rotation),!0===this.polygonOffset&&(n.polygonOffset=!0),0!==this.polygonOffsetFactor&&(n.polygonOffsetFactor=this.polygonOffsetFactor),0!==this.polygonOffsetUnits&&(n.polygonOffsetUnits=this.polygonOffsetUnits),void 0!==this.linewidth&&1!==this.linewidth&&(n.linewidth=this.linewidth),void 0!==this.dashSize&&(n.dashSize=this.dashSize),void 0!==this.gapSize&&(n.gapSize=this.gapSize),void 0!==this.scale&&(n.scale=this.scale),!0===this.dithering&&(n.dithering=!0),this.alphaTest>0&&(n.alphaTest=this.alphaTest),!0===this.alphaHash&&(n.alphaHash=this.alphaHash),!0===this.alphaToCoverage&&(n.alphaToCoverage=this.alphaToCoverage),!0===this.premultipliedAlpha&&(n.premultipliedAlpha=this.premultipliedAlpha),!0===this.forceSinglePass&&(n.forceSinglePass=this.forceSinglePass),!0===this.wireframe&&(n.wireframe=this.wireframe),this.wireframeLinewidth>1&&(n.wireframeLinewidth=this.wireframeLinewidth),"round"!==this.wireframeLinecap&&(n.wireframeLinecap=this.wireframeLinecap),"round"!==this.wireframeLinejoin&&(n.wireframeLinejoin=this.wireframeLinejoin),!0===this.flatShading&&(n.flatShading=this.flatShading),!1===this.visible&&(n.visible=!1),!1===this.toneMapped&&(n.toneMapped=!1),!1===this.fog&&(n.fog=!1),Object.keys(this.userData).length>0&&(n.userData=this.userData),t){const t=r(e.textures),i=r(e.images);t.length>0&&(n.textures=t),i.length>0&&(n.images=i)}return n}clone(){return(new this.constructor).copy(this)}copy(e){this.name=e.name,this.blending=e.blending,this.side=e.side,this.vertexColors=e.vertexColors,this.opacity=e.opacity,this.transparent=e.transparent,this.blendSrc=e.blendSrc,this.blendDst=e.blendDst,this.blendEquation=e.blendEquation,this.blendSrcAlpha=e.blendSrcAlpha,this.blendDstAlpha=e.blendDstAlpha,this.blendEquationAlpha=e.blendEquationAlpha,this.depthFunc=e.depthFunc,this.depthTest=e.depthTest,this.depthWrite=e.depthWrite,this.stencilWriteMask=e.stencilWriteMask,this.stencilFunc=e.stencilFunc,this.stencilRef=e.stencilRef,this.stencilFuncMask=e.stencilFuncMask,this.stencilFail=e.stencilFail,this.stencilZFail=e.stencilZFail,this.stencilZPass=e.stencilZPass,this.stencilWrite=e.stencilWrite;const t=e.clippingPlanes;let n=null;if(null!==t){const e=t.length;n=new Array(e);for(let r=0;r!==e;++r)n[r]=t[r].clone()}return this.clippingPlanes=n,this.clipIntersection=e.clipIntersection,this.clipShadows=e.clipShadows,this.shadowSide=e.shadowSide,this.colorWrite=e.colorWrite,this.precision=e.precision,this.polygonOffset=e.polygonOffset,this.polygonOffsetFactor=e.polygonOffsetFactor,this.polygonOffsetUnits=e.polygonOffsetUnits,this.dithering=e.dithering,this.alphaTest=e.alphaTest,this.alphaHash=e.alphaHash,this.alphaToCoverage=e.alphaToCoverage,this.premultipliedAlpha=e.premultipliedAlpha,this.forceSinglePass=e.forceSinglePass,this.visible=e.visible,this.toneMapped=e.toneMapped,this.userData=JSON.parse(JSON.stringify(e.userData)),this}dispose(){this.dispatchEvent({type:"dispose"})}set needsUpdate(e){!0===e&&this.version++}}const pd={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074},md={h:0,s:0,l:0},vd={h:0,s:0,l:0};function gd(e,t,n){return n<0&&(n+=1),n>1&&(n-=1),n<1/6?e+6*(t-e)*n:n<.5?t:n<2/3?e+6*(t-e)*(2/3-n):e}class bd{constructor(e,t,n){return this.isColor=!0,this.r=1,this.g=1,this.b=1,this.set(e,t,n)}set(e,t,n){if(void 0===t&&void 0===n){const t=e;t&&t.isColor?this.copy(t):"number"==typeof t?this.setHex(t):"string"==typeof t&&this.setStyle(t)}else this.setRGB(e,t,n);return this}setScalar(e){return this.r=e,this.g=e,this.b=e,this}setHex(e,t=il){return e=Math.floor(e),this.r=(e>>16&255)/255,this.g=(e>>8&255)/255,this.b=(255&e)/255,Bl.toWorkingColorSpace(this,t),this}setRGB(e,t,n,r=Bl.workingColorSpace){return this.r=e,this.g=t,this.b=n,Bl.toWorkingColorSpace(this,r),this}setHSL(e,t,n,r=Bl.workingColorSpace){if(e=_l(e,1),t=bl(t,0,1),n=bl(n,0,1),0===t)this.r=this.g=this.b=n;else{const r=n<=.5?n*(1+t):n+t-n*t,i=2*n-r;this.r=gd(i,r,e+1/3),this.g=gd(i,r,e),this.b=gd(i,r,e-1/3)}return Bl.toWorkingColorSpace(this,r),this}setStyle(e,t=il){function n(t){void 0!==t&&parseFloat(t)<1&&console.warn("THREE.Color: Alpha component of "+e+" will be ignored.")}let r;if(r=/^(\w+)\(([^\)]*)\)/.exec(e)){let i;const a=r[1],o=r[2];switch(a){case"rgb":case"rgba":if(i=/^\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*(?:,\s*(\d*\.?\d+)\s*)?$/.exec(o))return n(i[4]),this.setRGB(Math.min(255,parseInt(i[1],10))/255,Math.min(255,parseInt(i[2],10))/255,Math.min(255,parseInt(i[3],10))/255,t);if(i=/^\s*(\d+)\%\s*,\s*(\d+)\%\s*,\s*(\d+)\%\s*(?:,\s*(\d*\.?\d+)\s*)?$/.exec(o))return n(i[4]),this.setRGB(Math.min(100,parseInt(i[1],10))/100,Math.min(100,parseInt(i[2],10))/100,Math.min(100,parseInt(i[3],10))/100,t);break;case"hsl":case"hsla":if(i=/^\s*(\d*\.?\d+)\s*,\s*(\d*\.?\d+)\%\s*,\s*(\d*\.?\d+)\%\s*(?:,\s*(\d*\.?\d+)\s*)?$/.exec(o))return n(i[4]),this.setHSL(parseFloat(i[1])/360,parseFloat(i[2])/100,parseFloat(i[3])/100,t);break;default:console.warn("THREE.Color: Unknown color model "+e)}}else if(r=/^\#([A-Fa-f\d]+)$/.exec(e)){const n=r[1],i=n.length;if(3===i)return this.setRGB(parseInt(n.charAt(0),16)/15,parseInt(n.charAt(1),16)/15,parseInt(n.charAt(2),16)/15,t);if(6===i)return this.setHex(parseInt(n,16),t);console.warn("THREE.Color: Invalid hex color "+e)}else if(e&&e.length>0)return this.setColorName(e,t);return this}setColorName(e,t=il){const n=pd[e.toLowerCase()];return void 0!==n?this.setHex(n,t):console.warn("THREE.Color: Unknown color "+e),this}clone(){return new this.constructor(this.r,this.g,this.b)}copy(e){return this.r=e.r,this.g=e.g,this.b=e.b,this}copySRGBToLinear(e){return this.r=Il(e.r),this.g=Il(e.g),this.b=Il(e.b),this}copyLinearToSRGB(e){return this.r=Pl(e.r),this.g=Pl(e.g),this.b=Pl(e.b),this}convertSRGBToLinear(){return this.copySRGBToLinear(this),this}convertLinearToSRGB(){return this.copyLinearToSRGB(this),this}getHex(e=il){return Bl.fromWorkingColorSpace(_d.copy(this),e),65536*Math.round(bl(255*_d.r,0,255))+256*Math.round(bl(255*_d.g,0,255))+Math.round(bl(255*_d.b,0,255))}getHexString(e=il){return("000000"+this.getHex(e).toString(16)).slice(-6)}getHSL(e,t=Bl.workingColorSpace){Bl.fromWorkingColorSpace(_d.copy(this),t);const n=_d.r,r=_d.g,i=_d.b,a=Math.max(n,r,i),o=Math.min(n,r,i);let s,c;const l=(o+a)/2;if(o===a)s=0,c=0;else{const e=a-o;switch(c=l<=.5?e/(a+o):e/(2-a-o),a){case n:s=(r-i)/e+(r<i?6:0);break;case r:s=(i-n)/e+2;break;case i:s=(n-r)/e+4}s/=6}return e.h=s,e.s=c,e.l=l,e}getRGB(e,t=Bl.workingColorSpace){return Bl.fromWorkingColorSpace(_d.copy(this),t),e.r=_d.r,e.g=_d.g,e.b=_d.b,e}getStyle(e=il){Bl.fromWorkingColorSpace(_d.copy(this),e);const t=_d.r,n=_d.g,r=_d.b;return e!==il?`color(${e} ${t.toFixed(3)} ${n.toFixed(3)} ${r.toFixed(3)})`:`rgb(${Math.round(255*t)},${Math.round(255*n)},${Math.round(255*r)})`}offsetHSL(e,t,n){return this.getHSL(md),md.h+=e,md.s+=t,md.l+=n,this.setHSL(md.h,md.s,md.l),this}add(e){return this.r+=e.r,this.g+=e.g,this.b+=e.b,this}addColors(e,t){return this.r=e.r+t.r,this.g=e.g+t.g,this.b=e.b+t.b,this}addScalar(e){return this.r+=e,this.g+=e,this.b+=e,this}sub(e){return this.r=Math.max(0,this.r-e.r),this.g=Math.max(0,this.g-e.g),this.b=Math.max(0,this.b-e.b),this}multiply(e){return this.r*=e.r,this.g*=e.g,this.b*=e.b,this}multiplyScalar(e){return this.r*=e,this.g*=e,this.b*=e,this}lerp(e,t){return this.r+=(e.r-this.r)*t,this.g+=(e.g-this.g)*t,this.b+=(e.b-this.b)*t,this}lerpColors(e,t,n){return this.r=e.r+(t.r-e.r)*n,this.g=e.g+(t.g-e.g)*n,this.b=e.b+(t.b-e.b)*n,this}lerpHSL(e,t){this.getHSL(md),e.getHSL(vd);const n=yl(md.h,vd.h,t),r=yl(md.s,vd.s,t),i=yl(md.l,vd.l,t);return this.setHSL(n,r,i),this}setFromVector3(e){return this.r=e.x,this.g=e.y,this.b=e.z,this}applyMatrix3(e){const t=this.r,n=this.g,r=this.b,i=e.elements;return this.r=i[0]*t+i[3]*n+i[6]*r,this.g=i[1]*t+i[4]*n+i[7]*r,this.b=i[2]*t+i[5]*n+i[8]*r,this}equals(e){return e.r===this.r&&e.g===this.g&&e.b===this.b}fromArray(e,t=0){return this.r=e[t],this.g=e[t+1],this.b=e[t+2],this}toArray(e=[],t=0){return e[t]=this.r,e[t+1]=this.g,e[t+2]=this.b,e}fromBufferAttribute(e,t){return this.r=e.getX(t),this.g=e.getY(t),this.b=e.getZ(t),this}toJSON(){return this.getHex()}*[Symbol.iterator](){yield this.r,yield this.g,yield this.b}}const _d=new bd;bd.NAMES=pd;class yd extends hd{constructor(e){super(),this.isMeshBasicMaterial=!0,this.type="MeshBasicMaterial",this.color=new bd(16777215),this.map=null,this.lightMap=null,this.lightMapIntensity=1,this.aoMap=null,this.aoMapIntensity=1,this.specularMap=null,this.alphaMap=null,this.envMap=null,this.combine=xc,this.reflectivity=1,this.refractionRatio=.98,this.wireframe=!1,this.wireframeLinewidth=1,this.wireframeLinecap="round",this.wireframeLinejoin="round",this.fog=!0,this.setValues(e)}copy(e){return super.copy(e),this.color.copy(e.color),this.map=e.map,this.lightMap=e.lightMap,this.lightMapIntensity=e.lightMapIntensity,this.aoMap=e.aoMap,this.aoMapIntensity=e.aoMapIntensity,this.specularMap=e.specularMap,this.alphaMap=e.alphaMap,this.envMap=e.envMap,this.combine=e.combine,this.reflectivity=e.reflectivity,this.refractionRatio=e.refractionRatio,this.wireframe=e.wireframe,this.wireframeLinewidth=e.wireframeLinewidth,this.wireframeLinecap=e.wireframeLinecap,this.wireframeLinejoin=e.wireframeLinejoin,this.fog=e.fog,this}}const xd=new Jl,Ad=new Sl;class wd{constructor(e,t,n=!1){if(Array.isArray(e))throw new TypeError("THREE.BufferAttribute: array should be a Typed Array.");this.isBufferAttribute=!0,this.name="",this.array=e,this.itemSize=t,this.count=void 0!==e?e.length/t:0,this.normalized=n,this.usage=35044,this.updateRange={offset:0,count:-1},this.gpuType=Gc,this.version=0}onUploadCallback(){}set needsUpdate(e){!0===e&&this.version++}setUsage(e){return this.usage=e,this}copy(e){return this.name=e.name,this.array=new e.array.constructor(e.array),this.itemSize=e.itemSize,this.count=e.count,this.normalized=e.normalized,this.usage=e.usage,this.gpuType=e.gpuType,this}copyAt(e,t,n){e*=this.itemSize,n*=t.itemSize;for(let r=0,i=this.itemSize;r<i;r++)this.array[e+r]=t.array[n+r];return this}copyArray(e){return this.array.set(e),this}applyMatrix3(e){if(2===this.itemSize)for(let t=0,n=this.count;t<n;t++)Ad.fromBufferAttribute(this,t),Ad.applyMatrix3(e),this.setXY(t,Ad.x,Ad.y);else if(3===this.itemSize)for(let t=0,n=this.count;t<n;t++)xd.fromBufferAttribute(this,t),xd.applyMatrix3(e),this.setXYZ(t,xd.x,xd.y,xd.z);return this}applyMatrix4(e){for(let t=0,n=this.count;t<n;t++)xd.fromBufferAttribute(this,t),xd.applyMatrix4(e),this.setXYZ(t,xd.x,xd.y,xd.z);return this}applyNormalMatrix(e){for(let t=0,n=this.count;t<n;t++)xd.fromBufferAttribute(this,t),xd.applyNormalMatrix(e),this.setXYZ(t,xd.x,xd.y,xd.z);return this}transformDirection(e){for(let t=0,n=this.count;t<n;t++)xd.fromBufferAttribute(this,t),xd.transformDirection(e),this.setXYZ(t,xd.x,xd.y,xd.z);return this}set(e,t=0){return this.array.set(e,t),this}getX(e){let t=this.array[e*this.itemSize];return this.normalized&&(t=wl(t,this.array)),t}setX(e,t){return this.normalized&&(t=El(t,this.array)),this.array[e*this.itemSize]=t,this}getY(e){let t=this.array[e*this.itemSize+1];return this.normalized&&(t=wl(t,this.array)),t}setY(e,t){return this.normalized&&(t=El(t,this.array)),this.array[e*this.itemSize+1]=t,this}getZ(e){let t=this.array[e*this.itemSize+2];return this.normalized&&(t=wl(t,this.array)),t}setZ(e,t){return this.normalized&&(t=El(t,this.array)),this.array[e*this.itemSize+2]=t,this}getW(e){let t=this.array[e*this.itemSize+3];return this.normalized&&(t=wl(t,this.array)),t}setW(e,t){return this.normalized&&(t=El(t,this.array)),this.array[e*this.itemSize+3]=t,this}setXY(e,t,n){return e*=this.itemSize,this.normalized&&(t=El(t,this.array),n=El(n,this.array)),this.array[e+0]=t,this.array[e+1]=n,this}setXYZ(e,t,n,r){return e*=this.itemSize,this.normalized&&(t=El(t,this.array),n=El(n,this.array),r=El(r,this.array)),this.array[e+0]=t,this.array[e+1]=n,this.array[e+2]=r,this}setXYZW(e,t,n,r,i){return e*=this.itemSize,this.normalized&&(t=El(t,this.array),n=El(n,this.array),r=El(r,this.array),i=El(i,this.array)),this.array[e+0]=t,this.array[e+1]=n,this.array[e+2]=r,this.array[e+3]=i,this}onUpload(e){return this.onUploadCallback=e,this}clone(){return new this.constructor(this.array,this.itemSize).copy(this)}toJSON(){const e={itemSize:this.itemSize,type:this.array.constructor.name,array:Array.from(this.array),normalized:this.normalized};return""!==this.name&&(e.name=this.name),35044!==this.usage&&(e.usage=this.usage),0===this.updateRange.offset&&-1===this.updateRange.count||(e.updateRange=this.updateRange),e}}class Ed extends wd{constructor(e,t,n){super(new Uint16Array(e),t,n)}}class Td extends wd{constructor(e,t,n){super(new Uint32Array(e),t,n)}}class Sd extends wd{constructor(e,t,n){super(new Float32Array(e),t,n)}}let Cd=0;const Md=new Mu,kd=new Qu,Rd=new Jl,Ld=new tu,Od=new tu,Id=new Jl;class Pd extends fl{constructor(){super(),this.isBufferGeometry=!0,Object.defineProperty(this,"id",{value:Cd++}),this.uuid=gl(),this.name="",this.type="BufferGeometry",this.index=null,this.attributes={},this.morphAttributes={},this.morphTargetsRelative=!1,this.groups=[],this.boundingBox=null,this.boundingSphere=null,this.drawRange={start:0,count:1/0},this.userData={}}getIndex(){return this.index}setIndex(e){return Array.isArray(e)?this.index=new(kl(e)?Td:Ed)(e,1):this.index=e,this}getAttribute(e){return this.attributes[e]}setAttribute(e,t){return this.attributes[e]=t,this}deleteAttribute(e){return delete this.attributes[e],this}hasAttribute(e){return void 0!==this.attributes[e]}addGroup(e,t,n=0){this.groups.push({start:e,count:t,materialIndex:n})}clearGroups(){this.groups=[]}setDrawRange(e,t){this.drawRange.start=e,this.drawRange.count=t}applyMatrix4(e){const t=this.attributes.position;void 0!==t&&(t.applyMatrix4(e),t.needsUpdate=!0);const n=this.attributes.normal;if(void 0!==n){const t=(new Cl).getNormalMatrix(e);n.applyNormalMatrix(t),n.needsUpdate=!0}const r=this.attributes.tangent;return void 0!==r&&(r.transformDirection(e),r.needsUpdate=!0),null!==this.boundingBox&&this.computeBoundingBox(),null!==this.boundingSphere&&this.computeBoundingSphere(),this}applyQuaternion(e){return Md.makeRotationFromQuaternion(e),this.applyMatrix4(Md),this}rotateX(e){return Md.makeRotationX(e),this.applyMatrix4(Md),this}rotateY(e){return Md.makeRotationY(e),this.applyMatrix4(Md),this}rotateZ(e){return Md.makeRotationZ(e),this.applyMatrix4(Md),this}translate(e,t,n){return Md.makeTranslation(e,t,n),this.applyMatrix4(Md),this}scale(e,t,n){return Md.makeScale(e,t,n),this.applyMatrix4(Md),this}lookAt(e){return kd.lookAt(e),kd.updateMatrix(),this.applyMatrix4(kd.matrix),this}center(){return this.computeBoundingBox(),this.boundingBox.getCenter(Rd).negate(),this.translate(Rd.x,Rd.y,Rd.z),this}setFromPoints(e){const t=[];for(let n=0,r=e.length;n<r;n++){const r=e[n];t.push(r.x,r.y,r.z||0)}return this.setAttribute("position",new Sd(t,3)),this}computeBoundingBox(){null===this.boundingBox&&(this.boundingBox=new tu);const e=this.attributes.position,t=this.morphAttributes.position;if(e&&e.isGLBufferAttribute)return console.error('THREE.BufferGeometry.computeBoundingBox(): GLBufferAttribute requires a manual bounding box. Alternatively set "mesh.frustumCulled" to "false".',this),void this.boundingBox.set(new Jl(-1/0,-1/0,-1/0),new Jl(1/0,1/0,1/0));if(void 0!==e){if(this.boundingBox.setFromBufferAttribute(e),t)for(let e=0,n=t.length;e<n;e++){const n=t[e];Ld.setFromBufferAttribute(n),this.morphTargetsRelative?(Id.addVectors(this.boundingBox.min,Ld.min),this.boundingBox.expandByPoint(Id),Id.addVectors(this.boundingBox.max,Ld.max),this.boundingBox.expandByPoint(Id)):(this.boundingBox.expandByPoint(Ld.min),this.boundingBox.expandByPoint(Ld.max))}}else this.boundingBox.makeEmpty();(isNaN(this.boundingBox.min.x)||isNaN(this.boundingBox.min.y)||isNaN(this.boundingBox.min.z))&&console.error('THREE.BufferGeometry.computeBoundingBox(): Computed min/max have NaN values. The "position" attribute is likely to have NaN values.',this)}computeBoundingSphere(){null===this.boundingSphere&&(this.boundingSphere=new _u);const e=this.attributes.position,t=this.morphAttributes.position;if(e&&e.isGLBufferAttribute)return console.error('THREE.BufferGeometry.computeBoundingSphere(): GLBufferAttribute requires a manual bounding sphere. Alternatively set "mesh.frustumCulled" to "false".',this),void this.boundingSphere.set(new Jl,1/0);if(e){const n=this.boundingSphere.center;if(Ld.setFromBufferAttribute(e),t)for(let e=0,n=t.length;e<n;e++){const n=t[e];Od.setFromBufferAttribute(n),this.morphTargetsRelative?(Id.addVectors(Ld.min,Od.min),Ld.expandByPoint(Id),Id.addVectors(Ld.max,Od.max),Ld.expandByPoint(Id)):(Ld.expandByPoint(Od.min),Ld.expandByPoint(Od.max))}Ld.getCenter(n);let r=0;for(let t=0,i=e.count;t<i;t++)Id.fromBufferAttribute(e,t),r=Math.max(r,n.distanceToSquared(Id));if(t)for(let i=0,a=t.length;i<a;i++){const a=t[i],o=this.morphTargetsRelative;for(let t=0,i=a.count;t<i;t++)Id.fromBufferAttribute(a,t),o&&(Rd.fromBufferAttribute(e,t),Id.add(Rd)),r=Math.max(r,n.distanceToSquared(Id))}this.boundingSphere.radius=Math.sqrt(r),isNaN(this.boundingSphere.radius)&&console.error('THREE.BufferGeometry.computeBoundingSphere(): Computed radius is NaN. The "position" attribute is likely to have NaN values.',this)}}computeTangents(){const e=this.index,t=this.attributes;if(null===e||void 0===t.position||void 0===t.normal||void 0===t.uv)return void console.error("THREE.BufferGeometry: .computeTangents() failed. Missing required attributes (index, position, normal or uv)");const n=e.array,r=t.position.array,i=t.normal.array,a=t.uv.array,o=r.length/3;!1===this.hasAttribute("tangent")&&this.setAttribute("tangent",new wd(new Float32Array(4*o),4));const s=this.getAttribute("tangent").array,c=[],l=[];for(let e=0;e<o;e++)c[e]=new Jl,l[e]=new Jl;const u=new Jl,d=new Jl,f=new Jl,h=new Sl,p=new Sl,m=new Sl,v=new Jl,g=new Jl;function b(e,t,n){u.fromArray(r,3*e),d.fromArray(r,3*t),f.fromArray(r,3*n),h.fromArray(a,2*e),p.fromArray(a,2*t),m.fromArray(a,2*n),d.sub(u),f.sub(u),p.sub(h),m.sub(h);const i=1/(p.x*m.y-m.x*p.y);isFinite(i)&&(v.copy(d).multiplyScalar(m.y).addScaledVector(f,-p.y).multiplyScalar(i),g.copy(f).multiplyScalar(p.x).addScaledVector(d,-m.x).multiplyScalar(i),c[e].add(v),c[t].add(v),c[n].add(v),l[e].add(g),l[t].add(g),l[n].add(g))}let _=this.groups;0===_.length&&(_=[{start:0,count:n.length}]);for(let e=0,t=_.length;e<t;++e){const t=_[e],r=t.start;for(let e=r,i=r+t.count;e<i;e+=3)b(n[e+0],n[e+1],n[e+2])}const y=new Jl,x=new Jl,A=new Jl,w=new Jl;function E(e){A.fromArray(i,3*e),w.copy(A);const t=c[e];y.copy(t),y.sub(A.multiplyScalar(A.dot(t))).normalize(),x.crossVectors(w,t);const n=x.dot(l[e])<0?-1:1;s[4*e]=y.x,s[4*e+1]=y.y,s[4*e+2]=y.z,s[4*e+3]=n}for(let e=0,t=_.length;e<t;++e){const t=_[e],r=t.start;for(let e=r,i=r+t.count;e<i;e+=3)E(n[e+0]),E(n[e+1]),E(n[e+2])}}computeVertexNormals(){const e=this.index,t=this.getAttribute("position");if(void 0!==t){let n=this.getAttribute("normal");if(void 0===n)n=new wd(new Float32Array(3*t.count),3),this.setAttribute("normal",n);else for(let e=0,t=n.count;e<t;e++)n.setXYZ(e,0,0,0);const r=new Jl,i=new Jl,a=new Jl,o=new Jl,s=new Jl,c=new Jl,l=new Jl,u=new Jl;if(e)for(let d=0,f=e.count;d<f;d+=3){const f=e.getX(d+0),h=e.getX(d+1),p=e.getX(d+2);r.fromBufferAttribute(t,f),i.fromBufferAttribute(t,h),a.fromBufferAttribute(t,p),l.subVectors(a,i),u.subVectors(r,i),l.cross(u),o.fromBufferAttribute(n,f),s.fromBufferAttribute(n,h),c.fromBufferAttribute(n,p),o.add(l),s.add(l),c.add(l),n.setXYZ(f,o.x,o.y,o.z),n.setXYZ(h,s.x,s.y,s.z),n.setXYZ(p,c.x,c.y,c.z)}else for(let e=0,o=t.count;e<o;e+=3)r.fromBufferAttribute(t,e+0),i.fromBufferAttribute(t,e+1),a.fromBufferAttribute(t,e+2),l.subVectors(a,i),u.subVectors(r,i),l.cross(u),n.setXYZ(e+0,l.x,l.y,l.z),n.setXYZ(e+1,l.x,l.y,l.z),n.setXYZ(e+2,l.x,l.y,l.z);this.normalizeNormals(),n.needsUpdate=!0}}normalizeNormals(){const e=this.attributes.normal;for(let t=0,n=e.count;t<n;t++)Id.fromBufferAttribute(e,t),Id.normalize(),e.setXYZ(t,Id.x,Id.y,Id.z)}toNonIndexed(){function e(e,t){const n=e.array,r=e.itemSize,i=e.normalized,a=new n.constructor(t.length*r);let o=0,s=0;for(let i=0,c=t.length;i<c;i++){o=e.isInterleavedBufferAttribute?t[i]*e.data.stride+e.offset:t[i]*r;for(let e=0;e<r;e++)a[s++]=n[o++]}return new wd(a,r,i)}if(null===this.index)return console.warn("THREE.BufferGeometry.toNonIndexed(): BufferGeometry is already non-indexed."),this;const t=new Pd,n=this.index.array,r=this.attributes;for(const i in r){const a=e(r[i],n);t.setAttribute(i,a)}const i=this.morphAttributes;for(const r in i){const a=[],o=i[r];for(let t=0,r=o.length;t<r;t++){const r=e(o[t],n);a.push(r)}t.morphAttributes[r]=a}t.morphTargetsRelative=this.morphTargetsRelative;const a=this.groups;for(let e=0,n=a.length;e<n;e++){const n=a[e];t.addGroup(n.start,n.count,n.materialIndex)}return t}toJSON(){const e={metadata:{version:4.6,type:"BufferGeometry",generator:"BufferGeometry.toJSON"}};if(e.uuid=this.uuid,e.type=this.type,""!==this.name&&(e.name=this.name),Object.keys(this.userData).length>0&&(e.userData=this.userData),void 0!==this.parameters){const t=this.parameters;for(const n in t)void 0!==t[n]&&(e[n]=t[n]);return e}e.data={attributes:{}};const t=this.index;null!==t&&(e.data.index={type:t.array.constructor.name,array:Array.prototype.slice.call(t.array)});const n=this.attributes;for(const t in n){const r=n[t];e.data.attributes[t]=r.toJSON(e.data)}const r={};let i=!1;for(const t in this.morphAttributes){const n=this.morphAttributes[t],a=[];for(let t=0,r=n.length;t<r;t++){const r=n[t];a.push(r.toJSON(e.data))}a.length>0&&(r[t]=a,i=!0)}i&&(e.data.morphAttributes=r,e.data.morphTargetsRelative=this.morphTargetsRelative);const a=this.groups;a.length>0&&(e.data.groups=JSON.parse(JSON.stringify(a)));const o=this.boundingSphere;return null!==o&&(e.data.boundingSphere={center:o.center.toArray(),radius:o.radius}),e}clone(){return(new this.constructor).copy(this)}copy(e){this.index=null,this.attributes={},this.morphAttributes={},this.groups=[],this.boundingBox=null,this.boundingSphere=null;const t={};this.name=e.name;const n=e.index;null!==n&&this.setIndex(n.clone(t));const r=e.attributes;for(const e in r){const n=r[e];this.setAttribute(e,n.clone(t))}const i=e.morphAttributes;for(const e in i){const n=[],r=i[e];for(let e=0,i=r.length;e<i;e++)n.push(r[e].clone(t));this.morphAttributes[e]=n}this.morphTargetsRelative=e.morphTargetsRelative;const a=e.groups;for(let e=0,t=a.length;e<t;e++){const t=a[e];this.addGroup(t.start,t.count,t.materialIndex)}const o=e.boundingBox;null!==o&&(this.boundingBox=o.clone());const s=e.boundingSphere;return null!==s&&(this.boundingSphere=s.clone()),this.drawRange.start=e.drawRange.start,this.drawRange.count=e.drawRange.count,this.userData=e.userData,this}dispose(){this.dispatchEvent({type:"dispose"})}}const Dd=new Mu,Nd=new Cu,Ud=new _u,Fd=new Jl,Bd=new Jl,zd=new Jl,Hd=new Jl,Vd=new Jl,Gd=new Jl,$d=new Sl,Wd=new Sl,jd=new Sl,Xd=new Jl,Yd=new Jl,qd=new Jl,Kd=new Jl,Zd=new Jl;class Jd extends Qu{constructor(e=new Pd,t=new yd){super(),this.isMesh=!0,this.type="Mesh",this.geometry=e,this.material=t,this.updateMorphTargets()}copy(e,t){return super.copy(e,t),void 0!==e.morphTargetInfluences&&(this.morphTargetInfluences=e.morphTargetInfluences.slice()),void 0!==e.morphTargetDictionary&&(this.morphTargetDictionary=Object.assign({},e.morphTargetDictionary)),this.material=e.material,this.geometry=e.geometry,this}updateMorphTargets(){const e=this.geometry.morphAttributes,t=Object.keys(e);if(t.length>0){const n=e[t[0]];if(void 0!==n){this.morphTargetInfluences=[],this.morphTargetDictionary={};for(let e=0,t=n.length;e<t;e++){const t=n[e].name||String(e);this.morphTargetInfluences.push(0),this.morphTargetDictionary[t]=e}}}}getVertexPosition(e,t){const n=this.geometry,r=n.attributes.position,i=n.morphAttributes.position,a=n.morphTargetsRelative;t.fromBufferAttribute(r,e);const o=this.morphTargetInfluences;if(i&&o){Gd.set(0,0,0);for(let n=0,r=i.length;n<r;n++){const r=o[n],s=i[n];0!==r&&(Vd.fromBufferAttribute(s,e),a?Gd.addScaledVector(Vd,r):Gd.addScaledVector(Vd.sub(t),r))}t.add(Gd)}return t}raycast(e,t){const n=this.geometry,r=this.material,i=this.matrixWorld;if(void 0!==r){if(null===n.boundingSphere&&n.computeBoundingSphere(),Ud.copy(n.boundingSphere),Ud.applyMatrix4(i),Nd.copy(e.ray).recast(e.near),!1===Ud.containsPoint(Nd.origin)){if(null===Nd.intersectSphere(Ud,Fd))return;if(Nd.origin.distanceToSquared(Fd)>(e.far-e.near)**2)return}Dd.copy(i).invert(),Nd.copy(e.ray).applyMatrix4(Dd),null!==n.boundingBox&&!1===Nd.intersectsBox(n.boundingBox)||this._computeIntersections(e,t,Nd)}}_computeIntersections(e,t,n){let r;const i=this.geometry,a=this.material,o=i.index,s=i.attributes.position,c=i.attributes.uv,l=i.attributes.uv1,u=i.attributes.normal,d=i.groups,f=i.drawRange;if(null!==o)if(Array.isArray(a))for(let i=0,s=d.length;i<s;i++){const s=d[i],h=a[s.materialIndex];for(let i=Math.max(s.start,f.start),a=Math.min(o.count,Math.min(s.start+s.count,f.start+f.count));i<a;i+=3)r=Qd(this,h,e,n,c,l,u,o.getX(i),o.getX(i+1),o.getX(i+2)),r&&(r.faceIndex=Math.floor(i/3),r.face.materialIndex=s.materialIndex,t.push(r))}else for(let i=Math.max(0,f.start),s=Math.min(o.count,f.start+f.count);i<s;i+=3)r=Qd(this,a,e,n,c,l,u,o.getX(i),o.getX(i+1),o.getX(i+2)),r&&(r.faceIndex=Math.floor(i/3),t.push(r));else if(void 0!==s)if(Array.isArray(a))for(let i=0,o=d.length;i<o;i++){const o=d[i],h=a[o.materialIndex];for(let i=Math.max(o.start,f.start),a=Math.min(s.count,Math.min(o.start+o.count,f.start+f.count));i<a;i+=3)r=Qd(this,h,e,n,c,l,u,i,i+1,i+2),r&&(r.faceIndex=Math.floor(i/3),r.face.materialIndex=o.materialIndex,t.push(r))}else for(let i=Math.max(0,f.start),o=Math.min(s.count,f.start+f.count);i<o;i+=3)r=Qd(this,a,e,n,c,l,u,i,i+1,i+2),r&&(r.faceIndex=Math.floor(i/3),t.push(r))}}function Qd(e,t,n,r,i,a,o,s,c,l){e.getVertexPosition(s,Bd),e.getVertexPosition(c,zd),e.getVertexPosition(l,Hd);const u=function(e,t,n,r,i,a,o,s){let c;if(c=1===t.side?r.intersectTriangle(o,a,i,!0,s):r.intersectTriangle(i,a,o,0===t.side,s),null===c)return null;Zd.copy(s),Zd.applyMatrix4(e.matrixWorld);const l=n.ray.origin.distanceTo(Zd);return l<n.near||l>n.far?null:{distance:l,point:Zd.clone(),object:e}}(e,t,n,r,Bd,zd,Hd,Kd);if(u){i&&($d.fromBufferAttribute(i,s),Wd.fromBufferAttribute(i,c),jd.fromBufferAttribute(i,l),u.uv=dd.getInterpolation(Kd,Bd,zd,Hd,$d,Wd,jd,new Sl)),a&&($d.fromBufferAttribute(a,s),Wd.fromBufferAttribute(a,c),jd.fromBufferAttribute(a,l),u.uv1=dd.getInterpolation(Kd,Bd,zd,Hd,$d,Wd,jd,new Sl),u.uv2=u.uv1),o&&(Xd.fromBufferAttribute(o,s),Yd.fromBufferAttribute(o,c),qd.fromBufferAttribute(o,l),u.normal=dd.getInterpolation(Kd,Bd,zd,Hd,Xd,Yd,qd,new Jl),u.normal.dot(r.direction)>0&&u.normal.multiplyScalar(-1));const e={a:s,b:c,c:l,normal:new Jl,materialIndex:0};dd.getNormal(Bd,zd,Hd,e.normal),u.face=e}return u}class ef extends Pd{constructor(e=1,t=1,n=1,r=1,i=1,a=1){super(),this.type="BoxGeometry",this.parameters={width:e,height:t,depth:n,widthSegments:r,heightSegments:i,depthSegments:a};const o=this;r=Math.floor(r),i=Math.floor(i),a=Math.floor(a);const s=[],c=[],l=[],u=[];let d=0,f=0;function h(e,t,n,r,i,a,h,p,m,v,g){const b=a/m,_=h/v,y=a/2,x=h/2,A=p/2,w=m+1,E=v+1;let T=0,S=0;const C=new Jl;for(let a=0;a<E;a++){const o=a*_-x;for(let s=0;s<w;s++){const d=s*b-y;C[e]=d*r,C[t]=o*i,C[n]=A,c.push(C.x,C.y,C.z),C[e]=0,C[t]=0,C[n]=p>0?1:-1,l.push(C.x,C.y,C.z),u.push(s/m),u.push(1-a/v),T+=1}}for(let e=0;e<v;e++)for(let t=0;t<m;t++){const n=d+t+w*e,r=d+t+w*(e+1),i=d+(t+1)+w*(e+1),a=d+(t+1)+w*e;s.push(n,r,a),s.push(r,i,a),S+=6}o.addGroup(f,S,g),f+=S,d+=T}h("z","y","x",-1,-1,n,t,e,a,i,0),h("z","y","x",1,-1,n,t,-e,a,i,1),h("x","z","y",1,1,e,n,t,r,a,2),h("x","z","y",1,-1,e,n,-t,r,a,3),h("x","y","z",1,-1,e,t,n,r,i,4),h("x","y","z",-1,-1,e,t,-n,r,i,5),this.setIndex(s),this.setAttribute("position",new Sd(c,3)),this.setAttribute("normal",new Sd(l,3)),this.setAttribute("uv",new Sd(u,2))}copy(e){return super.copy(e),this.parameters=Object.assign({},e.parameters),this}static fromJSON(e){return new ef(e.width,e.height,e.depth,e.widthSegments,e.heightSegments,e.depthSegments)}}function tf(e){const t={};for(const n in e){t[n]={};for(const r in e[n]){const i=e[n][r];i&&(i.isColor||i.isMatrix3||i.isMatrix4||i.isVector2||i.isVector3||i.isVector4||i.isTexture||i.isQuaternion)?i.isRenderTargetTexture?(console.warn("UniformsUtils: Textures of render targets cannot be cloned via cloneUniforms() or mergeUniforms()."),t[n][r]=null):t[n][r]=i.clone():Array.isArray(i)?t[n][r]=i.slice():t[n][r]=i}}return t}function nf(e){const t={};for(let n=0;n<e.length;n++){const r=tf(e[n]);for(const e in r)t[e]=r[e]}return t}function rf(e){return null===e.getRenderTarget()?e.outputColorSpace:al}const af={clone:tf,merge:nf};class of extends hd{constructor(e){super(),this.isShaderMaterial=!0,this.type="ShaderMaterial",this.defines={},this.uniforms={},this.uniformsGroups=[],this.vertexShader="void main() {\n\tgl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",this.fragmentShader="void main() {\n\tgl_FragColor = vec4( 1.0, 0.0, 0.0, 1.0 );\n}",this.linewidth=1,this.wireframe=!1,this.wireframeLinewidth=1,this.fog=!1,this.lights=!1,this.clipping=!1,this.forceSinglePass=!0,this.extensions={derivatives:!1,fragDepth:!1,drawBuffers:!1,shaderTextureLOD:!1},this.defaultAttributeValues={color:[1,1,1],uv:[0,0],uv1:[0,0]},this.index0AttributeName=void 0,this.uniformsNeedUpdate=!1,this.glslVersion=null,void 0!==e&&this.setValues(e)}copy(e){return super.copy(e),this.fragmentShader=e.fragmentShader,this.vertexShader=e.vertexShader,this.uniforms=tf(e.uniforms),this.uniformsGroups=function(e){const t=[];for(let n=0;n<e.length;n++)t.push(e[n].clone());return t}(e.uniformsGroups),this.defines=Object.assign({},e.defines),this.wireframe=e.wireframe,this.wireframeLinewidth=e.wireframeLinewidth,this.fog=e.fog,this.lights=e.lights,this.clipping=e.clipping,this.extensions=Object.assign({},e.extensions),this.glslVersion=e.glslVersion,this}toJSON(e){const t=super.toJSON(e);t.glslVersion=this.glslVersion,t.uniforms={};for(const n in this.uniforms){const r=this.uniforms[n].value;r&&r.isTexture?t.uniforms[n]={type:"t",value:r.toJSON(e).uuid}:r&&r.isColor?t.uniforms[n]={type:"c",value:r.getHex()}:r&&r.isVector2?t.uniforms[n]={type:"v2",value:r.toArray()}:r&&r.isVector3?t.uniforms[n]={type:"v3",value:r.toArray()}:r&&r.isVector4?t.uniforms[n]={type:"v4",value:r.toArray()}:r&&r.isMatrix3?t.uniforms[n]={type:"m3",value:r.toArray()}:r&&r.isMatrix4?t.uniforms[n]={type:"m4",value:r.toArray()}:t.uniforms[n]={value:r}}Object.keys(this.defines).length>0&&(t.defines=this.defines),t.vertexShader=this.vertexShader,t.fragmentShader=this.fragmentShader,t.lights=this.lights,t.clipping=this.clipping;const n={};for(const e in this.extensions)!0===this.extensions[e]&&(n[e]=!0);return Object.keys(n).length>0&&(t.extensions=n),t}}class sf extends Qu{constructor(){super(),this.isCamera=!0,this.type="Camera",this.matrixWorldInverse=new Mu,this.projectionMatrix=new Mu,this.projectionMatrixInverse=new Mu,this.coordinateSystem=ul}copy(e,t){return super.copy(e,t),this.matrixWorldInverse.copy(e.matrixWorldInverse),this.projectionMatrix.copy(e.projectionMatrix),this.projectionMatrixInverse.copy(e.projectionMatrixInverse),this.coordinateSystem=e.coordinateSystem,this}getWorldDirection(e){this.updateWorldMatrix(!0,!1);const t=this.matrixWorld.elements;return e.set(-t[8],-t[9],-t[10]).normalize()}updateMatrixWorld(e){super.updateMatrixWorld(e),this.matrixWorldInverse.copy(this.matrixWorld).invert()}updateWorldMatrix(e,t){super.updateWorldMatrix(e,t),this.matrixWorldInverse.copy(this.matrixWorld).invert()}clone(){return(new this.constructor).copy(this)}}class cf extends sf{constructor(e=50,t=1,n=.1,r=2e3){super(),this.isPerspectiveCamera=!0,this.type="PerspectiveCamera",this.fov=e,this.zoom=1,this.near=n,this.far=r,this.focus=10,this.aspect=t,this.view=null,this.filmGauge=35,this.filmOffset=0,this.updateProjectionMatrix()}copy(e,t){return super.copy(e,t),this.fov=e.fov,this.zoom=e.zoom,this.near=e.near,this.far=e.far,this.focus=e.focus,this.aspect=e.aspect,this.view=null===e.view?null:Object.assign({},e.view),this.filmGauge=e.filmGauge,this.filmOffset=e.filmOffset,this}setFocalLength(e){const t=.5*this.getFilmHeight()/e;this.fov=2*vl*Math.atan(t),this.updateProjectionMatrix()}getFocalLength(){const e=Math.tan(.5*ml*this.fov);return.5*this.getFilmHeight()/e}getEffectiveFOV(){return 2*vl*Math.atan(Math.tan(.5*ml*this.fov)/this.zoom)}getFilmWidth(){return this.filmGauge*Math.min(this.aspect,1)}getFilmHeight(){return this.filmGauge/Math.max(this.aspect,1)}setViewOffset(e,t,n,r,i,a){this.aspect=e/t,null===this.view&&(this.view={enabled:!0,fullWidth:1,fullHeight:1,offsetX:0,offsetY:0,width:1,height:1}),this.view.enabled=!0,this.view.fullWidth=e,this.view.fullHeight=t,this.view.offsetX=n,this.view.offsetY=r,this.view.width=i,this.view.height=a,this.updateProjectionMatrix()}clearViewOffset(){null!==this.view&&(this.view.enabled=!1),this.updateProjectionMatrix()}updateProjectionMatrix(){const e=this.near;let t=e*Math.tan(.5*ml*this.fov)/this.zoom,n=2*t,r=this.aspect*n,i=-.5*r;const a=this.view;if(null!==this.view&&this.view.enabled){const e=a.fullWidth,o=a.fullHeight;i+=a.offsetX*r/e,t-=a.offsetY*n/o,r*=a.width/e,n*=a.height/o}const o=this.filmOffset;0!==o&&(i+=e*o/this.getFilmWidth()),this.projectionMatrix.makePerspective(i,i+r,t,t-n,e,this.far,this.coordinateSystem),this.projectionMatrixInverse.copy(this.projectionMatrix).invert()}toJSON(e){const t=super.toJSON(e);return t.object.fov=this.fov,t.object.zoom=this.zoom,t.object.near=this.near,t.object.far=this.far,t.object.focus=this.focus,t.object.aspect=this.aspect,null!==this.view&&(t.object.view=Object.assign({},this.view)),t.object.filmGauge=this.filmGauge,t.object.filmOffset=this.filmOffset,t}}const lf=-90;class uf extends Qu{constructor(e,t,n){super(),this.type="CubeCamera",this.renderTarget=n,this.coordinateSystem=null;const r=new cf(lf,1,e,t);r.layers=this.layers,this.add(r);const i=new cf(lf,1,e,t);i.layers=this.layers,this.add(i);const a=new cf(lf,1,e,t);a.layers=this.layers,this.add(a);const o=new cf(lf,1,e,t);o.layers=this.layers,this.add(o);const s=new cf(lf,1,e,t);s.layers=this.layers,this.add(s);const c=new cf(lf,1,e,t);c.layers=this.layers,this.add(c)}updateCoordinateSystem(){const e=this.coordinateSystem,t=this.children.concat(),[n,r,i,a,o,s]=t;for(const e of t)this.remove(e);if(e===ul)n.up.set(0,1,0),n.lookAt(1,0,0),r.up.set(0,1,0),r.lookAt(-1,0,0),i.up.set(0,0,-1),i.lookAt(0,1,0),a.up.set(0,0,1),a.lookAt(0,-1,0),o.up.set(0,1,0),o.lookAt(0,0,1),s.up.set(0,1,0),s.lookAt(0,0,-1);else{if(e!==dl)throw new Error("THREE.CubeCamera.updateCoordinateSystem(): Invalid coordinate system: "+e);n.up.set(0,-1,0),n.lookAt(-1,0,0),r.up.set(0,-1,0),r.lookAt(1,0,0),i.up.set(0,0,1),i.lookAt(0,1,0),a.up.set(0,0,-1),a.lookAt(0,-1,0),o.up.set(0,-1,0),o.lookAt(0,0,1),s.up.set(0,-1,0),s.lookAt(0,0,-1)}for(const e of t)this.add(e),e.updateMatrixWorld()}update(e,t){null===this.parent&&this.updateMatrixWorld();const n=this.renderTarget;this.coordinateSystem!==e.coordinateSystem&&(this.coordinateSystem=e.coordinateSystem,this.updateCoordinateSystem());const[r,i,a,o,s,c]=this.children,l=e.getRenderTarget(),u=e.toneMapping,d=e.xr.enabled;e.toneMapping=Ec,e.xr.enabled=!1;const f=n.texture.generateMipmaps;n.texture.generateMipmaps=!1,e.setRenderTarget(n,0),e.render(t,r),e.setRenderTarget(n,1),e.render(t,i),e.setRenderTarget(n,2),e.render(t,a),e.setRenderTarget(n,3),e.render(t,o),e.setRenderTarget(n,4),e.render(t,s),n.texture.generateMipmaps=f,e.setRenderTarget(n,5),e.render(t,c),e.setRenderTarget(l),e.toneMapping=u,e.xr.enabled=d,n.texture.needsPMREMUpdate=!0}}class df extends jl{constructor(e,t,n,r,i,a,o,s,c,l){super(e=void 0!==e?e:[],t=void 0!==t?t:Rc,n,r,i,a,o,s,c,l),this.isCubeTexture=!0,this.flipY=!1}get images(){return this.image}set images(e){this.image=e}}class ff extends Yl{constructor(e=1,t={}){super(e,e,t),this.isWebGLCubeRenderTarget=!0;const n={width:e,height:e,depth:1},r=[n,n,n,n,n,n];void 0!==t.encoding&&(Ol("THREE.WebGLCubeRenderTarget: option.encoding has been replaced by option.colorSpace."),t.colorSpace=t.encoding===rl?il:""),this.texture=new df(r,t.mapping,t.wrapS,t.wrapT,t.magFilter,t.minFilter,t.format,t.type,t.anisotropy,t.colorSpace),this.texture.isRenderTargetTexture=!0,this.texture.generateMipmaps=void 0!==t.generateMipmaps&&t.generateMipmaps,this.texture.minFilter=void 0!==t.minFilter?t.minFilter:Fc}fromEquirectangularTexture(e,t){this.texture.type=t.type,this.texture.colorSpace=t.colorSpace,this.texture.generateMipmaps=t.generateMipmaps,this.texture.minFilter=t.minFilter,this.texture.magFilter=t.magFilter;const n={tEquirect:{value:null}},r="\n\n\t\t\t\tvarying vec3 vWorldDirection;\n\n\t\t\t\tvec3 transformDirection( in vec3 dir, in mat4 matrix ) {\n\n\t\t\t\t\treturn normalize( ( matrix * vec4( dir, 0.0 ) ).xyz );\n\n\t\t\t\t}\n\n\t\t\t\tvoid main() {\n\n\t\t\t\t\tvWorldDirection = transformDirection( position, modelMatrix );\n\n\t\t\t\t\t#include <begin_vertex>\n\t\t\t\t\t#include <project_vertex>\n\n\t\t\t\t}\n\t\t\t",i="\n\n\t\t\t\tuniform sampler2D tEquirect;\n\n\t\t\t\tvarying vec3 vWorldDirection;\n\n\t\t\t\t#include <common>\n\n\t\t\t\tvoid main() {\n\n\t\t\t\t\tvec3 direction = normalize( vWorldDirection );\n\n\t\t\t\t\tvec2 sampleUV = equirectUv( direction );\n\n\t\t\t\t\tgl_FragColor = texture2D( tEquirect, sampleUV );\n\n\t\t\t\t}\n\t\t\t",a=new ef(5,5,5),o=new of({name:"CubemapFromEquirect",uniforms:tf(n),vertexShader:r,fragmentShader:i,side:1,blending:0});o.uniforms.tEquirect.value=t;const s=new Jd(a,o),c=t.minFilter;return t.minFilter===Bc&&(t.minFilter=Fc),new uf(1,10,this).update(e,s),t.minFilter=c,s.geometry.dispose(),s.material.dispose(),this}clear(e,t,n,r){const i=e.getRenderTarget();for(let i=0;i<6;i++)e.setRenderTarget(this,i),e.clear(t,n,r);e.setRenderTarget(i)}}const hf=new Jl,pf=new Jl,mf=new Cl;class vf{constructor(e=new Jl(1,0,0),t=0){this.isPlane=!0,this.normal=e,this.constant=t}set(e,t){return this.normal.copy(e),this.constant=t,this}setComponents(e,t,n,r){return this.normal.set(e,t,n),this.constant=r,this}setFromNormalAndCoplanarPoint(e,t){return this.normal.copy(e),this.constant=-t.dot(this.normal),this}setFromCoplanarPoints(e,t,n){const r=hf.subVectors(n,t).cross(pf.subVectors(e,t)).normalize();return this.setFromNormalAndCoplanarPoint(r,e),this}copy(e){return this.normal.copy(e.normal),this.constant=e.constant,this}normalize(){const e=1/this.normal.length();return this.normal.multiplyScalar(e),this.constant*=e,this}negate(){return this.constant*=-1,this.normal.negate(),this}distanceToPoint(e){return this.normal.dot(e)+this.constant}distanceToSphere(e){return this.distanceToPoint(e.center)-e.radius}projectPoint(e,t){return t.copy(e).addScaledVector(this.normal,-this.distanceToPoint(e))}intersectLine(e,t){const n=e.delta(hf),r=this.normal.dot(n);if(0===r)return 0===this.distanceToPoint(e.start)?t.copy(e.start):null;const i=-(e.start.dot(this.normal)+this.constant)/r;return i<0||i>1?null:t.copy(e.start).addScaledVector(n,i)}intersectsLine(e){const t=this.distanceToPoint(e.start),n=this.distanceToPoint(e.end);return t<0&&n>0||n<0&&t>0}intersectsBox(e){return e.intersectsPlane(this)}intersectsSphere(e){return e.intersectsPlane(this)}coplanarPoint(e){return e.copy(this.normal).multiplyScalar(-this.constant)}applyMatrix4(e,t){const n=t||mf.getNormalMatrix(e),r=this.coplanarPoint(hf).applyMatrix4(e),i=this.normal.applyMatrix3(n).normalize();return this.constant=-r.dot(i),this}translate(e){return this.constant-=e.dot(this.normal),this}equals(e){return e.normal.equals(this.normal)&&e.constant===this.constant}clone(){return(new this.constructor).copy(this)}}const gf=new _u,bf=new Jl;class _f{constructor(e=new vf,t=new vf,n=new vf,r=new vf,i=new vf,a=new vf){this.planes=[e,t,n,r,i,a]}set(e,t,n,r,i,a){const o=this.planes;return o[0].copy(e),o[1].copy(t),o[2].copy(n),o[3].copy(r),o[4].copy(i),o[5].copy(a),this}copy(e){const t=this.planes;for(let n=0;n<6;n++)t[n].copy(e.planes[n]);return this}setFromProjectionMatrix(e,t=2e3){const n=this.planes,r=e.elements,i=r[0],a=r[1],o=r[2],s=r[3],c=r[4],l=r[5],u=r[6],d=r[7],f=r[8],h=r[9],p=r[10],m=r[11],v=r[12],g=r[13],b=r[14],_=r[15];if(n[0].setComponents(s-i,d-c,m-f,_-v).normalize(),n[1].setComponents(s+i,d+c,m+f,_+v).normalize(),n[2].setComponents(s+a,d+l,m+h,_+g).normalize(),n[3].setComponents(s-a,d-l,m-h,_-g).normalize(),n[4].setComponents(s-o,d-u,m-p,_-b).normalize(),t===ul)n[5].setComponents(s+o,d+u,m+p,_+b).normalize();else{if(t!==dl)throw new Error("THREE.Frustum.setFromProjectionMatrix(): Invalid coordinate system: "+t);n[5].setComponents(o,u,p,b).normalize()}return this}intersectsObject(e){if(void 0!==e.boundingSphere)null===e.boundingSphere&&e.computeBoundingSphere(),gf.copy(e.boundingSphere).applyMatrix4(e.matrixWorld);else{const t=e.geometry;null===t.boundingSphere&&t.computeBoundingSphere(),gf.copy(t.boundingSphere).applyMatrix4(e.matrixWorld)}return this.intersectsSphere(gf)}intersectsSprite(e){return gf.center.set(0,0,0),gf.radius=.7071067811865476,gf.applyMatrix4(e.matrixWorld),this.intersectsSphere(gf)}intersectsSphere(e){const t=this.planes,n=e.center,r=-e.radius;for(let e=0;e<6;e++)if(t[e].distanceToPoint(n)<r)return!1;return!0}intersectsBox(e){const t=this.planes;for(let n=0;n<6;n++){const r=t[n];if(bf.x=r.normal.x>0?e.max.x:e.min.x,bf.y=r.normal.y>0?e.max.y:e.min.y,bf.z=r.normal.z>0?e.max.z:e.min.z,r.distanceToPoint(bf)<0)return!1}return!0}containsPoint(e){const t=this.planes;for(let n=0;n<6;n++)if(t[n].distanceToPoint(e)<0)return!1;return!0}clone(){return(new this.constructor).copy(this)}}function yf(){let e=null,t=!1,n=null,r=null;function i(t,a){n(t,a),r=e.requestAnimationFrame(i)}return{start:function(){!0!==t&&null!==n&&(r=e.requestAnimationFrame(i),t=!0)},stop:function(){e.cancelAnimationFrame(r),t=!1},setAnimationLoop:function(e){n=e},setContext:function(t){e=t}}}function xf(e,t){const n=t.isWebGL2,r=new WeakMap;return{get:function(e){return e.isInterleavedBufferAttribute&&(e=e.data),r.get(e)},remove:function(t){t.isInterleavedBufferAttribute&&(t=t.data);const n=r.get(t);n&&(e.deleteBuffer(n.buffer),r.delete(t))},update:function(t,i){if(t.isGLBufferAttribute){const e=r.get(t);return void((!e||e.version<t.version)&&r.set(t,{buffer:t.buffer,type:t.type,bytesPerElement:t.elementSize,version:t.version}))}t.isInterleavedBufferAttribute&&(t=t.data);const a=r.get(t);void 0===a?r.set(t,function(t,r){const i=t.array,a=t.usage,o=e.createBuffer();let s;if(e.bindBuffer(r,o),e.bufferData(r,i,a),t.onUploadCallback(),i instanceof Float32Array)s=e.FLOAT;else if(i instanceof Uint16Array)if(t.isFloat16BufferAttribute){if(!n)throw new Error("THREE.WebGLAttributes: Usage of Float16BufferAttribute requires WebGL2.");s=e.HALF_FLOAT}else s=e.UNSIGNED_SHORT;else if(i instanceof Int16Array)s=e.SHORT;else if(i instanceof Uint32Array)s=e.UNSIGNED_INT;else if(i instanceof Int32Array)s=e.INT;else if(i instanceof Int8Array)s=e.BYTE;else if(i instanceof Uint8Array)s=e.UNSIGNED_BYTE;else{if(!(i instanceof Uint8ClampedArray))throw new Error("THREE.WebGLAttributes: Unsupported buffer data format: "+i);s=e.UNSIGNED_BYTE}return{buffer:o,type:s,bytesPerElement:i.BYTES_PER_ELEMENT,version:t.version}}(t,i)):a.version<t.version&&(function(t,r,i){const a=r.array,o=r.updateRange;e.bindBuffer(i,t),-1===o.count?e.bufferSubData(i,0,a):(n?e.bufferSubData(i,o.offset*a.BYTES_PER_ELEMENT,a,o.offset,o.count):e.bufferSubData(i,o.offset*a.BYTES_PER_ELEMENT,a.subarray(o.offset,o.offset+o.count)),o.count=-1),r.onUploadCallback()}(a.buffer,t,i),a.version=t.version)}}}class Af extends Pd{constructor(e=1,t=1,n=1,r=1){super(),this.type="PlaneGeometry",this.parameters={width:e,height:t,widthSegments:n,heightSegments:r};const i=e/2,a=t/2,o=Math.floor(n),s=Math.floor(r),c=o+1,l=s+1,u=e/o,d=t/s,f=[],h=[],p=[],m=[];for(let e=0;e<l;e++){const t=e*d-a;for(let n=0;n<c;n++){const r=n*u-i;h.push(r,-t,0),p.push(0,0,1),m.push(n/o),m.push(1-e/s)}}for(let e=0;e<s;e++)for(let t=0;t<o;t++){const n=t+c*e,r=t+c*(e+1),i=t+1+c*(e+1),a=t+1+c*e;f.push(n,r,a),f.push(r,i,a)}this.setIndex(f),this.setAttribute("position",new Sd(h,3)),this.setAttribute("normal",new Sd(p,3)),this.setAttribute("uv",new Sd(m,2))}copy(e){return super.copy(e),this.parameters=Object.assign({},e.parameters),this}static fromJSON(e){return new Af(e.width,e.height,e.widthSegments,e.heightSegments)}}const wf={alphahash_fragment:"#ifdef USE_ALPHAHASH\n\tif ( diffuseColor.a < getAlphaHashThreshold( vPosition ) ) discard;\n#endif",alphahash_pars_fragment:"#ifdef USE_ALPHAHASH\n\tconst float ALPHA_HASH_SCALE = 0.05;\n\tfloat hash2D( vec2 value ) {\n\t\treturn fract( 1.0e4 * sin( 17.0 * value.x + 0.1 * value.y ) * ( 0.1 + abs( sin( 13.0 * value.y + value.x ) ) ) );\n\t}\n\tfloat hash3D( vec3 value ) {\n\t\treturn hash2D( vec2( hash2D( value.xy ), value.z ) );\n\t}\n\tfloat getAlphaHashThreshold( vec3 position ) {\n\t\tfloat maxDeriv = max(\n\t\t\tlength( dFdx( position.xyz ) ),\n\t\t\tlength( dFdy( position.xyz ) )\n\t\t);\n\t\tfloat pixScale = 1.0 / ( ALPHA_HASH_SCALE * maxDeriv );\n\t\tvec2 pixScales = vec2(\n\t\t\texp2( floor( log2( pixScale ) ) ),\n\t\t\texp2( ceil( log2( pixScale ) ) )\n\t\t);\n\t\tvec2 alpha = vec2(\n\t\t\thash3D( floor( pixScales.x * position.xyz ) ),\n\t\t\thash3D( floor( pixScales.y * position.xyz ) )\n\t\t);\n\t\tfloat lerpFactor = fract( log2( pixScale ) );\n\t\tfloat x = ( 1.0 - lerpFactor ) * alpha.x + lerpFactor * alpha.y;\n\t\tfloat a = min( lerpFactor, 1.0 - lerpFactor );\n\t\tvec3 cases = vec3(\n\t\t\tx * x / ( 2.0 * a * ( 1.0 - a ) ),\n\t\t\t( x - 0.5 * a ) / ( 1.0 - a ),\n\t\t\t1.0 - ( ( 1.0 - x ) * ( 1.0 - x ) / ( 2.0 * a * ( 1.0 - a ) ) )\n\t\t);\n\t\tfloat threshold = ( x < ( 1.0 - a ) )\n\t\t\t? ( ( x < a ) ? cases.x : cases.y )\n\t\t\t: cases.z;\n\t\treturn clamp( threshold , 1.0e-6, 1.0 );\n\t}\n#endif",alphamap_fragment:"#ifdef USE_ALPHAMAP\n\tdiffuseColor.a *= texture2D( alphaMap, vAlphaMapUv ).g;\n#endif",alphamap_pars_fragment:"#ifdef USE_ALPHAMAP\n\tuniform sampler2D alphaMap;\n#endif",alphatest_fragment:"#ifdef USE_ALPHATEST\n\tif ( diffuseColor.a < alphaTest ) discard;\n#endif",alphatest_pars_fragment:"#ifdef USE_ALPHATEST\n\tuniform float alphaTest;\n#endif",aomap_fragment:"#ifdef USE_AOMAP\n\tfloat ambientOcclusion = ( texture2D( aoMap, vAoMapUv ).r - 1.0 ) * aoMapIntensity + 1.0;\n\treflectedLight.indirectDiffuse *= ambientOcclusion;\n\t#if defined( USE_ENVMAP ) && defined( STANDARD )\n\t\tfloat dotNV = saturate( dot( geometry.normal, geometry.viewDir ) );\n\t\treflectedLight.indirectSpecular *= computeSpecularOcclusion( dotNV, ambientOcclusion, material.roughness );\n\t#endif\n#endif",aomap_pars_fragment:"#ifdef USE_AOMAP\n\tuniform sampler2D aoMap;\n\tuniform float aoMapIntensity;\n#endif",begin_vertex:"vec3 transformed = vec3( position );\n#ifdef USE_ALPHAHASH\n\tvPosition = vec3( position );\n#endif",beginnormal_vertex:"vec3 objectNormal = vec3( normal );\n#ifdef USE_TANGENT\n\tvec3 objectTangent = vec3( tangent.xyz );\n#endif",bsdfs:"float G_BlinnPhong_Implicit( ) {\n\treturn 0.25;\n}\nfloat D_BlinnPhong( const in float shininess, const in float dotNH ) {\n\treturn RECIPROCAL_PI * ( shininess * 0.5 + 1.0 ) * pow( dotNH, shininess );\n}\nvec3 BRDF_BlinnPhong( const in vec3 lightDir, const in vec3 viewDir, const in vec3 normal, const in vec3 specularColor, const in float shininess ) {\n\tvec3 halfDir = normalize( lightDir + viewDir );\n\tfloat dotNH = saturate( dot( normal, halfDir ) );\n\tfloat dotVH = saturate( dot( viewDir, halfDir ) );\n\tvec3 F = F_Schlick( specularColor, 1.0, dotVH );\n\tfloat G = G_BlinnPhong_Implicit( );\n\tfloat D = D_BlinnPhong( shininess, dotNH );\n\treturn F * ( G * D );\n} // validated",iridescence_fragment:"#ifdef USE_IRIDESCENCE\n\tconst mat3 XYZ_TO_REC709 = mat3(\n\t\t 3.2404542, -0.9692660,  0.0556434,\n\t\t-1.5371385,  1.8760108, -0.2040259,\n\t\t-0.4985314,  0.0415560,  1.0572252\n\t);\n\tvec3 Fresnel0ToIor( vec3 fresnel0 ) {\n\t\tvec3 sqrtF0 = sqrt( fresnel0 );\n\t\treturn ( vec3( 1.0 ) + sqrtF0 ) / ( vec3( 1.0 ) - sqrtF0 );\n\t}\n\tvec3 IorToFresnel0( vec3 transmittedIor, float incidentIor ) {\n\t\treturn pow2( ( transmittedIor - vec3( incidentIor ) ) / ( transmittedIor + vec3( incidentIor ) ) );\n\t}\n\tfloat IorToFresnel0( float transmittedIor, float incidentIor ) {\n\t\treturn pow2( ( transmittedIor - incidentIor ) / ( transmittedIor + incidentIor ));\n\t}\n\tvec3 evalSensitivity( float OPD, vec3 shift ) {\n\t\tfloat phase = 2.0 * PI * OPD * 1.0e-9;\n\t\tvec3 val = vec3( 5.4856e-13, 4.4201e-13, 5.2481e-13 );\n\t\tvec3 pos = vec3( 1.6810e+06, 1.7953e+06, 2.2084e+06 );\n\t\tvec3 var = vec3( 4.3278e+09, 9.3046e+09, 6.6121e+09 );\n\t\tvec3 xyz = val * sqrt( 2.0 * PI * var ) * cos( pos * phase + shift ) * exp( - pow2( phase ) * var );\n\t\txyz.x += 9.7470e-14 * sqrt( 2.0 * PI * 4.5282e+09 ) * cos( 2.2399e+06 * phase + shift[ 0 ] ) * exp( - 4.5282e+09 * pow2( phase ) );\n\t\txyz /= 1.0685e-7;\n\t\tvec3 rgb = XYZ_TO_REC709 * xyz;\n\t\treturn rgb;\n\t}\n\tvec3 evalIridescence( float outsideIOR, float eta2, float cosTheta1, float thinFilmThickness, vec3 baseF0 ) {\n\t\tvec3 I;\n\t\tfloat iridescenceIOR = mix( outsideIOR, eta2, smoothstep( 0.0, 0.03, thinFilmThickness ) );\n\t\tfloat sinTheta2Sq = pow2( outsideIOR / iridescenceIOR ) * ( 1.0 - pow2( cosTheta1 ) );\n\t\tfloat cosTheta2Sq = 1.0 - sinTheta2Sq;\n\t\tif ( cosTheta2Sq < 0.0 ) {\n\t\t\t return vec3( 1.0 );\n\t\t}\n\t\tfloat cosTheta2 = sqrt( cosTheta2Sq );\n\t\tfloat R0 = IorToFresnel0( iridescenceIOR, outsideIOR );\n\t\tfloat R12 = F_Schlick( R0, 1.0, cosTheta1 );\n\t\tfloat R21 = R12;\n\t\tfloat T121 = 1.0 - R12;\n\t\tfloat phi12 = 0.0;\n\t\tif ( iridescenceIOR < outsideIOR ) phi12 = PI;\n\t\tfloat phi21 = PI - phi12;\n\t\tvec3 baseIOR = Fresnel0ToIor( clamp( baseF0, 0.0, 0.9999 ) );\t\tvec3 R1 = IorToFresnel0( baseIOR, iridescenceIOR );\n\t\tvec3 R23 = F_Schlick( R1, 1.0, cosTheta2 );\n\t\tvec3 phi23 = vec3( 0.0 );\n\t\tif ( baseIOR[ 0 ] < iridescenceIOR ) phi23[ 0 ] = PI;\n\t\tif ( baseIOR[ 1 ] < iridescenceIOR ) phi23[ 1 ] = PI;\n\t\tif ( baseIOR[ 2 ] < iridescenceIOR ) phi23[ 2 ] = PI;\n\t\tfloat OPD = 2.0 * iridescenceIOR * thinFilmThickness * cosTheta2;\n\t\tvec3 phi = vec3( phi21 ) + phi23;\n\t\tvec3 R123 = clamp( R12 * R23, 1e-5, 0.9999 );\n\t\tvec3 r123 = sqrt( R123 );\n\t\tvec3 Rs = pow2( T121 ) * R23 / ( vec3( 1.0 ) - R123 );\n\t\tvec3 C0 = R12 + Rs;\n\t\tI = C0;\n\t\tvec3 Cm = Rs - T121;\n\t\tfor ( int m = 1; m <= 2; ++ m ) {\n\t\t\tCm *= r123;\n\t\t\tvec3 Sm = 2.0 * evalSensitivity( float( m ) * OPD, float( m ) * phi );\n\t\t\tI += Cm * Sm;\n\t\t}\n\t\treturn max( I, vec3( 0.0 ) );\n\t}\n#endif",bumpmap_pars_fragment:"#ifdef USE_BUMPMAP\n\tuniform sampler2D bumpMap;\n\tuniform float bumpScale;\n\tvec2 dHdxy_fwd() {\n\t\tvec2 dSTdx = dFdx( vBumpMapUv );\n\t\tvec2 dSTdy = dFdy( vBumpMapUv );\n\t\tfloat Hll = bumpScale * texture2D( bumpMap, vBumpMapUv ).x;\n\t\tfloat dBx = bumpScale * texture2D( bumpMap, vBumpMapUv + dSTdx ).x - Hll;\n\t\tfloat dBy = bumpScale * texture2D( bumpMap, vBumpMapUv + dSTdy ).x - Hll;\n\t\treturn vec2( dBx, dBy );\n\t}\n\tvec3 perturbNormalArb( vec3 surf_pos, vec3 surf_norm, vec2 dHdxy, float faceDirection ) {\n\t\tvec3 vSigmaX = dFdx( surf_pos.xyz );\n\t\tvec3 vSigmaY = dFdy( surf_pos.xyz );\n\t\tvec3 vN = surf_norm;\n\t\tvec3 R1 = cross( vSigmaY, vN );\n\t\tvec3 R2 = cross( vN, vSigmaX );\n\t\tfloat fDet = dot( vSigmaX, R1 ) * faceDirection;\n\t\tvec3 vGrad = sign( fDet ) * ( dHdxy.x * R1 + dHdxy.y * R2 );\n\t\treturn normalize( abs( fDet ) * surf_norm - vGrad );\n\t}\n#endif",clipping_planes_fragment:"#if NUM_CLIPPING_PLANES > 0\n\tvec4 plane;\n\t#pragma unroll_loop_start\n\tfor ( int i = 0; i < UNION_CLIPPING_PLANES; i ++ ) {\n\t\tplane = clippingPlanes[ i ];\n\t\tif ( dot( vClipPosition, plane.xyz ) > plane.w ) discard;\n\t}\n\t#pragma unroll_loop_end\n\t#if UNION_CLIPPING_PLANES < NUM_CLIPPING_PLANES\n\t\tbool clipped = true;\n\t\t#pragma unroll_loop_start\n\t\tfor ( int i = UNION_CLIPPING_PLANES; i < NUM_CLIPPING_PLANES; i ++ ) {\n\t\t\tplane = clippingPlanes[ i ];\n\t\t\tclipped = ( dot( vClipPosition, plane.xyz ) > plane.w ) && clipped;\n\t\t}\n\t\t#pragma unroll_loop_end\n\t\tif ( clipped ) discard;\n\t#endif\n#endif",clipping_planes_pars_fragment:"#if NUM_CLIPPING_PLANES > 0\n\tvarying vec3 vClipPosition;\n\tuniform vec4 clippingPlanes[ NUM_CLIPPING_PLANES ];\n#endif",clipping_planes_pars_vertex:"#if NUM_CLIPPING_PLANES > 0\n\tvarying vec3 vClipPosition;\n#endif",clipping_planes_vertex:"#if NUM_CLIPPING_PLANES > 0\n\tvClipPosition = - mvPosition.xyz;\n#endif",color_fragment:"#if defined( USE_COLOR_ALPHA )\n\tdiffuseColor *= vColor;\n#elif defined( USE_COLOR )\n\tdiffuseColor.rgb *= vColor;\n#endif",color_pars_fragment:"#if defined( USE_COLOR_ALPHA )\n\tvarying vec4 vColor;\n#elif defined( USE_COLOR )\n\tvarying vec3 vColor;\n#endif",color_pars_vertex:"#if defined( USE_COLOR_ALPHA )\n\tvarying vec4 vColor;\n#elif defined( USE_COLOR ) || defined( USE_INSTANCING_COLOR )\n\tvarying vec3 vColor;\n#endif",color_vertex:"#if defined( USE_COLOR_ALPHA )\n\tvColor = vec4( 1.0 );\n#elif defined( USE_COLOR ) || defined( USE_INSTANCING_COLOR )\n\tvColor = vec3( 1.0 );\n#endif\n#ifdef USE_COLOR\n\tvColor *= color;\n#endif\n#ifdef USE_INSTANCING_COLOR\n\tvColor.xyz *= instanceColor.xyz;\n#endif",common:"#define PI 3.141592653589793\n#define PI2 6.283185307179586\n#define PI_HALF 1.5707963267948966\n#define RECIPROCAL_PI 0.3183098861837907\n#define RECIPROCAL_PI2 0.15915494309189535\n#define EPSILON 1e-6\n#ifndef saturate\n#define saturate( a ) clamp( a, 0.0, 1.0 )\n#endif\n#define whiteComplement( a ) ( 1.0 - saturate( a ) )\nfloat pow2( const in float x ) { return x*x; }\nvec3 pow2( const in vec3 x ) { return x*x; }\nfloat pow3( const in float x ) { return x*x*x; }\nfloat pow4( const in float x ) { float x2 = x*x; return x2*x2; }\nfloat max3( const in vec3 v ) { return max( max( v.x, v.y ), v.z ); }\nfloat average( const in vec3 v ) { return dot( v, vec3( 0.3333333 ) ); }\nhighp float rand( const in vec2 uv ) {\n\tconst highp float a = 12.9898, b = 78.233, c = 43758.5453;\n\thighp float dt = dot( uv.xy, vec2( a,b ) ), sn = mod( dt, PI );\n\treturn fract( sin( sn ) * c );\n}\n#ifdef HIGH_PRECISION\n\tfloat precisionSafeLength( vec3 v ) { return length( v ); }\n#else\n\tfloat precisionSafeLength( vec3 v ) {\n\t\tfloat maxComponent = max3( abs( v ) );\n\t\treturn length( v / maxComponent ) * maxComponent;\n\t}\n#endif\nstruct IncidentLight {\n\tvec3 color;\n\tvec3 direction;\n\tbool visible;\n};\nstruct ReflectedLight {\n\tvec3 directDiffuse;\n\tvec3 directSpecular;\n\tvec3 indirectDiffuse;\n\tvec3 indirectSpecular;\n};\nstruct GeometricContext {\n\tvec3 position;\n\tvec3 normal;\n\tvec3 viewDir;\n#ifdef USE_CLEARCOAT\n\tvec3 clearcoatNormal;\n#endif\n};\n#ifdef USE_ALPHAHASH\n\tvarying vec3 vPosition;\n#endif\nvec3 transformDirection( in vec3 dir, in mat4 matrix ) {\n\treturn normalize( ( matrix * vec4( dir, 0.0 ) ).xyz );\n}\nvec3 inverseTransformDirection( in vec3 dir, in mat4 matrix ) {\n\treturn normalize( ( vec4( dir, 0.0 ) * matrix ).xyz );\n}\nmat3 transposeMat3( const in mat3 m ) {\n\tmat3 tmp;\n\ttmp[ 0 ] = vec3( m[ 0 ].x, m[ 1 ].x, m[ 2 ].x );\n\ttmp[ 1 ] = vec3( m[ 0 ].y, m[ 1 ].y, m[ 2 ].y );\n\ttmp[ 2 ] = vec3( m[ 0 ].z, m[ 1 ].z, m[ 2 ].z );\n\treturn tmp;\n}\nfloat luminance( const in vec3 rgb ) {\n\tconst vec3 weights = vec3( 0.2126729, 0.7151522, 0.0721750 );\n\treturn dot( weights, rgb );\n}\nbool isPerspectiveMatrix( mat4 m ) {\n\treturn m[ 2 ][ 3 ] == - 1.0;\n}\nvec2 equirectUv( in vec3 dir ) {\n\tfloat u = atan( dir.z, dir.x ) * RECIPROCAL_PI2 + 0.5;\n\tfloat v = asin( clamp( dir.y, - 1.0, 1.0 ) ) * RECIPROCAL_PI + 0.5;\n\treturn vec2( u, v );\n}\nvec3 BRDF_Lambert( const in vec3 diffuseColor ) {\n\treturn RECIPROCAL_PI * diffuseColor;\n}\nvec3 F_Schlick( const in vec3 f0, const in float f90, const in float dotVH ) {\n\tfloat fresnel = exp2( ( - 5.55473 * dotVH - 6.98316 ) * dotVH );\n\treturn f0 * ( 1.0 - fresnel ) + ( f90 * fresnel );\n}\nfloat F_Schlick( const in float f0, const in float f90, const in float dotVH ) {\n\tfloat fresnel = exp2( ( - 5.55473 * dotVH - 6.98316 ) * dotVH );\n\treturn f0 * ( 1.0 - fresnel ) + ( f90 * fresnel );\n} // validated",cube_uv_reflection_fragment:"#ifdef ENVMAP_TYPE_CUBE_UV\n\t#define cubeUV_minMipLevel 4.0\n\t#define cubeUV_minTileSize 16.0\n\tfloat getFace( vec3 direction ) {\n\t\tvec3 absDirection = abs( direction );\n\t\tfloat face = - 1.0;\n\t\tif ( absDirection.x > absDirection.z ) {\n\t\t\tif ( absDirection.x > absDirection.y )\n\t\t\t\tface = direction.x > 0.0 ? 0.0 : 3.0;\n\t\t\telse\n\t\t\t\tface = direction.y > 0.0 ? 1.0 : 4.0;\n\t\t} else {\n\t\t\tif ( absDirection.z > absDirection.y )\n\t\t\t\tface = direction.z > 0.0 ? 2.0 : 5.0;\n\t\t\telse\n\t\t\t\tface = direction.y > 0.0 ? 1.0 : 4.0;\n\t\t}\n\t\treturn face;\n\t}\n\tvec2 getUV( vec3 direction, float face ) {\n\t\tvec2 uv;\n\t\tif ( face == 0.0 ) {\n\t\t\tuv = vec2( direction.z, direction.y ) / abs( direction.x );\n\t\t} else if ( face == 1.0 ) {\n\t\t\tuv = vec2( - direction.x, - direction.z ) / abs( direction.y );\n\t\t} else if ( face == 2.0 ) {\n\t\t\tuv = vec2( - direction.x, direction.y ) / abs( direction.z );\n\t\t} else if ( face == 3.0 ) {\n\t\t\tuv = vec2( - direction.z, direction.y ) / abs( direction.x );\n\t\t} else if ( face == 4.0 ) {\n\t\t\tuv = vec2( - direction.x, direction.z ) / abs( direction.y );\n\t\t} else {\n\t\t\tuv = vec2( direction.x, direction.y ) / abs( direction.z );\n\t\t}\n\t\treturn 0.5 * ( uv + 1.0 );\n\t}\n\tvec3 bilinearCubeUV( sampler2D envMap, vec3 direction, float mipInt ) {\n\t\tfloat face = getFace( direction );\n\t\tfloat filterInt = max( cubeUV_minMipLevel - mipInt, 0.0 );\n\t\tmipInt = max( mipInt, cubeUV_minMipLevel );\n\t\tfloat faceSize = exp2( mipInt );\n\t\thighp vec2 uv = getUV( direction, face ) * ( faceSize - 2.0 ) + 1.0;\n\t\tif ( face > 2.0 ) {\n\t\t\tuv.y += faceSize;\n\t\t\tface -= 3.0;\n\t\t}\n\t\tuv.x += face * faceSize;\n\t\tuv.x += filterInt * 3.0 * cubeUV_minTileSize;\n\t\tuv.y += 4.0 * ( exp2( CUBEUV_MAX_MIP ) - faceSize );\n\t\tuv.x *= CUBEUV_TEXEL_WIDTH;\n\t\tuv.y *= CUBEUV_TEXEL_HEIGHT;\n\t\t#ifdef texture2DGradEXT\n\t\t\treturn texture2DGradEXT( envMap, uv, vec2( 0.0 ), vec2( 0.0 ) ).rgb;\n\t\t#else\n\t\t\treturn texture2D( envMap, uv ).rgb;\n\t\t#endif\n\t}\n\t#define cubeUV_r0 1.0\n\t#define cubeUV_v0 0.339\n\t#define cubeUV_m0 - 2.0\n\t#define cubeUV_r1 0.8\n\t#define cubeUV_v1 0.276\n\t#define cubeUV_m1 - 1.0\n\t#define cubeUV_r4 0.4\n\t#define cubeUV_v4 0.046\n\t#define cubeUV_m4 2.0\n\t#define cubeUV_r5 0.305\n\t#define cubeUV_v5 0.016\n\t#define cubeUV_m5 3.0\n\t#define cubeUV_r6 0.21\n\t#define cubeUV_v6 0.0038\n\t#define cubeUV_m6 4.0\n\tfloat roughnessToMip( float roughness ) {\n\t\tfloat mip = 0.0;\n\t\tif ( roughness >= cubeUV_r1 ) {\n\t\t\tmip = ( cubeUV_r0 - roughness ) * ( cubeUV_m1 - cubeUV_m0 ) / ( cubeUV_r0 - cubeUV_r1 ) + cubeUV_m0;\n\t\t} else if ( roughness >= cubeUV_r4 ) {\n\t\t\tmip = ( cubeUV_r1 - roughness ) * ( cubeUV_m4 - cubeUV_m1 ) / ( cubeUV_r1 - cubeUV_r4 ) + cubeUV_m1;\n\t\t} else if ( roughness >= cubeUV_r5 ) {\n\t\t\tmip = ( cubeUV_r4 - roughness ) * ( cubeUV_m5 - cubeUV_m4 ) / ( cubeUV_r4 - cubeUV_r5 ) + cubeUV_m4;\n\t\t} else if ( roughness >= cubeUV_r6 ) {\n\t\t\tmip = ( cubeUV_r5 - roughness ) * ( cubeUV_m6 - cubeUV_m5 ) / ( cubeUV_r5 - cubeUV_r6 ) + cubeUV_m5;\n\t\t} else {\n\t\t\tmip = - 2.0 * log2( 1.16 * roughness );\t\t}\n\t\treturn mip;\n\t}\n\tvec4 textureCubeUV( sampler2D envMap, vec3 sampleDir, float roughness ) {\n\t\tfloat mip = clamp( roughnessToMip( roughness ), cubeUV_m0, CUBEUV_MAX_MIP );\n\t\tfloat mipF = fract( mip );\n\t\tfloat mipInt = floor( mip );\n\t\tvec3 color0 = bilinearCubeUV( envMap, sampleDir, mipInt );\n\t\tif ( mipF == 0.0 ) {\n\t\t\treturn vec4( color0, 1.0 );\n\t\t} else {\n\t\t\tvec3 color1 = bilinearCubeUV( envMap, sampleDir, mipInt + 1.0 );\n\t\t\treturn vec4( mix( color0, color1, mipF ), 1.0 );\n\t\t}\n\t}\n#endif",defaultnormal_vertex:"vec3 transformedNormal = objectNormal;\n#ifdef USE_INSTANCING\n\tmat3 m = mat3( instanceMatrix );\n\ttransformedNormal /= vec3( dot( m[ 0 ], m[ 0 ] ), dot( m[ 1 ], m[ 1 ] ), dot( m[ 2 ], m[ 2 ] ) );\n\ttransformedNormal = m * transformedNormal;\n#endif\ntransformedNormal = normalMatrix * transformedNormal;\n#ifdef FLIP_SIDED\n\ttransformedNormal = - transformedNormal;\n#endif\n#ifdef USE_TANGENT\n\tvec3 transformedTangent = ( modelViewMatrix * vec4( objectTangent, 0.0 ) ).xyz;\n\t#ifdef FLIP_SIDED\n\t\ttransformedTangent = - transformedTangent;\n\t#endif\n#endif",displacementmap_pars_vertex:"#ifdef USE_DISPLACEMENTMAP\n\tuniform sampler2D displacementMap;\n\tuniform float displacementScale;\n\tuniform float displacementBias;\n#endif",displacementmap_vertex:"#ifdef USE_DISPLACEMENTMAP\n\ttransformed += normalize( objectNormal ) * ( texture2D( displacementMap, vDisplacementMapUv ).x * displacementScale + displacementBias );\n#endif",emissivemap_fragment:"#ifdef USE_EMISSIVEMAP\n\tvec4 emissiveColor = texture2D( emissiveMap, vEmissiveMapUv );\n\ttotalEmissiveRadiance *= emissiveColor.rgb;\n#endif",emissivemap_pars_fragment:"#ifdef USE_EMISSIVEMAP\n\tuniform sampler2D emissiveMap;\n#endif",colorspace_fragment:"gl_FragColor = linearToOutputTexel( gl_FragColor );",colorspace_pars_fragment:"vec4 LinearToLinear( in vec4 value ) {\n\treturn value;\n}\nvec4 LinearTosRGB( in vec4 value ) {\n\treturn vec4( mix( pow( value.rgb, vec3( 0.41666 ) ) * 1.055 - vec3( 0.055 ), value.rgb * 12.92, vec3( lessThanEqual( value.rgb, vec3( 0.0031308 ) ) ) ), value.a );\n}",envmap_fragment:"#ifdef USE_ENVMAP\n\t#ifdef ENV_WORLDPOS\n\t\tvec3 cameraToFrag;\n\t\tif ( isOrthographic ) {\n\t\t\tcameraToFrag = normalize( vec3( - viewMatrix[ 0 ][ 2 ], - viewMatrix[ 1 ][ 2 ], - viewMatrix[ 2 ][ 2 ] ) );\n\t\t} else {\n\t\t\tcameraToFrag = normalize( vWorldPosition - cameraPosition );\n\t\t}\n\t\tvec3 worldNormal = inverseTransformDirection( normal, viewMatrix );\n\t\t#ifdef ENVMAP_MODE_REFLECTION\n\t\t\tvec3 reflectVec = reflect( cameraToFrag, worldNormal );\n\t\t#else\n\t\t\tvec3 reflectVec = refract( cameraToFrag, worldNormal, refractionRatio );\n\t\t#endif\n\t#else\n\t\tvec3 reflectVec = vReflect;\n\t#endif\n\t#ifdef ENVMAP_TYPE_CUBE\n\t\tvec4 envColor = textureCube( envMap, vec3( flipEnvMap * reflectVec.x, reflectVec.yz ) );\n\t#else\n\t\tvec4 envColor = vec4( 0.0 );\n\t#endif\n\t#ifdef ENVMAP_BLENDING_MULTIPLY\n\t\toutgoingLight = mix( outgoingLight, outgoingLight * envColor.xyz, specularStrength * reflectivity );\n\t#elif defined( ENVMAP_BLENDING_MIX )\n\t\toutgoingLight = mix( outgoingLight, envColor.xyz, specularStrength * reflectivity );\n\t#elif defined( ENVMAP_BLENDING_ADD )\n\t\toutgoingLight += envColor.xyz * specularStrength * reflectivity;\n\t#endif\n#endif",envmap_common_pars_fragment:"#ifdef USE_ENVMAP\n\tuniform float envMapIntensity;\n\tuniform float flipEnvMap;\n\t#ifdef ENVMAP_TYPE_CUBE\n\t\tuniform samplerCube envMap;\n\t#else\n\t\tuniform sampler2D envMap;\n\t#endif\n\t\n#endif",envmap_pars_fragment:"#ifdef USE_ENVMAP\n\tuniform float reflectivity;\n\t#if defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( PHONG ) || defined( LAMBERT )\n\t\t#define ENV_WORLDPOS\n\t#endif\n\t#ifdef ENV_WORLDPOS\n\t\tvarying vec3 vWorldPosition;\n\t\tuniform float refractionRatio;\n\t#else\n\t\tvarying vec3 vReflect;\n\t#endif\n#endif",envmap_pars_vertex:"#ifdef USE_ENVMAP\n\t#if defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( PHONG ) || defined( LAMBERT )\n\t\t#define ENV_WORLDPOS\n\t#endif\n\t#ifdef ENV_WORLDPOS\n\t\t\n\t\tvarying vec3 vWorldPosition;\n\t#else\n\t\tvarying vec3 vReflect;\n\t\tuniform float refractionRatio;\n\t#endif\n#endif",envmap_physical_pars_fragment:"#ifdef USE_ENVMAP\n\tvec3 getIBLIrradiance( const in vec3 normal ) {\n\t\t#ifdef ENVMAP_TYPE_CUBE_UV\n\t\t\tvec3 worldNormal = inverseTransformDirection( normal, viewMatrix );\n\t\t\tvec4 envMapColor = textureCubeUV( envMap, worldNormal, 1.0 );\n\t\t\treturn PI * envMapColor.rgb * envMapIntensity;\n\t\t#else\n\t\t\treturn vec3( 0.0 );\n\t\t#endif\n\t}\n\tvec3 getIBLRadiance( const in vec3 viewDir, const in vec3 normal, const in float roughness ) {\n\t\t#ifdef ENVMAP_TYPE_CUBE_UV\n\t\t\tvec3 reflectVec = reflect( - viewDir, normal );\n\t\t\treflectVec = normalize( mix( reflectVec, normal, roughness * roughness) );\n\t\t\treflectVec = inverseTransformDirection( reflectVec, viewMatrix );\n\t\t\tvec4 envMapColor = textureCubeUV( envMap, reflectVec, roughness );\n\t\t\treturn envMapColor.rgb * envMapIntensity;\n\t\t#else\n\t\t\treturn vec3( 0.0 );\n\t\t#endif\n\t}\n\t#ifdef USE_ANISOTROPY\n\t\tvec3 getIBLAnisotropyRadiance( const in vec3 viewDir, const in vec3 normal, const in float roughness, const in vec3 bitangent, const in float anisotropy ) {\n\t\t\t#ifdef ENVMAP_TYPE_CUBE_UV\n\t\t\t\tvec3 bentNormal = cross( bitangent, viewDir );\n\t\t\t\tbentNormal = normalize( cross( bentNormal, bitangent ) );\n\t\t\t\tbentNormal = normalize( mix( bentNormal, normal, pow2( pow2( 1.0 - anisotropy * ( 1.0 - roughness ) ) ) ) );\n\t\t\t\treturn getIBLRadiance( viewDir, bentNormal, roughness );\n\t\t\t#else\n\t\t\t\treturn vec3( 0.0 );\n\t\t\t#endif\n\t\t}\n\t#endif\n#endif",envmap_vertex:"#ifdef USE_ENVMAP\n\t#ifdef ENV_WORLDPOS\n\t\tvWorldPosition = worldPosition.xyz;\n\t#else\n\t\tvec3 cameraToVertex;\n\t\tif ( isOrthographic ) {\n\t\t\tcameraToVertex = normalize( vec3( - viewMatrix[ 0 ][ 2 ], - viewMatrix[ 1 ][ 2 ], - viewMatrix[ 2 ][ 2 ] ) );\n\t\t} else {\n\t\t\tcameraToVertex = normalize( worldPosition.xyz - cameraPosition );\n\t\t}\n\t\tvec3 worldNormal = inverseTransformDirection( transformedNormal, viewMatrix );\n\t\t#ifdef ENVMAP_MODE_REFLECTION\n\t\t\tvReflect = reflect( cameraToVertex, worldNormal );\n\t\t#else\n\t\t\tvReflect = refract( cameraToVertex, worldNormal, refractionRatio );\n\t\t#endif\n\t#endif\n#endif",fog_vertex:"#ifdef USE_FOG\n\tvFogDepth = - mvPosition.z;\n#endif",fog_pars_vertex:"#ifdef USE_FOG\n\tvarying float vFogDepth;\n#endif",fog_fragment:"#ifdef USE_FOG\n\t#ifdef FOG_EXP2\n\t\tfloat fogFactor = 1.0 - exp( - fogDensity * fogDensity * vFogDepth * vFogDepth );\n\t#else\n\t\tfloat fogFactor = smoothstep( fogNear, fogFar, vFogDepth );\n\t#endif\n\tgl_FragColor.rgb = mix( gl_FragColor.rgb, fogColor, fogFactor );\n#endif",fog_pars_fragment:"#ifdef USE_FOG\n\tuniform vec3 fogColor;\n\tvarying float vFogDepth;\n\t#ifdef FOG_EXP2\n\t\tuniform float fogDensity;\n\t#else\n\t\tuniform float fogNear;\n\t\tuniform float fogFar;\n\t#endif\n#endif",gradientmap_pars_fragment:"#ifdef USE_GRADIENTMAP\n\tuniform sampler2D gradientMap;\n#endif\nvec3 getGradientIrradiance( vec3 normal, vec3 lightDirection ) {\n\tfloat dotNL = dot( normal, lightDirection );\n\tvec2 coord = vec2( dotNL * 0.5 + 0.5, 0.0 );\n\t#ifdef USE_GRADIENTMAP\n\t\treturn vec3( texture2D( gradientMap, coord ).r );\n\t#else\n\t\tvec2 fw = fwidth( coord ) * 0.5;\n\t\treturn mix( vec3( 0.7 ), vec3( 1.0 ), smoothstep( 0.7 - fw.x, 0.7 + fw.x, coord.x ) );\n\t#endif\n}",lightmap_fragment:"#ifdef USE_LIGHTMAP\n\tvec4 lightMapTexel = texture2D( lightMap, vLightMapUv );\n\tvec3 lightMapIrradiance = lightMapTexel.rgb * lightMapIntensity;\n\treflectedLight.indirectDiffuse += lightMapIrradiance;\n#endif",lightmap_pars_fragment:"#ifdef USE_LIGHTMAP\n\tuniform sampler2D lightMap;\n\tuniform float lightMapIntensity;\n#endif",lights_lambert_fragment:"LambertMaterial material;\nmaterial.diffuseColor = diffuseColor.rgb;\nmaterial.specularStrength = specularStrength;",lights_lambert_pars_fragment:"varying vec3 vViewPosition;\nstruct LambertMaterial {\n\tvec3 diffuseColor;\n\tfloat specularStrength;\n};\nvoid RE_Direct_Lambert( const in IncidentLight directLight, const in GeometricContext geometry, const in LambertMaterial material, inout ReflectedLight reflectedLight ) {\n\tfloat dotNL = saturate( dot( geometry.normal, directLight.direction ) );\n\tvec3 irradiance = dotNL * directLight.color;\n\treflectedLight.directDiffuse += irradiance * BRDF_Lambert( material.diffuseColor );\n}\nvoid RE_IndirectDiffuse_Lambert( const in vec3 irradiance, const in GeometricContext geometry, const in LambertMaterial material, inout ReflectedLight reflectedLight ) {\n\treflectedLight.indirectDiffuse += irradiance * BRDF_Lambert( material.diffuseColor );\n}\n#define RE_Direct\t\t\t\tRE_Direct_Lambert\n#define RE_IndirectDiffuse\t\tRE_IndirectDiffuse_Lambert",lights_pars_begin:"uniform bool receiveShadow;\nuniform vec3 ambientLightColor;\nuniform vec3 lightProbe[ 9 ];\nvec3 shGetIrradianceAt( in vec3 normal, in vec3 shCoefficients[ 9 ] ) {\n\tfloat x = normal.x, y = normal.y, z = normal.z;\n\tvec3 result = shCoefficients[ 0 ] * 0.886227;\n\tresult += shCoefficients[ 1 ] * 2.0 * 0.511664 * y;\n\tresult += shCoefficients[ 2 ] * 2.0 * 0.511664 * z;\n\tresult += shCoefficients[ 3 ] * 2.0 * 0.511664 * x;\n\tresult += shCoefficients[ 4 ] * 2.0 * 0.429043 * x * y;\n\tresult += shCoefficients[ 5 ] * 2.0 * 0.429043 * y * z;\n\tresult += shCoefficients[ 6 ] * ( 0.743125 * z * z - 0.247708 );\n\tresult += shCoefficients[ 7 ] * 2.0 * 0.429043 * x * z;\n\tresult += shCoefficients[ 8 ] * 0.429043 * ( x * x - y * y );\n\treturn result;\n}\nvec3 getLightProbeIrradiance( const in vec3 lightProbe[ 9 ], const in vec3 normal ) {\n\tvec3 worldNormal = inverseTransformDirection( normal, viewMatrix );\n\tvec3 irradiance = shGetIrradianceAt( worldNormal, lightProbe );\n\treturn irradiance;\n}\nvec3 getAmbientLightIrradiance( const in vec3 ambientLightColor ) {\n\tvec3 irradiance = ambientLightColor;\n\treturn irradiance;\n}\nfloat getDistanceAttenuation( const in float lightDistance, const in float cutoffDistance, const in float decayExponent ) {\n\t#if defined ( LEGACY_LIGHTS )\n\t\tif ( cutoffDistance > 0.0 && decayExponent > 0.0 ) {\n\t\t\treturn pow( saturate( - lightDistance / cutoffDistance + 1.0 ), decayExponent );\n\t\t}\n\t\treturn 1.0;\n\t#else\n\t\tfloat distanceFalloff = 1.0 / max( pow( lightDistance, decayExponent ), 0.01 );\n\t\tif ( cutoffDistance > 0.0 ) {\n\t\t\tdistanceFalloff *= pow2( saturate( 1.0 - pow4( lightDistance / cutoffDistance ) ) );\n\t\t}\n\t\treturn distanceFalloff;\n\t#endif\n}\nfloat getSpotAttenuation( const in float coneCosine, const in float penumbraCosine, const in float angleCosine ) {\n\treturn smoothstep( coneCosine, penumbraCosine, angleCosine );\n}\n#if NUM_DIR_LIGHTS > 0\n\tstruct DirectionalLight {\n\t\tvec3 direction;\n\t\tvec3 color;\n\t};\n\tuniform DirectionalLight directionalLights[ NUM_DIR_LIGHTS ];\n\tvoid getDirectionalLightInfo( const in DirectionalLight directionalLight, const in GeometricContext geometry, out IncidentLight light ) {\n\t\tlight.color = directionalLight.color;\n\t\tlight.direction = directionalLight.direction;\n\t\tlight.visible = true;\n\t}\n#endif\n#if NUM_POINT_LIGHTS > 0\n\tstruct PointLight {\n\t\tvec3 position;\n\t\tvec3 color;\n\t\tfloat distance;\n\t\tfloat decay;\n\t};\n\tuniform PointLight pointLights[ NUM_POINT_LIGHTS ];\n\tvoid getPointLightInfo( const in PointLight pointLight, const in GeometricContext geometry, out IncidentLight light ) {\n\t\tvec3 lVector = pointLight.position - geometry.position;\n\t\tlight.direction = normalize( lVector );\n\t\tfloat lightDistance = length( lVector );\n\t\tlight.color = pointLight.color;\n\t\tlight.color *= getDistanceAttenuation( lightDistance, pointLight.distance, pointLight.decay );\n\t\tlight.visible = ( light.color != vec3( 0.0 ) );\n\t}\n#endif\n#if NUM_SPOT_LIGHTS > 0\n\tstruct SpotLight {\n\t\tvec3 position;\n\t\tvec3 direction;\n\t\tvec3 color;\n\t\tfloat distance;\n\t\tfloat decay;\n\t\tfloat coneCos;\n\t\tfloat penumbraCos;\n\t};\n\tuniform SpotLight spotLights[ NUM_SPOT_LIGHTS ];\n\tvoid getSpotLightInfo( const in SpotLight spotLight, const in GeometricContext geometry, out IncidentLight light ) {\n\t\tvec3 lVector = spotLight.position - geometry.position;\n\t\tlight.direction = normalize( lVector );\n\t\tfloat angleCos = dot( light.direction, spotLight.direction );\n\t\tfloat spotAttenuation = getSpotAttenuation( spotLight.coneCos, spotLight.penumbraCos, angleCos );\n\t\tif ( spotAttenuation > 0.0 ) {\n\t\t\tfloat lightDistance = length( lVector );\n\t\t\tlight.color = spotLight.color * spotAttenuation;\n\t\t\tlight.color *= getDistanceAttenuation( lightDistance, spotLight.distance, spotLight.decay );\n\t\t\tlight.visible = ( light.color != vec3( 0.0 ) );\n\t\t} else {\n\t\t\tlight.color = vec3( 0.0 );\n\t\t\tlight.visible = false;\n\t\t}\n\t}\n#endif\n#if NUM_RECT_AREA_LIGHTS > 0\n\tstruct RectAreaLight {\n\t\tvec3 color;\n\t\tvec3 position;\n\t\tvec3 halfWidth;\n\t\tvec3 halfHeight;\n\t};\n\tuniform sampler2D ltc_1;\tuniform sampler2D ltc_2;\n\tuniform RectAreaLight rectAreaLights[ NUM_RECT_AREA_LIGHTS ];\n#endif\n#if NUM_HEMI_LIGHTS > 0\n\tstruct HemisphereLight {\n\t\tvec3 direction;\n\t\tvec3 skyColor;\n\t\tvec3 groundColor;\n\t};\n\tuniform HemisphereLight hemisphereLights[ NUM_HEMI_LIGHTS ];\n\tvec3 getHemisphereLightIrradiance( const in HemisphereLight hemiLight, const in vec3 normal ) {\n\t\tfloat dotNL = dot( normal, hemiLight.direction );\n\t\tfloat hemiDiffuseWeight = 0.5 * dotNL + 0.5;\n\t\tvec3 irradiance = mix( hemiLight.groundColor, hemiLight.skyColor, hemiDiffuseWeight );\n\t\treturn irradiance;\n\t}\n#endif",lights_toon_fragment:"ToonMaterial material;\nmaterial.diffuseColor = diffuseColor.rgb;",lights_toon_pars_fragment:"varying vec3 vViewPosition;\nstruct ToonMaterial {\n\tvec3 diffuseColor;\n};\nvoid RE_Direct_Toon( const in IncidentLight directLight, const in GeometricContext geometry, const in ToonMaterial material, inout ReflectedLight reflectedLight ) {\n\tvec3 irradiance = getGradientIrradiance( geometry.normal, directLight.direction ) * directLight.color;\n\treflectedLight.directDiffuse += irradiance * BRDF_Lambert( material.diffuseColor );\n}\nvoid RE_IndirectDiffuse_Toon( const in vec3 irradiance, const in GeometricContext geometry, const in ToonMaterial material, inout ReflectedLight reflectedLight ) {\n\treflectedLight.indirectDiffuse += irradiance * BRDF_Lambert( material.diffuseColor );\n}\n#define RE_Direct\t\t\t\tRE_Direct_Toon\n#define RE_IndirectDiffuse\t\tRE_IndirectDiffuse_Toon",lights_phong_fragment:"BlinnPhongMaterial material;\nmaterial.diffuseColor = diffuseColor.rgb;\nmaterial.specularColor = specular;\nmaterial.specularShininess = shininess;\nmaterial.specularStrength = specularStrength;",lights_phong_pars_fragment:"varying vec3 vViewPosition;\nstruct BlinnPhongMaterial {\n\tvec3 diffuseColor;\n\tvec3 specularColor;\n\tfloat specularShininess;\n\tfloat specularStrength;\n};\nvoid RE_Direct_BlinnPhong( const in IncidentLight directLight, const in GeometricContext geometry, const in BlinnPhongMaterial material, inout ReflectedLight reflectedLight ) {\n\tfloat dotNL = saturate( dot( geometry.normal, directLight.direction ) );\n\tvec3 irradiance = dotNL * directLight.color;\n\treflectedLight.directDiffuse += irradiance * BRDF_Lambert( material.diffuseColor );\n\treflectedLight.directSpecular += irradiance * BRDF_BlinnPhong( directLight.direction, geometry.viewDir, geometry.normal, material.specularColor, material.specularShininess ) * material.specularStrength;\n}\nvoid RE_IndirectDiffuse_BlinnPhong( const in vec3 irradiance, const in GeometricContext geometry, const in BlinnPhongMaterial material, inout ReflectedLight reflectedLight ) {\n\treflectedLight.indirectDiffuse += irradiance * BRDF_Lambert( material.diffuseColor );\n}\n#define RE_Direct\t\t\t\tRE_Direct_BlinnPhong\n#define RE_IndirectDiffuse\t\tRE_IndirectDiffuse_BlinnPhong",lights_physical_fragment:"PhysicalMaterial material;\nmaterial.diffuseColor = diffuseColor.rgb * ( 1.0 - metalnessFactor );\nvec3 dxy = max( abs( dFdx( geometryNormal ) ), abs( dFdy( geometryNormal ) ) );\nfloat geometryRoughness = max( max( dxy.x, dxy.y ), dxy.z );\nmaterial.roughness = max( roughnessFactor, 0.0525 );material.roughness += geometryRoughness;\nmaterial.roughness = min( material.roughness, 1.0 );\n#ifdef IOR\n\tmaterial.ior = ior;\n\t#ifdef USE_SPECULAR\n\t\tfloat specularIntensityFactor = specularIntensity;\n\t\tvec3 specularColorFactor = specularColor;\n\t\t#ifdef USE_SPECULAR_COLORMAP\n\t\t\tspecularColorFactor *= texture2D( specularColorMap, vSpecularColorMapUv ).rgb;\n\t\t#endif\n\t\t#ifdef USE_SPECULAR_INTENSITYMAP\n\t\t\tspecularIntensityFactor *= texture2D( specularIntensityMap, vSpecularIntensityMapUv ).a;\n\t\t#endif\n\t\tmaterial.specularF90 = mix( specularIntensityFactor, 1.0, metalnessFactor );\n\t#else\n\t\tfloat specularIntensityFactor = 1.0;\n\t\tvec3 specularColorFactor = vec3( 1.0 );\n\t\tmaterial.specularF90 = 1.0;\n\t#endif\n\tmaterial.specularColor = mix( min( pow2( ( material.ior - 1.0 ) / ( material.ior + 1.0 ) ) * specularColorFactor, vec3( 1.0 ) ) * specularIntensityFactor, diffuseColor.rgb, metalnessFactor );\n#else\n\tmaterial.specularColor = mix( vec3( 0.04 ), diffuseColor.rgb, metalnessFactor );\n\tmaterial.specularF90 = 1.0;\n#endif\n#ifdef USE_CLEARCOAT\n\tmaterial.clearcoat = clearcoat;\n\tmaterial.clearcoatRoughness = clearcoatRoughness;\n\tmaterial.clearcoatF0 = vec3( 0.04 );\n\tmaterial.clearcoatF90 = 1.0;\n\t#ifdef USE_CLEARCOATMAP\n\t\tmaterial.clearcoat *= texture2D( clearcoatMap, vClearcoatMapUv ).x;\n\t#endif\n\t#ifdef USE_CLEARCOAT_ROUGHNESSMAP\n\t\tmaterial.clearcoatRoughness *= texture2D( clearcoatRoughnessMap, vClearcoatRoughnessMapUv ).y;\n\t#endif\n\tmaterial.clearcoat = saturate( material.clearcoat );\tmaterial.clearcoatRoughness = max( material.clearcoatRoughness, 0.0525 );\n\tmaterial.clearcoatRoughness += geometryRoughness;\n\tmaterial.clearcoatRoughness = min( material.clearcoatRoughness, 1.0 );\n#endif\n#ifdef USE_IRIDESCENCE\n\tmaterial.iridescence = iridescence;\n\tmaterial.iridescenceIOR = iridescenceIOR;\n\t#ifdef USE_IRIDESCENCEMAP\n\t\tmaterial.iridescence *= texture2D( iridescenceMap, vIridescenceMapUv ).r;\n\t#endif\n\t#ifdef USE_IRIDESCENCE_THICKNESSMAP\n\t\tmaterial.iridescenceThickness = (iridescenceThicknessMaximum - iridescenceThicknessMinimum) * texture2D( iridescenceThicknessMap, vIridescenceThicknessMapUv ).g + iridescenceThicknessMinimum;\n\t#else\n\t\tmaterial.iridescenceThickness = iridescenceThicknessMaximum;\n\t#endif\n#endif\n#ifdef USE_SHEEN\n\tmaterial.sheenColor = sheenColor;\n\t#ifdef USE_SHEEN_COLORMAP\n\t\tmaterial.sheenColor *= texture2D( sheenColorMap, vSheenColorMapUv ).rgb;\n\t#endif\n\tmaterial.sheenRoughness = clamp( sheenRoughness, 0.07, 1.0 );\n\t#ifdef USE_SHEEN_ROUGHNESSMAP\n\t\tmaterial.sheenRoughness *= texture2D( sheenRoughnessMap, vSheenRoughnessMapUv ).a;\n\t#endif\n#endif\n#ifdef USE_ANISOTROPY\n\t#ifdef USE_ANISOTROPYMAP\n\t\tmat2 anisotropyMat = mat2( anisotropyVector.x, anisotropyVector.y, - anisotropyVector.y, anisotropyVector.x );\n\t\tvec3 anisotropyPolar = texture2D( anisotropyMap, vAnisotropyMapUv ).rgb;\n\t\tvec2 anisotropyV = anisotropyMat * normalize( 2.0 * anisotropyPolar.rg - vec2( 1.0 ) ) * anisotropyPolar.b;\n\t#else\n\t\tvec2 anisotropyV = anisotropyVector;\n\t#endif\n\tmaterial.anisotropy = length( anisotropyV );\n\tanisotropyV /= material.anisotropy;\n\tmaterial.anisotropy = saturate( material.anisotropy );\n\tmaterial.alphaT = mix( pow2( material.roughness ), 1.0, pow2( material.anisotropy ) );\n\tmaterial.anisotropyT = tbn[ 0 ] * anisotropyV.x - tbn[ 1 ] * anisotropyV.y;\n\tmaterial.anisotropyB = tbn[ 1 ] * anisotropyV.x + tbn[ 0 ] * anisotropyV.y;\n#endif",lights_physical_pars_fragment:"struct PhysicalMaterial {\n\tvec3 diffuseColor;\n\tfloat roughness;\n\tvec3 specularColor;\n\tfloat specularF90;\n\t#ifdef USE_CLEARCOAT\n\t\tfloat clearcoat;\n\t\tfloat clearcoatRoughness;\n\t\tvec3 clearcoatF0;\n\t\tfloat clearcoatF90;\n\t#endif\n\t#ifdef USE_IRIDESCENCE\n\t\tfloat iridescence;\n\t\tfloat iridescenceIOR;\n\t\tfloat iridescenceThickness;\n\t\tvec3 iridescenceFresnel;\n\t\tvec3 iridescenceF0;\n\t#endif\n\t#ifdef USE_SHEEN\n\t\tvec3 sheenColor;\n\t\tfloat sheenRoughness;\n\t#endif\n\t#ifdef IOR\n\t\tfloat ior;\n\t#endif\n\t#ifdef USE_TRANSMISSION\n\t\tfloat transmission;\n\t\tfloat transmissionAlpha;\n\t\tfloat thickness;\n\t\tfloat attenuationDistance;\n\t\tvec3 attenuationColor;\n\t#endif\n\t#ifdef USE_ANISOTROPY\n\t\tfloat anisotropy;\n\t\tfloat alphaT;\n\t\tvec3 anisotropyT;\n\t\tvec3 anisotropyB;\n\t#endif\n};\nvec3 clearcoatSpecular = vec3( 0.0 );\nvec3 sheenSpecular = vec3( 0.0 );\nvec3 Schlick_to_F0( const in vec3 f, const in float f90, const in float dotVH ) {\n    float x = clamp( 1.0 - dotVH, 0.0, 1.0 );\n    float x2 = x * x;\n    float x5 = clamp( x * x2 * x2, 0.0, 0.9999 );\n    return ( f - vec3( f90 ) * x5 ) / ( 1.0 - x5 );\n}\nfloat V_GGX_SmithCorrelated( const in float alpha, const in float dotNL, const in float dotNV ) {\n\tfloat a2 = pow2( alpha );\n\tfloat gv = dotNL * sqrt( a2 + ( 1.0 - a2 ) * pow2( dotNV ) );\n\tfloat gl = dotNV * sqrt( a2 + ( 1.0 - a2 ) * pow2( dotNL ) );\n\treturn 0.5 / max( gv + gl, EPSILON );\n}\nfloat D_GGX( const in float alpha, const in float dotNH ) {\n\tfloat a2 = pow2( alpha );\n\tfloat denom = pow2( dotNH ) * ( a2 - 1.0 ) + 1.0;\n\treturn RECIPROCAL_PI * a2 / pow2( denom );\n}\n#ifdef USE_ANISOTROPY\n\tfloat V_GGX_SmithCorrelated_Anisotropic( const in float alphaT, const in float alphaB, const in float dotTV, const in float dotBV, const in float dotTL, const in float dotBL, const in float dotNV, const in float dotNL ) {\n\t\tfloat gv = dotNL * length( vec3( alphaT * dotTV, alphaB * dotBV, dotNV ) );\n\t\tfloat gl = dotNV * length( vec3( alphaT * dotTL, alphaB * dotBL, dotNL ) );\n\t\tfloat v = 0.5 / ( gv + gl );\n\t\treturn saturate(v);\n\t}\n\tfloat D_GGX_Anisotropic( const in float alphaT, const in float alphaB, const in float dotNH, const in float dotTH, const in float dotBH ) {\n\t\tfloat a2 = alphaT * alphaB;\n\t\thighp vec3 v = vec3( alphaB * dotTH, alphaT * dotBH, a2 * dotNH );\n\t\thighp float v2 = dot( v, v );\n\t\tfloat w2 = a2 / v2;\n\t\treturn RECIPROCAL_PI * a2 * pow2 ( w2 );\n\t}\n#endif\n#ifdef USE_CLEARCOAT\n\tvec3 BRDF_GGX_Clearcoat( const in vec3 lightDir, const in vec3 viewDir, const in vec3 normal, const in PhysicalMaterial material) {\n\t\tvec3 f0 = material.clearcoatF0;\n\t\tfloat f90 = material.clearcoatF90;\n\t\tfloat roughness = material.clearcoatRoughness;\n\t\tfloat alpha = pow2( roughness );\n\t\tvec3 halfDir = normalize( lightDir + viewDir );\n\t\tfloat dotNL = saturate( dot( normal, lightDir ) );\n\t\tfloat dotNV = saturate( dot( normal, viewDir ) );\n\t\tfloat dotNH = saturate( dot( normal, halfDir ) );\n\t\tfloat dotVH = saturate( dot( viewDir, halfDir ) );\n\t\tvec3 F = F_Schlick( f0, f90, dotVH );\n\t\tfloat V = V_GGX_SmithCorrelated( alpha, dotNL, dotNV );\n\t\tfloat D = D_GGX( alpha, dotNH );\n\t\treturn F * ( V * D );\n\t}\n#endif\nvec3 BRDF_GGX( const in vec3 lightDir, const in vec3 viewDir, const in vec3 normal, const in PhysicalMaterial material ) {\n\tvec3 f0 = material.specularColor;\n\tfloat f90 = material.specularF90;\n\tfloat roughness = material.roughness;\n\tfloat alpha = pow2( roughness );\n\tvec3 halfDir = normalize( lightDir + viewDir );\n\tfloat dotNL = saturate( dot( normal, lightDir ) );\n\tfloat dotNV = saturate( dot( normal, viewDir ) );\n\tfloat dotNH = saturate( dot( normal, halfDir ) );\n\tfloat dotVH = saturate( dot( viewDir, halfDir ) );\n\tvec3 F = F_Schlick( f0, f90, dotVH );\n\t#ifdef USE_IRIDESCENCE\n\t\tF = mix( F, material.iridescenceFresnel, material.iridescence );\n\t#endif\n\t#ifdef USE_ANISOTROPY\n\t\tfloat dotTL = dot( material.anisotropyT, lightDir );\n\t\tfloat dotTV = dot( material.anisotropyT, viewDir );\n\t\tfloat dotTH = dot( material.anisotropyT, halfDir );\n\t\tfloat dotBL = dot( material.anisotropyB, lightDir );\n\t\tfloat dotBV = dot( material.anisotropyB, viewDir );\n\t\tfloat dotBH = dot( material.anisotropyB, halfDir );\n\t\tfloat V = V_GGX_SmithCorrelated_Anisotropic( material.alphaT, alpha, dotTV, dotBV, dotTL, dotBL, dotNV, dotNL );\n\t\tfloat D = D_GGX_Anisotropic( material.alphaT, alpha, dotNH, dotTH, dotBH );\n\t#else\n\t\tfloat V = V_GGX_SmithCorrelated( alpha, dotNL, dotNV );\n\t\tfloat D = D_GGX( alpha, dotNH );\n\t#endif\n\treturn F * ( V * D );\n}\nvec2 LTC_Uv( const in vec3 N, const in vec3 V, const in float roughness ) {\n\tconst float LUT_SIZE = 64.0;\n\tconst float LUT_SCALE = ( LUT_SIZE - 1.0 ) / LUT_SIZE;\n\tconst float LUT_BIAS = 0.5 / LUT_SIZE;\n\tfloat dotNV = saturate( dot( N, V ) );\n\tvec2 uv = vec2( roughness, sqrt( 1.0 - dotNV ) );\n\tuv = uv * LUT_SCALE + LUT_BIAS;\n\treturn uv;\n}\nfloat LTC_ClippedSphereFormFactor( const in vec3 f ) {\n\tfloat l = length( f );\n\treturn max( ( l * l + f.z ) / ( l + 1.0 ), 0.0 );\n}\nvec3 LTC_EdgeVectorFormFactor( const in vec3 v1, const in vec3 v2 ) {\n\tfloat x = dot( v1, v2 );\n\tfloat y = abs( x );\n\tfloat a = 0.8543985 + ( 0.4965155 + 0.0145206 * y ) * y;\n\tfloat b = 3.4175940 + ( 4.1616724 + y ) * y;\n\tfloat v = a / b;\n\tfloat theta_sintheta = ( x > 0.0 ) ? v : 0.5 * inversesqrt( max( 1.0 - x * x, 1e-7 ) ) - v;\n\treturn cross( v1, v2 ) * theta_sintheta;\n}\nvec3 LTC_Evaluate( const in vec3 N, const in vec3 V, const in vec3 P, const in mat3 mInv, const in vec3 rectCoords[ 4 ] ) {\n\tvec3 v1 = rectCoords[ 1 ] - rectCoords[ 0 ];\n\tvec3 v2 = rectCoords[ 3 ] - rectCoords[ 0 ];\n\tvec3 lightNormal = cross( v1, v2 );\n\tif( dot( lightNormal, P - rectCoords[ 0 ] ) < 0.0 ) return vec3( 0.0 );\n\tvec3 T1, T2;\n\tT1 = normalize( V - N * dot( V, N ) );\n\tT2 = - cross( N, T1 );\n\tmat3 mat = mInv * transposeMat3( mat3( T1, T2, N ) );\n\tvec3 coords[ 4 ];\n\tcoords[ 0 ] = mat * ( rectCoords[ 0 ] - P );\n\tcoords[ 1 ] = mat * ( rectCoords[ 1 ] - P );\n\tcoords[ 2 ] = mat * ( rectCoords[ 2 ] - P );\n\tcoords[ 3 ] = mat * ( rectCoords[ 3 ] - P );\n\tcoords[ 0 ] = normalize( coords[ 0 ] );\n\tcoords[ 1 ] = normalize( coords[ 1 ] );\n\tcoords[ 2 ] = normalize( coords[ 2 ] );\n\tcoords[ 3 ] = normalize( coords[ 3 ] );\n\tvec3 vectorFormFactor = vec3( 0.0 );\n\tvectorFormFactor += LTC_EdgeVectorFormFactor( coords[ 0 ], coords[ 1 ] );\n\tvectorFormFactor += LTC_EdgeVectorFormFactor( coords[ 1 ], coords[ 2 ] );\n\tvectorFormFactor += LTC_EdgeVectorFormFactor( coords[ 2 ], coords[ 3 ] );\n\tvectorFormFactor += LTC_EdgeVectorFormFactor( coords[ 3 ], coords[ 0 ] );\n\tfloat result = LTC_ClippedSphereFormFactor( vectorFormFactor );\n\treturn vec3( result );\n}\n#if defined( USE_SHEEN )\nfloat D_Charlie( float roughness, float dotNH ) {\n\tfloat alpha = pow2( roughness );\n\tfloat invAlpha = 1.0 / alpha;\n\tfloat cos2h = dotNH * dotNH;\n\tfloat sin2h = max( 1.0 - cos2h, 0.0078125 );\n\treturn ( 2.0 + invAlpha ) * pow( sin2h, invAlpha * 0.5 ) / ( 2.0 * PI );\n}\nfloat V_Neubelt( float dotNV, float dotNL ) {\n\treturn saturate( 1.0 / ( 4.0 * ( dotNL + dotNV - dotNL * dotNV ) ) );\n}\nvec3 BRDF_Sheen( const in vec3 lightDir, const in vec3 viewDir, const in vec3 normal, vec3 sheenColor, const in float sheenRoughness ) {\n\tvec3 halfDir = normalize( lightDir + viewDir );\n\tfloat dotNL = saturate( dot( normal, lightDir ) );\n\tfloat dotNV = saturate( dot( normal, viewDir ) );\n\tfloat dotNH = saturate( dot( normal, halfDir ) );\n\tfloat D = D_Charlie( sheenRoughness, dotNH );\n\tfloat V = V_Neubelt( dotNV, dotNL );\n\treturn sheenColor * ( D * V );\n}\n#endif\nfloat IBLSheenBRDF( const in vec3 normal, const in vec3 viewDir, const in float roughness ) {\n\tfloat dotNV = saturate( dot( normal, viewDir ) );\n\tfloat r2 = roughness * roughness;\n\tfloat a = roughness < 0.25 ? -339.2 * r2 + 161.4 * roughness - 25.9 : -8.48 * r2 + 14.3 * roughness - 9.95;\n\tfloat b = roughness < 0.25 ? 44.0 * r2 - 23.7 * roughness + 3.26 : 1.97 * r2 - 3.27 * roughness + 0.72;\n\tfloat DG = exp( a * dotNV + b ) + ( roughness < 0.25 ? 0.0 : 0.1 * ( roughness - 0.25 ) );\n\treturn saturate( DG * RECIPROCAL_PI );\n}\nvec2 DFGApprox( const in vec3 normal, const in vec3 viewDir, const in float roughness ) {\n\tfloat dotNV = saturate( dot( normal, viewDir ) );\n\tconst vec4 c0 = vec4( - 1, - 0.0275, - 0.572, 0.022 );\n\tconst vec4 c1 = vec4( 1, 0.0425, 1.04, - 0.04 );\n\tvec4 r = roughness * c0 + c1;\n\tfloat a004 = min( r.x * r.x, exp2( - 9.28 * dotNV ) ) * r.x + r.y;\n\tvec2 fab = vec2( - 1.04, 1.04 ) * a004 + r.zw;\n\treturn fab;\n}\nvec3 EnvironmentBRDF( const in vec3 normal, const in vec3 viewDir, const in vec3 specularColor, const in float specularF90, const in float roughness ) {\n\tvec2 fab = DFGApprox( normal, viewDir, roughness );\n\treturn specularColor * fab.x + specularF90 * fab.y;\n}\n#ifdef USE_IRIDESCENCE\nvoid computeMultiscatteringIridescence( const in vec3 normal, const in vec3 viewDir, const in vec3 specularColor, const in float specularF90, const in float iridescence, const in vec3 iridescenceF0, const in float roughness, inout vec3 singleScatter, inout vec3 multiScatter ) {\n#else\nvoid computeMultiscattering( const in vec3 normal, const in vec3 viewDir, const in vec3 specularColor, const in float specularF90, const in float roughness, inout vec3 singleScatter, inout vec3 multiScatter ) {\n#endif\n\tvec2 fab = DFGApprox( normal, viewDir, roughness );\n\t#ifdef USE_IRIDESCENCE\n\t\tvec3 Fr = mix( specularColor, iridescenceF0, iridescence );\n\t#else\n\t\tvec3 Fr = specularColor;\n\t#endif\n\tvec3 FssEss = Fr * fab.x + specularF90 * fab.y;\n\tfloat Ess = fab.x + fab.y;\n\tfloat Ems = 1.0 - Ess;\n\tvec3 Favg = Fr + ( 1.0 - Fr ) * 0.047619;\tvec3 Fms = FssEss * Favg / ( 1.0 - Ems * Favg );\n\tsingleScatter += FssEss;\n\tmultiScatter += Fms * Ems;\n}\n#if NUM_RECT_AREA_LIGHTS > 0\n\tvoid RE_Direct_RectArea_Physical( const in RectAreaLight rectAreaLight, const in GeometricContext geometry, const in PhysicalMaterial material, inout ReflectedLight reflectedLight ) {\n\t\tvec3 normal = geometry.normal;\n\t\tvec3 viewDir = geometry.viewDir;\n\t\tvec3 position = geometry.position;\n\t\tvec3 lightPos = rectAreaLight.position;\n\t\tvec3 halfWidth = rectAreaLight.halfWidth;\n\t\tvec3 halfHeight = rectAreaLight.halfHeight;\n\t\tvec3 lightColor = rectAreaLight.color;\n\t\tfloat roughness = material.roughness;\n\t\tvec3 rectCoords[ 4 ];\n\t\trectCoords[ 0 ] = lightPos + halfWidth - halfHeight;\t\trectCoords[ 1 ] = lightPos - halfWidth - halfHeight;\n\t\trectCoords[ 2 ] = lightPos - halfWidth + halfHeight;\n\t\trectCoords[ 3 ] = lightPos + halfWidth + halfHeight;\n\t\tvec2 uv = LTC_Uv( normal, viewDir, roughness );\n\t\tvec4 t1 = texture2D( ltc_1, uv );\n\t\tvec4 t2 = texture2D( ltc_2, uv );\n\t\tmat3 mInv = mat3(\n\t\t\tvec3( t1.x, 0, t1.y ),\n\t\t\tvec3(    0, 1,    0 ),\n\t\t\tvec3( t1.z, 0, t1.w )\n\t\t);\n\t\tvec3 fresnel = ( material.specularColor * t2.x + ( vec3( 1.0 ) - material.specularColor ) * t2.y );\n\t\treflectedLight.directSpecular += lightColor * fresnel * LTC_Evaluate( normal, viewDir, position, mInv, rectCoords );\n\t\treflectedLight.directDiffuse += lightColor * material.diffuseColor * LTC_Evaluate( normal, viewDir, position, mat3( 1.0 ), rectCoords );\n\t}\n#endif\nvoid RE_Direct_Physical( const in IncidentLight directLight, const in GeometricContext geometry, const in PhysicalMaterial material, inout ReflectedLight reflectedLight ) {\n\tfloat dotNL = saturate( dot( geometry.normal, directLight.direction ) );\n\tvec3 irradiance = dotNL * directLight.color;\n\t#ifdef USE_CLEARCOAT\n\t\tfloat dotNLcc = saturate( dot( geometry.clearcoatNormal, directLight.direction ) );\n\t\tvec3 ccIrradiance = dotNLcc * directLight.color;\n\t\tclearcoatSpecular += ccIrradiance * BRDF_GGX_Clearcoat( directLight.direction, geometry.viewDir, geometry.clearcoatNormal, material );\n\t#endif\n\t#ifdef USE_SHEEN\n\t\tsheenSpecular += irradiance * BRDF_Sheen( directLight.direction, geometry.viewDir, geometry.normal, material.sheenColor, material.sheenRoughness );\n\t#endif\n\treflectedLight.directSpecular += irradiance * BRDF_GGX( directLight.direction, geometry.viewDir, geometry.normal, material );\n\treflectedLight.directDiffuse += irradiance * BRDF_Lambert( material.diffuseColor );\n}\nvoid RE_IndirectDiffuse_Physical( const in vec3 irradiance, const in GeometricContext geometry, const in PhysicalMaterial material, inout ReflectedLight reflectedLight ) {\n\treflectedLight.indirectDiffuse += irradiance * BRDF_Lambert( material.diffuseColor );\n}\nvoid RE_IndirectSpecular_Physical( const in vec3 radiance, const in vec3 irradiance, const in vec3 clearcoatRadiance, const in GeometricContext geometry, const in PhysicalMaterial material, inout ReflectedLight reflectedLight) {\n\t#ifdef USE_CLEARCOAT\n\t\tclearcoatSpecular += clearcoatRadiance * EnvironmentBRDF( geometry.clearcoatNormal, geometry.viewDir, material.clearcoatF0, material.clearcoatF90, material.clearcoatRoughness );\n\t#endif\n\t#ifdef USE_SHEEN\n\t\tsheenSpecular += irradiance * material.sheenColor * IBLSheenBRDF( geometry.normal, geometry.viewDir, material.sheenRoughness );\n\t#endif\n\tvec3 singleScattering = vec3( 0.0 );\n\tvec3 multiScattering = vec3( 0.0 );\n\tvec3 cosineWeightedIrradiance = irradiance * RECIPROCAL_PI;\n\t#ifdef USE_IRIDESCENCE\n\t\tcomputeMultiscatteringIridescence( geometry.normal, geometry.viewDir, material.specularColor, material.specularF90, material.iridescence, material.iridescenceFresnel, material.roughness, singleScattering, multiScattering );\n\t#else\n\t\tcomputeMultiscattering( geometry.normal, geometry.viewDir, material.specularColor, material.specularF90, material.roughness, singleScattering, multiScattering );\n\t#endif\n\tvec3 totalScattering = singleScattering + multiScattering;\n\tvec3 diffuse = material.diffuseColor * ( 1.0 - max( max( totalScattering.r, totalScattering.g ), totalScattering.b ) );\n\treflectedLight.indirectSpecular += radiance * singleScattering;\n\treflectedLight.indirectSpecular += multiScattering * cosineWeightedIrradiance;\n\treflectedLight.indirectDiffuse += diffuse * cosineWeightedIrradiance;\n}\n#define RE_Direct\t\t\t\tRE_Direct_Physical\n#define RE_Direct_RectArea\t\tRE_Direct_RectArea_Physical\n#define RE_IndirectDiffuse\t\tRE_IndirectDiffuse_Physical\n#define RE_IndirectSpecular\t\tRE_IndirectSpecular_Physical\nfloat computeSpecularOcclusion( const in float dotNV, const in float ambientOcclusion, const in float roughness ) {\n\treturn saturate( pow( dotNV + ambientOcclusion, exp2( - 16.0 * roughness - 1.0 ) ) - 1.0 + ambientOcclusion );\n}",lights_fragment_begin:"\nGeometricContext geometry;\ngeometry.position = - vViewPosition;\ngeometry.normal = normal;\ngeometry.viewDir = ( isOrthographic ) ? vec3( 0, 0, 1 ) : normalize( vViewPosition );\n#ifdef USE_CLEARCOAT\n\tgeometry.clearcoatNormal = clearcoatNormal;\n#endif\n#ifdef USE_IRIDESCENCE\n\tfloat dotNVi = saturate( dot( normal, geometry.viewDir ) );\n\tif ( material.iridescenceThickness == 0.0 ) {\n\t\tmaterial.iridescence = 0.0;\n\t} else {\n\t\tmaterial.iridescence = saturate( material.iridescence );\n\t}\n\tif ( material.iridescence > 0.0 ) {\n\t\tmaterial.iridescenceFresnel = evalIridescence( 1.0, material.iridescenceIOR, dotNVi, material.iridescenceThickness, material.specularColor );\n\t\tmaterial.iridescenceF0 = Schlick_to_F0( material.iridescenceFresnel, 1.0, dotNVi );\n\t}\n#endif\nIncidentLight directLight;\n#if ( NUM_POINT_LIGHTS > 0 ) && defined( RE_Direct )\n\tPointLight pointLight;\n\t#if defined( USE_SHADOWMAP ) && NUM_POINT_LIGHT_SHADOWS > 0\n\tPointLightShadow pointLightShadow;\n\t#endif\n\t#pragma unroll_loop_start\n\tfor ( int i = 0; i < NUM_POINT_LIGHTS; i ++ ) {\n\t\tpointLight = pointLights[ i ];\n\t\tgetPointLightInfo( pointLight, geometry, directLight );\n\t\t#if defined( USE_SHADOWMAP ) && ( UNROLLED_LOOP_INDEX < NUM_POINT_LIGHT_SHADOWS )\n\t\tpointLightShadow = pointLightShadows[ i ];\n\t\tdirectLight.color *= ( directLight.visible && receiveShadow ) ? getPointShadow( pointShadowMap[ i ], pointLightShadow.shadowMapSize, pointLightShadow.shadowBias, pointLightShadow.shadowRadius, vPointShadowCoord[ i ], pointLightShadow.shadowCameraNear, pointLightShadow.shadowCameraFar ) : 1.0;\n\t\t#endif\n\t\tRE_Direct( directLight, geometry, material, reflectedLight );\n\t}\n\t#pragma unroll_loop_end\n#endif\n#if ( NUM_SPOT_LIGHTS > 0 ) && defined( RE_Direct )\n\tSpotLight spotLight;\n\tvec4 spotColor;\n\tvec3 spotLightCoord;\n\tbool inSpotLightMap;\n\t#if defined( USE_SHADOWMAP ) && NUM_SPOT_LIGHT_SHADOWS > 0\n\tSpotLightShadow spotLightShadow;\n\t#endif\n\t#pragma unroll_loop_start\n\tfor ( int i = 0; i < NUM_SPOT_LIGHTS; i ++ ) {\n\t\tspotLight = spotLights[ i ];\n\t\tgetSpotLightInfo( spotLight, geometry, directLight );\n\t\t#if ( UNROLLED_LOOP_INDEX < NUM_SPOT_LIGHT_SHADOWS_WITH_MAPS )\n\t\t#define SPOT_LIGHT_MAP_INDEX UNROLLED_LOOP_INDEX\n\t\t#elif ( UNROLLED_LOOP_INDEX < NUM_SPOT_LIGHT_SHADOWS )\n\t\t#define SPOT_LIGHT_MAP_INDEX NUM_SPOT_LIGHT_MAPS\n\t\t#else\n\t\t#define SPOT_LIGHT_MAP_INDEX ( UNROLLED_LOOP_INDEX - NUM_SPOT_LIGHT_SHADOWS + NUM_SPOT_LIGHT_SHADOWS_WITH_MAPS )\n\t\t#endif\n\t\t#if ( SPOT_LIGHT_MAP_INDEX < NUM_SPOT_LIGHT_MAPS )\n\t\t\tspotLightCoord = vSpotLightCoord[ i ].xyz / vSpotLightCoord[ i ].w;\n\t\t\tinSpotLightMap = all( lessThan( abs( spotLightCoord * 2. - 1. ), vec3( 1.0 ) ) );\n\t\t\tspotColor = texture2D( spotLightMap[ SPOT_LIGHT_MAP_INDEX ], spotLightCoord.xy );\n\t\t\tdirectLight.color = inSpotLightMap ? directLight.color * spotColor.rgb : directLight.color;\n\t\t#endif\n\t\t#undef SPOT_LIGHT_MAP_INDEX\n\t\t#if defined( USE_SHADOWMAP ) && ( UNROLLED_LOOP_INDEX < NUM_SPOT_LIGHT_SHADOWS )\n\t\tspotLightShadow = spotLightShadows[ i ];\n\t\tdirectLight.color *= ( directLight.visible && receiveShadow ) ? getShadow( spotShadowMap[ i ], spotLightShadow.shadowMapSize, spotLightShadow.shadowBias, spotLightShadow.shadowRadius, vSpotLightCoord[ i ] ) : 1.0;\n\t\t#endif\n\t\tRE_Direct( directLight, geometry, material, reflectedLight );\n\t}\n\t#pragma unroll_loop_end\n#endif\n#if ( NUM_DIR_LIGHTS > 0 ) && defined( RE_Direct )\n\tDirectionalLight directionalLight;\n\t#if defined( USE_SHADOWMAP ) && NUM_DIR_LIGHT_SHADOWS > 0\n\tDirectionalLightShadow directionalLightShadow;\n\t#endif\n\t#pragma unroll_loop_start\n\tfor ( int i = 0; i < NUM_DIR_LIGHTS; i ++ ) {\n\t\tdirectionalLight = directionalLights[ i ];\n\t\tgetDirectionalLightInfo( directionalLight, geometry, directLight );\n\t\t#if defined( USE_SHADOWMAP ) && ( UNROLLED_LOOP_INDEX < NUM_DIR_LIGHT_SHADOWS )\n\t\tdirectionalLightShadow = directionalLightShadows[ i ];\n\t\tdirectLight.color *= ( directLight.visible && receiveShadow ) ? getShadow( directionalShadowMap[ i ], directionalLightShadow.shadowMapSize, directionalLightShadow.shadowBias, directionalLightShadow.shadowRadius, vDirectionalShadowCoord[ i ] ) : 1.0;\n\t\t#endif\n\t\tRE_Direct( directLight, geometry, material, reflectedLight );\n\t}\n\t#pragma unroll_loop_end\n#endif\n#if ( NUM_RECT_AREA_LIGHTS > 0 ) && defined( RE_Direct_RectArea )\n\tRectAreaLight rectAreaLight;\n\t#pragma unroll_loop_start\n\tfor ( int i = 0; i < NUM_RECT_AREA_LIGHTS; i ++ ) {\n\t\trectAreaLight = rectAreaLights[ i ];\n\t\tRE_Direct_RectArea( rectAreaLight, geometry, material, reflectedLight );\n\t}\n\t#pragma unroll_loop_end\n#endif\n#if defined( RE_IndirectDiffuse )\n\tvec3 iblIrradiance = vec3( 0.0 );\n\tvec3 irradiance = getAmbientLightIrradiance( ambientLightColor );\n\tirradiance += getLightProbeIrradiance( lightProbe, geometry.normal );\n\t#if ( NUM_HEMI_LIGHTS > 0 )\n\t\t#pragma unroll_loop_start\n\t\tfor ( int i = 0; i < NUM_HEMI_LIGHTS; i ++ ) {\n\t\t\tirradiance += getHemisphereLightIrradiance( hemisphereLights[ i ], geometry.normal );\n\t\t}\n\t\t#pragma unroll_loop_end\n\t#endif\n#endif\n#if defined( RE_IndirectSpecular )\n\tvec3 radiance = vec3( 0.0 );\n\tvec3 clearcoatRadiance = vec3( 0.0 );\n#endif",lights_fragment_maps:"#if defined( RE_IndirectDiffuse )\n\t#ifdef USE_LIGHTMAP\n\t\tvec4 lightMapTexel = texture2D( lightMap, vLightMapUv );\n\t\tvec3 lightMapIrradiance = lightMapTexel.rgb * lightMapIntensity;\n\t\tirradiance += lightMapIrradiance;\n\t#endif\n\t#if defined( USE_ENVMAP ) && defined( STANDARD ) && defined( ENVMAP_TYPE_CUBE_UV )\n\t\tiblIrradiance += getIBLIrradiance( geometry.normal );\n\t#endif\n#endif\n#if defined( USE_ENVMAP ) && defined( RE_IndirectSpecular )\n\t#ifdef USE_ANISOTROPY\n\t\tradiance += getIBLAnisotropyRadiance( geometry.viewDir, geometry.normal, material.roughness, material.anisotropyB, material.anisotropy );\n\t#else\n\t\tradiance += getIBLRadiance( geometry.viewDir, geometry.normal, material.roughness );\n\t#endif\n\t#ifdef USE_CLEARCOAT\n\t\tclearcoatRadiance += getIBLRadiance( geometry.viewDir, geometry.clearcoatNormal, material.clearcoatRoughness );\n\t#endif\n#endif",lights_fragment_end:"#if defined( RE_IndirectDiffuse )\n\tRE_IndirectDiffuse( irradiance, geometry, material, reflectedLight );\n#endif\n#if defined( RE_IndirectSpecular )\n\tRE_IndirectSpecular( radiance, iblIrradiance, clearcoatRadiance, geometry, material, reflectedLight );\n#endif",logdepthbuf_fragment:"#if defined( USE_LOGDEPTHBUF ) && defined( USE_LOGDEPTHBUF_EXT )\n\tgl_FragDepthEXT = vIsPerspective == 0.0 ? gl_FragCoord.z : log2( vFragDepth ) * logDepthBufFC * 0.5;\n#endif",logdepthbuf_pars_fragment:"#if defined( USE_LOGDEPTHBUF ) && defined( USE_LOGDEPTHBUF_EXT )\n\tuniform float logDepthBufFC;\n\tvarying float vFragDepth;\n\tvarying float vIsPerspective;\n#endif",logdepthbuf_pars_vertex:"#ifdef USE_LOGDEPTHBUF\n\t#ifdef USE_LOGDEPTHBUF_EXT\n\t\tvarying float vFragDepth;\n\t\tvarying float vIsPerspective;\n\t#else\n\t\tuniform float logDepthBufFC;\n\t#endif\n#endif",logdepthbuf_vertex:"#ifdef USE_LOGDEPTHBUF\n\t#ifdef USE_LOGDEPTHBUF_EXT\n\t\tvFragDepth = 1.0 + gl_Position.w;\n\t\tvIsPerspective = float( isPerspectiveMatrix( projectionMatrix ) );\n\t#else\n\t\tif ( isPerspectiveMatrix( projectionMatrix ) ) {\n\t\t\tgl_Position.z = log2( max( EPSILON, gl_Position.w + 1.0 ) ) * logDepthBufFC - 1.0;\n\t\t\tgl_Position.z *= gl_Position.w;\n\t\t}\n\t#endif\n#endif",map_fragment:"#ifdef USE_MAP\n\tdiffuseColor *= texture2D( map, vMapUv );\n#endif",map_pars_fragment:"#ifdef USE_MAP\n\tuniform sampler2D map;\n#endif",map_particle_fragment:"#if defined( USE_MAP ) || defined( USE_ALPHAMAP )\n\t#if defined( USE_POINTS_UV )\n\t\tvec2 uv = vUv;\n\t#else\n\t\tvec2 uv = ( uvTransform * vec3( gl_PointCoord.x, 1.0 - gl_PointCoord.y, 1 ) ).xy;\n\t#endif\n#endif\n#ifdef USE_MAP\n\tdiffuseColor *= texture2D( map, uv );\n#endif\n#ifdef USE_ALPHAMAP\n\tdiffuseColor.a *= texture2D( alphaMap, uv ).g;\n#endif",map_particle_pars_fragment:"#if defined( USE_POINTS_UV )\n\tvarying vec2 vUv;\n#else\n\t#if defined( USE_MAP ) || defined( USE_ALPHAMAP )\n\t\tuniform mat3 uvTransform;\n\t#endif\n#endif\n#ifdef USE_MAP\n\tuniform sampler2D map;\n#endif\n#ifdef USE_ALPHAMAP\n\tuniform sampler2D alphaMap;\n#endif",metalnessmap_fragment:"float metalnessFactor = metalness;\n#ifdef USE_METALNESSMAP\n\tvec4 texelMetalness = texture2D( metalnessMap, vMetalnessMapUv );\n\tmetalnessFactor *= texelMetalness.b;\n#endif",metalnessmap_pars_fragment:"#ifdef USE_METALNESSMAP\n\tuniform sampler2D metalnessMap;\n#endif",morphcolor_vertex:"#if defined( USE_MORPHCOLORS ) && defined( MORPHTARGETS_TEXTURE )\n\tvColor *= morphTargetBaseInfluence;\n\tfor ( int i = 0; i < MORPHTARGETS_COUNT; i ++ ) {\n\t\t#if defined( USE_COLOR_ALPHA )\n\t\t\tif ( morphTargetInfluences[ i ] != 0.0 ) vColor += getMorph( gl_VertexID, i, 2 ) * morphTargetInfluences[ i ];\n\t\t#elif defined( USE_COLOR )\n\t\t\tif ( morphTargetInfluences[ i ] != 0.0 ) vColor += getMorph( gl_VertexID, i, 2 ).rgb * morphTargetInfluences[ i ];\n\t\t#endif\n\t}\n#endif",morphnormal_vertex:"#ifdef USE_MORPHNORMALS\n\tobjectNormal *= morphTargetBaseInfluence;\n\t#ifdef MORPHTARGETS_TEXTURE\n\t\tfor ( int i = 0; i < MORPHTARGETS_COUNT; i ++ ) {\n\t\t\tif ( morphTargetInfluences[ i ] != 0.0 ) objectNormal += getMorph( gl_VertexID, i, 1 ).xyz * morphTargetInfluences[ i ];\n\t\t}\n\t#else\n\t\tobjectNormal += morphNormal0 * morphTargetInfluences[ 0 ];\n\t\tobjectNormal += morphNormal1 * morphTargetInfluences[ 1 ];\n\t\tobjectNormal += morphNormal2 * morphTargetInfluences[ 2 ];\n\t\tobjectNormal += morphNormal3 * morphTargetInfluences[ 3 ];\n\t#endif\n#endif",morphtarget_pars_vertex:"#ifdef USE_MORPHTARGETS\n\tuniform float morphTargetBaseInfluence;\n\t#ifdef MORPHTARGETS_TEXTURE\n\t\tuniform float morphTargetInfluences[ MORPHTARGETS_COUNT ];\n\t\tuniform sampler2DArray morphTargetsTexture;\n\t\tuniform ivec2 morphTargetsTextureSize;\n\t\tvec4 getMorph( const in int vertexIndex, const in int morphTargetIndex, const in int offset ) {\n\t\t\tint texelIndex = vertexIndex * MORPHTARGETS_TEXTURE_STRIDE + offset;\n\t\t\tint y = texelIndex / morphTargetsTextureSize.x;\n\t\t\tint x = texelIndex - y * morphTargetsTextureSize.x;\n\t\t\tivec3 morphUV = ivec3( x, y, morphTargetIndex );\n\t\t\treturn texelFetch( morphTargetsTexture, morphUV, 0 );\n\t\t}\n\t#else\n\t\t#ifndef USE_MORPHNORMALS\n\t\t\tuniform float morphTargetInfluences[ 8 ];\n\t\t#else\n\t\t\tuniform float morphTargetInfluences[ 4 ];\n\t\t#endif\n\t#endif\n#endif",morphtarget_vertex:"#ifdef USE_MORPHTARGETS\n\ttransformed *= morphTargetBaseInfluence;\n\t#ifdef MORPHTARGETS_TEXTURE\n\t\tfor ( int i = 0; i < MORPHTARGETS_COUNT; i ++ ) {\n\t\t\tif ( morphTargetInfluences[ i ] != 0.0 ) transformed += getMorph( gl_VertexID, i, 0 ).xyz * morphTargetInfluences[ i ];\n\t\t}\n\t#else\n\t\ttransformed += morphTarget0 * morphTargetInfluences[ 0 ];\n\t\ttransformed += morphTarget1 * morphTargetInfluences[ 1 ];\n\t\ttransformed += morphTarget2 * morphTargetInfluences[ 2 ];\n\t\ttransformed += morphTarget3 * morphTargetInfluences[ 3 ];\n\t\t#ifndef USE_MORPHNORMALS\n\t\t\ttransformed += morphTarget4 * morphTargetInfluences[ 4 ];\n\t\t\ttransformed += morphTarget5 * morphTargetInfluences[ 5 ];\n\t\t\ttransformed += morphTarget6 * morphTargetInfluences[ 6 ];\n\t\t\ttransformed += morphTarget7 * morphTargetInfluences[ 7 ];\n\t\t#endif\n\t#endif\n#endif",normal_fragment_begin:"float faceDirection = gl_FrontFacing ? 1.0 : - 1.0;\n#ifdef FLAT_SHADED\n\tvec3 fdx = dFdx( vViewPosition );\n\tvec3 fdy = dFdy( vViewPosition );\n\tvec3 normal = normalize( cross( fdx, fdy ) );\n#else\n\tvec3 normal = normalize( vNormal );\n\t#ifdef DOUBLE_SIDED\n\t\tnormal *= faceDirection;\n\t#endif\n#endif\n#if defined( USE_NORMALMAP_TANGENTSPACE ) || defined( USE_CLEARCOAT_NORMALMAP ) || defined( USE_ANISOTROPY )\n\t#ifdef USE_TANGENT\n\t\tmat3 tbn = mat3( normalize( vTangent ), normalize( vBitangent ), normal );\n\t#else\n\t\tmat3 tbn = getTangentFrame( - vViewPosition, normal,\n\t\t#if defined( USE_NORMALMAP )\n\t\t\tvNormalMapUv\n\t\t#elif defined( USE_CLEARCOAT_NORMALMAP )\n\t\t\tvClearcoatNormalMapUv\n\t\t#else\n\t\t\tvUv\n\t\t#endif\n\t\t);\n\t#endif\n\t#if defined( DOUBLE_SIDED ) && ! defined( FLAT_SHADED )\n\t\ttbn[0] *= faceDirection;\n\t\ttbn[1] *= faceDirection;\n\t#endif\n#endif\n#ifdef USE_CLEARCOAT_NORMALMAP\n\t#ifdef USE_TANGENT\n\t\tmat3 tbn2 = mat3( normalize( vTangent ), normalize( vBitangent ), normal );\n\t#else\n\t\tmat3 tbn2 = getTangentFrame( - vViewPosition, normal, vClearcoatNormalMapUv );\n\t#endif\n\t#if defined( DOUBLE_SIDED ) && ! defined( FLAT_SHADED )\n\t\ttbn2[0] *= faceDirection;\n\t\ttbn2[1] *= faceDirection;\n\t#endif\n#endif\nvec3 geometryNormal = normal;",normal_fragment_maps:"#ifdef USE_NORMALMAP_OBJECTSPACE\n\tnormal = texture2D( normalMap, vNormalMapUv ).xyz * 2.0 - 1.0;\n\t#ifdef FLIP_SIDED\n\t\tnormal = - normal;\n\t#endif\n\t#ifdef DOUBLE_SIDED\n\t\tnormal = normal * faceDirection;\n\t#endif\n\tnormal = normalize( normalMatrix * normal );\n#elif defined( USE_NORMALMAP_TANGENTSPACE )\n\tvec3 mapN = texture2D( normalMap, vNormalMapUv ).xyz * 2.0 - 1.0;\n\tmapN.xy *= normalScale;\n\tnormal = normalize( tbn * mapN );\n#elif defined( USE_BUMPMAP )\n\tnormal = perturbNormalArb( - vViewPosition, normal, dHdxy_fwd(), faceDirection );\n#endif",normal_pars_fragment:"#ifndef FLAT_SHADED\n\tvarying vec3 vNormal;\n\t#ifdef USE_TANGENT\n\t\tvarying vec3 vTangent;\n\t\tvarying vec3 vBitangent;\n\t#endif\n#endif",normal_pars_vertex:"#ifndef FLAT_SHADED\n\tvarying vec3 vNormal;\n\t#ifdef USE_TANGENT\n\t\tvarying vec3 vTangent;\n\t\tvarying vec3 vBitangent;\n\t#endif\n#endif",normal_vertex:"#ifndef FLAT_SHADED\n\tvNormal = normalize( transformedNormal );\n\t#ifdef USE_TANGENT\n\t\tvTangent = normalize( transformedTangent );\n\t\tvBitangent = normalize( cross( vNormal, vTangent ) * tangent.w );\n\t#endif\n#endif",normalmap_pars_fragment:"#ifdef USE_NORMALMAP\n\tuniform sampler2D normalMap;\n\tuniform vec2 normalScale;\n#endif\n#ifdef USE_NORMALMAP_OBJECTSPACE\n\tuniform mat3 normalMatrix;\n#endif\n#if ! defined ( USE_TANGENT ) && ( defined ( USE_NORMALMAP_TANGENTSPACE ) || defined ( USE_CLEARCOAT_NORMALMAP ) || defined( USE_ANISOTROPY ) )\n\tmat3 getTangentFrame( vec3 eye_pos, vec3 surf_norm, vec2 uv ) {\n\t\tvec3 q0 = dFdx( eye_pos.xyz );\n\t\tvec3 q1 = dFdy( eye_pos.xyz );\n\t\tvec2 st0 = dFdx( uv.st );\n\t\tvec2 st1 = dFdy( uv.st );\n\t\tvec3 N = surf_norm;\n\t\tvec3 q1perp = cross( q1, N );\n\t\tvec3 q0perp = cross( N, q0 );\n\t\tvec3 T = q1perp * st0.x + q0perp * st1.x;\n\t\tvec3 B = q1perp * st0.y + q0perp * st1.y;\n\t\tfloat det = max( dot( T, T ), dot( B, B ) );\n\t\tfloat scale = ( det == 0.0 ) ? 0.0 : inversesqrt( det );\n\t\treturn mat3( T * scale, B * scale, N );\n\t}\n#endif",clearcoat_normal_fragment_begin:"#ifdef USE_CLEARCOAT\n\tvec3 clearcoatNormal = geometryNormal;\n#endif",clearcoat_normal_fragment_maps:"#ifdef USE_CLEARCOAT_NORMALMAP\n\tvec3 clearcoatMapN = texture2D( clearcoatNormalMap, vClearcoatNormalMapUv ).xyz * 2.0 - 1.0;\n\tclearcoatMapN.xy *= clearcoatNormalScale;\n\tclearcoatNormal = normalize( tbn2 * clearcoatMapN );\n#endif",clearcoat_pars_fragment:"#ifdef USE_CLEARCOATMAP\n\tuniform sampler2D clearcoatMap;\n#endif\n#ifdef USE_CLEARCOAT_NORMALMAP\n\tuniform sampler2D clearcoatNormalMap;\n\tuniform vec2 clearcoatNormalScale;\n#endif\n#ifdef USE_CLEARCOAT_ROUGHNESSMAP\n\tuniform sampler2D clearcoatRoughnessMap;\n#endif",iridescence_pars_fragment:"#ifdef USE_IRIDESCENCEMAP\n\tuniform sampler2D iridescenceMap;\n#endif\n#ifdef USE_IRIDESCENCE_THICKNESSMAP\n\tuniform sampler2D iridescenceThicknessMap;\n#endif",opaque_fragment:"#ifdef OPAQUE\ndiffuseColor.a = 1.0;\n#endif\n#ifdef USE_TRANSMISSION\ndiffuseColor.a *= material.transmissionAlpha;\n#endif\ngl_FragColor = vec4( outgoingLight, diffuseColor.a );",packing:"vec3 packNormalToRGB( const in vec3 normal ) {\n\treturn normalize( normal ) * 0.5 + 0.5;\n}\nvec3 unpackRGBToNormal( const in vec3 rgb ) {\n\treturn 2.0 * rgb.xyz - 1.0;\n}\nconst float PackUpscale = 256. / 255.;const float UnpackDownscale = 255. / 256.;\nconst vec3 PackFactors = vec3( 256. * 256. * 256., 256. * 256., 256. );\nconst vec4 UnpackFactors = UnpackDownscale / vec4( PackFactors, 1. );\nconst float ShiftRight8 = 1. / 256.;\nvec4 packDepthToRGBA( const in float v ) {\n\tvec4 r = vec4( fract( v * PackFactors ), v );\n\tr.yzw -= r.xyz * ShiftRight8;\treturn r * PackUpscale;\n}\nfloat unpackRGBAToDepth( const in vec4 v ) {\n\treturn dot( v, UnpackFactors );\n}\nvec2 packDepthToRG( in highp float v ) {\n\treturn packDepthToRGBA( v ).yx;\n}\nfloat unpackRGToDepth( const in highp vec2 v ) {\n\treturn unpackRGBAToDepth( vec4( v.xy, 0.0, 0.0 ) );\n}\nvec4 pack2HalfToRGBA( vec2 v ) {\n\tvec4 r = vec4( v.x, fract( v.x * 255.0 ), v.y, fract( v.y * 255.0 ) );\n\treturn vec4( r.x - r.y / 255.0, r.y, r.z - r.w / 255.0, r.w );\n}\nvec2 unpackRGBATo2Half( vec4 v ) {\n\treturn vec2( v.x + ( v.y / 255.0 ), v.z + ( v.w / 255.0 ) );\n}\nfloat viewZToOrthographicDepth( const in float viewZ, const in float near, const in float far ) {\n\treturn ( viewZ + near ) / ( near - far );\n}\nfloat orthographicDepthToViewZ( const in float depth, const in float near, const in float far ) {\n\treturn depth * ( near - far ) - near;\n}\nfloat viewZToPerspectiveDepth( const in float viewZ, const in float near, const in float far ) {\n\treturn ( ( near + viewZ ) * far ) / ( ( far - near ) * viewZ );\n}\nfloat perspectiveDepthToViewZ( const in float depth, const in float near, const in float far ) {\n\treturn ( near * far ) / ( ( far - near ) * depth - far );\n}",premultiplied_alpha_fragment:"#ifdef PREMULTIPLIED_ALPHA\n\tgl_FragColor.rgb *= gl_FragColor.a;\n#endif",project_vertex:"vec4 mvPosition = vec4( transformed, 1.0 );\n#ifdef USE_INSTANCING\n\tmvPosition = instanceMatrix * mvPosition;\n#endif\nmvPosition = modelViewMatrix * mvPosition;\ngl_Position = projectionMatrix * mvPosition;",dithering_fragment:"#ifdef DITHERING\n\tgl_FragColor.rgb = dithering( gl_FragColor.rgb );\n#endif",dithering_pars_fragment:"#ifdef DITHERING\n\tvec3 dithering( vec3 color ) {\n\t\tfloat grid_position = rand( gl_FragCoord.xy );\n\t\tvec3 dither_shift_RGB = vec3( 0.25 / 255.0, -0.25 / 255.0, 0.25 / 255.0 );\n\t\tdither_shift_RGB = mix( 2.0 * dither_shift_RGB, -2.0 * dither_shift_RGB, grid_position );\n\t\treturn color + dither_shift_RGB;\n\t}\n#endif",roughnessmap_fragment:"float roughnessFactor = roughness;\n#ifdef USE_ROUGHNESSMAP\n\tvec4 texelRoughness = texture2D( roughnessMap, vRoughnessMapUv );\n\troughnessFactor *= texelRoughness.g;\n#endif",roughnessmap_pars_fragment:"#ifdef USE_ROUGHNESSMAP\n\tuniform sampler2D roughnessMap;\n#endif",shadowmap_pars_fragment:"#if NUM_SPOT_LIGHT_COORDS > 0\n\tvarying vec4 vSpotLightCoord[ NUM_SPOT_LIGHT_COORDS ];\n#endif\n#if NUM_SPOT_LIGHT_MAPS > 0\n\tuniform sampler2D spotLightMap[ NUM_SPOT_LIGHT_MAPS ];\n#endif\n#ifdef USE_SHADOWMAP\n\t#if NUM_DIR_LIGHT_SHADOWS > 0\n\t\tuniform sampler2D directionalShadowMap[ NUM_DIR_LIGHT_SHADOWS ];\n\t\tvarying vec4 vDirectionalShadowCoord[ NUM_DIR_LIGHT_SHADOWS ];\n\t\tstruct DirectionalLightShadow {\n\t\t\tfloat shadowBias;\n\t\t\tfloat shadowNormalBias;\n\t\t\tfloat shadowRadius;\n\t\t\tvec2 shadowMapSize;\n\t\t};\n\t\tuniform DirectionalLightShadow directionalLightShadows[ NUM_DIR_LIGHT_SHADOWS ];\n\t#endif\n\t#if NUM_SPOT_LIGHT_SHADOWS > 0\n\t\tuniform sampler2D spotShadowMap[ NUM_SPOT_LIGHT_SHADOWS ];\n\t\tstruct SpotLightShadow {\n\t\t\tfloat shadowBias;\n\t\t\tfloat shadowNormalBias;\n\t\t\tfloat shadowRadius;\n\t\t\tvec2 shadowMapSize;\n\t\t};\n\t\tuniform SpotLightShadow spotLightShadows[ NUM_SPOT_LIGHT_SHADOWS ];\n\t#endif\n\t#if NUM_POINT_LIGHT_SHADOWS > 0\n\t\tuniform sampler2D pointShadowMap[ NUM_POINT_LIGHT_SHADOWS ];\n\t\tvarying vec4 vPointShadowCoord[ NUM_POINT_LIGHT_SHADOWS ];\n\t\tstruct PointLightShadow {\n\t\t\tfloat shadowBias;\n\t\t\tfloat shadowNormalBias;\n\t\t\tfloat shadowRadius;\n\t\t\tvec2 shadowMapSize;\n\t\t\tfloat shadowCameraNear;\n\t\t\tfloat shadowCameraFar;\n\t\t};\n\t\tuniform PointLightShadow pointLightShadows[ NUM_POINT_LIGHT_SHADOWS ];\n\t#endif\n\tfloat texture2DCompare( sampler2D depths, vec2 uv, float compare ) {\n\t\treturn step( compare, unpackRGBAToDepth( texture2D( depths, uv ) ) );\n\t}\n\tvec2 texture2DDistribution( sampler2D shadow, vec2 uv ) {\n\t\treturn unpackRGBATo2Half( texture2D( shadow, uv ) );\n\t}\n\tfloat VSMShadow (sampler2D shadow, vec2 uv, float compare ){\n\t\tfloat occlusion = 1.0;\n\t\tvec2 distribution = texture2DDistribution( shadow, uv );\n\t\tfloat hard_shadow = step( compare , distribution.x );\n\t\tif (hard_shadow != 1.0 ) {\n\t\t\tfloat distance = compare - distribution.x ;\n\t\t\tfloat variance = max( 0.00000, distribution.y * distribution.y );\n\t\t\tfloat softness_probability = variance / (variance + distance * distance );\t\t\tsoftness_probability = clamp( ( softness_probability - 0.3 ) / ( 0.95 - 0.3 ), 0.0, 1.0 );\t\t\tocclusion = clamp( max( hard_shadow, softness_probability ), 0.0, 1.0 );\n\t\t}\n\t\treturn occlusion;\n\t}\n\tfloat getShadow( sampler2D shadowMap, vec2 shadowMapSize, float shadowBias, float shadowRadius, vec4 shadowCoord ) {\n\t\tfloat shadow = 1.0;\n\t\tshadowCoord.xyz /= shadowCoord.w;\n\t\tshadowCoord.z += shadowBias;\n\t\tbool inFrustum = shadowCoord.x >= 0.0 && shadowCoord.x <= 1.0 && shadowCoord.y >= 0.0 && shadowCoord.y <= 1.0;\n\t\tbool frustumTest = inFrustum && shadowCoord.z <= 1.0;\n\t\tif ( frustumTest ) {\n\t\t#if defined( SHADOWMAP_TYPE_PCF )\n\t\t\tvec2 texelSize = vec2( 1.0 ) / shadowMapSize;\n\t\t\tfloat dx0 = - texelSize.x * shadowRadius;\n\t\t\tfloat dy0 = - texelSize.y * shadowRadius;\n\t\t\tfloat dx1 = + texelSize.x * shadowRadius;\n\t\t\tfloat dy1 = + texelSize.y * shadowRadius;\n\t\t\tfloat dx2 = dx0 / 2.0;\n\t\t\tfloat dy2 = dy0 / 2.0;\n\t\t\tfloat dx3 = dx1 / 2.0;\n\t\t\tfloat dy3 = dy1 / 2.0;\n\t\t\tshadow = (\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx0, dy0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( 0.0, dy0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx1, dy0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx2, dy2 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( 0.0, dy2 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx3, dy2 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx0, 0.0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx2, 0.0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy, shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx3, 0.0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx1, 0.0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx2, dy3 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( 0.0, dy3 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx3, dy3 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx0, dy1 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( 0.0, dy1 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx1, dy1 ), shadowCoord.z )\n\t\t\t) * ( 1.0 / 17.0 );\n\t\t#elif defined( SHADOWMAP_TYPE_PCF_SOFT )\n\t\t\tvec2 texelSize = vec2( 1.0 ) / shadowMapSize;\n\t\t\tfloat dx = texelSize.x;\n\t\t\tfloat dy = texelSize.y;\n\t\t\tvec2 uv = shadowCoord.xy;\n\t\t\tvec2 f = fract( uv * shadowMapSize + 0.5 );\n\t\t\tuv -= f * texelSize;\n\t\t\tshadow = (\n\t\t\t\ttexture2DCompare( shadowMap, uv, shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, uv + vec2( dx, 0.0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, uv + vec2( 0.0, dy ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, uv + texelSize, shadowCoord.z ) +\n\t\t\t\tmix( texture2DCompare( shadowMap, uv + vec2( -dx, 0.0 ), shadowCoord.z ),\n\t\t\t\t\t texture2DCompare( shadowMap, uv + vec2( 2.0 * dx, 0.0 ), shadowCoord.z ),\n\t\t\t\t\t f.x ) +\n\t\t\t\tmix( texture2DCompare( shadowMap, uv + vec2( -dx, dy ), shadowCoord.z ),\n\t\t\t\t\t texture2DCompare( shadowMap, uv + vec2( 2.0 * dx, dy ), shadowCoord.z ),\n\t\t\t\t\t f.x ) +\n\t\t\t\tmix( texture2DCompare( shadowMap, uv + vec2( 0.0, -dy ), shadowCoord.z ),\n\t\t\t\t\t texture2DCompare( shadowMap, uv + vec2( 0.0, 2.0 * dy ), shadowCoord.z ),\n\t\t\t\t\t f.y ) +\n\t\t\t\tmix( texture2DCompare( shadowMap, uv + vec2( dx, -dy ), shadowCoord.z ),\n\t\t\t\t\t texture2DCompare( shadowMap, uv + vec2( dx, 2.0 * dy ), shadowCoord.z ),\n\t\t\t\t\t f.y ) +\n\t\t\t\tmix( mix( texture2DCompare( shadowMap, uv + vec2( -dx, -dy ), shadowCoord.z ),\n\t\t\t\t\t\t  texture2DCompare( shadowMap, uv + vec2( 2.0 * dx, -dy ), shadowCoord.z ),\n\t\t\t\t\t\t  f.x ),\n\t\t\t\t\t mix( texture2DCompare( shadowMap, uv + vec2( -dx, 2.0 * dy ), shadowCoord.z ),\n\t\t\t\t\t\t  texture2DCompare( shadowMap, uv + vec2( 2.0 * dx, 2.0 * dy ), shadowCoord.z ),\n\t\t\t\t\t\t  f.x ),\n\t\t\t\t\t f.y )\n\t\t\t) * ( 1.0 / 9.0 );\n\t\t#elif defined( SHADOWMAP_TYPE_VSM )\n\t\t\tshadow = VSMShadow( shadowMap, shadowCoord.xy, shadowCoord.z );\n\t\t#else\n\t\t\tshadow = texture2DCompare( shadowMap, shadowCoord.xy, shadowCoord.z );\n\t\t#endif\n\t\t}\n\t\treturn shadow;\n\t}\n\tvec2 cubeToUV( vec3 v, float texelSizeY ) {\n\t\tvec3 absV = abs( v );\n\t\tfloat scaleToCube = 1.0 / max( absV.x, max( absV.y, absV.z ) );\n\t\tabsV *= scaleToCube;\n\t\tv *= scaleToCube * ( 1.0 - 2.0 * texelSizeY );\n\t\tvec2 planar = v.xy;\n\t\tfloat almostATexel = 1.5 * texelSizeY;\n\t\tfloat almostOne = 1.0 - almostATexel;\n\t\tif ( absV.z >= almostOne ) {\n\t\t\tif ( v.z > 0.0 )\n\t\t\t\tplanar.x = 4.0 - v.x;\n\t\t} else if ( absV.x >= almostOne ) {\n\t\t\tfloat signX = sign( v.x );\n\t\t\tplanar.x = v.z * signX + 2.0 * signX;\n\t\t} else if ( absV.y >= almostOne ) {\n\t\t\tfloat signY = sign( v.y );\n\t\t\tplanar.x = v.x + 2.0 * signY + 2.0;\n\t\t\tplanar.y = v.z * signY - 2.0;\n\t\t}\n\t\treturn vec2( 0.125, 0.25 ) * planar + vec2( 0.375, 0.75 );\n\t}\n\tfloat getPointShadow( sampler2D shadowMap, vec2 shadowMapSize, float shadowBias, float shadowRadius, vec4 shadowCoord, float shadowCameraNear, float shadowCameraFar ) {\n\t\tvec2 texelSize = vec2( 1.0 ) / ( shadowMapSize * vec2( 4.0, 2.0 ) );\n\t\tvec3 lightToPosition = shadowCoord.xyz;\n\t\tfloat dp = ( length( lightToPosition ) - shadowCameraNear ) / ( shadowCameraFar - shadowCameraNear );\t\tdp += shadowBias;\n\t\tvec3 bd3D = normalize( lightToPosition );\n\t\t#if defined( SHADOWMAP_TYPE_PCF ) || defined( SHADOWMAP_TYPE_PCF_SOFT ) || defined( SHADOWMAP_TYPE_VSM )\n\t\t\tvec2 offset = vec2( - 1, 1 ) * shadowRadius * texelSize.y;\n\t\t\treturn (\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.xyy, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.yyy, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.xyx, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.yyx, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.xxy, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.yxy, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.xxx, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.yxx, texelSize.y ), dp )\n\t\t\t) * ( 1.0 / 9.0 );\n\t\t#else\n\t\t\treturn texture2DCompare( shadowMap, cubeToUV( bd3D, texelSize.y ), dp );\n\t\t#endif\n\t}\n#endif",shadowmap_pars_vertex:"#if NUM_SPOT_LIGHT_COORDS > 0\n\tuniform mat4 spotLightMatrix[ NUM_SPOT_LIGHT_COORDS ];\n\tvarying vec4 vSpotLightCoord[ NUM_SPOT_LIGHT_COORDS ];\n#endif\n#ifdef USE_SHADOWMAP\n\t#if NUM_DIR_LIGHT_SHADOWS > 0\n\t\tuniform mat4 directionalShadowMatrix[ NUM_DIR_LIGHT_SHADOWS ];\n\t\tvarying vec4 vDirectionalShadowCoord[ NUM_DIR_LIGHT_SHADOWS ];\n\t\tstruct DirectionalLightShadow {\n\t\t\tfloat shadowBias;\n\t\t\tfloat shadowNormalBias;\n\t\t\tfloat shadowRadius;\n\t\t\tvec2 shadowMapSize;\n\t\t};\n\t\tuniform DirectionalLightShadow directionalLightShadows[ NUM_DIR_LIGHT_SHADOWS ];\n\t#endif\n\t#if NUM_SPOT_LIGHT_SHADOWS > 0\n\t\tstruct SpotLightShadow {\n\t\t\tfloat shadowBias;\n\t\t\tfloat shadowNormalBias;\n\t\t\tfloat shadowRadius;\n\t\t\tvec2 shadowMapSize;\n\t\t};\n\t\tuniform SpotLightShadow spotLightShadows[ NUM_SPOT_LIGHT_SHADOWS ];\n\t#endif\n\t#if NUM_POINT_LIGHT_SHADOWS > 0\n\t\tuniform mat4 pointShadowMatrix[ NUM_POINT_LIGHT_SHADOWS ];\n\t\tvarying vec4 vPointShadowCoord[ NUM_POINT_LIGHT_SHADOWS ];\n\t\tstruct PointLightShadow {\n\t\t\tfloat shadowBias;\n\t\t\tfloat shadowNormalBias;\n\t\t\tfloat shadowRadius;\n\t\t\tvec2 shadowMapSize;\n\t\t\tfloat shadowCameraNear;\n\t\t\tfloat shadowCameraFar;\n\t\t};\n\t\tuniform PointLightShadow pointLightShadows[ NUM_POINT_LIGHT_SHADOWS ];\n\t#endif\n#endif",shadowmap_vertex:"#if ( defined( USE_SHADOWMAP ) && ( NUM_DIR_LIGHT_SHADOWS > 0 || NUM_POINT_LIGHT_SHADOWS > 0 ) ) || ( NUM_SPOT_LIGHT_COORDS > 0 )\n\tvec3 shadowWorldNormal = inverseTransformDirection( transformedNormal, viewMatrix );\n\tvec4 shadowWorldPosition;\n#endif\n#if defined( USE_SHADOWMAP )\n\t#if NUM_DIR_LIGHT_SHADOWS > 0\n\t\t#pragma unroll_loop_start\n\t\tfor ( int i = 0; i < NUM_DIR_LIGHT_SHADOWS; i ++ ) {\n\t\t\tshadowWorldPosition = worldPosition + vec4( shadowWorldNormal * directionalLightShadows[ i ].shadowNormalBias, 0 );\n\t\t\tvDirectionalShadowCoord[ i ] = directionalShadowMatrix[ i ] * shadowWorldPosition;\n\t\t}\n\t\t#pragma unroll_loop_end\n\t#endif\n\t#if NUM_POINT_LIGHT_SHADOWS > 0\n\t\t#pragma unroll_loop_start\n\t\tfor ( int i = 0; i < NUM_POINT_LIGHT_SHADOWS; i ++ ) {\n\t\t\tshadowWorldPosition = worldPosition + vec4( shadowWorldNormal * pointLightShadows[ i ].shadowNormalBias, 0 );\n\t\t\tvPointShadowCoord[ i ] = pointShadowMatrix[ i ] * shadowWorldPosition;\n\t\t}\n\t\t#pragma unroll_loop_end\n\t#endif\n#endif\n#if NUM_SPOT_LIGHT_COORDS > 0\n\t#pragma unroll_loop_start\n\tfor ( int i = 0; i < NUM_SPOT_LIGHT_COORDS; i ++ ) {\n\t\tshadowWorldPosition = worldPosition;\n\t\t#if ( defined( USE_SHADOWMAP ) && UNROLLED_LOOP_INDEX < NUM_SPOT_LIGHT_SHADOWS )\n\t\t\tshadowWorldPosition.xyz += shadowWorldNormal * spotLightShadows[ i ].shadowNormalBias;\n\t\t#endif\n\t\tvSpotLightCoord[ i ] = spotLightMatrix[ i ] * shadowWorldPosition;\n\t}\n\t#pragma unroll_loop_end\n#endif",shadowmask_pars_fragment:"float getShadowMask() {\n\tfloat shadow = 1.0;\n\t#ifdef USE_SHADOWMAP\n\t#if NUM_DIR_LIGHT_SHADOWS > 0\n\tDirectionalLightShadow directionalLight;\n\t#pragma unroll_loop_start\n\tfor ( int i = 0; i < NUM_DIR_LIGHT_SHADOWS; i ++ ) {\n\t\tdirectionalLight = directionalLightShadows[ i ];\n\t\tshadow *= receiveShadow ? getShadow( directionalShadowMap[ i ], directionalLight.shadowMapSize, directionalLight.shadowBias, directionalLight.shadowRadius, vDirectionalShadowCoord[ i ] ) : 1.0;\n\t}\n\t#pragma unroll_loop_end\n\t#endif\n\t#if NUM_SPOT_LIGHT_SHADOWS > 0\n\tSpotLightShadow spotLight;\n\t#pragma unroll_loop_start\n\tfor ( int i = 0; i < NUM_SPOT_LIGHT_SHADOWS; i ++ ) {\n\t\tspotLight = spotLightShadows[ i ];\n\t\tshadow *= receiveShadow ? getShadow( spotShadowMap[ i ], spotLight.shadowMapSize, spotLight.shadowBias, spotLight.shadowRadius, vSpotLightCoord[ i ] ) : 1.0;\n\t}\n\t#pragma unroll_loop_end\n\t#endif\n\t#if NUM_POINT_LIGHT_SHADOWS > 0\n\tPointLightShadow pointLight;\n\t#pragma unroll_loop_start\n\tfor ( int i = 0; i < NUM_POINT_LIGHT_SHADOWS; i ++ ) {\n\t\tpointLight = pointLightShadows[ i ];\n\t\tshadow *= receiveShadow ? getPointShadow( pointShadowMap[ i ], pointLight.shadowMapSize, pointLight.shadowBias, pointLight.shadowRadius, vPointShadowCoord[ i ], pointLight.shadowCameraNear, pointLight.shadowCameraFar ) : 1.0;\n\t}\n\t#pragma unroll_loop_end\n\t#endif\n\t#endif\n\treturn shadow;\n}",skinbase_vertex:"#ifdef USE_SKINNING\n\tmat4 boneMatX = getBoneMatrix( skinIndex.x );\n\tmat4 boneMatY = getBoneMatrix( skinIndex.y );\n\tmat4 boneMatZ = getBoneMatrix( skinIndex.z );\n\tmat4 boneMatW = getBoneMatrix( skinIndex.w );\n#endif",skinning_pars_vertex:"#ifdef USE_SKINNING\n\tuniform mat4 bindMatrix;\n\tuniform mat4 bindMatrixInverse;\n\tuniform highp sampler2D boneTexture;\n\tuniform int boneTextureSize;\n\tmat4 getBoneMatrix( const in float i ) {\n\t\tfloat j = i * 4.0;\n\t\tfloat x = mod( j, float( boneTextureSize ) );\n\t\tfloat y = floor( j / float( boneTextureSize ) );\n\t\tfloat dx = 1.0 / float( boneTextureSize );\n\t\tfloat dy = 1.0 / float( boneTextureSize );\n\t\ty = dy * ( y + 0.5 );\n\t\tvec4 v1 = texture2D( boneTexture, vec2( dx * ( x + 0.5 ), y ) );\n\t\tvec4 v2 = texture2D( boneTexture, vec2( dx * ( x + 1.5 ), y ) );\n\t\tvec4 v3 = texture2D( boneTexture, vec2( dx * ( x + 2.5 ), y ) );\n\t\tvec4 v4 = texture2D( boneTexture, vec2( dx * ( x + 3.5 ), y ) );\n\t\tmat4 bone = mat4( v1, v2, v3, v4 );\n\t\treturn bone;\n\t}\n#endif",skinning_vertex:"#ifdef USE_SKINNING\n\tvec4 skinVertex = bindMatrix * vec4( transformed, 1.0 );\n\tvec4 skinned = vec4( 0.0 );\n\tskinned += boneMatX * skinVertex * skinWeight.x;\n\tskinned += boneMatY * skinVertex * skinWeight.y;\n\tskinned += boneMatZ * skinVertex * skinWeight.z;\n\tskinned += boneMatW * skinVertex * skinWeight.w;\n\ttransformed = ( bindMatrixInverse * skinned ).xyz;\n#endif",skinnormal_vertex:"#ifdef USE_SKINNING\n\tmat4 skinMatrix = mat4( 0.0 );\n\tskinMatrix += skinWeight.x * boneMatX;\n\tskinMatrix += skinWeight.y * boneMatY;\n\tskinMatrix += skinWeight.z * boneMatZ;\n\tskinMatrix += skinWeight.w * boneMatW;\n\tskinMatrix = bindMatrixInverse * skinMatrix * bindMatrix;\n\tobjectNormal = vec4( skinMatrix * vec4( objectNormal, 0.0 ) ).xyz;\n\t#ifdef USE_TANGENT\n\t\tobjectTangent = vec4( skinMatrix * vec4( objectTangent, 0.0 ) ).xyz;\n\t#endif\n#endif",specularmap_fragment:"float specularStrength;\n#ifdef USE_SPECULARMAP\n\tvec4 texelSpecular = texture2D( specularMap, vSpecularMapUv );\n\tspecularStrength = texelSpecular.r;\n#else\n\tspecularStrength = 1.0;\n#endif",specularmap_pars_fragment:"#ifdef USE_SPECULARMAP\n\tuniform sampler2D specularMap;\n#endif",tonemapping_fragment:"#if defined( TONE_MAPPING )\n\tgl_FragColor.rgb = toneMapping( gl_FragColor.rgb );\n#endif",tonemapping_pars_fragment:"#ifndef saturate\n#define saturate( a ) clamp( a, 0.0, 1.0 )\n#endif\nuniform float toneMappingExposure;\nvec3 LinearToneMapping( vec3 color ) {\n\treturn saturate( toneMappingExposure * color );\n}\nvec3 ReinhardToneMapping( vec3 color ) {\n\tcolor *= toneMappingExposure;\n\treturn saturate( color / ( vec3( 1.0 ) + color ) );\n}\nvec3 OptimizedCineonToneMapping( vec3 color ) {\n\tcolor *= toneMappingExposure;\n\tcolor = max( vec3( 0.0 ), color - 0.004 );\n\treturn pow( ( color * ( 6.2 * color + 0.5 ) ) / ( color * ( 6.2 * color + 1.7 ) + 0.06 ), vec3( 2.2 ) );\n}\nvec3 RRTAndODTFit( vec3 v ) {\n\tvec3 a = v * ( v + 0.0245786 ) - 0.000090537;\n\tvec3 b = v * ( 0.983729 * v + 0.4329510 ) + 0.238081;\n\treturn a / b;\n}\nvec3 ACESFilmicToneMapping( vec3 color ) {\n\tconst mat3 ACESInputMat = mat3(\n\t\tvec3( 0.59719, 0.07600, 0.02840 ),\t\tvec3( 0.35458, 0.90834, 0.13383 ),\n\t\tvec3( 0.04823, 0.01566, 0.83777 )\n\t);\n\tconst mat3 ACESOutputMat = mat3(\n\t\tvec3(  1.60475, -0.10208, -0.00327 ),\t\tvec3( -0.53108,  1.10813, -0.07276 ),\n\t\tvec3( -0.07367, -0.00605,  1.07602 )\n\t);\n\tcolor *= toneMappingExposure / 0.6;\n\tcolor = ACESInputMat * color;\n\tcolor = RRTAndODTFit( color );\n\tcolor = ACESOutputMat * color;\n\treturn saturate( color );\n}\nvec3 CustomToneMapping( vec3 color ) { return color; }",transmission_fragment:"#ifdef USE_TRANSMISSION\n\tmaterial.transmission = transmission;\n\tmaterial.transmissionAlpha = 1.0;\n\tmaterial.thickness = thickness;\n\tmaterial.attenuationDistance = attenuationDistance;\n\tmaterial.attenuationColor = attenuationColor;\n\t#ifdef USE_TRANSMISSIONMAP\n\t\tmaterial.transmission *= texture2D( transmissionMap, vTransmissionMapUv ).r;\n\t#endif\n\t#ifdef USE_THICKNESSMAP\n\t\tmaterial.thickness *= texture2D( thicknessMap, vThicknessMapUv ).g;\n\t#endif\n\tvec3 pos = vWorldPosition;\n\tvec3 v = normalize( cameraPosition - pos );\n\tvec3 n = inverseTransformDirection( normal, viewMatrix );\n\tvec4 transmitted = getIBLVolumeRefraction(\n\t\tn, v, material.roughness, material.diffuseColor, material.specularColor, material.specularF90,\n\t\tpos, modelMatrix, viewMatrix, projectionMatrix, material.ior, material.thickness,\n\t\tmaterial.attenuationColor, material.attenuationDistance );\n\tmaterial.transmissionAlpha = mix( material.transmissionAlpha, transmitted.a, material.transmission );\n\ttotalDiffuse = mix( totalDiffuse, transmitted.rgb, material.transmission );\n#endif",transmission_pars_fragment:"#ifdef USE_TRANSMISSION\n\tuniform float transmission;\n\tuniform float thickness;\n\tuniform float attenuationDistance;\n\tuniform vec3 attenuationColor;\n\t#ifdef USE_TRANSMISSIONMAP\n\t\tuniform sampler2D transmissionMap;\n\t#endif\n\t#ifdef USE_THICKNESSMAP\n\t\tuniform sampler2D thicknessMap;\n\t#endif\n\tuniform vec2 transmissionSamplerSize;\n\tuniform sampler2D transmissionSamplerMap;\n\tuniform mat4 modelMatrix;\n\tuniform mat4 projectionMatrix;\n\tvarying vec3 vWorldPosition;\n\tfloat w0( float a ) {\n\t\treturn ( 1.0 / 6.0 ) * ( a * ( a * ( - a + 3.0 ) - 3.0 ) + 1.0 );\n\t}\n\tfloat w1( float a ) {\n\t\treturn ( 1.0 / 6.0 ) * ( a *  a * ( 3.0 * a - 6.0 ) + 4.0 );\n\t}\n\tfloat w2( float a ){\n\t\treturn ( 1.0 / 6.0 ) * ( a * ( a * ( - 3.0 * a + 3.0 ) + 3.0 ) + 1.0 );\n\t}\n\tfloat w3( float a ) {\n\t\treturn ( 1.0 / 6.0 ) * ( a * a * a );\n\t}\n\tfloat g0( float a ) {\n\t\treturn w0( a ) + w1( a );\n\t}\n\tfloat g1( float a ) {\n\t\treturn w2( a ) + w3( a );\n\t}\n\tfloat h0( float a ) {\n\t\treturn - 1.0 + w1( a ) / ( w0( a ) + w1( a ) );\n\t}\n\tfloat h1( float a ) {\n\t\treturn 1.0 + w3( a ) / ( w2( a ) + w3( a ) );\n\t}\n\tvec4 bicubic( sampler2D tex, vec2 uv, vec4 texelSize, float lod ) {\n\t\tuv = uv * texelSize.zw + 0.5;\n\t\tvec2 iuv = floor( uv );\n\t\tvec2 fuv = fract( uv );\n\t\tfloat g0x = g0( fuv.x );\n\t\tfloat g1x = g1( fuv.x );\n\t\tfloat h0x = h0( fuv.x );\n\t\tfloat h1x = h1( fuv.x );\n\t\tfloat h0y = h0( fuv.y );\n\t\tfloat h1y = h1( fuv.y );\n\t\tvec2 p0 = ( vec2( iuv.x + h0x, iuv.y + h0y ) - 0.5 ) * texelSize.xy;\n\t\tvec2 p1 = ( vec2( iuv.x + h1x, iuv.y + h0y ) - 0.5 ) * texelSize.xy;\n\t\tvec2 p2 = ( vec2( iuv.x + h0x, iuv.y + h1y ) - 0.5 ) * texelSize.xy;\n\t\tvec2 p3 = ( vec2( iuv.x + h1x, iuv.y + h1y ) - 0.5 ) * texelSize.xy;\n\t\treturn g0( fuv.y ) * ( g0x * textureLod( tex, p0, lod ) + g1x * textureLod( tex, p1, lod ) ) +\n\t\t\tg1( fuv.y ) * ( g0x * textureLod( tex, p2, lod ) + g1x * textureLod( tex, p3, lod ) );\n\t}\n\tvec4 textureBicubic( sampler2D sampler, vec2 uv, float lod ) {\n\t\tvec2 fLodSize = vec2( textureSize( sampler, int( lod ) ) );\n\t\tvec2 cLodSize = vec2( textureSize( sampler, int( lod + 1.0 ) ) );\n\t\tvec2 fLodSizeInv = 1.0 / fLodSize;\n\t\tvec2 cLodSizeInv = 1.0 / cLodSize;\n\t\tvec4 fSample = bicubic( sampler, uv, vec4( fLodSizeInv, fLodSize ), floor( lod ) );\n\t\tvec4 cSample = bicubic( sampler, uv, vec4( cLodSizeInv, cLodSize ), ceil( lod ) );\n\t\treturn mix( fSample, cSample, fract( lod ) );\n\t}\n\tvec3 getVolumeTransmissionRay( const in vec3 n, const in vec3 v, const in float thickness, const in float ior, const in mat4 modelMatrix ) {\n\t\tvec3 refractionVector = refract( - v, normalize( n ), 1.0 / ior );\n\t\tvec3 modelScale;\n\t\tmodelScale.x = length( vec3( modelMatrix[ 0 ].xyz ) );\n\t\tmodelScale.y = length( vec3( modelMatrix[ 1 ].xyz ) );\n\t\tmodelScale.z = length( vec3( modelMatrix[ 2 ].xyz ) );\n\t\treturn normalize( refractionVector ) * thickness * modelScale;\n\t}\n\tfloat applyIorToRoughness( const in float roughness, const in float ior ) {\n\t\treturn roughness * clamp( ior * 2.0 - 2.0, 0.0, 1.0 );\n\t}\n\tvec4 getTransmissionSample( const in vec2 fragCoord, const in float roughness, const in float ior ) {\n\t\tfloat lod = log2( transmissionSamplerSize.x ) * applyIorToRoughness( roughness, ior );\n\t\treturn textureBicubic( transmissionSamplerMap, fragCoord.xy, lod );\n\t}\n\tvec3 volumeAttenuation( const in float transmissionDistance, const in vec3 attenuationColor, const in float attenuationDistance ) {\n\t\tif ( isinf( attenuationDistance ) ) {\n\t\t\treturn vec3( 1.0 );\n\t\t} else {\n\t\t\tvec3 attenuationCoefficient = -log( attenuationColor ) / attenuationDistance;\n\t\t\tvec3 transmittance = exp( - attenuationCoefficient * transmissionDistance );\t\t\treturn transmittance;\n\t\t}\n\t}\n\tvec4 getIBLVolumeRefraction( const in vec3 n, const in vec3 v, const in float roughness, const in vec3 diffuseColor,\n\t\tconst in vec3 specularColor, const in float specularF90, const in vec3 position, const in mat4 modelMatrix,\n\t\tconst in mat4 viewMatrix, const in mat4 projMatrix, const in float ior, const in float thickness,\n\t\tconst in vec3 attenuationColor, const in float attenuationDistance ) {\n\t\tvec3 transmissionRay = getVolumeTransmissionRay( n, v, thickness, ior, modelMatrix );\n\t\tvec3 refractedRayExit = position + transmissionRay;\n\t\tvec4 ndcPos = projMatrix * viewMatrix * vec4( refractedRayExit, 1.0 );\n\t\tvec2 refractionCoords = ndcPos.xy / ndcPos.w;\n\t\trefractionCoords += 1.0;\n\t\trefractionCoords /= 2.0;\n\t\tvec4 transmittedLight = getTransmissionSample( refractionCoords, roughness, ior );\n\t\tvec3 transmittance = diffuseColor * volumeAttenuation( length( transmissionRay ), attenuationColor, attenuationDistance );\n\t\tvec3 attenuatedColor = transmittance * transmittedLight.rgb;\n\t\tvec3 F = EnvironmentBRDF( n, v, specularColor, specularF90, roughness );\n\t\tfloat transmittanceFactor = ( transmittance.r + transmittance.g + transmittance.b ) / 3.0;\n\t\treturn vec4( ( 1.0 - F ) * attenuatedColor, 1.0 - ( 1.0 - transmittedLight.a ) * transmittanceFactor );\n\t}\n#endif",uv_pars_fragment:"#if defined( USE_UV ) || defined( USE_ANISOTROPY )\n\tvarying vec2 vUv;\n#endif\n#ifdef USE_MAP\n\tvarying vec2 vMapUv;\n#endif\n#ifdef USE_ALPHAMAP\n\tvarying vec2 vAlphaMapUv;\n#endif\n#ifdef USE_LIGHTMAP\n\tvarying vec2 vLightMapUv;\n#endif\n#ifdef USE_AOMAP\n\tvarying vec2 vAoMapUv;\n#endif\n#ifdef USE_BUMPMAP\n\tvarying vec2 vBumpMapUv;\n#endif\n#ifdef USE_NORMALMAP\n\tvarying vec2 vNormalMapUv;\n#endif\n#ifdef USE_EMISSIVEMAP\n\tvarying vec2 vEmissiveMapUv;\n#endif\n#ifdef USE_METALNESSMAP\n\tvarying vec2 vMetalnessMapUv;\n#endif\n#ifdef USE_ROUGHNESSMAP\n\tvarying vec2 vRoughnessMapUv;\n#endif\n#ifdef USE_ANISOTROPYMAP\n\tvarying vec2 vAnisotropyMapUv;\n#endif\n#ifdef USE_CLEARCOATMAP\n\tvarying vec2 vClearcoatMapUv;\n#endif\n#ifdef USE_CLEARCOAT_NORMALMAP\n\tvarying vec2 vClearcoatNormalMapUv;\n#endif\n#ifdef USE_CLEARCOAT_ROUGHNESSMAP\n\tvarying vec2 vClearcoatRoughnessMapUv;\n#endif\n#ifdef USE_IRIDESCENCEMAP\n\tvarying vec2 vIridescenceMapUv;\n#endif\n#ifdef USE_IRIDESCENCE_THICKNESSMAP\n\tvarying vec2 vIridescenceThicknessMapUv;\n#endif\n#ifdef USE_SHEEN_COLORMAP\n\tvarying vec2 vSheenColorMapUv;\n#endif\n#ifdef USE_SHEEN_ROUGHNESSMAP\n\tvarying vec2 vSheenRoughnessMapUv;\n#endif\n#ifdef USE_SPECULARMAP\n\tvarying vec2 vSpecularMapUv;\n#endif\n#ifdef USE_SPECULAR_COLORMAP\n\tvarying vec2 vSpecularColorMapUv;\n#endif\n#ifdef USE_SPECULAR_INTENSITYMAP\n\tvarying vec2 vSpecularIntensityMapUv;\n#endif\n#ifdef USE_TRANSMISSIONMAP\n\tuniform mat3 transmissionMapTransform;\n\tvarying vec2 vTransmissionMapUv;\n#endif\n#ifdef USE_THICKNESSMAP\n\tuniform mat3 thicknessMapTransform;\n\tvarying vec2 vThicknessMapUv;\n#endif",uv_pars_vertex:"#if defined( USE_UV ) || defined( USE_ANISOTROPY )\n\tvarying vec2 vUv;\n#endif\n#ifdef USE_MAP\n\tuniform mat3 mapTransform;\n\tvarying vec2 vMapUv;\n#endif\n#ifdef USE_ALPHAMAP\n\tuniform mat3 alphaMapTransform;\n\tvarying vec2 vAlphaMapUv;\n#endif\n#ifdef USE_LIGHTMAP\n\tuniform mat3 lightMapTransform;\n\tvarying vec2 vLightMapUv;\n#endif\n#ifdef USE_AOMAP\n\tuniform mat3 aoMapTransform;\n\tvarying vec2 vAoMapUv;\n#endif\n#ifdef USE_BUMPMAP\n\tuniform mat3 bumpMapTransform;\n\tvarying vec2 vBumpMapUv;\n#endif\n#ifdef USE_NORMALMAP\n\tuniform mat3 normalMapTransform;\n\tvarying vec2 vNormalMapUv;\n#endif\n#ifdef USE_DISPLACEMENTMAP\n\tuniform mat3 displacementMapTransform;\n\tvarying vec2 vDisplacementMapUv;\n#endif\n#ifdef USE_EMISSIVEMAP\n\tuniform mat3 emissiveMapTransform;\n\tvarying vec2 vEmissiveMapUv;\n#endif\n#ifdef USE_METALNESSMAP\n\tuniform mat3 metalnessMapTransform;\n\tvarying vec2 vMetalnessMapUv;\n#endif\n#ifdef USE_ROUGHNESSMAP\n\tuniform mat3 roughnessMapTransform;\n\tvarying vec2 vRoughnessMapUv;\n#endif\n#ifdef USE_ANISOTROPYMAP\n\tuniform mat3 anisotropyMapTransform;\n\tvarying vec2 vAnisotropyMapUv;\n#endif\n#ifdef USE_CLEARCOATMAP\n\tuniform mat3 clearcoatMapTransform;\n\tvarying vec2 vClearcoatMapUv;\n#endif\n#ifdef USE_CLEARCOAT_NORMALMAP\n\tuniform mat3 clearcoatNormalMapTransform;\n\tvarying vec2 vClearcoatNormalMapUv;\n#endif\n#ifdef USE_CLEARCOAT_ROUGHNESSMAP\n\tuniform mat3 clearcoatRoughnessMapTransform;\n\tvarying vec2 vClearcoatRoughnessMapUv;\n#endif\n#ifdef USE_SHEEN_COLORMAP\n\tuniform mat3 sheenColorMapTransform;\n\tvarying vec2 vSheenColorMapUv;\n#endif\n#ifdef USE_SHEEN_ROUGHNESSMAP\n\tuniform mat3 sheenRoughnessMapTransform;\n\tvarying vec2 vSheenRoughnessMapUv;\n#endif\n#ifdef USE_IRIDESCENCEMAP\n\tuniform mat3 iridescenceMapTransform;\n\tvarying vec2 vIridescenceMapUv;\n#endif\n#ifdef USE_IRIDESCENCE_THICKNESSMAP\n\tuniform mat3 iridescenceThicknessMapTransform;\n\tvarying vec2 vIridescenceThicknessMapUv;\n#endif\n#ifdef USE_SPECULARMAP\n\tuniform mat3 specularMapTransform;\n\tvarying vec2 vSpecularMapUv;\n#endif\n#ifdef USE_SPECULAR_COLORMAP\n\tuniform mat3 specularColorMapTransform;\n\tvarying vec2 vSpecularColorMapUv;\n#endif\n#ifdef USE_SPECULAR_INTENSITYMAP\n\tuniform mat3 specularIntensityMapTransform;\n\tvarying vec2 vSpecularIntensityMapUv;\n#endif\n#ifdef USE_TRANSMISSIONMAP\n\tuniform mat3 transmissionMapTransform;\n\tvarying vec2 vTransmissionMapUv;\n#endif\n#ifdef USE_THICKNESSMAP\n\tuniform mat3 thicknessMapTransform;\n\tvarying vec2 vThicknessMapUv;\n#endif",uv_vertex:"#if defined( USE_UV ) || defined( USE_ANISOTROPY )\n\tvUv = vec3( uv, 1 ).xy;\n#endif\n#ifdef USE_MAP\n\tvMapUv = ( mapTransform * vec3( MAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_ALPHAMAP\n\tvAlphaMapUv = ( alphaMapTransform * vec3( ALPHAMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_LIGHTMAP\n\tvLightMapUv = ( lightMapTransform * vec3( LIGHTMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_AOMAP\n\tvAoMapUv = ( aoMapTransform * vec3( AOMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_BUMPMAP\n\tvBumpMapUv = ( bumpMapTransform * vec3( BUMPMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_NORMALMAP\n\tvNormalMapUv = ( normalMapTransform * vec3( NORMALMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_DISPLACEMENTMAP\n\tvDisplacementMapUv = ( displacementMapTransform * vec3( DISPLACEMENTMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_EMISSIVEMAP\n\tvEmissiveMapUv = ( emissiveMapTransform * vec3( EMISSIVEMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_METALNESSMAP\n\tvMetalnessMapUv = ( metalnessMapTransform * vec3( METALNESSMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_ROUGHNESSMAP\n\tvRoughnessMapUv = ( roughnessMapTransform * vec3( ROUGHNESSMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_ANISOTROPYMAP\n\tvAnisotropyMapUv = ( anisotropyMapTransform * vec3( ANISOTROPYMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_CLEARCOATMAP\n\tvClearcoatMapUv = ( clearcoatMapTransform * vec3( CLEARCOATMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_CLEARCOAT_NORMALMAP\n\tvClearcoatNormalMapUv = ( clearcoatNormalMapTransform * vec3( CLEARCOAT_NORMALMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_CLEARCOAT_ROUGHNESSMAP\n\tvClearcoatRoughnessMapUv = ( clearcoatRoughnessMapTransform * vec3( CLEARCOAT_ROUGHNESSMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_IRIDESCENCEMAP\n\tvIridescenceMapUv = ( iridescenceMapTransform * vec3( IRIDESCENCEMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_IRIDESCENCE_THICKNESSMAP\n\tvIridescenceThicknessMapUv = ( iridescenceThicknessMapTransform * vec3( IRIDESCENCE_THICKNESSMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_SHEEN_COLORMAP\n\tvSheenColorMapUv = ( sheenColorMapTransform * vec3( SHEEN_COLORMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_SHEEN_ROUGHNESSMAP\n\tvSheenRoughnessMapUv = ( sheenRoughnessMapTransform * vec3( SHEEN_ROUGHNESSMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_SPECULARMAP\n\tvSpecularMapUv = ( specularMapTransform * vec3( SPECULARMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_SPECULAR_COLORMAP\n\tvSpecularColorMapUv = ( specularColorMapTransform * vec3( SPECULAR_COLORMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_SPECULAR_INTENSITYMAP\n\tvSpecularIntensityMapUv = ( specularIntensityMapTransform * vec3( SPECULAR_INTENSITYMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_TRANSMISSIONMAP\n\tvTransmissionMapUv = ( transmissionMapTransform * vec3( TRANSMISSIONMAP_UV, 1 ) ).xy;\n#endif\n#ifdef USE_THICKNESSMAP\n\tvThicknessMapUv = ( thicknessMapTransform * vec3( THICKNESSMAP_UV, 1 ) ).xy;\n#endif",worldpos_vertex:"#if defined( USE_ENVMAP ) || defined( DISTANCE ) || defined ( USE_SHADOWMAP ) || defined ( USE_TRANSMISSION ) || NUM_SPOT_LIGHT_COORDS > 0\n\tvec4 worldPosition = vec4( transformed, 1.0 );\n\t#ifdef USE_INSTANCING\n\t\tworldPosition = instanceMatrix * worldPosition;\n\t#endif\n\tworldPosition = modelMatrix * worldPosition;\n#endif",background_vert:"varying vec2 vUv;\nuniform mat3 uvTransform;\nvoid main() {\n\tvUv = ( uvTransform * vec3( uv, 1 ) ).xy;\n\tgl_Position = vec4( position.xy, 1.0, 1.0 );\n}",background_frag:"uniform sampler2D t2D;\nuniform float backgroundIntensity;\nvarying vec2 vUv;\nvoid main() {\n\tvec4 texColor = texture2D( t2D, vUv );\n\ttexColor.rgb *= backgroundIntensity;\n\tgl_FragColor = texColor;\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n}",backgroundCube_vert:"varying vec3 vWorldDirection;\n#include <common>\nvoid main() {\n\tvWorldDirection = transformDirection( position, modelMatrix );\n\t#include <begin_vertex>\n\t#include <project_vertex>\n\tgl_Position.z = gl_Position.w;\n}",backgroundCube_frag:"#ifdef ENVMAP_TYPE_CUBE\n\tuniform samplerCube envMap;\n#elif defined( ENVMAP_TYPE_CUBE_UV )\n\tuniform sampler2D envMap;\n#endif\nuniform float flipEnvMap;\nuniform float backgroundBlurriness;\nuniform float backgroundIntensity;\nvarying vec3 vWorldDirection;\n#include <cube_uv_reflection_fragment>\nvoid main() {\n\t#ifdef ENVMAP_TYPE_CUBE\n\t\tvec4 texColor = textureCube( envMap, vec3( flipEnvMap * vWorldDirection.x, vWorldDirection.yz ) );\n\t#elif defined( ENVMAP_TYPE_CUBE_UV )\n\t\tvec4 texColor = textureCubeUV( envMap, vWorldDirection, backgroundBlurriness );\n\t#else\n\t\tvec4 texColor = vec4( 0.0, 0.0, 0.0, 1.0 );\n\t#endif\n\ttexColor.rgb *= backgroundIntensity;\n\tgl_FragColor = texColor;\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n}",cube_vert:"varying vec3 vWorldDirection;\n#include <common>\nvoid main() {\n\tvWorldDirection = transformDirection( position, modelMatrix );\n\t#include <begin_vertex>\n\t#include <project_vertex>\n\tgl_Position.z = gl_Position.w;\n}",cube_frag:"uniform samplerCube tCube;\nuniform float tFlip;\nuniform float opacity;\nvarying vec3 vWorldDirection;\nvoid main() {\n\tvec4 texColor = textureCube( tCube, vec3( tFlip * vWorldDirection.x, vWorldDirection.yz ) );\n\tgl_FragColor = texColor;\n\tgl_FragColor.a *= opacity;\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n}",depth_vert:"#include <common>\n#include <uv_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\nvarying vec2 vHighPrecisionZW;\nvoid main() {\n\t#include <uv_vertex>\n\t#include <skinbase_vertex>\n\t#ifdef USE_DISPLACEMENTMAP\n\t\t#include <beginnormal_vertex>\n\t\t#include <morphnormal_vertex>\n\t\t#include <skinnormal_vertex>\n\t#endif\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\tvHighPrecisionZW = gl_Position.zw;\n}",depth_frag:"#if DEPTH_PACKING == 3200\n\tuniform float opacity;\n#endif\n#include <common>\n#include <packing>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <alphatest_pars_fragment>\n#include <alphahash_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvarying vec2 vHighPrecisionZW;\nvoid main() {\n\t#include <clipping_planes_fragment>\n\tvec4 diffuseColor = vec4( 1.0 );\n\t#if DEPTH_PACKING == 3200\n\t\tdiffuseColor.a = opacity;\n\t#endif\n\t#include <map_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <alphahash_fragment>\n\t#include <logdepthbuf_fragment>\n\tfloat fragCoordZ = 0.5 * vHighPrecisionZW[0] / vHighPrecisionZW[1] + 0.5;\n\t#if DEPTH_PACKING == 3200\n\t\tgl_FragColor = vec4( vec3( 1.0 - fragCoordZ ), opacity );\n\t#elif DEPTH_PACKING == 3201\n\t\tgl_FragColor = packDepthToRGBA( fragCoordZ );\n\t#endif\n}",distanceRGBA_vert:"#define DISTANCE\nvarying vec3 vWorldPosition;\n#include <common>\n#include <uv_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <clipping_planes_pars_vertex>\nvoid main() {\n\t#include <uv_vertex>\n\t#include <skinbase_vertex>\n\t#ifdef USE_DISPLACEMENTMAP\n\t\t#include <beginnormal_vertex>\n\t\t#include <morphnormal_vertex>\n\t\t#include <skinnormal_vertex>\n\t#endif\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <worldpos_vertex>\n\t#include <clipping_planes_vertex>\n\tvWorldPosition = worldPosition.xyz;\n}",distanceRGBA_frag:"#define DISTANCE\nuniform vec3 referencePosition;\nuniform float nearDistance;\nuniform float farDistance;\nvarying vec3 vWorldPosition;\n#include <common>\n#include <packing>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <alphatest_pars_fragment>\n#include <alphahash_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvoid main () {\n\t#include <clipping_planes_fragment>\n\tvec4 diffuseColor = vec4( 1.0 );\n\t#include <map_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <alphahash_fragment>\n\tfloat dist = length( vWorldPosition - referencePosition );\n\tdist = ( dist - nearDistance ) / ( farDistance - nearDistance );\n\tdist = saturate( dist );\n\tgl_FragColor = packDepthToRGBA( dist );\n}",equirect_vert:"varying vec3 vWorldDirection;\n#include <common>\nvoid main() {\n\tvWorldDirection = transformDirection( position, modelMatrix );\n\t#include <begin_vertex>\n\t#include <project_vertex>\n}",equirect_frag:"uniform sampler2D tEquirect;\nvarying vec3 vWorldDirection;\n#include <common>\nvoid main() {\n\tvec3 direction = normalize( vWorldDirection );\n\tvec2 sampleUV = equirectUv( direction );\n\tgl_FragColor = texture2D( tEquirect, sampleUV );\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n}",linedashed_vert:"uniform float scale;\nattribute float lineDistance;\nvarying float vLineDistance;\n#include <common>\n#include <uv_pars_vertex>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\nvoid main() {\n\tvLineDistance = scale * lineDistance;\n\t#include <uv_vertex>\n\t#include <color_vertex>\n\t#include <morphcolor_vertex>\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t#include <fog_vertex>\n}",linedashed_frag:"uniform vec3 diffuse;\nuniform float opacity;\nuniform float dashSize;\nuniform float totalSize;\nvarying float vLineDistance;\n#include <common>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <fog_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvoid main() {\n\t#include <clipping_planes_fragment>\n\tif ( mod( vLineDistance, totalSize ) > dashSize ) {\n\t\tdiscard;\n\t}\n\tvec3 outgoingLight = vec3( 0.0 );\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <color_fragment>\n\toutgoingLight = diffuseColor.rgb;\n\t#include <opaque_fragment>\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n\t#include <fog_fragment>\n\t#include <premultiplied_alpha_fragment>\n}",meshbasic_vert:"#include <common>\n#include <uv_pars_vertex>\n#include <envmap_pars_vertex>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\nvoid main() {\n\t#include <uv_vertex>\n\t#include <color_vertex>\n\t#include <morphcolor_vertex>\n\t#if defined ( USE_ENVMAP ) || defined ( USE_SKINNING )\n\t\t#include <beginnormal_vertex>\n\t\t#include <morphnormal_vertex>\n\t\t#include <skinbase_vertex>\n\t\t#include <skinnormal_vertex>\n\t\t#include <defaultnormal_vertex>\n\t#endif\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t#include <worldpos_vertex>\n\t#include <envmap_vertex>\n\t#include <fog_vertex>\n}",meshbasic_frag:"uniform vec3 diffuse;\nuniform float opacity;\n#ifndef FLAT_SHADED\n\tvarying vec3 vNormal;\n#endif\n#include <common>\n#include <dithering_pars_fragment>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <alphatest_pars_fragment>\n#include <alphahash_pars_fragment>\n#include <aomap_pars_fragment>\n#include <lightmap_pars_fragment>\n#include <envmap_common_pars_fragment>\n#include <envmap_pars_fragment>\n#include <fog_pars_fragment>\n#include <specularmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvoid main() {\n\t#include <clipping_planes_fragment>\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <color_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <alphahash_fragment>\n\t#include <specularmap_fragment>\n\tReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\n\t#ifdef USE_LIGHTMAP\n\t\tvec4 lightMapTexel = texture2D( lightMap, vLightMapUv );\n\t\treflectedLight.indirectDiffuse += lightMapTexel.rgb * lightMapIntensity * RECIPROCAL_PI;\n\t#else\n\t\treflectedLight.indirectDiffuse += vec3( 1.0 );\n\t#endif\n\t#include <aomap_fragment>\n\treflectedLight.indirectDiffuse *= diffuseColor.rgb;\n\tvec3 outgoingLight = reflectedLight.indirectDiffuse;\n\t#include <envmap_fragment>\n\t#include <opaque_fragment>\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n\t#include <fog_fragment>\n\t#include <premultiplied_alpha_fragment>\n\t#include <dithering_fragment>\n}",meshlambert_vert:"#define LAMBERT\nvarying vec3 vViewPosition;\n#include <common>\n#include <uv_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <envmap_pars_vertex>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <normal_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <shadowmap_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\nvoid main() {\n\t#include <uv_vertex>\n\t#include <color_vertex>\n\t#include <morphcolor_vertex>\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\t#include <normal_vertex>\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\tvViewPosition = - mvPosition.xyz;\n\t#include <worldpos_vertex>\n\t#include <envmap_vertex>\n\t#include <shadowmap_vertex>\n\t#include <fog_vertex>\n}",meshlambert_frag:"#define LAMBERT\nuniform vec3 diffuse;\nuniform vec3 emissive;\nuniform float opacity;\n#include <common>\n#include <packing>\n#include <dithering_pars_fragment>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <alphatest_pars_fragment>\n#include <alphahash_pars_fragment>\n#include <aomap_pars_fragment>\n#include <lightmap_pars_fragment>\n#include <emissivemap_pars_fragment>\n#include <envmap_common_pars_fragment>\n#include <envmap_pars_fragment>\n#include <fog_pars_fragment>\n#include <bsdfs>\n#include <lights_pars_begin>\n#include <normal_pars_fragment>\n#include <lights_lambert_pars_fragment>\n#include <shadowmap_pars_fragment>\n#include <bumpmap_pars_fragment>\n#include <normalmap_pars_fragment>\n#include <specularmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvoid main() {\n\t#include <clipping_planes_fragment>\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\tReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\n\tvec3 totalEmissiveRadiance = emissive;\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <color_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <alphahash_fragment>\n\t#include <specularmap_fragment>\n\t#include <normal_fragment_begin>\n\t#include <normal_fragment_maps>\n\t#include <emissivemap_fragment>\n\t#include <lights_lambert_fragment>\n\t#include <lights_fragment_begin>\n\t#include <lights_fragment_maps>\n\t#include <lights_fragment_end>\n\t#include <aomap_fragment>\n\tvec3 outgoingLight = reflectedLight.directDiffuse + reflectedLight.indirectDiffuse + totalEmissiveRadiance;\n\t#include <envmap_fragment>\n\t#include <opaque_fragment>\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n\t#include <fog_fragment>\n\t#include <premultiplied_alpha_fragment>\n\t#include <dithering_fragment>\n}",meshmatcap_vert:"#define MATCAP\nvarying vec3 vViewPosition;\n#include <common>\n#include <uv_pars_vertex>\n#include <color_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <fog_pars_vertex>\n#include <normal_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\nvoid main() {\n\t#include <uv_vertex>\n\t#include <color_vertex>\n\t#include <morphcolor_vertex>\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\t#include <normal_vertex>\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t#include <fog_vertex>\n\tvViewPosition = - mvPosition.xyz;\n}",meshmatcap_frag:"#define MATCAP\nuniform vec3 diffuse;\nuniform float opacity;\nuniform sampler2D matcap;\nvarying vec3 vViewPosition;\n#include <common>\n#include <dithering_pars_fragment>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <alphatest_pars_fragment>\n#include <alphahash_pars_fragment>\n#include <fog_pars_fragment>\n#include <normal_pars_fragment>\n#include <bumpmap_pars_fragment>\n#include <normalmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvoid main() {\n\t#include <clipping_planes_fragment>\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <color_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <alphahash_fragment>\n\t#include <normal_fragment_begin>\n\t#include <normal_fragment_maps>\n\tvec3 viewDir = normalize( vViewPosition );\n\tvec3 x = normalize( vec3( viewDir.z, 0.0, - viewDir.x ) );\n\tvec3 y = cross( viewDir, x );\n\tvec2 uv = vec2( dot( x, normal ), dot( y, normal ) ) * 0.495 + 0.5;\n\t#ifdef USE_MATCAP\n\t\tvec4 matcapColor = texture2D( matcap, uv );\n\t#else\n\t\tvec4 matcapColor = vec4( vec3( mix( 0.2, 0.8, uv.y ) ), 1.0 );\n\t#endif\n\tvec3 outgoingLight = diffuseColor.rgb * matcapColor.rgb;\n\t#include <opaque_fragment>\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n\t#include <fog_fragment>\n\t#include <premultiplied_alpha_fragment>\n\t#include <dithering_fragment>\n}",meshnormal_vert:"#define NORMAL\n#if defined( FLAT_SHADED ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP_TANGENTSPACE )\n\tvarying vec3 vViewPosition;\n#endif\n#include <common>\n#include <uv_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <normal_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\nvoid main() {\n\t#include <uv_vertex>\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\t#include <normal_vertex>\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n#if defined( FLAT_SHADED ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP_TANGENTSPACE )\n\tvViewPosition = - mvPosition.xyz;\n#endif\n}",meshnormal_frag:"#define NORMAL\nuniform float opacity;\n#if defined( FLAT_SHADED ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP_TANGENTSPACE )\n\tvarying vec3 vViewPosition;\n#endif\n#include <packing>\n#include <uv_pars_fragment>\n#include <normal_pars_fragment>\n#include <bumpmap_pars_fragment>\n#include <normalmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvoid main() {\n\t#include <clipping_planes_fragment>\n\t#include <logdepthbuf_fragment>\n\t#include <normal_fragment_begin>\n\t#include <normal_fragment_maps>\n\tgl_FragColor = vec4( packNormalToRGB( normal ), opacity );\n\t#ifdef OPAQUE\n\t\tgl_FragColor.a = 1.0;\n\t#endif\n}",meshphong_vert:"#define PHONG\nvarying vec3 vViewPosition;\n#include <common>\n#include <uv_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <envmap_pars_vertex>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <normal_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <shadowmap_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\nvoid main() {\n\t#include <uv_vertex>\n\t#include <color_vertex>\n\t#include <morphcolor_vertex>\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\t#include <normal_vertex>\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\tvViewPosition = - mvPosition.xyz;\n\t#include <worldpos_vertex>\n\t#include <envmap_vertex>\n\t#include <shadowmap_vertex>\n\t#include <fog_vertex>\n}",meshphong_frag:"#define PHONG\nuniform vec3 diffuse;\nuniform vec3 emissive;\nuniform vec3 specular;\nuniform float shininess;\nuniform float opacity;\n#include <common>\n#include <packing>\n#include <dithering_pars_fragment>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <alphatest_pars_fragment>\n#include <alphahash_pars_fragment>\n#include <aomap_pars_fragment>\n#include <lightmap_pars_fragment>\n#include <emissivemap_pars_fragment>\n#include <envmap_common_pars_fragment>\n#include <envmap_pars_fragment>\n#include <fog_pars_fragment>\n#include <bsdfs>\n#include <lights_pars_begin>\n#include <normal_pars_fragment>\n#include <lights_phong_pars_fragment>\n#include <shadowmap_pars_fragment>\n#include <bumpmap_pars_fragment>\n#include <normalmap_pars_fragment>\n#include <specularmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvoid main() {\n\t#include <clipping_planes_fragment>\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\tReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\n\tvec3 totalEmissiveRadiance = emissive;\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <color_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <alphahash_fragment>\n\t#include <specularmap_fragment>\n\t#include <normal_fragment_begin>\n\t#include <normal_fragment_maps>\n\t#include <emissivemap_fragment>\n\t#include <lights_phong_fragment>\n\t#include <lights_fragment_begin>\n\t#include <lights_fragment_maps>\n\t#include <lights_fragment_end>\n\t#include <aomap_fragment>\n\tvec3 outgoingLight = reflectedLight.directDiffuse + reflectedLight.indirectDiffuse + reflectedLight.directSpecular + reflectedLight.indirectSpecular + totalEmissiveRadiance;\n\t#include <envmap_fragment>\n\t#include <opaque_fragment>\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n\t#include <fog_fragment>\n\t#include <premultiplied_alpha_fragment>\n\t#include <dithering_fragment>\n}",meshphysical_vert:"#define STANDARD\nvarying vec3 vViewPosition;\n#ifdef USE_TRANSMISSION\n\tvarying vec3 vWorldPosition;\n#endif\n#include <common>\n#include <uv_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <normal_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <shadowmap_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\nvoid main() {\n\t#include <uv_vertex>\n\t#include <color_vertex>\n\t#include <morphcolor_vertex>\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\t#include <normal_vertex>\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\tvViewPosition = - mvPosition.xyz;\n\t#include <worldpos_vertex>\n\t#include <shadowmap_vertex>\n\t#include <fog_vertex>\n#ifdef USE_TRANSMISSION\n\tvWorldPosition = worldPosition.xyz;\n#endif\n}",meshphysical_frag:"#define STANDARD\n#ifdef PHYSICAL\n\t#define IOR\n\t#define USE_SPECULAR\n#endif\nuniform vec3 diffuse;\nuniform vec3 emissive;\nuniform float roughness;\nuniform float metalness;\nuniform float opacity;\n#ifdef IOR\n\tuniform float ior;\n#endif\n#ifdef USE_SPECULAR\n\tuniform float specularIntensity;\n\tuniform vec3 specularColor;\n\t#ifdef USE_SPECULAR_COLORMAP\n\t\tuniform sampler2D specularColorMap;\n\t#endif\n\t#ifdef USE_SPECULAR_INTENSITYMAP\n\t\tuniform sampler2D specularIntensityMap;\n\t#endif\n#endif\n#ifdef USE_CLEARCOAT\n\tuniform float clearcoat;\n\tuniform float clearcoatRoughness;\n#endif\n#ifdef USE_IRIDESCENCE\n\tuniform float iridescence;\n\tuniform float iridescenceIOR;\n\tuniform float iridescenceThicknessMinimum;\n\tuniform float iridescenceThicknessMaximum;\n#endif\n#ifdef USE_SHEEN\n\tuniform vec3 sheenColor;\n\tuniform float sheenRoughness;\n\t#ifdef USE_SHEEN_COLORMAP\n\t\tuniform sampler2D sheenColorMap;\n\t#endif\n\t#ifdef USE_SHEEN_ROUGHNESSMAP\n\t\tuniform sampler2D sheenRoughnessMap;\n\t#endif\n#endif\n#ifdef USE_ANISOTROPY\n\tuniform vec2 anisotropyVector;\n\t#ifdef USE_ANISOTROPYMAP\n\t\tuniform sampler2D anisotropyMap;\n\t#endif\n#endif\nvarying vec3 vViewPosition;\n#include <common>\n#include <packing>\n#include <dithering_pars_fragment>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <alphatest_pars_fragment>\n#include <alphahash_pars_fragment>\n#include <aomap_pars_fragment>\n#include <lightmap_pars_fragment>\n#include <emissivemap_pars_fragment>\n#include <iridescence_fragment>\n#include <cube_uv_reflection_fragment>\n#include <envmap_common_pars_fragment>\n#include <envmap_physical_pars_fragment>\n#include <fog_pars_fragment>\n#include <lights_pars_begin>\n#include <normal_pars_fragment>\n#include <lights_physical_pars_fragment>\n#include <transmission_pars_fragment>\n#include <shadowmap_pars_fragment>\n#include <bumpmap_pars_fragment>\n#include <normalmap_pars_fragment>\n#include <clearcoat_pars_fragment>\n#include <iridescence_pars_fragment>\n#include <roughnessmap_pars_fragment>\n#include <metalnessmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvoid main() {\n\t#include <clipping_planes_fragment>\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\tReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\n\tvec3 totalEmissiveRadiance = emissive;\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <color_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <alphahash_fragment>\n\t#include <roughnessmap_fragment>\n\t#include <metalnessmap_fragment>\n\t#include <normal_fragment_begin>\n\t#include <normal_fragment_maps>\n\t#include <clearcoat_normal_fragment_begin>\n\t#include <clearcoat_normal_fragment_maps>\n\t#include <emissivemap_fragment>\n\t#include <lights_physical_fragment>\n\t#include <lights_fragment_begin>\n\t#include <lights_fragment_maps>\n\t#include <lights_fragment_end>\n\t#include <aomap_fragment>\n\tvec3 totalDiffuse = reflectedLight.directDiffuse + reflectedLight.indirectDiffuse;\n\tvec3 totalSpecular = reflectedLight.directSpecular + reflectedLight.indirectSpecular;\n\t#include <transmission_fragment>\n\tvec3 outgoingLight = totalDiffuse + totalSpecular + totalEmissiveRadiance;\n\t#ifdef USE_SHEEN\n\t\tfloat sheenEnergyComp = 1.0 - 0.157 * max3( material.sheenColor );\n\t\toutgoingLight = outgoingLight * sheenEnergyComp + sheenSpecular;\n\t#endif\n\t#ifdef USE_CLEARCOAT\n\t\tfloat dotNVcc = saturate( dot( geometry.clearcoatNormal, geometry.viewDir ) );\n\t\tvec3 Fcc = F_Schlick( material.clearcoatF0, material.clearcoatF90, dotNVcc );\n\t\toutgoingLight = outgoingLight * ( 1.0 - material.clearcoat * Fcc ) + clearcoatSpecular * material.clearcoat;\n\t#endif\n\t#include <opaque_fragment>\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n\t#include <fog_fragment>\n\t#include <premultiplied_alpha_fragment>\n\t#include <dithering_fragment>\n}",meshtoon_vert:"#define TOON\nvarying vec3 vViewPosition;\n#include <common>\n#include <uv_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <normal_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <shadowmap_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\nvoid main() {\n\t#include <uv_vertex>\n\t#include <color_vertex>\n\t#include <morphcolor_vertex>\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\t#include <normal_vertex>\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\tvViewPosition = - mvPosition.xyz;\n\t#include <worldpos_vertex>\n\t#include <shadowmap_vertex>\n\t#include <fog_vertex>\n}",meshtoon_frag:"#define TOON\nuniform vec3 diffuse;\nuniform vec3 emissive;\nuniform float opacity;\n#include <common>\n#include <packing>\n#include <dithering_pars_fragment>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <alphatest_pars_fragment>\n#include <alphahash_pars_fragment>\n#include <aomap_pars_fragment>\n#include <lightmap_pars_fragment>\n#include <emissivemap_pars_fragment>\n#include <gradientmap_pars_fragment>\n#include <fog_pars_fragment>\n#include <bsdfs>\n#include <lights_pars_begin>\n#include <normal_pars_fragment>\n#include <lights_toon_pars_fragment>\n#include <shadowmap_pars_fragment>\n#include <bumpmap_pars_fragment>\n#include <normalmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvoid main() {\n\t#include <clipping_planes_fragment>\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\tReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\n\tvec3 totalEmissiveRadiance = emissive;\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <color_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <alphahash_fragment>\n\t#include <normal_fragment_begin>\n\t#include <normal_fragment_maps>\n\t#include <emissivemap_fragment>\n\t#include <lights_toon_fragment>\n\t#include <lights_fragment_begin>\n\t#include <lights_fragment_maps>\n\t#include <lights_fragment_end>\n\t#include <aomap_fragment>\n\tvec3 outgoingLight = reflectedLight.directDiffuse + reflectedLight.indirectDiffuse + totalEmissiveRadiance;\n\t#include <opaque_fragment>\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n\t#include <fog_fragment>\n\t#include <premultiplied_alpha_fragment>\n\t#include <dithering_fragment>\n}",points_vert:"uniform float size;\nuniform float scale;\n#include <common>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n#ifdef USE_POINTS_UV\n\tvarying vec2 vUv;\n\tuniform mat3 uvTransform;\n#endif\nvoid main() {\n\t#ifdef USE_POINTS_UV\n\t\tvUv = ( uvTransform * vec3( uv, 1 ) ).xy;\n\t#endif\n\t#include <color_vertex>\n\t#include <morphcolor_vertex>\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <project_vertex>\n\tgl_PointSize = size;\n\t#ifdef USE_SIZEATTENUATION\n\t\tbool isPerspective = isPerspectiveMatrix( projectionMatrix );\n\t\tif ( isPerspective ) gl_PointSize *= ( scale / - mvPosition.z );\n\t#endif\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t#include <worldpos_vertex>\n\t#include <fog_vertex>\n}",points_frag:"uniform vec3 diffuse;\nuniform float opacity;\n#include <common>\n#include <color_pars_fragment>\n#include <map_particle_pars_fragment>\n#include <alphatest_pars_fragment>\n#include <alphahash_pars_fragment>\n#include <fog_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvoid main() {\n\t#include <clipping_planes_fragment>\n\tvec3 outgoingLight = vec3( 0.0 );\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\t#include <logdepthbuf_fragment>\n\t#include <map_particle_fragment>\n\t#include <color_fragment>\n\t#include <alphatest_fragment>\n\t#include <alphahash_fragment>\n\toutgoingLight = diffuseColor.rgb;\n\t#include <opaque_fragment>\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n\t#include <fog_fragment>\n\t#include <premultiplied_alpha_fragment>\n}",shadow_vert:"#include <common>\n#include <fog_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <shadowmap_pars_vertex>\nvoid main() {\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <worldpos_vertex>\n\t#include <shadowmap_vertex>\n\t#include <fog_vertex>\n}",shadow_frag:"uniform vec3 color;\nuniform float opacity;\n#include <common>\n#include <packing>\n#include <fog_pars_fragment>\n#include <bsdfs>\n#include <lights_pars_begin>\n#include <logdepthbuf_pars_fragment>\n#include <shadowmap_pars_fragment>\n#include <shadowmask_pars_fragment>\nvoid main() {\n\t#include <logdepthbuf_fragment>\n\tgl_FragColor = vec4( color, opacity * ( 1.0 - getShadowMask() ) );\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n\t#include <fog_fragment>\n}",sprite_vert:"uniform float rotation;\nuniform vec2 center;\n#include <common>\n#include <uv_pars_vertex>\n#include <fog_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\nvoid main() {\n\t#include <uv_vertex>\n\tvec4 mvPosition = modelViewMatrix * vec4( 0.0, 0.0, 0.0, 1.0 );\n\tvec2 scale;\n\tscale.x = length( vec3( modelMatrix[ 0 ].x, modelMatrix[ 0 ].y, modelMatrix[ 0 ].z ) );\n\tscale.y = length( vec3( modelMatrix[ 1 ].x, modelMatrix[ 1 ].y, modelMatrix[ 1 ].z ) );\n\t#ifndef USE_SIZEATTENUATION\n\t\tbool isPerspective = isPerspectiveMatrix( projectionMatrix );\n\t\tif ( isPerspective ) scale *= - mvPosition.z;\n\t#endif\n\tvec2 alignedPosition = ( position.xy - ( center - vec2( 0.5 ) ) ) * scale;\n\tvec2 rotatedPosition;\n\trotatedPosition.x = cos( rotation ) * alignedPosition.x - sin( rotation ) * alignedPosition.y;\n\trotatedPosition.y = sin( rotation ) * alignedPosition.x + cos( rotation ) * alignedPosition.y;\n\tmvPosition.xy += rotatedPosition;\n\tgl_Position = projectionMatrix * mvPosition;\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t#include <fog_vertex>\n}",sprite_frag:"uniform vec3 diffuse;\nuniform float opacity;\n#include <common>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <alphatest_pars_fragment>\n#include <alphahash_pars_fragment>\n#include <fog_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\nvoid main() {\n\t#include <clipping_planes_fragment>\n\tvec3 outgoingLight = vec3( 0.0 );\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <alphahash_fragment>\n\toutgoingLight = diffuseColor.rgb;\n\t#include <opaque_fragment>\n\t#include <tonemapping_fragment>\n\t#include <colorspace_fragment>\n\t#include <fog_fragment>\n}"},Ef={common:{diffuse:{value:new bd(16777215)},opacity:{value:1},map:{value:null},mapTransform:{value:new Cl},alphaMap:{value:null},alphaMapTransform:{value:new Cl},alphaTest:{value:0}},specularmap:{specularMap:{value:null},specularMapTransform:{value:new Cl}},envmap:{envMap:{value:null},flipEnvMap:{value:-1},reflectivity:{value:1},ior:{value:1.5},refractionRatio:{value:.98}},aomap:{aoMap:{value:null},aoMapIntensity:{value:1},aoMapTransform:{value:new Cl}},lightmap:{lightMap:{value:null},lightMapIntensity:{value:1},lightMapTransform:{value:new Cl}},bumpmap:{bumpMap:{value:null},bumpMapTransform:{value:new Cl},bumpScale:{value:1}},normalmap:{normalMap:{value:null},normalMapTransform:{value:new Cl},normalScale:{value:new Sl(1,1)}},displacementmap:{displacementMap:{value:null},displacementMapTransform:{value:new Cl},displacementScale:{value:1},displacementBias:{value:0}},emissivemap:{emissiveMap:{value:null},emissiveMapTransform:{value:new Cl}},metalnessmap:{metalnessMap:{value:null},metalnessMapTransform:{value:new Cl}},roughnessmap:{roughnessMap:{value:null},roughnessMapTransform:{value:new Cl}},gradientmap:{gradientMap:{value:null}},fog:{fogDensity:{value:25e-5},fogNear:{value:1},fogFar:{value:2e3},fogColor:{value:new bd(16777215)}},lights:{ambientLightColor:{value:[]},lightProbe:{value:[]},directionalLights:{value:[],properties:{direction:{},color:{}}},directionalLightShadows:{value:[],properties:{shadowBias:{},shadowNormalBias:{},shadowRadius:{},shadowMapSize:{}}},directionalShadowMap:{value:[]},directionalShadowMatrix:{value:[]},spotLights:{value:[],properties:{color:{},position:{},direction:{},distance:{},coneCos:{},penumbraCos:{},decay:{}}},spotLightShadows:{value:[],properties:{shadowBias:{},shadowNormalBias:{},shadowRadius:{},shadowMapSize:{}}},spotLightMap:{value:[]},spotShadowMap:{value:[]},spotLightMatrix:{value:[]},pointLights:{value:[],properties:{color:{},position:{},decay:{},distance:{}}},pointLightShadows:{value:[],properties:{shadowBias:{},shadowNormalBias:{},shadowRadius:{},shadowMapSize:{},shadowCameraNear:{},shadowCameraFar:{}}},pointShadowMap:{value:[]},pointShadowMatrix:{value:[]},hemisphereLights:{value:[],properties:{direction:{},skyColor:{},groundColor:{}}},rectAreaLights:{value:[],properties:{color:{},position:{},width:{},height:{}}},ltc_1:{value:null},ltc_2:{value:null}},points:{diffuse:{value:new bd(16777215)},opacity:{value:1},size:{value:1},scale:{value:1},map:{value:null},alphaMap:{value:null},alphaMapTransform:{value:new Cl},alphaTest:{value:0},uvTransform:{value:new Cl}},sprite:{diffuse:{value:new bd(16777215)},opacity:{value:1},center:{value:new Sl(.5,.5)},rotation:{value:0},map:{value:null},mapTransform:{value:new Cl},alphaMap:{value:null},alphaMapTransform:{value:new Cl},alphaTest:{value:0}}},Tf={basic:{uniforms:nf([Ef.common,Ef.specularmap,Ef.envmap,Ef.aomap,Ef.lightmap,Ef.fog]),vertexShader:wf.meshbasic_vert,fragmentShader:wf.meshbasic_frag},lambert:{uniforms:nf([Ef.common,Ef.specularmap,Ef.envmap,Ef.aomap,Ef.lightmap,Ef.emissivemap,Ef.bumpmap,Ef.normalmap,Ef.displacementmap,Ef.fog,Ef.lights,{emissive:{value:new bd(0)}}]),vertexShader:wf.meshlambert_vert,fragmentShader:wf.meshlambert_frag},phong:{uniforms:nf([Ef.common,Ef.specularmap,Ef.envmap,Ef.aomap,Ef.lightmap,Ef.emissivemap,Ef.bumpmap,Ef.normalmap,Ef.displacementmap,Ef.fog,Ef.lights,{emissive:{value:new bd(0)},specular:{value:new bd(1118481)},shininess:{value:30}}]),vertexShader:wf.meshphong_vert,fragmentShader:wf.meshphong_frag},standard:{uniforms:nf([Ef.common,Ef.envmap,Ef.aomap,Ef.lightmap,Ef.emissivemap,Ef.bumpmap,Ef.normalmap,Ef.displacementmap,Ef.roughnessmap,Ef.metalnessmap,Ef.fog,Ef.lights,{emissive:{value:new bd(0)},roughness:{value:1},metalness:{value:0},envMapIntensity:{value:1}}]),vertexShader:wf.meshphysical_vert,fragmentShader:wf.meshphysical_frag},toon:{uniforms:nf([Ef.common,Ef.aomap,Ef.lightmap,Ef.emissivemap,Ef.bumpmap,Ef.normalmap,Ef.displacementmap,Ef.gradientmap,Ef.fog,Ef.lights,{emissive:{value:new bd(0)}}]),vertexShader:wf.meshtoon_vert,fragmentShader:wf.meshtoon_frag},matcap:{uniforms:nf([Ef.common,Ef.bumpmap,Ef.normalmap,Ef.displacementmap,Ef.fog,{matcap:{value:null}}]),vertexShader:wf.meshmatcap_vert,fragmentShader:wf.meshmatcap_frag},points:{uniforms:nf([Ef.points,Ef.fog]),vertexShader:wf.points_vert,fragmentShader:wf.points_frag},dashed:{uniforms:nf([Ef.common,Ef.fog,{scale:{value:1},dashSize:{value:1},totalSize:{value:2}}]),vertexShader:wf.linedashed_vert,fragmentShader:wf.linedashed_frag},depth:{uniforms:nf([Ef.common,Ef.displacementmap]),vertexShader:wf.depth_vert,fragmentShader:wf.depth_frag},normal:{uniforms:nf([Ef.common,Ef.bumpmap,Ef.normalmap,Ef.displacementmap,{opacity:{value:1}}]),vertexShader:wf.meshnormal_vert,fragmentShader:wf.meshnormal_frag},sprite:{uniforms:nf([Ef.sprite,Ef.fog]),vertexShader:wf.sprite_vert,fragmentShader:wf.sprite_frag},background:{uniforms:{uvTransform:{value:new Cl},t2D:{value:null},backgroundIntensity:{value:1}},vertexShader:wf.background_vert,fragmentShader:wf.background_frag},backgroundCube:{uniforms:{envMap:{value:null},flipEnvMap:{value:-1},backgroundBlurriness:{value:0},backgroundIntensity:{value:1}},vertexShader:wf.backgroundCube_vert,fragmentShader:wf.backgroundCube_frag},cube:{uniforms:{tCube:{value:null},tFlip:{value:-1},opacity:{value:1}},vertexShader:wf.cube_vert,fragmentShader:wf.cube_frag},equirect:{uniforms:{tEquirect:{value:null}},vertexShader:wf.equirect_vert,fragmentShader:wf.equirect_frag},distanceRGBA:{uniforms:nf([Ef.common,Ef.displacementmap,{referencePosition:{value:new Jl},nearDistance:{value:1},farDistance:{value:1e3}}]),vertexShader:wf.distanceRGBA_vert,fragmentShader:wf.distanceRGBA_frag},shadow:{uniforms:nf([Ef.lights,Ef.fog,{color:{value:new bd(0)},opacity:{value:1}}]),vertexShader:wf.shadow_vert,fragmentShader:wf.shadow_frag}};Tf.physical={uniforms:nf([Tf.standard.uniforms,{clearcoat:{value:0},clearcoatMap:{value:null},clearcoatMapTransform:{value:new Cl},clearcoatNormalMap:{value:null},clearcoatNormalMapTransform:{value:new Cl},clearcoatNormalScale:{value:new Sl(1,1)},clearcoatRoughness:{value:0},clearcoatRoughnessMap:{value:null},clearcoatRoughnessMapTransform:{value:new Cl},iridescence:{value:0},iridescenceMap:{value:null},iridescenceMapTransform:{value:new Cl},iridescenceIOR:{value:1.3},iridescenceThicknessMinimum:{value:100},iridescenceThicknessMaximum:{value:400},iridescenceThicknessMap:{value:null},iridescenceThicknessMapTransform:{value:new Cl},sheen:{value:0},sheenColor:{value:new bd(0)},sheenColorMap:{value:null},sheenColorMapTransform:{value:new Cl},sheenRoughness:{value:1},sheenRoughnessMap:{value:null},sheenRoughnessMapTransform:{value:new Cl},transmission:{value:0},transmissionMap:{value:null},transmissionMapTransform:{value:new Cl},transmissionSamplerSize:{value:new Sl},transmissionSamplerMap:{value:null},thickness:{value:0},thicknessMap:{value:null},thicknessMapTransform:{value:new Cl},attenuationDistance:{value:0},attenuationColor:{value:new bd(0)},specularColor:{value:new bd(1,1,1)},specularColorMap:{value:null},specularColorMapTransform:{value:new Cl},specularIntensity:{value:1},specularIntensityMap:{value:null},specularIntensityMapTransform:{value:new Cl},anisotropyVector:{value:new Sl},anisotropyMap:{value:null},anisotropyMapTransform:{value:new Cl}}]),vertexShader:wf.meshphysical_vert,fragmentShader:wf.meshphysical_frag};const Sf={r:0,b:0,g:0};function Cf(e,t,n,r,i,a,o){const s=new bd(0);let c,l,u=!0===a?0:1,d=null,f=0,h=null;function p(t,n){t.getRGB(Sf,rf(e)),r.buffers.color.setClear(Sf.r,Sf.g,Sf.b,n,o)}return{getClearColor:function(){return s},setClearColor:function(e,t=1){s.set(e),u=t,p(s,u)},getClearAlpha:function(){return u},setClearAlpha:function(e){u=e,p(s,u)},render:function(a,m){let v=!1,g=!0===m.isScene?m.background:null;switch(g&&g.isTexture&&(g=(m.backgroundBlurriness>0?n:t).get(g)),null===g?p(s,u):g&&g.isColor&&(p(g,1),v=!0),e.xr.getEnvironmentBlendMode()){case"opaque":v=!0;break;case"additive":r.buffers.color.setClear(0,0,0,1,o),v=!0;break;case"alpha-blend":r.buffers.color.setClear(0,0,0,0,o),v=!0}(e.autoClear||v)&&e.clear(e.autoClearColor,e.autoClearDepth,e.autoClearStencil),g&&(g.isCubeTexture||g.mapping===Oc)?(void 0===l&&(l=new Jd(new ef(1,1,1),new of({name:"BackgroundCubeMaterial",uniforms:tf(Tf.backgroundCube.uniforms),vertexShader:Tf.backgroundCube.vertexShader,fragmentShader:Tf.backgroundCube.fragmentShader,side:1,depthTest:!1,depthWrite:!1,fog:!1})),l.geometry.deleteAttribute("normal"),l.geometry.deleteAttribute("uv"),l.onBeforeRender=function(e,t,n){this.matrixWorld.copyPosition(n.matrixWorld)},Object.defineProperty(l.material,"envMap",{get:function(){return this.uniforms.envMap.value}}),i.update(l)),l.material.uniforms.envMap.value=g,l.material.uniforms.flipEnvMap.value=g.isCubeTexture&&!1===g.isRenderTargetTexture?-1:1,l.material.uniforms.backgroundBlurriness.value=m.backgroundBlurriness,l.material.uniforms.backgroundIntensity.value=m.backgroundIntensity,l.material.toneMapped=g.colorSpace!==il,d===g&&f===g.version&&h===e.toneMapping||(l.material.needsUpdate=!0,d=g,f=g.version,h=e.toneMapping),l.layers.enableAll(),a.unshift(l,l.geometry,l.material,0,0,null)):g&&g.isTexture&&(void 0===c&&(c=new Jd(new Af(2,2),new of({name:"BackgroundMaterial",uniforms:tf(Tf.background.uniforms),vertexShader:Tf.background.vertexShader,fragmentShader:Tf.background.fragmentShader,side:0,depthTest:!1,depthWrite:!1,fog:!1})),c.geometry.deleteAttribute("normal"),Object.defineProperty(c.material,"map",{get:function(){return this.uniforms.t2D.value}}),i.update(c)),c.material.uniforms.t2D.value=g,c.material.uniforms.backgroundIntensity.value=m.backgroundIntensity,c.material.toneMapped=g.colorSpace!==il,!0===g.matrixAutoUpdate&&g.updateMatrix(),c.material.uniforms.uvTransform.value.copy(g.matrix),d===g&&f===g.version&&h===e.toneMapping||(c.material.needsUpdate=!0,d=g,f=g.version,h=e.toneMapping),c.layers.enableAll(),a.unshift(c,c.geometry,c.material,0,0,null))}}}function Mf(e,t,n,r){const i=e.getParameter(e.MAX_VERTEX_ATTRIBS),a=r.isWebGL2?null:t.get("OES_vertex_array_object"),o=r.isWebGL2||null!==a,s={},c=h(null);let l=c,u=!1;function d(t){return r.isWebGL2?e.bindVertexArray(t):a.bindVertexArrayOES(t)}function f(t){return r.isWebGL2?e.deleteVertexArray(t):a.deleteVertexArrayOES(t)}function h(e){const t=[],n=[],r=[];for(let e=0;e<i;e++)t[e]=0,n[e]=0,r[e]=0;return{geometry:null,program:null,wireframe:!1,newAttributes:t,enabledAttributes:n,attributeDivisors:r,object:e,attributes:{},index:null}}function p(){const e=l.newAttributes;for(let t=0,n=e.length;t<n;t++)e[t]=0}function m(e){v(e,0)}function v(n,i){const a=l.newAttributes,o=l.enabledAttributes,s=l.attributeDivisors;a[n]=1,0===o[n]&&(e.enableVertexAttribArray(n),o[n]=1),s[n]!==i&&((r.isWebGL2?e:t.get("ANGLE_instanced_arrays"))[r.isWebGL2?"vertexAttribDivisor":"vertexAttribDivisorANGLE"](n,i),s[n]=i)}function g(){const t=l.newAttributes,n=l.enabledAttributes;for(let r=0,i=n.length;r<i;r++)n[r]!==t[r]&&(e.disableVertexAttribArray(r),n[r]=0)}function b(t,n,r,i,a,o,s){!0===s?e.vertexAttribIPointer(t,n,r,a,o):e.vertexAttribPointer(t,n,r,i,a,o)}function _(){y(),u=!0,l!==c&&(l=c,d(l.object))}function y(){c.geometry=null,c.program=null,c.wireframe=!1}return{setup:function(i,c,f,_,y){let x=!1;if(o){const t=function(t,n,i){const o=!0===i.wireframe;let c=s[t.id];void 0===c&&(c={},s[t.id]=c);let l=c[n.id];void 0===l&&(l={},c[n.id]=l);let u=l[o];return void 0===u&&(u=h(r.isWebGL2?e.createVertexArray():a.createVertexArrayOES()),l[o]=u),u}(_,f,c);l!==t&&(l=t,d(l.object)),x=function(e,t,n,r){const i=l.attributes,a=t.attributes;let o=0;const s=n.getAttributes();for(const t in s)if(s[t].location>=0){const n=i[t];let r=a[t];if(void 0===r&&("instanceMatrix"===t&&e.instanceMatrix&&(r=e.instanceMatrix),"instanceColor"===t&&e.instanceColor&&(r=e.instanceColor)),void 0===n)return!0;if(n.attribute!==r)return!0;if(r&&n.data!==r.data)return!0;o++}return l.attributesNum!==o||l.index!==r}(i,_,f,y),x&&function(e,t,n,r){const i={},a=t.attributes;let o=0;const s=n.getAttributes();for(const t in s)if(s[t].location>=0){let n=a[t];void 0===n&&("instanceMatrix"===t&&e.instanceMatrix&&(n=e.instanceMatrix),"instanceColor"===t&&e.instanceColor&&(n=e.instanceColor));const r={};r.attribute=n,n&&n.data&&(r.data=n.data),i[t]=r,o++}l.attributes=i,l.attributesNum=o,l.index=r}(i,_,f,y)}else{const e=!0===c.wireframe;l.geometry===_.id&&l.program===f.id&&l.wireframe===e||(l.geometry=_.id,l.program=f.id,l.wireframe=e,x=!0)}null!==y&&n.update(y,e.ELEMENT_ARRAY_BUFFER),(x||u)&&(u=!1,function(i,a,o,s){if(!1===r.isWebGL2&&(i.isInstancedMesh||s.isInstancedBufferGeometry)&&null===t.get("ANGLE_instanced_arrays"))return;p();const c=s.attributes,l=o.getAttributes(),u=a.defaultAttributeValues;for(const t in l){const a=l[t];if(a.location>=0){let o=c[t];if(void 0===o&&("instanceMatrix"===t&&i.instanceMatrix&&(o=i.instanceMatrix),"instanceColor"===t&&i.instanceColor&&(o=i.instanceColor)),void 0!==o){const t=o.normalized,c=o.itemSize,l=n.get(o);if(void 0===l)continue;const u=l.buffer,d=l.type,f=l.bytesPerElement,h=!0===r.isWebGL2&&(d===e.INT||d===e.UNSIGNED_INT||1013===o.gpuType);if(o.isInterleavedBufferAttribute){const n=o.data,r=n.stride,l=o.offset;if(n.isInstancedInterleavedBuffer){for(let e=0;e<a.locationSize;e++)v(a.location+e,n.meshPerAttribute);!0!==i.isInstancedMesh&&void 0===s._maxInstanceCount&&(s._maxInstanceCount=n.meshPerAttribute*n.count)}else for(let e=0;e<a.locationSize;e++)m(a.location+e);e.bindBuffer(e.ARRAY_BUFFER,u);for(let e=0;e<a.locationSize;e++)b(a.location+e,c/a.locationSize,d,t,r*f,(l+c/a.locationSize*e)*f,h)}else{if(o.isInstancedBufferAttribute){for(let e=0;e<a.locationSize;e++)v(a.location+e,o.meshPerAttribute);!0!==i.isInstancedMesh&&void 0===s._maxInstanceCount&&(s._maxInstanceCount=o.meshPerAttribute*o.count)}else for(let e=0;e<a.locationSize;e++)m(a.location+e);e.bindBuffer(e.ARRAY_BUFFER,u);for(let e=0;e<a.locationSize;e++)b(a.location+e,c/a.locationSize,d,t,c*f,c/a.locationSize*e*f,h)}}else if(void 0!==u){const n=u[t];if(void 0!==n)switch(n.length){case 2:e.vertexAttrib2fv(a.location,n);break;case 3:e.vertexAttrib3fv(a.location,n);break;case 4:e.vertexAttrib4fv(a.location,n);break;default:e.vertexAttrib1fv(a.location,n)}}}}g()}(i,c,f,_),null!==y&&e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,n.get(y).buffer))},reset:_,resetDefaultState:y,dispose:function(){_();for(const e in s){const t=s[e];for(const e in t){const n=t[e];for(const e in n)f(n[e].object),delete n[e];delete t[e]}delete s[e]}},releaseStatesOfGeometry:function(e){if(void 0===s[e.id])return;const t=s[e.id];for(const e in t){const n=t[e];for(const e in n)f(n[e].object),delete n[e];delete t[e]}delete s[e.id]},releaseStatesOfProgram:function(e){for(const t in s){const n=s[t];if(void 0===n[e.id])continue;const r=n[e.id];for(const e in r)f(r[e].object),delete r[e];delete n[e.id]}},initAttributes:p,enableAttribute:m,disableUnusedAttributes:g}}function kf(e,t,n,r){const i=r.isWebGL2;let a;this.setMode=function(e){a=e},this.render=function(t,r){e.drawArrays(a,t,r),n.update(r,a,1)},this.renderInstances=function(r,o,s){if(0===s)return;let c,l;if(i)c=e,l="drawArraysInstanced";else if(c=t.get("ANGLE_instanced_arrays"),l="drawArraysInstancedANGLE",null===c)return void console.error("THREE.WebGLBufferRenderer: using THREE.InstancedBufferGeometry but hardware does not support extension ANGLE_instanced_arrays.");c[l](a,r,o,s),n.update(o,a,s)}}function Rf(e,t,n){let r;function i(t){if("highp"===t){if(e.getShaderPrecisionFormat(e.VERTEX_SHADER,e.HIGH_FLOAT).precision>0&&e.getShaderPrecisionFormat(e.FRAGMENT_SHADER,e.HIGH_FLOAT).precision>0)return"highp";t="mediump"}return"mediump"===t&&e.getShaderPrecisionFormat(e.VERTEX_SHADER,e.MEDIUM_FLOAT).precision>0&&e.getShaderPrecisionFormat(e.FRAGMENT_SHADER,e.MEDIUM_FLOAT).precision>0?"mediump":"lowp"}const a="undefined"!=typeof WebGL2RenderingContext&&"WebGL2RenderingContext"===e.constructor.name;let o=void 0!==n.precision?n.precision:"highp";const s=i(o);s!==o&&(console.warn("THREE.WebGLRenderer:",o,"not supported, using",s,"instead."),o=s);const c=a||t.has("WEBGL_draw_buffers"),l=!0===n.logarithmicDepthBuffer,u=e.getParameter(e.MAX_TEXTURE_IMAGE_UNITS),d=e.getParameter(e.MAX_VERTEX_TEXTURE_IMAGE_UNITS),f=e.getParameter(e.MAX_TEXTURE_SIZE),h=e.getParameter(e.MAX_CUBE_MAP_TEXTURE_SIZE),p=e.getParameter(e.MAX_VERTEX_ATTRIBS),m=e.getParameter(e.MAX_VERTEX_UNIFORM_VECTORS),v=e.getParameter(e.MAX_VARYING_VECTORS),g=e.getParameter(e.MAX_FRAGMENT_UNIFORM_VECTORS),b=d>0,_=a||t.has("OES_texture_float");return{isWebGL2:a,drawBuffers:c,getMaxAnisotropy:function(){if(void 0!==r)return r;if(!0===t.has("EXT_texture_filter_anisotropic")){const n=t.get("EXT_texture_filter_anisotropic");r=e.getParameter(n.MAX_TEXTURE_MAX_ANISOTROPY_EXT)}else r=0;return r},getMaxPrecision:i,precision:o,logarithmicDepthBuffer:l,maxTextures:u,maxVertexTextures:d,maxTextureSize:f,maxCubemapSize:h,maxAttributes:p,maxVertexUniforms:m,maxVaryings:v,maxFragmentUniforms:g,vertexTextures:b,floatFragmentTextures:_,floatVertexTextures:b&&_,maxSamples:a?e.getParameter(e.MAX_SAMPLES):0}}function Lf(e){const t=this;let n=null,r=0,i=!1,a=!1;const o=new vf,s=new Cl,c={value:null,needsUpdate:!1};function l(e,n,r,i){const a=null!==e?e.length:0;let l=null;if(0!==a){if(l=c.value,!0!==i||null===l){const t=r+4*a,i=n.matrixWorldInverse;s.getNormalMatrix(i),(null===l||l.length<t)&&(l=new Float32Array(t));for(let t=0,n=r;t!==a;++t,n+=4)o.copy(e[t]).applyMatrix4(i,s),o.normal.toArray(l,n),l[n+3]=o.constant}c.value=l,c.needsUpdate=!0}return t.numPlanes=a,t.numIntersection=0,l}this.uniform=c,this.numPlanes=0,this.numIntersection=0,this.init=function(e,t){const n=0!==e.length||t||0!==r||i;return i=t,r=e.length,n},this.beginShadows=function(){a=!0,l(null)},this.endShadows=function(){a=!1},this.setGlobalState=function(e,t){n=l(e,t,0)},this.setState=function(o,s,u){const d=o.clippingPlanes,f=o.clipIntersection,h=o.clipShadows,p=e.get(o);if(!i||null===d||0===d.length||a&&!h)a?l(null):(c.value!==n&&(c.value=n,c.needsUpdate=r>0),t.numPlanes=r,t.numIntersection=0);else{const e=a?0:r,t=4*e;let i=p.clippingState||null;c.value=i,i=l(d,s,t,u);for(let e=0;e!==t;++e)i[e]=n[e];p.clippingState=i,this.numIntersection=f?this.numPlanes:0,this.numPlanes+=e}}}function Of(e){let t=new WeakMap;function n(e,t){return 303===t?e.mapping=Rc:304===t&&(e.mapping=Lc),e}function r(e){const n=e.target;n.removeEventListener("dispose",r);const i=t.get(n);void 0!==i&&(t.delete(n),i.dispose())}return{get:function(i){if(i&&i.isTexture&&!1===i.isRenderTargetTexture){const a=i.mapping;if(303===a||304===a){if(t.has(i))return n(t.get(i).texture,i.mapping);{const a=i.image;if(a&&a.height>0){const o=new ff(a.height/2);return o.fromEquirectangularTexture(e,i),t.set(i,o),i.addEventListener("dispose",r),n(o.texture,i.mapping)}return null}}}return i},dispose:function(){t=new WeakMap}}}class If extends sf{constructor(e=-1,t=1,n=1,r=-1,i=.1,a=2e3){super(),this.isOrthographicCamera=!0,this.type="OrthographicCamera",this.zoom=1,this.view=null,this.left=e,this.right=t,this.top=n,this.bottom=r,this.near=i,this.far=a,this.updateProjectionMatrix()}copy(e,t){return super.copy(e,t),this.left=e.left,this.right=e.right,this.top=e.top,this.bottom=e.bottom,this.near=e.near,this.far=e.far,this.zoom=e.zoom,this.view=null===e.view?null:Object.assign({},e.view),this}setViewOffset(e,t,n,r,i,a){null===this.view&&(this.view={enabled:!0,fullWidth:1,fullHeight:1,offsetX:0,offsetY:0,width:1,height:1}),this.view.enabled=!0,this.view.fullWidth=e,this.view.fullHeight=t,this.view.offsetX=n,this.view.offsetY=r,this.view.width=i,this.view.height=a,this.updateProjectionMatrix()}clearViewOffset(){null!==this.view&&(this.view.enabled=!1),this.updateProjectionMatrix()}updateProjectionMatrix(){const e=(this.right-this.left)/(2*this.zoom),t=(this.top-this.bottom)/(2*this.zoom),n=(this.right+this.left)/2,r=(this.top+this.bottom)/2;let i=n-e,a=n+e,o=r+t,s=r-t;if(null!==this.view&&this.view.enabled){const e=(this.right-this.left)/this.view.fullWidth/this.zoom,t=(this.top-this.bottom)/this.view.fullHeight/this.zoom;i+=e*this.view.offsetX,a=i+e*this.view.width,o-=t*this.view.offsetY,s=o-t*this.view.height}this.projectionMatrix.makeOrthographic(i,a,o,s,this.near,this.far,this.coordinateSystem),this.projectionMatrixInverse.copy(this.projectionMatrix).invert()}toJSON(e){const t=super.toJSON(e);return t.object.zoom=this.zoom,t.object.left=this.left,t.object.right=this.right,t.object.top=this.top,t.object.bottom=this.bottom,t.object.near=this.near,t.object.far=this.far,null!==this.view&&(t.object.view=Object.assign({},this.view)),t}}const Pf=[.125,.215,.35,.446,.526,.582],Df=new If,Nf=new bd;let Uf=null;const Ff=(1+Math.sqrt(5))/2,Bf=1/Ff,zf=[new Jl(1,1,1),new Jl(-1,1,1),new Jl(1,1,-1),new Jl(-1,1,-1),new Jl(0,Ff,Bf),new Jl(0,Ff,-Bf),new Jl(Bf,0,Ff),new Jl(-Bf,0,Ff),new Jl(Ff,Bf,0),new Jl(-Ff,Bf,0)];class Hf{constructor(e){this._renderer=e,this._pingPongRenderTarget=null,this._lodMax=0,this._cubeSize=0,this._lodPlanes=[],this._sizeLods=[],this._sigmas=[],this._blurMaterial=null,this._cubemapMaterial=null,this._equirectMaterial=null,this._compileMaterial(this._blurMaterial)}fromScene(e,t=0,n=.1,r=100){Uf=this._renderer.getRenderTarget(),this._setSize(256);const i=this._allocateTargets();return i.depthBuffer=!0,this._sceneToCubeUV(e,n,r,i),t>0&&this._blur(i,0,0,t),this._applyPMREM(i),this._cleanup(i),i}fromEquirectangular(e,t=null){return this._fromTexture(e,t)}fromCubemap(e,t=null){return this._fromTexture(e,t)}compileCubemapShader(){null===this._cubemapMaterial&&(this._cubemapMaterial=Wf(),this._compileMaterial(this._cubemapMaterial))}compileEquirectangularShader(){null===this._equirectMaterial&&(this._equirectMaterial=$f(),this._compileMaterial(this._equirectMaterial))}dispose(){this._dispose(),null!==this._cubemapMaterial&&this._cubemapMaterial.dispose(),null!==this._equirectMaterial&&this._equirectMaterial.dispose()}_setSize(e){this._lodMax=Math.floor(Math.log2(e)),this._cubeSize=Math.pow(2,this._lodMax)}_dispose(){null!==this._blurMaterial&&this._blurMaterial.dispose(),null!==this._pingPongRenderTarget&&this._pingPongRenderTarget.dispose();for(let e=0;e<this._lodPlanes.length;e++)this._lodPlanes[e].dispose()}_cleanup(e){this._renderer.setRenderTarget(Uf),e.scissorTest=!1,Gf(e,0,0,e.width,e.height)}_fromTexture(e,t){e.mapping===Rc||e.mapping===Lc?this._setSize(0===e.image.length?16:e.image[0].width||e.image[0].image.width):this._setSize(e.image.width/4),Uf=this._renderer.getRenderTarget();const n=t||this._allocateTargets();return this._textureToCubeUV(e,n),this._applyPMREM(n),this._cleanup(n),n}_allocateTargets(){const e=3*Math.max(this._cubeSize,112),t=4*this._cubeSize,n={magFilter:Fc,minFilter:Fc,generateMipmaps:!1,type:$c,format:jc,colorSpace:al,depthBuffer:!1},r=Vf(e,t,n);if(null===this._pingPongRenderTarget||this._pingPongRenderTarget.width!==e||this._pingPongRenderTarget.height!==t){null!==this._pingPongRenderTarget&&this._dispose(),this._pingPongRenderTarget=Vf(e,t,n);const{_lodMax:r}=this;({sizeLods:this._sizeLods,lodPlanes:this._lodPlanes,sigmas:this._sigmas}=function(e){const t=[],n=[],r=[];let i=e;const a=e-4+1+Pf.length;for(let o=0;o<a;o++){const a=Math.pow(2,i);n.push(a);let s=1/a;o>e-4?s=Pf[o-e+4-1]:0===o&&(s=0),r.push(s);const c=1/(a-2),l=-c,u=1+c,d=[l,l,u,l,u,u,l,l,u,u,l,u],f=6,h=6,p=3,m=2,v=1,g=new Float32Array(p*h*f),b=new Float32Array(m*h*f),_=new Float32Array(v*h*f);for(let e=0;e<f;e++){const t=e%3*2/3-1,n=e>2?0:-1,r=[t,n,0,t+2/3,n,0,t+2/3,n+1,0,t,n,0,t+2/3,n+1,0,t,n+1,0];g.set(r,p*h*e),b.set(d,m*h*e);const i=[e,e,e,e,e,e];_.set(i,v*h*e)}const y=new Pd;y.setAttribute("position",new wd(g,p)),y.setAttribute("uv",new wd(b,m)),y.setAttribute("faceIndex",new wd(_,v)),t.push(y),i>4&&i--}return{lodPlanes:t,sizeLods:n,sigmas:r}}(r)),this._blurMaterial=function(e,t,n){const r=new Float32Array(20),i=new Jl(0,1,0);return new of({name:"SphericalGaussianBlur",defines:{n:20,CUBEUV_TEXEL_WIDTH:1/t,CUBEUV_TEXEL_HEIGHT:1/n,CUBEUV_MAX_MIP:`${e}.0`},uniforms:{envMap:{value:null},samples:{value:1},weights:{value:r},latitudinal:{value:!1},dTheta:{value:0},mipInt:{value:0},poleAxis:{value:i}},vertexShader:"\n\n\t\tprecision mediump float;\n\t\tprecision mediump int;\n\n\t\tattribute float faceIndex;\n\n\t\tvarying vec3 vOutputDirection;\n\n\t\t// RH coordinate system; PMREM face-indexing convention\n\t\tvec3 getDirection( vec2 uv, float face ) {\n\n\t\t\tuv = 2.0 * uv - 1.0;\n\n\t\t\tvec3 direction = vec3( uv, 1.0 );\n\n\t\t\tif ( face == 0.0 ) {\n\n\t\t\t\tdirection = direction.zyx; // ( 1, v, u ) pos x\n\n\t\t\t} else if ( face == 1.0 ) {\n\n\t\t\t\tdirection = direction.xzy;\n\t\t\t\tdirection.xz *= -1.0; // ( -u, 1, -v ) pos y\n\n\t\t\t} else if ( face == 2.0 ) {\n\n\t\t\t\tdirection.x *= -1.0; // ( -u, v, 1 ) pos z\n\n\t\t\t} else if ( face == 3.0 ) {\n\n\t\t\t\tdirection = direction.zyx;\n\t\t\t\tdirection.xz *= -1.0; // ( -1, v, -u ) neg x\n\n\t\t\t} else if ( face == 4.0 ) {\n\n\t\t\t\tdirection = direction.xzy;\n\t\t\t\tdirection.xy *= -1.0; // ( -u, -1, v ) neg y\n\n\t\t\t} else if ( face == 5.0 ) {\n\n\t\t\t\tdirection.z *= -1.0; // ( u, v, -1 ) neg z\n\n\t\t\t}\n\n\t\t\treturn direction;\n\n\t\t}\n\n\t\tvoid main() {\n\n\t\t\tvOutputDirection = getDirection( uv, faceIndex );\n\t\t\tgl_Position = vec4( position, 1.0 );\n\n\t\t}\n\t",fragmentShader:"\n\n\t\t\tprecision mediump float;\n\t\t\tprecision mediump int;\n\n\t\t\tvarying vec3 vOutputDirection;\n\n\t\t\tuniform sampler2D envMap;\n\t\t\tuniform int samples;\n\t\t\tuniform float weights[ n ];\n\t\t\tuniform bool latitudinal;\n\t\t\tuniform float dTheta;\n\t\t\tuniform float mipInt;\n\t\t\tuniform vec3 poleAxis;\n\n\t\t\t#define ENVMAP_TYPE_CUBE_UV\n\t\t\t#include <cube_uv_reflection_fragment>\n\n\t\t\tvec3 getSample( float theta, vec3 axis ) {\n\n\t\t\t\tfloat cosTheta = cos( theta );\n\t\t\t\t// Rodrigues' axis-angle rotation\n\t\t\t\tvec3 sampleDirection = vOutputDirection * cosTheta\n\t\t\t\t\t+ cross( axis, vOutputDirection ) * sin( theta )\n\t\t\t\t\t+ axis * dot( axis, vOutputDirection ) * ( 1.0 - cosTheta );\n\n\t\t\t\treturn bilinearCubeUV( envMap, sampleDirection, mipInt );\n\n\t\t\t}\n\n\t\t\tvoid main() {\n\n\t\t\t\tvec3 axis = latitudinal ? poleAxis : cross( poleAxis, vOutputDirection );\n\n\t\t\t\tif ( all( equal( axis, vec3( 0.0 ) ) ) ) {\n\n\t\t\t\t\taxis = vec3( vOutputDirection.z, 0.0, - vOutputDirection.x );\n\n\t\t\t\t}\n\n\t\t\t\taxis = normalize( axis );\n\n\t\t\t\tgl_FragColor = vec4( 0.0, 0.0, 0.0, 1.0 );\n\t\t\t\tgl_FragColor.rgb += weights[ 0 ] * getSample( 0.0, axis );\n\n\t\t\t\tfor ( int i = 1; i < n; i++ ) {\n\n\t\t\t\t\tif ( i >= samples ) {\n\n\t\t\t\t\t\tbreak;\n\n\t\t\t\t\t}\n\n\t\t\t\t\tfloat theta = dTheta * float( i );\n\t\t\t\t\tgl_FragColor.rgb += weights[ i ] * getSample( -1.0 * theta, axis );\n\t\t\t\t\tgl_FragColor.rgb += weights[ i ] * getSample( theta, axis );\n\n\t\t\t\t}\n\n\t\t\t}\n\t\t",blending:0,depthTest:!1,depthWrite:!1})}(r,e,t)}return r}_compileMaterial(e){const t=new Jd(this._lodPlanes[0],e);this._renderer.compile(t,Df)}_sceneToCubeUV(e,t,n,r){const i=new cf(90,1,t,n),a=[1,-1,1,1,1,1],o=[1,1,1,-1,-1,-1],s=this._renderer,c=s.autoClear,l=s.toneMapping;s.getClearColor(Nf),s.toneMapping=Ec,s.autoClear=!1;const u=new yd({name:"PMREM.Background",side:1,depthWrite:!1,depthTest:!1}),d=new Jd(new ef,u);let f=!1;const h=e.background;h?h.isColor&&(u.color.copy(h),e.background=null,f=!0):(u.color.copy(Nf),f=!0);for(let t=0;t<6;t++){const n=t%3;0===n?(i.up.set(0,a[t],0),i.lookAt(o[t],0,0)):1===n?(i.up.set(0,0,a[t]),i.lookAt(0,o[t],0)):(i.up.set(0,a[t],0),i.lookAt(0,0,o[t]));const c=this._cubeSize;Gf(r,n*c,t>2?c:0,c,c),s.setRenderTarget(r),f&&s.render(d,i),s.render(e,i)}d.geometry.dispose(),d.material.dispose(),s.toneMapping=l,s.autoClear=c,e.background=h}_textureToCubeUV(e,t){const n=this._renderer,r=e.mapping===Rc||e.mapping===Lc;r?(null===this._cubemapMaterial&&(this._cubemapMaterial=Wf()),this._cubemapMaterial.uniforms.flipEnvMap.value=!1===e.isRenderTargetTexture?-1:1):null===this._equirectMaterial&&(this._equirectMaterial=$f());const i=r?this._cubemapMaterial:this._equirectMaterial,a=new Jd(this._lodPlanes[0],i);i.uniforms.envMap.value=e;const o=this._cubeSize;Gf(t,0,0,3*o,2*o),n.setRenderTarget(t),n.render(a,Df)}_applyPMREM(e){const t=this._renderer,n=t.autoClear;t.autoClear=!1;for(let t=1;t<this._lodPlanes.length;t++){const n=Math.sqrt(this._sigmas[t]*this._sigmas[t]-this._sigmas[t-1]*this._sigmas[t-1]),r=zf[(t-1)%zf.length];this._blur(e,t-1,t,n,r)}t.autoClear=n}_blur(e,t,n,r,i){const a=this._pingPongRenderTarget;this._halfBlur(e,a,t,n,r,"latitudinal",i),this._halfBlur(a,e,n,n,r,"longitudinal",i)}_halfBlur(e,t,n,r,i,a,o){const s=this._renderer,c=this._blurMaterial;"latitudinal"!==a&&"longitudinal"!==a&&console.error("blur direction must be either latitudinal or longitudinal!");const l=new Jd(this._lodPlanes[r],c),u=c.uniforms,d=this._sizeLods[n]-1,f=isFinite(i)?Math.PI/(2*d):2*Math.PI/39,h=i/f,p=isFinite(i)?1+Math.floor(3*h):20;p>20&&console.warn(`sigmaRadians, ${i}, is too large and will clip, as it requested ${p} samples when the maximum is set to 20`);const m=[];let v=0;for(let e=0;e<20;++e){const t=e/h,n=Math.exp(-t*t/2);m.push(n),0===e?v+=n:e<p&&(v+=2*n)}for(let e=0;e<m.length;e++)m[e]=m[e]/v;u.envMap.value=e.texture,u.samples.value=p,u.weights.value=m,u.latitudinal.value="latitudinal"===a,o&&(u.poleAxis.value=o);const{_lodMax:g}=this;u.dTheta.value=f,u.mipInt.value=g-n;const b=this._sizeLods[r];Gf(t,3*b*(r>g-4?r-g+4:0),4*(this._cubeSize-b),3*b,2*b),s.setRenderTarget(t),s.render(l,Df)}}function Vf(e,t,n){const r=new Yl(e,t,n);return r.texture.mapping=Oc,r.texture.name="PMREM.cubeUv",r.scissorTest=!0,r}function Gf(e,t,n,r,i){e.viewport.set(t,n,r,i),e.scissor.set(t,n,r,i)}function $f(){return new of({name:"EquirectangularToCubeUV",uniforms:{envMap:{value:null}},vertexShader:"\n\n\t\tprecision mediump float;\n\t\tprecision mediump int;\n\n\t\tattribute float faceIndex;\n\n\t\tvarying vec3 vOutputDirection;\n\n\t\t// RH coordinate system; PMREM face-indexing convention\n\t\tvec3 getDirection( vec2 uv, float face ) {\n\n\t\t\tuv = 2.0 * uv - 1.0;\n\n\t\t\tvec3 direction = vec3( uv, 1.0 );\n\n\t\t\tif ( face == 0.0 ) {\n\n\t\t\t\tdirection = direction.zyx; // ( 1, v, u ) pos x\n\n\t\t\t} else if ( face == 1.0 ) {\n\n\t\t\t\tdirection = direction.xzy;\n\t\t\t\tdirection.xz *= -1.0; // ( -u, 1, -v ) pos y\n\n\t\t\t} else if ( face == 2.0 ) {\n\n\t\t\t\tdirection.x *= -1.0; // ( -u, v, 1 ) pos z\n\n\t\t\t} else if ( face == 3.0 ) {\n\n\t\t\t\tdirection = direction.zyx;\n\t\t\t\tdirection.xz *= -1.0; // ( -1, v, -u ) neg x\n\n\t\t\t} else if ( face == 4.0 ) {\n\n\t\t\t\tdirection = direction.xzy;\n\t\t\t\tdirection.xy *= -1.0; // ( -u, -1, v ) neg y\n\n\t\t\t} else if ( face == 5.0 ) {\n\n\t\t\t\tdirection.z *= -1.0; // ( u, v, -1 ) neg z\n\n\t\t\t}\n\n\t\t\treturn direction;\n\n\t\t}\n\n\t\tvoid main() {\n\n\t\t\tvOutputDirection = getDirection( uv, faceIndex );\n\t\t\tgl_Position = vec4( position, 1.0 );\n\n\t\t}\n\t",fragmentShader:"\n\n\t\t\tprecision mediump float;\n\t\t\tprecision mediump int;\n\n\t\t\tvarying vec3 vOutputDirection;\n\n\t\t\tuniform sampler2D envMap;\n\n\t\t\t#include <common>\n\n\t\t\tvoid main() {\n\n\t\t\t\tvec3 outputDirection = normalize( vOutputDirection );\n\t\t\t\tvec2 uv = equirectUv( outputDirection );\n\n\t\t\t\tgl_FragColor = vec4( texture2D ( envMap, uv ).rgb, 1.0 );\n\n\t\t\t}\n\t\t",blending:0,depthTest:!1,depthWrite:!1})}function Wf(){return new of({name:"CubemapToCubeUV",uniforms:{envMap:{value:null},flipEnvMap:{value:-1}},vertexShader:"\n\n\t\tprecision mediump float;\n\t\tprecision mediump int;\n\n\t\tattribute float faceIndex;\n\n\t\tvarying vec3 vOutputDirection;\n\n\t\t// RH coordinate system; PMREM face-indexing convention\n\t\tvec3 getDirection( vec2 uv, float face ) {\n\n\t\t\tuv = 2.0 * uv - 1.0;\n\n\t\t\tvec3 direction = vec3( uv, 1.0 );\n\n\t\t\tif ( face == 0.0 ) {\n\n\t\t\t\tdirection = direction.zyx; // ( 1, v, u ) pos x\n\n\t\t\t} else if ( face == 1.0 ) {\n\n\t\t\t\tdirection = direction.xzy;\n\t\t\t\tdirection.xz *= -1.0; // ( -u, 1, -v ) pos y\n\n\t\t\t} else if ( face == 2.0 ) {\n\n\t\t\t\tdirection.x *= -1.0; // ( -u, v, 1 ) pos z\n\n\t\t\t} else if ( face == 3.0 ) {\n\n\t\t\t\tdirection = direction.zyx;\n\t\t\t\tdirection.xz *= -1.0; // ( -1, v, -u ) neg x\n\n\t\t\t} else if ( face == 4.0 ) {\n\n\t\t\t\tdirection = direction.xzy;\n\t\t\t\tdirection.xy *= -1.0; // ( -u, -1, v ) neg y\n\n\t\t\t} else if ( face == 5.0 ) {\n\n\t\t\t\tdirection.z *= -1.0; // ( u, v, -1 ) neg z\n\n\t\t\t}\n\n\t\t\treturn direction;\n\n\t\t}\n\n\t\tvoid main() {\n\n\t\t\tvOutputDirection = getDirection( uv, faceIndex );\n\t\t\tgl_Position = vec4( position, 1.0 );\n\n\t\t}\n\t",fragmentShader:"\n\n\t\t\tprecision mediump float;\n\t\t\tprecision mediump int;\n\n\t\t\tuniform float flipEnvMap;\n\n\t\t\tvarying vec3 vOutputDirection;\n\n\t\t\tuniform samplerCube envMap;\n\n\t\t\tvoid main() {\n\n\t\t\t\tgl_FragColor = textureCube( envMap, vec3( flipEnvMap * vOutputDirection.x, vOutputDirection.yz ) );\n\n\t\t\t}\n\t\t",blending:0,depthTest:!1,depthWrite:!1})}function jf(e){let t=new WeakMap,n=null;function r(e){const n=e.target;n.removeEventListener("dispose",r);const i=t.get(n);void 0!==i&&(t.delete(n),i.dispose())}return{get:function(i){if(i&&i.isTexture){const a=i.mapping,o=303===a||304===a,s=a===Rc||a===Lc;if(o||s){if(i.isRenderTargetTexture&&!0===i.needsPMREMUpdate){i.needsPMREMUpdate=!1;let r=t.get(i);return null===n&&(n=new Hf(e)),r=o?n.fromEquirectangular(i,r):n.fromCubemap(i,r),t.set(i,r),r.texture}if(t.has(i))return t.get(i).texture;{const a=i.image;if(o&&a&&a.height>0||s&&a&&function(e){let t=0;for(let n=0;n<6;n++)void 0!==e[n]&&t++;return 6===t}(a)){null===n&&(n=new Hf(e));const a=o?n.fromEquirectangular(i):n.fromCubemap(i);return t.set(i,a),i.addEventListener("dispose",r),a.texture}return null}}}return i},dispose:function(){t=new WeakMap,null!==n&&(n.dispose(),n=null)}}}function Xf(e){const t={};function n(n){if(void 0!==t[n])return t[n];let r;switch(n){case"WEBGL_depth_texture":r=e.getExtension("WEBGL_depth_texture")||e.getExtension("MOZ_WEBGL_depth_texture")||e.getExtension("WEBKIT_WEBGL_depth_texture");break;case"EXT_texture_filter_anisotropic":r=e.getExtension("EXT_texture_filter_anisotropic")||e.getExtension("MOZ_EXT_texture_filter_anisotropic")||e.getExtension("WEBKIT_EXT_texture_filter_anisotropic");break;case"WEBGL_compressed_texture_s3tc":r=e.getExtension("WEBGL_compressed_texture_s3tc")||e.getExtension("MOZ_WEBGL_compressed_texture_s3tc")||e.getExtension("WEBKIT_WEBGL_compressed_texture_s3tc");break;case"WEBGL_compressed_texture_pvrtc":r=e.getExtension("WEBGL_compressed_texture_pvrtc")||e.getExtension("WEBKIT_WEBGL_compressed_texture_pvrtc");break;default:r=e.getExtension(n)}return t[n]=r,r}return{has:function(e){return null!==n(e)},init:function(e){e.isWebGL2?n("EXT_color_buffer_float"):(n("WEBGL_depth_texture"),n("OES_texture_float"),n("OES_texture_half_float"),n("OES_texture_half_float_linear"),n("OES_standard_derivatives"),n("OES_element_index_uint"),n("OES_vertex_array_object"),n("ANGLE_instanced_arrays")),n("OES_texture_float_linear"),n("EXT_color_buffer_half_float"),n("WEBGL_multisampled_render_to_texture")},get:function(e){const t=n(e);return null===t&&console.warn("THREE.WebGLRenderer: "+e+" extension not supported."),t}}}function Yf(e,t,n,r){const i={},a=new WeakMap;function o(e){const s=e.target;null!==s.index&&t.remove(s.index);for(const e in s.attributes)t.remove(s.attributes[e]);for(const e in s.morphAttributes){const n=s.morphAttributes[e];for(let e=0,r=n.length;e<r;e++)t.remove(n[e])}s.removeEventListener("dispose",o),delete i[s.id];const c=a.get(s);c&&(t.remove(c),a.delete(s)),r.releaseStatesOfGeometry(s),!0===s.isInstancedBufferGeometry&&delete s._maxInstanceCount,n.memory.geometries--}function s(e){const n=[],r=e.index,i=e.attributes.position;let o=0;if(null!==r){const e=r.array;o=r.version;for(let t=0,r=e.length;t<r;t+=3){const r=e[t+0],i=e[t+1],a=e[t+2];n.push(r,i,i,a,a,r)}}else{const e=i.array;o=i.version;for(let t=0,r=e.length/3-1;t<r;t+=3){const e=t+0,r=t+1,i=t+2;n.push(e,r,r,i,i,e)}}const s=new(kl(n)?Td:Ed)(n,1);s.version=o;const c=a.get(e);c&&t.remove(c),a.set(e,s)}return{get:function(e,t){return!0===i[t.id]||(t.addEventListener("dispose",o),i[t.id]=!0,n.memory.geometries++),t},update:function(n){const r=n.attributes;for(const n in r)t.update(r[n],e.ARRAY_BUFFER);const i=n.morphAttributes;for(const n in i){const r=i[n];for(let n=0,i=r.length;n<i;n++)t.update(r[n],e.ARRAY_BUFFER)}},getWireframeAttribute:function(e){const t=a.get(e);if(t){const n=e.index;null!==n&&t.version<n.version&&s(e)}else s(e);return a.get(e)}}}function qf(e,t,n,r){const i=r.isWebGL2;let a,o,s;this.setMode=function(e){a=e},this.setIndex=function(e){o=e.type,s=e.bytesPerElement},this.render=function(t,r){e.drawElements(a,r,o,t*s),n.update(r,a,1)},this.renderInstances=function(r,c,l){if(0===l)return;let u,d;if(i)u=e,d="drawElementsInstanced";else if(u=t.get("ANGLE_instanced_arrays"),d="drawElementsInstancedANGLE",null===u)return void console.error("THREE.WebGLIndexedBufferRenderer: using THREE.InstancedBufferGeometry but hardware does not support extension ANGLE_instanced_arrays.");u[d](a,c,o,r*s,l),n.update(c,a,l)}}function Kf(e){const t={frame:0,calls:0,triangles:0,points:0,lines:0};return{memory:{geometries:0,textures:0},render:t,programs:null,autoReset:!0,reset:function(){t.calls=0,t.triangles=0,t.points=0,t.lines=0},update:function(n,r,i){switch(t.calls++,r){case e.TRIANGLES:t.triangles+=i*(n/3);break;case e.LINES:t.lines+=i*(n/2);break;case e.LINE_STRIP:t.lines+=i*(n-1);break;case e.LINE_LOOP:t.lines+=i*n;break;case e.POINTS:t.points+=i*n;break;default:console.error("THREE.WebGLInfo: Unknown draw mode:",r)}}}}function Zf(e,t){return e[0]-t[0]}function Jf(e,t){return Math.abs(t[1])-Math.abs(e[1])}function Qf(e,t,n){const r={},i=new Float32Array(8),a=new WeakMap,o=new Xl,s=[];for(let e=0;e<8;e++)s[e]=[e,0];return{update:function(c,l,u){const d=c.morphTargetInfluences;if(!0===t.isWebGL2){const f=l.morphAttributes.position||l.morphAttributes.normal||l.morphAttributes.color,h=void 0!==f?f.length:0;let p=a.get(l);if(void 0===p||p.count!==h){void 0!==p&&p.texture.dispose();const g=void 0!==l.morphAttributes.position,b=void 0!==l.morphAttributes.normal,_=void 0!==l.morphAttributes.color,y=l.morphAttributes.position||[],x=l.morphAttributes.normal||[],A=l.morphAttributes.color||[];let w=0;!0===g&&(w=1),!0===b&&(w=2),!0===_&&(w=3);let E=l.attributes.position.count*w,T=1;E>t.maxTextureSize&&(T=Math.ceil(E/t.maxTextureSize),E=t.maxTextureSize);const S=new Float32Array(E*T*4*h),C=new ql(S,E,T,h);C.type=Gc,C.needsUpdate=!0;const M=4*w;for(let R=0;R<h;R++){const L=y[R],O=x[R],I=A[R],P=E*T*4*R;for(let D=0;D<L.count;D++){const N=D*M;!0===g&&(o.fromBufferAttribute(L,D),S[P+N+0]=o.x,S[P+N+1]=o.y,S[P+N+2]=o.z,S[P+N+3]=0),!0===b&&(o.fromBufferAttribute(O,D),S[P+N+4]=o.x,S[P+N+5]=o.y,S[P+N+6]=o.z,S[P+N+7]=0),!0===_&&(o.fromBufferAttribute(I,D),S[P+N+8]=o.x,S[P+N+9]=o.y,S[P+N+10]=o.z,S[P+N+11]=4===I.itemSize?o.w:1)}}function k(){C.dispose(),a.delete(l),l.removeEventListener("dispose",k)}p={count:h,texture:C,size:new Sl(E,T)},a.set(l,p),l.addEventListener("dispose",k)}let m=0;for(let U=0;U<d.length;U++)m+=d[U];const v=l.morphTargetsRelative?1:1-m;u.getUniforms().setValue(e,"morphTargetBaseInfluence",v),u.getUniforms().setValue(e,"morphTargetInfluences",d),u.getUniforms().setValue(e,"morphTargetsTexture",p.texture,n),u.getUniforms().setValue(e,"morphTargetsTextureSize",p.size)}else{const F=void 0===d?0:d.length;let B=r[l.id];if(void 0===B||B.length!==F){B=[];for(let $=0;$<F;$++)B[$]=[$,0];r[l.id]=B}for(let W=0;W<F;W++){const j=B[W];j[0]=W,j[1]=d[W]}B.sort(Jf);for(let X=0;X<8;X++)X<F&&B[X][1]?(s[X][0]=B[X][0],s[X][1]=B[X][1]):(s[X][0]=Number.MAX_SAFE_INTEGER,s[X][1]=0);s.sort(Zf);const z=l.morphAttributes.position,H=l.morphAttributes.normal;let V=0;for(let Y=0;Y<8;Y++){const q=s[Y],K=q[0],Z=q[1];K!==Number.MAX_SAFE_INTEGER&&Z?(z&&l.getAttribute("morphTarget"+Y)!==z[K]&&l.setAttribute("morphTarget"+Y,z[K]),H&&l.getAttribute("morphNormal"+Y)!==H[K]&&l.setAttribute("morphNormal"+Y,H[K]),i[Y]=Z,V+=Z):(z&&!0===l.hasAttribute("morphTarget"+Y)&&l.deleteAttribute("morphTarget"+Y),H&&!0===l.hasAttribute("morphNormal"+Y)&&l.deleteAttribute("morphNormal"+Y),i[Y]=0)}const G=l.morphTargetsRelative?1:1-V;u.getUniforms().setValue(e,"morphTargetBaseInfluence",G),u.getUniforms().setValue(e,"morphTargetInfluences",i)}}}}function eh(e,t,n,r){let i=new WeakMap;function a(e){const t=e.target;t.removeEventListener("dispose",a),n.remove(t.instanceMatrix),null!==t.instanceColor&&n.remove(t.instanceColor)}return{update:function(o){const s=r.render.frame,c=o.geometry,l=t.get(o,c);if(i.get(l)!==s&&(t.update(l),i.set(l,s)),o.isInstancedMesh&&(!1===o.hasEventListener("dispose",a)&&o.addEventListener("dispose",a),i.get(o)!==s&&(n.update(o.instanceMatrix,e.ARRAY_BUFFER),null!==o.instanceColor&&n.update(o.instanceColor,e.ARRAY_BUFFER),i.set(o,s))),o.isSkinnedMesh){const e=o.skeleton;i.get(e)!==s&&(e.update(),i.set(e,s))}return l},dispose:function(){i=new WeakMap}}}const th=new jl,nh=new ql,rh=new Kl,ih=new df,ah=[],oh=[],sh=new Float32Array(16),ch=new Float32Array(9),lh=new Float32Array(4);function uh(e,t,n){const r=e[0];if(r<=0||r>0)return e;const i=t*n;let a=ah[i];if(void 0===a&&(a=new Float32Array(i),ah[i]=a),0!==t){r.toArray(a,0);for(let r=1,i=0;r!==t;++r)i+=n,e[r].toArray(a,i)}return a}function dh(e,t){if(e.length!==t.length)return!1;for(let n=0,r=e.length;n<r;n++)if(e[n]!==t[n])return!1;return!0}function fh(e,t){for(let n=0,r=t.length;n<r;n++)e[n]=t[n]}function hh(e,t){let n=oh[t];void 0===n&&(n=new Int32Array(t),oh[t]=n);for(let r=0;r!==t;++r)n[r]=e.allocateTextureUnit();return n}function ph(e,t){const n=this.cache;n[0]!==t&&(e.uniform1f(this.addr,t),n[0]=t)}function mh(e,t){const n=this.cache;if(void 0!==t.x)n[0]===t.x&&n[1]===t.y||(e.uniform2f(this.addr,t.x,t.y),n[0]=t.x,n[1]=t.y);else{if(dh(n,t))return;e.uniform2fv(this.addr,t),fh(n,t)}}function vh(e,t){const n=this.cache;if(void 0!==t.x)n[0]===t.x&&n[1]===t.y&&n[2]===t.z||(e.uniform3f(this.addr,t.x,t.y,t.z),n[0]=t.x,n[1]=t.y,n[2]=t.z);else if(void 0!==t.r)n[0]===t.r&&n[1]===t.g&&n[2]===t.b||(e.uniform3f(this.addr,t.r,t.g,t.b),n[0]=t.r,n[1]=t.g,n[2]=t.b);else{if(dh(n,t))return;e.uniform3fv(this.addr,t),fh(n,t)}}function gh(e,t){const n=this.cache;if(void 0!==t.x)n[0]===t.x&&n[1]===t.y&&n[2]===t.z&&n[3]===t.w||(e.uniform4f(this.addr,t.x,t.y,t.z,t.w),n[0]=t.x,n[1]=t.y,n[2]=t.z,n[3]=t.w);else{if(dh(n,t))return;e.uniform4fv(this.addr,t),fh(n,t)}}function bh(e,t){const n=this.cache,r=t.elements;if(void 0===r){if(dh(n,t))return;e.uniformMatrix2fv(this.addr,!1,t),fh(n,t)}else{if(dh(n,r))return;lh.set(r),e.uniformMatrix2fv(this.addr,!1,lh),fh(n,r)}}function _h(e,t){const n=this.cache,r=t.elements;if(void 0===r){if(dh(n,t))return;e.uniformMatrix3fv(this.addr,!1,t),fh(n,t)}else{if(dh(n,r))return;ch.set(r),e.uniformMatrix3fv(this.addr,!1,ch),fh(n,r)}}function yh(e,t){const n=this.cache,r=t.elements;if(void 0===r){if(dh(n,t))return;e.uniformMatrix4fv(this.addr,!1,t),fh(n,t)}else{if(dh(n,r))return;sh.set(r),e.uniformMatrix4fv(this.addr,!1,sh),fh(n,r)}}function xh(e,t){const n=this.cache;n[0]!==t&&(e.uniform1i(this.addr,t),n[0]=t)}function Ah(e,t){const n=this.cache;if(void 0!==t.x)n[0]===t.x&&n[1]===t.y||(e.uniform2i(this.addr,t.x,t.y),n[0]=t.x,n[1]=t.y);else{if(dh(n,t))return;e.uniform2iv(this.addr,t),fh(n,t)}}function wh(e,t){const n=this.cache;if(void 0!==t.x)n[0]===t.x&&n[1]===t.y&&n[2]===t.z||(e.uniform3i(this.addr,t.x,t.y,t.z),n[0]=t.x,n[1]=t.y,n[2]=t.z);else{if(dh(n,t))return;e.uniform3iv(this.addr,t),fh(n,t)}}function Eh(e,t){const n=this.cache;if(void 0!==t.x)n[0]===t.x&&n[1]===t.y&&n[2]===t.z&&n[3]===t.w||(e.uniform4i(this.addr,t.x,t.y,t.z,t.w),n[0]=t.x,n[1]=t.y,n[2]=t.z,n[3]=t.w);else{if(dh(n,t))return;e.uniform4iv(this.addr,t),fh(n,t)}}function Th(e,t){const n=this.cache;n[0]!==t&&(e.uniform1ui(this.addr,t),n[0]=t)}function Sh(e,t){const n=this.cache;if(void 0!==t.x)n[0]===t.x&&n[1]===t.y||(e.uniform2ui(this.addr,t.x,t.y),n[0]=t.x,n[1]=t.y);else{if(dh(n,t))return;e.uniform2uiv(this.addr,t),fh(n,t)}}function Ch(e,t){const n=this.cache;if(void 0!==t.x)n[0]===t.x&&n[1]===t.y&&n[2]===t.z||(e.uniform3ui(this.addr,t.x,t.y,t.z),n[0]=t.x,n[1]=t.y,n[2]=t.z);else{if(dh(n,t))return;e.uniform3uiv(this.addr,t),fh(n,t)}}function Mh(e,t){const n=this.cache;if(void 0!==t.x)n[0]===t.x&&n[1]===t.y&&n[2]===t.z&&n[3]===t.w||(e.uniform4ui(this.addr,t.x,t.y,t.z,t.w),n[0]=t.x,n[1]=t.y,n[2]=t.z,n[3]=t.w);else{if(dh(n,t))return;e.uniform4uiv(this.addr,t),fh(n,t)}}function kh(e,t,n){const r=this.cache,i=n.allocateTextureUnit();r[0]!==i&&(e.uniform1i(this.addr,i),r[0]=i),n.setTexture2D(t||th,i)}function Rh(e,t,n){const r=this.cache,i=n.allocateTextureUnit();r[0]!==i&&(e.uniform1i(this.addr,i),r[0]=i),n.setTexture3D(t||rh,i)}function Lh(e,t,n){const r=this.cache,i=n.allocateTextureUnit();r[0]!==i&&(e.uniform1i(this.addr,i),r[0]=i),n.setTextureCube(t||ih,i)}function Oh(e,t,n){const r=this.cache,i=n.allocateTextureUnit();r[0]!==i&&(e.uniform1i(this.addr,i),r[0]=i),n.setTexture2DArray(t||nh,i)}function Ih(e,t){e.uniform1fv(this.addr,t)}function Ph(e,t){const n=uh(t,this.size,2);e.uniform2fv(this.addr,n)}function Dh(e,t){const n=uh(t,this.size,3);e.uniform3fv(this.addr,n)}function Nh(e,t){const n=uh(t,this.size,4);e.uniform4fv(this.addr,n)}function Uh(e,t){const n=uh(t,this.size,4);e.uniformMatrix2fv(this.addr,!1,n)}function Fh(e,t){const n=uh(t,this.size,9);e.uniformMatrix3fv(this.addr,!1,n)}function Bh(e,t){const n=uh(t,this.size,16);e.uniformMatrix4fv(this.addr,!1,n)}function zh(e,t){e.uniform1iv(this.addr,t)}function Hh(e,t){e.uniform2iv(this.addr,t)}function Vh(e,t){e.uniform3iv(this.addr,t)}function Gh(e,t){e.uniform4iv(this.addr,t)}function $h(e,t){e.uniform1uiv(this.addr,t)}function Wh(e,t){e.uniform2uiv(this.addr,t)}function jh(e,t){e.uniform3uiv(this.addr,t)}function Xh(e,t){e.uniform4uiv(this.addr,t)}function Yh(e,t,n){const r=this.cache,i=t.length,a=hh(n,i);dh(r,a)||(e.uniform1iv(this.addr,a),fh(r,a));for(let e=0;e!==i;++e)n.setTexture2D(t[e]||th,a[e])}function qh(e,t,n){const r=this.cache,i=t.length,a=hh(n,i);dh(r,a)||(e.uniform1iv(this.addr,a),fh(r,a));for(let e=0;e!==i;++e)n.setTexture3D(t[e]||rh,a[e])}function Kh(e,t,n){const r=this.cache,i=t.length,a=hh(n,i);dh(r,a)||(e.uniform1iv(this.addr,a),fh(r,a));for(let e=0;e!==i;++e)n.setTextureCube(t[e]||ih,a[e])}function Zh(e,t,n){const r=this.cache,i=t.length,a=hh(n,i);dh(r,a)||(e.uniform1iv(this.addr,a),fh(r,a));for(let e=0;e!==i;++e)n.setTexture2DArray(t[e]||nh,a[e])}class Jh{constructor(e,t,n){this.id=e,this.addr=n,this.cache=[],this.setValue=function(e){switch(e){case 5126:return ph;case 35664:return mh;case 35665:return vh;case 35666:return gh;case 35674:return bh;case 35675:return _h;case 35676:return yh;case 5124:case 35670:return xh;case 35667:case 35671:return Ah;case 35668:case 35672:return wh;case 35669:case 35673:return Eh;case 5125:return Th;case 36294:return Sh;case 36295:return Ch;case 36296:return Mh;case 35678:case 36198:case 36298:case 36306:case 35682:return kh;case 35679:case 36299:case 36307:return Rh;case 35680:case 36300:case 36308:case 36293:return Lh;case 36289:case 36303:case 36311:case 36292:return Oh}}(t.type)}}class Qh{constructor(e,t,n){this.id=e,this.addr=n,this.cache=[],this.size=t.size,this.setValue=function(e){switch(e){case 5126:return Ih;case 35664:return Ph;case 35665:return Dh;case 35666:return Nh;case 35674:return Uh;case 35675:return Fh;case 35676:return Bh;case 5124:case 35670:return zh;case 35667:case 35671:return Hh;case 35668:case 35672:return Vh;case 35669:case 35673:return Gh;case 5125:return $h;case 36294:return Wh;case 36295:return jh;case 36296:return Xh;case 35678:case 36198:case 36298:case 36306:case 35682:return Yh;case 35679:case 36299:case 36307:return qh;case 35680:case 36300:case 36308:case 36293:return Kh;case 36289:case 36303:case 36311:case 36292:return Zh}}(t.type)}}class ep{constructor(e){this.id=e,this.seq=[],this.map={}}setValue(e,t,n){const r=this.seq;for(let i=0,a=r.length;i!==a;++i){const a=r[i];a.setValue(e,t[a.id],n)}}}const tp=/(\w+)(\])?(\[|\.)?/g;function np(e,t){e.seq.push(t),e.map[t.id]=t}function rp(e,t,n){const r=e.name,i=r.length;for(tp.lastIndex=0;;){const a=tp.exec(r),o=tp.lastIndex;let s=a[1];const c="]"===a[2],l=a[3];if(c&&(s|=0),void 0===l||"["===l&&o+2===i){np(n,void 0===l?new Jh(s,e,t):new Qh(s,e,t));break}{let e=n.map[s];void 0===e&&(e=new ep(s),np(n,e)),n=e}}}class ip{constructor(e,t){this.seq=[],this.map={};const n=e.getProgramParameter(t,e.ACTIVE_UNIFORMS);for(let r=0;r<n;++r){const n=e.getActiveUniform(t,r);rp(n,e.getUniformLocation(t,n.name),this)}}setValue(e,t,n,r){const i=this.map[t];void 0!==i&&i.setValue(e,n,r)}setOptional(e,t,n){const r=t[n];void 0!==r&&this.setValue(e,n,r)}static upload(e,t,n,r){for(let i=0,a=t.length;i!==a;++i){const a=t[i],o=n[a.id];!1!==o.needsUpdate&&a.setValue(e,o.value,r)}}static seqWithValue(e,t){const n=[];for(let r=0,i=e.length;r!==i;++r){const i=e[r];i.id in t&&n.push(i)}return n}}function ap(e,t,n){const r=e.createShader(t);return e.shaderSource(r,n),e.compileShader(r),r}let op=0;function sp(e,t,n){const r=e.getShaderParameter(t,e.COMPILE_STATUS),i=e.getShaderInfoLog(t).trim();if(r&&""===i)return"";const a=/ERROR: 0:(\d+)/.exec(i);if(a){const r=parseInt(a[1]);return n.toUpperCase()+"\n\n"+i+"\n\n"+function(e,t){const n=e.split("\n"),r=[],i=Math.max(t-6,0),a=Math.min(t+6,n.length);for(let e=i;e<a;e++){const i=e+1;r.push(`${i===t?">":" "} ${i}: ${n[e]}`)}return r.join("\n")}(e.getShaderSource(t),r)}return i}function cp(e,t){const n=function(e){switch(e){case al:return["Linear","( value )"];case il:return["sRGB","( value )"];default:return console.warn("THREE.WebGLProgram: Unsupported color space:",e),["Linear","( value )"]}}(t);return"vec4 "+e+"( vec4 value ) { return LinearTo"+n[0]+n[1]+"; }"}function lp(e,t){let n;switch(t){case Tc:n="Linear";break;case Sc:n="Reinhard";break;case Cc:n="OptimizedCineon";break;case Mc:n="ACESFilmic";break;case kc:n="Custom";break;default:console.warn("THREE.WebGLProgram: Unsupported toneMapping:",t),n="Linear"}return"vec3 "+e+"( vec3 color ) { return "+n+"ToneMapping( color ); }"}function up(e){return""!==e}function dp(e,t){const n=t.numSpotLightShadows+t.numSpotLightMaps-t.numSpotLightShadowsWithMaps;return e.replace(/NUM_DIR_LIGHTS/g,t.numDirLights).replace(/NUM_SPOT_LIGHTS/g,t.numSpotLights).replace(/NUM_SPOT_LIGHT_MAPS/g,t.numSpotLightMaps).replace(/NUM_SPOT_LIGHT_COORDS/g,n).replace(/NUM_RECT_AREA_LIGHTS/g,t.numRectAreaLights).replace(/NUM_POINT_LIGHTS/g,t.numPointLights).replace(/NUM_HEMI_LIGHTS/g,t.numHemiLights).replace(/NUM_DIR_LIGHT_SHADOWS/g,t.numDirLightShadows).replace(/NUM_SPOT_LIGHT_SHADOWS_WITH_MAPS/g,t.numSpotLightShadowsWithMaps).replace(/NUM_SPOT_LIGHT_SHADOWS/g,t.numSpotLightShadows).replace(/NUM_POINT_LIGHT_SHADOWS/g,t.numPointLightShadows)}function fp(e,t){return e.replace(/NUM_CLIPPING_PLANES/g,t.numClippingPlanes).replace(/UNION_CLIPPING_PLANES/g,t.numClippingPlanes-t.numClipIntersection)}const hp=/^[ \t]*#include +<([\w\d./]+)>/gm;function pp(e){return e.replace(hp,vp)}const mp=new Map([["encodings_fragment","colorspace_fragment"],["encodings_pars_fragment","colorspace_pars_fragment"],["output_fragment","opaque_fragment"]]);function vp(e,t){let n=wf[t];if(void 0===n){const e=mp.get(t);if(void 0===e)throw new Error("Can not resolve #include <"+t+">");n=wf[e],console.warn('THREE.WebGLRenderer: Shader chunk "%s" has been deprecated. Use "%s" instead.',t,e)}return pp(n)}const gp=/#pragma unroll_loop_start\s+for\s*\(\s*int\s+i\s*=\s*(\d+)\s*;\s*i\s*<\s*(\d+)\s*;\s*i\s*\+\+\s*\)\s*{([\s\S]+?)}\s+#pragma unroll_loop_end/g;function bp(e){return e.replace(gp,_p)}function _p(e,t,n,r){let i="";for(let e=parseInt(t);e<parseInt(n);e++)i+=r.replace(/\[\s*i\s*\]/g,"[ "+e+" ]").replace(/UNROLLED_LOOP_INDEX/g,e);return i}function yp(e){let t="precision "+e.precision+" float;\nprecision "+e.precision+" int;";return"highp"===e.precision?t+="\n#define HIGH_PRECISION":"mediump"===e.precision?t+="\n#define MEDIUM_PRECISION":"lowp"===e.precision&&(t+="\n#define LOW_PRECISION"),t}function xp(e,t,n,r){const i=e.getContext(),a=n.defines;let o=n.vertexShader,s=n.fragmentShader;const c=function(e){let t="SHADOWMAP_TYPE_BASIC";return e.shadowMapType===gc?t="SHADOWMAP_TYPE_PCF":e.shadowMapType===bc?t="SHADOWMAP_TYPE_PCF_SOFT":e.shadowMapType===_c&&(t="SHADOWMAP_TYPE_VSM"),t}(n),l=function(e){let t="ENVMAP_TYPE_CUBE";if(e.envMap)switch(e.envMapMode){case Rc:case Lc:t="ENVMAP_TYPE_CUBE";break;case Oc:t="ENVMAP_TYPE_CUBE_UV"}return t}(n),u=function(e){let t="ENVMAP_MODE_REFLECTION";return e.envMap&&e.envMapMode===Lc&&(t="ENVMAP_MODE_REFRACTION"),t}(n),d=function(e){let t="ENVMAP_BLENDING_NONE";if(e.envMap)switch(e.combine){case xc:t="ENVMAP_BLENDING_MULTIPLY";break;case Ac:t="ENVMAP_BLENDING_MIX";break;case wc:t="ENVMAP_BLENDING_ADD"}return t}(n),f=function(e){const t=e.envMapCubeUVHeight;if(null===t)return null;const n=Math.log2(t)-2,r=1/t;return{texelWidth:1/(3*Math.max(Math.pow(2,n),112)),texelHeight:r,maxMip:n}}(n),h=n.isWebGL2?"":function(e){return[e.extensionDerivatives||e.envMapCubeUVHeight||e.bumpMap||e.normalMapTangentSpace||e.clearcoatNormalMap||e.flatShading||"physical"===e.shaderID?"#extension GL_OES_standard_derivatives : enable":"",(e.extensionFragDepth||e.logarithmicDepthBuffer)&&e.rendererExtensionFragDepth?"#extension GL_EXT_frag_depth : enable":"",e.extensionDrawBuffers&&e.rendererExtensionDrawBuffers?"#extension GL_EXT_draw_buffers : require":"",(e.extensionShaderTextureLOD||e.envMap||e.transmission)&&e.rendererExtensionShaderTextureLod?"#extension GL_EXT_shader_texture_lod : enable":""].filter(up).join("\n")}(n),p=function(e){const t=[];for(const n in e){const r=e[n];!1!==r&&t.push("#define "+n+" "+r)}return t.join("\n")}(a),m=i.createProgram();let v,g,b=n.glslVersion?"#version "+n.glslVersion+"\n":"";n.isRawShaderMaterial?(v=["#define SHADER_TYPE "+n.shaderType,"#define SHADER_NAME "+n.shaderName,p].filter(up).join("\n"),v.length>0&&(v+="\n"),g=[h,"#define SHADER_TYPE "+n.shaderType,"#define SHADER_NAME "+n.shaderName,p].filter(up).join("\n"),g.length>0&&(g+="\n")):(v=[yp(n),"#define SHADER_TYPE "+n.shaderType,"#define SHADER_NAME "+n.shaderName,p,n.instancing?"#define USE_INSTANCING":"",n.instancingColor?"#define USE_INSTANCING_COLOR":"",n.useFog&&n.fog?"#define USE_FOG":"",n.useFog&&n.fogExp2?"#define FOG_EXP2":"",n.map?"#define USE_MAP":"",n.envMap?"#define USE_ENVMAP":"",n.envMap?"#define "+u:"",n.lightMap?"#define USE_LIGHTMAP":"",n.aoMap?"#define USE_AOMAP":"",n.bumpMap?"#define USE_BUMPMAP":"",n.normalMap?"#define USE_NORMALMAP":"",n.normalMapObjectSpace?"#define USE_NORMALMAP_OBJECTSPACE":"",n.normalMapTangentSpace?"#define USE_NORMALMAP_TANGENTSPACE":"",n.displacementMap?"#define USE_DISPLACEMENTMAP":"",n.emissiveMap?"#define USE_EMISSIVEMAP":"",n.anisotropyMap?"#define USE_ANISOTROPYMAP":"",n.clearcoatMap?"#define USE_CLEARCOATMAP":"",n.clearcoatRoughnessMap?"#define USE_CLEARCOAT_ROUGHNESSMAP":"",n.clearcoatNormalMap?"#define USE_CLEARCOAT_NORMALMAP":"",n.iridescenceMap?"#define USE_IRIDESCENCEMAP":"",n.iridescenceThicknessMap?"#define USE_IRIDESCENCE_THICKNESSMAP":"",n.specularMap?"#define USE_SPECULARMAP":"",n.specularColorMap?"#define USE_SPECULAR_COLORMAP":"",n.specularIntensityMap?"#define USE_SPECULAR_INTENSITYMAP":"",n.roughnessMap?"#define USE_ROUGHNESSMAP":"",n.metalnessMap?"#define USE_METALNESSMAP":"",n.alphaMap?"#define USE_ALPHAMAP":"",n.alphaHash?"#define USE_ALPHAHASH":"",n.transmission?"#define USE_TRANSMISSION":"",n.transmissionMap?"#define USE_TRANSMISSIONMAP":"",n.thicknessMap?"#define USE_THICKNESSMAP":"",n.sheenColorMap?"#define USE_SHEEN_COLORMAP":"",n.sheenRoughnessMap?"#define USE_SHEEN_ROUGHNESSMAP":"",n.mapUv?"#define MAP_UV "+n.mapUv:"",n.alphaMapUv?"#define ALPHAMAP_UV "+n.alphaMapUv:"",n.lightMapUv?"#define LIGHTMAP_UV "+n.lightMapUv:"",n.aoMapUv?"#define AOMAP_UV "+n.aoMapUv:"",n.emissiveMapUv?"#define EMISSIVEMAP_UV "+n.emissiveMapUv:"",n.bumpMapUv?"#define BUMPMAP_UV "+n.bumpMapUv:"",n.normalMapUv?"#define NORMALMAP_UV "+n.normalMapUv:"",n.displacementMapUv?"#define DISPLACEMENTMAP_UV "+n.displacementMapUv:"",n.metalnessMapUv?"#define METALNESSMAP_UV "+n.metalnessMapUv:"",n.roughnessMapUv?"#define ROUGHNESSMAP_UV "+n.roughnessMapUv:"",n.anisotropyMapUv?"#define ANISOTROPYMAP_UV "+n.anisotropyMapUv:"",n.clearcoatMapUv?"#define CLEARCOATMAP_UV "+n.clearcoatMapUv:"",n.clearcoatNormalMapUv?"#define CLEARCOAT_NORMALMAP_UV "+n.clearcoatNormalMapUv:"",n.clearcoatRoughnessMapUv?"#define CLEARCOAT_ROUGHNESSMAP_UV "+n.clearcoatRoughnessMapUv:"",n.iridescenceMapUv?"#define IRIDESCENCEMAP_UV "+n.iridescenceMapUv:"",n.iridescenceThicknessMapUv?"#define IRIDESCENCE_THICKNESSMAP_UV "+n.iridescenceThicknessMapUv:"",n.sheenColorMapUv?"#define SHEEN_COLORMAP_UV "+n.sheenColorMapUv:"",n.sheenRoughnessMapUv?"#define SHEEN_ROUGHNESSMAP_UV "+n.sheenRoughnessMapUv:"",n.specularMapUv?"#define SPECULARMAP_UV "+n.specularMapUv:"",n.specularColorMapUv?"#define SPECULAR_COLORMAP_UV "+n.specularColorMapUv:"",n.specularIntensityMapUv?"#define SPECULAR_INTENSITYMAP_UV "+n.specularIntensityMapUv:"",n.transmissionMapUv?"#define TRANSMISSIONMAP_UV "+n.transmissionMapUv:"",n.thicknessMapUv?"#define THICKNESSMAP_UV "+n.thicknessMapUv:"",n.vertexTangents&&!1===n.flatShading?"#define USE_TANGENT":"",n.vertexColors?"#define USE_COLOR":"",n.vertexAlphas?"#define USE_COLOR_ALPHA":"",n.vertexUv1s?"#define USE_UV1":"",n.vertexUv2s?"#define USE_UV2":"",n.vertexUv3s?"#define USE_UV3":"",n.pointsUvs?"#define USE_POINTS_UV":"",n.flatShading?"#define FLAT_SHADED":"",n.skinning?"#define USE_SKINNING":"",n.morphTargets?"#define USE_MORPHTARGETS":"",n.morphNormals&&!1===n.flatShading?"#define USE_MORPHNORMALS":"",n.morphColors&&n.isWebGL2?"#define USE_MORPHCOLORS":"",n.morphTargetsCount>0&&n.isWebGL2?"#define MORPHTARGETS_TEXTURE":"",n.morphTargetsCount>0&&n.isWebGL2?"#define MORPHTARGETS_TEXTURE_STRIDE "+n.morphTextureStride:"",n.morphTargetsCount>0&&n.isWebGL2?"#define MORPHTARGETS_COUNT "+n.morphTargetsCount:"",n.doubleSided?"#define DOUBLE_SIDED":"",n.flipSided?"#define FLIP_SIDED":"",n.shadowMapEnabled?"#define USE_SHADOWMAP":"",n.shadowMapEnabled?"#define "+c:"",n.sizeAttenuation?"#define USE_SIZEATTENUATION":"",n.useLegacyLights?"#define LEGACY_LIGHTS":"",n.logarithmicDepthBuffer?"#define USE_LOGDEPTHBUF":"",n.logarithmicDepthBuffer&&n.rendererExtensionFragDepth?"#define USE_LOGDEPTHBUF_EXT":"","uniform mat4 modelMatrix;","uniform mat4 modelViewMatrix;","uniform mat4 projectionMatrix;","uniform mat4 viewMatrix;","uniform mat3 normalMatrix;","uniform vec3 cameraPosition;","uniform bool isOrthographic;","#ifdef USE_INSTANCING","\tattribute mat4 instanceMatrix;","#endif","#ifdef USE_INSTANCING_COLOR","\tattribute vec3 instanceColor;","#endif","attribute vec3 position;","attribute vec3 normal;","attribute vec2 uv;","#ifdef USE_UV1","\tattribute vec2 uv1;","#endif","#ifdef USE_UV2","\tattribute vec2 uv2;","#endif","#ifdef USE_UV3","\tattribute vec2 uv3;","#endif","#ifdef USE_TANGENT","\tattribute vec4 tangent;","#endif","#if defined( USE_COLOR_ALPHA )","\tattribute vec4 color;","#elif defined( USE_COLOR )","\tattribute vec3 color;","#endif","#if ( defined( USE_MORPHTARGETS ) && ! defined( MORPHTARGETS_TEXTURE ) )","\tattribute vec3 morphTarget0;","\tattribute vec3 morphTarget1;","\tattribute vec3 morphTarget2;","\tattribute vec3 morphTarget3;","\t#ifdef USE_MORPHNORMALS","\t\tattribute vec3 morphNormal0;","\t\tattribute vec3 morphNormal1;","\t\tattribute vec3 morphNormal2;","\t\tattribute vec3 morphNormal3;","\t#else","\t\tattribute vec3 morphTarget4;","\t\tattribute vec3 morphTarget5;","\t\tattribute vec3 morphTarget6;","\t\tattribute vec3 morphTarget7;","\t#endif","#endif","#ifdef USE_SKINNING","\tattribute vec4 skinIndex;","\tattribute vec4 skinWeight;","#endif","\n"].filter(up).join("\n"),g=[h,yp(n),"#define SHADER_TYPE "+n.shaderType,"#define SHADER_NAME "+n.shaderName,p,n.useFog&&n.fog?"#define USE_FOG":"",n.useFog&&n.fogExp2?"#define FOG_EXP2":"",n.map?"#define USE_MAP":"",n.matcap?"#define USE_MATCAP":"",n.envMap?"#define USE_ENVMAP":"",n.envMap?"#define "+l:"",n.envMap?"#define "+u:"",n.envMap?"#define "+d:"",f?"#define CUBEUV_TEXEL_WIDTH "+f.texelWidth:"",f?"#define CUBEUV_TEXEL_HEIGHT "+f.texelHeight:"",f?"#define CUBEUV_MAX_MIP "+f.maxMip+".0":"",n.lightMap?"#define USE_LIGHTMAP":"",n.aoMap?"#define USE_AOMAP":"",n.bumpMap?"#define USE_BUMPMAP":"",n.normalMap?"#define USE_NORMALMAP":"",n.normalMapObjectSpace?"#define USE_NORMALMAP_OBJECTSPACE":"",n.normalMapTangentSpace?"#define USE_NORMALMAP_TANGENTSPACE":"",n.emissiveMap?"#define USE_EMISSIVEMAP":"",n.anisotropy?"#define USE_ANISOTROPY":"",n.anisotropyMap?"#define USE_ANISOTROPYMAP":"",n.clearcoat?"#define USE_CLEARCOAT":"",n.clearcoatMap?"#define USE_CLEARCOATMAP":"",n.clearcoatRoughnessMap?"#define USE_CLEARCOAT_ROUGHNESSMAP":"",n.clearcoatNormalMap?"#define USE_CLEARCOAT_NORMALMAP":"",n.iridescence?"#define USE_IRIDESCENCE":"",n.iridescenceMap?"#define USE_IRIDESCENCEMAP":"",n.iridescenceThicknessMap?"#define USE_IRIDESCENCE_THICKNESSMAP":"",n.specularMap?"#define USE_SPECULARMAP":"",n.specularColorMap?"#define USE_SPECULAR_COLORMAP":"",n.specularIntensityMap?"#define USE_SPECULAR_INTENSITYMAP":"",n.roughnessMap?"#define USE_ROUGHNESSMAP":"",n.metalnessMap?"#define USE_METALNESSMAP":"",n.alphaMap?"#define USE_ALPHAMAP":"",n.alphaTest?"#define USE_ALPHATEST":"",n.alphaHash?"#define USE_ALPHAHASH":"",n.sheen?"#define USE_SHEEN":"",n.sheenColorMap?"#define USE_SHEEN_COLORMAP":"",n.sheenRoughnessMap?"#define USE_SHEEN_ROUGHNESSMAP":"",n.transmission?"#define USE_TRANSMISSION":"",n.transmissionMap?"#define USE_TRANSMISSIONMAP":"",n.thicknessMap?"#define USE_THICKNESSMAP":"",n.vertexTangents&&!1===n.flatShading?"#define USE_TANGENT":"",n.vertexColors||n.instancingColor?"#define USE_COLOR":"",n.vertexAlphas?"#define USE_COLOR_ALPHA":"",n.vertexUv1s?"#define USE_UV1":"",n.vertexUv2s?"#define USE_UV2":"",n.vertexUv3s?"#define USE_UV3":"",n.pointsUvs?"#define USE_POINTS_UV":"",n.gradientMap?"#define USE_GRADIENTMAP":"",n.flatShading?"#define FLAT_SHADED":"",n.doubleSided?"#define DOUBLE_SIDED":"",n.flipSided?"#define FLIP_SIDED":"",n.shadowMapEnabled?"#define USE_SHADOWMAP":"",n.shadowMapEnabled?"#define "+c:"",n.premultipliedAlpha?"#define PREMULTIPLIED_ALPHA":"",n.useLegacyLights?"#define LEGACY_LIGHTS":"",n.logarithmicDepthBuffer?"#define USE_LOGDEPTHBUF":"",n.logarithmicDepthBuffer&&n.rendererExtensionFragDepth?"#define USE_LOGDEPTHBUF_EXT":"","uniform mat4 viewMatrix;","uniform vec3 cameraPosition;","uniform bool isOrthographic;",n.toneMapping!==Ec?"#define TONE_MAPPING":"",n.toneMapping!==Ec?wf.tonemapping_pars_fragment:"",n.toneMapping!==Ec?lp("toneMapping",n.toneMapping):"",n.dithering?"#define DITHERING":"",n.opaque?"#define OPAQUE":"",wf.colorspace_pars_fragment,cp("linearToOutputTexel",n.outputColorSpace),n.useDepthPacking?"#define DEPTH_PACKING "+n.depthPacking:"","\n"].filter(up).join("\n")),o=pp(o),o=dp(o,n),o=fp(o,n),s=pp(s),s=dp(s,n),s=fp(s,n),o=bp(o),s=bp(s),n.isWebGL2&&!0!==n.isRawShaderMaterial&&(b="#version 300 es\n",v=["precision mediump sampler2DArray;","#define attribute in","#define varying out","#define texture2D texture"].join("\n")+"\n"+v,g=["#define varying in",n.glslVersion===cl?"":"layout(location = 0) out highp vec4 pc_fragColor;",n.glslVersion===cl?"":"#define gl_FragColor pc_fragColor","#define gl_FragDepthEXT gl_FragDepth","#define texture2D texture","#define textureCube texture","#define texture2DProj textureProj","#define texture2DLodEXT textureLod","#define texture2DProjLodEXT textureProjLod","#define textureCubeLodEXT textureLod","#define texture2DGradEXT textureGrad","#define texture2DProjGradEXT textureProjGrad","#define textureCubeGradEXT textureGrad"].join("\n")+"\n"+g);const _=b+v+o,y=b+g+s,x=ap(i,i.VERTEX_SHADER,_),A=ap(i,i.FRAGMENT_SHADER,y);if(i.attachShader(m,x),i.attachShader(m,A),void 0!==n.index0AttributeName?i.bindAttribLocation(m,0,n.index0AttributeName):!0===n.morphTargets&&i.bindAttribLocation(m,0,"position"),i.linkProgram(m),e.debug.checkShaderErrors){const t=i.getProgramInfoLog(m).trim(),n=i.getShaderInfoLog(x).trim(),r=i.getShaderInfoLog(A).trim();let a=!0,o=!0;if(!1===i.getProgramParameter(m,i.LINK_STATUS))if(a=!1,"function"==typeof e.debug.onShaderError)e.debug.onShaderError(i,m,x,A);else{const e=sp(i,x,"vertex"),n=sp(i,A,"fragment");console.error("THREE.WebGLProgram: Shader Error "+i.getError()+" - VALIDATE_STATUS "+i.getProgramParameter(m,i.VALIDATE_STATUS)+"\n\nProgram Info Log: "+t+"\n"+e+"\n"+n)}else""!==t?console.warn("THREE.WebGLProgram: Program Info Log:",t):""!==n&&""!==r||(o=!1);o&&(this.diagnostics={runnable:a,programLog:t,vertexShader:{log:n,prefix:v},fragmentShader:{log:r,prefix:g}})}let w,E;return i.deleteShader(x),i.deleteShader(A),this.getUniforms=function(){return void 0===w&&(w=new ip(i,m)),w},this.getAttributes=function(){return void 0===E&&(E=function(e,t){const n={},r=e.getProgramParameter(t,e.ACTIVE_ATTRIBUTES);for(let i=0;i<r;i++){const r=e.getActiveAttrib(t,i),a=r.name;let o=1;r.type===e.FLOAT_MAT2&&(o=2),r.type===e.FLOAT_MAT3&&(o=3),r.type===e.FLOAT_MAT4&&(o=4),n[a]={type:r.type,location:e.getAttribLocation(t,a),locationSize:o}}return n}(i,m)),E},this.destroy=function(){r.releaseStatesOfProgram(this),i.deleteProgram(m),this.program=void 0},this.type=n.shaderType,this.name=n.shaderName,this.id=op++,this.cacheKey=t,this.usedTimes=1,this.program=m,this.vertexShader=x,this.fragmentShader=A,this}let Ap=0;class wp{constructor(){this.shaderCache=new Map,this.materialCache=new Map}update(e){const t=e.vertexShader,n=e.fragmentShader,r=this._getShaderStage(t),i=this._getShaderStage(n),a=this._getShaderCacheForMaterial(e);return!1===a.has(r)&&(a.add(r),r.usedTimes++),!1===a.has(i)&&(a.add(i),i.usedTimes++),this}remove(e){const t=this.materialCache.get(e);for(const e of t)e.usedTimes--,0===e.usedTimes&&this.shaderCache.delete(e.code);return this.materialCache.delete(e),this}getVertexShaderID(e){return this._getShaderStage(e.vertexShader).id}getFragmentShaderID(e){return this._getShaderStage(e.fragmentShader).id}dispose(){this.shaderCache.clear(),this.materialCache.clear()}_getShaderCacheForMaterial(e){const t=this.materialCache;let n=t.get(e);return void 0===n&&(n=new Set,t.set(e,n)),n}_getShaderStage(e){const t=this.shaderCache;let n=t.get(e);return void 0===n&&(n=new Ep(e),t.set(e,n)),n}}class Ep{constructor(e){this.id=Ap++,this.code=e,this.usedTimes=0}}function Tp(e,t,n,r,i,a,o){const s=new Bu,c=new wp,l=[],u=i.isWebGL2,d=i.logarithmicDepthBuffer,f=i.vertexTextures;let h=i.precision;const p={MeshDepthMaterial:"depth",MeshDistanceMaterial:"distanceRGBA",MeshNormalMaterial:"normal",MeshBasicMaterial:"basic",MeshLambertMaterial:"lambert",MeshPhongMaterial:"phong",MeshToonMaterial:"toon",MeshStandardMaterial:"physical",MeshPhysicalMaterial:"physical",MeshMatcapMaterial:"matcap",LineBasicMaterial:"basic",LineDashedMaterial:"dashed",PointsMaterial:"points",ShadowMaterial:"shadow",SpriteMaterial:"sprite"};function m(e){return 0===e?"uv":`uv${e}`}return{getParameters:function(a,s,l,v,g){const b=v.fog,_=g.geometry,y=a.isMeshStandardMaterial?v.environment:null,x=(a.isMeshStandardMaterial?n:t).get(a.envMap||y),A=x&&x.mapping===Oc?x.image.height:null,w=p[a.type];null!==a.precision&&(h=i.getMaxPrecision(a.precision),h!==a.precision&&console.warn("THREE.WebGLProgram.getParameters:",a.precision,"not supported, using",h,"instead."));const E=_.morphAttributes.position||_.morphAttributes.normal||_.morphAttributes.color,T=void 0!==E?E.length:0;let S,C,M,k,R=0;if(void 0!==_.morphAttributes.position&&(R=1),void 0!==_.morphAttributes.normal&&(R=2),void 0!==_.morphAttributes.color&&(R=3),w){const e=Tf[w];S=e.vertexShader,C=e.fragmentShader}else S=a.vertexShader,C=a.fragmentShader,c.update(a),M=c.getVertexShaderID(a),k=c.getFragmentShaderID(a);const L=e.getRenderTarget(),O=!0===g.isInstancedMesh,I=!!a.map,P=!!a.matcap,D=!!x,N=!!a.aoMap,U=!!a.lightMap,F=!!a.bumpMap,B=!!a.normalMap,z=!!a.displacementMap,H=!!a.emissiveMap,V=!!a.metalnessMap,G=!!a.roughnessMap,$=a.anisotropy>0,W=a.clearcoat>0,j=a.iridescence>0,X=a.sheen>0,Y=a.transmission>0,q=$&&!!a.anisotropyMap,K=W&&!!a.clearcoatMap,Z=W&&!!a.clearcoatNormalMap,J=W&&!!a.clearcoatRoughnessMap,Q=j&&!!a.iridescenceMap,ee=j&&!!a.iridescenceThicknessMap,te=X&&!!a.sheenColorMap,ne=X&&!!a.sheenRoughnessMap,re=!!a.specularMap,ie=!!a.specularColorMap,ae=!!a.specularIntensityMap,oe=Y&&!!a.transmissionMap,se=Y&&!!a.thicknessMap,ce=!!a.gradientMap,le=!!a.alphaMap,ue=a.alphaTest>0,de=!!a.alphaHash,fe=!!a.extensions,he=!!_.attributes.uv1,pe=!!_.attributes.uv2,me=!!_.attributes.uv3;return{isWebGL2:u,shaderID:w,shaderType:a.type,shaderName:a.name,vertexShader:S,fragmentShader:C,defines:a.defines,customVertexShaderID:M,customFragmentShaderID:k,isRawShaderMaterial:!0===a.isRawShaderMaterial,glslVersion:a.glslVersion,precision:h,instancing:O,instancingColor:O&&null!==g.instanceColor,supportsVertexTextures:f,outputColorSpace:null===L?e.outputColorSpace:!0===L.isXRRenderTarget?L.texture.colorSpace:al,map:I,matcap:P,envMap:D,envMapMode:D&&x.mapping,envMapCubeUVHeight:A,aoMap:N,lightMap:U,bumpMap:F,normalMap:B,displacementMap:f&&z,emissiveMap:H,normalMapObjectSpace:B&&1===a.normalMapType,normalMapTangentSpace:B&&0===a.normalMapType,metalnessMap:V,roughnessMap:G,anisotropy:$,anisotropyMap:q,clearcoat:W,clearcoatMap:K,clearcoatNormalMap:Z,clearcoatRoughnessMap:J,iridescence:j,iridescenceMap:Q,iridescenceThicknessMap:ee,sheen:X,sheenColorMap:te,sheenRoughnessMap:ne,specularMap:re,specularColorMap:ie,specularIntensityMap:ae,transmission:Y,transmissionMap:oe,thicknessMap:se,gradientMap:ce,opaque:!1===a.transparent&&1===a.blending,alphaMap:le,alphaTest:ue,alphaHash:de,combine:a.combine,mapUv:I&&m(a.map.channel),aoMapUv:N&&m(a.aoMap.channel),lightMapUv:U&&m(a.lightMap.channel),bumpMapUv:F&&m(a.bumpMap.channel),normalMapUv:B&&m(a.normalMap.channel),displacementMapUv:z&&m(a.displacementMap.channel),emissiveMapUv:H&&m(a.emissiveMap.channel),metalnessMapUv:V&&m(a.metalnessMap.channel),roughnessMapUv:G&&m(a.roughnessMap.channel),anisotropyMapUv:q&&m(a.anisotropyMap.channel),clearcoatMapUv:K&&m(a.clearcoatMap.channel),clearcoatNormalMapUv:Z&&m(a.clearcoatNormalMap.channel),clearcoatRoughnessMapUv:J&&m(a.clearcoatRoughnessMap.channel),iridescenceMapUv:Q&&m(a.iridescenceMap.channel),iridescenceThicknessMapUv:ee&&m(a.iridescenceThicknessMap.channel),sheenColorMapUv:te&&m(a.sheenColorMap.channel),sheenRoughnessMapUv:ne&&m(a.sheenRoughnessMap.channel),specularMapUv:re&&m(a.specularMap.channel),specularColorMapUv:ie&&m(a.specularColorMap.channel),specularIntensityMapUv:ae&&m(a.specularIntensityMap.channel),transmissionMapUv:oe&&m(a.transmissionMap.channel),thicknessMapUv:se&&m(a.thicknessMap.channel),alphaMapUv:le&&m(a.alphaMap.channel),vertexTangents:!!_.attributes.tangent&&(B||$),vertexColors:a.vertexColors,vertexAlphas:!0===a.vertexColors&&!!_.attributes.color&&4===_.attributes.color.itemSize,vertexUv1s:he,vertexUv2s:pe,vertexUv3s:me,pointsUvs:!0===g.isPoints&&!!_.attributes.uv&&(I||le),fog:!!b,useFog:!0===a.fog,fogExp2:b&&b.isFogExp2,flatShading:!0===a.flatShading,sizeAttenuation:!0===a.sizeAttenuation,logarithmicDepthBuffer:d,skinning:!0===g.isSkinnedMesh,morphTargets:void 0!==_.morphAttributes.position,morphNormals:void 0!==_.morphAttributes.normal,morphColors:void 0!==_.morphAttributes.color,morphTargetsCount:T,morphTextureStride:R,numDirLights:s.directional.length,numPointLights:s.point.length,numSpotLights:s.spot.length,numSpotLightMaps:s.spotLightMap.length,numRectAreaLights:s.rectArea.length,numHemiLights:s.hemi.length,numDirLightShadows:s.directionalShadowMap.length,numPointLightShadows:s.pointShadowMap.length,numSpotLightShadows:s.spotShadowMap.length,numSpotLightShadowsWithMaps:s.numSpotLightShadowsWithMaps,numClippingPlanes:o.numPlanes,numClipIntersection:o.numIntersection,dithering:a.dithering,shadowMapEnabled:e.shadowMap.enabled&&l.length>0,shadowMapType:e.shadowMap.type,toneMapping:a.toneMapped?e.toneMapping:Ec,useLegacyLights:e.useLegacyLights,premultipliedAlpha:a.premultipliedAlpha,doubleSided:2===a.side,flipSided:1===a.side,useDepthPacking:a.depthPacking>=0,depthPacking:a.depthPacking||0,index0AttributeName:a.index0AttributeName,extensionDerivatives:fe&&!0===a.extensions.derivatives,extensionFragDepth:fe&&!0===a.extensions.fragDepth,extensionDrawBuffers:fe&&!0===a.extensions.drawBuffers,extensionShaderTextureLOD:fe&&!0===a.extensions.shaderTextureLOD,rendererExtensionFragDepth:u||r.has("EXT_frag_depth"),rendererExtensionDrawBuffers:u||r.has("WEBGL_draw_buffers"),rendererExtensionShaderTextureLod:u||r.has("EXT_shader_texture_lod"),customProgramCacheKey:a.customProgramCacheKey()}},getProgramCacheKey:function(t){const n=[];if(t.shaderID?n.push(t.shaderID):(n.push(t.customVertexShaderID),n.push(t.customFragmentShaderID)),void 0!==t.defines)for(const e in t.defines)n.push(e),n.push(t.defines[e]);return!1===t.isRawShaderMaterial&&(function(e,t){e.push(t.precision),e.push(t.outputColorSpace),e.push(t.envMapMode),e.push(t.envMapCubeUVHeight),e.push(t.mapUv),e.push(t.alphaMapUv),e.push(t.lightMapUv),e.push(t.aoMapUv),e.push(t.bumpMapUv),e.push(t.normalMapUv),e.push(t.displacementMapUv),e.push(t.emissiveMapUv),e.push(t.metalnessMapUv),e.push(t.roughnessMapUv),e.push(t.anisotropyMapUv),e.push(t.clearcoatMapUv),e.push(t.clearcoatNormalMapUv),e.push(t.clearcoatRoughnessMapUv),e.push(t.iridescenceMapUv),e.push(t.iridescenceThicknessMapUv),e.push(t.sheenColorMapUv),e.push(t.sheenRoughnessMapUv),e.push(t.specularMapUv),e.push(t.specularColorMapUv),e.push(t.specularIntensityMapUv),e.push(t.transmissionMapUv),e.push(t.thicknessMapUv),e.push(t.combine),e.push(t.fogExp2),e.push(t.sizeAttenuation),e.push(t.morphTargetsCount),e.push(t.morphAttributeCount),e.push(t.numDirLights),e.push(t.numPointLights),e.push(t.numSpotLights),e.push(t.numSpotLightMaps),e.push(t.numHemiLights),e.push(t.numRectAreaLights),e.push(t.numDirLightShadows),e.push(t.numPointLightShadows),e.push(t.numSpotLightShadows),e.push(t.numSpotLightShadowsWithMaps),e.push(t.shadowMapType),e.push(t.toneMapping),e.push(t.numClippingPlanes),e.push(t.numClipIntersection),e.push(t.depthPacking)}(n,t),function(e,t){s.disableAll(),t.isWebGL2&&s.enable(0),t.supportsVertexTextures&&s.enable(1),t.instancing&&s.enable(2),t.instancingColor&&s.enable(3),t.matcap&&s.enable(4),t.envMap&&s.enable(5),t.normalMapObjectSpace&&s.enable(6),t.normalMapTangentSpace&&s.enable(7),t.clearcoat&&s.enable(8),t.iridescence&&s.enable(9),t.alphaTest&&s.enable(10),t.vertexColors&&s.enable(11),t.vertexAlphas&&s.enable(12),t.vertexUv1s&&s.enable(13),t.vertexUv2s&&s.enable(14),t.vertexUv3s&&s.enable(15),t.vertexTangents&&s.enable(16),t.anisotropy&&s.enable(17),e.push(s.mask),s.disableAll(),t.fog&&s.enable(0),t.useFog&&s.enable(1),t.flatShading&&s.enable(2),t.logarithmicDepthBuffer&&s.enable(3),t.skinning&&s.enable(4),t.morphTargets&&s.enable(5),t.morphNormals&&s.enable(6),t.morphColors&&s.enable(7),t.premultipliedAlpha&&s.enable(8),t.shadowMapEnabled&&s.enable(9),t.useLegacyLights&&s.enable(10),t.doubleSided&&s.enable(11),t.flipSided&&s.enable(12),t.useDepthPacking&&s.enable(13),t.dithering&&s.enable(14),t.transmission&&s.enable(15),t.sheen&&s.enable(16),t.opaque&&s.enable(17),t.pointsUvs&&s.enable(18),e.push(s.mask)}(n,t),n.push(e.outputColorSpace)),n.push(t.customProgramCacheKey),n.join()},getUniforms:function(e){const t=p[e.type];let n;if(t){const e=Tf[t];n=af.clone(e.uniforms)}else n=e.uniforms;return n},acquireProgram:function(t,n){let r;for(let e=0,t=l.length;e<t;e++){const t=l[e];if(t.cacheKey===n){r=t,++r.usedTimes;break}}return void 0===r&&(r=new xp(e,n,t,a),l.push(r)),r},releaseProgram:function(e){if(0==--e.usedTimes){const t=l.indexOf(e);l[t]=l[l.length-1],l.pop(),e.destroy()}},releaseShaderCache:function(e){c.remove(e)},programs:l,dispose:function(){c.dispose()}}}function Sp(){let e=new WeakMap;return{get:function(t){let n=e.get(t);return void 0===n&&(n={},e.set(t,n)),n},remove:function(t){e.delete(t)},update:function(t,n,r){e.get(t)[n]=r},dispose:function(){e=new WeakMap}}}function Cp(e,t){return e.groupOrder!==t.groupOrder?e.groupOrder-t.groupOrder:e.renderOrder!==t.renderOrder?e.renderOrder-t.renderOrder:e.material.id!==t.material.id?e.material.id-t.material.id:e.z!==t.z?e.z-t.z:e.id-t.id}function Mp(e,t){return e.groupOrder!==t.groupOrder?e.groupOrder-t.groupOrder:e.renderOrder!==t.renderOrder?e.renderOrder-t.renderOrder:e.z!==t.z?t.z-e.z:e.id-t.id}function kp(){const e=[];let t=0;const n=[],r=[],i=[];function a(n,r,i,a,o,s){let c=e[t];return void 0===c?(c={id:n.id,object:n,geometry:r,material:i,groupOrder:a,renderOrder:n.renderOrder,z:o,group:s},e[t]=c):(c.id=n.id,c.object=n,c.geometry=r,c.material=i,c.groupOrder=a,c.renderOrder=n.renderOrder,c.z=o,c.group=s),t++,c}return{opaque:n,transmissive:r,transparent:i,init:function(){t=0,n.length=0,r.length=0,i.length=0},push:function(e,t,o,s,c,l){const u=a(e,t,o,s,c,l);o.transmission>0?r.push(u):!0===o.transparent?i.push(u):n.push(u)},unshift:function(e,t,o,s,c,l){const u=a(e,t,o,s,c,l);o.transmission>0?r.unshift(u):!0===o.transparent?i.unshift(u):n.unshift(u)},finish:function(){for(let n=t,r=e.length;n<r;n++){const t=e[n];if(null===t.id)break;t.id=null,t.object=null,t.geometry=null,t.material=null,t.group=null}},sort:function(e,t){n.length>1&&n.sort(e||Cp),r.length>1&&r.sort(t||Mp),i.length>1&&i.sort(t||Mp)}}}function Rp(){let e=new WeakMap;return{get:function(t,n){const r=e.get(t);let i;return void 0===r?(i=new kp,e.set(t,[i])):n>=r.length?(i=new kp,r.push(i)):i=r[n],i},dispose:function(){e=new WeakMap}}}function Lp(){const e={};return{get:function(t){if(void 0!==e[t.id])return e[t.id];let n;switch(t.type){case"DirectionalLight":n={direction:new Jl,color:new bd};break;case"SpotLight":n={position:new Jl,direction:new Jl,color:new bd,distance:0,coneCos:0,penumbraCos:0,decay:0};break;case"PointLight":n={position:new Jl,color:new bd,distance:0,decay:0};break;case"HemisphereLight":n={direction:new Jl,skyColor:new bd,groundColor:new bd};break;case"RectAreaLight":n={color:new bd,position:new Jl,halfWidth:new Jl,halfHeight:new Jl}}return e[t.id]=n,n}}}let Op=0;function Ip(e,t){return(t.castShadow?2:0)-(e.castShadow?2:0)+(t.map?1:0)-(e.map?1:0)}function Pp(e,t){const n=new Lp,r=function(){const e={};return{get:function(t){if(void 0!==e[t.id])return e[t.id];let n;switch(t.type){case"DirectionalLight":case"SpotLight":n={shadowBias:0,shadowNormalBias:0,shadowRadius:1,shadowMapSize:new Sl};break;case"PointLight":n={shadowBias:0,shadowNormalBias:0,shadowRadius:1,shadowMapSize:new Sl,shadowCameraNear:1,shadowCameraFar:1e3}}return e[t.id]=n,n}}}(),i={version:0,hash:{directionalLength:-1,pointLength:-1,spotLength:-1,rectAreaLength:-1,hemiLength:-1,numDirectionalShadows:-1,numPointShadows:-1,numSpotShadows:-1,numSpotMaps:-1},ambient:[0,0,0],probe:[],directional:[],directionalShadow:[],directionalShadowMap:[],directionalShadowMatrix:[],spot:[],spotLightMap:[],spotShadow:[],spotShadowMap:[],spotLightMatrix:[],rectArea:[],rectAreaLTC1:null,rectAreaLTC2:null,point:[],pointShadow:[],pointShadowMap:[],pointShadowMatrix:[],hemi:[],numSpotLightShadowsWithMaps:0};for(let e=0;e<9;e++)i.probe.push(new Jl);const a=new Jl,o=new Mu,s=new Mu;return{setup:function(a,o){let s=0,c=0,l=0;for(let e=0;e<9;e++)i.probe[e].set(0,0,0);let u=0,d=0,f=0,h=0,p=0,m=0,v=0,g=0,b=0,_=0;a.sort(Ip);const y=!0===o?Math.PI:1;for(let e=0,t=a.length;e<t;e++){const t=a[e],o=t.color,x=t.intensity,A=t.distance,w=t.shadow&&t.shadow.map?t.shadow.map.texture:null;if(t.isAmbientLight)s+=o.r*x*y,c+=o.g*x*y,l+=o.b*x*y;else if(t.isLightProbe)for(let e=0;e<9;e++)i.probe[e].addScaledVector(t.sh.coefficients[e],x);else if(t.isDirectionalLight){const e=n.get(t);if(e.color.copy(t.color).multiplyScalar(t.intensity*y),t.castShadow){const e=t.shadow,n=r.get(t);n.shadowBias=e.bias,n.shadowNormalBias=e.normalBias,n.shadowRadius=e.radius,n.shadowMapSize=e.mapSize,i.directionalShadow[u]=n,i.directionalShadowMap[u]=w,i.directionalShadowMatrix[u]=t.shadow.matrix,m++}i.directional[u]=e,u++}else if(t.isSpotLight){const e=n.get(t);e.position.setFromMatrixPosition(t.matrixWorld),e.color.copy(o).multiplyScalar(x*y),e.distance=A,e.coneCos=Math.cos(t.angle),e.penumbraCos=Math.cos(t.angle*(1-t.penumbra)),e.decay=t.decay,i.spot[f]=e;const a=t.shadow;if(t.map&&(i.spotLightMap[b]=t.map,b++,a.updateMatrices(t),t.castShadow&&_++),i.spotLightMatrix[f]=a.matrix,t.castShadow){const e=r.get(t);e.shadowBias=a.bias,e.shadowNormalBias=a.normalBias,e.shadowRadius=a.radius,e.shadowMapSize=a.mapSize,i.spotShadow[f]=e,i.spotShadowMap[f]=w,g++}f++}else if(t.isRectAreaLight){const e=n.get(t);e.color.copy(o).multiplyScalar(x),e.halfWidth.set(.5*t.width,0,0),e.halfHeight.set(0,.5*t.height,0),i.rectArea[h]=e,h++}else if(t.isPointLight){const e=n.get(t);if(e.color.copy(t.color).multiplyScalar(t.intensity*y),e.distance=t.distance,e.decay=t.decay,t.castShadow){const e=t.shadow,n=r.get(t);n.shadowBias=e.bias,n.shadowNormalBias=e.normalBias,n.shadowRadius=e.radius,n.shadowMapSize=e.mapSize,n.shadowCameraNear=e.camera.near,n.shadowCameraFar=e.camera.far,i.pointShadow[d]=n,i.pointShadowMap[d]=w,i.pointShadowMatrix[d]=t.shadow.matrix,v++}i.point[d]=e,d++}else if(t.isHemisphereLight){const e=n.get(t);e.skyColor.copy(t.color).multiplyScalar(x*y),e.groundColor.copy(t.groundColor).multiplyScalar(x*y),i.hemi[p]=e,p++}}h>0&&(t.isWebGL2||!0===e.has("OES_texture_float_linear")?(i.rectAreaLTC1=Ef.LTC_FLOAT_1,i.rectAreaLTC2=Ef.LTC_FLOAT_2):!0===e.has("OES_texture_half_float_linear")?(i.rectAreaLTC1=Ef.LTC_HALF_1,i.rectAreaLTC2=Ef.LTC_HALF_2):console.error("THREE.WebGLRenderer: Unable to use RectAreaLight. Missing WebGL extensions.")),i.ambient[0]=s,i.ambient[1]=c,i.ambient[2]=l;const x=i.hash;x.directionalLength===u&&x.pointLength===d&&x.spotLength===f&&x.rectAreaLength===h&&x.hemiLength===p&&x.numDirectionalShadows===m&&x.numPointShadows===v&&x.numSpotShadows===g&&x.numSpotMaps===b||(i.directional.length=u,i.spot.length=f,i.rectArea.length=h,i.point.length=d,i.hemi.length=p,i.directionalShadow.length=m,i.directionalShadowMap.length=m,i.pointShadow.length=v,i.pointShadowMap.length=v,i.spotShadow.length=g,i.spotShadowMap.length=g,i.directionalShadowMatrix.length=m,i.pointShadowMatrix.length=v,i.spotLightMatrix.length=g+b-_,i.spotLightMap.length=b,i.numSpotLightShadowsWithMaps=_,x.directionalLength=u,x.pointLength=d,x.spotLength=f,x.rectAreaLength=h,x.hemiLength=p,x.numDirectionalShadows=m,x.numPointShadows=v,x.numSpotShadows=g,x.numSpotMaps=b,i.version=Op++)},setupView:function(e,t){let n=0,r=0,c=0,l=0,u=0;const d=t.matrixWorldInverse;for(let t=0,f=e.length;t<f;t++){const f=e[t];if(f.isDirectionalLight){const e=i.directional[n];e.direction.setFromMatrixPosition(f.matrixWorld),a.setFromMatrixPosition(f.target.matrixWorld),e.direction.sub(a),e.direction.transformDirection(d),n++}else if(f.isSpotLight){const e=i.spot[c];e.position.setFromMatrixPosition(f.matrixWorld),e.position.applyMatrix4(d),e.direction.setFromMatrixPosition(f.matrixWorld),a.setFromMatrixPosition(f.target.matrixWorld),e.direction.sub(a),e.direction.transformDirection(d),c++}else if(f.isRectAreaLight){const e=i.rectArea[l];e.position.setFromMatrixPosition(f.matrixWorld),e.position.applyMatrix4(d),s.identity(),o.copy(f.matrixWorld),o.premultiply(d),s.extractRotation(o),e.halfWidth.set(.5*f.width,0,0),e.halfHeight.set(0,.5*f.height,0),e.halfWidth.applyMatrix4(s),e.halfHeight.applyMatrix4(s),l++}else if(f.isPointLight){const e=i.point[r];e.position.setFromMatrixPosition(f.matrixWorld),e.position.applyMatrix4(d),r++}else if(f.isHemisphereLight){const e=i.hemi[u];e.direction.setFromMatrixPosition(f.matrixWorld),e.direction.transformDirection(d),u++}}},state:i}}function Dp(e,t){const n=new Pp(e,t),r=[],i=[];return{init:function(){r.length=0,i.length=0},state:{lightsArray:r,shadowsArray:i,lights:n},setupLights:function(e){n.setup(r,e)},setupLightsView:function(e){n.setupView(r,e)},pushLight:function(e){r.push(e)},pushShadow:function(e){i.push(e)}}}function Np(e,t){let n=new WeakMap;return{get:function(r,i=0){const a=n.get(r);let o;return void 0===a?(o=new Dp(e,t),n.set(r,[o])):i>=a.length?(o=new Dp(e,t),a.push(o)):o=a[i],o},dispose:function(){n=new WeakMap}}}class Up extends hd{constructor(e){super(),this.isMeshDepthMaterial=!0,this.type="MeshDepthMaterial",this.depthPacking=3200,this.map=null,this.alphaMap=null,this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.wireframe=!1,this.wireframeLinewidth=1,this.setValues(e)}copy(e){return super.copy(e),this.depthPacking=e.depthPacking,this.map=e.map,this.alphaMap=e.alphaMap,this.displacementMap=e.displacementMap,this.displacementScale=e.displacementScale,this.displacementBias=e.displacementBias,this.wireframe=e.wireframe,this.wireframeLinewidth=e.wireframeLinewidth,this}}class Fp extends hd{constructor(e){super(),this.isMeshDistanceMaterial=!0,this.type="MeshDistanceMaterial",this.map=null,this.alphaMap=null,this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.setValues(e)}copy(e){return super.copy(e),this.map=e.map,this.alphaMap=e.alphaMap,this.displacementMap=e.displacementMap,this.displacementScale=e.displacementScale,this.displacementBias=e.displacementBias,this}}function Bp(e,t,n){let r=new _f;const i=new Sl,a=new Sl,o=new Xl,s=new Up({depthPacking:3201}),c=new Fp,l={},u=n.maxTextureSize,d={0:1,1:0,2:2},f=new of({defines:{VSM_SAMPLES:8},uniforms:{shadow_pass:{value:null},resolution:{value:new Sl},radius:{value:4}},vertexShader:"void main() {\n\tgl_Position = vec4( position, 1.0 );\n}",fragmentShader:"uniform sampler2D shadow_pass;\nuniform vec2 resolution;\nuniform float radius;\n#include <packing>\nvoid main() {\n\tconst float samples = float( VSM_SAMPLES );\n\tfloat mean = 0.0;\n\tfloat squared_mean = 0.0;\n\tfloat uvStride = samples <= 1.0 ? 0.0 : 2.0 / ( samples - 1.0 );\n\tfloat uvStart = samples <= 1.0 ? 0.0 : - 1.0;\n\tfor ( float i = 0.0; i < samples; i ++ ) {\n\t\tfloat uvOffset = uvStart + i * uvStride;\n\t\t#ifdef HORIZONTAL_PASS\n\t\t\tvec2 distribution = unpackRGBATo2Half( texture2D( shadow_pass, ( gl_FragCoord.xy + vec2( uvOffset, 0.0 ) * radius ) / resolution ) );\n\t\t\tmean += distribution.x;\n\t\t\tsquared_mean += distribution.y * distribution.y + distribution.x * distribution.x;\n\t\t#else\n\t\t\tfloat depth = unpackRGBAToDepth( texture2D( shadow_pass, ( gl_FragCoord.xy + vec2( 0.0, uvOffset ) * radius ) / resolution ) );\n\t\t\tmean += depth;\n\t\t\tsquared_mean += depth * depth;\n\t\t#endif\n\t}\n\tmean = mean / samples;\n\tsquared_mean = squared_mean / samples;\n\tfloat std_dev = sqrt( squared_mean - mean * mean );\n\tgl_FragColor = pack2HalfToRGBA( vec2( mean, std_dev ) );\n}"}),h=f.clone();h.defines.HORIZONTAL_PASS=1;const p=new Pd;p.setAttribute("position",new wd(new Float32Array([-1,-1,.5,3,-1,.5,-1,3,.5]),3));const m=new Jd(p,f),v=this;this.enabled=!1,this.autoUpdate=!0,this.needsUpdate=!1,this.type=gc;let g=this.type;function b(n,r){const a=t.update(m);f.defines.VSM_SAMPLES!==n.blurSamples&&(f.defines.VSM_SAMPLES=n.blurSamples,h.defines.VSM_SAMPLES=n.blurSamples,f.needsUpdate=!0,h.needsUpdate=!0),null===n.mapPass&&(n.mapPass=new Yl(i.x,i.y)),f.uniforms.shadow_pass.value=n.map.texture,f.uniforms.resolution.value=n.mapSize,f.uniforms.radius.value=n.radius,e.setRenderTarget(n.mapPass),e.clear(),e.renderBufferDirect(r,null,a,f,m,null),h.uniforms.shadow_pass.value=n.mapPass.texture,h.uniforms.resolution.value=n.mapSize,h.uniforms.radius.value=n.radius,e.setRenderTarget(n.map),e.clear(),e.renderBufferDirect(r,null,a,h,m,null)}function _(t,n,r,i){let a=null;const o=!0===r.isPointLight?t.customDistanceMaterial:t.customDepthMaterial;if(void 0!==o)a=o;else if(a=!0===r.isPointLight?c:s,e.localClippingEnabled&&!0===n.clipShadows&&Array.isArray(n.clippingPlanes)&&0!==n.clippingPlanes.length||n.displacementMap&&0!==n.displacementScale||n.alphaMap&&n.alphaTest>0||n.map&&n.alphaTest>0){const e=a.uuid,t=n.uuid;let r=l[e];void 0===r&&(r={},l[e]=r);let i=r[t];void 0===i&&(i=a.clone(),r[t]=i),a=i}return a.visible=n.visible,a.wireframe=n.wireframe,a.side=i===_c?null!==n.shadowSide?n.shadowSide:n.side:null!==n.shadowSide?n.shadowSide:d[n.side],a.alphaMap=n.alphaMap,a.alphaTest=n.alphaTest,a.map=n.map,a.clipShadows=n.clipShadows,a.clippingPlanes=n.clippingPlanes,a.clipIntersection=n.clipIntersection,a.displacementMap=n.displacementMap,a.displacementScale=n.displacementScale,a.displacementBias=n.displacementBias,a.wireframeLinewidth=n.wireframeLinewidth,a.linewidth=n.linewidth,!0===r.isPointLight&&!0===a.isMeshDistanceMaterial&&(e.properties.get(a).light=r),a}function y(n,i,a,o,s){if(!1===n.visible)return;if(n.layers.test(i.layers)&&(n.isMesh||n.isLine||n.isPoints)&&(n.castShadow||n.receiveShadow&&s===_c)&&(!n.frustumCulled||r.intersectsObject(n))){n.modelViewMatrix.multiplyMatrices(a.matrixWorldInverse,n.matrixWorld);const r=t.update(n),i=n.material;if(Array.isArray(i)){const t=r.groups;for(let c=0,l=t.length;c<l;c++){const l=t[c],u=i[l.materialIndex];if(u&&u.visible){const t=_(n,u,o,s);e.renderBufferDirect(a,null,r,t,n,l)}}}else if(i.visible){const t=_(n,i,o,s);e.renderBufferDirect(a,null,r,t,n,null)}}const c=n.children;for(let e=0,t=c.length;e<t;e++)y(c[e],i,a,o,s)}this.render=function(t,n,s){if(!1===v.enabled)return;if(!1===v.autoUpdate&&!1===v.needsUpdate)return;if(0===t.length)return;const c=e.getRenderTarget(),l=e.getActiveCubeFace(),d=e.getActiveMipmapLevel(),f=e.state;f.setBlending(0),f.buffers.color.setClear(1,1,1,1),f.buffers.depth.setTest(!0),f.setScissorTest(!1);const h=g!==_c&&this.type===_c,p=g===_c&&this.type!==_c;for(let c=0,l=t.length;c<l;c++){const l=t[c],d=l.shadow;if(void 0===d){console.warn("THREE.WebGLShadowMap:",l,"has no shadow.");continue}if(!1===d.autoUpdate&&!1===d.needsUpdate)continue;i.copy(d.mapSize);const m=d.getFrameExtents();if(i.multiply(m),a.copy(d.mapSize),(i.x>u||i.y>u)&&(i.x>u&&(a.x=Math.floor(u/m.x),i.x=a.x*m.x,d.mapSize.x=a.x),i.y>u&&(a.y=Math.floor(u/m.y),i.y=a.y*m.y,d.mapSize.y=a.y)),null===d.map||!0===h||!0===p){const e=this.type!==_c?{minFilter:Nc,magFilter:Nc}:{};null!==d.map&&d.map.dispose(),d.map=new Yl(i.x,i.y,e),d.map.texture.name=l.name+".shadowMap",d.camera.updateProjectionMatrix()}e.setRenderTarget(d.map),e.clear();const v=d.getViewportCount();for(let e=0;e<v;e++){const t=d.getViewport(e);o.set(a.x*t.x,a.y*t.y,a.x*t.z,a.y*t.w),f.viewport(o),d.updateMatrices(l,e),r=d.getFrustum(),y(n,s,d.camera,l,this.type)}!0!==d.isPointLightShadow&&this.type===_c&&b(d,s),d.needsUpdate=!1}g=this.type,v.needsUpdate=!1,e.setRenderTarget(c,l,d)}}function zp(e,t,n){const r=n.isWebGL2,i=new function(){let t=!1;const n=new Xl;let r=null;const i=new Xl(0,0,0,0);return{setMask:function(n){r===n||t||(e.colorMask(n,n,n,n),r=n)},setLocked:function(e){t=e},setClear:function(t,r,a,o,s){!0===s&&(t*=o,r*=o,a*=o),n.set(t,r,a,o),!1===i.equals(n)&&(e.clearColor(t,r,a,o),i.copy(n))},reset:function(){t=!1,r=null,i.set(-1,0,0,0)}}},a=new function(){let t=!1,n=null,r=null,i=null;return{setTest:function(t){t?z(e.DEPTH_TEST):H(e.DEPTH_TEST)},setMask:function(r){n===r||t||(e.depthMask(r),n=r)},setFunc:function(t){if(r!==t){switch(t){case 0:e.depthFunc(e.NEVER);break;case 1:e.depthFunc(e.ALWAYS);break;case 2:e.depthFunc(e.LESS);break;case 3:default:e.depthFunc(e.LEQUAL);break;case 4:e.depthFunc(e.EQUAL);break;case 5:e.depthFunc(e.GEQUAL);break;case 6:e.depthFunc(e.GREATER);break;case 7:e.depthFunc(e.NOTEQUAL)}r=t}},setLocked:function(e){t=e},setClear:function(t){i!==t&&(e.clearDepth(t),i=t)},reset:function(){t=!1,n=null,r=null,i=null}}},o=new function(){let t=!1,n=null,r=null,i=null,a=null,o=null,s=null,c=null,l=null;return{setTest:function(n){t||(n?z(e.STENCIL_TEST):H(e.STENCIL_TEST))},setMask:function(r){n===r||t||(e.stencilMask(r),n=r)},setFunc:function(t,n,o){r===t&&i===n&&a===o||(e.stencilFunc(t,n,o),r=t,i=n,a=o)},setOp:function(t,n,r){o===t&&s===n&&c===r||(e.stencilOp(t,n,r),o=t,s=n,c=r)},setLocked:function(e){t=e},setClear:function(t){l!==t&&(e.clearStencil(t),l=t)},reset:function(){t=!1,n=null,r=null,i=null,a=null,o=null,s=null,c=null,l=null}}},s=new WeakMap,c=new WeakMap;let l={},u={},d=new WeakMap,f=[],h=null,p=!1,m=null,v=null,g=null,b=null,_=null,y=null,x=null,A=!1,w=null,E=null,T=null,S=null,C=null;const M=e.getParameter(e.MAX_COMBINED_TEXTURE_IMAGE_UNITS);let k=!1,R=0;const L=e.getParameter(e.VERSION);-1!==L.indexOf("WebGL")?(R=parseFloat(/^WebGL (\d)/.exec(L)[1]),k=R>=1):-1!==L.indexOf("OpenGL ES")&&(R=parseFloat(/^OpenGL ES (\d)/.exec(L)[1]),k=R>=2);let O=null,I={};const P=e.getParameter(e.SCISSOR_BOX),D=e.getParameter(e.VIEWPORT),N=(new Xl).fromArray(P),U=(new Xl).fromArray(D);function F(t,n,i,a){const o=new Uint8Array(4),s=e.createTexture();e.bindTexture(t,s),e.texParameteri(t,e.TEXTURE_MIN_FILTER,e.NEAREST),e.texParameteri(t,e.TEXTURE_MAG_FILTER,e.NEAREST);for(let s=0;s<i;s++)!r||t!==e.TEXTURE_3D&&t!==e.TEXTURE_2D_ARRAY?e.texImage2D(n+s,0,e.RGBA,1,1,0,e.RGBA,e.UNSIGNED_BYTE,o):e.texImage3D(n,0,e.RGBA,1,1,a,0,e.RGBA,e.UNSIGNED_BYTE,o);return s}const B={};function z(t){!0!==l[t]&&(e.enable(t),l[t]=!0)}function H(t){!1!==l[t]&&(e.disable(t),l[t]=!1)}B[e.TEXTURE_2D]=F(e.TEXTURE_2D,e.TEXTURE_2D,1),B[e.TEXTURE_CUBE_MAP]=F(e.TEXTURE_CUBE_MAP,e.TEXTURE_CUBE_MAP_POSITIVE_X,6),r&&(B[e.TEXTURE_2D_ARRAY]=F(e.TEXTURE_2D_ARRAY,e.TEXTURE_2D_ARRAY,1,1),B[e.TEXTURE_3D]=F(e.TEXTURE_3D,e.TEXTURE_3D,1,1)),i.setClear(0,0,0,1),a.setClear(1),o.setClear(0),z(e.DEPTH_TEST),a.setFunc(3),W(!1),j(1),z(e.CULL_FACE),$(0);const V={[yc]:e.FUNC_ADD,101:e.FUNC_SUBTRACT,102:e.FUNC_REVERSE_SUBTRACT};if(r)V[103]=e.MIN,V[104]=e.MAX;else{const e=t.get("EXT_blend_minmax");null!==e&&(V[103]=e.MIN_EXT,V[104]=e.MAX_EXT)}const G={200:e.ZERO,201:e.ONE,202:e.SRC_COLOR,204:e.SRC_ALPHA,210:e.SRC_ALPHA_SATURATE,208:e.DST_COLOR,206:e.DST_ALPHA,203:e.ONE_MINUS_SRC_COLOR,205:e.ONE_MINUS_SRC_ALPHA,209:e.ONE_MINUS_DST_COLOR,207:e.ONE_MINUS_DST_ALPHA};function $(t,n,r,i,a,o,s,c){if(0!==t){if(!1===p&&(z(e.BLEND),p=!0),5===t)a=a||n,o=o||r,s=s||i,n===v&&a===_||(e.blendEquationSeparate(V[n],V[a]),v=n,_=a),r===g&&i===b&&o===y&&s===x||(e.blendFuncSeparate(G[r],G[i],G[o],G[s]),g=r,b=i,y=o,x=s),m=t,A=!1;else if(t!==m||c!==A){if(v===yc&&_===yc||(e.blendEquation(e.FUNC_ADD),v=yc,_=yc),c)switch(t){case 1:e.blendFuncSeparate(e.ONE,e.ONE_MINUS_SRC_ALPHA,e.ONE,e.ONE_MINUS_SRC_ALPHA);break;case 2:e.blendFunc(e.ONE,e.ONE);break;case 3:e.blendFuncSeparate(e.ZERO,e.ONE_MINUS_SRC_COLOR,e.ZERO,e.ONE);break;case 4:e.blendFuncSeparate(e.ZERO,e.SRC_COLOR,e.ZERO,e.SRC_ALPHA);break;default:console.error("THREE.WebGLState: Invalid blending: ",t)}else switch(t){case 1:e.blendFuncSeparate(e.SRC_ALPHA,e.ONE_MINUS_SRC_ALPHA,e.ONE,e.ONE_MINUS_SRC_ALPHA);break;case 2:e.blendFunc(e.SRC_ALPHA,e.ONE);break;case 3:e.blendFuncSeparate(e.ZERO,e.ONE_MINUS_SRC_COLOR,e.ZERO,e.ONE);break;case 4:e.blendFunc(e.ZERO,e.SRC_COLOR);break;default:console.error("THREE.WebGLState: Invalid blending: ",t)}g=null,b=null,y=null,x=null,m=t,A=c}}else!0===p&&(H(e.BLEND),p=!1)}function W(t){w!==t&&(t?e.frontFace(e.CW):e.frontFace(e.CCW),w=t)}function j(t){0!==t?(z(e.CULL_FACE),t!==E&&(1===t?e.cullFace(e.BACK):2===t?e.cullFace(e.FRONT):e.cullFace(e.FRONT_AND_BACK))):H(e.CULL_FACE),E=t}function X(t,n,r){t?(z(e.POLYGON_OFFSET_FILL),S===n&&C===r||(e.polygonOffset(n,r),S=n,C=r)):H(e.POLYGON_OFFSET_FILL)}return{buffers:{color:i,depth:a,stencil:o},enable:z,disable:H,bindFramebuffer:function(t,n){return u[t]!==n&&(e.bindFramebuffer(t,n),u[t]=n,r&&(t===e.DRAW_FRAMEBUFFER&&(u[e.FRAMEBUFFER]=n),t===e.FRAMEBUFFER&&(u[e.DRAW_FRAMEBUFFER]=n)),!0)},drawBuffers:function(r,i){let a=f,o=!1;if(r)if(a=d.get(i),void 0===a&&(a=[],d.set(i,a)),r.isWebGLMultipleRenderTargets){const t=r.texture;if(a.length!==t.length||a[0]!==e.COLOR_ATTACHMENT0){for(let n=0,r=t.length;n<r;n++)a[n]=e.COLOR_ATTACHMENT0+n;a.length=t.length,o=!0}}else a[0]!==e.COLOR_ATTACHMENT0&&(a[0]=e.COLOR_ATTACHMENT0,o=!0);else a[0]!==e.BACK&&(a[0]=e.BACK,o=!0);o&&(n.isWebGL2?e.drawBuffers(a):t.get("WEBGL_draw_buffers").drawBuffersWEBGL(a))},useProgram:function(t){return h!==t&&(e.useProgram(t),h=t,!0)},setBlending:$,setMaterial:function(t,n){2===t.side?H(e.CULL_FACE):z(e.CULL_FACE);let r=1===t.side;n&&(r=!r),W(r),1===t.blending&&!1===t.transparent?$(0):$(t.blending,t.blendEquation,t.blendSrc,t.blendDst,t.blendEquationAlpha,t.blendSrcAlpha,t.blendDstAlpha,t.premultipliedAlpha),a.setFunc(t.depthFunc),a.setTest(t.depthTest),a.setMask(t.depthWrite),i.setMask(t.colorWrite);const s=t.stencilWrite;o.setTest(s),s&&(o.setMask(t.stencilWriteMask),o.setFunc(t.stencilFunc,t.stencilRef,t.stencilFuncMask),o.setOp(t.stencilFail,t.stencilZFail,t.stencilZPass)),X(t.polygonOffset,t.polygonOffsetFactor,t.polygonOffsetUnits),!0===t.alphaToCoverage?z(e.SAMPLE_ALPHA_TO_COVERAGE):H(e.SAMPLE_ALPHA_TO_COVERAGE)},setFlipSided:W,setCullFace:j,setLineWidth:function(t){t!==T&&(k&&e.lineWidth(t),T=t)},setPolygonOffset:X,setScissorTest:function(t){t?z(e.SCISSOR_TEST):H(e.SCISSOR_TEST)},activeTexture:function(t){void 0===t&&(t=e.TEXTURE0+M-1),O!==t&&(e.activeTexture(t),O=t)},bindTexture:function(t,n,r){void 0===r&&(r=null===O?e.TEXTURE0+M-1:O);let i=I[r];void 0===i&&(i={type:void 0,texture:void 0},I[r]=i),i.type===t&&i.texture===n||(O!==r&&(e.activeTexture(r),O=r),e.bindTexture(t,n||B[t]),i.type=t,i.texture=n)},unbindTexture:function(){const t=I[O];void 0!==t&&void 0!==t.type&&(e.bindTexture(t.type,null),t.type=void 0,t.texture=void 0)},compressedTexImage2D:function(){try{e.compressedTexImage2D.apply(e,arguments)}catch(e){console.error("THREE.WebGLState:",e)}},compressedTexImage3D:function(){try{e.compressedTexImage3D.apply(e,arguments)}catch(e){console.error("THREE.WebGLState:",e)}},texImage2D:function(){try{e.texImage2D.apply(e,arguments)}catch(e){console.error("THREE.WebGLState:",e)}},texImage3D:function(){try{e.texImage3D.apply(e,arguments)}catch(e){console.error("THREE.WebGLState:",e)}},updateUBOMapping:function(t,n){let r=c.get(n);void 0===r&&(r=new WeakMap,c.set(n,r));let i=r.get(t);void 0===i&&(i=e.getUniformBlockIndex(n,t.name),r.set(t,i))},uniformBlockBinding:function(t,n){const r=c.get(n).get(t);s.get(n)!==r&&(e.uniformBlockBinding(n,r,t.__bindingPointIndex),s.set(n,r))},texStorage2D:function(){try{e.texStorage2D.apply(e,arguments)}catch(e){console.error("THREE.WebGLState:",e)}},texStorage3D:function(){try{e.texStorage3D.apply(e,arguments)}catch(e){console.error("THREE.WebGLState:",e)}},texSubImage2D:function(){try{e.texSubImage2D.apply(e,arguments)}catch(e){console.error("THREE.WebGLState:",e)}},texSubImage3D:function(){try{e.texSubImage3D.apply(e,arguments)}catch(e){console.error("THREE.WebGLState:",e)}},compressedTexSubImage2D:function(){try{e.compressedTexSubImage2D.apply(e,arguments)}catch(e){console.error("THREE.WebGLState:",e)}},compressedTexSubImage3D:function(){try{e.compressedTexSubImage3D.apply(e,arguments)}catch(e){console.error("THREE.WebGLState:",e)}},scissor:function(t){!1===N.equals(t)&&(e.scissor(t.x,t.y,t.z,t.w),N.copy(t))},viewport:function(t){!1===U.equals(t)&&(e.viewport(t.x,t.y,t.z,t.w),U.copy(t))},reset:function(){e.disable(e.BLEND),e.disable(e.CULL_FACE),e.disable(e.DEPTH_TEST),e.disable(e.POLYGON_OFFSET_FILL),e.disable(e.SCISSOR_TEST),e.disable(e.STENCIL_TEST),e.disable(e.SAMPLE_ALPHA_TO_COVERAGE),e.blendEquation(e.FUNC_ADD),e.blendFunc(e.ONE,e.ZERO),e.blendFuncSeparate(e.ONE,e.ZERO,e.ONE,e.ZERO),e.colorMask(!0,!0,!0,!0),e.clearColor(0,0,0,0),e.depthMask(!0),e.depthFunc(e.LESS),e.clearDepth(1),e.stencilMask(4294967295),e.stencilFunc(e.ALWAYS,0,4294967295),e.stencilOp(e.KEEP,e.KEEP,e.KEEP),e.clearStencil(0),e.cullFace(e.BACK),e.frontFace(e.CCW),e.polygonOffset(0,0),e.activeTexture(e.TEXTURE0),e.bindFramebuffer(e.FRAMEBUFFER,null),!0===r&&(e.bindFramebuffer(e.DRAW_FRAMEBUFFER,null),e.bindFramebuffer(e.READ_FRAMEBUFFER,null)),e.useProgram(null),e.lineWidth(1),e.scissor(0,0,e.canvas.width,e.canvas.height),e.viewport(0,0,e.canvas.width,e.canvas.height),l={},O=null,I={},u={},d=new WeakMap,f=[],h=null,p=!1,m=null,v=null,g=null,b=null,_=null,y=null,x=null,A=!1,w=null,E=null,T=null,S=null,C=null,N.set(0,0,e.canvas.width,e.canvas.height),U.set(0,0,e.canvas.width,e.canvas.height),i.reset(),a.reset(),o.reset()}}}function Hp(e,t,n,r,i,a,o){const s=i.isWebGL2,c=i.maxTextures,l=i.maxCubemapSize,u=i.maxTextureSize,d=i.maxSamples,f=t.has("WEBGL_multisampled_render_to_texture")?t.get("WEBGL_multisampled_render_to_texture"):null,h="undefined"!=typeof navigator&&/OculusBrowser/g.test(navigator.userAgent),p=new WeakMap;let m;const v=new WeakMap;let g=!1;try{g="undefined"!=typeof OffscreenCanvas&&null!==new OffscreenCanvas(1,1).getContext("2d")}catch(e){}function b(e,t){return g?new OffscreenCanvas(e,t):Rl("canvas")}function _(e,t,n,r){let i=1;if((e.width>r||e.height>r)&&(i=r/Math.max(e.width,e.height)),i<1||!0===t){if("undefined"!=typeof HTMLImageElement&&e instanceof HTMLImageElement||"undefined"!=typeof HTMLCanvasElement&&e instanceof HTMLCanvasElement||"undefined"!=typeof ImageBitmap&&e instanceof ImageBitmap){const r=t?Al:Math.floor,a=r(i*e.width),o=r(i*e.height);void 0===m&&(m=b(a,o));const s=n?b(a,o):m;return s.width=a,s.height=o,s.getContext("2d").drawImage(e,0,0,a,o),console.warn("THREE.WebGLRenderer: Texture has been resized from ("+e.width+"x"+e.height+") to ("+a+"x"+o+")."),s}return"data"in e&&console.warn("THREE.WebGLRenderer: Image in DataTexture is too big ("+e.width+"x"+e.height+")."),e}return e}function y(e){return xl(e.width)&&xl(e.height)}function x(e,t){return e.generateMipmaps&&t&&e.minFilter!==Nc&&e.minFilter!==Fc}function A(t){e.generateMipmap(t)}function w(n,r,i,a,o=!1){if(!1===s)return r;if(null!==n){if(void 0!==e[n])return e[n];console.warn("THREE.WebGLRenderer: Attempt to use non-existing WebGL internal format '"+n+"'")}let c=r;return r===e.RED&&(i===e.FLOAT&&(c=e.R32F),i===e.HALF_FLOAT&&(c=e.R16F),i===e.UNSIGNED_BYTE&&(c=e.R8)),r===e.RG&&(i===e.FLOAT&&(c=e.RG32F),i===e.HALF_FLOAT&&(c=e.RG16F),i===e.UNSIGNED_BYTE&&(c=e.RG8)),r===e.RGBA&&(i===e.FLOAT&&(c=e.RGBA32F),i===e.HALF_FLOAT&&(c=e.RGBA16F),i===e.UNSIGNED_BYTE&&(c=a===il&&!1===o?e.SRGB8_ALPHA8:e.RGBA8),i===e.UNSIGNED_SHORT_4_4_4_4&&(c=e.RGBA4),i===e.UNSIGNED_SHORT_5_5_5_1&&(c=e.RGB5_A1)),c!==e.R16F&&c!==e.R32F&&c!==e.RG16F&&c!==e.RG32F&&c!==e.RGBA16F&&c!==e.RGBA32F||t.get("EXT_color_buffer_float"),c}function E(e,t,n){return!0===x(e,n)||e.isFramebufferTexture&&e.minFilter!==Nc&&e.minFilter!==Fc?Math.log2(Math.max(t.width,t.height))+1:void 0!==e.mipmaps&&e.mipmaps.length>0?e.mipmaps.length:e.isCompressedTexture&&Array.isArray(e.image)?t.mipmaps.length:1}function T(t){return t===Nc||1004===t||t===Uc?e.NEAREST:e.LINEAR}function S(e){const t=e.target;t.removeEventListener("dispose",S),function(e){const t=r.get(e);if(void 0===t.__webglInit)return;const n=e.source,i=v.get(n);if(i){const r=i[t.__cacheKey];r.usedTimes--,0===r.usedTimes&&M(e),0===Object.keys(i).length&&v.delete(n)}r.remove(e)}(t),t.isVideoTexture&&p.delete(t)}function C(t){const n=t.target;n.removeEventListener("dispose",C),function(t){const n=t.texture,i=r.get(t),a=r.get(n);if(void 0!==a.__webglTexture&&(e.deleteTexture(a.__webglTexture),o.memory.textures--),t.depthTexture&&t.depthTexture.dispose(),t.isWebGLCubeRenderTarget)for(let t=0;t<6;t++)e.deleteFramebuffer(i.__webglFramebuffer[t]),i.__webglDepthbuffer&&e.deleteRenderbuffer(i.__webglDepthbuffer[t]);else{if(e.deleteFramebuffer(i.__webglFramebuffer),i.__webglDepthbuffer&&e.deleteRenderbuffer(i.__webglDepthbuffer),i.__webglMultisampledFramebuffer&&e.deleteFramebuffer(i.__webglMultisampledFramebuffer),i.__webglColorRenderbuffer)for(let t=0;t<i.__webglColorRenderbuffer.length;t++)i.__webglColorRenderbuffer[t]&&e.deleteRenderbuffer(i.__webglColorRenderbuffer[t]);i.__webglDepthRenderbuffer&&e.deleteRenderbuffer(i.__webglDepthRenderbuffer)}if(t.isWebGLMultipleRenderTargets)for(let t=0,i=n.length;t<i;t++){const i=r.get(n[t]);i.__webglTexture&&(e.deleteTexture(i.__webglTexture),o.memory.textures--),r.remove(n[t])}r.remove(n),r.remove(t)}(n)}function M(t){const n=r.get(t);e.deleteTexture(n.__webglTexture);const i=t.source;delete v.get(i)[n.__cacheKey],o.memory.textures--}let k=0;function R(t,i){const a=r.get(t);if(t.isVideoTexture&&function(e){const t=o.render.frame;p.get(e)!==t&&(p.set(e,t),e.update())}(t),!1===t.isRenderTargetTexture&&t.version>0&&a.__version!==t.version){const e=t.image;if(null===e)console.warn("THREE.WebGLRenderer: Texture marked for update but no image data found.");else{if(!1!==e.complete)return void N(a,t,i);console.warn("THREE.WebGLRenderer: Texture marked for update but image is incomplete")}}n.bindTexture(e.TEXTURE_2D,a.__webglTexture,e.TEXTURE0+i)}const L={[Ic]:e.REPEAT,[Pc]:e.CLAMP_TO_EDGE,[Dc]:e.MIRRORED_REPEAT},O={[Nc]:e.NEAREST,1004:e.NEAREST_MIPMAP_NEAREST,[Uc]:e.NEAREST_MIPMAP_LINEAR,[Fc]:e.LINEAR,1007:e.LINEAR_MIPMAP_NEAREST,[Bc]:e.LINEAR_MIPMAP_LINEAR},I={512:e.NEVER,519:e.ALWAYS,513:e.LESS,515:e.LEQUAL,514:e.EQUAL,518:e.GEQUAL,516:e.GREATER,517:e.NOTEQUAL};function P(n,a,o){if(o?(e.texParameteri(n,e.TEXTURE_WRAP_S,L[a.wrapS]),e.texParameteri(n,e.TEXTURE_WRAP_T,L[a.wrapT]),n!==e.TEXTURE_3D&&n!==e.TEXTURE_2D_ARRAY||e.texParameteri(n,e.TEXTURE_WRAP_R,L[a.wrapR]),e.texParameteri(n,e.TEXTURE_MAG_FILTER,O[a.magFilter]),e.texParameteri(n,e.TEXTURE_MIN_FILTER,O[a.minFilter])):(e.texParameteri(n,e.TEXTURE_WRAP_S,e.CLAMP_TO_EDGE),e.texParameteri(n,e.TEXTURE_WRAP_T,e.CLAMP_TO_EDGE),n!==e.TEXTURE_3D&&n!==e.TEXTURE_2D_ARRAY||e.texParameteri(n,e.TEXTURE_WRAP_R,e.CLAMP_TO_EDGE),a.wrapS===Pc&&a.wrapT===Pc||console.warn("THREE.WebGLRenderer: Texture is not power of two. Texture.wrapS and Texture.wrapT should be set to THREE.ClampToEdgeWrapping."),e.texParameteri(n,e.TEXTURE_MAG_FILTER,T(a.magFilter)),e.texParameteri(n,e.TEXTURE_MIN_FILTER,T(a.minFilter)),a.minFilter!==Nc&&a.minFilter!==Fc&&console.warn("THREE.WebGLRenderer: Texture is not power of two. Texture.minFilter should be set to THREE.NearestFilter or THREE.LinearFilter.")),a.compareFunction&&(e.texParameteri(n,e.TEXTURE_COMPARE_MODE,e.COMPARE_REF_TO_TEXTURE),e.texParameteri(n,e.TEXTURE_COMPARE_FUNC,I[a.compareFunction])),!0===t.has("EXT_texture_filter_anisotropic")){const o=t.get("EXT_texture_filter_anisotropic");if(a.magFilter===Nc)return;if(a.minFilter!==Uc&&a.minFilter!==Bc)return;if(a.type===Gc&&!1===t.has("OES_texture_float_linear"))return;if(!1===s&&a.type===$c&&!1===t.has("OES_texture_half_float_linear"))return;(a.anisotropy>1||r.get(a).__currentAnisotropy)&&(e.texParameterf(n,o.TEXTURE_MAX_ANISOTROPY_EXT,Math.min(a.anisotropy,i.getMaxAnisotropy())),r.get(a).__currentAnisotropy=a.anisotropy)}}function D(t,n){let r=!1;void 0===t.__webglInit&&(t.__webglInit=!0,n.addEventListener("dispose",S));const i=n.source;let a=v.get(i);void 0===a&&(a={},v.set(i,a));const s=function(e){const t=[];return t.push(e.wrapS),t.push(e.wrapT),t.push(e.wrapR||0),t.push(e.magFilter),t.push(e.minFilter),t.push(e.anisotropy),t.push(e.internalFormat),t.push(e.format),t.push(e.type),t.push(e.generateMipmaps),t.push(e.premultiplyAlpha),t.push(e.flipY),t.push(e.unpackAlignment),t.push(e.colorSpace),t.join()}(n);if(s!==t.__cacheKey){void 0===a[s]&&(a[s]={texture:e.createTexture(),usedTimes:0},o.memory.textures++,r=!0),a[s].usedTimes++;const i=a[t.__cacheKey];void 0!==i&&(a[t.__cacheKey].usedTimes--,0===i.usedTimes&&M(n)),t.__cacheKey=s,t.__webglTexture=a[s].texture}return r}function N(t,i,o){let c=e.TEXTURE_2D;(i.isDataArrayTexture||i.isCompressedArrayTexture)&&(c=e.TEXTURE_2D_ARRAY),i.isData3DTexture&&(c=e.TEXTURE_3D);const l=D(t,i),d=i.source;n.bindTexture(c,t.__webglTexture,e.TEXTURE0+o);const f=r.get(d);if(d.version!==f.__version||!0===l){n.activeTexture(e.TEXTURE0+o),e.pixelStorei(e.UNPACK_FLIP_Y_WEBGL,i.flipY),e.pixelStorei(e.UNPACK_PREMULTIPLY_ALPHA_WEBGL,i.premultiplyAlpha),e.pixelStorei(e.UNPACK_ALIGNMENT,i.unpackAlignment),e.pixelStorei(e.UNPACK_COLORSPACE_CONVERSION_WEBGL,e.NONE);const t=function(e){return!s&&(e.wrapS!==Pc||e.wrapT!==Pc||e.minFilter!==Nc&&e.minFilter!==Fc)}(i)&&!1===y(i.image);let r=_(i.image,t,!1,u);r=V(i,r);const h=y(r)||s,p=a.convert(i.format,i.colorSpace);let m,v=a.convert(i.type),g=w(i.internalFormat,p,v,i.colorSpace);P(c,i,h);const b=i.mipmaps,T=s&&!0!==i.isVideoTexture,S=void 0===f.__version||!0===l,C=E(i,r,h);if(i.isDepthTexture)g=e.DEPTH_COMPONENT,s?g=i.type===Gc?e.DEPTH_COMPONENT32F:i.type===Vc?e.DEPTH_COMPONENT24:i.type===Wc?e.DEPTH24_STENCIL8:e.DEPTH_COMPONENT16:i.type===Gc&&console.error("WebGLRenderer: Floating point depth texture requires WebGL2."),i.format===Xc&&g===e.DEPTH_COMPONENT&&i.type!==Hc&&i.type!==Vc&&(console.warn("THREE.WebGLRenderer: Use UnsignedShortType or UnsignedIntType for DepthFormat DepthTexture."),i.type=Vc,v=a.convert(i.type)),i.format===Yc&&g===e.DEPTH_COMPONENT&&(g=e.DEPTH_STENCIL,i.type!==Wc&&(console.warn("THREE.WebGLRenderer: Use UnsignedInt248Type for DepthStencilFormat DepthTexture."),i.type=Wc,v=a.convert(i.type))),S&&(T?n.texStorage2D(e.TEXTURE_2D,1,g,r.width,r.height):n.texImage2D(e.TEXTURE_2D,0,g,r.width,r.height,0,p,v,null));else if(i.isDataTexture)if(b.length>0&&h){T&&S&&n.texStorage2D(e.TEXTURE_2D,C,g,b[0].width,b[0].height);for(let t=0,r=b.length;t<r;t++)m=b[t],T?n.texSubImage2D(e.TEXTURE_2D,t,0,0,m.width,m.height,p,v,m.data):n.texImage2D(e.TEXTURE_2D,t,g,m.width,m.height,0,p,v,m.data);i.generateMipmaps=!1}else T?(S&&n.texStorage2D(e.TEXTURE_2D,C,g,r.width,r.height),n.texSubImage2D(e.TEXTURE_2D,0,0,0,r.width,r.height,p,v,r.data)):n.texImage2D(e.TEXTURE_2D,0,g,r.width,r.height,0,p,v,r.data);else if(i.isCompressedTexture)if(i.isCompressedArrayTexture){T&&S&&n.texStorage3D(e.TEXTURE_2D_ARRAY,C,g,b[0].width,b[0].height,r.depth);for(let t=0,a=b.length;t<a;t++)m=b[t],i.format!==jc?null!==p?T?n.compressedTexSubImage3D(e.TEXTURE_2D_ARRAY,t,0,0,0,m.width,m.height,r.depth,p,m.data,0,0):n.compressedTexImage3D(e.TEXTURE_2D_ARRAY,t,g,m.width,m.height,r.depth,0,m.data,0,0):console.warn("THREE.WebGLRenderer: Attempt to load unsupported compressed texture format in .uploadTexture()"):T?n.texSubImage3D(e.TEXTURE_2D_ARRAY,t,0,0,0,m.width,m.height,r.depth,p,v,m.data):n.texImage3D(e.TEXTURE_2D_ARRAY,t,g,m.width,m.height,r.depth,0,p,v,m.data)}else{T&&S&&n.texStorage2D(e.TEXTURE_2D,C,g,b[0].width,b[0].height);for(let t=0,r=b.length;t<r;t++)m=b[t],i.format!==jc?null!==p?T?n.compressedTexSubImage2D(e.TEXTURE_2D,t,0,0,m.width,m.height,p,m.data):n.compressedTexImage2D(e.TEXTURE_2D,t,g,m.width,m.height,0,m.data):console.warn("THREE.WebGLRenderer: Attempt to load unsupported compressed texture format in .uploadTexture()"):T?n.texSubImage2D(e.TEXTURE_2D,t,0,0,m.width,m.height,p,v,m.data):n.texImage2D(e.TEXTURE_2D,t,g,m.width,m.height,0,p,v,m.data)}else if(i.isDataArrayTexture)T?(S&&n.texStorage3D(e.TEXTURE_2D_ARRAY,C,g,r.width,r.height,r.depth),n.texSubImage3D(e.TEXTURE_2D_ARRAY,0,0,0,0,r.width,r.height,r.depth,p,v,r.data)):n.texImage3D(e.TEXTURE_2D_ARRAY,0,g,r.width,r.height,r.depth,0,p,v,r.data);else if(i.isData3DTexture)T?(S&&n.texStorage3D(e.TEXTURE_3D,C,g,r.width,r.height,r.depth),n.texSubImage3D(e.TEXTURE_3D,0,0,0,0,r.width,r.height,r.depth,p,v,r.data)):n.texImage3D(e.TEXTURE_3D,0,g,r.width,r.height,r.depth,0,p,v,r.data);else if(i.isFramebufferTexture){if(S)if(T)n.texStorage2D(e.TEXTURE_2D,C,g,r.width,r.height);else{let t=r.width,i=r.height;for(let r=0;r<C;r++)n.texImage2D(e.TEXTURE_2D,r,g,t,i,0,p,v,null),t>>=1,i>>=1}}else if(b.length>0&&h){T&&S&&n.texStorage2D(e.TEXTURE_2D,C,g,b[0].width,b[0].height);for(let t=0,r=b.length;t<r;t++)m=b[t],T?n.texSubImage2D(e.TEXTURE_2D,t,0,0,p,v,m):n.texImage2D(e.TEXTURE_2D,t,g,p,v,m);i.generateMipmaps=!1}else T?(S&&n.texStorage2D(e.TEXTURE_2D,C,g,r.width,r.height),n.texSubImage2D(e.TEXTURE_2D,0,0,0,p,v,r)):n.texImage2D(e.TEXTURE_2D,0,g,p,v,r);x(i,h)&&A(c),f.__version=d.version,i.onUpdate&&i.onUpdate(i)}t.__version=i.version}function U(t,i,o,s,c){const l=a.convert(o.format,o.colorSpace),u=a.convert(o.type),d=w(o.internalFormat,l,u,o.colorSpace);r.get(i).__hasExternalTextures||(c===e.TEXTURE_3D||c===e.TEXTURE_2D_ARRAY?n.texImage3D(c,0,d,i.width,i.height,i.depth,0,l,u,null):n.texImage2D(c,0,d,i.width,i.height,0,l,u,null)),n.bindFramebuffer(e.FRAMEBUFFER,t),H(i)?f.framebufferTexture2DMultisampleEXT(e.FRAMEBUFFER,s,c,r.get(o).__webglTexture,0,z(i)):(c===e.TEXTURE_2D||c>=e.TEXTURE_CUBE_MAP_POSITIVE_X&&c<=e.TEXTURE_CUBE_MAP_NEGATIVE_Z)&&e.framebufferTexture2D(e.FRAMEBUFFER,s,c,r.get(o).__webglTexture,0),n.bindFramebuffer(e.FRAMEBUFFER,null)}function F(t,n,r){if(e.bindRenderbuffer(e.RENDERBUFFER,t),n.depthBuffer&&!n.stencilBuffer){let i=e.DEPTH_COMPONENT16;if(r||H(n)){const t=n.depthTexture;t&&t.isDepthTexture&&(t.type===Gc?i=e.DEPTH_COMPONENT32F:t.type===Vc&&(i=e.DEPTH_COMPONENT24));const r=z(n);H(n)?f.renderbufferStorageMultisampleEXT(e.RENDERBUFFER,r,i,n.width,n.height):e.renderbufferStorageMultisample(e.RENDERBUFFER,r,i,n.width,n.height)}else e.renderbufferStorage(e.RENDERBUFFER,i,n.width,n.height);e.framebufferRenderbuffer(e.FRAMEBUFFER,e.DEPTH_ATTACHMENT,e.RENDERBUFFER,t)}else if(n.depthBuffer&&n.stencilBuffer){const i=z(n);r&&!1===H(n)?e.renderbufferStorageMultisample(e.RENDERBUFFER,i,e.DEPTH24_STENCIL8,n.width,n.height):H(n)?f.renderbufferStorageMultisampleEXT(e.RENDERBUFFER,i,e.DEPTH24_STENCIL8,n.width,n.height):e.renderbufferStorage(e.RENDERBUFFER,e.DEPTH_STENCIL,n.width,n.height),e.framebufferRenderbuffer(e.FRAMEBUFFER,e.DEPTH_STENCIL_ATTACHMENT,e.RENDERBUFFER,t)}else{const t=!0===n.isWebGLMultipleRenderTargets?n.texture:[n.texture];for(let i=0;i<t.length;i++){const o=t[i],s=a.convert(o.format,o.colorSpace),c=a.convert(o.type),l=w(o.internalFormat,s,c,o.colorSpace),u=z(n);r&&!1===H(n)?e.renderbufferStorageMultisample(e.RENDERBUFFER,u,l,n.width,n.height):H(n)?f.renderbufferStorageMultisampleEXT(e.RENDERBUFFER,u,l,n.width,n.height):e.renderbufferStorage(e.RENDERBUFFER,l,n.width,n.height)}}e.bindRenderbuffer(e.RENDERBUFFER,null)}function B(t){const i=r.get(t),a=!0===t.isWebGLCubeRenderTarget;if(t.depthTexture&&!i.__autoAllocateDepthBuffer){if(a)throw new Error("target.depthTexture not supported in Cube render targets");!function(t,i){if(i&&i.isWebGLCubeRenderTarget)throw new Error("Depth Texture with cube render targets is not supported");if(n.bindFramebuffer(e.FRAMEBUFFER,t),!i.depthTexture||!i.depthTexture.isDepthTexture)throw new Error("renderTarget.depthTexture must be an instance of THREE.DepthTexture");r.get(i.depthTexture).__webglTexture&&i.depthTexture.image.width===i.width&&i.depthTexture.image.height===i.height||(i.depthTexture.image.width=i.width,i.depthTexture.image.height=i.height,i.depthTexture.needsUpdate=!0),R(i.depthTexture,0);const a=r.get(i.depthTexture).__webglTexture,o=z(i);if(i.depthTexture.format===Xc)H(i)?f.framebufferTexture2DMultisampleEXT(e.FRAMEBUFFER,e.DEPTH_ATTACHMENT,e.TEXTURE_2D,a,0,o):e.framebufferTexture2D(e.FRAMEBUFFER,e.DEPTH_ATTACHMENT,e.TEXTURE_2D,a,0);else{if(i.depthTexture.format!==Yc)throw new Error("Unknown depthTexture format");H(i)?f.framebufferTexture2DMultisampleEXT(e.FRAMEBUFFER,e.DEPTH_STENCIL_ATTACHMENT,e.TEXTURE_2D,a,0,o):e.framebufferTexture2D(e.FRAMEBUFFER,e.DEPTH_STENCIL_ATTACHMENT,e.TEXTURE_2D,a,0)}}(i.__webglFramebuffer,t)}else if(a){i.__webglDepthbuffer=[];for(let r=0;r<6;r++)n.bindFramebuffer(e.FRAMEBUFFER,i.__webglFramebuffer[r]),i.__webglDepthbuffer[r]=e.createRenderbuffer(),F(i.__webglDepthbuffer[r],t,!1)}else n.bindFramebuffer(e.FRAMEBUFFER,i.__webglFramebuffer),i.__webglDepthbuffer=e.createRenderbuffer(),F(i.__webglDepthbuffer,t,!1);n.bindFramebuffer(e.FRAMEBUFFER,null)}function z(e){return Math.min(d,e.samples)}function H(e){const n=r.get(e);return s&&e.samples>0&&!0===t.has("WEBGL_multisampled_render_to_texture")&&!1!==n.__useRenderToTexture}function V(e,n){const r=e.colorSpace,i=e.format,a=e.type;return!0===e.isCompressedTexture||e.format===ll||r!==al&&""!==r&&(r===il?!1===s?!0===t.has("EXT_sRGB")&&i===jc?(e.format=ll,e.minFilter=Fc,e.generateMipmaps=!1):n=Hl.sRGBToLinear(n):i===jc&&a===zc||console.warn("THREE.WebGLTextures: sRGB encoded textures have to use RGBAFormat and UnsignedByteType."):console.error("THREE.WebGLTextures: Unsupported texture color space:",r)),n}this.allocateTextureUnit=function(){const e=k;return e>=c&&console.warn("THREE.WebGLTextures: Trying to use "+e+" texture units while this GPU supports only "+c),k+=1,e},this.resetTextureUnits=function(){k=0},this.setTexture2D=R,this.setTexture2DArray=function(t,i){const a=r.get(t);t.version>0&&a.__version!==t.version?N(a,t,i):n.bindTexture(e.TEXTURE_2D_ARRAY,a.__webglTexture,e.TEXTURE0+i)},this.setTexture3D=function(t,i){const a=r.get(t);t.version>0&&a.__version!==t.version?N(a,t,i):n.bindTexture(e.TEXTURE_3D,a.__webglTexture,e.TEXTURE0+i)},this.setTextureCube=function(t,i){const o=r.get(t);t.version>0&&o.__version!==t.version?function(t,i,o){if(6!==i.image.length)return;const c=D(t,i),u=i.source;n.bindTexture(e.TEXTURE_CUBE_MAP,t.__webglTexture,e.TEXTURE0+o);const d=r.get(u);if(u.version!==d.__version||!0===c){n.activeTexture(e.TEXTURE0+o),e.pixelStorei(e.UNPACK_FLIP_Y_WEBGL,i.flipY),e.pixelStorei(e.UNPACK_PREMULTIPLY_ALPHA_WEBGL,i.premultiplyAlpha),e.pixelStorei(e.UNPACK_ALIGNMENT,i.unpackAlignment),e.pixelStorei(e.UNPACK_COLORSPACE_CONVERSION_WEBGL,e.NONE);const t=i.isCompressedTexture||i.image[0].isCompressedTexture,r=i.image[0]&&i.image[0].isDataTexture,f=[];for(let e=0;e<6;e++)f[e]=t||r?r?i.image[e].image:i.image[e]:_(i.image[e],!1,!0,l),f[e]=V(i,f[e]);const h=f[0],p=y(h)||s,m=a.convert(i.format,i.colorSpace),v=a.convert(i.type),g=w(i.internalFormat,m,v,i.colorSpace),b=s&&!0!==i.isVideoTexture,T=void 0===d.__version||!0===c;let S,C=E(i,h,p);if(P(e.TEXTURE_CUBE_MAP,i,p),t){b&&T&&n.texStorage2D(e.TEXTURE_CUBE_MAP,C,g,h.width,h.height);for(let t=0;t<6;t++){S=f[t].mipmaps;for(let r=0;r<S.length;r++){const a=S[r];i.format!==jc?null!==m?b?n.compressedTexSubImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,r,0,0,a.width,a.height,m,a.data):n.compressedTexImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,r,g,a.width,a.height,0,a.data):console.warn("THREE.WebGLRenderer: Attempt to load unsupported compressed texture format in .setTextureCube()"):b?n.texSubImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,r,0,0,a.width,a.height,m,v,a.data):n.texImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,r,g,a.width,a.height,0,m,v,a.data)}}}else{S=i.mipmaps,b&&T&&(S.length>0&&C++,n.texStorage2D(e.TEXTURE_CUBE_MAP,C,g,f[0].width,f[0].height));for(let t=0;t<6;t++)if(r){b?n.texSubImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,0,0,0,f[t].width,f[t].height,m,v,f[t].data):n.texImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,0,g,f[t].width,f[t].height,0,m,v,f[t].data);for(let r=0;r<S.length;r++){const i=S[r].image[t].image;b?n.texSubImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,r+1,0,0,i.width,i.height,m,v,i.data):n.texImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,r+1,g,i.width,i.height,0,m,v,i.data)}}else{b?n.texSubImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,0,0,0,m,v,f[t]):n.texImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,0,g,m,v,f[t]);for(let r=0;r<S.length;r++){const i=S[r];b?n.texSubImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,r+1,0,0,m,v,i.image[t]):n.texImage2D(e.TEXTURE_CUBE_MAP_POSITIVE_X+t,r+1,g,m,v,i.image[t])}}}x(i,p)&&A(e.TEXTURE_CUBE_MAP),d.__version=u.version,i.onUpdate&&i.onUpdate(i)}t.__version=i.version}(o,t,i):n.bindTexture(e.TEXTURE_CUBE_MAP,o.__webglTexture,e.TEXTURE0+i)},this.rebindTextures=function(t,n,i){const a=r.get(t);void 0!==n&&U(a.__webglFramebuffer,t,t.texture,e.COLOR_ATTACHMENT0,e.TEXTURE_2D),void 0!==i&&B(t)},this.setupRenderTarget=function(t){const c=t.texture,l=r.get(t),u=r.get(c);t.addEventListener("dispose",C),!0!==t.isWebGLMultipleRenderTargets&&(void 0===u.__webglTexture&&(u.__webglTexture=e.createTexture()),u.__version=c.version,o.memory.textures++);const d=!0===t.isWebGLCubeRenderTarget,f=!0===t.isWebGLMultipleRenderTargets,h=y(t)||s;if(d){l.__webglFramebuffer=[];for(let t=0;t<6;t++)l.__webglFramebuffer[t]=e.createFramebuffer()}else{if(l.__webglFramebuffer=e.createFramebuffer(),f)if(i.drawBuffers){const n=t.texture;for(let t=0,i=n.length;t<i;t++){const i=r.get(n[t]);void 0===i.__webglTexture&&(i.__webglTexture=e.createTexture(),o.memory.textures++)}}else console.warn("THREE.WebGLRenderer: WebGLMultipleRenderTargets can only be used with WebGL2 or WEBGL_draw_buffers extension.");if(s&&t.samples>0&&!1===H(t)){const r=f?c:[c];l.__webglMultisampledFramebuffer=e.createFramebuffer(),l.__webglColorRenderbuffer=[],n.bindFramebuffer(e.FRAMEBUFFER,l.__webglMultisampledFramebuffer);for(let n=0;n<r.length;n++){const i=r[n];l.__webglColorRenderbuffer[n]=e.createRenderbuffer(),e.bindRenderbuffer(e.RENDERBUFFER,l.__webglColorRenderbuffer[n]);const o=a.convert(i.format,i.colorSpace),s=a.convert(i.type),c=w(i.internalFormat,o,s,i.colorSpace,!0===t.isXRRenderTarget),u=z(t);e.renderbufferStorageMultisample(e.RENDERBUFFER,u,c,t.width,t.height),e.framebufferRenderbuffer(e.FRAMEBUFFER,e.COLOR_ATTACHMENT0+n,e.RENDERBUFFER,l.__webglColorRenderbuffer[n])}e.bindRenderbuffer(e.RENDERBUFFER,null),t.depthBuffer&&(l.__webglDepthRenderbuffer=e.createRenderbuffer(),F(l.__webglDepthRenderbuffer,t,!0)),n.bindFramebuffer(e.FRAMEBUFFER,null)}}if(d){n.bindTexture(e.TEXTURE_CUBE_MAP,u.__webglTexture),P(e.TEXTURE_CUBE_MAP,c,h);for(let n=0;n<6;n++)U(l.__webglFramebuffer[n],t,c,e.COLOR_ATTACHMENT0,e.TEXTURE_CUBE_MAP_POSITIVE_X+n);x(c,h)&&A(e.TEXTURE_CUBE_MAP),n.unbindTexture()}else if(f){const i=t.texture;for(let a=0,o=i.length;a<o;a++){const o=i[a],s=r.get(o);n.bindTexture(e.TEXTURE_2D,s.__webglTexture),P(e.TEXTURE_2D,o,h),U(l.__webglFramebuffer,t,o,e.COLOR_ATTACHMENT0+a,e.TEXTURE_2D),x(o,h)&&A(e.TEXTURE_2D)}n.unbindTexture()}else{let r=e.TEXTURE_2D;(t.isWebGL3DRenderTarget||t.isWebGLArrayRenderTarget)&&(s?r=t.isWebGL3DRenderTarget?e.TEXTURE_3D:e.TEXTURE_2D_ARRAY:console.error("THREE.WebGLTextures: THREE.Data3DTexture and THREE.DataArrayTexture only supported with WebGL2.")),n.bindTexture(r,u.__webglTexture),P(r,c,h),U(l.__webglFramebuffer,t,c,e.COLOR_ATTACHMENT0,r),x(c,h)&&A(r),n.unbindTexture()}t.depthBuffer&&B(t)},this.updateRenderTargetMipmap=function(t){const i=y(t)||s,a=!0===t.isWebGLMultipleRenderTargets?t.texture:[t.texture];for(let o=0,s=a.length;o<s;o++){const s=a[o];if(x(s,i)){const i=t.isWebGLCubeRenderTarget?e.TEXTURE_CUBE_MAP:e.TEXTURE_2D,a=r.get(s).__webglTexture;n.bindTexture(i,a),A(i),n.unbindTexture()}}},this.updateMultisampleRenderTarget=function(t){if(s&&t.samples>0&&!1===H(t)){const i=t.isWebGLMultipleRenderTargets?t.texture:[t.texture],a=t.width,o=t.height;let s=e.COLOR_BUFFER_BIT;const c=[],l=t.stencilBuffer?e.DEPTH_STENCIL_ATTACHMENT:e.DEPTH_ATTACHMENT,u=r.get(t),d=!0===t.isWebGLMultipleRenderTargets;if(d)for(let t=0;t<i.length;t++)n.bindFramebuffer(e.FRAMEBUFFER,u.__webglMultisampledFramebuffer),e.framebufferRenderbuffer(e.FRAMEBUFFER,e.COLOR_ATTACHMENT0+t,e.RENDERBUFFER,null),n.bindFramebuffer(e.FRAMEBUFFER,u.__webglFramebuffer),e.framebufferTexture2D(e.DRAW_FRAMEBUFFER,e.COLOR_ATTACHMENT0+t,e.TEXTURE_2D,null,0);n.bindFramebuffer(e.READ_FRAMEBUFFER,u.__webglMultisampledFramebuffer),n.bindFramebuffer(e.DRAW_FRAMEBUFFER,u.__webglFramebuffer);for(let n=0;n<i.length;n++){c.push(e.COLOR_ATTACHMENT0+n),t.depthBuffer&&c.push(l);const f=void 0!==u.__ignoreDepthValues&&u.__ignoreDepthValues;if(!1===f&&(t.depthBuffer&&(s|=e.DEPTH_BUFFER_BIT),t.stencilBuffer&&(s|=e.STENCIL_BUFFER_BIT)),d&&e.framebufferRenderbuffer(e.READ_FRAMEBUFFER,e.COLOR_ATTACHMENT0,e.RENDERBUFFER,u.__webglColorRenderbuffer[n]),!0===f&&(e.invalidateFramebuffer(e.READ_FRAMEBUFFER,[l]),e.invalidateFramebuffer(e.DRAW_FRAMEBUFFER,[l])),d){const t=r.get(i[n]).__webglTexture;e.framebufferTexture2D(e.DRAW_FRAMEBUFFER,e.COLOR_ATTACHMENT0,e.TEXTURE_2D,t,0)}e.blitFramebuffer(0,0,a,o,0,0,a,o,s,e.NEAREST),h&&e.invalidateFramebuffer(e.READ_FRAMEBUFFER,c)}if(n.bindFramebuffer(e.READ_FRAMEBUFFER,null),n.bindFramebuffer(e.DRAW_FRAMEBUFFER,null),d)for(let t=0;t<i.length;t++){n.bindFramebuffer(e.FRAMEBUFFER,u.__webglMultisampledFramebuffer),e.framebufferRenderbuffer(e.FRAMEBUFFER,e.COLOR_ATTACHMENT0+t,e.RENDERBUFFER,u.__webglColorRenderbuffer[t]);const a=r.get(i[t]).__webglTexture;n.bindFramebuffer(e.FRAMEBUFFER,u.__webglFramebuffer),e.framebufferTexture2D(e.DRAW_FRAMEBUFFER,e.COLOR_ATTACHMENT0+t,e.TEXTURE_2D,a,0)}n.bindFramebuffer(e.DRAW_FRAMEBUFFER,u.__webglMultisampledFramebuffer)}},this.setupDepthRenderbuffer=B,this.setupFrameBufferTexture=U,this.useMultisampledRTT=H}function Vp(e,t,n){const r=n.isWebGL2;return{convert:function(n,i=""){let a;if(n===zc)return e.UNSIGNED_BYTE;if(1017===n)return e.UNSIGNED_SHORT_4_4_4_4;if(1018===n)return e.UNSIGNED_SHORT_5_5_5_1;if(1010===n)return e.BYTE;if(1011===n)return e.SHORT;if(n===Hc)return e.UNSIGNED_SHORT;if(1013===n)return e.INT;if(n===Vc)return e.UNSIGNED_INT;if(n===Gc)return e.FLOAT;if(n===$c)return r?e.HALF_FLOAT:(a=t.get("OES_texture_half_float"),null!==a?a.HALF_FLOAT_OES:null);if(1021===n)return e.ALPHA;if(n===jc)return e.RGBA;if(1024===n)return e.LUMINANCE;if(1025===n)return e.LUMINANCE_ALPHA;if(n===Xc)return e.DEPTH_COMPONENT;if(n===Yc)return e.DEPTH_STENCIL;if(n===ll)return a=t.get("EXT_sRGB"),null!==a?a.SRGB_ALPHA_EXT:null;if(1028===n)return e.RED;if(1029===n)return e.RED_INTEGER;if(1030===n)return e.RG;if(1031===n)return e.RG_INTEGER;if(1033===n)return e.RGBA_INTEGER;if(n===qc||n===Kc||n===Zc||n===Jc)if(i===il){if(a=t.get("WEBGL_compressed_texture_s3tc_srgb"),null===a)return null;if(n===qc)return a.COMPRESSED_SRGB_S3TC_DXT1_EXT;if(n===Kc)return a.COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT;if(n===Zc)return a.COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT;if(n===Jc)return a.COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT}else{if(a=t.get("WEBGL_compressed_texture_s3tc"),null===a)return null;if(n===qc)return a.COMPRESSED_RGB_S3TC_DXT1_EXT;if(n===Kc)return a.COMPRESSED_RGBA_S3TC_DXT1_EXT;if(n===Zc)return a.COMPRESSED_RGBA_S3TC_DXT3_EXT;if(n===Jc)return a.COMPRESSED_RGBA_S3TC_DXT5_EXT}if(35840===n||35841===n||35842===n||35843===n){if(a=t.get("WEBGL_compressed_texture_pvrtc"),null===a)return null;if(35840===n)return a.COMPRESSED_RGB_PVRTC_4BPPV1_IMG;if(35841===n)return a.COMPRESSED_RGB_PVRTC_2BPPV1_IMG;if(35842===n)return a.COMPRESSED_RGBA_PVRTC_4BPPV1_IMG;if(35843===n)return a.COMPRESSED_RGBA_PVRTC_2BPPV1_IMG}if(36196===n)return a=t.get("WEBGL_compressed_texture_etc1"),null!==a?a.COMPRESSED_RGB_ETC1_WEBGL:null;if(37492===n||37496===n){if(a=t.get("WEBGL_compressed_texture_etc"),null===a)return null;if(37492===n)return i===il?a.COMPRESSED_SRGB8_ETC2:a.COMPRESSED_RGB8_ETC2;if(37496===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:a.COMPRESSED_RGBA8_ETC2_EAC}if(37808===n||37809===n||37810===n||37811===n||37812===n||37813===n||37814===n||37815===n||37816===n||37817===n||37818===n||37819===n||37820===n||37821===n){if(a=t.get("WEBGL_compressed_texture_astc"),null===a)return null;if(37808===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR:a.COMPRESSED_RGBA_ASTC_4x4_KHR;if(37809===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR:a.COMPRESSED_RGBA_ASTC_5x4_KHR;if(37810===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR:a.COMPRESSED_RGBA_ASTC_5x5_KHR;if(37811===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR:a.COMPRESSED_RGBA_ASTC_6x5_KHR;if(37812===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR:a.COMPRESSED_RGBA_ASTC_6x6_KHR;if(37813===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR:a.COMPRESSED_RGBA_ASTC_8x5_KHR;if(37814===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR:a.COMPRESSED_RGBA_ASTC_8x6_KHR;if(37815===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR:a.COMPRESSED_RGBA_ASTC_8x8_KHR;if(37816===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR:a.COMPRESSED_RGBA_ASTC_10x5_KHR;if(37817===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR:a.COMPRESSED_RGBA_ASTC_10x6_KHR;if(37818===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR:a.COMPRESSED_RGBA_ASTC_10x8_KHR;if(37819===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR:a.COMPRESSED_RGBA_ASTC_10x10_KHR;if(37820===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR:a.COMPRESSED_RGBA_ASTC_12x10_KHR;if(37821===n)return i===il?a.COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR:a.COMPRESSED_RGBA_ASTC_12x12_KHR}if(n===Qc){if(a=t.get("EXT_texture_compression_bptc"),null===a)return null;if(n===Qc)return i===il?a.COMPRESSED_SRGB_ALPHA_BPTC_UNORM_EXT:a.COMPRESSED_RGBA_BPTC_UNORM_EXT}if(36283===n||36284===n||36285===n||36286===n){if(a=t.get("EXT_texture_compression_rgtc"),null===a)return null;if(n===Qc)return a.COMPRESSED_RED_RGTC1_EXT;if(36284===n)return a.COMPRESSED_SIGNED_RED_RGTC1_EXT;if(36285===n)return a.COMPRESSED_RED_GREEN_RGTC2_EXT;if(36286===n)return a.COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT}return n===Wc?r?e.UNSIGNED_INT_24_8:(a=t.get("WEBGL_depth_texture"),null!==a?a.UNSIGNED_INT_24_8_WEBGL:null):void 0!==e[n]?e[n]:null}}}class Gp extends cf{constructor(e=[]){super(),this.isArrayCamera=!0,this.cameras=e}}class $p extends Qu{constructor(){super(),this.isGroup=!0,this.type="Group"}}const Wp={type:"move"};class jp{constructor(){this._targetRay=null,this._grip=null,this._hand=null}getHandSpace(){return null===this._hand&&(this._hand=new $p,this._hand.matrixAutoUpdate=!1,this._hand.visible=!1,this._hand.joints={},this._hand.inputState={pinching:!1}),this._hand}getTargetRaySpace(){return null===this._targetRay&&(this._targetRay=new $p,this._targetRay.matrixAutoUpdate=!1,this._targetRay.visible=!1,this._targetRay.hasLinearVelocity=!1,this._targetRay.linearVelocity=new Jl,this._targetRay.hasAngularVelocity=!1,this._targetRay.angularVelocity=new Jl),this._targetRay}getGripSpace(){return null===this._grip&&(this._grip=new $p,this._grip.matrixAutoUpdate=!1,this._grip.visible=!1,this._grip.hasLinearVelocity=!1,this._grip.linearVelocity=new Jl,this._grip.hasAngularVelocity=!1,this._grip.angularVelocity=new Jl),this._grip}dispatchEvent(e){return null!==this._targetRay&&this._targetRay.dispatchEvent(e),null!==this._grip&&this._grip.dispatchEvent(e),null!==this._hand&&this._hand.dispatchEvent(e),this}connect(e){if(e&&e.hand){const t=this._hand;if(t)for(const n of e.hand.values())this._getHandJoint(t,n)}return this.dispatchEvent({type:"connected",data:e}),this}disconnect(e){return this.dispatchEvent({type:"disconnected",data:e}),null!==this._targetRay&&(this._targetRay.visible=!1),null!==this._grip&&(this._grip.visible=!1),null!==this._hand&&(this._hand.visible=!1),this}update(e,t,n){let r=null,i=null,a=null;const o=this._targetRay,s=this._grip,c=this._hand;if(e&&"visible-blurred"!==t.session.visibilityState){if(c&&e.hand){a=!0;for(const r of e.hand.values()){const e=t.getJointPose(r,n),i=this._getHandJoint(c,r);null!==e&&(i.matrix.fromArray(e.transform.matrix),i.matrix.decompose(i.position,i.rotation,i.scale),i.matrixWorldNeedsUpdate=!0,i.jointRadius=e.radius),i.visible=null!==e}const r=c.joints["index-finger-tip"],i=c.joints["thumb-tip"],o=r.position.distanceTo(i.position),s=.02,l=.005;c.inputState.pinching&&o>s+l?(c.inputState.pinching=!1,this.dispatchEvent({type:"pinchend",handedness:e.handedness,target:this})):!c.inputState.pinching&&o<=s-l&&(c.inputState.pinching=!0,this.dispatchEvent({type:"pinchstart",handedness:e.handedness,target:this}))}else null!==s&&e.gripSpace&&(i=t.getPose(e.gripSpace,n),null!==i&&(s.matrix.fromArray(i.transform.matrix),s.matrix.decompose(s.position,s.rotation,s.scale),s.matrixWorldNeedsUpdate=!0,i.linearVelocity?(s.hasLinearVelocity=!0,s.linearVelocity.copy(i.linearVelocity)):s.hasLinearVelocity=!1,i.angularVelocity?(s.hasAngularVelocity=!0,s.angularVelocity.copy(i.angularVelocity)):s.hasAngularVelocity=!1));null!==o&&(r=t.getPose(e.targetRaySpace,n),null===r&&null!==i&&(r=i),null!==r&&(o.matrix.fromArray(r.transform.matrix),o.matrix.decompose(o.position,o.rotation,o.scale),o.matrixWorldNeedsUpdate=!0,r.linearVelocity?(o.hasLinearVelocity=!0,o.linearVelocity.copy(r.linearVelocity)):o.hasLinearVelocity=!1,r.angularVelocity?(o.hasAngularVelocity=!0,o.angularVelocity.copy(r.angularVelocity)):o.hasAngularVelocity=!1,this.dispatchEvent(Wp)))}return null!==o&&(o.visible=null!==r),null!==s&&(s.visible=null!==i),null!==c&&(c.visible=null!==a),this}_getHandJoint(e,t){if(void 0===e.joints[t.jointName]){const n=new $p;n.matrixAutoUpdate=!1,n.visible=!1,e.joints[t.jointName]=n,e.add(n)}return e.joints[t.jointName]}}class Xp extends jl{constructor(e,t,n,r,i,a,o,s,c,l){if((l=void 0!==l?l:Xc)!==Xc&&l!==Yc)throw new Error("DepthTexture format must be either THREE.DepthFormat or THREE.DepthStencilFormat");void 0===n&&l===Xc&&(n=Vc),void 0===n&&l===Yc&&(n=Wc),super(null,r,i,a,o,s,l,n,c),this.isDepthTexture=!0,this.image={width:e,height:t},this.magFilter=void 0!==o?o:Nc,this.minFilter=void 0!==s?s:Nc,this.flipY=!1,this.generateMipmaps=!1,this.compareFunction=null}copy(e){return super.copy(e),this.compareFunction=e.compareFunction,this}toJSON(e){const t=super.toJSON(e);return null!==this.compareFunction&&(t.compareFunction=this.compareFunction),t}}class Yp extends fl{constructor(e,t){super();const n=this;let r=null,i=1,a=null,o="local-floor",s=1,c=null,l=null,u=null,d=null,f=null,h=null;const p=t.getContextAttributes();let m=null,v=null;const g=[],b=[],_=new cf;_.layers.enable(1),_.viewport=new Xl;const y=new cf;y.layers.enable(2),y.viewport=new Xl;const x=[_,y],A=new Gp;A.layers.enable(1),A.layers.enable(2);let w=null,E=null;function T(e){const t=b.indexOf(e.inputSource);if(-1===t)return;const n=g[t];void 0!==n&&(n.update(e.inputSource,e.frame,c||a),n.dispatchEvent({type:e.type,data:e.inputSource}))}function S(){r.removeEventListener("select",T),r.removeEventListener("selectstart",T),r.removeEventListener("selectend",T),r.removeEventListener("squeeze",T),r.removeEventListener("squeezestart",T),r.removeEventListener("squeezeend",T),r.removeEventListener("end",S),r.removeEventListener("inputsourceschange",C);for(let e=0;e<g.length;e++){const t=b[e];null!==t&&(b[e]=null,g[e].disconnect(t))}w=null,E=null,e.setRenderTarget(m),f=null,d=null,u=null,r=null,v=null,O.stop(),n.isPresenting=!1,n.dispatchEvent({type:"sessionend"})}function C(e){for(let t=0;t<e.removed.length;t++){const n=e.removed[t],r=b.indexOf(n);r>=0&&(b[r]=null,g[r].disconnect(n))}for(let t=0;t<e.added.length;t++){const n=e.added[t];let r=b.indexOf(n);if(-1===r){for(let e=0;e<g.length;e++){if(e>=b.length){b.push(n),r=e;break}if(null===b[e]){b[e]=n,r=e;break}}if(-1===r)break}const i=g[r];i&&i.connect(n)}}this.cameraAutoUpdate=!0,this.enabled=!1,this.isPresenting=!1,this.getController=function(e){let t=g[e];return void 0===t&&(t=new jp,g[e]=t),t.getTargetRaySpace()},this.getControllerGrip=function(e){let t=g[e];return void 0===t&&(t=new jp,g[e]=t),t.getGripSpace()},this.getHand=function(e){let t=g[e];return void 0===t&&(t=new jp,g[e]=t),t.getHandSpace()},this.setFramebufferScaleFactor=function(e){i=e,!0===n.isPresenting&&console.warn("THREE.WebXRManager: Cannot change framebuffer scale while presenting.")},this.setReferenceSpaceType=function(e){o=e,!0===n.isPresenting&&console.warn("THREE.WebXRManager: Cannot change reference space type while presenting.")},this.getReferenceSpace=function(){return c||a},this.setReferenceSpace=function(e){c=e},this.getBaseLayer=function(){return null!==d?d:f},this.getBinding=function(){return u},this.getFrame=function(){return h},this.getSession=function(){return r},this.setSession=async function(l){if(r=l,null!==r){if(m=e.getRenderTarget(),r.addEventListener("select",T),r.addEventListener("selectstart",T),r.addEventListener("selectend",T),r.addEventListener("squeeze",T),r.addEventListener("squeezestart",T),r.addEventListener("squeezeend",T),r.addEventListener("end",S),r.addEventListener("inputsourceschange",C),!0!==p.xrCompatible&&await t.makeXRCompatible(),void 0===r.renderState.layers||!1===e.capabilities.isWebGL2){const n={antialias:void 0!==r.renderState.layers||p.antialias,alpha:!0,depth:p.depth,stencil:p.stencil,framebufferScaleFactor:i};f=new XRWebGLLayer(r,t,n),r.updateRenderState({baseLayer:f}),v=new Yl(f.framebufferWidth,f.framebufferHeight,{format:jc,type:zc,colorSpace:e.outputColorSpace,stencilBuffer:p.stencil})}else{let n=null,a=null,o=null;p.depth&&(o=p.stencil?t.DEPTH24_STENCIL8:t.DEPTH_COMPONENT24,n=p.stencil?Yc:Xc,a=p.stencil?Wc:Vc);const s={colorFormat:t.RGBA8,depthFormat:o,scaleFactor:i};u=new XRWebGLBinding(r,t),d=u.createProjectionLayer(s),r.updateRenderState({layers:[d]}),v=new Yl(d.textureWidth,d.textureHeight,{format:jc,type:zc,depthTexture:new Xp(d.textureWidth,d.textureHeight,a,void 0,void 0,void 0,void 0,void 0,void 0,n),stencilBuffer:p.stencil,colorSpace:e.outputColorSpace,samples:p.antialias?4:0}),e.properties.get(v).__ignoreDepthValues=d.ignoreDepthValues}v.isXRRenderTarget=!0,this.setFoveation(s),c=null,a=await r.requestReferenceSpace(o),O.setContext(r),O.start(),n.isPresenting=!0,n.dispatchEvent({type:"sessionstart"})}},this.getEnvironmentBlendMode=function(){if(null!==r)return r.environmentBlendMode};const M=new Jl,k=new Jl;function R(e,t){null===t?e.matrixWorld.copy(e.matrix):e.matrixWorld.multiplyMatrices(t.matrixWorld,e.matrix),e.matrixWorldInverse.copy(e.matrixWorld).invert()}this.updateCamera=function(e){if(null===r)return;A.near=y.near=_.near=e.near,A.far=y.far=_.far=e.far,w===A.near&&E===A.far||(r.updateRenderState({depthNear:A.near,depthFar:A.far}),w=A.near,E=A.far);const t=e.parent,n=A.cameras;R(A,t);for(let e=0;e<n.length;e++)R(n[e],t);2===n.length?function(e,t,n){M.setFromMatrixPosition(t.matrixWorld),k.setFromMatrixPosition(n.matrixWorld);const r=M.distanceTo(k),i=t.projectionMatrix.elements,a=n.projectionMatrix.elements,o=i[14]/(i[10]-1),s=i[14]/(i[10]+1),c=(i[9]+1)/i[5],l=(i[9]-1)/i[5],u=(i[8]-1)/i[0],d=(a[8]+1)/a[0],f=o*u,h=o*d,p=r/(-u+d),m=p*-u;t.matrixWorld.decompose(e.position,e.quaternion,e.scale),e.translateX(m),e.translateZ(p),e.matrixWorld.compose(e.position,e.quaternion,e.scale),e.matrixWorldInverse.copy(e.matrixWorld).invert();const v=o+p,g=s+p,b=f-m,_=h+(r-m),y=c*s/g*v,x=l*s/g*v;e.projectionMatrix.makePerspective(b,_,y,x,v,g),e.projectionMatrixInverse.copy(e.projectionMatrix).invert()}(A,_,y):A.projectionMatrix.copy(_.projectionMatrix),function(e,t,n){null===n?e.matrix.copy(t.matrixWorld):(e.matrix.copy(n.matrixWorld),e.matrix.invert(),e.matrix.multiply(t.matrixWorld)),e.matrix.decompose(e.position,e.quaternion,e.scale),e.updateMatrixWorld(!0);const r=e.children;for(let e=0,t=r.length;e<t;e++)r[e].updateMatrixWorld(!0);e.projectionMatrix.copy(t.projectionMatrix),e.projectionMatrixInverse.copy(t.projectionMatrixInverse),e.isPerspectiveCamera&&(e.fov=2*vl*Math.atan(1/e.projectionMatrix.elements[5]),e.zoom=1)}(e,A,t)},this.getCamera=function(){return A},this.getFoveation=function(){if(null!==d||null!==f)return s},this.setFoveation=function(e){s=e,null!==d&&(d.fixedFoveation=e),null!==f&&void 0!==f.fixedFoveation&&(f.fixedFoveation=e)};let L=null;const O=new yf;O.setAnimationLoop((function(t,r){if(l=r.getViewerPose(c||a),h=r,null!==l){const t=l.views;null!==f&&(e.setRenderTargetFramebuffer(v,f.framebuffer),e.setRenderTarget(v));let n=!1;t.length!==A.cameras.length&&(A.cameras.length=0,n=!0);for(let r=0;r<t.length;r++){const i=t[r];let a=null;if(null!==f)a=f.getViewport(i);else{const t=u.getViewSubImage(d,i);a=t.viewport,0===r&&(e.setRenderTargetTextures(v,t.colorTexture,d.ignoreDepthValues?void 0:t.depthStencilTexture),e.setRenderTarget(v))}let o=x[r];void 0===o&&(o=new cf,o.layers.enable(r),o.viewport=new Xl,x[r]=o),o.matrix.fromArray(i.transform.matrix),o.matrix.decompose(o.position,o.quaternion,o.scale),o.projectionMatrix.fromArray(i.projectionMatrix),o.projectionMatrixInverse.copy(o.projectionMatrix).invert(),o.viewport.set(a.x,a.y,a.width,a.height),0===r&&(A.matrix.copy(o.matrix),A.matrix.decompose(A.position,A.quaternion,A.scale)),!0===n&&A.cameras.push(o)}}for(let e=0;e<g.length;e++){const t=b[e],n=g[e];null!==t&&void 0!==n&&n.update(t,r,c||a)}L&&L(t,r),r.detectedPlanes&&n.dispatchEvent({type:"planesdetected",data:r}),h=null})),this.setAnimationLoop=function(e){L=e},this.dispose=function(){}}}function qp(e,t){function n(e,t){!0===e.matrixAutoUpdate&&e.updateMatrix(),t.value.copy(e.matrix)}function r(r,i){r.opacity.value=i.opacity,i.color&&r.diffuse.value.copy(i.color),i.emissive&&r.emissive.value.copy(i.emissive).multiplyScalar(i.emissiveIntensity),i.map&&(r.map.value=i.map,n(i.map,r.mapTransform)),i.alphaMap&&(r.alphaMap.value=i.alphaMap,n(i.alphaMap,r.alphaMapTransform)),i.bumpMap&&(r.bumpMap.value=i.bumpMap,n(i.bumpMap,r.bumpMapTransform),r.bumpScale.value=i.bumpScale,1===i.side&&(r.bumpScale.value*=-1)),i.normalMap&&(r.normalMap.value=i.normalMap,n(i.normalMap,r.normalMapTransform),r.normalScale.value.copy(i.normalScale),1===i.side&&r.normalScale.value.negate()),i.displacementMap&&(r.displacementMap.value=i.displacementMap,n(i.displacementMap,r.displacementMapTransform),r.displacementScale.value=i.displacementScale,r.displacementBias.value=i.displacementBias),i.emissiveMap&&(r.emissiveMap.value=i.emissiveMap,n(i.emissiveMap,r.emissiveMapTransform)),i.specularMap&&(r.specularMap.value=i.specularMap,n(i.specularMap,r.specularMapTransform)),i.alphaTest>0&&(r.alphaTest.value=i.alphaTest);const a=t.get(i).envMap;if(a&&(r.envMap.value=a,r.flipEnvMap.value=a.isCubeTexture&&!1===a.isRenderTargetTexture?-1:1,r.reflectivity.value=i.reflectivity,r.ior.value=i.ior,r.refractionRatio.value=i.refractionRatio),i.lightMap){r.lightMap.value=i.lightMap;const t=!0===e.useLegacyLights?Math.PI:1;r.lightMapIntensity.value=i.lightMapIntensity*t,n(i.lightMap,r.lightMapTransform)}i.aoMap&&(r.aoMap.value=i.aoMap,r.aoMapIntensity.value=i.aoMapIntensity,n(i.aoMap,r.aoMapTransform))}return{refreshFogUniforms:function(t,n){n.color.getRGB(t.fogColor.value,rf(e)),n.isFog?(t.fogNear.value=n.near,t.fogFar.value=n.far):n.isFogExp2&&(t.fogDensity.value=n.density)},refreshMaterialUniforms:function(e,i,a,o,s){i.isMeshBasicMaterial||i.isMeshLambertMaterial?r(e,i):i.isMeshToonMaterial?(r(e,i),function(e,t){t.gradientMap&&(e.gradientMap.value=t.gradientMap)}(e,i)):i.isMeshPhongMaterial?(r(e,i),function(e,t){e.specular.value.copy(t.specular),e.shininess.value=Math.max(t.shininess,1e-4)}(e,i)):i.isMeshStandardMaterial?(r(e,i),function(e,r){e.metalness.value=r.metalness,r.metalnessMap&&(e.metalnessMap.value=r.metalnessMap,n(r.metalnessMap,e.metalnessMapTransform)),e.roughness.value=r.roughness,r.roughnessMap&&(e.roughnessMap.value=r.roughnessMap,n(r.roughnessMap,e.roughnessMapTransform));t.get(r).envMap&&(e.envMapIntensity.value=r.envMapIntensity)}(e,i),i.isMeshPhysicalMaterial&&function(e,t,r){e.ior.value=t.ior,t.sheen>0&&(e.sheenColor.value.copy(t.sheenColor).multiplyScalar(t.sheen),e.sheenRoughness.value=t.sheenRoughness,t.sheenColorMap&&(e.sheenColorMap.value=t.sheenColorMap,n(t.sheenColorMap,e.sheenColorMapTransform)),t.sheenRoughnessMap&&(e.sheenRoughnessMap.value=t.sheenRoughnessMap,n(t.sheenRoughnessMap,e.sheenRoughnessMapTransform))),t.clearcoat>0&&(e.clearcoat.value=t.clearcoat,e.clearcoatRoughness.value=t.clearcoatRoughness,t.clearcoatMap&&(e.clearcoatMap.value=t.clearcoatMap,n(t.clearcoatMap,e.clearcoatMapTransform)),t.clearcoatRoughnessMap&&(e.clearcoatRoughnessMap.value=t.clearcoatRoughnessMap,n(t.clearcoatRoughnessMap,e.clearcoatRoughnessMapTransform)),t.clearcoatNormalMap&&(e.clearcoatNormalMap.value=t.clearcoatNormalMap,n(t.clearcoatNormalMap,e.clearcoatNormalMapTransform),e.clearcoatNormalScale.value.copy(t.clearcoatNormalScale),1===t.side&&e.clearcoatNormalScale.value.negate())),t.iridescence>0&&(e.iridescence.value=t.iridescence,e.iridescenceIOR.value=t.iridescenceIOR,e.iridescenceThicknessMinimum.value=t.iridescenceThicknessRange[0],e.iridescenceThicknessMaximum.value=t.iridescenceThicknessRange[1],t.iridescenceMap&&(e.iridescenceMap.value=t.iridescenceMap,n(t.iridescenceMap,e.iridescenceMapTransform)),t.iridescenceThicknessMap&&(e.iridescenceThicknessMap.value=t.iridescenceThicknessMap,n(t.iridescenceThicknessMap,e.iridescenceThicknessMapTransform))),t.transmission>0&&(e.transmission.value=t.transmission,e.transmissionSamplerMap.value=r.texture,e.transmissionSamplerSize.value.set(r.width,r.height),t.transmissionMap&&(e.transmissionMap.value=t.transmissionMap,n(t.transmissionMap,e.transmissionMapTransform)),e.thickness.value=t.thickness,t.thicknessMap&&(e.thicknessMap.value=t.thicknessMap,n(t.thicknessMap,e.thicknessMapTransform)),e.attenuationDistance.value=t.attenuationDistance,e.attenuationColor.value.copy(t.attenuationColor)),t.anisotropy>0&&(e.anisotropyVector.value.set(t.anisotropy*Math.cos(t.anisotropyRotation),t.anisotropy*Math.sin(t.anisotropyRotation)),t.anisotropyMap&&(e.anisotropyMap.value=t.anisotropyMap,n(t.anisotropyMap,e.anisotropyMapTransform))),e.specularIntensity.value=t.specularIntensity,e.specularColor.value.copy(t.specularColor),t.specularColorMap&&(e.specularColorMap.value=t.specularColorMap,n(t.specularColorMap,e.specularColorMapTransform)),t.specularIntensityMap&&(e.specularIntensityMap.value=t.specularIntensityMap,n(t.specularIntensityMap,e.specularIntensityMapTransform))}(e,i,s)):i.isMeshMatcapMaterial?(r(e,i),function(e,t){t.matcap&&(e.matcap.value=t.matcap)}(e,i)):i.isMeshDepthMaterial?r(e,i):i.isMeshDistanceMaterial?(r(e,i),function(e,n){const r=t.get(n).light;e.referencePosition.value.setFromMatrixPosition(r.matrixWorld),e.nearDistance.value=r.shadow.camera.near,e.farDistance.value=r.shadow.camera.far}(e,i)):i.isMeshNormalMaterial?r(e,i):i.isLineBasicMaterial?(function(e,t){e.diffuse.value.copy(t.color),e.opacity.value=t.opacity,t.map&&(e.map.value=t.map,n(t.map,e.mapTransform))}(e,i),i.isLineDashedMaterial&&function(e,t){e.dashSize.value=t.dashSize,e.totalSize.value=t.dashSize+t.gapSize,e.scale.value=t.scale}(e,i)):i.isPointsMaterial?function(e,t,r,i){e.diffuse.value.copy(t.color),e.opacity.value=t.opacity,e.size.value=t.size*r,e.scale.value=.5*i,t.map&&(e.map.value=t.map,n(t.map,e.uvTransform)),t.alphaMap&&(e.alphaMap.value=t.alphaMap,n(t.alphaMap,e.alphaMapTransform)),t.alphaTest>0&&(e.alphaTest.value=t.alphaTest)}(e,i,a,o):i.isSpriteMaterial?function(e,t){e.diffuse.value.copy(t.color),e.opacity.value=t.opacity,e.rotation.value=t.rotation,t.map&&(e.map.value=t.map,n(t.map,e.mapTransform)),t.alphaMap&&(e.alphaMap.value=t.alphaMap,n(t.alphaMap,e.alphaMapTransform)),t.alphaTest>0&&(e.alphaTest.value=t.alphaTest)}(e,i):i.isShadowMaterial?(e.color.value.copy(i.color),e.opacity.value=i.opacity):i.isShaderMaterial&&(i.uniformsNeedUpdate=!1)}}}function Kp(e,t,n,r){let i={},a={},o=[];const s=n.isWebGL2?e.getParameter(e.MAX_UNIFORM_BUFFER_BINDINGS):0;function c(e,t,n){const r=e.value;if(void 0===n[t]){if("number"==typeof r)n[t]=r;else{const e=Array.isArray(r)?r:[r],i=[];for(let t=0;t<e.length;t++)i.push(e[t].clone());n[t]=i}return!0}if("number"==typeof r){if(n[t]!==r)return n[t]=r,!0}else{const e=Array.isArray(n[t])?n[t]:[n[t]],i=Array.isArray(r)?r:[r];for(let t=0;t<e.length;t++){const n=e[t];if(!1===n.equals(i[t]))return n.copy(i[t]),!0}}return!1}function l(e){const t={boundary:0,storage:0};return"number"==typeof e?(t.boundary=4,t.storage=4):e.isVector2?(t.boundary=8,t.storage=8):e.isVector3||e.isColor?(t.boundary=16,t.storage=12):e.isVector4?(t.boundary=16,t.storage=16):e.isMatrix3?(t.boundary=48,t.storage=48):e.isMatrix4?(t.boundary=64,t.storage=64):e.isTexture?console.warn("THREE.WebGLRenderer: Texture samplers can not be part of an uniforms group."):console.warn("THREE.WebGLRenderer: Unsupported uniform value type.",e),t}function u(t){const n=t.target;n.removeEventListener("dispose",u);const r=o.indexOf(n.__bindingPointIndex);o.splice(r,1),e.deleteBuffer(i[n.id]),delete i[n.id],delete a[n.id]}return{bind:function(e,t){const n=t.program;r.uniformBlockBinding(e,n)},update:function(n,d){let f=i[n.id];void 0===f&&(function(e){const t=e.uniforms;let n=0;let r=0;for(let e=0,i=t.length;e<i;e++){const i=t[e],a={boundary:0,storage:0},o=Array.isArray(i.value)?i.value:[i.value];for(let e=0,t=o.length;e<t;e++){const t=l(o[e]);a.boundary+=t.boundary,a.storage+=t.storage}i.__data=new Float32Array(a.storage/Float32Array.BYTES_PER_ELEMENT),i.__offset=n,e>0&&(r=n%16,0!==r&&16-r-a.boundary<0&&(n+=16-r,i.__offset=n)),n+=a.storage}r=n%16,r>0&&(n+=16-r),e.__size=n,e.__cache={}}(n),f=function(t){const n=function(){for(let e=0;e<s;e++)if(-1===o.indexOf(e))return o.push(e),e;return console.error("THREE.WebGLRenderer: Maximum number of simultaneously usable uniforms groups reached."),0}();t.__bindingPointIndex=n;const r=e.createBuffer(),i=t.__size,a=t.usage;return e.bindBuffer(e.UNIFORM_BUFFER,r),e.bufferData(e.UNIFORM_BUFFER,i,a),e.bindBuffer(e.UNIFORM_BUFFER,null),e.bindBufferBase(e.UNIFORM_BUFFER,n,r),r}(n),i[n.id]=f,n.addEventListener("dispose",u));const h=d.program;r.updateUBOMapping(n,h);const p=t.render.frame;a[n.id]!==p&&(function(t){const n=i[t.id],r=t.uniforms,a=t.__cache;e.bindBuffer(e.UNIFORM_BUFFER,n);for(let t=0,n=r.length;t<n;t++){const n=r[t];if(!0===c(n,t,a)){const t=n.__offset,r=Array.isArray(n.value)?n.value:[n.value];let i=0;for(let a=0;a<r.length;a++){const o=r[a],s=l(o);"number"==typeof o?(n.__data[0]=o,e.bufferSubData(e.UNIFORM_BUFFER,t+i,n.__data)):o.isMatrix3?(n.__data[0]=o.elements[0],n.__data[1]=o.elements[1],n.__data[2]=o.elements[2],n.__data[3]=o.elements[0],n.__data[4]=o.elements[3],n.__data[5]=o.elements[4],n.__data[6]=o.elements[5],n.__data[7]=o.elements[0],n.__data[8]=o.elements[6],n.__data[9]=o.elements[7],n.__data[10]=o.elements[8],n.__data[11]=o.elements[0]):(o.toArray(n.__data,i),i+=s.storage/Float32Array.BYTES_PER_ELEMENT)}e.bufferSubData(e.UNIFORM_BUFFER,t,n.__data)}}e.bindBuffer(e.UNIFORM_BUFFER,null)}(n),a[n.id]=p)},dispose:function(){for(const t in i)e.deleteBuffer(i[t]);o=[],i={},a={}}}}function Zp(){const e=Rl("canvas");return e.style.display="block",e}class Jp{constructor(e={}){const{canvas:t=Zp(),context:n=null,depth:r=!0,stencil:i=!0,alpha:a=!1,antialias:o=!1,premultipliedAlpha:s=!0,preserveDrawingBuffer:c=!1,powerPreference:l="default",failIfMajorPerformanceCaveat:u=!1}=e;let d;this.isWebGLRenderer=!0,d=null!==n?n.getContextAttributes().alpha:a;const f=new Uint32Array(4),h=new Int32Array(4);let p=null,m=null;const v=[],g=[];this.domElement=t,this.debug={checkShaderErrors:!0,onShaderError:null},this.autoClear=!0,this.autoClearColor=!0,this.autoClearDepth=!0,this.autoClearStencil=!0,this.sortObjects=!0,this.clippingPlanes=[],this.localClippingEnabled=!1,this.outputColorSpace=il,this.useLegacyLights=!0,this.toneMapping=Ec,this.toneMappingExposure=1;const b=this;let _=!1,y=0,x=0,A=null,w=-1,E=null;const T=new Xl,S=new Xl;let C=null;const M=new bd(0);let k=0,R=t.width,L=t.height,O=1,I=null,P=null;const D=new Xl(0,0,R,L),N=new Xl(0,0,R,L);let U=!1;const F=new _f;let B=!1,z=!1,H=null;const V=new Mu,G=new Sl,$=new Jl,W={background:null,fog:null,environment:null,overrideMaterial:null,isScene:!0};function j(){return null===A?O:1}let X,Y,q,K,Z,J,Q,ee,te,ne,re,ie,ae,oe,se,ce,le,ue,de,fe,he,pe,me,ve,ge=n;function be(e,n){for(let r=0;r<e.length;r++){const i=e[r],a=t.getContext(i,n);if(null!==a)return a}return null}try{const e={alpha:!0,depth:r,stencil:i,antialias:o,premultipliedAlpha:s,preserveDrawingBuffer:c,powerPreference:l,failIfMajorPerformanceCaveat:u};if("setAttribute"in t&&t.setAttribute("data-engine",`three.js r${vc}`),t.addEventListener("webglcontextlost",xe,!1),t.addEventListener("webglcontextrestored",Ae,!1),t.addEventListener("webglcontextcreationerror",we,!1),null===ge){const t=["webgl2","webgl","experimental-webgl"];if(!0===b.isWebGL1Renderer&&t.shift(),ge=be(t,e),null===ge)throw be(t)?new Error("Error creating WebGL context with your selected attributes."):new Error("Error creating WebGL context.")}"undefined"!=typeof WebGLRenderingContext&&ge instanceof WebGLRenderingContext&&console.warn("THREE.WebGLRenderer: WebGL 1 support was deprecated in r153 and will be removed in r163."),void 0===ge.getShaderPrecisionFormat&&(ge.getShaderPrecisionFormat=function(){return{rangeMin:1,rangeMax:1,precision:1}})}catch(e){throw console.error("THREE.WebGLRenderer: "+e.message),e}function _e(){X=new Xf(ge),Y=new Rf(ge,X,e),X.init(Y),pe=new Vp(ge,X,Y),q=new zp(ge,X,Y),K=new Kf(ge),Z=new Sp,J=new Hp(ge,X,q,Z,Y,pe,K),Q=new Of(b),ee=new jf(b),te=new xf(ge,Y),me=new Mf(ge,X,te,Y),ne=new Yf(ge,te,K,me),re=new eh(ge,ne,te,K),de=new Qf(ge,Y,J),ce=new Lf(Z),ie=new Tp(b,Q,ee,X,Y,me,ce),ae=new qp(b,Z),oe=new Rp,se=new Np(X,Y),ue=new Cf(b,Q,ee,q,re,d,s),le=new Bp(b,re,Y),ve=new Kp(ge,K,Y,q),fe=new kf(ge,X,K,Y),he=new qf(ge,X,K,Y),K.programs=ie.programs,b.capabilities=Y,b.extensions=X,b.properties=Z,b.renderLists=oe,b.shadowMap=le,b.state=q,b.info=K}_e();const ye=new Yp(b,ge);function xe(e){e.preventDefault(),console.log("THREE.WebGLRenderer: Context Lost."),_=!0}function Ae(){console.log("THREE.WebGLRenderer: Context Restored."),_=!1;const e=K.autoReset,t=le.enabled,n=le.autoUpdate,r=le.needsUpdate,i=le.type;_e(),K.autoReset=e,le.enabled=t,le.autoUpdate=n,le.needsUpdate=r,le.type=i}function we(e){console.error("THREE.WebGLRenderer: A WebGL context could not be created. Reason: ",e.statusMessage)}function Ee(e){const t=e.target;t.removeEventListener("dispose",Ee),function(e){(function(e){const t=Z.get(e).programs;void 0!==t&&(t.forEach((function(e){ie.releaseProgram(e)})),e.isShaderMaterial&&ie.releaseShaderCache(e))})(e),Z.remove(e)}(t)}this.xr=ye,this.getContext=function(){return ge},this.getContextAttributes=function(){return ge.getContextAttributes()},this.forceContextLoss=function(){const e=X.get("WEBGL_lose_context");e&&e.loseContext()},this.forceContextRestore=function(){const e=X.get("WEBGL_lose_context");e&&e.restoreContext()},this.getPixelRatio=function(){return O},this.setPixelRatio=function(e){void 0!==e&&(O=e,this.setSize(R,L,!1))},this.getSize=function(e){return e.set(R,L)},this.setSize=function(e,n,r=!0){ye.isPresenting?console.warn("THREE.WebGLRenderer: Can't change size while VR device is presenting."):(R=e,L=n,t.width=Math.floor(e*O),t.height=Math.floor(n*O),!0===r&&(t.style.width=e+"px",t.style.height=n+"px"),this.setViewport(0,0,e,n))},this.getDrawingBufferSize=function(e){return e.set(R*O,L*O).floor()},this.setDrawingBufferSize=function(e,n,r){R=e,L=n,O=r,t.width=Math.floor(e*r),t.height=Math.floor(n*r),this.setViewport(0,0,e,n)},this.getCurrentViewport=function(e){return e.copy(T)},this.getViewport=function(e){return e.copy(D)},this.setViewport=function(e,t,n,r){e.isVector4?D.set(e.x,e.y,e.z,e.w):D.set(e,t,n,r),q.viewport(T.copy(D).multiplyScalar(O).floor())},this.getScissor=function(e){return e.copy(N)},this.setScissor=function(e,t,n,r){e.isVector4?N.set(e.x,e.y,e.z,e.w):N.set(e,t,n,r),q.scissor(S.copy(N).multiplyScalar(O).floor())},this.getScissorTest=function(){return U},this.setScissorTest=function(e){q.setScissorTest(U=e)},this.setOpaqueSort=function(e){I=e},this.setTransparentSort=function(e){P=e},this.getClearColor=function(e){return e.copy(ue.getClearColor())},this.setClearColor=function(){ue.setClearColor.apply(ue,arguments)},this.getClearAlpha=function(){return ue.getClearAlpha()},this.setClearAlpha=function(){ue.setClearAlpha.apply(ue,arguments)},this.clear=function(e=!0,t=!0,n=!0){let r=0;if(e){let e=!1;if(null!==A){const t=A.texture.format;e=1033===t||1031===t||1029===t}if(e){const e=A.texture.type,t=e===zc||e===Vc||e===Hc||e===Wc||1017===e||1018===e,n=ue.getClearColor(),r=ue.getClearAlpha(),i=n.r,a=n.g,o=n.b;t?(f[0]=i,f[1]=a,f[2]=o,f[3]=r,ge.clearBufferuiv(ge.COLOR,0,f)):(h[0]=i,h[1]=a,h[2]=o,h[3]=r,ge.clearBufferiv(ge.COLOR,0,h))}else r|=ge.COLOR_BUFFER_BIT}t&&(r|=ge.DEPTH_BUFFER_BIT),n&&(r|=ge.STENCIL_BUFFER_BIT),ge.clear(r)},this.clearColor=function(){this.clear(!0,!1,!1)},this.clearDepth=function(){this.clear(!1,!0,!1)},this.clearStencil=function(){this.clear(!1,!1,!0)},this.dispose=function(){t.removeEventListener("webglcontextlost",xe,!1),t.removeEventListener("webglcontextrestored",Ae,!1),t.removeEventListener("webglcontextcreationerror",we,!1),oe.dispose(),se.dispose(),Z.dispose(),Q.dispose(),ee.dispose(),re.dispose(),me.dispose(),ve.dispose(),ie.dispose(),ye.dispose(),ye.removeEventListener("sessionstart",Se),ye.removeEventListener("sessionend",Ce),H&&(H.dispose(),H=null),Me.stop()},this.renderBufferDirect=function(e,t,n,r,i,a){null===t&&(t=W);const o=i.isMesh&&i.matrixWorld.determinant()<0,s=function(e,t,n,r,i){!0!==t.isScene&&(t=W),J.resetTextureUnits();const a=t.fog,o=r.isMeshStandardMaterial?t.environment:null,s=null===A?b.outputColorSpace:!0===A.isXRRenderTarget?A.texture.colorSpace:al,c=(r.isMeshStandardMaterial?ee:Q).get(r.envMap||o),l=!0===r.vertexColors&&!!n.attributes.color&&4===n.attributes.color.itemSize,u=!!n.attributes.tangent&&(!!r.normalMap||r.anisotropy>0),d=!!n.morphAttributes.position,f=!!n.morphAttributes.normal,h=!!n.morphAttributes.color,p=r.toneMapped?b.toneMapping:Ec,v=n.morphAttributes.position||n.morphAttributes.normal||n.morphAttributes.color,g=void 0!==v?v.length:0,_=Z.get(r),y=m.state.lights;if(!0===B&&(!0===z||e!==E)){const t=e===E&&r.id===w;ce.setState(r,e,t)}let x=!1;r.version===_.__version?_.needsLights&&_.lightsStateVersion!==y.state.version||_.outputColorSpace!==s||i.isInstancedMesh&&!1===_.instancing?x=!0:i.isInstancedMesh||!0!==_.instancing?i.isSkinnedMesh&&!1===_.skinning?x=!0:i.isSkinnedMesh||!0!==_.skinning?_.envMap!==c||!0===r.fog&&_.fog!==a?x=!0:void 0===_.numClippingPlanes||_.numClippingPlanes===ce.numPlanes&&_.numIntersection===ce.numIntersection?(_.vertexAlphas!==l||_.vertexTangents!==u||_.morphTargets!==d||_.morphNormals!==f||_.morphColors!==h||_.toneMapping!==p||!0===Y.isWebGL2&&_.morphTargetsCount!==g)&&(x=!0):x=!0:x=!0:x=!0:(x=!0,_.__version=r.version);let T=_.currentProgram;!0===x&&(T=Ie(r,t,i));let S=!1,C=!1,M=!1;const k=T.getUniforms(),R=_.uniforms;if(q.useProgram(T.program)&&(S=!0,C=!0,M=!0),r.id!==w&&(w=r.id,C=!0),S||E!==e){if(k.setValue(ge,"projectionMatrix",e.projectionMatrix),Y.logarithmicDepthBuffer&&k.setValue(ge,"logDepthBufFC",2/(Math.log(e.far+1)/Math.LN2)),E!==e&&(E=e,C=!0,M=!0),r.isShaderMaterial||r.isMeshPhongMaterial||r.isMeshToonMaterial||r.isMeshStandardMaterial||r.envMap){const t=k.map.cameraPosition;void 0!==t&&t.setValue(ge,$.setFromMatrixPosition(e.matrixWorld))}(r.isMeshPhongMaterial||r.isMeshToonMaterial||r.isMeshLambertMaterial||r.isMeshBasicMaterial||r.isMeshStandardMaterial||r.isShaderMaterial)&&k.setValue(ge,"isOrthographic",!0===e.isOrthographicCamera),(r.isMeshPhongMaterial||r.isMeshToonMaterial||r.isMeshLambertMaterial||r.isMeshBasicMaterial||r.isMeshStandardMaterial||r.isShaderMaterial||r.isShadowMaterial||i.isSkinnedMesh)&&k.setValue(ge,"viewMatrix",e.matrixWorldInverse)}if(i.isSkinnedMesh){k.setOptional(ge,i,"bindMatrix"),k.setOptional(ge,i,"bindMatrixInverse");const e=i.skeleton;e&&(Y.floatVertexTextures?(null===e.boneTexture&&e.computeBoneTexture(),k.setValue(ge,"boneTexture",e.boneTexture,J),k.setValue(ge,"boneTextureSize",e.boneTextureSize)):console.warn("THREE.WebGLRenderer: SkinnedMesh can only be used with WebGL 2. With WebGL 1 OES_texture_float and vertex textures support is required."))}const I=n.morphAttributes;var P,D;if((void 0!==I.position||void 0!==I.normal||void 0!==I.color&&!0===Y.isWebGL2)&&de.update(i,n,T),(C||_.receiveShadow!==i.receiveShadow)&&(_.receiveShadow=i.receiveShadow,k.setValue(ge,"receiveShadow",i.receiveShadow)),r.isMeshGouraudMaterial&&null!==r.envMap&&(R.envMap.value=c,R.flipEnvMap.value=c.isCubeTexture&&!1===c.isRenderTargetTexture?-1:1),C&&(k.setValue(ge,"toneMappingExposure",b.toneMappingExposure),_.needsLights&&(D=M,(P=R).ambientLightColor.needsUpdate=D,P.lightProbe.needsUpdate=D,P.directionalLights.needsUpdate=D,P.directionalLightShadows.needsUpdate=D,P.pointLights.needsUpdate=D,P.pointLightShadows.needsUpdate=D,P.spotLights.needsUpdate=D,P.spotLightShadows.needsUpdate=D,P.rectAreaLights.needsUpdate=D,P.hemisphereLights.needsUpdate=D),a&&!0===r.fog&&ae.refreshFogUniforms(R,a),ae.refreshMaterialUniforms(R,r,O,L,H),ip.upload(ge,_.uniformsList,R,J)),r.isShaderMaterial&&!0===r.uniformsNeedUpdate&&(ip.upload(ge,_.uniformsList,R,J),r.uniformsNeedUpdate=!1),r.isSpriteMaterial&&k.setValue(ge,"center",i.center),k.setValue(ge,"modelViewMatrix",i.modelViewMatrix),k.setValue(ge,"normalMatrix",i.normalMatrix),k.setValue(ge,"modelMatrix",i.matrixWorld),r.isShaderMaterial||r.isRawShaderMaterial){const e=r.uniformsGroups;for(let t=0,n=e.length;t<n;t++)if(Y.isWebGL2){const n=e[t];ve.update(n,T),ve.bind(n,T)}else console.warn("THREE.WebGLRenderer: Uniform Buffer Objects can only be used with WebGL 2.")}return T}(e,t,n,r,i);q.setMaterial(r,o);let c=n.index,l=1;!0===r.wireframe&&(c=ne.getWireframeAttribute(n),l=2);const u=n.drawRange,d=n.attributes.position;let f=u.start*l,h=(u.start+u.count)*l;null!==a&&(f=Math.max(f,a.start*l),h=Math.min(h,(a.start+a.count)*l)),null!==c?(f=Math.max(f,0),h=Math.min(h,c.count)):null!=d&&(f=Math.max(f,0),h=Math.min(h,d.count));const p=h-f;if(p<0||p===1/0)return;let v;me.setup(i,r,s,n,c);let g=fe;if(null!==c&&(v=te.get(c),g=he,g.setIndex(v)),i.isMesh)!0===r.wireframe?(q.setLineWidth(r.wireframeLinewidth*j()),g.setMode(ge.LINES)):g.setMode(ge.TRIANGLES);else if(i.isLine){let e=r.linewidth;void 0===e&&(e=1),q.setLineWidth(e*j()),i.isLineSegments?g.setMode(ge.LINES):i.isLineLoop?g.setMode(ge.LINE_LOOP):g.setMode(ge.LINE_STRIP)}else i.isPoints?g.setMode(ge.POINTS):i.isSprite&&g.setMode(ge.TRIANGLES);if(i.isInstancedMesh)g.renderInstances(f,p,i.count);else if(n.isInstancedBufferGeometry){const e=void 0!==n._maxInstanceCount?n._maxInstanceCount:1/0,t=Math.min(n.instanceCount,e);g.renderInstances(f,p,t)}else g.render(f,p)},this.compile=function(e,t){function n(e,t,n){!0===e.transparent&&2===e.side&&!1===e.forceSinglePass?(e.side=1,e.needsUpdate=!0,Ie(e,t,n),e.side=0,e.needsUpdate=!0,Ie(e,t,n),e.side=2):Ie(e,t,n)}m=se.get(e),m.init(),g.push(m),e.traverseVisible((function(e){e.isLight&&e.layers.test(t.layers)&&(m.pushLight(e),e.castShadow&&m.pushShadow(e))})),m.setupLights(b.useLegacyLights),e.traverse((function(t){const r=t.material;if(r)if(Array.isArray(r))for(let i=0;i<r.length;i++)n(r[i],e,t);else n(r,e,t)})),g.pop(),m=null};let Te=null;function Se(){Me.stop()}function Ce(){Me.start()}const Me=new yf;function ke(e,t,n,r){if(!1===e.visible)return;if(e.layers.test(t.layers))if(e.isGroup)n=e.renderOrder;else if(e.isLOD)!0===e.autoUpdate&&e.update(t);else if(e.isLight)m.pushLight(e),e.castShadow&&m.pushShadow(e);else if(e.isSprite){if(!e.frustumCulled||F.intersectsSprite(e)){r&&$.setFromMatrixPosition(e.matrixWorld).applyMatrix4(V);const t=re.update(e),i=e.material;i.visible&&p.push(e,t,i,n,$.z,null)}}else if((e.isMesh||e.isLine||e.isPoints)&&(!e.frustumCulled||F.intersectsObject(e))){const t=re.update(e),i=e.material;if(r&&(void 0!==e.boundingSphere?(null===e.boundingSphere&&e.computeBoundingSphere(),$.copy(e.boundingSphere.center)):(null===t.boundingSphere&&t.computeBoundingSphere(),$.copy(t.boundingSphere.center)),$.applyMatrix4(e.matrixWorld).applyMatrix4(V)),Array.isArray(i)){const r=t.groups;for(let a=0,o=r.length;a<o;a++){const o=r[a],s=i[o.materialIndex];s&&s.visible&&p.push(e,t,s,n,$.z,o)}}else i.visible&&p.push(e,t,i,n,$.z,null)}const i=e.children;for(let e=0,a=i.length;e<a;e++)ke(i[e],t,n,r)}function Re(e,t,n,r){const i=e.opaque,a=e.transmissive,o=e.transparent;m.setupLightsView(n),!0===B&&ce.setGlobalState(b.clippingPlanes,n),a.length>0&&function(e,t,n,r){const i=Y.isWebGL2;null===H&&(H=new Yl(1,1,{generateMipmaps:!0,type:X.has("EXT_color_buffer_half_float")?$c:zc,minFilter:Bc,samples:i?4:0})),b.getDrawingBufferSize(G),i?H.setSize(G.x,G.y):H.setSize(Al(G.x),Al(G.y));const a=b.getRenderTarget();b.setRenderTarget(H),b.getClearColor(M),k=b.getClearAlpha(),k<1&&b.setClearColor(16777215,.5),b.clear();const o=b.toneMapping;b.toneMapping=Ec,Le(e,n,r),J.updateMultisampleRenderTarget(H),J.updateRenderTargetMipmap(H);let s=!1;for(let e=0,i=t.length;e<i;e++){const i=t[e],a=i.object,o=i.geometry,c=i.material,l=i.group;if(2===c.side&&a.layers.test(r.layers)){const e=c.side;c.side=1,c.needsUpdate=!0,Oe(a,n,r,o,c,l),c.side=e,c.needsUpdate=!0,s=!0}}!0===s&&(J.updateMultisampleRenderTarget(H),J.updateRenderTargetMipmap(H)),b.setRenderTarget(a),b.setClearColor(M,k),b.toneMapping=o}(i,a,t,n),r&&q.viewport(T.copy(r)),i.length>0&&Le(i,t,n),a.length>0&&Le(a,t,n),o.length>0&&Le(o,t,n),q.buffers.depth.setTest(!0),q.buffers.depth.setMask(!0),q.buffers.color.setMask(!0),q.setPolygonOffset(!1)}function Le(e,t,n){const r=!0===t.isScene?t.overrideMaterial:null;for(let i=0,a=e.length;i<a;i++){const a=e[i],o=a.object,s=a.geometry,c=null===r?a.material:r,l=a.group;o.layers.test(n.layers)&&Oe(o,t,n,s,c,l)}}function Oe(e,t,n,r,i,a){e.onBeforeRender(b,t,n,r,i,a),e.modelViewMatrix.multiplyMatrices(n.matrixWorldInverse,e.matrixWorld),e.normalMatrix.getNormalMatrix(e.modelViewMatrix),i.onBeforeRender(b,t,n,r,e,a),!0===i.transparent&&2===i.side&&!1===i.forceSinglePass?(i.side=1,i.needsUpdate=!0,b.renderBufferDirect(n,t,r,i,e,a),i.side=0,i.needsUpdate=!0,b.renderBufferDirect(n,t,r,i,e,a),i.side=2):b.renderBufferDirect(n,t,r,i,e,a),e.onAfterRender(b,t,n,r,i,a)}function Ie(e,t,n){!0!==t.isScene&&(t=W);const r=Z.get(e),i=m.state.lights,a=m.state.shadowsArray,o=i.state.version,s=ie.getParameters(e,i.state,a,t,n),c=ie.getProgramCacheKey(s);let l=r.programs;r.environment=e.isMeshStandardMaterial?t.environment:null,r.fog=t.fog,r.envMap=(e.isMeshStandardMaterial?ee:Q).get(e.envMap||r.environment),void 0===l&&(e.addEventListener("dispose",Ee),l=new Map,r.programs=l);let u=l.get(c);if(void 0!==u){if(r.currentProgram===u&&r.lightsStateVersion===o)return Pe(e,s),u}else s.uniforms=ie.getUniforms(e),e.onBuild(n,s,b),e.onBeforeCompile(s,b),u=ie.acquireProgram(s,c),l.set(c,u),r.uniforms=s.uniforms;const d=r.uniforms;(e.isShaderMaterial||e.isRawShaderMaterial)&&!0!==e.clipping||(d.clippingPlanes=ce.uniform),Pe(e,s),r.needsLights=function(e){return e.isMeshLambertMaterial||e.isMeshToonMaterial||e.isMeshPhongMaterial||e.isMeshStandardMaterial||e.isShadowMaterial||e.isShaderMaterial&&!0===e.lights}(e),r.lightsStateVersion=o,r.needsLights&&(d.ambientLightColor.value=i.state.ambient,d.lightProbe.value=i.state.probe,d.directionalLights.value=i.state.directional,d.directionalLightShadows.value=i.state.directionalShadow,d.spotLights.value=i.state.spot,d.spotLightShadows.value=i.state.spotShadow,d.rectAreaLights.value=i.state.rectArea,d.ltc_1.value=i.state.rectAreaLTC1,d.ltc_2.value=i.state.rectAreaLTC2,d.pointLights.value=i.state.point,d.pointLightShadows.value=i.state.pointShadow,d.hemisphereLights.value=i.state.hemi,d.directionalShadowMap.value=i.state.directionalShadowMap,d.directionalShadowMatrix.value=i.state.directionalShadowMatrix,d.spotShadowMap.value=i.state.spotShadowMap,d.spotLightMatrix.value=i.state.spotLightMatrix,d.spotLightMap.value=i.state.spotLightMap,d.pointShadowMap.value=i.state.pointShadowMap,d.pointShadowMatrix.value=i.state.pointShadowMatrix);const f=u.getUniforms(),h=ip.seqWithValue(f.seq,d);return r.currentProgram=u,r.uniformsList=h,u}function Pe(e,t){const n=Z.get(e);n.outputColorSpace=t.outputColorSpace,n.instancing=t.instancing,n.skinning=t.skinning,n.morphTargets=t.morphTargets,n.morphNormals=t.morphNormals,n.morphColors=t.morphColors,n.morphTargetsCount=t.morphTargetsCount,n.numClippingPlanes=t.numClippingPlanes,n.numIntersection=t.numClipIntersection,n.vertexAlphas=t.vertexAlphas,n.vertexTangents=t.vertexTangents,n.toneMapping=t.toneMapping}Me.setAnimationLoop((function(e){Te&&Te(e)})),"undefined"!=typeof self&&Me.setContext(self),this.setAnimationLoop=function(e){Te=e,ye.setAnimationLoop(e),null===e?Me.stop():Me.start()},ye.addEventListener("sessionstart",Se),ye.addEventListener("sessionend",Ce),this.render=function(e,t){if(void 0!==t&&!0!==t.isCamera)return void console.error("THREE.WebGLRenderer.render: camera is not an instance of THREE.Camera.");if(!0===_)return;!0===e.matrixWorldAutoUpdate&&e.updateMatrixWorld(),null===t.parent&&!0===t.matrixWorldAutoUpdate&&t.updateMatrixWorld(),!0===ye.enabled&&!0===ye.isPresenting&&(!0===ye.cameraAutoUpdate&&ye.updateCamera(t),t=ye.getCamera()),!0===e.isScene&&e.onBeforeRender(b,e,t,A),m=se.get(e,g.length),m.init(),g.push(m),V.multiplyMatrices(t.projectionMatrix,t.matrixWorldInverse),F.setFromProjectionMatrix(V),z=this.localClippingEnabled,B=ce.init(this.clippingPlanes,z),p=oe.get(e,v.length),p.init(),v.push(p),ke(e,t,0,b.sortObjects),p.finish(),!0===b.sortObjects&&p.sort(I,P),this.info.render.frame++,!0===B&&ce.beginShadows();const n=m.state.shadowsArray;if(le.render(n,e,t),!0===B&&ce.endShadows(),!0===this.info.autoReset&&this.info.reset(),ue.render(p,e),m.setupLights(b.useLegacyLights),t.isArrayCamera){const n=t.cameras;for(let t=0,r=n.length;t<r;t++){const r=n[t];Re(p,e,r,r.viewport)}}else Re(p,e,t);null!==A&&(J.updateMultisampleRenderTarget(A),J.updateRenderTargetMipmap(A)),!0===e.isScene&&e.onAfterRender(b,e,t),me.resetDefaultState(),w=-1,E=null,g.pop(),m=g.length>0?g[g.length-1]:null,v.pop(),p=v.length>0?v[v.length-1]:null},this.getActiveCubeFace=function(){return y},this.getActiveMipmapLevel=function(){return x},this.getRenderTarget=function(){return A},this.setRenderTargetTextures=function(e,t,n){Z.get(e.texture).__webglTexture=t,Z.get(e.depthTexture).__webglTexture=n;const r=Z.get(e);r.__hasExternalTextures=!0,r.__hasExternalTextures&&(r.__autoAllocateDepthBuffer=void 0===n,r.__autoAllocateDepthBuffer||!0===X.has("WEBGL_multisampled_render_to_texture")&&(console.warn("THREE.WebGLRenderer: Render-to-texture extension was disabled because an external texture was provided"),r.__useRenderToTexture=!1))},this.setRenderTargetFramebuffer=function(e,t){const n=Z.get(e);n.__webglFramebuffer=t,n.__useDefaultFramebuffer=void 0===t},this.setRenderTarget=function(e,t=0,n=0){A=e,y=t,x=n;let r=!0,i=null,a=!1,o=!1;if(e){const n=Z.get(e);void 0!==n.__useDefaultFramebuffer?(q.bindFramebuffer(ge.FRAMEBUFFER,null),r=!1):void 0===n.__webglFramebuffer?J.setupRenderTarget(e):n.__hasExternalTextures&&J.rebindTextures(e,Z.get(e.texture).__webglTexture,Z.get(e.depthTexture).__webglTexture);const s=e.texture;(s.isData3DTexture||s.isDataArrayTexture||s.isCompressedArrayTexture)&&(o=!0);const c=Z.get(e).__webglFramebuffer;e.isWebGLCubeRenderTarget?(i=c[t],a=!0):i=Y.isWebGL2&&e.samples>0&&!1===J.useMultisampledRTT(e)?Z.get(e).__webglMultisampledFramebuffer:c,T.copy(e.viewport),S.copy(e.scissor),C=e.scissorTest}else T.copy(D).multiplyScalar(O).floor(),S.copy(N).multiplyScalar(O).floor(),C=U;if(q.bindFramebuffer(ge.FRAMEBUFFER,i)&&Y.drawBuffers&&r&&q.drawBuffers(e,i),q.viewport(T),q.scissor(S),q.setScissorTest(C),a){const r=Z.get(e.texture);ge.framebufferTexture2D(ge.FRAMEBUFFER,ge.COLOR_ATTACHMENT0,ge.TEXTURE_CUBE_MAP_POSITIVE_X+t,r.__webglTexture,n)}else if(o){const r=Z.get(e.texture),i=t||0;ge.framebufferTextureLayer(ge.FRAMEBUFFER,ge.COLOR_ATTACHMENT0,r.__webglTexture,n||0,i)}w=-1},this.readRenderTargetPixels=function(e,t,n,r,i,a,o){if(!e||!e.isWebGLRenderTarget)return void console.error("THREE.WebGLRenderer.readRenderTargetPixels: renderTarget is not THREE.WebGLRenderTarget.");let s=Z.get(e).__webglFramebuffer;if(e.isWebGLCubeRenderTarget&&void 0!==o&&(s=s[o]),s){q.bindFramebuffer(ge.FRAMEBUFFER,s);try{const o=e.texture,s=o.format,c=o.type;if(s!==jc&&pe.convert(s)!==ge.getParameter(ge.IMPLEMENTATION_COLOR_READ_FORMAT))return void console.error("THREE.WebGLRenderer.readRenderTargetPixels: renderTarget is not in RGBA or implementation defined format.");const l=c===$c&&(X.has("EXT_color_buffer_half_float")||Y.isWebGL2&&X.has("EXT_color_buffer_float"));if(!(c===zc||pe.convert(c)===ge.getParameter(ge.IMPLEMENTATION_COLOR_READ_TYPE)||c===Gc&&(Y.isWebGL2||X.has("OES_texture_float")||X.has("WEBGL_color_buffer_float"))||l))return void console.error("THREE.WebGLRenderer.readRenderTargetPixels: renderTarget is not in UnsignedByteType or implementation defined type.");t>=0&&t<=e.width-r&&n>=0&&n<=e.height-i&&ge.readPixels(t,n,r,i,pe.convert(s),pe.convert(c),a)}finally{const e=null!==A?Z.get(A).__webglFramebuffer:null;q.bindFramebuffer(ge.FRAMEBUFFER,e)}}},this.copyFramebufferToTexture=function(e,t,n=0){const r=Math.pow(2,-n),i=Math.floor(t.image.width*r),a=Math.floor(t.image.height*r);J.setTexture2D(t,0),ge.copyTexSubImage2D(ge.TEXTURE_2D,n,0,0,e.x,e.y,i,a),q.unbindTexture()},this.copyTextureToTexture=function(e,t,n,r=0){const i=t.image.width,a=t.image.height,o=pe.convert(n.format),s=pe.convert(n.type);J.setTexture2D(n,0),ge.pixelStorei(ge.UNPACK_FLIP_Y_WEBGL,n.flipY),ge.pixelStorei(ge.UNPACK_PREMULTIPLY_ALPHA_WEBGL,n.premultiplyAlpha),ge.pixelStorei(ge.UNPACK_ALIGNMENT,n.unpackAlignment),t.isDataTexture?ge.texSubImage2D(ge.TEXTURE_2D,r,e.x,e.y,i,a,o,s,t.image.data):t.isCompressedTexture?ge.compressedTexSubImage2D(ge.TEXTURE_2D,r,e.x,e.y,t.mipmaps[0].width,t.mipmaps[0].height,o,t.mipmaps[0].data):ge.texSubImage2D(ge.TEXTURE_2D,r,e.x,e.y,o,s,t.image),0===r&&n.generateMipmaps&&ge.generateMipmap(ge.TEXTURE_2D),q.unbindTexture()},this.copyTextureToTexture3D=function(e,t,n,r,i=0){if(b.isWebGL1Renderer)return void console.warn("THREE.WebGLRenderer.copyTextureToTexture3D: can only be used with WebGL2.");const a=e.max.x-e.min.x+1,o=e.max.y-e.min.y+1,s=e.max.z-e.min.z+1,c=pe.convert(r.format),l=pe.convert(r.type);let u;if(r.isData3DTexture)J.setTexture3D(r,0),u=ge.TEXTURE_3D;else{if(!r.isDataArrayTexture)return void console.warn("THREE.WebGLRenderer.copyTextureToTexture3D: only supports THREE.DataTexture3D and THREE.DataTexture2DArray.");J.setTexture2DArray(r,0),u=ge.TEXTURE_2D_ARRAY}ge.pixelStorei(ge.UNPACK_FLIP_Y_WEBGL,r.flipY),ge.pixelStorei(ge.UNPACK_PREMULTIPLY_ALPHA_WEBGL,r.premultiplyAlpha),ge.pixelStorei(ge.UNPACK_ALIGNMENT,r.unpackAlignment);const d=ge.getParameter(ge.UNPACK_ROW_LENGTH),f=ge.getParameter(ge.UNPACK_IMAGE_HEIGHT),h=ge.getParameter(ge.UNPACK_SKIP_PIXELS),p=ge.getParameter(ge.UNPACK_SKIP_ROWS),m=ge.getParameter(ge.UNPACK_SKIP_IMAGES),v=n.isCompressedTexture?n.mipmaps[0]:n.image;ge.pixelStorei(ge.UNPACK_ROW_LENGTH,v.width),ge.pixelStorei(ge.UNPACK_IMAGE_HEIGHT,v.height),ge.pixelStorei(ge.UNPACK_SKIP_PIXELS,e.min.x),ge.pixelStorei(ge.UNPACK_SKIP_ROWS,e.min.y),ge.pixelStorei(ge.UNPACK_SKIP_IMAGES,e.min.z),n.isDataTexture||n.isData3DTexture?ge.texSubImage3D(u,i,t.x,t.y,t.z,a,o,s,c,l,v.data):n.isCompressedArrayTexture?(console.warn("THREE.WebGLRenderer.copyTextureToTexture3D: untested support for compressed srcTexture."),ge.compressedTexSubImage3D(u,i,t.x,t.y,t.z,a,o,s,c,v.data)):ge.texSubImage3D(u,i,t.x,t.y,t.z,a,o,s,c,l,v),ge.pixelStorei(ge.UNPACK_ROW_LENGTH,d),ge.pixelStorei(ge.UNPACK_IMAGE_HEIGHT,f),ge.pixelStorei(ge.UNPACK_SKIP_PIXELS,h),ge.pixelStorei(ge.UNPACK_SKIP_ROWS,p),ge.pixelStorei(ge.UNPACK_SKIP_IMAGES,m),0===i&&r.generateMipmaps&&ge.generateMipmap(u),q.unbindTexture()},this.initTexture=function(e){e.isCubeTexture?J.setTextureCube(e,0):e.isData3DTexture?J.setTexture3D(e,0):e.isDataArrayTexture||e.isCompressedArrayTexture?J.setTexture2DArray(e,0):J.setTexture2D(e,0),q.unbindTexture()},this.resetState=function(){y=0,x=0,A=null,q.reset(),me.reset()},"undefined"!=typeof __THREE_DEVTOOLS__&&__THREE_DEVTOOLS__.dispatchEvent(new CustomEvent("observe",{detail:this}))}get coordinateSystem(){return ul}get physicallyCorrectLights(){return console.warn("THREE.WebGLRenderer: the property .physicallyCorrectLights has been removed. Set renderer.useLegacyLights instead."),!this.useLegacyLights}set physicallyCorrectLights(e){console.warn("THREE.WebGLRenderer: the property .physicallyCorrectLights has been removed. Set renderer.useLegacyLights instead."),this.useLegacyLights=!e}get outputEncoding(){return console.warn("THREE.WebGLRenderer: Property .outputEncoding has been removed. Use .outputColorSpace instead."),this.outputColorSpace===il?rl:3e3}set outputEncoding(e){console.warn("THREE.WebGLRenderer: Property .outputEncoding has been removed. Use .outputColorSpace instead."),this.outputColorSpace=e===rl?il:al}}(class extends Jp{}).prototype.isWebGL1Renderer=!0;class Qp extends Qu{constructor(){super(),this.isScene=!0,this.type="Scene",this.background=null,this.environment=null,this.fog=null,this.backgroundBlurriness=0,this.backgroundIntensity=1,this.overrideMaterial=null,"undefined"!=typeof __THREE_DEVTOOLS__&&__THREE_DEVTOOLS__.dispatchEvent(new CustomEvent("observe",{detail:this}))}copy(e,t){return super.copy(e,t),null!==e.background&&(this.background=e.background.clone()),null!==e.environment&&(this.environment=e.environment.clone()),null!==e.fog&&(this.fog=e.fog.clone()),this.backgroundBlurriness=e.backgroundBlurriness,this.backgroundIntensity=e.backgroundIntensity,null!==e.overrideMaterial&&(this.overrideMaterial=e.overrideMaterial.clone()),this.matrixAutoUpdate=e.matrixAutoUpdate,this}toJSON(e){const t=super.toJSON(e);return null!==this.fog&&(t.object.fog=this.fog.toJSON()),this.backgroundBlurriness>0&&(t.object.backgroundBlurriness=this.backgroundBlurriness),1!==this.backgroundIntensity&&(t.object.backgroundIntensity=this.backgroundIntensity),t}}class em extends hd{constructor(e){super(),this.isLineBasicMaterial=!0,this.type="LineBasicMaterial",this.color=new bd(16777215),this.map=null,this.linewidth=1,this.linecap="round",this.linejoin="round",this.fog=!0,this.setValues(e)}copy(e){return super.copy(e),this.color.copy(e.color),this.map=e.map,this.linewidth=e.linewidth,this.linecap=e.linecap,this.linejoin=e.linejoin,this.fog=e.fog,this}}const tm=new Jl,nm=new Jl,rm=new Mu,im=new Cu,am=new _u;class om extends Qu{constructor(e=new Pd,t=new em){super(),this.isLine=!0,this.type="Line",this.geometry=e,this.material=t,this.updateMorphTargets()}copy(e,t){return super.copy(e,t),this.material=e.material,this.geometry=e.geometry,this}computeLineDistances(){const e=this.geometry;if(null===e.index){const t=e.attributes.position,n=[0];for(let e=1,r=t.count;e<r;e++)tm.fromBufferAttribute(t,e-1),nm.fromBufferAttribute(t,e),n[e]=n[e-1],n[e]+=tm.distanceTo(nm);e.setAttribute("lineDistance",new Sd(n,1))}else console.warn("THREE.Line.computeLineDistances(): Computation only possible with non-indexed BufferGeometry.");return this}raycast(e,t){const n=this.geometry,r=this.matrixWorld,i=e.params.Line.threshold,a=n.drawRange;if(null===n.boundingSphere&&n.computeBoundingSphere(),am.copy(n.boundingSphere),am.applyMatrix4(r),am.radius+=i,!1===e.ray.intersectsSphere(am))return;rm.copy(r).invert(),im.copy(e.ray).applyMatrix4(rm);const o=i/((this.scale.x+this.scale.y+this.scale.z)/3),s=o*o,c=new Jl,l=new Jl,u=new Jl,d=new Jl,f=this.isLineSegments?2:1,h=n.index,p=n.attributes.position;if(null!==h)for(let n=Math.max(0,a.start),r=Math.min(h.count,a.start+a.count)-1;n<r;n+=f){const r=h.getX(n),i=h.getX(n+1);if(c.fromBufferAttribute(p,r),l.fromBufferAttribute(p,i),im.distanceSqToSegment(c,l,d,u)>s)continue;d.applyMatrix4(this.matrixWorld);const a=e.ray.origin.distanceTo(d);a<e.near||a>e.far||t.push({distance:a,point:u.clone().applyMatrix4(this.matrixWorld),index:n,face:null,faceIndex:null,object:this})}else for(let n=Math.max(0,a.start),r=Math.min(p.count,a.start+a.count)-1;n<r;n+=f){if(c.fromBufferAttribute(p,n),l.fromBufferAttribute(p,n+1),im.distanceSqToSegment(c,l,d,u)>s)continue;d.applyMatrix4(this.matrixWorld);const r=e.ray.origin.distanceTo(d);r<e.near||r>e.far||t.push({distance:r,point:u.clone().applyMatrix4(this.matrixWorld),index:n,face:null,faceIndex:null,object:this})}}updateMorphTargets(){const e=this.geometry.morphAttributes,t=Object.keys(e);if(t.length>0){const n=e[t[0]];if(void 0!==n){this.morphTargetInfluences=[],this.morphTargetDictionary={};for(let e=0,t=n.length;e<t;e++){const t=n[e].name||String(e);this.morphTargetInfluences.push(0),this.morphTargetDictionary[t]=e}}}}}const sm=new Jl,cm=new Jl;class lm extends om{constructor(e,t){super(e,t),this.isLineSegments=!0,this.type="LineSegments"}computeLineDistances(){const e=this.geometry;if(null===e.index){const t=e.attributes.position,n=[];for(let e=0,r=t.count;e<r;e+=2)sm.fromBufferAttribute(t,e),cm.fromBufferAttribute(t,e+1),n[e]=0===e?0:n[e-1],n[e+1]=n[e]+sm.distanceTo(cm);e.setAttribute("lineDistance",new Sd(n,1))}else console.warn("THREE.LineSegments.computeLineDistances(): Computation only possible with non-indexed BufferGeometry.");return this}}class um extends hd{constructor(e){super(),this.isPointsMaterial=!0,this.type="PointsMaterial",this.color=new bd(16777215),this.map=null,this.alphaMap=null,this.size=1,this.sizeAttenuation=!0,this.fog=!0,this.setValues(e)}copy(e){return super.copy(e),this.color.copy(e.color),this.map=e.map,this.alphaMap=e.alphaMap,this.size=e.size,this.sizeAttenuation=e.sizeAttenuation,this.fog=e.fog,this}}const dm=new Mu,fm=new Cu,hm=new _u,pm=new Jl;class mm extends Qu{constructor(e=new Pd,t=new um){super(),this.isPoints=!0,this.type="Points",this.geometry=e,this.material=t,this.updateMorphTargets()}copy(e,t){return super.copy(e,t),this.material=e.material,this.geometry=e.geometry,this}raycast(e,t){const n=this.geometry,r=this.matrixWorld,i=e.params.Points.threshold,a=n.drawRange;if(null===n.boundingSphere&&n.computeBoundingSphere(),hm.copy(n.boundingSphere),hm.applyMatrix4(r),hm.radius+=i,!1===e.ray.intersectsSphere(hm))return;dm.copy(r).invert(),fm.copy(e.ray).applyMatrix4(dm);const o=i/((this.scale.x+this.scale.y+this.scale.z)/3),s=o*o,c=n.index,l=n.attributes.position;if(null!==c)for(let n=Math.max(0,a.start),i=Math.min(c.count,a.start+a.count);n<i;n++){const i=c.getX(n);pm.fromBufferAttribute(l,i),vm(pm,i,s,r,e,t,this)}else for(let n=Math.max(0,a.start),i=Math.min(l.count,a.start+a.count);n<i;n++)pm.fromBufferAttribute(l,n),vm(pm,n,s,r,e,t,this)}updateMorphTargets(){const e=this.geometry.morphAttributes,t=Object.keys(e);if(t.length>0){const n=e[t[0]];if(void 0!==n){this.morphTargetInfluences=[],this.morphTargetDictionary={};for(let e=0,t=n.length;e<t;e++){const t=n[e].name||String(e);this.morphTargetInfluences.push(0),this.morphTargetDictionary[t]=e}}}}}function vm(e,t,n,r,i,a,o){const s=fm.distanceSqToPoint(e);if(s<n){const n=new Jl;fm.closestPointToPoint(e,n),n.applyMatrix4(r);const c=i.ray.origin.distanceTo(n);if(c<i.near||c>i.far)return;a.push({distance:c,distanceToRay:Math.sqrt(s),point:n,index:t,face:null,object:o})}}class gm extends hd{constructor(e){super(),this.isMeshPhongMaterial=!0,this.type="MeshPhongMaterial",this.color=new bd(16777215),this.specular=new bd(1118481),this.shininess=30,this.map=null,this.lightMap=null,this.lightMapIntensity=1,this.aoMap=null,this.aoMapIntensity=1,this.emissive=new bd(0),this.emissiveIntensity=1,this.emissiveMap=null,this.bumpMap=null,this.bumpScale=1,this.normalMap=null,this.normalMapType=0,this.normalScale=new Sl(1,1),this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.specularMap=null,this.alphaMap=null,this.envMap=null,this.combine=xc,this.reflectivity=1,this.refractionRatio=.98,this.wireframe=!1,this.wireframeLinewidth=1,this.wireframeLinecap="round",this.wireframeLinejoin="round",this.flatShading=!1,this.fog=!0,this.setValues(e)}copy(e){return super.copy(e),this.color.copy(e.color),this.specular.copy(e.specular),this.shininess=e.shininess,this.map=e.map,this.lightMap=e.lightMap,this.lightMapIntensity=e.lightMapIntensity,this.aoMap=e.aoMap,this.aoMapIntensity=e.aoMapIntensity,this.emissive.copy(e.emissive),this.emissiveMap=e.emissiveMap,this.emissiveIntensity=e.emissiveIntensity,this.bumpMap=e.bumpMap,this.bumpScale=e.bumpScale,this.normalMap=e.normalMap,this.normalMapType=e.normalMapType,this.normalScale.copy(e.normalScale),this.displacementMap=e.displacementMap,this.displacementScale=e.displacementScale,this.displacementBias=e.displacementBias,this.specularMap=e.specularMap,this.alphaMap=e.alphaMap,this.envMap=e.envMap,this.combine=e.combine,this.reflectivity=e.reflectivity,this.refractionRatio=e.refractionRatio,this.wireframe=e.wireframe,this.wireframeLinewidth=e.wireframeLinewidth,this.wireframeLinecap=e.wireframeLinecap,this.wireframeLinejoin=e.wireframeLinejoin,this.flatShading=e.flatShading,this.fog=e.fog,this}}class bm extends hd{constructor(e){super(),this.isMeshNormalMaterial=!0,this.type="MeshNormalMaterial",this.bumpMap=null,this.bumpScale=1,this.normalMap=null,this.normalMapType=0,this.normalScale=new Sl(1,1),this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.wireframe=!1,this.wireframeLinewidth=1,this.flatShading=!1,this.setValues(e)}copy(e){return super.copy(e),this.bumpMap=e.bumpMap,this.bumpScale=e.bumpScale,this.normalMap=e.normalMap,this.normalMapType=e.normalMapType,this.normalScale.copy(e.normalScale),this.displacementMap=e.displacementMap,this.displacementScale=e.displacementScale,this.displacementBias=e.displacementBias,this.wireframe=e.wireframe,this.wireframeLinewidth=e.wireframeLinewidth,this.flatShading=e.flatShading,this}}function _m(e,t,n){return xm(e)?new e.constructor(e.subarray(t,void 0!==n?n:e.length)):e.slice(t,n)}function ym(e,t,n){return!e||!n&&e.constructor===t?e:"number"==typeof t.BYTES_PER_ELEMENT?new t(e):Array.prototype.slice.call(e)}function xm(e){return ArrayBuffer.isView(e)&&!(e instanceof DataView)}class Am{constructor(e,t,n,r){this.parameterPositions=e,this._cachedIndex=0,this.resultBuffer=void 0!==r?r:new t.constructor(n),this.sampleValues=t,this.valueSize=n,this.settings=null,this.DefaultSettings_={}}evaluate(e){const t=this.parameterPositions;let n=this._cachedIndex,r=t[n],i=t[n-1];e:{t:{let a;n:{r:if(!(e<r)){for(let a=n+2;;){if(void 0===r){if(e<i)break r;return n=t.length,this._cachedIndex=n,this.copySampleValue_(n-1)}if(n===a)break;if(i=r,r=t[++n],e<r)break t}a=t.length;break n}if(e>=i)break e;{const o=t[1];e<o&&(n=2,i=o);for(let a=n-2;;){if(void 0===i)return this._cachedIndex=0,this.copySampleValue_(0);if(n===a)break;if(r=i,i=t[--n-1],e>=i)break t}a=n,n=0}}for(;n<a;){const r=n+a>>>1;e<t[r]?a=r:n=r+1}if(r=t[n],i=t[n-1],void 0===i)return this._cachedIndex=0,this.copySampleValue_(0);if(void 0===r)return n=t.length,this._cachedIndex=n,this.copySampleValue_(n-1)}this._cachedIndex=n,this.intervalChanged_(n,i,r)}return this.interpolate_(n,i,e,r)}getSettings_(){return this.settings||this.DefaultSettings_}copySampleValue_(e){const t=this.resultBuffer,n=this.sampleValues,r=this.valueSize,i=e*r;for(let e=0;e!==r;++e)t[e]=n[i+e];return t}interpolate_(){throw new Error("call to abstract method")}intervalChanged_(){}}class wm extends Am{constructor(e,t,n,r){super(e,t,n,r),this._weightPrev=-0,this._offsetPrev=-0,this._weightNext=-0,this._offsetNext=-0,this.DefaultSettings_={endingStart:2400,endingEnd:2400}}intervalChanged_(e,t,n){const r=this.parameterPositions;let i=e-2,a=e+1,o=r[i],s=r[a];if(void 0===o)switch(this.getSettings_().endingStart){case 2401:i=e,o=2*t-n;break;case 2402:i=r.length-2,o=t+r[i]-r[i+1];break;default:i=e,o=n}if(void 0===s)switch(this.getSettings_().endingEnd){case 2401:a=e,s=2*n-t;break;case 2402:a=1,s=n+r[1]-r[0];break;default:a=e-1,s=t}const c=.5*(n-t),l=this.valueSize;this._weightPrev=c/(t-o),this._weightNext=c/(s-n),this._offsetPrev=i*l,this._offsetNext=a*l}interpolate_(e,t,n,r){const i=this.resultBuffer,a=this.sampleValues,o=this.valueSize,s=e*o,c=s-o,l=this._offsetPrev,u=this._offsetNext,d=this._weightPrev,f=this._weightNext,h=(n-t)/(r-t),p=h*h,m=p*h,v=-d*m+2*d*p-d*h,g=(1+d)*m+(-1.5-2*d)*p+(-.5+d)*h+1,b=(-1-f)*m+(1.5+f)*p+.5*h,_=f*m-f*p;for(let e=0;e!==o;++e)i[e]=v*a[l+e]+g*a[c+e]+b*a[s+e]+_*a[u+e];return i}}class Em extends Am{constructor(e,t,n,r){super(e,t,n,r)}interpolate_(e,t,n,r){const i=this.resultBuffer,a=this.sampleValues,o=this.valueSize,s=e*o,c=s-o,l=(n-t)/(r-t),u=1-l;for(let e=0;e!==o;++e)i[e]=a[c+e]*u+a[s+e]*l;return i}}class Tm extends Am{constructor(e,t,n,r){super(e,t,n,r)}interpolate_(e){return this.copySampleValue_(e-1)}}class Sm{constructor(e,t,n,r){if(void 0===e)throw new Error("THREE.KeyframeTrack: track name is undefined");if(void 0===t||0===t.length)throw new Error("THREE.KeyframeTrack: no keyframes in track named "+e);this.name=e,this.times=ym(t,this.TimeBufferType),this.values=ym(n,this.ValueBufferType),this.setInterpolation(r||this.DefaultInterpolation)}static toJSON(e){const t=e.constructor;let n;if(t.toJSON!==this.toJSON)n=t.toJSON(e);else{n={name:e.name,times:ym(e.times,Array),values:ym(e.values,Array)};const t=e.getInterpolation();t!==e.DefaultInterpolation&&(n.interpolation=t)}return n.type=e.ValueTypeName,n}InterpolantFactoryMethodDiscrete(e){return new Tm(this.times,this.values,this.getValueSize(),e)}InterpolantFactoryMethodLinear(e){return new Em(this.times,this.values,this.getValueSize(),e)}InterpolantFactoryMethodSmooth(e){return new wm(this.times,this.values,this.getValueSize(),e)}setInterpolation(e){let t;switch(e){case el:t=this.InterpolantFactoryMethodDiscrete;break;case tl:t=this.InterpolantFactoryMethodLinear;break;case nl:t=this.InterpolantFactoryMethodSmooth}if(void 0===t){const t="unsupported interpolation for "+this.ValueTypeName+" keyframe track named "+this.name;if(void 0===this.createInterpolant){if(e===this.DefaultInterpolation)throw new Error(t);this.setInterpolation(this.DefaultInterpolation)}return console.warn("THREE.KeyframeTrack:",t),this}return this.createInterpolant=t,this}getInterpolation(){switch(this.createInterpolant){case this.InterpolantFactoryMethodDiscrete:return el;case this.InterpolantFactoryMethodLinear:return tl;case this.InterpolantFactoryMethodSmooth:return nl}}getValueSize(){return this.values.length/this.times.length}shift(e){if(0!==e){const t=this.times;for(let n=0,r=t.length;n!==r;++n)t[n]+=e}return this}scale(e){if(1!==e){const t=this.times;for(let n=0,r=t.length;n!==r;++n)t[n]*=e}return this}trim(e,t){const n=this.times,r=n.length;let i=0,a=r-1;for(;i!==r&&n[i]<e;)++i;for(;-1!==a&&n[a]>t;)--a;if(++a,0!==i||a!==r){i>=a&&(a=Math.max(a,1),i=a-1);const e=this.getValueSize();this.times=_m(n,i,a),this.values=_m(this.values,i*e,a*e)}return this}validate(){let e=!0;const t=this.getValueSize();t-Math.floor(t)!=0&&(console.error("THREE.KeyframeTrack: Invalid value size in track.",this),e=!1);const n=this.times,r=this.values,i=n.length;0===i&&(console.error("THREE.KeyframeTrack: Track is empty.",this),e=!1);let a=null;for(let t=0;t!==i;t++){const r=n[t];if("number"==typeof r&&isNaN(r)){console.error("THREE.KeyframeTrack: Time is not a valid number.",this,t,r),e=!1;break}if(null!==a&&a>r){console.error("THREE.KeyframeTrack: Out of order keys.",this,t,r,a),e=!1;break}a=r}if(void 0!==r&&xm(r))for(let t=0,n=r.length;t!==n;++t){const n=r[t];if(isNaN(n)){console.error("THREE.KeyframeTrack: Value is not a valid number.",this,t,n),e=!1;break}}return e}optimize(){const e=_m(this.times),t=_m(this.values),n=this.getValueSize(),r=this.getInterpolation()===nl,i=e.length-1;let a=1;for(let o=1;o<i;++o){let i=!1;const s=e[o];if(s!==e[o+1]&&(1!==o||s!==e[0]))if(r)i=!0;else{const e=o*n,r=e-n,a=e+n;for(let o=0;o!==n;++o){const n=t[e+o];if(n!==t[r+o]||n!==t[a+o]){i=!0;break}}}if(i){if(o!==a){e[a]=e[o];const r=o*n,i=a*n;for(let e=0;e!==n;++e)t[i+e]=t[r+e]}++a}}if(i>0){e[a]=e[i];for(let e=i*n,r=a*n,o=0;o!==n;++o)t[r+o]=t[e+o];++a}return a!==e.length?(this.times=_m(e,0,a),this.values=_m(t,0,a*n)):(this.times=e,this.values=t),this}clone(){const e=_m(this.times,0),t=_m(this.values,0),n=new(0,this.constructor)(this.name,e,t);return n.createInterpolant=this.createInterpolant,n}}Sm.prototype.TimeBufferType=Float32Array,Sm.prototype.ValueBufferType=Float32Array,Sm.prototype.DefaultInterpolation=tl;class Cm extends Sm{}Cm.prototype.ValueTypeName="bool",Cm.prototype.ValueBufferType=Array,Cm.prototype.DefaultInterpolation=el,Cm.prototype.InterpolantFactoryMethodLinear=void 0,Cm.prototype.InterpolantFactoryMethodSmooth=void 0;(class extends Sm{}).prototype.ValueTypeName="color";(class extends Sm{}).prototype.ValueTypeName="number";class Mm extends Am{constructor(e,t,n,r){super(e,t,n,r)}interpolate_(e,t,n,r){const i=this.resultBuffer,a=this.sampleValues,o=this.valueSize,s=(n-t)/(r-t);let c=e*o;for(let e=c+o;c!==e;c+=4)Zl.slerpFlat(i,0,a,c-o,a,c,s);return i}}class km extends Sm{InterpolantFactoryMethodLinear(e){return new Mm(this.times,this.values,this.getValueSize(),e)}}km.prototype.ValueTypeName="quaternion",km.prototype.DefaultInterpolation=tl,km.prototype.InterpolantFactoryMethodSmooth=void 0;class Rm extends Sm{}Rm.prototype.ValueTypeName="string",Rm.prototype.ValueBufferType=Array,Rm.prototype.DefaultInterpolation=el,Rm.prototype.InterpolantFactoryMethodLinear=void 0,Rm.prototype.InterpolantFactoryMethodSmooth=void 0;(class extends Sm{}).prototype.ValueTypeName="vector";const Lm={enabled:!1,files:{},add:function(e,t){!1!==this.enabled&&(this.files[e]=t)},get:function(e){if(!1!==this.enabled)return this.files[e]},remove:function(e){delete this.files[e]},clear:function(){this.files={}}};class Om{constructor(e,t,n){const r=this;let i,a=!1,o=0,s=0;const c=[];this.onStart=void 0,this.onLoad=e,this.onProgress=t,this.onError=n,this.itemStart=function(e){s++,!1===a&&void 0!==r.onStart&&r.onStart(e,o,s),a=!0},this.itemEnd=function(e){o++,void 0!==r.onProgress&&r.onProgress(e,o,s),o===s&&(a=!1,void 0!==r.onLoad&&r.onLoad())},this.itemError=function(e){void 0!==r.onError&&r.onError(e)},this.resolveURL=function(e){return i?i(e):e},this.setURLModifier=function(e){return i=e,this},this.addHandler=function(e,t){return c.push(e,t),this},this.removeHandler=function(e){const t=c.indexOf(e);return-1!==t&&c.splice(t,2),this},this.getHandler=function(e){for(let t=0,n=c.length;t<n;t+=2){const n=c[t],r=c[t+1];if(n.global&&(n.lastIndex=0),n.test(e))return r}return null}}}const Im=new Om;class Pm{constructor(e){this.manager=void 0!==e?e:Im,this.crossOrigin="anonymous",this.withCredentials=!1,this.path="",this.resourcePath="",this.requestHeader={}}load(){}loadAsync(e,t){const n=this;return new Promise((function(r,i){n.load(e,r,t,i)}))}parse(){}setCrossOrigin(e){return this.crossOrigin=e,this}setWithCredentials(e){return this.withCredentials=e,this}setPath(e){return this.path=e,this}setResourcePath(e){return this.resourcePath=e,this}setRequestHeader(e){return this.requestHeader=e,this}}Pm.DEFAULT_MATERIAL_NAME="__DEFAULT";const Dm={};class Nm extends Error{constructor(e,t){super(e),this.response=t}}class Um extends Pm{constructor(e){super(e)}load(e,t,n,r){void 0===e&&(e=""),void 0!==this.path&&(e=this.path+e),e=this.manager.resolveURL(e);const i=Lm.get(e);if(void 0!==i)return this.manager.itemStart(e),setTimeout((()=>{t&&t(i),this.manager.itemEnd(e)}),0),i;if(void 0!==Dm[e])return void Dm[e].push({onLoad:t,onProgress:n,onError:r});Dm[e]=[],Dm[e].push({onLoad:t,onProgress:n,onError:r});const a=new Request(e,{headers:new Headers(this.requestHeader),credentials:this.withCredentials?"include":"same-origin"}),o=this.mimeType,s=this.responseType;fetch(a).then((t=>{if(200===t.status||0===t.status){if(0===t.status&&console.warn("THREE.FileLoader: HTTP Status 0 received."),"undefined"==typeof ReadableStream||void 0===t.body||void 0===t.body.getReader)return t;const n=Dm[e],r=t.body.getReader(),i=t.headers.get("Content-Length")||t.headers.get("X-File-Size"),a=i?parseInt(i):0,o=0!==a;let s=0;const c=new ReadableStream({start(e){!function t(){r.read().then((({done:r,value:i})=>{if(r)e.close();else{s+=i.byteLength;const r=new ProgressEvent("progress",{lengthComputable:o,loaded:s,total:a});for(let e=0,t=n.length;e<t;e++){const t=n[e];t.onProgress&&t.onProgress(r)}e.enqueue(i),t()}}))}()}});return new Response(c)}throw new Nm(`fetch for "${t.url}" responded with ${t.status}: ${t.statusText}`,t)})).then((e=>{switch(s){case"arraybuffer":return e.arrayBuffer();case"blob":return e.blob();case"document":return e.text().then((e=>(new DOMParser).parseFromString(e,o)));case"json":return e.json();default:if(void 0===o)return e.text();{const t=/charset="?([^;"\s]*)"?/i.exec(o),n=t&&t[1]?t[1].toLowerCase():void 0,r=new TextDecoder(n);return e.arrayBuffer().then((e=>r.decode(e)))}}})).then((t=>{Lm.add(e,t);const n=Dm[e];delete Dm[e];for(let e=0,r=n.length;e<r;e++){const r=n[e];r.onLoad&&r.onLoad(t)}})).catch((t=>{const n=Dm[e];if(void 0===n)throw this.manager.itemError(e),t;delete Dm[e];for(let e=0,r=n.length;e<r;e++){const r=n[e];r.onError&&r.onError(t)}this.manager.itemError(e)})).finally((()=>{this.manager.itemEnd(e)})),this.manager.itemStart(e)}setResponseType(e){return this.responseType=e,this}setMimeType(e){return this.mimeType=e,this}}const Fm="\\[\\]\\.:\\/",Bm=new RegExp("["+Fm+"]","g"),zm="[^"+Fm+"]",Hm="[^"+Fm.replace("\\.","")+"]",Vm=new RegExp("^"+/((?:WC+[\/:])*)/.source.replace("WC",zm)+/(WCOD+)?/.source.replace("WCOD",Hm)+/(?:\.(WC+)(?:\[(.+)\])?)?/.source.replace("WC",zm)+/\.(WC+)(?:\[(.+)\])?/.source.replace("WC",zm)+"$"),Gm=["material","materials","bones","map"];class $m{constructor(e,t,n){this.path=t,this.parsedPath=n||$m.parseTrackName(t),this.node=$m.findNode(e,this.parsedPath.nodeName),this.rootNode=e,this.getValue=this._getValue_unbound,this.setValue=this._setValue_unbound}static create(e,t,n){return e&&e.isAnimationObjectGroup?new $m.Composite(e,t,n):new $m(e,t,n)}static sanitizeNodeName(e){return e.replace(/\s/g,"_").replace(Bm,"")}static parseTrackName(e){const t=Vm.exec(e);if(null===t)throw new Error("PropertyBinding: Cannot parse trackName: "+e);const n={nodeName:t[2],objectName:t[3],objectIndex:t[4],propertyName:t[5],propertyIndex:t[6]},r=n.nodeName&&n.nodeName.lastIndexOf(".");if(void 0!==r&&-1!==r){const e=n.nodeName.substring(r+1);-1!==Gm.indexOf(e)&&(n.nodeName=n.nodeName.substring(0,r),n.objectName=e)}if(null===n.propertyName||0===n.propertyName.length)throw new Error("PropertyBinding: can not parse propertyName from trackName: "+e);return n}static findNode(e,t){if(void 0===t||""===t||"."===t||-1===t||t===e.name||t===e.uuid)return e;if(e.skeleton){const n=e.skeleton.getBoneByName(t);if(void 0!==n)return n}if(e.children){const n=function(e){for(let r=0;r<e.length;r++){const i=e[r];if(i.name===t||i.uuid===t)return i;const a=n(i.children);if(a)return a}return null},r=n(e.children);if(r)return r}return null}_getValue_unavailable(){}_setValue_unavailable(){}_getValue_direct(e,t){e[t]=this.targetObject[this.propertyName]}_getValue_array(e,t){const n=this.resolvedProperty;for(let r=0,i=n.length;r!==i;++r)e[t++]=n[r]}_getValue_arrayElement(e,t){e[t]=this.resolvedProperty[this.propertyIndex]}_getValue_toArray(e,t){this.resolvedProperty.toArray(e,t)}_setValue_direct(e,t){this.targetObject[this.propertyName]=e[t]}_setValue_direct_setNeedsUpdate(e,t){this.targetObject[this.propertyName]=e[t],this.targetObject.needsUpdate=!0}_setValue_direct_setMatrixWorldNeedsUpdate(e,t){this.targetObject[this.propertyName]=e[t],this.targetObject.matrixWorldNeedsUpdate=!0}_setValue_array(e,t){const n=this.resolvedProperty;for(let r=0,i=n.length;r!==i;++r)n[r]=e[t++]}_setValue_array_setNeedsUpdate(e,t){const n=this.resolvedProperty;for(let r=0,i=n.length;r!==i;++r)n[r]=e[t++];this.targetObject.needsUpdate=!0}_setValue_array_setMatrixWorldNeedsUpdate(e,t){const n=this.resolvedProperty;for(let r=0,i=n.length;r!==i;++r)n[r]=e[t++];this.targetObject.matrixWorldNeedsUpdate=!0}_setValue_arrayElement(e,t){this.resolvedProperty[this.propertyIndex]=e[t]}_setValue_arrayElement_setNeedsUpdate(e,t){this.resolvedProperty[this.propertyIndex]=e[t],this.targetObject.needsUpdate=!0}_setValue_arrayElement_setMatrixWorldNeedsUpdate(e,t){this.resolvedProperty[this.propertyIndex]=e[t],this.targetObject.matrixWorldNeedsUpdate=!0}_setValue_fromArray(e,t){this.resolvedProperty.fromArray(e,t)}_setValue_fromArray_setNeedsUpdate(e,t){this.resolvedProperty.fromArray(e,t),this.targetObject.needsUpdate=!0}_setValue_fromArray_setMatrixWorldNeedsUpdate(e,t){this.resolvedProperty.fromArray(e,t),this.targetObject.matrixWorldNeedsUpdate=!0}_getValue_unbound(e,t){this.bind(),this.getValue(e,t)}_setValue_unbound(e,t){this.bind(),this.setValue(e,t)}bind(){let e=this.node;const t=this.parsedPath,n=t.objectName,r=t.propertyName;let i=t.propertyIndex;if(e||(e=$m.findNode(this.rootNode,t.nodeName),this.node=e),this.getValue=this._getValue_unavailable,this.setValue=this._setValue_unavailable,!e)return void console.error("THREE.PropertyBinding: Trying to update node for track: "+this.path+" but it wasn't found.");if(n){let r=t.objectIndex;switch(n){case"materials":if(!e.material)return void console.error("THREE.PropertyBinding: Can not bind to material as node does not have a material.",this);if(!e.material.materials)return void console.error("THREE.PropertyBinding: Can not bind to material.materials as node.material does not have a materials array.",this);e=e.material.materials;break;case"bones":if(!e.skeleton)return void console.error("THREE.PropertyBinding: Can not bind to bones as node does not have a skeleton.",this);e=e.skeleton.bones;for(let t=0;t<e.length;t++)if(e[t].name===r){r=t;break}break;case"map":if("map"in e){e=e.map;break}if(!e.material)return void console.error("THREE.PropertyBinding: Can not bind to material as node does not have a material.",this);if(!e.material.map)return void console.error("THREE.PropertyBinding: Can not bind to material.map as node.material does not have a map.",this);e=e.material.map;break;default:if(void 0===e[n])return void console.error("THREE.PropertyBinding: Can not bind to objectName of node undefined.",this);e=e[n]}if(void 0!==r){if(void 0===e[r])return void console.error("THREE.PropertyBinding: Trying to bind to objectIndex of objectName, but is undefined.",this,e);e=e[r]}}const a=e[r];if(void 0===a){const n=t.nodeName;return void console.error("THREE.PropertyBinding: Trying to update property for track: "+n+"."+r+" but it wasn't found.",e)}let o=this.Versioning.None;this.targetObject=e,void 0!==e.needsUpdate?o=this.Versioning.NeedsUpdate:void 0!==e.matrixWorldNeedsUpdate&&(o=this.Versioning.MatrixWorldNeedsUpdate);let s=this.BindingType.Direct;if(void 0!==i){if("morphTargetInfluences"===r){if(!e.geometry)return void console.error("THREE.PropertyBinding: Can not bind to morphTargetInfluences because node does not have a geometry.",this);if(!e.geometry.morphAttributes)return void console.error("THREE.PropertyBinding: Can not bind to morphTargetInfluences because node does not have a geometry.morphAttributes.",this);void 0!==e.morphTargetDictionary[i]&&(i=e.morphTargetDictionary[i])}s=this.BindingType.ArrayElement,this.resolvedProperty=a,this.propertyIndex=i}else void 0!==a.fromArray&&void 0!==a.toArray?(s=this.BindingType.HasFromToArray,this.resolvedProperty=a):Array.isArray(a)?(s=this.BindingType.EntireArray,this.resolvedProperty=a):this.propertyName=r;this.getValue=this.GetterByBindingType[s],this.setValue=this.SetterByBindingTypeAndVersioning[s][o]}unbind(){this.node=null,this.getValue=this._getValue_unbound,this.setValue=this._setValue_unbound}}$m.Composite=class{constructor(e,t,n){const r=n||$m.parseTrackName(t);this._targetGroup=e,this._bindings=e.subscribe_(t,r)}getValue(e,t){this.bind();const n=this._targetGroup.nCachedObjects_,r=this._bindings[n];void 0!==r&&r.getValue(e,t)}setValue(e,t){const n=this._bindings;for(let r=this._targetGroup.nCachedObjects_,i=n.length;r!==i;++r)n[r].setValue(e,t)}bind(){const e=this._bindings;for(let t=this._targetGroup.nCachedObjects_,n=e.length;t!==n;++t)e[t].bind()}unbind(){const e=this._bindings;for(let t=this._targetGroup.nCachedObjects_,n=e.length;t!==n;++t)e[t].unbind()}},$m.prototype.BindingType={Direct:0,EntireArray:1,ArrayElement:2,HasFromToArray:3},$m.prototype.Versioning={None:0,NeedsUpdate:1,MatrixWorldNeedsUpdate:2},$m.prototype.GetterByBindingType=[$m.prototype._getValue_direct,$m.prototype._getValue_array,$m.prototype._getValue_arrayElement,$m.prototype._getValue_toArray],$m.prototype.SetterByBindingTypeAndVersioning=[[$m.prototype._setValue_direct,$m.prototype._setValue_direct_setNeedsUpdate,$m.prototype._setValue_direct_setMatrixWorldNeedsUpdate],[$m.prototype._setValue_array,$m.prototype._setValue_array_setNeedsUpdate,$m.prototype._setValue_array_setMatrixWorldNeedsUpdate],[$m.prototype._setValue_arrayElement,$m.prototype._setValue_arrayElement_setNeedsUpdate,$m.prototype._setValue_arrayElement_setMatrixWorldNeedsUpdate],[$m.prototype._setValue_fromArray,$m.prototype._setValue_fromArray_setNeedsUpdate,$m.prototype._setValue_fromArray_setMatrixWorldNeedsUpdate]],new Float32Array(1),"undefined"!=typeof __THREE_DEVTOOLS__&&__THREE_DEVTOOLS__.dispatchEvent(new CustomEvent("register",{detail:{revision:vc}})),"undefined"!=typeof window&&(window.__THREE__?console.warn("WARNING: Multiple instances of Three.js being imported."):window.__THREE__=vc);const Wm=/^[og]\s*(.+)?/,jm=/^mtllib /,Xm=/^usemtl /,Ym=/^usemap /,qm=/\s+/,Km=new Jl,Zm=new Jl,Jm=new Jl,Qm=new Jl,ev=new Jl,tv=new bd;function nv(){const e={objects:[],object:{},vertices:[],normals:[],colors:[],uvs:[],materials:{},materialLibraries:[],startObject:function(e,t){if(this.object&&!1===this.object.fromDeclaration)return this.object.name=e,void(this.object.fromDeclaration=!1!==t);const n=this.object&&"function"==typeof this.object.currentMaterial?this.object.currentMaterial():void 0;if(this.object&&"function"==typeof this.object._finalize&&this.object._finalize(!0),this.object={name:e||"",fromDeclaration:!1!==t,geometry:{vertices:[],normals:[],colors:[],uvs:[],hasUVIndices:!1},materials:[],smooth:!0,startMaterial:function(e,t){const n=this._finalize(!1);n&&(n.inherited||n.groupCount<=0)&&this.materials.splice(n.index,1);const r={index:this.materials.length,name:e||"",mtllib:Array.isArray(t)&&t.length>0?t[t.length-1]:"",smooth:void 0!==n?n.smooth:this.smooth,groupStart:void 0!==n?n.groupEnd:0,groupEnd:-1,groupCount:-1,inherited:!1,clone:function(e){const t={index:"number"==typeof e?e:this.index,name:this.name,mtllib:this.mtllib,smooth:this.smooth,groupStart:0,groupEnd:-1,groupCount:-1,inherited:!1};return t.clone=this.clone.bind(t),t}};return this.materials.push(r),r},currentMaterial:function(){if(this.materials.length>0)return this.materials[this.materials.length-1]},_finalize:function(e){const t=this.currentMaterial();if(t&&-1===t.groupEnd&&(t.groupEnd=this.geometry.vertices.length/3,t.groupCount=t.groupEnd-t.groupStart,t.inherited=!1),e&&this.materials.length>1)for(let e=this.materials.length-1;e>=0;e--)this.materials[e].groupCount<=0&&this.materials.splice(e,1);return e&&0===this.materials.length&&this.materials.push({name:"",smooth:this.smooth}),t}},n&&n.name&&"function"==typeof n.clone){const e=n.clone(0);e.inherited=!0,this.object.materials.push(e)}this.objects.push(this.object)},finalize:function(){this.object&&"function"==typeof this.object._finalize&&this.object._finalize(!0)},parseVertexIndex:function(e,t){const n=parseInt(e,10);return 3*(n>=0?n-1:n+t/3)},parseNormalIndex:function(e,t){const n=parseInt(e,10);return 3*(n>=0?n-1:n+t/3)},parseUVIndex:function(e,t){const n=parseInt(e,10);return 2*(n>=0?n-1:n+t/2)},addVertex:function(e,t,n){const r=this.vertices,i=this.object.geometry.vertices;i.push(r[e+0],r[e+1],r[e+2]),i.push(r[t+0],r[t+1],r[t+2]),i.push(r[n+0],r[n+1],r[n+2])},addVertexPoint:function(e){const t=this.vertices;this.object.geometry.vertices.push(t[e+0],t[e+1],t[e+2])},addVertexLine:function(e){const t=this.vertices;this.object.geometry.vertices.push(t[e+0],t[e+1],t[e+2])},addNormal:function(e,t,n){const r=this.normals,i=this.object.geometry.normals;i.push(r[e+0],r[e+1],r[e+2]),i.push(r[t+0],r[t+1],r[t+2]),i.push(r[n+0],r[n+1],r[n+2])},addFaceNormal:function(e,t,n){const r=this.vertices,i=this.object.geometry.normals;Km.fromArray(r,e),Zm.fromArray(r,t),Jm.fromArray(r,n),ev.subVectors(Jm,Zm),Qm.subVectors(Km,Zm),ev.cross(Qm),ev.normalize(),i.push(ev.x,ev.y,ev.z),i.push(ev.x,ev.y,ev.z),i.push(ev.x,ev.y,ev.z)},addColor:function(e,t,n){const r=this.colors,i=this.object.geometry.colors;void 0!==r[e]&&i.push(r[e+0],r[e+1],r[e+2]),void 0!==r[t]&&i.push(r[t+0],r[t+1],r[t+2]),void 0!==r[n]&&i.push(r[n+0],r[n+1],r[n+2])},addUV:function(e,t,n){const r=this.uvs,i=this.object.geometry.uvs;i.push(r[e+0],r[e+1]),i.push(r[t+0],r[t+1]),i.push(r[n+0],r[n+1])},addDefaultUV:function(){const e=this.object.geometry.uvs;e.push(0,0),e.push(0,0),e.push(0,0)},addUVLine:function(e){const t=this.uvs;this.object.geometry.uvs.push(t[e+0],t[e+1])},addFace:function(e,t,n,r,i,a,o,s,c){const l=this.vertices.length;let u=this.parseVertexIndex(e,l),d=this.parseVertexIndex(t,l),f=this.parseVertexIndex(n,l);if(this.addVertex(u,d,f),this.addColor(u,d,f),void 0!==o&&""!==o){const e=this.normals.length;u=this.parseNormalIndex(o,e),d=this.parseNormalIndex(s,e),f=this.parseNormalIndex(c,e),this.addNormal(u,d,f)}else this.addFaceNormal(u,d,f);if(void 0!==r&&""!==r){const e=this.uvs.length;u=this.parseUVIndex(r,e),d=this.parseUVIndex(i,e),f=this.parseUVIndex(a,e),this.addUV(u,d,f),this.object.geometry.hasUVIndices=!0}else this.addDefaultUV()},addPointGeometry:function(e){this.object.geometry.type="Points";const t=this.vertices.length;for(let n=0,r=e.length;n<r;n++){const r=this.parseVertexIndex(e[n],t);this.addVertexPoint(r),this.addColor(r)}},addLineGeometry:function(e,t){this.object.geometry.type="Line";const n=this.vertices.length,r=this.uvs.length;for(let t=0,r=e.length;t<r;t++)this.addVertexLine(this.parseVertexIndex(e[t],n));for(let e=0,n=t.length;e<n;e++)this.addUVLine(this.parseUVIndex(t[e],r))}};return e.startObject("",!1),e}class rv extends Pm{constructor(e){super(e),this.materials=null}load(e,t,n,r){const i=this,a=new Um(this.manager);a.setPath(this.path),a.setRequestHeader(this.requestHeader),a.setWithCredentials(this.withCredentials),a.load(e,(function(n){try{t(i.parse(n))}catch(t){r?r(t):console.error(t),i.manager.itemError(e)}}),n,r)}setMaterials(e){return this.materials=e,this}parse(e){const t=new nv;-1!==e.indexOf("\r\n")&&(e=e.replace(/\r\n/g,"\n")),-1!==e.indexOf("\\\n")&&(e=e.replace(/\\\n/g,""));const n=e.split("\n");let r=[];for(let e=0,i=n.length;e<i;e++){const i=n[e].trimStart();if(0===i.length)continue;const a=i.charAt(0);if("#"!==a)if("v"===a){const e=i.split(qm);switch(e[0]){case"v":t.vertices.push(parseFloat(e[1]),parseFloat(e[2]),parseFloat(e[3])),e.length>=7?(tv.setRGB(parseFloat(e[4]),parseFloat(e[5]),parseFloat(e[6])).convertSRGBToLinear(),t.colors.push(tv.r,tv.g,tv.b)):t.colors.push(void 0,void 0,void 0);break;case"vn":t.normals.push(parseFloat(e[1]),parseFloat(e[2]),parseFloat(e[3]));break;case"vt":t.uvs.push(parseFloat(e[1]),parseFloat(e[2]))}}else if("f"===a){const e=i.slice(1).trim().split(qm),n=[];for(let t=0,r=e.length;t<r;t++){const r=e[t];if(r.length>0){const e=r.split("/");n.push(e)}}const r=n[0];for(let e=1,i=n.length-1;e<i;e++){const i=n[e],a=n[e+1];t.addFace(r[0],i[0],a[0],r[1],i[1],a[1],r[2],i[2],a[2])}}else if("l"===a){const e=i.substring(1).trim().split(" ");let n=[];const r=[];if(-1===i.indexOf("/"))n=e;else for(let t=0,i=e.length;t<i;t++){const i=e[t].split("/");""!==i[0]&&n.push(i[0]),""!==i[1]&&r.push(i[1])}t.addLineGeometry(n,r)}else if("p"===a){const e=i.slice(1).trim().split(" ");t.addPointGeometry(e)}else if(null!==(r=Wm.exec(i))){const e=(" "+r[0].slice(1).trim()).slice(1);t.startObject(e)}else if(Xm.test(i))t.object.startMaterial(i.substring(7).trim(),t.materialLibraries);else if(jm.test(i))t.materialLibraries.push(i.substring(7).trim());else if(Ym.test(i))console.warn('THREE.OBJLoader: Rendering identifier "usemap" not supported. Textures must be defined in MTL files.');else if("s"===a){if(r=i.split(" "),r.length>1){const e=r[1].trim().toLowerCase();t.object.smooth="0"!==e&&"off"!==e}else t.object.smooth=!0;const e=t.object.currentMaterial();e&&(e.smooth=t.object.smooth)}else{if("\0"===i)continue;console.warn('THREE.OBJLoader: Unexpected line: "'+i+'"')}}t.finalize();const i=new $p;if(i.materialLibraries=[].concat(t.materialLibraries),!0==!(1===t.objects.length&&0===t.objects[0].geometry.vertices.length))for(let e=0,n=t.objects.length;e<n;e++){const n=t.objects[e],r=n.geometry,a=n.materials,o="Line"===r.type,s="Points"===r.type;let c=!1;if(0===r.vertices.length)continue;const l=new Pd;l.setAttribute("position",new Sd(r.vertices,3)),r.normals.length>0&&l.setAttribute("normal",new Sd(r.normals,3)),r.colors.length>0&&(c=!0,l.setAttribute("color",new Sd(r.colors,3))),!0===r.hasUVIndices&&l.setAttribute("uv",new Sd(r.uvs,2));const u=[];for(let e=0,n=a.length;e<n;e++){const n=a[e],r=n.name+"_"+n.smooth+"_"+c;let i=t.materials[r];if(null!==this.materials)if(i=this.materials.create(n.name),!o||!i||i instanceof em){if(s&&i&&!(i instanceof um)){const e=new um({size:10,sizeAttenuation:!1});hd.prototype.copy.call(e,i),e.color.copy(i.color),e.map=i.map,i=e}}else{const e=new em;hd.prototype.copy.call(e,i),e.color.copy(i.color),i=e}void 0===i&&(i=o?new em:s?new um({size:1,sizeAttenuation:!1}):new gm,i.name=n.name,i.flatShading=!n.smooth,i.vertexColors=c,t.materials[r]=i),u.push(i)}let d;if(u.length>1){for(let e=0,t=a.length;e<t;e++){const t=a[e];l.addGroup(t.groupStart,t.groupCount,e)}d=o?new lm(l,u):s?new mm(l,u):new Jd(l,u)}else d=o?new lm(l,u[0]):s?new mm(l,u[0]):new Jd(l,u[0]);d.name=n.name,i.add(d)}else if(t.vertices.length>0){const e=new um({size:1,sizeAttenuation:!1}),n=new Pd;n.setAttribute("position",new Sd(t.vertices,3)),t.colors.length>0&&void 0!==t.colors[0]&&(n.setAttribute("color",new Sd(t.colors,3)),e.vertexColors=!0);const r=new mm(n,e);i.add(r)}return i}}class iv extends Pm{constructor(e){super(e)}load(e,t,n,r){const i=this,a=new Um(this.manager);a.setPath(this.path),a.setResponseType("arraybuffer"),a.setRequestHeader(this.requestHeader),a.setWithCredentials(this.withCredentials),a.load(e,(function(n){try{t(i.parse(n))}catch(t){r?r(t):console.error(t),i.manager.itemError(e)}}),n,r)}parse(e){function t(e,t,n){for(let r=0,i=e.length;r<i;r++)if(e[r]!==t.getUint8(n+r))return!1;return!0}const n=function(e){if("string"==typeof e){const t=new Uint8Array(e.length);for(let n=0;n<e.length;n++)t[n]=255&e.charCodeAt(n);return t.buffer||t}return e}(e);return function(e){const n=new DataView(e);if(84+50*n.getUint32(80,!0)===n.byteLength)return!0;const r=[115,111,108,105,100];for(let e=0;e<5;e++)if(t(r,n,e))return!1;return!0}(n)?function(e){const t=new DataView(e),n=t.getUint32(80,!0);let r,i,a,o,s,c,l,u,d=!1;for(let e=0;e<70;e++)1129270351==t.getUint32(e,!1)&&82==t.getUint8(e+4)&&61==t.getUint8(e+5)&&(d=!0,o=new Float32Array(3*n*3),s=t.getUint8(e+6)/255,c=t.getUint8(e+7)/255,l=t.getUint8(e+8)/255,u=t.getUint8(e+9)/255);const f=new Pd,h=new Float32Array(3*n*3),p=new Float32Array(3*n*3),m=new bd;for(let e=0;e<n;e++){const n=84+50*e,u=t.getFloat32(n,!0),f=t.getFloat32(n+4,!0),v=t.getFloat32(n+8,!0);if(d){const e=t.getUint16(n+48,!0);0==(32768&e)?(r=(31&e)/31,i=(e>>5&31)/31,a=(e>>10&31)/31):(r=s,i=c,a=l)}for(let s=1;s<=3;s++){const c=n+12*s,l=3*e*3+3*(s-1);h[l]=t.getFloat32(c,!0),h[l+1]=t.getFloat32(c+4,!0),h[l+2]=t.getFloat32(c+8,!0),p[l]=u,p[l+1]=f,p[l+2]=v,d&&(m.set(r,i,a).convertSRGBToLinear(),o[l]=m.r,o[l+1]=m.g,o[l+2]=m.b)}}return f.setAttribute("position",new wd(h,3)),f.setAttribute("normal",new wd(p,3)),d&&(f.setAttribute("color",new wd(o,3)),f.hasColors=!0,f.alpha=u),f}(n):function(e){const t=new Pd,n=/solid([\s\S]*?)endsolid/g,r=/facet([\s\S]*?)endfacet/g;let i=0;const a=/[\s]+([+-]?(?:\d*)(?:\.\d*)?(?:[eE][+-]?\d+)?)/.source,o=new RegExp("vertex"+a+a+a,"g"),s=new RegExp("normal"+a+a+a,"g"),c=[],l=[],u=new Jl;let d,f=0,h=0,p=0;for(;null!==(d=n.exec(e));){h=p;const e=d[0];for(;null!==(d=r.exec(e));){let e=0,t=0;const n=d[0];for(;null!==(d=s.exec(n));)u.x=parseFloat(d[1]),u.y=parseFloat(d[2]),u.z=parseFloat(d[3]),t++;for(;null!==(d=o.exec(n));)c.push(parseFloat(d[1]),parseFloat(d[2]),parseFloat(d[3])),l.push(u.x,u.y,u.z),e++,p++;1!==t&&console.error("THREE.STLLoader: Something isn't right with the normal of face number "+i),3!==e&&console.error("THREE.STLLoader: Something isn't right with the vertices of face number "+i),i++}const n=h,a=p-h;t.addGroup(n,a,f),f++}return t.setAttribute("position",new Sd(c,3)),t.setAttribute("normal",new Sd(l,3)),t}("string"!=typeof(r=e)?(new TextDecoder).decode(r):r);var r}}class av extends Pm{load(e,t,n,r){const i=this,a=new Um(this.manager);a.setPath(this.path),a.setRequestHeader(this.requestHeader),a.setWithCredentials(this.withCredentials),a.load(e,(function(n){try{t(i.parse(n))}catch(t){r?r(t):console.error(t),i.manager.itemError(e)}}),n,r)}parse(e){const t=e.split("\n"),n=[],r=[],i=new bd;for(let e of t){if(e=e.trim(),"#"===e.charAt(0))continue;const t=e.split(/\s+/);if(3===t.length&&(n.push(parseFloat(t[0])),n.push(parseFloat(t[1])),n.push(parseFloat(t[2]))),6===t.length){n.push(parseFloat(t[0])),n.push(parseFloat(t[1])),n.push(parseFloat(t[2]));const e=parseFloat(t[3])/255,a=parseFloat(t[4])/255,o=parseFloat(t[5])/255;i.set(e,a,o).convertSRGBToLinear(),r.push(i.r,i.g,i.b)}}const a=new Pd;return a.setAttribute("position",new Sd(n,3)),r.length>0&&a.setAttribute("color",new Sd(r,3)),a}}const ov={type:"change"},sv={type:"start"},cv={type:"end"};class lv extends fl{constructor(e,t){super();const n=this,r=-1;this.object=e,this.domElement=t,this.domElement.style.touchAction="none",this.enabled=!0,this.screen={left:0,top:0,width:0,height:0},this.rotateSpeed=1,this.zoomSpeed=1.2,this.panSpeed=.3,this.noRotate=!1,this.noZoom=!1,this.noPan=!1,this.staticMoving=!1,this.dynamicDampingFactor=.2,this.minDistance=0,this.maxDistance=1/0,this.minZoom=0,this.maxZoom=1/0,this.keys=["KeyA","KeyS","KeyD"],this.mouseButtons={LEFT:0,MIDDLE:1,RIGHT:2},this.target=new Jl;const i=1e-6,a=new Jl;let o=1,s=r,c=r,l=0,u=0,d=0;const f=new Jl,h=new Sl,p=new Sl,m=new Jl,v=new Sl,g=new Sl,b=new Sl,_=new Sl,y=[],x={};this.target0=this.target.clone(),this.position0=this.object.position.clone(),this.up0=this.object.up.clone(),this.zoom0=this.object.zoom,this.handleResize=function(){const e=n.domElement.getBoundingClientRect(),t=n.domElement.ownerDocument.documentElement;n.screen.left=e.left+window.pageXOffset-t.clientLeft,n.screen.top=e.top+window.pageYOffset-t.clientTop,n.screen.width=e.width,n.screen.height=e.height};const A=function(){const e=new Sl;return function(t,r){return e.set((t-n.screen.left)/n.screen.width,(r-n.screen.top)/n.screen.height),e}}(),w=function(){const e=new Sl;return function(t,r){return e.set((t-.5*n.screen.width-n.screen.left)/(.5*n.screen.width),(n.screen.height+2*(n.screen.top-r))/n.screen.width),e}}();function E(e){!1!==n.enabled&&(0===y.length&&(n.domElement.setPointerCapture(e.pointerId),n.domElement.addEventListener("pointermove",T),n.domElement.addEventListener("pointerup",S)),function(e){y.push(e)}(e),"touch"===e.pointerType?function(e){if(1===(I(e),y.length))s=3,p.copy(w(y[0].pageX,y[0].pageY)),h.copy(p);else{s=4;const e=y[0].pageX-y[1].pageX,t=y[0].pageY-y[1].pageY;u=l=Math.sqrt(e*e+t*t);const n=(y[0].pageX+y[1].pageX)/2,r=(y[0].pageY+y[1].pageY)/2;b.copy(A(n,r)),_.copy(b)}n.dispatchEvent(sv)}(e):function(e){if(s===r)switch(e.button){case n.mouseButtons.LEFT:s=0;break;case n.mouseButtons.MIDDLE:s=1;break;case n.mouseButtons.RIGHT:s=2}const t=c!==r?c:s;0!==t||n.noRotate?1!==t||n.noZoom?2!==t||n.noPan||(b.copy(A(e.pageX,e.pageY)),_.copy(b)):(v.copy(A(e.pageX,e.pageY)),g.copy(v)):(p.copy(w(e.pageX,e.pageY)),h.copy(p)),n.dispatchEvent(sv)}(e))}function T(e){!1!==n.enabled&&("touch"===e.pointerType?function(e){if(1===(I(e),y.length))h.copy(p),p.copy(w(e.pageX,e.pageY));else{const t=function(e){const t=e.pointerId===y[0].pointerId?y[1]:y[0];return x[t.pointerId]}(e),n=e.pageX-t.x,r=e.pageY-t.y;u=Math.sqrt(n*n+r*r);const i=(e.pageX+t.x)/2,a=(e.pageY+t.y)/2;_.copy(A(i,a))}}(e):function(e){const t=c!==r?c:s;0!==t||n.noRotate?1!==t||n.noZoom?2!==t||n.noPan||_.copy(A(e.pageX,e.pageY)):g.copy(A(e.pageX,e.pageY)):(h.copy(p),p.copy(w(e.pageX,e.pageY)))}(e))}function S(e){!1!==n.enabled&&("touch"===e.pointerType?function(e){switch(y.length){case 0:s=r;break;case 1:s=3,p.copy(w(e.pageX,e.pageY)),h.copy(p);break;case 2:s=4;for(let t=0;t<y.length;t++)if(y[t].pointerId!==e.pointerId){const e=x[y[t].pointerId];p.copy(w(e.x,e.y)),h.copy(p);break}}n.dispatchEvent(cv)}(e):(s=r,n.dispatchEvent(cv)),O(e),0===y.length&&(n.domElement.releasePointerCapture(e.pointerId),n.domElement.removeEventListener("pointermove",T),n.domElement.removeEventListener("pointerup",S)))}function C(e){O(e)}function M(e){!1!==n.enabled&&(window.removeEventListener("keydown",M),c===r&&(e.code!==n.keys[0]||n.noRotate?e.code!==n.keys[1]||n.noZoom?e.code!==n.keys[2]||n.noPan||(c=2):c=1:c=0))}function k(){!1!==n.enabled&&(c=r,window.addEventListener("keydown",M))}function R(e){if(!1!==n.enabled&&!0!==n.noZoom){switch(e.preventDefault(),e.deltaMode){case 2:v.y-=.025*e.deltaY;break;case 1:v.y-=.01*e.deltaY;break;default:v.y-=25e-5*e.deltaY}n.dispatchEvent(sv),n.dispatchEvent(cv)}}function L(e){!1!==n.enabled&&e.preventDefault()}function O(e){delete x[e.pointerId];for(let t=0;t<y.length;t++)if(y[t].pointerId==e.pointerId)return void y.splice(t,1)}function I(e){let t=x[e.pointerId];void 0===t&&(t=new Sl,x[e.pointerId]=t),t.set(e.pageX,e.pageY)}this.rotateCamera=function(){const e=new Jl,t=new Zl,r=new Jl,i=new Jl,a=new Jl,o=new Jl;return function(){o.set(p.x-h.x,p.y-h.y,0);let s=o.length();s?(f.copy(n.object.position).sub(n.target),r.copy(f).normalize(),i.copy(n.object.up).normalize(),a.crossVectors(i,r).normalize(),i.setLength(p.y-h.y),a.setLength(p.x-h.x),o.copy(i.add(a)),e.crossVectors(o,f).normalize(),s*=n.rotateSpeed,t.setFromAxisAngle(e,s),f.applyQuaternion(t),n.object.up.applyQuaternion(t),m.copy(e),d=s):!n.staticMoving&&d&&(d*=Math.sqrt(1-n.dynamicDampingFactor),f.copy(n.object.position).sub(n.target),t.setFromAxisAngle(m,d),f.applyQuaternion(t),n.object.up.applyQuaternion(t)),h.copy(p)}}(),this.zoomCamera=function(){let e;4===s?(e=l/u,l=u,n.object.isPerspectiveCamera?f.multiplyScalar(e):n.object.isOrthographicCamera?(n.object.zoom=Tl.clamp(n.object.zoom/e,n.minZoom,n.maxZoom),o!==n.object.zoom&&n.object.updateProjectionMatrix()):console.warn("THREE.TrackballControls: Unsupported camera type")):(e=1+(g.y-v.y)*n.zoomSpeed,1!==e&&e>0&&(n.object.isPerspectiveCamera?f.multiplyScalar(e):n.object.isOrthographicCamera?(n.object.zoom=Tl.clamp(n.object.zoom/e,n.minZoom,n.maxZoom),o!==n.object.zoom&&n.object.updateProjectionMatrix()):console.warn("THREE.TrackballControls: Unsupported camera type")),n.staticMoving?v.copy(g):v.y+=(g.y-v.y)*this.dynamicDampingFactor)},this.panCamera=function(){const e=new Sl,t=new Jl,r=new Jl;return function(){if(e.copy(_).sub(b),e.lengthSq()){if(n.object.isOrthographicCamera){const t=(n.object.right-n.object.left)/n.object.zoom/n.domElement.clientWidth,r=(n.object.top-n.object.bottom)/n.object.zoom/n.domElement.clientWidth;e.x*=t,e.y*=r}e.multiplyScalar(f.length()*n.panSpeed),r.copy(f).cross(n.object.up).setLength(e.x),r.add(t.copy(n.object.up).setLength(e.y)),n.object.position.add(r),n.target.add(r),n.staticMoving?b.copy(_):b.add(e.subVectors(_,b).multiplyScalar(n.dynamicDampingFactor))}}}(),this.checkDistances=function(){n.noZoom&&n.noPan||(f.lengthSq()>n.maxDistance*n.maxDistance&&(n.object.position.addVectors(n.target,f.setLength(n.maxDistance)),v.copy(g)),f.lengthSq()<n.minDistance*n.minDistance&&(n.object.position.addVectors(n.target,f.setLength(n.minDistance)),v.copy(g)))},this.update=function(){f.subVectors(n.object.position,n.target),n.noRotate||n.rotateCamera(),n.noZoom||n.zoomCamera(),n.noPan||n.panCamera(),n.object.position.addVectors(n.target,f),n.object.isPerspectiveCamera?(n.checkDistances(),n.object.lookAt(n.target),a.distanceToSquared(n.object.position)>i&&(n.dispatchEvent(ov),a.copy(n.object.position))):n.object.isOrthographicCamera?(n.object.lookAt(n.target),(a.distanceToSquared(n.object.position)>i||o!==n.object.zoom)&&(n.dispatchEvent(ov),a.copy(n.object.position),o=n.object.zoom)):console.warn("THREE.TrackballControls: Unsupported camera type")},this.reset=function(){s=r,c=r,n.target.copy(n.target0),n.object.position.copy(n.position0),n.object.up.copy(n.up0),n.object.zoom=n.zoom0,n.object.updateProjectionMatrix(),f.subVectors(n.object.position,n.target),n.object.lookAt(n.target),n.dispatchEvent(ov),a.copy(n.object.position),o=n.object.zoom},this.dispose=function(){n.domElement.removeEventListener("contextmenu",L),n.domElement.removeEventListener("pointerdown",E),n.domElement.removeEventListener("pointercancel",C),n.domElement.removeEventListener("wheel",R),n.domElement.removeEventListener("pointermove",T),n.domElement.removeEventListener("pointerup",S),window.removeEventListener("keydown",M),window.removeEventListener("keyup",k)},this.domElement.addEventListener("contextmenu",L),this.domElement.addEventListener("pointerdown",E),this.domElement.addEventListener("pointercancel",C),this.domElement.addEventListener("wheel",R,{passive:!1}),window.addEventListener("keydown",M),window.addEventListener("keyup",k),this.handleResize(),this.update()}}var uv=class{static isWebGLAvailable(){try{const e=document.createElement("canvas");return!(!window.WebGLRenderingContext||!e.getContext("webgl")&&!e.getContext("experimental-webgl"))}catch(e){return!1}}static isWebGL2Available(){try{const e=document.createElement("canvas");return!(!window.WebGL2RenderingContext||!e.getContext("webgl2"))}catch(e){return!1}}static getWebGLErrorMessage(){return this.getErrorMessage(1)}static getWebGL2ErrorMessage(){return this.getErrorMessage(2)}static getErrorMessage(e){const t={1:window.WebGLRenderingContext,2:window.WebGL2RenderingContext};let n='Your $0 does not seem to support <a href="http://khronos.org/webgl/wiki/Getting_a_WebGL_Implementation" style="color:#000">$1</a>';const r=document.createElement("div");return r.id="webglmessage",r.style.fontFamily="monospace",r.style.fontSize="13px",r.style.fontWeight="normal",r.style.textAlign="center",r.style.background="#fff",r.style.color="#000",r.style.padding="1.5em",r.style.width="400px",r.style.margin="5em auto 0",n=t[e]?n.replace("$0","graphics card"):n.replace("$0","browser"),n=n.replace("$1",{1:"WebGL",2:"WebGL 2"}[e]),r.innerHTML=n,r}},dv={data(){return{loaders:{obj:rv,stl:iv,xyz:av},renderer:null,scene:null,camera:null,controls:null,material:null,distance:0,loading:!0,error:"",forceLoad:!1}},props:{type:String,modelUrl:String,fileSize:Number,maxFileSize:Number},methods:{resetView(){this.controls.reset(),this.camera.position.set(0,0,this.distance),this.camera.updateProjectionMatrix()},toggleWireframe(){this.material.wireframe=!this.material.wireframe},toggleFullscreen(){kadi.utils.toggleFullscreen(this.$refs.container)},resizeView(){const e=this.$refs.renderContainer.getBoundingClientRect().width,t=Math.round(window.innerHeight/window.innerWidth*e);kadi.utils.isFullscreen()?(this.$refs.renderContainer.style.height="100vh",this.$refs.container.style.borderRadius="0"):(this.$refs.renderContainer.style.height=`${t}px`,this.$refs.container.style.borderRadius="0.25rem"),this.camera.aspect=e/t,this.camera.updateProjectionMatrix(),this.renderer.setSize(e,t)},animate(){window.requestAnimationFrame(this.animate),this.renderer.render(this.scene,this.camera),this.controls.update()},onLoad(e){this.loading=!1,this.renderer=new Jp({antialias:!0}),this.renderer.setPixelRatio(window.devicePixelRatio),this.$refs.renderContainer.appendChild(this.renderer.domElement),this.scene=new Qp,this.scene.background=new bd(16250871),this.camera=new cf,this.scene.add(this.camera),this.controls=new lv(this.camera,this.renderer.domElement),this.controls.rotateSpeed=2;let t=null;switch(this.type){case"obj":this.material=new bm,t=e,t.traverse((e=>{e instanceof Jd&&(e.material=this.material)}));break;case"stl":this.material=new bm,t=new Jd(e,this.material),t.geometry.center();break;case"xyz":t=new mm(e,new um({size:.1,color:0}));break;default:return}this.scene.add(t);const n=(new tu).setFromObject(t),r=n.getSize(new Jl).length(),i=this.camera.fov/2*(Math.PI/180);this.distance=r/2/Math.tan(i),this.distance-this.camera.far>n.max.z&&(this.distance=this.camera.far+n.max.z-n.max.z/10),this.resizeView(),this.resetView(),this.animate(),window.addEventListener("resize",this.resizeView)},onError(e){this.loading=!1,this.error=$t("Error loading model."),console.error(e)},async loadFile(){this.forceLoad=!0,await this.$nextTick(),(new this.loaders[this.type]).load(this.modelUrl,this.onLoad,null,this.onError)}},mounted(){this.type in this.loaders?uv.isWebGLAvailable()?this.fileSize<=this.maxFileSize&&this.loadFile():this.error=$t("WebGL not available."):this.error="Invalid object type."},beforeDestroy(){window.removeEventListener("resize",this.resizeView)}},fv=dv,hv=(n(2823),hc(fv,mc,[],!1,null,"6285d09a",null).exports),pv=function(){var e=this,t=e._self._c;return t("div",{ref:"container"},[e.toolsEndpoint?t("div",[e.toolDialogActive?t("div",{staticClass:"modal-backdrop show"}):e._e(),e._v(" "),t("div",{ref:"toolDialog",staticClass:"modal",attrs:{tabindex:"-1"}},[t("div",{staticClass:"modal-dialog modal-dialog-centered modal-lg"},[t("div",{staticClass:"modal-content"},[t("div",{staticClass:"modal-body"},[t("dynamic-pagination",{attrs:{placeholder:"No tools.","filter-placeholder":"Filter by filename or record identifier",endpoint:e.toolsEndpoint,"per-page":5,"enable-filter":!0},scopedSlots:e._u([{key:"default",fn:function(n){return[t("div",{staticClass:"d-flex justify-content-between mb-4"},[t("div",[t("strong",[e._v("Tools")]),e._v(" "),t("span",{staticClass:"badge badge-pill badge-light text-muted border border-muted"},[e._v(e._s(n.total))])]),e._v(" "),t("button",{staticClass:"close",attrs:{type:"button","data-dismiss":"modal"}},[t("i",{staticClass:"fa-solid fa-xmark fa-xs"})])]),e._v(" "),n.total>0?t("ul",{staticClass:"list-group"},[t("li",{staticClass:"list-group-item bg-light py-2"},[t("div",{staticClass:"row"},[t("div",{staticClass:"col-lg-5"},[e._v("File")]),e._v(" "),t("div",{staticClass:"col-lg-5"},[e._v("Tool")])])]),e._v(" "),e._l(n.items,(function(n){return t("li",{key:n.id,staticClass:"list-group-item py-2"},[t("div",{staticClass:"row align-items-center"},[t("div",{staticClass:"col-lg-5 mb-2 mb-lg-0"},[t("strong",[e._v(e._s(n.file))]),e._v(" "),t("br"),e._v("\n                        @"+e._s(n.record)+"\n                      ")]),e._v(" "),t("div",{staticClass:"col-lg-5 mb-2 mb-lg-0"},[n.tool?t("div",[t("strong",[e._v(e._s(n.tool.name))]),e._v(" "),t("small",[e._v("["+e._s(n.tool.type)+"]")]),e._v(" "),n.tool.version?t("span",[t("br"),e._v("\n                            Version "+e._s(n.tool.version)+"\n                          ")]):e._e()]):t("div",[t("em",{staticClass:"text-muted"},[e._v("Invalid tool description.")])])]),e._v(" "),t("div",{staticClass:"col-lg-2 d-lg-flex justify-content-end"},[t("div",[t("button",{staticClass:"btn btn-light btn-sm",attrs:{type:"button",disabled:!n.tool},on:{click:function(t){return e.addTool(n.tool)}}},[t("i",{staticClass:"fa-solid fa-plus"})])])])])])}))],2):e._e()]}}],null,!1,2125371247)})],1)])])])]):e._e(),e._v(" "),t("div",{ref:"editorContainer",staticClass:"card editor-container",class:{"bg-light":!e.editable}},[t("div",{ref:"editorToolbar",staticClass:"editor-toolbar mt-1 mr-1"},[t("button",{class:e.toolbarBtnClasses,attrs:{type:"button",title:"Reset view"},on:{click:e.resetView}},[t("i",{staticClass:"fa-solid fa-eye"})]),e._v(" "),t("button",{class:e.toolbarBtnClasses,attrs:{type:"button",title:"Toggle fullscreen"},on:{click:e.toggleFullscreen}},[t("i",{staticClass:"fa-solid fa-expand"})]),e._v(" "),e.editable?t("button",{class:e.toolbarBtnClasses,attrs:{type:"button",title:"Reset editor"},on:{click:e.resetEditor}},[t("i",{staticClass:"fa-solid fa-broom"})]):e._e()]),e._v(" "),t("div",{ref:"editor"})]),e._v(" "),e._t("default",null,{editor:e.editor})],2)};function mv(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function vv(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function gv(e,t,n){return t&&vv(e.prototype,t),n&&vv(e,n),e}function bv(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=[],r=!0,i=!1,a=void 0;try{for(var o,s=e[Symbol.iterator]();!(r=(o=s.next()).done)&&(n.push(o.value),!t||n.length!==t);r=!0);}catch(e){i=!0,a=e}finally{try{r||null==s.return||s.return()}finally{if(i)throw a}}return n}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance")}()}function _v(e){return function(e){if(Array.isArray(e)){for(var t=0,n=new Array(e.length);t<e.length;t++)n[t]=e[t];return n}}(e)||function(e){if(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e))return Array.from(e)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}()}pv._withStripped=!0,n(5666),function(e){if(e&&"undefined"!=typeof window){var t=document.createElement("style");t.setAttribute("type","text/css"),t.innerHTML=e,document.head.appendChild(t)}}(".rete-background {\n  display: table;\n  z-index: -1;\n  position: absolute;\n  top: -320000px;\n  left: -320000px;\n  width: 640000px;\n  height: 640000px;\n}\n.rete-background.default {\n  background-size: 32px 32px;\n  background-image: linear-gradient(to right, #ccc 1px, transparent 1px), linear-gradient(to bottom, #ccc 1px, transparent 1px);\n}");var yv=function e(t,n){if(mv(this,e),n){var r=n instanceof HTMLElement?n:document.createElement("div");r.classList+=" rete-background ".concat(!0===n?"default":""),t.view.area.appendChild(r)}},xv=function(){function e(t,n,r){mv(this,e),this.editor=t,this.scaleExtent=n,this.translateExtent=r,n&&t.on("zoom",this.restrictZoom.bind(this)),r&&t.on("translate",this.restrictTranslate.bind(this))}return gv(e,[{key:"restrictZoom",value:function(e){var t="boolean"==typeof this.scaleExtent?{min:.1,max:1}:this.scaleExtent;e.transform,e.zoom<t.min?e.zoom=t.min:e.zoom>t.max&&(e.zoom=t.max)}},{key:"restrictTranslate",value:function(e){var t="boolean"==typeof this.translateExtent?{width:5e3,height:4e3}:this.translateExtent,n=this.editor.view.container,r=e.transform.k,i=t.width*r,a=t.height*r,o=n.clientWidth/2,s=n.clientHeight/2;e.x-=o,e.y-=s,e.x>i?e.x=i:e.x<-i&&(e.x=-i),e.y>a?e.y=a:e.y<-a&&(e.y=-a),e.x+=o,e.y+=s}}]),e}(),Av=function(){function e(t,n){var r=this,i=n.size,a=void 0===i?16:i,o=n.dynamic,s=void 0===o||o;mv(this,e),this.editor=t,this.size=a,s?this.editor.on("nodetranslate",this.onTranslate.bind(this)):this.editor.on("rendernode",(function(e){var t=e.node,n=e.el;n.addEventListener("mouseup",r.onDrag.bind(r,t)),n.addEventListener("touchend",r.onDrag.bind(r,t)),n.addEventListener("touchcancel",r.onDrag.bind(r,t))}))}return gv(e,[{key:"onTranslate",value:function(e){var t=e.x,n=e.y;e.x=this.snap(t),e.y=this.snap(n)}},{key:"onDrag",value:function(e){var t=bv(e.position,2),n=t[0],r=t[1];e.position[0]=this.snap(n),e.position[1]=this.snap(r),console.log(this,n,r,e.position),this.editor.view.nodes.get(e).update(),this.editor.view.updateConnections({node:e})}},{key:"snap",value:function(e){return Math.round(e/this.size)*this.size}}]),e}(),wv=function(e){return 0===e.length?0:Math.min.apply(Math,_v(e))},Ev=function(e){return 0===e.length?0:Math.max.apply(Math,_v(e))},Tv={install:function(e,t){var n=t.background||!1,r=t.snap||!1,i=t.scaleExtent||!1,a=t.translateExtent||!1;n&&(this._background=new yv(e,n)),(i||a)&&(this._restrictor=new xv(e,i,a)),r&&(this._snap=new Av(e,r))},zoomAt:function(e){var t=function(e,t){var n=wv(t.map((function(e){return e.position[0]}))),r=wv(t.map((function(e){return e.position[1]}))),i=Ev(t.map((function(t){return t.position[0]+e.view.nodes.get(t).el.clientWidth}))),a=Ev(t.map((function(t){return t.position[1]+e.view.nodes.get(t).el.clientHeight})));return{left:n,right:i,top:r,bottom:a,width:Math.abs(n-i),height:Math.abs(r-a),getCenter:function(){return[(n+i)/2,(r+a)/2]}}}(e,arguments.length>1&&void 0!==arguments[1]?arguments[1]:e.nodes),n=bv(t.getCenter(),2),r=n[0],i=n[1],a=[e.view.container.clientWidth,e.view.container.clientHeight],o=a[0],s=a[1],c=e.view.area,l=o/t.width,u=s/t.height,d=Math.min(.9*u,.9*l,1);c.transform.x=c.container.clientWidth/2-r*d,c.transform.y=c.container.clientHeight/2-i*d,c.zoom(d,0,0),c.update()}},Sv=Tv;function Cv(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}function Mv(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{};t%2?Cv(Object(n),!0).forEach((function(t){Dv(e,t,n[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(n)):Cv(Object(n)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(n,t))}))}return e}function kv(){kv=function(){return e};var e={},t=Object.prototype,n=t.hasOwnProperty,r="function"==typeof Symbol?Symbol:{},i=r.iterator||"@@iterator",a=r.asyncIterator||"@@asyncIterator",o=r.toStringTag||"@@toStringTag";function s(e,t,n){return Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}),e[t]}try{s({},"")}catch(e){s=function(e,t,n){return e[t]=n}}function c(e,t,n,r){var i=t&&t.prototype instanceof d?t:d,a=Object.create(i.prototype),o=new w(r||[]);return a._invoke=function(e,t,n){var r="suspendedStart";return function(i,a){if("executing"===r)throw new Error("Generator is already running");if("completed"===r){if("throw"===i)throw a;return{value:void 0,done:!0}}for(n.method=i,n.arg=a;;){var o=n.delegate;if(o){var s=y(o,n);if(s){if(s===u)continue;return s}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if("suspendedStart"===r)throw r="completed",n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);r="executing";var c=l(e,t,n);if("normal"===c.type){if(r=n.done?"completed":"suspendedYield",c.arg===u)continue;return{value:c.arg,done:n.done}}"throw"===c.type&&(r="completed",n.method="throw",n.arg=c.arg)}}}(e,n,o),a}function l(e,t,n){try{return{type:"normal",arg:e.call(t,n)}}catch(e){return{type:"throw",arg:e}}}e.wrap=c;var u={};function d(){}function f(){}function h(){}var p={};s(p,i,(function(){return this}));var m=Object.getPrototypeOf,v=m&&m(m(E([])));v&&v!==t&&n.call(v,i)&&(p=v);var g=h.prototype=d.prototype=Object.create(p);function b(e){["next","throw","return"].forEach((function(t){s(e,t,(function(e){return this._invoke(t,e)}))}))}function _(e,t){function r(i,a,o,s){var c=l(e[i],e,a);if("throw"!==c.type){var u=c.arg,d=u.value;return d&&"object"==typeof d&&n.call(d,"__await")?t.resolve(d.__await).then((function(e){r("next",e,o,s)}),(function(e){r("throw",e,o,s)})):t.resolve(d).then((function(e){u.value=e,o(u)}),(function(e){return r("throw",e,o,s)}))}s(c.arg)}var i;this._invoke=function(e,n){function a(){return new t((function(t,i){r(e,n,t,i)}))}return i=i?i.then(a,a):a()}}function y(e,t){var n=e.iterator[t.method];if(void 0===n){if(t.delegate=null,"throw"===t.method){if(e.iterator.return&&(t.method="return",t.arg=void 0,y(e,t),"throw"===t.method))return u;t.method="throw",t.arg=new TypeError("The iterator does not provide a 'throw' method")}return u}var r=l(n,e.iterator,t.arg);if("throw"===r.type)return t.method="throw",t.arg=r.arg,t.delegate=null,u;var i=r.arg;return i?i.done?(t[e.resultName]=i.value,t.next=e.nextLoc,"return"!==t.method&&(t.method="next",t.arg=void 0),t.delegate=null,u):i:(t.method="throw",t.arg=new TypeError("iterator result is not an object"),t.delegate=null,u)}function x(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function A(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function w(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(x,this),this.reset(!0)}function E(e){if(e){var t=e[i];if(t)return t.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var r=-1,a=function t(){for(;++r<e.length;)if(n.call(e,r))return t.value=e[r],t.done=!1,t;return t.value=void 0,t.done=!0,t};return a.next=a}}return{next:T}}function T(){return{value:void 0,done:!0}}return f.prototype=h,s(g,"constructor",h),s(h,"constructor",f),f.displayName=s(h,o,"GeneratorFunction"),e.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===f||"GeneratorFunction"===(t.displayName||t.name))},e.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,h):(e.__proto__=h,s(e,o,"GeneratorFunction")),e.prototype=Object.create(g),e},e.awrap=function(e){return{__await:e}},b(_.prototype),s(_.prototype,a,(function(){return this})),e.AsyncIterator=_,e.async=function(t,n,r,i,a){void 0===a&&(a=Promise);var o=new _(c(t,n,r,i),a);return e.isGeneratorFunction(n)?o:o.next().then((function(e){return e.done?e.value:o.next()}))},b(g),s(g,o,"Generator"),s(g,i,(function(){return this})),s(g,"toString",(function(){return"[object Generator]"})),e.keys=function(e){var t=[];for(var n in e)t.push(n);return t.reverse(),function n(){for(;t.length;){var r=t.pop();if(r in e)return n.value=r,n.done=!1,n}return n.done=!0,n}},e.values=E,w.prototype={constructor:w,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,this.tryEntries.forEach(A),!e)for(var t in this)"t"===t.charAt(0)&&n.call(this,t)&&!isNaN(+t.slice(1))&&(this[t]=void 0)},stop:function(){this.done=!0;var e=this.tryEntries[0].completion;if("throw"===e.type)throw e.arg;return this.rval},dispatchException:function(e){if(this.done)throw e;var t=this;function r(n,r){return o.type="throw",o.arg=e,t.next=n,r&&(t.method="next",t.arg=void 0),!!r}for(var i=this.tryEntries.length-1;i>=0;--i){var a=this.tryEntries[i],o=a.completion;if("root"===a.tryLoc)return r("end");if(a.tryLoc<=this.prev){var s=n.call(a,"catchLoc"),c=n.call(a,"finallyLoc");if(s&&c){if(this.prev<a.catchLoc)return r(a.catchLoc,!0);if(this.prev<a.finallyLoc)return r(a.finallyLoc)}else if(s){if(this.prev<a.catchLoc)return r(a.catchLoc,!0)}else{if(!c)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return r(a.finallyLoc)}}}},abrupt:function(e,t){for(var r=this.tryEntries.length-1;r>=0;--r){var i=this.tryEntries[r];if(i.tryLoc<=this.prev&&n.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var a=i;break}}a&&("break"===e||"continue"===e)&&a.tryLoc<=t&&t<=a.finallyLoc&&(a=null);var o=a?a.completion:{};return o.type=e,o.arg=t,a?(this.method="next",this.next=a.finallyLoc,u):this.complete(o)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),u},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.finallyLoc===e)return this.complete(n.completion,n.afterLoc),A(n),u}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.tryLoc===e){var r=n.completion;if("throw"===r.type){var i=r.arg;A(n)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(e,t,n){return this.delegate={iterator:E(e),resultName:t,nextLoc:n},"next"===this.method&&(this.arg=void 0),u}},e}function Rv(e,t,n,r,i,a,o){try{var s=e[a](o),c=s.value}catch(e){return void n(e)}s.done?t(c):Promise.resolve(c).then(r,i)}function Lv(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var a=e.apply(t,n);function o(e){Rv(a,r,i,o,s,"next",e)}function s(e){Rv(a,r,i,o,s,"throw",e)}o(void 0)}))}}function Ov(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function Iv(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function Pv(e,t,n){return t&&Iv(e.prototype,t),n&&Iv(e,n),Object.defineProperty(e,"prototype",{writable:!1}),e}function Dv(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Nv(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&Fv(e,t)}function Uv(e){return Uv=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)},Uv(e)}function Fv(e,t){return Fv=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e},Fv(e,t)}function Bv(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function zv(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=Uv(e);if(t){var i=Uv(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return function(e,t){if(t&&("object"==typeof t||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return Bv(e)}(this,n)}}function Hv(){return Hv="undefined"!=typeof Reflect&&Reflect.get?Reflect.get.bind():function(e,t,n){var r=function(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=Uv(e)););return e}(e,t);if(r){var i=Object.getOwnPropertyDescriptor(r,t);return i.get?i.get.call(arguments.length<3?e:n):i.value}},Hv.apply(this,arguments)}function Vv(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,a=[],o=!0,s=!1;try{for(n=n.call(e);!(o=(r=n.next()).done)&&(a.push(r.value),!t||a.length!==t);o=!0);}catch(e){s=!0,i=e}finally{try{o||null==n.return||n.return()}finally{if(s)throw i}}return a}}(e,t)||$v(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Gv(e){return function(e){if(Array.isArray(e))return Wv(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||$v(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function $v(e,t){if(e){if("string"==typeof e)return Wv(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(e):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Wv(e,t):void 0}}function Wv(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function jv(e,t){var n="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!n){if(Array.isArray(e)||(n=$v(e))||t&&e&&"number"==typeof e.length){n&&(e=n);var r=0,i=function(){};return{s:i,n:function(){return r>=e.length?{done:!0}:{done:!1,value:e[r++]}},e:function(e){throw e},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var a,o=!0,s=!1;return{s:function(){n=n.call(e)},n:function(){var e=n.next();return o=e.done,e},e:function(e){s=!0,a=e},f:function(){try{o||null==n.return||n.return()}finally{if(s)throw a}}}}var Xv=Pv((function e(t){Ov(this,e),Dv(this,"name",void 0),Dv(this,"data",{}),Dv(this,"engine",null),this.name=t})),Yv=function(){function e(t){Ov(this,e),Dv(this,"name",void 0),Dv(this,"id",void 0),Dv(this,"position",[0,0]),Dv(this,"inputs",new Map),Dv(this,"outputs",new Map),Dv(this,"controls",new Map),Dv(this,"data",{}),Dv(this,"meta",{}),this.name=t,this.id=e.incrementId()}return Pv(e,[{key:"_add",value:function(e,t,n){if(e.has(t.key))throw new Error("Item with key '".concat(t.key,"' already been added to the node"));if(null!==t[n])throw new Error("Item has already been added to some node");t[n]=this,e.set(t.key,t)}},{key:"addControl",value:function(e){return this._add(this.controls,e,"parent"),this}},{key:"removeControl",value:function(e){e.parent=null,this.controls.delete(e.key)}},{key:"addInput",value:function(e){return this._add(this.inputs,e,"node"),this}},{key:"removeInput",value:function(e){e.removeConnections(),e.node=null,this.inputs.delete(e.key)}},{key:"addOutput",value:function(e){return this._add(this.outputs,e,"node"),this}},{key:"removeOutput",value:function(e){e.removeConnections(),e.node=null,this.outputs.delete(e.key)}},{key:"setMeta",value:function(e){return this.meta=e,this}},{key:"getConnections",value:function(){return[].concat(Gv(this.inputs.values()),Gv(this.outputs.values())).reduce((function(e,t){return[].concat(Gv(e),Gv(t.connections))}),[])}},{key:"update",value:function(){}},{key:"toJSON",value:function(){var e=function(e){return Array.from(e).reduce((function(e,t){var n=Vv(t,2),r=n[0],i=n[1];return e[r]=i.toJSON(),e}),{})};return{id:this.id,data:this.data,inputs:e(this.inputs),outputs:e(this.outputs),position:this.position,name:this.name}}}],[{key:"incrementId",value:function(){return this.latestId?this.latestId++:this.latestId=1,this.latestId}},{key:"resetId",value:function(){this.latestId=0}},{key:"fromJSON",value:function(t){var n=new e(t.name),r=Vv(t.position,2),i=r[0],a=r[1];return n.id=t.id,n.data=t.data,n.position=[i,a],n.name=t.name,e.latestId=Math.max(n.id,e.latestId),n}}]),e}();Dv(Yv,"latestId",0);var qv=function(e){Nv(r,e);var t,n=zv(r);function r(e){var t;return Ov(this,r),Dv(Bv(t=n.call(this,e)),"editor",null),Dv(Bv(t),"data",{}),t}return Pv(r,[{key:"build",value:(t=Lv(kv().mark((function e(t){return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,this.builder(t);case 2:return e.abrupt("return",t);case 3:case"end":return e.stop()}}),e,this)}))),function(e){return t.apply(this,arguments)})},{key:"createNode",value:function(){var e=Lv(kv().mark((function e(){var t,n,r=arguments;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return t=r.length>0&&void 0!==r[0]?r[0]:{},(n=new Yv(this.name)).data=t,e.next=5,this.build(n);case 5:return e.abrupt("return",n);case 6:case"end":return e.stop()}}),e,this)})));return function(){return e.apply(this,arguments)}}()}]),r}(Xv),Kv=function(){function e(t,n){Ov(this,e),Dv(this,"output",void 0),Dv(this,"input",void 0),Dv(this,"data",{}),this.output=t,this.input=n,this.data={},this.input.addConnection(this)}return Pv(e,[{key:"remove",value:function(){this.input.removeConnection(this),this.output.removeConnection(this)}}]),e}(),Zv=function(){function e(t){if(Ov(this,e),Dv(this,"key",void 0),Dv(this,"data",{}),Dv(this,"parent",null),this.constructor===e)throw new TypeError("Can not construct abstract class");if(!t)throw new Error("The key parameter is missing in super() of Control ");this.key=t}return Pv(e,[{key:"getNode",value:function(){if(null===this.parent)throw new Error("Control isn't added to Node/Input");if(this.parent instanceof Yv)return this.parent;if(!this.parent.node)throw new Error("Control hasn't be added to Input or Node");return this.parent.node}},{key:"getData",value:function(e){return this.getNode().data[e]}},{key:"putData",value:function(e,t){this.getNode().data[e]=t}}]),e}(),Jv=function(){function e(t){Ov(this,e),Dv(this,"events",{}),Dv(this,"silent",!1),this.events=t instanceof e?t.events:t.handlers}return Pv(e,[{key:"on",value:function(e,t){var n=this;return(e instanceof Array?e:e.split(" ")).forEach((function(e){if(!n.events[e])throw new Error("The event ".concat(e," does not exist"));n.events[e].push(t)})),this}},{key:"trigger",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!(e in this.events))throw new Error("The event ".concat(String(e)," cannot be triggered"));return this.events[e].reduce((function(e,n){return!1!==n(t)&&e}),!0)}},{key:"bind",value:function(e){if(this.events[e])throw new Error("The event ".concat(e," is already bound"));this.events[e]=[]}},{key:"exist",value:function(e){return Array.isArray(this.events[e])}}]),e}(),Qv=function(){function e(t,n,r,i){Ov(this,e),Dv(this,"node",null),Dv(this,"multipleConnections",void 0),Dv(this,"connections",[]),Dv(this,"key",void 0),Dv(this,"name",void 0),Dv(this,"socket",void 0),this.node=null,this.multipleConnections=i,this.connections=[],this.key=t,this.name=n,this.socket=r}return Pv(e,[{key:"removeConnection",value:function(e){this.connections.splice(this.connections.indexOf(e),1)}},{key:"removeConnections",value:function(){var e=this;this.connections.forEach((function(t){return e.removeConnection(t)}))}}]),e}(),eg=function(e){Nv(n,e);var t=zv(n);function n(e,r,i){var a,o=arguments.length>3&&void 0!==arguments[3]&&arguments[3];return Ov(this,n),Dv(Bv(a=t.call(this,e,r,i,o)),"control",null),a}return Pv(n,[{key:"hasConnection",value:function(){return this.connections.length>0}},{key:"addConnection",value:function(e){if(!this.multipleConnections&&this.hasConnection())throw new Error("Multiple connections not allowed");this.connections.push(e)}},{key:"addControl",value:function(e){this.control=e,e.parent=this}},{key:"showControl",value:function(){return!this.hasConnection()&&null!==this.control}},{key:"toJSON",value:function(){return{connections:this.connections.map((function(e){if(!e.output.node)throw new Error("Node not added to Output");return{node:e.output.node.id,output:e.output.key,data:e.data}}))}}}]),n}(Qv),tg=function(){function e(){Ov(this,e)}return Pv(e,null,[{key:"isValidData",value:function(e){return"string"==typeof e.id&&this.isValidId(e.id)&&e.nodes instanceof Object&&!(e.nodes instanceof Array)}},{key:"isValidId",value:function(e){return/^[\w-]{3,}@[0-9]+\.[0-9]+\.[0-9]+$/.test(e)}},{key:"validate",value:function(e,t){var n=e.split("@"),r=t.id.split("@"),i=[];return this.isValidData(t)||i.push("Data is not suitable"),e!==t.id&&i.push("IDs not equal"),n[0]!==r[0]&&i.push("Names don't match"),n[1]!==r[1]&&i.push("Versions don't match"),{success:Boolean(!i.length),msg:i.join(". ")}}}]),e}(),ng=function(e){Nv(n,e);var t=zv(n);function n(e,r){var i;if(Ov(this,n),Dv(Bv(i=t.call(this,r)),"id",void 0),Dv(Bv(i),"plugins",void 0),Dv(Bv(i),"components",void 0),!tg.isValidId(e))throw new Error("ID should be valid to name@0.1.0 format");return i.id=e,i.plugins=new Map,i.components=new Map,i}return Pv(n,[{key:"use",value:function(e,t){if(e.name&&this.plugins.has(e.name))throw new Error("Plugin ".concat(e.name," already in use"));e.install(this,t||{}),this.plugins.set(e.name,t)}},{key:"register",value:function(e){if(this.components.has(e.name))throw new Error("Component ".concat(e.name," already registered"));this.components.set(e.name,e),this.trigger("componentregister",e)}},{key:"destroy",value:function(){this.trigger("destroy")}}]),n}(Jv);function rg(e,t){return window.addEventListener(e,t),function(){window.removeEventListener(e,t)}}var ig=function(){function e(t){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:function(e,t,n){},r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:function(e){},i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:function(e){};Ov(this,e),this.onTranslate=n,this.onStart=r,this.onDrag=i,Dv(this,"pointerStart",void 0),Dv(this,"el",void 0),Dv(this,"destroy",void 0),this.pointerStart=null,this.el=t,this.el.style.touchAction="none",this.el.addEventListener("pointerdown",this.down.bind(this));var a=rg("pointermove",this.move.bind(this)),o=rg("pointerup",this.up.bind(this));this.destroy=function(){a(),o()}}return Pv(e,[{key:"down",value:function(e){"mouse"===e.pointerType&&0!==e.button||(e.stopPropagation(),this.pointerStart=[e.pageX,e.pageY],this.onStart(e))}},{key:"move",value:function(e){if(this.pointerStart){e.preventDefault();var t=[e.pageX,e.pageY],n=t[1],r=[t[0]-this.pointerStart[0],n-this.pointerStart[1]],i=this.el.getBoundingClientRect().width/this.el.offsetWidth;this.onTranslate(r[0]/i,r[1]/i,e)}}},{key:"up",value:function(e){this.pointerStart&&(this.pointerStart=null,this.onDrag(e))}}]),e}(),ag=function(){function e(t,n,r,i){Ov(this,e),Dv(this,"el",void 0),Dv(this,"intensity",void 0),Dv(this,"onzoom",void 0),Dv(this,"previous",null),Dv(this,"pointers",[]),Dv(this,"destroy",void 0),this.el=n,this.intensity=r,this.onzoom=i,t.addEventListener("wheel",this.wheel.bind(this)),t.addEventListener("pointerdown",this.down.bind(this)),t.addEventListener("dblclick",this.dblclick.bind(this));var a=rg("pointermove",this.move.bind(this)),o=rg("pointerup",this.end.bind(this)),s=rg("pointercancel",this.end.bind(this));this.destroy=function(){a(),o(),s()}}return Pv(e,[{key:"translating",get:function(){return this.pointers.length>=2}},{key:"wheel",value:function(e){e.preventDefault();var t=this.el.getBoundingClientRect(),n=e.deltaY<0?this.intensity:-this.intensity,r=(t.left-e.clientX)*n,i=(t.top-e.clientY)*n;this.onzoom(n,r,i,"wheel")}},{key:"touches",value:function(){var e={touches:this.pointers},t=[e.touches[0].clientX,e.touches[0].clientY],n=t[0],r=t[1],i=[e.touches[1].clientX,e.touches[1].clientY],a=i[0],o=i[1];return{cx:(n+a)/2,cy:(r+o)/2,distance:Math.sqrt(Math.pow(n-a,2)+Math.pow(r-o,2))}}},{key:"down",value:function(e){this.pointers.push(e)}},{key:"move",value:function(e){if(this.pointers=this.pointers.map((function(t){return t.pointerId===e.pointerId?e:t})),this.translating){var t=this.el.getBoundingClientRect(),n=this.touches(),r=n.cx,i=n.cy,a=n.distance;if(null!==this.previous){var o=a/this.previous.distance-1,s=(t.left-r)*o,c=(t.top-i)*o;this.onzoom(o,s-(this.previous.cx-r),c-(this.previous.cy-i),"touch")}this.previous={cx:r,cy:i,distance:a}}}},{key:"end",value:function(e){this.previous=null,this.pointers=this.pointers.filter((function(t){return t.pointerId!==e.pointerId}))}},{key:"dblclick",value:function(e){e.preventDefault();var t=this.el.getBoundingClientRect(),n=4*this.intensity,r=(t.left-e.clientX)*n,i=(t.top-e.clientY)*n;this.onzoom(n,r,i,"dblclick")}}]),e}(),og=function(e){Nv(n,e);var t=zv(n);function n(e,r){var i;Ov(this,n),Dv(Bv(i=t.call(this,r)),"el",void 0),Dv(Bv(i),"container",void 0),Dv(Bv(i),"transform",{k:1,x:0,y:0}),Dv(Bv(i),"mouse",{x:0,y:0}),Dv(Bv(i),"_startPosition",null),Dv(Bv(i),"_zoom",void 0),Dv(Bv(i),"_drag",void 0);var a=i.el=document.createElement("div");return i.container=e,a.style.transformOrigin="0 0",i._zoom=new ag(e,a,.1,i.onZoom.bind(Bv(i))),i._drag=new ig(e,i.onTranslate.bind(Bv(i)),i.onStart.bind(Bv(i))),r.on("destroy",(function(){i._zoom.destroy(),i._drag.destroy()})),i.container.addEventListener("pointermove",i.pointermove.bind(Bv(i))),i.update(),i}return Pv(n,[{key:"update",value:function(){var e=this.transform;this.el.style.transform="translate(".concat(e.x,"px, ").concat(e.y,"px) scale(").concat(e.k,")")}},{key:"pointermove",value:function(e){var t=e.clientX,n=e.clientY,r=this.el.getBoundingClientRect(),i=t-r.left,a=n-r.top,o=this.transform.k;this.mouse={x:i/o,y:a/o},this.trigger("mousemove",Mv({},this.mouse))}},{key:"onStart",value:function(){this._startPosition=Mv({},this.transform)}},{key:"onTranslate",value:function(e,t){this._zoom.translating||this._startPosition&&this.translate(this._startPosition.x+e,this._startPosition.y+t)}},{key:"onZoom",value:function(e,t,n,r){this.zoom(this.transform.k*(1+e),t,n,r),this.update()}},{key:"translate",value:function(e,t){var n={transform:this.transform,x:e,y:t};this.trigger("translate",n)&&(this.transform.x=n.x,this.transform.y=n.y,this.update(),this.trigger("translated"))}},{key:"zoom",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:0,r=arguments.length>3?arguments[3]:void 0,i=this.transform.k,a={transform:this.transform,zoom:e,source:r};if(this.trigger("zoom",a)){var o=(i-a.zoom)/(i-e||1);this.transform.k=a.zoom||1,this.transform.x+=t*o,this.transform.y+=n*o,this.update(),this.trigger("zoomed",{source:r})}}},{key:"appendChild",value:function(e){this.el.appendChild(e)}},{key:"removeChild",value:function(e){this.el.removeChild(e)}}]),n}(Jv),sg=function(e){Nv(n,e);var t=zv(n);function n(e,r,i,a){var o;return Ov(this,n),Dv(Bv(o=t.call(this,a)),"connection",void 0),Dv(Bv(o),"inputNode",void 0),Dv(Bv(o),"outputNode",void 0),Dv(Bv(o),"el",void 0),o.connection=e,o.inputNode=r,o.outputNode=i,o.el=document.createElement("div"),o.el.style.position="absolute",o.el.style.zIndex="-1",o.trigger("renderconnection",{el:o.el,connection:o.connection,points:o.getPoints()}),o}return Pv(n,[{key:"getPoints",value:function(){var e=this.connection,t=e.input,n=e.output;if(this.inputNode.hasSocket(t)&&this.outputNode.hasSocket(n)){var r=Vv(this.outputNode.getSocketPosition(n),2),i=r[0],a=r[1],o=Vv(this.inputNode.getSocketPosition(t),2);return[i,a,o[0],o[1]]}return[0,0,0,0]}},{key:"update",value:function(){this.trigger("updateconnection",{el:this.el,connection:this.connection,points:this.getPoints()})}}]),n}(Jv),cg=function(e){Nv(n,e);var t=zv(n);function n(e,r,i){var a;return Ov(this,n),(a=t.call(this,i)).trigger("rendercontrol",{el:e,control:r}),a}return Pv(n)}(Jv),lg=function(e){Nv(n,e);var t=zv(n);function n(e,r,i,a,o){var s,c;return Ov(this,n),Dv(Bv(c=t.call(this,o)),"el",void 0),Dv(Bv(c),"type",void 0),Dv(Bv(c),"io",void 0),Dv(Bv(c),"node",void 0),c.el=e,c.type=r,c.io=i,c.node=a,c.trigger("rendersocket",(Dv(s={el:e},r,c.io),Dv(s,"socket",i.socket),s)),c}return Pv(n,[{key:"getPosition",value:function(e,t){var n=e.position,r=this.el,i=function(e,t){for(var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:8,r=e.offsetLeft,i=e.offsetTop,a=e.offsetParent;a&&a!==t&&n>0;)n--,r+=a.offsetLeft,i+=a.offsetTop,a=a.offsetParent;return{x:r,y:i}}(r,t),a=i.x,o=i.y;return[n[0]+a+r.offsetWidth/2,n[1]+o+r.offsetHeight/2]}}]),n}(Jv),ug=function(e){Nv(n,e);var t=zv(n);function n(e,r,i){var a;return Ov(this,n),Dv(Bv(a=t.call(this,i)),"node",void 0),Dv(Bv(a),"component",void 0),Dv(Bv(a),"sockets",new Map),Dv(Bv(a),"controls",new Map),Dv(Bv(a),"el",void 0),Dv(Bv(a),"_startPosition",[]),Dv(Bv(a),"_drag",void 0),a.node=e,a.component=r,a.el=document.createElement("div"),a.el.style.position="absolute",a.el.addEventListener("contextmenu",(function(e){return a.trigger("contextmenu",{e:e,node:a.node})})),a._drag=new ig(a.el,a.onTranslate.bind(Bv(a)),a.onSelect.bind(Bv(a)),(function(){a.trigger("nodedraged",e),a.trigger("nodedragged",e)})),a.trigger("rendernode",{el:a.el,node:e,component:r.data,bindSocket:a.bindSocket.bind(Bv(a)),bindControl:a.bindControl.bind(Bv(a))}),a.update(),a}return Pv(n,[{key:"clearSockets",value:function(){var e=this,t=[].concat(Gv(this.node.inputs.values()),Gv(this.node.outputs.values()));this.sockets.forEach((function(n){t.includes(n.io)||e.sockets.delete(n.io)}))}},{key:"bindSocket",value:function(e,t,n){this.clearSockets(),this.sockets.set(n,new lg(e,t,n,this.node,this))}},{key:"bindControl",value:function(e,t){this.controls.set(t,new cg(e,t,this))}},{key:"hasSocket",value:function(e){return this.sockets.has(e)}},{key:"getSocketPosition",value:function(e){var t=this.sockets.get(e);if(!t)throw new Error("Socket not found for ".concat(e.name," with key ").concat(e.key));return t.getPosition(this.node,this.el)}},{key:"onSelect",value:function(e){var t={node:this.node,accumulate:e.ctrlKey,e:e};this.onStart(),this.trigger("multiselectnode",t),this.trigger("selectnode",t)}},{key:"onStart",value:function(){this._startPosition=Gv(this.node.position)}},{key:"onTranslate",value:function(e,t){this.trigger("translatenode",{node:this.node,dx:e,dy:t})}},{key:"onDrag",value:function(e,t){var n=this._startPosition[0]+e,r=this._startPosition[1]+t;this.translate(n,r)}},{key:"translate",value:function(e,t){var n=this.node,r={node:n,x:e,y:t};if(this.trigger("nodetranslate",r)){var i=Vv(n.position,2),a=[i[0],i[1]];n.position[0]=r.x,n.position[1]=r.y,this.update(),this.trigger("nodetranslated",{node:n,prev:a})}}},{key:"update",value:function(){var e=Vv(this.node.position,2),t=e[0],n=e[1];this.el.style.transform="translate(".concat(t,"px, ").concat(n,"px)")}},{key:"remove",value:function(){}},{key:"destroy",value:function(){this._drag.destroy()}}]),n}(Jv),dg=function(e){Nv(n,e);var t=zv(n);function n(e,r,i){var a;return Ov(this,n),Dv(Bv(a=t.call(this,i)),"container",void 0),Dv(Bv(a),"components",void 0),Dv(Bv(a),"nodes",new Map),Dv(Bv(a),"connections",new Map),Dv(Bv(a),"area",void 0),a.container=e,a.components=r,a.container.style.overflow="hidden",a.container.addEventListener("click",a.click.bind(Bv(a))),a.container.addEventListener("contextmenu",(function(e){return a.trigger("contextmenu",{e:e,view:Bv(a)})})),i.on("destroy",rg("resize",a.resize.bind(Bv(a)))),i.on("destroy",(function(){return a.nodes.forEach((function(e){return e.destroy()}))})),a.on("nodetranslated",a.updateConnections.bind(Bv(a))),a.on("rendersocket",(function(e){var t=e.input,n=e.output;Array.from(a.connections.entries()).filter((function(e){var r=Vv(e,1)[0];return r.input===t||r.output===n})).forEach((function(e){var t=Vv(e,2);t[0];var n=t[1];return requestAnimationFrame((function(){return n.update()}))}))})),a.area=new og(e,Bv(a)),a.container.appendChild(a.area.el),a}return Pv(n,[{key:"addNode",value:function(e){var t=this.components.get(e.name);if(!t)throw new Error("Component ".concat(e.name," not found"));var n=new ug(e,t,this);this.nodes.set(e,n),this.area.appendChild(n.el)}},{key:"removeNode",value:function(e){var t=this.nodes.get(e);this.nodes.delete(e),t&&(this.area.removeChild(t.el),t.destroy())}},{key:"addConnection",value:function(e){if(!e.input.node||!e.output.node)throw new Error("Connection input or output not added to node");var t=this.nodes.get(e.input.node),n=this.nodes.get(e.output.node);if(!t||!n)throw new Error("View node not found for input or output");var r=new sg(e,t,n,this);this.connections.set(e,r),this.area.appendChild(r.el)}},{key:"removeConnection",value:function(e){var t=this.connections.get(e);this.connections.delete(e),t&&this.area.removeChild(t.el)}},{key:"updateConnections",value:function(e){var t=this;e.node.getConnections().forEach((function(e){var n=t.connections.get(e);if(!n)throw new Error("Connection view not found");n.update()}))}},{key:"resize",value:function(){var e=this.container;if(!e.parentElement)throw new Error("Container doesn't have parent element");var t=e.parentElement.clientWidth,n=e.parentElement.clientHeight;e.style.width=t+"px",e.style.height=n+"px"}},{key:"click",value:function(e){var t=this.container;t===e.target&&this.trigger("click",{e:e,container:t})}}]),n}(Jv),fg=function(){function e(){Ov(this,e),Dv(this,"list",[])}return Pv(e,[{key:"add",value:function(e){arguments.length>1&&void 0!==arguments[1]&&arguments[1]?this.contains(e)||this.list.push(e):this.list=[e]}},{key:"clear",value:function(){this.list=[]}},{key:"remove",value:function(e){this.list.splice(this.list.indexOf(e),1)}},{key:"contains",value:function(e){return-1!==this.list.indexOf(e)}},{key:"each",value:function(e){this.list.forEach(e)}}]),e}(),hg=Pv((function e(t){Ov(this,e),Dv(this,"handlers",void 0),this.handlers=Mv({warn:[console.warn],error:[console.error],componentregister:[],destroy:[]},t)})),pg=function(e){Nv(n,e);var t=zv(n);function n(){return Ov(this,n),t.call(this,{nodecreate:[],nodecreated:[],noderemove:[],noderemoved:[],connectioncreate:[],connectioncreated:[],connectionremove:[],connectionremoved:[],translatenode:[],nodetranslate:[],nodetranslated:[],nodedraged:[],nodedragged:[],selectnode:[],multiselectnode:[],nodeselect:[],nodeselected:[],rendernode:[],rendersocket:[],rendercontrol:[],renderconnection:[],updateconnection:[],keydown:[],keyup:[],translate:[],translated:[],zoom:[],zoomed:[],click:[],mousemove:[],contextmenu:[],import:[],export:[],process:[],clear:[]})}return Pv(n)}(hg),mg=function(e){Nv(r,e);var t,n=zv(r);function r(e,t){var i;return Ov(this,r),Dv(Bv(i=n.call(this,e,new pg)),"nodes",[]),Dv(Bv(i),"selected",new fg),Dv(Bv(i),"view",void 0),i.view=new dg(t,i.components,Bv(i)),i.on("destroy",rg("keydown",(function(e){return i.trigger("keydown",e)}))),i.on("destroy",rg("keyup",(function(e){return i.trigger("keyup",e)}))),i.on("selectnode",(function(e){var t=e.node,n=e.accumulate;return i.selectNode(t,n)})),i.on("nodeselected",(function(){return i.selected.each((function(e){var t=i.view.nodes.get(e);t&&t.onStart()}))})),i.on("translatenode",(function(e){var t=e.dx,n=e.dy;return i.selected.each((function(e){var r=i.view.nodes.get(e);r&&r.onDrag(t,n)}))})),i}return Pv(r,[{key:"addNode",value:function(e){this.trigger("nodecreate",e)&&(this.nodes.push(e),this.view.addNode(e),this.trigger("nodecreated",e))}},{key:"removeNode",value:function(e){var t=this;this.trigger("noderemove",e)&&(e.getConnections().forEach((function(e){return t.removeConnection(e)})),this.nodes.splice(this.nodes.indexOf(e),1),this.view.removeNode(e),this.trigger("noderemoved",e))}},{key:"connect",value:function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};if(this.trigger("connectioncreate",{output:e,input:t}))try{var r=e.connectTo(t);r.data=n,this.view.addConnection(r),this.trigger("connectioncreated",r)}catch(e){this.trigger("warn",e)}}},{key:"removeConnection",value:function(e){this.trigger("connectionremove",e)&&(this.view.removeConnection(e),e.remove(),this.trigger("connectionremoved",e))}},{key:"selectNode",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(-1===this.nodes.indexOf(e))throw new Error("Node not exist in list");this.trigger("nodeselect",e)&&(this.selected.add(e,t),this.trigger("nodeselected",e))}},{key:"getComponent",value:function(e){var t=this.components.get(e);if(!t)throw"Component ".concat(e," not found");return t}},{key:"register",value:function(e){Hv(Uv(r.prototype),"register",this).call(this,e),e.editor=this}},{key:"clear",value:function(){var e=this;Gv(this.nodes).forEach((function(t){return e.removeNode(t)})),this.trigger("clear")}},{key:"toJSON",value:function(){var e={id:this.id,nodes:{}};return this.nodes.forEach((function(t){return e.nodes[t.id]=t.toJSON()})),this.trigger("export",e),e}},{key:"beforeImport",value:function(e){var t=tg.validate(this.id,e);return t.success?(this.silent=!0,this.clear(),this.trigger("import",e),!0):(this.trigger("warn",t.msg),!1)}},{key:"afterImport",value:function(){return this.silent=!1,!0}},{key:"fromJSON",value:(t=Lv(kv().mark((function e(t){var n,r=this;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(this.beforeImport(t)){e.next=2;break}return e.abrupt("return",!1);case 2:return n={},e.prev=3,e.next=6,Promise.all(Object.keys(t.nodes).map(function(){var e=Lv(kv().mark((function e(i){var a,o;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return a=t.nodes[i],o=r.getComponent(a.name),e.next=4,o.build(Yv.fromJSON(a));case 4:n[i]=e.sent,r.addNode(n[i]);case 6:case"end":return e.stop()}}),e)})));return function(t){return e.apply(this,arguments)}}()));case 6:Object.keys(t.nodes).forEach((function(e){var i=t.nodes[e],a=n[e];Object.keys(i.outputs).forEach((function(e){i.outputs[e].connections.forEach((function(t){var i=t.node,o=t.data,s=a.outputs.get(e),c=n[i].inputs.get(t.input);if(!s||!c)return r.trigger("error","IO not found for node ".concat(a.id));r.connect(s,c,o)}))}))})),e.next=13;break;case 9:return e.prev=9,e.t0=e.catch(3),this.trigger("warn",e.t0),e.abrupt("return",!this.afterImport());case 13:return e.abrupt("return",this.afterImport());case 14:case"end":return e.stop()}}),e,this,[[3,9]])}))),function(e){return t.apply(this,arguments)})}]),r}(ng),vg=function(e){Nv(n,e);var t=zv(n);function n(e,r,i){var a=!(arguments.length>3&&void 0!==arguments[3])||arguments[3];return Ov(this,n),t.call(this,e,r,i,a)}return Pv(n,[{key:"hasConnection",value:function(){return this.connections.length>0}},{key:"connectTo",value:function(e){if(!this.socket.compatibleWith(e.socket))throw new Error("Sockets not compatible");if(!e.multipleConnections&&e.hasConnection())throw new Error("Input already has one connection");if(!this.multipleConnections&&this.hasConnection())throw new Error("Output already has one connection");var t=new Kv(this,e);return this.connections.push(t),t}},{key:"connectedTo",value:function(e){return this.connections.some((function(t){return t.input===e}))}},{key:"toJSON",value:function(){return{connections:this.connections.map((function(e){if(!e.input.node)throw new Error("Node not added to Input");return{node:e.input.node.id,input:e.input.key,data:e.data}}))}}}]),n}(Qv),gg=function(){function e(t){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};Ov(this,e),Dv(this,"name",void 0),Dv(this,"data",void 0),Dv(this,"compatible",[]),this.name=t,this.data=n,this.compatible=[]}return Pv(e,[{key:"combineWith",value:function(e){this.compatible.push(e)}},{key:"compatibleWith",value:function(e){return this===e||this.compatible.includes(e)}}]),e}(),bg=function(){function e(t){Ov(this,e),Dv(this,"nodes",void 0),this.nodes=t}return Pv(e,[{key:"extractInputNodes",value:function(e){var t=this;return Object.keys(e.inputs).reduce((function(n,r){var i=(e.inputs[r].connections||[]).reduce((function(e,n){return[].concat(Gv(e),[t.nodes[n.node]])}),[]);return[].concat(Gv(n),Gv(i))}),[])}},{key:"findSelf",value:function(e,t){var n,r=(n=t,e.filter((function(e){return-1!==n.indexOf(e)})));if(r.length)return r[0];var i,a=jv(t);try{for(a.s();!(i=a.n()).done;){var o=i.value,s=[o].concat(Gv(e)),c=this.findSelf(s,this.extractInputNodes(o));if(c)return c}}catch(e){a.e(e)}finally{a.f()}return null}},{key:"detect",value:function(){var e,t=this,n=jv(Object.keys(this.nodes).map((function(e){return t.nodes[e]})));try{for(n.s();!(e=n.n()).done;){var r=e.value,i=this.findSelf([r],this.extractInputNodes(r));if(i)return i}}catch(e){n.e(e)}finally{n.f()}return null}}]),e}(),_g=function(e){Nv(n,e);var t=zv(n);function n(){return Ov(this,n),t.call(this,{})}return Pv(n)}(hg),yg=function(e){Nv(h,e);var t,n,r,i,a,o,s,c,l,u,d,f=zv(h);function h(e){var t;return Ov(this,h),Dv(Bv(t=f.call(this,e,new _g)),"args",[]),Dv(Bv(t),"data",null),Dv(Bv(t),"state",0),Dv(Bv(t),"forwarded",new Set),Dv(Bv(t),"onAbort",(function(){})),t}return Pv(h,[{key:"clone",value:function(){var e=new h(this.id);return this.components.forEach((function(t){return e.register(t)})),e}},{key:"throwError",value:(d=Lv(kv().mark((function e(t){var n,r=arguments;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return n=r.length>1&&void 0!==r[1]?r[1]:null,e.next=3,this.abort();case 3:return this.trigger("error",{message:t,data:n}),this.processDone(),e.abrupt("return","error");case 6:case"end":return e.stop()}}),e,this)}))),function(e){return d.apply(this,arguments)})},{key:"processStart",value:function(){return 0===this.state?(this.state=1,!0):(2===this.state||console.warn("The process is busy and has not been restarted.\n                Use abort() to force it to complete"),!1)}},{key:"processDone",value:function(){var e=2!==this.state;return this.state=0,e||(this.onAbort(),this.onAbort=function(){}),e}},{key:"abort",value:(u=Lv(kv().mark((function e(){var t=this;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.abrupt("return",new Promise((function(e){1===t.state?(t.state=2,t.onAbort=e):2===t.state?(t.onAbort(),t.onAbort=e):e()})));case 1:case"end":return e.stop()}}),e)}))),function(){return u.apply(this,arguments)})},{key:"lock",value:(l=Lv(kv().mark((function e(t){return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.abrupt("return",new Promise((function(e){t.unlockPool=t.unlockPool||[],t.busy&&!t.outputData?t.unlockPool.push(e):e(),t.busy=!0})));case 1:case"end":return e.stop()}}),e)}))),function(e){return l.apply(this,arguments)})},{key:"unlock",value:function(e){e.unlockPool.forEach((function(e){return e()})),e.unlockPool=[],e.busy=!1}},{key:"extractInputData",value:(c=Lv(kv().mark((function e(t){var n,r,i,a,o,s,c,l=this;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:n={},r=0,i=Object.keys(t.inputs);case 2:if(!(r<i.length)){e.next=13;break}return a=i[r],o=t.inputs[a],s=o.connections,e.next=8,Promise.all(s.map(function(){var e=Lv(kv().mark((function e(t){var n,r;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return n=l.data.nodes[t.node],e.next=3,l.processNode(n);case 3:if(r=e.sent){e.next=8;break}l.abort(),e.next=9;break;case 8:return e.abrupt("return",r[t.output]);case 9:case"end":return e.stop()}}),e)})));return function(t){return e.apply(this,arguments)}}()));case 8:c=e.sent,n[a]=c;case 10:r++,e.next=2;break;case 13:return e.abrupt("return",n);case 14:case"end":return e.stop()}}),e)}))),function(e){return c.apply(this,arguments)})},{key:"processWorker",value:(s=Lv(kv().mark((function e(t){var n,r,i;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,this.extractInputData(t);case 2:return n=e.sent,r=this.components.get(t.name),i={},e.prev=5,e.next=8,r.worker.apply(r,[t,n,i].concat(Gv(this.args)));case 8:e.next=14;break;case 10:e.prev=10,e.t0=e.catch(5),this.abort(),this.trigger("warn",e.t0);case 14:return e.abrupt("return",i);case 15:case"end":return e.stop()}}),e,this,[[5,10]])}))),function(e){return s.apply(this,arguments)})},{key:"processNode",value:(o=Lv(kv().mark((function e(t){return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(2!==this.state&&t){e.next=2;break}return e.abrupt("return",null);case 2:return e.next=4,this.lock(t);case 4:if(t.outputData){e.next=8;break}return e.next=7,this.processWorker(t);case 7:t.outputData=e.sent;case 8:return this.unlock(t),e.abrupt("return",t.outputData);case 10:case"end":return e.stop()}}),e,this)}))),function(e){return o.apply(this,arguments)})},{key:"forwardProcess",value:(a=Lv(kv().mark((function e(t){var n=this;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(2!==this.state){e.next=2;break}return e.abrupt("return",null);case 2:return e.next=4,Promise.all(Object.keys(t.outputs).map(function(){var e=Lv(kv().mark((function e(r){var i;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return i=t.outputs[r],e.next=3,Promise.all(i.connections.map(function(){var e=Lv(kv().mark((function e(t){var r;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(r=n.data.nodes[t.node],n.forwarded.has(r)){e.next=7;break}return n.forwarded.add(r),e.next=5,n.processNode(r);case 5:return e.next=7,n.forwardProcess(r);case 7:case"end":return e.stop()}}),e)})));return function(t){return e.apply(this,arguments)}}()));case 3:return e.abrupt("return",e.sent);case 4:case"end":return e.stop()}}),e)})));return function(t){return e.apply(this,arguments)}}()));case 4:return e.abrupt("return",e.sent);case 5:case"end":return e.stop()}}),e,this)}))),function(e){return a.apply(this,arguments)})},{key:"copy",value:function(e){return(e=Object.assign({},e)).nodes=Object.assign({},e.nodes),Object.keys(e.nodes).forEach((function(t){e.nodes[t]=Object.assign({},e.nodes[t])})),e}},{key:"validate",value:(i=Lv(kv().mark((function e(t){var n,r,i;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(n=tg.validate(this.id,t),r=new bg(t.nodes),n.success){e.next=6;break}return e.next=5,this.throwError(n.msg);case 5:case 10:return e.abrupt("return",e.sent);case 6:if(!(i=r.detect())){e.next=11;break}return e.next=10,this.throwError("Recursion detected",i);case 11:return e.abrupt("return",!0);case 12:case"end":return e.stop()}}),e,this)}))),function(e){return i.apply(this,arguments)})},{key:"processStartNode",value:(r=Lv(kv().mark((function e(t){var n;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(t){e.next=2;break}return e.abrupt("return");case 2:if(n=this.data.nodes[t]){e.next=7;break}return e.next=6,this.throwError("Node with such id not found");case 6:return e.abrupt("return",e.sent);case 7:return e.next=9,this.processNode(n);case 9:return e.next=11,this.forwardProcess(n);case 11:case"end":return e.stop()}}),e,this)}))),function(e){return r.apply(this,arguments)})},{key:"processUnreachable",value:(n=Lv(kv().mark((function e(){var t,n,r;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:t=this.data,e.t0=kv().keys(t.nodes);case 2:if((e.t1=e.t0()).done){e.next=12;break}if(n=e.t1.value,void 0!==(r=t.nodes[n]).outputData){e.next=10;break}return e.next=8,this.processNode(r);case 8:return e.next=10,this.forwardProcess(r);case 10:e.next=2;break;case 12:case"end":return e.stop()}}),e,this)}))),function(){return n.apply(this,arguments)})},{key:"process",value:(t=Lv(kv().mark((function e(t){var n,r,i,a,o=arguments;return kv().wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(n=o.length>1&&void 0!==o[1]?o[1]:null,this.processStart()){e.next=3;break}return e.abrupt("return");case 3:if(this.validate(t)){e.next=5;break}return e.abrupt("return");case 5:for(this.data=this.copy(t),r=o.length,i=new Array(r>2?r-2:0),a=2;a<r;a++)i[a-2]=o[a];return this.args=i,this.forwarded=new Set,e.next=11,this.processStartNode(n);case 11:return e.next=13,this.processUnreachable();case 13:return e.abrupt("return",this.processDone()?"success":"aborted");case 14:case"end":return e.stop()}}),e,this)}))),function(e){return t.apply(this,arguments)})}]),h}(ng),xg={Engine:yg,Recursion:bg,Component:qv,Control:Zv,Connection:Kv,Emitter:Jv,Input:eg,IO:Qv,Node:Yv,NodeEditor:mg,Output:vg,Socket:gg};function Ag(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function wg(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function Eg(e,t,n){return t&&wg(e.prototype,t),n&&wg(e,n),e}function Tg(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Sg(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=[],r=!0,i=!1,a=void 0;try{for(var o,s=e[Symbol.iterator]();!(r=(o=s.next()).done)&&(n.push(o.value),!t||n.length!==t);r=!0);}catch(e){i=!0,a=e}finally{try{r||null==s.return||s.return()}finally{if(i)throw a}}return n}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance")}()}function Cg(e){return e.toLowerCase().replace(/ /g,"-")}function Mg(e,t){return e.get(t)||(t.parentElement?Mg(e,t.parentElement):null)}function kg(e,t,n){var r={points:t,connection:n,d:""};return e.trigger("connectionpath",r),r.d||function(e,t){var n=Sg(e,4),r=n[0],i=n[1],a=n[2],o=n[3],s=r+.4*Math.abs(a-r),c=a-.4*Math.abs(a-r);return"M ".concat(r," ").concat(i," C ").concat(s," ").concat(i," ").concat(c," ").concat(o," ").concat(a," ").concat(o)}(t)}function Rg(e){var t=e.el,n=e.d,r=t.querySelector(".connection path");if(!r)throw new Error("Path of connection was broken");r.setAttribute("d",n)}function Lg(e){var t,n=e.el,r=e.d,i=e.connection,a=i?["input-"+Cg(i.input.name),"output-"+Cg(i.output.name),"socket-input-"+Cg(i.input.socket.name),"socket-output-"+Cg(i.output.socket.name)]:[],o=document.createElementNS("http://www.w3.org/2000/svg","svg"),s=document.createElementNS("http://www.w3.org/2000/svg","path");(t=o.classList).add.apply(t,["connection"].concat(a)),s.classList.add("main-path"),s.setAttribute("d",r),o.appendChild(s),n.appendChild(o),Rg({el:n,d:r})}var Og=function(){function e(t,n){Ag(this,e),this.emitter=t,this.editorView=n,Tg(this,"el",void 0),this.el=document.createElement("div"),this.el.style.position="absolute",this.editorView.area.appendChild(this.el)}return Eg(e,[{key:"updatePseudoConnection",value:function(e){null!==e?this.renderConnection(e):this.el.parentElement&&(this.el.innerHTML="")}},{key:"getPoints",value:function(e){var t=this.editorView.area.mouse;if(!e.node)throw new Error("Node in output/input not found");var n=this.editorView.nodes.get(e.node);if(!n)throw new Error("Node view not found");var r=Sg(n.getSocketPosition(e),2),i=r[0],a=r[1];return e instanceof vg?[i,a,t.x,t.y]:[t.x,t.y,i,a]}},{key:"updateConnection",value:function(e){var t=kg(this.emitter,this.getPoints(e));Rg({el:this.el,d:t})}},{key:"renderConnection",value:function(e){var t=kg(this.emitter,this.getPoints(e));Lg({el:this.el,d:t})}}]),e}(),Ig=function(){function e(t){var n=this;Ag(this,e),Tg(this,"editor",void 0),Tg(this,"_io",null),Tg(this,"view",void 0),this.editor=t,this.view=new Og(t,t.view),t.on("mousemove",(function(){return n.io&&n.view.updateConnection(n.io)}))}return Eg(e,[{key:"reset",value:function(){this.io=null}},{key:"pickOutput",value:function(e){if(this.editor.trigger("connectionpick",e)){if(this.io instanceof eg)return!e.multipleConnections&&e.hasConnection()&&this.editor.removeConnection(e.connections[0]),this.editor.connect(e,this.io),void this.reset();this.io&&this.reset(),this.io=e}}},{key:"pickInput",value:function(e){var t=this;if(this.editor.trigger("connectionpick",e)){if(null===this.io)return e.hasConnection()?(this.io=e.connections[0].output,this.editor.removeConnection(e.connections[0])):this.io=e,!0;if(!e.multipleConnections&&e.hasConnection()&&this.editor.removeConnection(e.connections[0]),!this.io.multipleConnections&&this.io.hasConnection()&&this.editor.removeConnection(this.io.connections[0]),this.io instanceof vg&&this.io.connectedTo(e)){var n=e.connections.find((function(e){return e.output===t.io}));n&&this.editor.removeConnection(n)}this.io instanceof vg&&(this.editor.connect(this.io,e),this.reset())}}},{key:"pickConnection",value:function(e){var t=e.output;this.editor.removeConnection(e),this.io=t}},{key:"io",get:function(){return this._io},set:function(e){this._io=e,this.view.updatePseudoConnection(e)}}]),e}(),Pg=function(){function e(t){Ag(this,e),Tg(this,"picker",void 0),Tg(this,"target",void 0),this.picker=t,this.target=null}return Eg(e,[{key:"act",value:function(e){var t=e.input,n=e.output;this.unlock(t||n)||(t?this.picker.pickInput(t):n?this.picker.pickOutput(n):this.picker.reset())}},{key:"start",value:function(e,t){this.act(e),this.target=t}},{key:"complete",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.act(e)}},{key:"hasTarget",value:function(){return Boolean(this.target)}},{key:"unlock",value:function(e){var t=this.target;return this.target=null,t&&t===e}}]),e}();!function(e){if(e&&"undefined"!=typeof window){var t=document.createElement("style");t.setAttribute("type","text/css"),t.innerHTML=e,document.head.appendChild(t)}}(".connection {\n  overflow: visible !important;\n  position: absolute;\n  z-index: -1;\n  pointer-events: none; }\n  .connection > * {\n    pointer-events: all; }\n  .connection .main-path {\n    fill: none;\n    stroke-width: 5px;\n    stroke: steelblue; }\n");var Dg={name:"connection",install:function(e){e.bind("connectionpath"),e.bind("connectiondrop"),e.bind("connectionpick"),e.bind("resetconnection");var t=new Ig(e),n=new Pg(t),r=new WeakMap;function i(t){var i=r.get(this);if(i){var a=i.input,o=i.output;e.view.container.dispatchEvent(new PointerEvent("pointermove",t)),t.preventDefault(),t.stopPropagation(),n.start({input:a,output:o},a||o)}}function a(i){var a=document.elementFromPoint(i.clientX,i.clientY);t.io&&e.trigger("connectiondrop",t.io),a&&n.complete(Mg(r,a)||{})}e.on("resetconnection",(function(){return n.complete()})),e.on("rendersocket",(function(e){var t=e.el,n=e.input,a=e.output;r.set(t,{input:n,output:a}),t.removeEventListener("pointerdown",i),t.addEventListener("pointerdown",i)})),window.addEventListener("pointerup",a),e.on("renderconnection",(function(t){var n=t.el,r=t.connection,i=t.points;Lg({el:n,d:kg(e,i,r),connection:r})})),e.on("updateconnection",(function(t){var n=t.el,r=t.connection,i=t.points;Rg({el:n,d:kg(e,i,r)})})),e.on("destroy",(function(){window.removeEventListener("pointerup",a)}))}},Ng=function(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)},Ug="object"==typeof n.g&&n.g&&n.g.Object===Object&&n.g,Fg="object"==typeof self&&self&&self.Object===Object&&self,Bg=Ug||Fg||Function("return this")(),zg=function(){return Bg.Date.now()},Hg=Bg.Symbol,Vg=Object.prototype,Gg=Vg.hasOwnProperty,$g=Vg.toString,Wg=Hg?Hg.toStringTag:void 0,jg=Object.prototype.toString,Xg=Hg?Hg.toStringTag:void 0,Yg=function(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":Xg&&Xg in Object(e)?function(e){var t=Gg.call(e,Wg),n=e[Wg];try{e[Wg]=void 0;var r=!0}catch(e){}var i=$g.call(e);return r&&(t?e[Wg]=n:delete e[Wg]),i}(e):function(e){return jg.call(e)}(e)},qg=/^\s+|\s+$/g,Kg=/^[-+]0x[0-9a-f]+$/i,Zg=/^0b[01]+$/i,Jg=/^0o[0-7]+$/i,Qg=parseInt,eb=function(e){if("number"==typeof e)return e;if(function(e){return"symbol"==typeof e||function(e){return null!=e&&"object"==typeof e}(e)&&"[object Symbol]"==Yg(e)}(e))return NaN;if(Ng(e)){var t="function"==typeof e.valueOf?e.valueOf():e;e=Ng(t)?t+"":t}if("string"!=typeof e)return 0===e?e:+e;e=e.replace(qg,"");var n=Zg.test(e);return n||Jg.test(e)?Qg(e.slice(2),n?2:8):Kg.test(e)?NaN:+e},tb=Math.max,nb=Math.min,rb=Object.freeze({});function ib(e){return null==e}function ab(e){return null!=e}function ob(e){return!0===e}function sb(e){return"string"==typeof e||"number"==typeof e||"symbol"==typeof e||"boolean"==typeof e}function cb(e){return null!==e&&"object"==typeof e}var lb=Object.prototype.toString;function ub(e){return"[object Object]"===lb.call(e)}function db(e){var t=parseFloat(String(e));return t>=0&&Math.floor(t)===t&&isFinite(e)}function fb(e){return null==e?"":"object"==typeof e?JSON.stringify(e,null,2):String(e)}function hb(e){var t=parseFloat(e);return isNaN(t)?e:t}function pb(e,t){for(var n=Object.create(null),r=e.split(","),i=0;i<r.length;i++)n[r[i]]=!0;return t?function(e){return n[e.toLowerCase()]}:function(e){return n[e]}}var mb=pb("slot,component",!0),vb=pb("key,ref,slot,slot-scope,is");function gb(e,t){if(e.length){var n=e.indexOf(t);if(n>-1)return e.splice(n,1)}}var bb=Object.prototype.hasOwnProperty;function _b(e,t){return bb.call(e,t)}function yb(e){var t=Object.create(null);return function(n){return t[n]||(t[n]=e(n))}}var xb=/-(\w)/g,Ab=yb((function(e){return e.replace(xb,(function(e,t){return t?t.toUpperCase():""}))})),wb=yb((function(e){return e.charAt(0).toUpperCase()+e.slice(1)})),Eb=/\B([A-Z])/g,Tb=yb((function(e){return e.replace(Eb,"-$1").toLowerCase()})),Sb=Function.prototype.bind?function(e,t){return e.bind(t)}:function(e,t){function n(n){var r=arguments.length;return r?r>1?e.apply(t,arguments):e.call(t,n):e.call(t)}return n._length=e.length,n};function Cb(e,t){t=t||0;for(var n=e.length-t,r=new Array(n);n--;)r[n]=e[n+t];return r}function Mb(e,t){for(var n in t)e[n]=t[n];return e}function kb(e){for(var t={},n=0;n<e.length;n++)e[n]&&Mb(t,e[n]);return t}function Rb(e,t,n){}var Lb=function(e,t,n){return!1},Ob=function(e){return e};function Ib(e,t){if(e===t)return!0;var n=cb(e),r=cb(t);if(!n||!r)return!n&&!r&&String(e)===String(t);try{var i=Array.isArray(e),a=Array.isArray(t);if(i&&a)return e.length===t.length&&e.every((function(e,n){return Ib(e,t[n])}));if(i||a)return!1;var o=Object.keys(e),s=Object.keys(t);return o.length===s.length&&o.every((function(n){return Ib(e[n],t[n])}))}catch(e){return!1}}function Pb(e,t){for(var n=0;n<e.length;n++)if(Ib(e[n],t))return n;return-1}function Db(e){var t=!1;return function(){t||(t=!0,e.apply(this,arguments))}}var Nb="data-server-rendered",Ub=["component","directive","filter"],Fb=["beforeCreate","created","beforeMount","mounted","beforeUpdate","updated","beforeDestroy","destroyed","activated","deactivated","errorCaptured"],Bb={optionMergeStrategies:Object.create(null),silent:!1,productionTip:!1,devtools:!1,performance:!1,errorHandler:null,warnHandler:null,ignoredElements:[],keyCodes:Object.create(null),isReservedTag:Lb,isReservedAttr:Lb,isUnknownElement:Lb,getTagNamespace:Rb,parsePlatformTagName:Ob,mustUseProp:Lb,_lifecycleHooks:Fb};function zb(e){var t=(e+"").charCodeAt(0);return 36===t||95===t}function Hb(e,t,n,r){Object.defineProperty(e,t,{value:n,enumerable:!!r,writable:!0,configurable:!0})}var Vb,Gb=/[^\w.$]/,$b="__proto__"in{},Wb="undefined"!=typeof window,jb="undefined"!=typeof WXEnvironment&&!!WXEnvironment.platform,Xb=jb&&WXEnvironment.platform.toLowerCase(),Yb=Wb&&window.navigator.userAgent.toLowerCase(),qb=Yb&&/msie|trident/.test(Yb),Kb=Yb&&Yb.indexOf("msie 9.0")>0,Zb=Yb&&Yb.indexOf("edge/")>0,Jb=(Yb&&Yb.indexOf("android"),Yb&&/iphone|ipad|ipod|ios/.test(Yb)||"ios"===Xb),Qb=(Yb&&/chrome\/\d+/.test(Yb),{}.watch),e_=!1;if(Wb)try{var t_={};Object.defineProperty(t_,"passive",{get:function(){e_=!0}}),window.addEventListener("test-passive",null,t_)}catch(e){}var n_=function(){return void 0===Vb&&(Vb=!Wb&&!jb&&void 0!==n.g&&"server"===n.g.process.env.VUE_ENV),Vb},r_=Wb&&window.__VUE_DEVTOOLS_GLOBAL_HOOK__;function i_(e){return"function"==typeof e&&/native code/.test(e.toString())}var a_,o_="undefined"!=typeof Symbol&&i_(Symbol)&&"undefined"!=typeof Reflect&&i_(Reflect.ownKeys);a_="undefined"!=typeof Set&&i_(Set)?Set:function(){function e(){this.set=Object.create(null)}return e.prototype.has=function(e){return!0===this.set[e]},e.prototype.add=function(e){this.set[e]=!0},e.prototype.clear=function(){this.set=Object.create(null)},e}();var s_=Rb,c_=0,l_=function(){this.id=c_++,this.subs=[]};l_.prototype.addSub=function(e){this.subs.push(e)},l_.prototype.removeSub=function(e){gb(this.subs,e)},l_.prototype.depend=function(){l_.target&&l_.target.addDep(this)},l_.prototype.notify=function(){for(var e=this.subs.slice(),t=0,n=e.length;t<n;t++)e[t].update()},l_.target=null;var u_=[];function d_(e){l_.target&&u_.push(l_.target),l_.target=e}function f_(){l_.target=u_.pop()}var h_=function(e,t,n,r,i,a,o,s){this.tag=e,this.data=t,this.children=n,this.text=r,this.elm=i,this.ns=void 0,this.context=a,this.fnContext=void 0,this.fnOptions=void 0,this.fnScopeId=void 0,this.key=t&&t.key,this.componentOptions=o,this.componentInstance=void 0,this.parent=void 0,this.raw=!1,this.isStatic=!1,this.isRootInsert=!0,this.isComment=!1,this.isCloned=!1,this.isOnce=!1,this.asyncFactory=s,this.asyncMeta=void 0,this.isAsyncPlaceholder=!1},p_={child:{configurable:!0}};p_.child.get=function(){return this.componentInstance},Object.defineProperties(h_.prototype,p_);var m_=function(e){void 0===e&&(e="");var t=new h_;return t.text=e,t.isComment=!0,t};function v_(e){return new h_(void 0,void 0,void 0,String(e))}function g_(e){var t=new h_(e.tag,e.data,e.children,e.text,e.elm,e.context,e.componentOptions,e.asyncFactory);return t.ns=e.ns,t.isStatic=e.isStatic,t.key=e.key,t.isComment=e.isComment,t.fnContext=e.fnContext,t.fnOptions=e.fnOptions,t.fnScopeId=e.fnScopeId,t.isCloned=!0,t}var b_=Array.prototype,__=Object.create(b_);["push","pop","shift","unshift","splice","sort","reverse"].forEach((function(e){var t=b_[e];Hb(__,e,(function(){for(var n=[],r=arguments.length;r--;)n[r]=arguments[r];var i,a=t.apply(this,n),o=this.__ob__;switch(e){case"push":case"unshift":i=n;break;case"splice":i=n.slice(2)}return i&&o.observeArray(i),o.dep.notify(),a}))}));var y_=Object.getOwnPropertyNames(__),x_=!0;function A_(e){x_=e}var w_=function(e){this.value=e,this.dep=new l_,this.vmCount=0,Hb(e,"__ob__",this),Array.isArray(e)?(($b?E_:T_)(e,__,y_),this.observeArray(e)):this.walk(e)};function E_(e,t,n){e.__proto__=t}function T_(e,t,n){for(var r=0,i=n.length;r<i;r++){var a=n[r];Hb(e,a,t[a])}}function S_(e,t){var n;if(cb(e)&&!(e instanceof h_))return _b(e,"__ob__")&&e.__ob__ instanceof w_?n=e.__ob__:x_&&!n_()&&(Array.isArray(e)||ub(e))&&Object.isExtensible(e)&&!e._isVue&&(n=new w_(e)),t&&n&&n.vmCount++,n}function C_(e,t,n,r,i){var a=new l_,o=Object.getOwnPropertyDescriptor(e,t);if(!o||!1!==o.configurable){var s=o&&o.get;s||2!==arguments.length||(n=e[t]);var c=o&&o.set,l=!i&&S_(n);Object.defineProperty(e,t,{enumerable:!0,configurable:!0,get:function(){var t=s?s.call(e):n;return l_.target&&(a.depend(),l&&(l.dep.depend(),Array.isArray(t)&&R_(t))),t},set:function(t){var r=s?s.call(e):n;t===r||t!=t&&r!=r||(c?c.call(e,t):n=t,l=!i&&S_(t),a.notify())}})}}function M_(e,t,n){if(Array.isArray(e)&&db(t))return e.length=Math.max(e.length,t),e.splice(t,1,n),n;if(t in e&&!(t in Object.prototype))return e[t]=n,n;var r=e.__ob__;return e._isVue||r&&r.vmCount?n:r?(C_(r.value,t,n),r.dep.notify(),n):(e[t]=n,n)}function k_(e,t){if(Array.isArray(e)&&db(t))e.splice(t,1);else{var n=e.__ob__;e._isVue||n&&n.vmCount||_b(e,t)&&(delete e[t],n&&n.dep.notify())}}function R_(e){for(var t=void 0,n=0,r=e.length;n<r;n++)(t=e[n])&&t.__ob__&&t.__ob__.dep.depend(),Array.isArray(t)&&R_(t)}w_.prototype.walk=function(e){for(var t=Object.keys(e),n=0;n<t.length;n++)C_(e,t[n])},w_.prototype.observeArray=function(e){for(var t=0,n=e.length;t<n;t++)S_(e[t])};var L_=Bb.optionMergeStrategies;function O_(e,t){if(!t)return e;for(var n,r,i,a=Object.keys(t),o=0;o<a.length;o++)r=e[n=a[o]],i=t[n],_b(e,n)?ub(r)&&ub(i)&&O_(r,i):M_(e,n,i);return e}function I_(e,t,n){return n?function(){var r="function"==typeof t?t.call(n,n):t,i="function"==typeof e?e.call(n,n):e;return r?O_(r,i):i}:t?e?function(){return O_("function"==typeof t?t.call(this,this):t,"function"==typeof e?e.call(this,this):e)}:t:e}function P_(e,t){return t?e?e.concat(t):Array.isArray(t)?t:[t]:e}function D_(e,t,n,r){var i=Object.create(e||null);return t?Mb(i,t):i}L_.data=function(e,t,n){return n?I_(e,t,n):t&&"function"!=typeof t?e:I_(e,t)},Fb.forEach((function(e){L_[e]=P_})),Ub.forEach((function(e){L_[e+"s"]=D_})),L_.watch=function(e,t,n,r){if(e===Qb&&(e=void 0),t===Qb&&(t=void 0),!t)return Object.create(e||null);if(!e)return t;var i={};for(var a in Mb(i,e),t){var o=i[a],s=t[a];o&&!Array.isArray(o)&&(o=[o]),i[a]=o?o.concat(s):Array.isArray(s)?s:[s]}return i},L_.props=L_.methods=L_.inject=L_.computed=function(e,t,n,r){if(!e)return t;var i=Object.create(null);return Mb(i,e),t&&Mb(i,t),i},L_.provide=I_;var N_=function(e,t){return void 0===t?e:t};function U_(e,t,n){"function"==typeof t&&(t=t.options),function(e,t){var n=e.props;if(n){var r,i,a={};if(Array.isArray(n))for(r=n.length;r--;)"string"==typeof(i=n[r])&&(a[Ab(i)]={type:null});else if(ub(n))for(var o in n)i=n[o],a[Ab(o)]=ub(i)?i:{type:i};e.props=a}}(t),function(e,t){var n=e.inject;if(n){var r=e.inject={};if(Array.isArray(n))for(var i=0;i<n.length;i++)r[n[i]]={from:n[i]};else if(ub(n))for(var a in n){var o=n[a];r[a]=ub(o)?Mb({from:a},o):{from:o}}}}(t),function(e){var t=e.directives;if(t)for(var n in t){var r=t[n];"function"==typeof r&&(t[n]={bind:r,update:r})}}(t);var r=t.extends;if(r&&(e=U_(e,r,n)),t.mixins)for(var i=0,a=t.mixins.length;i<a;i++)e=U_(e,t.mixins[i],n);var o,s={};for(o in e)c(o);for(o in t)_b(e,o)||c(o);function c(r){var i=L_[r]||N_;s[r]=i(e[r],t[r],n,r)}return s}function F_(e,t,n,r){if("string"==typeof n){var i=e[t];if(_b(i,n))return i[n];var a=Ab(n);if(_b(i,a))return i[a];var o=wb(a);return _b(i,o)?i[o]:i[n]||i[a]||i[o]}}function B_(e,t,n,r){var i=t[e],a=!_b(n,e),o=n[e],s=V_(Boolean,i.type);if(s>-1)if(a&&!_b(i,"default"))o=!1;else if(""===o||o===Tb(e)){var c=V_(String,i.type);(c<0||s<c)&&(o=!0)}if(void 0===o){o=function(e,t,n){if(_b(t,"default")){var r=t.default;return e&&e.$options.propsData&&void 0===e.$options.propsData[n]&&void 0!==e._props[n]?e._props[n]:"function"==typeof r&&"Function"!==z_(t.type)?r.call(e):r}}(r,i,e);var l=x_;A_(!0),S_(o),A_(l)}return o}function z_(e){var t=e&&e.toString().match(/^\s*function (\w+)/);return t?t[1]:""}function H_(e,t){return z_(e)===z_(t)}function V_(e,t){if(!Array.isArray(t))return H_(t,e)?0:-1;for(var n=0,r=t.length;n<r;n++)if(H_(t[n],e))return n;return-1}function G_(e,t,n){if(t)for(var r=t;r=r.$parent;){var i=r.$options.errorCaptured;if(i)for(var a=0;a<i.length;a++)try{if(!1===i[a].call(r,e,t,n))return}catch(e){$_(e,r,"errorCaptured hook")}}$_(e,t,n)}function $_(e,t,n){if(Bb.errorHandler)try{return Bb.errorHandler.call(null,e,t,n)}catch(e){W_(e)}W_(e)}function W_(e,t,n){if(!Wb&&!jb||"undefined"==typeof console)throw e;console.error(e)}var j_,X_,Y_=[],q_=!1;function K_(){q_=!1;var e=Y_.slice(0);Y_.length=0;for(var t=0;t<e.length;t++)e[t]()}var Z_=!1;if("undefined"!=typeof setImmediate&&i_(setImmediate))X_=function(){setImmediate(K_)};else if("undefined"==typeof MessageChannel||!i_(MessageChannel)&&"[object MessageChannelConstructor]"!==MessageChannel.toString())X_=function(){setTimeout(K_,0)};else{var J_=new MessageChannel,Q_=J_.port2;J_.port1.onmessage=K_,X_=function(){Q_.postMessage(1)}}if("undefined"!=typeof Promise&&i_(Promise)){var ey=Promise.resolve();j_=function(){ey.then(K_),Jb&&setTimeout(Rb)}}else j_=X_;function ty(e,t){var n;if(Y_.push((function(){if(e)try{e.call(t)}catch(e){G_(e,t,"nextTick")}else n&&n(t)})),q_||(q_=!0,Z_?X_():j_()),!e&&"undefined"!=typeof Promise)return new Promise((function(e){n=e}))}var ny=new a_;function ry(e){iy(e,ny),ny.clear()}function iy(e,t){var n,r,i=Array.isArray(e);if(!(!i&&!cb(e)||Object.isFrozen(e)||e instanceof h_)){if(e.__ob__){var a=e.__ob__.dep.id;if(t.has(a))return;t.add(a)}if(i)for(n=e.length;n--;)iy(e[n],t);else for(n=(r=Object.keys(e)).length;n--;)iy(e[r[n]],t)}}var ay,oy=yb((function(e){var t="&"===e.charAt(0),n="~"===(e=t?e.slice(1):e).charAt(0),r="!"===(e=n?e.slice(1):e).charAt(0);return{name:e=r?e.slice(1):e,once:n,capture:r,passive:t}}));function sy(e){function t(){var e=arguments,n=t.fns;if(!Array.isArray(n))return n.apply(null,arguments);for(var r=n.slice(),i=0;i<r.length;i++)r[i].apply(null,e)}return t.fns=e,t}function cy(e,t,n,r,i){var a,o,s,c;for(a in e)o=e[a],s=t[a],c=oy(a),ib(o)||(ib(s)?(ib(o.fns)&&(o=e[a]=sy(o)),n(c.name,o,c.once,c.capture,c.passive,c.params)):o!==s&&(s.fns=o,e[a]=s));for(a in t)ib(e[a])&&r((c=oy(a)).name,t[a],c.capture)}function ly(e,t,n){var r;e instanceof h_&&(e=e.data.hook||(e.data.hook={}));var i=e[t];function a(){n.apply(this,arguments),gb(r.fns,a)}ib(i)?r=sy([a]):ab(i.fns)&&ob(i.merged)?(r=i).fns.push(a):r=sy([i,a]),r.merged=!0,e[t]=r}function uy(e,t,n,r,i){if(ab(t)){if(_b(t,n))return e[n]=t[n],i||delete t[n],!0;if(_b(t,r))return e[n]=t[r],i||delete t[r],!0}return!1}function dy(e){return sb(e)?[v_(e)]:Array.isArray(e)?hy(e):void 0}function fy(e){return ab(e)&&ab(e.text)&&!1===e.isComment}function hy(e,t){var n,r,i,a,o=[];for(n=0;n<e.length;n++)ib(r=e[n])||"boolean"==typeof r||(a=o[i=o.length-1],Array.isArray(r)?r.length>0&&(fy((r=hy(r,(t||"")+"_"+n))[0])&&fy(a)&&(o[i]=v_(a.text+r[0].text),r.shift()),o.push.apply(o,r)):sb(r)?fy(a)?o[i]=v_(a.text+r):""!==r&&o.push(v_(r)):fy(r)&&fy(a)?o[i]=v_(a.text+r.text):(ob(e._isVList)&&ab(r.tag)&&ib(r.key)&&ab(t)&&(r.key="__vlist"+t+"_"+n+"__"),o.push(r)));return o}function py(e,t){return(e.__esModule||o_&&"Module"===e[Symbol.toStringTag])&&(e=e.default),cb(e)?t.extend(e):e}function my(e){return e.isComment&&e.asyncFactory}function vy(e){if(Array.isArray(e))for(var t=0;t<e.length;t++){var n=e[t];if(ab(n)&&(ab(n.componentOptions)||my(n)))return n}}function gy(e,t,n){n?ay.$once(e,t):ay.$on(e,t)}function by(e,t){ay.$off(e,t)}function _y(e,t,n){ay=e,cy(t,n||{},gy,by),ay=void 0}function yy(e,t){var n={};if(!e)return n;for(var r=0,i=e.length;r<i;r++){var a=e[r],o=a.data;if(o&&o.attrs&&o.attrs.slot&&delete o.attrs.slot,a.context!==t&&a.fnContext!==t||!o||null==o.slot)(n.default||(n.default=[])).push(a);else{var s=o.slot,c=n[s]||(n[s]=[]);"template"===a.tag?c.push.apply(c,a.children||[]):c.push(a)}}for(var l in n)n[l].every(xy)&&delete n[l];return n}function xy(e){return e.isComment&&!e.asyncFactory||" "===e.text}function Ay(e,t){t=t||{};for(var n=0;n<e.length;n++)Array.isArray(e[n])?Ay(e[n],t):t[e[n].key]=e[n].fn;return t}var wy=null;function Ey(e){for(;e&&(e=e.$parent);)if(e._inactive)return!0;return!1}function Ty(e,t){if(t){if(e._directInactive=!1,Ey(e))return}else if(e._directInactive)return;if(e._inactive||null===e._inactive){e._inactive=!1;for(var n=0;n<e.$children.length;n++)Ty(e.$children[n]);Cy(e,"activated")}}function Sy(e,t){if(!(t&&(e._directInactive=!0,Ey(e))||e._inactive)){e._inactive=!0;for(var n=0;n<e.$children.length;n++)Sy(e.$children[n]);Cy(e,"deactivated")}}function Cy(e,t){d_();var n=e.$options[t];if(n)for(var r=0,i=n.length;r<i;r++)try{n[r].call(e)}catch(n){G_(n,e,t+" hook")}e._hasHookEvent&&e.$emit("hook:"+t),f_()}var My=[],ky=[],Ry={},Ly=!1,Oy=!1,Iy=0;function Py(){var e,t;for(Oy=!0,My.sort((function(e,t){return e.id-t.id})),Iy=0;Iy<My.length;Iy++)t=(e=My[Iy]).id,Ry[t]=null,e.run();var n=ky.slice(),r=My.slice();Iy=My.length=ky.length=0,Ry={},Ly=Oy=!1,function(e){for(var t=0;t<e.length;t++)e[t]._inactive=!0,Ty(e[t],!0)}(n),function(e){for(var t=e.length;t--;){var n=e[t],r=n.vm;r._watcher===n&&r._isMounted&&Cy(r,"updated")}}(r),r_&&Bb.devtools&&r_.emit("flush")}var Dy=0,Ny=function(e,t,n,r,i){this.vm=e,i&&(e._watcher=this),e._watchers.push(this),r?(this.deep=!!r.deep,this.user=!!r.user,this.lazy=!!r.lazy,this.sync=!!r.sync):this.deep=this.user=this.lazy=this.sync=!1,this.cb=n,this.id=++Dy,this.active=!0,this.dirty=this.lazy,this.deps=[],this.newDeps=[],this.depIds=new a_,this.newDepIds=new a_,this.expression="","function"==typeof t?this.getter=t:(this.getter=function(e){if(!Gb.test(e)){var t=e.split(".");return function(e){for(var n=0;n<t.length;n++){if(!e)return;e=e[t[n]]}return e}}}(t),this.getter||(this.getter=function(){})),this.value=this.lazy?void 0:this.get()};Ny.prototype.get=function(){var e;d_(this);var t=this.vm;try{e=this.getter.call(t,t)}catch(e){if(!this.user)throw e;G_(e,t,'getter for watcher "'+this.expression+'"')}finally{this.deep&&ry(e),f_(),this.cleanupDeps()}return e},Ny.prototype.addDep=function(e){var t=e.id;this.newDepIds.has(t)||(this.newDepIds.add(t),this.newDeps.push(e),this.depIds.has(t)||e.addSub(this))},Ny.prototype.cleanupDeps=function(){for(var e=this,t=this.deps.length;t--;){var n=e.deps[t];e.newDepIds.has(n.id)||n.removeSub(e)}var r=this.depIds;this.depIds=this.newDepIds,this.newDepIds=r,this.newDepIds.clear(),r=this.deps,this.deps=this.newDeps,this.newDeps=r,this.newDeps.length=0},Ny.prototype.update=function(){this.lazy?this.dirty=!0:this.sync?this.run():function(e){var t=e.id;if(null==Ry[t]){if(Ry[t]=!0,Oy){for(var n=My.length-1;n>Iy&&My[n].id>e.id;)n--;My.splice(n+1,0,e)}else My.push(e);Ly||(Ly=!0,ty(Py))}}(this)},Ny.prototype.run=function(){if(this.active){var e=this.get();if(e!==this.value||cb(e)||this.deep){var t=this.value;if(this.value=e,this.user)try{this.cb.call(this.vm,e,t)}catch(e){G_(e,this.vm,'callback for watcher "'+this.expression+'"')}else this.cb.call(this.vm,e,t)}}},Ny.prototype.evaluate=function(){this.value=this.get(),this.dirty=!1},Ny.prototype.depend=function(){for(var e=this.deps.length;e--;)this.deps[e].depend()},Ny.prototype.teardown=function(){if(this.active){this.vm._isBeingDestroyed||gb(this.vm._watchers,this);for(var e=this.deps.length;e--;)this.deps[e].removeSub(this);this.active=!1}};var Uy={enumerable:!0,configurable:!0,get:Rb,set:Rb};function Fy(e,t,n){Uy.get=function(){return this[t][n]},Uy.set=function(e){this[t][n]=e},Object.defineProperty(e,n,Uy)}var By={lazy:!0};function zy(e,t,n){var r=!n_();"function"==typeof n?(Uy.get=r?Hy(t):n,Uy.set=Rb):(Uy.get=n.get?r&&!1!==n.cache?Hy(t):n.get:Rb,Uy.set=n.set?n.set:Rb),Object.defineProperty(e,t,Uy)}function Hy(e){return function(){var t=this._computedWatchers&&this._computedWatchers[e];if(t)return t.dirty&&t.evaluate(),l_.target&&t.depend(),t.value}}function Vy(e,t,n,r){return ub(n)&&(r=n,n=n.handler),"string"==typeof n&&(n=e[n]),e.$watch(t,n,r)}function Gy(e,t){if(e){for(var n=Object.create(null),r=o_?Reflect.ownKeys(e).filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable})):Object.keys(e),i=0;i<r.length;i++){for(var a=r[i],o=e[a].from,s=t;s;){if(s._provided&&_b(s._provided,o)){n[a]=s._provided[o];break}s=s.$parent}if(!s&&"default"in e[a]){var c=e[a].default;n[a]="function"==typeof c?c.call(t):c}}return n}}function $y(e,t){var n,r,i,a,o;if(Array.isArray(e)||"string"==typeof e)for(n=new Array(e.length),r=0,i=e.length;r<i;r++)n[r]=t(e[r],r);else if("number"==typeof e)for(n=new Array(e),r=0;r<e;r++)n[r]=t(r+1,r);else if(cb(e))for(a=Object.keys(e),n=new Array(a.length),r=0,i=a.length;r<i;r++)o=a[r],n[r]=t(e[o],o,r);return ab(n)&&(n._isVList=!0),n}function Wy(e,t,n,r){var i,a=this.$scopedSlots[e];if(a)n=n||{},r&&(n=Mb(Mb({},r),n)),i=a(n)||t;else{var o=this.$slots[e];o&&(o._rendered=!0),i=o||t}var s=n&&n.slot;return s?this.$createElement("template",{slot:s},i):i}function jy(e){return F_(this.$options,"filters",e)||Ob}function Xy(e,t){return Array.isArray(e)?-1===e.indexOf(t):e!==t}function Yy(e,t,n,r,i){var a=Bb.keyCodes[t]||n;return i&&r&&!Bb.keyCodes[t]?Xy(i,r):a?Xy(a,e):r?Tb(r)!==t:void 0}function qy(e,t,n,r,i){if(n&&cb(n)){var a;Array.isArray(n)&&(n=kb(n));var o=function(o){if("class"===o||"style"===o||vb(o))a=e;else{var s=e.attrs&&e.attrs.type;a=r||Bb.mustUseProp(t,s,o)?e.domProps||(e.domProps={}):e.attrs||(e.attrs={})}o in a||(a[o]=n[o],i&&((e.on||(e.on={}))["update:"+o]=function(e){n[o]=e}))};for(var s in n)o(s)}return e}function Ky(e,t){var n=this._staticTrees||(this._staticTrees=[]),r=n[e];return r&&!t||Jy(r=n[e]=this.$options.staticRenderFns[e].call(this._renderProxy,null,this),"__static__"+e,!1),r}function Zy(e,t,n){return Jy(e,"__once__"+t+(n?"_"+n:""),!0),e}function Jy(e,t,n){if(Array.isArray(e))for(var r=0;r<e.length;r++)e[r]&&"string"!=typeof e[r]&&Qy(e[r],t+"_"+r,n);else Qy(e,t,n)}function Qy(e,t,n){e.isStatic=!0,e.key=t,e.isOnce=n}function ex(e,t){if(t&&ub(t)){var n=e.on=e.on?Mb({},e.on):{};for(var r in t){var i=n[r],a=t[r];n[r]=i?[].concat(i,a):a}}return e}function tx(e){e._o=Zy,e._n=hb,e._s=fb,e._l=$y,e._t=Wy,e._q=Ib,e._i=Pb,e._m=Ky,e._f=jy,e._k=Yy,e._b=qy,e._v=v_,e._e=m_,e._u=Ay,e._g=ex}function nx(e,t,n,r,i){var a,o=i.options;_b(r,"_uid")?(a=Object.create(r))._original=r:(a=r,r=r._original);var s=ob(o._compiled),c=!s;this.data=e,this.props=t,this.children=n,this.parent=r,this.listeners=e.on||rb,this.injections=Gy(o.inject,r),this.slots=function(){return yy(n,r)},s&&(this.$options=o,this.$slots=this.slots(),this.$scopedSlots=e.scopedSlots||rb),o._scopeId?this._c=function(e,t,n,i){var s=ux(a,e,t,n,i,c);return s&&!Array.isArray(s)&&(s.fnScopeId=o._scopeId,s.fnContext=r),s}:this._c=function(e,t,n,r){return ux(a,e,t,n,r,c)}}function rx(e,t,n,r){var i=g_(e);return i.fnContext=n,i.fnOptions=r,t.slot&&((i.data||(i.data={})).slot=t.slot),i}function ix(e,t){for(var n in t)e[Ab(n)]=t[n]}tx(nx.prototype);var ax={init:function(e,t,n,r){if(e.componentInstance&&!e.componentInstance._isDestroyed&&e.data.keepAlive){var i=e;ax.prepatch(i,i)}else{var a=e.componentInstance=function(e,t,n,r){var i={_isComponent:!0,parent:t,_parentVnode:e,_parentElm:n||null,_refElm:r||null},a=e.data.inlineTemplate;return ab(a)&&(i.render=a.render,i.staticRenderFns=a.staticRenderFns),new e.componentOptions.Ctor(i)}(e,wy,n,r);a.$mount(t?e.elm:void 0,t)}},prepatch:function(e,t){var n=t.componentOptions;!function(e,t,n,r,i){var a=!!(i||e.$options._renderChildren||r.data.scopedSlots||e.$scopedSlots!==rb);if(e.$options._parentVnode=r,e.$vnode=r,e._vnode&&(e._vnode.parent=r),e.$options._renderChildren=i,e.$attrs=r.data.attrs||rb,e.$listeners=n||rb,t&&e.$options.props){A_(!1);for(var o=e._props,s=e.$options._propKeys||[],c=0;c<s.length;c++){var l=s[c],u=e.$options.props;o[l]=B_(l,u,t,e)}A_(!0),e.$options.propsData=t}n=n||rb;var d=e.$options._parentListeners;e.$options._parentListeners=n,_y(e,n,d),a&&(e.$slots=yy(i,r.context),e.$forceUpdate())}(t.componentInstance=e.componentInstance,n.propsData,n.listeners,t,n.children)},insert:function(e){var t,n=e.context,r=e.componentInstance;r._isMounted||(r._isMounted=!0,Cy(r,"mounted")),e.data.keepAlive&&(n._isMounted?((t=r)._inactive=!1,ky.push(t)):Ty(r,!0))},destroy:function(e){var t=e.componentInstance;t._isDestroyed||(e.data.keepAlive?Sy(t,!0):t.$destroy())}},ox=Object.keys(ax);function sx(e,t,n,r,i){if(!ib(e)){var a=n.$options._base;if(cb(e)&&(e=a.extend(e)),"function"==typeof e){var o;if(ib(e.cid)&&(e=function(e,t,n){if(ob(e.error)&&ab(e.errorComp))return e.errorComp;if(ab(e.resolved))return e.resolved;if(ob(e.loading)&&ab(e.loadingComp))return e.loadingComp;if(!ab(e.contexts)){var r=e.contexts=[n],i=!0,a=function(){for(var e=0,t=r.length;e<t;e++)r[e].$forceUpdate()},o=Db((function(n){e.resolved=py(n,t),i||a()})),s=Db((function(t){ab(e.errorComp)&&(e.error=!0,a())})),c=e(o,s);return cb(c)&&("function"==typeof c.then?ib(e.resolved)&&c.then(o,s):ab(c.component)&&"function"==typeof c.component.then&&(c.component.then(o,s),ab(c.error)&&(e.errorComp=py(c.error,t)),ab(c.loading)&&(e.loadingComp=py(c.loading,t),0===c.delay?e.loading=!0:setTimeout((function(){ib(e.resolved)&&ib(e.error)&&(e.loading=!0,a())}),c.delay||200)),ab(c.timeout)&&setTimeout((function(){ib(e.resolved)&&s(null)}),c.timeout))),i=!1,e.loading?e.loadingComp:e.resolved}e.contexts.push(n)}(o=e,a,n),void 0===e))return function(e,t,n,r,i){var a=m_();return a.asyncFactory=e,a.asyncMeta={data:t,context:n,children:r,tag:i},a}(o,t,n,r,i);t=t||{},hx(e),ab(t.model)&&function(e,t){var n=e.model&&e.model.prop||"value",r=e.model&&e.model.event||"input";(t.props||(t.props={}))[n]=t.model.value;var i=t.on||(t.on={});ab(i[r])?i[r]=[t.model.callback].concat(i[r]):i[r]=t.model.callback}(e.options,t);var s=function(e,t,n){var r=t.options.props;if(!ib(r)){var i={},a=e.attrs,o=e.props;if(ab(a)||ab(o))for(var s in r){var c=Tb(s);uy(i,o,s,c,!0)||uy(i,a,s,c,!1)}return i}}(t,e);if(ob(e.options.functional))return function(e,t,n,r,i){var a=e.options,o={},s=a.props;if(ab(s))for(var c in s)o[c]=B_(c,s,t||rb);else ab(n.attrs)&&ix(o,n.attrs),ab(n.props)&&ix(o,n.props);var l=new nx(n,o,i,r,e),u=a.render.call(null,l._c,l);if(u instanceof h_)return rx(u,n,l.parent,a);if(Array.isArray(u)){for(var d=dy(u)||[],f=new Array(d.length),h=0;h<d.length;h++)f[h]=rx(d[h],n,l.parent,a);return f}}(e,s,t,n,r);var c=t.on;if(t.on=t.nativeOn,ob(e.options.abstract)){var l=t.slot;t={},l&&(t.slot=l)}!function(e){for(var t=e.hook||(e.hook={}),n=0;n<ox.length;n++){var r=ox[n];t[r]=ax[r]}}(t);var u=e.options.name||i;return new h_("vue-component-"+e.cid+(u?"-"+u:""),t,void 0,void 0,void 0,n,{Ctor:e,propsData:s,listeners:c,tag:i,children:r},o)}}}var cx=1,lx=2;function ux(e,t,n,r,i,a){return(Array.isArray(n)||sb(n))&&(i=r,r=n,n=void 0),ob(a)&&(i=lx),function(e,t,n,r,i){if(ab(n)&&ab(n.__ob__))return m_();if(ab(n)&&ab(n.is)&&(t=n.is),!t)return m_();var a,o,s;(Array.isArray(r)&&"function"==typeof r[0]&&((n=n||{}).scopedSlots={default:r[0]},r.length=0),i===lx?r=dy(r):i===cx&&(r=function(e){for(var t=0;t<e.length;t++)if(Array.isArray(e[t]))return Array.prototype.concat.apply([],e);return e}(r)),"string"==typeof t)?(o=e.$vnode&&e.$vnode.ns||Bb.getTagNamespace(t),a=Bb.isReservedTag(t)?new h_(Bb.parsePlatformTagName(t),n,r,void 0,void 0,e):ab(s=F_(e.$options,"components",t))?sx(s,n,e,r,t):new h_(t,n,r,void 0,void 0,e)):a=sx(t,n,e,r);return Array.isArray(a)?a:ab(a)?(ab(o)&&dx(a,o),ab(n)&&function(e){cb(e.style)&&ry(e.style),cb(e.class)&&ry(e.class)}(n),a):m_()}(e,t,n,r,i)}function dx(e,t,n){if(e.ns=t,"foreignObject"===e.tag&&(t=void 0,n=!0),ab(e.children))for(var r=0,i=e.children.length;r<i;r++){var a=e.children[r];ab(a.tag)&&(ib(a.ns)||ob(n)&&"svg"!==a.tag)&&dx(a,t,n)}}var fx=0;function hx(e){var t=e.options;if(e.super){var n=hx(e.super);if(n!==e.superOptions){e.superOptions=n;var r=function(e){var t,n=e.options,r=e.extendOptions,i=e.sealedOptions;for(var a in n)n[a]!==i[a]&&(t||(t={}),t[a]=px(n[a],r[a],i[a]));return t}(e);r&&Mb(e.extendOptions,r),(t=e.options=U_(n,e.extendOptions)).name&&(t.components[t.name]=e)}}return t}function px(e,t,n){if(Array.isArray(e)){var r=[];n=Array.isArray(n)?n:[n],t=Array.isArray(t)?t:[t];for(var i=0;i<e.length;i++)(t.indexOf(e[i])>=0||n.indexOf(e[i])<0)&&r.push(e[i]);return r}return e}function mx(e){this._init(e)}function vx(e){return e&&(e.Ctor.options.name||e.tag)}function gx(e,t){return Array.isArray(e)?e.indexOf(t)>-1:"string"==typeof e?e.split(",").indexOf(t)>-1:(n=e,!("[object RegExp]"!==lb.call(n))&&e.test(t));var n}function bx(e,t){var n=e.cache,r=e.keys,i=e._vnode;for(var a in n){var o=n[a];if(o){var s=vx(o.componentOptions);s&&!t(s)&&_x(n,a,r,i)}}}function _x(e,t,n,r){var i=e[t];!i||r&&i.tag===r.tag||i.componentInstance.$destroy(),e[t]=null,gb(n,t)}!function(e){e.prototype._init=function(e){var t=this;t._uid=fx++,t._isVue=!0,e&&e._isComponent?function(e,t){var n=e.$options=Object.create(e.constructor.options),r=t._parentVnode;n.parent=t.parent,n._parentVnode=r,n._parentElm=t._parentElm,n._refElm=t._refElm;var i=r.componentOptions;n.propsData=i.propsData,n._parentListeners=i.listeners,n._renderChildren=i.children,n._componentTag=i.tag,t.render&&(n.render=t.render,n.staticRenderFns=t.staticRenderFns)}(t,e):t.$options=U_(hx(t.constructor),e||{},t),t._renderProxy=t,t._self=t,function(e){var t=e.$options,n=t.parent;if(n&&!t.abstract){for(;n.$options.abstract&&n.$parent;)n=n.$parent;n.$children.push(e)}e.$parent=n,e.$root=n?n.$root:e,e.$children=[],e.$refs={},e._watcher=null,e._inactive=null,e._directInactive=!1,e._isMounted=!1,e._isDestroyed=!1,e._isBeingDestroyed=!1}(t),function(e){e._events=Object.create(null),e._hasHookEvent=!1;var t=e.$options._parentListeners;t&&_y(e,t)}(t),function(e){e._vnode=null,e._staticTrees=null;var t=e.$options,n=e.$vnode=t._parentVnode,r=n&&n.context;e.$slots=yy(t._renderChildren,r),e.$scopedSlots=rb,e._c=function(t,n,r,i){return ux(e,t,n,r,i,!1)},e.$createElement=function(t,n,r,i){return ux(e,t,n,r,i,!0)};var i=n&&n.data;C_(e,"$attrs",i&&i.attrs||rb,null,!0),C_(e,"$listeners",t._parentListeners||rb,null,!0)}(t),Cy(t,"beforeCreate"),function(e){var t=Gy(e.$options.inject,e);t&&(A_(!1),Object.keys(t).forEach((function(n){C_(e,n,t[n])})),A_(!0))}(t),function(e){e._watchers=[];var t=e.$options;t.props&&function(e,t){var n=e.$options.propsData||{},r=e._props={},i=e.$options._propKeys=[];!e.$parent||A_(!1);var a=function(a){i.push(a);var o=B_(a,t,n,e);C_(r,a,o),a in e||Fy(e,"_props",a)};for(var o in t)a(o);A_(!0)}(e,t.props),t.methods&&function(e,t){for(var n in e.$options.props,t)e[n]=null==t[n]?Rb:Sb(t[n],e)}(e,t.methods),t.data?function(e){var t=e.$options.data;ub(t=e._data="function"==typeof t?function(e,t){d_();try{return e.call(t,t)}catch(e){return G_(e,t,"data()"),{}}finally{f_()}}(t,e):t||{})||(t={});for(var n=Object.keys(t),r=e.$options.props,i=(e.$options.methods,n.length);i--;){var a=n[i];r&&_b(r,a)||zb(a)||Fy(e,"_data",a)}S_(t,!0)}(e):S_(e._data={},!0),t.computed&&function(e,t){var n=e._computedWatchers=Object.create(null),r=n_();for(var i in t){var a=t[i],o="function"==typeof a?a:a.get;r||(n[i]=new Ny(e,o||Rb,Rb,By)),i in e||zy(e,i,a)}}(e,t.computed),t.watch&&t.watch!==Qb&&function(e,t){for(var n in t){var r=t[n];if(Array.isArray(r))for(var i=0;i<r.length;i++)Vy(e,n,r[i]);else Vy(e,n,r)}}(e,t.watch)}(t),function(e){var t=e.$options.provide;t&&(e._provided="function"==typeof t?t.call(e):t)}(t),Cy(t,"created"),t.$options.el&&t.$mount(t.$options.el)}}(mx),function(e){Object.defineProperty(e.prototype,"$data",{get:function(){return this._data}}),Object.defineProperty(e.prototype,"$props",{get:function(){return this._props}}),e.prototype.$set=M_,e.prototype.$delete=k_,e.prototype.$watch=function(e,t,n){var r=this;if(ub(t))return Vy(r,e,t,n);(n=n||{}).user=!0;var i=new Ny(r,e,t,n);return n.immediate&&t.call(r,i.value),function(){i.teardown()}}}(mx),function(e){var t=/^hook:/;e.prototype.$on=function(e,n){var r=this;if(Array.isArray(e))for(var i=0,a=e.length;i<a;i++)this.$on(e[i],n);else(r._events[e]||(r._events[e]=[])).push(n),t.test(e)&&(r._hasHookEvent=!0);return r},e.prototype.$once=function(e,t){var n=this;function r(){n.$off(e,r),t.apply(n,arguments)}return r.fn=t,n.$on(e,r),n},e.prototype.$off=function(e,t){var n=this;if(!arguments.length)return n._events=Object.create(null),n;if(Array.isArray(e)){for(var r=0,i=e.length;r<i;r++)this.$off(e[r],t);return n}var a=n._events[e];if(!a)return n;if(!t)return n._events[e]=null,n;if(t)for(var o,s=a.length;s--;)if((o=a[s])===t||o.fn===t){a.splice(s,1);break}return n},e.prototype.$emit=function(e){var t=this,n=t._events[e];if(n){n=n.length>1?Cb(n):n;for(var r=Cb(arguments,1),i=0,a=n.length;i<a;i++)try{n[i].apply(t,r)}catch(n){G_(n,t,'event handler for "'+e+'"')}}return t}}(mx),function(e){e.prototype._update=function(e,t){var n=this;n._isMounted&&Cy(n,"beforeUpdate");var r=n.$el,i=n._vnode,a=wy;wy=n,n._vnode=e,i?n.$el=n.__patch__(i,e):(n.$el=n.__patch__(n.$el,e,t,!1,n.$options._parentElm,n.$options._refElm),n.$options._parentElm=n.$options._refElm=null),wy=a,r&&(r.__vue__=null),n.$el&&(n.$el.__vue__=n),n.$vnode&&n.$parent&&n.$vnode===n.$parent._vnode&&(n.$parent.$el=n.$el)},e.prototype.$forceUpdate=function(){this._watcher&&this._watcher.update()},e.prototype.$destroy=function(){var e=this;if(!e._isBeingDestroyed){Cy(e,"beforeDestroy"),e._isBeingDestroyed=!0;var t=e.$parent;!t||t._isBeingDestroyed||e.$options.abstract||gb(t.$children,e),e._watcher&&e._watcher.teardown();for(var n=e._watchers.length;n--;)e._watchers[n].teardown();e._data.__ob__&&e._data.__ob__.vmCount--,e._isDestroyed=!0,e.__patch__(e._vnode,null),Cy(e,"destroyed"),e.$off(),e.$el&&(e.$el.__vue__=null),e.$vnode&&(e.$vnode.parent=null)}}}(mx),function(e){tx(e.prototype),e.prototype.$nextTick=function(e){return ty(e,this)},e.prototype._render=function(){var e,t=this,n=t.$options,r=n.render,i=n._parentVnode;i&&(t.$scopedSlots=i.data.scopedSlots||rb),t.$vnode=i;try{e=r.call(t._renderProxy,t.$createElement)}catch(n){G_(n,t,"render"),e=t._vnode}return e instanceof h_||(e=m_()),e.parent=i,e}}(mx);var yx=[String,RegExp,Array],xx={name:"keep-alive",abstract:!0,props:{include:yx,exclude:yx,max:[String,Number]},created:function(){this.cache=Object.create(null),this.keys=[]},destroyed:function(){var e=this;for(var t in e.cache)_x(e.cache,t,e.keys)},mounted:function(){var e=this;this.$watch("include",(function(t){bx(e,(function(e){return gx(t,e)}))})),this.$watch("exclude",(function(t){bx(e,(function(e){return!gx(t,e)}))}))},render:function(){var e=this.$slots.default,t=vy(e),n=t&&t.componentOptions;if(n){var r=vx(n),i=this.include,a=this.exclude;if(i&&(!r||!gx(i,r))||a&&r&&gx(a,r))return t;var o=this.cache,s=this.keys,c=null==t.key?n.Ctor.cid+(n.tag?"::"+n.tag:""):t.key;o[c]?(t.componentInstance=o[c].componentInstance,gb(s,c),s.push(c)):(o[c]=t,s.push(c),this.max&&s.length>parseInt(this.max)&&_x(o,s[0],s,this._vnode)),t.data.keepAlive=!0}return t||e&&e[0]}},Ax={KeepAlive:xx};!function(e){var t={get:function(){return Bb}};Object.defineProperty(e,"config",t),e.util={warn:s_,extend:Mb,mergeOptions:U_,defineReactive:C_},e.set=M_,e.delete=k_,e.nextTick=ty,e.options=Object.create(null),Ub.forEach((function(t){e.options[t+"s"]=Object.create(null)})),e.options._base=e,Mb(e.options.components,Ax),function(e){e.use=function(e){var t=this._installedPlugins||(this._installedPlugins=[]);if(t.indexOf(e)>-1)return this;var n=Cb(arguments,1);return n.unshift(this),"function"==typeof e.install?e.install.apply(e,n):"function"==typeof e&&e.apply(null,n),t.push(e),this}}(e),function(e){e.mixin=function(e){return this.options=U_(this.options,e),this}}(e),function(e){e.cid=0;var t=1;e.extend=function(e){e=e||{};var n=this,r=n.cid,i=e._Ctor||(e._Ctor={});if(i[r])return i[r];var a=e.name||n.options.name,o=function(e){this._init(e)};return(o.prototype=Object.create(n.prototype)).constructor=o,o.cid=t++,o.options=U_(n.options,e),o.super=n,o.options.props&&function(e){var t=e.options.props;for(var n in t)Fy(e.prototype,"_props",n)}(o),o.options.computed&&function(e){var t=e.options.computed;for(var n in t)zy(e.prototype,n,t[n])}(o),o.extend=n.extend,o.mixin=n.mixin,o.use=n.use,Ub.forEach((function(e){o[e]=n[e]})),a&&(o.options.components[a]=o),o.superOptions=n.options,o.extendOptions=e,o.sealedOptions=Mb({},o.options),i[r]=o,o}}(e),function(e){Ub.forEach((function(t){e[t]=function(e,n){return n?("component"===t&&ub(n)&&(n.name=n.name||e,n=this.options._base.extend(n)),"directive"===t&&"function"==typeof n&&(n={bind:n,update:n}),this.options[t+"s"][e]=n,n):this.options[t+"s"][e]}}))}(e)}(mx),Object.defineProperty(mx.prototype,"$isServer",{get:n_}),Object.defineProperty(mx.prototype,"$ssrContext",{get:function(){return this.$vnode&&this.$vnode.ssrContext}}),Object.defineProperty(mx,"FunctionalRenderContext",{value:nx}),mx.version="2.5.17";var wx=pb("style,class"),Ex=pb("input,textarea,option,select,progress"),Tx=function(e,t,n){return"value"===n&&Ex(e)&&"button"!==t||"selected"===n&&"option"===e||"checked"===n&&"input"===e||"muted"===n&&"video"===e},Sx=pb("contenteditable,draggable,spellcheck"),Cx=pb("allowfullscreen,async,autofocus,autoplay,checked,compact,controls,declare,default,defaultchecked,defaultmuted,defaultselected,defer,disabled,enabled,formnovalidate,hidden,indeterminate,inert,ismap,itemscope,loop,multiple,muted,nohref,noresize,noshade,novalidate,nowrap,open,pauseonexit,readonly,required,reversed,scoped,seamless,selected,sortable,translate,truespeed,typemustmatch,visible"),Mx="http://www.w3.org/1999/xlink",kx=function(e){return":"===e.charAt(5)&&"xlink"===e.slice(0,5)},Rx=function(e){return kx(e)?e.slice(6,e.length):""},Lx=function(e){return null==e||!1===e};function Ox(e,t){return{staticClass:Ix(e.staticClass,t.staticClass),class:ab(e.class)?[e.class,t.class]:t.class}}function Ix(e,t){return e?t?e+" "+t:e:t||""}function Px(e){return Array.isArray(e)?function(e){for(var t,n="",r=0,i=e.length;r<i;r++)ab(t=Px(e[r]))&&""!==t&&(n&&(n+=" "),n+=t);return n}(e):cb(e)?function(e){var t="";for(var n in e)e[n]&&(t&&(t+=" "),t+=n);return t}(e):"string"==typeof e?e:""}var Dx={svg:"http://www.w3.org/2000/svg",math:"http://www.w3.org/1998/Math/MathML"},Nx=pb("html,body,base,head,link,meta,style,title,address,article,aside,footer,header,h1,h2,h3,h4,h5,h6,hgroup,nav,section,div,dd,dl,dt,figcaption,figure,picture,hr,img,li,main,ol,p,pre,ul,a,b,abbr,bdi,bdo,br,cite,code,data,dfn,em,i,kbd,mark,q,rp,rt,rtc,ruby,s,samp,small,span,strong,sub,sup,time,u,var,wbr,area,audio,map,track,video,embed,object,param,source,canvas,script,noscript,del,ins,caption,col,colgroup,table,thead,tbody,td,th,tr,button,datalist,fieldset,form,input,label,legend,meter,optgroup,option,output,progress,select,textarea,details,dialog,menu,menuitem,summary,content,element,shadow,template,blockquote,iframe,tfoot"),Ux=pb("svg,animate,circle,clippath,cursor,defs,desc,ellipse,filter,font-face,foreignObject,g,glyph,image,line,marker,mask,missing-glyph,path,pattern,polygon,polyline,rect,switch,symbol,text,textpath,tspan,use,view",!0),Fx=function(e){return Nx(e)||Ux(e)};function Bx(e){return Ux(e)?"svg":"math"===e?"math":void 0}var zx=Object.create(null),Hx=pb("text,number,password,search,email,tel,url");function Vx(e){return"string"==typeof e?document.querySelector(e)||document.createElement("div"):e}var Gx=Object.freeze({createElement:function(e,t){var n=document.createElement(e);return"select"!==e||t.data&&t.data.attrs&&void 0!==t.data.attrs.multiple&&n.setAttribute("multiple","multiple"),n},createElementNS:function(e,t){return document.createElementNS(Dx[e],t)},createTextNode:function(e){return document.createTextNode(e)},createComment:function(e){return document.createComment(e)},insertBefore:function(e,t,n){e.insertBefore(t,n)},removeChild:function(e,t){e.removeChild(t)},appendChild:function(e,t){e.appendChild(t)},parentNode:function(e){return e.parentNode},nextSibling:function(e){return e.nextSibling},tagName:function(e){return e.tagName},setTextContent:function(e,t){e.textContent=t},setStyleScope:function(e,t){e.setAttribute(t,"")}}),$x={create:function(e,t){Wx(t)},update:function(e,t){e.data.ref!==t.data.ref&&(Wx(e,!0),Wx(t))},destroy:function(e){Wx(e,!0)}};function Wx(e,t){var n=e.data.ref;if(ab(n)){var r=e.context,i=e.componentInstance||e.elm,a=r.$refs;t?Array.isArray(a[n])?gb(a[n],i):a[n]===i&&(a[n]=void 0):e.data.refInFor?Array.isArray(a[n])?a[n].indexOf(i)<0&&a[n].push(i):a[n]=[i]:a[n]=i}}var jx=new h_("",{},[]),Xx=["create","activate","update","remove","destroy"];function Yx(e,t){return e.key===t.key&&(e.tag===t.tag&&e.isComment===t.isComment&&ab(e.data)===ab(t.data)&&function(e,t){if("input"!==e.tag)return!0;var n,r=ab(n=e.data)&&ab(n=n.attrs)&&n.type,i=ab(n=t.data)&&ab(n=n.attrs)&&n.type;return r===i||Hx(r)&&Hx(i)}(e,t)||ob(e.isAsyncPlaceholder)&&e.asyncFactory===t.asyncFactory&&ib(t.asyncFactory.error))}function qx(e,t,n){var r,i,a={};for(r=t;r<=n;++r)ab(i=e[r].key)&&(a[i]=r);return a}var Kx={create:Zx,update:Zx,destroy:function(e){Zx(e,jx)}};function Zx(e,t){(e.data.directives||t.data.directives)&&function(e,t){var n,r,i,a=e===jx,o=t===jx,s=Qx(e.data.directives,e.context),c=Qx(t.data.directives,t.context),l=[],u=[];for(n in c)r=s[n],i=c[n],r?(i.oldValue=r.value,tA(i,"update",t,e),i.def&&i.def.componentUpdated&&u.push(i)):(tA(i,"bind",t,e),i.def&&i.def.inserted&&l.push(i));if(l.length){var d=function(){for(var n=0;n<l.length;n++)tA(l[n],"inserted",t,e)};a?ly(t,"insert",d):d()}if(u.length&&ly(t,"postpatch",(function(){for(var n=0;n<u.length;n++)tA(u[n],"componentUpdated",t,e)})),!a)for(n in s)c[n]||tA(s[n],"unbind",e,e,o)}(e,t)}var Jx=Object.create(null);function Qx(e,t){var n,r,i=Object.create(null);if(!e)return i;for(n=0;n<e.length;n++)(r=e[n]).modifiers||(r.modifiers=Jx),i[eA(r)]=r,r.def=F_(t.$options,"directives",r.name);return i}function eA(e){return e.rawName||e.name+"."+Object.keys(e.modifiers||{}).join(".")}function tA(e,t,n,r,i){var a=e.def&&e.def[t];if(a)try{a(n.elm,e,n,r,i)}catch(r){G_(r,n.context,"directive "+e.name+" "+t+" hook")}}var nA=[$x,Kx];function rA(e,t){var n=t.componentOptions;if(!(ab(n)&&!1===n.Ctor.options.inheritAttrs||ib(e.data.attrs)&&ib(t.data.attrs))){var r,i,a=t.elm,o=e.data.attrs||{},s=t.data.attrs||{};for(r in ab(s.__ob__)&&(s=t.data.attrs=Mb({},s)),s)i=s[r],o[r]!==i&&iA(a,r,i);for(r in(qb||Zb)&&s.value!==o.value&&iA(a,"value",s.value),o)ib(s[r])&&(kx(r)?a.removeAttributeNS(Mx,Rx(r)):Sx(r)||a.removeAttribute(r))}}function iA(e,t,n){e.tagName.indexOf("-")>-1?aA(e,t,n):Cx(t)?Lx(n)?e.removeAttribute(t):(n="allowfullscreen"===t&&"EMBED"===e.tagName?"true":t,e.setAttribute(t,n)):Sx(t)?e.setAttribute(t,Lx(n)||"false"===n?"false":"true"):kx(t)?Lx(n)?e.removeAttributeNS(Mx,Rx(t)):e.setAttributeNS(Mx,t,n):aA(e,t,n)}function aA(e,t,n){if(Lx(n))e.removeAttribute(t);else{if(qb&&!Kb&&"TEXTAREA"===e.tagName&&"placeholder"===t&&!e.__ieph){var r=function(t){t.stopImmediatePropagation(),e.removeEventListener("input",r)};e.addEventListener("input",r),e.__ieph=!0}e.setAttribute(t,n)}}var oA={create:rA,update:rA};function sA(e,t){var n=t.elm,r=t.data,i=e.data;if(!(ib(r.staticClass)&&ib(r.class)&&(ib(i)||ib(i.staticClass)&&ib(i.class)))){var a=function(e){for(var t=e.data,n=e,r=e;ab(r.componentInstance);)(r=r.componentInstance._vnode)&&r.data&&(t=Ox(r.data,t));for(;ab(n=n.parent);)n&&n.data&&(t=Ox(t,n.data));return i=t.staticClass,a=t.class,ab(i)||ab(a)?Ix(i,Px(a)):"";var i,a}(t),o=n._transitionClasses;ab(o)&&(a=Ix(a,Px(o))),a!==n._prevClass&&(n.setAttribute("class",a),n._prevClass=a)}}var cA,lA,uA,dA,fA,hA,pA={create:sA,update:sA},mA=/[\w).+\-_$\]]/;function vA(e){var t,n,r,i,a,o=!1,s=!1,c=!1,l=!1,u=0,d=0,f=0,h=0;for(r=0;r<e.length;r++)if(n=t,t=e.charCodeAt(r),o)39===t&&92!==n&&(o=!1);else if(s)34===t&&92!==n&&(s=!1);else if(c)96===t&&92!==n&&(c=!1);else if(l)47===t&&92!==n&&(l=!1);else if(124!==t||124===e.charCodeAt(r+1)||124===e.charCodeAt(r-1)||u||d||f){switch(t){case 34:s=!0;break;case 39:o=!0;break;case 96:c=!0;break;case 40:f++;break;case 41:f--;break;case 91:d++;break;case 93:d--;break;case 123:u++;break;case 125:u--}if(47===t){for(var p=r-1,m=void 0;p>=0&&" "===(m=e.charAt(p));p--);m&&mA.test(m)||(l=!0)}}else void 0===i?(h=r+1,i=e.slice(0,r).trim()):v();function v(){(a||(a=[])).push(e.slice(h,r).trim()),h=r+1}if(void 0===i?i=e.slice(0,r).trim():0!==h&&v(),a)for(r=0;r<a.length;r++)i=gA(i,a[r]);return i}function gA(e,t){var n=t.indexOf("(");if(n<0)return'_f("'+t+'")('+e+")";var r=t.slice(0,n),i=t.slice(n+1);return'_f("'+r+'")('+e+(")"!==i?","+i:i)}function bA(e){console.error("[Vue compiler]: "+e)}function _A(e,t){return e?e.map((function(e){return e[t]})).filter((function(e){return e})):[]}function yA(e,t,n){(e.props||(e.props=[])).push({name:t,value:n}),e.plain=!1}function xA(e,t,n){(e.attrs||(e.attrs=[])).push({name:t,value:n}),e.plain=!1}function AA(e,t,n){e.attrsMap[t]=n,e.attrsList.push({name:t,value:n})}function wA(e,t,n,r,i,a){(e.directives||(e.directives=[])).push({name:t,rawName:n,value:r,arg:i,modifiers:a}),e.plain=!1}function EA(e,t,n,r,i,a){var o;(r=r||rb).capture&&(delete r.capture,t="!"+t),r.once&&(delete r.once,t="~"+t),r.passive&&(delete r.passive,t="&"+t),"click"===t&&(r.right?(t="contextmenu",delete r.right):r.middle&&(t="mouseup")),r.native?(delete r.native,o=e.nativeEvents||(e.nativeEvents={})):o=e.events||(e.events={});var s={value:n.trim()};r!==rb&&(s.modifiers=r);var c=o[t];Array.isArray(c)?i?c.unshift(s):c.push(s):o[t]=c?i?[s,c]:[c,s]:s,e.plain=!1}function TA(e,t,n){var r=SA(e,":"+t)||SA(e,"v-bind:"+t);if(null!=r)return vA(r);if(!1!==n){var i=SA(e,t);if(null!=i)return JSON.stringify(i)}}function SA(e,t,n){var r;if(null!=(r=e.attrsMap[t]))for(var i=e.attrsList,a=0,o=i.length;a<o;a++)if(i[a].name===t){i.splice(a,1);break}return n&&delete e.attrsMap[t],r}function CA(e,t,n){var r=n||{},i=r.number,a="$$v";r.trim&&(a="(typeof $$v === 'string'? $$v.trim(): $$v)"),i&&(a="_n("+a+")");var o=MA(t,a);e.model={value:"("+t+")",expression:'"'+t+'"',callback:"function ($$v) {"+o+"}"}}function MA(e,t){var n=function(e){if(e=e.trim(),cA=e.length,e.indexOf("[")<0||e.lastIndexOf("]")<cA-1)return(dA=e.lastIndexOf("."))>-1?{exp:e.slice(0,dA),key:'"'+e.slice(dA+1)+'"'}:{exp:e,key:null};for(lA=e,dA=fA=hA=0;!RA();)LA(uA=kA())?IA(uA):91===uA&&OA(uA);return{exp:e.slice(0,fA),key:e.slice(fA+1,hA)}}(e);return null===n.key?e+"="+t:"$set("+n.exp+", "+n.key+", "+t+")"}function kA(){return lA.charCodeAt(++dA)}function RA(){return dA>=cA}function LA(e){return 34===e||39===e}function OA(e){var t=1;for(fA=dA;!RA();)if(LA(e=kA()))IA(e);else if(91===e&&t++,93===e&&t--,0===t){hA=dA;break}}function IA(e){for(var t=e;!RA()&&(e=kA())!==t;);}var PA,DA="__r",NA="__c";function UA(e,t,n,r,i){var a;t=(a=t)._withTask||(a._withTask=function(){Z_=!0;var e=a.apply(null,arguments);return Z_=!1,e}),n&&(t=function(e,t,n){var r=PA;return function i(){null!==e.apply(null,arguments)&&FA(t,i,n,r)}}(t,e,r)),PA.addEventListener(e,t,e_?{capture:r,passive:i}:r)}function FA(e,t,n,r){(r||PA).removeEventListener(e,t._withTask||t,n)}function BA(e,t){if(!ib(e.data.on)||!ib(t.data.on)){var n=t.data.on||{},r=e.data.on||{};PA=t.elm,function(e){if(ab(e[DA])){var t=qb?"change":"input";e[t]=[].concat(e[DA],e[t]||[]),delete e[DA]}ab(e[NA])&&(e.change=[].concat(e[NA],e.change||[]),delete e[NA])}(n),cy(n,r,UA,FA,t.context),PA=void 0}}var zA={create:BA,update:BA};function HA(e,t){if(!ib(e.data.domProps)||!ib(t.data.domProps)){var n,r,i=t.elm,a=e.data.domProps||{},o=t.data.domProps||{};for(n in ab(o.__ob__)&&(o=t.data.domProps=Mb({},o)),a)ib(o[n])&&(i[n]="");for(n in o){if(r=o[n],"textContent"===n||"innerHTML"===n){if(t.children&&(t.children.length=0),r===a[n])continue;1===i.childNodes.length&&i.removeChild(i.childNodes[0])}if("value"===n){i._value=r;var s=ib(r)?"":String(r);VA(i,s)&&(i.value=s)}else i[n]=r}}}function VA(e,t){return!e.composing&&("OPTION"===e.tagName||function(e,t){var n=!0;try{n=document.activeElement!==e}catch(e){}return n&&e.value!==t}(e,t)||function(e,t){var n=e.value,r=e._vModifiers;if(ab(r)){if(r.lazy)return!1;if(r.number)return hb(n)!==hb(t);if(r.trim)return n.trim()!==t.trim()}return n!==t}(e,t))}var GA={create:HA,update:HA},$A=yb((function(e){var t={},n=/:(.+)/;return e.split(/;(?![^(]*\))/g).forEach((function(e){if(e){var r=e.split(n);r.length>1&&(t[r[0].trim()]=r[1].trim())}})),t}));function WA(e){var t=jA(e.style);return e.staticStyle?Mb(e.staticStyle,t):t}function jA(e){return Array.isArray(e)?kb(e):"string"==typeof e?$A(e):e}var XA,YA=/^--/,qA=/\s*!important$/,KA=function(e,t,n){if(YA.test(t))e.style.setProperty(t,n);else if(qA.test(n))e.style.setProperty(t,n.replace(qA,""),"important");else{var r=JA(t);if(Array.isArray(n))for(var i=0,a=n.length;i<a;i++)e.style[r]=n[i];else e.style[r]=n}},ZA=["Webkit","Moz","ms"],JA=yb((function(e){if(XA=XA||document.createElement("div").style,"filter"!==(e=Ab(e))&&e in XA)return e;for(var t=e.charAt(0).toUpperCase()+e.slice(1),n=0;n<ZA.length;n++){var r=ZA[n]+t;if(r in XA)return r}}));function QA(e,t){var n=t.data,r=e.data;if(!(ib(n.staticStyle)&&ib(n.style)&&ib(r.staticStyle)&&ib(r.style))){var i,a,o=t.elm,s=r.staticStyle,c=r.normalizedStyle||r.style||{},l=s||c,u=jA(t.data.style)||{};t.data.normalizedStyle=ab(u.__ob__)?Mb({},u):u;var d=function(e,t){for(var n,r={},i=e;i.componentInstance;)(i=i.componentInstance._vnode)&&i.data&&(n=WA(i.data))&&Mb(r,n);(n=WA(e.data))&&Mb(r,n);for(var a=e;a=a.parent;)a.data&&(n=WA(a.data))&&Mb(r,n);return r}(t);for(a in l)ib(d[a])&&KA(o,a,"");for(a in d)(i=d[a])!==l[a]&&KA(o,a,null==i?"":i)}}var ew={create:QA,update:QA};function tw(e,t){if(t&&(t=t.trim()))if(e.classList)t.indexOf(" ")>-1?t.split(/\s+/).forEach((function(t){return e.classList.add(t)})):e.classList.add(t);else{var n=" "+(e.getAttribute("class")||"")+" ";n.indexOf(" "+t+" ")<0&&e.setAttribute("class",(n+t).trim())}}function nw(e,t){if(t&&(t=t.trim()))if(e.classList)t.indexOf(" ")>-1?t.split(/\s+/).forEach((function(t){return e.classList.remove(t)})):e.classList.remove(t),e.classList.length||e.removeAttribute("class");else{for(var n=" "+(e.getAttribute("class")||"")+" ",r=" "+t+" ";n.indexOf(r)>=0;)n=n.replace(r," ");(n=n.trim())?e.setAttribute("class",n):e.removeAttribute("class")}}function rw(e){if(e){if("object"==typeof e){var t={};return!1!==e.css&&Mb(t,iw(e.name||"v")),Mb(t,e),t}return"string"==typeof e?iw(e):void 0}}var iw=yb((function(e){return{enterClass:e+"-enter",enterToClass:e+"-enter-to",enterActiveClass:e+"-enter-active",leaveClass:e+"-leave",leaveToClass:e+"-leave-to",leaveActiveClass:e+"-leave-active"}})),aw=Wb&&!Kb,ow="transition",sw="animation",cw="transition",lw="transitionend",uw="animation",dw="animationend";aw&&(void 0===window.ontransitionend&&void 0!==window.onwebkittransitionend&&(cw="WebkitTransition",lw="webkitTransitionEnd"),void 0===window.onanimationend&&void 0!==window.onwebkitanimationend&&(uw="WebkitAnimation",dw="webkitAnimationEnd"));var fw=Wb?window.requestAnimationFrame?window.requestAnimationFrame.bind(window):setTimeout:function(e){return e()};function hw(e){fw((function(){fw(e)}))}function pw(e,t){var n=e._transitionClasses||(e._transitionClasses=[]);n.indexOf(t)<0&&(n.push(t),tw(e,t))}function mw(e,t){e._transitionClasses&&gb(e._transitionClasses,t),nw(e,t)}function vw(e,t,n){var r=bw(e,t),i=r.type,a=r.timeout,o=r.propCount;if(!i)return n();var s=i===ow?lw:dw,c=0,l=function(){e.removeEventListener(s,u),n()},u=function(t){t.target===e&&++c>=o&&l()};setTimeout((function(){c<o&&l()}),a+1),e.addEventListener(s,u)}var gw=/\b(transform|all)(,|$)/;function bw(e,t){var n,r=window.getComputedStyle(e),i=r[cw+"Delay"].split(", "),a=r[cw+"Duration"].split(", "),o=_w(i,a),s=r[uw+"Delay"].split(", "),c=r[uw+"Duration"].split(", "),l=_w(s,c),u=0,d=0;return t===ow?o>0&&(n=ow,u=o,d=a.length):t===sw?l>0&&(n=sw,u=l,d=c.length):d=(n=(u=Math.max(o,l))>0?o>l?ow:sw:null)?n===ow?a.length:c.length:0,{type:n,timeout:u,propCount:d,hasTransform:n===ow&&gw.test(r[cw+"Property"])}}function _w(e,t){for(;e.length<t.length;)e=e.concat(e);return Math.max.apply(null,t.map((function(t,n){return yw(t)+yw(e[n])})))}function yw(e){return 1e3*Number(e.slice(0,-1))}function xw(e,t){var n=e.elm;ab(n._leaveCb)&&(n._leaveCb.cancelled=!0,n._leaveCb());var r=rw(e.data.transition);if(!ib(r)&&!ab(n._enterCb)&&1===n.nodeType){for(var i=r.css,a=r.type,o=r.enterClass,s=r.enterToClass,c=r.enterActiveClass,l=r.appearClass,u=r.appearToClass,d=r.appearActiveClass,f=r.beforeEnter,h=r.enter,p=r.afterEnter,m=r.enterCancelled,v=r.beforeAppear,g=r.appear,b=r.afterAppear,_=r.appearCancelled,y=r.duration,x=wy,A=wy.$vnode;A&&A.parent;)x=(A=A.parent).context;var w=!x._isMounted||!e.isRootInsert;if(!w||g||""===g){var E=w&&l?l:o,T=w&&d?d:c,S=w&&u?u:s,C=w&&v||f,M=w&&"function"==typeof g?g:h,k=w&&b||p,R=w&&_||m,L=hb(cb(y)?y.enter:y),O=!1!==i&&!Kb,I=Ew(M),P=n._enterCb=Db((function(){O&&(mw(n,S),mw(n,T)),P.cancelled?(O&&mw(n,E),R&&R(n)):k&&k(n),n._enterCb=null}));e.data.show||ly(e,"insert",(function(){var t=n.parentNode,r=t&&t._pending&&t._pending[e.key];r&&r.tag===e.tag&&r.elm._leaveCb&&r.elm._leaveCb(),M&&M(n,P)})),C&&C(n),O&&(pw(n,E),pw(n,T),hw((function(){mw(n,E),P.cancelled||(pw(n,S),I||(ww(L)?setTimeout(P,L):vw(n,a,P)))}))),e.data.show&&(t&&t(),M&&M(n,P)),O||I||P()}}}function Aw(e,t){var n=e.elm;ab(n._enterCb)&&(n._enterCb.cancelled=!0,n._enterCb());var r=rw(e.data.transition);if(ib(r)||1!==n.nodeType)return t();if(!ab(n._leaveCb)){var i=r.css,a=r.type,o=r.leaveClass,s=r.leaveToClass,c=r.leaveActiveClass,l=r.beforeLeave,u=r.leave,d=r.afterLeave,f=r.leaveCancelled,h=r.delayLeave,p=r.duration,m=!1!==i&&!Kb,v=Ew(u),g=hb(cb(p)?p.leave:p),b=n._leaveCb=Db((function(){n.parentNode&&n.parentNode._pending&&(n.parentNode._pending[e.key]=null),m&&(mw(n,s),mw(n,c)),b.cancelled?(m&&mw(n,o),f&&f(n)):(t(),d&&d(n)),n._leaveCb=null}));h?h(_):_()}function _(){b.cancelled||(e.data.show||((n.parentNode._pending||(n.parentNode._pending={}))[e.key]=e),l&&l(n),m&&(pw(n,o),pw(n,c),hw((function(){mw(n,o),b.cancelled||(pw(n,s),v||(ww(g)?setTimeout(b,g):vw(n,a,b)))}))),u&&u(n,b),m||v||b())}}function ww(e){return"number"==typeof e&&!isNaN(e)}function Ew(e){if(ib(e))return!1;var t=e.fns;return ab(t)?Ew(Array.isArray(t)?t[0]:t):(e._length||e.length)>1}function Tw(e,t){!0!==t.data.show&&xw(t)}var Sw=function(e){var t,n,r={},i=e.modules,a=e.nodeOps;for(t=0;t<Xx.length;++t)for(r[Xx[t]]=[],n=0;n<i.length;++n)ab(i[n][Xx[t]])&&r[Xx[t]].push(i[n][Xx[t]]);function o(e){var t=a.parentNode(e);ab(t)&&a.removeChild(t,e)}function s(e,t,n,i,o,s,d){if(ab(e.elm)&&ab(s)&&(e=s[d]=g_(e)),e.isRootInsert=!o,!function(e,t,n,i){var a=e.data;if(ab(a)){var o=ab(e.componentInstance)&&a.keepAlive;if(ab(a=a.hook)&&ab(a=a.init)&&a(e,!1,n,i),ab(e.componentInstance))return c(e,t),ob(o)&&function(e,t,n,i){for(var a,o=e;o.componentInstance;)if(ab(a=(o=o.componentInstance._vnode).data)&&ab(a=a.transition)){for(a=0;a<r.activate.length;++a)r.activate[a](jx,o);t.push(o);break}l(n,e.elm,i)}(e,t,n,i),!0}}(e,t,n,i)){var p=e.data,m=e.children,v=e.tag;ab(v)?(e.elm=e.ns?a.createElementNS(e.ns,v):a.createElement(v,e),h(e),u(e,m,t),ab(p)&&f(e,t),l(n,e.elm,i)):ob(e.isComment)?(e.elm=a.createComment(e.text),l(n,e.elm,i)):(e.elm=a.createTextNode(e.text),l(n,e.elm,i))}}function c(e,t){ab(e.data.pendingInsert)&&(t.push.apply(t,e.data.pendingInsert),e.data.pendingInsert=null),e.elm=e.componentInstance.$el,d(e)?(f(e,t),h(e)):(Wx(e),t.push(e))}function l(e,t,n){ab(e)&&(ab(n)?n.parentNode===e&&a.insertBefore(e,t,n):a.appendChild(e,t))}function u(e,t,n){if(Array.isArray(t))for(var r=0;r<t.length;++r)s(t[r],n,e.elm,null,!0,t,r);else sb(e.text)&&a.appendChild(e.elm,a.createTextNode(String(e.text)))}function d(e){for(;e.componentInstance;)e=e.componentInstance._vnode;return ab(e.tag)}function f(e,n){for(var i=0;i<r.create.length;++i)r.create[i](jx,e);ab(t=e.data.hook)&&(ab(t.create)&&t.create(jx,e),ab(t.insert)&&n.push(e))}function h(e){var t;if(ab(t=e.fnScopeId))a.setStyleScope(e.elm,t);else for(var n=e;n;)ab(t=n.context)&&ab(t=t.$options._scopeId)&&a.setStyleScope(e.elm,t),n=n.parent;ab(t=wy)&&t!==e.context&&t!==e.fnContext&&ab(t=t.$options._scopeId)&&a.setStyleScope(e.elm,t)}function p(e,t,n,r,i,a){for(;r<=i;++r)s(n[r],a,e,t,!1,n,r)}function m(e){var t,n,i=e.data;if(ab(i))for(ab(t=i.hook)&&ab(t=t.destroy)&&t(e),t=0;t<r.destroy.length;++t)r.destroy[t](e);if(ab(t=e.children))for(n=0;n<e.children.length;++n)m(e.children[n])}function v(e,t,n,r){for(;n<=r;++n){var i=t[n];ab(i)&&(ab(i.tag)?(g(i),m(i)):o(i.elm))}}function g(e,t){if(ab(t)||ab(e.data)){var n,i=r.remove.length+1;for(ab(t)?t.listeners+=i:t=function(e,t){function n(){0==--n.listeners&&o(e)}return n.listeners=t,n}(e.elm,i),ab(n=e.componentInstance)&&ab(n=n._vnode)&&ab(n.data)&&g(n,t),n=0;n<r.remove.length;++n)r.remove[n](e,t);ab(n=e.data.hook)&&ab(n=n.remove)?n(e,t):t()}else o(e.elm)}function b(e,t,n,r){for(var i=n;i<r;i++){var a=t[i];if(ab(a)&&Yx(e,a))return i}}function _(e,t,n,i){if(e!==t){var o=t.elm=e.elm;if(ob(e.isAsyncPlaceholder))ab(t.asyncFactory.resolved)?A(e.elm,t,n):t.isAsyncPlaceholder=!0;else if(ob(t.isStatic)&&ob(e.isStatic)&&t.key===e.key&&(ob(t.isCloned)||ob(t.isOnce)))t.componentInstance=e.componentInstance;else{var c,l=t.data;ab(l)&&ab(c=l.hook)&&ab(c=c.prepatch)&&c(e,t);var u=e.children,f=t.children;if(ab(l)&&d(t)){for(c=0;c<r.update.length;++c)r.update[c](e,t);ab(c=l.hook)&&ab(c=c.update)&&c(e,t)}ib(t.text)?ab(u)&&ab(f)?u!==f&&function(e,t,n,r,i){for(var o,c,l,u=0,d=0,f=t.length-1,h=t[0],m=t[f],g=n.length-1,y=n[0],x=n[g],A=!i;u<=f&&d<=g;)ib(h)?h=t[++u]:ib(m)?m=t[--f]:Yx(h,y)?(_(h,y,r),h=t[++u],y=n[++d]):Yx(m,x)?(_(m,x,r),m=t[--f],x=n[--g]):Yx(h,x)?(_(h,x,r),A&&a.insertBefore(e,h.elm,a.nextSibling(m.elm)),h=t[++u],x=n[--g]):Yx(m,y)?(_(m,y,r),A&&a.insertBefore(e,m.elm,h.elm),m=t[--f],y=n[++d]):(ib(o)&&(o=qx(t,u,f)),ib(c=ab(y.key)?o[y.key]:b(y,t,u,f))?s(y,r,e,h.elm,!1,n,d):Yx(l=t[c],y)?(_(l,y,r),t[c]=void 0,A&&a.insertBefore(e,l.elm,h.elm)):s(y,r,e,h.elm,!1,n,d),y=n[++d]);u>f?p(e,ib(n[g+1])?null:n[g+1].elm,n,d,g,r):d>g&&v(0,t,u,f)}(o,u,f,n,i):ab(f)?(ab(e.text)&&a.setTextContent(o,""),p(o,null,f,0,f.length-1,n)):ab(u)?v(0,u,0,u.length-1):ab(e.text)&&a.setTextContent(o,""):e.text!==t.text&&a.setTextContent(o,t.text),ab(l)&&ab(c=l.hook)&&ab(c=c.postpatch)&&c(e,t)}}}function y(e,t,n){if(ob(n)&&ab(e.parent))e.parent.data.pendingInsert=t;else for(var r=0;r<t.length;++r)t[r].data.hook.insert(t[r])}var x=pb("attrs,class,staticClass,staticStyle,key");function A(e,t,n,r){var i,a=t.tag,o=t.data,s=t.children;if(r=r||o&&o.pre,t.elm=e,ob(t.isComment)&&ab(t.asyncFactory))return t.isAsyncPlaceholder=!0,!0;if(ab(o)&&(ab(i=o.hook)&&ab(i=i.init)&&i(t,!0),ab(i=t.componentInstance)))return c(t,n),!0;if(ab(a)){if(ab(s))if(e.hasChildNodes())if(ab(i=o)&&ab(i=i.domProps)&&ab(i=i.innerHTML)){if(i!==e.innerHTML)return!1}else{for(var l=!0,d=e.firstChild,h=0;h<s.length;h++){if(!d||!A(d,s[h],n,r)){l=!1;break}d=d.nextSibling}if(!l||d)return!1}else u(t,s,n);if(ab(o)){var p=!1;for(var m in o)if(!x(m)){p=!0,f(t,n);break}!p&&o.class&&ry(o.class)}}else e.data!==t.text&&(e.data=t.text);return!0}return function(e,t,n,i,o,c){if(!ib(t)){var l,u=!1,f=[];if(ib(e))u=!0,s(t,f,o,c);else{var h=ab(e.nodeType);if(!h&&Yx(e,t))_(e,t,f,i);else{if(h){if(1===e.nodeType&&e.hasAttribute(Nb)&&(e.removeAttribute(Nb),n=!0),ob(n)&&A(e,t,f))return y(t,f,!0),e;l=e,e=new h_(a.tagName(l).toLowerCase(),{},[],void 0,l)}var p=e.elm,g=a.parentNode(p);if(s(t,f,p._leaveCb?null:g,a.nextSibling(p)),ab(t.parent))for(var b=t.parent,x=d(t);b;){for(var w=0;w<r.destroy.length;++w)r.destroy[w](b);if(b.elm=t.elm,x){for(var E=0;E<r.create.length;++E)r.create[E](jx,b);var T=b.data.hook.insert;if(T.merged)for(var S=1;S<T.fns.length;S++)T.fns[S]()}else Wx(b);b=b.parent}ab(g)?v(0,[e],0,0):ab(e.tag)&&m(e)}}return y(t,f,u),t.elm}ab(e)&&m(e)}}({nodeOps:Gx,modules:[oA,pA,zA,GA,ew,Wb?{create:Tw,activate:Tw,remove:function(e,t){!0!==e.data.show?Aw(e,t):t()}}:{}].concat(nA)});Kb&&document.addEventListener("selectionchange",(function(){var e=document.activeElement;e&&e.vmodel&&Pw(e,"input")}));var Cw={inserted:function(e,t,n,r){"select"===n.tag?(r.elm&&!r.elm._vOptions?ly(n,"postpatch",(function(){Cw.componentUpdated(e,t,n)})):Mw(e,t,n.context),e._vOptions=[].map.call(e.options,Lw)):("textarea"===n.tag||Hx(e.type))&&(e._vModifiers=t.modifiers,t.modifiers.lazy||(e.addEventListener("compositionstart",Ow),e.addEventListener("compositionend",Iw),e.addEventListener("change",Iw),Kb&&(e.vmodel=!0)))},componentUpdated:function(e,t,n){if("select"===n.tag){Mw(e,t,n.context);var r=e._vOptions,i=e._vOptions=[].map.call(e.options,Lw);i.some((function(e,t){return!Ib(e,r[t])}))&&(e.multiple?t.value.some((function(e){return Rw(e,i)})):t.value!==t.oldValue&&Rw(t.value,i))&&Pw(e,"change")}}};function Mw(e,t,n){kw(e,t),(qb||Zb)&&setTimeout((function(){kw(e,t)}),0)}function kw(e,t,n){var r=t.value,i=e.multiple;if(!i||Array.isArray(r)){for(var a,o,s=0,c=e.options.length;s<c;s++)if(o=e.options[s],i)a=Pb(r,Lw(o))>-1,o.selected!==a&&(o.selected=a);else if(Ib(Lw(o),r))return void(e.selectedIndex!==s&&(e.selectedIndex=s));i||(e.selectedIndex=-1)}}function Rw(e,t){return t.every((function(t){return!Ib(t,e)}))}function Lw(e){return"_value"in e?e._value:e.value}function Ow(e){e.target.composing=!0}function Iw(e){e.target.composing&&(e.target.composing=!1,Pw(e.target,"input"))}function Pw(e,t){var n=document.createEvent("HTMLEvents");n.initEvent(t,!0,!0),e.dispatchEvent(n)}function Dw(e){return!e.componentInstance||e.data&&e.data.transition?e:Dw(e.componentInstance._vnode)}var Nw={bind:function(e,t,n){var r=t.value,i=(n=Dw(n)).data&&n.data.transition,a=e.__vOriginalDisplay="none"===e.style.display?"":e.style.display;r&&i?(n.data.show=!0,xw(n,(function(){e.style.display=a}))):e.style.display=r?a:"none"},update:function(e,t,n){var r=t.value;!r!=!t.oldValue&&((n=Dw(n)).data&&n.data.transition?(n.data.show=!0,r?xw(n,(function(){e.style.display=e.__vOriginalDisplay})):Aw(n,(function(){e.style.display="none"}))):e.style.display=r?e.__vOriginalDisplay:"none")},unbind:function(e,t,n,r,i){i||(e.style.display=e.__vOriginalDisplay)}},Uw={model:Cw,show:Nw},Fw={name:String,appear:Boolean,css:Boolean,mode:String,type:String,enterClass:String,leaveClass:String,enterToClass:String,leaveToClass:String,enterActiveClass:String,leaveActiveClass:String,appearClass:String,appearActiveClass:String,appearToClass:String,duration:[Number,String,Object]};function Bw(e){var t=e&&e.componentOptions;return t&&t.Ctor.options.abstract?Bw(vy(t.children)):e}function zw(e){var t={},n=e.$options;for(var r in n.propsData)t[r]=e[r];var i=n._parentListeners;for(var a in i)t[Ab(a)]=i[a];return t}function Hw(e,t){if(/\d-keep-alive$/.test(t.tag))return e("keep-alive",{props:t.componentOptions.propsData})}var Vw={name:"transition",props:Fw,abstract:!0,render:function(e){var t=this,n=this.$slots.default;if(n&&(n=n.filter((function(e){return e.tag||my(e)}))).length){var r=this.mode,i=n[0];if(function(e){for(;e=e.parent;)if(e.data.transition)return!0}(this.$vnode))return i;var a=Bw(i);if(!a)return i;if(this._leaving)return Hw(e,i);var o="__transition-"+this._uid+"-";a.key=null==a.key?a.isComment?o+"comment":o+a.tag:sb(a.key)?0===String(a.key).indexOf(o)?a.key:o+a.key:a.key;var s=(a.data||(a.data={})).transition=zw(this),c=this._vnode,l=Bw(c);if(a.data.directives&&a.data.directives.some((function(e){return"show"===e.name}))&&(a.data.show=!0),l&&l.data&&!function(e,t){return t.key===e.key&&t.tag===e.tag}(a,l)&&!my(l)&&(!l.componentInstance||!l.componentInstance._vnode.isComment)){var u=l.data.transition=Mb({},s);if("out-in"===r)return this._leaving=!0,ly(u,"afterLeave",(function(){t._leaving=!1,t.$forceUpdate()})),Hw(e,i);if("in-out"===r){if(my(a))return c;var d,f=function(){d()};ly(s,"afterEnter",f),ly(s,"enterCancelled",f),ly(u,"delayLeave",(function(e){d=e}))}}return i}}},Gw=Mb({tag:String,moveClass:String},Fw);function $w(e){e.elm._moveCb&&e.elm._moveCb(),e.elm._enterCb&&e.elm._enterCb()}function Ww(e){e.data.newPos=e.elm.getBoundingClientRect()}function jw(e){var t=e.data.pos,n=e.data.newPos,r=t.left-n.left,i=t.top-n.top;if(r||i){e.data.moved=!0;var a=e.elm.style;a.transform=a.WebkitTransform="translate("+r+"px,"+i+"px)",a.transitionDuration="0s"}}delete Gw.mode;var Xw={Transition:Vw,TransitionGroup:{props:Gw,render:function(e){for(var t=this.tag||this.$vnode.data.tag||"span",n=Object.create(null),r=this.prevChildren=this.children,i=this.$slots.default||[],a=this.children=[],o=zw(this),s=0;s<i.length;s++){var c=i[s];c.tag&&null!=c.key&&0!==String(c.key).indexOf("__vlist")&&(a.push(c),n[c.key]=c,(c.data||(c.data={})).transition=o)}if(r){for(var l=[],u=[],d=0;d<r.length;d++){var f=r[d];f.data.transition=o,f.data.pos=f.elm.getBoundingClientRect(),n[f.key]?l.push(f):u.push(f)}this.kept=e(t,null,l),this.removed=u}return e(t,null,a)},beforeUpdate:function(){this.__patch__(this._vnode,this.kept,!1,!0),this._vnode=this.kept},updated:function(){var e=this.prevChildren,t=this.moveClass||(this.name||"v")+"-move";e.length&&this.hasMove(e[0].elm,t)&&(e.forEach($w),e.forEach(Ww),e.forEach(jw),this._reflow=document.body.offsetHeight,e.forEach((function(e){if(e.data.moved){var n=e.elm,r=n.style;pw(n,t),r.transform=r.WebkitTransform=r.transitionDuration="",n.addEventListener(lw,n._moveCb=function e(r){r&&!/transform$/.test(r.propertyName)||(n.removeEventListener(lw,e),n._moveCb=null,mw(n,t))})}})))},methods:{hasMove:function(e,t){if(!aw)return!1;if(this._hasMove)return this._hasMove;var n=e.cloneNode();e._transitionClasses&&e._transitionClasses.forEach((function(e){nw(n,e)})),tw(n,t),n.style.display="none",this.$el.appendChild(n);var r=bw(n);return this.$el.removeChild(n),this._hasMove=r.hasTransform}}}};mx.config.mustUseProp=Tx,mx.config.isReservedTag=Fx,mx.config.isReservedAttr=wx,mx.config.getTagNamespace=Bx,mx.config.isUnknownElement=function(e){if(!Wb)return!0;if(Fx(e))return!1;if(e=e.toLowerCase(),null!=zx[e])return zx[e];var t=document.createElement(e);return e.indexOf("-")>-1?zx[e]=t.constructor===window.HTMLUnknownElement||t.constructor===window.HTMLElement:zx[e]=/HTMLUnknownElement/.test(t.toString())},Mb(mx.options.directives,Uw),Mb(mx.options.components,Xw),mx.prototype.__patch__=Wb?Sw:Rb,mx.prototype.$mount=function(e,t){return function(e,t,n){var r;return e.$el=t,e.$options.render||(e.$options.render=m_),Cy(e,"beforeMount"),r=function(){e._update(e._render(),n)},new Ny(e,r,Rb,null,!0),n=!1,null==e.$vnode&&(e._isMounted=!0,Cy(e,"mounted")),e}(this,e=e&&Wb?Vx(e):void 0,t)},Wb&&setTimeout((function(){Bb.devtools&&r_&&r_.emit("init",mx)}),0);var Yw,qw=/\{\{((?:.|\n)+?)\}\}/g,Kw=/[-.*+?^${}()|[\]\/\\]/g,Zw=yb((function(e){var t=e[0].replace(Kw,"\\$&"),n=e[1].replace(Kw,"\\$&");return new RegExp(t+"((?:.|\\n)+?)"+n,"g")})),Jw={staticKeys:["staticClass"],transformNode:function(e,t){t.warn;var n=SA(e,"class");n&&(e.staticClass=JSON.stringify(n));var r=TA(e,"class",!1);r&&(e.classBinding=r)},genData:function(e){var t="";return e.staticClass&&(t+="staticClass:"+e.staticClass+","),e.classBinding&&(t+="class:"+e.classBinding+","),t}},Qw={staticKeys:["staticStyle"],transformNode:function(e,t){t.warn;var n=SA(e,"style");n&&(e.staticStyle=JSON.stringify($A(n)));var r=TA(e,"style",!1);r&&(e.styleBinding=r)},genData:function(e){var t="";return e.staticStyle&&(t+="staticStyle:"+e.staticStyle+","),e.styleBinding&&(t+="style:("+e.styleBinding+"),"),t}},eE=pb("area,base,br,col,embed,frame,hr,img,input,isindex,keygen,link,meta,param,source,track,wbr"),tE=pb("colgroup,dd,dt,li,options,p,td,tfoot,th,thead,tr,source"),nE=pb("address,article,aside,base,blockquote,body,caption,col,colgroup,dd,details,dialog,div,dl,dt,fieldset,figcaption,figure,footer,form,h1,h2,h3,h4,h5,h6,head,header,hgroup,hr,html,legend,li,menuitem,meta,optgroup,option,param,rp,rt,source,style,summary,tbody,td,tfoot,th,thead,title,tr,track"),rE=/^\s*([^\s"'<>\/=]+)(?:\s*(=)\s*(?:"([^"]*)"+|'([^']*)'+|([^\s"'=<>`]+)))?/,iE="[a-zA-Z_][\\w\\-\\.]*",aE="((?:"+iE+"\\:)?"+iE+")",oE=new RegExp("^<"+aE),sE=/^\s*(\/?)>/,cE=new RegExp("^<\\/"+aE+"[^>]*>"),lE=/^<!DOCTYPE [^>]+>/i,uE=/^<!\--/,dE=/^<!\[/,fE=!1;"x".replace(/x(.)?/g,(function(e,t){fE=""===t}));var hE=pb("script,style,textarea",!0),pE={},mE={"&lt;":"<","&gt;":">","&quot;":'"',"&amp;":"&","&#10;":"\n","&#9;":"\t"},vE=/&(?:lt|gt|quot|amp);/g,gE=/&(?:lt|gt|quot|amp|#10|#9);/g,bE=pb("pre,textarea",!0),_E=function(e,t){return e&&bE(e)&&"\n"===t[0]};function yE(e,t){var n=t?gE:vE;return e.replace(n,(function(e){return mE[e]}))}var xE,AE,wE,EE,TE,SE,CE,ME,kE=/^@|^v-on:/,RE=/^v-|^@|^:/,LE=/([^]*?)\s+(?:in|of)\s+([^]*)/,OE=/,([^,\}\]]*)(?:,([^,\}\]]*))?$/,IE=/^\(|\)$/g,PE=/:(.*)$/,DE=/^:|^v-bind:/,NE=/\.[^.]+/g,UE=yb((function(e){return(Yw=Yw||document.createElement("div")).innerHTML=e,Yw.textContent}));function FE(e,t,n){return{type:1,tag:e,attrsList:t,attrsMap:GE(t),parent:n,children:[]}}function BE(e,t){var n,r;(r=TA(n=e,"key"))&&(n.key=r),e.plain=!e.key&&!e.attrsList.length,function(e){var t=TA(e,"ref");t&&(e.ref=t,e.refInFor=function(e){for(var t=e;t;){if(void 0!==t.for)return!0;t=t.parent}return!1}(e))}(e),function(e){if("slot"===e.tag)e.slotName=TA(e,"name");else{var t;"template"===e.tag?(t=SA(e,"scope"),e.slotScope=t||SA(e,"slot-scope")):(t=SA(e,"slot-scope"))&&(e.slotScope=t);var n=TA(e,"slot");n&&(e.slotTarget='""'===n?'"default"':n,"template"===e.tag||e.slotScope||xA(e,"slot",n))}}(e),function(e){var t;(t=TA(e,"is"))&&(e.component=t),null!=SA(e,"inline-template")&&(e.inlineTemplate=!0)}(e);for(var i=0;i<wE.length;i++)e=wE[i](e,t)||e;!function(e){var t,n,r,i,a,o,s,c=e.attrsList;for(t=0,n=c.length;t<n;t++)if(r=i=c[t].name,a=c[t].value,RE.test(r))if(e.hasBindings=!0,(o=VE(r))&&(r=r.replace(NE,"")),DE.test(r))r=r.replace(DE,""),a=vA(a),s=!1,o&&(o.prop&&(s=!0,"innerHtml"===(r=Ab(r))&&(r="innerHTML")),o.camel&&(r=Ab(r)),o.sync&&EA(e,"update:"+Ab(r),MA(a,"$event"))),s||!e.component&&CE(e.tag,e.attrsMap.type,r)?yA(e,r,a):xA(e,r,a);else if(kE.test(r))EA(e,r=r.replace(kE,""),a,o,!1);else{var l=(r=r.replace(RE,"")).match(PE),u=l&&l[1];u&&(r=r.slice(0,-(u.length+1))),wA(e,r,i,a,u,o)}else xA(e,r,JSON.stringify(a)),!e.component&&"muted"===r&&CE(e.tag,e.attrsMap.type,r)&&yA(e,r,"true")}(e)}function zE(e){var t;if(t=SA(e,"v-for")){var n=function(e){var t=e.match(LE);if(t){var n={};n.for=t[2].trim();var r=t[1].trim().replace(IE,""),i=r.match(OE);return i?(n.alias=r.replace(OE,""),n.iterator1=i[1].trim(),i[2]&&(n.iterator2=i[2].trim())):n.alias=r,n}}(t);n&&Mb(e,n)}}function HE(e,t){e.ifConditions||(e.ifConditions=[]),e.ifConditions.push(t)}function VE(e){var t=e.match(NE);if(t){var n={};return t.forEach((function(e){n[e.slice(1)]=!0})),n}}function GE(e){for(var t={},n=0,r=e.length;n<r;n++)t[e[n].name]=e[n].value;return t}var $E=/^xmlns:NS\d+/,WE=/^NS\d+:/;function jE(e){return FE(e.tag,e.attrsList.slice(),e.parent)}var XE,YE,qE,KE=[Jw,Qw,{preTransformNode:function(e,t){if("input"===e.tag){var n,r=e.attrsMap;if(!r["v-model"])return;if((r[":type"]||r["v-bind:type"])&&(n=TA(e,"type")),r.type||n||!r["v-bind"]||(n="("+r["v-bind"]+").type"),n){var i=SA(e,"v-if",!0),a=i?"&&("+i+")":"",o=null!=SA(e,"v-else",!0),s=SA(e,"v-else-if",!0),c=jE(e);zE(c),AA(c,"type","checkbox"),BE(c,t),c.processed=!0,c.if="("+n+")==='checkbox'"+a,HE(c,{exp:c.if,block:c});var l=jE(e);SA(l,"v-for",!0),AA(l,"type","radio"),BE(l,t),HE(c,{exp:"("+n+")==='radio'"+a,block:l});var u=jE(e);return SA(u,"v-for",!0),AA(u,":type",n),BE(u,t),HE(c,{exp:i,block:u}),o?c.else=!0:s&&(c.elseif=s),c}}}}],ZE={model:function(e,t,n){var r=t.value,i=t.modifiers,a=e.tag,o=e.attrsMap.type;if(e.component)return CA(e,r,i),!1;if("select"===a)!function(e,t,n){var r='var $$selectedVal = Array.prototype.filter.call($event.target.options,function(o){return o.selected}).map(function(o){var val = "_value" in o ? o._value : o.value;return '+(n&&n.number?"_n(val)":"val")+"});";EA(e,"change",r=r+" "+MA(t,"$event.target.multiple ? $$selectedVal : $$selectedVal[0]"),null,!0)}(e,r,i);else if("input"===a&&"checkbox"===o)!function(e,t,n){var r=n&&n.number,i=TA(e,"value")||"null",a=TA(e,"true-value")||"true",o=TA(e,"false-value")||"false";yA(e,"checked","Array.isArray("+t+")?_i("+t+","+i+")>-1"+("true"===a?":("+t+")":":_q("+t+","+a+")")),EA(e,"change","var $$a="+t+",$$el=$event.target,$$c=$$el.checked?("+a+"):("+o+");if(Array.isArray($$a)){var $$v="+(r?"_n("+i+")":i)+",$$i=_i($$a,$$v);if($$el.checked){$$i<0&&("+MA(t,"$$a.concat([$$v])")+")}else{$$i>-1&&("+MA(t,"$$a.slice(0,$$i).concat($$a.slice($$i+1))")+")}}else{"+MA(t,"$$c")+"}",null,!0)}(e,r,i);else if("input"===a&&"radio"===o)!function(e,t,n){var r=n&&n.number,i=TA(e,"value")||"null";yA(e,"checked","_q("+t+","+(i=r?"_n("+i+")":i)+")"),EA(e,"change",MA(t,i),null,!0)}(e,r,i);else if("input"===a||"textarea"===a)!function(e,t,n){var r=e.attrsMap.type,i=n||{},a=i.lazy,o=i.number,s=i.trim,c=!a&&"range"!==r,l=a?"change":"range"===r?DA:"input",u="$event.target.value";s&&(u="$event.target.value.trim()"),o&&(u="_n("+u+")");var d=MA(t,u);c&&(d="if($event.target.composing)return;"+d),yA(e,"value","("+t+")"),EA(e,l,d,null,!0),(s||o)&&EA(e,"blur","$forceUpdate()")}(e,r,i);else if(!Bb.isReservedTag(a))return CA(e,r,i),!1;return!0},text:function(e,t){t.value&&yA(e,"textContent","_s("+t.value+")")},html:function(e,t){t.value&&yA(e,"innerHTML","_s("+t.value+")")}},JE={expectHTML:!0,modules:KE,directives:ZE,isPreTag:function(e){return"pre"===e},isUnaryTag:eE,mustUseProp:Tx,canBeLeftOpenTag:tE,isReservedTag:Fx,getTagNamespace:Bx,staticKeys:(qE=KE,qE.reduce((function(e,t){return e.concat(t.staticKeys||[])}),[]).join(","))},QE=yb((function(e){return pb("type,tag,attrsList,attrsMap,plain,parent,children,attrs"+(e?","+e:""))}));function eT(e,t){e&&(XE=QE(t.staticKeys||""),YE=t.isReservedTag||Lb,tT(e),nT(e,!1))}function tT(e){if(e.static=function(e){return 2!==e.type&&(3===e.type||!(!e.pre&&(e.hasBindings||e.if||e.for||mb(e.tag)||!YE(e.tag)||function(e){for(;e.parent;){if("template"!==(e=e.parent).tag)return!1;if(e.for)return!0}return!1}(e)||!Object.keys(e).every(XE))))}(e),1===e.type){if(!YE(e.tag)&&"slot"!==e.tag&&null==e.attrsMap["inline-template"])return;for(var t=0,n=e.children.length;t<n;t++){var r=e.children[t];tT(r),r.static||(e.static=!1)}if(e.ifConditions)for(var i=1,a=e.ifConditions.length;i<a;i++){var o=e.ifConditions[i].block;tT(o),o.static||(e.static=!1)}}}function nT(e,t){if(1===e.type){if((e.static||e.once)&&(e.staticInFor=t),e.static&&e.children.length&&(1!==e.children.length||3!==e.children[0].type))return void(e.staticRoot=!0);if(e.staticRoot=!1,e.children)for(var n=0,r=e.children.length;n<r;n++)nT(e.children[n],t||!!e.for);if(e.ifConditions)for(var i=1,a=e.ifConditions.length;i<a;i++)nT(e.ifConditions[i].block,t)}}var rT=/^([\w$_]+|\([^)]*?\))\s*=>|^function\s*\(/,iT=/^[A-Za-z_$][\w$]*(?:\.[A-Za-z_$][\w$]*|\['[^']*?']|\["[^"]*?"]|\[\d+]|\[[A-Za-z_$][\w$]*])*$/,aT={esc:27,tab:9,enter:13,space:32,up:38,left:37,right:39,down:40,delete:[8,46]},oT={esc:"Escape",tab:"Tab",enter:"Enter",space:" ",up:["Up","ArrowUp"],left:["Left","ArrowLeft"],right:["Right","ArrowRight"],down:["Down","ArrowDown"],delete:["Backspace","Delete"]},sT=function(e){return"if("+e+")return null;"},cT={stop:"$event.stopPropagation();",prevent:"$event.preventDefault();",self:sT("$event.target !== $event.currentTarget"),ctrl:sT("!$event.ctrlKey"),shift:sT("!$event.shiftKey"),alt:sT("!$event.altKey"),meta:sT("!$event.metaKey"),left:sT("'button' in $event && $event.button !== 0"),middle:sT("'button' in $event && $event.button !== 1"),right:sT("'button' in $event && $event.button !== 2")};function lT(e,t,n){var r=t?"nativeOn:{":"on:{";for(var i in e)r+='"'+i+'":'+uT(i,e[i])+",";return r.slice(0,-1)+"}"}function uT(e,t){if(!t)return"function(){}";if(Array.isArray(t))return"["+t.map((function(t){return uT(e,t)})).join(",")+"]";var n=iT.test(t.value),r=rT.test(t.value);if(t.modifiers){var i="",a="",o=[];for(var s in t.modifiers)if(cT[s])a+=cT[s],aT[s]&&o.push(s);else if("exact"===s){var c=t.modifiers;a+=sT(["ctrl","shift","alt","meta"].filter((function(e){return!c[e]})).map((function(e){return"$event."+e+"Key"})).join("||"))}else o.push(s);return o.length&&(i+=function(e){return"if(!('button' in $event)&&"+e.map(dT).join("&&")+")return null;"}(o)),a&&(i+=a),"function($event){"+i+(n?"return "+t.value+"($event)":r?"return ("+t.value+")($event)":t.value)+"}"}return n||r?t.value:"function($event){"+t.value+"}"}function dT(e){var t=parseInt(e,10);if(t)return"$event.keyCode!=="+t;var n=aT[e],r=oT[e];return"_k($event.keyCode,"+JSON.stringify(e)+","+JSON.stringify(n)+",$event.key,"+JSON.stringify(r)+")"}var fT={on:function(e,t){e.wrapListeners=function(e){return"_g("+e+","+t.value+")"}},bind:function(e,t){e.wrapData=function(n){return"_b("+n+",'"+e.tag+"',"+t.value+","+(t.modifiers&&t.modifiers.prop?"true":"false")+(t.modifiers&&t.modifiers.sync?",true":"")+")"}},cloak:Rb},hT=function(e){this.options=e,this.warn=e.warn||bA,this.transforms=_A(e.modules,"transformCode"),this.dataGenFns=_A(e.modules,"genData"),this.directives=Mb(Mb({},fT),e.directives);var t=e.isReservedTag||Lb;this.maybeComponent=function(e){return!t(e.tag)},this.onceId=0,this.staticRenderFns=[]};function pT(e,t){var n=new hT(t);return{render:"with(this){return "+(e?mT(e,n):'_c("div")')+"}",staticRenderFns:n.staticRenderFns}}function mT(e,t){if(e.staticRoot&&!e.staticProcessed)return vT(e,t);if(e.once&&!e.onceProcessed)return gT(e,t);if(e.for&&!e.forProcessed)return function(e,t,n,r){var i=e.for,a=e.alias,o=e.iterator1?","+e.iterator1:"",s=e.iterator2?","+e.iterator2:"";return e.forProcessed=!0,"_l(("+i+"),function("+a+o+s+"){return "+mT(e,t)+"})"}(e,t);if(e.if&&!e.ifProcessed)return bT(e,t);if("template"!==e.tag||e.slotTarget){if("slot"===e.tag)return function(e,t){var n=e.slotName||'"default"',r=AT(e,t),i="_t("+n+(r?","+r:""),a=e.attrs&&"{"+e.attrs.map((function(e){return Ab(e.name)+":"+e.value})).join(",")+"}",o=e.attrsMap["v-bind"];return!a&&!o||r||(i+=",null"),a&&(i+=","+a),o&&(i+=(a?"":",null")+","+o),i+")"}(e,t);var n;if(e.component)n=function(e,t,n){var r=t.inlineTemplate?null:AT(t,n,!0);return"_c("+e+","+yT(t,n)+(r?","+r:"")+")"}(e.component,e,t);else{var r=e.plain?void 0:yT(e,t),i=e.inlineTemplate?null:AT(e,t,!0);n="_c('"+e.tag+"'"+(r?","+r:"")+(i?","+i:"")+")"}for(var a=0;a<t.transforms.length;a++)n=t.transforms[a](e,n);return n}return AT(e,t)||"void 0"}function vT(e,t){return e.staticProcessed=!0,t.staticRenderFns.push("with(this){return "+mT(e,t)+"}"),"_m("+(t.staticRenderFns.length-1)+(e.staticInFor?",true":"")+")"}function gT(e,t){if(e.onceProcessed=!0,e.if&&!e.ifProcessed)return bT(e,t);if(e.staticInFor){for(var n="",r=e.parent;r;){if(r.for){n=r.key;break}r=r.parent}return n?"_o("+mT(e,t)+","+t.onceId+++","+n+")":mT(e,t)}return vT(e,t)}function bT(e,t,n,r){return e.ifProcessed=!0,_T(e.ifConditions.slice(),t,n,r)}function _T(e,t,n,r){if(!e.length)return r||"_e()";var i=e.shift();return i.exp?"("+i.exp+")?"+a(i.block)+":"+_T(e,t,n,r):""+a(i.block);function a(e){return n?n(e,t):e.once?gT(e,t):mT(e,t)}}function yT(e,t){var n="{",r=function(e,t){var n=e.directives;if(n){var r,i,a,o,s="directives:[",c=!1;for(r=0,i=n.length;r<i;r++){a=n[r],o=!0;var l=t.directives[a.name];l&&(o=!!l(e,a,t.warn)),o&&(c=!0,s+='{name:"'+a.name+'",rawName:"'+a.rawName+'"'+(a.value?",value:("+a.value+"),expression:"+JSON.stringify(a.value):"")+(a.arg?',arg:"'+a.arg+'"':"")+(a.modifiers?",modifiers:"+JSON.stringify(a.modifiers):"")+"},")}return c?s.slice(0,-1)+"]":void 0}}(e,t);r&&(n+=r+","),e.key&&(n+="key:"+e.key+","),e.ref&&(n+="ref:"+e.ref+","),e.refInFor&&(n+="refInFor:true,"),e.pre&&(n+="pre:true,"),e.component&&(n+='tag:"'+e.tag+'",');for(var i=0;i<t.dataGenFns.length;i++)n+=t.dataGenFns[i](e);if(e.attrs&&(n+="attrs:{"+TT(e.attrs)+"},"),e.props&&(n+="domProps:{"+TT(e.props)+"},"),e.events&&(n+=lT(e.events,!1,t.warn)+","),e.nativeEvents&&(n+=lT(e.nativeEvents,!0,t.warn)+","),e.slotTarget&&!e.slotScope&&(n+="slot:"+e.slotTarget+","),e.scopedSlots&&(n+=function(e,t){return"scopedSlots:_u(["+Object.keys(e).map((function(n){return xT(n,e[n],t)})).join(",")+"])"}(e.scopedSlots,t)+","),e.model&&(n+="model:{value:"+e.model.value+",callback:"+e.model.callback+",expression:"+e.model.expression+"},"),e.inlineTemplate){var a=function(e,t){var n=e.children[0];if(1===n.type){var r=pT(n,t.options);return"inlineTemplate:{render:function(){"+r.render+"},staticRenderFns:["+r.staticRenderFns.map((function(e){return"function(){"+e+"}"})).join(",")+"]}"}}(e,t);a&&(n+=a+",")}return n=n.replace(/,$/,"")+"}",e.wrapData&&(n=e.wrapData(n)),e.wrapListeners&&(n=e.wrapListeners(n)),n}function xT(e,t,n){return t.for&&!t.forProcessed?function(e,t,n){var r=t.for,i=t.alias,a=t.iterator1?","+t.iterator1:"",o=t.iterator2?","+t.iterator2:"";return t.forProcessed=!0,"_l(("+r+"),function("+i+a+o+"){return "+xT(e,t,n)+"})"}(e,t,n):"{key:"+e+",fn:function("+String(t.slotScope)+"){return "+("template"===t.tag?t.if?t.if+"?"+(AT(t,n)||"undefined")+":undefined":AT(t,n)||"undefined":mT(t,n))+"}}"}function AT(e,t,n,r,i){var a=e.children;if(a.length){var o=a[0];if(1===a.length&&o.for&&"template"!==o.tag&&"slot"!==o.tag)return(r||mT)(o,t);var s=n?function(e,t){for(var n=0,r=0;r<e.length;r++){var i=e[r];if(1===i.type){if(wT(i)||i.ifConditions&&i.ifConditions.some((function(e){return wT(e.block)}))){n=2;break}(t(i)||i.ifConditions&&i.ifConditions.some((function(e){return t(e.block)})))&&(n=1)}}return n}(a,t.maybeComponent):0,c=i||ET;return"["+a.map((function(e){return c(e,t)})).join(",")+"]"+(s?","+s:"")}}function wT(e){return void 0!==e.for||"template"===e.tag||"slot"===e.tag}function ET(e,t){return 1===e.type?mT(e,t):3===e.type&&e.isComment?function(e){return"_e("+JSON.stringify(e.text)+")"}(e):"_v("+(2===(n=e).type?n.expression:ST(JSON.stringify(n.text)))+")";var n}function TT(e){for(var t="",n=0;n<e.length;n++){var r=e[n];t+='"'+r.name+'":'+ST(r.value)+","}return t.slice(0,-1)}function ST(e){return e.replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029")}function CT(e,t){try{return new Function(e)}catch(n){return t.push({err:n,code:e}),Rb}}function MT(e){var t=Object.create(null);return function(n,r,i){(r=Mb({},r)).warn,delete r.warn;var a=r.delimiters?String(r.delimiters)+n:n;if(t[a])return t[a];var o=e(n,r),s={},c=[];return s.render=CT(o.render,c),s.staticRenderFns=o.staticRenderFns.map((function(e){return CT(e,c)})),t[a]=s}}new RegExp("\\b"+"do,if,for,let,new,try,var,case,else,with,await,break,catch,class,const,super,throw,while,yield,delete,export,import,return,switch,default,extends,finally,continue,debugger,function,arguments".split(",").join("\\b|\\b")+"\\b"),new RegExp("\\b"+"delete,typeof,void".split(",").join("\\s*\\([^\\)]*\\)|\\b")+"\\s*\\([^\\)]*\\)");var kT,RT,LT=(kT=function(e,t){var n=function(e,t){xE=t.warn||bA,SE=t.isPreTag||Lb,CE=t.mustUseProp||Lb,ME=t.getTagNamespace||Lb,wE=_A(t.modules,"transformNode"),EE=_A(t.modules,"preTransformNode"),TE=_A(t.modules,"postTransformNode"),AE=t.delimiters;var n,r,i=[],a=!1!==t.preserveWhitespace,o=!1,s=!1;function c(e){e.pre&&(o=!1),SE(e.tag)&&(s=!1);for(var n=0;n<TE.length;n++)TE[n](e,t)}return function(e,t){for(var n,r,i=[],a=t.expectHTML,o=t.isUnaryTag||Lb,s=t.canBeLeftOpenTag||Lb,c=0;e;){if(n=e,r&&hE(r)){var l=0,u=r.toLowerCase(),d=pE[u]||(pE[u]=new RegExp("([\\s\\S]*?)(</"+u+"[^>]*>)","i")),f=e.replace(d,(function(e,n,r){return l=r.length,hE(u)||"noscript"===u||(n=n.replace(/<!\--([\s\S]*?)-->/g,"$1").replace(/<!\[CDATA\[([\s\S]*?)]]>/g,"$1")),_E(u,n)&&(n=n.slice(1)),t.chars&&t.chars(n),""}));c+=e.length-f.length,e=f,S(u,c-l,c)}else{var h=e.indexOf("<");if(0===h){if(uE.test(e)){var p=e.indexOf("--\x3e");if(p>=0){t.shouldKeepComment&&t.comment(e.substring(4,p)),w(p+3);continue}}if(dE.test(e)){var m=e.indexOf("]>");if(m>=0){w(m+2);continue}}var v=e.match(lE);if(v){w(v[0].length);continue}var g=e.match(cE);if(g){var b=c;w(g[0].length),S(g[1],b,c);continue}var _=E();if(_){T(_),_E(r,e)&&w(1);continue}}var y=void 0,x=void 0,A=void 0;if(h>=0){for(x=e.slice(h);!(cE.test(x)||oE.test(x)||uE.test(x)||dE.test(x)||(A=x.indexOf("<",1))<0);)h+=A,x=e.slice(h);y=e.substring(0,h),w(h)}h<0&&(y=e,e=""),t.chars&&y&&t.chars(y)}if(e===n){t.chars&&t.chars(e);break}}function w(t){c+=t,e=e.substring(t)}function E(){var t=e.match(oE);if(t){var n,r,i={tagName:t[1],attrs:[],start:c};for(w(t[0].length);!(n=e.match(sE))&&(r=e.match(rE));)w(r[0].length),i.attrs.push(r);if(n)return i.unarySlash=n[1],w(n[0].length),i.end=c,i}}function T(e){var n=e.tagName,c=e.unarySlash;a&&("p"===r&&nE(n)&&S(r),s(n)&&r===n&&S(n));for(var l=o(n)||!!c,u=e.attrs.length,d=new Array(u),f=0;f<u;f++){var h=e.attrs[f];fE&&-1===h[0].indexOf('""')&&(""===h[3]&&delete h[3],""===h[4]&&delete h[4],""===h[5]&&delete h[5]);var p=h[3]||h[4]||h[5]||"",m="a"===n&&"href"===h[1]?t.shouldDecodeNewlinesForHref:t.shouldDecodeNewlines;d[f]={name:h[1],value:yE(p,m)}}l||(i.push({tag:n,lowerCasedTag:n.toLowerCase(),attrs:d}),r=n),t.start&&t.start(n,d,l,e.start,e.end)}function S(e,n,a){var o,s;if(null==n&&(n=c),null==a&&(a=c),e&&(s=e.toLowerCase()),e)for(o=i.length-1;o>=0&&i[o].lowerCasedTag!==s;o--);else o=0;if(o>=0){for(var l=i.length-1;l>=o;l--)t.end&&t.end(i[l].tag,n,a);i.length=o,r=o&&i[o-1].tag}else"br"===s?t.start&&t.start(e,[],!0,n,a):"p"===s&&(t.start&&t.start(e,[],!1,n,a),t.end&&t.end(e,n,a))}S()}(e,{warn:xE,expectHTML:t.expectHTML,isUnaryTag:t.isUnaryTag,canBeLeftOpenTag:t.canBeLeftOpenTag,shouldDecodeNewlines:t.shouldDecodeNewlines,shouldDecodeNewlinesForHref:t.shouldDecodeNewlinesForHref,shouldKeepComment:t.comments,start:function(e,a,l){var u=r&&r.ns||ME(e);qb&&"svg"===u&&(a=function(e){for(var t=[],n=0;n<e.length;n++){var r=e[n];$E.test(r.name)||(r.name=r.name.replace(WE,""),t.push(r))}return t}(a));var d,f=FE(e,a,r);u&&(f.ns=u),"style"!==(d=f).tag&&("script"!==d.tag||d.attrsMap.type&&"text/javascript"!==d.attrsMap.type)||n_()||(f.forbidden=!0);for(var h=0;h<EE.length;h++)f=EE[h](f,t)||f;if(o||(function(e){null!=SA(e,"v-pre")&&(e.pre=!0)}(f),f.pre&&(o=!0)),SE(f.tag)&&(s=!0),o?function(e){var t=e.attrsList.length;if(t)for(var n=e.attrs=new Array(t),r=0;r<t;r++)n[r]={name:e.attrsList[r].name,value:JSON.stringify(e.attrsList[r].value)};else e.pre||(e.plain=!0)}(f):f.processed||(zE(f),function(e){var t=SA(e,"v-if");if(t)e.if=t,HE(e,{exp:t,block:e});else{null!=SA(e,"v-else")&&(e.else=!0);var n=SA(e,"v-else-if");n&&(e.elseif=n)}}(f),function(e){null!=SA(e,"v-once")&&(e.once=!0)}(f),BE(f,t)),n?i.length||n.if&&(f.elseif||f.else)&&HE(n,{exp:f.elseif,block:f}):n=f,r&&!f.forbidden)if(f.elseif||f.else)!function(e,t){var n=function(e){for(var t=e.length;t--;){if(1===e[t].type)return e[t];e.pop()}}(t.children);n&&n.if&&HE(n,{exp:e.elseif,block:e})}(f,r);else if(f.slotScope){r.plain=!1;var p=f.slotTarget||'"default"';(r.scopedSlots||(r.scopedSlots={}))[p]=f}else r.children.push(f),f.parent=r;l?c(f):(r=f,i.push(f))},end:function(){var e=i[i.length-1],t=e.children[e.children.length-1];t&&3===t.type&&" "===t.text&&!s&&e.children.pop(),i.length-=1,r=i[i.length-1],c(e)},chars:function(e){if(r&&(!qb||"textarea"!==r.tag||r.attrsMap.placeholder!==e)){var t,n,i=r.children;(e=s||e.trim()?"script"===(t=r).tag||"style"===t.tag?e:UE(e):a&&i.length?" ":"")&&(!o&&" "!==e&&(n=function(e,t){var n=t?Zw(t):qw;if(n.test(e)){for(var r,i,a,o=[],s=[],c=n.lastIndex=0;r=n.exec(e);){(i=r.index)>c&&(s.push(a=e.slice(c,i)),o.push(JSON.stringify(a)));var l=vA(r[1].trim());o.push("_s("+l+")"),s.push({"@binding":l}),c=i+r[0].length}return c<e.length&&(s.push(a=e.slice(c)),o.push(JSON.stringify(a))),{expression:o.join("+"),tokens:s}}}(e,AE))?i.push({type:2,expression:n.expression,tokens:n.tokens,text:e}):" "===e&&i.length&&" "===i[i.length-1].text||i.push({type:3,text:e}))}},comment:function(e){r.children.push({type:3,text:e,isComment:!0})}}),n}(e.trim(),t);!1!==t.optimize&&eT(n,t);var r=pT(n,t);return{ast:n,render:r.render,staticRenderFns:r.staticRenderFns}},function(e){function t(t,n){var r=Object.create(e),i=[],a=[];if(r.warn=function(e,t){(t?a:i).push(e)},n)for(var o in n.modules&&(r.modules=(e.modules||[]).concat(n.modules)),n.directives&&(r.directives=Mb(Object.create(e.directives||null),n.directives)),n)"modules"!==o&&"directives"!==o&&(r[o]=n[o]);var s=kT(t,r);return s.errors=i,s.tips=a,s}return{compile:t,compileToFunctions:MT(t)}}),OT=LT(JE).compileToFunctions;function IT(e){return(RT=RT||document.createElement("div")).innerHTML=e?'<a href="\n"/>':'<div a="\n"/>',RT.innerHTML.indexOf("&#10;")>0}var PT=!!Wb&&IT(!1),DT=!!Wb&&IT(!0),NT=yb((function(e){var t=Vx(e);return t&&t.innerHTML})),UT=mx.prototype.$mount;mx.prototype.$mount=function(e,t){if((e=e&&Vx(e))===document.body||e===document.documentElement)return this;var n=this.$options;if(!n.render){var r=n.template;if(r)if("string"==typeof r)"#"===r.charAt(0)&&(r=NT(r));else{if(!r.nodeType)return this;r=r.innerHTML}else e&&(r=function(e){if(e.outerHTML)return e.outerHTML;var t=document.createElement("div");return t.appendChild(e.cloneNode(!0)),t.innerHTML}(e));if(r){var i=OT(r,{shouldDecodeNewlines:PT,shouldDecodeNewlinesForHref:DT,delimiters:n.delimiters,comments:n.comments},this),a=i.render,o=i.staticRenderFns;n.render=a,n.staticRenderFns=o}}return UT.call(this,e,t)},mx.compile=OT;var FT=mx;function BT(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}function zT(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{};t%2?BT(Object(n),!0).forEach((function(t){jT(e,t,n[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(n)):BT(Object(n)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(n,t))}))}return e}function HT(e){return HT="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},HT(e)}function VT(e,t,n,r,i,a,o){try{var s=e[a](o),c=s.value}catch(e){return void n(e)}s.done?t(c):Promise.resolve(c).then(r,i)}function GT(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var a=e.apply(t,n);function o(e){VT(a,r,i,o,s,"next",e)}function s(e){VT(a,r,i,o,s,"throw",e)}o(void 0)}))}}function $T(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function WT(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function jT(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function XT(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&qT(e,t)}function YT(e){return YT=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},YT(e)}function qT(e,t){return qT=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},qT(e,t)}function KT(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},a=Object.keys(e);for(r=0;r<a.length;r++)n=a[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var a=Object.getOwnPropertySymbols(e);for(r=0;r<a.length;r++)n=a[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function ZT(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=YT(e);if(t){var i=YT(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return function(e,t){if(t&&("object"==typeof t||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e)}(this,n)}}function JT(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,a=[],o=!0,s=!1;try{for(n=n.call(e);!(o=(r=n.next()).done)&&(a.push(r.value),!t||a.length!==t);o=!0);}catch(e){s=!0,i=e}finally{try{o||null==n.return||n.return()}finally{if(s)throw i}}return a}}(e,t)||eS(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function QT(e){return function(e){if(Array.isArray(e))return tS(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||eS(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function eS(e,t){if(e){if("string"==typeof e)return tS(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(e):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?tS(e,t):void 0}}function tS(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function nS(e,t){var n="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!n){if(Array.isArray(e)||(n=eS(e))||t&&e&&"number"==typeof e.length){n&&(e=n);var r=0,i=function(){};return{s:i,n:function(){return r>=e.length?{done:!0}:{done:!1,value:e[r++]}},e:function(e){throw e},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var a,o=!0,s=!1;return{s:function(){n=n.call(e)},n:function(){var e=n.next();return o=e.done,e},e:function(e){s=!0,a=e},f:function(){try{o||null==n.return||n.return()}finally{if(s)throw a}}}}function rS(e){return JSON.parse(JSON.stringify(e))}function iS(e,t){return aS.apply(this,arguments)}function aS(){return(aS=GT(regeneratorRuntime.mark((function e(t,n){var r,i,a,o,s,c,l,u,d;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return r=n.data,i=void 0===r?{}:r,a=n.meta,o=void 0===a?{}:a,s=n.x,c=void 0===s?0:s,l=n.y,u=void 0===l?0:l,e.next=3,t.createNode(rS(i));case 3:return(d=e.sent).meta=Object.assign(rS(o),d.meta),d.position[0]=c,d.position[1]=u,e.abrupt("return",d);case 8:case"end":return e.stop()}}),e)})))).apply(this,arguments)}function oS(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];"object"===HT(e)&&Object.keys(e).map((function(r){"function"==typeof e[r]?t(r,e[r],n):oS(e[r],t,[].concat(QT(n),[r]))}))}var sS=function(e){return{props:{delay:{type:Number,required:!0}},data:function(){return{timeoutHide:function(){}}},methods:{cancelHide:function(){var e=this.timeoutHide;e&&e.cancel&&this.timeoutHide.cancel()}},mounted:function(){this.timeoutHide=function(e,t,n){var r,i,a,o,s,c,l=0,u=!1,d=!1,f=!0;if("function"!=typeof e)throw new TypeError("Expected a function");function h(t){var n=r,a=i;return r=i=void 0,l=t,o=e.apply(a,n)}function p(e){var n=e-c;return void 0===c||n>=t||n<0||d&&e-l>=a}function m(){var e=zg();if(p(e))return v(e);s=setTimeout(m,function(e){var n=t-(e-c);return d?nb(n,a-(e-l)):n}(e))}function v(e){return s=void 0,f&&r?h(e):(r=i=void 0,o)}function g(){var e=zg(),n=p(e);if(r=arguments,i=this,c=e,n){if(void 0===s)return function(e){return l=e,s=setTimeout(m,t),u?h(e):o}(c);if(d)return clearTimeout(s),s=setTimeout(m,t),h(c)}return void 0===s&&(s=setTimeout(m,t)),o}return t=eb(t)||0,Ng(n)&&(u=!!n.leading,a=(d="maxWait"in n)?tb(eb(n.maxWait)||0,t):a,f="trailing"in n?!!n.trailing:f),g.cancel=function(){void 0!==s&&clearTimeout(s),l=0,r=c=i=s=void 0},g.flush=function(){return void 0===s?o:v(zg())},g}(this[e],this.delay)}}};const cS={name:"Item",mixins:[sS("hideSubitems")],props:{item:Object,args:Object},data:function(){return{visibleSubitems:!1}},computed:{hasSubitems:function(){return this.item.subitems}},methods:{showSubitems:function(){this.visibleSubitems=!0,this.cancelHide()},hideSubitems:function(){this.visibleSubitems=!1},onClick:function(e){e.stopPropagation(),this.item.onClick&&this.item.onClick(this.args),this.$root.$emit("hide")}}};var lS=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"item",class:{hasSubitems:e.hasSubitems},on:{click:function(t){e.onClick(t)},mouseover:function(t){e.showSubitems()},mouseleave:function(t){e.timeoutHide()}}},[e._v(e._s(e.item.title)),n("div",{directives:[{name:"show",rawName:"v-show",value:e.hasSubitems&&this.visibleSubitems,expression:"hasSubitems && this.visibleSubitems"}],staticClass:"subitems"},e._l(e.item.subitems,(function(t){return n("Item",{key:t.title,attrs:{item:t,args:e.args,delay:e.delay}})})))])};lS._withStripped=!0;var uS=function(e,t,n,r,i,a,o,s){const c=("function"==typeof n?n.options:n)||{};c.__file="/home/ni55an/Workflow/retejs/context-menu-plugin/src/menu/Item.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0),c._scopeId="data-v-3092298f";{let e;if(t&&(e=function(e){t.call(this,o())}),void 0!==e)if(c.functional){const t=c.render;c.render=function(n,r){return e.call(r),t(n,r)}}else{const t=c.beforeCreate;c.beforeCreate=t?[].concat(t,e):[e]}}return c}({render:lS,staticRenderFns:[]},(function(e){e&&e("data-v-3092298f_0",{source:"@charset \"UTF-8\";\n.item[data-v-3092298f], .item .subitems .subitem[data-v-3092298f] {\n  color: #fff;\n  padding: 4px;\n  border-bottom: 1px solid rgba(69, 103, 255, 0.8);\n  background-color: rgba(110, 136, 255, 0.8);\n  cursor: pointer;\n  width: 100%;\n  position: relative;\n}\n.item[data-v-3092298f]:first-child, .item .subitems .subitem[data-v-3092298f]:first-child {\n    border-top-left-radius: 5px;\n    border-top-right-radius: 5px;\n}\n.item[data-v-3092298f]:last-child, .item .subitems .subitem[data-v-3092298f]:last-child {\n    border-bottom-left-radius: 5px;\n    border-bottom-right-radius: 5px;\n}\n.item[data-v-3092298f]:hover, .item .subitems .subitem[data-v-3092298f]:hover {\n    background-color: rgba(130, 153, 255, 0.8);\n}\n.hasSubitems.item[data-v-3092298f]:after, .item .subitems .hasSubitems.subitem[data-v-3092298f]:after {\n  content: '►';\n  position: absolute;\n  opacity: 0.6;\n  right: 5px;\n  top: 5px;\n}\n.item .subitems[data-v-3092298f], .item .subitems .subitem .subitems[data-v-3092298f] {\n  position: absolute;\n  top: 0;\n  left: 100%;\n  width: 120px;\n}\n\n/*# sourceMappingURL=Item.vue.map */",map:{version:3,sources:["Item.vue","/home/ni55an/Workflow/retejs/context-menu-plugin/src/menu/Item.vue"],names:[],mappings:"AAAA,gBAAgB;ACyDhB;EDvDE,WAAW;EACX,YAAY;EACZ,gDAAgD;EAChD,0CAA0C;EAC1C,eAAe;EACf,WAAW;EACX,kBAAkB;AAAE;ACiDtB;ID/CI,2BAA2B;IAC3B,4BAA4B;AAAE;AC8ClC;ID5CI,8BAA8B;IAC9B,+BAA+B;AAAE;AC2CrC;IDzCI,0CAA0C;AAAE;AC2ChD;EACA,YAAA;EACA,kBAAA;EACA,YAAA;EACA,UAAA;EACA,QAAA;AAAA;AAPA;EASA,kBAAA;EACA,MAAA;EACA,UAAA;EACA,YAAA;AAAA;;ADtCA,mCAAmC",file:"Item.vue",sourcesContent:["@charset \"UTF-8\";\n.item, .item .subitems .subitem {\n  color: #fff;\n  padding: 4px;\n  border-bottom: 1px solid rgba(69, 103, 255, 0.8);\n  background-color: rgba(110, 136, 255, 0.8);\n  cursor: pointer;\n  width: 100%;\n  position: relative; }\n  .item:first-child, .item .subitems .subitem:first-child {\n    border-top-left-radius: 5px;\n    border-top-right-radius: 5px; }\n  .item:last-child, .item .subitems .subitem:last-child {\n    border-bottom-left-radius: 5px;\n    border-bottom-right-radius: 5px; }\n  .item:hover, .item .subitems .subitem:hover {\n    background-color: rgba(130, 153, 255, 0.8); }\n\n.hasSubitems.item:after, .item .subitems .hasSubitems.subitem:after {\n  content: '►';\n  position: absolute;\n  opacity: 0.6;\n  right: 5px;\n  top: 5px; }\n\n.item .subitems, .item .subitems .subitem .subitems {\n  position: absolute;\n  top: 0;\n  left: 100%;\n  width: 120px; }\n\n/*# sourceMappingURL=Item.vue.map */",'<template lang="pug">\n.item(\n  @click="onClick($event)"\n  @mouseover="showSubitems()"\n  @mouseleave="timeoutHide()"\n  :class="{ hasSubitems }"\n) {{item.title}}\n  .subitems(v-show="hasSubitems && this.visibleSubitems")\n    Item(v-for="subitem in item.subitems"\n      :key="subitem.title"\n      :item="subitem"\n      :args="args"\n      :delay="delay"\n      )\n</template>\n\n<script>\nimport hideMixin from \'./debounceHide\'\n\nexport default {\n  name: \'Item\',\n  mixins: [hideMixin(\'hideSubitems\')],\n  props: { item: Object, args: Object },\n  data() {\n    return {\n      visibleSubitems: false, \n    }\n  },\n  computed: {\n    hasSubitems() {\n      return this.item.subitems\n    }\n  },\n  methods: {\n    showSubitems() {\n      this.visibleSubitems = true;\n      this.cancelHide();\n    },\n    hideSubitems() {\n      this.visibleSubitems = false;\n    },\n    onClick(e) {\n      e.stopPropagation();\n      \n      if(this.item.onClick)\n        this.item.onClick(this.args);\n      this.$root.$emit(\'hide\');\n    }\n  }\n}\n<\/script>\n\n\n<style lang="sass" scoped>\n@import \'../vars.sass\'\n@import \'../common.sass\'\n\n.item\n  @extend .item\n  &.hasSubitems:after\n    content: \'►\'\n    position: absolute\n    opacity: 0.6\n    right: 5px\n    top: 5px\n  .subitems\n    position: absolute\n    top: 0\n    left: 100%\n    width: $width\n    .subitem\n      @extend .item\n</style>\n']},media:void 0})}),cS,0,0,0,(function e(){const t=document.head||document.getElementsByTagName("head")[0],n=e.styles||(e.styles={}),r="undefined"!=typeof navigator&&/msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());return function(e,i){if(document.querySelector('style[data-vue-ssr-id~="'+e+'"]'))return;const a=r?i.media||"default":e,o=n[a]||(n[a]={ids:[],parts:[],element:void 0});if(!o.ids.includes(e)){let n=i.source,s=o.ids.length;if(o.ids.push(e),r&&(o.element=o.element||document.querySelector("style[data-group="+a+"]")),!o.element){const e=o.element=document.createElement("style");e.type="text/css",i.media&&e.setAttribute("media",i.media),r&&(e.setAttribute("data-group",a),e.setAttribute("data-next-index","0")),t.appendChild(e)}if(r&&(s=parseInt(o.element.getAttribute("data-next-index")),o.element.setAttribute("data-next-index",s+1)),o.element.styleSheet)o.parts.push(n),o.element.styleSheet.cssText=o.parts.filter(Boolean).join("\n");else{const e=document.createTextNode(n),t=o.element.childNodes;t[s]&&o.element.removeChild(t[s]),t.length?o.element.insertBefore(e,t[s]):o.element.appendChild(e)}}}}));var dS=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"search"},[n("input",{directives:[{name:"model",rawName:"v-model",value:e.value,expression:"value"}],domProps:{value:e.value},on:{input:function(t){t.target.composing||(e.value=t.target.value)}}})])};dS._withStripped=!0;var fS=function(e,t,n,r,i,a,o,s){const c=("function"==typeof n?n.options:n)||{};c.__file="/home/ni55an/Workflow/retejs/context-menu-plugin/src/menu/Search.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0),c._scopeId="data-v-149fa19e";{let e;if(t&&(e=function(e){t.call(this,o())}),void 0!==e)if(c.functional){const t=c.render;c.render=function(n,r){return e.call(r),t(n,r)}}else{const t=c.beforeCreate;c.beforeCreate=t?[].concat(t,e):[e]}}return c}({render:dS,staticRenderFns:[]},(function(e){e&&e("data-v-149fa19e_0",{source:".search input[data-v-149fa19e] {\n  color: white;\n  padding: 1px 8px;\n  border: 1px solid white;\n  border-radius: 10px;\n  font-size: 16px;\n  font-family: serif;\n  width: 100%;\n  box-sizing: border-box;\n  background: transparent;\n}\n\n/*# sourceMappingURL=Search.vue.map */",map:{version:3,sources:["/home/ni55an/Workflow/retejs/context-menu-plugin/src/menu/Search.vue","Search.vue"],names:[],mappings:"AAkBA;EAEA,YAAA;EACA,gBAAA;EACA,uBAAA;EACA,mBAAA;EACA,eAAA;EACA,kBAAA;EACA,WAAA;EACA,sBAAA;EACA,uBAAA;AAAA;;ACjBA,qCAAqC",file:"Search.vue",sourcesContent:["<template lang=\"pug\">\n.search\n  input(v-model=\"value\")\n</template>\n\n<script>\nexport default {\n  props: ['value', 'search'],\n  watch: {\n    value() {\n      this.$emit('search', this.value);\n    }\n  }\n}\n<\/script>\n\n\n<style lang=\"sass\" scoped>\n.search\n  input    \n    color: white\n    padding: 1px 8px\n    border: 1px solid white\n    border-radius: 10px\n    font-size: 16px\n    font-family: serif\n    width: 100%\n    box-sizing: border-box\n    background: transparent\n</style>\n",".search input {\n  color: white;\n  padding: 1px 8px;\n  border: 1px solid white;\n  border-radius: 10px;\n  font-size: 16px;\n  font-family: serif;\n  width: 100%;\n  box-sizing: border-box;\n  background: transparent; }\n\n/*# sourceMappingURL=Search.vue.map */"]},media:void 0})}),{props:["value","search"],watch:{value:function(){this.$emit("search",this.value)}}},0,0,0,(function e(){const t=document.head||document.getElementsByTagName("head")[0],n=e.styles||(e.styles={}),r="undefined"!=typeof navigator&&/msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());return function(e,i){if(document.querySelector('style[data-vue-ssr-id~="'+e+'"]'))return;const a=r?i.media||"default":e,o=n[a]||(n[a]={ids:[],parts:[],element:void 0});if(!o.ids.includes(e)){let n=i.source,s=o.ids.length;if(o.ids.push(e),r&&(o.element=o.element||document.querySelector("style[data-group="+a+"]")),!o.element){const e=o.element=document.createElement("style");e.type="text/css",i.media&&e.setAttribute("media",i.media),r&&(e.setAttribute("data-group",a),e.setAttribute("data-next-index","0")),t.appendChild(e)}if(r&&(s=parseInt(o.element.getAttribute("data-next-index")),o.element.setAttribute("data-next-index",s+1)),o.element.styleSheet)o.parts.push(n),o.element.styleSheet.cssText=o.parts.filter(Boolean).join("\n");else{const e=document.createTextNode(n),t=o.element.childNodes;t[s]&&o.element.removeChild(t[s]),t.length?o.element.insertBefore(e,t[s]):o.element.appendChild(e)}}}})),hS={props:{searchBar:Boolean,searchKeep:Function},mixins:[sS("hide")],data:function(){return{x:0,y:0,visible:!1,args:{},filter:"",items:[]}},computed:{style:function(){return{top:this.y+"px",left:this.x+"px"}},filtered:function(){var e=this;if(!this.filter)return this.items;var t=new RegExp(this.filter,"i");return this.extractLeafs(this.items).filter((function(n){var r=n.title;return e.searchKeep(r)||r.match(t)}))}},methods:{extractLeafs:function(e){var t=this;if(!e)return[];var n=[];return e.map((function(e){e.subitems||n.push(e),n.push.apply(n,QT(t.extractLeafs(e.subitems)))})),n},onSearch:function(e){this.filter=e},show:function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};this.visible=!0,this.x=e,this.y=t,this.args=n,this.cancelHide()},hide:function(){this.visible=!1},additem:function(e,t){var n,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[],i=this.items,a=nS(r);try{var o=function(){var e=n.value,t=i.find((function(t){return t.title===e}));t||(t={title:e,subitems:[]},i.push(t)),i=t.subitems||(t.subitems=[])};for(a.s();!(n=a.n()).done;)o()}catch(e){a.e(e)}finally{a.f()}i.push({title:e,onClick:t})}},updated:function(){if(this.$refs.menu){var e=(n=[this.x,this.y],r=this.$refs.menu,a=(i=JT(n,2))[0],o=i[1],[Math.min(a,window.innerWidth-r.clientWidth),Math.min(o,window.innerHeight-r.clientHeight)]),t=JT(e,2);this.x=t[0],this.y=t[1]}var n,r,i,a,o},mounted:function(){this.$root.$on("show",this.show),this.$root.$on("hide",this.hide),this.$root.$on("additem",this.additem)},components:{Item:uS,Search:fS}};const pS=hS;var mS=function(){var e=this,t=e.$createElement,n=e._self._c||t;return e.visible?n("div",{ref:"menu",staticClass:"context-menu",style:e.style,on:{mouseleave:function(t){e.timeoutHide()},mouseover:function(t){e.cancelHide()},contextmenu:function(e){e.preventDefault()},wheel:function(e){e.stopPropagation()}}},[e.searchBar?n("Search",{on:{search:e.onSearch},model:{value:e.filter,callback:function(t){e.filter=t},expression:"filter"}}):e._e(),e._l(e.filtered,(function(t){return n("Item",{key:t.title,attrs:{item:t,args:e.args,delay:e.delay/2}})}))],2):e._e()};mS._withStripped=!0;var vS=function(e,t,n,r,i,a,o,s){const c=("function"==typeof n?n.options:n)||{};c.__file="/home/ni55an/Workflow/retejs/context-menu-plugin/src/menu/Menu.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0),c._scopeId="data-v-4da435cc";{let e;if(t&&(e=function(e){t.call(this,o())}),void 0!==e)if(c.functional){const t=c.render;c.render=function(n,r){return e.call(r),t(n,r)}}else{const t=c.beforeCreate;c.beforeCreate=t?[].concat(t,e):[e]}}return c}({render:mS,staticRenderFns:[]},(function(e){e&&e("data-v-4da435cc_0",{source:".item[data-v-4da435cc], .context-menu .search[data-v-4da435cc] {\n  color: #fff;\n  padding: 4px;\n  border-bottom: 1px solid rgba(69, 103, 255, 0.8);\n  background-color: rgba(110, 136, 255, 0.8);\n  cursor: pointer;\n  width: 100%;\n  position: relative;\n}\n.item[data-v-4da435cc]:first-child, .context-menu .search[data-v-4da435cc]:first-child {\n    border-top-left-radius: 5px;\n    border-top-right-radius: 5px;\n}\n.item[data-v-4da435cc]:last-child, .context-menu .search[data-v-4da435cc]:last-child {\n    border-bottom-left-radius: 5px;\n    border-bottom-right-radius: 5px;\n}\n.item[data-v-4da435cc]:hover, .context-menu .search[data-v-4da435cc]:hover {\n    background-color: rgba(130, 153, 255, 0.8);\n}\n.context-menu[data-v-4da435cc] {\n  left: 0;\n  top: 0;\n  position: fixed;\n  padding: 10px;\n  width: 120px;\n  margin-top: -20px;\n  margin-left: -60px;\n}\n\n/*# sourceMappingURL=Menu.vue.map */",map:{version:3,sources:["Menu.vue","/home/ni55an/Workflow/retejs/context-menu-plugin/src/menu/Menu.vue"],names:[],mappings:"AAAA;EACE,WAAW;EACX,YAAY;EACZ,gDAAgD;EAChD,0CAA0C;EAC1C,eAAe;EACf,WAAW;EACX,kBAAkB;AAAE;AACpB;IACE,2BAA2B;IAC3B,4BAA4B;AAAE;AAChC;IACE,8BAA8B;IAC9B,+BAA+B;AAAE;AACnC;IACE,0CAA0C;AAAE;ACwGhD;EACA,OAAA;EACA,MAAA;EACA,eAAA;EACA,aAAA;EACA,YAAA;EACA,iBAAA;EACA,kBAAA;AAAA;;ADpGA,mCAAmC",file:"Menu.vue",sourcesContent:[".item, .context-menu .search {\n  color: #fff;\n  padding: 4px;\n  border-bottom: 1px solid rgba(69, 103, 255, 0.8);\n  background-color: rgba(110, 136, 255, 0.8);\n  cursor: pointer;\n  width: 100%;\n  position: relative; }\n  .item:first-child, .context-menu .search:first-child {\n    border-top-left-radius: 5px;\n    border-top-right-radius: 5px; }\n  .item:last-child, .context-menu .search:last-child {\n    border-bottom-left-radius: 5px;\n    border-bottom-right-radius: 5px; }\n  .item:hover, .context-menu .search:hover {\n    background-color: rgba(130, 153, 255, 0.8); }\n\n.context-menu {\n  left: 0;\n  top: 0;\n  position: fixed;\n  padding: 10px;\n  width: 120px;\n  margin-top: -20px;\n  margin-left: -60px; }\n\n/*# sourceMappingURL=Menu.vue.map */","<template lang=\"pug\">\n.context-menu(\n  ref=\"menu\"\n  v-if=\"visible\"\n  v-bind:style=\"style\",\n  @mouseleave='timeoutHide()',\n  @mouseover=\"cancelHide()\"\n  @contextmenu.prevent=\"\"\n  @wheel.stop=\"\"\n)\n  Search(v-if=\"searchBar\", v-model=\"filter\", @search=\"onSearch\")\n  Item(v-for='item in filtered'\n    :key=\"item.title\"\n    :item=\"item\"\n    :args=\"args\"\n    :delay=\"delay / 2\"\n  )\n</template>\n\n<script>\nimport hideMixin from './debounceHide'\nimport Item from './Item.vue';\nimport Search from './Search.vue';\nimport { fitViewport } from '../utils';\n\nexport default {\n  props: { searchBar: Boolean, searchKeep: Function },\n  mixins: [hideMixin('hide')],\n  data() {\n    return {\n      x: 0,\n      y: 0,\n      visible: false,\n      args: {},\n      filter: '',\n      items: [],\n    }\n  },\n  computed: {\n    style() {\n      return {\n        top: this.y+'px', \n        left: this.x+'px'\n      }\n    },\n    filtered() {\n      if(!this.filter) return this.items;\n      const regex = new RegExp(this.filter, 'i');\n      \n      return this.extractLeafs(this.items)\n        .filter(({ title }) => {\n          return this.searchKeep(title) || title.match(regex)\n        });\n    }\n  },\n  methods: {\n    extractLeafs(items) {\n      if(!items) return [];\n      let leafs = [];\n      items.map(item => {\n        if(!item.subitems) leafs.push(item)\n\n        leafs.push(...this.extractLeafs(item.subitems))\n      })\n\n      return leafs;\n    },\n    onSearch(e) {\n      this.filter = e;\n    },\n    show(x, y, args = {}) {\n      this.visible = true;\n      this.x = x;\n      this.y = y;\n      this.args = args;\n  \n      this.cancelHide();\n    },\n    hide() {\n      this.visible = false;\n    },\n    additem(title, onClick, path = []) {\n      let items = this.items;\n      for(let level of path) {\n        let exist = items.find(i => i.title === level);\n\n        if(!exist) {\n          exist = { title: level, subitems: [] };\n          items.push(exist)\n        }\n\n        items = exist.subitems || (exist.subitems = []);\n      }\n\n      items.push({ title, onClick });\n    },\n  },\n  updated() {\n    if(this.$refs.menu) {\n      [this.x, this.y] = fitViewport([this.x, this.y], this.$refs.menu)\n    } \n  },\n  mounted() {\n    this.$root.$on('show', this.show);\n    this.$root.$on('hide', this.hide);\n    this.$root.$on('additem', this.additem);\n  },\n  components: {\n    Item,\n    Search\n  }\n}\n<\/script>\n\n\n<style lang=\"sass\" scoped>\n@import '../vars.sass'\n@import '../common.sass'\n\n.context-menu\n  left: 0\n  top: 0\n  position: fixed\n  padding: 10px\n  width: $width\n  margin-top: -20px\n  margin-left: -$width/2\n  .search\n    @extend .item\n</style>\n"]},media:void 0})}),pS,0,0,0,(function e(){const t=document.head||document.getElementsByTagName("head")[0],n=e.styles||(e.styles={}),r="undefined"!=typeof navigator&&/msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());return function(e,i){if(document.querySelector('style[data-vue-ssr-id~="'+e+'"]'))return;const a=r?i.media||"default":e,o=n[a]||(n[a]={ids:[],parts:[],element:void 0});if(!o.ids.includes(e)){let n=i.source,s=o.ids.length;if(o.ids.push(e),r&&(o.element=o.element||document.querySelector("style[data-group="+a+"]")),!o.element){const e=o.element=document.createElement("style");e.type="text/css",i.media&&e.setAttribute("media",i.media),r&&(e.setAttribute("data-group",a),e.setAttribute("data-next-index","0")),t.appendChild(e)}if(r&&(s=parseInt(o.element.getAttribute("data-next-index")),o.element.setAttribute("data-next-index",s+1)),o.element.styleSheet)o.parts.push(n),o.element.styleSheet.cssText=o.parts.filter(Boolean).join("\n");else{const e=document.createTextNode(n),t=o.element.childNodes;t[s]&&o.element.removeChild(t[s]),t.length?o.element.insertBefore(e,t[s]):o.element.appendChild(e)}}}})),gS=function(){function e(t,n,r){$T(this,e);var i=document.createElement("div");t.view.container.appendChild(i),this.menu=new FT({render:function(e){return e(r||vS,{props:n})}}).$mount(i)}var t,n;return t=e,n=[{key:"addItem",value:function(){for(var e,t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];(e=this.menu).$emit.apply(e,["additem"].concat(n))}},{key:"show",value:function(){for(var e,t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];(e=this.menu).$emit.apply(e,["show"].concat(n))}},{key:"hide",value:function(){this.menu.$emit("hide")}}],n&&WT(t.prototype,n),e}(),bS=function(e){XT(n,e);var t=ZT(n);function n(e,r,i,a){var o,s=a.items,c=a.allocate,l=a.rename;$T(this,n),o=t.call(this,e,r,i);var u={x:0,y:0};e.on("mousemove",(function(e){var t=e.x,n=e.y;u.x=t,u.y=n}));var d,f=nS(e.components.values());try{var h=function(){var t=d.value,n=c(t);Array.isArray(n)&&o.addItem(l(t),GT(regeneratorRuntime.mark((function n(){return regeneratorRuntime.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:return n.t0=e,n.next=3,iS(t,u);case 3:n.t1=n.sent,n.t0.addNode.call(n.t0,n.t1);case 5:case"end":return n.stop()}}),n)}))),n)};for(f.s();!(d=f.n()).done;)h()}catch(e){f.e(e)}finally{f.f()}return oS(s,(function(e,t,n){return o.addItem(e,t,n)})),o}return n}(gS),_S=["name","position"],yS=function(e){XT(n,e);var t=ZT(n);function n(e,r,i,a){var o;return $T(this,n),o=t.call(this,e,r,i),!1!==a.Delete&&o.addItem("Delete",(function(t){var n=t.node;-1!==e.selected.list.indexOf(n)&&e.selected.remove(n),e.removeNode(n)})),!1!==a.Clone&&o.addItem("Clone",function(){var t=GT(regeneratorRuntime.mark((function t(n){var r,i,a,o,s,c,l,u;return regeneratorRuntime.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return r=n.node,i=r.name,a=JT(r.position,2),o=a[0],s=a[1],c=KT(r,_S),l=e.components.get(i),t.next=4,iS(l,zT(zT({},c),{},{x:o+10,y:s+10}));case 4:u=t.sent,e.addNode(u);case 6:case"end":return t.stop()}}),t)})));return function(e){return t.apply(this,arguments)}}()),oS(a,(function(e,t,n){return o.addItem(e,t,n)})),o}return n}(gS),xS=vS,AS=uS,wS=fS,ES={name:"context-menu",install:function(e,t){var n=t.searchBar,r=void 0===n||n,i=t.searchKeep,a=void 0===i?function(){return!1}:i,o=t.delay,s=void 0===o?1e3:o,c=t.items,l=void 0===c?{}:c,u=t.nodeItems,d=void 0===u?{}:u,f=t.allocate,h=void 0===f?function(){return[]}:f,p=t.rename,m=void 0===p?function(e){return e.name}:p,v=t.vueComponent,g=void 0===v?null:v;e.bind("hidecontextmenu"),e.bind("showcontextmenu");var b=null;e.on("hidecontextmenu",(function(){b&&b.hide()})),e.on("click contextmenu",(function(){e.trigger("hidecontextmenu")})),e.on("contextmenu",(function(t){var n=t.e,i=t.node;if(n.preventDefault(),n.stopPropagation(),e.trigger("showcontextmenu",{e:n,node:i})){var o=[n.clientX,n.clientY],c=o[0],u=o[1];i?(b=new yS(e,{searchBar:!1,delay:s},g,function(e){if(!Ng(e))return!1;var t=Yg(e);return"[object Function]"==t||"[object GeneratorFunction]"==t||"[object AsyncFunction]"==t||"[object Proxy]"==t}(d)?d(i):d)).show(c,u,{node:i}):(b=new bS(e,{searchBar:r,searchKeep:a,delay:s},g,{items:l,allocate:h,rename:m})).show(c,u)}}))}},TS=ES,SS=Object.freeze({}),CS=Array.isArray;function MS(e){return null==e}function kS(e){return null!=e}function RS(e){return!0===e}function LS(e){return"string"==typeof e||"number"==typeof e||"symbol"==typeof e||"boolean"==typeof e}function OS(e){return"function"==typeof e}function IS(e){return null!==e&&"object"==typeof e}var PS=Object.prototype.toString;function DS(e){return"[object Object]"===PS.call(e)}function NS(e){var t=parseFloat(String(e));return t>=0&&Math.floor(t)===t&&isFinite(e)}function US(e){return kS(e)&&"function"==typeof e.then&&"function"==typeof e.catch}function FS(e){return null==e?"":Array.isArray(e)||DS(e)&&e.toString===PS?JSON.stringify(e,null,2):String(e)}function BS(e){var t=parseFloat(e);return isNaN(t)?e:t}function zS(e,t){for(var n=Object.create(null),r=e.split(","),i=0;i<r.length;i++)n[r[i]]=!0;return t?function(e){return n[e.toLowerCase()]}:function(e){return n[e]}}var HS=zS("slot,component",!0),VS=zS("key,ref,slot,slot-scope,is");function GS(e,t){var n=e.length;if(n){if(t===e[n-1])return void(e.length=n-1);var r=e.indexOf(t);if(r>-1)return e.splice(r,1)}}var $S=Object.prototype.hasOwnProperty;function WS(e,t){return $S.call(e,t)}function jS(e){var t=Object.create(null);return function(n){return t[n]||(t[n]=e(n))}}var XS=/-(\w)/g,YS=jS((function(e){return e.replace(XS,(function(e,t){return t?t.toUpperCase():""}))})),qS=jS((function(e){return e.charAt(0).toUpperCase()+e.slice(1)})),KS=/\B([A-Z])/g,ZS=jS((function(e){return e.replace(KS,"-$1").toLowerCase()})),JS=Function.prototype.bind?function(e,t){return e.bind(t)}:function(e,t){function n(n){var r=arguments.length;return r?r>1?e.apply(t,arguments):e.call(t,n):e.call(t)}return n._length=e.length,n};function QS(e,t){t=t||0;for(var n=e.length-t,r=new Array(n);n--;)r[n]=e[n+t];return r}function eC(e,t){for(var n in t)e[n]=t[n];return e}function tC(e){for(var t={},n=0;n<e.length;n++)e[n]&&eC(t,e[n]);return t}function nC(e,t,n){}var rC=function(e,t,n){return!1},iC=function(e){return e};function aC(e,t){if(e===t)return!0;var n=IS(e),r=IS(t);if(!n||!r)return!n&&!r&&String(e)===String(t);try{var i=Array.isArray(e),a=Array.isArray(t);if(i&&a)return e.length===t.length&&e.every((function(e,n){return aC(e,t[n])}));if(e instanceof Date&&t instanceof Date)return e.getTime()===t.getTime();if(i||a)return!1;var o=Object.keys(e),s=Object.keys(t);return o.length===s.length&&o.every((function(n){return aC(e[n],t[n])}))}catch(e){return!1}}function oC(e,t){for(var n=0;n<e.length;n++)if(aC(e[n],t))return n;return-1}function sC(e){var t=!1;return function(){t||(t=!0,e.apply(this,arguments))}}var cC="data-server-rendered",lC=["component","directive","filter"],uC=["beforeCreate","created","beforeMount","mounted","beforeUpdate","updated","beforeDestroy","destroyed","activated","deactivated","errorCaptured","serverPrefetch","renderTracked","renderTriggered"],dC={optionMergeStrategies:Object.create(null),silent:!1,productionTip:!1,devtools:!1,performance:!1,errorHandler:null,warnHandler:null,ignoredElements:[],keyCodes:Object.create(null),isReservedTag:rC,isReservedAttr:rC,isUnknownElement:rC,getTagNamespace:nC,parsePlatformTagName:iC,mustUseProp:rC,async:!0,_lifecycleHooks:uC},fC=/a-zA-Z\u00B7\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u037D\u037F-\u1FFF\u200C-\u200D\u203F-\u2040\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD/;function hC(e){var t=(e+"").charCodeAt(0);return 36===t||95===t}function pC(e,t,n,r){Object.defineProperty(e,t,{value:n,enumerable:!!r,writable:!0,configurable:!0})}var mC=new RegExp("[^".concat(fC.source,".$_\\d]")),vC="__proto__"in{},gC="undefined"!=typeof window,bC=gC&&window.navigator.userAgent.toLowerCase(),_C=bC&&/msie|trident/.test(bC),yC=bC&&bC.indexOf("msie 9.0")>0,xC=bC&&bC.indexOf("edge/")>0;bC&&bC.indexOf("android");var AC=bC&&/iphone|ipad|ipod|ios/.test(bC);bC&&/chrome\/\d+/.test(bC),bC&&/phantomjs/.test(bC);var wC,EC=bC&&bC.match(/firefox\/(\d+)/),TC={}.watch,SC=!1;if(gC)try{var CC={};Object.defineProperty(CC,"passive",{get:function(){SC=!0}}),window.addEventListener("test-passive",null,CC)}catch(e){}var MC=function(){return void 0===wC&&(wC=!gC&&void 0!==n.g&&n.g.process&&"server"===n.g.process.env.VUE_ENV),wC},kC=gC&&window.__VUE_DEVTOOLS_GLOBAL_HOOK__;function RC(e){return"function"==typeof e&&/native code/.test(e.toString())}var LC,OC="undefined"!=typeof Symbol&&RC(Symbol)&&"undefined"!=typeof Reflect&&RC(Reflect.ownKeys);LC="undefined"!=typeof Set&&RC(Set)?Set:function(){function e(){this.set=Object.create(null)}return e.prototype.has=function(e){return!0===this.set[e]},e.prototype.add=function(e){this.set[e]=!0},e.prototype.clear=function(){this.set=Object.create(null)},e}();var IC=null;function PC(e){void 0===e&&(e=null),e||IC&&IC._scope.off(),IC=e,e&&e._scope.on()}var DC=function(){function e(e,t,n,r,i,a,o,s){this.tag=e,this.data=t,this.children=n,this.text=r,this.elm=i,this.ns=void 0,this.context=a,this.fnContext=void 0,this.fnOptions=void 0,this.fnScopeId=void 0,this.key=t&&t.key,this.componentOptions=o,this.componentInstance=void 0,this.parent=void 0,this.raw=!1,this.isStatic=!1,this.isRootInsert=!0,this.isComment=!1,this.isCloned=!1,this.isOnce=!1,this.asyncFactory=s,this.asyncMeta=void 0,this.isAsyncPlaceholder=!1}return Object.defineProperty(e.prototype,"child",{get:function(){return this.componentInstance},enumerable:!1,configurable:!0}),e}(),NC=function(e){void 0===e&&(e="");var t=new DC;return t.text=e,t.isComment=!0,t};function UC(e){return new DC(void 0,void 0,void 0,String(e))}function FC(e){var t=new DC(e.tag,e.data,e.children&&e.children.slice(),e.text,e.elm,e.context,e.componentOptions,e.asyncFactory);return t.ns=e.ns,t.isStatic=e.isStatic,t.key=e.key,t.isComment=e.isComment,t.fnContext=e.fnContext,t.fnOptions=e.fnOptions,t.fnScopeId=e.fnScopeId,t.asyncMeta=e.asyncMeta,t.isCloned=!0,t}var BC=0,zC=[],HC=function(){for(var e=0;e<zC.length;e++){var t=zC[e];t.subs=t.subs.filter((function(e){return e})),t._pending=!1}zC.length=0},VC=function(){function e(){this._pending=!1,this.id=BC++,this.subs=[]}return e.prototype.addSub=function(e){this.subs.push(e)},e.prototype.removeSub=function(e){this.subs[this.subs.indexOf(e)]=null,this._pending||(this._pending=!0,zC.push(this))},e.prototype.depend=function(t){e.target&&e.target.addDep(this)},e.prototype.notify=function(e){for(var t=this.subs.filter((function(e){return e})),n=0,r=t.length;n<r;n++)t[n].update()},e}();VC.target=null;var GC=[];function $C(e){GC.push(e),VC.target=e}function WC(){GC.pop(),VC.target=GC[GC.length-1]}var jC=Array.prototype,XC=Object.create(jC);["push","pop","shift","unshift","splice","sort","reverse"].forEach((function(e){var t=jC[e];pC(XC,e,(function(){for(var n=[],r=0;r<arguments.length;r++)n[r]=arguments[r];var i,a=t.apply(this,n),o=this.__ob__;switch(e){case"push":case"unshift":i=n;break;case"splice":i=n.slice(2)}return i&&o.observeArray(i),o.dep.notify(),a}))}));var YC=Object.getOwnPropertyNames(XC),qC={},KC=!0;function ZC(e){KC=e}var JC={notify:nC,depend:nC,addSub:nC,removeSub:nC},QC=function(){function e(e,t,n){if(void 0===t&&(t=!1),void 0===n&&(n=!1),this.value=e,this.shallow=t,this.mock=n,this.dep=n?JC:new VC,this.vmCount=0,pC(e,"__ob__",this),CS(e)){if(!n)if(vC)e.__proto__=XC;else for(var r=0,i=YC.length;r<i;r++)pC(e,o=YC[r],XC[o]);t||this.observeArray(e)}else{var a=Object.keys(e);for(r=0;r<a.length;r++){var o;tM(e,o=a[r],qC,void 0,t,n)}}}return e.prototype.observeArray=function(e){for(var t=0,n=e.length;t<n;t++)eM(e[t],!1,this.mock)},e}();function eM(e,t,n){return e&&WS(e,"__ob__")&&e.__ob__ instanceof QC?e.__ob__:!KC||!n&&MC()||!CS(e)&&!DS(e)||!Object.isExtensible(e)||e.__v_skip||sM(e)||e instanceof DC?void 0:new QC(e,t,n)}function tM(e,t,n,r,i,a){var o=new VC,s=Object.getOwnPropertyDescriptor(e,t);if(!s||!1!==s.configurable){var c=s&&s.get,l=s&&s.set;c&&!l||n!==qC&&2!==arguments.length||(n=e[t]);var u=!i&&eM(n,!1,a);return Object.defineProperty(e,t,{enumerable:!0,configurable:!0,get:function(){var t=c?c.call(e):n;return VC.target&&(o.depend(),u&&(u.dep.depend(),CS(t)&&iM(t))),sM(t)&&!i?t.value:t},set:function(t){var r,s,d=c?c.call(e):n;if((r=d)===(s=t)?0===r&&1/r!=1/s:r==r||s==s){if(l)l.call(e,t);else{if(c)return;if(!i&&sM(d)&&!sM(t))return void(d.value=t);n=t}u=!i&&eM(t,!1,a),o.notify()}}}),o}}function nM(e,t,n){if(!oM(e)){var r=e.__ob__;return CS(e)&&NS(t)?(e.length=Math.max(e.length,t),e.splice(t,1,n),r&&!r.shallow&&r.mock&&eM(n,!1,!0),n):t in e&&!(t in Object.prototype)?(e[t]=n,n):e._isVue||r&&r.vmCount?n:r?(tM(r.value,t,n,void 0,r.shallow,r.mock),r.dep.notify(),n):(e[t]=n,n)}}function rM(e,t){if(CS(e)&&NS(t))e.splice(t,1);else{var n=e.__ob__;e._isVue||n&&n.vmCount||oM(e)||WS(e,t)&&(delete e[t],n&&n.dep.notify())}}function iM(e){for(var t=void 0,n=0,r=e.length;n<r;n++)(t=e[n])&&t.__ob__&&t.__ob__.dep.depend(),CS(t)&&iM(t)}function aM(e){return function(e,t){oM(e)||eM(e,t,MC())}(e,!0),pC(e,"__v_isShallow",!0),e}function oM(e){return!(!e||!e.__v_isReadonly)}function sM(e){return!(!e||!0!==e.__v_isRef)}function cM(e,t,n){Object.defineProperty(e,n,{enumerable:!0,configurable:!0,get:function(){var e=t[n];if(sM(e))return e.value;var r=e&&e.__ob__;return r&&r.dep.depend(),e},set:function(e){var r=t[n];sM(r)&&!sM(e)?r.value=e:t[n]=e}})}var lM=jS((function(e){var t="&"===e.charAt(0),n="~"===(e=t?e.slice(1):e).charAt(0),r="!"===(e=n?e.slice(1):e).charAt(0);return{name:e=r?e.slice(1):e,once:n,capture:r,passive:t}}));function uM(e,t){function n(){var e=n.fns;if(!CS(e))return yk(e,null,arguments,t,"v-on handler");for(var r=e.slice(),i=0;i<r.length;i++)yk(r[i],null,arguments,t,"v-on handler")}return n.fns=e,n}function dM(e,t,n,r,i,a){var o,s,c,l;for(o in e)s=e[o],c=t[o],l=lM(o),MS(s)||(MS(c)?(MS(s.fns)&&(s=e[o]=uM(s,a)),RS(l.once)&&(s=e[o]=i(l.name,s,l.capture)),n(l.name,s,l.capture,l.passive,l.params)):s!==c&&(c.fns=s,e[o]=c));for(o in t)MS(e[o])&&r((l=lM(o)).name,t[o],l.capture)}function fM(e,t,n){var r;e instanceof DC&&(e=e.data.hook||(e.data.hook={}));var i=e[t];function a(){n.apply(this,arguments),GS(r.fns,a)}MS(i)?r=uM([a]):kS(i.fns)&&RS(i.merged)?(r=i).fns.push(a):r=uM([i,a]),r.merged=!0,e[t]=r}function hM(e,t,n,r,i){if(kS(t)){if(WS(t,n))return e[n]=t[n],i||delete t[n],!0;if(WS(t,r))return e[n]=t[r],i||delete t[r],!0}return!1}function pM(e){return LS(e)?[UC(e)]:CS(e)?vM(e):void 0}function mM(e){return kS(e)&&kS(e.text)&&!1===e.isComment}function vM(e,t){var n,r,i,a,o=[];for(n=0;n<e.length;n++)MS(r=e[n])||"boolean"==typeof r||(a=o[i=o.length-1],CS(r)?r.length>0&&(mM((r=vM(r,"".concat(t||"","_").concat(n)))[0])&&mM(a)&&(o[i]=UC(a.text+r[0].text),r.shift()),o.push.apply(o,r)):LS(r)?mM(a)?o[i]=UC(a.text+r):""!==r&&o.push(UC(r)):mM(r)&&mM(a)?o[i]=UC(a.text+r.text):(RS(e._isVList)&&kS(r.tag)&&MS(r.key)&&kS(t)&&(r.key="__vlist".concat(t,"_").concat(n,"__")),o.push(r)));return o}var gM=1,bM=2;function _M(e,t,n,r,i,a){return(CS(n)||LS(n))&&(i=r,r=n,n=void 0),RS(a)&&(i=bM),function(e,t,n,r,i){if(kS(n)&&kS(n.__ob__))return NC();if(kS(n)&&kS(n.is)&&(t=n.is),!t)return NC();var a,o;if(CS(r)&&OS(r[0])&&((n=n||{}).scopedSlots={default:r[0]},r.length=0),i===bM?r=pM(r):i===gM&&(r=function(e){for(var t=0;t<e.length;t++)if(CS(e[t]))return Array.prototype.concat.apply([],e);return e}(r)),"string"==typeof t){var s=void 0;o=e.$vnode&&e.$vnode.ns||dC.getTagNamespace(t),a=dC.isReservedTag(t)?new DC(dC.parsePlatformTagName(t),n,r,void 0,void 0,e):n&&n.pre||!kS(s=fR(e.$options,"components",t))?new DC(t,n,r,void 0,void 0,e):nR(s,n,e,r,t)}else a=nR(t,n,e,r);return CS(a)?a:kS(a)?(kS(o)&&yM(a,o),kS(n)&&function(e){IS(e.style)&&Dk(e.style),IS(e.class)&&Dk(e.class)}(n),a):NC()}(e,t,n,r,i)}function yM(e,t,n){if(e.ns=t,"foreignObject"===e.tag&&(t=void 0,n=!0),kS(e.children))for(var r=0,i=e.children.length;r<i;r++){var a=e.children[r];kS(a.tag)&&(MS(a.ns)||RS(n)&&"svg"!==a.tag)&&yM(a,t,n)}}function xM(e,t){var n,r,i,a,o=null;if(CS(e)||"string"==typeof e)for(o=new Array(e.length),n=0,r=e.length;n<r;n++)o[n]=t(e[n],n);else if("number"==typeof e)for(o=new Array(e),n=0;n<e;n++)o[n]=t(n+1,n);else if(IS(e))if(OC&&e[Symbol.iterator]){o=[];for(var s=e[Symbol.iterator](),c=s.next();!c.done;)o.push(t(c.value,o.length)),c=s.next()}else for(i=Object.keys(e),o=new Array(i.length),n=0,r=i.length;n<r;n++)a=i[n],o[n]=t(e[a],a,n);return kS(o)||(o=[]),o._isVList=!0,o}function AM(e,t,n,r){var i,a=this.$scopedSlots[e];a?(n=n||{},r&&(n=eC(eC({},r),n)),i=a(n)||(OS(t)?t():t)):i=this.$slots[e]||(OS(t)?t():t);var o=n&&n.slot;return o?this.$createElement("template",{slot:o},i):i}function wM(e){return fR(this.$options,"filters",e)||iC}function EM(e,t){return CS(e)?-1===e.indexOf(t):e!==t}function TM(e,t,n,r,i){var a=dC.keyCodes[t]||n;return i&&r&&!dC.keyCodes[t]?EM(i,r):a?EM(a,e):r?ZS(r)!==t:void 0===e}function SM(e,t,n,r,i){if(n&&IS(n)){CS(n)&&(n=tC(n));var a=void 0,o=function(o){if("class"===o||"style"===o||VS(o))a=e;else{var s=e.attrs&&e.attrs.type;a=r||dC.mustUseProp(t,s,o)?e.domProps||(e.domProps={}):e.attrs||(e.attrs={})}var c=YS(o),l=ZS(o);c in a||l in a||(a[o]=n[o],i&&((e.on||(e.on={}))["update:".concat(o)]=function(e){n[o]=e}))};for(var s in n)o(s)}return e}function CM(e,t){var n=this._staticTrees||(this._staticTrees=[]),r=n[e];return r&&!t||kM(r=n[e]=this.$options.staticRenderFns[e].call(this._renderProxy,this._c,this),"__static__".concat(e),!1),r}function MM(e,t,n){return kM(e,"__once__".concat(t).concat(n?"_".concat(n):""),!0),e}function kM(e,t,n){if(CS(e))for(var r=0;r<e.length;r++)e[r]&&"string"!=typeof e[r]&&RM(e[r],"".concat(t,"_").concat(r),n);else RM(e,t,n)}function RM(e,t,n){e.isStatic=!0,e.key=t,e.isOnce=n}function LM(e,t){if(t&&DS(t)){var n=e.on=e.on?eC({},e.on):{};for(var r in t){var i=n[r],a=t[r];n[r]=i?[].concat(i,a):a}}return e}function OM(e,t,n,r){t=t||{$stable:!n};for(var i=0;i<e.length;i++){var a=e[i];CS(a)?OM(a,t,n):a&&(a.proxy&&(a.fn.proxy=!0),t[a.key]=a.fn)}return r&&(t.$key=r),t}function IM(e,t){for(var n=0;n<t.length;n+=2){var r=t[n];"string"==typeof r&&r&&(e[t[n]]=t[n+1])}return e}function PM(e,t){return"string"==typeof e?t+e:e}function DM(e){e._o=MM,e._n=BS,e._s=FS,e._l=xM,e._t=AM,e._q=aC,e._i=oC,e._m=CM,e._f=wM,e._k=TM,e._b=SM,e._v=UC,e._e=NC,e._u=OM,e._g=LM,e._d=IM,e._p=PM}function NM(e,t){if(!e||!e.length)return{};for(var n={},r=0,i=e.length;r<i;r++){var a=e[r],o=a.data;if(o&&o.attrs&&o.attrs.slot&&delete o.attrs.slot,a.context!==t&&a.fnContext!==t||!o||null==o.slot)(n.default||(n.default=[])).push(a);else{var s=o.slot,c=n[s]||(n[s]=[]);"template"===a.tag?c.push.apply(c,a.children||[]):c.push(a)}}for(var l in n)n[l].every(UM)&&delete n[l];return n}function UM(e){return e.isComment&&!e.asyncFactory||" "===e.text}function FM(e){return e.isComment&&e.asyncFactory}function BM(e,t,n,r){var i,a=Object.keys(n).length>0,o=t?!!t.$stable:!a,s=t&&t.$key;if(t){if(t._normalized)return t._normalized;if(o&&r&&r!==SS&&s===r.$key&&!a&&!r.$hasNormal)return r;for(var c in i={},t)t[c]&&"$"!==c[0]&&(i[c]=zM(e,n,c,t[c]))}else i={};for(var l in n)l in i||(i[l]=HM(n,l));return t&&Object.isExtensible(t)&&(t._normalized=i),pC(i,"$stable",o),pC(i,"$key",s),pC(i,"$hasNormal",a),i}function zM(e,t,n,r){var i=function(){var t=IC;PC(e);var n=arguments.length?r.apply(null,arguments):r({}),i=(n=n&&"object"==typeof n&&!CS(n)?[n]:pM(n))&&n[0];return PC(t),n&&(!i||1===n.length&&i.isComment&&!FM(i))?void 0:n};return r.proxy&&Object.defineProperty(t,n,{get:i,enumerable:!0,configurable:!0}),i}function HM(e,t){return function(){return e[t]}}function VM(e,t,n,r,i){var a=!1;for(var o in t)o in e?t[o]!==n[o]&&(a=!0):(a=!0,GM(e,o,r,i));for(var o in e)o in t||(a=!0,delete e[o]);return a}function GM(e,t,n,r){Object.defineProperty(e,t,{enumerable:!0,configurable:!0,get:function(){return n[r][t]}})}function $M(e,t){for(var n in t)e[n]=t[n];for(var n in e)n in t||delete e[n]}var WM,jM=null;function XM(e,t){return(e.__esModule||OC&&"Module"===e[Symbol.toStringTag])&&(e=e.default),IS(e)?t.extend(e):e}function YM(e){if(CS(e))for(var t=0;t<e.length;t++){var n=e[t];if(kS(n)&&(kS(n.componentOptions)||FM(n)))return n}}function qM(e,t){WM.$on(e,t)}function KM(e,t){WM.$off(e,t)}function ZM(e,t){var n=WM;return function r(){null!==t.apply(null,arguments)&&n.$off(e,r)}}function JM(e,t,n){WM=e,dM(t,n||{},qM,KM,ZM,e),WM=void 0}var QM=null;function ek(e){var t=QM;return QM=e,function(){QM=t}}function tk(e){for(;e&&(e=e.$parent);)if(e._inactive)return!0;return!1}function nk(e,t){if(t){if(e._directInactive=!1,tk(e))return}else if(e._directInactive)return;if(e._inactive||null===e._inactive){e._inactive=!1;for(var n=0;n<e.$children.length;n++)nk(e.$children[n]);ik(e,"activated")}}function rk(e,t){if(!(t&&(e._directInactive=!0,tk(e))||e._inactive)){e._inactive=!0;for(var n=0;n<e.$children.length;n++)rk(e.$children[n]);ik(e,"deactivated")}}function ik(e,t,n,r){void 0===r&&(r=!0),$C();var i=IC;r&&PC(e);var a=e.$options[t],o="".concat(t," hook");if(a)for(var s=0,c=a.length;s<c;s++)yk(a[s],e,n||null,e,o);e._hasHookEvent&&e.$emit("hook:"+t),r&&PC(i),WC()}var ak=[],ok=[],sk={},ck=!1,lk=!1,uk=0,dk=0,fk=Date.now;if(gC&&!_C){var hk=window.performance;hk&&"function"==typeof hk.now&&fk()>document.createEvent("Event").timeStamp&&(fk=function(){return hk.now()})}var pk=function(e,t){if(e.post){if(!t.post)return 1}else if(t.post)return-1;return e.id-t.id};function mk(){var e,t;for(dk=fk(),lk=!0,ak.sort(pk),uk=0;uk<ak.length;uk++)(e=ak[uk]).before&&e.before(),t=e.id,sk[t]=null,e.run();var n=ok.slice(),r=ak.slice();uk=ak.length=ok.length=0,sk={},ck=lk=!1,function(e){for(var t=0;t<e.length;t++)e[t]._inactive=!0,nk(e[t],!0)}(n),function(e){for(var t=e.length;t--;){var n=e[t],r=n.vm;r&&r._watcher===n&&r._isMounted&&!r._isDestroyed&&ik(r,"updated")}}(r),HC(),kC&&dC.devtools&&kC.emit("flush")}var vk,gk="watcher";"".concat(gk," callback"),"".concat(gk," getter"),"".concat(gk," cleanup");var bk=function(){function e(e){void 0===e&&(e=!1),this.detached=e,this.active=!0,this.effects=[],this.cleanups=[],this.parent=vk,!e&&vk&&(this.index=(vk.scopes||(vk.scopes=[])).push(this)-1)}return e.prototype.run=function(e){if(this.active){var t=vk;try{return vk=this,e()}finally{vk=t}}},e.prototype.on=function(){vk=this},e.prototype.off=function(){vk=this.parent},e.prototype.stop=function(e){if(this.active){var t=void 0,n=void 0;for(t=0,n=this.effects.length;t<n;t++)this.effects[t].teardown();for(t=0,n=this.cleanups.length;t<n;t++)this.cleanups[t]();if(this.scopes)for(t=0,n=this.scopes.length;t<n;t++)this.scopes[t].stop(!0);if(!this.detached&&this.parent&&!e){var r=this.parent.scopes.pop();r&&r!==this&&(this.parent.scopes[this.index]=r,r.index=this.index)}this.parent=void 0,this.active=!1}},e}();function _k(e,t,n){$C();try{if(t)for(var r=t;r=r.$parent;){var i=r.$options.errorCaptured;if(i)for(var a=0;a<i.length;a++)try{if(!1===i[a].call(r,e,t,n))return}catch(e){xk(e,r,"errorCaptured hook")}}xk(e,t,n)}finally{WC()}}function yk(e,t,n,r,i){var a;try{(a=n?e.apply(t,n):e.call(t))&&!a._isVue&&US(a)&&!a._handled&&(a.catch((function(e){return _k(e,r,i+" (Promise/async)")})),a._handled=!0)}catch(e){_k(e,r,i)}return a}function xk(e,t,n){if(dC.errorHandler)try{return dC.errorHandler.call(null,e,t,n)}catch(t){t!==e&&Ak(t)}Ak(e)}function Ak(e,t,n){if(!gC||"undefined"==typeof console)throw e;console.error(e)}var wk,Ek=!1,Tk=[],Sk=!1;function Ck(){Sk=!1;var e=Tk.slice(0);Tk.length=0;for(var t=0;t<e.length;t++)e[t]()}if("undefined"!=typeof Promise&&RC(Promise)){var Mk=Promise.resolve();wk=function(){Mk.then(Ck),AC&&setTimeout(nC)},Ek=!0}else if(_C||"undefined"==typeof MutationObserver||!RC(MutationObserver)&&"[object MutationObserverConstructor]"!==MutationObserver.toString())wk="undefined"!=typeof setImmediate&&RC(setImmediate)?function(){setImmediate(Ck)}:function(){setTimeout(Ck,0)};else{var kk=1,Rk=new MutationObserver(Ck),Lk=document.createTextNode(String(kk));Rk.observe(Lk,{characterData:!0}),wk=function(){kk=(kk+1)%2,Lk.data=String(kk)},Ek=!0}function Ok(e,t){var n;if(Tk.push((function(){if(e)try{e.call(t)}catch(e){_k(e,t,"nextTick")}else n&&n(t)})),Sk||(Sk=!0,wk()),!e&&"undefined"!=typeof Promise)return new Promise((function(e){n=e}))}function Ik(e){return function(t,n){if(void 0===n&&(n=IC),n)return function(e,t,n){var r=e.$options;r[t]=cR(r[t],n)}(n,e,t)}}Ik("beforeMount"),Ik("mounted"),Ik("beforeUpdate"),Ik("updated"),Ik("beforeDestroy"),Ik("destroyed"),Ik("activated"),Ik("deactivated"),Ik("serverPrefetch"),Ik("renderTracked"),Ik("renderTriggered"),Ik("errorCaptured");var Pk=new LC;function Dk(e){return Nk(e,Pk),Pk.clear(),e}function Nk(e,t){var n,r,i=CS(e);if(!(!i&&!IS(e)||e.__v_skip||Object.isFrozen(e)||e instanceof DC)){if(e.__ob__){var a=e.__ob__.dep.id;if(t.has(a))return;t.add(a)}if(i)for(n=e.length;n--;)Nk(e[n],t);else if(sM(e))Nk(e.value,t);else for(n=(r=Object.keys(e)).length;n--;)Nk(e[r[n]],t)}}var Uk=0,Fk=function(){function e(e,t,n,r,i){var a;void 0===(a=vk&&!vk._vm?vk:e?e._scope:void 0)&&(a=vk),a&&a.active&&a.effects.push(this),(this.vm=e)&&i&&(e._watcher=this),r?(this.deep=!!r.deep,this.user=!!r.user,this.lazy=!!r.lazy,this.sync=!!r.sync,this.before=r.before):this.deep=this.user=this.lazy=this.sync=!1,this.cb=n,this.id=++Uk,this.active=!0,this.post=!1,this.dirty=this.lazy,this.deps=[],this.newDeps=[],this.depIds=new LC,this.newDepIds=new LC,this.expression="",OS(t)?this.getter=t:(this.getter=function(e){if(!mC.test(e)){var t=e.split(".");return function(e){for(var n=0;n<t.length;n++){if(!e)return;e=e[t[n]]}return e}}}(t),this.getter||(this.getter=nC)),this.value=this.lazy?void 0:this.get()}return e.prototype.get=function(){var e;$C(this);var t=this.vm;try{e=this.getter.call(t,t)}catch(e){if(!this.user)throw e;_k(e,t,'getter for watcher "'.concat(this.expression,'"'))}finally{this.deep&&Dk(e),WC(),this.cleanupDeps()}return e},e.prototype.addDep=function(e){var t=e.id;this.newDepIds.has(t)||(this.newDepIds.add(t),this.newDeps.push(e),this.depIds.has(t)||e.addSub(this))},e.prototype.cleanupDeps=function(){for(var e=this.deps.length;e--;){var t=this.deps[e];this.newDepIds.has(t.id)||t.removeSub(this)}var n=this.depIds;this.depIds=this.newDepIds,this.newDepIds=n,this.newDepIds.clear(),n=this.deps,this.deps=this.newDeps,this.newDeps=n,this.newDeps.length=0},e.prototype.update=function(){this.lazy?this.dirty=!0:this.sync?this.run():function(e){var t=e.id;if(null==sk[t]&&(e!==VC.target||!e.noRecurse)){if(sk[t]=!0,lk){for(var n=ak.length-1;n>uk&&ak[n].id>e.id;)n--;ak.splice(n+1,0,e)}else ak.push(e);ck||(ck=!0,Ok(mk))}}(this)},e.prototype.run=function(){if(this.active){var e=this.get();if(e!==this.value||IS(e)||this.deep){var t=this.value;if(this.value=e,this.user){var n='callback for watcher "'.concat(this.expression,'"');yk(this.cb,this.vm,[e,t],this.vm,n)}else this.cb.call(this.vm,e,t)}}},e.prototype.evaluate=function(){this.value=this.get(),this.dirty=!1},e.prototype.depend=function(){for(var e=this.deps.length;e--;)this.deps[e].depend()},e.prototype.teardown=function(){if(this.vm&&!this.vm._isBeingDestroyed&&GS(this.vm._scope.effects,this),this.active){for(var e=this.deps.length;e--;)this.deps[e].removeSub(this);this.active=!1,this.onStop&&this.onStop()}},e}(),Bk={enumerable:!0,configurable:!0,get:nC,set:nC};function zk(e,t,n){Bk.get=function(){return this[t][n]},Bk.set=function(e){this[t][n]=e},Object.defineProperty(e,n,Bk)}function Hk(e){var t=e.$options;if(t.props&&function(e,t){var n=e.$options.propsData||{},r=e._props=aM({}),i=e.$options._propKeys=[];!e.$parent||ZC(!1);var a=function(a){i.push(a);var o=hR(a,t,n,e);tM(r,a,o),a in e||zk(e,"_props",a)};for(var o in t)a(o);ZC(!0)}(e,t.props),function(e){var t=e.$options,n=t.setup;if(n){var r=e._setupContext=function(e){return{get attrs(){if(!e._attrsProxy){var t=e._attrsProxy={};pC(t,"_v_attr_proxy",!0),VM(t,e.$attrs,SS,e,"$attrs")}return e._attrsProxy},get listeners(){return e._listenersProxy||VM(e._listenersProxy={},e.$listeners,SS,e,"$listeners"),e._listenersProxy},get slots(){return function(e){return e._slotsProxy||$M(e._slotsProxy={},e.$scopedSlots),e._slotsProxy}(e)},emit:JS(e.$emit,e),expose:function(t){t&&Object.keys(t).forEach((function(n){return cM(e,t,n)}))}}}(e);PC(e),$C();var i=yk(n,null,[e._props||aM({}),r],e,"setup");if(WC(),PC(),OS(i))t.render=i;else if(IS(i))if(e._setupState=i,i.__sfc){var a=e._setupProxy={};for(var o in i)"__sfc"!==o&&cM(a,i,o)}else for(var o in i)hC(o)||cM(e,i,o)}}(e),t.methods&&function(e,t){for(var n in e.$options.props,t)e[n]="function"!=typeof t[n]?nC:JS(t[n],e)}(e,t.methods),t.data)!function(e){var t=e.$options.data;DS(t=e._data=OS(t)?function(e,t){$C();try{return e.call(t,t)}catch(e){return _k(e,t,"data()"),{}}finally{WC()}}(t,e):t||{})||(t={});for(var n=Object.keys(t),r=e.$options.props,i=(e.$options.methods,n.length);i--;){var a=n[i];r&&WS(r,a)||hC(a)||zk(e,"_data",a)}var o=eM(t);o&&o.vmCount++}(e);else{var n=eM(e._data={});n&&n.vmCount++}t.computed&&function(e,t){var n=e._computedWatchers=Object.create(null),r=MC();for(var i in t){var a=t[i],o=OS(a)?a:a.get;r||(n[i]=new Fk(e,o||nC,nC,Vk)),i in e||Gk(e,i,a)}}(e,t.computed),t.watch&&t.watch!==TC&&function(e,t){for(var n in t){var r=t[n];if(CS(r))for(var i=0;i<r.length;i++)jk(e,n,r[i]);else jk(e,n,r)}}(e,t.watch)}var Vk={lazy:!0};function Gk(e,t,n){var r=!MC();OS(n)?(Bk.get=r?$k(t):Wk(n),Bk.set=nC):(Bk.get=n.get?r&&!1!==n.cache?$k(t):Wk(n.get):nC,Bk.set=n.set||nC),Object.defineProperty(e,t,Bk)}function $k(e){return function(){var t=this._computedWatchers&&this._computedWatchers[e];if(t)return t.dirty&&t.evaluate(),VC.target&&t.depend(),t.value}}function Wk(e){return function(){return e.call(this,this)}}function jk(e,t,n,r){return DS(n)&&(r=n,n=n.handler),"string"==typeof n&&(n=e[n]),e.$watch(t,n,r)}function Xk(e,t){if(e){for(var n=Object.create(null),r=OC?Reflect.ownKeys(e):Object.keys(e),i=0;i<r.length;i++){var a=r[i];if("__ob__"!==a){var o=e[a].from;if(o in t._provided)n[a]=t._provided[o];else if("default"in e[a]){var s=e[a].default;n[a]=OS(s)?s.call(t):s}}}return n}}var Yk=0;function qk(e){var t=e.options;if(e.super){var n=qk(e.super);if(n!==e.superOptions){e.superOptions=n;var r=function(e){var t,n=e.options,r=e.sealedOptions;for(var i in n)n[i]!==r[i]&&(t||(t={}),t[i]=n[i]);return t}(e);r&&eC(e.extendOptions,r),(t=e.options=dR(n,e.extendOptions)).name&&(t.components[t.name]=e)}}return t}function Kk(e,t,n,r,i){var a,o=this,s=i.options;WS(r,"_uid")?(a=Object.create(r))._original=r:(a=r,r=r._original);var c=RS(s._compiled),l=!c;this.data=e,this.props=t,this.children=n,this.parent=r,this.listeners=e.on||SS,this.injections=Xk(s.inject,r),this.slots=function(){return o.$slots||BM(r,e.scopedSlots,o.$slots=NM(n,r)),o.$slots},Object.defineProperty(this,"scopedSlots",{enumerable:!0,get:function(){return BM(r,e.scopedSlots,this.slots())}}),c&&(this.$options=s,this.$slots=this.slots(),this.$scopedSlots=BM(r,e.scopedSlots,this.$slots)),s._scopeId?this._c=function(e,t,n,i){var o=_M(a,e,t,n,i,l);return o&&!CS(o)&&(o.fnScopeId=s._scopeId,o.fnContext=r),o}:this._c=function(e,t,n,r){return _M(a,e,t,n,r,l)}}function Zk(e,t,n,r,i){var a=FC(e);return a.fnContext=n,a.fnOptions=r,t.slot&&((a.data||(a.data={})).slot=t.slot),a}function Jk(e,t){for(var n in t)e[YS(n)]=t[n]}function Qk(e){return e.name||e.__name||e._componentTag}DM(Kk.prototype);var eR={init:function(e,t){if(e.componentInstance&&!e.componentInstance._isDestroyed&&e.data.keepAlive){var n=e;eR.prepatch(n,n)}else(e.componentInstance=function(e,t){var n={_isComponent:!0,_parentVnode:e,parent:t},r=e.data.inlineTemplate;return kS(r)&&(n.render=r.render,n.staticRenderFns=r.staticRenderFns),new e.componentOptions.Ctor(n)}(e,QM)).$mount(t?e.elm:void 0,t)},prepatch:function(e,t){var n=t.componentOptions;!function(e,t,n,r,i){var a=r.data.scopedSlots,o=e.$scopedSlots,s=!!(a&&!a.$stable||o!==SS&&!o.$stable||a&&e.$scopedSlots.$key!==a.$key||!a&&e.$scopedSlots.$key),c=!!(i||e.$options._renderChildren||s),l=e.$vnode;e.$options._parentVnode=r,e.$vnode=r,e._vnode&&(e._vnode.parent=r),e.$options._renderChildren=i;var u=r.data.attrs||SS;e._attrsProxy&&VM(e._attrsProxy,u,l.data&&l.data.attrs||SS,e,"$attrs")&&(c=!0),e.$attrs=u,n=n||SS;var d=e.$options._parentListeners;if(e._listenersProxy&&VM(e._listenersProxy,n,d||SS,e,"$listeners"),e.$listeners=e.$options._parentListeners=n,JM(e,n,d),t&&e.$options.props){ZC(!1);for(var f=e._props,h=e.$options._propKeys||[],p=0;p<h.length;p++){var m=h[p],v=e.$options.props;f[m]=hR(m,v,t,e)}ZC(!0),e.$options.propsData=t}c&&(e.$slots=NM(i,r.context),e.$forceUpdate())}(t.componentInstance=e.componentInstance,n.propsData,n.listeners,t,n.children)},insert:function(e){var t,n=e.context,r=e.componentInstance;r._isMounted||(r._isMounted=!0,ik(r,"mounted")),e.data.keepAlive&&(n._isMounted?((t=r)._inactive=!1,ok.push(t)):nk(r,!0))},destroy:function(e){var t=e.componentInstance;t._isDestroyed||(e.data.keepAlive?rk(t,!0):t.$destroy())}},tR=Object.keys(eR);function nR(e,t,n,r,i){if(!MS(e)){var a=n.$options._base;if(IS(e)&&(e=a.extend(e)),"function"==typeof e){var o;if(MS(e.cid)&&(e=function(e,t){if(RS(e.error)&&kS(e.errorComp))return e.errorComp;if(kS(e.resolved))return e.resolved;var n=jM;if(n&&kS(e.owners)&&-1===e.owners.indexOf(n)&&e.owners.push(n),RS(e.loading)&&kS(e.loadingComp))return e.loadingComp;if(n&&!kS(e.owners)){var r=e.owners=[n],i=!0,a=null,o=null;n.$on("hook:destroyed",(function(){return GS(r,n)}));var s=function(e){for(var t=0,n=r.length;t<n;t++)r[t].$forceUpdate();e&&(r.length=0,null!==a&&(clearTimeout(a),a=null),null!==o&&(clearTimeout(o),o=null))},c=sC((function(n){e.resolved=XM(n,t),i?r.length=0:s(!0)})),l=sC((function(t){kS(e.errorComp)&&(e.error=!0,s(!0))})),u=e(c,l);return IS(u)&&(US(u)?MS(e.resolved)&&u.then(c,l):US(u.component)&&(u.component.then(c,l),kS(u.error)&&(e.errorComp=XM(u.error,t)),kS(u.loading)&&(e.loadingComp=XM(u.loading,t),0===u.delay?e.loading=!0:a=setTimeout((function(){a=null,MS(e.resolved)&&MS(e.error)&&(e.loading=!0,s(!1))}),u.delay||200)),kS(u.timeout)&&(o=setTimeout((function(){o=null,MS(e.resolved)&&l(null)}),u.timeout)))),i=!1,e.loading?e.loadingComp:e.resolved}}(o=e,a),void 0===e))return function(e,t,n,r,i){var a=NC();return a.asyncFactory=e,a.asyncMeta={data:t,context:n,children:r,tag:i},a}(o,t,n,r,i);t=t||{},qk(e),kS(t.model)&&function(e,t){var n=e.model&&e.model.prop||"value",r=e.model&&e.model.event||"input";(t.attrs||(t.attrs={}))[n]=t.model.value;var i=t.on||(t.on={}),a=i[r],o=t.model.callback;kS(a)?(CS(a)?-1===a.indexOf(o):a!==o)&&(i[r]=[o].concat(a)):i[r]=o}(e.options,t);var s=function(e,t,n){var r=t.options.props;if(!MS(r)){var i={},a=e.attrs,o=e.props;if(kS(a)||kS(o))for(var s in r){var c=ZS(s);hM(i,o,s,c,!0)||hM(i,a,s,c,!1)}return i}}(t,e);if(RS(e.options.functional))return function(e,t,n,r,i){var a=e.options,o={},s=a.props;if(kS(s))for(var c in s)o[c]=hR(c,s,t||SS);else kS(n.attrs)&&Jk(o,n.attrs),kS(n.props)&&Jk(o,n.props);var l=new Kk(n,o,i,r,e),u=a.render.call(null,l._c,l);if(u instanceof DC)return Zk(u,n,l.parent,a);if(CS(u)){for(var d=pM(u)||[],f=new Array(d.length),h=0;h<d.length;h++)f[h]=Zk(d[h],n,l.parent,a);return f}}(e,s,t,n,r);var c=t.on;if(t.on=t.nativeOn,RS(e.options.abstract)){var l=t.slot;t={},l&&(t.slot=l)}!function(e){for(var t=e.hook||(e.hook={}),n=0;n<tR.length;n++){var r=tR[n],i=t[r],a=eR[r];i===a||i&&i._merged||(t[r]=i?rR(a,i):a)}}(t);var u=Qk(e.options)||i;return new DC("vue-component-".concat(e.cid).concat(u?"-".concat(u):""),t,void 0,void 0,void 0,n,{Ctor:e,propsData:s,listeners:c,tag:i,children:r},o)}}}function rR(e,t){var n=function(n,r){e(n,r),t(n,r)};return n._merged=!0,n}var iR=nC,aR=dC.optionMergeStrategies;function oR(e,t,n){if(void 0===n&&(n=!0),!t)return e;for(var r,i,a,o=OC?Reflect.ownKeys(t):Object.keys(t),s=0;s<o.length;s++)"__ob__"!==(r=o[s])&&(i=e[r],a=t[r],n&&WS(e,r)?i!==a&&DS(i)&&DS(a)&&oR(i,a):nM(e,r,a));return e}function sR(e,t,n){return n?function(){var r=OS(t)?t.call(n,n):t,i=OS(e)?e.call(n,n):e;return r?oR(r,i):i}:t?e?function(){return oR(OS(t)?t.call(this,this):t,OS(e)?e.call(this,this):e)}:t:e}function cR(e,t){var n=t?e?e.concat(t):CS(t)?t:[t]:e;return n?function(e){for(var t=[],n=0;n<e.length;n++)-1===t.indexOf(e[n])&&t.push(e[n]);return t}(n):n}function lR(e,t,n,r){var i=Object.create(e||null);return t?eC(i,t):i}aR.data=function(e,t,n){return n?sR(e,t,n):t&&"function"!=typeof t?e:sR(e,t)},uC.forEach((function(e){aR[e]=cR})),lC.forEach((function(e){aR[e+"s"]=lR})),aR.watch=function(e,t,n,r){if(e===TC&&(e=void 0),t===TC&&(t=void 0),!t)return Object.create(e||null);if(!e)return t;var i={};for(var a in eC(i,e),t){var o=i[a],s=t[a];o&&!CS(o)&&(o=[o]),i[a]=o?o.concat(s):CS(s)?s:[s]}return i},aR.props=aR.methods=aR.inject=aR.computed=function(e,t,n,r){if(!e)return t;var i=Object.create(null);return eC(i,e),t&&eC(i,t),i},aR.provide=function(e,t){return e?function(){var n=Object.create(null);return oR(n,OS(e)?e.call(this):e),t&&oR(n,OS(t)?t.call(this):t,!1),n}:t};var uR=function(e,t){return void 0===t?e:t};function dR(e,t,n){if(OS(t)&&(t=t.options),function(e,t){var n=e.props;if(n){var r,i,a={};if(CS(n))for(r=n.length;r--;)"string"==typeof(i=n[r])&&(a[YS(i)]={type:null});else if(DS(n))for(var o in n)i=n[o],a[YS(o)]=DS(i)?i:{type:i};e.props=a}}(t),function(e,t){var n=e.inject;if(n){var r=e.inject={};if(CS(n))for(var i=0;i<n.length;i++)r[n[i]]={from:n[i]};else if(DS(n))for(var a in n){var o=n[a];r[a]=DS(o)?eC({from:a},o):{from:o}}}}(t),function(e){var t=e.directives;if(t)for(var n in t){var r=t[n];OS(r)&&(t[n]={bind:r,update:r})}}(t),!t._base&&(t.extends&&(e=dR(e,t.extends,n)),t.mixins))for(var r=0,i=t.mixins.length;r<i;r++)e=dR(e,t.mixins[r],n);var a,o={};for(a in e)s(a);for(a in t)WS(e,a)||s(a);function s(r){var i=aR[r]||uR;o[r]=i(e[r],t[r],n,r)}return o}function fR(e,t,n,r){if("string"==typeof n){var i=e[t];if(WS(i,n))return i[n];var a=YS(n);if(WS(i,a))return i[a];var o=qS(a);return WS(i,o)?i[o]:i[n]||i[a]||i[o]}}function hR(e,t,n,r){var i=t[e],a=!WS(n,e),o=n[e],s=gR(Boolean,i.type);if(s>-1)if(a&&!WS(i,"default"))o=!1;else if(""===o||o===ZS(e)){var c=gR(String,i.type);(c<0||s<c)&&(o=!0)}if(void 0===o){o=function(e,t,n){if(WS(t,"default")){var r=t.default;return e&&e.$options.propsData&&void 0===e.$options.propsData[n]&&void 0!==e._props[n]?e._props[n]:OS(r)&&"Function"!==mR(t.type)?r.call(e):r}}(r,i,e);var l=KC;ZC(!0),eM(o),ZC(l)}return o}var pR=/^\s*function (\w+)/;function mR(e){var t=e&&e.toString().match(pR);return t?t[1]:""}function vR(e,t){return mR(e)===mR(t)}function gR(e,t){if(!CS(t))return vR(t,e)?0:-1;for(var n=0,r=t.length;n<r;n++)if(vR(t[n],e))return n;return-1}function bR(e){this._init(e)}function _R(e){return e&&(Qk(e.Ctor.options)||e.tag)}function yR(e,t){return CS(e)?e.indexOf(t)>-1:"string"==typeof e?e.split(",").indexOf(t)>-1:(n=e,!("[object RegExp]"!==PS.call(n))&&e.test(t));var n}function xR(e,t){var n=e.cache,r=e.keys,i=e._vnode;for(var a in n){var o=n[a];if(o){var s=o.name;s&&!t(s)&&AR(n,a,r,i)}}}function AR(e,t,n,r){var i=e[t];!i||r&&i.tag===r.tag||i.componentInstance.$destroy(),e[t]=null,GS(n,t)}!function(e){e.prototype._init=function(e){var t=this;t._uid=Yk++,t._isVue=!0,t.__v_skip=!0,t._scope=new bk(!0),t._scope._vm=!0,e&&e._isComponent?function(e,t){var n=e.$options=Object.create(e.constructor.options),r=t._parentVnode;n.parent=t.parent,n._parentVnode=r;var i=r.componentOptions;n.propsData=i.propsData,n._parentListeners=i.listeners,n._renderChildren=i.children,n._componentTag=i.tag,t.render&&(n.render=t.render,n.staticRenderFns=t.staticRenderFns)}(t,e):t.$options=dR(qk(t.constructor),e||{},t),t._renderProxy=t,t._self=t,function(e){var t=e.$options,n=t.parent;if(n&&!t.abstract){for(;n.$options.abstract&&n.$parent;)n=n.$parent;n.$children.push(e)}e.$parent=n,e.$root=n?n.$root:e,e.$children=[],e.$refs={},e._provided=n?n._provided:Object.create(null),e._watcher=null,e._inactive=null,e._directInactive=!1,e._isMounted=!1,e._isDestroyed=!1,e._isBeingDestroyed=!1}(t),function(e){e._events=Object.create(null),e._hasHookEvent=!1;var t=e.$options._parentListeners;t&&JM(e,t)}(t),function(e){e._vnode=null,e._staticTrees=null;var t=e.$options,n=e.$vnode=t._parentVnode,r=n&&n.context;e.$slots=NM(t._renderChildren,r),e.$scopedSlots=n?BM(e.$parent,n.data.scopedSlots,e.$slots):SS,e._c=function(t,n,r,i){return _M(e,t,n,r,i,!1)},e.$createElement=function(t,n,r,i){return _M(e,t,n,r,i,!0)};var i=n&&n.data;tM(e,"$attrs",i&&i.attrs||SS,null,!0),tM(e,"$listeners",t._parentListeners||SS,null,!0)}(t),ik(t,"beforeCreate",void 0,!1),function(e){var t=Xk(e.$options.inject,e);t&&(ZC(!1),Object.keys(t).forEach((function(n){tM(e,n,t[n])})),ZC(!0))}(t),Hk(t),function(e){var t=e.$options.provide;if(t){var n=OS(t)?t.call(e):t;if(!IS(n))return;for(var r=function(e){var t=e._provided,n=e.$parent&&e.$parent._provided;return n===t?e._provided=Object.create(n):t}(e),i=OC?Reflect.ownKeys(n):Object.keys(n),a=0;a<i.length;a++){var o=i[a];Object.defineProperty(r,o,Object.getOwnPropertyDescriptor(n,o))}}}(t),ik(t,"created"),t.$options.el&&t.$mount(t.$options.el)}}(bR),function(e){Object.defineProperty(e.prototype,"$data",{get:function(){return this._data}}),Object.defineProperty(e.prototype,"$props",{get:function(){return this._props}}),e.prototype.$set=nM,e.prototype.$delete=rM,e.prototype.$watch=function(e,t,n){var r=this;if(DS(t))return jk(r,e,t,n);(n=n||{}).user=!0;var i=new Fk(r,e,t,n);if(n.immediate){var a='callback for immediate watcher "'.concat(i.expression,'"');$C(),yk(t,r,[i.value],r,a),WC()}return function(){i.teardown()}}}(bR),function(e){var t=/^hook:/;e.prototype.$on=function(e,n){var r=this;if(CS(e))for(var i=0,a=e.length;i<a;i++)r.$on(e[i],n);else(r._events[e]||(r._events[e]=[])).push(n),t.test(e)&&(r._hasHookEvent=!0);return r},e.prototype.$once=function(e,t){var n=this;function r(){n.$off(e,r),t.apply(n,arguments)}return r.fn=t,n.$on(e,r),n},e.prototype.$off=function(e,t){var n=this;if(!arguments.length)return n._events=Object.create(null),n;if(CS(e)){for(var r=0,i=e.length;r<i;r++)n.$off(e[r],t);return n}var a,o=n._events[e];if(!o)return n;if(!t)return n._events[e]=null,n;for(var s=o.length;s--;)if((a=o[s])===t||a.fn===t){o.splice(s,1);break}return n},e.prototype.$emit=function(e){var t=this,n=t._events[e];if(n){n=n.length>1?QS(n):n;for(var r=QS(arguments,1),i='event handler for "'.concat(e,'"'),a=0,o=n.length;a<o;a++)yk(n[a],t,r,t,i)}return t}}(bR),function(e){e.prototype._update=function(e,t){var n=this,r=n.$el,i=n._vnode,a=ek(n);n._vnode=e,n.$el=i?n.__patch__(i,e):n.__patch__(n.$el,e,t,!1),a(),r&&(r.__vue__=null),n.$el&&(n.$el.__vue__=n);for(var o=n;o&&o.$vnode&&o.$parent&&o.$vnode===o.$parent._vnode;)o.$parent.$el=o.$el,o=o.$parent},e.prototype.$forceUpdate=function(){this._watcher&&this._watcher.update()},e.prototype.$destroy=function(){var e=this;if(!e._isBeingDestroyed){ik(e,"beforeDestroy"),e._isBeingDestroyed=!0;var t=e.$parent;!t||t._isBeingDestroyed||e.$options.abstract||GS(t.$children,e),e._scope.stop(),e._data.__ob__&&e._data.__ob__.vmCount--,e._isDestroyed=!0,e.__patch__(e._vnode,null),ik(e,"destroyed"),e.$off(),e.$el&&(e.$el.__vue__=null),e.$vnode&&(e.$vnode.parent=null)}}}(bR),function(e){DM(e.prototype),e.prototype.$nextTick=function(e){return Ok(e,this)},e.prototype._render=function(){var e,t=this,n=t.$options,r=n.render,i=n._parentVnode;i&&t._isMounted&&(t.$scopedSlots=BM(t.$parent,i.data.scopedSlots,t.$slots,t.$scopedSlots),t._slotsProxy&&$M(t._slotsProxy,t.$scopedSlots)),t.$vnode=i;try{PC(t),jM=t,e=r.call(t._renderProxy,t.$createElement)}catch(n){_k(n,t,"render"),e=t._vnode}finally{jM=null,PC()}return CS(e)&&1===e.length&&(e=e[0]),e instanceof DC||(e=NC()),e.parent=i,e}}(bR);var wR=[String,RegExp,Array],ER={name:"keep-alive",abstract:!0,props:{include:wR,exclude:wR,max:[String,Number]},methods:{cacheVNode:function(){var e=this,t=e.cache,n=e.keys,r=e.vnodeToCache,i=e.keyToCache;if(r){var a=r.tag,o=r.componentInstance,s=r.componentOptions;t[i]={name:_R(s),tag:a,componentInstance:o},n.push(i),this.max&&n.length>parseInt(this.max)&&AR(t,n[0],n,this._vnode),this.vnodeToCache=null}}},created:function(){this.cache=Object.create(null),this.keys=[]},destroyed:function(){for(var e in this.cache)AR(this.cache,e,this.keys)},mounted:function(){var e=this;this.cacheVNode(),this.$watch("include",(function(t){xR(e,(function(e){return yR(t,e)}))})),this.$watch("exclude",(function(t){xR(e,(function(e){return!yR(t,e)}))}))},updated:function(){this.cacheVNode()},render:function(){var e=this.$slots.default,t=YM(e),n=t&&t.componentOptions;if(n){var r=_R(n),i=this.include,a=this.exclude;if(i&&(!r||!yR(i,r))||a&&r&&yR(a,r))return t;var o=this.cache,s=this.keys,c=null==t.key?n.Ctor.cid+(n.tag?"::".concat(n.tag):""):t.key;o[c]?(t.componentInstance=o[c].componentInstance,GS(s,c),s.push(c)):(this.vnodeToCache=t,this.keyToCache=c),t.data.keepAlive=!0}return t||e&&e[0]}},TR={KeepAlive:ER};!function(e){var t={get:function(){return dC}};Object.defineProperty(e,"config",t),e.util={warn:iR,extend:eC,mergeOptions:dR,defineReactive:tM},e.set=nM,e.delete=rM,e.nextTick=Ok,e.observable=function(e){return eM(e),e},e.options=Object.create(null),lC.forEach((function(t){e.options[t+"s"]=Object.create(null)})),e.options._base=e,eC(e.options.components,TR),function(e){e.use=function(e){var t=this._installedPlugins||(this._installedPlugins=[]);if(t.indexOf(e)>-1)return this;var n=QS(arguments,1);return n.unshift(this),OS(e.install)?e.install.apply(e,n):OS(e)&&e.apply(null,n),t.push(e),this}}(e),function(e){e.mixin=function(e){return this.options=dR(this.options,e),this}}(e),function(e){e.cid=0;var t=1;e.extend=function(e){e=e||{};var n=this,r=n.cid,i=e._Ctor||(e._Ctor={});if(i[r])return i[r];var a=Qk(e)||Qk(n.options),o=function(e){this._init(e)};return(o.prototype=Object.create(n.prototype)).constructor=o,o.cid=t++,o.options=dR(n.options,e),o.super=n,o.options.props&&function(e){var t=e.options.props;for(var n in t)zk(e.prototype,"_props",n)}(o),o.options.computed&&function(e){var t=e.options.computed;for(var n in t)Gk(e.prototype,n,t[n])}(o),o.extend=n.extend,o.mixin=n.mixin,o.use=n.use,lC.forEach((function(e){o[e]=n[e]})),a&&(o.options.components[a]=o),o.superOptions=n.options,o.extendOptions=e,o.sealedOptions=eC({},o.options),i[r]=o,o}}(e),function(e){lC.forEach((function(t){e[t]=function(e,n){return n?("component"===t&&DS(n)&&(n.name=n.name||e,n=this.options._base.extend(n)),"directive"===t&&OS(n)&&(n={bind:n,update:n}),this.options[t+"s"][e]=n,n):this.options[t+"s"][e]}}))}(e)}(bR),Object.defineProperty(bR.prototype,"$isServer",{get:MC}),Object.defineProperty(bR.prototype,"$ssrContext",{get:function(){return this.$vnode&&this.$vnode.ssrContext}}),Object.defineProperty(bR,"FunctionalRenderContext",{value:Kk}),bR.version="2.7.14";var SR=zS("style,class"),CR=zS("input,textarea,option,select,progress"),MR=function(e,t,n){return"value"===n&&CR(e)&&"button"!==t||"selected"===n&&"option"===e||"checked"===n&&"input"===e||"muted"===n&&"video"===e},kR=zS("contenteditable,draggable,spellcheck"),RR=zS("events,caret,typing,plaintext-only"),LR=function(e,t){return NR(t)||"false"===t?"false":"contenteditable"===e&&RR(t)?t:"true"},OR=zS("allowfullscreen,async,autofocus,autoplay,checked,compact,controls,declare,default,defaultchecked,defaultmuted,defaultselected,defer,disabled,enabled,formnovalidate,hidden,indeterminate,inert,ismap,itemscope,loop,multiple,muted,nohref,noresize,noshade,novalidate,nowrap,open,pauseonexit,readonly,required,reversed,scoped,seamless,selected,sortable,truespeed,typemustmatch,visible"),IR="http://www.w3.org/1999/xlink",PR=function(e){return":"===e.charAt(5)&&"xlink"===e.slice(0,5)},DR=function(e){return PR(e)?e.slice(6,e.length):""},NR=function(e){return null==e||!1===e};function UR(e,t){return{staticClass:FR(e.staticClass,t.staticClass),class:kS(e.class)?[e.class,t.class]:t.class}}function FR(e,t){return e?t?e+" "+t:e:t||""}function BR(e){return Array.isArray(e)?function(e){for(var t,n="",r=0,i=e.length;r<i;r++)kS(t=BR(e[r]))&&""!==t&&(n&&(n+=" "),n+=t);return n}(e):IS(e)?function(e){var t="";for(var n in e)e[n]&&(t&&(t+=" "),t+=n);return t}(e):"string"==typeof e?e:""}var zR={svg:"http://www.w3.org/2000/svg",math:"http://www.w3.org/1998/Math/MathML"},HR=zS("html,body,base,head,link,meta,style,title,address,article,aside,footer,header,h1,h2,h3,h4,h5,h6,hgroup,nav,section,div,dd,dl,dt,figcaption,figure,picture,hr,img,li,main,ol,p,pre,ul,a,b,abbr,bdi,bdo,br,cite,code,data,dfn,em,i,kbd,mark,q,rp,rt,rtc,ruby,s,samp,small,span,strong,sub,sup,time,u,var,wbr,area,audio,map,track,video,embed,object,param,source,canvas,script,noscript,del,ins,caption,col,colgroup,table,thead,tbody,td,th,tr,button,datalist,fieldset,form,input,label,legend,meter,optgroup,option,output,progress,select,textarea,details,dialog,menu,menuitem,summary,content,element,shadow,template,blockquote,iframe,tfoot"),VR=zS("svg,animate,circle,clippath,cursor,defs,desc,ellipse,filter,font-face,foreignobject,g,glyph,image,line,marker,mask,missing-glyph,path,pattern,polygon,polyline,rect,switch,symbol,text,textpath,tspan,use,view",!0),GR=function(e){return HR(e)||VR(e)};function $R(e){return VR(e)?"svg":"math"===e?"math":void 0}var WR=Object.create(null),jR=zS("text,number,password,search,email,tel,url");function XR(e){return"string"==typeof e?document.querySelector(e)||document.createElement("div"):e}var YR=Object.freeze({__proto__:null,createElement:function(e,t){var n=document.createElement(e);return"select"!==e||t.data&&t.data.attrs&&void 0!==t.data.attrs.multiple&&n.setAttribute("multiple","multiple"),n},createElementNS:function(e,t){return document.createElementNS(zR[e],t)},createTextNode:function(e){return document.createTextNode(e)},createComment:function(e){return document.createComment(e)},insertBefore:function(e,t,n){e.insertBefore(t,n)},removeChild:function(e,t){e.removeChild(t)},appendChild:function(e,t){e.appendChild(t)},parentNode:function(e){return e.parentNode},nextSibling:function(e){return e.nextSibling},tagName:function(e){return e.tagName},setTextContent:function(e,t){e.textContent=t},setStyleScope:function(e,t){e.setAttribute(t,"")}}),qR={create:function(e,t){KR(t)},update:function(e,t){e.data.ref!==t.data.ref&&(KR(e,!0),KR(t))},destroy:function(e){KR(e,!0)}};function KR(e,t){var n=e.data.ref;if(kS(n)){var r=e.context,i=e.componentInstance||e.elm,a=t?null:i,o=t?void 0:i;if(OS(n))yk(n,r,[a],r,"template ref function");else{var s=e.data.refInFor,c="string"==typeof n||"number"==typeof n,l=sM(n),u=r.$refs;if(c||l)if(s){var d=c?u[n]:n.value;t?CS(d)&&GS(d,i):CS(d)?d.includes(i)||d.push(i):c?(u[n]=[i],ZR(r,n,u[n])):n.value=[i]}else if(c){if(t&&u[n]!==i)return;u[n]=o,ZR(r,n,a)}else if(l){if(t&&n.value!==i)return;n.value=a}}}}function ZR(e,t,n){var r=e._setupState;r&&WS(r,t)&&(sM(r[t])?r[t].value=n:r[t]=n)}var JR=new DC("",{},[]),QR=["create","activate","update","remove","destroy"];function eL(e,t){return e.key===t.key&&e.asyncFactory===t.asyncFactory&&(e.tag===t.tag&&e.isComment===t.isComment&&kS(e.data)===kS(t.data)&&function(e,t){if("input"!==e.tag)return!0;var n,r=kS(n=e.data)&&kS(n=n.attrs)&&n.type,i=kS(n=t.data)&&kS(n=n.attrs)&&n.type;return r===i||jR(r)&&jR(i)}(e,t)||RS(e.isAsyncPlaceholder)&&MS(t.asyncFactory.error))}function tL(e,t,n){var r,i,a={};for(r=t;r<=n;++r)kS(i=e[r].key)&&(a[i]=r);return a}var nL={create:rL,update:rL,destroy:function(e){rL(e,JR)}};function rL(e,t){(e.data.directives||t.data.directives)&&function(e,t){var n,r,i,a=e===JR,o=t===JR,s=aL(e.data.directives,e.context),c=aL(t.data.directives,t.context),l=[],u=[];for(n in c)r=s[n],i=c[n],r?(i.oldValue=r.value,i.oldArg=r.arg,sL(i,"update",t,e),i.def&&i.def.componentUpdated&&u.push(i)):(sL(i,"bind",t,e),i.def&&i.def.inserted&&l.push(i));if(l.length){var d=function(){for(var n=0;n<l.length;n++)sL(l[n],"inserted",t,e)};a?fM(t,"insert",d):d()}if(u.length&&fM(t,"postpatch",(function(){for(var n=0;n<u.length;n++)sL(u[n],"componentUpdated",t,e)})),!a)for(n in s)c[n]||sL(s[n],"unbind",e,e,o)}(e,t)}var iL=Object.create(null);function aL(e,t){var n,r,i=Object.create(null);if(!e)return i;for(n=0;n<e.length;n++){if((r=e[n]).modifiers||(r.modifiers=iL),i[oL(r)]=r,t._setupState&&t._setupState.__sfc){var a=r.def||fR(t,"_setupState","v-"+r.name);r.def="function"==typeof a?{bind:a,update:a}:a}r.def=r.def||fR(t.$options,"directives",r.name)}return i}function oL(e){return e.rawName||"".concat(e.name,".").concat(Object.keys(e.modifiers||{}).join("."))}function sL(e,t,n,r,i){var a=e.def&&e.def[t];if(a)try{a(n.elm,e,n,r,i)}catch(r){_k(r,n.context,"directive ".concat(e.name," ").concat(t," hook"))}}var cL=[qR,nL];function lL(e,t){var n=t.componentOptions;if(!(kS(n)&&!1===n.Ctor.options.inheritAttrs||MS(e.data.attrs)&&MS(t.data.attrs))){var r,i,a=t.elm,o=e.data.attrs||{},s=t.data.attrs||{};for(r in(kS(s.__ob__)||RS(s._v_attr_proxy))&&(s=t.data.attrs=eC({},s)),s)i=s[r],o[r]!==i&&uL(a,r,i,t.data.pre);for(r in(_C||xC)&&s.value!==o.value&&uL(a,"value",s.value),o)MS(s[r])&&(PR(r)?a.removeAttributeNS(IR,DR(r)):kR(r)||a.removeAttribute(r))}}function uL(e,t,n,r){r||e.tagName.indexOf("-")>-1?dL(e,t,n):OR(t)?NR(n)?e.removeAttribute(t):(n="allowfullscreen"===t&&"EMBED"===e.tagName?"true":t,e.setAttribute(t,n)):kR(t)?e.setAttribute(t,LR(t,n)):PR(t)?NR(n)?e.removeAttributeNS(IR,DR(t)):e.setAttributeNS(IR,t,n):dL(e,t,n)}function dL(e,t,n){if(NR(n))e.removeAttribute(t);else{if(_C&&!yC&&"TEXTAREA"===e.tagName&&"placeholder"===t&&""!==n&&!e.__ieph){var r=function(t){t.stopImmediatePropagation(),e.removeEventListener("input",r)};e.addEventListener("input",r),e.__ieph=!0}e.setAttribute(t,n)}}var fL={create:lL,update:lL};function hL(e,t){var n=t.elm,r=t.data,i=e.data;if(!(MS(r.staticClass)&&MS(r.class)&&(MS(i)||MS(i.staticClass)&&MS(i.class)))){var a=function(e){for(var t=e.data,n=e,r=e;kS(r.componentInstance);)(r=r.componentInstance._vnode)&&r.data&&(t=UR(r.data,t));for(;kS(n=n.parent);)n&&n.data&&(t=UR(t,n.data));return i=t.staticClass,a=t.class,kS(i)||kS(a)?FR(i,BR(a)):"";var i,a}(t),o=n._transitionClasses;kS(o)&&(a=FR(a,BR(o))),a!==n._prevClass&&(n.setAttribute("class",a),n._prevClass=a)}}var pL,mL,vL,gL,bL,_L,yL={create:hL,update:hL},xL=/[\w).+\-_$\]]/;function AL(e){var t,n,r,i,a,o=!1,s=!1,c=!1,l=!1,u=0,d=0,f=0,h=0;for(r=0;r<e.length;r++)if(n=t,t=e.charCodeAt(r),o)39===t&&92!==n&&(o=!1);else if(s)34===t&&92!==n&&(s=!1);else if(c)96===t&&92!==n&&(c=!1);else if(l)47===t&&92!==n&&(l=!1);else if(124!==t||124===e.charCodeAt(r+1)||124===e.charCodeAt(r-1)||u||d||f){switch(t){case 34:s=!0;break;case 39:o=!0;break;case 96:c=!0;break;case 40:f++;break;case 41:f--;break;case 91:d++;break;case 93:d--;break;case 123:u++;break;case 125:u--}if(47===t){for(var p=r-1,m=void 0;p>=0&&" "===(m=e.charAt(p));p--);m&&xL.test(m)||(l=!0)}}else void 0===i?(h=r+1,i=e.slice(0,r).trim()):v();function v(){(a||(a=[])).push(e.slice(h,r).trim()),h=r+1}if(void 0===i?i=e.slice(0,r).trim():0!==h&&v(),a)for(r=0;r<a.length;r++)i=wL(i,a[r]);return i}function wL(e,t){var n=t.indexOf("(");if(n<0)return'_f("'.concat(t,'")(').concat(e,")");var r=t.slice(0,n),i=t.slice(n+1);return'_f("'.concat(r,'")(').concat(e).concat(")"!==i?","+i:i)}function EL(e,t){console.error("[Vue compiler]: ".concat(e))}function TL(e,t){return e?e.map((function(e){return e[t]})).filter((function(e){return e})):[]}function SL(e,t,n,r,i){(e.props||(e.props=[])).push(DL({name:t,value:n,dynamic:i},r)),e.plain=!1}function CL(e,t,n,r,i){(i?e.dynamicAttrs||(e.dynamicAttrs=[]):e.attrs||(e.attrs=[])).push(DL({name:t,value:n,dynamic:i},r)),e.plain=!1}function ML(e,t,n,r){e.attrsMap[t]=n,e.attrsList.push(DL({name:t,value:n},r))}function kL(e,t,n,r,i,a,o,s){(e.directives||(e.directives=[])).push(DL({name:t,rawName:n,value:r,arg:i,isDynamicArg:a,modifiers:o},s)),e.plain=!1}function RL(e,t,n){return n?"_p(".concat(t,',"').concat(e,'")'):e+t}function LL(e,t,n,r,i,a,o,s){var c;(r=r||SS).right?s?t="(".concat(t,")==='click'?'contextmenu':(").concat(t,")"):"click"===t&&(t="contextmenu",delete r.right):r.middle&&(s?t="(".concat(t,")==='click'?'mouseup':(").concat(t,")"):"click"===t&&(t="mouseup")),r.capture&&(delete r.capture,t=RL("!",t,s)),r.once&&(delete r.once,t=RL("~",t,s)),r.passive&&(delete r.passive,t=RL("&",t,s)),r.native?(delete r.native,c=e.nativeEvents||(e.nativeEvents={})):c=e.events||(e.events={});var l=DL({value:n.trim(),dynamic:s},o);r!==SS&&(l.modifiers=r);var u=c[t];Array.isArray(u)?i?u.unshift(l):u.push(l):c[t]=u?i?[l,u]:[u,l]:l,e.plain=!1}function OL(e,t,n){var r=IL(e,":"+t)||IL(e,"v-bind:"+t);if(null!=r)return AL(r);if(!1!==n){var i=IL(e,t);if(null!=i)return JSON.stringify(i)}}function IL(e,t,n){var r;if(null!=(r=e.attrsMap[t]))for(var i=e.attrsList,a=0,o=i.length;a<o;a++)if(i[a].name===t){i.splice(a,1);break}return n&&delete e.attrsMap[t],r}function PL(e,t){for(var n=e.attrsList,r=0,i=n.length;r<i;r++){var a=n[r];if(t.test(a.name))return n.splice(r,1),a}}function DL(e,t){return t&&(null!=t.start&&(e.start=t.start),null!=t.end&&(e.end=t.end)),e}function NL(e,t,n){var r=n||{},i=r.number,a="$$v",o=a;r.trim&&(o="(typeof ".concat(a," === 'string'")+"? ".concat(a,".trim()")+": ".concat(a,")")),i&&(o="_n(".concat(o,")"));var s=UL(t,o);e.model={value:"(".concat(t,")"),expression:JSON.stringify(t),callback:"function (".concat(a,") {").concat(s,"}")}}function UL(e,t){var n=function(e){if(e=e.trim(),pL=e.length,e.indexOf("[")<0||e.lastIndexOf("]")<pL-1)return(gL=e.lastIndexOf("."))>-1?{exp:e.slice(0,gL),key:'"'+e.slice(gL+1)+'"'}:{exp:e,key:null};for(mL=e,gL=bL=_L=0;!BL();)zL(vL=FL())?VL(vL):91===vL&&HL(vL);return{exp:e.slice(0,bL),key:e.slice(bL+1,_L)}}(e);return null===n.key?"".concat(e,"=").concat(t):"$set(".concat(n.exp,", ").concat(n.key,", ").concat(t,")")}function FL(){return mL.charCodeAt(++gL)}function BL(){return gL>=pL}function zL(e){return 34===e||39===e}function HL(e){var t=1;for(bL=gL;!BL();)if(zL(e=FL()))VL(e);else if(91===e&&t++,93===e&&t--,0===t){_L=gL;break}}function VL(e){for(var t=e;!BL()&&(e=FL())!==t;);}var GL,$L="__r",WL="__c";function jL(e,t,n){var r=GL;return function i(){null!==t.apply(null,arguments)&&qL(e,i,n,r)}}var XL=Ek&&!(EC&&Number(EC[1])<=53);function YL(e,t,n,r){if(XL){var i=dk,a=t;t=a._wrapper=function(e){if(e.target===e.currentTarget||e.timeStamp>=i||e.timeStamp<=0||e.target.ownerDocument!==document)return a.apply(this,arguments)}}GL.addEventListener(e,t,SC?{capture:n,passive:r}:n)}function qL(e,t,n,r){(r||GL).removeEventListener(e,t._wrapper||t,n)}function KL(e,t){if(!MS(e.data.on)||!MS(t.data.on)){var n=t.data.on||{},r=e.data.on||{};GL=t.elm||e.elm,function(e){if(kS(e[$L])){var t=_C?"change":"input";e[t]=[].concat(e[$L],e[t]||[]),delete e[$L]}kS(e[WL])&&(e.change=[].concat(e[WL],e.change||[]),delete e[WL])}(n),dM(n,r,YL,qL,jL,t.context),GL=void 0}}var ZL,JL={create:KL,update:KL,destroy:function(e){return KL(e,JR)}};function QL(e,t){if(!MS(e.data.domProps)||!MS(t.data.domProps)){var n,r,i=t.elm,a=e.data.domProps||{},o=t.data.domProps||{};for(n in(kS(o.__ob__)||RS(o._v_attr_proxy))&&(o=t.data.domProps=eC({},o)),a)n in o||(i[n]="");for(n in o){if(r=o[n],"textContent"===n||"innerHTML"===n){if(t.children&&(t.children.length=0),r===a[n])continue;1===i.childNodes.length&&i.removeChild(i.childNodes[0])}if("value"===n&&"PROGRESS"!==i.tagName){i._value=r;var s=MS(r)?"":String(r);eO(i,s)&&(i.value=s)}else if("innerHTML"===n&&VR(i.tagName)&&MS(i.innerHTML)){(ZL=ZL||document.createElement("div")).innerHTML="<svg>".concat(r,"</svg>");for(var c=ZL.firstChild;i.firstChild;)i.removeChild(i.firstChild);for(;c.firstChild;)i.appendChild(c.firstChild)}else if(r!==a[n])try{i[n]=r}catch(e){}}}}function eO(e,t){return!e.composing&&("OPTION"===e.tagName||function(e,t){var n=!0;try{n=document.activeElement!==e}catch(e){}return n&&e.value!==t}(e,t)||function(e,t){var n=e.value,r=e._vModifiers;if(kS(r)){if(r.number)return BS(n)!==BS(t);if(r.trim)return n.trim()!==t.trim()}return n!==t}(e,t))}var tO={create:QL,update:QL},nO=jS((function(e){var t={},n=/:(.+)/;return e.split(/;(?![^(]*\))/g).forEach((function(e){if(e){var r=e.split(n);r.length>1&&(t[r[0].trim()]=r[1].trim())}})),t}));function rO(e){var t=iO(e.style);return e.staticStyle?eC(e.staticStyle,t):t}function iO(e){return Array.isArray(e)?tC(e):"string"==typeof e?nO(e):e}var aO,oO=/^--/,sO=/\s*!important$/,cO=function(e,t,n){if(oO.test(t))e.style.setProperty(t,n);else if(sO.test(n))e.style.setProperty(ZS(t),n.replace(sO,""),"important");else{var r=uO(t);if(Array.isArray(n))for(var i=0,a=n.length;i<a;i++)e.style[r]=n[i];else e.style[r]=n}},lO=["Webkit","Moz","ms"],uO=jS((function(e){if(aO=aO||document.createElement("div").style,"filter"!==(e=YS(e))&&e in aO)return e;for(var t=e.charAt(0).toUpperCase()+e.slice(1),n=0;n<lO.length;n++){var r=lO[n]+t;if(r in aO)return r}}));function dO(e,t){var n=t.data,r=e.data;if(!(MS(n.staticStyle)&&MS(n.style)&&MS(r.staticStyle)&&MS(r.style))){var i,a,o=t.elm,s=r.staticStyle,c=r.normalizedStyle||r.style||{},l=s||c,u=iO(t.data.style)||{};t.data.normalizedStyle=kS(u.__ob__)?eC({},u):u;var d=function(e,t){for(var n,r={},i=e;i.componentInstance;)(i=i.componentInstance._vnode)&&i.data&&(n=rO(i.data))&&eC(r,n);(n=rO(e.data))&&eC(r,n);for(var a=e;a=a.parent;)a.data&&(n=rO(a.data))&&eC(r,n);return r}(t);for(a in l)MS(d[a])&&cO(o,a,"");for(a in d)(i=d[a])!==l[a]&&cO(o,a,null==i?"":i)}}var fO={create:dO,update:dO},hO=/\s+/;function pO(e,t){if(t&&(t=t.trim()))if(e.classList)t.indexOf(" ")>-1?t.split(hO).forEach((function(t){return e.classList.add(t)})):e.classList.add(t);else{var n=" ".concat(e.getAttribute("class")||""," ");n.indexOf(" "+t+" ")<0&&e.setAttribute("class",(n+t).trim())}}function mO(e,t){if(t&&(t=t.trim()))if(e.classList)t.indexOf(" ")>-1?t.split(hO).forEach((function(t){return e.classList.remove(t)})):e.classList.remove(t),e.classList.length||e.removeAttribute("class");else{for(var n=" ".concat(e.getAttribute("class")||""," "),r=" "+t+" ";n.indexOf(r)>=0;)n=n.replace(r," ");(n=n.trim())?e.setAttribute("class",n):e.removeAttribute("class")}}function vO(e){if(e){if("object"==typeof e){var t={};return!1!==e.css&&eC(t,gO(e.name||"v")),eC(t,e),t}return"string"==typeof e?gO(e):void 0}}var gO=jS((function(e){return{enterClass:"".concat(e,"-enter"),enterToClass:"".concat(e,"-enter-to"),enterActiveClass:"".concat(e,"-enter-active"),leaveClass:"".concat(e,"-leave"),leaveToClass:"".concat(e,"-leave-to"),leaveActiveClass:"".concat(e,"-leave-active")}})),bO=gC&&!yC,_O="transition",yO="animation",xO="transition",AO="transitionend",wO="animation",EO="animationend";bO&&(void 0===window.ontransitionend&&void 0!==window.onwebkittransitionend&&(xO="WebkitTransition",AO="webkitTransitionEnd"),void 0===window.onanimationend&&void 0!==window.onwebkitanimationend&&(wO="WebkitAnimation",EO="webkitAnimationEnd"));var TO=gC?window.requestAnimationFrame?window.requestAnimationFrame.bind(window):setTimeout:function(e){return e()};function SO(e){TO((function(){TO(e)}))}function CO(e,t){var n=e._transitionClasses||(e._transitionClasses=[]);n.indexOf(t)<0&&(n.push(t),pO(e,t))}function MO(e,t){e._transitionClasses&&GS(e._transitionClasses,t),mO(e,t)}function kO(e,t,n){var r=LO(e,t),i=r.type,a=r.timeout,o=r.propCount;if(!i)return n();var s=i===_O?AO:EO,c=0,l=function(){e.removeEventListener(s,u),n()},u=function(t){t.target===e&&++c>=o&&l()};setTimeout((function(){c<o&&l()}),a+1),e.addEventListener(s,u)}var RO=/\b(transform|all)(,|$)/;function LO(e,t){var n,r=window.getComputedStyle(e),i=(r[xO+"Delay"]||"").split(", "),a=(r[xO+"Duration"]||"").split(", "),o=OO(i,a),s=(r[wO+"Delay"]||"").split(", "),c=(r[wO+"Duration"]||"").split(", "),l=OO(s,c),u=0,d=0;return t===_O?o>0&&(n=_O,u=o,d=a.length):t===yO?l>0&&(n=yO,u=l,d=c.length):d=(n=(u=Math.max(o,l))>0?o>l?_O:yO:null)?n===_O?a.length:c.length:0,{type:n,timeout:u,propCount:d,hasTransform:n===_O&&RO.test(r[xO+"Property"])}}function OO(e,t){for(;e.length<t.length;)e=e.concat(e);return Math.max.apply(null,t.map((function(t,n){return IO(t)+IO(e[n])})))}function IO(e){return 1e3*Number(e.slice(0,-1).replace(",","."))}function PO(e,t){var n=e.elm;kS(n._leaveCb)&&(n._leaveCb.cancelled=!0,n._leaveCb());var r=vO(e.data.transition);if(!MS(r)&&!kS(n._enterCb)&&1===n.nodeType){for(var i=r.css,a=r.type,o=r.enterClass,s=r.enterToClass,c=r.enterActiveClass,l=r.appearClass,u=r.appearToClass,d=r.appearActiveClass,f=r.beforeEnter,h=r.enter,p=r.afterEnter,m=r.enterCancelled,v=r.beforeAppear,g=r.appear,b=r.afterAppear,_=r.appearCancelled,y=r.duration,x=QM,A=QM.$vnode;A&&A.parent;)x=A.context,A=A.parent;var w=!x._isMounted||!e.isRootInsert;if(!w||g||""===g){var E=w&&l?l:o,T=w&&d?d:c,S=w&&u?u:s,C=w&&v||f,M=w&&OS(g)?g:h,k=w&&b||p,R=w&&_||m,L=BS(IS(y)?y.enter:y),O=!1!==i&&!yC,I=UO(M),P=n._enterCb=sC((function(){O&&(MO(n,S),MO(n,T)),P.cancelled?(O&&MO(n,E),R&&R(n)):k&&k(n),n._enterCb=null}));e.data.show||fM(e,"insert",(function(){var t=n.parentNode,r=t&&t._pending&&t._pending[e.key];r&&r.tag===e.tag&&r.elm._leaveCb&&r.elm._leaveCb(),M&&M(n,P)})),C&&C(n),O&&(CO(n,E),CO(n,T),SO((function(){MO(n,E),P.cancelled||(CO(n,S),I||(NO(L)?setTimeout(P,L):kO(n,a,P)))}))),e.data.show&&(t&&t(),M&&M(n,P)),O||I||P()}}}function DO(e,t){var n=e.elm;kS(n._enterCb)&&(n._enterCb.cancelled=!0,n._enterCb());var r=vO(e.data.transition);if(MS(r)||1!==n.nodeType)return t();if(!kS(n._leaveCb)){var i=r.css,a=r.type,o=r.leaveClass,s=r.leaveToClass,c=r.leaveActiveClass,l=r.beforeLeave,u=r.leave,d=r.afterLeave,f=r.leaveCancelled,h=r.delayLeave,p=r.duration,m=!1!==i&&!yC,v=UO(u),g=BS(IS(p)?p.leave:p),b=n._leaveCb=sC((function(){n.parentNode&&n.parentNode._pending&&(n.parentNode._pending[e.key]=null),m&&(MO(n,s),MO(n,c)),b.cancelled?(m&&MO(n,o),f&&f(n)):(t(),d&&d(n)),n._leaveCb=null}));h?h(_):_()}function _(){b.cancelled||(!e.data.show&&n.parentNode&&((n.parentNode._pending||(n.parentNode._pending={}))[e.key]=e),l&&l(n),m&&(CO(n,o),CO(n,c),SO((function(){MO(n,o),b.cancelled||(CO(n,s),v||(NO(g)?setTimeout(b,g):kO(n,a,b)))}))),u&&u(n,b),m||v||b())}}function NO(e){return"number"==typeof e&&!isNaN(e)}function UO(e){if(MS(e))return!1;var t=e.fns;return kS(t)?UO(Array.isArray(t)?t[0]:t):(e._length||e.length)>1}function FO(e,t){!0!==t.data.show&&PO(t)}var BO=function(e){var t,n,r={},i=e.modules,a=e.nodeOps;for(t=0;t<QR.length;++t)for(r[QR[t]]=[],n=0;n<i.length;++n)kS(i[n][QR[t]])&&r[QR[t]].push(i[n][QR[t]]);function o(e){var t=a.parentNode(e);kS(t)&&a.removeChild(t,e)}function s(e,t,n,i,o,s,d){if(kS(e.elm)&&kS(s)&&(e=s[d]=FC(e)),e.isRootInsert=!o,!function(e,t,n,i){var a=e.data;if(kS(a)){var o=kS(e.componentInstance)&&a.keepAlive;if(kS(a=a.hook)&&kS(a=a.init)&&a(e,!1),kS(e.componentInstance))return c(e,t),l(n,e.elm,i),RS(o)&&function(e,t,n,i){for(var a,o=e;o.componentInstance;)if(kS(a=(o=o.componentInstance._vnode).data)&&kS(a=a.transition)){for(a=0;a<r.activate.length;++a)r.activate[a](JR,o);t.push(o);break}l(n,e.elm,i)}(e,t,n,i),!0}}(e,t,n,i)){var p=e.data,m=e.children,v=e.tag;kS(v)?(e.elm=e.ns?a.createElementNS(e.ns,v):a.createElement(v,e),h(e),u(e,m,t),kS(p)&&f(e,t),l(n,e.elm,i)):RS(e.isComment)?(e.elm=a.createComment(e.text),l(n,e.elm,i)):(e.elm=a.createTextNode(e.text),l(n,e.elm,i))}}function c(e,t){kS(e.data.pendingInsert)&&(t.push.apply(t,e.data.pendingInsert),e.data.pendingInsert=null),e.elm=e.componentInstance.$el,d(e)?(f(e,t),h(e)):(KR(e),t.push(e))}function l(e,t,n){kS(e)&&(kS(n)?a.parentNode(n)===e&&a.insertBefore(e,t,n):a.appendChild(e,t))}function u(e,t,n){if(CS(t))for(var r=0;r<t.length;++r)s(t[r],n,e.elm,null,!0,t,r);else LS(e.text)&&a.appendChild(e.elm,a.createTextNode(String(e.text)))}function d(e){for(;e.componentInstance;)e=e.componentInstance._vnode;return kS(e.tag)}function f(e,n){for(var i=0;i<r.create.length;++i)r.create[i](JR,e);kS(t=e.data.hook)&&(kS(t.create)&&t.create(JR,e),kS(t.insert)&&n.push(e))}function h(e){var t;if(kS(t=e.fnScopeId))a.setStyleScope(e.elm,t);else for(var n=e;n;)kS(t=n.context)&&kS(t=t.$options._scopeId)&&a.setStyleScope(e.elm,t),n=n.parent;kS(t=QM)&&t!==e.context&&t!==e.fnContext&&kS(t=t.$options._scopeId)&&a.setStyleScope(e.elm,t)}function p(e,t,n,r,i,a){for(;r<=i;++r)s(n[r],a,e,t,!1,n,r)}function m(e){var t,n,i=e.data;if(kS(i))for(kS(t=i.hook)&&kS(t=t.destroy)&&t(e),t=0;t<r.destroy.length;++t)r.destroy[t](e);if(kS(t=e.children))for(n=0;n<e.children.length;++n)m(e.children[n])}function v(e,t,n){for(;t<=n;++t){var r=e[t];kS(r)&&(kS(r.tag)?(g(r),m(r)):o(r.elm))}}function g(e,t){if(kS(t)||kS(e.data)){var n,i=r.remove.length+1;for(kS(t)?t.listeners+=i:t=function(e,t){function n(){0==--n.listeners&&o(e)}return n.listeners=t,n}(e.elm,i),kS(n=e.componentInstance)&&kS(n=n._vnode)&&kS(n.data)&&g(n,t),n=0;n<r.remove.length;++n)r.remove[n](e,t);kS(n=e.data.hook)&&kS(n=n.remove)?n(e,t):t()}else o(e.elm)}function b(e,t,n,r){for(var i=n;i<r;i++){var a=t[i];if(kS(a)&&eL(e,a))return i}}function _(e,t,n,i,o,c){if(e!==t){kS(t.elm)&&kS(i)&&(t=i[o]=FC(t));var l=t.elm=e.elm;if(RS(e.isAsyncPlaceholder))kS(t.asyncFactory.resolved)?A(e.elm,t,n):t.isAsyncPlaceholder=!0;else if(RS(t.isStatic)&&RS(e.isStatic)&&t.key===e.key&&(RS(t.isCloned)||RS(t.isOnce)))t.componentInstance=e.componentInstance;else{var u,f=t.data;kS(f)&&kS(u=f.hook)&&kS(u=u.prepatch)&&u(e,t);var h=e.children,m=t.children;if(kS(f)&&d(t)){for(u=0;u<r.update.length;++u)r.update[u](e,t);kS(u=f.hook)&&kS(u=u.update)&&u(e,t)}MS(t.text)?kS(h)&&kS(m)?h!==m&&function(e,t,n,r,i){for(var o,c,l,u=0,d=0,f=t.length-1,h=t[0],m=t[f],g=n.length-1,y=n[0],x=n[g],A=!i;u<=f&&d<=g;)MS(h)?h=t[++u]:MS(m)?m=t[--f]:eL(h,y)?(_(h,y,r,n,d),h=t[++u],y=n[++d]):eL(m,x)?(_(m,x,r,n,g),m=t[--f],x=n[--g]):eL(h,x)?(_(h,x,r,n,g),A&&a.insertBefore(e,h.elm,a.nextSibling(m.elm)),h=t[++u],x=n[--g]):eL(m,y)?(_(m,y,r,n,d),A&&a.insertBefore(e,m.elm,h.elm),m=t[--f],y=n[++d]):(MS(o)&&(o=tL(t,u,f)),MS(c=kS(y.key)?o[y.key]:b(y,t,u,f))?s(y,r,e,h.elm,!1,n,d):eL(l=t[c],y)?(_(l,y,r,n,d),t[c]=void 0,A&&a.insertBefore(e,l.elm,h.elm)):s(y,r,e,h.elm,!1,n,d),y=n[++d]);u>f?p(e,MS(n[g+1])?null:n[g+1].elm,n,d,g,r):d>g&&v(t,u,f)}(l,h,m,n,c):kS(m)?(kS(e.text)&&a.setTextContent(l,""),p(l,null,m,0,m.length-1,n)):kS(h)?v(h,0,h.length-1):kS(e.text)&&a.setTextContent(l,""):e.text!==t.text&&a.setTextContent(l,t.text),kS(f)&&kS(u=f.hook)&&kS(u=u.postpatch)&&u(e,t)}}}function y(e,t,n){if(RS(n)&&kS(e.parent))e.parent.data.pendingInsert=t;else for(var r=0;r<t.length;++r)t[r].data.hook.insert(t[r])}var x=zS("attrs,class,staticClass,staticStyle,key");function A(e,t,n,r){var i,a=t.tag,o=t.data,s=t.children;if(r=r||o&&o.pre,t.elm=e,RS(t.isComment)&&kS(t.asyncFactory))return t.isAsyncPlaceholder=!0,!0;if(kS(o)&&(kS(i=o.hook)&&kS(i=i.init)&&i(t,!0),kS(i=t.componentInstance)))return c(t,n),!0;if(kS(a)){if(kS(s))if(e.hasChildNodes())if(kS(i=o)&&kS(i=i.domProps)&&kS(i=i.innerHTML)){if(i!==e.innerHTML)return!1}else{for(var l=!0,d=e.firstChild,h=0;h<s.length;h++){if(!d||!A(d,s[h],n,r)){l=!1;break}d=d.nextSibling}if(!l||d)return!1}else u(t,s,n);if(kS(o)){var p=!1;for(var m in o)if(!x(m)){p=!0,f(t,n);break}!p&&o.class&&Dk(o.class)}}else e.data!==t.text&&(e.data=t.text);return!0}return function(e,t,n,i){if(!MS(t)){var o,c=!1,l=[];if(MS(e))c=!0,s(t,l);else{var u=kS(e.nodeType);if(!u&&eL(e,t))_(e,t,l,null,null,i);else{if(u){if(1===e.nodeType&&e.hasAttribute(cC)&&(e.removeAttribute(cC),n=!0),RS(n)&&A(e,t,l))return y(t,l,!0),e;o=e,e=new DC(a.tagName(o).toLowerCase(),{},[],void 0,o)}var f=e.elm,h=a.parentNode(f);if(s(t,l,f._leaveCb?null:h,a.nextSibling(f)),kS(t.parent))for(var p=t.parent,g=d(t);p;){for(var b=0;b<r.destroy.length;++b)r.destroy[b](p);if(p.elm=t.elm,g){for(var x=0;x<r.create.length;++x)r.create[x](JR,p);var w=p.data.hook.insert;if(w.merged)for(var E=1;E<w.fns.length;E++)w.fns[E]()}else KR(p);p=p.parent}kS(h)?v([e],0,0):kS(e.tag)&&m(e)}}return y(t,l,c),t.elm}kS(e)&&m(e)}}({nodeOps:YR,modules:[fL,yL,JL,tO,fO,gC?{create:FO,activate:FO,remove:function(e,t){!0!==e.data.show?DO(e,t):t()}}:{}].concat(cL)});yC&&document.addEventListener("selectionchange",(function(){var e=document.activeElement;e&&e.vmodel&&XO(e,"input")}));var zO={inserted:function(e,t,n,r){"select"===n.tag?(r.elm&&!r.elm._vOptions?fM(n,"postpatch",(function(){zO.componentUpdated(e,t,n)})):HO(e,t,n.context),e._vOptions=[].map.call(e.options,$O)):("textarea"===n.tag||jR(e.type))&&(e._vModifiers=t.modifiers,t.modifiers.lazy||(e.addEventListener("compositionstart",WO),e.addEventListener("compositionend",jO),e.addEventListener("change",jO),yC&&(e.vmodel=!0)))},componentUpdated:function(e,t,n){if("select"===n.tag){HO(e,t,n.context);var r=e._vOptions,i=e._vOptions=[].map.call(e.options,$O);i.some((function(e,t){return!aC(e,r[t])}))&&(e.multiple?t.value.some((function(e){return GO(e,i)})):t.value!==t.oldValue&&GO(t.value,i))&&XO(e,"change")}}};function HO(e,t,n){VO(e,t),(_C||xC)&&setTimeout((function(){VO(e,t)}),0)}function VO(e,t,n){var r=t.value,i=e.multiple;if(!i||Array.isArray(r)){for(var a,o,s=0,c=e.options.length;s<c;s++)if(o=e.options[s],i)a=oC(r,$O(o))>-1,o.selected!==a&&(o.selected=a);else if(aC($O(o),r))return void(e.selectedIndex!==s&&(e.selectedIndex=s));i||(e.selectedIndex=-1)}}function GO(e,t){return t.every((function(t){return!aC(t,e)}))}function $O(e){return"_value"in e?e._value:e.value}function WO(e){e.target.composing=!0}function jO(e){e.target.composing&&(e.target.composing=!1,XO(e.target,"input"))}function XO(e,t){var n=document.createEvent("HTMLEvents");n.initEvent(t,!0,!0),e.dispatchEvent(n)}function YO(e){return!e.componentInstance||e.data&&e.data.transition?e:YO(e.componentInstance._vnode)}var qO={model:zO,show:{bind:function(e,t,n){var r=t.value,i=(n=YO(n)).data&&n.data.transition,a=e.__vOriginalDisplay="none"===e.style.display?"":e.style.display;r&&i?(n.data.show=!0,PO(n,(function(){e.style.display=a}))):e.style.display=r?a:"none"},update:function(e,t,n){var r=t.value;!r!=!t.oldValue&&((n=YO(n)).data&&n.data.transition?(n.data.show=!0,r?PO(n,(function(){e.style.display=e.__vOriginalDisplay})):DO(n,(function(){e.style.display="none"}))):e.style.display=r?e.__vOriginalDisplay:"none")},unbind:function(e,t,n,r,i){i||(e.style.display=e.__vOriginalDisplay)}}},KO={name:String,appear:Boolean,css:Boolean,mode:String,type:String,enterClass:String,leaveClass:String,enterToClass:String,leaveToClass:String,enterActiveClass:String,leaveActiveClass:String,appearClass:String,appearActiveClass:String,appearToClass:String,duration:[Number,String,Object]};function ZO(e){var t=e&&e.componentOptions;return t&&t.Ctor.options.abstract?ZO(YM(t.children)):e}function JO(e){var t={},n=e.$options;for(var r in n.propsData)t[r]=e[r];var i=n._parentListeners;for(var r in i)t[YS(r)]=i[r];return t}function QO(e,t){if(/\d-keep-alive$/.test(t.tag))return e("keep-alive",{props:t.componentOptions.propsData})}var eI=function(e){return e.tag||FM(e)},tI=function(e){return"show"===e.name},nI={name:"transition",props:KO,abstract:!0,render:function(e){var t=this,n=this.$slots.default;if(n&&(n=n.filter(eI)).length){var r=this.mode,i=n[0];if(function(e){for(;e=e.parent;)if(e.data.transition)return!0}(this.$vnode))return i;var a=ZO(i);if(!a)return i;if(this._leaving)return QO(e,i);var o="__transition-".concat(this._uid,"-");a.key=null==a.key?a.isComment?o+"comment":o+a.tag:LS(a.key)?0===String(a.key).indexOf(o)?a.key:o+a.key:a.key;var s=(a.data||(a.data={})).transition=JO(this),c=this._vnode,l=ZO(c);if(a.data.directives&&a.data.directives.some(tI)&&(a.data.show=!0),l&&l.data&&!function(e,t){return t.key===e.key&&t.tag===e.tag}(a,l)&&!FM(l)&&(!l.componentInstance||!l.componentInstance._vnode.isComment)){var u=l.data.transition=eC({},s);if("out-in"===r)return this._leaving=!0,fM(u,"afterLeave",(function(){t._leaving=!1,t.$forceUpdate()})),QO(e,i);if("in-out"===r){if(FM(a))return c;var d,f=function(){d()};fM(s,"afterEnter",f),fM(s,"enterCancelled",f),fM(u,"delayLeave",(function(e){d=e}))}}return i}}},rI=eC({tag:String,moveClass:String},KO);delete rI.mode;var iI={props:rI,beforeMount:function(){var e=this,t=this._update;this._update=function(n,r){var i=ek(e);e.__patch__(e._vnode,e.kept,!1,!0),e._vnode=e.kept,i(),t.call(e,n,r)}},render:function(e){for(var t=this.tag||this.$vnode.data.tag||"span",n=Object.create(null),r=this.prevChildren=this.children,i=this.$slots.default||[],a=this.children=[],o=JO(this),s=0;s<i.length;s++)(u=i[s]).tag&&null!=u.key&&0!==String(u.key).indexOf("__vlist")&&(a.push(u),n[u.key]=u,(u.data||(u.data={})).transition=o);if(r){var c=[],l=[];for(s=0;s<r.length;s++){var u;(u=r[s]).data.transition=o,u.data.pos=u.elm.getBoundingClientRect(),n[u.key]?c.push(u):l.push(u)}this.kept=e(t,null,c),this.removed=l}return e(t,null,a)},updated:function(){var e=this.prevChildren,t=this.moveClass||(this.name||"v")+"-move";e.length&&this.hasMove(e[0].elm,t)&&(e.forEach(aI),e.forEach(oI),e.forEach(sI),this._reflow=document.body.offsetHeight,e.forEach((function(e){if(e.data.moved){var n=e.elm,r=n.style;CO(n,t),r.transform=r.WebkitTransform=r.transitionDuration="",n.addEventListener(AO,n._moveCb=function e(r){r&&r.target!==n||r&&!/transform$/.test(r.propertyName)||(n.removeEventListener(AO,e),n._moveCb=null,MO(n,t))})}})))},methods:{hasMove:function(e,t){if(!bO)return!1;if(this._hasMove)return this._hasMove;var n=e.cloneNode();e._transitionClasses&&e._transitionClasses.forEach((function(e){mO(n,e)})),pO(n,t),n.style.display="none",this.$el.appendChild(n);var r=LO(n);return this.$el.removeChild(n),this._hasMove=r.hasTransform}}};function aI(e){e.elm._moveCb&&e.elm._moveCb(),e.elm._enterCb&&e.elm._enterCb()}function oI(e){e.data.newPos=e.elm.getBoundingClientRect()}function sI(e){var t=e.data.pos,n=e.data.newPos,r=t.left-n.left,i=t.top-n.top;if(r||i){e.data.moved=!0;var a=e.elm.style;a.transform=a.WebkitTransform="translate(".concat(r,"px,").concat(i,"px)"),a.transitionDuration="0s"}}var cI={Transition:nI,TransitionGroup:iI};bR.config.mustUseProp=MR,bR.config.isReservedTag=GR,bR.config.isReservedAttr=SR,bR.config.getTagNamespace=$R,bR.config.isUnknownElement=function(e){if(!gC)return!0;if(GR(e))return!1;if(e=e.toLowerCase(),null!=WR[e])return WR[e];var t=document.createElement(e);return e.indexOf("-")>-1?WR[e]=t.constructor===window.HTMLUnknownElement||t.constructor===window.HTMLElement:WR[e]=/HTMLUnknownElement/.test(t.toString())},eC(bR.options.directives,qO),eC(bR.options.components,cI),bR.prototype.__patch__=gC?BO:nC,bR.prototype.$mount=function(e,t){return function(e,t,n){var r;e.$el=t,e.$options.render||(e.$options.render=NC),ik(e,"beforeMount"),r=function(){e._update(e._render(),n)},new Fk(e,r,nC,{before:function(){e._isMounted&&!e._isDestroyed&&ik(e,"beforeUpdate")}},!0),n=!1;var i=e._preWatchers;if(i)for(var a=0;a<i.length;a++)i[a].run();return null==e.$vnode&&(e._isMounted=!0,ik(e,"mounted")),e}(this,e=e&&gC?XR(e):void 0,t)},gC&&setTimeout((function(){dC.devtools&&kC&&kC.emit("init",bR)}),0);var lI,uI=/\{\{((?:.|\r?\n)+?)\}\}/g,dI=/[-.*+?^${}()|[\]\/\\]/g,fI=jS((function(e){var t=e[0].replace(dI,"\\$&"),n=e[1].replace(dI,"\\$&");return new RegExp(t+"((?:.|\\n)+?)"+n,"g")})),hI={staticKeys:["staticClass"],transformNode:function(e,t){t.warn;var n=IL(e,"class");n&&(e.staticClass=JSON.stringify(n.replace(/\s+/g," ").trim()));var r=OL(e,"class",!1);r&&(e.classBinding=r)},genData:function(e){var t="";return e.staticClass&&(t+="staticClass:".concat(e.staticClass,",")),e.classBinding&&(t+="class:".concat(e.classBinding,",")),t}},pI={staticKeys:["staticStyle"],transformNode:function(e,t){t.warn;var n=IL(e,"style");n&&(e.staticStyle=JSON.stringify(nO(n)));var r=OL(e,"style",!1);r&&(e.styleBinding=r)},genData:function(e){var t="";return e.staticStyle&&(t+="staticStyle:".concat(e.staticStyle,",")),e.styleBinding&&(t+="style:(".concat(e.styleBinding,"),")),t}},mI=zS("area,base,br,col,embed,frame,hr,img,input,isindex,keygen,link,meta,param,source,track,wbr"),vI=zS("colgroup,dd,dt,li,options,p,td,tfoot,th,thead,tr,source"),gI=zS("address,article,aside,base,blockquote,body,caption,col,colgroup,dd,details,dialog,div,dl,dt,fieldset,figcaption,figure,footer,form,h1,h2,h3,h4,h5,h6,head,header,hgroup,hr,html,legend,li,menuitem,meta,optgroup,option,param,rp,rt,source,style,summary,tbody,td,tfoot,th,thead,title,tr,track"),bI=/^\s*([^\s"'<>\/=]+)(?:\s*(=)\s*(?:"([^"]*)"+|'([^']*)'+|([^\s"'=<>`]+)))?/,_I=/^\s*((?:v-[\w-]+:|@|:|#)\[[^=]+?\][^\s"'<>\/=]*)(?:\s*(=)\s*(?:"([^"]*)"+|'([^']*)'+|([^\s"'=<>`]+)))?/,yI="[a-zA-Z_][\\-\\.0-9_a-zA-Z".concat(fC.source,"]*"),xI="((?:".concat(yI,"\\:)?").concat(yI,")"),AI=new RegExp("^<".concat(xI)),wI=/^\s*(\/?)>/,EI=new RegExp("^<\\/".concat(xI,"[^>]*>")),TI=/^<!DOCTYPE [^>]+>/i,SI=/^<!\--/,CI=/^<!\[/,MI=zS("script,style,textarea",!0),kI={},RI={"&lt;":"<","&gt;":">","&quot;":'"',"&amp;":"&","&#10;":"\n","&#9;":"\t","&#39;":"'"},LI=/&(?:lt|gt|quot|amp|#39);/g,OI=/&(?:lt|gt|quot|amp|#39|#10|#9);/g,II=zS("pre,textarea",!0),PI=function(e,t){return e&&II(e)&&"\n"===t[0]};function DI(e,t){var n=t?OI:LI;return e.replace(n,(function(e){return RI[e]}))}var NI,UI,FI,BI,zI,HI,VI,GI,$I=/^@|^v-on:/,WI=/^v-|^@|^:|^#/,jI=/([\s\S]*?)\s+(?:in|of)\s+([\s\S]*)/,XI=/,([^,\}\]]*)(?:,([^,\}\]]*))?$/,YI=/^\(|\)$/g,qI=/^\[.*\]$/,KI=/:(.*)$/,ZI=/^:|^\.|^v-bind:/,JI=/\.[^.\]]+(?=[^\]]*$)/g,QI=/^v-slot(:|$)|^#/,eP=/[\r\n]/,tP=/[ \f\t\r\n]+/g,nP=jS((function(e){return(lI=lI||document.createElement("div")).innerHTML=e,lI.textContent})),rP="_empty_";function iP(e,t,n){return{type:1,tag:e,attrsList:t,attrsMap:dP(t),rawAttrsMap:{},parent:n,children:[]}}function aP(e,t){NI=t.warn||EL,HI=t.isPreTag||rC,VI=t.mustUseProp||rC,GI=t.getTagNamespace||rC;t.isReservedTag;FI=TL(t.modules,"transformNode"),BI=TL(t.modules,"preTransformNode"),zI=TL(t.modules,"postTransformNode"),UI=t.delimiters;var n,r,i=[],a=!1!==t.preserveWhitespace,o=t.whitespace,s=!1,c=!1;function l(e){if(u(e),s||e.processed||(e=oP(e,t)),i.length||e===n||n.if&&(e.elseif||e.else)&&cP(n,{exp:e.elseif,block:e}),r&&!e.forbidden)if(e.elseif||e.else)o=e,l=function(e){for(var t=e.length;t--;){if(1===e[t].type)return e[t];e.pop()}}(r.children),l&&l.if&&cP(l,{exp:o.elseif,block:o});else{if(e.slotScope){var a=e.slotTarget||'"default"';(r.scopedSlots||(r.scopedSlots={}))[a]=e}r.children.push(e),e.parent=r}var o,l;e.children=e.children.filter((function(e){return!e.slotScope})),u(e),e.pre&&(s=!1),HI(e.tag)&&(c=!1);for(var d=0;d<zI.length;d++)zI[d](e,t)}function u(e){if(!c)for(var t=void 0;(t=e.children[e.children.length-1])&&3===t.type&&" "===t.text;)e.children.pop()}return function(e,t){for(var n,r,i=[],a=t.expectHTML,o=t.isUnaryTag||rC,s=t.canBeLeftOpenTag||rC,c=0,l=function(){if(n=e,r&&MI(r)){var l=0,f=r.toLowerCase(),h=kI[f]||(kI[f]=new RegExp("([\\s\\S]*?)(</"+f+"[^>]*>)","i"));A=e.replace(h,(function(e,n,r){return l=r.length,MI(f)||"noscript"===f||(n=n.replace(/<!\--([\s\S]*?)-->/g,"$1").replace(/<!\[CDATA\[([\s\S]*?)]]>/g,"$1")),PI(f,n)&&(n=n.slice(1)),t.chars&&t.chars(n),""})),c+=e.length-A.length,e=A,d(f,c-l,c)}else{var p=e.indexOf("<");if(0===p){if(SI.test(e)){var m=e.indexOf("--\x3e");if(m>=0)return t.shouldKeepComment&&t.comment&&t.comment(e.substring(4,m),c,c+m+3),u(m+3),"continue"}if(CI.test(e)){var v=e.indexOf("]>");if(v>=0)return u(v+2),"continue"}var g=e.match(TI);if(g)return u(g[0].length),"continue";var b=e.match(EI);if(b){var _=c;return u(b[0].length),d(b[1],_,c),"continue"}var y=function(){var t=e.match(AI);if(t){var n={tagName:t[1],attrs:[],start:c};u(t[0].length);for(var r=void 0,i=void 0;!(r=e.match(wI))&&(i=e.match(_I)||e.match(bI));)i.start=c,u(i[0].length),i.end=c,n.attrs.push(i);if(r)return n.unarySlash=r[1],u(r[0].length),n.end=c,n}}();if(y)return function(e){var n=e.tagName,c=e.unarySlash;a&&("p"===r&&gI(n)&&d(r),s(n)&&r===n&&d(n));for(var l=o(n)||!!c,u=e.attrs.length,f=new Array(u),h=0;h<u;h++){var p=e.attrs[h],m=p[3]||p[4]||p[5]||"",v="a"===n&&"href"===p[1]?t.shouldDecodeNewlinesForHref:t.shouldDecodeNewlines;f[h]={name:p[1],value:DI(m,v)}}l||(i.push({tag:n,lowerCasedTag:n.toLowerCase(),attrs:f,start:e.start,end:e.end}),r=n),t.start&&t.start(n,f,l,e.start,e.end)}(y),PI(y.tagName,e)&&u(1),"continue"}var x=void 0,A=void 0,w=void 0;if(p>=0){for(A=e.slice(p);!(EI.test(A)||AI.test(A)||SI.test(A)||CI.test(A)||(w=A.indexOf("<",1))<0);)p+=w,A=e.slice(p);x=e.substring(0,p)}p<0&&(x=e),x&&u(x.length),t.chars&&x&&t.chars(x,c-x.length,c)}if(e===n)return t.chars&&t.chars(e),"break"};e&&"break"!==l(););function u(t){c+=t,e=e.substring(t)}function d(e,n,a){var o,s;if(null==n&&(n=c),null==a&&(a=c),e)for(s=e.toLowerCase(),o=i.length-1;o>=0&&i[o].lowerCasedTag!==s;o--);else o=0;if(o>=0){for(var l=i.length-1;l>=o;l--)t.end&&t.end(i[l].tag,n,a);i.length=o,r=o&&i[o-1].tag}else"br"===s?t.start&&t.start(e,[],!0,n,a):"p"===s&&(t.start&&t.start(e,[],!1,n,a),t.end&&t.end(e,n,a))}d()}(e,{warn:NI,expectHTML:t.expectHTML,isUnaryTag:t.isUnaryTag,canBeLeftOpenTag:t.canBeLeftOpenTag,shouldDecodeNewlines:t.shouldDecodeNewlines,shouldDecodeNewlinesForHref:t.shouldDecodeNewlinesForHref,shouldKeepComment:t.comments,outputSourceRange:t.outputSourceRange,start:function(e,a,o,u,d){var f=r&&r.ns||GI(e);_C&&"svg"===f&&(a=function(e){for(var t=[],n=0;n<e.length;n++){var r=e[n];fP.test(r.name)||(r.name=r.name.replace(hP,""),t.push(r))}return t}(a));var h,p=iP(e,a,r);f&&(p.ns=f),"style"!==(h=p).tag&&("script"!==h.tag||h.attrsMap.type&&"text/javascript"!==h.attrsMap.type)||MC()||(p.forbidden=!0);for(var m=0;m<BI.length;m++)p=BI[m](p,t)||p;s||(function(e){null!=IL(e,"v-pre")&&(e.pre=!0)}(p),p.pre&&(s=!0)),HI(p.tag)&&(c=!0),s?function(e){var t=e.attrsList,n=t.length;if(n)for(var r=e.attrs=new Array(n),i=0;i<n;i++)r[i]={name:t[i].name,value:JSON.stringify(t[i].value)},null!=t[i].start&&(r[i].start=t[i].start,r[i].end=t[i].end);else e.pre||(e.plain=!0)}(p):p.processed||(sP(p),function(e){var t=IL(e,"v-if");if(t)e.if=t,cP(e,{exp:t,block:e});else{null!=IL(e,"v-else")&&(e.else=!0);var n=IL(e,"v-else-if");n&&(e.elseif=n)}}(p),function(e){null!=IL(e,"v-once")&&(e.once=!0)}(p)),n||(n=p),o?l(p):(r=p,i.push(p))},end:function(e,t,n){var a=i[i.length-1];i.length-=1,r=i[i.length-1],l(a)},chars:function(e,t,n){if(r&&(!_C||"textarea"!==r.tag||r.attrsMap.placeholder!==e)){var i,l=r.children;if(e=c||e.trim()?"script"===(i=r).tag||"style"===i.tag?e:nP(e):l.length?o?"condense"===o&&eP.test(e)?"":" ":a?" ":"":""){c||"condense"!==o||(e=e.replace(tP," "));var u=void 0,d=void 0;!s&&" "!==e&&(u=function(e,t){var n=t?fI(t):uI;if(n.test(e)){for(var r,i,a,o=[],s=[],c=n.lastIndex=0;r=n.exec(e);){(i=r.index)>c&&(s.push(a=e.slice(c,i)),o.push(JSON.stringify(a)));var l=AL(r[1].trim());o.push("_s(".concat(l,")")),s.push({"@binding":l}),c=i+r[0].length}return c<e.length&&(s.push(a=e.slice(c)),o.push(JSON.stringify(a))),{expression:o.join("+"),tokens:s}}}(e,UI))?d={type:2,expression:u.expression,tokens:u.tokens,text:e}:" "===e&&l.length&&" "===l[l.length-1].text||(d={type:3,text:e}),d&&l.push(d)}}},comment:function(e,t,n){if(r){var i={type:3,text:e,isComment:!0};r.children.push(i)}}}),n}function oP(e,t){var n;!function(e){var t=OL(e,"key");t&&(e.key=t)}(e),e.plain=!e.key&&!e.scopedSlots&&!e.attrsList.length,function(e){var t=OL(e,"ref");t&&(e.ref=t,e.refInFor=function(e){for(var t=e;t;){if(void 0!==t.for)return!0;t=t.parent}return!1}(e))}(e),function(e){var t;"template"===e.tag?(t=IL(e,"scope"),e.slotScope=t||IL(e,"slot-scope")):(t=IL(e,"slot-scope"))&&(e.slotScope=t);var n,r=OL(e,"slot");if(r&&(e.slotTarget='""'===r?'"default"':r,e.slotTargetDynamic=!(!e.attrsMap[":slot"]&&!e.attrsMap["v-bind:slot"]),"template"===e.tag||e.slotScope||CL(e,"slot",r,function(e,t){return e.rawAttrsMap[":"+t]||e.rawAttrsMap["v-bind:"+t]||e.rawAttrsMap[t]}(e,"slot"))),"template"===e.tag){if(n=PL(e,QI)){var i=lP(n),a=i.name,o=i.dynamic;e.slotTarget=a,e.slotTargetDynamic=o,e.slotScope=n.value||rP}}else if(n=PL(e,QI)){var s=e.scopedSlots||(e.scopedSlots={}),c=lP(n),l=c.name,u=(o=c.dynamic,s[l]=iP("template",[],e));u.slotTarget=l,u.slotTargetDynamic=o,u.children=e.children.filter((function(e){if(!e.slotScope)return e.parent=u,!0})),u.slotScope=n.value||rP,e.children=[],e.plain=!1}}(e),"slot"===(n=e).tag&&(n.slotName=OL(n,"name")),function(e){var t;(t=OL(e,"is"))&&(e.component=t),null!=IL(e,"inline-template")&&(e.inlineTemplate=!0)}(e);for(var r=0;r<FI.length;r++)e=FI[r](e,t)||e;return function(e){var t,n,r,i,a,o,s,c,l=e.attrsList;for(t=0,n=l.length;t<n;t++)if(r=i=l[t].name,a=l[t].value,WI.test(r))if(e.hasBindings=!0,(o=uP(r.replace(WI,"")))&&(r=r.replace(JI,"")),ZI.test(r))r=r.replace(ZI,""),a=AL(a),(c=qI.test(r))&&(r=r.slice(1,-1)),o&&(o.prop&&!c&&"innerHtml"===(r=YS(r))&&(r="innerHTML"),o.camel&&!c&&(r=YS(r)),o.sync&&(s=UL(a,"$event"),c?LL(e,'"update:"+('.concat(r,")"),s,null,!1,0,l[t],!0):(LL(e,"update:".concat(YS(r)),s,null,!1,0,l[t]),ZS(r)!==YS(r)&&LL(e,"update:".concat(ZS(r)),s,null,!1,0,l[t])))),o&&o.prop||!e.component&&VI(e.tag,e.attrsMap.type,r)?SL(e,r,a,l[t],c):CL(e,r,a,l[t],c);else if($I.test(r))r=r.replace($I,""),(c=qI.test(r))&&(r=r.slice(1,-1)),LL(e,r,a,o,!1,0,l[t],c);else{var u=(r=r.replace(WI,"")).match(KI),d=u&&u[1];c=!1,d&&(r=r.slice(0,-(d.length+1)),qI.test(d)&&(d=d.slice(1,-1),c=!0)),kL(e,r,i,a,d,c,o,l[t])}else CL(e,r,JSON.stringify(a),l[t]),!e.component&&"muted"===r&&VI(e.tag,e.attrsMap.type,r)&&SL(e,r,"true",l[t])}(e),e}function sP(e){var t;if(t=IL(e,"v-for")){var n=function(e){var t=e.match(jI);if(t){var n={};n.for=t[2].trim();var r=t[1].trim().replace(YI,""),i=r.match(XI);return i?(n.alias=r.replace(XI,"").trim(),n.iterator1=i[1].trim(),i[2]&&(n.iterator2=i[2].trim())):n.alias=r,n}}(t);n&&eC(e,n)}}function cP(e,t){e.ifConditions||(e.ifConditions=[]),e.ifConditions.push(t)}function lP(e){var t=e.name.replace(QI,"");return t||"#"!==e.name[0]&&(t="default"),qI.test(t)?{name:t.slice(1,-1),dynamic:!0}:{name:'"'.concat(t,'"'),dynamic:!1}}function uP(e){var t=e.match(JI);if(t){var n={};return t.forEach((function(e){n[e.slice(1)]=!0})),n}}function dP(e){for(var t={},n=0,r=e.length;n<r;n++)t[e[n].name]=e[n].value;return t}var fP=/^xmlns:NS\d+/,hP=/^NS\d+:/;function pP(e){return iP(e.tag,e.attrsList.slice(),e.parent)}var mP,vP,gP=[hI,pI,{preTransformNode:function(e,t){if("input"===e.tag){var n=e.attrsMap;if(!n["v-model"])return;var r=void 0;if((n[":type"]||n["v-bind:type"])&&(r=OL(e,"type")),n.type||r||!n["v-bind"]||(r="(".concat(n["v-bind"],").type")),r){var i=IL(e,"v-if",!0),a=i?"&&(".concat(i,")"):"",o=null!=IL(e,"v-else",!0),s=IL(e,"v-else-if",!0),c=pP(e);sP(c),ML(c,"type","checkbox"),oP(c,t),c.processed=!0,c.if="(".concat(r,")==='checkbox'")+a,cP(c,{exp:c.if,block:c});var l=pP(e);IL(l,"v-for",!0),ML(l,"type","radio"),oP(l,t),cP(c,{exp:"(".concat(r,")==='radio'")+a,block:l});var u=pP(e);return IL(u,"v-for",!0),ML(u,":type",r),oP(u,t),cP(c,{exp:i,block:u}),o?c.else=!0:s&&(c.elseif=s),c}}}}],bP={model:function(e,t,n){var r=t.value,i=t.modifiers,a=e.tag,o=e.attrsMap.type;if(e.component)return NL(e,r,i),!1;if("select"===a)!function(e,t,n){var r=n&&n.number,i='Array.prototype.filter.call($event.target.options,function(o){return o.selected}).map(function(o){var val = "_value" in o ? o._value : o.value;'+"return ".concat(r?"_n(val)":"val","})"),a="var $$selectedVal = ".concat(i,";");LL(e,"change",a="".concat(a," ").concat(UL(t,"$event.target.multiple ? $$selectedVal : $$selectedVal[0]")),null,!0)}(e,r,i);else if("input"===a&&"checkbox"===o)!function(e,t,n){var r=n&&n.number,i=OL(e,"value")||"null",a=OL(e,"true-value")||"true",o=OL(e,"false-value")||"false";SL(e,"checked","Array.isArray(".concat(t,")")+"?_i(".concat(t,",").concat(i,")>-1")+("true"===a?":(".concat(t,")"):":_q(".concat(t,",").concat(a,")"))),LL(e,"change","var $$a=".concat(t,",")+"$$el=$event.target,"+"$$c=$$el.checked?(".concat(a,"):(").concat(o,");")+"if(Array.isArray($$a)){"+"var $$v=".concat(r?"_n("+i+")":i,",")+"$$i=_i($$a,$$v);"+"if($$el.checked){$$i<0&&(".concat(UL(t,"$$a.concat([$$v])"),")}")+"else{$$i>-1&&(".concat(UL(t,"$$a.slice(0,$$i).concat($$a.slice($$i+1))"),")}")+"}else{".concat(UL(t,"$$c"),"}"),null,!0)}(e,r,i);else if("input"===a&&"radio"===o)!function(e,t,n){var r=n&&n.number,i=OL(e,"value")||"null";i=r?"_n(".concat(i,")"):i,SL(e,"checked","_q(".concat(t,",").concat(i,")")),LL(e,"change",UL(t,i),null,!0)}(e,r,i);else if("input"===a||"textarea"===a)!function(e,t,n){var r=e.attrsMap.type,i=n||{},a=i.lazy,o=i.number,s=i.trim,c=!a&&"range"!==r,l=a?"change":"range"===r?$L:"input",u="$event.target.value";s&&(u="$event.target.value.trim()"),o&&(u="_n(".concat(u,")"));var d=UL(t,u);c&&(d="if($event.target.composing)return;".concat(d)),SL(e,"value","(".concat(t,")")),LL(e,l,d,null,!0),(s||o)&&LL(e,"blur","$forceUpdate()")}(e,r,i);else if(!dC.isReservedTag(a))return NL(e,r,i),!1;return!0},text:function(e,t){t.value&&SL(e,"textContent","_s(".concat(t.value,")"),t)},html:function(e,t){t.value&&SL(e,"innerHTML","_s(".concat(t.value,")"),t)}},_P={expectHTML:!0,modules:gP,directives:bP,isPreTag:function(e){return"pre"===e},isUnaryTag:mI,mustUseProp:MR,canBeLeftOpenTag:vI,isReservedTag:GR,getTagNamespace:$R,staticKeys:function(e){return e.reduce((function(e,t){return e.concat(t.staticKeys||[])}),[]).join(",")}(gP)},yP=jS((function(e){return zS("type,tag,attrsList,attrsMap,plain,parent,children,attrs,start,end,rawAttrsMap"+(e?","+e:""))}));function xP(e,t){e&&(mP=yP(t.staticKeys||""),vP=t.isReservedTag||rC,AP(e),wP(e,!1))}function AP(e){if(e.static=function(e){return 2!==e.type&&(3===e.type||!(!e.pre&&(e.hasBindings||e.if||e.for||HS(e.tag)||!vP(e.tag)||function(e){for(;e.parent;){if("template"!==(e=e.parent).tag)return!1;if(e.for)return!0}return!1}(e)||!Object.keys(e).every(mP))))}(e),1===e.type){if(!vP(e.tag)&&"slot"!==e.tag&&null==e.attrsMap["inline-template"])return;for(var t=0,n=e.children.length;t<n;t++){var r=e.children[t];AP(r),r.static||(e.static=!1)}if(e.ifConditions)for(t=1,n=e.ifConditions.length;t<n;t++){var i=e.ifConditions[t].block;AP(i),i.static||(e.static=!1)}}}function wP(e,t){if(1===e.type){if((e.static||e.once)&&(e.staticInFor=t),e.static&&e.children.length&&(1!==e.children.length||3!==e.children[0].type))return void(e.staticRoot=!0);if(e.staticRoot=!1,e.children)for(var n=0,r=e.children.length;n<r;n++)wP(e.children[n],t||!!e.for);if(e.ifConditions)for(n=1,r=e.ifConditions.length;n<r;n++)wP(e.ifConditions[n].block,t)}}var EP=/^([\w$_]+|\([^)]*?\))\s*=>|^function(?:\s+[\w$]+)?\s*\(/,TP=/\([^)]*?\);*$/,SP=/^[A-Za-z_$][\w$]*(?:\.[A-Za-z_$][\w$]*|\['[^']*?']|\["[^"]*?"]|\[\d+]|\[[A-Za-z_$][\w$]*])*$/,CP={esc:27,tab:9,enter:13,space:32,up:38,left:37,right:39,down:40,delete:[8,46]},MP={esc:["Esc","Escape"],tab:"Tab",enter:"Enter",space:[" ","Spacebar"],up:["Up","ArrowUp"],left:["Left","ArrowLeft"],right:["Right","ArrowRight"],down:["Down","ArrowDown"],delete:["Backspace","Delete","Del"]},kP=function(e){return"if(".concat(e,")return null;")},RP={stop:"$event.stopPropagation();",prevent:"$event.preventDefault();",self:kP("$event.target !== $event.currentTarget"),ctrl:kP("!$event.ctrlKey"),shift:kP("!$event.shiftKey"),alt:kP("!$event.altKey"),meta:kP("!$event.metaKey"),left:kP("'button' in $event && $event.button !== 0"),middle:kP("'button' in $event && $event.button !== 1"),right:kP("'button' in $event && $event.button !== 2")};function LP(e,t){var n=t?"nativeOn:":"on:",r="",i="";for(var a in e){var o=OP(e[a]);e[a]&&e[a].dynamic?i+="".concat(a,",").concat(o,","):r+='"'.concat(a,'":').concat(o,",")}return r="{".concat(r.slice(0,-1),"}"),i?n+"_d(".concat(r,",[").concat(i.slice(0,-1),"])"):n+r}function OP(e){if(!e)return"function(){}";if(Array.isArray(e))return"[".concat(e.map((function(e){return OP(e)})).join(","),"]");var t=SP.test(e.value),n=EP.test(e.value),r=SP.test(e.value.replace(TP,""));if(e.modifiers){var i="",a="",o=[],s=function(t){if(RP[t])a+=RP[t],CP[t]&&o.push(t);else if("exact"===t){var n=e.modifiers;a+=kP(["ctrl","shift","alt","meta"].filter((function(e){return!n[e]})).map((function(e){return"$event.".concat(e,"Key")})).join("||"))}else o.push(t)};for(var c in e.modifiers)s(c);o.length&&(i+=function(e){return"if(!$event.type.indexOf('key')&&"+"".concat(e.map(IP).join("&&"),")return null;")}(o)),a&&(i+=a);var l=t?"return ".concat(e.value,".apply(null, arguments)"):n?"return (".concat(e.value,").apply(null, arguments)"):r?"return ".concat(e.value):e.value;return"function($event){".concat(i).concat(l,"}")}return t||n?e.value:"function($event){".concat(r?"return ".concat(e.value):e.value,"}")}function IP(e){var t=parseInt(e,10);if(t)return"$event.keyCode!==".concat(t);var n=CP[e],r=MP[e];return"_k($event.keyCode,"+"".concat(JSON.stringify(e),",")+"".concat(JSON.stringify(n),",")+"$event.key,"+"".concat(JSON.stringify(r))+")"}var PP={on:function(e,t){e.wrapListeners=function(e){return"_g(".concat(e,",").concat(t.value,")")}},bind:function(e,t){e.wrapData=function(n){return"_b(".concat(n,",'").concat(e.tag,"',").concat(t.value,",").concat(t.modifiers&&t.modifiers.prop?"true":"false").concat(t.modifiers&&t.modifiers.sync?",true":"",")")}},cloak:nC},DP=function(e){this.options=e,this.warn=e.warn||EL,this.transforms=TL(e.modules,"transformCode"),this.dataGenFns=TL(e.modules,"genData"),this.directives=eC(eC({},PP),e.directives);var t=e.isReservedTag||rC;this.maybeComponent=function(e){return!!e.component||!t(e.tag)},this.onceId=0,this.staticRenderFns=[],this.pre=!1};function NP(e,t){var n=new DP(t),r=e?"script"===e.tag?"null":UP(e,n):'_c("div")';return{render:"with(this){return ".concat(r,"}"),staticRenderFns:n.staticRenderFns}}function UP(e,t){if(e.parent&&(e.pre=e.pre||e.parent.pre),e.staticRoot&&!e.staticProcessed)return FP(e,t);if(e.once&&!e.onceProcessed)return BP(e,t);if(e.for&&!e.forProcessed)return VP(e,t);if(e.if&&!e.ifProcessed)return zP(e,t);if("template"!==e.tag||e.slotTarget||t.pre){if("slot"===e.tag)return function(e,t){var n=e.slotName||'"default"',r=jP(e,t),i="_t(".concat(n).concat(r?",function(){return ".concat(r,"}"):""),a=e.attrs||e.dynamicAttrs?qP((e.attrs||[]).concat(e.dynamicAttrs||[]).map((function(e){return{name:YS(e.name),value:e.value,dynamic:e.dynamic}}))):null,o=e.attrsMap["v-bind"];return!a&&!o||r||(i+=",null"),a&&(i+=",".concat(a)),o&&(i+="".concat(a?"":",null",",").concat(o)),i+")"}(e,t);var n=void 0;if(e.component)n=function(e,t,n){var r=t.inlineTemplate?null:jP(t,n,!0);return"_c(".concat(e,",").concat(GP(t,n)).concat(r?",".concat(r):"",")")}(e.component,e,t);else{var r=void 0,i=t.maybeComponent(e);(!e.plain||e.pre&&i)&&(r=GP(e,t));var a=void 0,o=t.options.bindings;i&&o&&!1!==o.__isScriptSetup&&(a=function(e,t){var n=YS(t),r=qS(n),i=function(i){return e[t]===i?t:e[n]===i?n:e[r]===i?r:void 0},a=i("setup-const")||i("setup-reactive-const");if(a)return a;var o=i("setup-let")||i("setup-ref")||i("setup-maybe-ref");return o||void 0}(o,e.tag)),a||(a="'".concat(e.tag,"'"));var s=e.inlineTemplate?null:jP(e,t,!0);n="_c(".concat(a).concat(r?",".concat(r):"").concat(s?",".concat(s):"",")")}for(var c=0;c<t.transforms.length;c++)n=t.transforms[c](e,n);return n}return jP(e,t)||"void 0"}function FP(e,t){e.staticProcessed=!0;var n=t.pre;return e.pre&&(t.pre=e.pre),t.staticRenderFns.push("with(this){return ".concat(UP(e,t),"}")),t.pre=n,"_m(".concat(t.staticRenderFns.length-1).concat(e.staticInFor?",true":"",")")}function BP(e,t){if(e.onceProcessed=!0,e.if&&!e.ifProcessed)return zP(e,t);if(e.staticInFor){for(var n="",r=e.parent;r;){if(r.for){n=r.key;break}r=r.parent}return n?"_o(".concat(UP(e,t),",").concat(t.onceId++,",").concat(n,")"):UP(e,t)}return FP(e,t)}function zP(e,t,n,r){return e.ifProcessed=!0,HP(e.ifConditions.slice(),t,n,r)}function HP(e,t,n,r){if(!e.length)return r||"_e()";var i=e.shift();return i.exp?"(".concat(i.exp,")?").concat(a(i.block),":").concat(HP(e,t,n,r)):"".concat(a(i.block));function a(e){return n?n(e,t):e.once?BP(e,t):UP(e,t)}}function VP(e,t,n,r){var i=e.for,a=e.alias,o=e.iterator1?",".concat(e.iterator1):"",s=e.iterator2?",".concat(e.iterator2):"";return e.forProcessed=!0,"".concat(r||"_l","((").concat(i,"),")+"function(".concat(a).concat(o).concat(s,"){")+"return ".concat((n||UP)(e,t))+"})"}function GP(e,t){var n="{",r=function(e,t){var n=e.directives;if(n){var r,i,a,o,s="directives:[",c=!1;for(r=0,i=n.length;r<i;r++){a=n[r],o=!0;var l=t.directives[a.name];l&&(o=!!l(e,a,t.warn)),o&&(c=!0,s+='{name:"'.concat(a.name,'",rawName:"').concat(a.rawName,'"').concat(a.value?",value:(".concat(a.value,"),expression:").concat(JSON.stringify(a.value)):"").concat(a.arg?",arg:".concat(a.isDynamicArg?a.arg:'"'.concat(a.arg,'"')):"").concat(a.modifiers?",modifiers:".concat(JSON.stringify(a.modifiers)):"","},"))}return c?s.slice(0,-1)+"]":void 0}}(e,t);r&&(n+=r+","),e.key&&(n+="key:".concat(e.key,",")),e.ref&&(n+="ref:".concat(e.ref,",")),e.refInFor&&(n+="refInFor:true,"),e.pre&&(n+="pre:true,"),e.component&&(n+='tag:"'.concat(e.tag,'",'));for(var i=0;i<t.dataGenFns.length;i++)n+=t.dataGenFns[i](e);if(e.attrs&&(n+="attrs:".concat(qP(e.attrs),",")),e.props&&(n+="domProps:".concat(qP(e.props),",")),e.events&&(n+="".concat(LP(e.events,!1),",")),e.nativeEvents&&(n+="".concat(LP(e.nativeEvents,!0),",")),e.slotTarget&&!e.slotScope&&(n+="slot:".concat(e.slotTarget,",")),e.scopedSlots&&(n+="".concat(function(e,t,n){var r=e.for||Object.keys(t).some((function(e){var n=t[e];return n.slotTargetDynamic||n.if||n.for||$P(n)})),i=!!e.if;if(!r)for(var a=e.parent;a;){if(a.slotScope&&a.slotScope!==rP||a.for){r=!0;break}a.if&&(i=!0),a=a.parent}var o=Object.keys(t).map((function(e){return WP(t[e],n)})).join(",");return"scopedSlots:_u([".concat(o,"]").concat(r?",null,true":"").concat(!r&&i?",null,false,".concat(function(e){for(var t=5381,n=e.length;n;)t=33*t^e.charCodeAt(--n);return t>>>0}(o)):"",")")}(e,e.scopedSlots,t),",")),e.model&&(n+="model:{value:".concat(e.model.value,",callback:").concat(e.model.callback,",expression:").concat(e.model.expression,"},")),e.inlineTemplate){var a=function(e,t){var n=e.children[0];if(n&&1===n.type){var r=NP(n,t.options);return"inlineTemplate:{render:function(){".concat(r.render,"},staticRenderFns:[").concat(r.staticRenderFns.map((function(e){return"function(){".concat(e,"}")})).join(","),"]}")}}(e,t);a&&(n+="".concat(a,","))}return n=n.replace(/,$/,"")+"}",e.dynamicAttrs&&(n="_b(".concat(n,',"').concat(e.tag,'",').concat(qP(e.dynamicAttrs),")")),e.wrapData&&(n=e.wrapData(n)),e.wrapListeners&&(n=e.wrapListeners(n)),n}function $P(e){return 1===e.type&&("slot"===e.tag||e.children.some($P))}function WP(e,t){var n=e.attrsMap["slot-scope"];if(e.if&&!e.ifProcessed&&!n)return zP(e,t,WP,"null");if(e.for&&!e.forProcessed)return VP(e,t,WP);var r=e.slotScope===rP?"":String(e.slotScope),i="function(".concat(r,"){")+"return ".concat("template"===e.tag?e.if&&n?"(".concat(e.if,")?").concat(jP(e,t)||"undefined",":undefined"):jP(e,t)||"undefined":UP(e,t),"}"),a=r?"":",proxy:true";return"{key:".concat(e.slotTarget||'"default"',",fn:").concat(i).concat(a,"}")}function jP(e,t,n,r,i){var a=e.children;if(a.length){var o=a[0];if(1===a.length&&o.for&&"template"!==o.tag&&"slot"!==o.tag){var s=n?t.maybeComponent(o)?",1":",0":"";return"".concat((r||UP)(o,t)).concat(s)}var c=n?function(e,t){for(var n=0,r=0;r<e.length;r++){var i=e[r];if(1===i.type){if(XP(i)||i.ifConditions&&i.ifConditions.some((function(e){return XP(e.block)}))){n=2;break}(t(i)||i.ifConditions&&i.ifConditions.some((function(e){return t(e.block)})))&&(n=1)}}return n}(a,t.maybeComponent):0,l=i||YP;return"[".concat(a.map((function(e){return l(e,t)})).join(","),"]").concat(c?",".concat(c):"")}}function XP(e){return void 0!==e.for||"template"===e.tag||"slot"===e.tag}function YP(e,t){return 1===e.type?UP(e,t):3===e.type&&e.isComment?function(e){return"_e(".concat(JSON.stringify(e.text),")")}(e):"_v(".concat(2===(n=e).type?n.expression:KP(JSON.stringify(n.text)),")");var n}function qP(e){for(var t="",n="",r=0;r<e.length;r++){var i=e[r],a=KP(i.value);i.dynamic?n+="".concat(i.name,",").concat(a,","):t+='"'.concat(i.name,'":').concat(a,",")}return t="{".concat(t.slice(0,-1),"}"),n?"_d(".concat(t,",[").concat(n.slice(0,-1),"])"):t}function KP(e){return e.replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029")}function ZP(e,t){try{return new Function(e)}catch(n){return t.push({err:n,code:e}),nC}}function JP(e){var t=Object.create(null);return function(n,r,i){(r=eC({},r)).warn,delete r.warn;var a=r.delimiters?String(r.delimiters)+n:n;if(t[a])return t[a];var o=e(n,r),s={},c=[];return s.render=ZP(o.render,c),s.staticRenderFns=o.staticRenderFns.map((function(e){return ZP(e,c)})),t[a]=s}}new RegExp("\\b"+"do,if,for,let,new,try,var,case,else,with,await,break,catch,class,const,super,throw,while,yield,delete,export,import,return,switch,default,extends,finally,continue,debugger,function,arguments".split(",").join("\\b|\\b")+"\\b"),new RegExp("\\b"+"delete,typeof,void".split(",").join("\\s*\\([^\\)]*\\)|\\b")+"\\s*\\([^\\)]*\\)");var QP,eD=function(e){function t(t,n){var r=Object.create(e),i=[],a=[];if(n)for(var o in n.modules&&(r.modules=(e.modules||[]).concat(n.modules)),n.directives&&(r.directives=eC(Object.create(e.directives||null),n.directives)),n)"modules"!==o&&"directives"!==o&&(r[o]=n[o]);r.warn=function(e,t,n){(n?a:i).push(e)};var s=function(e,t){var n=aP(e.trim(),t);!1!==t.optimize&&xP(n,t);var r=NP(n,t);return{ast:n,render:r.render,staticRenderFns:r.staticRenderFns}}(t.trim(),r);return s.errors=i,s.tips=a,s}return{compile:t,compileToFunctions:JP(t)}},tD=eD(_P).compileToFunctions;function nD(e){return(QP=QP||document.createElement("div")).innerHTML=e?'<a href="\n"/>':'<div a="\n"/>',QP.innerHTML.indexOf("&#10;")>0}var rD=!!gC&&nD(!1),iD=!!gC&&nD(!0),aD=jS((function(e){var t=XR(e);return t&&t.innerHTML})),oD=bR.prototype.$mount;function sD(e,t,n,r,i,a,o){try{var s=e[a](o),c=s.value}catch(e){return void n(e)}s.done?t(c):Promise.resolve(c).then(r,i)}function cD(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var a=e.apply(t,n);function o(e){sD(a,r,i,o,s,"next",e)}function s(e){sD(a,r,i,o,s,"throw",e)}o(void 0)}))}}function lD(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function uD(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){lD(e,t,n[t])}))}return e}bR.prototype.$mount=function(e,t){if((e=e&&XR(e))===document.body||e===document.documentElement)return this;var n=this.$options;if(!n.render){var r=n.template;if(r)if("string"==typeof r)"#"===r.charAt(0)&&(r=aD(r));else{if(!r.nodeType)return this;r=r.innerHTML}else e&&(r=function(e){if(e.outerHTML)return e.outerHTML;var t=document.createElement("div");return t.appendChild(e.cloneNode(!0)),t.innerHTML}(e));if(r){var i=tD(r,{outputSourceRange:!1,shouldDecodeNewlines:rD,shouldDecodeNewlinesForHref:iD,delimiters:n.delimiters,comments:n.comments},this),a=i.render,o=i.staticRenderFns;n.render=a,n.staticRenderFns=o}}return oD.call(this,e,t)},bR.compile=tD,bR.filter("kebab",(function(e){var t=function(e){return e.toLowerCase().replace(/ /g,"-")};return Array.isArray(e)?e.map(t):t(e)}));var dD={props:["node","editor","bindSocket","bindControl"],methods:{inputs:function(){return Array.from(this.node.inputs.values())},outputs:function(){return Array.from(this.node.outputs.values())},controls:function(){return Array.from(this.node.controls.values())},selected:function(){return this.editor.selected.contains(this.node)?"selected":""}},directives:{socket:{bind:function(e,t,n){n.context.bindSocket(e,t.arg,t.value)},update:function(e,t,n){n.context.bindSocket(e,t.arg,t.value)}},control:{bind:function(e,t,n){t.value&&n.context.bindControl(e,t.value)}}}},fD=function(e,t,n,r,i,a,o,s,c,l){"boolean"!=typeof o&&(c=s,s=o,o=!1);var u,d="function"==typeof n?n.options:n;if(e&&e.render&&(d.render=e.render,d.staticRenderFns=e.staticRenderFns,d._compiled=!0,i&&(d.functional=!0)),r&&(d._scopeId=r),a?(u=function(e){(e=e||this.$vnode&&this.$vnode.ssrContext||this.parent&&this.parent.$vnode&&this.parent.$vnode.ssrContext)||"undefined"==typeof __VUE_SSR_CONTEXT__||(e=__VUE_SSR_CONTEXT__),t&&t.call(this,c(e)),e&&e._registeredComponents&&e._registeredComponents.add(a)},d._ssrRegister=u):t&&(u=o?function(){t.call(this,l(this.$root.$options.shadowRoot))}:function(e){t.call(this,s(e))}),u)if(d.functional){var f=d.render;d.render=function(e,t){return u.call(t),f(e,t)}}else{var h=d.beforeCreate;d.beforeCreate=h?[].concat(h,u):[u]}return n},hD="undefined"!=typeof navigator&&/msie [6-9]\\b/.test(navigator.userAgent.toLowerCase()),pD=document.head||document.getElementsByTagName("head")[0],mD={},vD=function(e){return function(e,t){return function(e,t){var n=hD?t.media||"default":e,r=mD[n]||(mD[n]={ids:new Set,styles:[]});if(!r.ids.has(e)){r.ids.add(e);var i=t.source;if(t.map&&(i+="\n/*# sourceURL="+t.map.sources[0]+" */",i+="\n/*# sourceMappingURL=data:application/json;base64,"+btoa(unescape(encodeURIComponent(JSON.stringify(t.map))))+" */"),r.element||(r.element=document.createElement("style"),r.element.type="text/css",t.media&&r.element.setAttribute("media",t.media),pD.appendChild(r.element)),"styleSheet"in r.element)r.styles.push(i),r.element.styleSheet.cssText=r.styles.filter(Boolean).join("\n");else{var a=r.ids.size-1,o=document.createTextNode(i),s=r.element.childNodes;s[a]&&r.element.removeChild(s[a]),s.length?r.element.insertBefore(o,s[a]):r.element.appendChild(o)}}}(e,t)}};var gD=function(){var e=this,t=e.$createElement;return(e._self._c||t)("div",{staticClass:"socket",class:e._f("kebab")([e.type,e.socket.name]),attrs:{title:e.socket.name}})};gD._withStripped=!0;var bD=fD({render:gD,staticRenderFns:[]},(function(e){e&&e("data-v-1d52cca4_0",{source:".socket[data-v-1d52cca4] {\n  display: inline-block;\n  cursor: pointer;\n  border: 1px solid white;\n  border-radius: 12px;\n  width: 24px;\n  height: 24px;\n  margin: 6px;\n  vertical-align: middle;\n  background: #96b38a;\n  z-index: 2;\n  box-sizing: border-box;\n}\n.socket[data-v-1d52cca4]:hover {\n    border-width: 4px;\n}\n.socket.multiple[data-v-1d52cca4] {\n    border-color: yellow;\n}\n.socket.output[data-v-1d52cca4] {\n    margin-right: -12px;\n}\n.socket.input[data-v-1d52cca4] {\n    margin-left: -12px;\n}\n\n/*# sourceMappingURL=Socket.vue.map */",map:{version:3,sources:["/home/ni55an/Workflow/retejs/_issues/retejs-react-render-forked/src/vue-render-plugin/src/Socket.vue","Socket.vue"],names:[],mappings:"AAgBA;EACA,qBAAA;EACA,eAAA;EACA,uBAAA;EACA,mBAAA;EACA,WAAA;EACA,YAAA;EACA,WAAA;EACA,sBAAA;EACA,mBAAA;EACA,UAAA;EACA,sBAAA;AAAA;AAXA;IAaA,iBAAA;AAAA;AAbA;IAeA,oBAAA;AAAA;AAfA;IAiBA,mBAAA;AAAA;AAjBA;IAmBA,kBAAA;AAAA;;ACdA,qCAAqC",file:"Socket.vue",sourcesContent:['<template lang="pug">\n.socket(\n  :class="[type, socket.name] | kebab",\n  :title="socket.name"\n)\n</template>\n\n<script>\nexport default {\n  props: [\'type\', \'socket\']\n}\n<\/script>\n\n<style lang="sass" scoped>\n@import "./vars"\n\n.socket\n  display: inline-block\n  cursor: pointer\n  border: 1px solid white\n  border-radius: $socket-size/2.0\n  width: $socket-size\n  height: $socket-size\n  margin: $socket-margin\n  vertical-align: middle\n  background: $socket-color\n  z-index: 2\n  box-sizing: border-box\n  &:hover\n    border-width: 4px\n  &.multiple\n    border-color: yellow\n  &.output\n    margin-right: - $socket-size / 2\n  &.input\n    margin-left: - $socket-size / 2\n</style>\n',".socket {\n  display: inline-block;\n  cursor: pointer;\n  border: 1px solid white;\n  border-radius: 12px;\n  width: 24px;\n  height: 24px;\n  margin: 6px;\n  vertical-align: middle;\n  background: #96b38a;\n  z-index: 2;\n  box-sizing: border-box; }\n  .socket:hover {\n    border-width: 4px; }\n  .socket.multiple {\n    border-color: yellow; }\n  .socket.output {\n    margin-right: -12px; }\n  .socket.input {\n    margin-left: -12px; }\n\n/*# sourceMappingURL=Socket.vue.map */"]},media:void 0})}),{props:["type","socket"]},"data-v-1d52cca4",!1,void 0,vD,void 0);const _D={mixins:[dD],components:{Socket:bD}};var yD=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"node",class:e._f("kebab")([e.selected(),e.node.name])},[n("div",{staticClass:"title"},[e._v(e._s(e.node.name))]),e._l(e.outputs(),(function(t){return n("div",{key:t.key,staticClass:"output"},[n("div",{staticClass:"output-title"},[e._v(e._s(t.name))]),n("Socket",{directives:[{name:"socket",rawName:"v-socket:output",value:t,expression:"output",arg:"output"}],attrs:{type:"output",socket:t.socket}})],1)})),e._l(e.controls(),(function(e){return n("div",{directives:[{name:"control",rawName:"v-control",value:e,expression:"control"}],key:e.key,staticClass:"control"})})),e._l(e.inputs(),(function(t){return n("div",{key:t.key,staticClass:"input"},[n("Socket",{directives:[{name:"socket",rawName:"v-socket:input",value:t,expression:"input",arg:"input"}],attrs:{type:"input",socket:t.socket}}),n("div",{directives:[{name:"show",rawName:"v-show",value:!t.showControl(),expression:"!input.showControl()"}],staticClass:"input-title"},[e._v(e._s(t.name))]),n("div",{directives:[{name:"show",rawName:"v-show",value:t.showControl(),expression:"input.showControl()"},{name:"control",rawName:"v-control",value:t.control,expression:"input.control"}],staticClass:"input-control"})],1)}))],2)};yD._withStripped=!0;var xD=fD({render:yD,staticRenderFns:[]},(function(e){e&&e("data-v-61501374_0",{source:".node[data-v-61501374] {\n  background: rgba(110, 136, 255, 0.8);\n  border: 2px solid #4e58bf;\n  border-radius: 10px;\n  cursor: pointer;\n  min-width: 180px;\n  height: auto;\n  padding-bottom: 6px;\n  box-sizing: content-box;\n  position: relative;\n  user-select: none;\n}\n.node[data-v-61501374]:hover {\n    background: rgba(130, 153, 255, 0.8);\n}\n.node.selected[data-v-61501374] {\n    background: #ffd92c;\n    border-color: #e3c000;\n}\n.node .title[data-v-61501374] {\n    color: white;\n    font-family: sans-serif;\n    font-size: 18px;\n    padding: 8px;\n}\n.node .output[data-v-61501374] {\n    text-align: right;\n}\n.node .input[data-v-61501374] {\n    text-align: left;\n}\n.node .input-title[data-v-61501374], .node .output-title[data-v-61501374] {\n    vertical-align: middle;\n    color: white;\n    display: inline-block;\n    font-family: sans-serif;\n    font-size: 14px;\n    margin: 6px;\n    line-height: 24px;\n}\n.node .input-control[data-v-61501374] {\n    z-index: 1;\n    width: calc(100% - 36px);\n    vertical-align: middle;\n    display: inline-block;\n}\n.node .control[data-v-61501374] {\n    padding: 6px 18px;\n}\n\n/*# sourceMappingURL=Node.vue.map */",map:{version:3,sources:["/home/ni55an/Workflow/retejs/_issues/retejs-react-render-forked/src/vue-render-plugin/src/Node.vue","Node.vue"],names:[],mappings:"AAyCA;EACA,oCAAA;EACA,yBAAA;EACA,mBAAA;EACA,eAAA;EACA,gBAAA;EACA,YAAA;EACA,mBAAA;EACA,uBAAA;EACA,kBAAA;EACA,iBAAA;AAAA;AAVA;IAYA,oCAAA;AAAA;AAZA;IAcA,mBAAA;IACA,qBAAA;AAAA;AAfA;IAiBA,YAAA;IACA,uBAAA;IACA,eAAA;IACA,YAAA;AAAA;AApBA;IAsBA,iBAAA;AAAA;AAtBA;IAwBA,gBAAA;AAAA;AAxBA;IA0BA,sBAAA;IACA,YAAA;IACA,qBAAA;IACA,uBAAA;IACA,eAAA;IACA,WAAA;IACA,iBAAA;AAAA;AAhCA;IAkCA,UAAA;IACA,wBAAA;IACA,sBAAA;IACA,qBAAA;AAAA;AArCA;IAuCA,iBAAA;AAAA;;ACvCA,mCAAmC",file:"Node.vue",sourcesContent:['<template lang="pug">\n.node(:class="[selected(), node.name] | kebab")\n  .title {{node.name}}\n\n  // Outputs\n  .output(v-for=\'output in outputs()\' :key="output.key")\n    .output-title {{output.name}}\n    Socket(v-socket:output="output", type="output", :socket="output.socket")\n\n  // Controls\n  .control(\n    v-for=\'control in controls()\',\n    :key="control.key",\n    v-control="control"\n  )\n\n  // Inputs\n  .input(v-for=\'input in inputs()\' :key="input.key")\n    Socket(v-socket:input="input", type="input", :socket="input.socket")\n    .input-title(v-show=\'!input.showControl()\') {{input.name}}\n    .input-control(\n      v-show=\'input.showControl()\'\n      v-control="input.control"\n    )\n</template>\n\n<script>\nimport mixin from \'./mixin\';\nimport Socket from \'./Socket.vue\';\n\nexport default {\n  mixins: [mixin],\n  components: {\n    Socket\n  }\n}\n<\/script>\n\n<style lang="sass" scoped>\n@import "./vars"\n\n.node\n  background: $node-color\n  border: 2px solid #4e58bf\n  border-radius: 10px\n  cursor: pointer\n  min-width: $node-width\n  height: auto\n  padding-bottom: 6px\n  box-sizing: content-box\n  position: relative\n  user-select: none\n  &:hover\n    background: lighten($node-color,4%)\n  &.selected\n    background: $node-color-selected\n    border-color: #e3c000\n  .title\n    color: white\n    font-family: sans-serif\n    font-size: 18px\n    padding: 8px\n  .output\n    text-align: right\n  .input\n    text-align: left\n  .input-title,.output-title\n    vertical-align: middle\n    color: white\n    display: inline-block\n    font-family: sans-serif\n    font-size: 14px\n    margin: $socket-margin\n    line-height: $socket-size\n  .input-control\n    z-index: 1\n    width: calc(100% - #{$socket-size + 2*$socket-margin})\n    vertical-align: middle\n    display: inline-block\n  .control\n    padding: $socket-margin $socket-size/2 + $socket-margin\n</style>',".node {\n  background: rgba(110, 136, 255, 0.8);\n  border: 2px solid #4e58bf;\n  border-radius: 10px;\n  cursor: pointer;\n  min-width: 180px;\n  height: auto;\n  padding-bottom: 6px;\n  box-sizing: content-box;\n  position: relative;\n  user-select: none; }\n  .node:hover {\n    background: rgba(130, 153, 255, 0.8); }\n  .node.selected {\n    background: #ffd92c;\n    border-color: #e3c000; }\n  .node .title {\n    color: white;\n    font-family: sans-serif;\n    font-size: 18px;\n    padding: 8px; }\n  .node .output {\n    text-align: right; }\n  .node .input {\n    text-align: left; }\n  .node .input-title, .node .output-title {\n    vertical-align: middle;\n    color: white;\n    display: inline-block;\n    font-family: sans-serif;\n    font-size: 14px;\n    margin: 6px;\n    line-height: 24px; }\n  .node .input-control {\n    z-index: 1;\n    width: calc(100% - 36px);\n    vertical-align: middle;\n    display: inline-block; }\n  .node .control {\n    padding: 6px 18px; }\n\n/*# sourceMappingURL=Node.vue.map */"]},media:void 0})}),_D,"data-v-61501374",!1,void 0,vD,void 0);function AD(e,t,n){var r=new bR(uD({render:function(e){return e(t,{props:n})}},arguments.length>3&&void 0!==arguments[3]?arguments[3]:{})),i=document.createElement("div");return e.appendChild(i),r.$mount(i),r}var wD=function(e){return new Promise((function(t){if(!e.vueContext)return t();e.vueContext.$forceUpdate(),e.vueContext.$nextTick(t)}))},ED={name:"vue-render",install:function(e,t){var n=t.component,r=t.options;e.on("rendernode",(function(t){var i=t.el,a=t.node,o=t.component,s=t.bindSocket,c=t.bindControl;o.render&&"vue"!==o.render||(a._vue=function(e,t,n,r){var i=n.node,a=n.component,o=n.bindSocket,s=n.bindControl,c=AD(n.el,a.component||t||xD,uD({},a.props,{node:i,editor:e,bindSocket:o,bindControl:s}),r);return i.vueContext=c.$children[0],c}(e,n,{el:i,node:a,component:o,bindSocket:s,bindControl:c},r),a.update=cD(regeneratorRuntime.mark((function e(){return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,wD(a);case 2:return e.abrupt("return",e.sent);case 3:case"end":return e.stop()}}),e)}))))})),e.on("rendercontrol",(function(e){var t=e.el,n=e.control;n.render&&"vue"!==n.render||(n._vue=function(e,t,n){var r=t.control,i=AD(t.el,r.component,uD({},r.props,{getData:r.getData.bind(r),putData:r.putData.bind(r)}),n);return r.vueContext=i.$children[0],i}(0,{el:t,control:n},r),n.update=cD(regeneratorRuntime.mark((function e(){return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,wD(n);case 2:return e.abrupt("return",e.sent);case 3:case"end":return e.stop()}}),e)}))))})),e.on("connectioncreated connectionremoved",(function(e){wD(e.output.node),wD(e.input.node)}));var i=[];e.on("nodeselected",(function(t){var n,r=function(e){if(Array.isArray(e)){for(var t=0,n=new Array(e.length);t<e.length;t++)n[t]=e[t];return n}}(n=e.selected.list)||function(e){if(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e))return Array.from(e)}(n)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}();i.filter((function(e){return!r.includes(e)})).forEach(wD),wD(t),i=r}))},mixin:dD,Node:xD,Socket:bD},TD={randomUUID:"undefined"!=typeof crypto&&crypto.randomUUID&&crypto.randomUUID.bind(crypto)};let SD;const CD=new Uint8Array(16);function MD(){if(!SD&&(SD="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!SD))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return SD(CD)}const kD=[];for(let e=0;e<256;++e)kD.push((e+256).toString(16).slice(1));var RD=function(e,t,n){if(TD.randomUUID&&!t&&!e)return TD.randomUUID();const r=(e=e||{}).random||(e.rng||MD)();if(r[6]=15&r[6]|64,r[8]=63&r[8]|128,t){n=n||0;for(let e=0;e<16;++e)t[n+e]=r[e];return t}return function(e,t=0){return(kD[e[t+0]]+kD[e[t+1]]+kD[e[t+2]]+kD[e[t+3]]+"-"+kD[e[t+4]]+kD[e[t+5]]+"-"+kD[e[t+6]]+kD[e[t+7]]+"-"+kD[e[t+8]]+kD[e[t+9]]+"-"+kD[e[t+10]]+kD[e[t+11]]+kD[e[t+12]]+kD[e[t+13]]+kD[e[t+14]]+kD[e[t+15]]).toLowerCase()}(r)},LD=function(){var e=this,t=e._self._c;return t("div",{ref:"node",staticClass:"node",class:[e.selected(),e.node.type],attrs:{title:e.node.name}},["source"!==e.node.type?t("div",{staticClass:"mx-3 mb-3 text-center"},[t("div",{staticClass:"d-flex justify-content-between align-items-center"},[t("strong",[e._v(e._s(e.node.name))]),e._v(" "),t("div",{staticClass:"dropdown ml-4",on:{pointerdown:function(e){e.stopPropagation()}}},[t("button",{staticClass:"btn btn-sm dropdown-btn",attrs:{type:"button","data-toggle":"dropdown","data-display":"static",title:e.executionProfile}},[t("i",{class:e.getExecutionProfileIcon(e.executionProfile)})]),e._v(" "),t("div",{staticClass:"dropdown-menu m-0 p-0"},[t("div",{staticClass:"dropdown-header text-default px-2 py-1"},[e._v("Execution profile")]),e._v(" "),t("div",{staticClass:"dropdown-divider my-0"}),e._v(" "),e._l(e.executionProfiles,(function(n){return t("button",{key:n,staticClass:"dropdown-item px-2",class:{active:n===e.executionProfile},attrs:{type:"button"},on:{click:function(t){return e.updateExecutionProfile(n)}}},[t("small",[t("i",{class:e.getExecutionProfileIcon(n)}),e._v(" "+e._s(n)+"\n            ")])])}))],2)])])]):e._e(),e._v(" "),t("div",{staticClass:"content"},[e.node.inputs.size>0?t("div",{staticClass:"column"},e._l(e.inputs(),(function(n){return t("div",{key:n.key,staticClass:"input"},[t("socket",{directives:[{name:"socket",rawName:"v-socket:input",value:n,expression:"input",arg:"input"}],attrs:{type:"input",title:n.name,editor:e.editor,socket:n.socket,used:n.connections.length>0,multi:n.multipleConnections}}),e._v(" "),t("span",{attrs:{title:n.name}},[e._v("\n          "+e._s(n.name)+" "),n.required?t("strong",[e._v("*")]):e._e()])],1)})),0):e._e(),e._v(" "),e.node.controls.size>0?t("div",{staticClass:"column"},e._l(e.controls(),(function(n){return t("div",{key:n.key,staticClass:"control"},[n.title?t("div",{staticClass:"form-row d-flex align-items-center"},[t("div",{staticClass:"col-auto title",attrs:{title:n.title}},[t("span",{staticClass:"ws-normal"},[e._v(e._s(n.title))])]),e._v(" "),t("div",{directives:[{name:"control",rawName:"v-control",value:n,expression:"control"}],staticClass:"col-auto"})]):t("div",{directives:[{name:"control",rawName:"v-control",value:n,expression:"control"}]})])})),0):e._e(),e._v(" "),e.node.outputs.size>0?t("div",{staticClass:"column"},e._l(e.outputs(),(function(n){return t("div",{key:n.key,staticClass:"output"},[t("span",{attrs:{title:n.name}},[e._v(e._s(n.name))]),e._v(" "),t("socket",{directives:[{name:"socket",rawName:"v-socket:output",value:n,expression:"output",arg:"output"}],attrs:{type:"output",editor:e.editor,socket:n.socket,used:n.connections.length>0,multi:n.multipleConnections}})],1)})),0):e._e()]),e._v(" "),e.validationClass?t("div",{staticClass:"validation",class:e.validationClass,style:{width:`${e.nodeWidth}px`}},[e._v("\n    "+e._s(e.validationMessage)+"\n  ")]):e._e()])};LD._withStripped=!0;var OD=function(){var e=this,t=e._self._c;return t("div",{staticClass:"socket",class:[e.type,e.socket.name,e.used?"used":"",e.compatible?"":"incompatible"],on:{mouseenter:function(t){return t.stopPropagation(),e.mouseenter.apply(null,arguments)},mouseleave:function(t){return t.stopPropagation(),e.mouseleave.apply(null,arguments)}}},[e.multi?t("div",[e._v("+")]):e._e()])};OD._withStripped=!0;var ID={extends:ED.Socket,data(){return{id:kadi.utils.randomAlnum(),compatible:!0}},props:{editor:Object,used:Boolean,multi:Boolean},methods:{mouseenter(){this.editor.trigger("socketenter",{id:this.id,socket:this.socket,type:this.type})},mouseleave(){this.editor.trigger("socketleave")}},mounted(){this.editor.on("socketenter",(({id:e,socket:t,type:n})=>{this.id===e?this.compatible=!0:this.type===n?this.compatible=!1:"input"===this.type?this.compatible=t.compatibleWith(this.socket):this.compatible=this.socket.compatibleWith(t)})),this.editor.on("socketleave",(()=>this.compatible=!0))}},PD=ID,DD=(n(5515),hc(PD,OD,[],!1,null,"25150d6f",null).exports),ND={mixins:[ED.mixin],components:{Socket:DD},data(){return{nodeWidth:0,executionProfile:this.node.executionProfile,executionProfileIcons:{Default:"fa-solid fa-play",Skip:"fa-solid fa-ban",Detached:"fa-solid fa-link-slash"},validationStateClasses:{info:"bg-info",success:"bg-success",warning:"bg-warning",danger:"bg-danger"}}},props:{executionProfiles:Array,validationState:{type:String,default:null},validationMessage:{type:String,default:null}},computed:{validationClass(){return this.validationState in this.validationStateClasses?this.validationStateClasses[this.validationState]:""}},methods:{getExecutionProfileIcon(e){return this.executionProfileIcons[e]||"fa-solid fa-question"},updateExecutionProfile(e){this.executionProfile!==e&&(this.executionProfile=this.node.executionProfile=e,this.editor.trigger("unsavedchanges"))}},mounted(){for(const e of this.controls()){e.vueContext.$on("change-value",(()=>this.editor.trigger("controlchanged",e)));for(const[t,n]of Object.entries(e.events))this.editor.on(t,n)}this.$nextTick((()=>{this.nodeWidth=this.$refs.node.getBoundingClientRect().width}))}},UD=(n(6162),hc(ND,LD,[],!1,null,"29f7742a",null).exports);const FD={str:new xg.Socket("str"),int:new xg.Socket("int"),float:new xg.Socket("float"),bool:new xg.Socket("bool"),dep:new xg.Socket("dep"),pipe:new xg.Socket("pipe"),env:new xg.Socket("env")},BD={str:["int","float","bool"],int:["str","float"],float:["str","int"],bool:["str"],pipe:["str","int","float","bool"]};for(const[e,t]of Object.entries(BD))for(const n of t)FD[e].combineWith(FD[n]);const zD={dep:{key:"dependency",title:"Dependencies",socket:FD.dep,multi:!0},pipe:{key:"pipe",title:"stdin",socket:FD.pipe},env:{key:"env",title:"env",socket:FD.env}},HD={dep:{key:"dependency",title:"Dependents",socket:FD.dep,multi:!0},pipe:{key:"pipe",title:"stdout",socket:FD.pipe},env:{key:"env",title:"env",socket:FD.env}},VD=["Default","Skip","Detached"],GD=[zD.dep.key,zD.pipe.key,zD.env.key];class $D extends xg.Component{constructor(e,t){super(e),this.data.component=UD,this.data.props={executionProfiles:VD},this.type=t}static makeInput(e){const t=e.title||kadi.utils.capitalize(e.key),n=e.socket||FD.str,r=e.multi||!1,i=new xg.Input(e.key,t,n,r);return i.required=e.required||!1,i}static makeOutput(e){const t=e.title||kadi.utils.capitalize(e.key),n=e.socket||FD.str,r=e.multi||!1;return new xg.Output(e.key,t,n,r)}builder(e){if(e.type=this.type,"number"==typeof e.id&&(e.id=`{${RD()}}`),e.data._meta){for(const[t,n]of Object.entries(e.data._meta))e[t]=n;delete e.data._meta}e.executionProfile||(e.executionProfile=VD[0])}fromFlow(e){return{id:e.id,name:e.model.name,data:{_meta:{executionProfile:e.model.executionProfile}},inputs:new Map,outputs:new Map,position:[e.position.x,e.position.y]}}toFlow(e){return{id:e.id,model:{name:e.name,executionProfile:e.executionProfile},position:{x:e.position[0],y:e.position[1]}}}}class WD extends $D{constructor(e,t,n=null,r=[],i=[],a={}){super(e,t),this.data.props={...this.data.props,...a},this.menu=n,this.inputs=r,this.outputs=i}builder(e){super.builder(e);for(const t of this.inputs)e.addInput(WD.makeInput(t));for(const t of this.outputs)e.addOutput(WD.makeOutput(t))}fromFlow(e){const t=super.fromFlow(e);for(const e of this.inputs)t.inputs.set(e.key,{connections:[]});for(const e of this.outputs)t.outputs.set(e.key,{connections:[]});return t}}class jD extends $D{constructor(e){super(jD.nameFromTool(e),e.type),this.tool=e}static nameFromTool(e){return null!==e.version?`${e.name} ${e.version}`:e.name}static toolFromFlow(e){const t=e.model.tool,n={type:"ToolNode"===e.model.name?"program":"env",name:t.name,version:t.version,path:t.path,params:[]};for(const t of e.model.tool.ports)if(!GD.includes(t.type)){const e={name:t.name,char:t.shortName,type:t.type,required:t.required||!1};n.params.push(e)}return n}static inputFromParam(e,t){const n=e.name||`arg${t}`;let r=null,i=null;switch(e.type){case"string":r=`String: ${n}`,i=FD.str;break;case"int":case"long":r=`Integer: ${n}`,i=FD.int;break;case"float":case"real":r=`Float: ${n}`,i=FD.float;break;case"bool":case"flag":r=`Boolean: ${n}`,i=FD.bool;break;default:r=`${kadi.utils.capitalize(e.type)}: ${n}`,i=FD.str}const a=$D.makeInput({key:`in${t}`,title:r,socket:i,required:e.required});return a.param=e,a}static makeFlowPort(e,t,n){return e.param?{name:e.param.name,shortName:e.param.char,type:e.param.type,required:e.param.required,port_direction:t,port_index:n}:{name:e.name,shortName:null,type:e.key,required:!1,port_direction:t,port_index:n}}builder(e){super.builder(e),"program"===this.type&&e.addInput(jD.makeInput(zD.dep));for(let t=0;t<this.tool.params.length;t++)e.addInput(jD.inputFromParam(this.tool.params[t],t));"program"===this.type&&(e.addInput(jD.makeInput(zD.env)),e.addInput(jD.makeInput(zD.pipe))),"program"===this.type?(e.addOutput(jD.makeOutput(HD.dep)),e.addOutput(jD.makeOutput(HD.pipe))):"env"===this.type&&e.addOutput(jD.makeOutput(HD.env))}fromFlow(e){const t=super.fromFlow(e);t.name=jD.nameFromTool(e.model.tool);let n=0;for(const r of e.model.tool.ports)"in"===r.port_direction?GD.includes(r.type)?t.inputs.set(r.type,{connections:[]}):t.inputs.set("in"+n++,{connections:[]}):t.outputs.set(r.type,{connections:[]});return t}toFlow(e){const t=super.toFlow(e);t.model.name="program"===this.type?"ToolNode":"EnvNode",t.model.tool={name:this.tool.name,version:this.tool.version,path:this.tool.path||this.tool.name,ports:[]};let n=e.inputs.values();for(let r=0;r<e.inputs.size;r++){const e=n.next().value,i=jD.makeFlowPort(e,"in",r);t.model.tool.ports.push(i)}n=e.outputs.values();for(let r=0;r<e.outputs.size;r++){const e=n.next().value,i=jD.makeFlowPort(e,"out",r);t.model.tool.ports.push(i)}return t}}class XD extends xg.NodeEditor{constructor(e,t){super(e,t),this.bind("controlchanged"),this.bind("socketenter"),this.bind("socketleave"),this.bind("unsavedchanges"),this.on("click",(()=>{this.selected.clear(),this.nodes.map((e=>e.update()))})),this.on("zoom",(({source:e})=>"dblclick"!==e)),this.on("nodeselected",(e=>{const t=this.view.nodes.get(e).el,n=t.parentElement;n.lastElementChild!==t&&n.lastElementChild.after(t)}))}static iterValueAt(e,t){let n=t;for(const t of e)if(--n<0)return t;return null}fromFlow(e){const t={id:e.id||this.id,nodes:{}};let n=null;for(const r of e.nodes){if(["ToolNode","EnvNode"].includes(r.model.name)){const e=jD.nameFromTool(r.model.tool);if(!this.components.has(e)){const e=jD.toolFromFlow(r);this.register(new jD(e))}n=this.components.get(e).fromFlow(r)}else{const e=this.components.get(r.model.name);if(!e)continue;n=e.fromFlow(r)}t.nodes[r.id]=n}for(const n of e.connections){const e=t.nodes[n.out_id],r=t.nodes[n.in_id];if(e&&r){const t=XD.iterValueAt(e.outputs.keys(),n.out_index),i=XD.iterValueAt(r.inputs.keys(),n.in_index),a=e.outputs.get(t),o=r.inputs.get(i);a&&o&&(a.connections.push({node:r.id,input:i,data:{}}),o.connections.push({node:e.id,output:t,data:{}}))}}for(const e in t.nodes)t.nodes[e].outputs=Object.fromEntries(t.nodes[e].outputs),t.nodes[e].inputs=Object.fromEntries(t.nodes[e].inputs);return this.fromJSON(t)}toFlow(){const e={id:this.id,connections:[],nodes:[]};for(const t of this.nodes){const n=this.components.get(t.name).toFlow(t),r=t.outputs.values();for(let n=0;n<t.outputs.size;n++){const i=r.next().value;for(const r of i.connections){const i=[...r.input.node.inputs.keys()],a={in_id:r.input.node.id,in_index:i.findIndex((e=>e===r.input.key)),out_id:t.id,out_index:n};e.connections.push(a)}}e.nodes.push(n)}return e}}var YD=function(){var e=this,t=e._self._c;return e.visible?t("div",{ref:"menu",staticClass:"context-menu",style:e.style,on:{mouseleave:function(e){e.preventDefault()},mouseover:function(e){e.preventDefault()},contextmenu:function(e){e.preventDefault()},wheel:function(e){e.stopPropagation()}}},[e.searchBar?t("search",{on:{search:e.onSearch},model:{value:e.filter,callback:function(t){e.filter=t},expression:"filter"}}):e._e(),e._v(" "),e._l(e.filtered,(function(n){return t("item",{key:n.title,attrs:{item:n,args:e.args,delay:e.delay/2}})}))],2):e._e()};YD._withStripped=!0;var qD={extends:AS,name:"Item",methods:{onClick(e){e.stopPropagation(),this.item.onClick&&this.item.onClick(this.args),this.item.keepOpen||this.$root.$emit("hide")}}},KD=(n(2202),hc(qD,void 0,void 0,!1,null,"560bf204",null).exports),ZD=function(){var e=this,t=e._self._c;return t("div",{staticClass:"search"},[t("input",{directives:[{name:"model",rawName:"v-model",value:e.value_,expression:"value_"}],ref:"input",staticClass:"form-control form-control-sm",attrs:{placeholder:"Filter"},domProps:{value:e.value_},on:{pointerdown:function(e){e.stopPropagation()},input:function(t){t.target.composing||(e.value_=t.target.value)}}})])};ZD._withStripped=!0;var JD={extends:wS,data(){return{value_:""}},watch:{value(){this.value_=this.value},value_(){this.$emit("search",this.value_)}},mounted(){this.$refs.input.focus()}},QD=(n(3637),{extends:xS,components:{Item:KD,Search:hc(JD,ZD,[],!1,null,"60675475",null).exports},data(){return{maxItems:5}},computed:{filtered(){if(!this.filter)return this.items;const e=new RegExp(this.filter,"i"),t=[];for(const n of this.extractLeafs(this.items))if(this.searchKeep(n.title)||n.title.match(e)){if(t.length===this.maxItems){t.push({title:"...",onClick:()=>this.maxItems+=5,keepOpen:!0});break}t.push(n)}return t}},watch:{filter(){this.maxItems=5}}}),eN=(n(7002),hc(QD,YD,[],!1,null,"b541c1c0",null).exports),tN=function(){var e=this,t=e._self._c;return t("div",{staticClass:"node",class:e.selected(),attrs:{title:e.node.name}},[t("textarea",{directives:[{name:"model",rawName:"v-model",value:e.text,expression:"text"}],ref:"textarea",staticClass:"content form-control",attrs:{spellcheck:"false"},domProps:{value:e.text},on:{pointerdown:function(e){e.stopPropagation()},input:function(t){t.target.composing||(e.text=t.target.value)}}})])};tN._withStripped=!0;var nN={mixins:[ED.mixin],data(){return{text:this.node.data.text}},watch:{text(){this.node.data.text=this.text,this.editor.trigger("unsavedchanges"),this.$nextTick((()=>{const e=this.$refs.textarea;e.style.height="0",e.style.height=`${e.scrollHeight}px`}))}}},rN=(n(3632),hc(nN,tN,[],!1,null,"51294ea3",null).exports),iN=[new class extends WD{constructor(){super("Note","note","Annotation"),this.data.component=rN}builder(e){super.builder(e),e.data.text||(e.data.text="")}fromFlow(e){const t=super.fromFlow(e);return t.data.text=e.model.text,t}toFlow(e){const t=super.toFlow(e);return t.model.text=e.data.text,delete t.model.executionProfile,t}}];class aN extends xg.Control{constructor(e,t,n,r=null){super(e),this.props={ikey:e,defaultValue:n},this.component=t,this.title=r,this.events={}}}var oN=function(){var e=this,t=e._self._c;return t("div",{staticClass:"input-group",on:{pointerdown:function(e){e.stopPropagation()}}},[t("input",{directives:[{name:"model",rawName:"v-model.number",value:e.value,expression:"value",modifiers:{number:!0}}],staticClass:"form-control input",attrs:{title:e.value},domProps:{value:e.value},on:{input:function(t){t.target.composing||(e.value=e._n(t.target.value))},blur:function(t){return e.$forceUpdate()}}}),e._v(" "),t("div",{staticClass:"input-group-append"},[t("button",{staticClass:"btn btn-light",attrs:{title:"Remove port"},on:{click:function(t){e.value--}}},[t("i",{staticClass:"fa-solid fa-minus"})]),e._v(" "),t("button",{staticClass:"btn btn-light",attrs:{title:"Add port"},on:{click:function(t){e.value++}}},[t("i",{staticClass:"fa-solid fa-plus"})])])])};oN._withStripped=!0;var sN={props:{ikey:String,getData:Function,putData:Function},data(){return{value:null}},watch:{value(){this.convertValue(),this.putData(this.ikey,this.value),this.$emit("change-value")}},methods:{updateValue(e){this.value=e},convertValue(){}},mounted(){this.value=this.getData(this.ikey),void 0===this.value&&(void 0!==this.defaultValue?this.value=this.defaultValue:this.value=null),this.putData(this.ikey,this.value)}},cN={mixins:[sN],props:{defaultValue:Number},methods:{convertValue(){const e=Number(this.value);window.isNaN(e)?this.value=this.defaultValue:this.value=e>99?99:e<0?0:Math.floor(e)}}},lN=(n(5124),hc(cN,oN,[],!1,null,"40afaf14",null).exports);class uN extends aN{constructor(e,t=null){super(e,lN,3,t)}}const dN="control",fN="Control";var hN=[new WD("Variable",dN,fN,[zD.dep,{key:"name"},{key:"value"}],[HD.dep]),new WD("VariableList",dN,fN,[zD.dep,{key:"names"},{key:"values"},{key:"delimiter",title:"Delimiter [;]"}],[HD.dep]),new WD("VariableJson",dN,fN,[zD.dep,{key:"jsonString",title:"JSON String"},{key:"key",title:"Key [data]"}],[HD.dep]),new WD("IfBranch",dN,fN,[zD.dep,{key:"condition",socket:FD.bool}],[HD.dep,{key:"true",socket:FD.dep,multi:!0},{key:"false",socket:FD.dep,multi:!0}]),new WD("Loop",dN,fN,[zD.dep,{key:"condition",socket:FD.bool},{key:"startIndex",title:"Start Index [0]",socket:FD.int},{key:"endIndex",title:"End Index",socket:FD.int},{key:"step",title:"Step [1]",socket:FD.int},{key:"indexVarName",title:"Index Variable Name"}],[HD.dep,{key:"loop",socket:FD.dep,multi:!0},{key:"index",socket:FD.int,multi:!0}]),new class extends WD{constructor(){super("BranchSelect",dN,fN,[zD.dep,{key:"selected",socket:FD.int}],[HD.dep])}builder(e){super.builder(e),e.meta.prevBranches=0;const t=new uN("branches","Branches");e.addControl(t),this.editor.on("controlchanged",(n=>{if(n!==t)return;const r=e.data.branches;if(r>e.meta.prevBranches)for(let t=e.meta.prevBranches;t<r;t++)e.addOutput(new xg.Output(`branch${t}`,`Branch ${t+1}`,FD.dep,!0));else for(let t=r;t<e.meta.prevBranches;t++){const n=e.outputs.get(`branch${t}`);for(let e=n.connections.length-1;e>=0;e--)this.editor.removeConnection(n.connections[e]);e.removeOutput(n)}e.vueContext.$forceUpdate(),e.meta.prevBranches=r}))}fromFlow(e){const t=super.fromFlow(e);t.data.branches=e.model.nBranches;for(let e=0;e<t.data.branches;e++)t.outputs.set(`branch${e}`,{connections:[]});return t}toFlow(e){const t=super.toFlow(e);return t.model.nBranches=e.data.branches,t}}],pN=function(){var e=this;return(0,e._self._c)("input",{directives:[{name:"model",rawName:"v-model",value:e.value,expression:"value"}],staticClass:"align-middle",attrs:{type:"checkbox"},domProps:{checked:Array.isArray(e.value)?e._i(e.value,null)>-1:e.value},on:{pointerdown:function(e){e.stopPropagation()},change:function(t){var n=e.value,r=t.target,i=!!r.checked;if(Array.isArray(n)){var a=e._i(n,null);r.checked?a<0&&(e.value=n.concat([null])):a>-1&&(e.value=n.slice(0,a).concat(n.slice(a+1)))}else e.value=i}}})};pN._withStripped=!0;var mN=hc({mixins:[sN],props:{defaultValue:Boolean},methods:{convertValue(){"false"===this.value?this.value=!1:"true"===this.value?this.value=!0:this.value=Boolean(this.value)}}},pN,[],!1,null,null,null).exports;class vN extends aN{constructor(e,t=null){super(e,mN,!1,t)}}const gN="File I/O";var bN=[new WD("FileInput","io",gN,[zD.dep,{key:"path",title:"File Path"}],[HD.dep,HD.pipe]),new class extends WD{constructor(){super("FileOutput","io",gN,[zD.dep,{key:"path",title:"File Path"},{key:"append",socket:FD.bool},zD.pipe],[HD.dep])}builder(e){super.builder(e),e.addControl(new vN("shortcut","Shortcut"))}fromFlow(e){const t=super.fromFlow(e);return t.data.shortcut=e.model.createShortcut,t}toFlow(e){const t=super.toFlow(e);return t.model.createShortcut=e.data.shortcut,t}}],_N=function(){var e=this,t=e._self._c;return t("div",{staticClass:"input-group",on:{pointerdown:function(e){e.stopPropagation()}}},[t("input",{directives:[{name:"model",rawName:"v-model",value:e.value,expression:"value"}],staticClass:"form-control input",attrs:{title:e.value},domProps:{value:e.value},on:{input:function(t){t.target.composing||(e.value=t.target.value)}}}),e._v(" "),t("div",{staticClass:"input-group-append"},[t("button",{staticClass:"btn btn-light",attrs:{title:"Revert to default"},on:{click:function(t){e.value=e.defaultFormat}}},[t("i",{staticClass:"fa-solid fa-rotate"})])])])};_N._withStripped=!0;var yN={mixins:[sN],data(){return{defaultFormat:""}},props:{defaultValue:String},methods:{updateDefaultFormat(e){this.defaultFormat=e}}},xN=(n(5120),hc(yN,_N,[],!1,null,"51a83194",null).exports);class AN extends aN{constructor(e,t=null){super(e,xN,"",t)}}var wN=[new class extends WD{constructor(){super("FormatString","misc","Miscellaneous",[zD.dep],[HD.dep,{key:"formattedString",title:"Formatted String",multi:!0}])}builder(e){super.builder(e),e.meta.prevInputs=0;const t=new uN("inputs","Inputs"),n=new AN("format","Format");e.addControl(t),e.addControl(n),this.editor.on("controlchanged",(r=>{if(r!==t)return;const i=e.data.inputs;if(i>e.meta.prevInputs)for(let t=e.meta.prevInputs;t<i;t++)e.addInput(new xg.Input(`input${t}`,`%${t}`,FD.str));else for(let t=i;t<e.meta.prevInputs;t++){const n=e.inputs.get(`input${t}`);for(let e=n.connections.length-1;e>=0;e--)this.editor.removeConnection(n.connections[e]);e.removeInput(n)}const a=[];for(let e=0;e<i;e++)a.push(`%${e}`);const o=`[${a.join(", ")}]`;n.vueContext.updateDefaultFormat(o),e.data.format||n.vueContext.updateValue(o),e.vueContext.$forceUpdate(),e.meta.prevInputs=i}))}fromFlow(e){const t=super.fromFlow(e);t.data.inputs=e.model.nInputs,t.data.format=e.model.value;for(let e=0;e<t.data.inputs;e++)t.inputs.set(`input${e}`,{connections:[]});return t}toFlow(e){const t=super.toFlow(e);return t.model.nInputs=e.data.inputs,t.model.value=e.data.format,t}}],EN=function(){var e=this;return(0,e._self._c)("input",{directives:[{name:"model",rawName:"v-model.number",value:e.value,expression:"value",modifiers:{number:!0}}],staticClass:"form-control d-inline",attrs:{title:e.value},domProps:{value:e.value},on:{pointerdown:function(e){e.stopPropagation()},input:function(t){t.target.composing||(e.value=e._n(t.target.value))},blur:function(t){return e.$forceUpdate()}}})};EN._withStripped=!0;var TN=hc({mixins:[sN],props:{defaultValue:Number},methods:{convertValue(){const e=Number(this.value);window.isNaN(e)?this.value=this.defaultValue:this.value=e}}},EN,[],!1,null,null,null).exports,SN=function(){var e=this;return(0,e._self._c)("input",{directives:[{name:"model",rawName:"v-model.number",value:e.value,expression:"value",modifiers:{number:!0}}],staticClass:"form-control d-inline",attrs:{title:e.value},domProps:{value:e.value},on:{pointerdown:function(e){e.stopPropagation()},input:function(t){t.target.composing||(e.value=e._n(t.target.value))},blur:function(t){return e.$forceUpdate()}}})};SN._withStripped=!0;var CN=hc({mixins:[sN],props:{defaultValue:Number},methods:{convertValue(){const e=Number(this.value);window.isNaN(e)?this.value=this.defaultValue:this.value=Math.floor(e)}}},SN,[],!1,null,null,null).exports,MN=function(){var e=this;return(0,e._self._c)("input",{directives:[{name:"model",rawName:"v-model",value:e.value,expression:"value"}],staticClass:"form-control d-inline",attrs:{title:e.value},domProps:{value:e.value},on:{pointerdown:function(e){e.stopPropagation()},input:function(t){t.target.composing||(e.value=t.target.value)}}})};MN._withStripped=!0;var kN=hc({mixins:[sN],props:{defaultValue:String}},MN,[],!1,null,null,null).exports;class RN extends WD{constructor(e,t,n){super(e,"source","Source",[],[{key:"out",title:e,socket:t,multi:!0}]),this.widget=n}builder(e){super.builder(e),e.addControl(new this.widget("value"))}fromFlow(e){const t=super.fromFlow(e);return t.data.value=e.model.value,t}toFlow(e){const t=super.toFlow(e);return null===e.data.value?t.model.value="":t.model.value=String(e.data.value),delete t.model.executionProfile,t}}var LN=[new RN("String",FD.str,class extends aN{constructor(e,t=null){super(e,kN,"",t)}}),new RN("Integer",FD.int,class extends aN{constructor(e,t=null){super(e,CN,0,t)}}),new RN("Float",FD.float,class extends aN{constructor(e,t=null){super(e,TN,0,t)}}),new RN("Boolean",FD.bool,vN)];const ON="user-input",IN="User Input";var PN=[new WD("UserInputText",ON,IN,[zD.dep,{key:"prompt"},{key:"default"},{key:"multiline",socket:FD.bool}],[HD.dep,{key:"value",multi:!0}]),new WD("UserInputInteger",ON,IN,[zD.dep,{key:"prompt"},{key:"default",socket:FD.int}],[HD.dep,{key:"value",multi:!0,socket:FD.int}]),new WD("UserInputFloat",ON,IN,[zD.dep,{key:"prompt"},{key:"default",socket:FD.float}],[HD.dep,{key:"value",multi:!0,socket:FD.float}]),new WD("UserInputBool",ON,IN,[zD.dep,{key:"prompt"},{key:"default",socket:FD.bool}],[HD.dep,{key:"value",multi:!0,socket:FD.bool}]),new WD("UserInputFile",ON,IN,[zD.dep,{key:"prompt"},{key:"default"}],[HD.dep,{key:"value",multi:!0}]),new WD("UserInputSelect",ON,IN,[zD.dep,{key:"prompt"},{key:"values"},{key:"default"},{key:"delimiter",title:"Delimiter [,]"}],[HD.dep,{key:"value",multi:!0}]),new WD("UserInputSelectBoundingBox",ON,IN,[zD.dep,{key:"prompt"},{key:"imagePath",title:"Image Path"}],[HD.dep,{key:"x",socket:FD.int,multi:!0},{key:"y",socket:FD.int,multi:!0},{key:"width",socket:FD.int,multi:!0},{key:"height",socket:FD.int,multi:!0}]),new WD("UserInputPeriodicTable",ON,IN,[zD.dep,{key:"prompt"},{key:"default"}],[HD.dep,{key:"selectedElements",title:"Selected Elements",multi:!0}]),new WD("UserInputForm",ON,IN,[zD.dep,{key:"jsonFile",title:"JSON File"}],[HD.dep,{key:"jsonString",title:"JSON String",multi:!0}]),new WD("UserInputCropImages",ON,null,[zD.dep,{key:"prompt"},{key:"imagePath",title:"Image Path"}],[HD.dep,{key:"cropInfo",title:"Crop Info",multi:!0}],{validationState:"warning",validationMessage:'Deprecated in favor of "UserInputSelectBoundingBox".'}),new class extends WD{constructor(){super("UserInputChoose",ON,IN,[zD.dep,{key:"prompt"},{key:"default",socket:FD.int}],[HD.dep,{key:"selected",socket:FD.int,multi:!0},{key:"value",multi:!0}])}builder(e){super.builder(e),e.meta.prevOptions=0;const t=new uN("options","Options");e.addControl(t),this.editor.on("controlchanged",(n=>{if(n!==t)return;const r=e.data.options;if(r>e.meta.prevOptions)for(let t=e.meta.prevOptions;t<r;t++)e.addInput(new xg.Input(`option${t}`,`Option ${t+1}`,FD.str));else for(let t=r;t<e.meta.prevOptions;t++){const n=e.inputs.get(`option${t}`);for(let e=n.connections.length-1;e>=0;e--)this.editor.removeConnection(n.connections[e]);e.removeInput(n)}e.vueContext.$forceUpdate(),e.meta.prevOptions=r}))}fromFlow(e){const t=super.fromFlow(e);t.data.options=e.model.nOptions;for(let e=0;e<t.data.options;e++)t.inputs.set(`option${e}`,{connections:[]});return t}toFlow(e){const t=super.toFlow(e);return t.model.nOptions=e.data.options,t}}];const DN="user-output",NN="User Output";var UN=[new WD("UserOutputText",DN,NN,[zD.dep,{key:"file",title:"Text File",required:!0}],[HD.dep]),new WD("UserOutputWebView",DN,NN,[zD.dep,{key:"description"},{key:"url",title:"URL"}],[HD.dep])],FN=(n(6566),{data(){return{version:"kadi@0.1.0",editor:null,area:null,unsavedChanges_:!1,toolDialogActive:!1,menuItems:{},currX:0,currY:0}},props:{editable:{type:Boolean,default:!0},workflowUrl:{type:String,default:null},toolsEndpoint:{type:String,default:null},unsavedChanges:{type:Boolean,default:!1},isRendered:{type:Boolean,default:!0}},computed:{toolbarBtnClasses(){return"btn btn-link text-primary"}},watch:{workflowUrl(){this.loadWorkflow(this.workflowUrl)},unsavedChanges(){this.unsavedChanges_=this.unsavedChanges},unsavedChanges_(){this.$emit("unsaved-changes",this.unsavedChanges_)},isRendered(){this.resizeView(!1)}},methods:{resetView(){this.area.zoomAt(this.editor)},toggleFullscreen(){kadi.utils.toggleFullscreen(this.$refs.container)},resetEditor(){window.confirm("Are you sure you want to reset the editor?")&&(this.editor.clear(),this.unsavedChanges_=!1)},resizeView(e=!0){if(!this.isRendered)return;const t=this.$refs.editorContainer.getBoundingClientRect().width;kadi.utils.isFullscreen()?(this.$refs.editorContainer.style.height="100vh",this.$refs.editorContainer.style.borderRadius="0"):(this.$refs.editorContainer.style.height=`${Math.round(window.innerHeight/window.innerWidth*t)}px`,this.$refs.editorContainer.style.borderRadius="0.25rem"),this.editor.view.resize(),e&&this.resetView()},loadWorkflow(e){axios.get(e).then((e=>{try{this.editor.fromFlow(e.data).then((e=>{e||kadi.base.flashWarning("Could not fully reconstruct workflow.")})).catch((e=>{console.error(e),kadi.base.flashDanger("Error parsing workflow data.")})).finally((()=>this.resetView()))}catch(e){console.error(e),kadi.base.flashDanger("Error parsing workflow data.")}})).catch((e=>kadi.base.flashDanger("Error loading workflow.",{request:e.request})))},addTool(e){const t=jD.nameFromTool(e);this.editor.components.has(t)||this.editor.register(new jD(e)),this.addNode(this.editor.components.get(t))},async addNode(e){const t=await e.createNode();t.position[0]=this.currX,t.position[1]=this.currY,this.editor.addNode(t)},beforeUnload(e){return this.unsavedChanges_?(e.preventDefault(),(e||window.event).returnValue="",""):null}},mounted(){if(this.editor=new XD(this.version,this.$refs.editor),this.area=Sv,!this.editable){let e=e=>{Array.from(this.$refs.editorToolbar.getElementsByTagName("*")).includes(e.target)||(e.preventDefault(),e.stopPropagation())};this.$refs.editorContainer.addEventListener("click",e,{capture:!0}),e=e=>{e.target!==this.$refs.editor&&(e.preventDefault(),e.stopPropagation())},this.$refs.editorContainer.addEventListener("pointerdown",e,{capture:!0}),this.$refs.editorContainer.addEventListener("pointerup",e,{capture:!0}),e=e=>{e.preventDefault(),e.stopPropagation()},this.$refs.editorContainer.addEventListener("dblclick",e,{capture:!0}),this.$refs.editorContainer.addEventListener("contextmenu",e,{capture:!0})}this.editor.use(Sv,{snap:{size:16,dynamic:!0}}),this.editor.use(Dg),this.editor.use(ED),this.editor.use(TS,{vueComponent:eN,searchBar:!0,delay:0,items:this.menuItems,allocate:()=>null}),[...iN,...hN,...bN,...LN,...PN,...UN,...wN].forEach((e=>this.editor.register(e))),this.toolsEndpoint&&(this.menuItems["Select Tools..."]=()=>{this.toolDialogActive=!0,$(this.$refs.toolDialog).modal({backdrop:!1})},$(this.$refs.toolDialog).on("hidden.bs.modal",(()=>{this.toolDialogActive=!1})));for(const e of this.editor.components.values())e.menu&&(this.menuItems[e.menu]||(this.menuItems[e.menu]={}),this.menuItems[e.menu][e.name]=()=>this.addNode(e));"development"===kadi.globals.environment&&(this.menuItems.Debug={"Dump Flow":()=>console.info(this.editor.toFlow()),"Dump JSON":()=>console.info(this.editor.toJSON())}),this.editor.on("showcontextmenu",(({e:e})=>{const t=this.editor.view.area,n=t.el.getBoundingClientRect();this.currX=(e.clientX-n.left)/t.transform.k,this.currY=(e.clientY-n.top)/t.transform.k})),this.editor.on(["nodecreated","noderemoved","nodetranslated","connectioncreated","connectionremoved","controlchanged","unsavedchanges"].join(" "),(()=>{this.editor.silent||(this.unsavedChanges_=!0)})),this.resizeView(),this.workflowUrl&&this.loadWorkflow(this.workflowUrl),window.addEventListener("resize",this.resizeView),window.addEventListener("beforeunload",this.beforeUnload)},beforeDestroy(){window.removeEventListener("resize",this.resizeView),window.removeEventListener("beforeunload",this.beforeUnload),$(this.$refs.toolDialog).modal("dispose")}}),BN=(n(2924),hc(FN,pv,[],!1,null,"0b9afe58",null).exports);kadi.base.newVue({components:{ExcelViewer:pc,ModelViewer:hv,WorkflowEditor:BN},data:{previewData:null,initialized:!1},mounted(){axios.get(kadi.context.get_file_preview_endpoint).then((e=>{this.previewData=e.data,this.initialized=!0})).catch((e=>{404!==e.request.status?kadi.base.flashDanger($t("Error loading file preview."),{request:e.request}):this.initialized=!0}))}})}()}();
//# sourceMappingURL=view-file.js.map